/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","os","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/window/common/window","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],re=function(J){for(var e=[],S=0,A=J.length;S<A;S++)e[S]=se[J[S]];return e};define(se[134],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function S($,w,g){const h=A($,w);if(h!==-1)return $[h]}e.$eb=S;function A($,w,g=$.length-1){for(let h=g;h>=0;h--){const a=$[h];if(w(a))return h}return-1}e.$fb=A;function s($,w){const g=M($,w);return g===-1?void 0:$[g]}e.$gb=s;function M($,w,g=0,h=$.length){let a=g,k=h;for(;a<k;){const f=Math.floor((a+k)/2);w($[f])?a=f+1:k=f}return a-1}e.$hb=M;function C($,w){const g=P($,w);return g===$.length?void 0:$[g]}e.$ib=C;function P($,w,g=0,h=$.length){let a=g,k=h;for(;a<k;){const f=Math.floor((a+k)/2);w($[f])?k=f:a=f+1}return a}e.$jb=P;function d($,w,g=0,h=$.length){const a=P($,w,g,h);return a===$.length?-1:a}e.$kb=d;class u{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(u.assertInvariants){if(this.d){for(const h of this.e)if(this.d(h)&&!w(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const g=M(this.e,w,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$lb=u;function b($,w){if($.length===0)return;let g=$[0];for(let h=1;h<$.length;h++){const a=$[h];w(a,g)>0&&(g=a)}return g}e.$mb=b;function y($,w){if($.length===0)return;let g=$[0];for(let h=1;h<$.length;h++){const a=$[h];w(a,g)>=0&&(g=a)}return g}e.$nb=y;function p($,w){return b($,(g,h)=>-w(g,h))}e.$ob=p;function l($,w){if($.length===0)return-1;let g=0;for(let h=1;h<$.length;h++){const a=$[h];w(a,$[g])>0&&(g=h)}return g}e.$pb=l;function v($,w){for(const g of $){const h=w(g);if(h!==void 0)return h}}e.$qb=v}),define(se[135],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function S(C,P){const d=Object.create(null);for(const u of C){const b=P(u);let y=d[b];y||(y=d[b]=[]),y.push(u)}return d}e.$J=S;function A(C,P){const d=[],u=[];for(const b of C)P.has(b)||d.push(b);for(const b of P)C.has(b)||u.push(b);return{removed:d,added:u}}e.$K=A;function s(C,P){const d=[],u=[];for(const[b,y]of C)P.has(b)||d.push(y);for(const[b,y]of P)C.has(b)||u.push(y);return{removed:d,added:u}}e.$L=s;function M(C,P){const d=new Set;for(const u of P)C.has(u)&&d.add(u);return d}e.$M=M}),define(se[136],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=e.$5s=e.$4s=e.$3s=void 0;function S(P,d){const u=Math.pow(10,d);return Math.round(P*u)/u}class A{constructor(d,u,b,y=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=S(Math.max(Math.min(1,y),0),3)}static equals(d,u){return d.r===u.r&&d.g===u.g&&d.b===u.b&&d.a===u.a}}e.$3s=A;class s{constructor(d,u,b,y){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=S(Math.max(Math.min(1,u),0),3),this.l=S(Math.max(Math.min(1,b),0),3),this.a=S(Math.max(Math.min(1,y),0),3)}static equals(d,u){return d.h===u.h&&d.s===u.s&&d.l===u.l&&d.a===u.a}static fromRGBA(d){const u=d.r/255,b=d.g/255,y=d.b/255,p=d.a,l=Math.max(u,b,y),v=Math.min(u,b,y);let $=0,w=0;const g=(v+l)/2,h=l-v;if(h>0){switch(w=Math.min(g<=.5?h/(2*g):h/(2-2*g),1),l){case u:$=(b-y)/h+(b<y?6:0);break;case b:$=(y-u)/h+2;break;case y:$=(u-b)/h+4;break}$*=60,$=Math.round($)}return new s($,w,g,p)}static i(d,u,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?d+(u-d)*6*b:b<1/2?u:b<2/3?d+(u-d)*(2/3-b)*6:d}static toRGBA(d){const u=d.h/360,{s:b,l:y,a:p}=d;let l,v,$;if(b===0)l=v=$=y;else{const w=y<.5?y*(1+b):y+b-y*b,g=2*y-w;l=s.i(g,w,u+1/3),v=s.i(g,w,u),$=s.i(g,w,u-1/3)}return new A(Math.round(l*255),Math.round(v*255),Math.round($*255),p)}}e.$4s=s;class M{constructor(d,u,b,y){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=S(Math.max(Math.min(1,u),0),3),this.v=S(Math.max(Math.min(1,b),0),3),this.a=S(Math.max(Math.min(1,y),0),3)}static equals(d,u){return d.h===u.h&&d.s===u.s&&d.v===u.v&&d.a===u.a}static fromRGBA(d){const u=d.r/255,b=d.g/255,y=d.b/255,p=Math.max(u,b,y),l=Math.min(u,b,y),v=p-l,$=p===0?0:v/p;let w;return v===0?w=0:p===u?w=((b-y)/v%6+6)%6:p===b?w=(y-u)/v+2:w=(u-b)/v+4,new M(Math.round(w*60),$,p,d.a)}static toRGBA(d){const{h:u,s:b,v:y,a:p}=d,l=y*b,v=l*(1-Math.abs(u/60%2-1)),$=y-l;let[w,g,h]=[0,0,0];return u<60?(w=l,g=v):u<120?(w=v,g=l):u<180?(g=l,h=v):u<240?(g=v,h=l):u<300?(w=v,h=l):u<=360&&(w=l,h=v),w=Math.round((w+$)*255),g=Math.round((g+$)*255),h=Math.round((h+$)*255),new A(w,g,h,p)}}e.$5s=M;class C{static fromHex(d){return C.Format.CSS.parseHex(d)||C.red}static equals(d,u){return!d&&!u?!0:!d||!u?!1:d.equals(u)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof A)this.rgba=d;else if(d instanceof s)this.i=d,this.rgba=s.toRGBA(d);else if(d instanceof M)this.j=d,this.rgba=M.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&A.equals(this.rgba,d.rgba)&&s.equals(this.hsla,d.hsla)&&M.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=C.k(this.rgba.r),u=C.k(this.rgba.g),b=C.k(this.rgba.b),y=.2126*d+.7152*u+.0722*b;return S(y,4)}static k(d){const u=d/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(d){const u=this.getRelativeLuminance(),b=d.getRelativeLuminance();return u>b?(u+.05)/(b+.05):(b+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const u=this.getRelativeLuminance(),b=d.getRelativeLuminance();return u>b}isDarkerThan(d){const u=this.getRelativeLuminance(),b=d.getRelativeLuminance();return u<b}lighten(d){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:u,g:b,b:y,a:p}=this.rgba;return new C(new A(u,b,y,p*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new A(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const u=d.rgba,b=this.rgba.a,y=u.a,p=b+y*(1-b);if(p<1e-6)return C.transparent;const l=this.rgba.r*b/p+u.r*y*(1-b)/p,v=this.rgba.g*b/p+u.g*y*(1-b)/p,$=this.rgba.b*b/p+u.b*y*(1-b)/p;return new C(new A(l,v,$,p))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:u,g:b,b:y,a:p}=this.rgba;return new C(new A(d.rgba.r-p*(d.rgba.r-u),d.rgba.g-p*(d.rgba.g-b),d.rgba.b-p*(d.rgba.b-y),1))}flatten(...d){const u=d.reduceRight((b,y)=>C.o(y,b));return C.o(this,u)}static o(d,u){const b=1-d.rgba.a;return new C(new A(b*u.rgba.r+d.rgba.a*d.rgba.r,b*u.rgba.g+d.rgba.a*d.rgba.g,b*u.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this.u||(this.u=C.Format.CSS.format(this)),this.u}static getLighterColor(d,u,b){if(d.isLighterThan(u))return d;b=b||.5;const y=d.getRelativeLuminance(),p=u.getRelativeLuminance();return b=b*(p-y)/p,d.lighten(b)}static getDarkerColor(d,u,b){if(d.isDarkerThan(u))return d;b=b||.5;const y=d.getRelativeLuminance(),p=u.getRelativeLuminance();return b=b*(y-p)/y,d.darken(b)}static{this.white=new C(new A(255,255,255,1))}static{this.black=new C(new A(0,0,0,1))}static{this.red=new C(new A(255,0,0,1))}static{this.blue=new C(new A(0,0,255,1))}static{this.green=new C(new A(0,255,0,1))}static{this.cyan=new C(new A(0,255,255,1))}static{this.lightgrey=new C(new A(211,211,211,1))}static{this.transparent=new C(new A(0,0,0,0))}}e.$6s=C,function(P){let d;(function(u){let b;(function(y){function p(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:P.Format.CSS.formatRGBA(i)}y.formatRGB=p;function l(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}y.formatRGBA=l;function v(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(i)}y.formatHSL=v;function $(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}y.formatHSLA=$;function w(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function g(i){return`#${w(i.rgba.r)}${w(i.rgba.g)}${w(i.rgba.b)}`}y.formatHex=g;function h(i,o=!1){return o&&i.rgba.a===1?P.Format.CSS.formatHex(i):`#${w(i.rgba.r)}${w(i.rgba.g)}${w(i.rgba.b)}${w(Math.round(i.rgba.a*255))}`}y.formatHexA=h;function a(i){return i.isOpaque()?P.Format.CSS.formatHex(i):P.Format.CSS.formatRGBA(i)}y.format=a;function k(i){const o=i.length;if(o===0||i.charCodeAt(0)!==35)return null;if(o===7){const r=16*f(i.charCodeAt(1))+f(i.charCodeAt(2)),t=16*f(i.charCodeAt(3))+f(i.charCodeAt(4)),n=16*f(i.charCodeAt(5))+f(i.charCodeAt(6));return new P(new A(r,t,n,1))}if(o===9){const r=16*f(i.charCodeAt(1))+f(i.charCodeAt(2)),t=16*f(i.charCodeAt(3))+f(i.charCodeAt(4)),n=16*f(i.charCodeAt(5))+f(i.charCodeAt(6)),c=16*f(i.charCodeAt(7))+f(i.charCodeAt(8));return new P(new A(r,t,n,c/255))}if(o===4){const r=f(i.charCodeAt(1)),t=f(i.charCodeAt(2)),n=f(i.charCodeAt(3));return new P(new A(16*r+r,16*t+t,16*n+n))}if(o===5){const r=f(i.charCodeAt(1)),t=f(i.charCodeAt(2)),n=f(i.charCodeAt(3)),c=f(i.charCodeAt(4));return new P(new A(16*r+r,16*t+t,16*n+n,(16*c+c)/255))}return null}y.parseHex=k;function f(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=u.CSS||(u.CSS={}))})(d=P.Format||(P.Format={}))}(C||(e.$6s=C={}))}),define(se[56],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=void 0;function S(C){return(P,d,u)=>{let b=null,y=null;if(typeof u.value=="function"?(b="value",y=u.value):typeof u.get=="function"&&(b="get",y=u.get),!y)throw new Error("not supported");u[b]=C(y,d)}}function A(C,P,d){let u=null,b=null;if(typeof d.value=="function"?(u="value",b=d.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(u="get",b=d.get),!b)throw new Error("not supported");const y=`$memoize$${P}`;d[u]=function(...p){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,p)}),this[y]}}e.$ph=A;function s(C,P,d){return S((u,b)=>{const y=`$debounce$${b}`,p=`$debounce$result$${b}`;return function(...l){this[p]||(this[p]=d?d():void 0),clearTimeout(this[y]),P&&(this[p]=P(this[p],...l),l=[this[p]]),this[y]=setTimeout(()=>{u.apply(this,l),this[p]=d?d():void 0},C)}})}e.$qh=s;function M(C,P,d){return S((u,b)=>{const y=`$throttle$timer$${b}`,p=`$throttle$result$${b}`,l=`$throttle$lastRun$${b}`,v=`$throttle$pending$${b}`;return function(...$){if(this[p]||(this[p]=d?d():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),P&&(this[p]=P(this[p],...$)),this[v])return;const w=this[l]+C;w<=Date.now()?(this[l]=Date.now(),u.apply(this,[this[p]]),this[p]=d?d():void 0):(this[v]=!0,this[y]=setTimeout(()=>{this[v]=!1,this[l]=Date.now(),u.apply(this,[this[p]]),this[p]=d?d():void 0},w-Date.now()))}})}e.$rh=M}),define(se[14],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class S{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?a.isErrorNoTelemetry(i)?new a(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$V=S,e.$W=new S;function A(f){e.$W.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=A;function s(f){if(!f||typeof f!="object")return!1;const i=f;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Y=s;function M(f){u(f)||e.$W.onUnexpectedError(f)}e.$Z=M;function C(f){u(f)||e.$W.onUnexpectedExternalError(f)}e.$1=C;function P(f){if(f instanceof Error){const{name:i,message:o}=f,r=f.stacktrace||f.stack;return{$isError:!0,name:i,message:o,stack:r,noTelemetry:a.isErrorNoTelemetry(f)}}return f}e.$2=P;const d="Canceled";function u(f){return f instanceof b?!0:f instanceof Error&&f.name===d&&f.message===d}e.$3=u;class b extends Error{constructor(){super(d),this.name=this.message}}e.$4=b;function y(){const f=new Error(d);return f.name=f.message,f}e.$5=y;function p(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.$6=p;function l(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.$7=l;class v extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=v;function $(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.$9=$;class w extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=w;class g extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=g;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=h;class a extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof a)return i;const o=new a;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=a;class k extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype)}}e.$bb=k}),define(se[23],re([0,1,14,134]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function s(j,B=0){return j[j.length-(1+B)]}e.$rb=s;function M(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.$sb=M;function C(j,B,T=(Z,he)=>Z===he){if(j===B)return!0;if(!j||!B||j.length!==B.length)return!1;for(let Z=0,he=j.length;Z<he;Z++)if(!T(j[Z],B[Z]))return!1;return!0}e.$tb=C;function P(j,B){const T=j.length-1;B<T&&(j[B]=j[T]),j.pop()}e.$ub=P;function d(j,B,T){return u(j.length,Z=>T(j[Z],B))}e.$vb=d;function u(j,B){let T=0,Z=j-1;for(;T<=Z;){const he=(T+Z)/2|0,de=B(he);if(de<0)T=he+1;else if(de>0)Z=he-1;else return he}return-(T+1)}e.$wb=u;function b(j,B,T){if(j=j|0,j>=B.length)throw new TypeError("invalid index");const Z=B[Math.floor(B.length*Math.random())],he=[],de=[],le=[];for(const we of B){const be=T(we,Z);be<0?he.push(we):be>0?de.push(we):le.push(we)}return j<he.length?b(j,he,T):j<he.length+le.length?le[0]:b(j-(he.length+le.length),de,T)}e.$xb=b;function y(j,B){const T=[];let Z;for(const he of j.slice(0).sort(B))!Z||B(Z[0],he)!==0?(Z=[he],T.push(Z)):Z.push(he);return T}e.$yb=y;function*p(j,B){let T,Z;for(const he of j)Z!==void 0&&B(Z,he)?T.push(he):(T&&(yield T),T=[he]),Z=he;T&&(yield T)}e.$zb=p;function l(j,B){for(let T=0;T<=j.length;T++)B(T===0?void 0:j[T-1],T===j.length?void 0:j[T])}e.$Ab=l;function v(j,B){for(let T=0;T<j.length;T++)B(T===0?void 0:j[T-1],j[T],T+1===j.length?void 0:j[T+1])}e.$Bb=v;function $(j,B,T){const Z=[];function he(we,be,Ee){if(be===0&&Ee.length===0)return;const Se=Z[Z.length-1];Se&&Se.start+Se.deleteCount===we?(Se.deleteCount+=be,Se.toInsert.push(...Ee)):Z.push({start:we,deleteCount:be,toInsert:Ee})}let de=0,le=0;for(;;){if(de===j.length){he(de,0,B.slice(le));break}if(le===B.length){he(de,j.length-de,[]);break}const we=j[de],be=B[le],Ee=T(we,be);Ee===0?(de+=1,le+=1):Ee<0?(he(de,1,[]),de+=1):Ee>0&&(he(de,0,[be]),le+=1)}return Z}e.$Cb=$;function w(j,B,T){const Z=$(j,B,T),he=[],de=[];for(const le of Z)he.push(...j.slice(le.start,le.start+le.deleteCount)),de.push(...le.toInsert);return{removed:he,added:de}}e.$Db=w;function g(j,B,T){if(T===0)return[];const Z=j.slice(0,T).sort(B);return a(j,B,Z,T,j.length),Z}e.top=g;function h(j,B,T,Z,he){return T===0?Promise.resolve([]):new Promise((de,le)=>{(async()=>{const we=j.length,be=j.slice(0,T).sort(B);for(let Ee=T,Se=Math.min(T+Z,we);Ee<we;Ee=Se,Se=Math.min(Se+Z,we)){if(Ee>T&&await new Promise(je=>setTimeout(je)),he&&he.isCancellationRequested)throw new S.$4;a(j,B,be,Ee,Se)}return be})().then(de,le)})}e.$Fb=h;function a(j,B,T,Z,he){for(const de=T.length;Z<he;Z++){const le=j[Z];if(B(le,T[de-1])<0){T.pop();const we=(0,A.$jb)(T,be=>B(le,be)<0);T.splice(we,0,le)}}}function k(j){return j.filter(B=>!!B)}e.$Gb=k;function f(j){let B=0;for(let T=0;T<j.length;T++)j[T]&&(j[B]=j[T],B+=1);j.length=B}e.$Hb=f;function i(j,B,T){j.splice(T,0,j.splice(B,1)[0])}e.$Ib=i;function o(j){return!Array.isArray(j)||j.length===0}e.$Jb=o;function r(j){return Array.isArray(j)&&j.length>0}e.$Kb=r;function t(j,B=T=>T){const T=new Set;return j.filter(Z=>{const he=B(Z);return T.has(he)?!1:(T.add(he),!0)})}e.$Lb=t;function n(j){const B=new Set;return T=>{const Z=j(T);return B.has(Z)?!1:(B.add(Z),!0)}}e.$Mb=n;function c(j,B){return j.length>0?j[0]:B}e.$Nb=c;function m(j,B){return j.length>0?j[j.length-1]:B}e.$Ob=m;function D(j,B,T=(Z,he)=>Z===he){let Z=0;for(let he=0,de=Math.min(j.length,B.length);he<de&&T(j[he],B[he]);he++)Z++;return Z}e.$Pb=D;function I(j){return[].concat(...j)}e.$Qb=I;function E(j,B){let T=typeof B=="number"?j:0;typeof B=="number"?T=j:(T=0,B=j);const Z=[];if(T<=B)for(let he=T;he<B;he++)Z.push(he);else for(let he=T;he>B;he--)Z.push(he);return Z}e.$Rb=E;function R(j,B,T){return j.reduce((Z,he)=>(Z[B(he)]=T?T(he):he,Z),Object.create(null))}e.$Sb=R;function L(j,B){return j.push(B),()=>F(j,B)}e.$Tb=L;function F(j,B){const T=j.indexOf(B);if(T>-1)return j.splice(T,1),B}e.$Ub=F;function U(j,B,T){const Z=j.slice(0,B),he=j.slice(B);return Z.concat(T,he)}e.$Vb=U;function x(j,B){let T;if(typeof B=="number"){let Z=B;T=()=>{const he=Math.sin(Z++)*179426549;return he-Math.floor(he)}}else T=Math.random;for(let Z=j.length-1;Z>0;Z-=1){const he=Math.floor(T()*(Z+1)),de=j[Z];j[Z]=j[he],j[he]=de}}e.$Wb=x;function Y(j,B){const T=j.indexOf(B);T>-1&&(j.splice(T,1),j.unshift(B))}e.$Xb=Y;function ae(j,B){const T=j.indexOf(B);T>-1&&(j.splice(T,1),j.push(B))}e.$Yb=ae;function oe(j,B){for(const T of B)j.push(T)}e.$Zb=oe;function ce(j,B){return Array.isArray(j)?j.map(B):B(j)}e.$1b=ce;function Q(j){return Array.isArray(j)?j:[j]}e.$2b=Q;function K(j){return j[Math.floor(Math.random()*j.length)]}e.$3b=K;function V(j,B,T){const Z=W(j,B),he=j.length,de=T.length;j.length=he+de;for(let le=he-1;le>=Z;le--)j[le+de]=j[le];for(let le=0;le<de;le++)j[le+Z]=T[le]}e.$4b=V;function z(j,B,T,Z){const he=W(j,B);let de=j.splice(he,T);return de===void 0&&(de=[]),V(j,he,Z),de}e.$5b=z;function W(j,B){return B<0?Math.max(B+j.length,0):Math.min(B,j.length)}var H;(function(j){function B(de){return de<0}j.isLessThan=B;function T(de){return de<=0}j.isLessThanOrEqual=T;function Z(de){return de>0}j.isGreaterThan=Z;function he(de){return de===0}j.isNeitherLessOrGreaterThan=he,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(H||(e.CompareResult=H={}));function q(j,B){return(T,Z)=>B(j(T),j(Z))}e.$6b=q;function _(...j){return(B,T)=>{for(const Z of j){const he=Z(B,T);if(!H.isNeitherLessOrGreaterThan(he))return he}return H.neitherLessOrGreaterThan}}e.$7b=_;const ne=(j,B)=>j-B;e.$8b=ne;const X=(j,B)=>(0,e.$8b)(j?1:0,B?1:0);e.$9b=X;function O(j){return(B,T)=>-j(B,T)}e.$0b=O;class N{constructor(B){this.g=B,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(B){let T=this.c;for(;T<this.g.length&&B(this.g[T]);)T++;const Z=T===this.c?null:this.g.slice(this.c,T);return this.c=T,Z}takeFromEndWhile(B){let T=this.d;for(;T>=0&&B(this.g[T]);)T--;const Z=T===this.d?null:this.g.slice(T+1,this.d+1);return this.d=T,Z}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const B=this.g[this.c];return this.c++,B}removeLast(){const B=this.g[this.d];return this.d--,B}takeCount(B){const T=this.g.slice(this.c,this.c+B);return this.c+=B,T}}e.$$b=N;class G{static{this.empty=new G(B=>{})}constructor(B){this.iterate=B}forEach(B){this.iterate(T=>(B(T),!0))}toArray(){const B=[];return this.iterate(T=>(B.push(T),!0)),B}filter(B){return new G(T=>this.iterate(Z=>B(Z)?T(Z):!0))}map(B){return new G(T=>this.iterate(Z=>T(B(Z))))}some(B){let T=!1;return this.iterate(Z=>(T=B(Z),!T)),T}findFirst(B){let T;return this.iterate(Z=>B(Z)?(T=Z,!1):!0),T}findLast(B){let T;return this.iterate(Z=>(B(Z)&&(T=Z),!0)),T}findLastMaxBy(B){let T,Z=!0;return this.iterate(he=>((Z||H.isGreaterThan(B(he,T)))&&(Z=!1,T=he),!0)),T}}e.$_b=G}),define(se[137],re([0,1,14]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function A(d,u){if(!d)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=A;function s(d,u="Unreachable"){throw new Error(u)}e.$4c=s;function M(d){if(!d)throw new S.$bb("Assertion Failed")}e.$5c=M;function C(d){if(!d()){debugger;d(),(0,S.$Z)(new S.$bb("Assertion Failed"))}}e.$6c=C;function P(d,u){let b=0;for(;b<d.length-1;){const y=d[b],p=d[b+1];if(!u(y,p))return!1;b++}return!0}e.$7c=P}),define(se[84],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function S(A,s){const M=this;let C=!1,P;return function(){if(C)return P;if(C=!0,s)try{P=A.apply(M,arguments)}finally{s()}else P=A.apply(M,arguments);return P}}e.$cb=S}),define(se[71],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(A){function s(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}A.is=s;const M=Object.freeze([]);function C(){return M}A.empty=C;function*P(f){yield f}A.single=P;function d(f){return s(f)?f:P(f)}A.wrap=d;function u(f){return f||M}A.from=u;function*b(f){for(let i=f.length-1;i>=0;i--)yield f[i]}A.reverse=b;function y(f){return!f||f[Symbol.iterator]().next().done===!0}A.isEmpty=y;function p(f){return f[Symbol.iterator]().next().value}A.first=p;function l(f,i){for(const o of f)if(i(o))return!0;return!1}A.some=l;function v(f,i){for(const o of f)if(i(o))return o}A.find=v;function*$(f,i){for(const o of f)i(o)&&(yield o)}A.filter=$;function*w(f,i){let o=0;for(const r of f)yield i(r,o++)}A.map=w;function*g(...f){for(const i of f)for(const o of i)yield o}A.concat=g;function h(f,i,o){let r=o;for(const t of f)r=i(r,t);return r}A.reduce=h;function*a(f,i,o=f.length){for(i<0&&(i+=f.length),o<0?o+=f.length:o>f.length&&(o=f.length);i<o;i++)yield f[i]}A.slice=a;function k(f,i=Number.POSITIVE_INFINITY){const o=[];if(i===0)return[o,f];const r=f[Symbol.iterator]();for(let t=0;t<i;t++){const n=r.next();if(n.done)return[o,A.empty()];o.push(n.value)}return[o,{[Symbol.iterator](){return r}}]}A.consume=k})(S||(e.Iterable=S={}))}),define(se[44],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var s;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function C(i,o=!1){let r=0;const t=i.length;let n="",c=0,m=16,D=0;function I(Y){let ae=0,oe=0;for(;ae<Y;){const ce=i.charCodeAt(r);if(ce>=48&&ce<=57)oe=oe*16+ce-48;else if(ce>=65&&ce<=70)oe=oe*16+ce-65+10;else if(ce>=97&&ce<=102)oe=oe*16+ce-97+10;else break;r++,ae++}return ae<Y&&(oe=-1),oe}function E(Y){r=Y,n="",c=0,m=16,D=0}function R(){const Y=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&u(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&u(i.charCodeAt(r)))for(r++;r<i.length&&u(i.charCodeAt(r));)r++;else return D=3,i.substring(Y,r);let ae=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&u(i.charCodeAt(r))){for(r++;r<i.length&&u(i.charCodeAt(r));)r++;ae=r}else D=3;return i.substring(Y,ae)}function L(){let Y="",ae=r;for(;;){if(r>=t){Y+=i.substring(ae,r),D=2;break}const oe=i.charCodeAt(r);if(oe===34){Y+=i.substring(ae,r),r++;break}if(oe===92){if(Y+=i.substring(ae,r),r++,r>=t){D=2;break}switch(i.charCodeAt(r++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:{const Q=I(4);Q>=0?Y+=String.fromCharCode(Q):D=4;break}default:D=5}ae=r;continue}if(oe>=0&&oe<=31)if(d(oe)){Y+=i.substring(ae,r),D=2;break}else D=6;r++}return Y}function F(){if(n="",D=0,c=r,r>=t)return c=t,m=17;let Y=i.charCodeAt(r);if(P(Y)){do r++,n+=String.fromCharCode(Y),Y=i.charCodeAt(r);while(P(Y));return m=15}if(d(Y))return r++,n+=String.fromCharCode(Y),Y===13&&i.charCodeAt(r)===10&&(r++,n+=`
`),m=14;switch(Y){case 123:return r++,m=1;case 125:return r++,m=2;case 91:return r++,m=3;case 93:return r++,m=4;case 58:return r++,m=6;case 44:return r++,m=5;case 34:return r++,n=L(),m=10;case 47:{const ae=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<t&&!d(i.charCodeAt(r));)r++;return n=i.substring(ae,r),m=12}if(i.charCodeAt(r+1)===42){r+=2;const oe=t-1;let ce=!1;for(;r<oe;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,ce=!0;break}r++}return ce||(r++,D=1),n=i.substring(ae,r),m=13}return n+=String.fromCharCode(Y),r++,m=16}case 45:if(n+=String.fromCharCode(Y),r++,r===t||!u(i.charCodeAt(r)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=R(),m=11;default:for(;r<t&&U(Y);)r++,Y=i.charCodeAt(r);if(c!==r){switch(n=i.substring(c,r),n){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return n+=String.fromCharCode(Y),r++,m=16}}function U(Y){if(P(Y)||d(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let Y;do Y=F();while(Y>=12&&Y<=15);return Y}return{setPosition:E,getPosition:()=>r,scan:o?x:F,getToken:()=>m,getTokenValue:()=>n,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>D}}e.$3m=C;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function d(i){return i===10||i===13||i===8232||i===8233}function u(i){return i>=48&&i<=57}var b;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(b||(b={}));function y(i,o){const r=[],t=new Object;let n;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function D(I,E,R,L){c.value=I,c.offset=E,c.length=R,c.type=L,c.colonOffset=void 0,n=c}try{a(i,{onObjectBegin:(I,E)=>{if(o<=I)throw t;n=void 0,m=o>I,r.push("")},onObjectProperty:(I,E,R)=>{if(o<E||(D(I,E,R,"property"),r[r.length-1]=I,o<=E+R))throw t},onObjectEnd:(I,E)=>{if(o<=I)throw t;n=void 0,r.pop()},onArrayBegin:(I,E)=>{if(o<=I)throw t;n=void 0,r.push(0)},onArrayEnd:(I,E)=>{if(o<=I)throw t;n=void 0,r.pop()},onLiteralValue:(I,E,R)=>{if(o<E||(D(I,E,R,f(I)),o<=E+R))throw t},onSeparator:(I,E,R)=>{if(o<=E)throw t;if(I===":"&&n&&n.type==="property")n.colonOffset=E,m=!1,n=void 0;else if(I===","){const L=r[r.length-1];typeof L=="number"?r[r.length-1]=L+1:(m=!0,r[r.length-1]=""),n=void 0}}})}catch(I){if(I!==t)throw I}return{path:r,previousNode:n,isAtPropertyKey:m,matches:I=>{let E=0;for(let R=0;E<I.length&&R<r.length;R++)if(I[E]===r[R]||I[E]==="*")E++;else if(I[E]!=="**")return!1;return E===I.length}}}e.$4m=y;function p(i,o=[],r=M.DEFAULT){let t=null,n=[];const c=[];function m(I){Array.isArray(n)?n.push(I):t!==null&&(n[t]=I)}return a(i,{onObjectBegin:()=>{const I={};m(I),c.push(n),n=I,t=null},onObjectProperty:I=>{t=I},onObjectEnd:()=>{n=c.pop()},onArrayBegin:()=>{const I=[];m(I),c.push(n),n=I,t=null},onArrayEnd:()=>{n=c.pop()},onLiteralValue:m,onError:(I,E,R)=>{o.push({error:I,offset:E,length:R})}},r),n[0]}e.$5m=p;function l(i,o=[],r=M.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(I){t.type==="property"&&(t.length=I-t.offset,t=t.parent)}function c(I){return t.children.push(I),I}a(i,{onObjectBegin:I=>{t=c({type:"object",offset:I,length:-1,parent:t,children:[]})},onObjectProperty:(I,E,R)=>{t=c({type:"property",offset:E,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:I,offset:E,length:R,parent:t})},onObjectEnd:(I,E)=>{t.length=I+E-t.offset,t=t.parent,n(I+E)},onArrayBegin:(I,E)=>{t=c({type:"array",offset:I,length:-1,parent:t,children:[]})},onArrayEnd:(I,E)=>{t.length=I+E-t.offset,t=t.parent,n(I+E)},onLiteralValue:(I,E,R)=>{c({type:f(I),offset:E,length:R,parent:t,value:I}),n(E+R)},onSeparator:(I,E,R)=>{t.type==="property"&&(I===":"?t.colonOffset=E:I===","&&n(E))},onError:(I,E,R)=>{o.push({error:I,offset:E,length:R})}},r);const D=t.children[0];return D&&delete D.parent,D}e.$6m=l;function v(i,o){if(!i)return;let r=i;for(const t of o)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===t){r=c.children[1],n=!0;break}if(!n)return}else{const n=t;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$7m=v;function $(i){if(!i.parent||!i.parent.children)return[];const o=$(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;o.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&o.push(r)}return o}e.$8m=$;function w(i){switch(i.type){case"array":return i.children.map(w);case"object":{const o=Object.create(null);for(const r of i.children){const t=r.children[1];t&&(o[r.children[0].value]=w(t))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$9m=w;function g(i,o,r=!1){return o>=i.offset&&o<i.offset+i.length||r&&o===i.offset+i.length}e.$0m=g;function h(i,o,r=!1){if(g(i,o,r)){const t=i.children;if(Array.isArray(t))for(let n=0;n<t.length&&t[n].offset<=o;n++){const c=h(t[n],o,r);if(c)return c}return i}}e.$$m=h;function a(i,o,r=M.DEFAULT){const t=C(i,!1);function n(q){return q?()=>q(t.getTokenOffset(),t.getTokenLength()):()=>!0}function c(q){return q?_=>q(_,t.getTokenOffset(),t.getTokenLength()):()=>!0}const m=n(o.onObjectBegin),D=c(o.onObjectProperty),I=n(o.onObjectEnd),E=n(o.onArrayBegin),R=n(o.onArrayEnd),L=c(o.onLiteralValue),F=c(o.onSeparator),U=n(o.onComment),x=c(o.onError),Y=r&&r.disallowComments,ae=r&&r.allowTrailingComma;function oe(){for(;;){const q=t.scan();switch(t.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:Y||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(q){case 12:case 13:Y?ce(10):U();break;case 16:ce(1);break;case 15:case 14:break;default:return q}}}function ce(q,_=[],ne=[]){if(x(q),_.length+ne.length>0){let X=t.getToken();for(;X!==17;){if(_.indexOf(X)!==-1){oe();break}else if(ne.indexOf(X)!==-1)break;X=oe()}}}function Q(q){const _=t.getTokenValue();return q?L(_):D(_),oe(),!0}function K(){switch(t.getToken()){case 11:{let q=0;try{q=JSON.parse(t.getTokenValue()),typeof q!="number"&&(ce(2),q=0)}catch{ce(2)}L(q);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return oe(),!0}function V(){return t.getToken()!==10?(ce(3,[],[2,5]),!1):(Q(!1),t.getToken()===6?(F(":"),oe(),H()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function z(){m(),oe();let q=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(q||ce(4,[],[]),F(","),oe(),t.getToken()===2&&ae)break}else q&&ce(6,[],[]);V()||ce(4,[],[2,5]),q=!0}return I(),t.getToken()!==2?ce(7,[2],[]):oe(),!0}function W(){E(),oe();let q=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(q||ce(4,[],[]),F(","),oe(),t.getToken()===4&&ae)break}else q&&ce(6,[],[]);H()||ce(4,[],[4,5]),q=!0}return R(),t.getToken()!==4?ce(8,[4],[]):oe(),!0}function H(){switch(t.getToken()){case 3:return W();case 1:return z();case 10:return Q(!0);default:return K()}}return oe(),t.getToken()===17?r.allowEmptyContent?!0:(ce(4,[],[]),!1):H()?(t.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}e.$_m=a;function k(i,o){const r=C(i),t=[];let n,c=0,m;do switch(m=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:c!==m&&t.push(i.substring(c,m)),o!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,o)),c=r.getPosition();break}while(n!==17);return t.join("")}e.$an=k;function f(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$bn=f}),define(se[138],re([0,1,44]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yT=e.$xT=e.$wT=e.$vT=void 0;function A(u,b,y){let p,l,v,$,w;if(b){for($=b.offset,w=$+b.length,v=$;v>0&&!d(u,v-1);)v--;let m=w;for(;m<u.length&&!d(u,m);)m++;l=u.substring(v,m),p=C(l,y)}else l=u,p=0,v=0,$=0,w=u.length;const g=P(y,u);let h=!1,a=0,k;y.insertSpaces?k=M(" ",y.tabSize||4):k="	";const f=(0,S.$3m)(l,!1);let i=!1;function o(){return g+M(k,p+a)}function r(){let m=f.scan();for(h=!1;m===15||m===14;)h=h||m===14,m=f.scan();return i=m===16||f.getTokenError()!==0,m}const t=[];function n(m,D,I){!i&&D<w&&I>$&&u.substring(D,I)!==m&&t.push({offset:D,length:I-D,content:m})}let c=r();if(c!==17){const m=f.getTokenOffset()+v,D=M(k,p);n(D,v,m)}for(;c!==17;){let m=f.getTokenOffset()+f.getTokenLength()+v,D=r(),I="";for(;!h&&(D===12||D===13);){const R=f.getTokenOffset()+v;n(" ",m,R),m=f.getTokenOffset()+f.getTokenLength()+v,I=D===12?o():"",D=r()}if(D===2)c!==1&&(a--,I=o());else if(D===4)c!==3&&(a--,I=o());else{switch(c){case 3:case 1:a++,I=o();break;case 5:case 12:I=o();break;case 13:h?I=o():I=" ";break;case 6:I=" ";break;case 10:if(D===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:D===12||D===13?I=" ":D!==5&&D!==17&&(i=!0);break;case 16:i=!0;break}h&&(D===12||D===13)&&(I=o())}const E=f.getTokenOffset()+v;n(I,m,E),c=D}return t}e.$vT=A;function s(u,b){const y=JSON.stringify(u,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?y.replace(/\r\n|\r|\n/g,b.eol):y}e.$wT=s;function M(u,b){let y="";for(let p=0;p<b;p++)y+=u;return y}function C(u,b){let y=0,p=0;const l=b.tabSize||4;for(;y<u.length;){const v=u.charAt(y);if(v===" ")p++;else if(v==="	")p+=l;else break;y++}return Math.floor(p/l)}function P(u,b){for(let y=0;y<b.length;y++){const p=b.charAt(y);if(p==="\r")return y+1<b.length&&b.charAt(y+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return u&&u.eol||`
`}e.$xT=P;function d(u,b){return`\r
`.indexOf(u.charAt(b))!==-1}e.$yT=d}),define(se[139],re([0,1,44,138]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DT=e.$CT=e.$BT=e.$AT=e.$zT=void 0;function s(u,b,y){return M(u,b,void 0,y)}e.$zT=s;function M(u,b,y,p,l){const v=b.slice(),$=[],w=(0,S.$6m)(u,$);let g,h;for(;v.length>0&&(h=v.pop(),g=(0,S.$7m)(w,v),g===void 0&&y!==void 0);)typeof h=="string"?y={[h]:y}:y=[y];if(g)if(g.type==="object"&&typeof h=="string"&&Array.isArray(g.children)){const a=(0,S.$7m)(g,[h]);if(a!==void 0)if(y===void 0){if(!a.parent)throw new Error("Malformed AST");const k=g.children.indexOf(a.parent);let f,i=a.parent.offset+a.parent.length;if(k>0){const o=g.children[k-1];f=o.offset+o.length}else f=g.offset+1,g.children.length>1&&(i=g.children[1].offset);return C(u,{offset:f,length:i-f,content:""},p)}else return C(u,{offset:a.offset,length:a.length,content:JSON.stringify(y)},p);else{if(y===void 0)return[];const k=`${JSON.stringify(h)}: ${JSON.stringify(y)}`,f=l?l(g.children.map(o=>o.children[0].value)):g.children.length;let i;if(f>0){const o=g.children[f-1];i={offset:o.offset+o.length,length:0,content:","+k}}else g.children.length===0?i={offset:g.offset+1,length:0,content:k}:i={offset:g.offset+1,length:0,content:k+","};return C(u,i,p)}}else if(g.type==="array"&&typeof h=="number"&&Array.isArray(g.children))if(y!==void 0){const a=`${JSON.stringify(y)}`;let k;if(g.children.length===0||h===0)k={offset:g.offset+1,length:0,content:g.children.length===0?a:a+","};else{const f=h===-1||h>g.children.length?g.children.length:h,i=g.children[f-1];k={offset:i.offset+i.length,length:0,content:","+a}}return C(u,k,p)}else{const a=h,k=g.children[a];let f;if(g.children.length===1)f={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===a){const i=g.children[a-1],o=i.offset+i.length,r=g.offset+g.length;f={offset:o,length:r-2-o,content:""}}else f={offset:k.offset,length:g.children[a+1].offset-k.offset,content:""};return C(u,f,p)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${g.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return C(u,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(y)},p)}}e.$AT=M;function C(u,b,y){let p=P(u,b),l=b.offset,v=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;l>0&&!(0,A.$yT)(p,l-1);)l--;for(;v<p.length&&!(0,A.$yT)(p,v);)v++}const $=(0,A.$vT)(p,{offset:l,length:v-l},y);for(let g=$.length-1;g>=0;g--){const h=$[g];p=P(p,h),l=Math.min(l,h.offset),v=Math.max(v,h.offset+h.length),v+=h.content.length-h.length}const w=u.length-(p.length-v)-l;return[{offset:l,length:w,content:p.substring(l,v)}]}e.$BT=C;function P(u,b){return u.substring(0,b.offset)+b.content+u.substring(b.offset+b.length)}e.$CT=P;function d(u,b){const y=b.slice(0).sort((l,v)=>{const $=l.offset-v.offset;return $===0?l.length-v.length:$});let p=u.length;for(let l=y.length-1;l>=0;l--){const v=y[l];if(v.offset+v.length<=p)u=P(u,v);else throw new Error("Overlapping edit");p=v.offset}return u}e.$DT=d}),define(se[72],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class S{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=S}),define(se[101],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class S{static{this.Undefined=new S(void 0)}constructor(M){this.element=M,this.next=S.Undefined,this.prev=S.Undefined}}class A{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let M=this.a;for(;M!==S.Undefined;){const C=M.next;M.prev=S.Undefined,M.next=S.Undefined,M=C}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,C){const P=new S(M);if(this.a===S.Undefined)this.a=P,this.b=P;else if(C){const u=this.b;this.b=P,P.prev=u,u.next=P}else{const u=this.a;this.a=P,P.next=u,u.prev=P}this.c+=1;let d=!1;return()=>{d||(d=!0,this.e(P))}}shift(){if(this.a!==S.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==S.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==S.Undefined&&M.next!==S.Undefined){const C=M.prev;C.next=M.next,M.next.prev=C}else M.prev===S.Undefined&&M.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):M.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):M.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==S.Undefined;)yield M.element,M=M.next}}e.$2c=A}),define(se[31],re([0,1]),function(J,e){"use strict";var S,A,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function M(h,a,k){let f=h.get(a);return f===void 0&&(f=k,h.set(a,f)),f}e.$wc=M;function C(h){const a=[];return h.forEach((k,f)=>{a.push(`${f} => ${k}`)}),`Map(${h.size}) {${a.join(", ")}}`}e.$xc=C;function P(h){const a=[];return h.forEach(k=>{a.push(k)}),`Set(${h.size}) {${a.join(", ")}}`}e.$yc=P;class d{constructor(a,k){this.uri=a,this.value=k}}function u(h){return Array.isArray(h)}class b{static{this.a=a=>a.toString()}constructor(a,k){if(this[S]="ResourceMap",a instanceof b)this.b=new Map(a.b),this.c=k??b.a;else if(u(a)){this.b=new Map,this.c=k??b.a;for(const[f,i]of a)this.set(f,i)}else this.b=new Map,this.c=a??b.a}set(a,k){return this.b.set(this.c(a),new d(a,k)),this}get(a){return this.b.get(this.c(a))?.value}has(a){return this.b.has(this.c(a))}get size(){return this.b.size}clear(){this.b.clear()}delete(a){return this.b.delete(this.c(a))}forEach(a,k){typeof k<"u"&&(a=a.bind(k));for(const[f,i]of this.b)a(i.value,i.uri,this)}*values(){for(const a of this.b.values())yield a.value}*keys(){for(const a of this.b.values())yield a.uri}*entries(){for(const a of this.b.values())yield[a.uri,a.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.b)yield[a.uri,a.value]}}e.$zc=b;class y{constructor(a,k){this[A]="ResourceSet",!a||typeof a=="function"?this.a=new b(a):(this.a=new b(k),a.forEach(this.add,this))}get size(){return this.a.size}add(a){return this.a.set(a,a),this}clear(){this.a.clear()}delete(a){return this.a.delete(a)}forEach(a,k){this.a.forEach((f,i)=>a.call(k,i,i,this))}has(a){return this.a.has(a)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=y;var p;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class l{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(a){return this.a.has(a)}get(a,k=0){const f=this.a.get(a);if(f)return k!==0&&this.j(f,k),f.value}set(a,k,f=0){let i=this.a.get(a);if(i)i.value=k,f!==0&&this.j(i,f);else{switch(i={key:a,value:k,next:void 0,previous:void 0},f){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(a,i),this.d++}return this}delete(a){return!!this.remove(a)}remove(a){const k=this.a.get(a);if(k)return this.a.delete(a),this.i(k),this.d--,k.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const a=this.b;return this.a.delete(a.key),this.i(a),this.d--,a.value}forEach(a,k){const f=this.e;let i=this.b;for(;i;){if(k?a.bind(k)(i.value,i.key,this):a(i.value,i.key,this),this.e!==f)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const a=this,k=this.e;let f=this.b;const i={[Symbol.iterator](){return i},next(){if(a.e!==k)throw new Error("LinkedMap got modified during iteration.");if(f){const o={value:f.key,done:!1};return f=f.next,o}else return{value:void 0,done:!0}}};return i}values(){const a=this,k=this.e;let f=this.b;const i={[Symbol.iterator](){return i},next(){if(a.e!==k)throw new Error("LinkedMap got modified during iteration.");if(f){const o={value:f.value,done:!1};return f=f.next,o}else return{value:void 0,done:!0}}};return i}entries(){const a=this,k=this.e;let f=this.b;const i={[Symbol.iterator](){return i},next(){if(a.e!==k)throw new Error("LinkedMap got modified during iteration.");if(f){const o={value:[f.key,f.value],done:!1};return f=f.next,o}else return{value:void 0,done:!0}}};return i}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(a){if(a>=this.size)return;if(a===0){this.clear();return}let k=this.b,f=this.size;for(;k&&f>a;)this.a.delete(k.key),k=k.next,f--;this.b=k,this.d=f,k&&(k.previous=void 0),this.e++}g(a){if(!this.b&&!this.c)this.c=a;else if(this.b)a.next=this.b,this.b.previous=a;else throw new Error("Invalid list");this.b=a,this.e++}h(a){if(!this.b&&!this.c)this.b=a;else if(this.c)a.previous=this.c,this.c.next=a;else throw new Error("Invalid list");this.c=a,this.e++}i(a){if(a===this.b&&a===this.c)this.b=void 0,this.c=void 0;else if(a===this.b){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.b=a.next}else if(a===this.c){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.c=a.previous}else{const k=a.next,f=a.previous;if(!k||!f)throw new Error("Invalid list");k.previous=f,f.next=k}a.next=void 0,a.previous=void 0,this.e++}j(a,k){if(!this.b||!this.c)throw new Error("Invalid list");if(!(k!==1&&k!==2)){if(k===1){if(a===this.b)return;const f=a.next,i=a.previous;a===this.c?(i.next=void 0,this.c=i):(f.previous=i,i.next=f),a.previous=void 0,a.next=this.b,this.b.previous=a,this.b=a,this.e++}else if(k===2){if(a===this.c)return;const f=a.next,i=a.previous;a===this.b?(f.previous=void 0,this.b=f):(f.previous=i,i.next=f),a.next=void 0,a.previous=this.c,this.c.next=a,this.c=a,this.e++}}}toJSON(){const a=[];return this.forEach((k,f)=>{a.push([f,k])}),a}fromJSON(a){this.clear();for(const[k,f]of a)this.set(k,f)}}e.$Bc=l;class v extends l{constructor(a,k=1){super(),this.k=a,this.l=Math.min(Math.max(0,k),1)}get limit(){return this.k}set limit(a){this.k=a,this.m()}get ratio(){return this.l}set ratio(a){this.l=Math.min(Math.max(0,a),1),this.m()}get(a,k=2){return super.get(a,k)}peek(a){return super.get(a,0)}set(a,k){return super.set(a,k,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=v;class ${constructor(){this.a=new Map}add(a){return this.a.set(a,(this.a.get(a)||0)+1),this}delete(a){let k=this.a.get(a)||0;return k===0?!1:(k--,k===0?this.a.delete(a):this.a.set(a,k),!0)}has(a){return this.a.has(a)}}e.$Dc=$;class w{constructor(a){if(this.a=new Map,this.b=new Map,a)for(const[k,f]of a)this.set(k,f)}clear(){this.a.clear(),this.b.clear()}set(a,k){this.a.set(a,k),this.b.set(k,a)}get(a){return this.a.get(a)}getKey(a){return this.b.get(a)}delete(a){const k=this.a.get(a);return k===void 0?!1:(this.a.delete(a),this.b.delete(k),!0)}forEach(a,k){this.a.forEach((f,i)=>{a.call(k,f,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=w;class g{constructor(){this.a=new Map}add(a,k){let f=this.a.get(a);f||(f=new Set,this.a.set(a,f)),f.add(k)}delete(a,k){const f=this.a.get(a);f&&(f.delete(k),f.size===0&&this.a.delete(a))}forEach(a,k){const f=this.a.get(a);f&&f.forEach(k)}get(a){const k=this.a.get(a);return k||new Set}}e.$Fc=g}),define(se[2],re([0,1,23,135,31,84,71]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const P=!1;let d=null;class u{constructor(){this.b=new Map}static{this.a=0}c(L){let F=this.b.get(L);return F||(F={parent:null,source:null,isSingleton:!1,value:L,idx:u.a++},this.b.set(L,F)),F}trackDisposable(L){const F=this.c(L);F.source||(F.source=new Error().stack)}setParent(L,F){const U=this.c(L);U.parent=F}markAsDisposed(L){this.b.delete(L)}markAsSingleton(L){this.c(L).isSingleton=!0}f(L,F){const U=F.get(L);if(U)return U;const x=L.parent?this.f(this.c(L.parent),F):L;return F.set(L,x),x}getTrackedDisposables(){const L=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,L).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(L=10,F){let U;if(F)U=F;else{const ce=new Map,Q=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,ce).isSingleton);if(Q.length===0)return;const K=new Set(Q.map(V=>V.value));if(U=Q.filter(V=>!(V.parent&&K.has(V.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function x(ce){function Q(V,z){for(;V.length>0&&z.some(W=>typeof W=="string"?W===V[0]:V[0].match(W));)V.shift()}const K=ce.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return Q(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const Y=new s.$Fc;for(const ce of U){const Q=x(ce);for(let K=0;K<=Q.length;K++)Y.add(Q.slice(0,K).join(`
`),ce)}U.sort((0,S.$6b)(ce=>ce.idx,S.$8b));let ae="",oe=0;for(const ce of U.slice(0,L)){oe++;const Q=x(ce),K=[];for(let V=0;V<Q.length;V++){let z=Q[V];z=`(shared with ${Y.get(Q.slice(0,V+1).join(`
`)).size}/${U.length} leaks) at ${z}`;const H=Y.get(Q.slice(0,V).join(`
`)),q=(0,A.$J)([...H].map(_=>x(_)[V]),_=>_);delete q[Q[V]];for(const[_,ne]of Object.entries(q))K.unshift(`    - stacktraces of ${ne.length} other leaks continue with ${_}`);K.unshift(z)}ae+=`


==================== Leaking disposable ${oe}/${U.length}: ${ce.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return U.length>L&&(ae+=`


... and ${U.length-L} more leaking disposables

`),{leaks:U,details:ae}}}e.$Gc=u;function b(R){d=R}if(e.$Hc=b,P){const R="__is_disposable_tracked__";b(new class{trackDisposable(L){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[R]||console.log(F)},3e3)}setParent(L,F){if(L&&L!==i.None)try{L[R]=!0}catch{}}markAsDisposed(L){if(L&&L!==i.None)try{L[R]=!0}catch{}}markAsSingleton(L){}})}function y(R){return d?.trackDisposable(R),R}e.$Ic=y;function p(R){d?.markAsDisposed(R)}e.$Jc=p;function l(R,L){d?.setParent(R,L)}function v(R,L){if(d)for(const F of R)d.setParent(F,L)}function $(R){return d?.markAsSingleton(R),R}e.$Kc=$;function w(R){return typeof R.dispose=="function"&&R.dispose.length===0}e.$Lc=w;function g(R){if(C.Iterable.is(R)){const L=[];for(const F of R)if(F)try{F.dispose()}catch(U){L.push(U)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}e.$Mc=g;function h(R){for(const L of R)w(L)&&L.dispose();return[]}e.$Nc=h;function a(...R){const L=k(()=>g(R));return v(R,L),L}e.$Oc=a;function k(R){const L=y({dispose:(0,M.$cb)(()=>{p(L),R()})});return L}e.$Pc=k;class f{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return l(L,this),this.g?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(L),L}delete(L){if(L){if(L===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(L),L.dispose()}}deleteAndLeak(L){L&&this.f.has(L)&&(this.f.delete(L),l(L,null))}}e.$Qc=f;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new f,y(this),l(this.q,this)}dispose(){p(this),this.q.dispose()}B(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(L)}}e.$Rc=i;class o{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(L){this.b||L===this.a||(this.a?.dispose(),L&&l(L,this),this.a=L)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const L=this.a;return this.a=void 0,L&&l(L,null),L}}e.$Sc=o;class r{constructor(L){this.a=new o,this.b=!1,this.a.value=L}get value(){return this.a.value}set value(L){this.b||L===this.a.value||(this.a.value=L)}dispose(){this.b=!0,this.a.dispose()}}e.$Tc=r;class t{constructor(L){this.b=L,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=t;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(L){let F=L;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,p(this))},this}}e.$Vc=n;class c{constructor(){this.a=new Map}acquire(L,...F){let U=this.a.get(L);U||(U={counter:0,object:this.b(L,...F)},this.a.set(L,U));const{object:x}=U,Y=(0,M.$cb)(()=>{--U.counter===0&&(this.c(L,U.object),this.a.delete(L))});return U.counter++,{object:x,dispose:Y}}}e.$Wc=c;class m{constructor(L){this.a=L}async acquire(L,...F){const U=this.a.acquire(L,...F);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(x){throw U.dispose(),x}}}e.$Xc=m;class D{constructor(L){this.object=L}dispose(){}}e.$Yc=D;function I(R){const L=new f;try{R(L)}finally{L.dispose()}}e.$Zc=I;class E{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(L){return this.a.has(L)}get size(){return this.a.size}get(L){return this.a.get(L)}set(L,F,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(L)?.dispose(),this.a.set(L,F)}deleteAndDispose(L){this.a.get(L)?.dispose(),this.a.delete(L)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=E}),define(se[85],re([0,1,31]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=e.$wl=void 0;const A=new S.$Cc(1e4);function s(u){return d(u,"NFC",A)}e.$wl=s;const M=new S.$Cc(1e4);function C(u){return d(u,"NFD",M)}e.$xl=C;const P=/[^\u0000-\u0080]/;function d(u,b,y){if(!u)return u;const p=y.get(u);if(p)return p;let l;return P.test(u)?l=u.normalize(b):l=u,y.set(u,l),l}e.$yl=function(){const u=/[\u0300-\u036f]/g;return function(b){return C(b).replace(u,"")}}()}),define(se[140],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.rot=e.$Wl=void 0;function S(P,d,u){return Math.min(Math.max(P,d),u)}e.$Wl=S;function A(P,d){return(d+P%d)%d}e.rot=A;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Yl=s;class M{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Zl=M;class C{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const u=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$1l=C}),function(){function J(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function C(d){M.push(d,Date.now())}function P(){const d=[];for(let u=0;u<M.length;u+=2)d.push({name:M[u],startTime:M[u+1]});return d}return{mark:C,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const C of performance.getEntriesByType("mark"))M.push({name:C.name,startTime:Math.round(s+C.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function S(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=S(A))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var A in S)(typeof exports=="object"?exports:J)[A]=S[A]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function S(A){if(e[A])return e[A].exports;var s=e[A]={i:A,l:!1,exports:{}};return J[A].call(s.exports,s,s.exports,S),s.l=!0,s.exports}return S.m=J,S.c=e,S.d=function(A,s,M){S.o(A,s)||Object.defineProperty(A,s,{enumerable:!0,get:M})},S.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},S.t=function(A,s){if(1&s&&(A=S(A)),8&s||4&s&&typeof A=="object"&&A&&A.__esModule)return A;var M=Object.create(null);if(S.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:A}),2&s&&typeof A!="string")for(var C in A)S.d(M,C,function(P){return A[P]}.bind(null,C));return M},S.n=function(A){var s=A&&A.__esModule?function(){return A.default}:function(){return A};return S.d(s,"a",s),s},S.o=function(A,s){return Object.prototype.hasOwnProperty.call(A,s)},S.p="",S(S.s=0)}([function(J,e,S){(function(A){var s;e=J.exports=ne,s=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],d=e.src=[],u=0,b=u++;d[b]="0|[1-9]\\d*";var y=u++;d[y]="[0-9]+";var p=u++;d[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=u++;d[l]="("+d[b]+")\\.("+d[b]+")\\.("+d[b]+")";var v=u++;d[v]="("+d[y]+")\\.("+d[y]+")\\.("+d[y]+")";var $=u++;d[$]="(?:"+d[b]+"|"+d[p]+")";var w=u++;d[w]="(?:"+d[y]+"|"+d[p]+")";var g=u++;d[g]="(?:-("+d[$]+"(?:\\."+d[$]+")*))";var h=u++;d[h]="(?:-?("+d[w]+"(?:\\."+d[w]+")*))";var a=u++;d[a]="[0-9A-Za-z-]+";var k=u++;d[k]="(?:\\+("+d[a]+"(?:\\."+d[a]+")*))";var f=u++,i="v?"+d[l]+d[g]+"?"+d[k]+"?";d[f]="^"+i+"$";var o="[v=\\s]*"+d[v]+d[h]+"?"+d[k]+"?",r=u++;d[r]="^"+o+"$";var t=u++;d[t]="((?:<|>)?=?)";var n=u++;d[n]=d[y]+"|x|X|\\*";var c=u++;d[c]=d[b]+"|x|X|\\*";var m=u++;d[m]="[v=\\s]*("+d[c]+")(?:\\.("+d[c]+")(?:\\.("+d[c]+")(?:"+d[g]+")?"+d[k]+"?)?)?";var D=u++;d[D]="[v=\\s]*("+d[n]+")(?:\\.("+d[n]+")(?:\\.("+d[n]+")(?:"+d[h]+")?"+d[k]+"?)?)?";var I=u++;d[I]="^"+d[t]+"\\s*"+d[m]+"$";var E=u++;d[E]="^"+d[t]+"\\s*"+d[D]+"$";var R=u++;d[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=u++;d[L]="(?:~>?)";var F=u++;d[F]="(\\s*)"+d[L]+"\\s+",P[F]=new RegExp(d[F],"g");var U=u++;d[U]="^"+d[L]+d[m]+"$";var x=u++;d[x]="^"+d[L]+d[D]+"$";var Y=u++;d[Y]="(?:\\^)";var ae=u++;d[ae]="(\\s*)"+d[Y]+"\\s+",P[ae]=new RegExp(d[ae],"g");var oe=u++;d[oe]="^"+d[Y]+d[m]+"$";var ce=u++;d[ce]="^"+d[Y]+d[D]+"$";var Q=u++;d[Q]="^"+d[t]+"\\s*("+o+")$|^$";var K=u++;d[K]="^"+d[t]+"\\s*("+i+")$|^$";var V=u++;d[V]="(\\s*)"+d[t]+"\\s*("+o+"|"+d[m]+")",P[V]=new RegExp(d[V],"g");var z=u++;d[z]="^\\s*("+d[m]+")\\s+-\\s+("+d[m]+")\\s*$";var W=u++;d[W]="^\\s*("+d[D]+")\\s+-\\s+("+d[D]+")\\s*$";var H=u++;d[H]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)s(q,d[q]),P[q]||(P[q]=new RegExp(d[q]));function _(ee,ue){if(ee instanceof ne)return ee;if(typeof ee!="string"||ee.length>M||!(ue?P[r]:P[f]).test(ee))return null;try{return new ne(ee,ue)}catch{return null}}function ne(ee,ue){if(ee instanceof ne){if(ee.loose===ue)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ne))return new ne(ee,ue);s("SemVer",ee,ue),this.loose=ue;var ge=ee.trim().match(ue?P[r]:P[f]);if(!ge)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Re){if(/^[0-9]+$/.test(Re)){var De=+Re;if(De>=0&&De<C)return De}return Re}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=_,e.valid=function(ee,ue){var ge=_(ee,ue);return ge?ge.version:null},e.clean=function(ee,ue){var ge=_(ee.trim().replace(/^[=v]+/,""),ue);return ge?ge.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(ee){return s("SemVer.compare",this.version,this.loose,ee),ee instanceof ne||(ee=new ne(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},ne.prototype.compareMain=function(ee){return ee instanceof ne||(ee=new ne(ee,this.loose)),O(this.major,ee.major)||O(this.minor,ee.minor)||O(this.patch,ee.patch)},ne.prototype.comparePre=function(ee){if(ee instanceof ne||(ee=new ne(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var ue=0;do{var ge=this.prerelease[ue],Re=ee.prerelease[ue];if(s("prerelease compare",ue,ge,Re),ge===void 0&&Re===void 0)return 0;if(Re===void 0)return 1;if(ge===void 0)return-1;if(ge!==Re)return O(ge,Re)}while(++ue)},ne.prototype.inc=function(ee,ue){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,ue,ge,Re){typeof ge=="string"&&(Re=ge,ge=void 0);try{return new ne(ee,ge).inc(ue,Re).version}catch{return null}},e.diff=function(ee,ue){if(B(ee,ue))return null;var ge=_(ee),Re=_(ue);if(ge.prerelease.length||Re.prerelease.length){for(var De in ge)if((De==="major"||De==="minor"||De==="patch")&&ge[De]!==Re[De])return"pre"+De;return"prerelease"}for(var De in ge)if((De==="major"||De==="minor"||De==="patch")&&ge[De]!==Re[De])return De},e.compareIdentifiers=O;var X=/^[0-9]+$/;function O(ee,ue){var ge=X.test(ee),Re=X.test(ue);return ge&&Re&&(ee=+ee,ue=+ue),ge&&!Re?-1:Re&&!ge?1:ee<ue?-1:ee>ue?1:0}function N(ee,ue,ge){return new ne(ee,ge).compare(new ne(ue,ge))}function G(ee,ue,ge){return N(ee,ue,ge)>0}function j(ee,ue,ge){return N(ee,ue,ge)<0}function B(ee,ue,ge){return N(ee,ue,ge)===0}function T(ee,ue,ge){return N(ee,ue,ge)!==0}function Z(ee,ue,ge){return N(ee,ue,ge)>=0}function he(ee,ue,ge){return N(ee,ue,ge)<=0}function de(ee,ue,ge,Re){var De;switch(ue){case"===":typeof ee=="object"&&(ee=ee.version),typeof ge=="object"&&(ge=ge.version),De=ee===ge;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ge=="object"&&(ge=ge.version),De=ee!==ge;break;case"":case"=":case"==":De=B(ee,ge,Re);break;case"!=":De=T(ee,ge,Re);break;case">":De=G(ee,ge,Re);break;case">=":De=Z(ee,ge,Re);break;case"<":De=j(ee,ge,Re);break;case"<=":De=he(ee,ge,Re);break;default:throw new TypeError("Invalid operator: "+ue)}return De}function le(ee,ue){if(ee instanceof le){if(ee.loose===ue)return ee;ee=ee.value}if(!(this instanceof le))return new le(ee,ue);s("comparator",ee,ue),this.loose=ue,this.parse(ee),this.semver===we?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(ee,ue){return O(ue,ee)},e.major=function(ee,ue){return new ne(ee,ue).major},e.minor=function(ee,ue){return new ne(ee,ue).minor},e.patch=function(ee,ue){return new ne(ee,ue).patch},e.compare=N,e.compareLoose=function(ee,ue){return N(ee,ue,!0)},e.rcompare=function(ee,ue,ge){return N(ue,ee,ge)},e.sort=function(ee,ue){return ee.sort(function(ge,Re){return e.compare(ge,Re,ue)})},e.rsort=function(ee,ue){return ee.sort(function(ge,Re){return e.rcompare(ge,Re,ue)})},e.gt=G,e.lt=j,e.eq=B,e.neq=T,e.gte=Z,e.lte=he,e.cmp=de,e.Comparator=le;var we={};function be(ee,ue){if(ee instanceof be)return ee.loose===ue?ee:new be(ee.raw,ue);if(ee instanceof le)return new be(ee.value,ue);if(!(this instanceof be))return new be(ee,ue);if(this.loose=ue,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Ee(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Se(ee,ue,ge,Re,De,Fe,Me,Ve,ze,ie,fe,$e,ye){return((ue=Ee(ge)?"":Ee(Re)?">="+ge+".0.0":Ee(De)?">="+ge+"."+Re+".0":">="+ue)+" "+(Ve=Ee(ze)?"":Ee(ie)?"<"+(+ze+1)+".0.0":Ee(fe)?"<"+ze+"."+(+ie+1)+".0":$e?"<="+ze+"."+ie+"."+fe+"-"+$e:"<="+Ve)).trim()}function je(ee,ue){for(var ge=0;ge<ee.length;ge++)if(!ee[ge].test(ue))return!1;if(ue.prerelease.length){for(ge=0;ge<ee.length;ge++)if(s(ee[ge].semver),ee[ge].semver!==we&&ee[ge].semver.prerelease.length>0){var Re=ee[ge].semver;if(Re.major===ue.major&&Re.minor===ue.minor&&Re.patch===ue.patch)return!0}return!1}return!0}function ke(ee,ue,ge){try{ue=new be(ue,ge)}catch{return!1}return ue.test(ee)}function pe(ee,ue,ge,Re){var De,Fe,Me,Ve,ze;switch(ee=new ne(ee,Re),ue=new be(ue,Re),ge){case">":De=G,Fe=he,Me=j,Ve=">",ze=">=";break;case"<":De=j,Fe=Z,Me=G,Ve="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(ee,ue,Re))return!1;for(var ie=0;ie<ue.set.length;++ie){var fe=ue.set[ie],$e=null,ye=null;if(fe.forEach(function(Ce){Ce.semver===we&&(Ce=new le(">=0.0.0")),$e=$e||Ce,ye=ye||Ce,De(Ce.semver,$e.semver,Re)?$e=Ce:Me(Ce.semver,ye.semver,Re)&&(ye=Ce)}),$e.operator===Ve||$e.operator===ze||(!ye.operator||ye.operator===Ve)&&Fe(ee,ye.semver)||ye.operator===ze&&Me(ee,ye.semver))return!1}return!0}le.prototype.parse=function(ee){var ue=this.loose?P[Q]:P[K],ge=ee.match(ue);if(!ge)throw new TypeError("Invalid comparator: "+ee);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new ne(ge[2],this.loose):this.semver=we},le.prototype.toString=function(){return this.value},le.prototype.test=function(ee){return s("Comparator.test",ee,this.loose),this.semver===we||(typeof ee=="string"&&(ee=new ne(ee,this.loose)),de(ee,this.operator,this.semver,this.loose))},le.prototype.intersects=function(ee,ue){if(!(ee instanceof le))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(ee.value,ue),ke(this.value,ge,ue);if(ee.operator==="")return ge=new be(this.value,ue),ke(ee.semver,ge,ue);var Re=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Fe=this.semver.version===ee.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Ve=de(this.semver,"<",ee.semver,ue)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),ze=de(this.semver,">",ee.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return Re||De||Fe&&Me||Ve||ze},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ee){var ue=this.loose;ee=ee.trim(),s("range",ee,ue);var ge=ue?P[W]:P[z];ee=ee.replace(ge,Se),s("hyphen replace",ee),ee=ee.replace(P[V],"$1$2$3"),s("comparator trim",ee,P[V]),ee=(ee=(ee=ee.replace(P[F],"$1~")).replace(P[ae],"$1^")).split(/\s+/).join(" ");var Re=ue?P[Q]:P[K],De=ee.split(" ").map(function(Fe){return function(Me,Ve){return s("comp",Me),Me=function(ze,ie){return ze.trim().split(/\s+/).map(function(fe){return function($e,ye){s("caret",$e,ye);var Ce=ye?P[ce]:P[oe];return $e.replace(Ce,function(Ue,Le,We,qe,Ge){var Xe;return s("caret",$e,Ue,Le,We,qe,Ge),Ee(Le)?Xe="":Ee(We)?Xe=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ee(qe)?Xe=Le==="0"?">="+Le+"."+We+".0 <"+Le+"."+(+We+1)+".0":">="+Le+"."+We+".0 <"+(+Le+1)+".0.0":Ge?(s("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Xe=Le==="0"?We==="0"?">="+Le+"."+We+"."+qe+Ge+" <"+Le+"."+We+"."+(+qe+1):">="+Le+"."+We+"."+qe+Ge+" <"+Le+"."+(+We+1)+".0":">="+Le+"."+We+"."+qe+Ge+" <"+(+Le+1)+".0.0"):(s("no pr"),Xe=Le==="0"?We==="0"?">="+Le+"."+We+"."+qe+" <"+Le+"."+We+"."+(+qe+1):">="+Le+"."+We+"."+qe+" <"+Le+"."+(+We+1)+".0":">="+Le+"."+We+"."+qe+" <"+(+Le+1)+".0.0"),s("caret return",Xe),Xe})}(fe,ie)}).join(" ")}(Me,Ve),s("caret",Me),Me=function(ze,ie){return ze.trim().split(/\s+/).map(function(fe){return function($e,ye){var Ce=ye?P[x]:P[U];return $e.replace(Ce,function(Ue,Le,We,qe,Ge){var Xe;return s("tilde",$e,Ue,Le,We,qe,Ge),Ee(Le)?Xe="":Ee(We)?Xe=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ee(qe)?Xe=">="+Le+"."+We+".0 <"+Le+"."+(+We+1)+".0":Ge?(s("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Xe=">="+Le+"."+We+"."+qe+Ge+" <"+Le+"."+(+We+1)+".0"):Xe=">="+Le+"."+We+"."+qe+" <"+Le+"."+(+We+1)+".0",s("tilde return",Xe),Xe})}(fe,ie)}).join(" ")}(Me,Ve),s("tildes",Me),Me=function(ze,ie){return s("replaceXRanges",ze,ie),ze.split(/\s+/).map(function(fe){return function($e,ye){$e=$e.trim();var Ce=ye?P[E]:P[I];return $e.replace(Ce,function(Ue,Le,We,qe,Ge,Xe){s("xRange",$e,Ue,Le,We,qe,Ge,Xe);var _e=Ee(We),Ye=_e||Ee(qe),it=Ye||Ee(Ge);return Le==="="&&it&&(Le=""),_e?Ue=Le===">"||Le==="<"?"<0.0.0":"*":Le&&it?(Ye&&(qe=0),it&&(Ge=0),Le===">"?(Le=">=",Ye?(We=+We+1,qe=0,Ge=0):it&&(qe=+qe+1,Ge=0)):Le==="<="&&(Le="<",Ye?We=+We+1:qe=+qe+1),Ue=Le+We+"."+qe+"."+Ge):Ye?Ue=">="+We+".0.0 <"+(+We+1)+".0.0":it&&(Ue=">="+We+"."+qe+".0 <"+We+"."+(+qe+1)+".0"),s("xRange return",Ue),Ue})}(fe,ie)}).join(" ")}(Me,Ve),s("xrange",Me),Me=function(ze,ie){return s("replaceStars",ze,ie),ze.trim().replace(P[H],"")}(Me,Ve),s("stars",Me),Me}(Fe,ue)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Fe){return!!Fe.match(Re)})),De=De.map(function(Fe){return new le(Fe,ue)})},be.prototype.intersects=function(ee,ue){if(!(ee instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Re){return ee.set.some(function(De){return De.every(function(Fe){return Re.intersects(Fe,ue)})})})})},e.toComparators=function(ee,ue){return new be(ee,ue).set.map(function(ge){return ge.map(function(Re){return Re.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new ne(ee,this.loose));for(var ue=0;ue<this.set.length;ue++)if(je(this.set[ue],ee))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(ee,ue,ge){var Re=null,De=null;try{var Fe=new be(ue,ge)}catch{return null}return ee.forEach(function(Me){Fe.test(Me)&&(Re&&De.compare(Me)!==-1||(De=new ne(Re=Me,ge)))}),Re},e.minSatisfying=function(ee,ue,ge){var Re=null,De=null;try{var Fe=new be(ue,ge)}catch{return null}return ee.forEach(function(Me){Fe.test(Me)&&(Re&&De.compare(Me)!==1||(De=new ne(Re=Me,ge)))}),Re},e.validRange=function(ee,ue){try{return new be(ee,ue).range||"*"}catch{return null}},e.ltr=function(ee,ue,ge){return pe(ee,ue,"<",ge)},e.gtr=function(ee,ue,ge){return pe(ee,ue,">",ge)},e.outside=pe,e.prerelease=function(ee,ue){var ge=_(ee,ue);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ee,ue,ge){return ee=new be(ee,ge),ue=new be(ue,ge),ee.intersects(ue)},e.coerce=function(ee){if(ee instanceof ne)return ee;if(typeof ee!="string")return null;var ue=ee.match(P[R]);return ue==null?null:_((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,S(1))},function(J,e){var S,A,s=J.exports={};function M(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function P(w){if(S===setTimeout)return setTimeout(w,0);if((S===M||!S)&&setTimeout)return S=setTimeout,setTimeout(w,0);try{return S(w,0)}catch{try{return S.call(null,w,0)}catch{return S.call(this,w,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:M}catch{S=M}try{A=typeof clearTimeout=="function"?clearTimeout:C}catch{A=C}})();var d,u=[],b=!1,y=-1;function p(){b&&d&&(b=!1,d.length?u=d.concat(u):y=-1,u.length&&l())}function l(){if(!b){var w=P(p);b=!0;for(var g=u.length;g;){for(d=u,u=[];++y<g;)d&&d[y].run();y=-1,g=u.length}d=null,b=!1,function(h){if(A===clearTimeout)return clearTimeout(h);if((A===C||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(h);try{A(h)}catch{try{return A.call(null,h)}catch{return A.call(this,h)}}}(w)}}function v(w,g){this.fun=w,this.array=g}function $(){}s.nextTick=function(w){var g=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)g[h-1]=arguments[h];u.push(new v(w,g)),u.length!==1||b||P(l)},v.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=$,s.addListener=$,s.once=$,s.off=$,s.removeListener=$,s.removeAllListeners=$,s.emit=$,s.prependListener=$,s.prependOnceListener=$,s.listeners=function(w){return[]},s.binding=function(w){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(w){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(se[141],re([0,1]),function(J,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=void 0;class A{constructor(P,d,u){this.level=P,this.key=d,this.value=u,this.forward=[]}}const s=void 0;class M{constructor(P,d=2**16){this.comparator=P,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(d)|0),this.e=new A(this.c,s,s)}get size(){return this.f}clear(){this.e=new A(this.c,s,s),this.f=0}has(P){return!!M.g(this,P,this.comparator)}get(P){return M.g(this,P,this.comparator)?.value}set(P,d){return M.h(this,P,d,this.comparator)&&(this.f+=1),this}delete(P){const d=M.k(this,P,this.comparator);return d&&(this.f-=1),d}forEach(P,d){let u=this.e.forward[0];for(;u;)P.call(d,u.value,u.key,this),u=u.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",d=this.e.forward[0];for(;d;)P+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return P}static g(P,d,u){let b=P.e;for(let y=P.d-1;y>=0;y--)for(;b.forward[y]&&u(b.forward[y].key,d)<0;)b=b.forward[y];if(b=b.forward[0],b&&u(b.key,d)===0)return b}static h(P,d,u,b){const y=[];let p=P.e;for(let l=P.d-1;l>=0;l--){for(;p.forward[l]&&b(p.forward[l].key,d)<0;)p=p.forward[l];y[l]=p}if(p=p.forward[0],p&&b(p.key,d)===0)return p.value=u,!1;{const l=M.j(P);if(l>P.d){for(let v=P.d;v<l;v++)y[v]=P.e;P.d=l}p=new A(l,d,u);for(let v=0;v<l;v++)p.forward[v]=y[v].forward[v],y[v].forward[v]=p;return!0}}static j(P,d=.5){let u=1;for(;Math.random()<d&&u<P.c;)u+=1;return u}static k(P,d,u){const b=[];let y=P.e;for(let p=P.d-1;p>=0;p--){for(;y.forward[p]&&u(y.forward[p].key,d)<0;)y=y.forward[p];b[p]=y}if(y=y.forward[0],!y||u(y.key,d)!==0)return!1;for(let p=0;p<P.d&&b[p].forward[p]===y;p++)b[p].forward[p]=y.forward[p];for(;P.d>0&&P.e.forward[P.d-1]===s;)P.d-=1;return!0}}e.$Gr=M}),define(se[73],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0;const S=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(M){return new A(M)}constructor(M){this.c=S&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Nd=A}),define(se[3],re([0,1,14,84,2,101,73]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.Event=void 0;const P=!1,d=!1;var u;(function(I){I.None=()=>s.$Rc.None;function E(de){if(d){const{onDidAddListener:le}=de,we=v.create();let be=0;de.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),we.print()),le?.()}}}function R(de,le){return K(de,()=>{},0,void 0,!0,void 0,le)}I.defer=R;function L(de){return(le,we=null,be)=>{let Ee=!1,Se;return Se=de(je=>{if(!Ee)return Se?Se.dispose():Ee=!0,le.call(we,je)},null,be),Ee&&Se.dispose(),Se}}I.once=L;function F(de,le,we){return ce((be,Ee=null,Se)=>de(je=>be.call(Ee,le(je)),null,Se),we)}I.map=F;function U(de,le,we){return ce((be,Ee=null,Se)=>de(je=>{le(je),be.call(Ee,je)},null,Se),we)}I.forEach=U;function x(de,le,we){return ce((be,Ee=null,Se)=>de(je=>le(je)&&be.call(Ee,je),null,Se),we)}I.filter=x;function Y(de){return de}I.signal=Y;function ae(...de){return(le,we=null,be)=>{const Ee=(0,s.$Oc)(...de.map(Se=>Se(je=>le.call(we,je))));return Q(Ee,be)}}I.any=ae;function oe(de,le,we,be){let Ee=we;return F(de,Se=>(Ee=le(Ee,Se),Ee),be)}I.reduce=oe;function ce(de,le){let we;const be={onWillAddFirstListener(){we=de(Ee.fire,Ee)},onDidRemoveLastListener(){we?.dispose()}};le||E(be);const Ee=new a(be);return le?.add(Ee),Ee.event}function Q(de,le){return le instanceof Array?le.push(de):le&&le.add(de),de}function K(de,le,we=100,be=!1,Ee=!1,Se,je){let ke,pe,ee,ue=0,ge;const Re={leakWarningThreshold:Se,onWillAddFirstListener(){ke=de(Fe=>{ue++,pe=le(pe,Fe),be&&!ee&&(De.fire(pe),pe=void 0),ge=()=>{const Me=pe;pe=void 0,ee=void 0,(!be||ue>1)&&De.fire(Me),ue=0},typeof we=="number"?(clearTimeout(ee),ee=setTimeout(ge,we)):ee===void 0&&(ee=0,queueMicrotask(ge))})},onWillRemoveListener(){Ee&&ue>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,ke.dispose()}};je||E(Re);const De=new a(Re);return je?.add(De),De.event}I.debounce=K;function V(de,le=0,we){return I.debounce(de,(be,Ee)=>be?(be.push(Ee),be):[Ee],le,void 0,!0,void 0,we)}I.accumulate=V;function z(de,le=(be,Ee)=>be===Ee,we){let be=!0,Ee;return x(de,Se=>{const je=be||!le(Se,Ee);return be=!1,Ee=Se,je},we)}I.latch=z;function W(de,le,we){return[I.filter(de,le,we),I.filter(de,be=>!le(be),we)]}I.split=W;function H(de,le=!1,we=[],be){let Ee=we.slice(),Se=de(pe=>{Ee?Ee.push(pe):ke.fire(pe)});be&&be.add(Se);const je=()=>{Ee?.forEach(pe=>ke.fire(pe)),Ee=null},ke=new a({onWillAddFirstListener(){Se||(Se=de(pe=>ke.fire(pe)),be&&be.add(Se))},onDidAddFirstListener(){Ee&&(le?setTimeout(je):je())},onDidRemoveLastListener(){Se&&Se.dispose(),Se=null}});return be&&be.add(ke),ke.event}I.buffer=H;function q(de,le){return(be,Ee,Se)=>{const je=le(new ne);return de(function(ke){const pe=je.evaluate(ke);pe!==_&&be.call(Ee,pe)},void 0,Se)}}I.chain=q;const _=Symbol("HaltChainable");class ne{constructor(){this.f=[]}map(le){return this.f.push(le),this}forEach(le){return this.f.push(we=>(le(we),we)),this}filter(le){return this.f.push(we=>le(we)?we:_),this}reduce(le,we){let be=we;return this.f.push(Ee=>(be=le(be,Ee),be)),this}latch(le=(we,be)=>we===be){let we=!0,be;return this.f.push(Ee=>{const Se=we||!le(Ee,be);return we=!1,be=Ee,Se?Ee:_}),this}evaluate(le){for(const we of this.f)if(le=we(le),le===_)break;return le}}function X(de,le,we=be=>be){const be=(...ke)=>je.fire(we(...ke)),Ee=()=>de.on(le,be),Se=()=>de.removeListener(le,be),je=new a({onWillAddFirstListener:Ee,onDidRemoveLastListener:Se});return je.event}I.fromNodeEventEmitter=X;function O(de,le,we=be=>be){const be=(...ke)=>je.fire(we(...ke)),Ee=()=>de.addEventListener(le,be),Se=()=>de.removeEventListener(le,be),je=new a({onWillAddFirstListener:Ee,onDidRemoveLastListener:Se});return je.event}I.fromDOMEventEmitter=O;function N(de){return new Promise(le=>L(de)(le))}I.toPromise=N;function G(de){const le=new a;return de.then(we=>{le.fire(we)},()=>{le.fire(void 0)}).finally(()=>{le.dispose()}),le.event}I.fromPromise=G;function j(de,le,we){return le(we),de(be=>le(be))}I.runAndSubscribe=j;function B(de,le){let we=null;function be(Se){we?.dispose(),we=new s.$Qc,le(Se,we)}be(void 0);const Ee=de(Se=>be(Se));return(0,s.$Pc)(()=>{Ee.dispose(),we?.dispose()})}I.runAndSubscribeWithStore=B;class T{constructor(le,we){this._observable=le,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{le.addObserver(this)},onDidRemoveLastListener:()=>{le.removeObserver(this)}};we||E(be),this.emitter=new a(be),we&&we.add(this.emitter)}beginUpdate(le){this.f++}handlePossibleChange(le){}handleChange(le,we){this.g=!0}endUpdate(le){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Z(de,le){return new T(de,le).emitter.event}I.fromObservable=Z;function he(de){return le=>{let we=0,be=!1;const Ee={beginUpdate(){we++},endUpdate(){we--,we===0&&(de.reportChanges(),be&&(be=!1,le()))},handlePossibleChange(){},handleChange(){be=!0}};return de.addObserver(Ee),de.reportChanges(),{dispose(){de.removeObserver(Ee)}}}}I.fromObservableLight=he})(u||(e.Event=u={}));class b{static{this.all=new Set}static{this.f=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${b.f++}`,b.all.add(this)}start(E){this.g=new C.$Nd,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$Pd=b;let y=-1;function p(I){const E=y;return y=I,{dispose(){y=E}}}e.$Qd=p;class l{constructor(E,R=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=R,this.g=0}dispose(){this.f?.clear()}check(E,R){const L=this.threshold;if(L<=0||R<L)return;this.f||(this.f=new Map);const F=this.f.get(E.value)||0;if(this.f.set(E.value,F+1),this.g-=1,this.g<=0){this.g=L*.5;let U,x=0;for(const[Y,ae]of this.f)(!U||x<ae)&&(U=Y,x=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${R} listeners already. MOST frequent listener (${x}):`),console.warn(U)}return()=>{const U=this.f.get(E.value)||0;this.f.set(E.value,U-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let $=0;class w{constructor(E){this.value=E,this.id=$++}}const g=2,h=(I,E)=>{if(I instanceof w)E(I);else for(let R=0;R<I.length;R++){const L=I[R];L&&E(L)}};class a{constructor(E){this.w=0,this.f=E,this.g=y>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??y):void 0,this.j=this.f?._profName?new b(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const E=this.t;queueMicrotask(()=>{h(E,R=>R.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(E,R,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Rc.None;if(this.m)return s.$Rc.None;R&&(E=E.bind(R));const F=new w(E);let U,x;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=v.create(),U=this.g.check(F.stack,this.w+1)),P&&(F.stack=x??v.create()),this.t?this.t instanceof w?(this.u??=new f,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const Y=(0,s.$Pc)(()=>{U?.(),this.x(F)});return L instanceof s.$Qc?L.add(Y):Array.isArray(L)&&L.push(Y),Y},this.q}x(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const R=this.t,L=R.indexOf(E);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,R[L]=void 0;const F=this.u.current===this;if(this.w*g<=R.length){let U=0;for(let x=0;x<R.length;x++)R[x]?R[U++]=R[x]:F&&(this.u.end--,U<this.u.i&&this.u.i--);R.length=U}}y(E,R){if(!E)return;const L=this.f?.onListenerError||S.$Z;if(!L){E.value(R);return}try{E.value(R)}catch(F){L(F)}}z(E){const R=E.current.t;for(;E.i<E.end;)this.y(R[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof w)this.y(this.t,E);else{const R=this.u;R.enqueue(this,E,this.t.length),this.z(R)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Rd=a;const k=()=>new f;e.$Sd=k;class f{constructor(){this.i=-1,this.end=0}enqueue(E,R,L){this.i=0,this.end=L,this.current=E,this.value=R}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends a{async fireAsync(E,R,L){if(this.t)for(this.h||(this.h=new M.$2c),h(this.t,F=>this.h.push([F.value,E]));this.h.size>0&&!R.isCancellationRequested;){const[F,U]=this.h.shift(),x=[],Y={...U,token:R,waitUntil:ae=>{if(Object.isFrozen(x))throw new Error("waitUntil can NOT be called asynchronous");L&&(ae=L(ae,F)),x.push(ae)}};try{F(Y)}catch(ae){(0,S.$Z)(ae);continue}Object.freeze(x),await Promise.allSettled(x).then(ae=>{for(const oe of ae)oe.status==="rejected"&&(0,S.$Z)(oe.reason)})}}}e.$Td=i;class o extends a{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new M.$2c,this.A=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.A(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.w&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$Ud=o;class r extends o{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$Vd=r;class t extends a{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(R=>super.fire(R)),this.h=[]}))}}e.$Wd=t;class n{constructor(){this.g=!1,this.h=[],this.f=new a({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const R={event:E,listener:null};this.h.push(R),this.g&&this.m(R);const L=()=>{this.g&&this.o(R);const F=this.h.indexOf(R);this.h.splice(F,1)};return(0,s.$Pc)((0,A.$cb)(L))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(R=>this.f.fire(R))}o(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.f.dispose()}}e.$Xd=n;class c{constructor(E,R,L,F){this.f=new s.$Qc;const U=this.f.add(new n),x=this.f.add(new s.$1c);function Y(ae){x.set(ae,U.add(F(ae)))}for(const ae of E)Y(ae);this.f.add(R(ae=>{Y(ae)})),this.f.add(L(ae=>{x.deleteAndDispose(ae)})),this.event=U.event}dispose(){this.f.dispose()}}e.$Yd=c;class m{constructor(){this.f=[]}wrapEvent(E){return(R,L,F)=>E(U=>{const x=this.f[this.f.length-1];x?x.push(()=>R.call(L,U)):R.call(L,U)},void 0,F)}bufferEvents(E){const R=[];this.f.push(R);const L=E();return this.f.pop(),R.forEach(F=>F()),L}}e.$Zd=m;class D{constructor(){this.f=!1,this.g=u.None,this.h=s.$Rc.None,this.j=new a({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$1d=D}),define(se[22],re([0,1,3]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.CancellationToken=void 0;const A=Object.freeze(function(P,d){const u=setTimeout(P.bind(d),0);return{dispose(){clearTimeout(u)}}});var s;(function(P){function d(u){return u===P.None||u===P.Cancelled||u instanceof M?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}P.isCancellationToken=d,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new S.$Rd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(d){this.f=void 0,this.g=void 0,this.g=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(d=!1){d&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$2d=C}),define(se[142],re([0,1,22]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=void 0;class A{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new S.$2d,d=this.b(P.token);return this.a={promise:d,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$Ae=A;class s{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const d=JSON.stringify(P);return this.b!==d&&(this.b=d,this.a=this.c(P)),this.a}}e.$Be=s;class M{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const d=this.b(P);return this.a.set(P,d),d}}e.$Ce=M}),define(se[62],re([0,1,14,2]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function s(k){const f=k;return f?typeof f.read=="function":!1}e.$3d=s;function M(k){const f=k;return f?[f.on,f.pause,f.resume,f.destroy].every(i=>typeof i=="function"):!1}e.$4d=M;function C(k){const f=k;return f?M(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.$5d=C;function P(k,f){return new d(k,f)}e.$6d=P;class d{constructor(f,i){this.e=f,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(i=>i(f))}h(f){this.c.error.length===0?(0,S.$Z)(f):this.c.error.slice(0).forEach(i=>i(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,i){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(f,i){if(this.a.destroyed)return;let o;switch(f){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(i);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(k,f){const i=[];let o;for(;(o=k.read())!==null;)i.push(o);return f(i)}e.$7d=u;function b(k,f,i){const o=[];let r;for(;(r=k.read())!==null&&o.length<i;)o.push(r);return r===null&&o.length>0?f(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const t=r;return r=void 0,t}return k.read()}}}e.$8d=b;function y(k,f){return new Promise((i,o)=>{const r=[];p(k,{onData:t=>{f&&r.push(t)},onError:t=>{f?o(t):i(void 0)},onEnd:()=>{i(f?f(r):void 0)}})})}e.$9d=y;function p(k,f,i){k.on("error",o=>{i?.isCancellationRequested||f.onError(o)}),k.on("end",()=>{i?.isCancellationRequested||f.onEnd()}),k.on("data",o=>{i?.isCancellationRequested||f.onData(o)})}e.$0d=p;function l(k,f){return new Promise((i,o)=>{const r=new A.$Qc,t=[],n=D=>{if(t.push(D),t.length>f)return r.dispose(),k.pause(),i({stream:k,buffer:t,ended:!1})},c=D=>(r.dispose(),o(D)),m=()=>(r.dispose(),i({stream:k,buffer:t,ended:!0}));r.add((0,A.$Pc)(()=>k.removeListener("error",c))),k.on("error",c),r.add((0,A.$Pc)(()=>k.removeListener("end",m))),k.on("end",m),r.add((0,A.$Pc)(()=>k.removeListener("data",n))),k.on("data",n)})}e.$$d=l;function v(k,f){const i=P(f);return i.end(k),i}e.$_d=v;function $(){const k=P(()=>{throw new Error("not supported")});return k.end(),k}e.$ae=$;function w(k){let f=!1;return{read:()=>f?null:(f=!0,k)}}e.$be=w;function g(k,f,i){const o=P(i);return p(k,{onData:r=>o.write(f.data(r)),onError:r=>o.error(f.error?f.error(r):r),onEnd:()=>o.end()}),o}e.$ce=g;function h(k,f,i){let o=!1;return{read:()=>{const r=f.read();return o?r:(o=!0,r!==null?i([k,r]):k)}}}e.$de=h;function a(k,f,i){let o=!1;const r=P(i);return p(f,{onData:t=>o?r.write(t):(o=!0,r.write(i([k,t]))),onError:t=>r.error(t),onEnd:()=>{o||(o=!0,r.write(k)),r.end()}}),r}e.$ee=a}),define(se[18],re([0,1,72,62]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const s=typeof Buffer<"u",M=new S.$U(()=>new Uint8Array(256));let C,P;class d{static alloc(R){return s?new d(Buffer.allocUnsafe(R)):new d(new Uint8Array(R))}static wrap(R){return s&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new d(R)}static fromString(R,L){return!(L?.dontUseNodeBuffer||!1)&&s?new d(Buffer.from(R)):(C||(C=new TextEncoder),new d(C.encode(R)))}static fromByteArray(R){const L=d.alloc(R.length);for(let F=0,U=R.length;F<U;F++)L.buffer[F]=R[F];return L}static concat(R,L){if(typeof L>"u"){L=0;for(let x=0,Y=R.length;x<Y;x++)L+=R[x].byteLength}const F=d.alloc(L);let U=0;for(let x=0,Y=R.length;x<Y;x++){const ae=R[x];F.set(ae,U),U+=ae.byteLength}return F}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=d.alloc(this.byteLength);return R.set(this),R}toString(){return s?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(R,L){return new d(this.buffer.subarray(R,L))}set(R,L){if(R instanceof d)this.buffer.set(R.buffer,L);else if(R instanceof Uint8Array)this.buffer.set(R,L);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),L);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return p(this.buffer,R)}writeUInt32BE(R,L){l(this.buffer,R,L)}readUInt32LE(R){return v(this.buffer,R)}writeUInt32LE(R,L){$(this.buffer,R,L)}readUInt8(R){return w(this.buffer,R)}writeUInt8(R,L){g(this.buffer,R,L)}indexOf(R,L=0){return u(this.buffer,R instanceof d?R.buffer:R,L)}}e.$fe=d;function u(E,R,L=0){const F=R.byteLength,U=E.byteLength;if(F===0)return 0;if(F===1)return E.indexOf(R[0]);if(F>U-L)return-1;const x=M.value;x.fill(R.length);for(let ce=0;ce<R.length;ce++)x[R[ce]]=R.length-ce-1;let Y=L+R.length-1,ae=Y,oe=-1;for(;Y<U;)if(E[Y]===R[ae]){if(ae===0){oe=Y;break}Y--,ae--}else Y+=Math.max(R.length-ae,x[E[Y]]),ae=R.length-1;return oe}e.$ge=u;function b(E,R){return E[R+0]<<0>>>0|E[R+1]<<8>>>0}e.$he=b;function y(E,R,L){E[L+0]=R&255,R=R>>>8,E[L+1]=R&255}e.$ie=y;function p(E,R){return E[R]*2**24+E[R+1]*2**16+E[R+2]*2**8+E[R+3]}e.$je=p;function l(E,R,L){E[L+3]=R,R=R>>>8,E[L+2]=R,R=R>>>8,E[L+1]=R,R=R>>>8,E[L]=R}e.$ke=l;function v(E,R){return E[R+0]<<0>>>0|E[R+1]<<8>>>0|E[R+2]<<16>>>0|E[R+3]<<24>>>0}e.$le=v;function $(E,R,L){E[L+0]=R&255,R=R>>>8,E[L+1]=R&255,R=R>>>8,E[L+2]=R&255,R=R>>>8,E[L+3]=R&255}e.$me=$;function w(E,R){return E[R]}e.$ne=w;function g(E,R,L){E[L]=R}e.$oe=g;function h(E){return A.$7d(E,R=>d.concat(R))}e.$pe=h;function a(E){return A.$be(E)}e.$qe=a;function k(E){return A.$9d(E,R=>d.concat(R))}e.$re=k;async function f(E){return E.ended?d.concat(E.buffer):d.concat([...E.buffer,await k(E.stream)])}e.$se=f;function i(E){return A.$_d(E,R=>d.concat(R))}e.$te=i;function o(E){return A.$ce(E,{data:R=>typeof R=="string"?d.fromString(R):d.wrap(R)},R=>d.concat(R))}e.$ue=o;function r(E){return A.$6d(R=>d.concat(R),E)}e.$ve=r;function t(E,R){return A.$de(E,R,L=>d.concat(L))}e.$we=t;function n(E,R){return A.$ee(E,R,L=>d.concat(L))}e.$xe=n;function c(E){let R=0,L=0,F=0;const U=new Uint8Array(Math.floor(E.length/4*3)),x=ae=>{switch(L){case 3:U[F++]=R|ae,L=0;break;case 2:U[F++]=R|ae>>>2,R=ae<<6,L=3;break;case 1:U[F++]=R|ae>>>4,R=ae<<4,L=2;break;default:R=ae<<2,L=1}};for(let ae=0;ae<E.length;ae++){const oe=E.charCodeAt(ae);if(oe>=65&&oe<=90)x(oe-65);else if(oe>=97&&oe<=122)x(oe-97+26);else if(oe>=48&&oe<=57)x(oe-48+52);else if(oe===43||oe===45)x(62);else if(oe===47||oe===95)x(63);else{if(oe===61)break;throw new SyntaxError(`Unexpected base64 character ${E[ae]}`)}}const Y=F;for(;L>0;)x(0);return d.wrap(U).slice(0,Y)}e.$ye=c;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:E},R=!0,L=!1){const F=L?D:m;let U="";const x=E.byteLength%3;let Y=0;for(;Y<E.byteLength-x;Y+=3){const ae=E[Y+0],oe=E[Y+1],ce=E[Y+2];U+=F[ae>>>2],U+=F[(ae<<4|oe>>>4)&63],U+=F[(oe<<2|ce>>>6)&63],U+=F[ce&63]}if(x===1){const ae=E[Y+0];U+=F[ae>>>2],U+=F[ae<<4&63],R&&(U+="==")}else if(x===2){const ae=E[Y+0],oe=E[Y+1];U+=F[ae>>>2],U+=F[(ae<<4|oe>>>4)&63],U+=F[oe<<2&63],R&&(U+="=")}return U}e.$ze=I}),define(se[25],re([0,1,142,72]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bf=e.$Af=e.$zf=e.$yf=e.GraphemeBreakType=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=void 0;function s(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.$Fe=s;const M=/{(\d+)}/g;function C(ie,...fe){return fe.length===0?ie:ie.replace(M,function($e,ye){const Ce=parseInt(ye,10);return isNaN(Ce)||Ce<0||Ce>=fe.length?$e:fe[Ce]})}e.$Ge=C;const P=/{([^}]+)}/g;function d(ie,fe){return Object.keys(fe).length===0?ie:ie.replace(P,($e,ye)=>fe[ye]??$e)}e.$He=d;function u(ie){return ie.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$Ie=u;function b(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Je=b;function y(ie,fe){let $e=0;const ye=fe.charCodeAt(0);for(let Ce=ie.length-1;Ce>=0;Ce--)ie.charCodeAt(Ce)===ye&&$e++;return $e}e.$Ke=y;function p(ie,fe,$e="\u2026"){return ie.length<=fe?ie:`${ie.substr(0,fe)}${$e}`}e.$Le=p;function l(ie,fe=" "){const $e=v(ie,fe);return $($e,fe)}e.$Me=l;function v(ie,fe){if(!ie||!fe)return ie;const $e=fe.length;if($e===0||ie.length===0)return ie;let ye=0;for(;ie.indexOf(fe,ye)===ye;)ye=ye+$e;return ie.substring(ye)}e.$Ne=v;function $(ie,fe){if(!ie||!fe)return ie;const $e=fe.length,ye=ie.length;if($e===0||ye===0)return ie;let Ce=ye,Ue=-1;for(;Ue=ie.lastIndexOf(fe,Ce-1),!(Ue===-1||Ue+$e!==Ce);){if(Ue===0)return"";Ce=Ue}return ie.substring(0,Ce)}e.$Oe=$;function w(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Pe=w;function g(ie){return ie.replace(/\*/g,"")}e.$Qe=g;function h(ie,fe,$e={}){if(!ie)throw new Error("Cannot create regex from empty string");fe||(ie=b(ie)),$e.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(ie,ye)}e.$Re=h;function a(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.$Se=a;function k(ie){return ie.split(/\r\n|\r|\n/)}e.$Te=k;function f(ie){for(let fe=0,$e=ie.length;fe<$e;fe++){const ye=ie.charCodeAt(fe);if(ye!==32&&ye!==9)return fe}return-1}e.$Ue=f;function i(ie,fe=0,$e=ie.length){for(let ye=fe;ye<$e;ye++){const Ce=ie.charCodeAt(ye);if(Ce!==32&&Ce!==9)return ie.substring(fe,ye)}return ie.substring(fe,$e)}e.$Ve=i;function o(ie,fe=ie.length-1){for(let $e=fe;$e>=0;$e--){const ye=ie.charCodeAt($e);if(ye!==32&&ye!==9)return $e}return-1}e.$We=o;function r(ie,fe,$e){const ye=[];let Ce=0;for(const Ue of ie.matchAll(fe)){if(ye.push(ie.slice(Ce,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");Ce=Ue.index+Ue[0].length,ye.push($e(Ue[0],...Ue.slice(1),Ue.index,ie,Ue.groups))}return ye.push(ie.slice(Ce)),Promise.all(ye).then(Ue=>Ue.join(""))}e.$Xe=r;function t(ie,fe){return ie<fe?-1:ie>fe?1:0}e.$Ye=t;function n(ie,fe,$e=0,ye=ie.length,Ce=0,Ue=fe.length){for(;$e<ye&&Ce<Ue;$e++,Ce++){const qe=ie.charCodeAt($e),Ge=fe.charCodeAt(Ce);if(qe<Ge)return-1;if(qe>Ge)return 1}const Le=ye-$e,We=Ue-Ce;return Le<We?-1:Le>We?1:0}e.$Ze=n;function c(ie,fe){return m(ie,fe,0,ie.length,0,fe.length)}e.$1e=c;function m(ie,fe,$e=0,ye=ie.length,Ce=0,Ue=fe.length){for(;$e<ye&&Ce<Ue;$e++,Ce++){let qe=ie.charCodeAt($e),Ge=fe.charCodeAt(Ce);if(qe===Ge)continue;if(qe>=128||Ge>=128)return n(ie.toLowerCase(),fe.toLowerCase(),$e,ye,Ce,Ue);I(qe)&&(qe-=32),I(Ge)&&(Ge-=32);const Xe=qe-Ge;if(Xe!==0)return Xe}const Le=ye-$e,We=Ue-Ce;return Le<We?-1:Le>We?1:0}e.$2e=m;function D(ie){return ie>=48&&ie<=57}e.$3e=D;function I(ie){return ie>=97&&ie<=122}e.$4e=I;function E(ie){return ie>=65&&ie<=90}e.$5e=E;function R(ie,fe){return ie.length===fe.length&&m(ie,fe)===0}e.$6e=R;function L(ie,fe){const $e=fe.length;return fe.length>ie.length?!1:m(ie,fe,0,$e)===0}e.$7e=L;function F(ie,fe){const $e=Math.min(ie.length,fe.length);let ye;for(ye=0;ye<$e;ye++)if(ie.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return $e}e.$8e=F;function U(ie,fe){const $e=Math.min(ie.length,fe.length);let ye;const Ce=ie.length-1,Ue=fe.length-1;for(ye=0;ye<$e;ye++)if(ie.charCodeAt(Ce-ye)!==fe.charCodeAt(Ue-ye))return ye;return $e}e.$9e=U;function x(ie){return 55296<=ie&&ie<=56319}e.$0e=x;function Y(ie){return 56320<=ie&&ie<=57343}e.$$e=Y;function ae(ie,fe){return(ie-55296<<10)+(fe-56320)+65536}e.$_e=ae;function oe(ie,fe,$e){const ye=ie.charCodeAt($e);if(x(ye)&&$e+1<fe){const Ce=ie.charCodeAt($e+1);if(Y(Ce))return ae(ye,Ce)}return ye}e.$af=oe;function ce(ie,fe){const $e=ie.charCodeAt(fe-1);if(Y($e)&&fe>1){const ye=ie.charCodeAt(fe-2);if(x(ye))return ae(ye,$e)}return $e}class Q{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=ce(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=oe(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$bf=Q;class K{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new Q(fe,$e)}nextGraphemeLength(){const fe=ue.getInstance(),$e=this.c,ye=$e.offset;let Ce=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Ue=$e.offset,Le=fe.getGraphemeBreakType($e.nextCodePoint());if(pe(Ce,Le)){$e.setOffset(Ue);break}Ce=Le}return $e.offset-ye}prevGraphemeLength(){const fe=ue.getInstance(),$e=this.c,ye=$e.offset;let Ce=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Ue=$e.offset,Le=fe.getGraphemeBreakType($e.prevCodePoint());if(pe(Le,Ce)){$e.setOffset(Ue);break}Ce=Le}return ye-$e.offset}eol(){return this.c.eol()}}e.$cf=K;function V(ie,fe){return new K(ie,fe).nextGraphemeLength()}e.$df=V;function z(ie,fe){return new K(ie,fe).prevGraphemeLength()}e.$ef=z;function W(ie,fe){fe>0&&Y(ie.charCodeAt(fe))&&fe--;const $e=fe+V(ie,fe);return[$e-z(ie,$e),$e]}e.$ff=W;function H(ie){const fe=new K(ie);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}e.$gf=H;let q;function _(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ne(ie){return q||(q=_()),q.test(ie)}e.$hf=ne;const X=/^[\t\n\r\x20-\x7E]*$/;function O(ie){return X.test(ie)}e.$if=O,e.$jf=/[\u2028\u2029]/;function N(ie){return e.$jf.test(ie)}e.$kf=N;function G(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.$lf=G;function j(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.$mf=j;function B(ie,fe){if(ie.length<fe)return ie;const $e=/\b/g;let ye=0;for(;$e.test(ie)&&!(ie.length-$e.lastIndex<fe);)ye=$e.lastIndex,$e.lastIndex+=1;return ie.substring(ye).replace(/^\s/,"")}e.$nf=B;const T=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Z=/\x1b\].*?\x07/g;function he(ie){return ie&&(ie=ie.replace(T,"").replace(Z,"")),ie}e.$of=he,e.$pf=String.fromCharCode(65279);function de(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.$qf=de;function le(ie){return de(ie)?ie.substr(1):ie}e.$rf=le;function we(ie,fe){if(!ie||!fe||ie.length<fe.length)return!1;const $e=fe.length,ye=ie.toLowerCase();let Ce=0,Ue=-1;for(;Ce<$e;){const Le=ye.indexOf(fe[Ce],Ue+1);if(Le<0)return!1;Ue=Le,Ce++}return!0}e.$sf=we;function be(ie,fe=!1){return ie?(fe&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.$tf=be;function Ee(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.$uf=Ee;function Se(ie,fe=1){if(fe===0)return"";let $e=-1;do $e=ie.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?ie:(ie[$e-1]==="\r"&&$e--,ie.substr(0,$e))}e.$vf=Se;function je(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.$wf=je;function ke(ie){return ue.getInstance().getGraphemeBreakType(ie)}e.$xf=ke;function pe(ie,fe){return ie===0?fe!==5&&fe!==7:ie===2&&fe===3?!1:ie===4||ie===2||ie===3||fe===4||fe===2||fe===3?!0:!(ie===8&&(fe===8||fe===9||fe===11||fe===12)||(ie===11||ie===9)&&(fe===9||fe===10)||(ie===12||ie===10)&&fe===10||fe===5||fe===13||fe===7||ie===1||ie===13&&fe===14||ie===6&&fe===6)}var ee;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(ee||(e.GraphemeBreakType=ee={}));class ue{static{this.c=null}static getInstance(){return ue.c||(ue.c=new ue),ue.c}constructor(){this.d=ge()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const $e=this.d,ye=$e.length/3;let Ce=1;for(;Ce<=ye;)if(fe<$e[3*Ce])Ce=2*Ce;else if(fe>$e[3*Ce+1])Ce=2*Ce+1;else return $e[3*Ce+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Re(ie,fe){if(ie===0)return 0;const $e=De(ie,fe);if($e!==void 0)return $e;const ye=new Q(fe,ie);return ye.prevCodePoint(),ye.offset}e.$yf=Re;function De(ie,fe){const $e=new Q(fe,ie);let ye=$e.prevCodePoint();for(;Fe(ye)||ye===65039||ye===8419;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!j(ye))return;let Ce=$e.offset;return Ce>0&&$e.prevCodePoint()===8205&&(Ce=$e.offset),Ce}function Fe(ie){return 127995<=ie&&ie<=127999}var Me;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.$zf="\xA0";class Ve{static{this.c=new A.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new S.$Be(fe=>{function $e(Xe){const _e=new Map;for(let Ye=0;Ye<Xe.length;Ye+=2)_e.set(Xe[Ye],Xe[Ye+1]);return _e}function ye(Xe,_e){const Ye=new Map(Xe);for(const[it,st]of _e)Ye.set(it,st);return Ye}function Ce(Xe,_e){if(!Xe)return _e;const Ye=new Map;for(const[it,st]of Xe)_e.has(it)&&Ye.set(it,st);return Ye}const Ue=this.c.value;let Le=fe.filter(Xe=>!Xe.startsWith("_")&&Xe in Ue);Le.length===0&&(Le=["_default"]);let We;for(const Xe of Le){const _e=$e(Ue[Xe]);We=Ce(We,_e)}const qe=$e(Ue._common),Ge=ye(qe,We);return new Ve(Ge)})}static getInstance(fe){return Ve.d.get(Array.from(fe))}static{this.e=new A.$U(()=>Object.keys(Ve.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return Ve.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Af=Ve;class ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ze.c())),this.d}static isInvisibleCharacter(fe){return ze.e().has(fe)}static get codePoints(){return ze.e()}}e.$Bf=ze}),define(se[45],re([0,1,25]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=void 0;function A(g){return s(g,0)}e.$Li=A;function s(g,h){switch(typeof g){case"object":return g===null?M(349,h):Array.isArray(g)?d(g,h):u(g,h);case"string":return P(g,h);case"boolean":return C(g,h);case"number":return M(g,h);case"undefined":return M(937,h);default:return M(617,h)}}e.$Mi=s;function M(g,h){return(h<<5)-h+g|0}e.$Ni=M;function C(g,h){return M(g?433:863,h)}function P(g,h){h=M(149417,h);for(let a=0,k=g.length;a<k;a++)h=M(g.charCodeAt(a),h);return h}e.$Oi=P;function d(g,h){return h=M(104579,h),g.reduce((a,k)=>s(k,a),h)}function u(g,h){return h=M(181387,h),Object.keys(g).sort().reduce((a,k)=>(a=P(k,a),s(g[k],a)),h)}class b{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=s(h,this.g),this.g}}e.$Pi=b;var y;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function p(g,h,a=32){const k=a-h,f=~((1<<k)-1);return(g<<h|(f&g)>>>k)>>>0}function l(g,h=0,a=g.byteLength,k=0){for(let f=0;f<a;f++)g[h+f]=k}function v(g,h,a="0"){for(;g.length<h;)g=a+g;return g}function $(g,h=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(a=>a.toString(16).padStart(2,"0")).join(""):v((g>>>0).toString(16),h/4)}e.$Qi=$;class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const a=h.length;if(a===0)return;const k=this.p;let f=this.r,i=this.u,o,r;for(i!==0?(o=i,r=-1,i=0):(o=h.charCodeAt(0),r=0);;){let t=o;if(S.$0e(o))if(r+1<a){const n=h.charCodeAt(r+1);S.$$e(n)?(r++,t=S.$_e(o,n)):t=65533}else{i=o;break}else S.$$e(o)&&(t=65533);if(f=this.w(k,f,t),r++,r<a)o=h.charCodeAt(r);else break}this.r=f,this.u=i}w(h,a,k){return k<128?h[a++]=k:k<2048?(h[a++]=192|(k&1984)>>>6,h[a++]=128|(k&63)>>>0):k<65536?(h[a++]=224|(k&61440)>>>12,h[a++]=128|(k&4032)>>>6,h[a++]=128|(k&63)>>>0):(h[a++]=240|(k&1835008)>>>18,h[a++]=128|(k&258048)>>>12,h[a++]=128|(k&4032)>>>6,h[a++]=128|(k&63)>>>0),a>=64&&(this.y(),a-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),a}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),$(this.h)+$(this.l)+$(this.m)+$(this.n)+$(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=w.g,a=this.q;for(let m=0;m<64;m+=4)h.setUint32(m,a.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)h.setUint32(m,p(h.getUint32(m-12,!1)^h.getUint32(m-32,!1)^h.getUint32(m-56,!1)^h.getUint32(m-64,!1),1),!1);let k=this.h,f=this.l,i=this.m,o=this.n,r=this.o,t,n,c;for(let m=0;m<80;m++)m<20?(t=f&i|~f&o,n=1518500249):m<40?(t=f^i^o,n=1859775393):m<60?(t=f&i|f&o|i&o,n=2400959708):(t=f^i^o,n=3395469782),c=p(k,5)+t+r+n+h.getUint32(m*4,!1)&4294967295,r=o,o=i,i=p(f,30),f=k,k=c;this.h=this.h+k&4294967295,this.l=this.l+f&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$Ri=w}),define(se[74],re([0,1,25]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(A||(A={})),function(s){const M="error",C="warning",P="warn",d="info",u="ignore";function b(p){return p?S.$6e(M,p)?s.Error:S.$6e(C,p)||S.$6e(P,p)?s.Warning:S.$6e(d,p)?s.Info:s.Ignore:s.Ignore}s.fromValue=b;function y(p){switch(p){case s.Error:return M;case s.Warning:return C;case s.Info:return d;default:return u}}s.toString=y}(A||(A={})),e.default=A}),define(se[143],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(se[57],re([0,1,23,25]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=void 0;class s{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const v=l.charCodeAt(0),$=this.b.charCodeAt(this.c);return v-$}value(){return this.b[this.c]}}e.$Zh=s;class M{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,A.$Ze)(l,this.b,0,l.length,this.c,this.d):(0,A.$2e)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$1h=M;class C{constructor(l=!0,v=!0){this.f=l,this.g=v}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let v=l.length-1;v>=0;v--,this.c--){const $=this.b.charCodeAt(v);if(!($===47||this.f&&$===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,A.$Ze)(l,this.b,0,l.length,this.d,this.e):(0,A.$2e)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$2h=C;var P;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(P||(P={}));class d{constructor(l,v){this.f=l,this.g=v,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,A.$1e)(l,this.c.scheme);if(this.d[this.e]===2)return(0,A.$1e)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,A.$Ye)(l,this.c.query);if(this.d[this.e]===5)return(0,A.$Ye)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$3h=d;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(b||(b={}));class y{static forUris(l=()=>!1,v=()=>!1){return new y(new d(l,v))}static forPaths(l=!1){return new y(new C(void 0,!l))}static forStrings(){return new y(new s)}static forConfigKeys(){return new y(new M)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,v){if(v){const $=v.slice(0);(0,S.$Wb)($);for(const w of $)this.set(w,l)}else{const $=l.slice(0);(0,S.$Wb)($);for(const w of $)this.set(w[0],w[1])}}set(l,v){const $=this.b.reset(l);let w;this.c||(this.c=new u,this.c.segment=$.value());const g=[];for(w=this.c;;){const a=$.cmp(w.segment);if(a>0)w.left||(w.left=new u,w.left.segment=$.value()),g.push([-1,w]),w=w.left;else if(a<0)w.right||(w.right=new u,w.right.segment=$.value()),g.push([1,w]),w=w.right;else if($.hasNext())$.next(),w.mid||(w.mid=new u,w.mid.segment=$.value()),g.push([0,w]),w=w.mid;else break}const h=w.value;w.value=v,w.key=l;for(let a=g.length-1;a>=0;a--){const k=g[a][1];k.updateHeight();const f=k.balanceFactor();if(f<-1||f>1){const i=g[a][0],o=g[a+1][0];if(i===1&&o===1)g[a][1]=k.rotateLeft();else if(i===-1&&o===-1)g[a][1]=k.rotateRight();else if(i===1&&o===-1)k.right=g[a+1][1]=g[a+1][1].rotateRight(),g[a][1]=k.rotateLeft();else if(i===-1&&o===1)k.left=g[a+1][1]=g[a+1][1].rotateLeft(),g[a][1]=k.rotateRight();else throw new Error;if(a>0)switch(g[a-1][0]){case-1:g[a-1][1].left=g[a][1];break;case 1:g[a-1][1].right=g[a][1];break;case 0:g[a-1][1].mid=g[a][1];break}else this.c=g[0][1]}}return h}get(l){return this.d(l)?.value}d(l){const v=this.b.reset(l);let $=this.c;for(;$;){const w=v.cmp($.segment);if(w>0)$=$.left;else if(w<0)$=$.right;else if(v.hasNext())v.next(),$=$.mid;else break}return $}has(l){const v=this.d(l);return!(v?.value===void 0&&v?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,v){const $=this.b.reset(l),w=[];let g=this.c;for(;g;){const h=$.cmp(g.segment);if(h>0)w.push([-1,g]),g=g.left;else if(h<0)w.push([1,g]),g=g.right;else if($.hasNext())$.next(),w.push([0,g]),g=g.mid;else break}if(g){if(v?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const h=this.f(g.right);if(h.key){const{key:a,value:k,segment:f}=h;this.e(h.key,!1),g.key=a,g.value=k,g.segment=f}}else{const h=g.left??g.right;if(w.length>0){const[a,k]=w[w.length-1];switch(a){case-1:k.left=h;break;case 0:k.mid=h;break;case 1:k.right=h;break}}else this.c=h}for(let h=w.length-1;h>=0;h--){const a=w[h][1];a.updateHeight();const k=a.balanceFactor();if(k>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),w[h][1]=a.rotateLeft()):k<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),w[h][1]=a.rotateRight()),h>0)switch(w[h-1][0]){case-1:w[h-1][1].left=w[h][1];break;case 1:w[h-1][1].right=w[h][1];break;case 0:w[h-1][1].mid=w[h][1];break}else this.c=w[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const v=this.b.reset(l);let $=this.c,w;for(;$;){const g=v.cmp($.segment);if(g>0)$=$.left;else if(g<0)$=$.right;else if(v.hasNext())v.next(),w=$.value||w,$=$.mid;else break}return $&&$.value||w}findSuperstr(l){return this.g(l,!1)}g(l,v){const $=this.b.reset(l);let w=this.c;for(;w;){const g=$.cmp(w.segment);if(g>0)w=w.left;else if(g<0)w=w.right;else if($.hasNext())$.next(),w=w.mid;else return w.mid?this.h(w.mid):v?w.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[v,$]of this)l($,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const v=[];return this.j(l,v),v[Symbol.iterator]()}j(l,v){l&&(l.left&&this.j(l.left,v),l.value&&v.push([l.key,l.value]),l.mid&&this.j(l.mid,v),l.right&&this.j(l.right,v))}_isBalanced(){const l=v=>{if(!v)return!0;const $=v.balanceFactor();return $<-1||$>1?!1:l(v.left)&&l(v.right)};return l(this.c)}}e.$4h=y}),define(se[12],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=void 0;function S(f){return typeof f=="string"}e.$Cf=S;function A(f){return Array.isArray(f)&&f.every(i=>S(i))}e.$Df=A;function s(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.$Ef=s;function M(f){const i=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof i}e.$Ff=M;function C(f){return typeof f=="number"&&!isNaN(f)}e.$Gf=C;function P(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.$Hf=P;function d(f){return f===!0||f===!1}e.$If=d;function u(f){return typeof f>"u"}e.$Jf=u;function b(f){return!y(f)}e.$Kf=b;function y(f){return u(f)||f===null}e.$Lf=y;function p(f,i){if(!f)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$Mf=p;function l(f){if(y(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.$Nf=l;function v(...f){const i=[];for(let o=0;o<f.length;o++){const r=f[o];if(y(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(r)}return i}e.$Of=v;const $=Object.prototype.hasOwnProperty;function w(f){if(!s(f))return!1;for(const i in f)if($.call(f,i))return!1;return!0}e.$Pf=w;function g(f){return typeof f=="function"}e.$Qf=g;function h(...f){return f.length>0&&f.every(g)}e.$Rf=h;function a(f,i){const o=Math.min(f.length,i.length);for(let r=0;r<o;r++)k(f[r],i[r])}e.$Sf=a;function k(f,i){if(S(i)){if(typeof f!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(g(i)){try{if(f instanceof i)return}catch{}if(!y(f)&&f.constructor===i||i.length===1&&i.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Tf=k}),define(se[75],re([0,1,12]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=void 0;const A=Object.create(null);function s(P,d){if((0,S.$Cf)(d)){const u=A[d];if(u===void 0)throw new Error(`${P} references an unknown codicon: ${d}`);d=u}return A[P]=d,{id:P}}function M(){return A}e.$1j=M;function C(){return Object.values(e.$3j)}e.$2j=C,e.$3j={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(se[38],re([0,1,12]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=void 0;function A(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const h=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([a,k])=>{h[a]=k&&typeof k=="object"?A(k):k}),h}e.$cn=A;function s(g){if(!g||typeof g!="object")return g;const h=[g];for(;h.length>0;){const a=h.shift();Object.freeze(a);for(const k in a)if(M.call(a,k)){const f=a[k];typeof f=="object"&&!Object.isFrozen(f)&&!(0,S.$Ff)(f)&&h.push(f)}}return g}e.$dn=s;const M=Object.prototype.hasOwnProperty;function C(g,h){return P(g,h,new Set)}e.$en=C;function P(g,h,a){if((0,S.$Lf)(g))return g;const k=h(g);if(typeof k<"u")return k;if(Array.isArray(g)){const f=[];for(const i of g)f.push(P(i,h,a));return f}if((0,S.$Ef)(g)){if(a.has(g))throw new Error("Cannot clone recursive data-structure");a.add(g);const f={};for(const i in g)M.call(g,i)&&(f[i]=P(g[i],h,a));return a.delete(g),f}return g}function d(g,h,a=!0){return(0,S.$Ef)(g)?((0,S.$Ef)(h)&&Object.keys(h).forEach(k=>{k in g?a&&((0,S.$Ef)(g[k])&&(0,S.$Ef)(h[k])?d(g[k],h[k],a):g[k]=h[k]):g[k]=h[k]}),g):h}e.$fn=d;function u(g,h){if(g===h)return!0;if(g==null||h===null||h===void 0||typeof g!=typeof h||typeof g!="object"||Array.isArray(g)!==Array.isArray(h))return!1;let a,k;if(Array.isArray(g)){if(g.length!==h.length)return!1;for(a=0;a<g.length;a++)if(!u(g[a],h[a]))return!1}else{const f=[];for(k in g)f.push(k);f.sort();const i=[];for(k in h)i.push(k);if(i.sort(),!u(f,i))return!1;for(a=0;a<f.length;a++)if(!u(g[f[a]],h[f[a]]))return!1}return!0}e.$gn=u;function b(g){const h=new Set;return JSON.stringify(g,(a,k)=>{if((0,S.$Ef)(k)||Array.isArray(k)){if(h.has(k))return"[Circular]";h.add(k)}return k})}e.$hn=b;function y(g,h){const a=Object.create(null);return!g||!h||Object.keys(h).forEach(f=>{const i=g[f],o=h[f];u(i,o)||(a[f]=o)}),a}e.$in=y;function p(g,h){const a=h.toLowerCase(),k=Object.keys(g).find(f=>f.toLowerCase()===a);return k?g[k]:g[h]}e.$jn=p;function l(g,h){const a=Object.create(null);for(const[k,f]of Object.entries(g))h(k,f)&&(a[k]=f);return a}e.$kn=l;function v(g){let h=[];for(;Object.prototype!==g;)h=h.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return h}e.$ln=v;function $(g){const h=[];for(const a of v(g))typeof g[a]=="function"&&h.push(a);return h}e.$mn=$;function w(g,h){const a=f=>function(){const i=Array.prototype.slice.call(arguments,0);return h(f,i)},k={};for(const f of g)k[f]=a(f);return k}e.$nn=w}),define(se[102],re([0,1,75]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$4j=e.ThemeColor=void 0;var A;(function(C){function P(d){return d&&typeof d=="object"&&typeof d.id=="string"}C.isThemeColor=P})(A||(e.ThemeColor=A={}));function s(C){return{id:C}}e.$4j=s;var M;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function d(h){const a=P.exec(h.id);if(!a)return d(S.$3j.error);const[,k,f]=a,i=["codicon","codicon-"+k];return f&&i.push("codicon-modifier-"+f.substring(1)),i}C.asClassNameArray=d;function u(h){return d(h).join(" ")}C.asClassName=u;function b(h){return"."+d(h).join(".")}C.asCSSSelector=b;function y(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||A.isThemeColor(h.color))}C.isThemeIcon=y;const p=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function l(h){const a=p.exec(h);if(!a)return;const[,k]=a;return{id:k}}C.fromString=l;function v(h){return{id:h}}C.fromId=v;function $(h,a){let k=h.id;const f=k.lastIndexOf("~");return f!==-1&&(k=k.substring(0,f)),a&&(k=`${k}~${a}`),{id:k}}C.modify=$;function w(h){const a=h.id.lastIndexOf("~");if(a!==-1)return h.id.substring(a+1)}C.getModifier=w;function g(h,a){return h.id===a.id&&h.color?.id===a.color?.id}C.isEqual=g})(M||(e.ThemeIcon=M={}))}),define(se[32],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kg=e.$jg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(s){return S.test(s)}e.$jg=A,e.$kg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(P){for(let d=0;d<P.length;d++)P[d]=Math.floor(Math.random()*256);return P};const M=new Uint8Array(16),C=[];for(let P=0;P<256;P++)C.push(P.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let d=0,u="";return u+=C[M[d++]],u+=C[M[d++]],u+=C[M[d++]],u+=C[M[d++]],u+="-",u+=C[M[d++]],u+=C[M[d++]],u+="-",u+=C[M[d++]],u+=C[M[d++]],u+="-",u+=C[M[d++]],u+=C[M[d++]],u+="-",u+=C[M[d++]],u+=C[M[d++]],u+=C[M[d++]],u+=C[M[d++]],u+=C[M[d++]],u+=C[M[d++]],u}}()}),define(se[144],re([0,1,86,46,84]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ST=void 0;async function M(C,P){if(await new Promise((b,y)=>{const p=A.createReadStream(C),l=S.createHash("sha1");p.pipe(l);const v=(0,s.$cb)(($,w)=>{p.removeAllListeners(),l.removeAllListeners(),$?y($):b(w)});p.once("error",v),p.once("end",v),l.once("error",v),l.once("data",$=>v(void 0,$.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.$ST=M}),define(se[145],re([0,1,28]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(C){const P=C.replace(/\-/g,":").toLowerCase();return!A.has(P)}function M(){const C=(0,S.networkInterfaces)();for(const P in C){const d=C[P];if(d){for(const{mac:u}of d)if(s(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Ym=M}),define(se[103],re([0,1,87]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=e.$ng=e.$mg=void 0;function A(P,d,u,b=1){let y=!1;return new Promise(p=>{const l=setTimeout(()=>{if(!y)return y=!0,p(0)},u);s(P,d,b,v=>{if(!y)return y=!0,clearTimeout(l),p(v)})})}e.$mg=A;function s(P,d,u,b){if(d===0)return b(0);const y=new S.Socket;y.once("connect",()=>(C(y),s(P+u,d-1,u,b))),y.once("data",()=>{}),y.once("error",p=>(C(y),p.code!=="ECONNREFUSED"?s(P+u,d-1,u,b):b(P))),y.connect(P,"127.0.0.1")}e.$ng={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(P,d,u,b="127.0.0.1"){let y=!1,p,l=1;const v=S.createServer({pauseOnConnect:!0});function $(w,g){y||(y=!0,v.removeAllListeners(),v.close(),p&&clearTimeout(p),g(w))}return new Promise(w=>{p=setTimeout(()=>{$(0,w)},u),v.on("listening",()=>{$(P,w)}),v.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&l<d?(P++,l++,v.listen(P,b)):$(0,w)}),v.on("close",()=>{$(0,w)}),v.listen(P,b)})}e.$og=M;function C(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(d){console.error(d)}}}),function(){function J(){function e(){return process.uncHostAllowlist}function S(d){const u=new Set;if(Array.isArray(d))for(const b of d)typeof b=="string"&&u.add(b);return Array.from(u)}function A(){const d=e();return d?Array.from(d):[]}function s(d){if(process.platform!=="win32")return;const u=e();if(u)if(typeof d=="string")u.add(d.toLowerCase());else for(const b of S(d))s(b)}function M(d){if(typeof d!="string")return;const u=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let b;for(const y of u){if(d.indexOf(y)!==0)continue;const l=d.indexOf("\\",y.length);if(l===-1)continue;const v=d.substring(y.length,l);if(v){b=v;break}}return b}function C(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:A,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:C,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return J()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=J():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(se[146],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WT=e.$VT=void 0,e.$VT="vscode:contextmenu",e.$WT="vscode:onCloseContextMenu"}),define(se[147],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4T=void 0;class S{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$4T=S}),define(se[148],re([11,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(se[149],re([0,1,148]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=void 0;const A=60,s=A*60,M=s*24,C=M*7,P=M*30,d=M*365;function u(y,p,l,v){typeof y!="number"&&(y=y.getTime());const $=Math.round((new Date().getTime()-y)/1e3);if($<-30)return(0,S.localize)(0,null,u(new Date().getTime()+$*1e3,!1));if(!v&&$<30)return(0,S.localize)(1,null);let w;return $<A?(w=$,p?w===1?l?(0,S.localize)(2,null,w):(0,S.localize)(3,null,w):l?(0,S.localize)(4,null,w):(0,S.localize)(5,null,w):w===1?l?(0,S.localize)(6,null,w):(0,S.localize)(7,null,w):l?(0,S.localize)(8,null,w):(0,S.localize)(9,null,w)):$<s?(w=Math.floor($/A),p?w===1?l?(0,S.localize)(10,null,w):(0,S.localize)(11,null,w):l?(0,S.localize)(12,null,w):(0,S.localize)(13,null,w):w===1?l?(0,S.localize)(14,null,w):(0,S.localize)(15,null,w):l?(0,S.localize)(16,null,w):(0,S.localize)(17,null,w)):$<M?(w=Math.floor($/s),p?w===1?l?(0,S.localize)(18,null,w):(0,S.localize)(19,null,w):l?(0,S.localize)(20,null,w):(0,S.localize)(21,null,w):w===1?l?(0,S.localize)(22,null,w):(0,S.localize)(23,null,w):l?(0,S.localize)(24,null,w):(0,S.localize)(25,null,w)):$<C?(w=Math.floor($/M),p?w===1?(0,S.localize)(26,null,w):(0,S.localize)(27,null,w):w===1?(0,S.localize)(28,null,w):(0,S.localize)(29,null,w)):$<P?(w=Math.floor($/C),p?w===1?l?(0,S.localize)(30,null,w):(0,S.localize)(31,null,w):l?(0,S.localize)(32,null,w):(0,S.localize)(33,null,w):w===1?l?(0,S.localize)(34,null,w):(0,S.localize)(35,null,w):l?(0,S.localize)(36,null,w):(0,S.localize)(37,null,w)):$<d?(w=Math.floor($/P),p?w===1?l?(0,S.localize)(38,null,w):(0,S.localize)(39,null,w):l?(0,S.localize)(40,null,w):(0,S.localize)(41,null,w):w===1?l?(0,S.localize)(42,null,w):(0,S.localize)(43,null,w):l?(0,S.localize)(44,null,w):(0,S.localize)(45,null,w)):(w=Math.floor($/d),p?w===1?l?(0,S.localize)(46,null,w):(0,S.localize)(47,null,w):l?(0,S.localize)(48,null,w):(0,S.localize)(49,null,w):w===1?l?(0,S.localize)(50,null,w):(0,S.localize)(51,null,w):l?(0,S.localize)(52,null,w):(0,S.localize)(53,null,w))}e.$lm=u;function b(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$mm=b}),define(se[150],re([11,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(se[50],re([0,1,23,12,150]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=void 0;function M(y,p){return p&&(y.stack||y.stacktrace)?s.localize(0,null,P(y),C(y.stack)||C(y.stacktrace)):P(y)}function C(y){return Array.isArray(y)?y.join(`
`):y}function P(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?s.localize(1,null,y.message):y.message||s.localize(2,null)}function d(y=null,p=!1){if(!y)return s.localize(3,null);if(Array.isArray(y)){const l=S.$Gb(y),v=d(l[0],p);return l.length>1?s.localize(4,null,v,l.length):v}if(A.$Cf(y))return y;if(y.detail){const l=y.detail;if(l.error)return M(l.error,p);if(l.exception)return M(l.exception,p)}return y.stack?M(y,p):y.message?y.message:s.localize(5,null)}e.$Ii=d;function u(y){const p=y;return p instanceof Error&&Array.isArray(p.actions)}e.$Ji=u;function b(y,p){let l;return typeof y=="string"?l=new Error(y):l=y,l.actions=p,l}e.$Ki=b}),define(se[151],re([11,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(se[152],re([0,1,151]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;function A(s){switch(s){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.$Ep=A}),define(se[153],re([11,10]),function(J,e){return J.create("vs/base/common/platform",e)}),define(se[4],re([0,1,153]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let A=!1,s=!1,M=!1,C=!1,P=!1,d=!1,u=!1,b=!1,y=!1,p=!1,l,v=e.$g,$=e.$g,w,g;const h=globalThis;let a;typeof h.vscode<"u"&&typeof h.vscode.process<"u"?a=h.vscode.process:typeof process<"u"&&(a=process);const k=typeof a?.versions?.electron=="string",f=k&&a?.type==="renderer";if(typeof navigator=="object"&&!f)g=navigator.userAgent,A=g.indexOf("Windows")>=0,s=g.indexOf("Macintosh")>=0,b=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=g.indexOf("Linux")>=0,p=g?.indexOf("Mobi")>=0,d=!0,l=S.getConfiguredDefaultLocale(S.localize(0,null))||e.$g,v=l,$=navigator.language;else if(typeof a=="object"){A=a.platform==="win32",s=a.platform==="darwin",M=a.platform==="linux",C=M&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,u=k,y=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.$g,v=e.$g;const I=a.env.VSCODE_NLS_CONFIG;if(I)try{const E=JSON.parse(I),R=E.availableLanguages["*"];l=E.locale,$=E.osLocale,v=R||e.$g,w=E._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var i;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let r=0;s?r=1:A?r=3:M&&(r=2),e.$i=A,e.$j=s,e.$k=M,e.$l=C,e.$m=P,e.$n=u,e.$o=d,e.$p=d&&typeof h.importScripts=="function",e.$q=e.$p?h.origin:void 0,e.$r=b,e.$s=p,e.$t=y,e.$u=r,e.$v=g,e.$w=v;var t;(function(I){function E(){return e.$w}I.value=E;function R(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}I.isDefaultVariant=R;function L(){return e.$w==="en"}I.isDefault=L})(t||(e.Language=t={})),e.$x=l,e.$y=$,e.$z=w,e.$A=typeof h.postMessage=="function"&&!h.importScripts,e.$B=(()=>{if(e.$A){const I=[];h.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let L=0,F=I.length;L<F;L++){const U=I[L];if(U.id===R.data.vscodeScheduleAsyncWork){I.splice(L,1),U.callback();return}}});let E=0;return R=>{const L=++E;I.push({id:L,callback:R}),h.postMessage({vscodeScheduleAsyncWork:L},"*")}}return I=>setTimeout(I)})();var n;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=s||b?2:A?1:3;let c=!0,m=!1;function D(){if(!m){m=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,c=new Uint16Array(I.buffer)[0]===(2<<8)+1}return c}e.$D=D,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(se[35],re([0,1,4]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let A;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.process<"u"){const M=s.process;A={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return S.$i?"win32":S.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$cc=A.platform,e.$dc=A.arch}),define(se[9],re([0,1,35]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const A=65,s=97,M=90,C=122,P=46,d=47,u=92,b=58,y=63;class p extends Error{constructor(o,r,t){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const c=o.indexOf(".")!==-1?"property":"argument";let m=`The "${o}" ${c} ${n} of type ${r}`;m+=`. Received type ${typeof t}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function l(i,o){if(i===null||typeof i!="object")throw new p(o,"Object",i)}function v(i,o){if(typeof i!="string")throw new p(o,"string",i)}const $=S.$cc==="win32";function w(i){return i===d||i===u}function g(i){return i===d}function h(i){return i>=A&&i<=M||i>=s&&i<=C}function a(i,o,r,t){let n="",c=0,m=-1,D=0,I=0;for(let E=0;E<=i.length;++E){if(E<i.length)I=i.charCodeAt(E);else{if(t(I))break;I=d}if(t(I)){if(!(m===E-1||D===1))if(D===2){if(n.length<2||c!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const R=n.lastIndexOf(r);R===-1?(n="",c=0):(n=n.slice(0,R),c=n.length-1-n.lastIndexOf(r)),m=E,D=0;continue}else if(n.length!==0){n="",c=0,m=E,D=0;continue}}o&&(n+=n.length>0?`${r}..`:"..",c=2)}else n.length>0?n+=`${r}${i.slice(m+1,E)}`:n=i.slice(m+1,E),c=E-m-1;m=E,D=0}else I===P&&D!==-1?++D:D=-1}return n}function k(i,o){l(o,"pathObject");const r=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${t}`:`${r}${i}${t}`:t}e.$ec={resolve(...i){let o="",r="",t=!1;for(let n=i.length-1;n>=-1;n--){let c;if(n>=0){if(c=i[n],v(c,"path"),c.length===0)continue}else o.length===0?c=S.cwd():(c=S.env[`=${o}`]||S.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==o.toLowerCase()&&c.charCodeAt(2)===u)&&(c=`${o}\\`));const m=c.length;let D=0,I="",E=!1;const R=c.charCodeAt(0);if(m===1)w(R)&&(D=1,E=!0);else if(w(R))if(E=!0,w(c.charCodeAt(1))){let L=2,F=L;for(;L<m&&!w(c.charCodeAt(L));)L++;if(L<m&&L!==F){const U=c.slice(F,L);for(F=L;L<m&&w(c.charCodeAt(L));)L++;if(L<m&&L!==F){for(F=L;L<m&&!w(c.charCodeAt(L));)L++;(L===m||L!==F)&&(I=`\\\\${U}\\${c.slice(F,L)}`,D=L)}}}else D=1;else h(R)&&c.charCodeAt(1)===b&&(I=c.slice(0,2),D=2,m>2&&w(c.charCodeAt(2))&&(E=!0,D=3));if(I.length>0)if(o.length>0){if(I.toLowerCase()!==o.toLowerCase())continue}else o=I;if(t){if(o.length>0)break}else if(r=`${c.slice(D)}\\${r}`,t=E,E&&o.length>0)break}return r=a(r,!t,"\\",w),t?`${o}\\${r}`:`${o}${r}`||"."},normalize(i){v(i,"path");const o=i.length;if(o===0)return".";let r=0,t,n=!1;const c=i.charCodeAt(0);if(o===1)return g(c)?"\\":i;if(w(c))if(n=!0,w(i.charCodeAt(1))){let D=2,I=D;for(;D<o&&!w(i.charCodeAt(D));)D++;if(D<o&&D!==I){const E=i.slice(I,D);for(I=D;D<o&&w(i.charCodeAt(D));)D++;if(D<o&&D!==I){for(I=D;D<o&&!w(i.charCodeAt(D));)D++;if(D===o)return`\\\\${E}\\${i.slice(I)}\\`;D!==I&&(t=`\\\\${E}\\${i.slice(I,D)}`,r=D)}}}else r=1;else h(c)&&i.charCodeAt(1)===b&&(t=i.slice(0,2),r=2,o>2&&w(i.charCodeAt(2))&&(n=!0,r=3));let m=r<o?a(i.slice(r),!n,"\\",w):"";return m.length===0&&!n&&(m="."),m.length>0&&w(i.charCodeAt(o-1))&&(m+="\\"),t===void 0?n?`\\${m}`:m:n?`${t}\\${m}`:`${t}${m}`},isAbsolute(i){v(i,"path");const o=i.length;if(o===0)return!1;const r=i.charCodeAt(0);return w(r)||o>2&&h(r)&&i.charCodeAt(1)===b&&w(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,r;for(let c=0;c<i.length;++c){const m=i[c];v(m,"path"),m.length>0&&(o===void 0?o=r=m:o+=`\\${m}`)}if(o===void 0)return".";let t=!0,n=0;if(typeof r=="string"&&w(r.charCodeAt(0))){++n;const c=r.length;c>1&&w(r.charCodeAt(1))&&(++n,c>2&&(w(r.charCodeAt(2))?++n:t=!1))}if(t){for(;n<o.length&&w(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.$ec.normalize(o)},relative(i,o){if(v(i,"from"),v(o,"to"),i===o)return"";const r=e.$ec.resolve(i),t=e.$ec.resolve(o);if(r===t||(i=r.toLowerCase(),o=t.toLowerCase(),i===o))return"";let n=0;for(;n<i.length&&i.charCodeAt(n)===u;)n++;let c=i.length;for(;c-1>n&&i.charCodeAt(c-1)===u;)c--;const m=c-n;let D=0;for(;D<o.length&&o.charCodeAt(D)===u;)D++;let I=o.length;for(;I-1>D&&o.charCodeAt(I-1)===u;)I--;const E=I-D,R=m<E?m:E;let L=-1,F=0;for(;F<R;F++){const x=i.charCodeAt(n+F);if(x!==o.charCodeAt(D+F))break;x===u&&(L=F)}if(F!==R){if(L===-1)return t}else{if(E>R){if(o.charCodeAt(D+F)===u)return t.slice(D+F+1);if(F===2)return t.slice(D+F)}m>R&&(i.charCodeAt(n+F)===u?L=F:F===2&&(L=3)),L===-1&&(L=0)}let U="";for(F=n+L+1;F<=c;++F)(F===c||i.charCodeAt(F)===u)&&(U+=U.length===0?"..":"\\..");return D+=L,U.length>0?`${U}${t.slice(D,I)}`:(t.charCodeAt(D)===u&&++D,t.slice(D,I))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$ec.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===u){if(o.charCodeAt(1)===u){const r=o.charCodeAt(2);if(r!==y&&r!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(h(o.charCodeAt(0))&&o.charCodeAt(1)===b&&o.charCodeAt(2)===u)return`\\\\?\\${o}`;return i},dirname(i){v(i,"path");const o=i.length;if(o===0)return".";let r=-1,t=0;const n=i.charCodeAt(0);if(o===1)return w(n)?i:".";if(w(n)){if(r=t=1,w(i.charCodeAt(1))){let D=2,I=D;for(;D<o&&!w(i.charCodeAt(D));)D++;if(D<o&&D!==I){for(I=D;D<o&&w(i.charCodeAt(D));)D++;if(D<o&&D!==I){for(I=D;D<o&&!w(i.charCodeAt(D));)D++;if(D===o)return i;D!==I&&(r=t=D+1)}}}}else h(n)&&i.charCodeAt(1)===b&&(r=o>2&&w(i.charCodeAt(2))?3:2,t=r);let c=-1,m=!0;for(let D=o-1;D>=t;--D)if(w(i.charCodeAt(D))){if(!m){c=D;break}}else m=!1;if(c===-1){if(r===-1)return".";c=r}return i.slice(0,c)},basename(i,o){o!==void 0&&v(o,"ext"),v(i,"path");let r=0,t=-1,n=!0,c;if(i.length>=2&&h(i.charCodeAt(0))&&i.charCodeAt(1)===b&&(r=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let m=o.length-1,D=-1;for(c=i.length-1;c>=r;--c){const I=i.charCodeAt(c);if(w(I)){if(!n){r=c+1;break}}else D===-1&&(n=!1,D=c+1),m>=0&&(I===o.charCodeAt(m)?--m===-1&&(t=c):(m=-1,t=D))}return r===t?t=D:t===-1&&(t=i.length),i.slice(r,t)}for(c=i.length-1;c>=r;--c)if(w(i.charCodeAt(c))){if(!n){r=c+1;break}}else t===-1&&(n=!1,t=c+1);return t===-1?"":i.slice(r,t)},extname(i){v(i,"path");let o=0,r=-1,t=0,n=-1,c=!0,m=0;i.length>=2&&i.charCodeAt(1)===b&&h(i.charCodeAt(0))&&(o=t=2);for(let D=i.length-1;D>=o;--D){const I=i.charCodeAt(D);if(w(I)){if(!c){t=D+1;break}continue}n===-1&&(c=!1,n=D+1),I===P?r===-1?r=D:m!==1&&(m=1):r!==-1&&(m=-1)}return r===-1||n===-1||m===0||m===1&&r===n-1&&r===t+1?"":i.slice(r,n)},format:k.bind(null,"\\"),parse(i){v(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const r=i.length;let t=0,n=i.charCodeAt(0);if(r===1)return w(n)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(w(n)){if(t=1,w(i.charCodeAt(1))){let L=2,F=L;for(;L<r&&!w(i.charCodeAt(L));)L++;if(L<r&&L!==F){for(F=L;L<r&&w(i.charCodeAt(L));)L++;if(L<r&&L!==F){for(F=L;L<r&&!w(i.charCodeAt(L));)L++;L===r?t=L:L!==F&&(t=L+1)}}}}else if(h(n)&&i.charCodeAt(1)===b){if(r<=2)return o.root=o.dir=i,o;if(t=2,w(i.charCodeAt(2))){if(r===3)return o.root=o.dir=i,o;t=3}}t>0&&(o.root=i.slice(0,t));let c=-1,m=t,D=-1,I=!0,E=i.length-1,R=0;for(;E>=t;--E){if(n=i.charCodeAt(E),w(n)){if(!I){m=E+1;break}continue}D===-1&&(I=!1,D=E+1),n===P?c===-1?c=E:R!==1&&(R=1):c!==-1&&(R=-1)}return D!==-1&&(c===-1||R===0||R===1&&c===D-1&&c===m+1?o.base=o.name=i.slice(m,D):(o.name=i.slice(m,c),o.base=i.slice(m,D),o.ext=i.slice(c,D))),m>0&&m!==t?o.dir=i.slice(0,m-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const f=(()=>{if($){const i=/\\/g;return()=>{const o=S.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>S.cwd()})();e.$fc={resolve(...i){let o="",r=!1;for(let t=i.length-1;t>=-1&&!r;t--){const n=t>=0?i[t]:f();v(n,"path"),n.length!==0&&(o=`${n}/${o}`,r=n.charCodeAt(0)===d)}return o=a(o,!r,"/",g),r?`/${o}`:o.length>0?o:"."},normalize(i){if(v(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===d,r=i.charCodeAt(i.length-1)===d;return i=a(i,!o,"/",g),i.length===0?o?"/":r?"./":".":(r&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return v(i,"path"),i.length>0&&i.charCodeAt(0)===d},join(...i){if(i.length===0)return".";let o;for(let r=0;r<i.length;++r){const t=i[r];v(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.$fc.normalize(o)},relative(i,o){if(v(i,"from"),v(o,"to"),i===o||(i=e.$fc.resolve(i),o=e.$fc.resolve(o),i===o))return"";const r=1,t=i.length,n=t-r,c=1,m=o.length-c,D=n<m?n:m;let I=-1,E=0;for(;E<D;E++){const L=i.charCodeAt(r+E);if(L!==o.charCodeAt(c+E))break;L===d&&(I=E)}if(E===D)if(m>D){if(o.charCodeAt(c+E)===d)return o.slice(c+E+1);if(E===0)return o.slice(c+E)}else n>D&&(i.charCodeAt(r+E)===d?I=E:E===0&&(I=0));let R="";for(E=r+I+1;E<=t;++E)(E===t||i.charCodeAt(E)===d)&&(R+=R.length===0?"..":"/..");return`${R}${o.slice(c+I)}`},toNamespacedPath(i){return i},dirname(i){if(v(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===d;let r=-1,t=!0;for(let n=i.length-1;n>=1;--n)if(i.charCodeAt(n)===d){if(!t){r=n;break}}else t=!1;return r===-1?o?"/":".":o&&r===1?"//":i.slice(0,r)},basename(i,o){o!==void 0&&v(o,"ext"),v(i,"path");let r=0,t=-1,n=!0,c;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let m=o.length-1,D=-1;for(c=i.length-1;c>=0;--c){const I=i.charCodeAt(c);if(I===d){if(!n){r=c+1;break}}else D===-1&&(n=!1,D=c+1),m>=0&&(I===o.charCodeAt(m)?--m===-1&&(t=c):(m=-1,t=D))}return r===t?t=D:t===-1&&(t=i.length),i.slice(r,t)}for(c=i.length-1;c>=0;--c)if(i.charCodeAt(c)===d){if(!n){r=c+1;break}}else t===-1&&(n=!1,t=c+1);return t===-1?"":i.slice(r,t)},extname(i){v(i,"path");let o=-1,r=0,t=-1,n=!0,c=0;for(let m=i.length-1;m>=0;--m){const D=i.charCodeAt(m);if(D===d){if(!n){r=m+1;break}continue}t===-1&&(n=!1,t=m+1),D===P?o===-1?o=m:c!==1&&(c=1):o!==-1&&(c=-1)}return o===-1||t===-1||c===0||c===1&&o===t-1&&o===r+1?"":i.slice(o,t)},format:k.bind(null,"/"),parse(i){v(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const r=i.charCodeAt(0)===d;let t;r?(o.root="/",t=1):t=0;let n=-1,c=0,m=-1,D=!0,I=i.length-1,E=0;for(;I>=t;--I){const R=i.charCodeAt(I);if(R===d){if(!D){c=I+1;break}continue}m===-1&&(D=!1,m=I+1),R===P?n===-1?n=I:E!==1&&(E=1):n!==-1&&(E=-1)}if(m!==-1){const R=c===0&&r?1:c;n===-1||E===0||E===1&&n===m-1&&n===c+1?o.base=o.name=i.slice(R,m):(o.name=i.slice(R,n),o.base=i.slice(R,m),o.ext=i.slice(n,m))}return c>0?o.dir=i.slice(0,c-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=$?e.$ec.normalize:e.$fc.normalize,e.$hc=$?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=$?e.$ec.join:e.$fc.join,e.$jc=$?e.$ec.resolve:e.$fc.resolve,e.$kc=$?e.$ec.relative:e.$fc.relative,e.$lc=$?e.$ec.dirname:e.$fc.dirname,e.$mc=$?e.$ec.basename:e.$fc.basename,e.$nc=$?e.$ec.extname:e.$fc.extname,e.$oc=$?e.$ec.format:e.$fc.format,e.$pc=$?e.$ec.parse:e.$fc.parse,e.$qc=$?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=$?e.$ec.sep:e.$fc.sep,e.$sc=$?e.$ec.delimiter:e.$fc.delimiter}),define(se[33],re([0,1,9,4,25,12]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function C(c){return c===47||c===92}e.$Uf=C;function P(c){return c.replace(/[\\/]/g,S.$fc.sep)}e.$Vf=P;function d(c){return c.indexOf("/")===-1&&(c=P(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.$Wf=d;function u(c,m=S.$fc.sep){if(!c)return"";const D=c.length,I=c.charCodeAt(0);if(C(I)){if(C(c.charCodeAt(1))&&!C(c.charCodeAt(2))){let R=3;const L=R;for(;R<D&&!C(c.charCodeAt(R));R++);if(L!==R&&!C(c.charCodeAt(R+1))){for(R+=1;R<D;R++)if(C(c.charCodeAt(R)))return c.slice(0,R+1).replace(/[\\/]/g,m)}}return m}else if(g(I)&&c.charCodeAt(1)===58)return C(c.charCodeAt(2))?c.slice(0,2)+m:c.slice(0,2);let E=c.indexOf("://");if(E!==-1){for(E+=3;E<D;E++)if(C(c.charCodeAt(E)))return c.slice(0,E+1)}return""}e.$Xf=u;function b(c){if(!A.$i||!c||c.length<5)return!1;let m=c.charCodeAt(0);if(m!==92||(m=c.charCodeAt(1),m!==92))return!1;let D=2;const I=D;for(;D<c.length&&(m=c.charCodeAt(D),m!==92);D++);return!(I===D||(m=c.charCodeAt(D+1),isNaN(m)||m===92))}e.$Yf=b;const y=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(c,m=A.$i){const D=m?y:p;return!(!c||c.length===0||/^\s+$/.test(c)||(D.lastIndex=0,D.test(c))||m&&l.test(c)||c==="."||c===".."||m&&c[c.length-1]==="."||m&&c.length!==c.trim().length||c.length>255)}e.$Zf=v;function $(c,m,D){const I=c===m;return!D||I?I:!c||!m?!1:(0,s.$6e)(c,m)}e.$1f=$;function w(c,m,D,I=S.sep){if(c===m)return!0;if(!c||!m||m.length>c.length)return!1;if(D){if(!(0,s.$7e)(c,m))return!1;if(m.length===c.length)return!0;let R=m.length;return m.charAt(m.length-1)===I&&R--,c.charAt(R)===I}return m.charAt(m.length-1)!==I&&(m+=I),c.indexOf(m)===0}e.$2f=w;function g(c){return c>=65&&c<=90||c>=97&&c<=122}e.$3f=g;function h(c,m){return A.$i&&c.endsWith(":")&&(c+=S.sep),(0,S.$hc)(c)||(c=(0,S.$ic)(m,c)),c=(0,S.$gc)(c),A.$i?(c=(0,s.$Oe)(c,S.sep),c.endsWith(":")&&(c+=S.sep)):(c=(0,s.$Oe)(c,S.sep),c||(c=S.sep)),c}e.$4f=h;function a(c){const m=(0,S.$gc)(c);return A.$i?c.length>3?!1:k(m)&&(c.length===2||m.charCodeAt(2)===92):m===S.$fc.sep}e.$5f=a;function k(c,m=A.$i){return m?g(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.$6f=k;function f(c,m=A.$i){return k(c,m)?c[0]:void 0}e.$7f=f;function i(c,m,D){return m.length>c.length?-1:c===m?0:(D&&(c=c.toLowerCase(),m=m.toLowerCase()),c.indexOf(m))}e.$8f=i;function o(c){const m=c.split(":");let D,I,E;for(const R of m){const L=Number(R);(0,M.$Gf)(L)?I===void 0?I=L:E===void 0&&(E=L):D=D?[D,R].join(":"):R}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:I!==void 0?I:void 0,column:E!==void 0?E:I!==void 0?1:void 0}}e.$9f=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(c,m,D=8){let I="";for(let R=0;R<D;R++){let L;R===0&&A.$i&&!m&&(D===3||D===4)?L=t:L=r,I+=L.charAt(Math.floor(Math.random()*L.length))}let E;return m?E=`${m}-${I}`:E=I,c?(0,S.$ic)(c,E):E}e.$0f=n}),define(se[76],re([0,1,4]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.TerminateResponseCode=e.Source=void 0;var A;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(A||(e.Source=A={}));var s;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(P,...d){const u=d.reduce((p,l)=>(p[l]=!0,p),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(p=>!u[p]).forEach(p=>{for(let l=0;l<b.length;l++)if(p.search(b[l])!==-1){delete P[p];break}})}e.$Hl=M;function C(P){P&&(delete P.DEBUG,S.$j&&delete P.DYLD_LIBRARY_PATH,S.$k&&delete P.LD_PRELOAD)}e.$Il=C}),define(se[7],re([0,1,9,4]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,C=/^\/\//;function P(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!s.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!M.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(t,n){return!t&&!n?"file":t}function u(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==y&&(n=y+n):n=y;break}return n}const b="",y="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(n){return n instanceof l?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,c,m,D,I,E=!1){typeof n=="object"?(this.scheme=n.scheme||b,this.authority=n.authority||b,this.path=n.path||b,this.query=n.query||b,this.fragment=n.fragment||b):(this.scheme=d(n,E),this.authority=c||b,this.path=u(this.scheme,m||b),this.query=D||b,this.fragment=I||b,P(this,E))}get fsPath(){return k(this,!1)}with(n){if(!n)return this;let{scheme:c,authority:m,path:D,query:I,fragment:E}=n;return c===void 0?c=this.scheme:c===null&&(c=b),m===void 0?m=this.authority:m===null&&(m=b),D===void 0?D=this.path:D===null&&(D=b),I===void 0?I=this.query:I===null&&(I=b),E===void 0?E=this.fragment:E===null&&(E=b),c===this.scheme&&m===this.authority&&D===this.path&&I===this.query&&E===this.fragment?this:new w(c,m,D,I,E)}static parse(n,c=!1){const m=p.exec(n);return m?new w(m[2]||b,r(m[4]||b),r(m[5]||b),r(m[7]||b),r(m[9]||b),c):new w(b,b,b,b,b)}static file(n){let c=b;if(A.$i&&(n=n.replace(/\\/g,y)),n[0]===y&&n[1]===y){const m=n.indexOf(y,2);m===-1?(c=n.substring(2),n=y):(c=n.substring(2,m),n=n.substring(m)||y)}return new w("file",c,n,b,b)}static from(n,c){return new w(n.scheme,n.authority,n.path,n.query,n.fragment,c)}static joinPath(n,...c){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return A.$i&&n.scheme==="file"?m=l.file(S.$ec.join(k(n,!0),...c)).path:m=S.$fc.join(n.path,...c),n.with({path:m})}toString(n=!1){return f(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof l)return n;{const c=new w(n);return c._formatted=n.external??null,c._fsPath=n._sep===$?n.fsPath??null:null,c}}else return n}}e.URI=l;function v(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.$uc=v;const $=A.$i?1:void 0;class w extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=k(this,!1)),this._fsPath}toString(n=!1){return n?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=$),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(t,n,c){let m,D=-1;for(let I=0;I<t.length;I++){const E=t.charCodeAt(I);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||n&&E===47||c&&E===91||c&&E===93||c&&E===58)D!==-1&&(m+=encodeURIComponent(t.substring(D,I)),D=-1),m!==void 0&&(m+=t.charAt(I));else{m===void 0&&(m=t.substr(0,I));const R=g[E];R!==void 0?(D!==-1&&(m+=encodeURIComponent(t.substring(D,I)),D=-1),m+=R):D===-1&&(D=I)}}return D!==-1&&(m+=encodeURIComponent(t.substring(D))),m!==void 0?m:t}function a(t){let n;for(let c=0;c<t.length;c++){const m=t.charCodeAt(c);m===35||m===63?(n===void 0&&(n=t.substr(0,c)),n+=g[m]):n!==void 0&&(n+=t[c])}return n!==void 0?n:t}function k(t,n){let c;return t.authority&&t.path.length>1&&t.scheme==="file"?c=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?c=t.path.substr(1):c=t.path[1].toLowerCase()+t.path.substr(2):c=t.path,A.$i&&(c=c.replace(/\//g,"\\")),c}e.$vc=k;function f(t,n){const c=n?a:h;let m="",{scheme:D,authority:I,path:E,query:R,fragment:L}=t;if(D&&(m+=D,m+=":"),(I||D==="file")&&(m+=y,m+=y),I){let F=I.indexOf("@");if(F!==-1){const U=I.substr(0,F);I=I.substr(F+1),F=U.lastIndexOf(":"),F===-1?m+=c(U,!1,!1):(m+=c(U.substr(0,F),!1,!1),m+=":",m+=c(U.substr(F+1),!1,!0)),m+="@"}I=I.toLowerCase(),F=I.lastIndexOf(":"),F===-1?m+=c(I,!1,!0):(m+=c(I.substr(0,F),!1,!0),m+=I.substr(F))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const F=E.charCodeAt(1);F>=65&&F<=90&&(E=`/${String.fromCharCode(F+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const F=E.charCodeAt(0);F>=65&&F<=90&&(E=`${String.fromCharCode(F+32)}:${E.substr(2)}`)}m+=c(E,!0,!1)}return R&&(m+="?",m+=c(R,!1,!1)),L&&(m+="#",m+=n?L:h(L,!1,!1)),m}function i(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+i(t.substr(3)):t}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(o)?t.replace(o,n=>i(n)):t}}),define(se[154],re([0,1,7]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$8p=e.$7p=e.$6p=void 0;function A(u){const b=u;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.$6p=A;function s(u){const b=[];let y;try{const p=JSON.parse(u.arguments),l=p[p.length-1];l&&l.__$stack&&(p.pop(),y=l.__$stack),b.push(...p)}catch{b.push("Unable to log remote console arguments",u.arguments)}return{args:b,stack:y}}e.$7p=s;function M(u){if(typeof u!="string")return M(s(u).stack);const b=u;if(b){const y=C(b),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(p&&p.length===4)return{uri:S.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$8p=M;function C(u){if(!u)return u;const b=u.indexOf(`
`);return b===-1?u:u.substring(0,b)}function P(u,b){const{args:y,stack:p}=s(u),l=typeof y[0]=="string"&&y.length===1;let v=C(p);v&&(v=`(${v.trim()})`);let $=[];if(typeof y[0]=="string"?v&&l?$=[`%c[${b}] %c${y[0]} %c${v}`,d("blue"),d(""),d("grey")]:$=[`%c[${b}] %c${y[0]}`,d("blue"),d(""),...y.slice(1)]:$=[`%c[${b}]%`,d("blue"),...y],v&&!l&&$.push(v),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,$)}e.log=P;function d(u){return`color: ${u}`}}),define(se[77],re([0,1,18,7]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uh=e.$th=e.$sh=void 0;function s(d){return JSON.stringify(d,C)}e.$sh=s;function M(d){let u=JSON.parse(d);return u=P(u),u}e.$th=M;function C(d,u){return u instanceof RegExp?{$mid:2,source:u.source,flags:u.flags}:u}function P(d,u=0){if(!d||u>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return A.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof S.$fe||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let b=0;b<d.length;++b)d[b]=P(d[b],u+1);else for(const b in d)Object.hasOwnProperty.call(d,b)&&(d[b]=P(d[b],u+1))}return d}e.$uh=P}),define(se[13],re([0,1,14,4,25,7]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var C;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(C||(e.Schemas=C={}));function P(p,l){return M.URI.isUri(p)?(0,s.$6e)(p.scheme,l):(0,s.$7e)(p,l+":")}e.$$f=P;function d(p,...l){return l.some(v=>P(p,v))}e.$_f=d,e.$ag="vscode-tkn",e.$bg="tkn";class u{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(l){this.d=l}setDelegate(l){this.e=l}setServerRootPath(l){this.f=`${l}/${C.vscodeRemoteResource}`}set(l,v,$){this.a[l]=v,this.b[l]=$}setConnectionToken(l,v){this.c[l]=v}getPreferredWebSchema(){return this.d}rewrite(l){if(this.e)try{return this.e(l)}catch(a){return S.$Z(a),l}const v=l.authority;let $=this.a[v];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const w=this.b[v],g=this.c[v];let h=`path=${encodeURIComponent(l.path)}`;return typeof g=="string"&&(h+=`&${e.$bg}=${encodeURIComponent(g)}`),M.URI.from({scheme:A.$o?this.d:C.vscodeRemoteResource,authority:`${$}:${w}`,path:this.f,query:h})}}e.$cg=new u,e.$dg="vs/../../extensions",e.$eg="vs/../../node_modules",e.$fg="vs/../../node_modules.asar",e.$gg="vs/../../node_modules.asar.unpacked",e.$hg="vscode-app";class b{static{this.a=e.$hg}asBrowserUri(l){const v=this.b(l,J);return this.uriToBrowserUri(v)}uriToBrowserUri(l){return l.scheme===C.vscodeRemote?e.$cg.rewrite(l):l.scheme===C.file&&(A.$m||A.$q===`${C.vscodeFileResource}://${b.a}`)?l.with({scheme:C.vscodeFileResource,authority:l.authority||b.a,query:null,fragment:null}):l}asFileUri(l){const v=this.b(l,J);return this.uriToFileUri(v)}uriToFileUri(l){return l.scheme===C.vscodeFileResource?l.with({scheme:C.file,authority:l.authority!==b.a?l.authority:null,query:null,fragment:null}):l}b(l,v){return M.URI.isUri(l)?l:M.URI.parse(v.toUrl(l))}}e.$ig=new b;var y;(function(p){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(l.get("3"));const v="vscode-coi";function $(g){let h;typeof g=="string"?h=new URL(g).searchParams:g instanceof URL?h=g.searchParams:M.URI.isUri(g)&&(h=new URL(g.toString(!0)).searchParams);const a=h?.get(v);if(a)return l.get(a)}p.getHeadersFromQuery=$;function w(g,h,a){if(!globalThis.crossOriginIsolated)return;const k=h&&a?"3":a?"2":"1";g instanceof URLSearchParams?g.set(v,k):g[v]=k}p.addSearchParam=w})(y||(e.COI=y={}))}),define(se[19],re([0,1,33,13,9,4,25,7]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lg=e.DataUri=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=void 0;function d(l){return(0,P.$vc)(l,!0)}e.$pg=d;class u{constructor(v){this.a=v}compare(v,$,w=!1){return v===$?0:(0,C.$Ye)(this.getComparisonKey(v,w),this.getComparisonKey($,w))}isEqual(v,$,w=!1){return v===$?!0:!v||!$?!1:this.getComparisonKey(v,w)===this.getComparisonKey($,w)}getComparisonKey(v,$=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:$?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,$,w=!1){if(v.scheme===$.scheme){if(v.scheme===A.Schemas.file)return S.$2f(d(v),d($),this.a(v))&&v.query===$.query&&(w||v.fragment===$.fragment);if((0,e.$Gg)(v.authority,$.authority))return S.$2f(v.path,$.path,this.a(v),"/")&&v.query===$.query&&(w||v.fragment===$.fragment)}return!1}joinPath(v,...$){return P.URI.joinPath(v,...$)}basenameOrAuthority(v){return(0,e.$yg)(v)||v.authority}basename(v){return s.$fc.basename(v.path)}extname(v){return s.$fc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let $;return v.scheme===A.Schemas.file?$=P.URI.file(s.$lc(d(v))).path:($=s.$fc.dirname(v.path),v.authority&&$.length&&$.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),$="/")),v.with({path:$})}normalizePath(v){if(!v.path.length)return v;let $;return v.scheme===A.Schemas.file?$=P.URI.file(s.$gc(d(v))).path:$=s.$fc.normalize(v.path),v.with({path:$})}relativePath(v,$){if(v.scheme!==$.scheme||!(0,e.$Gg)(v.authority,$.authority))return;if(v.scheme===A.Schemas.file){const h=s.$kc(d(v),d($));return M.$i?S.$Vf(h):h}let w=v.path||"/";const g=$.path||"/";if(this.a(v)){let h=0;for(const a=Math.min(w.length,g.length);h<a&&!(w.charCodeAt(h)!==g.charCodeAt(h)&&w.charAt(h).toLowerCase()!==g.charAt(h).toLowerCase());h++);w=g.substr(0,h)+w.substr(h)}return s.$fc.relative(w,g)}resolvePath(v,$){if(v.scheme===A.Schemas.file){const w=P.URI.file(s.$jc(d(v),$));return v.with({authority:w.authority,path:w.path})}return $=S.$Wf($),v.with({path:s.$fc.resolve(v.path,$)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,$){return v===$||v!==void 0&&$!==void 0&&(0,C.$6e)(v,$)}hasTrailingPathSeparator(v,$=s.sep){if(v.scheme===A.Schemas.file){const w=d(v);return w.length>S.$Xf(w).length&&w[w.length-1]===$}else{const w=v.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,$=s.sep){return(0,e.$Hg)(v,$)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,$=s.sep){let w=!1;if(v.scheme===A.Schemas.file){const g=d(v);w=g!==void 0&&g.length===S.$Xf(g).length&&g[g.length-1]===$}else{$="/";const g=v.path;w=g.length===1&&g.charCodeAt(g.length-1)===47}return!w&&!(0,e.$Hg)(v,$)?v.with({path:v.path+"/"}):v}}e.$qg=u,e.$rg=new u(()=>!1),e.$sg=new u(l=>l.scheme===A.Schemas.file?!M.$k:!0),e.$tg=new u(l=>!0),e.$ug=e.$rg.isEqual.bind(e.$rg),e.$vg=e.$rg.isEqualOrParent.bind(e.$rg),e.$wg=e.$rg.getComparisonKey.bind(e.$rg),e.$xg=e.$rg.basenameOrAuthority.bind(e.$rg),e.$yg=e.$rg.basename.bind(e.$rg),e.$zg=e.$rg.extname.bind(e.$rg),e.$Ag=e.$rg.dirname.bind(e.$rg),e.$Bg=e.$rg.joinPath.bind(e.$rg),e.$Cg=e.$rg.normalizePath.bind(e.$rg),e.$Dg=e.$rg.relativePath.bind(e.$rg),e.$Eg=e.$rg.resolvePath.bind(e.$rg),e.$Fg=e.$rg.isAbsolutePath.bind(e.$rg),e.$Gg=e.$rg.isEqualAuthority.bind(e.$rg),e.$Hg=e.$rg.hasTrailingPathSeparator.bind(e.$rg),e.$Ig=e.$rg.removeTrailingPathSeparator.bind(e.$rg),e.$Jg=e.$rg.addTrailingPathSeparator.bind(e.$rg);function b(l,v){const $=[];for(let w=0;w<l.length;w++){const g=v(l[w]);l.some((h,a)=>a===w?!1:(0,e.$vg)(g,v(h)))||$.push(l[w])}return $}e.$Kg=b;var y;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function v($){const w=new Map;$.path.substring($.path.indexOf(";")+1,$.path.lastIndexOf(";")).split(";").forEach(a=>{const[k,f]=a.split(":");k&&f&&w.set(k,f)});const h=$.path.substring(0,$.path.indexOf(";"));return h&&w.set(l.META_DATA_MIME,h),w}l.parseMetaData=v})(y||(e.DataUri=y={}));function p(l,v,$){if(v){let w=l.path;return w&&w[0]!==s.$fc.sep&&(w=s.$fc.sep+w),l.with({scheme:$,authority:v,path:w})}return l.with({scheme:$})}e.$Lg=p}),define(se[8],re([0,1,22,14,3,2,19,4,143]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oh=e.$nh=e.$mh=e.$lh=e.Promises=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=void 0;function u(G){return!!G&&typeof G.then=="function"}e.$Mg=u;function b(G){const j=new S.$2d,B=G(j.token),T=new Promise((Z,he)=>{const de=j.token.onCancellationRequested(()=>{de.dispose(),j.dispose(),he(new A.$4)});Promise.resolve(B).then(le=>{de.dispose(),j.dispose(),Z(le)},le=>{de.dispose(),j.dispose(),he(le)})});return new class{cancel(){j.cancel()}then(Z,he){return T.then(Z,he)}catch(Z){return this.then(void 0,Z)}finally(Z){return T.finally(Z)}}}e.$Ng=b;function y(G,j,B){return new Promise((T,Z)=>{const he=j.onCancellationRequested(()=>{he.dispose(),T(B)});G.then(T,Z).finally(()=>he.dispose())})}e.$Og=y;function p(G,j){return new Promise((B,T)=>{const Z=j.onCancellationRequested(()=>{Z.dispose(),T(new A.$4)});G.then(B,T).finally(()=>Z.dispose())})}e.$Pg=p;async function l(G){let j=-1;const B=G.map((T,Z)=>T.then(he=>(j=Z,he)));try{return await Promise.race(B)}finally{G.forEach((T,Z)=>{Z!==j&&T.cancel()})}}e.$Qg=l;function v(G,j,B){let T;const Z=setTimeout(()=>{T?.(void 0),B?.()},j);return Promise.race([G.finally(()=>clearTimeout(Z)),new Promise(he=>T=he)])}e.$Rg=v;function $(G){return new Promise((j,B)=>{const T=G();u(T)?T.then(j,B):j(T)})}e.$Sg=$;class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(j){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=j,!this.b){const B=()=>{if(this.b=null,this.f)return;const T=this.queue(this.d);return this.d=null,T};this.b=new Promise(T=>{this.a.then(B,B).then(T)})}return new Promise((B,T)=>{this.b.then(B,T)})}return this.a=j(),new Promise((B,T)=>{this.a.then(Z=>{this.a=null,B(Z)},Z=>{this.a=null,T(Z)})})}dispose(){this.f=!0}}e.$Tg=w;class g{constructor(){this.a=Promise.resolve(null)}queue(j){return this.a=this.a.then(()=>j(),()=>j())}}e.$Ug=g;class h{constructor(){this.a=new Map}queue(j,B){const Z=(this.a.get(j)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.a.get(j)===Z&&this.a.delete(j)});return this.a.set(j,Z),Z}}e.$Vg=h;const a=(G,j)=>{let B=!0;const T=setTimeout(()=>{B=!1,j()},G);return{isTriggered:()=>B,dispose:()=>{clearTimeout(T),B=!1}}},k=G=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,G())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class f{constructor(j){this.defaultDelay=j,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(j,B=this.defaultDelay){this.g=j,this.h(),this.b||(this.b=new Promise((Z,he)=>{this.d=Z,this.f=he}).then(()=>{if(this.b=null,this.d=null,this.g){const Z=this.g;return this.g=null,Z()}}));const T=()=>{this.a=null,this.d?.(null)};return this.a=B===d.$Od?k(T):a(B,T),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Wg=f;class i{constructor(j){this.a=new f(j),this.b=new w}trigger(j,B){return this.a.trigger(()=>this.b.queue(j),B)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Xg=i;class o{constructor(){this.a=!1,this.b=new Promise((j,B)=>{this.d=j})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Yg=o;class r extends o{constructor(j){super(),this.f=setTimeout(()=>this.open(),j)}open(){clearTimeout(this.f),super.open()}}e.$Zg=r;function t(G,j){return j?new Promise((B,T)=>{const Z=setTimeout(()=>{he.dispose(),B()},G),he=j.onCancellationRequested(()=>{clearTimeout(Z),he.dispose(),T(new A.$4)})}):b(B=>t(G,B))}e.$1g=t;function n(G,j=0,B){const T=setTimeout(()=>{G(),B&&Z.dispose()},j),Z=(0,M.$Pc)(()=>{clearTimeout(T),B?.deleteAndLeak(Z)});return B?.add(Z),Z}e.$2g=n;function c(G){const j=[];let B=0;const T=G.length;function Z(){return B<T?G[B++]():null}function he(de){de!=null&&j.push(de);const le=Z();return le?le.then(he):Promise.resolve(j)}return Promise.resolve(null).then(he)}e.$3g=c;function m(G,j=T=>!!T,B=null){let T=0;const Z=G.length,he=()=>{if(T>=Z)return Promise.resolve(B);const de=G[T++];return Promise.resolve(de()).then(we=>j(we)?Promise.resolve(we):he())};return he()}e.$4g=m;function D(G,j=T=>!!T,B=null){if(G.length===0)return Promise.resolve(B);let T=G.length;const Z=()=>{T=-1;for(const he of G)he.cancel?.()};return new Promise((he,de)=>{for(const le of G)le.then(we=>{--T>=0&&j(we)?(Z(),he(we)):T===0&&he(B)}).catch(we=>{--T>=0&&(Z(),de(we))})})}e.$5g=D;class I{constructor(j){this.a=0,this.d=j,this.f=[],this.b=0,this.g=new s.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(j){return this.a++,new Promise((B,T)=>{this.f.push({factory:j,c:B,e:T}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const j=this.f.shift();this.b++;const B=j.factory();B.then(j.c,j.e),B.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$6g=I;class E extends I{constructor(){super(1)}}e.$7g=E;class R{constructor(){this.a=new V,this.b=0}queue(j){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,j())):this.a.run(this.b++,j())}}e.$8g=R;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const j=new H;return this.b.add(j),j.p}g(){for(const[,j]of this.a)if(j.size>0)return!1;return!0}queueFor(j,B=C.$rg){const T=B.getComparisonKey(j);let Z=this.a.get(T);if(!Z){Z=new E;const he=this.f++,de=s.Event.once(Z.onDrained)(()=>{Z?.dispose(),this.a.delete(T),this.h(),this.d?.deleteAndDispose(he),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$1c),this.d.set(he,de),this.a.set(T,Z)}return Z}h(){this.g()&&this.j()}j(){for(const j of this.b)j.complete();this.b.clear()}dispose(){for(const[,j]of this.a)j.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$9g=L;class F{constructor(j,B){this.a=-1,typeof j=="function"&&typeof B=="number"&&this.setIfNotSet(j,B)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(j,B){this.cancel(),this.a=setTimeout(()=>{this.a=-1,j()},B)}setIfNotSet(j,B){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,j()},B))}}e.$0g=F;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(j,B,T=globalThis){this.cancel();const Z=T.setInterval(()=>{j()},B);this.d=(0,M.$Pc)(()=>{T.clearInterval(Z),this.d=void 0})}dispose(){this.cancel()}}e.$$g=U;class x{constructor(j,B){this.b=-1,this.a=j,this.d=B,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(j=this.d){this.cancel(),this.b=setTimeout(this.f,j)}get delay(){return this.d}set delay(j){this.d=j}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$_g=x;class Y{constructor(j,B){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.a=j,this.b=B,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(j=this.b){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(j/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ah=Y;class ae extends x{constructor(j,B){super(j,B),this.j=[]}work(j){this.j.push(j),this.isScheduled()||this.schedule()}h(){const j=this.j;this.j=[],this.a?.(j)}dispose(){this.j=[],super.dispose()}}e.$bh=ae;class oe extends M.$Rc{constructor(j,B){super(),this.g=j,this.h=B,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(j){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+j.length>this.g.maxBufferedWork)return!1}else if(this.pending+j.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const B of j)this.a.push(B);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new x(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ch=oe,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$eh=(G,j)=>{(0,P.$B)(()=>{if(B)return;const T=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,T-Date.now())}}))});let B=!1;return{dispose(){B||(B=!0)}}}:e.$eh=(G,j,B)=>{const T=G.requestIdleCallback(j,typeof B=="number"?{timeout:B}:void 0);let Z=!1;return{dispose(){Z||(Z=!0,G.cancelIdleCallback(T))}}},e.$dh=G=>(0,e.$eh)(globalThis,G)}();class ce{constructor(j,B){this.g=!1,this.d=()=>{try{this.j=B()}catch(T){this.l=T}finally{this.g=!0}},this.f=(0,e.$eh)(j,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$fh=ce;class Q extends ce{constructor(j){super(globalThis,j)}}e.$gh=Q;async function K(G,j,B){let T;for(let Z=0;Z<B;Z++)try{return await G()}catch(he){T=he,await t(j)}throw T}e.$hh=K;class V{isRunning(j){return typeof j=="number"?this.a?.taskId===j:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(j,B,T){return this.a={taskId:j,cancel:()=>T?.(),promise:B},B.then(()=>this.d(j),()=>this.d(j)),B}d(j){this.a&&j===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const j=this.b;this.b=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}queue(j){if(this.b)this.b.run=j;else{let B,T;const Z=new Promise((he,de)=>{B=he,T=de});this.b={run:j,promise:Z,promiseResolve:B,promiseReject:T}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ih=V;class z{constructor(j,B=()=>Date.now()){this.d=j,this.f=B,this.a=0,this.b=0}increment(){const j=this.f();return j-this.a>this.d&&(this.a=j,this.b=0),this.b++,this.b}}e.$jh=z;var W;(function(G){G[G.Resolved=0]="Resolved",G[G.Rejected=1]="Rejected"})(W||(W={}));class H{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((j,B)=>{this.a=j,this.b=B})}complete(j){return new Promise(B=>{this.a(j),this.d={outcome:0,value:j},B()})}error(j){return new Promise(B=>{this.b(j),this.d={outcome:1,value:j},B()})}cancel(){return this.error(new A.$4)}}e.$kh=H;var q;(function(G){async function j(T){let Z;const he=await Promise.all(T.map(de=>de.then(le=>le,le=>{Z||(Z=le)})));if(typeof Z<"u")throw Z;return he}G.settled=j;function B(T){return new Promise(async(Z,he)=>{try{await T(Z,he)}catch(de){he(de)}})}G.withAsyncBody=B})(q||(e.Promises=q={}));var _;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(_||(_={}));class ne{static fromArray(j){return new ne(B=>{B.emitMany(j)})}static fromPromise(j){return new ne(async B=>{B.emitMany(await j)})}static fromPromises(j){return new ne(async B=>{await Promise.all(j.map(async T=>B.emitOne(await T)))})}static merge(j){return new ne(async B=>{await Promise.all(j.map(async T=>{for await(const Z of T)B.emitOne(Z)}))})}static{this.EMPTY=ne.fromArray([])}constructor(j){this.a=0,this.b=[],this.d=null,this.f=new s.$Rd,queueMicrotask(async()=>{const B={emitOne:T=>this.g(T),emitMany:T=>this.h(T),reject:T=>this.k(T)};try{await Promise.resolve(j(B)),this.j()}catch(T){this.k(T)}finally{B.emitOne=void 0,B.emitMany=void 0,B.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(j<this.b.length)return{done:!1,value:this.b[j++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(j,B){return new ne(async T=>{for await(const Z of j)T.emitOne(B(Z))})}map(j){return ne.map(this,j)}static filter(j,B){return new ne(async T=>{for await(const Z of j)B(Z)&&T.emitOne(Z)})}filter(j){return ne.filter(this,j)}static coalesce(j){return ne.filter(j,B=>!!B)}coalesce(){return ne.coalesce(this)}static async toPromise(j){const B=[];for await(const T of j)B.push(T);return B}toPromise(){return ne.toPromise(this)}g(j){this.a===0&&(this.b.push(j),this.f.fire())}h(j){this.a===0&&(this.b=this.b.concat(j),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(j){this.a===0&&(this.a=2,this.d=j,this.f.fire())}}e.$lh=ne;class X extends ne{constructor(j,B){super(B),this.l=j}cancel(){this.l.cancel()}}e.$mh=X;function O(G){const j=new S.$2d,B=G(j.token);return new X(j,async T=>{const Z=j.token.onCancellationRequested(()=>{Z.dispose(),j.dispose(),T.reject(new A.$4)});try{for await(const he of B){if(j.token.isCancellationRequested)return;T.emitOne(he)}Z.dispose(),j.dispose()}catch(he){Z.dispose(),j.dispose(),T.reject(he)}})}e.$nh=O;class N{constructor(){this.a=new H,this.b=new ne(T=>{if(j){T.reject(j);return}return B&&T.emitMany(B),this.d=Z=>T.reject(Z),this.f=Z=>T.emitOne(Z),this.a.p});let j,B;this.f=T=>{B||(B=[]),B.push(T)},this.d=T=>{j||(j=T)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(j){this.d(j),this.a.complete()}emitOne(j){this.f(j)}}e.$oh=N}),define(se[104],re([0,1,23,8,33,31,9,4,25]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=void 0;function u(){return Object.create(null)}e.$zj=u,e.$Aj="**",e.$Bj="/";const b="[/\\\\]",y="[^/\\\\]",p=/\//g;function l(K,V){switch(K){case 0:return"";case 1:return`${y}*?`;default:return`(?:${b}|${y}+${b}${V?`|${b}${y}+`:""})*?`}}function v(K,V){if(!K)return[];const z=[];let W=!1,H=!1,q="";for(const _ of K){switch(_){case V:if(!W&&!H){z.push(q),q="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":H=!0;break;case"]":H=!1;break}q+=_}return q&&z.push(q),z}e.$Cj=v;function $(K){if(!K)return"";let V="";const z=v(K,e.$Bj);if(z.every(W=>W===e.$Aj))V=".*";else{let W=!1;z.forEach((H,q)=>{if(H===e.$Aj){if(W)return;V+=l(2,q===z.length-1)}else{let _=!1,ne="",X=!1,O="";for(const N of H){if(N!=="}"&&_){ne+=N;continue}if(X&&(N!=="]"||!O)){let G;N==="-"?G=N:(N==="^"||N==="!")&&!O?G="^":N===e.$Bj?G="":G=(0,d.$Je)(N),O+=G;continue}switch(N){case"{":_=!0;continue;case"[":X=!0;continue;case"}":{const j=`(?:${v(ne,",").map(B=>$(B)).join("|")})`;V+=j,_=!1,ne="";break}case"]":{V+="["+O+"]",X=!1,O="";break}case"?":V+=y;continue;case"*":V+=l(1);continue;default:V+=(0,d.$Je)(N)}}q<z.length-1&&(z[q+1]!==e.$Aj||q+2<z.length)&&(V+=b)}W=H===e.$Aj})}return V}const w=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,k=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.$Cc(1e4),o=function(){return!1},r=function(){return null};function t(K,V){if(!K)return r;let z;typeof K!="string"?z=K.pattern:z=K,z=z.trim();const W=`${z}_${!!V.trimForExclusions}`;let H=i.get(W);if(H)return n(H,K);let q;return w.test(z)?H=m(z.substr(4),z):(q=g.exec(c(z,V)))?H=D(q[1],z):(V.trimForExclusions?a:h).test(z)?H=I(z,V):(q=k.exec(c(z,V)))?H=E(q[1].substr(1),z,!0):(q=f.exec(c(z,V)))?H=E(q[1],z,!1):H=R(z),i.set(W,H),n(H,K)}function n(K,V){if(typeof V=="string")return K;const z=function(W,H){return(0,s.$2f)(W,V.base,!P.$k)?K((0,d.$Ne)(W.substr(V.base.length),C.sep),H):null};return z.allBasenames=K.allBasenames,z.allPaths=K.allPaths,z.basenames=K.basenames,z.patterns=K.patterns,z}function c(K,V){return V.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function m(K,V){return function(z,W){return typeof z=="string"&&z.endsWith(K)?V:null}}function D(K,V){const z=`/${K}`,W=`\\${K}`,H=function(_,ne){return typeof _!="string"?null:ne?ne===K?V:null:_===K||_.endsWith(z)||_.endsWith(W)?V:null},q=[K];return H.basenames=q,H.patterns=[V],H.allBasenames=q,H}function I(K,V){const z=ce(K.slice(1,-1).split(",").map(ne=>t(ne,V)).filter(ne=>ne!==r),K),W=z.length;if(!W)return r;if(W===1)return z[0];const H=function(ne,X){for(let O=0,N=z.length;O<N;O++)if(z[O](ne,X))return K;return null},q=z.find(ne=>!!ne.allBasenames);q&&(H.allBasenames=q.allBasenames);const _=z.reduce((ne,X)=>X.allPaths?ne.concat(X.allPaths):ne,[]);return _.length&&(H.allPaths=_),H}function E(K,V,z){const W=C.sep===C.$fc.sep,H=W?K:K.replace(p,C.sep),q=C.sep+H,_=C.$fc.sep+K;let ne;return z?ne=function(X,O){return typeof X=="string"&&(X===H||X.endsWith(q)||!W&&(X===K||X.endsWith(_)))?V:null}:ne=function(X,O){return typeof X=="string"&&(X===H||!W&&X===K)?V:null},ne.allPaths=[(z?"*/":"./")+K],ne}function R(K){try{const V=new RegExp(`^${$(K)}$`);return function(z){return V.lastIndex=0,typeof z=="string"&&V.test(z)?K:null}}catch{return r}}function L(K,V,z){return!K||typeof V!="string"?!1:F(K)(V,void 0,z)}e.$Dj=L;function F(K,V={}){if(!K)return o;if(typeof K=="string"||U(K)){const z=t(K,V);if(z===r)return o;const W=function(H,q){return!!z(H,q)};return z.allBasenames&&(W.allBasenames=z.allBasenames),z.allPaths&&(W.allPaths=z.allPaths),W}return ae(K,V)}e.$Ej=F;function U(K){const V=K;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.$Fj=U;function x(K){return K.allBasenames||[]}e.$Gj=x;function Y(K){return K.allPaths||[]}e.$Hj=Y;function ae(K,V){const z=ce(Object.getOwnPropertyNames(K).map(ne=>oe(ne,K[ne],V)).filter(ne=>ne!==r)),W=z.length;if(!W)return r;if(!z.some(ne=>!!ne.requiresSiblings)){if(W===1)return z[0];const ne=function(N,G){let j;for(let B=0,T=z.length;B<T;B++){const Z=z[B](N,G);if(typeof Z=="string")return Z;(0,A.$Mg)(Z)&&(j||(j=[]),j.push(Z))}return j?(async()=>{for(const B of j){const T=await B;if(typeof T=="string")return T}return null})():null},X=z.find(N=>!!N.allBasenames);X&&(ne.allBasenames=X.allBasenames);const O=z.reduce((N,G)=>G.allPaths?N.concat(G.allPaths):N,[]);return O.length&&(ne.allPaths=O),ne}const H=function(ne,X,O){let N,G;for(let j=0,B=z.length;j<B;j++){const T=z[j];T.requiresSiblings&&O&&(X||(X=(0,C.$mc)(ne)),N||(N=X.substr(0,X.length-(0,C.$nc)(ne).length)));const Z=T(ne,X,N,O);if(typeof Z=="string")return Z;(0,A.$Mg)(Z)&&(G||(G=[]),G.push(Z))}return G?(async()=>{for(const j of G){const B=await j;if(typeof B=="string")return B}return null})():null},q=z.find(ne=>!!ne.allBasenames);q&&(H.allBasenames=q.allBasenames);const _=z.reduce((ne,X)=>X.allPaths?ne.concat(X.allPaths):ne,[]);return _.length&&(H.allPaths=_),H}function oe(K,V,z){if(V===!1)return r;const W=t(K,z);if(W===r)return r;if(typeof V=="boolean")return W;if(V){const H=V.when;if(typeof H=="string"){const q=(_,ne,X,O)=>{if(!O||!W(_,ne))return null;const N=H.replace("$(basename)",()=>X),G=O(N);return(0,A.$Mg)(G)?G.then(j=>j?K:null):G?K:null};return q.requiresSiblings=!0,q}}return W}function ce(K,V){const z=K.filter(ne=>!!ne.basenames);if(z.length<2)return K;const W=z.reduce((ne,X)=>{const O=X.basenames;return O?ne.concat(O):ne},[]);let H;if(V){H=[];for(let ne=0,X=W.length;ne<X;ne++)H.push(V)}else H=z.reduce((ne,X)=>{const O=X.patterns;return O?ne.concat(O):ne},[]);const q=function(ne,X){if(typeof ne!="string")return null;if(!X){let N;for(N=ne.length;N>0;N--){const G=ne.charCodeAt(N-1);if(G===47||G===92)break}X=ne.substr(N)}const O=W.indexOf(X);return O!==-1?H[O]:null};q.basenames=W,q.patterns=H,q.allBasenames=W;const _=K.filter(ne=>!ne.basenames);return _.push(q),_}function Q(K,V){return(0,S.$tb)(K,V,(z,W)=>typeof z=="string"&&typeof W=="string"?z===W:typeof z!="string"&&typeof W!="string"?z.base===W.base&&z.pattern===W.pattern:!1)}e.$Ij=Q}),define(se[47],re([0,1,23,33,9,4,19,25]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=void 0;function d(t,n){const{os:c,tildify:m,relative:D}=n;if(D){const R=u(t,D,c);if(typeof R=="string")return R}let I=t.fsPath;if(c===1&&!M.$i?I=I.replace(/\//g,"\\"):c!==1&&M.$i&&(I=I.replace(/\\/g,"/")),c!==1&&m?.userHome){const R=m.userHome.fsPath;let L;t.scheme!==m.userHome.scheme&&t.path[0]===s.$fc.sep&&t.path[1]!==s.$fc.sep?L=m.userHome.with({path:t.path}).fsPath:L=I,I=p(L,R,c)}return(c===1?s.$ec:s.$fc).normalize(b(I,c===1))}e.$Av=d;function u(t,n,c){const m=c===1?s.$ec:s.$fc,D=c===3?C.$rg:C.$tg,I=n.getWorkspace(),E=(0,S.$Nb)(I.folders);if(!E)return;t.scheme!==E.uri.scheme&&t.path[0]===s.$fc.sep&&t.path[1]!==s.$fc.sep&&(t=E.uri.with({path:t.path}));const R=n.getWorkspaceFolder(t);if(!R)return;let L;if(D.isEqual(R.uri,t)?L="":L=D.relativePath(R.uri,t)??"",L&&(L=m.normalize(L)),I.folders.length>1&&!n.noPrefix){const F=R.name?R.name:D.basenameOrAuthority(R.uri);L=L?`${F} \u2022 ${L}`:F}return L}function b(t,n=M.$i){return(0,A.$6f)(t,n)?t.charAt(0).toUpperCase()+t.slice(1):t}e.$Bv=b;let y=Object.create(null);function p(t,n,c=M.OS){if(c===1||!t||!n)return t;let m=y.original===n?y.normalized:void 0;m||(m=n,M.$i&&(m=(0,A.$Vf)(m)),m=`${(0,P.$Oe)(m,s.$fc.sep)}${s.$fc.sep}`,y={original:n,normalized:m});let D=t;return M.$i&&(D=(0,A.$Vf)(D)),(c===3?D.startsWith(m):(0,P.$7e)(D,m))?`~/${D.substr(m.length)}`:t}e.$Cv=p;function l(t,n){return t.replace(/^~($|\/|\\)/,`${n}$1`)}e.$Dv=l;const v="\u2026",$="\\\\",w="~";function g(t,n=s.sep){const c=new Array(t.length);let m=!1;for(let D=0;D<t.length;D++){const I=t[D];if(I===""){c[D]=`.${n}`;continue}if(!I){c[D]=I;continue}m=!0;let E="",R=I;R.indexOf($)===0?(E=R.substr(0,R.indexOf($)+$.length),R=R.substr(R.indexOf($)+$.length)):R.indexOf(n)===0?(E=R.substr(0,R.indexOf(n)+n.length),R=R.substr(R.indexOf(n)+n.length)):R.indexOf(w)===0&&(E=R.substr(0,R.indexOf(w)+w.length),R=R.substr(R.indexOf(w)+w.length));const L=R.split(n);for(let F=1;m&&F<=L.length;F++)for(let U=L.length-F;m&&U>=0;U--){m=!1;let x=L.slice(U,U+F).join(n);for(let Y=0;!m&&Y<t.length;Y++)if(Y!==D&&t[Y]&&t[Y].indexOf(x)>-1){const ae=U+F===L.length,oe=U>0&&t[Y].indexOf(n)>-1?n+x:x,ce=t[Y].endsWith(oe);m=!ae||ce}if(!m){let Y="";(L[0].endsWith(":")||E!=="")&&(U===1&&(U=0,F++,x=L[0]+n+x),U>0&&(Y=L[0]+n),Y=E+Y),U>0&&(Y=Y+v+n),Y=Y+x,U+F<L.length&&(Y=Y+n+v),c[D]=Y}}m&&(c[D]=I)}return c}e.$Ev=g;var h;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function a(t,n=Object.create(null)){const c=[];let m=!1,D="";for(const I of t)if(I==="$"||m&&I==="{")D&&c.push({value:D,type:h.TEXT}),D="",m=!0;else if(I==="}"&&m){const E=n[D];if(typeof E=="string")E.length&&c.push({value:E,type:h.VARIABLE});else if(E){const R=c[c.length-1];(!R||R.type!==h.SEPARATOR)&&c.push({value:E.label,type:h.SEPARATOR})}D="",m=!1}else D+=I;return D&&!m&&c.push({value:D,type:h.TEXT}),c.filter((I,E)=>{if(I.type===h.SEPARATOR){const R=c[E-1],L=c[E+1];return[R,L].every(F=>F&&(F.type===h.VARIABLE||F.type===h.TEXT)&&F.value.length>0)}return!0}).map(I=>I.value).join("")}e.$Fv=a;function k(t,n){return M.$j||n?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):t.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.$Gv=k;function f(t,n){return M.$j||n?t.replace(/\(&&\w\)|&&/g,""):M.$i?t.replace(/&&|&/g,c=>c==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.$Hv=f;function i(t){return t.replace(/&/g,"&&")}e.$Iv=i;function o(t){if(t.endsWith("]")){const n=t.lastIndexOf(" [",t.length-2);if(n!==-1){const c=r(t.substring(0,n));return{name:c.name,parentPath:c.parentPath+t.substring(n)}}}return r(t)}e.$Jv=o;function r(t){const n=t.indexOf("/")!==-1?s.$fc:s.$ec,c=n.basename(t),m=n.dirname(t);return c.length?{name:c,parentPath:m}:{name:m,parentPath:""}}}),define(se[155],re([0,1,18,7]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=void 0;function s(y){return y.toJSON()}class M{constructor(p){this.a=p}transformIncoming(p){const l=this.a.transformIncoming(p);return l===p?p:s(A.URI.from(l))}transformOutgoing(p){const l=this.a.transformOutgoing(p);return l===p?p:s(A.URI.from(l))}transformOutgoingURI(p){const l=this.a.transformOutgoing(p);return l===p?p:A.URI.from(l)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Tm=M,e.$Um=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function C(y,p,l){if(!y||l>200)return null;if(typeof y=="object"){if(y instanceof A.URI)return p.transformOutgoing(y);for(const v in y)if(Object.hasOwnProperty.call(y,v)){const $=C(y[v],p,l+1);$!==null&&(y[v]=$)}}return null}function P(y,p){const l=C(y,p,0);return l===null?y:l}e.$Vm=P;function d(y,p,l,v){if(!y||v>200)return null;if(typeof y=="object"){if(y.$mid===1)return l?A.URI.revive(p.transformIncoming(y)):p.transformIncoming(y);if(y instanceof S.$fe)return null;for(const $ in y)if(Object.hasOwnProperty.call(y,$)){const w=d(y[$],p,l,v+1);w!==null&&(y[$]=w)}}return null}function u(y,p){const l=d(y,p,!1,0);return l===null?y:l}e.$Wm=u;function b(y,p){const l=d(y,p,!0,0);return l===null?y:l}e.$Xm=b}),define(se[88],re([0,1,28,57,32,145,4]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=e.$Zm=void 0,e.$Zm=new class{c(p){return this.a||(this.a=A.$4h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,l=0;const v=(0,S.networkInterfaces)();for(const $ in v){const w=v[$];if(w)for(const{mac:g,internal:h}of w)h||(l+=1,this.c(g.toUpperCase())&&(p+=1))}this.b=l>0?p/l:0}return this.b}};let P;async function d(p){return P||(P=(async()=>await u(p)||s.$kg())()),P}e.$1m=d;async function u(p){try{const l=await new Promise(($,w)=>{J(["crypto"],$,w)}),v=(0,M.$Ym)();return l.createHash("sha256").update(v,"utf8").digest("hex")}catch(l){p(l);return}}const b="Software\\Microsoft\\SQMClient";async function y(p){if(C.$i){const l=await new Promise((v,$)=>{J(["@vscode/windows-registry"],v,$)});try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",b,"MachineId")||""}catch(v){return p(v),""}}return""}e.$2m=y}),define(se[21],re([0,1,46,28,156,8,33,85,9,4,19,7]),function(J,e,S,A,s,M,C,P,d,u,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(oe){oe[oe.UNLINK=0]="UNLINK",oe[oe.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function l(oe,ce=p.UNLINK,Q){if((0,C.$5f)(oe))throw new Error("rimraf - will refuse to recursively delete root");return ce===p.UNLINK?$(oe):v(oe,Q)}async function v(oe,ce=(0,C.$0f)((0,A.tmpdir)())){try{try{await S.promises.rename(oe,ce)}catch(Q){return Q.code==="ENOENT"?void 0:$(oe)}$(ce).catch(Q=>{})}catch(Q){if(Q.code!=="ENOENT")throw Q}}async function $(oe){return(0,s.promisify)(S.rm)(oe,{recursive:!0,force:!0,maxRetries:3})}function w(oe){if((0,C.$5f)(oe))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(oe,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function g(oe,ce){return k(await(ce?h(oe):(0,s.promisify)(S.readdir)(oe)))}async function h(oe){try{return await(0,s.promisify)(S.readdir)(oe,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const ce=[],Q=await g(oe);for(const K of Q){let V=!1,z=!1,W=!1;try{const H=await e.Promises.lstat((0,d.$ic)(oe,K));V=H.isFile(),z=H.isDirectory(),W=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}ce.push({name:K,isFile:()=>V,isDirectory:()=>z,isSymbolicLink:()=>W})}return ce}function a(oe){return k(S.readdirSync(oe))}e.readdirSync=a;function k(oe){return oe.map(ce=>typeof ce=="string"?u.$j?(0,P.$wl)(ce):ce:(ce.name=u.$j?(0,P.$wl)(ce.name):ce.name,ce))}async function f(oe){const ce=await g(oe),Q=[];for(const K of ce)await o.existsDirectory((0,d.$ic)(oe,K))&&Q.push(K);return Q}function i(oe,ce=1e3){return new Promise(Q=>{let K=!1;const V=setInterval(()=>{K||(K=!0,S.access(oe,z=>{K=!1,z&&(clearInterval(V),Q(void 0))}))},ce)})}e.whenDeleted=i;var o;(function(oe){async function ce(V){let z;try{if(z=await e.Promises.lstat(V),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(u.$i&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw H}throw W}}oe.stat=ce;async function Q(V){try{const{stat:z,symbolicLink:W}=await oe.stat(V);return z.isFile()&&W?.dangling!==!0}catch{}return!1}oe.existsFile=Q;async function K(V){try{const{stat:z,symbolicLink:W}=await oe.stat(V);return z.isDirectory()&&W?.dangling!==!0}catch{}return!1}oe.existsDirectory=K})(o||(e.SymlinkSupport=o={}));const r=new M.$9g;function t(oe,ce,Q){return r.queueFor(y.URI.file(oe),b.$sg).queue(()=>{const K=I(Q);return new Promise((V,z)=>m(oe,ce,K,W=>W?z(W):V()))})}let n=!0;function c(oe){n=oe}e.configureFlushOnWrite=c;function m(oe,ce,Q,K){if(!n)return S.writeFile(oe,ce,{mode:Q.mode,flag:Q.flag},K);S.open(oe,Q.flag,Q.mode,(V,z)=>{if(V)return K(V);S.writeFile(z,ce,W=>{if(W)return S.close(z,()=>K(W));S.fdatasync(z,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),c(!1)),S.close(z,q=>K(q))))})})}function D(oe,ce,Q){const K=I(Q);if(!n)return S.writeFileSync(oe,ce,{mode:K.mode,flag:K.flag});const V=S.openSync(oe,K.flag,K.mode);try{S.writeFileSync(V,ce);try{S.fdatasyncSync(V)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),c(!1)}}finally{S.closeSync(V)}}e.writeFileSync=D;function I(oe){return oe?{mode:typeof oe.mode=="number"?oe.mode:438,flag:typeof oe.flag=="string"?oe.flag:"w"}:{mode:438,flag:"w"}}async function E(oe,ce,Q=6e4){if(oe!==ce)try{u.$i&&typeof Q=="number"?await R(oe,ce,Date.now(),Q):await(0,s.promisify)(S.rename)(oe,ce)}catch(K){if(oe.toLowerCase()!==ce.toLowerCase()&&K.code==="EXDEV"||oe.endsWith("."))await L(oe,ce,{preserveSymlinks:!1}),await l(oe,p.MOVE);else throw K}}async function R(oe,ce,Q,K,V=0){try{return await(0,s.promisify)(S.rename)(oe,ce)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-Q>=K)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${z}`),z;if(V===0){let W=!1;try{const{stat:H}=await o.stat(ce);H.isFile()||(W=!0)}catch{}if(W)throw z}return await(0,M.$1g)(Math.min(100,V*10)),R(oe,ce,Q,K,V+1)}}async function L(oe,ce,Q){return U(oe,ce,{root:{source:oe,target:ce},options:Q,handledSourcePaths:new Set})}const F=511;async function U(oe,ce,Q){if(Q.handledSourcePaths.has(oe))return;Q.handledSourcePaths.add(oe);const{stat:K,symbolicLink:V}=await o.stat(oe);if(V){if(Q.options.preserveSymlinks)try{return await ae(oe,ce,Q)}catch{}if(V.dangling)return}return K.isDirectory()?x(oe,ce,K.mode&F,Q):Y(oe,ce,K.mode&F)}async function x(oe,ce,Q,K){await e.Promises.mkdir(ce,{recursive:!0,mode:Q});const V=await g(oe);for(const z of V)await U((0,d.$ic)(oe,z),(0,d.$ic)(ce,z),K)}async function Y(oe,ce,Q){await e.Promises.copyFile(oe,ce),await e.Promises.chmod(ce,Q)}async function ae(oe,ce,Q){let K=await e.Promises.readlink(oe);(0,C.$2f)(K,Q.root.source,!u.$k)&&(K=(0,d.$ic)(Q.root.target,K.substr(Q.root.source.length+1))),await e.Promises.symlink(K,ce)}e.Promises=new class{get access(){return(0,s.promisify)(S.access)}get stat(){return(0,s.promisify)(S.stat)}get lstat(){return(0,s.promisify)(S.lstat)}get utimes(){return(0,s.promisify)(S.utimes)}get read(){return(oe,ce,Q,K,V)=>new Promise((z,W)=>{S.read(oe,ce,Q,K,V,(H,q,_)=>H?W(H):z({bytesRead:q,buffer:_}))})}get readFile(){return(0,s.promisify)(S.readFile)}get write(){return(oe,ce,Q,K,V)=>new Promise((z,W)=>{S.write(oe,ce,Q,K,V,(H,q,_)=>H?W(H):z({bytesWritten:q,buffer:_}))})}get appendFile(){return(0,s.promisify)(S.appendFile)}get fdatasync(){return(0,s.promisify)(S.fdatasync)}get truncate(){return(0,s.promisify)(S.truncate)}get copyFile(){return(0,s.promisify)(S.copyFile)}get open(){return(0,s.promisify)(S.open)}get close(){return(0,s.promisify)(S.close)}get symlink(){return(0,s.promisify)(S.symlink)}get readlink(){return(0,s.promisify)(S.readlink)}get chmod(){return(0,s.promisify)(S.chmod)}get mkdir(){return(0,s.promisify)(S.mkdir)}get unlink(){return(0,s.promisify)(S.unlink)}get rmdir(){return(0,s.promisify)(S.rmdir)}get realpath(){return(0,s.promisify)(S.realpath)}async exists(oe){try{return await e.Promises.access(oe),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return f}get writeFile(){return t}get rm(){return l}get rename(){return E}get copy(){return L}}}),define(se[105],re([0,1,46,9,4,25,21]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=e.$bq=e.$aq=void 0;function P(p){if(s.$k)return p;const l=(0,A.$lc)(p);if(p===l)return p;const v=((0,A.$mc)(p)||p).toLowerCase();try{const w=(0,C.readdirSync)(l).filter(g=>g.toLowerCase()===v);if(w.length===1){const g=P(l);if(g)return(0,A.$ic)(g,w[0])}else if(w.length>1){const g=w.indexOf(v);if(g>=0){const h=P(l);if(h)return(0,A.$ic)(h,w[g])}}}catch{}return null}e.$aq=P;async function d(p){if(s.$k)return p;const l=(0,A.$lc)(p);if(p===l)return p;const v=((0,A.$mc)(p)||p).toLowerCase();try{const w=(await C.Promises.readdir(l)).filter(g=>g.toLowerCase()===v);if(w.length===1){const g=await d(l);if(g)return(0,A.$ic)(g,w[0])}else if(w.length>1){const g=w.indexOf(v);if(g>=0){const h=await d(l);if(h)return(0,A.$ic)(h,w[g])}}}catch{}return null}e.$bq=d;async function u(p){try{return await C.Promises.realpath(p)}catch{const v=y(p);return await C.Promises.access(v,S.constants.R_OK),v}}e.$cq=u;function b(p){try{return S.realpathSync(p)}catch{const v=y(p);return S.accessSync(v,S.constants.R_OK),v}}e.$dq=b;function y(p){return(0,M.$Oe)((0,A.$gc)(p),A.sep)}}),define(se[106],re([0,1,28,9,21]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=void 0;const M=/^\d+$/,C=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var d;(function(k){k[k.x64=0]="x64",k[k.x86=1]="x86",k[k.ARM=2]="ARM"})(d||(d={}));let u;switch(process.arch){case"ia32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class y{constructor(f,i,o){this.exePath=f,this.displayName=i,this.a=o}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:k=!1}={}){return k?u===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function l({useAlternateBitness:k=!1,findPreview:f=!1}={}){const i=p({useAlternateBitness:k});if(!i)return null;const o=A.$ic(i,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(o))return null;let r=-1,t=null;for(const m of await s.Promises.readdir(o)){let D=-1;if(f){const E=m.indexOf("-");if(E<0)continue;const R=m.substring(0,E);if(!M.test(R)||m.substring(E+1)!=="preview")continue;D=parseInt(R,10)}else{if(!M.test(m))continue;D=parseInt(m,10)}if(D<=r)continue;const I=A.$ic(o,m,"pwsh.exe");await s.SymlinkSupport.existsFile(I)&&(t=I,r=D)}if(!t)return null;const n=i.includes("x86")?" (x86)":"",c=f?" Preview":"";return new y(t,`PowerShell${c}${n}`,!0)}async function v({findPreview:k}={}){if(!process.env.LOCALAPPDATA)return null;const f=A.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=k?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(f))if(i.test(r)){const t=A.$ic(f,r,"pwsh.exe");return new y(t,o)}return null}function $(){const k=A.$ic(S.homedir(),".dotnet","tools","pwsh.exe");return new y(k,".NET Core PowerShell Global Tool")}function w(){const k=A.$ic(process.env.windir,u===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(k,"Windows PowerShell",!0)}async function*g(){let k=await l();k&&(yield k),k=await l({useAlternateBitness:!0}),k&&(yield k),k=await v(),k&&(yield k),k=$(),k&&(yield k),k=await l({findPreview:!0}),k&&(yield k),k=await v({findPreview:!0}),k&&(yield k),k=await l({useAlternateBitness:!0,findPreview:!0}),k&&(yield k),k=w(),k&&(yield k)}async function*h(){for await(const k of g())await k.exists()&&(yield k)}e.$Fl=h;async function a(){for await(const k of h())return k;return null}e.$Gl=a}),define(se[89],re([0,1,9,4,35,76,12,21]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Kl=e.$Jl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function d(y=s.env){return y.comspec||"cmd.exe"}e.$Jl=d;function u(y){let p=[],l=!1;const v=function($){if(l){p.push($);return}(!y.send($,g=>{if(g&&console.error(g),l=!1,p.length>0){const h=p.slice(0);p=[],h.forEach(a=>v(a))}})||A.$i)&&(l=!0)};return{send:v}}e.$Kl=u;var b;(function(y){async function p(l,v,$){if(S.$hc(l))return l;if(v===void 0&&(v=s.cwd()),S.$lc(l)!=="."||($===void 0&&C.$Cf(s.env.PATH)&&($=s.env.PATH.split(S.$sc)),$===void 0||$.length===0))return S.$ic(v,l);async function g(h){if(await P.Promises.exists(h)){let a;try{a=await P.Promises.stat(h)}catch(k){k.message.startsWith("EACCES")&&(a=await P.Promises.lstat(h))}return a?!a.isDirectory():!1}return!1}for(const h of $){let a;if(S.$hc(h)?a=S.$ic(h,l):a=S.$ic(v,h,l),await g(a))return a;let k=a+".com";if(await g(k)||(k=a+".exe",await g(k)))return k}return S.$ic(v,l)}y.findExecutable=p})(b||(e.win32=b={}))}),define(se[107],re([0,1,48,13]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=void 0;function s(C){return new Promise((P,d)=>{let u;const b=new Map;function y(l,v,$,w,g){const h=b.get(v);if(l===C||h){const a={name:p($),cmd:$,pid:l,ppid:v,load:w,mem:g};b.set(l,a),l===C&&(u=a),h&&(h.children||(h.children=[]),h.children.push(a),h.children.length>1&&(h.children=h.children.sort((k,f)=>k.pid-f.pid)))}}function p(l){const v=/--utility-sub-type=network/i,$=/--ms-enable-electron-run-as-node/i,w=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,a=/--type=([a-zA-Z-]+)/;if(w.exec(l))return"electron-crash-reporter";if(g.exec(l))return"winpty-agent";if(h.exec(l))return"conpty-agent";let k=a.exec(l);if(k&&k.length===2)return k[1]==="renderer"?"window":k[1]==="utility"?v.exec(l)?"utility-network-service":"utility-process":k[1]==="extensionHost"?"extension-host":k[1];const f=/[a-zA-Z-]+\.js/g;let i="";do k=f.exec(l),k&&(i+=k+" ");while(k);return i&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${i})`:$.exec(l)?`electron-nodejs (${l})`:l}if(process.platform==="win32"){const l=v=>v.indexOf("\\\\?\\")===0||v.indexOf("\\??\\")===0?v.substring(4):v.indexOf('"\\\\?\\')===0||v.indexOf('"\\??\\')===0?'"'+v.substring(5):v;new Promise((v,$)=>{J(["@vscode/windows-process-tree"],v,$)}).then(v=>{v.getProcessList(C,$=>{if(!$){d(new Error(`Root process ${C} not found`));return}v.getProcessCpuUsage($,w=>{const g=new Map;w.forEach(h=>{const a=l(h.commandLine||"");g.set(h.pid,{name:p(a),cmd:a,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),u=g.get(C),u?(g.forEach(h=>{const a=g.get(h.ppid);a&&(a.children||(a.children=[]),a.children.push(h))}),g.forEach(h=>{h.children&&(h.children=h.children.sort((a,k)=>a.pid-k.pid))}),P(u)):d(new Error(`Root process ${C} not found`))})},v.ProcessDataFlag.CommandLine|v.ProcessDataFlag.Memory)})}else{let l=function(){let v=[u];const $=[];for(;v.length;){const g=v.shift();g&&($.push(g.pid),g.children&&(v=v.concat(g.children)))}let w=JSON.stringify(A.$ig.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+$.join(" "),(0,S.exec)(w,{},(g,h,a)=>{if(g||a)d(g||new Error(a.toString()));else{const k=h.toString().split(`
`);for(let f=0;f<$.length;f++){const i=b.get($[f]);i.load=parseFloat(k[f])}if(!u){d(new Error(`Root process ${C} not found`));return}P(u)}})};(0,S.exec)("which ps",{},(v,$,w)=>{if(v||w)if(process.platform!=="linux")d(v||new Error(w.toString()));else{const g=JSON.stringify(A.$ig.asFileUri("vs/base/node/ps.sh").fsPath);(0,S.exec)(g,{},(h,a,k)=>{h||k?d(h||new Error(k.toString())):(M(a,y),l())})}else{const g=$.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${g} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(a,k,f)=>{a||f&&!f.includes("screen size is bogus")?d(a||new Error(f.toString())):(M(k,y),process.platform==="linux"?l():u?P(u):d(new Error(`Root process ${C} not found`)))})}})}})}e.$Kr=s;function M(C,P){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,u=C.toString().split(`
`);for(const b of u){const y=d.exec(b.trim());y&&y.length===6&&P(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(se[108],re([0,1,28,4,106,89]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=void 0;async function C(y,p){return y===1?A.$i?b():M.$Jl(p):d(y,p)}e.$Ll=C;let P=null;function d(y,p){if(A.$k&&y===2||A.$j&&y===3)return"/bin/bash";if(!P){let l;if(A.$i)l="/bin/bash";else{if(l=p.SHELL,!l)try{l=(0,S.userInfo)().shell}catch{}l||(l="sh"),l==="/bin/false"&&(l="/bin/bash")}P=l}return P}let u=null;async function b(){return u||(u=(await(0,s.$Gl)()).exePath),u}});var ve=this&&this.__decorate||function(J,e,S,A){var s=arguments.length,M=s<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,S):A,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(J,e,S,A);else for(var P=J.length-1;P>=0;P--)(C=J[P])&&(M=(s<3?C(M):s>3?C(e,S,M):C(e,S))||M);return s>3&&M&&Object.defineProperty(e,S,M),M};define(se[42],re([0,1,23,8,18,22,56,14,3,2,77,25,12]),function(J,e,S,A,s,M,C,P,d,u,b,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gh=e.ProxyChannel=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.RequestInitiator=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=void 0;var l;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(l||(l={}));function v(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var $;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})($||($={}));function w(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(g||(g={}));function h(V){let z=0;for(let W=0;;W+=7){const H=V.read(1);if(z|=(H.buffer[0]&127)<<W,!(H.buffer[0]&128))return z}}const a=r(0);function k(V,z){if(z===0){V.write(a);return}let W=0;for(let q=z;q!==0;q=q>>>7)W++;const H=s.$fe.alloc(W);for(let q=0;z!==0;q++)H.buffer[q]=z&127,z=z>>>7,z>0&&(H.buffer[q]|=128);V.write(H)}class f{constructor(z){this.b=z,this.a=0}read(z){const W=this.b.slice(this.a,this.a+z);return this.a+=W.byteLength,W}}e.$vh=f;class i{constructor(){this.a=[]}get buffer(){return s.$fe.concat(this.a)}write(z){this.a.push(z)}}e.$wh=i;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function r(V){const z=s.$fe.alloc(1);return z.writeUInt8(V,0),z}const t={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},n=typeof Buffer<"u";function c(V,z){if(typeof z>"u")V.write(t.Undefined);else if(typeof z=="string"){const W=s.$fe.fromString(z);V.write(t.String),k(V,W.byteLength),V.write(W)}else if(n&&Buffer.isBuffer(z)){const W=s.$fe.wrap(z);V.write(t.Buffer),k(V,W.byteLength),V.write(W)}else if(z instanceof s.$fe)V.write(t.VSBuffer),k(V,z.byteLength),V.write(z);else if(Array.isArray(z)){V.write(t.Array),k(V,z.length);for(const W of z)c(V,W)}else if(typeof z=="number"&&(z|0)===z)V.write(t.Uint),k(V,z);else{const W=s.$fe.fromString(JSON.stringify(z));V.write(t.Object),k(V,W.byteLength),V.write(W)}}e.$xh=c;function m(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(h(V)).toString();case o.Buffer:return V.read(h(V)).buffer;case o.VSBuffer:return V.read(h(V));case o.Array:{const W=h(V),H=[];for(let q=0;q<W;q++)H.push(m(V));return H}case o.Object:return JSON.parse(V.read(h(V)).toString());case o.Int:return h(V)}}e.$yh=m;class D{constructor(z,W,H=null,q=1e3){this.h=z,this.j=W,this.k=H,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(z,W){this.b.set(z,W),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case 200:{const W=this.o([z.type]);this.k?.logOutgoing(W,0,1,w(z.type));return}case 201:case 202:case 204:case 203:{const W=this.o([z.type,z.id],z.data);this.k?.logOutgoing(W,z.id,1,w(z.type),z.data);return}}}o(z,W=void 0){const H=new i;return c(H,z),c(H,W),this.p(H.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const W=new f(z),H=m(W),q=m(W),_=H[0];switch(_){case 100:return this.k?.logIncoming(z.byteLength,H[1],1,`${v(_)}: ${H[2]}.${H[3]}`,q),this.s({type:_,id:H[1],channelName:H[2],name:H[3],arg:q});case 102:return this.k?.logIncoming(z.byteLength,H[1],1,`${v(_)}: ${H[2]}.${H[3]}`,q),this.t({type:_,id:H[1],channelName:H[2],name:H[3],arg:q});case 101:return this.k?.logIncoming(z.byteLength,H[1],1,`${v(_)}`),this.u({type:_,id:H[1]});case 103:return this.k?.logIncoming(z.byteLength,H[1],1,`${v(_)}`),this.u({type:_,id:H[1]})}}s(z){const W=this.b.get(z.channelName);if(!W){this.v(z);return}const H=new M.$2d;let q;try{q=W.call(this.j,z.name,z.arg,H.token)}catch(X){q=Promise.reject(X)}const _=z.id;q.then(X=>{this.m({id:_,data:X,type:201})},X=>{X instanceof Error?this.m({id:_,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.m({id:_,data:X,type:203})}).finally(()=>{ne.dispose(),this.d.delete(z.id)});const ne=(0,u.$Pc)(()=>H.cancel());this.d.set(z.id,ne)}t(z){const W=this.b.get(z.channelName);if(!W){this.v(z);return}const H=z.id,_=W.listen(this.j,z.name,z.arg)(ne=>this.m({id:H,data:ne,type:204}));this.d.set(z.id,_)}u(z){const W=this.d.get(z.id);W&&(W.dispose(),this.d.delete(z.id))}v(z){let W=this.g.get(z.channelName);W||(W=[],this.g.set(z.channelName,W));const H=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:z,timeoutTimer:H})}w(z){const W=this.g.get(z);if(W){for(const H of W)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.$Mc)(this.d.values()),this.d.clear()}}e.$zh=D;var I;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class E{constructor(z,W=null){this.l=z,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.$Rd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=W}getChannel(z){const W=this;return{call(H,q,_){return W.a?Promise.reject(new P.$4):W.m(z,H,q,_)},listen(H,q){return W.a?d.Event.None:W.o(z,H,q)}}}m(z,W,H,q=M.CancellationToken.None){const _=this.g++,X={id:_,type:100,channelName:z,name:W,arg:H};if(q.isCancellationRequested)return Promise.reject(new P.$4);let O;return new Promise((G,j)=>{if(q.isCancellationRequested)return j(new P.$4);const B=()=>{const de=le=>{switch(le.type){case 201:this.f.delete(_),G(le.data);break;case 202:{this.f.delete(_);const we=new Error(le.data.message);we.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,we.name=le.data.name,j(we);break}case 203:this.f.delete(_),j(le.data);break}};this.f.set(_,de),this.p(X)};let T=null;this.b===g.Idle?B():(T=(0,A.$Ng)(de=>this.u()),T.then(()=>{T=null,B()}));const Z=()=>{T?(T.cancel(),T=null):this.p({id:_,type:101}),j(new P.$4)},he=q.onCancellationRequested(Z);O=(0,u.$Oc)((0,u.$Pc)(Z),he),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(z,W,H){const q=this.g++,ne={id:q,type:102,channelName:z,name:W,arg:H};let X=null;const O=new d.$Rd({onWillAddFirstListener:()=>{X=(0,A.$Ng)(G=>this.u()),X.then(()=>{X=null,this.d.add(O),this.p(ne)})},onDidRemoveLastListener:()=>{X?(X.cancel(),X=null):(this.d.delete(O),this.p({id:q,type:103}))}}),N=G=>O.fire(G.data);return this.f.set(q,N),O.event}p(z){switch(z.type){case 100:case 102:{const W=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(W,z.id,0,`${v(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const W=this.q([z.type,z.id]);this.j?.logOutgoing(W,z.id,0,v(z.type));return}}}q(z,W=void 0){const H=new i;return c(H,z),c(H,W),this.r(H.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const W=new f(z),H=m(W),q=m(W),_=H[0];switch(_){case 200:return this.j?.logIncoming(z.byteLength,0,0,w(_)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(z.byteLength,H[1],0,w(_),q),this.t({type:H[0],id:H[1],data:q})}}t(z){if(z.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.$Mc)(this.d.values()),this.d.clear()}}e.$Ah=E,ve([C.$ph],E.prototype,"onDidInitializePromise",null);class R{get connections(){const z=[];return this.f.forEach(W=>z.push(W)),z}constructor(z){this.a=new Map,this.f=new Set,this.g=new d.$Rd,this.onDidAddConnection=this.g.event,this.h=new d.$Rd,this.onDidRemoveConnection=this.h.event,this.j=new u.$Qc,this.j.add(z(({protocol:W,onDidClientDisconnect:H})=>{const q=d.Event.once(W.onMessage);this.j.add(q(_=>{const ne=new f(_),X=m(ne),O=new D(W,X),N=new E(W);this.a.forEach((j,B)=>O.registerChannel(B,j));const G={channelServer:O,channelClient:N,ctx:X};this.f.add(G),this.g.fire(G),this.j.add(H(()=>{O.dispose(),N.dispose(),this.f.delete(G),this.h.fire(G)}))}))}))}getChannel(z,W){const H=this;return{call(q,_,ne){let X;if((0,p.$Qf)(W)){const N=(0,S.$3b)(H.connections.filter(W));X=N?Promise.resolve(N):d.Event.toPromise(d.Event.filter(H.onDidAddConnection,W))}else X=W.routeCall(H,q,_);const O=X.then(N=>N.channelClient.getChannel(z));return F(O).call(q,_,ne)},listen(q,_){if((0,p.$Qf)(W))return H.k(z,W,q,_);const ne=W.routeEvent(H,q,_).then(X=>X.channelClient.getChannel(z));return F(ne).listen(q,_)}}}k(z,W,H,q){const _=this;let ne;const X=new d.$Rd({onWillAddFirstListener:()=>{ne=new u.$Qc;const O=new d.$Xd,N=new Map,G=B=>{const Z=B.channelClient.getChannel(z).listen(H,q),he=O.add(Z);N.set(B,he)},j=B=>{const T=N.get(B);T&&(T.dispose(),N.delete(B))};_.connections.filter(W).forEach(G),d.Event.filter(_.onDidAddConnection,W)(G,void 0,ne),_.onDidRemoveConnection(j,void 0,ne),O.event(X.fire,X,ne),ne.add(O)},onDidRemoveLastListener:()=>{ne?.dispose(),ne=void 0}});return X.event}registerChannel(z,W){this.a.set(z,W);for(const H of this.f)H.channelServer.registerChannel(z,W)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Bh=R;class L{constructor(z,W,H=null){const q=new i;c(q,W),z.send(q.buffer),this.a=new E(z,H),this.d=new D(z,W,H)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,W){this.d.registerChannel(z,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Ch=L;function F(V){return{call(z,W,H){return V.then(q=>q.call(z,W,H))},listen(z,W){const H=new d.$1d;return V.then(q=>H.input=q.listen(z,W)),H.event}}}e.$Dh=F;function U(V){let z=!1;return{call(W,H,q){return z?V.call(W,H,q):(0,A.$1g)(0).then(()=>z=!0).then(()=>V.call(W,H,q))},listen(W,H){if(z)return V.listen(W,H);const q=new d.$1d;return(0,A.$1g)(0).then(()=>z=!0).then(()=>q.input=V.listen(W,H)),q.event}}}e.$Eh=U;class x{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const W of z.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await d.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$Fh=x;var Y;(function(V){function z(_,ne,X){const O=_,N=X&&X.disableMarshalling,G=new Map;for(const j in O)H(j)&&G.set(j,d.Event.buffer(O[j],!0,void 0,ne));return new class{listen(j,B,T){const Z=G.get(B);if(Z)return Z;if(q(B)){const he=O[B];if(typeof he=="function")return he.call(O,T)}throw new P.$ab(`Event not found: ${B}`)}call(j,B,T){const Z=O[B];if(typeof Z=="function"){if(!N&&Array.isArray(T))for(let de=0;de<T.length;de++)T[de]=(0,b.$uh)(T[de]);let he=Z.apply(O,T);return he instanceof Promise||(he=Promise.resolve(he)),he}throw new P.$ab(`Method not found: ${B}`)}}}V.fromService=z;function W(_,ne){const X=ne&&ne.disableMarshalling;return new Proxy({},{get(O,N){if(typeof N=="string")return ne?.properties?.has(N)?ne.properties.get(N):q(N)?function(G){return _.listen(N,G)}:H(N)?_.listen(N):async function(...G){let j;ne&&!(0,p.$Lf)(ne.context)?j=[ne.context,...G]:j=G;const B=await _.call(N,j);return X?B:(0,b.$uh)(B)};throw new P.$ab(`Property not found: ${String(N)}`)}})}V.toService=W;function H(_){return _[0]==="o"&&_[1]==="n"&&y.$5e(_.charCodeAt(2))}function q(_){return/^onDynamic/.test(_)&&y.$5e(_.charCodeAt(9))}})(Y||(e.ProxyChannel=Y={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function oe(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const z=V.toString();if(z!=="[object Object]")return z}return V}function ce(V){return Array.isArray(V)?V.map(oe):oe(V)}function Q(V,z,W,H,q,_,ne){ne=ce(ne);const X=ae[q],O=X[H%X.length];let N=[`%c[${V}]%c[${String(z).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(_)?(N=N.concat(ne),N.push(")")):N.push(ne),console.log.apply(console,N)}class K{constructor(z,W){this.d=z,this.f=W,this.a=0,this.b=0}logOutgoing(z,W,H,q,_){this.b+=z,Q(this.d,this.b,z,W,H,q,_)}logIncoming(z,W,H,q,_){this.a+=z,Q(this.f,this.a,z,W,H,q,_)}}e.$Gh=K}),define(se[157],re([0,1,18,3,42]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2T=e.$1T=void 0;class M{constructor(d){this.a=d,this.onMessage=A.Event.fromDOMEventEmitter(this.a,"message",u=>S.$fe.wrap(u.data)),d.start()}send(d){this.a.postMessage(d.buffer)}disconnect(){this.a.close()}}e.$1T=M;class C extends s.$Ch{constructor(d,u){const b=new M(d);super(b,u),this.b=b}dispose(){this.b.disconnect(),super.dispose()}}e.$2T=C}),define(se[109],re([0,1,18,3,2,42]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.ProtocolConstants=e.$Hh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var P;(function(t){t.enableDiagnostics=!1,t.records=[];const n=new WeakMap;let c=0;function m(I,E){if(!n.has(I)){const R=String(++c);n.set(I,R)}return n.get(I)}function D(I,E,R,L){if(!t.enableDiagnostics)return;const F=m(I,E);if(L instanceof S.$fe||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const U=S.$fe.alloc(L.byteLength);U.set(L),t.records.push({timestamp:Date.now(),id:F,label:E,type:R,buff:U})}else t.records.push({timestamp:Date.now(),id:F,label:E,type:R,data:L})}t.traceSocketEvent=D})(P||(e.SocketDiagnostics=P={}));var d;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d||(e.SocketCloseEventType=d={}));let u=null;function b(){return u||(u=S.$fe.alloc(0)),u}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,c){if(n===0)return b();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const E=this.a[0];return c&&(this.a.shift(),this.b-=n),E}if(this.a[0].byteLength>n){const E=this.a[0].slice(0,n);return c&&(this.a[0]=this.a[0].slice(n),this.b-=n),E}const m=S.$fe.alloc(n);let D=0,I=0;for(;n>0;){const E=this.a[I];if(E.byteLength>n){const R=E.slice(0,n);m.set(R,D),D+=n,c&&(this.a[I]=E.slice(n),this.b-=n),n-=n}else m.set(E,D),D+=E.byteLength,c?(this.a.shift(),this.b-=E.byteLength):I++,n-=E.byteLength}return m}}e.$Hh=y;var p;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(p||(p={}));function l(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class ${constructor(n,c,m,D){this.type=n,this.id=c,this.ack=m,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends s.$Rc{constructor(n){super(),this.f=this.B(new A.$Rd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new y,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:l(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const m=this.g.messageType,D=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new $(m,D,I,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=S.$fe.alloc(13);c.writeUInt8(n.type,0),c.writeUInt32BE(n.id,1),c.writeUInt32BE(n.ack,5),c.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:l(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(c,n.data)}g(n,c){const m=this.f===0;return this.d.push(n,c),this.f+=n.byteLength+c.byteLength,m}h(){const n=S.$fe.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,c){this.g(n,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class h extends s.$Rc{constructor(n){super(),this.f=new A.$Rd,this.onMessage=this.f.event,this.g=new A.$Rd,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new g(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new $(1,0,0,n))}}e.$Ih=h;class a extends M.$Ch{static fromSocket(n,c){return new a(new h(n),c)}get onDidDispose(){return this.b.onDidDispose}constructor(n,c,m=null){super(n,c,m),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$Jh=a;class k{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$Rd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Kh=k;class f{constructor(n){this.data=n,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let n=0,c=this.a;for(;c;)c=c.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let c=0,m=this.a;for(;m;)n[c++]=m.data,m=m.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const c=new f(n);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const n=Date.now();for(let c=0;c<o.a;c++)this.c[c]=n-1e3*c;setInterval(()=>{for(let c=o.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),c=(1+o.a)*1e3;let m=0;for(let D=0;D<o.a;D++)n-this.c[D]<=c&&m++;return 1-m/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new k,this.onControlMessage=this.u.event,this.v=new k,this.onMessage=this.v.event,this.w=new k,this.onDidDispose=this.w.event,this.x=new k,this.onSocketClose=this.x.event,this.y=new k,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??o.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Qc,this.o=n.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(c=>this.z(c))),this.r.add(this.o.onClose(c=>this.x.fire(c))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new $(5,0,0,b());this.p.write(n),this.p.flush()}sendPause(){const n=new $(7,0,0,b());this.p.write(n)}sendResume(){const n=new $(8,0,0,b());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,c){this.a=!0,this.r.dispose(),this.r=new s.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(m=>this.z(m))),this.r.add(this.o.onClose(m=>this.x.fire(m))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new $(3,0,this.h,b());this.p.write(n);const c=this.b.toArray();for(let m=0,D=c.length;m<D;m++)this.p.write(c[m]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const c=this.b.peek();if(c&&c.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new $(6,0,0,b())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const c=this.b.toArray();for(let m=0,D=c.length;m<D;m++)this.p.write(c[m]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const c=++this.c;this.h=this.g;const m=new $(1,c,this.h,n);this.b.push(m),this.a||(this.p.write(m),this.B())}sendControl(n){const c=new $(2,0,0,n);this.p.write(c)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),c=Date.now()-n.writtenTime,m=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(c>=2e4&&m>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:m});return}const I=Math.max(2e4-c,2e4-m,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new $(3,0,this.h,b());this.p.write(n)}D(){this.h=this.g;const n=new $(9,0,this.h,b());this.p.write(n)}}e.$Lh=r}),define(se[36],re([0,1,15,14,13]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XT=void 0;class M{constructor(){this.a=new WeakMap}on(P,d){const u=(b,...y)=>{this.b(P,b)&&d(b,...y)};return this.a.set(d,u),S.ipcMain.on(P,u),this}once(P,d){return S.ipcMain.once(P,(u,...b)=>{this.b(P,u)&&d(u,...b)}),this}handle(P,d){return S.ipcMain.handle(P,(u,...b)=>this.b(P,u)?d(u,...b):Promise.reject(`Invalid channel '${P}' or sender for ipcMain.handle() usage.`)),this}removeHandler(P){return S.ipcMain.removeHandler(P),this}removeListener(P,d){const u=this.a.get(d);return u&&(S.ipcMain.removeListener(P,u),this.a.delete(d)),this}b(P,d){if(!P||!P.startsWith("vscode:"))return(0,A.$Z)(`Refused to handle ipcMain event for channel '${P}' because the channel is unknown.`),!1;const u=d.senderFrame,b=u.url;if(!b||b==="about:blank")return!0;let y="unknown";try{y=new URL(b).host}catch{return(0,A.$Z)(`Refused to handle ipcMain event for channel '${P}' because of a malformed URL '${b}'.`),!1}return y!==s.$hg?((0,A.$Z)(`Refused to handle ipcMain event for channel '${P}' because of a bad origin of '${y}'.`),!1):u.parent!==null?((0,A.$Z)(`Refused to handle ipcMain event for channel '${P}' because sender of origin '${y}' is not a main frame.`),!1):!0}}e.$XT=new M}),define(se[158],re([0,1,15,36,146]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YT=void 0;function M(){A.$XT.on(s.$VT,(P,d,u,b,y)=>{const p=C(P,b,u);p.popup({x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{p&&P.sender.send(s.$WT,d)}})})}e.$YT=M;function C(P,d,u){const b=new S.Menu;return u.forEach(y=>{let p;y.type==="separator"?p=new S.MenuItem({type:y.type}):Array.isArray(y.submenu)?p=new S.MenuItem({submenu:C(P,d,y.submenu),label:y.label}):p=new S.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(l,v,$)=>P.sender.send(d,y.id,$)}),b.append(p)}),b}}),define(se[159],re([0,1,36,18,3,2,42,147]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5T=void 0;function d(b,y){const p=s.Event.fromNodeEventEmitter(S.$XT,y,(v,$)=>({event:v,message:$})),l=s.Event.filter(p,({event:v})=>v.sender.id===b);return s.Event.map(l,({message:v})=>v&&A.$fe.wrap(v))}class u extends C.$Bh{static{this.b=new Map}static d(){const y=s.Event.fromNodeEventEmitter(S.$XT,"vscode:hello",({sender:p})=>p);return s.Event.map(y,p=>{const l=p.id;u.b.get(l)?.dispose();const $=new s.$Rd;u.b.set(l,(0,M.$Pc)(()=>$.fire()));const w=d(l,"vscode:message"),g=s.Event.any(s.Event.signal(d(l,"vscode:disconnect")),$.event);return{protocol:new P.$4T(p,w),onDidClientDisconnect:g}})}constructor(){super(u.d())}}e.$5T=u}),define(se[110],re([0,1,36,3,32,157]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7T=e.$6T=void 0;class C extends M.$2T{constructor(u,b){super({addEventListener:(y,p)=>u.addListener(y,p),removeEventListener:(y,p)=>u.removeListener(y,p),postMessage:y=>u.postMessage(y),start:()=>u.start(),close:()=>u.close()},b)}}e.$6T=C;async function P(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const u=(0,s.$kg)();d.webContents.send("vscode:createMessageChannel",u);const b=A.Event.fromNodeEventEmitter(S.$XT,"vscode:createMessageChannelResult",(p,l)=>({nonce:l,port:p.ports[0]})),{port:y}=await A.Event.toPromise(A.Event.once(A.Event.filter(b,p=>p.nonce===u)));return y}e.$7T=P}),define(se[160],re([0,1,48,8,18,22,154,14,3,2,38,89,76,42]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=void 0;class v extends l.$zh{constructor(g){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",h=>s.$fe.wrap(Buffer.from(h,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$0p=v;class ${constructor(g,h){this.i=g,this.j=h,this.c=new Set,this.g=new Map,this.h=new d.$Rd,this.onDidProcessExit=this.h.event;const a=h&&h.timeout?h.timeout:6e4;this.b=new A.$Wg(a),this.d=null,this.f=null}getChannel(g){const h=this;return{call(a,k,f){return h.k(g,a,k,f)},listen(a,k){return h.l(g,a,k)}}}k(g,h,a,k=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(k.isCancellationRequested)return Promise.reject(P.$5());this.b.cancel();const f=this.n(g),i=(0,A.$Ng)(t=>f.call(h,a,t)),o=k.onCancellationRequested(()=>i.cancel()),r=(0,u.$Pc)(()=>i.cancel());return this.c.add(r),i.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(g,h,a){if(!this.b)return d.Event.None;this.b.cancel();let k;const f=new d.$Rd({onWillAddFirstListener:()=>{k=this.n(g).listen(h,a)(f.fire,f),this.c.add(k)},onDidRemoveLastListener:()=>{this.c.delete(k),k.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return f.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,b.$cn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,p.$Il)(h.env),this.d=(0,S.fork)(this.i,g,h);const a=new d.$Rd;d.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,C.$6p)(n)){(0,C.log)(n,`IPC Library: ${this.j.serverName}`);return}a.fire(s.$fe.wrap(Buffer.from(n,"base64")))});const f=this.j.useQueue?(0,y.$Kl)(this.d):this.d,i=n=>this.d&&this.d.connected&&f.send(n.buffer.toString("base64")),o=a.event,r={send:i,onMessage:o};this.f=new l.$Ah(r);const t=()=>this.o();process.once("exit",t),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,c)=>{process.removeListener("exit",t),this.c.forEach(m=>(0,u.$Mc)(m)),this.c.clear(),n!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:c})})}return this.f}n(g){let h=this.g.get(g);return h||(h=this.m.getChannel(g),this.g.set(g,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$$p=$}),define(se[111],re([0,1,8,3,2,77,12]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.StorageState=e.$9o=e.StorageHint=void 0;var P;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function d(p){const l=p;return l?.changed instanceof Map||l?.deleted instanceof Set}e.$9o=d;var u;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(u||(e.StorageState=u={}));class b extends s.$Rc{static{this.a=100}constructor(l,v=Object.create(null)){super(),this.r=l,this.s=v,this.b=this.B(new A.$Ud),this.onDidChangeStorage=this.b.event,this.c=u.None,this.f=new Map,this.g=this.B(new S.$Xg(b.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(l=>this.u(l)))}u(l){this.b.pause();try{l.changed?.forEach((v,$)=>this.w($,v)),l.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(l,v){if(this.c===u.Closed)return;let $=!1;(0,C.$Lf)(v)?$=this.f.delete(l):this.f.get(l)!==v&&(this.f.set(l,v),$=!0),$&&this.b.fire({key:l,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===u.None&&(this.c=u.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(l,v){const $=this.f.get(l);return(0,C.$Lf)($)?v:$}getBoolean(l,v){const $=this.get(l);return(0,C.$Lf)($)?v:$==="true"}getNumber(l,v){const $=this.get(l);return(0,C.$Lf)($)?v:parseInt($,10)}getObject(l,v){const $=this.get(l);return(0,C.$Lf)($)?v:(0,M.$th)($)}async set(l,v,$=!1){if(this.c===u.Closed)return;if((0,C.$Lf)(v))return this.delete(l,$);const w=(0,C.$Ef)(v)||Array.isArray(v)?(0,M.$sh)(v):String(v);if(this.f.get(l)!==w)return this.f.set(l,w),this.j.set(l,w),this.h.delete(l),this.b.fire({key:l,external:$}),this.D()}async delete(l,v=!1){if(!(this.c===u.Closed||!this.f.delete(l)))return this.h.has(l)||this.h.add(l),this.j.delete(l),this.b.fire({key:l,external:v}),this.D()}async optimize(){if(this.c!==u.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=u.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const l={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(l).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(l){if(this.z)return this.D(l)}async D(l){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),l)}async whenFlushed(){if(this.z)return new Promise(l=>this.n.push(l))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$0o=b;class y{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(l){l.insert?.forEach((v,$)=>this.a.set($,v)),l.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$$o=y}),define(se[161],re([0,1,8,3,31,9,21]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qU=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return A.Event.None}static{this.a=2e3}static{this.b=256}constructor(b,y=Object.create(null)){this.g=b,this.h=y,this.c=(0,M.$mc)(this.g),this.d=new d(this.h.logging),this.f=this.n(this.g)}async getItems(){const b=await this.f,y=new Map;return(await this.s(b,"SELECT * FROM ItemTable")).forEach(l=>y.set(l.key,l.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${y.size} rows`),y}async updateItems(b){const y=await this.f;return this.j(y,b)}j(b,y){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${y.insert?(0,s.$xc)(y.insert):"0"}), delete(${y.delete?(0,s.$yc)(y.delete):"0"})`),this.t(b,()=>{const p=y.insert,l=y.delete;if(p&&p.size>0){const v=[];v.push([]);let $=0;p.forEach((w,g)=>{let h=v[$];h.length>P.b&&($++,h=[],v.push(h)),h.push(g,w)}),v.forEach(w=>{this.u(b,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,g=>g.run(w),()=>{const g=[];let h=0;return p.forEach((a,k)=>{g.push(k),h+=a.length}),`Keys: ${g.join(", ")} Length: ${h}`})})}if(l&&l.size){const v=[];v.push([]);let $=0;l.forEach(w=>{let g=v[$];g.length>P.b&&($++,g=[],v.push(g)),g.push(w)}),v.forEach(w=>{this.u(b,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,g=>g.run(w),()=>{const g=[];return l.forEach(h=>{g.push(h)}),`Keys: ${g.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const b=await this.f;return this.q(b,"VACUUM")}async close(b){this.d.trace(`[storage ${this.c}] close()`);const y=await this.f;return this.k(y,b)}k(b,y){return new Promise((p,l)=>{b.db.close(v=>(v&&this.o(b,`[storage ${this.c}] close(): ${v}`),this.g===P.IN_MEMORY_PATH?p():!b.isErroneous&&!b.isInMemory?this.l().then(p,$=>(this.d.error(`[storage ${this.c}] backup(): ${$}`),p())):typeof y=="function"?C.Promises.unlink(this.g).then(()=>this.p(this.g).then($=>{const w=()=>this.k($,void 0);return this.j($,{insert:y()}).then(()=>w(),g=>(w(),Promise.reject(g)))})).then(p,l):l(v||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const b=this.m(this.g);return C.Promises.copy(this.g,b,{preserveSymlinks:!1})}m(b){return`${b}.backup`}async checkIntegrity(b){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${b})`);const y=await this.f,p=await this.r(y,b?"PRAGMA integrity_check":"PRAGMA quick_check"),l=b?p.integrity_check:p.quick_check;return y.isErroneous?`${l} (last error: ${y.lastError})`:y.isInMemory?`${l} (in-memory!)`:l}async n(b,y=!0){this.d.trace(`[storage ${this.c}] open(${b}, retryOnBusy: ${y})`);try{return await this.p(b)}catch(p){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&y)return await(0,S.$1g)(P.a),this.n(b,!1);try{await C.Promises.unlink(b);try{await C.Promises.rename(this.m(b),b,!1)}catch{}return await this.p(b)}catch(l){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${l}`),this.p(P.IN_MEMORY_PATH)}}}o(b,y){b.isErroneous=!0,b.lastError=y,this.d.error(y)}p(b){return new Promise((y,p)=>{new Promise((l,v)=>{J(["@vscode/sqlite3"],l,v)}).then(l=>{const v={db:new(this.d.isTracing?l.verbose().Database:l.Database)(b,$=>$?v.db&&$.code!=="SQLITE_CANTOPEN"?v.db.close(()=>p($)):p($):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>y(v),w=>v.db.close(()=>p(w)))),isInMemory:b===P.IN_MEMORY_PATH};v.db.on("error",$=>this.o(v,`[storage ${this.c}] Error (event): ${$}`)),this.d.isTracing&&v.db.on("trace",$=>this.d.trace(`[storage ${this.c}] Trace (event): ${$}`))},p)})}q(b,y){return new Promise((p,l)=>{b.db.exec(y,v=>v?(this.o(b,`[storage ${this.c}] exec(): ${v}`),l(v)):p())})}r(b,y){return new Promise((p,l)=>{b.db.get(y,(v,$)=>v?(this.o(b,`[storage ${this.c}] get(): ${v}`),l(v)):p($))})}s(b,y){return new Promise((p,l)=>{b.db.all(y,(v,$)=>v?(this.o(b,`[storage ${this.c}] all(): ${v}`),l(v)):p($))})}t(b,y){return new Promise((p,l)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),y(),b.db.run("END TRANSACTION",v=>v?(this.o(b,`[storage ${this.c}] transaction(): ${v}`),l(v)):p())})})}u(b,y,p,l){const v=b.db.prepare(y),$=w=>{this.o(b,`[storage ${this.c}] prepare(): ${w} (${y}). Details: ${l()}`)};v.on("error",$),p(v),v.finalize(w=>{w&&$(w),v.removeListener("error",$)})}}e.$qU=P;class d{static{this.a="VSCODE_TRACE_STORAGE"}constructor(b){b&&typeof b.logTrace=="function"&&process.env[d.a]&&(this.b=b.logTrace),b&&typeof b.logError=="function"&&(this.c=b.logError)}get isTracing(){return!!this.b}trace(b){this.b?.(b)}error(b){this.c?.(b)}}}),define(se[162],re([11,10]),function(J,e){return J.create("vs/code/electron-main/app",e)}),define(se[163],re([11,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(se[164],re([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(se[165],re([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(se[166],re([11,10]),function(J,e){return J.create("vs/platform/dialogs/common/dialogs",e)}),define(se[167],re([11,10]),function(J,e){return J.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(se[168],re([11,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(se[169],re([11,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(se[170],re([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(se[171],re([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(se[172],re([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(se[173],re([11,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(se[174],re([11,10]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(se[175],re([11,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(se[176],re([11,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(se[177],re([11,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(se[178],re([11,10]),function(J,e){return J.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(se[179],re([11,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(se[180],re([11,10]),function(J,e){return J.create("vs/platform/issue/electron-main/issueMainService",e)}),define(se[181],re([11,10]),function(J,e){return J.create("vs/platform/menubar/electron-main/menubar",e)}),define(se[182],re([11,10]),function(J,e){return J.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(se[183],re([11,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(se[184],re([11,10]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(se[185],re([11,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(se[186],re([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(se[187],re([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalProfiles",e)}),define(se[188],re([11,10]),function(J,e){return J.create("vs/platform/update/common/update.config.contribution",e)}),define(se[189],re([11,10]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(se[190],re([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowImpl",e)}),define(se[191],re([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(se[192],re([11,10]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(se[193],re([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(se[194],re([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(se[195],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_eb=e.$$eb=void 0;function S(s){return s&&s.hasOwnProperty("folderUri")}e.$$eb=S;function A(s){return s&&s.hasOwnProperty("workspace")}e.$_eb=A}),define(se[196],re([0,1,7]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p8b=e.$o8b=e.$n8b=void 0;function A(C){return typeof C?.backupFolder=="string"}e.$n8b=A;function s(C){let P=[];try{Array.isArray(C.workspaces)&&(P=C.workspaces.map(d=>({workspace:{id:d.id,configPath:S.URI.parse(d.configURIPath)},remoteAuthority:d.remoteAuthority})))}catch{}return P}e.$o8b=s;function M(C){let P=[];try{Array.isArray(C.folders)&&(P=C.folders.map(d=>({folderUri:S.URI.parse(d.folderUri),remoteAuthority:d.remoteAuthority})))}catch{}return P}e.$p8b=M}),define(se[197],re([0,1,14,165]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.TokenType=void 0;var s;(function(u){u[u.LParen=0]="LParen",u[u.RParen=1]="RParen",u[u.Neg=2]="Neg",u[u.Eq=3]="Eq",u[u.NotEq=4]="NotEq",u[u.Lt=5]="Lt",u[u.LtEq=6]="LtEq",u[u.Gt=7]="Gt",u[u.GtEq=8]="GtEq",u[u.RegexOp=9]="RegexOp",u[u.RegexStr=10]="RegexStr",u[u.True=11]="True",u[u.False=12]="False",u[u.In=13]="In",u[u.Not=14]="Not",u[u.And=15]="And",u[u.Or=16]="Or",u[u.Str=17]="Str",u[u.QuotedStr=18]="QuotedStr",u[u.Error=19]="Error",u[u.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...u){switch(u.length){case 1:return(0,A.localize)(0,null,u[0]);case 2:return(0,A.localize)(1,null,u[0],u[1]);case 3:return(0,A.localize)(2,null,u[0],u[1],u[2]);default:return}}const C=(0,A.localize)(3,null),P=(0,A.localize)(4,null);class d{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return b.isTripleEq?"===":"==";case 4:return b.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return b.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return b.lexeme;case 18:return b.lexeme;case 19:return b.lexeme;case 20:return"EOF";default:throw(0,S.$7)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const y=this.d,p=this.c.substring(this.d,this.e),l={type:19,offset:this.d,lexeme:p};this.g.push({offset:y,lexeme:p,additionalInfo:b}),this.f.push(l)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const y=this.c.substring(this.d,this.e),p=d.b.get(y);p?this.k(p):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,y=!1,p=!1;for(;;){if(b>=this.c.length){this.e=b,this.l(P);return}const v=this.c.charCodeAt(b);if(y)y=!1;else if(v===47&&!p){b++;break}else v===91?p=!0:v===92?y=!0:v===93&&(p=!1);b++}for(;b<this.c.length&&d.a.has(this.c.charCodeAt(b));)b++;this.e=b;const l=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Si=d}),define(se[198],re([0,1,3,2]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=e.$Un=void 0;class s{constructor(){this.a=new S.$Rd,this.b=new S.$Rd,this.c=new S.$Rd,this.d=new S.$Rd}static{this.ChannelName="extensionhostdebugservice"}call(P,d,u){switch(d){case"close":return Promise.resolve(this.a.fire({sessionId:u[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:u[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:u[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:u[0],port:u[1],subId:u[2]}))}throw new Error("Method not implemented.")}listen(P,d,u){switch(d){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Un=s;class M extends A.$Rc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,d,u){this.b.call("attach",[P,d,u])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,d){this.b.call("terminate",[P,d])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,d){return this.b.call("openExtensionDevelopmentHostWindow",[P,d])}}e.$Vn=M}),define(se[199],re([0,1,149,56,13,9,35,19,7]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=e.$om=e.$nm=void 0,e.$nm=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,M.$lc)(s.$ig.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return d.URI.file((0,M.$ic)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.b.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,P.$Bg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$Bg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,S.$mm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$ic)(this.userDataPath,"logs",l)}return d.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$Bg)(d.URI.file((0,M.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$Bg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$Bg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$Bg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=C.env.VSCODE_PORTABLE;return l?d.URI.file((0,M.$ic)(l,"argv.json")):(0,P.$Bg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,M.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,M.$jc)(l):(0,M.$gc)((0,M.$ic)(s.$ig.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?d.URI.file((0,M.$jc)(l)):d.URI.file((0,M.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,M.$jc)(l);const v=C.env.VSCODE_EXTENSIONS;if(v)return v;const $=C.env.VSCODE_PORTABLE;return $?(0,M.$ic)($,"extensions"):(0,P.$Bg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(v=>/^[^:/?#]+?:\/\//.test(v)?d.URI.parse(v):d.URI.file((0,M.$gc)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?d.URI.parse(l):d.URI.file((0,M.$gc)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$nm.test(l))}get extensionLogLevel(){const l=[];for(const v of this.args.log||[]){const $=e.$nm.exec(v);$&&$[1]&&$[2]&&l.push([$[1],$[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,P.$Bg)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=C.env.VSCODE_PORTABLE;return l?d.URI.file((0,M.$ic)(l,"policy.json")):(0,P.$Bg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,v,$){this.a=l,this.b=v,this.c=$,this.editSessionId=this.args.editSessionId}}e.$om=u,ve([A.$ph],u.prototype,"appRoot",null),ve([A.$ph],u.prototype,"userHome",null),ve([A.$ph],u.prototype,"userDataPath",null),ve([A.$ph],u.prototype,"appSettingsHome",null),ve([A.$ph],u.prototype,"tmpDir",null),ve([A.$ph],u.prototype,"cacheHome",null),ve([A.$ph],u.prototype,"stateResource",null),ve([A.$ph],u.prototype,"userRoamingDataHome",null),ve([A.$ph],u.prototype,"userDataSyncHome",null),ve([A.$ph],u.prototype,"sync",null),ve([A.$ph],u.prototype,"machineSettingsResource",null),ve([A.$ph],u.prototype,"workspaceStorageHome",null),ve([A.$ph],u.prototype,"localHistoryHome",null),ve([A.$ph],u.prototype,"keyboardLayoutResource",null),ve([A.$ph],u.prototype,"argvResource",null),ve([A.$ph],u.prototype,"isExtensionDevelopment",null),ve([A.$ph],u.prototype,"untitledWorkspacesHome",null),ve([A.$ph],u.prototype,"builtinExtensionsPath",null),ve([A.$ph],u.prototype,"extensionsPath",null),ve([A.$ph],u.prototype,"extensionDevelopmentLocationURI",null),ve([A.$ph],u.prototype,"extensionDevelopmentKind",null),ve([A.$ph],u.prototype,"extensionTestsLocationURI",null),ve([A.$ph],u.prototype,"debugExtensionHost",null),ve([A.$ph],u.prototype,"logLevel",null),ve([A.$ph],u.prototype,"extensionLogLevel",null),ve([A.$ph],u.prototype,"serviceMachineIdResource",null),ve([A.$ph],u.prototype,"disableTelemetry",null),ve([A.$ph],u.prototype,"disableWorkspaceTrust",null),ve([A.$ph],u.prototype,"useInMemorySecretStorage",null),ve([A.$ph],u.prototype,"policyFile",null);function b(p,l){return y(p["inspect-extensions"],p["inspect-brk-extensions"],5870,l,p.debugId,p.extensionEnvironment)}e.$pm=b;function y(p,l,v,$,w,g){const a=Number(l||p)||($?null:v),k=a?!!l:!1;let f;if(g)try{f=JSON.parse(g)}catch{}return{port:a,break:k,debugId:w,env:f}}e.$qm=y}),define(se[112],re([0,1,309,4,168]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$Ml=["tunnel","serve-web"],e.$Nl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P($,w,g=C){const h=$.find(c=>c.length>0&&c[0]!=="-"),a={},k=["_"],f=[],i={};let o;for(const c in w){const m=w[c];m.type==="subcommand"?c===h&&(o=m):(m.alias&&(a[c]=m.alias),m.type==="string"||m.type==="string[]"?(k.push(c),m.deprecates&&k.push(...m.deprecates)):m.type==="boolean"&&(f.push(c),m.deprecates&&f.push(...m.deprecates)),m.global&&(i[c]=m))}if(o&&h){const c=i;for(const E in o.options)c[E]=o.options[E];const m=$.filter(E=>E!==h),D=g.getSubcommandReporter?g.getSubcommandReporter(h):void 0,I=P(m,c,D);return{[h]:I,_:[]}}const r=S($,{string:k,boolean:f,alias:a}),t={},n=r;t._=r._.map(c=>String(c)).filter(c=>c.length>0),delete n._;for(const c in w){const m=w[c];if(m.type==="subcommand")continue;m.alias&&delete n[m.alias];let D=n[c];if(m.deprecates)for(const I of m.deprecates)n.hasOwnProperty(I)&&(D||(D=n[I],D&&g.onDeprecatedOption(I,m.deprecationMessage||(0,s.localize)(37,null,c))),delete n[I]);if(typeof D<"u"){if(m.type==="string[]"){if(Array.isArray(D)||(D=[D]),!m.allowEmptyValue){const I=D.filter(E=>E.length>0);I.length!==D.length&&(g.onEmptyValue(c),D=I.length>0?I:void 0)}}else m.type==="string"&&(Array.isArray(D)?(D=D.pop(),g.onMultipleValues(c,D)):!D&&!m.allowEmptyValue&&(g.onEmptyValue(c),D=void 0));t[c]=D,m.deprecationMessage&&g.onDeprecatedOption(c,m.deprecationMessage)}delete n[c]}for(const c in n)g.onUnknownOption(c);return t}e.$Ol=P;function d($,w){let g="";return w.args&&(Array.isArray(w.args)?g=` <${w.args.join("> <")}>`:g=` <${w.args}>`),w.alias?`-${w.alias} --${$}${g}`:`--${$}${g}`}function u($,w){const g=[];for(const h in $){const a=$[h],k=d(h,a);g.push([k,a.description])}return b(g,w)}e.$Pl=u;function b($,w){const h=$.reduce((f,i)=>Math.max(f,i[0].length),12)+2+1;if(w-h<25)return $.reduce((f,i)=>f.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const a=w-h-1,k=[];for(const f of $){const i=f[0],o=p(f[1],a),r=y(h-i.length-2);k.push("  "+i+r+o[0]);for(let t=1;t<o.length;t++)k.push(y(h)+o[t])}return k}function y($){return" ".repeat($)}function p($,w){const g=[];for(;$.length;){const h=$.length<w?$.length:$.lastIndexOf(" ",w),a=$.slice(0,h).trim();$=$.slice(h),g.push(a)}return g}function l($,w,g,h,a){const k=process.stdout.isTTY&&process.stdout.columns||80,f=a?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",i=[`${$} ${g}`];i.push(""),i.push(`${(0,s.localize)(39,null)}: ${w} [${(0,s.localize)(40,null)}]${f}`),i.push(""),a?.noPipe!==!0&&(A.$i?i.push((0,s.localize)(41,null,w)):i.push((0,s.localize)(42,null,w)),i.push(""));const o={},r=[];for(const t in h){const n=h[t];if(n.type==="subcommand")n.description&&r.push({command:t,description:n.description});else if(n.description&&n.cat){let c=o[n.cat];c||(o[n.cat]=c={}),c[t]=n}}for(const t in o){const n=t,c=o[n];c&&(i.push(M[n]),i.push(...u(c,k)),i.push(""))}return r.length&&(i.push((0,s.localize)(43,null)),i.push(...b(r.map(t=>[t.command,t.description]),k)),i.push("")),i.join(`
`)}e.$Ql=l;function v($,w){return`${$||(0,s.localize)(44,null)}
${w||(0,s.localize)(45,null)}
${process.arch}`}e.$Rl=v}),define(se[200],re([0,1,87,198,112]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q8b=void 0;class M extends A.$Un{constructor(P){super(),this.f=P}call(P,d,u){return d==="openExtensionDevelopmentHostWindow"?this.g(u[0],u[1]):super.call(P,d,u)}async g(P,d){const u=(0,s.$Ol)(P,s.$Nl);u.debugRenderer=d;const b=u.extensionDevelopmentPath;if(!b)return{success:!1};const[y]=await this.f.openExtensionDevelopmentHostWindow(b,{context:5,cli:u,forceProfile:u.profile,forceTempProfile:u["profile-temp"]});if(!d)return{success:!0};const p=y.win;if(!p)return{success:!0};const l=p.webContents.debugger;let v=l.isAttached()?1/0:0;const $=(0,S.createServer)(w=>{v++===0&&l.attach();let g=!1;const h=f=>{g||w.write(JSON.stringify(f)+"\0")},a=(f,i,o,r)=>h({method:i,params:o,sessionId:r});p.on("close",()=>{l.removeListener("message",a),w.end(),g=!0}),l.addListener("message",a);let k=Buffer.alloc(0);w.on("data",f=>{k=Buffer.concat([k,f]);for(let i=k.indexOf(0);i!==-1;i=k.indexOf(0)){let o;try{const r=k.slice(0,i).toString("utf8");k=k.slice(i+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}l.sendCommand(o.method,o.params,o.sessionId).then(r=>h({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>h({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),w.on("error",f=>{console.error("error on cdp pipe:",f)}),w.on("close",()=>{g=!0,--v===0&&l.detach()})});return await new Promise(w=>$.listen(0,w)),p.on("close",()=>$.close()),{rendererDebugPort:$.address().port,success:!0}}}e.$Q8b=M}),define(se[63],re([0,1,310,169,112]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Tl=e.$Sl=void 0;function M(y,p){const l=(a,k)=>{console.warn((0,A.localize)(0,null,a,k))},v=a=>{console.warn((0,A.localize)(1,null,a))},$=(a,k)=>{console.warn((0,A.localize)(2,null,a,k))},w=a=>({onUnknownOption:k=>{s.$Ml.includes(a)||console.warn((0,A.localize)(3,null,k,a))},onMultipleValues:l,onEmptyValue:v,onDeprecatedOption:$,getSubcommandReporter:s.$Ml.includes(a)?w:void 0}),g={onUnknownOption:a=>{console.warn((0,A.localize)(4,null,a))},onMultipleValues:l,onEmptyValue:v,onDeprecatedOption:$,getSubcommandReporter:w},h=(0,s.$Ol)(y,s.$Nl,p?g:void 0);return h.goto&&h._.forEach(a=>S(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(a),(0,A.localize)(5,null))),h}function C(y){const p=y.findIndex(l=>!/^-/.test(l));if(p>-1)return[...y.slice(0,p),...y.slice(p+1)]}function P(y){let[,...p]=y;process.env.VSCODE_DEV&&(p=C(p)||[]);const l=!b(process.env);return M(p,l)}e.$Sl=P;function d(y){let[,,...p]=y;return process.env.VSCODE_DEV&&(p=C(p)||[]),M(p,!0)}e.$Tl=d;function u(y,...p){const l=y.indexOf("--");return l===-1?y.push(...p):y.splice(l,0,...p),y}e.$Ul=u;function b(y){return y.VSCODE_CLI==="1"}e.$Vl=b}),function(){"use strict";function J(e,S,A){function s(C,P){const d=M(C,P),u=[d];return e.isAbsolute(d)||u.unshift(A),e.resolve(...u)}function M(C,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,P);const b=C["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(y,"AppData","Roaming")}break;case"darwin":u=e.join(S.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,P)}return{getUserDataPath:s}}if(typeof define=="function")define(se[201],re([113,28,35]),function(e,S,A){return J(e,S,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=J(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[90],re([0,1,28,199,201]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=void 0;class M extends A.$om{constructor(u,b){super(u,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,s.getUserDataPath)(u,b.nameShort)},b)}}e.$rm=M;function C(d,u){return(0,A.$qm)(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,u,d.extensionEnvironment)}e.$sm=C;function P(d,u){return(0,A.$qm)(d["inspect-sharedprocess"],d["inspect-brk-sharedprocess"],5879,u,d.extensionEnvironment)}e.$tm=P}),define(se[202],re([0,1,46,28,33]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$99b=void 0;function M(C){const P=(0,s.$0f)((0,A.tmpdir)());try{return(0,S.writeFileSync)(P,""),C&&console.log(`Marker file for --wait created: ${P}`),P}catch(d){C&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.$99b=M}),define(se[203],re([0,1,12,171]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=void 0;function s(C,P,d,u){try{M(C,P,d,u)}catch(b){C.error(b?.message??b)}return P}e.$Fp=s;function M(C,P,d,u){const b=(y,p,l)=>{const v=y[p];if((0,S.$Cf)(v)){const $=v,w=$.length;if(w>1&&$[0]==="%"&&$[w-1]==="%"){const g=$.substr(1,w-2);let h=d[g];h===void 0&&u&&(h=u[g]);const a=typeof h=="string"?h:h?.message,k=u?.[g],f=typeof k=="string"?k:k?.message;if(!a){f||C.warn(`[${P.name}]: ${(0,A.localize)(0,null,g)}`);return}if(l&&(p==="title"||p==="category")&&f&&f!==a){const i={value:a,original:f};y[p]=i}else y[p]=a}}else if((0,S.$Ef)(v))for(const $ in v)v.hasOwnProperty($)&&($==="commands"?b(v,$,!0):b(v,$,l));else if(Array.isArray(v))for(let $=0;$<v.length;$++)b(v,$,l)};for(const y in P)P.hasOwnProperty(y)&&b(P,y)}}),define(se[204],re([0,1,19,74,173,205]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function d(g){return g=g.trim(),g==="*"||C.test(g)}e.$To=d;function u(g){if(!d(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=g.match(C);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.$Uo=u;function b(g){if(!g)return null;const h=g.majorBase,a=g.majorMustEqual,k=g.minorBase;let f=g.minorMustEqual;const i=g.patchBase;let o=g.patchMustEqual;g.hasCaret&&(h===0||(f=!1),o=!1);let r=0;if(g.preRelease){const t=P.exec(g.preRelease);if(t){const[,n,c,m]=t;r=Date.UTC(Number(n),Number(c)-1,Number(m))}}return{majorBase:h,majorMustEqual:a,minorBase:k,minorMustEqual:f,patchBase:i,patchMustEqual:o,isMinimum:g.hasGreaterEquals,notBefore:r}}e.$Vo=b;function y(g,h,a){let k;typeof g=="string"?k=b(u(g)):k=g;let f;h instanceof Date?f=h.getTime():typeof h=="string"&&(f=new Date(h).getTime());let i;if(typeof a=="string"?i=b(u(a)):i=a,!k||!i)return!1;const o=k.majorBase,r=k.minorBase,t=k.patchBase;let n=i.majorBase,c=i.minorBase,m=i.patchBase;const D=i.notBefore;let I=i.majorMustEqual,E=i.minorMustEqual,R=i.patchMustEqual;return i.isMinimum?o>n?!0:o<n?!1:r>c?!0:r<c||f&&f<D?!1:t>=m:(o===1&&n===0&&(!I||!E||!R)&&(n=1,c=0,m=0,I=!0,E=!1,R=!1),o<n?!1:o>n?!I:r<c?!1:r>c?!E:t<m?!1:t>m?!R:!(f&&f<D))}e.$Wo=y;function p(g,h,a,k,f){const i=[];if(typeof k.publisher<"u"&&typeof k.publisher!="string")return i.push([A.default.Error,s.localize(0,null)]),i;if(typeof k.name!="string")return i.push([A.default.Error,s.localize(1,null,"name")]),i;if(typeof k.version!="string")return i.push([A.default.Error,s.localize(2,null,"version")]),i;if(!k.engines)return i.push([A.default.Error,s.localize(3,null,"engines")]),i;if(typeof k.engines.vscode!="string")return i.push([A.default.Error,s.localize(4,null,"engines.vscode")]),i;if(typeof k.extensionDependencies<"u"&&!w(k.extensionDependencies))return i.push([A.default.Error,s.localize(5,null,"extensionDependencies")]),i;if(typeof k.activationEvents<"u"){if(!w(k.activationEvents))return i.push([A.default.Error,s.localize(6,null,"activationEvents")]),i;if(typeof k.main>"u"&&typeof k.browser>"u")return i.push([A.default.Error,s.localize(7,null,"activationEvents","main","browser")]),i}if(typeof k.extensionKind<"u"&&typeof k.main>"u"&&i.push([A.default.Warning,s.localize(8,null,"extensionKind")]),typeof k.main<"u"){if(typeof k.main!="string")return i.push([A.default.Error,s.localize(9,null,"main")]),i;{const t=(0,S.$Bg)(a,k.main);(0,S.$vg)(t,a)||i.push([A.default.Warning,s.localize(10,null,t.path,a.path)])}}if(typeof k.browser<"u"){if(typeof k.browser!="string")return i.push([A.default.Error,s.localize(11,null,"browser")]),i;{const t=(0,S.$Bg)(a,k.browser);(0,S.$vg)(t,a)||i.push([A.default.Warning,s.localize(12,null,t.path,a.path)])}}if(!M.valid(k.version))return i.push([A.default.Error,s.localize(13,null)]),i;const o=[];if(!l(g,h,k,f,o))for(const t of o)i.push([A.default.Error,t]);return i}e.$Xo=p;function l(g,h,a,k,f){return k||typeof a.main>"u"&&typeof a.browser>"u"?!0:$(g,h,a.engines.vscode,f)}e.$Yo=l;function v(g,h,a){return g==="*"||$(h,a,g)}e.$Zo=v;function $(g,h,a,k=[]){const f=b(u(a));if(!f)return k.push(s.localize(14,null,a)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return k.push(s.localize(15,null,a)),!1}else if(!f.majorMustEqual)return k.push(s.localize(16,null,a)),!1;return y(g,h,f)?!0:(k.push(s.localize(17,null,g,a)),!1)}function w(g){if(!Array.isArray(g))return!1;for(let h=0,a=g.length;h<a;h++)if(typeof g[h]!="string")return!1;return!0}}),define(se[206],re([0,1,18,32]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=void 0;async function s(M,C,P){let d=P&&P.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const b=(await C.readFile(M.serviceMachineIdResource)).value.toString();d=(0,A.$jg)(b)?b:null}catch{d=null}if(!d){d=(0,A.$kg)();try{await C.writeFile(M.serviceMachineIdResource,S.$fe.fromString(d))}catch{}}return P?.store("storage.serviceMachineId",d,-1,1),d}e.$hp=s}),define(se[78],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=void 0;class S{constructor(s,M=[],C=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=C}}e.$Uh=S}),define(se[207],re([0,1,78]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=e.InstantiationType=void 0;const A=[];var s;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(P,d,u){d instanceof S.$Uh||(d=new S.$Uh(d,[],!!u)),A.push([P,d])}e.$Er=M;function C(){return A}e.$Fr=C}),define(se[208],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;class S{constructor(M,C){this.key=M,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$jq=S;class A{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const C of this.a.values())C.outgoing.size===0&&M.push(C);return M}insertEdge(M,C){const P=this.lookupOrInsertNode(M),d=this.lookupOrInsertNode(C);P.outgoing.set(d.key,d),d.incoming.set(P.key,P)}removeNode(M){const C=this.b(M);this.a.delete(C);for(const P of this.a.values())P.outgoing.delete(C),P.incoming.delete(C)}lookupOrInsertNode(M){const C=this.b(M);let P=this.a.get(C);return P||(P=new S(C,M),this.a.set(C,P)),P}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[C,P]of this.a)M.push(`${C}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,C]of this.a){const P=new Set([M]),d=this.c(C,P);if(d)return d}}c(M,C){for(const[P,d]of M.outgoing){if(C.has(P))return[...C,P].join(" -> ");C.add(P);const u=this.c(d,C);if(u)return u;C.delete(P)}}}e.$kq=A}),define(se[6],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=e.$Wh=e._util=void 0;var S;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function P(d){return d[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=P})(S||(e._util=S={})),e.$Wh=s("instantiationService");function A(C,P,d){P[S.DI_TARGET]===P?P[S.DI_DEPENDENCIES].push({id:C,index:d}):(P[S.DI_DEPENDENCIES]=[{id:C,index:d}],P[S.DI_TARGET]=P)}function s(C){if(S.serviceIds.has(C))return S.serviceIds.get(C);const P=function(d,u,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,d,b)};return P.toString=()=>C,S.serviceIds.set(C,P),P}e.$Xh=s;function M(C){return C}e.$Yh=M}),define(se[64],re([0,1,13,6]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J8b=e.$I8b=void 0,e.$I8b=(0,A.$Xh)("auxiliaryWindowsMainService");function s(M){return M?.opener?.url.startsWith(`${S.Schemas.vscodeFileResource}://${S.$hg}/`)}e.$J8b=s}),define(se[65],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q8b=void 0,e.$q8b=(0,S.$Xh)("backupMainService")}),define(se[17],re([0,1,12,7,6]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.ConfigurationTarget=e.$ti=e.$si=e.$ri=void 0,e.$ri=(0,s.$Xh)("configurationService");function M(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof A.URI)}e.$si=M;function C(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof A.URI)}e.$ti=C;var P;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function d(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ui=d;function u(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}e.$vi=u;function b(g,h){const a=Object.create(null);for(const k in g)y(a,k,g[k],h);return a}e.$wi=b;function y(g,h,a,k){const f=h.split("."),i=f.pop();let o=g;for(let r=0;r<f.length;r++){const t=f[r];let n=o[t];switch(typeof n){case"undefined":n=o[t]=Object.create(null);break;case"object":break;default:k(`Ignoring ${h} as ${f.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[i]=a}catch{k(`Ignoring ${h} as ${f.join(".")} is ${JSON.stringify(o)}`)}else k(`Ignoring ${h} as ${f.join(".")} is ${JSON.stringify(o)}`)}e.$xi=y;function p(g,h){const a=h.split(".");l(g,a)}e.$yi=p;function l(g,h){const a=h.shift();if(h.length===0){delete g[a];return}if(Object.keys(g).indexOf(a)!==-1){const k=g[a];typeof k=="object"&&!Array.isArray(k)&&(l(k,h),Object.keys(k).length===0&&delete g[a])}}function v(g,h,a){function k(o,r){let t=o;for(const n of r){if(typeof t!="object"||t===null)return;t=t[n]}return t}const f=h.split("."),i=k(g,f);return typeof i>"u"?a:i}e.$zi=v;function $(g,h,a){Object.keys(h).forEach(k=>{k!=="__proto__"&&(k in g?S.$Ef(g[k])&&S.$Ef(h[k])?$(g[k],h[k],a):a&&(g[k]=h[k]):g[k]=h[k])})}e.$Ai=$;function w(g){return g.replace(/[\[\]]/g,"")}e.$Bi=w}),define(se[114],re([0,1,4,25,197,6,164,14]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.ContextKeyExprType=e.$Ti=void 0;const d=new Map;d.set("false",!1),d.set("true",!0),d.set("isMac",S.$j),d.set("isLinux",S.$k),d.set("isWindows",S.$i),d.set("isWeb",S.$o),d.set("isMacNative",S.$j&&!S.$o),d.set("isEdge",S.$H),d.set("isFirefox",S.$F),d.set("isChrome",S.$E),d.set("isSafari",S.$G);function u(X,O){if(d.get(X)!==void 0)throw(0,P.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");d.set(X,O)}e.$Ti=u;const b=Object.prototype.hasOwnProperty;var y;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const p={regexParsingWithErrorRecovery:!0},l=(0,C.localize)(0,null),v=(0,C.localize)(1,null),$=(0,C.localize)(2,null),w=(0,C.localize)(3,null),g=(0,C.localize)(4,null),h=(0,C.localize)(5,null),a=(0,C.localize)(6,null),k=(0,C.localize)(7,null);class f{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=p){this.k=O,this.d=new s.$Si,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const G=this.D(),j=G.type===17?h:void 0;throw this.h.push({message:g,offset:G.offset,lexeme:s.$Si.getLexeme(G),additionalInfo:j}),f.c}return N}catch(N){if(N!==f.c)throw N;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const N=this.o();O.push(N)}return O.length===1?O[0]:i.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const N=this.s();O.push(N)}return O.length===1?O[0]:i.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),c.INSTANCE;case 0:{this.z();const N=this.l();return this.A(1,w),N?.negate()}case 17:return this.z(),L.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const N=this.l();return this.A(1,w),N}case 17:{const N=O.lexeme;if(this.z(),this.y(9)){const j=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),j.type!==10)throw this.B("REGEX",j);const B=j.lexeme,T=B.lastIndexOf("/"),Z=T===B.length-1?void 0:this.w(B.substring(T+1));let he;try{he=new RegExp(B.substring(1,T),Z)}catch{throw this.B("REGEX",j)}return oe.create(N,he)}switch(j.type){case 10:case 19:{const B=[j.lexeme];this.z();let T=this.D(),Z=0;for(let be=0;be<j.lexeme.length;be++)j.lexeme.charCodeAt(be)===40?Z++:j.lexeme.charCodeAt(be)===41&&Z--;for(;!this.E()&&T.type!==15&&T.type!==16;){switch(T.type){case 0:Z++;break;case 1:Z--;break;case 10:case 18:for(let be=0;be<T.lexeme.length;be++)T.lexeme.charCodeAt(be)===40?Z++:j.lexeme.charCodeAt(be)===41&&Z--}if(Z<0)break;B.push(s.$Si.getLexeme(T)),this.z(),T=this.D()}const he=B.join(""),de=he.lastIndexOf("/"),le=de===he.length-1?void 0:this.w(he.substring(de+1));let we;try{we=new RegExp(he.substring(1,de),le)}catch{throw this.B("REGEX",j)}return i.regex(N,we)}case 18:{const B=j.lexeme;this.z();let T=null;if(!(0,A.$Fe)(B)){const Z=B.indexOf("/"),he=B.lastIndexOf("/");if(Z!==he&&Z>=0){const de=B.slice(Z+1,he),le=B[he+1]==="i"?"i":"";try{T=new RegExp(de,le)}catch{throw this.B("REGEX",j)}}}if(T===null)throw this.B("REGEX",j);return oe.create(N,T)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,$);const j=this.u();return i.notIn(N,j)}switch(this.D().type){case 3:{this.z();const j=this.u();if(this.x().type===18)return i.equals(N,j);switch(j){case"true":return i.has(N);case"false":return i.not(N);default:return i.equals(N,j)}}case 4:{this.z();const j=this.u();if(this.x().type===18)return i.notEquals(N,j);switch(j){case"true":return i.not(N);case"false":return i.has(N);default:return i.notEquals(N,j)}}case 5:return this.z(),Y.create(N,this.u());case 6:return this.z(),ae.create(N,this.u());case 7:return this.z(),U.create(N,this.u());case 8:return this.z(),x.create(N,this.u());case 13:return this.z(),i.in(N,this.u());default:return i.has(N)}}case 20:throw this.h.push({message:a,offset:O.offset,lexeme:"",additionalInfo:k}),f.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,N){if(this.C(O))return this.z();throw this.B(N,this.D())}B(O,N,G){const j=(0,C.localize)(8,null,O,s.$Si.getLexeme(N)),B=N.offset,T=s.$Si.getLexeme(N);return this.h.push({message:j,offset:B,lexeme:T,additionalInfo:G}),f.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ui=f;class i{static false(){return n.INSTANCE}static true(){return c.INSTANCE}static has(O){return m.create(O)}static equals(O,N){return D.create(O,N)}static notEquals(O,N){return R.create(O,N)}static regex(O,N){return oe.create(O,N)}static in(O,N){return I.create(O,N)}static notIn(O,N){return E.create(O,N)}static not(O){return L.create(O)}static and(...O){return K.create(O,null,!0)}static or(...O){return V.create(O,null,!0)}static greater(O,N){return U.create(O,N)}static greaterEquals(O,N){return x.create(O,N)}static smaller(O,N){return Y.create(O,N)}static smallerEquals(O,N){return ae.create(O,N)}static{this.c=new f({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Vi=i;function o(X){const O=new f({regexParsingWithErrorRecovery:!1});return X.map(N=>(O.parse(N),O.lexingErrors.length>0?O.lexingErrors.map(G=>({errorMessage:G.additionalInfo?(0,C.localize)(9,null,G.additionalInfo):(0,C.localize)(10,null),offset:G.offset,length:G.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(G=>({errorMessage:G.additionalInfo?`${G.message}. ${G.additionalInfo}`:G.message,offset:G.offset,length:G.lexeme.length})):[]))}e.$Wi=o;function r(X,O){const N=X?X.substituteConstants():void 0,G=O?O.substituteConstants():void 0;return!N&&!G?!0:!N||!G?!1:N.equals(G)}e.$Xi=r;function t(X,O){return X.cmp(O)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return c.INSTANCE}}e.$Yi=n;class c{static{this.INSTANCE=new c}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$Zi=c;class m{static create(O,N=null){const G=d.get(O);return typeof G=="boolean"?G?c.INSTANCE:n.INSTANCE:new m(O,N)}constructor(O,N){this.key=O,this.c=N,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:W(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=d.get(this.key);return typeof O=="boolean"?O?c.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$1i=m;class D{static create(O,N,G=null){if(typeof N=="boolean")return N?m.create(O,G):L.create(O,G);const j=d.get(O);return typeof j=="boolean"?N===(j?"true":"false")?c.INSTANCE:n.INSTANCE:new D(O,N,G)}constructor(O,N,G){this.c=O,this.d=N,this.f=G,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=d.get(this.c);if(typeof O=="boolean"){const N=O?"true":"false";return this.d===N?c.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$2i=D;class I{static create(O,N){return new I(O,N)}constructor(O,N){this.d=O,this.f=N,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:H(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const N=O.getValue(this.f),G=O.getValue(this.d);return Array.isArray(N)?N.includes(G):typeof G=="string"&&typeof N=="object"&&N!==null?b.call(N,G):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$3i=I;class E{static create(O,N){return new E(O,N)}constructor(O,N){this.d=O,this.f=N,this.type=11,this.c=I.create(O,N)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$4i=E;class R{static create(O,N,G=null){if(typeof N=="boolean")return N?L.create(O,G):m.create(O,G);const j=d.get(O);return typeof j=="boolean"?N===(j?"true":"false")?n.INSTANCE:c.INSTANCE:new R(O,N,G)}constructor(O,N,G){this.c=O,this.d=N,this.f=G,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=d.get(this.c);if(typeof O=="boolean"){const N=O?"true":"false";return this.d===N?n.INSTANCE:c.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$5i=R;class L{static create(O,N=null){const G=d.get(O);return typeof G=="boolean"?G?n.INSTANCE:c.INSTANCE:new L(O,N)}constructor(O,N){this.c=O,this.d=N,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:W(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=d.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:c.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=m.create(this.c,this)),this.d}}e.$6i=L;function F(X,O){if(typeof X=="string"){const N=parseFloat(X);isNaN(N)||(X=N)}return typeof X=="string"||typeof X=="number"?O(X):n.INSTANCE}class U{static create(O,N,G=null){return F(N,j=>new U(O,j,G))}constructor(O,N,G){this.c=O,this.d=N,this.f=G,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$7i=U;class x{static create(O,N,G=null){return F(N,j=>new x(O,j,G))}constructor(O,N,G){this.c=O,this.d=N,this.f=G,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$8i=x;class Y{static create(O,N,G=null){return F(N,j=>new Y(O,j,G))}constructor(O,N,G){this.c=O,this.d=N,this.f=G,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$9i=Y;class ae{static create(O,N,G=null){return F(N,j=>new ae(O,j,G))}constructor(O,N,G){this.c=O,this.d=N,this.f=G,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$0i=ae;class oe{static create(O,N){return new oe(O,N)}constructor(O,N){this.d=O,this.f=N,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const N=this.f?this.f.source:"",G=O.f?O.f.source:"";return N<G?-1:N>G?1:0}equals(O){if(O.type===this.type){const N=this.f?this.f.source:"",G=O.f?O.f.source:"";return this.d===O.d&&N===G}return!1}substituteConstants(){return this}evaluate(O){const N=O.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$$i=oe;class ce{static create(O){return new ce(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new ce(this.c.map(O))}negate(){return this.c}}e.$_i=ce;function Q(X){let O=null;for(let N=0,G=X.length;N<G;N++){const j=X[N].substituteConstants();if(X[N]!==j&&O===null){O=[];for(let B=0;B<N;B++)O[B]=X[B]}O!==null&&(O[N]=j)}return O===null?X:O}class K{static create(O,N,G){return K.d(O,N,G)}constructor(O,N){this.expr=O,this.c=N,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let N=0,G=this.expr.length;N<G;N++){const j=t(this.expr[N],O.expr[N]);if(j!==0)return j}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let N=0,G=this.expr.length;N<G;N++)if(!this.expr[N].equals(O.expr[N]))return!1;return!0}return!1}substituteConstants(){const O=Q(this.expr);return O===this.expr?this:K.create(O,this.c,!1)}evaluate(O){for(let N=0,G=this.expr.length;N<G;N++)if(!this.expr[N].evaluate(O))return!1;return!0}static d(O,N,G){const j=[];let B=!1;for(const T of O)if(T){if(T.type===1){B=!0;continue}if(T.type===0)return n.INSTANCE;if(T.type===6){j.push(...T.expr);continue}j.push(T)}if(j.length===0&&B)return c.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(t);for(let T=1;T<j.length;T++)j[T-1].equals(j[T])&&(j.splice(T,1),T--);if(j.length===1)return j[0];for(;j.length>1;){const T=j[j.length-1];if(T.type!==9)break;j.pop();const Z=j.pop(),he=j.length===0,de=V.create(T.expr.map(le=>K.create([le,Z],null,G)),null,he);de&&(j.push(de),j.sort(t))}if(j.length===1)return j[0];if(G){for(let T=0;T<j.length;T++)for(let Z=T+1;Z<j.length;Z++)if(j[T].negate().equals(j[Z]))return n.INSTANCE;if(j.length===1)return j[0]}return new K(j,N)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const N of this.expr)O.push(...N.keys());return O}map(O){return new K(this.expr.map(N=>N.map(O)),null)}negate(){if(!this.c){const O=[];for(const N of this.expr)O.push(N.negate());this.c=V.create(O,this,!0)}return this.c}}e.$aj=K;class V{static create(O,N,G){return V.d(O,N,G)}constructor(O,N){this.expr=O,this.c=N,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let N=0,G=this.expr.length;N<G;N++){const j=t(this.expr[N],O.expr[N]);if(j!==0)return j}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let N=0,G=this.expr.length;N<G;N++)if(!this.expr[N].equals(O.expr[N]))return!1;return!0}return!1}substituteConstants(){const O=Q(this.expr);return O===this.expr?this:V.create(O,this.c,!1)}evaluate(O){for(let N=0,G=this.expr.length;N<G;N++)if(this.expr[N].evaluate(O))return!0;return!1}static d(O,N,G){let j=[],B=!1;if(O){for(let T=0,Z=O.length;T<Z;T++){const he=O[T];if(he){if(he.type===0){B=!0;continue}if(he.type===1)return c.INSTANCE;if(he.type===9){j=j.concat(he.expr);continue}j.push(he)}}if(j.length===0&&B)return n.INSTANCE;j.sort(t)}if(j.length!==0){if(j.length===1)return j[0];for(let T=1;T<j.length;T++)j[T-1].equals(j[T])&&(j.splice(T,1),T--);if(j.length===1)return j[0];if(G){for(let T=0;T<j.length;T++)for(let Z=T+1;Z<j.length;Z++)if(j[T].negate().equals(j[Z]))return c.INSTANCE;if(j.length===1)return j[0]}return new V(j,N)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const N of this.expr)O.push(...N.keys());return O}map(O){return new V(this.expr.map(N=>N.map(O)),null)}negate(){if(!this.c){const O=[];for(const N of this.expr)O.push(N.negate());for(;O.length>1;){const N=O.shift(),G=O.shift(),j=[];for(const B of ne(N))for(const T of ne(G))j.push(K.create([B,T],null,!1));O.unshift(V.create(j,null,!1))}this.c=V.create(O,this,!0)}return this.c}}e.$bj=V;class z extends m{static{this.d=[]}static all(){return z.d.values()}constructor(O,N,G){super(O,null),this.f=N,typeof G=="object"?z.d.push({...G,key:O}):G!==!0&&z.d.push({key:O,description:G,type:N!=null?typeof N:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return D.create(this.key,O)}notEqualsTo(O){return R.create(this.key,O)}}e.$cj=z,e.$dj=(0,M.$Xh)("contextKeyService");function W(X,O){return X<O?-1:X>O?1:0}function H(X,O,N,G){return X<N?-1:X>N?1:O<G?-1:O>G?1:0}function q(X,O){if(X.type===0||O.type===1)return!0;if(X.type===9)return O.type===9?_(X.expr,O.expr):!1;if(O.type===9){for(const N of O.expr)if(q(X,N))return!0;return!1}if(X.type===6){if(O.type===6)return _(O.expr,X.expr);for(const N of X.expr)if(q(N,O))return!0;return!1}return X.equals(O)}e.$ej=q;function _(X,O){let N=0,G=0;for(;N<X.length&&G<O.length;){const j=X[N].cmp(O[G]);if(j<0)return!1;j===0&&N++,G++}return N===X.length}function ne(X){return X.type===9?X.expr:[X]}}),define(se[91],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=e.$ym=e.ID=void 0,e.ID="diagnosticsService",e.$ym=(0,S.$Xh)(e.ID);function A(M){return!!M.hostName&&!!M.errorMessage}e.$zm=A;class s{async getPerformanceInfo(C,P){return{}}async getSystemInfo(C,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,P){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.$Am=s}),define(se[115],re([0,1,19,74,166,6,47,4,38]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ov=e.$Nv=e.ConfirmResult=e.$Mv=e.$Lv=e.$Kv=void 0,e.$Kv=(0,M.$Xh)("dialogService");var u;(function($){$[$.Confirmation=1]="Confirmation",$[$.Prompt=2]="Prompt",$[$.Input=3]="Input"})(u||(u={}));class b{a(w){return this.d(w,u.Confirmation)}b(w){return this.d(w,u.Prompt)}c(w){return this.d(w,u.Input)}d(w,g){const h=[];switch(g){case u.Confirmation:{const a=w;a.primaryButton?h.push(a.primaryButton):h.push((0,s.localize)(0,null)),a.cancelButton?h.push(a.cancelButton):h.push((0,s.localize)(1,null));break}case u.Prompt:{const a=w;Array.isArray(a.buttons)&&a.buttons.length>0&&h.push(...a.buttons.map(k=>k.label)),a.cancelButton&&(a.cancelButton===!0?h.push((0,s.localize)(2,null)):typeof a.cancelButton=="string"?h.push(a.cancelButton):a.cancelButton.label?h.push(a.cancelButton.label):h.push((0,s.localize)(3,null))),h.length===0&&h.push((0,s.localize)(4,null));break}case u.Input:{const a=w;a.primaryButton?h.push(a.primaryButton):h.push((0,s.localize)(5,null)),a.cancelButton?h.push(a.cancelButton):h.push((0,s.localize)(6,null));break}}return h}e(w){if(typeof w=="string")return w;if(typeof w=="number")return w===A.default.Info?"info":w===A.default.Error?"error":w===A.default.Warning?"warning":"none"}f(w,g,h){const a=[...w.buttons??[]];w.cancelButton&&typeof w.cancelButton!="string"&&typeof w.cancelButton!="boolean"&&a.push(w.cancelButton);let k=a[g]?.run({checkboxChecked:h});return k instanceof Promise||(k=Promise.resolve(k)),{result:k,checkboxChecked:h}}}e.$Lv=b,e.$Mv=(0,M.$Xh)("fileDialogService");var y;(function($){$[$.SAVE=0]="SAVE",$[$.DONT_SAVE=1]="DONT_SAVE",$[$.CANCEL=2]="CANCEL"})(y||(e.ConfirmResult=y={}));const p=10;function l($){const w=[];return w.push(...$.slice(0,p).map(g=>typeof g=="string"?g:(0,S.$yg)(g))),$.length>p&&($.length-p===1?w.push((0,s.localize)(7,null)):w.push((0,s.localize)(8,null,$.length-p))),w.push(""),w.join(`
`)}e.$Nv=l;function v($,w){const g=(0,d.$cn)($);let h=(g.buttons??[]).map(i=>(0,C.$Hv)(i)),a=($.buttons||[]).map((i,o)=>o),k=0,f=g.cancelId??h.length-1;if(h.length>1){const i=typeof f=="number"?h[f]:void 0;if(P.$k||P.$j){if(typeof i=="string"&&h.length>1&&f!==1){h.splice(f,1),h.splice(1,0,i);const o=a[f];a.splice(f,1),a.splice(1,0,o),f=1}P.$k&&h.length>1&&(h=h.reverse(),a=a.reverse(),k=h.length-1,typeof i=="string"&&(f=k-1))}else if(P.$i&&typeof i=="string"&&h.length>1&&f!==h.length-1){h.splice(f,1),h.push(i);const o=a[f];a.splice(f,1),a.push(o),f=h.length-1}}return g.buttons=h,g.defaultId=k,g.cancelId=f,g.noLink=!0,g.title=g.title||w.nameLong,{options:g,buttonIndeces:a}}e.$Ov=v}),define(se[116],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IU=e.$HU=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$GU=e.$FU=void 0,e.$FU=(0,S.$Xh)("encryptionService"),e.$GU=(0,S.$Xh)("encryptionMainService");var A;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnome="gnome",P.gnomeKeyring="gnome-keyring",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(A||(e.PasswordStoreCLIOption=A={}));var s;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(P){return P==="kwallet"||P==="kwallet5"||P==="kwallet6"}e.$HU=M;function C(P){return P==="gnome_any"||P==="gnome_libsecret"||P==="gnome_keyring"}e.$IU=C}),define(se[37],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=void 0,e.$5h=(0,S.$Xh)("environmentService"),e.$6h=(0,S.$Yh)(e.$5h)}),define(se[117],re([0,1,170,6]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$fo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=void 0,e.$6n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$7n=new RegExp(e.$6n),e.$8n="__web_extension",e.$9n="skipWalkthrough",e.$0n="extensionsSync",e.$$n="dependecyOrPackExtensionInstall";function s(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$_n=s;function M(g){switch(g){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$ao=M;function C(g,h){switch(g){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$bo=C;function P(g,h){return h==="web"&&!g.includes("web")}e.$co=P;function d(g,h,a){return P(h,a)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===a}e.$do=d;function u(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.$eo=u;var b;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var y;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var p;(function(g){g.Install="install",g.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var l;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(l||(e.InstallOperation=l={})),e.$fo=(0,A.$Xh)("extensionGalleryService");var v;(function(g){g.Unsupported="Unsupported",g.Deprecated="Deprecated",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Signature="Signature",g.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var $;(function(g){g.UnknownError="UnknownError",g.PackageIsInvalidZip="PackageIsInvalidZip",g.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})($||(e.ExtensionSignaturetErrorCode=$={}));class w extends Error{constructor(h,a){super(h),this.code=a,this.name=a}}e.$go=w,e.$ho=(0,A.$Xh)("extensionManagementService"),e.$io="extensionsIdentifiers/disabled",e.$jo="extensionsIdentifiers/enabled",e.$ko=(0,A.$Xh)("IGlobalExtensionEnablementService"),e.$lo=(0,A.$Xh)("IExtensionTipsService"),e.$mo=(0,S.localize)(0,null),e.$no={value:e.$mo,original:"Extensions"},e.$oo={value:(0,S.localize)(1,null),original:"Preferences"}}),define(se[209],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y8b=e.$X8b=void 0,e.$X8b=(0,S.$Xh)("extensionHostStarter"),e.$Y8b="extensionHostStarter"}),define(se[210],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Zb=e.$4Zb=void 0,e.$4Zb=(0,S.$Xh)("externalTerminal"),e.$5Zb="Terminal.app"}),define(se[211],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$18b=void 0,e.$18b=(0,S.$Xh)("externalTerminal")}),define(se[212],re([0,1,48,13,9,4,76,21,89,174,210]),function(J,e,S,A,s,M,C,P,d,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$48b=e.$38b=e.$28b=void 0;const y=u.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:l.getDefaultTerminalWindows(),linux:await $.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class l extends p{static{this.b="cmd.exe"}openTerminal(k,f){return this.spawnTerminal(S,k,d.$Jl(),f)}spawnTerminal(k,f,i,o){const r=f.windowsExec||l.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const t=s.$mc(r,".exe").toLowerCase();if(t==="cmder")return k.spawn(r,o?[o]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),t==="wt"&&n.push("-d ."),new Promise((c,m)=>{const D=w(process),I=k.spawn(i,n,{cwd:o,env:D});I.on("error",m),I.on("exit",()=>c())})}runInTerminal(k,f,i,o,r){const t="windowsExec"in r&&r.windowsExec?r.windowsExec:l.getDefaultTerminalWindows();return new Promise((n,c)=>{const m=`"${f} - ${y}"`,D=`""${i.join('" "')}" & pause"`,I=Object.assign({},w(process),o);Object.keys(I).filter(U=>I[U]===null).forEach(U=>delete I[U]);const E={cwd:f,env:I,windowsVerbatimArguments:!0};let R,L;s.$mc(t,".exe")==="wt"?(R=t,L=["-d",".",l.b,"/c",D]):(R=l.b,L=["/c","start",m,"/wait",t,"/c",D]),S.spawn(R,L,E).on("error",U=>{c(g(U))}),n(void 0)})}static getDefaultTerminalWindows(){if(!l.d){const k=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");l.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${k?"Sysnative":"System32"}\\cmd.exe`}return l.d}}e.$28b=l;class v extends p{static{this.b="/usr/bin/osascript"}openTerminal(k,f){return this.spawnTerminal(S,k,f)}runInTerminal(k,f,i,o,r){const t=r.osxExec||b.$5Zb;return new Promise((n,c)=>{if(t===b.$5Zb||t==="iTerm.app"){const m=t===b.$5Zb?"TerminalHelper":"iTermHelper",I=[A.$ig.asFileUri(`vs/workbench/contrib/externalTerminal/node/${m}.scpt`).fsPath,"-t",k||y,"-w",f];for(const L of i)I.push("-a"),I.push(L);if(o){const L=Object.assign({},w(process),o);for(const F in L){const U=L[F];U===null?(I.push("-u"),I.push(F)):(I.push("-e"),I.push(`${F}=${U}`))}}let E="";const R=S.spawn(v.b,I);R.on("error",L=>{c(g(L))}),R.stderr.on("data",L=>{E+=L.toString()}),R.on("exit",L=>{if(L===0)n(void 0);else if(E){const F=E.split(`
`,1);c(new Error(F[0]))}else c(new Error(u.localize(1,null,m,L)))})}else c(new Error(u.localize(2,null,t)))})}spawnTerminal(k,f,i){const o=f.osxExec||b.$5Zb;return new Promise((r,t)=>{const n=["-a",o];i&&n.push(i);const c=w(process),m=k.spawn("/usr/bin/open",n,{cwd:i,env:c});m.on("error",t),m.on("exit",()=>r())})}}e.$38b=v;class $ extends p{static{this.b=u.localize(3,null)}openTerminal(k,f){return this.spawnTerminal(S,k,f)}runInTerminal(k,f,i,o,r){const t=r.linuxExec?Promise.resolve(r.linuxExec):$.getDefaultTerminalLinuxReady();return new Promise((n,c)=>{const m=[];t.then(D=>{D.indexOf("gnome-terminal")>=0?m.push("-x"):m.push("-e"),m.push("bash"),m.push("-c");const I=`${h(i)}; echo; read -p "${$.b}" -n1;`;m.push(`''${I}''`);const E=Object.assign({},w(process),o);Object.keys(E).filter(U=>E[U]===null).forEach(U=>delete E[U]);const R={cwd:f,env:E};let L="";const F=S.spawn(D,m,R);F.on("error",U=>{c(g(U))}),F.stderr.on("data",U=>{L+=U.toString()}),F.on("exit",U=>{if(U===0)n(void 0);else if(L){const x=L.split(`
`,1);c(new Error(x[0]))}else c(new Error(u.localize(4,null,D,U)))})})})}static async getDefaultTerminalLinuxReady(){if(!$.d)if(!M.$k)$.d=Promise.resolve("xterm");else{const k=await P.Promises.exists("/etc/debian_version");$.d=new Promise(f=>{k?f("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?f("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?f("konsole"):process.env.COLORTERM?f(process.env.COLORTERM):process.env.TERM?f(process.env.TERM):f("xterm")})}return $.d}spawnTerminal(k,f,i){const o=f.linuxExec?Promise.resolve(f.linuxExec):$.getDefaultTerminalLinuxReady();return new Promise((r,t)=>{o.then(n=>{const c=w(process),m=k.spawn(n,[],{cwd:i,env:c});m.on("error",t),m.on("exit",()=>r())})})}}e.$48b=$;function w(a){const k={...a.env};return(0,C.$Hl)(k),k}function g(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(u.localize(5,null,a.path)):a}function h(a){let k="";for(const f of a)f.indexOf(" ")>=0?k+='"'+f+'"':k+=f,k+=" ";return k}}),define(se[16],re([0,1,57,9,25,12,7,176,6,4,13,72]),function(J,e,S,A,s,M,C,P,d,u,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileKind=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileOperationResult=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.FileChangeType=e.$yk=e.FileOperation=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileSystemProviderErrorCode=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.FileSystemProviderCapabilities=e.$ik=e.FilePermission=e.FileType=e.$hk=e.$gk=void 0,e.$gk=(0,d.$Xh)("fileService");function p(q){return q.create===!0}e.$hk=p;var l;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var v;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function $(q){const _=q;return!!_&&typeof _.onDidChange=="function"}e.$ik=$;var w;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function g(q){return!!(q.capabilities&2)}e.$jk=g;function h(q){return!!(q.capabilities&8)}e.$kk=h;function a(q){return!!(q.capabilities&131072)}e.$lk=a;function k(q){return!!(q.capabilities&4)}e.$mk=k;function f(q){return!!(q.capabilities&16)}e.$nk=f;function i(q){return g(q)?!!(q.capabilities&16384):!1}e.$ok=i;function o(q){return g(q)?!!(q.capabilities&32768):!1}e.$pk=o;function r(q){return!!(q.capabilities&65536)}e.$qk=r;function t(q){return!!(q.capabilities&2048)}e.$rk=t;var n;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class c extends Error{static create(_,ne){const X=new c(_.toString(),ne);return I(X,ne),X}constructor(_,ne){super(_),this.code=ne}}e.$sk=c;function m(q,_){return c.create(q,_)}e.$tk=m;function D(q){return q||m((0,P.localize)(0,null),n.Unknown)}e.$uk=D;function I(q,_){return q.name=_?`${_} (FileSystemError)`:"FileSystemError",q}e.$vk=I;function E(q){if(!q)return n.Unknown;if(q instanceof c)return q.code;const _=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!_)return n.Unknown;switch(_[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$wk=E;function R(q){if(q instanceof ae)return q.fileOperationResult;switch(E(q)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$xk=R;var L;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class F{constructor(_,ne,X){this.resource=_,this.operation=ne,this.target=X}isOperation(_){return this.operation===_}}e.$yk=F;var U;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class x{static{this.a=null}constructor(_,ne){this.c=ne,this.b=void 0,this.d=new y.$U(()=>{const X=S.$4h.forUris(()=>this.c);return X.fill(this.rawAdded.map(O=>[O,!0])),X}),this.f=new y.$U(()=>{const X=S.$4h.forUris(()=>this.c);return X.fill(this.rawUpdated.map(O=>[O,!0])),X}),this.g=new y.$U(()=>{const X=S.$4h.forUris(()=>this.c);return X.fill(this.rawDeleted.map(O=>[O,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of _){switch(X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}this.b!==x.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=x.a):this.b!==void 0&&(this.b=x.a))}}contains(_,...ne){return this.h(_,{includeChildren:!1},...ne)}affects(_,...ne){return this.h(_,{includeChildren:!0},...ne)}h(_,ne,...X){if(!_)return!1;const O=X.length>0;return!!((!O||X.includes(1))&&(this.d.value.get(_)||ne.includeChildren&&this.d.value.findSuperstr(_))||(!O||X.includes(0))&&(this.f.value.get(_)||ne.includeChildren&&this.f.value.findSuperstr(_))||(!O||X.includes(2))&&(this.g.value.findSubstr(_)||ne.includeChildren&&this.g.value.findSuperstr(_)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(_){return this.b===_}hasCorrelation(){return typeof this.b=="number"}}e.$zk=x;function Y(q,_,ne){return!q||!_||q===_||_.length>q.length?!1:(_.charAt(_.length-1)!==A.sep&&(_+=A.sep),ne?(0,s.$7e)(q,_):q.indexOf(_)===0)}e.$Ak=Y;class ae extends Error{constructor(_,ne,X){super(_),this.fileOperationResult=ne,this.options=X}}e.$Bk=ae;class oe extends ae{constructor(_,ne,X,O){super(_,ne,O),this.fileOperationResult=ne,this.size=X}}e.$Ck=oe;class ce extends ae{constructor(_,ne,X){super(_,2,X),this.stat=ne}}e.$Dk=ce;var Q;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Q||(e.FileOperationResult=Q={})),e.$Ek={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Fk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Gk="files.associations",e.$Hk="files.exclude",e.$Ik="files.readonlyInclude",e.$Jk="files.readonlyExclude",e.$Kk="files.readonlyFromPermissions";var K;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$Lk="";function V(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$Mk=V;async function z(q,_){if(!_.hasProvider(C.URI.from({scheme:q.scheme})))return new Promise(ne=>{const X=_.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===q.scheme&&O.added&&(X.dispose(),ne())})})}e.$Nk=z;class W{static{this.KB=1024}static{this.MB=W.KB*W.KB}static{this.GB=W.MB*W.KB}static{this.TB=W.GB*W.KB}static formatSize(_){return(0,M.$Gf)(_)||(_=0),_<W.KB?(0,P.localize)(1,null,_.toFixed(0)):_<W.MB?(0,P.localize)(2,null,(_/W.KB).toFixed(2)):_<W.GB?(0,P.localize)(3,null,(_/W.MB).toFixed(2)):_<W.TB?(0,P.localize)(4,null,(_/W.GB).toFixed(2)):(0,P.localize)(5,null,(_/W.TB).toFixed(2))}}e.$Ok=W;function H(q){const _=typeof q=="string"||q?.scheme===b.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===b.Schemas.file?1024*W.MB:_?10*W.MB:u.$o?50*W.MB:1024*W.MB}e.$Pk=H}),define(se[118],re([0,1,18,14,177,16]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=void 0;async function C(b,y,p,l,v,$){let w;try{await P(b,y,p,l,v,$)}catch(g){w=g}finally{w&&v.errorTransformer&&(w=v.errorTransformer(w)),typeof w<"u"&&p.error(w),p.end()}}e.$Up=C;async function P(b,y,p,l,v,$){d($);const w=await b.open(y,{create:!1});try{d($);let g=0,h=0,a=v&&typeof v.length=="number"?v.length:void 0,k=S.$fe.alloc(Math.min(v.bufferSize,typeof a=="number"?a:v.bufferSize)),f=v&&typeof v.position=="number"?v.position:0,i=0;do h=await b.read(w,f,k.buffer,i,k.byteLength-i),f+=h,i+=h,g+=h,typeof a=="number"&&(a-=h),i===k.byteLength&&(await p.write(l(k)),k=S.$fe.alloc(Math.min(v.bufferSize,typeof a=="number"?a:v.bufferSize)),i=0);while(h>0&&(typeof a!="number"||a>0)&&d($)&&u(g,v));if(i>0){let o=i;typeof a=="number"&&(o=Math.min(i,a)),p.write(l(k.slice(0,o)))}}catch(g){throw(0,M.$uk)(g)}finally{await b.close(w)}}function d(b){if(b.isCancellationRequested)throw(0,A.$5)();return!0}function u(b,y){if(typeof y?.limits?.size=="number"&&b>y.limits.size)throw(0,M.$tk)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(se[66],re([0,1,104,2,9,4,7,16]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=e.$2p=e.$1p=e.$Zp=e.$Yp=e.$Xp=e.$Wp=void 0;function d(g){return g.recursive===!0}e.$Wp=d;class u extends A.$Rc{static{this.a=5}constructor(h,a,k,f){super(),this.h=h,this.j=a,this.m=k,this.n=f,this.c=this.B(new A.$Sc),this.f=void 0,this.g=0}s(){const h=new A.$Qc;this.c.value=h,this.b=this.r(h),this.b.setVerboseLogging(this.m),h.add(this.b.onDidChangeFile(a=>this.h(a))),h.add(this.b.onDidLogMessage(a=>this.j(a))),h.add(this.b.onDidError(a=>this.t(a)))}t(h){this.n.restartOnError?this.g<u.a&&this.f?(this.w(`restarting watcher after error: ${h}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${h}`):this.w(h)}u(h){this.g++,this.s(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.m=h,await this.b?.setVerboseLogging(h)}w(h){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${h}`})}y(h){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Xp=u;class b extends u{constructor(h,a,k){super(h,a,k,{type:"node.js",restartOnError:!1})}}e.$Yp=b;class y extends u{constructor(h,a,k){super(h,a,k,{type:"universal",restartOnError:!0})}}e.$Zp=y;function p(g){return g.map(h=>({type:h.type,resource:C.URI.revive(h.resource),cId:h.cId}))}e.$1p=p;function l(g){const h=new w;for(const a of g)h.processEvent(a);return h.coalesce()}e.$2p=l;function v(g,h){return typeof h=="string"&&!h.startsWith(S.$Aj)&&!(0,s.$hc)(h)?{base:g,pattern:h}:h}e.$3p=v;function $(g,h){const a=[];for(const k of h)a.push((0,S.$Ej)(v(g,k)));return a}e.$4p=$;class w{constructor(){this.a=new Set,this.b=new Map}c(h){return M.$k?h.resource.fsPath:h.resource.fsPath.toLowerCase()}processEvent(h){const a=this.b.get(this.c(h));let k=!1;if(a){const f=a.type,i=h.type;a.resource.fsPath!==h.resource.fsPath&&(h.type===2||h.type===1)?k=!0:f===1&&i===2?(this.b.delete(this.c(h)),this.a.delete(a)):f===2&&i===1?a.type=0:f===1&&i===0||(a.type=i)}else k=!0;k&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],a=[];return Array.from(this.a).filter(k=>k.type!==2?(h.push(k),!1):!0).sort((k,f)=>k.resource.fsPath.length-f.resource.fsPath.length).filter(k=>a.some(f=>(0,P.$Ak)(k.resource.fsPath,f,!M.$k))?!1:(a.push(k.resource.fsPath),!0)).concat(h)}}}),define(se[213],re([0,1,18,50,14,3,2,62,32,16,66]),function(J,e,S,A,s,M,C,P,d,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HN=e.$GN=void 0,e.$GN="localFilesystem";class y extends C.$Rc{constructor(l,v){super(),this.a=l,this.b=v,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$Rd),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$Rd),this.onDidWatchError=this.g.event,this.h=(0,d.$kg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(l){return this.a.call("stat",[l])}readdir(l){return this.a.call("readdir",[l])}async readFile(l,v){const{buffer:$}=await this.a.call("readFile",[l,v]);return $}readFileStream(l,v,$){const w=(0,P.$6d)(h=>S.$fe.concat(h.map(a=>S.$fe.wrap(a))).buffer),g=new C.$Qc;return g.add(this.a.listen("readFileStream",[l,v])(h=>{if(h instanceof S.$fe)w.write(h.buffer);else{if(h==="end")w.end();else{let a;if(h instanceof Error)a=h;else{const k=h;a=(0,u.$tk)(k.message??(0,A.$Ii)(k),k.code??u.FileSystemProviderErrorCode.Unknown)}w.error(a),w.end()}g.dispose()}})),g.add($.onCancellationRequested(()=>{w.error((0,s.$5)()),w.end(),g.dispose()})),w}writeFile(l,v,$){return this.a.call("writeFile",[l,S.$fe.wrap(v),$])}open(l,v){return this.a.call("open",[l,v])}close(l){return this.a.call("close",[l])}async read(l,v,$,w,g){const[h,a]=await this.a.call("read",[l,v,g]);return $.set(h.buffer.slice(0,a),w),a}write(l,v,$,w,g){return this.a.call("write",[l,v,S.$fe.wrap($),w,g])}mkdir(l){return this.a.call("mkdir",[l])}delete(l,v){return this.a.call("delete",[l,v])}rename(l,v,$){return this.a.call("rename",[l,v,$])}copy(l,v,$){return this.a.call("copy",[l,v,$])}cloneFile(l,v){return this.a.call("cloneFile",[l,v])}j(){this.B(this.a.listen("fileChange",[this.h])(l=>{if(Array.isArray(l)){const v=l;this.f.fire((0,b.$1p)(v))}else{const v=l;this.g.fire(v)}}))}watch(l,v){const $=(0,d.$kg)();return this.a.call("watch",[this.h,$,l,v]),(0,C.$Pc)(()=>this.a.call("unwatch",[this.h,$]))}}e.$HN=y}),define(se[214],re([0,1,46,8,22,33,2,85,9,4,19,7,105,21,66]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;class $ extends C.$Rc{static{this.a=100}static{this.b=75}constructor(h,a,k,f){super(),this.m=h,this.n=a,this.r=k,this.s=f,this.c=this.B(new A.$ch({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new A.$bh(i=>this.z(i),$.b)),this.g=(0,v.$4p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,v.$4p)(this.m.path,this.m.includes):void 0,this.j=new s.$2d,this.ready=this.t()}async t(){try{const h=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const a=await l.Promises.stat(h);this.B(await this.w(h,a.isDirectory()))}catch(h){h.code!=="ENOENT"?this.D(h):this.G(h)}}async u(h){let a=h.path;try{a=await l.Promises.realpath(h.path),h.path===a&&(a=await(0,p.$bq)(h.path)??h.path),h.path!==a&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${a})`)}catch{}return a}async w(h,a){if(u.$j&&(0,M.$2f)(h,"/Volumes/",!0))return this.D(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.$Rc.None;const k=new s.$2d(this.j.token),f=new C.$Qc;try{const i=y.URI.file(this.m.path),o=(0,d.$mc)(h),r=(0,S.watch)(h);f.add((0,C.$Pc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${h}'`);const t=new Set;if(a)try{for(const c of await l.Promises.readdir(h))t.add(c)}catch(c){this.D(c)}const n=new Map;f.add((0,C.$Pc)(()=>{for(const[,c]of n)c.dispose();n.clear()})),r.on("error",(c,m)=>{this.D(`Failed to watch ${h} for changes using fs.watch() (${c}, ${m})`),this.dispose()}),r.on("change",(c,m)=>{if(k.token.isCancellationRequested)return;this.G(`[raw] ["${c}"] ${m}`);let D="";if(m&&(D=m.toString(),u.$j&&(D=(0,P.$wl)(D))),!(!D||c!=="change"&&c!=="rename"))if(a)if(c==="rename"){n.get(D)?.dispose();const I=setTimeout(async()=>{if(n.delete(D),D===o&&!await l.Promises.exists(h)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const E=await this.C((0,d.$ic)(h,D));if(k.token.isCancellationRequested)return;let R;E?t.has(D)?R=0:(R=1,t.add(D)):(t.delete(D),R=2),this.y({resource:(0,b.$Bg)(i,D),type:R,cId:this.m.correlationId})},$.a);n.set(D,(0,C.$Pc)(()=>clearTimeout(I)))}else{let I;t.has(D)?I=0:(I=1,t.add(D)),this.y({resource:(0,b.$Bg)(i,D),type:I,cId:this.m.correlationId})}else if(c==="rename"||D!==o){const I=setTimeout(async()=>{const E=await l.Promises.exists(h);k.token.isCancellationRequested||(E?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),f.add(await this.w(h,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},$.a);f.clear(),f.add((0,C.$Pc)(()=>clearTimeout(I)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await l.Promises.exists(h)&&!k.token.isCancellationRequested&&this.D(`Failed to watch ${h} for changes using fs.watch() (${i.toString()})`)}return(0,C.$Pc)(()=>{k.dispose(!0),f.dispose()})}y(h,a=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`),!a&&this.g.some(k=>k(h.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${h.resource.fsPath}`):!a&&this.h&&this.h.length>0&&!this.h.some(k=>k(h.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${h.resource.fsPath}`):this.f.work(h))}z(h){const a=(0,v.$2p)(h);if(a.length>0){if(this.s)for(const f of a)this.G(` >> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`);this.c.work(a)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${a[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(h){if(u.$k)return l.Promises.exists(h);try{const a=(0,d.$mc)(h);return(await l.Promises.readdir((0,d.$lc)(h))).some(f=>f===a)}catch(a){return this.G(a),!1}}setVerboseLogging(h){this.s=h}D(h){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}F(h){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}G(h){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$eq=$;async function w(g,h,a,k,f=512){const i=await l.Promises.open(g,"r"),o=Buffer.allocUnsafe(f),r=new s.$2d(k);let t,n=!1;const c={path:g,excludes:[],recursive:!1},m=new $(c,D=>{(async()=>{for(const{type:I}of D)if(I===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:E}=await l.Promises.read(i,o,0,f,null);if(!E||r.token.isCancellationRequested)break;h(o.slice(0,E))}}catch(E){t=new Error(E),r.dispose(!0)}finally{n=!1}}})()});return await m.ready,a(),new Promise((D,I)=>{r.token.onCancellationRequested(async()=>{m.dispose();try{await l.Promises.close(i)}catch(E){t=new Error(E)}t?I(t):D()})})}e.$fq=w}),define(se[215],re([0,1,3,104,2,4,214]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0;class P extends s.$Rc{constructor(){super(...arguments),this.a=this.B(new S.$Rd),this.onDidChangeFile=this.a.event,this.b=this.B(new S.$Rd),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(u){const b=this.j(u),y=b.filter(l=>{const v=this.c.get(l.path);return v?!(0,A.$Ij)(v.request.excludes,l.excludes)||!(0,A.$Ij)(v.request.includes,l.includes):!0}),p=Array.from(this.c.values()).filter(({request:l})=>!b.find(v=>v.path===l.path&&(0,A.$Ij)(v.excludes,l.excludes)&&(0,A.$Ij)(v.includes,l.includes))).map(({request:l})=>l.path);y.length&&this.m(`Request to start watching: ${y.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"}, correlationId: ${typeof l.correlationId=="number"?l.correlationId:"<none>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const l of p)this.h(l);for(const l of y)this.g(l)}g(u){const b=new C.$eq(u,p=>this.a.fire(p),p=>this.b.fire(p),this.f),y={request:u,instance:b};this.c.set(u.path,y)}async stop(){for(const[u]of this.c)this.h(u);this.c.clear()}h(u){const b=this.c.get(u);b&&(this.c.delete(u),b.instance.dispose())}j(u){const b=new Map;for(const y of u){const p=M.$k?y.path:y.path.toLowerCase();let l=b.get(y.correlationId);l||(l=new Map,b.set(y.correlationId,l)),l.set(p,y)}return Array.from(b.values()).map(y=>Array.from(y.values())).flat()}async setVerboseLogging(u){this.f=u;for(const[,b]of this.c)b.instance.setVerboseLogging(u)}m(u){this.f&&this.b.fire({type:"trace",message:this.n(u)})}n(u,b){return b?`[File Watcher (node.js)] ${u} (path: ${b.request.path})`:`[File Watcher (node.js)] ${u}`}}e.$gq=P}),define(se[216],re([0,1,66,215]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=void 0;class s extends S.$Yp{constructor(C,P,d){super(C,P,d),this.s()}r(C){return C.add(new A.$gq)}}e.$hq=s}),define(se[217],re([0,1,13,42,160,66]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;class C extends M.$Zp{constructor(d,u,b){super(d,u,b),this.s()}r(d){const u=d.add(new s.$$p(S.$ig.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(u.onDidProcessExit(({code:b,signal:y})=>this.t(`terminated by itself with code ${b}, signal: ${y}`))),A.ProxyChannel.toService((0,A.$Eh)(u.getChannel("watcher")))}}e.$_p=C}),define(se[92],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=void 0;class S{constructor(...s){this.a=new Map;for(const[M,C]of s)this.set(M,C)}set(s,M){const C=this.a.get(s);return this.a.set(s,M),C}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$Vh=S}),define(se[218],re([0,1,8,14,2,78,208,6,92,101]),function(J,e,S,A,s,M,C,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=void 0;const b=!1;class y extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class p{constructor(w=new d.$Vh,g=!1,h,a=b){this.f=w,this.g=g,this.h=h,this.i=a,this.o=new Set,this.f.set(P.$Wh,this),this._globalGraph=a?h?._globalGraph??new C.$kq(k=>k):void 0}createChild(w){return new p(w,this.g,this,this.i)}invokeFunction(w,...g){const h=v.traceInvocation(this.i,w);let a=!1;try{return w({get:f=>{if(a)throw(0,A.$7)("service accessor is only valid during the invocation of its target method");const i=this.m(f,h);if(!i)throw new Error(`[invokeFunction] unknown service '${f}'`);return i}},...g)}finally{a=!0,h.stop()}}createInstance(w,...g){let h,a;return w instanceof M.$Uh?(h=v.traceCreation(this.i,w.ctor),a=this.j(w.ctor,w.staticArguments.concat(g),h)):(h=v.traceCreation(this.i,w),a=this.j(w,g,h)),h.stop(),a}j(w,g=[],h){const a=P._util.getServiceDependencies(w).sort((i,o)=>i.index-o.index),k=[];for(const i of a){const o=this.m(i.id,h);o||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${i.id}.`,!1),k.push(o)}const f=a.length>0?a[0].index:g.length;if(g.length!==f){console.trace(`[createInstance] First service dependency of ${w.name} at position ${f+1} conflicts with ${g.length} static arguments`);const i=f-g.length;i>0?g=g.concat(new Array(i)):g=g.slice(0,f)}return Reflect.construct(w,g.concat(k))}k(w,g){if(this.f.get(w)instanceof M.$Uh)this.f.set(w,g);else if(this.h)this.h.k(w,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const g=this.f.get(w);return!g&&this.h?this.h.l(w):g}m(w,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const h=this.l(w);return h instanceof M.$Uh?this.q(w,h,g.branch(w,!0)):(g.branch(w,!1),h)}q(w,g,h){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,g,h)}finally{this.o.delete(w)}}r(w,g,h){const a=new C.$kq(i=>i.id.toString());let k=0;const f=[{id:w,desc:g,_trace:h}];for(;f.length;){const i=f.pop();if(a.lookupOrInsertNode(i),k++>1e3)throw new y(a);for(const o of P._util.getServiceDependencies(i.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),r instanceof M.$Uh){const t={id:o.id,desc:r,_trace:i._trace.branch(o.id,!0)};a.insertEdge(i,t),f.push(t)}}}for(;;){const i=a.roots();if(i.length===0){if(!a.isEmpty())throw new y(a);break}for(const{data:o}of i){if(this.l(o.id)instanceof M.$Uh){const t=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,t)}a.removeNode(o)}}return this.l(w)}s(w,g,h=[],a,k){if(this.f.get(w)instanceof M.$Uh)return this.t(w,g,h,a,k);if(this.h)return this.h.s(w,g,h,a,k);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t(w,g,h=[],a,k){if(a){const f=new p(void 0,this.g,this,this.i);f.c=String(w);const i=new Map,o=new S.$gh(()=>{const r=f.j(g,h,k);for(const[t,n]of i){const c=r[t];if(typeof c=="function")for(const m of n)c.apply(r,m)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,t){if(!o.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let m=i.get(t);return m||(m=new u.$2c,i.set(t,m)),(I,E,R)=>{const L=m.push([I,E,R]);return(0,s.$Pc)(L)}}if(t in r)return r[t];const n=o.value;let c=n[t];return typeof c!="function"||(c=c.bind(n),r[t]=c),c},set(r,t,n){return o.value[t]=n,!0},getPrototypeOf(r){return g.prototype}})}else return this.j(g,h,k)}u(w,g){if(g&&console.warn(w),this.g)throw new Error(w)}}e.$lq=p;var l;(function($){$[$.None=0]="None",$[$.Creation=1]="Creation",$[$.Invocation=2]="Invocation",$[$.Branch=3]="Branch"})(l||(l={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,g){return w?new v(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(w,g){return w?new v(1,g.name):v.c}static{this.f=0}constructor(w,g){this.type=w,this.name=g,this.g=Date.now(),this.h=[]}branch(w,g){const h=new v(3,w.toString());return this.h.push([w,g,h]),h}stop(){const w=Date.now()-this.g;v.f+=w;let g=!1;function h(k,f){const i=[],o=new Array(k+1).join("	");for(const[r,t,n]of f.h)if(t&&n){g=!0,i.push(`${o}CREATES -> ${r}`);const c=h(k+1,n);c&&i.push(c)}else i.push(`${o}uses -> ${r}`);return i.join(`
`)}const a=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(w>2||g)&&v.all.add(a.join(`
`))}}e.$mq=v}),define(se[219],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ayb=e.IssueType=void 0;var A;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(A||(e.IssueType=A={})),e.$ayb=(0,S.$Xh)("issueService")}),define(se[5],re([0,1,50,3,45,2,31,4,19,12,7,114,6]),function(J,e,S,A,s,M,C,P,d,u,b,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.log=e.$ij=e.LogLevel=e.$hj=e.$gj=e.$fj=void 0,e.$fj=(0,p.$Xh)("logService"),e.$gj=(0,p.$Xh)("loggerService");function l(){return new Date().toISOString()}function v(I){return(0,u.$Gf)(I)}e.$hj=v;var $;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})($||(e.LogLevel=$={})),e.$ij=$.Info;function w(I,E,R){switch(E){case $.Trace:I.trace(R);break;case $.Debug:I.debug(R);break;case $.Info:I.info(R);break;case $.Warning:I.warn(R);break;case $.Error:I.error(R);break;case $.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=w;function g(I,E=!1){let R="";for(let L=0;L<I.length;L++){let F=I[L];if(F instanceof Error&&(F=(0,S.$Ii)(F,E)),typeof F=="object")try{F=JSON.stringify(F)}catch{}R+=(L>0?" ":"")+F}return R}class h extends M.$Rc{constructor(){super(...arguments),this.b=e.$ij,this.c=this.B(new A.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==$.Off&&this.b<=E}}e.$kj=h;class a extends h{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...R){this.f($.Trace)&&this.g($.Trace,g([E,...R],!0))}debug(E,...R){this.f($.Debug)&&this.g($.Debug,g([E,...R]))}info(E,...R){this.f($.Info)&&this.g($.Info,g([E,...R]))}warn(E,...R){this.f($.Warning)&&this.g($.Warning,g([E,...R]))}error(E,...R){if(this.f($.Error))if(E instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=E.stack,this.g($.Error,g(L))}else this.g($.Error,g([E,...R]))}flush(){}}e.$lj=a;class k extends h{constructor(E=e.$ij){super(),this.setLevel(E),this.g=!P.$i}trace(E,...R){this.f($.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...R):console.log(`[main ${l()}]`,E,...R))}debug(E,...R){this.f($.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...R):console.log(`[main ${l()}]`,E,...R))}info(E,...R){this.f($.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...R):console.log(`[main ${l()}]`,E,...R))}warn(E,...R){this.f($.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,E,...R):console.warn(`[main ${l()}]`,E,...R))}error(E,...R){this.f($.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,E,...R):console.error(`[main ${l()}]`,E,...R))}dispose(){}flush(){}}e.$mj=k;class f extends h{constructor(E=e.$ij,R=!0){super(),this.g=R,this.setLevel(E)}trace(E,...R){this.f($.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...R):console.log(E,...R))}debug(E,...R){this.f($.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...R):console.log(E,...R))}info(E,...R){this.f($.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...R):console.log(E,...R))}warn(E,...R){this.f($.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...R):console.log(E,...R))}error(E,...R){this.f($.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...R):console.error(E,...R))}dispose(){}flush(){}}e.$nj=f;class i extends h{constructor(E,R=e.$ij){super(),this.g=E,this.setLevel(R)}trace(E,...R){this.f($.Trace)&&this.g.log($.Trace,[this.h(E),...R])}debug(E,...R){this.f($.Debug)&&this.g.log($.Debug,[this.h(E),...R])}info(E,...R){this.f($.Info)&&this.g.log($.Info,[this.h(E),...R])}warn(E,...R){this.f($.Warning)&&this.g.log($.Warning,[this.h(E),...R])}error(E,...R){this.f($.Error)&&this.g.log($.Error,[this.h(E),...R])}h(E){return typeof E=="string"?E:(0,S.$Ii)(E,this.f($.Trace))}dispose(){}flush(){}}e.$oj=i;class o extends h{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const R of this.g)R.setLevel(E);super.setLevel(E)}trace(E,...R){for(const L of this.g)L.trace(E,...R)}debug(E,...R){for(const L of this.g)L.debug(E,...R)}info(E,...R){for(const L of this.g)L.info(E,...R)}warn(E,...R){for(const L of this.g)L.warn(E,...R)}error(E,...R){for(const L of this.g)L.error(E,...R)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose()}}e.$pj=o;class r extends M.$Rc{constructor(E,R,L){if(super(),this.h=E,this.j=R,this.b=new C.$zc,this.c=this.B(new A.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$Rd),this.onDidChangeVisibility=this.g.event,L)for(const F of L)this.b.set(F.resource,{logger:void 0,info:F})}m(E){return(0,u.$Cf)(E)?[...this.b.values()].find(R=>R.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,R){const L=this.n(E),F=(0,u.$Cf)(E)?E:R?.id??(0,s.$Li)(L.toString()).toString(16);let U=this.b.get(L)?.logger;const x=R?.logLevel==="always"?$.Trace:R?.logLevel;U||(U=this.s(L,x??this.getLogLevel(L)??this.h,{...R,id:F}));const Y={logger:U,info:{resource:L,id:F,logLevel:x,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(Y.info),this.b.set(L,Y),U}n(E){return(0,u.$Cf)(E)?(0,d.$Bg)(this.j,`${E}.log`):E}setLogLevel(E,R){if(b.URI.isUri(E)){const L=E,F=R,U=this.b.get(L);U&&F!==U.info.logLevel&&(U.info.logLevel=F===this.h?void 0:F,U.logger?.setLevel(F),this.b.set(U.info.resource,U),this.f.fire([L,F]))}else{this.h=E;for(const[L,F]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,R){const L=this.m(E);L&&R!==!L.info.hidden&&(L.info.hidden=!R,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,R]))}getLogLevel(E){let R;return E&&(R=this.b.get(E)?.info.logLevel),R??this.h}registerLogger(E){const R=this.b.get(E.resource);R?R.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const R=this.b.get(E);R&&(R.logger&&R.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$qj=r;class t{constructor(){this.onDidChangeLogLevel=new A.$Rd().event}setLevel(E){}getLevel(){return $.Info}trace(E,...R){}debug(E,...R){}info(E,...R){}warn(E,...R){}error(E,...R){}critical(E,...R){}dispose(){}flush(){}}e.$rj=t;class n extends t{}e.$sj=n;function c(I){if(I.verbose)return $.Trace;if(typeof I.logLevel=="string"){const E=D(I.logLevel.toLowerCase());if(E!==void 0)return E}return e.$ij}e.$tj=c;function m(I){switch(I){case $.Trace:return"trace";case $.Debug:return"debug";case $.Info:return"info";case $.Warning:return"warn";case $.Error:return"error";case $.Off:return"off"}}e.$uj=m;function D(I){switch(I){case"trace":return $.Trace;case"debug":return $.Debug;case"info":return $.Info;case"warn":return $.Warning;case"error":return $.Error;case"critical":return $.Error;case"off":return $.Off}}e.$vj=D,e.$wj=new y.$cj("logLevel",m($.Info))});var te=this&&this.__param||function(J,e){return function(S,A){e(S,A,J)}};define(se[220],re([0,1,15,4,5]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W8b=void 0;const M=S.safeStorage;let C=class{constructor(d){this.a=d,S.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(d){this.a.trace("[EncryptionMainService] Encrypting value.");try{const u=JSON.stringify(M.encryptString(d));return this.a.trace("[EncryptionMainService] Encrypted value."),u}catch(u){throw this.a.error(u),u}}async decrypt(d){let u;try{if(u=JSON.parse(d),!u.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${d}`);const b=Buffer.from(u.data);this.a.trace("[EncryptionMainService] Decrypting value.");const y=M.decryptString(b);return this.a.trace("[EncryptionMainService] Decrypted value."),y}catch(b){throw this.a.error(b),b}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(A.$i)return Promise.resolve("dpapi");if(A.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const d=M.getSelectedStorageBackend();return Promise.resolve(d)}catch(d){this.a.error(d)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(A.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(A.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$W8b=C,e.$W8b=C=ve([te(0,s.$fj)],C)}),define(se[221],re([0,1,23,8,14,3,2,9,66,5]),function(J,e,S,A,s,M,C,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0;class b extends C.$Rc{constructor(p,l){super(),this.a=p,this.b=l,this.c=this.B(new M.$Rd),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$Rd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$Xg(0)),this.w=[],this.y=this.B(new A.$Xg(0))}watch(p,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(p,l):this.z(p,l)}n(p,l){const v={path:this.H(p),excludes:l.excludes,includes:l.includes,recursive:l.recursive,correlationId:l.correlationId},$=(0,S.$Tb)(this.j,v);return this.r(),(0,C.$Pc)(()=>{$(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,s.$Z)(p))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,d.$1p)(l)),l=>this.G(l),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const l of this.j)(0,d.$Wp)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const l of this.j)(0,d.$Wp)(l)&&p.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,l){const v={path:this.H(p),excludes:l.excludes,includes:l.includes,recursive:!1,correlationId:l.correlationId},$=(0,S.$Tb)(this.w,v);return this.C(),(0,C.$Pc)(()=>{$(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,s.$Z)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,d.$1p)(p)),p=>this.G(p),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,P.$gc)(p.fsPath)}}e.$5p=b}),define(se[222],re([0,1,23,8,18,22,3,45,71,2,57,13,67,19,62,175,16,118,5,14]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w,g,h,a){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=void 0;let f=class extends u.$Rc{static{k=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new C.$Rd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$Rd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$Rd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$Rd),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$Rd),this.Y=this.B(new C.$Rd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new C.$Rd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$9g)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${o}`);const t=new u.$Qc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),t.add(r.onDidChangeFile(n=>{const c=new w.$zk(n,!this.S(r));this.X.fire(c),c.hasCorrelation()||this.Y.fire(c)})),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,u.$Pc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,u.$Mc)(t)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(t){r.push(t)}}),!this.h.has(o)&&await A.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const t=this.h.get(o.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return d.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,l.$Fg)(o))throw new w.$Bk((0,$.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const t=new a.$ab;throw t.message=(0,$.localize)(1,null,o.toString()),t}return r}async m(o){const r=await this.j(o);if((0,w.$mk)(r)||(0,w.$jk)(r)||(0,w.$nk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,w.$mk)(r)||(0,w.$jk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(t){throw(0,w.$wk)(t)===w.FileSystemProviderErrorCode.FileNotFound?new w.$Bk((0,$.localize)(2,null,this.sb(o)),1):(0,w.$uk)(t)}}async s(o,r){const t=await this.j(o),n=this.S(t),c=r?.resolveTo,m=r?.resolveSingleChildDescendants,D=r?.resolveMetadata,I=await t.stat(o);let E;return this.t(t,o,I,void 0,!!D,(R,L)=>(E||(E=b.$4h.forUris(()=>!n),E.set(o,!0),c&&E.fill(!0,c)),E.get(R.resource)||E.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&m?L===1:!1))}async t(o,r,t,n,c,m){const{providerExtUri:D}=this.R(o),I={resource:r,name:D.basename(r),isFile:(t.type&w.FileType.File)!==0,isDirectory:(t.type&w.FileType.Directory)!==0,isSymbolicLink:(t.type&w.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&w.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((t.permissions??0)&w.FilePermission.Locked),etag:(0,w.$Mk)({mtime:t.mtime,size:t.size}),children:void 0};if(I.isDirectory&&m(I,n)){try{const E=await o.readdir(r),R=await A.Promises.settled(E.map(async([L,F])=>{try{const U=D.joinPath(r,L),x=c?await o.stat(U):{type:F};return await this.t(o,U,x,E.length,c,m)}catch(U){return this.b.trace(U),null}}));I.children=(0,S.$Gb)(R)}catch(E){this.b.trace(E),I.children=[]}return I}return I}async resolveAll(o){return A.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),t=await r.stat(o);return this.t(r,o,t,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(t){return t}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new w.$Bk((0,$.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=s.$fe.fromString(""),t){await this.u(o,t);const n=await this.writeFile(o,r);return this.r.fire(new w.$yk(o,0,n)),n}async writeFile(o,r,t){const n=this.qb(await this.n(o),o),{providerExtUri:c}=this.R(n);let m=t;if((0,w.$pk)(n)&&!m?.atomic){const D=n.enforceAtomicWriteFile?.(o);D&&(m={...t,atomic:D})}try{await this.w(n,o,m)||await this.U(n,c.dirname(o));let I;if((0,w.$jk)(n)&&!(r instanceof s.$fe))if((0,v.$4d)(r)){const E=await(0,v.$$d)(r,3);E.ended?I=s.$fe.concat(E.buffer):I=E}else I=(0,v.$8d)(r,E=>s.$fe.concat(E),3);else I=r;!(0,w.$mk)(n)||(0,w.$jk)(n)&&I instanceof s.$fe||(0,w.$jk)(n)&&(0,w.$pk)(n)&&m?.atomic?await this.hb(n,o,m,I):await this.db(n,o,m,I instanceof s.$fe?(0,s.$qe)(I):I),this.r.fire(new w.$yk(o,4))}catch(D){throw new w.$Bk((0,$.localize)(4,null,this.sb(o),(0,w.$uk)(D).toString()),(0,w.$xk)(D),m)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,t){const n=!!t?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,$.localize)(5,null,this.sb(r)));if(!!t?.atomic){if(!(o.capabilities&32768))throw new Error((0,$.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,$.localize)(7,null,this.sb(r)));if(n)throw new Error((0,$.localize)(8,null,this.sb(r)))}let m;try{m=await o.stat(r)}catch{return}if(m.type&w.FileType.Directory)throw new w.$Bk((0,$.localize)(9,null,this.sb(r)),0,t);if(this.rb(r,m),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==w.$Lk&&typeof m.mtime=="number"&&typeof m.size=="number"&&t.mtime<m.mtime&&t.etag!==(0,w.$Mk)({mtime:t.mtime,size:m.size}))throw new w.$Bk((0,$.localize)(10,null),3,t);return m}async readFile(o,r,t){const n=await this.m(o);return r?.atomic?this.z(n,o,r,t):this.C(n,o,r,t)}async z(o,r,t,n){return new Promise((c,m)=>{this.cb.queueFor(r,this.R(o).providerExtUri).queue(async()=>{try{const D=await this.C(o,r,t,n);c(D)}catch(D){m(D)}})})}async C(o,r,t,n){const c=await this.D(o,r,{...t,preferUnbuffered:!0},n);return{...c,value:await(0,s.$re)(c.value)}}async readFileStream(o,r,t){const n=await this.m(o);return this.D(n,o,r,t)}async D(o,r,t,n){const c=new M.$2d(n);let m=t;(0,w.$ok)(o)&&o.enforceAtomicReadFile?.(r)&&(m={...t,atomic:!0});const D=this.J(r,m).then(E=>E,E=>{throw c.dispose(!0),E});let I;try{return typeof m?.etag=="string"&&m.etag!==w.$Lk&&await D,m?.atomic&&(0,w.$ok)(o)||!((0,w.$mk)(o)||(0,w.$nk)(o))||(0,w.$jk)(o)&&m?.preferUnbuffered?I=this.I(o,r,m):(0,w.$nk)(o)?I=this.G(o,r,c.token,m):I=this.H(o,r,c.token,m),I.on("end",()=>c.dispose()),I.on("error",()=>c.dispose()),{...await D,value:I}}catch(E){throw I&&await(0,v.$9d)(I),this.F(E,r,m)}}F(o,r,t){const n=(0,$.localize)(11,null,this.sb(r),(0,w.$uk)(o).toString());return o instanceof w.$Dk?new w.$Dk(n,o.stat,t):o instanceof w.$Ck?new w.$Ck(n,o.fileOperationResult,o.size,o.options):new w.$Bk(n,(0,w.$xk)(o),t)}G(o,r,t,n=Object.create(null)){const c=o.readFileStream(r,n,t);return(0,v.$ce)(c,{data:m=>m instanceof s.$fe?m:s.$fe.wrap(m),error:m=>this.F(m,r,n)},m=>s.$fe.concat(m))}H(o,r,t,n=Object.create(null)){const c=(0,s.$ve)();return(0,g.$Up)(o,r,c,m=>m,{...n,bufferSize:this.a,errorTransformer:m=>this.F(m,r,n)},t),c}I(o,r,t){const n=(0,v.$6d)(c=>s.$fe.concat(c));return(async()=>{try{let c;t?.atomic&&(0,w.$ok)(o)?c=await o.readFile(r,{atomic:!0}):c=await o.readFile(r),typeof t?.position=="number"&&(c=c.slice(t.position)),typeof t?.length=="number"&&(c=c.slice(0,t.length)),this.L(r,c.byteLength,t),n.end(s.$fe.wrap(c))}catch(c){n.error(c),n.end()}})(),n}async J(o,r){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new w.$Bk((0,$.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==w.$Lk&&r.etag===t.etag)throw new w.$Dk((0,$.localize)(13,null),t,r);return this.L(o,t.size,r),t}L(o,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new w.$Ck((0,$.localize)(14,null,this.sb(o)),7,r,t)}async canMove(o,r,t){return this.M(o,r,"move",t)}async canCopy(o,r,t){return this.M(o,r,"copy",t)}async M(o,r,t,n){if(o.toString()!==r.toString())try{const c=t==="move"?this.qb(await this.n(o),o):await this.m(o),m=this.qb(await this.n(r),r);await this.Q(c,o,m,r,t,n)}catch(c){return c}return!0}async move(o,r,t){const n=this.qb(await this.n(o),o),c=this.qb(await this.n(r),r),m=await this.N(n,o,c,r,"move",!!t),D=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new w.$yk(o,m==="move"?2:3,D)),D}async copy(o,r,t){const n=await this.m(o),c=this.qb(await this.n(r),r),m=await this.N(n,o,c,r,"copy",!!t),D=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new w.$yk(o,m==="copy"?3:2,D)),D}async N(o,r,t,n,c,m){if(r.toString()===n.toString())return c;const{exists:D,isSameResourceWithDifferentPathCase:I}=await this.Q(o,r,t,n,c,m);if(D&&!I&&m&&await this.del(n,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(n)),c==="copy"){if(o===t&&(0,w.$kk)(o))await o.copy(r,n,{overwrite:m});else{const E=await this.resolve(r);E.isDirectory?await this.P(o,E,t,n):await this.O(o,r,t,n)}return c}else return o===t?(await o.rename(r,n,{overwrite:m}),c):(await this.N(o,r,t,n,"copy",m),await this.del(r,{recursive:!0}),"copy")}async O(o,r,t,n){if((0,w.$mk)(o)&&(0,w.$mk)(t))return this.jb(o,r,t,n);if((0,w.$mk)(o)&&(0,w.$jk)(t))return this.pb(o,r,t,n);if((0,w.$jk)(o)&&(0,w.$mk)(t))return this.nb(o,r,t,n);if((0,w.$jk)(o)&&(0,w.$jk)(t))return this.lb(o,r,t,n)}async P(o,r,t,n){await t.mkdir(n),Array.isArray(r.children)&&await A.Promises.settled(r.children.map(async c=>{const m=this.R(t).providerExtUri.joinPath(n,c.name);return c.isDirectory?this.P(o,await this.resolve(c.resource),t,m):this.O(o,c.resource,t,m)}))}async Q(o,r,t,n,c,m){let D=!1;if(o===t){const{providerExtUri:E,isPathCaseSensitive:R}=this.R(o);if(R||(D=E.isEqual(r,n)),D&&c==="copy")throw new Error((0,$.localize)(15,null,this.sb(r),this.sb(n)));if(!D&&E.isEqualOrParent(n,r))throw new Error((0,$.localize)(16,null,this.sb(r),this.sb(n)))}const I=await this.exists(n);if(I&&!D){if(!m)throw new w.$Bk((0,$.localize)(17,null,this.sb(r),this.sb(n)),4);if(o===t){const{providerExtUri:E}=this.R(o);if(E.isEqualOrParent(r,n))throw new Error((0,$.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:I,isSameResourceWithDifferentPathCase:D}}R(o){const r=this.S(o);return{providerExtUri:r?l.$rg:l.$tg,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const t=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new w.$yk(o,0,t)),t}async U(o,r){const t=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await o.stat(r)).type&w.FileType.Directory))throw new Error((0,$.localize)(19,null,this.sb(r)));break}catch(c){if((0,w.$wk)(c)!==w.FileSystemProviderErrorCode.FileNotFound)throw c;t.push(n.basename(r)),r=n.dirname(r)}for(let c=t.length-1;c>=0;c--){r=n.joinPath(r,t[c]);try{await o.mkdir(r)}catch(m){if((0,w.$wk)(m)!==w.FileSystemProviderErrorCode.FileExists)throw m}}}async canDelete(o,r){try{await this.W(o,r)}catch(t){return t}return!0}async W(o,r){const t=this.qb(await this.j(o),o),n=!!r?.useTrash;if(n&&!(t.capabilities&4096))throw new Error((0,$.localize)(20,null,this.sb(o)));const c=r?.atomic;if(c&&!(t.capabilities&65536))throw new Error((0,$.localize)(21,null,this.sb(o)));if(n&&c)throw new Error((0,$.localize)(22,null,this.sb(o)));let m;try{m=await t.stat(o)}catch{}if(m)this.rb(o,m);else throw new w.$Bk((0,$.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const I=await this.resolve(o);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,$.localize)(24,null,this.sb(o)))}return t}async del(o,r){const t=await this.W(o,r);let n=r;if((0,w.$qk)(t)&&!n?.atomic){const I=t.enforceAtomicDelete?.(o);I&&(n={...r,atomic:I})}const c=!!n?.useTrash,m=!!n?.recursive,D=n?.atomic??!1;await t.delete(o,{recursive:m,useTrash:c,atomic:D}),this.r.fire(new w.$yk(o,1))}async cloneFile(o,r){const t=await this.j(o),n=this.qb(await this.n(r),r);if(t===n&&this.R(t).providerExtUri.isEqual(o,r))return;if(t===n&&(0,w.$lk)(t))return t.cloneFile(o,r);await this.U(n,this.R(n).providerExtUri.dirname(r));const c=this.cb.queueFor(o,this.R(t).providerExtUri);return t===n&&(0,w.$kk)(t)?c.queue(()=>t.copy(o,r,{overwrite:!0})):c.queue(()=>this.O(t,o,n,r))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:k.ab++})}watch(o,r={recursive:!1,excludes:[]}){const t=new u.$Qc;let n=!1,c=()=>{n=!0};t.add((0,u.$Pc)(()=>c())),(async()=>{try{const D=await this.bb(o,r);n?(0,u.$Mc)(D):c=()=>(0,u.$Mc)(D)}catch(D){this.b.error(D)}})();const m=r.correlationId;if(typeof m=="number"){const D=t.add(new C.$Rd);return t.add(this.X.event(E=>{E.correlates(m)&&D.fire(E)})),{onDidChange:D.event,dispose:()=>t.dispose()}}return t}async bb(o,r){const t=await this.j(o),n=(0,P.$Li)([this.R(t).providerExtUri.getComparisonKey(o),r]);let c=this.$.get(n);return c||(c={count:0,disposable:t.watch(o,r)},this.$.set(n,c)),c.count+=1,(0,u.$Pc)(()=>{c&&(c.count--,c.count===0&&((0,u.$Mc)(c.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,u.$Mc)(o.disposable);this.$.clear()}async db(o,r,t,n){return this.cb.queueFor(r,this.R(o).providerExtUri).queue(async()=>{const c=await o.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,v.$4d)(n)||(0,v.$5d)(n)?await this.eb(o,c,n):await this.fb(o,c,n)}catch(m){throw(0,w.$uk)(m)}finally{await o.close(c)}})}async eb(o,r,t){let n=0,c;if((0,v.$5d)(t)){if(t.buffer.length>0){const m=s.$fe.concat(t.buffer);await this.gb(o,r,m,m.byteLength,n,0),n+=m.byteLength}if(t.ended)return;c=t.stream}else c=t;return new Promise((m,D)=>{(0,v.$0d)(c,{onData:async I=>{c.pause();try{await this.gb(o,r,I,I.byteLength,n,0)}catch(E){return D(E)}n+=I.byteLength,setTimeout(()=>c.resume())},onError:I=>D(I),onEnd:()=>m()})})}async fb(o,r,t){let n=0,c;for(;(c=t.read())!==null;)await this.gb(o,r,c,c.byteLength,n,0),n+=c.byteLength}async gb(o,r,t,n,c,m){let D=0;for(;D<n;){const I=await o.write(r,c+D,t.buffer,m+D,n-D);D+=I}}async hb(o,r,t,n){return this.cb.queueFor(r,this.R(o).providerExtUri).queue(()=>this.ib(o,r,t,n))}async ib(o,r,t,n){let c;n instanceof s.$fe?c=n:(0,v.$4d)(n)?c=await(0,s.$re)(n):(0,v.$5d)(n)?c=await(0,s.$se)(n):c=(0,s.$pe)(n),await o.writeFile(r,c.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.kb(o,r,t,n))}async kb(o,r,t,n){let c,m;try{c=await o.open(r,{create:!1}),m=await t.open(n,{create:!0,unlock:!1});const D=s.$fe.alloc(this.a);let I=0,E=0,R=0;do R=await o.read(c,I,D.buffer,E,D.byteLength-E),await this.gb(t,m,D,R,I,E),I+=R,E+=R,E===D.byteLength&&(E=0);while(R>0)}catch(D){throw(0,w.$uk)(D)}finally{await A.Promises.settled([typeof c=="number"?o.close(c):Promise.resolve(),typeof m=="number"?t.close(m):Promise.resolve()])}}async lb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.mb(o,r,t,n))}async mb(o,r,t,n){return t.writeFile(n,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.ob(o,r,t,n))}async ob(o,r,t,n){const c=await t.open(n,{create:!0,unlock:!1});try{const m=await o.readFile(r);await this.gb(t,c,s.$fe.wrap(m),m.byteLength,0,0)}catch(m){throw(0,w.$uk)(m)}finally{await t.close(c)}}async pb(o,r,t,n){const c=await(0,s.$re)(this.H(o,r,M.CancellationToken.None));await this.hb(t,n,void 0,c)}qb(o,r){if(o.capabilities&2048)throw new w.$Bk((0,$.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&w.FilePermission.Readonly)throw new w.$Bk((0,$.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===y.Schemas.file?o.fsPath:o.toString(!0)}};e.$Vp=f,e.$Vp=f=k=ve([te(0,h.$fj)],f)}),define(se[93],re([0,1,46,311,8,31,18,3,33,2,9,4,19,62,21,179,16,118,221,50,217,216]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w,g,h,a,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=void 0,(()=>{try{(0,A.gracefulify)(S)}catch(o){console.error(`Error enabling graceful-fs: ${(0,a.$Ii)(o)}`)}})();class i extends h.$5p{static{this.I=!1}constructor(r,t){super(r,t),this.onDidChangeCapabilities=P.Event.None,this.N=new M.$zc(n=>p.$sg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,y.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:t,symbolicLink:n}=await v.SymlinkSupport.stat(this.H(r));return{type:this.M(t,n),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:w.FilePermission.Locked}}catch(t){throw this.fb(t)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const t=await v.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(t.map(async c=>{try{let m;c.isSymbolicLink()?m=(await this.stat((0,p.$Bg)(r,c.name))).type:m=this.M(c),n.push([c.name,m])}catch(m){this.a.trace(m)}})),n}catch(t){throw this.fb(t)}}M(r,t){let n;return t?.dangling?n=w.FileType.Unknown:r.isFile()?n=w.FileType.File:r.isDirectory()?n=w.FileType.Directory:n=w.FileType.Unknown,t&&(n|=w.FileType.SymbolicLink),n}async O(r){const t=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await n.wait();const c=new s.$Yg;return this.N.set(r,c),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,u.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.N.get(r)===c&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),c.open()})}async readFile(r,t){let n;try{t?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const c=this.H(r);return await v.Promises.readFile(c)}catch(c){throw this.fb(c)}finally{n?.dispose()}}P(r){i.I&&this.a.trace(r)}readFileStream(r,t,n){const c=(0,l.$6d)(m=>C.$fe.concat(m.map(D=>C.$fe.wrap(D))).buffer);return(0,g.$Up)(this,r,c,m=>m.buffer,{...t,bufferSize:256*1024},n),c}async writeFile(r,t,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,p.$Bg)((0,p.$Ag)(r),`${(0,p.$yg)(r)}${n.atomic.postfix}`),t,n):this.S(r,t,n)}async Q(r){try{const t=this.H(r),{symbolicLink:n}=await v.SymlinkSupport.stat(t);if(n)return!1}catch{}return!0}async R(r,t,n,c){const m=new u.$Qc;try{m.add(await this.O(r)),m.add(await this.O(t)),await this.S(t,n,c,!0);try{await this.rename(t,r,{overwrite:!0})}catch(D){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{m.dispose()}}async S(r,t,n,c){let m;try{const D=this.H(r);if(!n.create||!n.overwrite){if(await v.Promises.exists(D)){if(!n.overwrite)throw(0,w.$tk)((0,$.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,w.$tk)((0,$.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}m=await this.open(r,{create:!0,unlock:n.unlock},c),await this.write(m,0,t,0,t.byteLength)}catch(D){throw await this.gb(r,D)}finally{typeof m=="number"&&await this.close(m)}}static{this.Y=!0}static configureFlushOnWrite(r){i.Y=r}async open(r,t,n){const c=this.H(r);let m;(0,w.$hk)(t)&&!n&&(m=await this.O(r));let D;try{if((0,w.$hk)(t)&&t.unlock)try{const{stat:E}=await v.SymlinkSupport.stat(c);E.mode&128||await v.Promises.chmod(c,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let I;if((0,w.$hk)(t)){if(y.$i)try{await v.Promises.truncate(c,0),I="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}I||(I="w")}else I="r";D=await v.Promises.open(c,I)}catch(I){throw m?.dispose(),(0,w.$hk)(t)?await this.gb(r,I):this.fb(I)}if(this.U.set(D,0),(0,w.$hk)(t)&&this.X.set(D,r),m){const I=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${c})`),this.W.set(D,m),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${c})`),I.dispose())}return D}async close(r){const t=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&i.Y)try{await v.Promises.fdatasync(r)}catch(n){i.configureFlushOnWrite(!1),this.a.error(n)}return await v.Promises.close(r)}catch(n){throw this.fb(n)}finally{t&&(this.W.get(r)===t&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),t.dispose())}}async read(r,t,n,c,m){const D=this.Z(r,t);let I=null;try{I=(await v.Promises.read(r,n,c,m,D)).bytesRead}catch(E){throw this.fb(E)}finally{this.$(r,D,I)}return I}Z(r,t){return t===this.U.get(r)?null:t}$(r,t,n){const c=this.U.get(r);typeof c=="number"&&(typeof t=="number"||(typeof n=="number"?this.U.set(r,c+n):this.U.delete(r)))}async write(r,t,n,c,m){return(0,s.$hh)(()=>this.ab(r,t,n,c,m),100,3)}async ab(r,t,n,c,m){const D=this.Z(r,t);let I=null;try{I=(await v.Promises.write(r,n,c,m,D)).bytesWritten}catch(E){throw await this.gb(this.X.get(r),E)}finally{this.$(r,D,I)}return I}async mkdir(r){try{await v.Promises.mkdir(this.H(r))}catch(t){throw this.fb(t)}}async delete(r,t){try{const n=this.H(r);if(t.recursive){let c;t?.atomic!==!1&&t.atomic.postfix&&(c=(0,b.$ic)((0,b.$lc)(n),`${(0,b.$mc)(n)}${t.atomic.postfix}`)),await v.Promises.rm(n,v.RimRafMode.MOVE,c)}else try{await v.Promises.unlink(n)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let m=!1;try{const{stat:D,symbolicLink:I}=await v.SymlinkSupport.stat(n);m=D.isDirectory()&&!I}catch{}if(m)await v.Promises.rmdir(n);else throw c}else throw c}}catch(n){throw this.fb(n)}}async rename(r,t,n){const c=this.H(r),m=this.H(t);if(c!==m)try{await this.bb(r,t,"move",n.overwrite),await v.Promises.rename(c,m)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,$.localize)(2,null,(0,b.$mc)(c),(0,b.$mc)((0,b.$lc)(m)),D.toString()))),this.fb(D)}}async copy(r,t,n){const c=this.H(r),m=this.H(t);if(c!==m)try{await this.bb(r,t,"copy",n.overwrite),await v.Promises.copy(c,m,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,$.localize)(3,null,(0,b.$mc)(c),(0,b.$mc)((0,b.$lc)(m)),D.toString()))),this.fb(D)}}async bb(r,t,n,c){const m=this.H(r),D=this.H(t);let I=!1;if(!!(this.capabilities&1024)||(I=(0,d.$1f)(m,D,!0)),I){if(n==="copy")throw(0,w.$tk)((0,$.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const R=await this.L(r);if(!R)throw(0,w.$tk)((0,$.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(t);if(L){if(!c)throw(0,w.$tk)((0,$.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);R.type&w.FileType.File&&L.type&w.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,t){return this.cb(r,t,!1)}async cb(r,t,n){const c=this.H(r),m=this.H(t),D=!!(this.capabilities&1024);if((0,d.$1f)(c,m,!D))return;const I=new u.$Qc;try{I.add(await this.O(r)),I.add(await this.O(t)),n&&await v.Promises.mkdir((0,b.$lc)(m),{recursive:!0}),await v.Promises.copyFile(c,m)}catch(E){if(E.code==="ENOENT"&&!n)return this.cb(r,t,!0);throw this.fb(E)}finally{I.dispose()}}t(r,t,n){return new k.$_p(c=>r(c),c=>t(c),n)}F(r,t,n){return new f.$hq(c=>r(c),c=>t(c),n)}fb(r){if(r instanceof w.$sk)return r;let t=r,n;switch(r.code){case"ENOENT":n=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=w.FileSystemProviderErrorCode.Unknown;break;default:n=w.FileSystemProviderErrorCode.Unknown}return(0,w.$tk)(t,n)}async gb(r,t){let n=this.fb(t);if(r&&n.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await v.SymlinkSupport.stat(this.H(r));c.mode&128||(n=(0,w.$tk)(t,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return n}}e.$iq=i}),define(se[223],re([0,1,3,93,2,18,62,22]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=void 0;class d extends s.$Rc{constructor(y,p){super(),this.a=y,this.b=p,this.F=new Map,this.G=new Map}call(y,p,l){const v=this.c(y);switch(p){case"stat":return this.g(v,l[0]);case"readdir":return this.h(v,l[0]);case"open":return this.r(v,l[0],l[1]);case"close":return this.s(l[0]);case"read":return this.t(l[0],l[1],l[2]);case"readFile":return this.j(v,l[0],l[1]);case"write":return this.u(l[0],l[1],l[2],l[3],l[4]);case"writeFile":return this.n(v,l[0],l[1],l[2]);case"rename":return this.z(v,l[0],l[1],l[2]);case"copy":return this.C(v,l[0],l[1],l[2]);case"cloneFile":return this.D(v,l[0],l[1]);case"mkdir":return this.w(v,l[0]);case"delete":return this.y(v,l[0],l[1]);case"watch":return this.I(v,l[0],l[1],l[2],l[3]);case"unwatch":return this.J(l[0],l[1])}throw new Error(`IPC Command ${p} not found`)}listen(y,p,l){const v=this.c(y);switch(p){case"fileChange":return this.H(v,l[0]);case"readFileStream":return this.m(v,l[0],l[1])}throw new Error(`Unknown event ${p}`)}g(y,p){const l=this.f(y,p,!0);return this.a.stat(l)}h(y,p){const l=this.f(y,p);return this.a.readdir(l)}async j(y,p,l){const v=this.f(y,p,!0),$=await this.a.readFile(v,l);return M.$fe.wrap($)}m(y,p,l){const v=this.f(y,p,!0),$=new P.$2d,w=new S.$Rd({onDidRemoveLastListener:()=>{$.cancel()}}),g=this.a.readFileStream(v,l,$.token);return(0,C.$0d)(g,{onData:h=>w.fire(M.$fe.wrap(h)),onError:h=>w.fire(h),onEnd:()=>{w.fire("end"),w.dispose(),$.dispose()}}),w.event}n(y,p,l,v){const $=this.f(y,p);return this.a.writeFile($,l.buffer,v)}r(y,p,l){const v=this.f(y,p,!0);return this.a.open(v,l)}s(y){return this.a.close(y)}async t(y,p,l){const v=M.$fe.alloc(l),$=0,w=await this.a.read(y,p,v.buffer,$,l);return[v,w]}u(y,p,l,v,$){return this.a.write(y,p,l.buffer,v,$)}w(y,p){const l=this.f(y,p);return this.a.mkdir(l)}y(y,p,l){const v=this.f(y,p);return this.a.delete(v,l)}z(y,p,l,v){const $=this.f(y,p),w=this.f(y,l);return this.a.rename($,w,v)}C(y,p,l,v){const $=this.f(y,p),w=this.f(y,l);return this.a.copy($,w,v)}D(y,p,l){const v=this.f(y,p),$=this.f(y,l);return this.a.cloneFile(v,$)}H(y,p){const l=new S.$Rd({onWillAddFirstListener:()=>{this.F.set(p,this.L(y,l))},onDidRemoveLastListener:()=>{(0,s.$Mc)(this.F.get(p)),this.F.delete(p)}});return l.event}async I(y,p,l,v,$){const w=this.F.get(p);if(w){const g=this.f(y,v),h=w.watch(l,g,$);this.G.set(p+l,h)}}async J(y,p){const l=y+p,v=this.G.get(l);v&&((0,s.$Mc)(v),this.G.delete(l))}dispose(){super.dispose();for(const[,y]of this.G)y.dispose();this.G.clear();for(const[,y]of this.F)y.dispose();this.F.clear()}}e.$Qr=d;class u extends s.$Rc{constructor(y,p,l,v){super(),this.c=y,this.f=l,this.g=v,this.a=new Map,this.b=this.B(new A.$iq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(p)}h(y){const p=this.B(new S.$Rd);this.B(p.event(l=>{y.fire(l.map(v=>({resource:this.c.transformOutgoingURI(v.resource),type:v.type,cId:v.cId})))})),this.B(this.b.onDidChangeFile(l=>p.fire(l))),this.B(this.b.onDidWatchError(l=>y.fire(l)))}j(y){}m(y){}watch(y,p,l){const v=this.m(this.g);return Array.isArray(v)&&(l.excludes=[...l.excludes,...v]),this.a.set(y,this.b.watch(p,l)),(0,s.$Pc)(()=>{(0,s.$Mc)(this.a.get(y)),this.a.delete(y)})}dispose(){for(const[,y]of this.a)y.dispose();this.a.clear(),super.dispose()}}e.$Rr=u}),define(se[224],re([0,1,15,178,4,7,16,9,223,155]),function(J,e,S,A,s,M,C,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$58b=void 0;class b extends d.$Qr{constructor(l,v,$){super(l,v),this.M=$}c(l){return u.$Um}f(l,v){return M.URI.revive(v)}async y(l,v,$){if(!$.useTrash)return super.y(l,v,$);const w=this.f(l,v),g=(0,P.$gc)(w.fsPath);try{await S.shell.trashItem(g)}catch{throw(0,C.$tk)(s.$i?(0,A.localize)(0,null,(0,P.$mc)(g)):(0,A.localize)(1,null,(0,P.$mc)(g)),C.FileSystemProviderErrorCode.Unknown)}}L(l,v){return new y(l,v,this.b,this.M)}}e.$58b=b;class y extends d.$Rr{watch(l,v,$){if($.recursive)throw(0,C.$tk)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch(l,v,$)}}}),define(se[225],re([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q5b=void 0;class A extends S.$lj{constructor(M=S.$ij){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(C=>{this.n?.setLevel(C)}))}set logger(M){this.n=M;for(const{level:C,message:P}of this.m)(0,S.log)(M,C,P);this.m=[]}g(M,C){this.n?(0,S.log)(this.n,M,C):this.getLevel()<=M&&this.m.push({level:M,message:C})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$Q5b=A}),define(se[226],re([0,1,7,3,5,2]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=e.$gr=void 0;class C extends s.$qj{constructor(y,p,l,v,$){super(p,l,v),this.r=y,this.t=$,this.B($.listen("onDidChangeLogLevel",y)(w=>{(0,s.$hj)(w)?super.setLogLevel(w):super.setLogLevel(S.URI.revive(w[0]),w[1])})),this.B($.listen("onDidChangeVisibility",y)(([w,g])=>super.setVisibility(S.URI.revive(w),g))),this.B($.listen("onDidChangeLoggers",y)(({added:w,removed:g})=>{for(const h of w)super.registerLogger({...h,resource:S.URI.revive(h.resource)});for(const h of g)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new s.$oj({log:(y,p)=>{this.t.call("consoleLog",[y,p])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,p){super.setLogLevel(y,p),this.t.call("setLogLevel",[y,p])}setVisibility(y,p){super.setVisibility(y,p),this.t.call("setVisibility",[this.n(y),p])}s(y,p,l){return new P(this.t,y,p,l,this.r)}static setLogLevel(y,p,l){return y.call("setLogLevel",[p,l])}}e.$gr=C;class P extends s.$lj{constructor(y,p,l,v,$){super(v?.logLevel==="always"),this.r=y,this.s=p,this.m=!1,this.n=[],this.setLevel(l),this.r.call("createLogger",[p,v,$]).then(()=>{this.u(this.n),this.m=!0})}g(y,p){const l=[[y,p]];this.m?this.u(l):this.n.push(...l)}u(y){this.r.call("log",[this.s,y])}}class d{constructor(y,p){this.a=y,this.b=p}listen(y,p){const l=this.b(y);switch(p){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,v=>({added:[...v.added].map($=>this.c($,l)),removed:[...v.removed].map($=>this.c($,l))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,v=>[l.transformOutgoingURI(v[0]),v[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,v=>(0,s.$hj)(v)?v:[l.transformOutgoingURI(v[0]),v[1]])}throw new Error(`Event not found: ${p}`)}async call(y,p,l){const v=this.b(y);switch(p){case"setLogLevel":return(0,s.$hj)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(S.URI.revive(v.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map($=>this.c($,v)))}throw new Error(`Call not found: ${p}`)}c(y,p){return{...y,resource:p.transformOutgoingURI(y.resource)}}}e.$hr=d;class u extends M.$Rc{constructor(y,p){super(),p.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(l=>p.call("setLogLevel",[l]))),p.call("getRegisteredLoggers").then(l=>{for(const v of l)y.registerLogger({...v,resource:S.URI.revive(v.resource)})}),this.B(p.listen("onDidChangeVisibility")(([l,v])=>y.setVisibility(S.URI.revive(l),v))),this.B(p.listen("onDidChangeLoggers")(({added:l,removed:v})=>{for(const $ of l)y.registerLogger({...$,resource:S.URI.revive($.resource)});for(const $ of v)y.deregisterLogger($.resource)}))}}e.$ir=u}),define(se[227],re([0,1,2,5]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YN=void 0;class s extends S.$Rc{constructor(C,P=[]){super(),this.a=new A.$pj([C,...P]),this.B(C.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...P){this.a.trace(C,...P)}debug(C,...P){this.a.debug(C,...P)}info(C,...P){this.a.info(C,...P)}warn(C,...P){this.a.warn(C,...P)}error(C,...P){this.a.error(C,...P)}flush(){this.a.flush()}}e.$YN=s}),define(se[228],re([0,1,31,7,5]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y9b=void 0;class M{constructor(P){this.b=P,this.a=new S.$zc}listen(P,d,u){switch(d){case"onDidChangeLoggers":return u?this.b.getOnDidChangeLoggersEvent(u):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return u?this.b.getOnDidChangeLogLevelEvent(u):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return u?this.b.getOnDidChangeVisibilityEvent(u):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${d}`)}async call(P,d,u){switch(d){case"createLogger":this.c(A.URI.revive(u[0]),u[1],u[2]);return;case"log":return this.e(A.URI.revive(u[0]),u[1]);case"consoleLog":return this.d(u[0],u[1]);case"setLogLevel":return(0,s.$hj)(u[0])?this.b.setLogLevel(u[0]):this.b.setLogLevel(A.URI.revive(u[0]),u[1]);case"setVisibility":return this.b.setVisibility(A.URI.revive(u[0]),u[1]);case"registerLogger":return this.b.registerLogger({...u[0],resource:A.URI.revive(u[0].resource)},u[1]);case"deregisterLogger":return this.b.deregisterLogger(A.URI.revive(u[0]))}throw new Error(`Call not found: ${d}`)}c(P,d,u){this.a.set(P,this.b.createLogger(P,d,u))}d(P,d){let u=console.log;switch(P){case s.LogLevel.Error:u=console.error;break;case s.LogLevel.Warning:u=console.warn;break;case s.LogLevel.Info:u=console.info;break}u.call(console,...d)}e(P,d){const u=this.a.get(P);if(!u)throw new Error("Create the logger before logging");for(const[b,y]of d)(0,s.log)(u,b,y)}}e.$Y9b=M}),define(se[229],re([0,1,16,5]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=void 0;var s;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(s||(s={}));async function M(u,b,y,p,l){try{const v=await new Promise((w,g)=>{J(["@vscode/spdlog"],w,g)});v.setFlushOn(s.Trace);const $=await v.createAsyncRotatingLogger(u,b,y,p);return l?$.clearFormatters():$.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),$}catch(v){console.error(v)}return null}function C(u,b,y){switch(b){case A.LogLevel.Trace:u.trace(y);break;case A.LogLevel.Debug:u.debug(y);break;case A.LogLevel.Info:u.info(y);break;case A.LogLevel.Warning:u.warn(y);break;case A.LogLevel.Error:u.error(y);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function P(u,b){switch(b){case A.LogLevel.Trace:u.setLevel(s.Trace);break;case A.LogLevel.Debug:u.setLevel(s.Debug);break;case A.LogLevel.Info:u.setLevel(s.Info);break;case A.LogLevel.Warning:u.setLevel(s.Warning);break;case A.LogLevel.Error:u.setLevel(s.Error);break;case A.LogLevel.Off:u.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class d extends A.$lj{constructor(b,y,p,l,v){super(),this.m=[],this.setLevel(v),this.n=this.s(b,y,p,l),this.B(this.onDidChangeLogLevel($=>{this.r&&P(this.r,$)}))}async s(b,y,p,l){const v=p?6:1,$=30/v*S.$Ok.MB,w=await M(b,y,$,v,l);if(w){this.r=w,P(this.r,this.getLevel());for(const{level:g,message:h}of this.m)C(this.r,g,h);this.m=[]}}g(b,y){this.r?C(this.r,b,y):this.getLevel()<=b&&this.m.push({level:b,message:y})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$NN=d}),define(se[230],re([0,1,32,5,229]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ON=void 0;class M extends A.$qj{s(P,d,u){return new s.$NN((0,S.$kg)(),P.fsPath,!u?.donotRotate,!!u?.donotUseFormatters,d)}}e.$ON=M}),define(se[68],re([0,1,31,3,6,5,230]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E8b=e.$D8b=void 0,e.$D8b=(0,s.$Yh)(M.$gj);class P extends C.$ON{constructor(){super(...arguments),this.u=new S.$zc}createLogger(u,b,y){y!==void 0&&this.u.set(this.n(u),y);try{return super.createLogger(u,b)}catch(p){throw this.u.delete(this.n(u)),p}}registerLogger(u,b){b!==void 0&&this.u.set(u.resource,b),super.registerLogger(u)}deregisterLogger(u){this.u.delete(u),super.deregisterLogger(u)}getRegisteredLoggers(u){const b=[];for(const y of super.getRegisteredLoggers())u===this.u.get(y.resource)&&b.push(y);return b}getOnDidChangeLogLevelEvent(u){return A.Event.filter(this.onDidChangeLogLevel,b=>(0,M.$hj)(b)||this.w(b[0],u))}getOnDidChangeVisibilityEvent(u){return A.Event.filter(this.onDidChangeVisibility,([b])=>this.w(b,u))}getOnDidChangeLoggersEvent(u){return A.Event.filter(A.Event.map(this.onDidChangeLoggers,b=>({added:[...b.added].filter(p=>this.w(p.resource,u)),removed:[...b.removed].filter(p=>this.w(p.resource,u))})),b=>b.added.length>0||b.removed.length>0)}deregisterLoggers(u){for(const[b,y]of this.u)y===u&&this.deregisterLogger(b)}w(u,b){const y=this.u.get(u);return y===void 0||y===b}dispose(){super.dispose(),this.u.clear()}}e.$E8b=P}),define(se[231],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h9b=e.$g9b=e.$f9b=e.$e9b=void 0;function S(C){return C.submenu!==void 0}e.$e9b=S;function A(C){return C.id==="vscode.menubar.separator"}e.$f9b=A;function s(C){return C.uri!==void 0}e.$g9b=s;function M(C){return!S(C)&&!A(C)&&!s(C)}e.$h9b=M}),define(se[39],re([0,1,3,71,2,6]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=e.$rn=e.$qn=void 0,e.$qn=(0,M.$Xh)("policy");class C extends s.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$Rd),this.onDidChange=this.h.event}async updatePolicyDefinitions(u){const b=Object.keys(this.f).length;return this.f={...u,...this.f},b!==Object.keys(this.f).length&&await this.j(u),A.Iterable.reduce(this.g.entries(),(y,[p,l])=>({...y,[p]:l}),{})}getPolicyValue(u){return this.g.get(u)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(u,[b,y])=>({...u,[b]:{definition:y,value:this.g.get(b)}}),{})}}e.$rn=C;class P{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$sn=P}),define(se[232],re([0,1,8,3,71,12,16,5,39]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f0b=void 0;function u(y,p){const l=[];for(const v of new Set(s.Iterable.concat(y.keys(),p.keys())))y.get(v)!==p.get(v)&&l.push(v);return l}let b=class extends d.$rn{constructor(p,l,v){super(),this.m=p,this.n=l,this.s=v,this.c=this.B(new S.$Xg(500));const $=A.Event.filter(l.onDidFilesChange,w=>w.affects(p));this.B(l.watch(p)),this.B($(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const p=new Map;try{const l=await this.n.readFile(this.m),v=JSON.parse(l.value.toString());if(!(0,M.$Ef)(v))throw new Error("Policy file isn't a JSON object");for(const $ of Object.keys(v))this.f[$]&&p.set($,v[$])}catch(l){l.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",l)}return p}async w(){const p=await this.u(),l=u(this.g,p);this.g=p,l.length>0&&this.h.fire(l)}};e.$f0b=b,e.$f0b=b=ve([te(1,C.$gk),te(2,P.$fj)],b)}),define(se[233],re([0,1,3,2,39]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q9b=e.$P9b=void 0;class M{constructor(d){this.b=d,this.a=new A.$Qc}listen(d,u){switch(u){case"onDidChange":return S.Event.map(this.b.onDidChange,b=>b.reduce((y,p)=>({...y,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${u}`)}call(d,u,b){switch(u){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(b)}throw new Error(`Call not found: ${u}`)}dispose(){this.a.dispose()}}e.$P9b=M;class C extends s.$rn{constructor(d,u){super(),this.a=u;for(const b in d){const{definition:y,value:p}=d[b];this.f[b]=y,p!==void 0&&this.g.set(b,p)}this.a.listen("onDidChange")(b=>{for(const y in b){const p=b[y];p===null?this.g.delete(y):this.g.set(y,p)}this.h.fire(Object.keys(b))})}async j(d){const u=await this.a.call("updatePolicyDefinitions",d);for(const b in u)this.g.set(b,u[b])}}e.$Q9b=C}),define(se[234],re([0,1,39,8,2,5]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e0b=void 0;let C=class extends S.$rn{constructor(d,u){super(),this.m=d,this.n=u,this.a=new A.$Tg,this.b=this.B(new s.$Sc)}async j(d){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(d).length} policy definitions`);const{createWatcher:u}=await new Promise((b,y)=>{J(["@vscode/policy-watcher"],b,y)});await this.a.queue(()=>new Promise((b,y)=>{try{this.b.value=u(this.n,d,p=>{this.t(p),b()})}catch(p){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),y(p)}}))}t(d){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(d)}`);for(const u in d){const b=d[u];b===void 0?this.g.delete(u):this.g.set(u,b)}this.h.fire(Object.keys(d))}};e.$e0b=C,e.$e0b=C=ve([te(0,M.$fj)],C)}),define(se[79],re([0,1,35]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.context<"u"){const M=s.context.configuration();if(M)A=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,S.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:M.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(se[26],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=void 0,e.$xj=(0,S.$Xh)("productService"),e.$yj="vscode://schemas/vscode-product"}),define(se[235],re([0,1,8,5]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$88b=void 0;let s=class{constructor(C,P,d){this.a=C,this.b=P,this.c=d}async inspect(C){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,S.$1g)(C);const d=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),d.profile}async d(){const C=this.a.webContents.debugger;C.attach(),await C.sendCommand("Profiler.enable")}async e(){const C=this.a.webContents.debugger;await C.sendCommand("Profiler.disable"),C.detach()}};e.$88b=s,e.$88b=s=ve([te(2,A.$fj)],s)}),define(se[80],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t8b=void 0,e.$t8b=(0,S.$Xh)("protocolMainService")}),define(se[43],re([0,1,137,12]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=void 0;class s{constructor(){this.a=new Map}add(C,P){S.ok(A.$Cf(C)),S.ok(A.$Ef(P)),S.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,P)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$on=new s}),define(se[236],re([0,1,3,43]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=void 0,e.$pn={JSONContribution:"base.contributions.json"};function s(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class M{constructor(){this.b=new S.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,u){this.a[s(d)]=u,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const C=new M;A.$on.add(e.$pn.JSONContribution,C)}),define(se[58],re([0,1,23,3,12,163,17,236,43]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.ConfigurationScope=e.$tn=e.EditPresentationTypes=void 0;var u;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(u||(e.EditPresentationTypes=u={})),e.$tn={Configuration:"base.contributions.configuration"};var b;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b||(e.ConfigurationScope=b={})),e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn={properties:{},patternProperties:{}},e.$zn={properties:{},patternProperties:{}},e.$An="vscode://schemas/settings/resourceLanguage",e.$Bn="vscode://schemas/settings/configurationDefaults";const y=d.$on.as(P.$pn.JSONContribution);class p{constructor(){this.h=new Set,this.i=new A.$Rd,this.onDidSchemaChange=this.i.event,this.j=new A.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$An,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const r=new Set;this.n(i,o,r),y.registerSchema(e.$An,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const o=new Set;this.o(i,o),y.registerSchema(e.$An,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const r=new Set;this.o(o,r),this.n(i,!1,r),y.registerSchema(e.$An,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const r=[];for(const{overrides:t,source:n}of i)for(const c in t)if(o.add(c),e.$Dn.test(c)){const m=this.a.get(c),D=m?.valuesSources??new Map;if(n)for(const L of Object.keys(t[c]))D.set(L,n);const I={...m?.value||{},...t[c]};this.a.set(c,{source:n,value:I,valuesSources:D});const E=(0,C.$Bi)(c),R={type:"object",default:I,description:M.localize(1,null,E),$ref:e.$An,defaultDefaultValue:I,source:s.$Cf(n)?void 0:n,defaultValueSource:n};r.push(...$(c)),this.d[c]=R,this.b.properties[c]=R}else{this.a.set(c,{value:t[c],source:n});const m=this.d[c];m&&(this.w(c,m),this.r(c,m))}this.m(r)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:r,source:t}of i)for(const n in r){const c=this.a.get(n),m=s.$Cf(t)?t:t?.id,D=s.$Cf(c?.source)?c?.source:c?.source?.id;if(m===D)if(o.add(n),this.a.delete(n),e.$Dn.test(n))delete this.d[n],delete this.b.properties[n];else{const I=this.d[n];I&&(this.w(n,I),this.r(n,I))}}this.u()}deltaConfiguration(i){let o=!1;const r=new Set;i.removedDefaults&&(this.l(i.removedDefaults,r),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,r),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,r),i.addedConfigurations&&this.n(i.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,r){i.forEach(t=>{this.p(t,o,t.extensionInfo,t.restrictedProperties,void 0,r),this.c.push(t),this.q(t)})}o(i,o){const r=t=>{if(t.properties)for(const n in t.properties){o.add(n);const c=this.d[n];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[n],this.s(n,t.properties[n])}t.allOf?.forEach(n=>r(n))};for(const t of i){r(t);const n=this.c.indexOf(t);n!==-1&&this.c.splice(n,1)}}p(i,o=!0,r,t,n=3,c){n=s.$Lf(i.scope)?n:i.scope;const m=i.properties;if(m)for(const I in m){const E=m[I];if(o&&a(I,E)){delete m[I];continue}if(E.source=r,E.defaultDefaultValue=m[I].default,this.w(I,E),e.$Dn.test(I)?E.scope=void 0:(E.scope=s.$Lf(E.scope)?n:E.scope,E.restricted=s.$Lf(E.restricted)?!!t?.includes(I):E.restricted),m[I].hasOwnProperty("included")&&!m[I].included){this.f[I]=m[I],delete m[I];continue}else this.d[I]=m[I],m[I].policy?.name&&this.e.set(m[I].policy.name,I);!m[I].deprecationMessage&&m[I].markdownDeprecationMessage&&(m[I].deprecationMessage=m[I].markdownDeprecationMessage),c.add(I)}const D=i.allOf;if(D)for(const I of D)this.p(I,o,r,t,n,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=r=>{const t=r.properties;if(t)for(const c in t)this.r(c,t[c]);r.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$un.properties[i]=o,o.scope){case 1:e.$vn.properties[i]=o;break;case 2:e.$wn.properties[i]=o;break;case 6:e.$xn.properties[i]=o;break;case 3:e.$yn.properties[i]=o;break;case 4:e.$zn.properties[i]=o;break;case 5:e.$zn.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$un.properties[i],o.scope){case 1:delete e.$vn.properties[i];break;case 2:delete e.$wn.properties[i];break;case 6:delete e.$xn.properties[i];break;case 3:delete e.$yn.properties[i];break;case 4:case 5:delete e.$zn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$An};this.w(o,r),e.$un.properties[o]=r,e.$vn.properties[o]=r,e.$wn.properties[o]=r,e.$xn.properties[o]=r,e.$yn.properties[o]=r,e.$zn.properties[o]=r}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$An};e.$un.patternProperties[e.$Cn]=i,e.$vn.patternProperties[e.$Cn]=i,e.$wn.patternProperties[e.$Cn]=i,e.$xn.patternProperties[e.$Cn]=i,e.$yn.patternProperties[e.$Cn]=i,e.$zn.patternProperties[e.$Cn]=i,this.i.fire()}w(i,o){const r=this.a.get(i);let t=r?.value,n=r?.source;s.$Jf(t)&&(t=o.defaultDefaultValue,n=void 0),s.$Jf(t)&&(t=g(o.type)),o.default=t,o.defaultValueSource=n}}const l="\\[([^\\]]+)\\]",v=new RegExp(l,"g");e.$Cn=`^(${l})+$`,e.$Dn=new RegExp(e.$Cn);function $(f){const i=[];if(e.$Dn.test(f)){let o=v.exec(f);for(;o?.length;){const r=o[1].trim();r&&i.push(r),o=v.exec(f)}}return(0,S.$Lb)(i)}e.$En=$;function w(f){return f.reduce((i,o)=>`${i}[${o}]`,"")}e.$Fn=w;function g(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Gn=g;const h=new p;d.$on.add(e.$tn.Configuration,h);function a(f,i){return f.trim()?e.$Dn.test(f)?M.localize(7,null,f):h.getConfigurationProperties()[f]!==void 0?M.localize(8,null,f):i.policy?.name&&h.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,f,i.policy?.name,h.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.$Hn=a;function k(){const f=[],i=h.getConfigurationProperties();for(const o of Object.keys(i))f.push([o,i[o].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.$In=k}),define(se[119],re([0,1,23,3,44,2,31,38,12,7,17,58,43]),function(J,e,S,A,s,M,C,P,d,u,b,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=void 0;function l(o){return Object.isFrozen(o)?o:P.$dn(o)}class v{constructor(r={},t=[],n=[],c){this.b=r,this.c=t,this.d=n,this.raw=c,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(t=>{if(t instanceof v)return t;const n=new $("");return n.parseRaw(t),n.configurationModel});this.f=r.reduce((t,n)=>n===t?n:t.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,b.$zi)(this.contents,r):this.contents}inspect(r,t){const n=this.rawConfiguration.getValue(r),c=t?this.rawConfiguration.getOverrideValue(r,t):void 0,m=t?this.rawConfiguration.override(t).getValue(r):n;return{value:n,override:c,merged:m}}getOverrideValue(r,t){const n=this.i(t);return n?r?(0,b.$zi)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const n of this.overrides)n.identifiers.includes(r)&&t.push(...n.keys);return S.$Lb(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return S.$Lb(r)}override(r){let t=this.a.get(r);return t||(t=this.g(r),this.a.set(r,t)),t}merge(...r){const t=P.$cn(this.contents),n=P.$cn(this.overrides),c=[...this.keys],m=this.raw?.length?[...this.raw]:[this];for(const D of r)if(m.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(t,D.contents);for(const I of D.overrides){const[E]=n.filter(R=>S.$tb(R.identifiers,I.identifiers));E?(this.h(E.contents,I.contents),E.keys.push(...I.keys),E.keys=S.$Lb(E.keys)):n.push(P.$cn(I))}for(const I of D.keys)c.indexOf(I)===-1&&c.push(I)}return new v(t,c,n,m.every(D=>D instanceof v)?void 0:m)}g(r){const t=this.i(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const n={};for(const c of S.$Lb([...Object.keys(this.contents),...Object.keys(t)])){let m=this.contents[c];const D=t[c];D&&(typeof m=="object"&&typeof D=="object"?(m=P.$cn(m),this.h(m,D)):m=D),n[c]=m}return new v(n,this.keys,this.overrides)}h(r,t){for(const n of Object.keys(t)){if(n in r&&d.$Ef(r[n])&&d.$Ef(t[n])){this.h(r[n],t[n]);continue}r[n]=P.$cn(t[n])}}i(r){let t=null,n=null;const c=m=>{m&&(n?this.h(n,m):n=P.$cn(m))};for(const m of this.overrides)m.identifiers.length===1&&m.identifiers[0]===r?t=m.contents:m.identifiers.includes(r)&&c(m.contents);return c(t),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,t){this.j(r,t,!0)}setValue(r,t){this.j(r,t,!1)}removeValue(r){const t=this.keys.indexOf(r);t!==-1&&(this.keys.splice(t,1),(0,b.$yi)(this.contents,r),y.$Dn.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>S.$tb(n.identifiers,(0,y.$En)(r))),1))}j(r,t,n){(0,b.$xi)(this.contents,r,t,c=>console.error(c)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),y.$Dn.test(r)&&this.overrides.push({identifiers:(0,y.$En)(r),keys:Object.keys(this.contents[r]),contents:(0,b.$wi)(this.contents[r],c=>console.error(c))})}}e.$Jn=v;class ${constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,t){if(!d.$Lf(r)){const n=this.g(r);this.parseRaw(n,t)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,t){this.a=r;const{contents:n,keys:c,overrides:m,restricted:D,hasExcludedProperties:I}=this.h(r,t);this.b=new v(n,c,m,I?[r]:void 0),this.c=D||[]}g(r){let t={},n=null,c=[];const m=[],D=[];function I(R){Array.isArray(c)?c.push(R):n!==null&&(c[n]=R)}const E={onObjectBegin:()=>{const R={};I(R),m.push(c),c=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{c=m.pop()},onArrayBegin:()=>{const R=[];I(R),m.push(c),c=R,n=null},onArrayEnd:()=>{c=m.pop()},onLiteralValue:I,onError:(R,L,F)=>{D.push({error:R,offset:L,length:F})}};if(r)try{s.$_m(r,E),t=c[0]||{}}catch(R){console.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return t}h(r,t){const n=p.$on.as(y.$tn.Configuration).getConfigurationProperties(),c=this.i(r,n,!0,t);r=c.raw;const m=(0,b.$wi)(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),D=Object.keys(r),I=this.j(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:m,keys:D,overrides:I,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}i(r,t,n,c){let m=!1;if(!c?.scopes&&!c?.skipRestricted&&!c?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:m};const D={},I=[];for(const E in r)if(y.$Dn.test(E)&&n){const R=this.i(r[E],t,!1,c);D[E]=R.raw,m=m||R.hasExcludedProperties,I.push(...R.restricted)}else{const R=t[E],L=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&I.push(E),!c.exclude?.includes(E)&&(c.include?.includes(E)||(L===void 0||c.scopes===void 0||c.scopes.includes(L))&&!(c.skipRestricted&&R?.restricted))?D[E]=r[E]:m=!0}return{raw:D,restricted:I,hasExcludedProperties:m}}j(r,t){const n=[];for(const c of Object.keys(r))if(y.$Dn.test(c)){const m={};for(const D in r[c])m[D]=r[c][D];n.push({identifiers:(0,y.$En)(c),keys:Object.keys(m),contents:(0,b.$wi)(m,t)})}return n}}e.$Kn=$;class w extends M.$Rc{constructor(r,t,n,c){super(),this.c=r,this.f=t,this.g=c,this.b=this.B(new A.$Rd),this.onDidChange=this.b.event,this.a=new $(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,m=>m.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,m=>(m.isOperation(0)||m.isOperation(3)||m.isOperation(1)||m.isOperation(4))&&n.isEqual(m.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Ln=w;class g{constructor(r,t,n,c,m,D,I,E,R,L,F,U,x){this.a=r,this.b=t,this.c=n,this.overrideIdentifiers=c,this.d=m,this.f=D,this.g=I,this.h=E,this.i=R,this.j=L,this.k=F,this.l=U,this.m=x}get value(){return l(this.c)}n(r,t,n){const c=r.inspect(t,n);return{get value(){return l(c.value)},get override(){return l(c.override)},get merged(){return l(c.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(r,t,n,c,m=new v,D=new v,I=new C.$zc,E=new v,R=new C.$zc){this.c=r,this.d=t,this.f=n,this.g=c,this.h=m,this.i=D,this.j=I,this.l=E,this.m=R,this.a=null,this.b=new C.$zc,this.n=null}getValue(r,t,n){return this.p(r,t,n).getValue(r)}updateValue(r,t,n={}){let c;n.resource?(c=this.m.get(n.resource),c||(c=new v,this.m.set(n.resource,c))):c=this.l,t===void 0?c.removeValue(r):c.setValue(r,t),n.resource||(this.a=null)}inspect(r,t,n){const c=this.p(r,t,n),m=this.t(t.resource,n),D=t.resource?this.m.get(t.resource)||this.l:this.l,I=new Set;for(const E of c.overrides)for(const R of E.identifiers)c.getOverrideValue(r,R)!==void 0&&I.add(R);return new g(r,t,c.getValue(r),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,m||void 0,D)}keys(r){const t=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,t){this.j.set(r,t),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const n=[];if(!t){const{added:c,updated:m,removed:D}=f(this.c,r);t=[...c,...m,...D]}for(const c of t)for(const m of(0,y.$En)(c)){const D=this.c.getKeysForOverrideIdentifier(m),I=r.getKeysForOverrideIdentifier(m),E=[...I.filter(R=>D.indexOf(R)===-1),...D.filter(R=>I.indexOf(R)===-1),...D.filter(R=>!P.$gn(this.c.override(m).getValue(R),r.override(m).getValue(R)))];n.push([m,E])}return this.updateDefaultConfiguration(r),{keys:t,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:t,updated:n,removed:c}=f(this.d,r),m=[...t,...n,...c];return m.length&&this.updatePolicyConfiguration(r),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:t,updated:n,removed:c,overrides:m}=f(this.applicationConfiguration,r),D=[...t,...n,...c];return D.length&&this.updateApplicationConfiguration(r),{keys:D,overrides:m}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:n,removed:c,overrides:m}=f(this.localUserConfiguration,r),D=[...t,...n,...c];return D.length&&this.updateLocalUserConfiguration(r),{keys:D,overrides:m}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:n,removed:c,overrides:m}=f(this.remoteUserConfiguration,r),D=[...t,...n,...c];return D.length&&this.updateRemoteUserConfiguration(r),{keys:D,overrides:m}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:n,removed:c,overrides:m}=f(this.workspaceConfiguration,r),D=[...t,...n,...c];return D.length&&this.updateWorkspaceConfiguration(r),{keys:D,overrides:m}}compareAndUpdateFolderConfiguration(r,t){const n=this.folderConfigurations.get(r),{added:c,updated:m,removed:D,overrides:I}=f(n,t),E=[...c,...m,...D];return(E.length||!n)&&this.updateFolderConfiguration(r,t),{keys:E,overrides:I}}compareAndDeleteFolderConfiguration(r){const t=this.folderConfigurations.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:c,removed:m,overrides:D}=f(t,void 0);return{keys:[...n,...c,...m],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,t,n){let c=this.q(t,n);return t.overrideIdentifier&&(c=c.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(c=c.merge(this.d)),c}q({resource:r},t){let n=this.r();if(t&&r){const c=t.getFolder(r);c&&(n=this.s(c.uri)||n);const m=this.m.get(r);m&&(n=n.merge(m))}return n}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let t=this.b.get(r);if(!t){const n=this.r(),c=this.j.get(r);c?(t=n.merge(c),this.b.set(r,t)):t=n}return t}t(r,t){if(t&&r){const n=t.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,t)=>{const{contents:n,overrides:c,keys:m}=this.j.get(t);return r.push([t,{contents:n,overrides:c,keys:m}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(t=>r.add(t)),this.userConfiguration.keys.forEach(t=>r.add(t)),this.i.keys.forEach(t=>r.add(t)),this.j.forEach(t=>t.keys.forEach(n=>r.add(n))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.i.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.j.forEach(t=>t.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}v(r){const t=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(c=>t.add(c))),[...t.values()]}static parse(r){const t=this.w(r.defaults),n=this.w(r.policy),c=this.w(r.application),m=this.w(r.user),D=this.w(r.workspace),I=r.folders.reduce((E,R)=>(E.set(u.URI.revive(R[0]),this.w(R[1])),E),new C.$zc);return new h(t,n,c,m,new v,D,I,new v,new C.$zc)}static w(r){return new v(r.contents,r.keys,r.overrides)}}e.$Mn=h;function a(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,t=new Map;for(const c of o)c.keys.forEach(m=>r.add(m)),c.overrides.forEach(([m,D])=>{const I=(0,C.$wc)(t,m,new Set);D.forEach(E=>I.add(E))});const n=[];return t.forEach((c,m)=>n.push([m,[...c.values()]])),{keys:[...r.values()],overrides:n}}e.$Nn=a;class k{constructor(r,t,n,c){this.change=r,this.f=t,this.g=n,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const m of r.keys)this.affectedKeys.add(m);for(const[,m]of r.overrides)for(const D of m)this.affectedKeys.add(D);this.d=this.a;for(const m of this.affectedKeys)this.d+=m+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(r,t){const n=this.a+r,c=this.d.indexOf(n);if(c<0)return!1;const m=c+n.length;if(m>=this.d.length)return!1;const D=this.d.charCodeAt(m);if(D!==this.b&&D!==this.c)return!1;if(t){const I=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.f?.workspace):void 0,E=this.g.getValue(r,t,this.h);return!P.$gn(I,E)}return!0}}e.$On=k;function f(o,r){const{added:t,removed:n,updated:c}=i(r?.rawConfiguration,o?.rawConfiguration),m=[],D=o?.getAllOverrideIdentifiers()||[],I=r?.getAllOverrideIdentifiers()||[];if(r){const E=I.filter(R=>!D.includes(R));for(const R of E)m.push([R,r.getKeysForOverrideIdentifier(R)])}if(o){const E=D.filter(R=>!I.includes(R));for(const R of E)m.push([R,o.getKeysForOverrideIdentifier(R)])}if(r&&o){for(const E of D)if(I.includes(E)){const R=i({contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});m.push([E,[...R.added,...R.removed,...R.updated]])}}return{added:t,removed:n,updated:c,overrides:m}}function i(o,r){const t=o?r?o.keys.filter(m=>r.keys.indexOf(m)===-1):[...o.keys]:[],n=r?o?r.keys.filter(m=>o.keys.indexOf(m)===-1):[...r.keys]:[],c=[];if(o&&r){for(const m of r.keys)if(o.keys.indexOf(m)!==-1){const D=(0,b.$zi)(r.contents,m),I=(0,b.$zi)(o.contents,m);P.$gn(D,I)||c.push(m)}}return{added:t,removed:n,updated:c}}}),define(se[237],re([0,1,23,3,2,38,12,119,58,5,39,43]),function(J,e,S,A,s,M,C,P,d,u,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=e.$Qn=e.$Pn=void 0;class p extends s.$Rc{constructor(){super(...arguments),this.a=this.B(new A.$Rd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$Jn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(y.$on.as(d.$tn.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:g})=>this.c(Array.from(w),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,g){this.h(w,y.$on.as(d.$tn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new P.$Jn;const w=y.$on.as(d.$tn.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,g){const h=this.f();for(const a of w){const k=h[a],f=g[a];k!==void 0?this.b.addValue(a,k):f?this.b.addValue(a,f.default):this.b.removeValue(a)}}}e.$Pn=p;class l{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new P.$Jn}async initialize(){return this.configurationModel}}e.$Qn=l;let v=class extends s.$Rc{get configurationModel(){return this.b}constructor(w,g,h){super(),this.c=w,this.f=g,this.g=h,this.a=this.B(new A.$Rd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$Jn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const g={},h=[],a=y.$on.as(d.$tn.Configuration).getConfigurationProperties();for(const k of w){const f=a[k];if(!f){h.push(k);continue}if(f.policy){if(f.type!=="string"&&f.type!=="number"){this.g.warn(`Policy ${f.policy.name} has unsupported type ${f.type}`);continue}h.push(k),g[f.policy.name]={type:f.type}}}return(0,C.$Pf)(g)||await this.f.updatePolicyDefinitions(g),h}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const g=y.$on.as(d.$tn.Configuration).getPolicyConfigurations(),h=(0,S.$Gb)(w.map(a=>g.get(a)));this.m(h,!0)}m(w,g){this.g.trace("PolicyConfiguration#update",w);const h=y.$on.as(d.$tn.Configuration).getConfigurationProperties(),a=[],k=this.b.isEmpty();for(const f of w){const i=h[f]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(k?o!==void 0:!(0,M.$gn)(this.b.getValue(f),o))&&a.push([f,o])}else this.b.getValue(f)!==void 0&&a.push([f,void 0])}if(a.length){this.g.trace("PolicyConfiguration#changed",a);const f=this.b;this.b=new P.$Jn;for(const i of f.keys)this.b.setValue(i,f.getValue(i));for(const[i,o]of a)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);g&&this.a.fire(this.b)}}};e.$Rn=v,e.$Rn=v=ve([te(1,b.$qn),te(2,u.$fj)],v)}),define(se[238],re([0,1,8,3,2,19,17,119,237,39]),function(J,e,S,A,s,M,C,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=void 0;class b extends s.$Rc{constructor(p,l,v,$){super(),this.j=p,this.h=this.B(new A.$Rd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new d.$Pn),this.c=v instanceof u.$sn?new d.$Qn:this.B(new d.$Rn(this.b,v,$)),this.f=this.B(new P.$Ln(this.j,{},M.$sg,l)),this.a=new P.$Mn(this.b.configurationModel,this.c.configurationModel,new P.$Jn,new P.$Jn),this.g=this.B(new S.$_g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:w,properties:g})=>this.n(w,g))),this.B(this.c.onDidChangeConfiguration(w=>this.r(w))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,l,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.$Mn(p,l,new P.$Jn,v)}getConfigurationData(){return this.a.toData()}getValue(p,l){const v=typeof p=="string"?p:void 0,$=(0,C.$si)(p)?p:(0,C.$si)(l)?l:{};return this.a.getValue(v,$,void 0)}updateValue(p,l,v,$){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.m(p)}m(p){const l=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(p);this.s(v,l,2)}n(p,l){const v=this.a.toData(),$=this.a.compareAndUpdateDefaultConfiguration(p,l);this.s($,v,7)}r(p){const l=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(p);this.s(v,l,7)}s(p,l,v){const $=new P.$On(p,{data:l},this.a);$.source=v,$.sourceConfig=this.t(v),this.h.fire($)}t(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Sn=b}),define(se[239],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$69b=e.$59b=e.$49b=void 0,e.$49b="request",e.$59b="remoteResourceHandler";class S{async routeCall(s,M,C){if(M!==e.$49b)throw new Error(`Call not found: ${M}`);const P=C[0];if(P?.authority){const d=s.connections.find(u=>u.ctx===P.authority);if(d)return d}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$69b=S}),define(se[240],re([0,1,14,6]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.RemoteAuthorityResolverErrorCode=e.$Zk=e.$Yk=e.RemoteConnectionType=e.$Xk=void 0,e.$Xk=(0,A.$Xh)("remoteAuthorityResolverService");var s;(function(b){b[b.WebSocket=0]="WebSocket",b[b.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$Yk=M;class C{constructor(y,p){this.host=y,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Zk=C;var P;(function(b){b.Unknown="Unknown",b.NotAvailable="NotAvailable",b.TemporarilyNotAvailable="TemporarilyNotAvailable",b.NoResolverFound="NoResolverFound",b.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class d extends S.$ab{static isNotAvailable(y){return y instanceof d&&y._code===P.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof d&&y._code===P.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof d&&y._code===P.NoResolverFound}static isInvalidAuthority(y){return y instanceof d&&y._code===P.InvalidAuthority}static isHandled(y){return y instanceof d&&y.isHandled}constructor(y,p=P.Unknown,l){super(y),this._message=y,this._code=p,this._detail=l,this.isHandled=p===P.NotAvailable&&l===!0,Object.setPrototypeOf(this,d.prototype)}}e.$1k=d;function u(b){const y=b.indexOf("+");return y===-1?b:b.substring(0,y)}e.$2k=u}),define(se[59],re([0,1,13]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=void 0;function A(u){return u.scheme===S.Schemas.vscodeRemote?u.authority:void 0}e.$3k=A;function s(u){if(!u)return;const b=u.indexOf("+");return b<0?u:u.substr(0,b)}e.$4k=s;function M(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.$5k=M;function C(u){const{host:b,port:y}=d(u);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:y}}e.$6k=C;function P(u,b){let{host:y,port:p}=d(u);return typeof p>"u"&&(p=b),{host:y,port:p}}e.$7k=P;function d(u){const b=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const y=u.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const p=u.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:u,port:void 0}}}),define(se[120],re([0,1,25,6,59]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.TargetPlatform=e.ExtensionType=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l="extensions.user.cache",e.$9l="extensions.builtin.cache",e.$0l="undefined_publisher",e.$$l=["ui","workspace","web"];function M($){if(typeof $=="object"&&$!==null&&$.supported!==!0)return $.description}e.$_l=M,e.$am=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function($){$[$.System=0]="System",$[$.User=1]="User"})(C||(e.ExtensionType=C={}));var P;(function($){$.WIN32_X64="win32-x64",$.WIN32_ARM64="win32-arm64",$.LINUX_X64="linux-x64",$.LINUX_ARM64="linux-arm64",$.LINUX_ARMHF="linux-armhf",$.ALPINE_X64="alpine-x64",$.ALPINE_ARM64="alpine-arm64",$.DARWIN_X64="darwin-x64",$.DARWIN_ARM64="darwin-arm64",$.WEB="web",$.UNIVERSAL="universal",$.UNKNOWN="unknown",$.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class d{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,g){if(typeof w>"u"||w===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof w=="string"||typeof g=="string"){const h=typeof w=="string"?w:w.value,a=typeof g=="string"?g:g.value;return S.$6e(h,a)}return w._lower===g._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$bm=d;class u{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const g of w)this.add(g)}add(w){this.c.add(d.toKey(w))}delete(w){return this.c.delete(d.toKey(w))}has(w){return this.c.has(d.toKey(w))}}e.$cm=u;class b{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(d.toKey(w))}get(w){return this.c.get(d.toKey(w))}has(w){return this.c.has(d.toKey(w))}set(w,g){this.c.set(d.toKey(w),g)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$dm=b;function y($){return p($)}e.$em=y;function p($){return $.contributes&&$.contributes.localizations?$.contributes.localizations.length>0:!1}e.$fm=p;function l($){return $.contributes&&$.contributes.authentication?$.contributes.authentication.length>0:!1}e.$gm=l;function v($,w){if(w){const g=`onResolveRemoteAuthority:${(0,s.$4k)(w)}`;return!!$.activationEvents?.includes(g)}return!1}e.$hm=v,e.$im=(0,A.$Xh)("IBuiltinExtensionsScannerService")}),define(se[241],re([0,1,8,18,22,14,3,2,67,73,32,109,240,59]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.PersistentConnectionEventType=e.$bl=e.$al=e.$_k=e.ConnectionType=void 0;const v=30*1e3;var $;(function(X){X[X.Management=1]="Management",X[X.ExtensionHost=2]="ExtensionHost",X[X.Tunnel=3]="Tunnel"})($||(e.ConnectionType=$={}));function w(X){switch(X){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(X){const O=new s.$2d;return setTimeout(()=>O.cancel(),X),O.token}function h(X,O){if(X.isCancellationRequested||O.isCancellationRequested)return s.CancellationToken.Cancelled;const N=new s.$2d;return X.onCancellationRequested(()=>N.cancel()),O.onCancellationRequested(()=>N.cancel()),N.token}class a{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new P.$Qc,this.promise=new Promise((N,G)=>{this.f=N,this.g=G}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function k(X,O){const N=new a(O);return N.registerDisposable(X.onControlMessage(G=>{const j=JSON.parse(G.toString()),B=z(j);B?N.reject(B):N.resolve(j)})),N.promise}function f(X,O,N,G,j,B,T,Z){const he=new a(Z),de=u.$Nd.create(!1);return X.info(`Creating a socket (${T})...`),d.mark(`code/willCreateSocket/${B}`),O.connect(N,G,j,T).then(le=>{he.didTimeout?(d.mark(`code/didCreateSocketError/${B}`),X.info(`Creating a socket (${T}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(d.mark(`code/didCreateSocketOK/${B}`),X.info(`Creating a socket (${T}) was successful after ${de.elapsed()} ms.`),he.resolve(le))},le=>{d.mark(`code/didCreateSocketError/${B}`),X.info(`Creating a socket (${T}) returned an error after ${de.elapsed()} ms.`),X.error(le),he.reject(le)}),he.promise}function i(X,O){const N=new a(O);return X.then(G=>{N.didTimeout||N.resolve(G)},G=>{N.didTimeout||N.reject(G)}),N.promise}async function o(X,O,N,G){const j=_(X,O);X.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let B;try{B=await f(X.logService,X.remoteSocketFactoryService,X.connectTo,(0,l.$5k)(X),`reconnectionToken=${X.reconnectionToken}&reconnection=${X.reconnectionProtocol?"true":"false"}`,w(O),`renderer-${w(O)}-${X.reconnectionToken}`,G)}catch(le){throw X.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),X.logService.error(le),le}X.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let T,Z;X.reconnectionProtocol?(X.reconnectionProtocol.beginAcceptReconnection(B,null),T=X.reconnectionProtocol,Z=!1):(T=new y.$Lh({socket:B}),Z=!0),X.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const he=await i(X.signService.createNewMessage((0,b.$kg)()),G),de={type:"auth",auth:X.connectionToken||"00000000000000000000",data:he.data};T.sendControl(A.$fe.fromString(JSON.stringify(de)));try{const le=await k(T,h(G,g(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(X.logService.trace(`${j} 4/6. received SignRequest control message.`),!await i(X.signService.validate(he,le.signedData),G)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const be=await i(X.signService.sign(le.data),G),Ee={type:"connectionType",commit:X.commit,signedData:be,desiredConnectionType:O};return N&&(Ee.args=N),X.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),T.sendControl(A.$fe.fromString(JSON.stringify(Ee))),{protocol:T,ownsProtocol:Z}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(X.logService.error(`${j} the handshake timed out. Error:`),X.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(X.logService.error(`${j} received error control message when negotiating connection. Error:`),X.logService.error(le)),Z&&V(T),le}}async function r(X,O,N,G){const j=Date.now(),B=_(X,O),{protocol:T,ownsProtocol:Z}=await o(X,O,N,G),he=new a(G);return he.registerDisposable(T.onControlMessage(de=>{const le=JSON.parse(de.toString()),we=z(le);we?(X.logService.error(`${B} received error control message when negotiating connection. Error:`),X.logService.error(we),Z&&V(T),he.reject(we)):(X.reconnectionProtocol?.endAcceptReconnection(),X.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${ne(j)}!`),he.resolve({protocol:T,firstMessage:le}))})),he.promise}async function t(X,O){const{protocol:N}=await r(X,1,void 0,O);return{protocol:N}}async function n(X,O,N){const{protocol:G,firstMessage:j}=await r(X,2,O,N),B=j&&j.debugPort;return{protocol:G,debugPort:B}}async function c(X,O,N){const G=Date.now(),j=_(X,3),{protocol:B}=await o(X,3,O,N);return X.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${ne(G)}!`),B}async function m(X,O,N){const{connectTo:G,connectionToken:j}=await X.addressProvider.getAddress();return{commit:X.commit,quality:X.quality,connectTo:G,connectionToken:j,reconnectionToken:O,reconnectionProtocol:N,remoteSocketFactoryService:X.remoteSocketFactoryService,signService:X.signService,logService:X.logService}}async function D(X,O,N){return E(X,async G=>{const{protocol:j}=await t(G,s.CancellationToken.None);return new Q(X,O,N,G.reconnectionToken,j)})}e.$_k=D;async function I(X,O){return E(X,async N=>{const{protocol:G,debugPort:j}=await n(N,O,s.CancellationToken.None);return new K(X,O,N.reconnectionToken,G,j)})}e.$al=I;async function E(X,O){for(let G=1;;G++)try{const j=(0,b.$kg)(),B=await m(X,j,null);return await O(B)}catch(j){if(G<5)X.logService.error(`[remote-connection][attempt ${G}] An error occurred in initial connection! Will retry... Error:`),X.logService.error(j);else throw X.logService.error(`[remote-connection][attempt ${G}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),X.logService.error(j),ce.triggerPermanentFailure(0,0,p.$1k.isHandled(j)),j}}async function R(X,O,N){const G=await m(X,(0,b.$kg)(),null);return await c(G,{host:O,port:N},s.CancellationToken.None)}e.$bl=R;function L(X){return(0,S.$Ng)(O=>new Promise((N,G)=>{const j=setTimeout(N,X*1e3);O.onCancellationRequested(()=>{clearTimeout(j),N()})}))}var F;(function(X){X[X.ConnectionLost=0]="ConnectionLost",X[X.ReconnectionWait=1]="ReconnectionWait",X[X.ReconnectionRunning=2]="ReconnectionRunning",X[X.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",X[X.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class U{constructor(O,N){this.reconnectionToken=O,this.millisSinceLastIncomingData=N,this.type=0}}e.$cl=U;class x{constructor(O,N,G,j){this.reconnectionToken=O,this.millisSinceLastIncomingData=N,this.durationSeconds=G,this.c=j,this.type=1}skipWait(){this.c.cancel()}}e.$dl=x;class Y{constructor(O,N,G){this.reconnectionToken=O,this.millisSinceLastIncomingData=N,this.attempt=G,this.type=2}}e.$el=Y;class ae{constructor(O,N,G){this.reconnectionToken=O,this.millisSinceLastIncomingData=N,this.attempt=G,this.type=4}}e.$fl=ae;class oe{constructor(O,N,G,j){this.reconnectionToken=O,this.millisSinceLastIncomingData=N,this.attempt=G,this.handled=j,this.type=3}}e.$gl=oe;class ce extends P.$Rc{static triggerPermanentFailure(O,N,G){this._permanentFailure=!0,this.f=O,this.g=N,this.h=G,this.j.forEach(j=>j.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ce._permanentFailure}constructor(O,N,G,j,B){super(),this.t=O,this.u=N,this.reconnectionToken=G,this.protocol=j,this.w=B,this.m=this.B(new C.$Rd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ae(this.reconnectionToken,0,0)),this.B(j.onSocketClose(T=>{const Z=q(this.t,this.reconnectionToken,!0);T?T.type===0?(this.u.logService.info(`${Z} received socket close event (hadError: ${T.hadError}).`),T.error&&this.u.logService.error(T.error)):(this.u.logService.info(`${Z} received socket close event (wasClean: ${T.wasClean}, code: ${T.code}, reason: ${T.reason}).`),T.event&&this.u.logService.error(T.event)):this.u.logService.info(`${Z} received socket close event.`),this.y()})),this.B(j.onSocketTimeout(T=>{const Z=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Z} received socket timeout event (unacknowledgedMsgCount: ${T.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${T.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${T.timeSinceLastReceivedSomeData}).`),this.y()})),ce.j.push(this),this.B((0,P.$Pc)(()=>{const T=ce.j.indexOf(this);T>=0&&ce.j.splice(T,1)})),this.n&&this.D(ce.f,ce.g,ce.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let G=-1;do{G++;const j=G<N.length?N[G]:N[N.length-1];try{if(j>0){const T=L(j);this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,T)),this.u.logService.info(`${O} waiting for ${j} seconds before reconnecting...`);try{await T}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this.u.logService.info(`${O} resolving connection...`);const B=await m(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${B.connectTo}...`),await this.G(B,g(v)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(G>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(p.$1k.isTemporarilyNotAvailable(B)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if((0,M.$3)(B)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if(B instanceof p.$1k){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),G+1,p.$1k.isHandled(B));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!this.n&&!this.s)}C(O,N,G){this.w?ce.triggerPermanentFailure(O,N,G):this.D(O,N,G)}D(O,N,G){this.m.fire(new oe(this.reconnectionToken,O,N,G)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$hl=ce;class Q extends ce{constructor(O,N,G,j,B){super(1,O,j,B,!0),this.client=this.B(new y.$Jh(B,{remoteAuthority:N,clientId:G},O.ipcLogger))}async G(O,N){await t(O,N)}}e.$il=Q;class K extends ce{constructor(O,N,G,j,B){super(2,O,G,j,!1),this.H=N,this.debugPort=B}async G(O,N){await n(O,this.H,N)}}e.$jl=K;function V(X){try{X.acceptDisconnect();const O=X.getSocket();X.dispose(),O.dispose()}catch(O){(0,M.$Z)(O)}}function z(X){if(X&&X.type==="error"){const O=new Error(`Connection error: ${X.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function W(X,O){for(;X.length<O;)X+=" ";return X}function H(X,O){return`[remote-connection][${W(w(X),13)}][${O.substr(0,5)}\u2026]`}function q(X,O,N){return`${H(X,O)}[${N?"reconnect":"initial"}]`}function _(X,O){return`${q(O,X.reconnectionToken,!!X.reconnectionProtocol)}[${X.connectTo}]`}function ne(X){return`${Date.now()-X} ms`}}),define(se[242],re([0,1,2,6]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=void 0,e.$8k=(0,A.$Xh)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(C,P){return this.a[C]??=[],this.a[C].push(P),(0,S.$Pc)(()=>{const d=this.a[C]?.indexOf(P);typeof d=="number"&&d>=0&&this.a[C]?.splice(d,1)})}b(C){return(this.a[C.type]||[]).find(d=>d.supports(C))}connect(C,P,d,u){const b=this.b(C);if(!b)throw new Error(`No socket factory found for ${C}`);return b.connect(C,P,d,u)}}e.$9k=s}),define(se[243],re([0,1,28,48,21,113]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$78b=void 0;let C;async function P(l=!1){return(C===void 0||l)&&(C=d()),C}e.$78b=P;async function d(){const l=u();if(l===void 0)return!1;if(l>=22e3){const v=y();if(v)return new Promise($=>{A.execFile(v,["--status"],w=>$(!w))})}else{const v=p();if(v)try{if((await s.Promises.stat(v)).isFile())return!0}catch{}}return!1}function u(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(l)return parseInt(l[3])}function b(l){const v=process.env.SystemRoot;if(v){const $=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(v,$?"Sysnative":"System32",l)}}function y(){return b("wsl.exe")}function p(){return b("lxss\\LxssManager.dll")}}),define(se[51],re([0,1,18,14,2,183,58,6,5,43]),function(J,e,S,A,s,M,C,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0,e.$1o=(0,P.$Xh)("requestService");class b{constructor(f){this.b=f}toJSON(){if(!this.a){const f=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?f[i]="*****":f[i]=this.b[i];this.a=f}return this.a}}class y extends s.$Rc{constructor(f){super(),this.b=0,this.a=f.createLogger("network",{name:(0,M.localize)(0,null),when:d.$wj.isEqualTo((0,d.$uj)(d.LogLevel.Trace)).serialize()})}async c(f,i,o){const r=`${f} #${++this.b}: ${i.url}`;this.a.trace(`${r} - begin`,i.type,new b(i.headers??{}));try{const t=await o();return this.a.trace(`${r} - end`,i.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${r} - error`,i.type,(0,A.$9)(t)),t}}}e.$2o=y;function p(k){return k.res.statusCode&&k.res.statusCode>=200&&k.res.statusCode<300||k.res.statusCode===1223}e.$3o=p;function l(k){return k.res.statusCode===204}e.$4o=l;async function v(k){return l(k)?null:(await(0,S.$re)(k.stream)).toString()}e.$5o=v;async function $(k){if(!p(k))throw new Error("Server returned "+k.res.statusCode);return v(k)}e.$6o=$;async function w(k){if(!p(k))throw new Error("Server returned "+k.res.statusCode);if(l(k))return null;const i=(await(0,S.$re)(k.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.$7o=w;function g(k){a(k)}e.$8o=g;let h;function a(k){const f=u.$on.as(C.$tn.Configuration),i=h;h={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:k,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},f.updateConfigurations({add:[h],remove:i?[i]:[]})}a(1)}),define(se[244],re([0,1,18,22]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=void 0;class s{constructor(P){this.a=P}listen(P,d){throw new Error("Invalid listen")}call(P,d,u,b=A.CancellationToken.None){switch(d){case"request":return this.a.request(u[0],b).then(async({res:y,stream:p})=>{const l=await(0,S.$re)(p);return[{statusCode:y.statusCode,headers:y.headers},l]});case"resolveProxy":return this.a.resolveProxy(u[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$4q=s;class M{constructor(P){this.a=P}async request(P,d){const[u,b]=await this.a.call("request",[P],d);return{res:u,stream:(0,S.$te)(b)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$5q=M}),define(se[245],re([0,1,246,12]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;function s(C,P){return C.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:C.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function M(C,P,d={}){const u=(0,S.parse)(C),b=d.proxyUrl||s(u,P);if(!b)return null;const y=(0,S.parse)(b);if(!/^https?:$/.test(y.protocol||""))return null;const p={host:y.hostname||"",port:(y.port?+y.port:0)||(y.protocol==="https"?443:80),auth:y.auth,rejectUnauthorized:(0,A.$If)(d.strictSSL)?d.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((l,v)=>{J(["http-proxy-agent"],l,v)})).HttpProxyAgent(b,p):new(await new Promise((l,v)=>{J(["https-proxy-agent"],l,v)})).HttpsProxyAgent(b,p)}e.$6q=M}),define(se[247],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p9b=e.$o9b=e.$n9b=void 0,e.$n9b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$o9b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$p9b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(se[94],re([0,1,48,9,184,22,50,14,4,32,108,63,8,140]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=void 0;let v;async function $(g,h,a,k){return a["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.$i?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.$Vl)(k)&&!a["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.$Vl)(k)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=p.Promises.withAsyncBody(async(f,i)=>{const o=new M.$2d;let r=1e4;const t=g.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(r=(0,l.$Wl)(t,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),i(new Error((0,s.localize)(0,null)))},r);try{f(await w(h,o.token))}catch(c){!(0,P.$3)(c)&&!o.token.isCancellationRequested?i(new Error((0,s.localize)(1,null,(0,C.$Ii)(c)))):f({})}finally{clearTimeout(n),o.dispose()}})),v)}e.$2l=$;async function w(g,h){const a=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",a);const k=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",k);const f=(0,u.$kg)().replace(/-/g,"").substr(0,12),i=new RegExp(f+"({.*})"+f),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",o);const r=await(0,b.$Ll)(d.OS,o);return g.trace("getUnixShellEnvironment#shell",r),new Promise((t,n)=>{if(h.isCancellationRequested)return n(new P.$4);const c=(0,A.$mc)(r);let m,D;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(m=`& '${process.execPath}' ${I} -p '''${f}'' + JSON.stringify(process.env) + ''${f}'''`,D=["-Login","-Command"]):c==="nu"?(m=`^'${process.execPath}' ${I} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,D=["-i","-l","-c"]):(m=`'${process.execPath}' ${I} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,c==="tcsh"||c==="csh"?D=["-ic"]:D=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),m);const E=(0,S.spawn)(r,[...D,m],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});h.onCancellationRequested(()=>(E.kill(),n(new P.$4))),E.on("error",F=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,C.$Ii)(F)),n(F)});const R=[];E.stdout.on("data",F=>R.push(F));const L=[];E.stderr.on("data",F=>L.push(F)),E.on("close",(F,U)=>{const x=Buffer.concat(R).toString("utf8");g.trace("getUnixShellEnvironment#raw",x);const Y=Buffer.concat(L).toString("utf8");if(Y.trim()&&g.trace("getUnixShellEnvironment#stderr",Y),F||U)return n(new Error((0,s.localize)(2,null,F,U)));const ae=i.exec(x),oe=ae?ae[1]:"{}";try{const ce=JSON.parse(oe);a?ce.ELECTRON_RUN_AS_NODE=a:delete ce.ELECTRON_RUN_AS_NODE,k?ce.ELECTRON_NO_ATTACH_CONSOLE=k:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",ce),t(ce)}catch(ce){g.error("getUnixShellEnvironment#errorCaught",(0,C.$Ii)(ce)),n(ce)}})})}}),define(se[248],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g5b=void 0;class S{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const C=String(S.a++);return this.b.set(C,M),{id:C,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const C=this.b.get(s.id);if(!C)return!1;this.b.delete(s.id);try{return C.validate(M)==="ok"}catch{return!1}finally{C.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$g5b=S}),define(se[95],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=void 0,e.$0k="signService",e.$$k=(0,S.$Xh)(e.$0k)}),define(se[249],re([0,1,248]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d0b=void 0;class A extends S.$g5b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(C=>new C.signer().sign(M))}h(){return new Promise((M,C)=>J(["vsda"],M,C))}}e.$d0b=A}),define(se[34],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QN=e.$PN=void 0,e.$PN=(0,S.$Xh)("stateReadService"),e.$QN=(0,S.$Xh)("stateService")}),define(se[121],re([0,1,8,18,2,12,37,16,5]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=e.$SN=e.$RN=e.SaveStrategy=void 0;var u;(function(l){l[l.IMMEDIATE=0]="IMMEDIATE",l[l.DELAYED=1]="DELAYED"})(u||(e.SaveStrategy=u={}));class b extends s.$Rc{constructor(v,$,w,g){super(),this.h=v,this.j=$,this.m=w,this.n=g,this.a=Object.create(null),this.b="",this.c=this.B(new S.$Xg(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.m.error(v)}}getItem(v,$){const w=this.a[v];return(0,M.$Lf)(w)?$:w}setItem(v,$){this.setItems([{key:v,data:$}])}setItems(v){let $=!1;for(const{key:w,data:g}of v)this.a[w]!==g&&((0,M.$Lf)(g)?(0,M.$Jf)(this.a[w])||(this.a[w]=void 0,$=!0):(this.a[w]=g,$=!0));$&&this.s()}removeItem(v){(0,M.$Jf)(this.a[v])||(this.a[v]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.n.writeFile(this.h,A.$fe.fromString(v),{atomic:{postfix:".vsctmp"}}),this.b=v}catch($){this.m.error($)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$RN=b;let y=class extends s.$Rc{constructor(v,$,w,g){super(),this.a=this.B(new b($.stateResource,v,w,g))}async init(){await this.a.init()}getItem(v,$){return this.a.getItem(v,$)}};e.$SN=y,e.$SN=y=ve([te(1,C.$5h),te(2,d.$fj),te(3,P.$gk)],y);class p extends y{setItem(v,$){this.a.setItem(v,$)}setItems(v){this.a.setItems(v)}removeItem(v){this.a.removeItem(v)}close(){return this.a.close()}}e.$TN=p}),define(se[122],re([0,1,4,35,32]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=void 0;function M(d){if(S.$u===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}function C(d,u,b,y,p,l,v,$,w){const g=Object.create(null);g["common.machineId"]=l,g["common.sqmId"]=v,g.sessionID=(0,s.$kg)()+Date.now(),g.commitHash=y,g.version=p,g["common.platformVersion"]=(d||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,S.$h)(S.$u),g["common.nodePlatform"]=A.$cc,g["common.nodeArch"]=b,g["common.product"]=w||"desktop",$&&(g["common.msftInternal"]=$);let h=0;const a=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),S.$l&&(g["common.snap"]="true");const k=M(u);return k&&(g["common.platformDetail"]=k),g}e.$po=C;function P(d){const u=A.env.USERDNSDOMAIN;if(!u)return!1;const b=u.toLowerCase();return d.some(y=>b===y)}e.$qo=P}),define(se[27],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=void 0,e.$kl=(0,S.$Xh)("telemetryService"),e.$ll=(0,S.$Xh)("customEndpointTelemetryService"),e.$ml="telemetry.currentSessionDate",e.$nl="telemetry.firstSessionDate",e.$ol="telemetry.lastSessionDate",e.$pl="telemetry.machineId",e.$ql="telemetry.sqmId",e.$rl="telemetry",e.$sl="telemetry.telemetryLevel",e.$tl="telemetry.enableCrashReporter",e.$ul="telemetry.enableTelemetry";var A;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(se[250],re([0,1,28,8,44,13,9,4,7,88,21,107,91,16,26,27]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=e.$Nr=e.$Mr=e.$Lr=void 0;const w=new Map;async function g(i,o){const r=`${i}::${o.join(":")}`,t=w.get(r);if(t)return t;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,m=new Map,D=2e4;function I(R,L,F,U){const x=L.substring(R.length+1);return A.Promises.withAsyncBody(async Y=>{let ae;try{ae=await b.Promises.readdir(L,{withFileTypes:!0})}catch{Y();return}if(U.count>=D){U.count+=ae.length,U.maxReached=!0,Y();return}let oe=ae.length;if(oe===0){Y();return}let ce=ae;U.count+ae.length>D&&(U.maxReached=!0,oe=D-U.count,ce=ae.slice(0,oe)),U.count+=ae.length;for(const Q of ce)if(Q.isDirectory()){if(F.includes(Q.name)||await I(R,(0,C.$ic)(L,Q.name),F,U),--oe===0){Y();return}}else{const K=Q.name.lastIndexOf(".");if(K>=0){const V=Q.name.substring(K+1);V&&c.set(V,(c.get(V)??0)+1)}for(const V of n)V.relativePathPattern?.test(x)!==!1&&V.filePattern.test(Q.name)&&m.set(V.tag,(m.get(V.tag)??0)+1);if(--oe===0){Y();return}}})}const E=A.Promises.withAsyncBody(async R=>{const L={count:0,maxReached:!1};await I(i,i,o,L);const F=await k(i);R({configFiles:h(m),fileTypes:h(c),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:F})});return w.set(r,E),E}e.$Lr=g;function h(i){return Array.from(i.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function a(){const i={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/l.$Ok.GB).toFixed(2)}GB (${(S.freemem()/l.$Ok.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.$Zm.value()*100)}%`},o=S.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.$Mr=a;async function k(i){try{const o=new Map,r=(0,C.$ic)(i,".vscode","launch.json"),t=await b.Promises.readFile(r),n=[],c=(0,s.$5m)(t.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$bn)(c)==="object"&&c.configurations)for(const m of c.configurations){const D=m.type;D&&(o.has(D)?o.set(D,o.get(D)+1):o.set(D,1))}return h(o)}catch{return[]}}e.$Nr=k;let f=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const t=S.cpus();return t&&t.length>0&&r.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),r.push(`Memory (System):  ${(S.totalmem()/l.$Ok.GB).toFixed(2)}GB (${(S.freemem()/l.$Ok.GB).toFixed(2)}GB free)`),P.$i||r.push(`Load (avg):       ${S.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(u.$Zm.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,y.$Kr)(o.mainPID),this.k(o)]).then(async t=>{let[n,c]=t,m=this.m(o,n);return r.forEach(D=>{if((0,p.$zm)(D))m+=`
${D.errorMessage}`,c+=`
${D.errorMessage}`;else if(m+=`

Remote: ${D.hostName}`,D.processes&&(m+=`
${this.m(o,D.processes)}`),D.workspaceMetadata){c+=`
|  Remote: ${D.hostName}`;for(const I of Object.keys(D.workspaceMetadata)){const E=D.workspaceMetadata[I];let R=`${E.fileCount} files`;E.maxFilesReached&&(R=`more than ${R}`),c+=`|    Folder (${I}): ${R}`,c+=this.h(E)}}}),{processInfo:m,workspaceInfo:c}})}async getSystemInfo(o,r){const{memory:t,vmHint:n,os:c,cpus:m}=a(),D={os:c,memory:t,cpus:m,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return P.$i||(D.load=`${S.loadavg().map(I=>Math.round(I)).join(", ")}`),P.$k&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(o,r){const t=[];return(0,y.$Kr)(o.mainPID).then(async n=>(t.push(""),t.push(this.g(o)),t.push(""),t.push(this.m(o,n)),o.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.k(o))),r.forEach(c=>{if((0,p.$zm)(c))t.push(`
${c.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${c.hostName}`),t.push(this.f(c.machineInfo)),c.processes&&t.push(this.m(o,c.processes)),c.workspaceMetadata)for(const m of Object.keys(c.workspaceMetadata)){const D=c.workspaceMetadata[m];let I=`${D.fileCount} files`;D.maxFilesReached&&(I=`more than ${I}`),t.push(`Folder (${m}): ${I}`),t.push(this.h(D))}}),t.push(""),t.push(""),t.join(`
`)))}h(o){const r=[];let n=0;const c=(E,R)=>{const L=` ${E}(${R})`;n+L.length>60?(r.push(m),m="|                 ",n=m.length):n+=L.length,m+=L};let m="|      File types:";const D=10,I=o.fileTypes.length>D?D:o.fileTypes.length;for(let E=0;E<I;E++){const R=o.fileTypes[E];c(R.name,R.count)}if(r.push(m),o.configFiles.length>=0&&(m="|      Conf files:",n=0,o.configFiles.forEach(E=>{c(E.name,E.count)}),r.push(m)),o.launchConfigFiles.length>0){let E="|      Launch Configs:";o.launchConfigFiles.forEach(R=>{const L=R.count>1?` ${R.name}(${R.count})`:` ${R.name}`;E+=L}),r.push(E)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(t=>t.length));return Object.keys(o).map(t=>`${t}:  ${" ".repeat(r-t.length)}  ${o[t]}`).join(`
                  `)}k(o){const r=[],t=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(c=>{const m=d.URI.revive(c);if(m.scheme===M.Schemas.file){const D=m.fsPath;t.push(g(D,["node_modules",".git"]).then(I=>{let E=`${I.fileCount} files`;I.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${(0,C.$mc)(D)}): ${E}`),r.push(this.h(I))}).catch(I=>{r.push(`|      Error: Unable to collect workspace stats for folder ${D} (${I.toString()})`)}))}else r.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(o,r){const t=new Map;o.windows.forEach(c=>t.set(c.pid,`window [${c.id}] (${c.title})`)),o.pidToNames.forEach(({pid:c,name:m})=>t.set(c,m));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,t,n,r,0),n.join(`
`)}n(o,r,t,n,c){const m=c===0;let D;m?D=n.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?D=r.get(n.pid):D=`${"  ".repeat(c)} ${n.name}`;const I=process.platform==="win32"?n.mem:S.totalmem()*(n.mem/100);t.push(`${n.load.toFixed(0).padStart(5," ")}	${(I/l.$Ok.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(n.children)&&n.children.forEach(E=>this.n(o,r,t,E,c+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:t}of o.folders){const n=d.URI.revive(t);if(n.scheme!==M.Schemas.file)continue;const c=n.fsPath;try{(await g(c,["node_modules",".git"])).fileTypes.forEach(D=>r.add(D.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const t=d.URI.revive(r);if(t.scheme!==M.Schemas.file)continue;const n=t.fsPath;try{const c=await g(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),c.fileTypes.forEach(m=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:m.name,count:m.count})}),c.launchConfigFiles.forEach(m=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:m.name,count:m.count})}),c.configFiles.forEach(m=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};e.$Or=f,e.$Or=f=ve([te(0,$.$kl),te(1,v.$xj)],f)}),define(se[251],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t9b=e.$s9b=void 0;class S{constructor(M){this.b=M}listen(M,C){throw new Error(`Event not found: ${C}`)}call(M,C,{eventName:P,data:d}){return this.b.forEach(u=>u.log(P,d)),Promise.resolve(null)}}e.$s9b=S;class A{constructor(M){this.b=M}log(M,C){return this.b.call("log",{eventName:M,data:C}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$t9b=A}),define(se[52],re([0,1,38,12,3,17,59,122,27]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=void 0;class u{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$ro=u;class b{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$so=b,e.$to=new b;class y{async publicLog(n,c,m){}async publicLogError(n,c,m){}}e.$uo=y,e.$vo="telemetry",e.$wo="extensionTelemetryLog",e.$xo={log:()=>null,flush:()=>Promise.resolve(null)};function p(t,n){return s.Event.debounce(n.onDidChangeConfiguration,(m,D)=>{const I=m?new Set([...m.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:I}},1e3,!0)(m=>{m.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,M.$ui)(m.source),configurationKeys:Array.from(m.affectedKeys)})})}e.$yo=p;function l(t,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!t.enableTelemetry)}e.$zo=l;function v(t,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$Ao=v;function $(t){const n=t.getValue(d.$sl),c=t.getValue(d.$tl);if(t.getValue(d.$ul)===!1||c===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Bo=$;function w(t){const n={},c={},m={};a(t,m);for(let D in m){D=D.length>150?D.substr(D.length-149):D;const I=m[D];typeof I=="number"?c[D]=I:typeof I=="boolean"?c[D]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${I.length}`),n[D]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(n[D]=I)}return{properties:n,measurements:c}}e.$Co=w;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(t){if(!t)return"none";const n=(0,C.$4k)(t);return g.has(n)?n:"other"}e.$Do=h;function a(t,n,c=0,m){if(t)for(const D of Object.getOwnPropertyNames(t)){const I=t[D],E=m?m+D:D;Array.isArray(I)?n[E]=(0,S.$hn)(I):I instanceof Date?n[E]=I.toISOString():(0,A.$Ef)(I)?c<2?a(I,n,c+1,E+"."):n[E]=(0,S.$hn)(I):n[E]=I}}function k(t,n){const c=t.msftInternalDomains||[],m=n.getValue("telemetry.internalTesting");return(0,P.$qo)(c)||m}e.$Eo=k;function f(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$Fo=f;function i(t,n){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const m=[];for(const R of n)for(;;){const L=R.exec(t);if(!L)break;m.push([L.index,R.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(c="";;){const R=I.exec(t);if(!R)break;const L=m.some(([F,U])=>R.index<U&&F<I.lastIndex);!D.test(R[0])&&!L&&(c+=t.substring(E,R.index)+"<REDACTED: user-file-path>",E=I.lastIndex)}return E<t.length&&(c+=t.substr(E)),c}function o(t){if(!t)return t;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of n)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function r(t,n){return(0,S.$en)(t,c=>{if(c instanceof u||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let m=c.replaceAll("%20"," ");m=i(m,n);for(const D of n)m=m.replace(D,"");return m=o(m),m}})}e.$Go=r}),define(se[123],re([0,1,25,117,120,4,7,14,35,52]),function(J,e,S,A,s,M,C,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0;function b(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,S.$1e)(r.id,t.id)===0}e.$Ho=b;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(t){const n=t.manifest?t.manifest.version:t.version,c=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new p(t.identifier,n,c)}static parse(t){const n=y.exec(t);return n&&n[1]&&n[2]?new p({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,c="undefined"){this.version=n,this.targetPlatform=c,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof p?b(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Io=p;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(r){const t=l.exec(r);return t&&t[1]?[w(t[1]),t[2]]:[w(r),void 0]}e.$Jo=v;function $(r,t){return`${r}.${t}`}e.$Ko=$;function w(r){return r.toLowerCase()}e.$Lo=w;function g(r,t){return w($(r??s.$0l,t))}e.$Mo=g;function h(r,t){const n=[],c=m=>{for(const D of n)if(D.some(I=>b(t(I),t(m))))return D;return null};for(const m of r){const D=c(m);D?D.push(m):n.push([m])}return n}e.$No=h;function a(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$Oo=a;function k(r){return{id:new u.$ro(r.identifier.id),name:new u.$ro(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Po=k,e.$Qo=new s.$bm("pprice.better-merge");function f(r,t){const n=[],c=t.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const m=c.shift();if(m&&n.every(D=>!b(D.identifier,{id:m}))){const D=r.filter(I=>b(I.identifier,{id:m}));D.length===1&&(n.push(D[0]),c.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Ro=f;async function i(r,t){if(!M.$k)return!1;let n;try{n=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(m){t.debug("Error while getting the os-release file.",(0,P.$9)(m))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,t){const n=await i(r,t),c=(0,A.$bo)(n?"alpine":M.$u,d.$dc);return t.debug("ComputeTargetPlatform:",c),c}e.$So=o}),define(se[252],re([0,1,206,52]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=void 0;async function s(M,C,P,d,u,b,y){const p={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${C.nameShort})`};if((0,A.$zo)(C,P)&&(0,A.$Bo)(d)===3){const l=await(0,S.$hp)(P,u,b);p["X-Market-User-Id"]=l,p["VSCode-SessionId"]=y.machineId||l}return p}e.$ip=s}),define(se[253],re([0,1,2,38,4,25,185,17,58,79,26,43,27,52]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;let v=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,h,a){this.k=h,this.l=a,this.d={},this.i=new S.$Qc,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const k of this.f)this.j.push(new RegExp((0,M.$Je)(k),"gi")),k.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$Je)(k.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(k=>{(k.affectsConfiguration(p.$sl)||k.affectsConfiguration(p.$ul)||k.affectsConfiguration(p.$tl))&&this.m()}))}setExperimentProperty(g,h){this.d[g]=h}m(){let g=(0,l.$Bo)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const a=h.usage?3:h.error?2:0;g=Math.min(g,a)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,h,a){this.g<h||(a=(0,A.$fn)(a,this.d),a=(0,l.$Go)(a,this.j),a=(0,A.$fn)(a,this.c),this.b.forEach(k=>k.log(g,a)))}publicLog(g,h){this.n(g,3,h)}publicLog2(g,h){this.publicLog(g,h)}publicLogError(g,h){this.h&&this.n(g,2,h)}publicLogError2(g,h){this.publicLogError(g,h)}};e.$9q=v,e.$9q=v=ve([te(1,P.$ri),te(2,b.$xj)],v);function $(){const w=(0,C.localize)(0,null,u.default.nameLong),g=u.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=s.$o?"":(0,C.localize)(3,null),a=(0,C.localize)(4,null),k=(0,C.localize)(5,null),f=(0,C.localize)(6,null),i=(0,C.localize)(7,null),o=`
|       | ${a} | ${k} | ${f} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${w} ${g} ${h}

&nbsp;

${i}
${o}

&nbsp;

${r}
`}y.$on.as(d.$tn.Configuration).registerConfiguration({id:p.$rl,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[p.$sl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:$(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.$on.as(d.$tn.Configuration).registerConfiguration({id:p.$rl,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[p.$ul]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,C.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,C.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${p.$sl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(se[254],re([0,1,4,88,27]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V9b=e.$U9b=void 0;async function M(P,d){let u=P.getItem(s.$pl);return(typeof u!="string"||S.$j&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,A.$1m)(d.error.bind(d))),u}e.$U9b=M;async function C(P,d){let u=P.getItem(s.$ql);return typeof u!="string"&&(u=await(0,A.$2m)(d.error.bind(d))),u}e.$V9b=C}),define(se[255],re([0,1,27,254]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X9b=e.$W9b=void 0;async function s(C,P){const d=await(0,A.$U9b)(C,P);return C.setItem(S.$pl,d),d}e.$W9b=s;async function M(C,P){const d=await(0,A.$V9b)(C,P);return C.setItem(S.$ql,d),d}e.$X9b=M}),define(se[124],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var S;(function(A){A[A.Replace=1]="Replace",A[A.Append=2]="Append",A[A.Prepend=3]="Prepend"})(S||(e.EnvironmentVariableMutatorType=S={}))}),define(se[256],re([0,1,4,124]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;const s=new Map([[A.EnvironmentVariableMutatorType.Append,"APPEND"],[A.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[A.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(b){this.collections=b,this.a=new Map,this.b=new Map,b.forEach((y,p)=>{this.d(y,p);const l=y.map.entries();let v=l.next();for(;!v.done;){const $=v.value[1],w=v.value[0];let g=this.a.get(w);if(g||(g=[],this.a.set(w,g)),g.length>0&&g[0].type===A.EnvironmentVariableMutatorType.Replace){v=l.next();continue}const h={extensionIdentifier:p,value:$.value,type:$.type,scope:$.scope,variable:$.variable,options:$.options};h.scope||delete h.scope,g.unshift(h),v=l.next()}})}async applyToProcessEnvironment(b,y,p){let l;S.$i&&(l={},Object.keys(b).forEach(v=>l[v.toLowerCase()]=v));for(const[v,$]of this.getVariableMap(y)){const w=S.$i&&l[v.toLowerCase()]||v;for(const g of $){const h=p?await p(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case A.EnvironmentVariableMutatorType.Append:b[w]=(b[w]||"")+h;break;case A.EnvironmentVariableMutatorType.Prepend:b[w]=h+(b[w]||"");break;case A.EnvironmentVariableMutatorType.Replace:b[w]=h;break}if(g.options?.applyAtShellIntegration??!1){const a=`VSCODE_ENV_${s.get(g.type)}`;b[a]=(b[a]?b[a]+":":"")+v+"="+this.c(h)}}}}c(b){return b.replaceAll(":","\\x3a")}diff(b,y){const p=new Map,l=new Map,v=new Map;if(b.getVariableMap(y).forEach(($,w)=>{const g=this.getVariableMap(y).get(w),h=P($,g);h&&p.set(w,h)}),this.getVariableMap(y).forEach(($,w)=>{const g=b.getVariableMap(y).get(w),h=P($,g);h&&v.set(w,h)}),this.getVariableMap(y).forEach(($,w)=>{const g=b.getVariableMap(y).get(w),h=d($,g);h&&l.set(w,h)}),!(p.size===0&&l.size===0&&v.size===0))return{added:p,changed:l,removed:v}}getVariableMap(b){const y=new Map;for(const p of this.a.values()){const l=p.filter(v=>C(v,b));l.length>0&&y.set(l[0].variable,l)}return y}getDescriptionMap(b){const y=new Map;for(const p of this.b.values()){const l=p.filter(v=>C(v,b,!0));for(const v of l)y.set(v.extensionIdentifier,v.description)}return y}d(b,y){if(!b.descriptionMap)return;const p=b.descriptionMap.entries();let l=p.next();for(;!l.done;){const v=l.value[1],$=l.value[0];let w=this.b.get($);w||(w=[],this.b.set($,w));const g={extensionIdentifier:y,scope:v.scope,description:v.description};g.scope||delete g.scope,w.push(g),l=p.next()}}}e.$yr=M;function C(u,b,y=!1){return u.scope?!!(u.scope.workspaceFolder&&b?.workspaceFolder&&u.scope.workspaceFolder.index===b.workspaceFolder.index):y?b===u.scope:!0}function P(u,b){if(!b)return u;const y=new Set;b.forEach(l=>y.add(l.extensionIdentifier));const p=[];return u.forEach(l=>{y.has(l.extensionIdentifier)||p.push(l)}),p.length===0?void 0:p}function d(u,b){if(!b)return;const y=new Map;b.forEach(l=>y.set(l.extensionIdentifier,l));const p=[];return u.forEach(l=>{const v=y.get(l.extensionIdentifier);v&&(l.type!==v.type||l.value!==v.value||l.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index)&&p.push(v)}),p.length===0?void 0:p}}),define(se[257],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=e.$vr=e.$ur=e.$tr=e.$sr=void 0;function S(d){return[...d.entries()]}e.$sr=S;function A(d){return d?[...d.entries()]:[]}e.$tr=A;function s(d){return new Map(d)}e.$ur=s;function M(d){return new Map(d??[])}e.$vr=M;function C(d){return Array.from(d.entries()).map(u=>[u[0],S(u[1].map),A(u[1].descriptionMap)])}e.$wr=C;function P(d){return new Map(d.map(u=>[u[0],{map:s(u[1]),descriptionMap:M(u[2])}]))}e.$xr=P}),define(se[258],re([0,1,8,22,3,2,5]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;let P=class extends M.$Rc{constructor(u,b){super(),this.h=b,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Rd),this.onCreateRequest=this.g.event,this.b=u===void 0?15e3:u,this.B((0,M.$Pc)(()=>{for(const y of this.f.values())(0,M.$Mc)(y)}))}createRequest(u){return new Promise((b,y)=>{const p=++this.a;this.c.set(p,b),this.g.fire({requestId:p,...u});const l=new A.$2d;(0,S.$1g)(this.b,l.token).then(()=>y(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,M.$Pc)(()=>l.cancel())])})}acceptReply(u,b){const y=this.c.get(u);y?(this.c.delete(u),(0,M.$Mc)(this.f.get(u)||[]),this.f.delete(u),y(b)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${u}`)}};e.$jr=P,e.$jr=P=ve([te(1,C.$fj)],P)}),define(se[125],re([0,1,6,114,43]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=e.$dr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$cr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$br=void 0,e.$br=new A.$cj("terminalTabFocusMode",!1,!0);var M;(function(f){f.AutomationProfile="terminal.integrated.automationProfile.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var C;(function(f){f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationProfileLinux="terminal.integrated.automationProfile.linux",f.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",f.AutomationProfileWindows="terminal.integrated.automationProfile.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsDefaultColor="terminal.integrated.tabs.defaultColor",f.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.TabStopWidth="terminal.integrated.tabStopWidth",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorStyleInactive="terminal.integrated.cursorStyleInactive",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.TabFocusMode="terminal.integrated.tabFocusMode",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoEnabled="terminal.integrated.localEchoEnabled",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.HideOnStartup="terminal.integrated.hideOnStartup",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover",f.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",f.AutoReplies="terminal.integrated.autoReplies",f.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",f.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",f.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",f.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",f.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",f.EnableImages="terminal.integrated.enableImages",f.SmoothScrolling="terminal.integrated.smoothScrolling",f.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",f.FocusAfterRun="terminal.integrated.focusAfterRun",f.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",f.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",f.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",f.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",f.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",f.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",f.DevMode="terminal.integrated.developer.devMode"})(C||(e.TerminalSettingId=C={}));var P;(function(f){f.PowerShell="pwsh",f.Bash="bash",f.Fish="fish",f.Sh="sh",f.Csh="csh",f.Ksh="ksh",f.Zsh="zsh"})(P||(e.PosixShellType=P={}));var d;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(d||(e.WindowsShellType=d={}));var u;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(u||(e.TitleEventSource=u={}));var b;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.PtyHostWindow="ptyHostWindow",f.Logger="logger",f.Heartbeat="heartbeat"})(b||(e.TerminalIpcChannels=b={}));var y;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions",f.Title="title",f.ShellType="shellType",f.HasChildProcesses="hasChildProcesses",f.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",f.OverrideDimensions="overrideDimensions",f.FailedShellIntegrationActivation="failedShellIntegrationActivation",f.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$cr=(0,S.$Xh)("ptyService");var p;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var l;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(l||(e.TerminalLocation=l={}));var v;(function(f){f.TerminalView="view",f.Editor="editor"})(v||(e.TerminalLocationString=v={}));var $;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})($||(e.LocalReconnectConstants=$={}));var w;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(w||(e.FlowControlConstants=w={}));var g;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var h;(function(f){f[f.Off=0]="Off",f[f.FinalTerm=1]="FinalTerm",f[f.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var a;(function(f){f[f.Unknown=0]="Unknown",f[f.Shutdown=1]="Shutdown",f[f.Process=2]="Process",f[f.User=3]="User",f[f.Extension=4]="Extension"})(a||(e.TerminalExitReason=a={})),e.$dr={Backend:"workbench.contributions.terminal.processBackend"};class k{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const o=this.b(i.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}s.$on.add(e.$dr.Backend,new k),e.$er=(0,S.$Xh)("localPtyService"),e.$fr=(0,S.$Xh)("terminalLogService")}),define(se[259],re([0,1,75,7,187,102]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.$lr=e.$kr=void 0;function C(p,l){const v=[{name:null,description:(0,s.localize)(0,null)}];return v.push(...p.map($=>({name:$.profileName,description:P($)}))),l&&v.push(...l.map($=>({name:$.title,description:d($)}))),{values:v.map($=>$.name),markdownDescriptions:v.map($=>$.description)}}e.$kr=C;function P(p){let l=`$(${M.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:S.$3j.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?l+=`
- args: "${p.args}"`:l+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(l+=`
- overrideName: ${p.overrideName}`),p.color&&(l+=`
- color: ${p.color}`),p.env&&(l+=`
- env: ${JSON.stringify(p.env)}`),l}function d(p){return`$(${M.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:S.$3j.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function u(p,l){if(!p&&!l)return!0;if(typeof p=="string"&&typeof l=="string")return p===l;if(Array.isArray(p)&&Array.isArray(l)){if(p.length!==l.length)return!1;for(let v=0;v<p.length;v++)if(p[v]!==l[v])return!1;return!0}return!1}e.$lr=u;function b(p,l){if(!p&&!l)return!0;if(!p||!l)return!1;if(M.ThemeIcon.isThemeIcon(p)&&M.ThemeIcon.isThemeIcon(l))return p.id===l.id&&p.color===l.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof l=="object"&&"light"in l&&"dark"in l){const v=p,$=l;if((A.URI.isUri(v.light)||y(v.light))&&(A.URI.isUri(v.dark)||y(v.dark))&&(A.URI.isUri($.light)||y($.light))&&(A.URI.isUri($.dark)||y($.dark)))return v.light.path===$.light.path&&v.dark.path===$.dark.path}if(A.URI.isUri(p)&&A.URI.isUri(l)||y(p)||y(l)){const v=p,$=l;return v.path===$.path&&v.scheme===$.scheme}return!1}e.$mr=b;function y(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.$nr=y}),define(se[260],re([0,1,75,4,186,58,43,259]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=e.$qr=e.$pr=e.$or=void 0,e.$or={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$pr={type:"string",enum:Array.from((0,S.$2j)(),w=>w.id),markdownEnumDescriptions:Array.from((0,S.$2j)(),w=>`$(${w.id})`)};const d={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$pr},color:{description:(0,s.localize)(3,null),...e.$or},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},u={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...d}},b={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...d}};function y(w){const g=w===2?"linux":w===1?"osx":"windows";return(0,s.localize)(7,null,(0,A.$h)(w),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const p={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:y(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...d}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...d}},{type:"null"},u]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:y(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...d}},{type:"null"},u]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:y(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...d}},{type:"null"},u]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){C.$on.as(M.$tn.Configuration).registerConfiguration(p),$()}e.$qr=l;let v;function $(w,g){const h=C.$on.as(M.$tn.Configuration);let a;w&&(a=(0,P.$kr)(w?.profiles,g));const k=v;v={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:w?.os===3?a?.values:void 0,markdownEnumDescriptions:w?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:w?.os===2?a?.values:void 0,markdownEnumDescriptions:w?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:w?.os===1?a?.values:void 0,markdownEnumDescriptions:w?.os===1?a?.markdownDescriptions:void 0}}},h.updateConfigurations({add:[v],remove:k?[k]:[]})}e.$rr=$}),define(se[261],re([0,1,28,13,38,9,4,35,25,12,21,124,257,256]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.$zr=void 0;function v(){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let n=0;return t&&t.length===4&&(n=parseInt(t[3])),n}e.$zr=v;async function $(t,n,c,m=P.env,D=b.Promises.exists){if(M.$hc(t))return await D(t)?t:void 0;if(n===void 0&&(n=P.cwd()),M.$lc(t)!=="."){const L=M.$ic(n,t);return await D(L)?L:void 0}const E=(0,s.$jn)(m,"PATH");if(c===void 0&&(0,u.$Cf)(E)&&(c=E.split(M.$sc)),c===void 0||c.length===0){const L=M.$ic(n,t);return await D(L)?L:void 0}for(const L of c){let F;if(M.$hc(L)?F=M.$ic(L,t):F=M.$ic(n,L,t),await D(F))return F;if(C.$i){let U=F+".com";if(await D(U)||(U=F+".exe",await D(U)))return U}}const R=M.$ic(n,t);return await D(R)?R:void 0}e.$Ar=$;function w(t,n,c,m,D){const I=C.$i&&(!n.windowsEnableConpty||v()<18309);if(!n.shellIntegration.enabled||!t.executable||t.isFeatureTerminal||t.hideFromUser||t.ignoreShellIntegration||I)return;const E=t.args,R=P.$cc==="win32"?M.$mc(t.executable).toLowerCase():M.$mc(t.executable),L=M.$lc(A.$ig.asFileUri("").fsPath);let F;const U={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(U.VSCODE_NONCE=n.shellIntegration.nonce),C.$i){if(R==="pwsh.exe"||R==="powershell.exe")return!E||o(E)?F=a.get(h.WindowsPwsh):i(E)&&(F=a.get(h.WindowsPwshLogin)),F?(F=[...F],F[F.length-1]=(0,d.$Ge)(F[F.length-1],L,""),{newArgs:F,envMixin:U}):void 0;m.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args);return}switch(R){case"bash":return!E||E.length===0?F=a.get(h.Bash):r(E)&&(U.VSCODE_SHELL_LOGIN="1",g(n,U),F=a.get(h.Bash)),F?(F=[...F],F[F.length-1]=(0,d.$Ge)(F[F.length-1],L),{newArgs:F,envMixin:U}):void 0;case"fish":{const x=c?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",Y=M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return U.XDG_DATA_DIRS=`${x}:${Y}`,g(n,U),{newArgs:void 0,envMixin:U}}case"pwsh":return!E||o(E)?F=a.get(h.Pwsh):i(E)&&(F=a.get(h.PwshLogin)),F?(F=[...F],F[F.length-1]=(0,d.$Ge)(F[F.length-1],L,""),{newArgs:F,envMixin:U}):void 0;case"zsh":{if(!E||E.length===0?F=a.get(h.Zsh):r(E)?(F=a.get(h.ZshLogin),g(n,U)):(E===a.get(h.Zsh)||E===a.get(h.ZshLogin))&&(F=E),!F)return;F=[...F],F[F.length-1]=(0,d.$Ge)(F[F.length-1],L);let x;try{x=S.userInfo().username}catch{x="unknown"}const Y=M.$ic(S.tmpdir(),`${x}-${D.applicationName}-zsh`);U.ZDOTDIR=Y;const ae=c?.ZDOTDIR??S.homedir()??"~";U.USER_ZDOTDIR=ae;const oe=[];return oe.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$ic(Y,".zshrc")}),oe.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$ic(Y,".zprofile")}),oe.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$ic(Y,".zshenv")}),oe.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$ic(Y,".zlogin")}),{newArgs:F,envMixin:U,filesToCopy:oe}}}m.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args)}e.$Br=w;function g(t,n){if(C.$j&&t.environmentVariableCollections){const c=(0,p.$xr)(t.environmentVariableCollections),D=new l.$yr(c).getVariableMap({workspaceFolder:t.workspaceFolder}).get("PATH"),I=[];if(D)for(const E of D)E.type===y.EnvironmentVariableMutatorType.Prepend&&I.push(E.value);I.length>0&&(n.VSCODE_PATH_PREFIX=I.join(""))}}var h;(function(t){t.WindowsPwsh="windows-pwsh",t.WindowsPwshLogin="windows-pwsh-login",t.Pwsh="pwsh",t.PwshLogin="pwsh-login",t.Zsh="zsh",t.ZshLogin="zsh-login",t.Bash="bash"})(h||(h={}));const a=new Map;a.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),a.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),a.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),a.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),a.set(h.Zsh,["-i"]),a.set(h.ZshLogin,["-il"]),a.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const k=["-login","-l"],f=["-nol","-nologo"];function i(t){return typeof t=="string"?k.includes(t.toLowerCase()):t.length===1&&k.includes(t[0].toLowerCase())||t.length===2&&(k.includes(t[0].toLowerCase())||k.includes(t[1].toLowerCase()))&&(f.includes(t[0].toLowerCase())||f.includes(t[1].toLowerCase()))}function o(t){return typeof t=="string"?f.includes(t.toLowerCase()):t.length===0||t?.length===1&&f.includes(t[0].toLowerCase())}function r(t){return t==="string"&&k.includes(t.toLowerCase())||typeof t!="string"&&t.length===1&&k.includes(t[0].toLowerCase())}}),define(se[262],re([0,1,48,75,9,4,12,21,106,261,113]),function(J,e,S,A,s,M,C,P,d,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;var y;(function(c){c.UnixShellsPath="/etc/shells"})(y||(y={}));let p,l=!0;function v(c,m,D,I,E=process.env,R,L,F,U){return R=R||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},M.$i?$(D,R,E,L,I.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:I.getValue("terminal.integrated.profiles.windows"),typeof m=="string"?m:I.getValue("terminal.integrated.defaultProfile.windows"),U,F):r(R,L,D,c&&typeof c=="object"?{...c}:I.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof m=="string"?m:I.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),U,F,E)}e.$Cr=v;async function $(c,m,D,I,E,R,L,F,U){const x=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),Y=`${process.env.windir}\\${x?"Sysnative":"System32"}`;let ae=!1;(0,u.$zr)()>=16299&&(ae=!0),await a(F);const oe=new Map;if(c){oe.set("PowerShell",{source:"PowerShell",icon:A.$3j.terminalPowershell,isAutoDetected:!0}),oe.set("Windows PowerShell",{path:`${Y}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.$3j.terminalPowershell,isAutoDetected:!0}),oe.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),oe.set("Command Prompt",{path:`${Y}\\cmd.exe`,icon:A.$3j.terminalCmd,isAutoDetected:!0}),oe.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),oe.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:A.$3j.terminalBash,isAutoDetected:!0});const Q=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;oe.set("Cmder",{path:`${Y}\\cmd.exe`,args:["/K",Q],requiresPath:process.env.CMDER_ROOT?Q:{path:Q,isUnsafe:!0},isAutoDetected:!0})}t(R,oe);const ce=await w(oe.entries(),L,m,D,I,U);if(c&&E)try{const Q=await i(`${Y}\\${ae?"wsl":"bash"}.exe`,L);for(const K of Q)(!R||!(K.profileName in R))&&ce.push(K)}catch{l&&(I?.info("WSL is not installed, so could not detect WSL profiles"),l=!1)}return ce}async function w(c,m,D,I=process.env,E,R){const L=[];for(const[F,U]of c)L.push(g(F,U,m,D,I,E,R));return(await Promise.all(L)).filter(F=>!!F)}async function g(c,m,D,I,E=process.env,R,L){if(m===null)return;let F,U,x;if("source"in m&&!("path"in m)){const ce=p?.get(m.source);if(!ce)return;F=ce.paths,U=m.args||ce.args,m.icon?x=h(m.icon):ce.icon&&(x=ce.icon)}else F=Array.isArray(m.path)?m.path:[m.path],U=M.$i||Array.isArray(m.args)?m.args:void 0,x=h(m.icon);let Y;if(L){const ce=F.map(K=>typeof K=="string"?K:K.path),Q=await L(ce);Y=new Array(F.length);for(let K=0;K<F.length;K++)typeof F[K]=="string"?Y[K]=Q[K]:Y[K]={path:Q[K],isUnsafe:!0}}else Y=F.slice();let ae;if(m.requiresPath){let ce;if((0,C.$Cf)(m.requiresPath)?ce=m.requiresPath:(ce=m.requiresPath.path,m.requiresPath.isUnsafe&&(ae=ce)),!await I.existsFile(ce))return}const oe=await n(c,D,Y,I,E,U,m.env,m.overrideName,m.isAutoDetected,ae);if(!oe){R?.debug("Terminal profile not validated",c,F);return}return oe.isAutoDetected=m.isAutoDetected,oe.icon=x,oe.color=m.color,oe}function h(c){return typeof c=="string"?{id:c}:c}async function a(c){if(p&&!c)return;const[m,D]=await Promise.all([k(),c||f()]);p=new Map,p.set("Git Bash",{profileName:"Git Bash",paths:m,args:["--login","-i"]}),p.set("PowerShell",{profileName:"PowerShell",paths:D,icon:A.$3j.terminalPowershell})}async function k(){const c=new Set,m=await(0,u.$Ar)("git.exe");if(m){const E=(0,b.dirname)(m);c.add((0,b.resolve)(E,"../.."))}function D(E,R){R&&E.add(R)}D(c,process.env.ProgramW6432),D(c,process.env.ProgramFiles),D(c,process.env["ProgramFiles(X86)"]),D(c,`${process.env.LocalAppData}\\Program`);const I=[];for(const E of c)I.push(`${E}\\Git\\bin\\bash.exe`,`${E}\\Git\\usr\\bin\\bash.exe`,`${E}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function f(){const c=[];for await(const m of(0,d.$Fl)())c.push(m.exePath);return c}async function i(c,m){const D=[],I=await new Promise((L,F)=>{S.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(U,x)=>{if(U)return F("Problem occurred when getting wsl distros");L(x)})});if(!I)return[];const E=new RegExp(/[\r?\n]/),R=I.split(E).filter(L=>L.trim().length>0&&L!=="");for(const L of R){if(L===""||L.startsWith("docker-desktop"))continue;const F=`${L} (WSL)`,U={profileName:F,path:c,args:["-d",`${L}`],isDefault:F===m,icon:o(L),isAutoDetected:!1};D.push(U)}return D}function o(c){return c.includes("Ubuntu")?A.$3j.terminalUbuntu:c.includes("Debian")?A.$3j.terminalDebian:A.$3j.terminalLinux}async function r(c,m,D,I,E,R,L,F){const U=new Map;if(D&&await c.existsFile("/etc/shells")){const x=(await c.readFile("/etc/shells")).toString(),Y=(R||x.split(`
`)).map(oe=>{const ce=oe.indexOf("#");return ce===-1?oe:oe.substring(0,ce)}).filter(oe=>oe.trim().length>0),ae=new Map;for(const oe of Y){let ce=(0,s.$mc)(oe),Q=ae.get(ce)||0;Q++,Q>1&&(ce=`${ce} (${Q})`),ae.set(ce,Q),U.set(ce,{path:oe,isAutoDetected:!0})}}return t(I,U),await w(U.entries(),E,c,F,m,L)}function t(c,m){if(c)for(const[D,I]of Object.entries(c))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?m.delete(D):(I.icon=I.icon||m.get(D)?.icon,m.set(D,I))}async function n(c,m,D,I,E,R,L,F,U,x){if(D.length===0)return Promise.resolve(void 0);const Y=D.shift();if(Y==="")return n(c,m,D,I,E,R,L,F,U);const ae=typeof Y!="string"&&Y.isUnsafe,oe=typeof Y=="string"?Y:Y.path,ce={profileName:c,path:oe,args:R,env:L,overrideName:F,isAutoDetected:U,isDefault:c===m,isUnsafePath:ae,requiresUnsafePath:x};if((0,s.$mc)(oe)===oe){const K=E.PATH?E.PATH.split(s.$sc):void 0,V=await(0,u.$Ar)(oe,void 0,K,void 0,I.existsFile);return V?(ce.path=V,ce.isFromPath=!0,ce):n(c,m,D,I,E,R)}return await I.existsFile((0,s.$gc)(oe))?ce:n(c,m,D,I,E,R,L,F,U)}}),define(se[263],re([0,1,3,2,4,42,17,5,226,94,258,125,260,262,108,73]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;var w;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let g=class extends A.$Rc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(a,k,f,i){super(),this.M=a,this.N=k,this.O=f,this.P=i,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new S.$Rd),this.onPtyHostExit=this.u.event,this.w=this.B(new S.$Rd),this.onPtyHostStart=this.w.event,this.y=this.B(new S.$Rd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new S.$Rd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new S.$Rd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new S.$Rd),this.onProcessData=this.D.event,this.F=this.B(new S.$Rd),this.onProcessReady=this.F.event,this.G=this.B(new S.$Rd),this.onProcessReplay=this.G.event,this.H=this.B(new S.$Rd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new S.$Rd),this.onDidRequestDetach=this.I.event,this.J=this.B(new S.$Rd),this.onDidChangeProperty=this.J.event,this.L=this.B(new S.$Rd),this.onProcessExit=this.L.event,(0,p.$qr)(),this.B(this.M),this.B((0,A.$Pc)(()=>this.W())),this.j=this.B(new b.$jr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&S.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,u.$2l)(this.N,this.O,{_:[]},process.env)}catch(a){return this.O.error("ptyHost was unable to resolve shell environment",a),{}}}U(){const a=this.M.start(),k=a.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(k.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(a.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=w.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const i=M.ProxyChannel.toService(k.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(i.onProcessData(o=>this.D.fire(o))),this.B(i.onProcessReady(o=>this.F.fire(o))),this.B(i.onProcessExit(o=>this.L.fire(o))),this.B(i.onDidChangeProperty(o=>this.J.fire(o))),this.B(i.onProcessReplay(o=>this.G.fire(o))),this.B(i.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(i.onDidRequestDetach(o=>this.I.fire(o))),this.B(new d.$ir(this.P,k.getChannel(y.TerminalIpcChannels.Logger))),this.a=a,this.b=i,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[a,i]}async createProcess(a,k,f,i,o,r,t,n,c,m,D){const I=setTimeout(()=>this.$(),y.HeartbeatConstants.CreateProcessTimeout),E=await this.f.createProcess(a,k,f,i,o,r,t,n,c,m,D);return clearTimeout(I),E}updateTitle(a,k,f){return this.f.updateTitle(a,k,f)}updateIcon(a,k,f,i){return this.f.updateIcon(a,k,f,i)}attachToProcess(a){return this.f.attachToProcess(a)}detachFromProcess(a,k){return this.f.detachFromProcess(a,k)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(a){return this.f.start(a)}shutdown(a,k){return this.f.shutdown(a,k)}input(a,k){return this.f.input(a,k)}processBinary(a,k){return this.f.processBinary(a,k)}resize(a,k,f){return this.f.resize(a,k,f)}clearBuffer(a){return this.f.clearBuffer(a)}acknowledgeDataEvent(a,k){return this.f.acknowledgeDataEvent(a,k)}setUnicodeVersion(a,k){return this.f.setUnicodeVersion(a,k)}getInitialCwd(a){return this.f.getInitialCwd(a)}getCwd(a){return this.f.getCwd(a)}async getLatency(){const a=new $.$Nd,k=await this.f.getLatency();return a.stop(),[{label:"ptyhostservice<->ptyhost",latency:a.elapsed()},...k]}orphanQuestionReply(a){return this.f.orphanQuestionReply(a)}installAutoReply(a,k){return this.f.installAutoReply(a,k)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(a){return this.f.uninstallAutoReply(a)}getDefaultSystemShell(a){return this.g?.getDefaultSystemShell(a)??(0,v.$Ll)(a??s.OS,process.env)}async getProfiles(a,k,f,i=!1){const o=await this.S();return(0,l.$Cr)(k,f,i,this.N,o,void 0,this.O,this.bb.bind(this,a))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(a,k){return this.f.getWslPath(a,k)}getRevivedPtyNewId(a,k){return this.f.getRevivedPtyNewId(a,k)}setTerminalLayoutInfo(a){return this.f.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return this.g?.getTerminalLayoutInfo(a)}async requestDetachInstance(a,k){return this.f.requestDetachInstance(a,k)}async acceptDetachInstanceReply(a,k){return this.f.acceptDetachInstanceReply(a,k)}async freePortKillProcess(a){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(a)}async serializeTerminalState(a){return this.f.serializeTerminalState(a)}async reviveTerminalProcesses(a,k,f){return this.f.reviveTerminalProcesses(a,k,f)}async refreshProperty(a,k){return this.f.refreshProperty(a,k)}async updateProperty(a,k,f){return this.f.updateProperty(a,k,f)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(a){this.ab(),this.s=setTimeout(()=>this.Y(),a?y.HeartbeatConstants.ConnectingBeatInterval:y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(a,k){return this.j.createRequest({workspaceId:a,originalText:k})}async acceptPtyHostResolvedVariables(a,k){this.j.acceptReply(a,k)}};e.$Dr=g,e.$Dr=g=ve([te(1,C.$ri),te(2,P.$fj),te(3,P.$gj)],g)}),define(se[69],re([0,1,15,3,2,4,17,6,34]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m8b=e.$l8b=void 0;const u="#FFFFFF",b="#1E1E1E",y="#000000",p="#FFFFFF",l="theme",v="themeBackground",$="windowSplash";e.$l8b=(0,P.$Xh)("themeMainService");let w=class extends s.$Rc{constructor(h,a){super(),this.b=h,this.c=a,this.a=this.B(new A.$Rd),this.onDidChangeColorScheme=this.a.event,S.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.$i){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const h=this.getColorScheme();if(h.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return h.dark?y:p;let a=this.b.getItem(v,null);if(!a)switch(this.b.getItem(l,"vs-dark").split(" ")[0]){case"vs":a=u;break;case"hc-black":a=y;break;case"hc-light":a=p;break;default:a=b}return M.$j&&a.toUpperCase()===b&&(a="#171717"),a}saveWindowSplash(h,a){this.b.setItems([{key:l,data:a.baseTheme},{key:v,data:a.colorInfo.background},{key:$,data:a}]),typeof h=="number"&&this.f(h,a)}f(h,a){for(const k of S.BrowserWindow.getAllWindows())if(k.id===h){k.setBackgroundColor(a.colorInfo.background);break}}getWindowSplash(){return this.b.getItem($)}};e.$m8b=w,e.$m8b=w=ve([te(0,d.$QN),te(1,C.$ri)],w)}),define(se[126],re([0,1,3,17,6,5]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.ProvidedOnAutoForward=e.$hv=e.TunnelPrivacyId=e.TunnelProtocol=e.$gv=e.$fv=void 0,e.$fv=(0,s.$Xh)("tunnelService"),e.$gv=(0,s.$Xh)("sharedTunnelsService");var C;(function(w){w.Http="http",w.Https="https"})(C||(e.TunnelProtocol=C={}));var P;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(P||(e.TunnelPrivacyId=P={}));function d(w){return!!w.forwardPort}e.$hv=d;var u;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function b(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(g)return{address:g[1],port:+g[2]}}e.$iv=b,e.$jv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(w){return e.$jv.indexOf(w)>=0}e.$kv=y,e.$lv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(w){return e.$lv.indexOf(w)>=0}e.$mv=p;function l(w,g,h,a){if(h===1)return!1;if(h===2&&p(g)){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(k?.length===4&&parseInt(k[1])>=18)return!1}return w<1024}e.$nv=l;class v{constructor(g,h,a){this.remoteAddress=g,this.localAddress=h,this.b=a,this.a=new S.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$ov=v;let $=class{constructor(g,h){this.j=g,this.k=h,this.a=new S.$Rd,this.onTunnelOpened=this.a.event,this.b=new S.$Rd,this.onTunnelClosed=this.b.event,this.c=new S.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const g=this.k.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this.f=g,g?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this.g=g.elevation,this.h=g.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const g=[],h=Array.from(this.e.values());for(const a of h){const k=Array.from(a.values());for(const f of k){const i=await f.value;i&&typeof i!="string"&&g.push(i)}}return g}async dispose(){for(const g of this.e.values()){for(const{value:h}of g.values())await h.then(a=>typeof a!="string"?a?.dispose():void 0);g.clear()}this.e.clear()}setEnvironmentTunnel(g,h,a,k,f){this.p(g,h,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:h,localAddress:a,privacy:k,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,h){(p(g)||y(g))&&(g=e.$jv[0]);const a=this.r(g,h);if(a)return++a.refcount,a.value}openTunnel(g,h,a,k,f,i=!1,o,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${a} on local port ${f}.`);const t=this.f??g;if(!t)return;if(h||(h="localhost"),k||(k=this.l),this.f&&this.i.has(a)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(t,h,a,k,f,i,o,r);return n?n.then(c=>{if(c){if(typeof c=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(h,a),c}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(h,a);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.n(c);return(c.tunnelRemoteHost!==h||c.tunnelRemotePort!==a)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&c.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(m),m}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const h=this.e.get(g.tunnelRemoteHost);if(h){const a=h.get(g.tunnelRemotePort);a&&(a.refcount--,await this.o(g.tunnelRemoteHost,g.tunnelRemotePort,a))}}}}async o(g,h,a){if(a.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${h}.`);const k=a.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(g)&&this.e.get(g).delete(h),k}}async closeTunnel(g,h){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${h} `);const a=this.e.get(g);if(a&&a.has(h)){const k=a.get(h);k.refcount=0,await this.o(g,h,k)}}p(g,h,a){this.e.has(g)||this.e.set(g,new Map),this.e.get(g).set(h,{refcount:1,value:a})}async q(g,h){const a=this.e.get(g);if(a){const k=a.get(h),f=k?await k.value:void 0;(!f||typeof f=="string")&&a.delete(h),a.size===0&&this.e.delete(g)}}r(g,h){const a=[g];y(g)?(a.push(...e.$jv),a.push(...e.$lv)):p(g)&&a.push(...e.$lv);const k=a.map(f=>this.e.get(f));for(const f of k){const i=f?.get(h);if(i)return i}}canTunnel(g){return!!b(g)}t(g,h,a,k,f,i,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${a} on local port ${k}.`);const r=a;this.i.add(r);const t=k===void 0?a:k,n={elevationRequired:f?this.isPortPrivileged(t):!1},c={remoteAddress:{host:h,port:a},localAddressPort:k,privacy:i,public:i?i!==P.Private:void 0,protocol:o},m=g.forwardPort(c,n);return m?(this.p(h,a,m),m.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),m}};e.$pv=$,e.$pv=$=ve([te(0,M.$fj),te(1,A.$ri)],$)}),define(se[49],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WU=e.$VU=e.DisablementReason=e.UpdateType=e.StateType=void 0;var A;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.Disabled="disabled",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(A||(e.StateType=A={}));var s;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(C){C[C.NotBuilt=0]="NotBuilt",C[C.DisabledByEnvironment=1]="DisabledByEnvironment",C[C.ManuallyDisabled=2]="ManuallyDisabled",C[C.MissingConfiguration=3]="MissingConfiguration",C[C.InvalidConfiguration=4]="InvalidConfiguration",C[C.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$VU={Uninitialized:{type:"uninitialized"},Disabled:C=>({type:"disabled",reason:C}),Idle:(C,P)=>({type:"idle",updateType:C,error:P}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.$WU=(0,S.$Xh)("updateService")}),define(se[264],re([0,1,4,188,58,43]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$on.as(s.$tn.Configuration).registerConfiguration({id:"update",order:15,title:(0,A.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,A.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,A.localize)(2,null),(0,A.localize)(3,null),(0,A.localize)(4,null),(0,A.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,A.localize)(6,null),deprecationMessage:(0,A.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,A.localize)(8,null),description:(0,A.localize)(9,null),included:S.$i&&!S.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,A.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(se[265],re([0,1,3,49]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v9b=e.$u9b=void 0;class s{constructor(P){this.a=P}listen(P,d){switch(d){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${d}`)}call(P,d,u){switch(d){case"checkForUpdates":return this.a.checkForUpdates(u);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(u)}throw new Error(`Call not found: ${d}`)}}e.$u9b=s;class M{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new S.$Rd,this.onStateChange=this.a.event,this.b=A.$VU.Uninitialized,this.c.listen("onStateChange")(d=>this.state=d),this.c.call("_getInitialState").then(d=>this.state=d)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.$v9b=M}),define(se[40],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=void 0,e.$Qk=(0,S.$Xh)("IUriIdentityService")}),define(se[266],re([0,1,40,207,16,19,141,3,2]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=void 0;class u{static{this._clock=0}constructor(p){this.uri=p,this.time=u._clock++}touch(){return this.time=u._clock++,this}}let b=class{constructor(p){this.g=p,this.c=new d.$Qc,this.f=2**16;const l=new Map,v=$=>{let w=l.get($.scheme);return w===void 0&&(w=p.hasProvider($)&&!this.g.hasCapability($,1024),l.set($.scheme,w)),w};this.c.add(P.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)($=>{l.delete($.scheme)})),this.extUri=new M.$qg(v),this.d=new C.$Gr(($,w)=>this.extUri.compare($,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,M.$Cg)(p));const l=this.d.get(p);return l?l.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new u(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((v,$)=>v[1].time<$[1].time?1:v[1].time>$[1].time?-1:0);u._clock=0,this.d.clear();const l=this.f*.5;for(let v=0;v<l;v++)this.d.set(p[v][0],p[v][1].touch())}};e.$Hr=b,e.$Hr=b=ve([te(0,s.$gk)],b),(0,A.$Er)(S.$Qk,b,1)}),define(se[127],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MU=void 0,e.$MU=(0,S.$Xh)("urlService")}),define(se[267],re([0,1,7]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E9b=e.$D9b=e.$C9b=void 0;class A{constructor(P){this.a=P}listen(P,d){throw new Error(`Event not found: ${d}`)}call(P,d,u){switch(d){case"handleURL":return this.a.handleURL(S.URI.revive(u[0]),u[1])}throw new Error(`Call not found: ${d}`)}}e.$C9b=A;class s{constructor(P){this.a=P}handleURL(P,d){return this.a.call("handleURL",[P.toJSON(),d])}}e.$D9b=s;class M{constructor(P,d){this.a=P,this.b=d}async routeCall(P,d,u,b){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(Array.isArray(u)&&u.length>0){const y=S.URI.revive(u[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",y.toString(!0)),y.query){const p=/\bwindowId=(\d+)/.exec(y.query);if(p){const l=p[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${l}"`,y.toString(!0));const v=new RegExp(`window:${l}`),$=P.connections.find(w=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",w.ctx),v.test(w.ctx)));if($)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",y.toString(!0)),$;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",y.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",y.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,d,u,b)}routeEvent(P,d){throw new Error(`Event not found: ${d}`)}}e.$E9b=M}),define(se[268],re([0,1,8,2,7,26]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OU=e.$NU=void 0;class C extends A.$Rc{constructor(){super(...arguments),this.a=new Set}open(u,b){const y=[...this.a.values()];return(0,S.$4g)(y.map(p=>()=>p.handleURL(u,b)),void 0,!1).then(p=>p||!1)}registerHandler(u){return this.a.add(u),(0,A.$Pc)(()=>this.a.delete(u))}}e.$NU=C;let P=class extends C{constructor(u){super(),this.b=u}create(u){let{authority:b,path:y,query:p,fragment:l}=u||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&y&&y.indexOf("/")!==0&&(y=`/${y}`),s.URI.from({scheme:this.b.urlProtocol,authority:b,path:y,query:p,fragment:l})}};e.$OU=P,e.$OU=P=ve([te(0,M.$xj)],P)}),define(se[269],re([0,1,15,8,3,2,4,7]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F9b=void 0;class d extends M.$Rc{constructor(b,y,p,l,v,$){if(super(),this.c=y,this.f=$,this.a=[],this.b=0,b&&($.trace("ElectronURLListener initialUrisToHandle:",b.map(h=>h.originalUrl)),this.a=b),C.$i){const h=l.isBuilt?[]:[`"${l.appRoot}"`];h.push("--open-url","--"),S.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,h)}const w=s.Event.map(s.Event.fromNodeEventEmitter(S.app,"open-url",(h,a)=>({event:h,url:a})),({event:h,url:a})=>(h.preventDefault(),a));this.B(w(h=>{const a=this.g(h);a&&this.c.open(a,{originalUrl:h})})),p.getWindows().filter(h=>h.isReady).length>0?($.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):($.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(p.onDidSignalReadyWindow)(()=>this.h())))}g(b){try{return P.URI.parse(b)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const b=[];for(const y of this.a)await this.c.open(y.uri,{originalUrl:y.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",y.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",y.originalUrl),b.push(y));b.length!==0&&(this.a=b,(0,A.$2g)(()=>this.h(),500,this.q))}}e.$F9b=d}),define(se[270],re([0,1,3,2,16,57,31]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g0b=void 0;class P extends A.$Rc{constructor(u,b,y,p,l,v){super(),this.f=u,this.g=b,this.h=y,this.j=p,this.m=l,this.n=v,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$Rd),this.onDidChangeFile=this.a.event,this.b=M.$4h.forUris(()=>!(this.capabilities&1024)),this.c=new C.$Ac($=>this.m.extUri.getComparisonKey(this.t($))),this.r(),this.B(p.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile($=>this.s($)))}r(){this.c.clear();for(const u of this.j.profiles)this.c.add(u.settingsResource),this.c.add(u.keybindingsResource),this.c.add(u.tasksResource),this.c.add(u.extensionsResource)}open(u,b){return this.g.open(this.t(u),b)}close(u){return this.g.close(u)}read(u,b,y,p,l){return this.g.read(u,b,y,p,l)}write(u,b,y,p,l){return this.g.write(u,b,y,p,l)}watch(u,b){this.b.set(u,u);const y=this.g.watch(this.t(u),b);return(0,A.$Pc)(()=>{this.b.delete(u),y.dispose()})}stat(u){return this.g.stat(this.t(u))}mkdir(u){return this.g.mkdir(this.t(u))}rename(u,b,y){return this.g.rename(this.t(u),this.t(b),y)}readFile(u,b){return this.g.readFile(this.t(u),b)}readFileStream(u,b,y){return this.g.readFileStream(this.t(u),b,y)}readdir(u){return this.g.readdir(this.t(u))}enforceAtomicReadFile(u){return this.c.has(u)}writeFile(u,b,y){return this.g.writeFile(this.t(u),b,y)}enforceAtomicWriteFile(u){return this.c.has(u)?{postfix:".vsctmp"}:!1}delete(u,b){return this.g.delete(this.t(u),b)}copy(u,b,y){if((0,s.$kk)(this.g))return this.g.copy(this.t(u),this.t(b),y);throw new Error("copy not supported")}cloneFile(u,b){if((0,s.$lk)(this.g))return this.g.cloneFile(this.t(u),this.t(b));throw new Error("clone not supported")}s(u){const b=[];for(const y of u){if(y.resource.scheme!==this.f)continue;const p=this.u(y.resource);this.b.findSubstr(p)&&b.push({resource:p,type:y.type,cId:y.cId})}b.length&&(this.n.debug("User data changed"),this.a.fire(b))}t(u){return u.with({scheme:this.f})}u(u){return u.with({scheme:this.h})}}e.$g0b=P}),define(se[271],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z9b=void 0,e.$Z9b="utilityProcessWorker"}),define(se[272],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G9b=void 0,e.$G9b=(0,S.$Xh)("webviewManagerService")}),define(se[273],re([0,1,15,2,13,7]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H9b=void 0;class C extends A.$Rc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const d=this.b.bind(this);S.protocol.registerFileProtocol(s.Schemas.vscodeWebview,d)}b(d,u){try{const b=M.URI.parse(d.url),y=C.a.get(b.path);if(typeof y=="string"){const p=`vs/workbench/contrib/webview/browser/pre/${y}`,l=s.$ig.asFileUri(p);return u({path:l.fsPath,headers:{...s.COI.getHeadersFromQuery(d.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return u({error:-10})}catch{}return u({error:-2})}}e.$H9b=C}),define(se[60],re([0,1,4]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wC=e.$vC=e.$uC=e.$tC=e.$sC=e.$rC=e.$qC=e.$pC=e.$oC=void 0,e.$oC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(y){return typeof y.parentId=="number"}e.$pC=A;function s(y){return!!y.workspaceUri}e.$qC=s;function M(y){return!!y.folderUri}e.$rC=M;function C(y){return!!y.fileUri}e.$sC=C;function P(y){const p=d(y),l=y.getValue("window.menuBarVisibility");return l==="default"||p==="native"&&l==="compact"||S.$j&&S.$m?"classic":l}e.$tC=P;function d(y){if(S.$o)return"custom";const p=y.getValue("window");if(p){if(S.$j&&p.nativeTabs===!0||S.$j&&p.nativeFullScreen===!1)return"native";const $=p.titleBarStyle;if($==="native"||$==="custom")return $}return S.$k?"native":"custom"}e.$uC=d;function u(y){return!(!S.$i||S.$o||d(y)==="native")}e.$vC=u;function b(y=0){return Math.pow(1.2,y)}e.$wC=b}),define(se[128],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$97b=e.UnloadReason=e.LoadReason=void 0;var S;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(S||(e.LoadReason=S={}));var A;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(A||(e.UnloadReason=A={}));const s=function(P=1){return{width:1024,height:768,mode:P}};e.$97b=s;var M;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var C;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(C||(e.WindowError=C={}))}),define(se[274],re([0,1,8,3,2]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N9b=void 0;class M extends s.$Rc{constructor({onDidOpenMainWindow:P,onDidFocusMainWindow:d,getActiveWindowId:u}){super(),this.a=this.B(new s.$Qc),A.Event.latch(A.Event.any(P,d))(this.f,this,this.a),this.b=(0,S.$Ng)(()=>u()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$N9b=M}),define(se[30],re([0,1,192,9,57,19,7,6,13]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.WorkbenchState=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=void 0,e.$7h=(0,P.$Xh)("contextService");function u(t){const n=t;return typeof n?.id=="string"&&C.URI.isUri(n.uri)}e.$8h=u;function b(t){return typeof t?.id=="string"&&!u(t)&&!p(t)}e.$9h=b,e.$0h={id:"ext-dev"},e.$$h={id:"empty-window"};function y(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,A.$mc)(t)}:n?e.$0h:e.$$h;const c=t;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.$_h=y;function p(t){const n=t;return typeof n?.id=="string"&&C.URI.isUri(n.configPath)}e.$ai=p;function l(t){const n=t;if(n?.uri)return{id:n.id,uri:C.URI.revive(n.uri)};const c=t;if(c?.configPath)return{id:c.id,configPath:C.URI.revive(c.configPath)};if(t?.id)return{id:t.id}}e.$bi=l;var v;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function $(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$ci=$;function w(t){const n=t;return!!(n&&typeof n=="object"&&C.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$di=w;class g{constructor(n,c,m,D,I){this.h=n,this.j=m,this.k=D,this.l=I,this.c=s.$4h.forUris(this.l,()=>!0),this.folders=c}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$4h.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ei=g;class h{constructor(n,c){this.raw=c,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$Bg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$fi=h;function a(t){return new h({uri:t,index:0,name:(0,M.$xg)(t)},{uri:t.toString()})}e.$gi=a,e.$hi="code-workspace",e.$ii=`.${e.$hi}`,e.$ji=[{name:(0,S.localize)(0,null),extensions:[e.$hi]}],e.$ki="workspace.json";function k(t,n){return M.$sg.isEqualOrParent(t,n.untitledWorkspacesHome)}e.$li=k;function f(t){let n;return C.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===d.Schemas.tmp}e.$mi=f,e.$ni="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.$ni}e.$oi=i;function o(t,n){return!k(t,n)&&!f(t)}e.$pi=o;function r(t){return(typeof t=="string"?(0,A.$nc)(t):(0,M.$zg)(t))===e.$ii}e.$qi=r}),define(se[53],re([0,1,15,8,45,47,2,85,4,21,167,115,6,5,26,30]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s8b=e.$r8b=void 0,e.$r8b=(0,p.$Xh)("dialogMainService");let w=class{constructor(h,a){this.d=h,this.e=a,this.a=new Map,this.b=new Map,this.c=new A.$7g}pickFileFolder(h,a){return this.f({...h,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},a)}pickFolder(h,a){return this.f({...h,pickFolders:!0,title:(0,b.localize)(1,null)},a)}pickFile(h,a){return this.f({...h,pickFiles:!0,title:(0,b.localize)(2,null)},a)}pickWorkspace(h,a){const k=(0,b.localize)(3,null),f=(0,M.$Hv)((0,b.localize)(4,null)),i=$.$ji;return this.f({...h,pickFiles:!0,title:k,filters:i,buttonLabel:f},a)}async f(h,a){const k={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters,defaultPath:h.defaultPath};(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(k.properties=void 0,h.pickFiles&&h.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),d.$j&&k.properties.push("treatPackageAsDirectory");const f=await this.showOpenDialog(k,(a||S.BrowserWindow.getFocusedWindow())??void 0);if(f&&f.filePaths&&f.filePaths.length>0)return f.filePaths}g(h){if(h){let a=this.b.get(h.id);return a||(a=new A.$7g,this.b.set(h.id,a)),a}else return this.c}showMessageBox(h,a){return this.g(a).queue(async()=>{const{options:k,buttonIndeces:f}=(0,y.$Ov)(h,this.e);let i;return a?i=await S.dialog.showMessageBox(a,k):i=await S.dialog.showMessageBox(k),{response:f[i.response],checkboxChecked:i.checkboxChecked}})}async showSaveDialog(h,a){const k=this.j(h,a);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(a).queue(async()=>{let f;return a?f=await S.dialog.showSaveDialog(a,h):f=await S.dialog.showSaveDialog(h),f.filePath=this.h(f.filePath),f})}finally{(0,C.$Mc)(k)}}h(h){return h&&d.$j&&(h=(0,P.$wl)(h)),h}i(h){return h.map(a=>this.h(a))}async showOpenDialog(h,a){h.defaultPath&&(await u.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const k=this.j(h,a);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(a).queue(async()=>{let f;return a?f=await S.dialog.showOpenDialog(a,h):f=await S.dialog.showOpenDialog(h),f.filePaths=this.i(f.filePaths),f})}finally{(0,C.$Mc)(k)}}j(h,a){if(!a)return C.$Rc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",h);let k=this.a.get(a.id);k||(k=new Set,this.a.set(a.id,k));const f=(0,s.$Li)(h);if(!k.has(f))return this.d.trace("[DialogMainService]: new file dialog lock created",h),k.add(f),(0,C.$Pc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",h),k?.delete(f),k?.size===0&&this.a.delete(a.id)})}};e.$s8b=w,e.$s8b=w=ve([te(0,l.$fj),te(1,v.$xj)],w)}),define(se[275],re([0,1,3,2,77,30]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r9b=void 0;class C extends A.$Rc{static{this.a=100}constructor(d,u){super(),this.f=d,this.g=u,this.b=this.B(new S.$Rd),this.c=new Map,this.h(u.applicationStorage,this.b)}h(d,u){this.B(S.Event.debounce(d.onDidChangeStorage,(b,y)=>(b?b.push(y):b=[y],b),C.a)(b=>{b.length&&u.fire(this.j(b,d))}))}j(d,u){const b=new Map,y=new Set;return d.forEach(p=>{const l=u.get(p.key);typeof l=="string"?b.set(p.key,l):y.add(p.key)}),{changed:Array.from(b.entries()),deleted:Array.from(y.values())}}listen(d,u,b){switch(u){case"onDidChangeStorage":{const y=b.profile?(0,s.$uh)(b.profile):void 0;if(!y)return this.b.event;let p=this.c.get(y.id);return p||(p=this.B(new S.$Rd),this.h(this.g.profileStorage(y),p),this.c.set(y.id,p)),p.event}}throw new Error(`Event not found: ${u}`)}async call(d,u,b){const y=b.profile?(0,s.$uh)(b.profile):void 0,p=(0,M.$bi)(b.workspace),l=await this.m(y,p);switch(u){case"getItems":return Array.from(l.items.entries());case"updateItems":{const v=b;if(v.insert)for(const[$,w]of v.insert)l.set($,w);v.delete?.forEach($=>l.delete($));break}case"optimize":return l.optimize();case"isUsed":{const v=b.payload;if(typeof v=="string")return this.g.isUsed(v)}default:throw new Error(`Call not found: ${u}`)}}async m(d,u){let b;u?b=this.g.workspaceStorage(u):d?b=this.g.profileStorage(d):b=this.g.applicationStorage;try{await b.init()}catch(y){this.f.error(`StorageIPC#init: Unable to init ${u?"workspace":d?"profile":"application"} storage due to ${y}`)}return b}}e.$r9b=C}),define(se[41],re([0,1,45,3,2,19,7,189,37,16,6,5,30,31,40,8,32,25,12]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.ProfileResourceType=void 0;var a;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(a||(e.ProfileResourceType=a={}));function k(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&C.URI.isUri(n.location)&&C.URI.isUri(n.globalStorageHome)&&C.URI.isUri(n.settingsResource)&&C.URI.isUri(n.keybindingsResource)&&C.URI.isUri(n.tasksResource)&&C.URI.isUri(n.snippetsHome)&&C.URI.isUri(n.extensionsResource))}e.$Rk=k,e.$Sk=(0,b.$Xh)("IUserDataProfilesService");function f(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:C.URI.revive(t.location).with({scheme:n}),globalStorageHome:C.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:C.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:C.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:C.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:C.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:C.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:C.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.$Tk=f;function i(t,n,c,m,D,I){return{id:t,name:n,location:c,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:I&&D?.useDefaultFlags?.globalState?I.globalStorageHome:(0,M.$Bg)(c,"globalStorage"),settingsResource:I&&D?.useDefaultFlags?.settings?I.settingsResource:(0,M.$Bg)(c,"settings.json"),keybindingsResource:I&&D?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,M.$Bg)(c,"keybindings.json"),tasksResource:I&&D?.useDefaultFlags?.tasks?I.tasksResource:(0,M.$Bg)(c,"tasks.json"),snippetsHome:I&&D?.useDefaultFlags?.snippets?I.snippetsHome:(0,M.$Bg)(c,"snippets"),extensionsResource:I&&D?.useDefaultFlags?.extensions?I.extensionsResource:(0,M.$Bg)(c,"extensions.json"),cacheHome:(0,M.$Bg)(m,t),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.$Uk=i;let o=class extends s.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,c,m,D){super(),this.t=n,this.u=c,this.w=m,this.y=D,this.f=!0,this.h=this.B(new A.$Rd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$Rd),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$Rd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$Rd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new l.$zc,emptyWindows:new Map},this.profilesHome=(0,M.$Bg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$Bg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),c=[n];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,h.$Cf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}c.push(i((0,M.$yg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},n))}}catch(I){this.y.error(I)}const m=new l.$zc,D=new Map;if(c.length)try{const I=this.Q();if(I.workspaces)for(const[E,R]of Object.entries(I.workspaces)){const L=C.URI.parse(E),F=c.find(U=>U.id===R);F&&m.set(L,F)}if(I.emptyWindows)for(const[E,R]of Object.entries(I.emptyWindows)){const L=c.find(F=>F.id===R);L&&D.set(E,L)}}catch(I){this.y.error(I)}this.z={profiles:c,workspaces:m,emptyWindows:D}}return this.z}D(){const n=i("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const c="Temp",m=new RegExp(`${(0,g.$Je)(c)}\\s(\\d+)`);let D=0;for(const E of this.profiles){const R=m.exec(E.name),L=R?parseInt(R[1]):0;D=L>D?L:D}const I=`${c} ${D+1}`;return this.createProfile((0,S.$Li)((0,w.$kg)()).toString(16),I,{transient:!0},n)}async createNamedProfile(n,c,m){return this.createProfile((0,S.$Li)((0,w.$kg)()).toString(16),n,c,m)}async createProfile(n,c,m,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(n,c,m);return D&&await this.setProfileForWorkspace(D,I),I}async F(n,c,m){if(!(0,h.$Cf)(c)||!c)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(c);return D||(D=(async()=>{try{const I=this.profiles.find(L=>L.name===c||L.id===n);if(I)return I;const E=i(n,c,(0,M.$Bg)(this.profilesHome,n),this.g,m,this.defaultProfile);await this.u.createFolder(E.location);const R=[];return this.j.fire({profile:E,join(L){R.push(L)}}),await $.Promises.settled(R),this.I([E],[],[]),E}finally{this.r.delete(c)}})(),this.r.set(c,D)),D}async updateProfile(n,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let m=this.profiles.find(D=>D.id===n.id);if(!m)throw new Error(`Profile '${n.name}' does not exist`);return m=i(m.id,c.name??m.name,m.location,this.g,{shortName:c.shortName??m.shortName,icon:c.icon===null?void 0:c.icon??m.icon,transient:c.transient??m.isTransient,useDefaultFlags:c.useDefaultFlags??m.useDefaultFlags},this.defaultProfile),this.I([],[],[m]),m}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const c=this.profiles.find(D=>D.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);const m=[];this.m.fire({profile:c,join(D){m.push(D)}});try{await Promise.allSettled(m)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])c.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])c.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[c],[]);try{await this.u.del(c.cacheHome,{recursive:!0})}catch(D){(0,u.$xk)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(n,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=this.profiles.find(D=>D.id===c.id);if(!m)throw new Error(`Profile '${c.name}' does not exist`);this.L(n,m)}unsetWorkspace(n,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,c)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(c=>c.isDirectory&&this.profiles.every(m=>!this.w.extUri.isEqual(m.location,c.resource))).map(c=>this.u.del(c.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(c=>!this.H(c));await Promise.allSettled(n.map(c=>this.removeProfile(c)))}getProfileForWorkspace(n){const c=this.G(n);return C.URI.isUri(c)?this.s.workspaces.get(c)??this.C.workspaces.get(c):this.s.emptyWindows.get(c)??this.C.emptyWindows.get(c)}G(n){return(0,p.$8h)(n)?n.uri:(0,p.$ai)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,n.location))||[...this.s.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,n.location))||[...this.C.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,n.location))||[...this.C.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,n.location)))}I(n,c,m){const D=[...this.profiles,...n],I=[];this.s.profiles=[];for(let E of D)E.isDefault||c.some(R=>E.id===R.id)||(E=m.find(R=>E.id===R.id)??E,E.isTransient?this.s.profiles.push(E):I.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(I),this.z=void 0,this.J(n,c,m)}J(n,c,m){this.h.fire({added:n,removed:c,updated:m,all:this.profiles})}L(n,c,m){m=c?.isTransient?!0:m,m||this.L(n,void 0,!0);const D=this.G(n),I=m?this.s:this.C;C.URI.isUri(D)?(I.workspaces.delete(D),c&&I.workspaces.set(D,c)):(I.emptyWindows.delete(D),c&&I.emptyWindows.set(D,c)),m||this.M()}M(){const n={};for(const[m,D]of this.C.workspaces.entries())n[m.toString()]=D.id;const c={};for(const[m,D]of this.C.emptyWindows.entries())c[m.toString()]=D.id;this.R({workspaces:n,emptyWindows:c}),this.z=void 0}N(n){const c={},m=this.D();if(n.workspaces)for(const[I,E]of Object.entries(n.workspaces)){const R=C.URI.parse(E);c[I]=this.w.extUri.isEqual(R,m.location)?m.id:this.w.extUri.basename(R)}const D={};if(n.emptyWindows)for(const[I,E]of Object.entries(n.emptyWindows)){const R=C.URI.parse(E);D[I]=this.w.extUri.isEqual(R,m.location)?m.id:this.w.extUri.basename(R)}return{workspaces:c,emptyWindows:D}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Vk=o,e.$Vk=o=ve([te(0,d.$5h),te(1,u.$gk),te(2,v.$Qk),te(3,y.$fj)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Wk=r}),define(se[81],re([0,1,8,18,2,3,31,7,117,123,16,6,5,41,40,12,14,27]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class a extends Error{constructor(r,t){super(r),this.code=t}}e.$Bp=a,e.$Cp=(0,y.$Xh)("IExtensionsProfileScannerService");let k=class extends s.$Rc{constructor(r,t,n,c,m,D){super(),this.j=r,this.m=t,this.n=n,this.r=c,this.s=m,this.t=D,this.b=this.B(new M.$Rd),this.onAddExtensions=this.b.event,this.c=this.B(new M.$Rd),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$Rd),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$Rd),this.onDidRemoveExtensions=this.g.event,this.h=new C.$zc}scanProfileExtensions(r,t){return this.u(r,void 0,t)}async addExtensionsToProfile(r,t){const n=[],c=[];try{return await this.u(t,m=>{const D=[];for(const I of m)r.some(([E])=>(0,u.$Ho)(E.identifier,I.identifier)&&E.manifest.version!==I.version)?n.push(I):D.push(I);for(const[I,E]of r){const R=D.findIndex(F=>(0,u.$Ho)(F.identifier,I.identifier)&&F.version===I.manifest.version),L={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:E};R===-1?(c.push(L),D.push(L)):D.splice(R,1,L)}return c.length&&this.b.fire({extensions:c,profileLocation:t}),n.length&&this.f.fire({extensions:n,profileLocation:t}),D}),c.length&&this.c.fire({extensions:c,profileLocation:t}),n.length&&this.g.fire({extensions:n,profileLocation:t}),c}catch(m){throw c.length&&this.c.fire({extensions:c,error:m,profileLocation:t}),n.length&&this.g.fire({extensions:n,error:m,profileLocation:t}),m}}async updateMetadata(r,t){const n=[];return await this.u(t,c=>{const m=[];for(const D of c){const I=r.find(([E])=>(0,u.$Ho)(E.identifier,D.identifier)&&E.manifest.version===D.version);I&&(D.metadata={...D.metadata,...I[1]},n.push(D)),m.push(D)}return m}),n}async removeExtensionFromProfile(r,t){const n=[];try{await this.u(t,c=>{const m=[];for(const D of c)(0,u.$Ho)(D.identifier,r.identifier)?n.push(D):m.push(D);return n.length&&this.f.fire({extensions:n,profileLocation:t}),m}),n.length&&this.g.fire({extensions:n,profileLocation:t})}catch(c){throw n.length&&this.g.fire({extensions:n,error:c,profileLocation:t}),c}}async u(r,t,n){return this.F(r).queue(async()=>{let c=[],m;try{const D=await this.m.readFile(r);m=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,b.$xk)(D)!==1)throw D;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(m=await this.D()),!m&&n?.bailOutWhenFileNotFound)throw new a((0,w.$9)(D),"ERROR_PROFILE_NOT_FOUND")}if(m){Array.isArray(m)||this.w(r);let D=!1;for(const I of m){f(I)||this.w(r);let E;if((0,$.$Cf)(I.relativeLocation)&&I.relativeLocation)E=this.z(I.relativeLocation);else if((0,$.$Cf)(I.location))E=this.z(I.location),D=!0,I.relativeLocation=I.location,I.location=E.toJSON();else{E=P.URI.revive(I.location);const R=this.y(E);R&&(D=!0,I.relativeLocation=R)}c.push({identifier:I.identifier,location:E,version:I.version,metadata:I.metadata})}D&&await this.m.writeFile(r,A.$fe.fromString(JSON.stringify(m)))}if(t){c=t(c);const D=c.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(r,A.$fe.fromString(JSON.stringify(D)))}return c})}w(r){const t=new a(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(m){if((0,b.$xk)(m)===1)return;throw m}this.t.info("Migrating extensions from old default profile location",r.toString());let c;try{const m=JSON.parse(n);Array.isArray(m)&&m.every(D=>f(D))?c=m:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",m)}catch(m){this.t.error(m)}if(c)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$fe.fromString(JSON.stringify(c)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(m){if((0,b.$xk)(m)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw m}try{await this.m.del(r)}catch(m){(0,b.$xk)(m)!==1&&this.t.error(m)}try{await this.m.del(t)}catch(m){(0,b.$xk)(m)!==1&&this.t.error(m)}return c})()),this.C}F(r){let t=this.h.get(r);return t||(t=new S.$7g,this.h.set(r,t)),t}};e.$Dp=k,e.$Dp=k=ve([te(1,b.$gk),te(2,l.$Sk),te(3,v.$Qk),te(4,g.$kl),te(5,p.$fj)],k);function f(o){return(0,$.$Ef)(o)&&(0,d.$eo)(o.identifier)&&(i(o.location)||(0,$.$Cf)(o.location)&&o.location)&&((0,$.$Jf)(o.relativeLocation)||(0,$.$Cf)(o.relativeLocation))&&o.version&&(0,$.$Cf)(o.version)}function i(o){return o?(0,$.$Cf)(o.path)&&(0,$.$Cf)(o.scheme):!1}}),define(se[129],re([0,1,23,8,38,18,14,44,152,2,13,9,4,19,205,74,12,7,172,37,123,120,204,16,6,5,26,3,77,81,41,40,203]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w,g,h,a,k,f,i,o,r,t,n,c,m,D,I,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.Translations=void 0;var L;(function(ce){function Q(K,V){if(K===V)return!0;const z=Object.keys(K),W=new Set;for(const H of Object.keys(V))W.add(H);if(z.length!==W.size)return!1;for(const H of z){if(K[H]!==V[H])return!1;W.delete(H)}return W.size===0}ce.equals=Q})(L||(e.Translations=L={})),e.$Gp=(0,r.$Xh)("IExtensionsScannerService");let F=class extends u.$Rc{constructor(Q,K,V,z,W,H,q,_,ne,X,O,N){super(),this.systemExtensionsLocation=Q,this.userExtensionsLocation=K,this.r=V,this.s=z,this.t=W,this.u=H,this.w=q,this.y=_,this.z=ne,this.C=X,this.D=O,this.F=N,this.g=this.B(new c.$Rd),this.onDidChangeCache=this.g.event,this.h=(0,l.$Bg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(Y,this.s,this.h)),this.m=this.B(this.F.createInstance(Y,this.s,this.h)),this.n=this.B(this.F.createInstance(x,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,k.$So)(this.w,this.y)),this.G}async scanAllExtensions(Q,K,V){const[z,W]=await Promise.all([this.scanSystemExtensions(Q),this.scanUserExtensions(K)]),H=V?await this.scanExtensionsUnderDevelopment(Q,[...z,...W]):[];return this.L(z,W,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Q){const K=[];K.push(this.M(!!Q.useCache,Q.language)),K.push(this.N(Q.language,!!Q.checkControlFile));const[V,z]=await Promise.all(K);return this.J([...V,...z],0,Q,!1)}async scanUserExtensions(Q){const K=Q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const V=this.D.extUri.isEqual(Q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(K,!!Q.profileLocation,1,!Q.includeUninstalled,Q.language,!0,V),W=Q.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let H;try{H=await W.scanExtensions(z)}catch(q){if(q instanceof D.$Bp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),H=await W.scanExtensions(z);else throw q}return H=await this.J(H,1,Q,!0),this.y.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(Q,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===b.Schemas.file).map(async z=>{const W=await this.P(z,!1,1,!0,Q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(W)).map(q=>(q.type=K.find(_=>(0,k.$Ho)(_.identifier,q.identifier))?.type??q.type,this.n.validate(q,W)))}))).flat();return this.J(V,"development",Q,!0)}return[]}async scanExistingExtension(Q,K,V){const z=await this.P(Q,!1,K,!0,V.language,!0,void 0),W=await this.n.scanExtension(z);return!W||!V.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(Q,K,V){const z=await this.P(Q,!1,K,!0,V.language,!0,void 0),W=await this.n.scanOneOrMultipleExtensions(z);return this.J(W,K,V,!0)}async scanMetadata(Q){const K=(0,l.$Bg)(Q,"package.json"),V=(await this.w.readFile(K)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(Q,K){const V=(0,l.$Bg)(Q,"package.json"),z=(await this.w.readFile(V)).value.toString(),W=JSON.parse(z);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,W.__metadata={...W.__metadata,...K},await this.w.writeFile((0,l.$Bg)(Q,"package.json"),M.$fe.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Q){if(Q instanceof D.$Bp&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Q=await this.scanUserExtensions({includeInvalid:!0});if(Q.length)await this.u.addExtensionsToProfile(Q.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$fe.fromString(JSON.stringify([])))}catch(K){(0,o.$xk)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$9)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Q){this.y.error(Q)}finally{this.H=void 0}})()),this.H}async J(Q,K,V,z){return V.includeAllVersions||(Q=this.L(K===0?Q:void 0,K===1?Q:void 0,K==="development"?Q:void 0,await this.getTargetPlatform(),z)),V.includeInvalid||(Q=Q.filter(W=>W.isValid)),Q.sort((W,H)=>{const q=y.$mc(W.location.fsPath),_=y.$mc(H.location.fsPath);return q<_?-1:q>_?1:0})}L(Q,K,V,z,W){const H=(_,ne,X)=>{if(_.isValid&&!ne.isValid)return!1;if(_.isValid===ne.isValid){if(W&&v.gt(_.manifest.version,ne.manifest.version))return this.y.debug(`Skipping extension ${ne.location.path} with lower version ${ne.manifest.version} in favour of ${_.location.path} with version ${_.manifest.version}`),!1;if(v.eq(_.manifest.version,ne.manifest.version)){if(_.type===0)return this.y.debug(`Skipping extension ${ne.location.path} in favour of system extension ${_.location.path} with same version`),!1;if(_.targetPlatform===z)return this.y.debug(`Skipping extension ${ne.location.path} from different target platform ${ne.targetPlatform}`),!1}}return X?this.y.warn(`Overwriting user extension ${_.location.path} with ${ne.location.path}.`):this.y.debug(`Overwriting user extension ${_.location.path} with ${ne.location.path}.`),!0},q=new f.$dm;return Q?.forEach(_=>{const ne=q.get(_.identifier.id);(!ne||H(ne,_,!1))&&q.set(_.identifier.id,_)}),K?.forEach(_=>{const ne=q.get(_.identifier.id);if(!ne&&Q&&_.type===0){this.y.debug(`Skipping obsolete system extension ${_.location.path}.`);return}(!ne||H(ne,_,!1))&&q.set(_.identifier.id,_)}),V?.forEach(_=>{const ne=q.get(_.identifier.id);(!ne||H(ne,_,!0))&&q.set(_.identifier.id,_),q.set(_.identifier.id,_)}),[...q.values()]}async M(Q,K){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),W=await(Q&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",W.length),W}async N(Q,K){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const z=K?await this.O():{},W=[],H=g.URI.file(y.$gc(y.$ic(b.$ig.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const _ of V){const ne=z[_.name]||"marketplace";switch(ne){case"disabled":break;case"marketplace":W.push((0,l.$Bg)(H,_.name));break;default:W.push(g.URI.file(ne));break}}const q=await Promise.all(W.map(async _=>this.n.scanExtension(await this.P(_,!1,0,!0,Q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",q.length),(0,S.$Gb)(q)}async O(){try{const Q=await this.w.readFile(this.r);return JSON.parse(Q.value.toString())}catch{return{}}}async P(Q,K,V,z,W,H,q){const _=await this.f(W??p.$w),ne=await this.Q(Q),X=K&&!this.D.extUri.isEqual(Q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=X?await this.Q(X):void 0;return new U(Q,ne,X,O,K,q,V,z,H,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,W,_)}async Q(Q){try{const K=await this.w.stat(Q);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.$Hp=F,e.$Hp=F=ve([te(4,I.$Sk),te(5,D.$Cp),te(6,o.$gk),te(7,t.$fj),te(8,a.$5h),te(9,n.$xj),te(10,E.$Qk),te(11,r.$Wh)],F);class U{constructor(Q,K,V,z,W,H,q,_,ne,X,O,N,G,j,B){this.location=Q,this.mtime=K,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=z,this.profile=W,this.profileScanOptions=H,this.type=q,this.excludeObsolete=_,this.validate=ne,this.productVersion=X,this.productDate=O,this.productCommit=N,this.devMode=G,this.language=j,this.translations=B}static createNlsConfiguration(Q){return{language:Q.language,pseudo:Q.language==="pseudo",devMode:Q.devMode,translations:Q.translations}}static equals(Q,K){return(0,l.$ug)(Q.location,K.location)&&Q.mtime===K.mtime&&(0,l.$ug)(Q.applicationExtensionslocation,K.applicationExtensionslocation)&&Q.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&Q.profile===K.profile&&s.$gn(Q.profileScanOptions,K.profileScanOptions)&&Q.type===K.type&&Q.excludeObsolete===K.excludeObsolete&&Q.validate===K.validate&&Q.productVersion===K.productVersion&&Q.productDate===K.productDate&&Q.productCommit===K.productCommit&&Q.devMode===K.devMode&&Q.language===K.language&&L.equals(Q.translations,K.translations)}}e.$Ip=U;let x=class extends u.$Rc{constructor(Q,K,V,z,W){super(),this.f=Q,this.g=K,this.h=V,this.j=z,this.m=W}async scanExtensions(Q){const K=Q.profile?await this.r(Q):await this.n(Q);let V={};if(Q.excludeObsolete&&Q.type===1)try{const z=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(z)}catch{}return(0,w.$Pf)(V)?K:K.filter(z=>!V[k.$Io.create(z).toString()])}async n(Q){const K=await this.j.resolve(Q.location);if(!K.children?.length)return[];const V=await Promise.all(K.children.map(async z=>{if(!z.isDirectory||Q.type===1&&(0,l.$yg)(z.resource).indexOf(".")===0)return null;const W=new U(z.resource,Q.mtime,Q.applicationExtensionslocation,Q.applicationExtensionslocationMtime,Q.profile,Q.profileScanOptions,Q.type,Q.excludeObsolete,Q.validate,Q.productVersion,Q.productDate,Q.productCommit,Q.devMode,Q.language,Q.translations);return this.scanExtension(W)}));return(0,S.$Gb)(V).sort((z,W)=>z.location.path<W.location.path?-1:1)}async r(Q){let K=await this.s(Q.location,()=>!0,Q);if(Q.applicationExtensionslocation&&!this.h.extUri.isEqual(Q.location,Q.applicationExtensionslocation)){K=K.filter(z=>!z.metadata?.isApplicationScoped);const V=await this.s(Q.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,Q);K.push(...V)}return K}async s(Q,K,V){const z=await this.g.scanProfileExtensions(Q,V.profileScanOptions);if(!z.length)return[];const W=await Promise.all(z.map(async H=>{if(K(H)){const q=new U(H.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(q,H.metadata)}return null}));return(0,S.$Gb)(W)}async scanOneOrMultipleExtensions(Q){try{if(await this.j.exists((0,l.$Bg)(Q.location,"package.json"))){const K=await this.scanExtension(Q);return K?[K]:[]}else return await this.scanExtensions(Q)}catch(K){return this.m.error(`Error scanning extensions at ${Q.location.path}:`,(0,C.$9)(K)),[]}}async scanExtension(Q,K){try{let V=await this.scanExtensionManifest(Q.location);if(V){V.publisher||(V.publisher=f.$0l),K=K??V.__metadata,delete V.__metadata;const z=(0,k.$Mo)(V.publisher,V.name),W=K?.id?{id:z,uuid:K.id}:{id:z},H=K?.isSystem?0:Q.type,q=H===0||!!K?.isBuiltin;V=await this.t(Q.location,V,U.createNlsConfiguration(Q));const _={type:H,identifier:W,manifest:V,location:Q.location,isBuiltin:q,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return Q.validate?this.validate(_,Q):_}}catch(V){Q.type!==0&&this.m.error(V)}return null}validate(Q,K){let V=!0;const z=(0,i.$Xo)(K.productVersion,K.productDate,K.location,Q.manifest,Q.isBuiltin);for(const[W,H]of z)W===$.default.Error&&(V=!1,this.m.error(this.z(K.location,H)));return Q.isValid=V,Q.validations=z,Q}async scanExtensionManifest(Q){const K=(0,l.$Bg)(Q,"package.json");let V;try{V=(await this.j.readFile(K)).value.toString()}catch(W){return(0,o.$xk)(W)!==1&&this.m.error(this.z(Q,(0,h.localize)(0,null,K.path,W.message))),null}let z;try{z=JSON.parse(V)}catch{const H=[];(0,P.$5m)(V,H);for(const q of H)this.m.error(this.z(Q,(0,h.localize)(1,null,K.path,q.offset,q.length,(0,d.$Ep)(q.error))));return null}return(0,P.$bn)(z)!=="object"?(this.m.error(this.z(Q,(0,h.localize)(2,null,K.path))),null):z}async t(Q,K,V){const z=await this.u(Q,K,V);if(z)try{const W=[],H=await this.w(z.default,W);if(W.length>0)return W.forEach(_=>{this.m.error(this.z(Q,(0,h.localize)(3,null,z.default?.path,(0,d.$Ep)(_.error))))}),K;if((0,P.$bn)(z)!=="object")return this.m.error(this.z(Q,(0,h.localize)(4,null,z.default?.path))),K;const q=z.values||Object.create(null);return(0,R.$Fp)(this.m,K,q,H)}catch{}return K}async u(Q,K,V){const z=(0,l.$Bg)(Q,"package.nls.json"),W=(ne,X)=>{X.forEach(O=>{this.m.error(this.z(Q,(0,h.localize)(5,null,ne?.path,(0,d.$Ep)(O.error))))})},H=ne=>{this.m.error(this.z(Q,(0,h.localize)(6,null,ne?.path)))},q=`${K.publisher}.${K.name}`,_=V.translations[q];if(_)try{const ne=g.URI.file(_),X=(await this.j.readFile(ne)).value.toString(),O=[],N=(0,P.$5m)(X,O);return O.length>0?(W(ne,O),{values:void 0,default:z}):(0,P.$bn)(N)!=="object"?(H(ne),{values:void 0,default:z}):{values:N.contents?N.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.j.exists(z))return;let X;try{X=await this.y(Q,V)}catch{return}if(!X.localized)return{values:void 0,default:X.original};try{const O=(await this.j.readFile(X.localized)).value.toString(),N=[],G=(0,P.$5m)(O,N);return N.length>0?(W(X.localized,N),{values:void 0,default:X.original}):(0,P.$bn)(G)!=="object"?(H(X.localized),{values:void 0,default:X.original}):{values:G,default:X.original}}catch{return{values:void 0,default:X.original}}}}async w(Q,K){if(Q)try{const V=(await this.j.readFile(Q)).value.toString();return(0,P.$5m)(V,K)}catch{}}y(Q,K){return new Promise((V,z)=>{const W=H=>{const q=(0,l.$Bg)(Q,`package.nls.${H}.json`);this.j.exists(q).then(_=>{_&&V({localized:q,original:(0,l.$Bg)(Q,"package.nls.json")});const ne=H.lastIndexOf("-");ne===-1?V({localized:(0,l.$Bg)(Q,"package.nls.json"),original:null}):(H=H.substring(0,ne),W(H))})};if(K.devMode||K.pseudo||!K.language)return V({localized:(0,l.$Bg)(Q,"package.nls.json"),original:null});W(K.language)})}z(Q,K){return`[${Q.path}]: ${K}`}};x=ve([te(1,D.$Cp),te(2,E.$Qk),te(3,o.$gk),te(4,t.$fj)],x);let Y=class extends x{constructor(Q,K,V,z,W,H,q){super(K,z,W,H,q),this.G=Q,this.H=V,this.D=this.B(new A.$Xg(3e3)),this.F=this.B(new c.$Rd),this.onDidChangeCache=this.F.event}async scanExtensions(Q){const K=this.M(Q),V=await this.I(K);if(this.C=Q,V&&V.input&&U.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",Q.location.toString()),this.D.trigger(()=>this.L()),V.result.map(W=>(W.location=g.URI.revive(W.location),W));const z=await super.scanExtensions(Q);return await this.J(K,{input:Q,result:z}),z}async I(Q){try{const K=await this.j.readFile(Q),V=JSON.parse(K.value.toString());return{result:V.result,input:(0,m.$uh)(V.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",Q.path,(0,C.$9)(K))}return null}async J(Q,K){try{await this.j.writeFile(Q,M.$fe.fromString(JSON.stringify(K)))}catch(V){this.m.debug("Error while writing the extension cache file:",Q.path,(0,C.$9)(V))}}async L(){if(!this.C)return;const Q=this.M(this.C),K=await this.I(Q);if(!K)return;const V=K.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$gn(z,V))try{this.m.info("Invalidating Cache",V,z),await this.j.del(Q),this.F.fire()}catch(W){this.m.error(W)}}M(Q){const K=this.N(Q);return this.h.extUri.joinPath(K.cacheHome,Q.type===0?f.$9l:f.$8l)}N(Q){return Q.type===0?this.H.defaultProfile:Q.profile?this.h.extUri.isEqual(Q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(Q.location,K.extensionsResource))??this.G:this.H.defaultProfile}};Y=ve([te(2,I.$Sk),te(3,D.$Cp),te(4,E.$Qk),te(5,o.$gk),te(6,t.$fj)],Y);function ae(ce,Q){const K=(0,k.$Ko)(ce.manifest.publisher,ce.manifest.name);return{id:K,identifier:new f.$bm(K),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:Q,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}e.$Jp=ae;class oe extends F{constructor(Q,K,V,z,W,H,q,_,ne,X,O,N){super(Q,K,(0,l.$Bg)(V,".vscode-oss-dev","extensions","control.json"),z,W,H,q,_,ne,X,O,N),this.R=(async()=>{if(p.$z)try{const G=await this.w.readFile(g.URI.file(p.$z));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}f(Q){return this.R}}e.$Kp=oe}),define(se[276],re([0,1,5,41,40,27,81,16,37,7]),function(J,e,S,A,s,M,C,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XN=void 0;let b=class extends C.$Dp{constructor(p,l,v,$,w,g){super(u.URI.file(p.extensionsPath),l,v,$,w,g)}};e.$XN=b,e.$XN=b=ve([te(0,d.$6h),te(1,P.$gk),te(2,A.$Sk),te(3,s.$Qk),te(4,M.$kl),te(5,S.$fj)],b)}),define(se[277],re([0,1,7,37,81,129,16,6,5,26,40,41]),function(J,e,S,A,s,M,C,P,d,u,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R9b=void 0;let p=class extends M.$Kp{constructor(v,$,w,g,h,a,k,f){super(S.URI.file(h.builtinExtensionsPath),S.URI.file(h.extensionsPath),h.userHome,v.defaultProfile,v,$,w,g,h,a,k,f)}};e.$R9b=p,e.$R9b=p=ve([te(0,y.$Sk),te(1,s.$Cp),te(2,C.$gk),te(3,d.$fj),te(4,A.$6h),te(5,u.$xj),te(6,b.$Qk),te(7,P.$Wh)],p)}),define(se[278],re([0,1,15,2,13,9,4,57,7,32,36,37,5,41]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$09b=void 0;let v=class extends A.$Rc{constructor(w,g,h){super(),this.c=w,this.f=h,this.a=P.$4h.forPaths(!C.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(w.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:w}=S.session;w.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(g,h)=>this.j(g,h)),w.protocol.interceptFileProtocol(s.Schemas.file,(g,h)=>this.h(g,h)),this.B((0,A.$Pc)(()=>{w.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(w){const g=(0,M.$gc)(w);return this.a.get(g)?A.$Rc.None:(this.a.set(g,!0),(0,A.$Pc)(()=>this.a.delete(g)))}h(w,g){const h=d.URI.parse(w.url);return this.f.error(`Refused to load resource ${h.fsPath} from ${s.Schemas.file}: protocol (original URL: ${w.url})`),g({error:-3})}j(w,g){const h=this.m(w);let a;return this.c.crossOriginIsolated&&((0,M.$mc)(h)==="workbench.html"||(0,M.$mc)(h)==="workbench-dev.html"?a=s.COI.CoopAndCoep:a=s.COI.getHeadersFromQuery(w.url)),this.a.findSubstr(h)?g({path:h,headers:a}):this.b.has((0,M.$nc)(h).toLowerCase())?g({path:h}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${h} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),g({error:-3}))}m(w){const g=d.URI.parse(w.url),h=s.$ig.uriToFileUri(g);return(0,M.$gc)(h.fsPath)}createIPCObjectUrl(){let w;const g=d.URI.from({scheme:"vscode",path:(0,u.$kg)()}),h=g.toString(),a=async()=>w;return b.$XT.handle(h,a),this.f.trace(`IPC Object URL: Registered new channel ${h}.`),{resource:g,update:k=>w=k,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${h}.`),b.$XT.removeHandler(h)}}}};e.$09b=v,e.$09b=v=ve([te(0,y.$6h),te(1,l.$Sk),te(2,p.$fj)],v)}),define(se[96],re([0,1,8,3,2,67,12,111,6,41]),function(J,e,S,A,s,M,C,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$bp=e.$ap=e.$_o=void 0,e.$_o="__$__isNewStorageMarker",e.$ap="__$__targetStorageMarker",e.$bp=(0,d.$Xh)("storageService");var b;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(b||(e.WillSaveStateReason=b={}));var y;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var p;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function l(h){const a=h.get(e.$ap);if(a)try{return JSON.parse(a)}catch{}return Object.create(null)}e.$cp=l;class v extends s.$Rc{static{this.a=60*1e3}constructor(a={flushInterval:v.a}){super(),this.m=a,this.b=this.B(new A.$Ud),this.c=this.B(new A.$Ud),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$Rd),this.onWillSaveState=this.f.event,this.h=this.B(new S.$_g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(a,k,f){return A.Event.filter(this.b.event,i=>i.scope===a&&(k===void 0||i.key===k),f)}n(){this.j.value=(0,S.$dh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(a,k){const{key:f,external:i}=k;if(f===e.$ap){switch(a){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:a})}else this.b.fire({scope:a,key:f,target:this.J(a)[f],external:i})}w(a){this.f.fire({reason:a})}get(a,k,f){return this.P(k)?.get(a,f)}getBoolean(a,k,f){return this.P(k)?.getBoolean(a,f)}getNumber(a,k,f){return this.P(k)?.getNumber(a,f)}getObject(a,k,f){return this.P(k)?.getObject(a,f)}storeAll(a,k){this.y(()=>{for(const f of a)this.store(f.key,f.value,f.scope,f.target,k)})}store(a,k,f,i,o=!1){if((0,C.$Lf)(k)){this.remove(a,f,o);return}this.y(()=>{this.z(a,f,i),this.P(f)?.set(a,k,o)})}remove(a,k,f=!1){this.y(()=>{this.z(a,k,void 0),this.P(k)?.delete(a,f)})}y(a){this.b.pause(),this.c.pause();try{a()}finally{this.b.resume(),this.c.resume()}}keys(a,k){const f=[],i=this.J(a);for(const o of Object.keys(i))i[o]===k&&f.push(o);return f}z(a,k,f,i=!1){const o=this.J(k);typeof f=="number"?o[a]!==f&&(o[a]=f,this.P(k)?.set(e.$ap,JSON.stringify(o),i)):typeof o[a]=="number"&&(delete o[a],this.P(k)?.set(e.$ap,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(a){switch(a){case-1:return this.I;case 0:return this.G;default:return this.D}}L(a){const k=this.P(a);return k?l(k):Object.create(null)}isNew(a){return this.getBoolean(e.$_o,a)===!0}async flush(a=b.NONE){this.f.fire({reason:a});const k=this.P(-1),f=this.P(0),i=this.P(1);switch(a){case b.NONE:await S.Promises.settled([k?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await S.Promises.settled([k?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const a=this.P(-1)?.items??new Map,k=this.P(0)?.items??new Map,f=this.P(1)?.items??new Map;return g(a,k,f,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(a){return await this.flush(),this.P(a)?.optimize()}async switch(a,k){return this.w(b.NONE),(0,u.$Rk)(a)?this.R(a,k):this.S(a,k)}M(a,k){return!(a.id===k.id||$(k)&&$(a))}N(a,k,f){this.y(()=>{const i=new Set;for(const[o,r]of a)i.add(o),k.get(o)!==r&&this.u(f,{key:o,external:!0});for(const[o]of k.items)i.has(o)||this.u(f,{key:o,external:!0})})}}e.$dp=v;function $(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.$ep=$;class w extends v{constructor(){super(),this.U=this.B(new P.$0o(new P.$$o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$0o(new P.$$o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$0o(new P.$$o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(a=>this.u(1,a))),this.B(this.W.onDidChangeStorage(a=>this.u(0,a))),this.B(this.U.onDidChangeStorage(a=>this.u(-1,a)))}P(a){switch(a){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(a){switch(a){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(a){return!1}}e.$fp=w;async function g(h,a,k,f,i,o){const r=L=>{try{return JSON.parse(L)}catch{return L}},t=new Map,n=new Map;h.forEach((L,F)=>{t.set(F,L),n.set(F,r(L))});const c=new Map,m=new Map;a.forEach((L,F)=>{c.set(F,L),m.set(F,r(L))});const D=new Map,I=new Map;k.forEach((L,F)=>{D.set(F,L),I.set(F,r(L))}),console.group(f!==i?`Storage: Application (path: ${f})`:`Storage: Application & Profile (path: ${f}, default profile)`);const E=[];if(t.forEach((L,F)=>{E.push({key:F,value:L})}),console.table(E),console.groupEnd(),console.log(n),f!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const L=[];c.forEach((F,U)=>{L.push({key:U,value:F})}),console.table(L),console.groupEnd(),console.log(m)}console.group(`Storage: Workspace (path: ${o})`);const R=[];D.forEach((L,F)=>{R.push({key:F,value:L})}),console.table(R),console.groupEnd(),console.log(I)}e.$gp=g}),define(se[279],re([0,1,23,8,3,2,9,73,7,21,111,161,5,96,27,30,13]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e8b=e.$d8b=e.$c8b=e.$b8b=void 0;class g extends M.$Rc{static{this.a=2e3}get storage(){return this.f}constructor(r,t){super(),this.m=r,this.n=t,this.b=this.B(new s.$Rd),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Rd),this.onDidCloseStorage=this.c.event,this.f=this.B(new b.$0o(new b.$$o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new A.$kh,this.whenInit=this.h.p,this.j=b.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===b.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const t=r.getBoolean(l.$_o);t===void 0?r.set(l.$_o,!0):t&&r.set(l.$_o,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=b.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===p.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,t){return this.f.get(r,t)}set(r,t){return this.f.set(r,t)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new P.$Nd(!1);await this.w(),r.stop(),r.elapsed()>g.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const t=(0,S.top)(Array.from(this.f.items.entries()).map(([c,m])=>({key:c,length:m.length})),(c,m)=>m.length-c.length,5).map(c=>`${c.key}:${c.length}`).join(", "),n=(await this.n.stat(d.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${t}`)}catch(t){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",t)}}async w(){this.g&&await this.g,this.j=b.StorageState.Closed,await this.f.close()}}class h extends g{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,C.$ic)(this.z.globalStorageHome.with({scheme:w.Schemas.file}).fsPath,h.y)}constructor(r,t,n,c){super(n,c),this.z=r,this.C=t}async t(){return new b.$0o(new y.$qU(this.path??y.$qU.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:b.StorageHint.STORAGE_IN_MEMORY})}}class a extends h{constructor(r,t,n,c){super(r,t,n,c)}}e.$b8b=a;class k extends h{constructor(r,t,n,c){super(t.defaultProfile,r,n,c)}async s(r){await super.s(r),this.G(r)}G(r){r.get(v.$nl,void 0)===void 0&&r.set(v.$nl,new Date().toUTCString());const n=r.get(v.$ml,void 0),c=new Date().toUTCString();r.set(v.$ol,typeof n>"u"?null:n),r.set(v.$ml,c)}}e.$c8b=k;class f extends g{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,C.$ic)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id,f.y)}constructor(r,t,n,c,m){super(n,m),this.C=r,this.D=t,this.F=c}async t(){const{storageFilePath:r,wasCreated:t}=await this.H();return new b.$0o(new y.$qU(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?b.StorageHint.STORAGE_IN_MEMORY:t?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:y.$qU.IN_MEMORY_PATH,wasCreated:!0};const r=(0,C.$ic)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id),t=(0,C.$ic)(r,f.y);return await u.Promises.exists(r)?{storageFilePath:t,wasCreated:!1}:(await u.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:t,wasCreated:!0})}async I(r){let t;if((0,$.$8h)(this.C)?t={folder:this.C.uri.toString()}:(0,$.$ai)(this.C)&&(t={workspace:this.C.configPath.toString()}),t)try{const n=(0,C.$ic)(r,f.z);await u.Promises.exists(n)||await u.Promises.writeFile(n,JSON.stringify(t,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$d8b=f;class i extends g{get path(){}async t(){return new b.$0o(new b.$$o,{hint:b.StorageHint.STORAGE_IN_MEMORY})}}e.$e8b=i}),define(se[280],re([0,1,3,2,96]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T9b=void 0;class M extends A.$Rc{constructor(P,d,u){super(),this.b=P,this.c=d,this.f=u;const b=this.B(new A.$Sc);this.a=this.B(new S.$Rd({onWillAddFirstListener:()=>b.value=this.g(),onDidRemoveLastListener:()=>b.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new A.$Qc;return P.add(S.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(d,u)=>(d?d.push(u.key):d=[u.key],d),100)(d=>this.h(d))),P.add(S.Event.debounce(this.b.onDidChangeProfileStorage,(d,u)=>{d||(d=new Map);let b=d.get(u.profile.id);return b||d.set(u.profile.id,b={profile:u.profile,keys:[],storage:u.storage}),b.keys.push(u.key),d},100)(d=>this.j(d))),P}h(P){const d=P.includes(s.$ap)?[this.c.defaultProfile]:[],u=[];if(P=P.filter(b=>b!==s.$ap),P.length){const b=(0,s.$cp)(this.b.applicationStorage.storage);u.push({profile:this.c.defaultProfile,changes:P.map(y=>({key:y,scope:0,target:b[y]}))})}this.m(d,u)}j(P){const d=[],u=new Map;for(const[b,y]of P.entries()){y.keys.includes(s.$ap)&&d.push(y.profile);const p=y.keys.filter(l=>l!==s.$ap);if(p.length){const l=(0,s.$cp)(y.storage.storage);u.set(b,{profile:y.profile,changes:p.map(v=>({key:v,scope:0,target:l[v]}))})}}this.m(d,[...u.values()])}m(P,d){(P.length||d.length)&&this.a.fire({valueChanges:d,targetChanges:P})}listen(P,d,u){switch(d){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${d}`)}async call(P,d){throw new Error(`Call not found: ${d}`)}}e.$T9b=M}),define(se[281],re([0,1,7,37,16,5,34,40,41,12,121]),function(J,e,S,A,s,M,C,P,d,u,b){"use strict";var y,p;Object.defineProperty(e,"__esModule",{value:!0}),e.$WN=e.$VN=e.$UN=void 0;let l=class extends d.$Vk{static{y=this}static{this.a="profileAssociationsMigration"}constructor(g,h,a,k,f){super(a,k,h,f),this.U=g,this.W=a}O(){return this.U.getItem(y.b,[]).map(h=>({...h,location:(0,u.$Cf)(h.location)?this.w.extUri.joinPath(this.profilesHome,h.location):S.URI.revive(h.location)}))}Q(){const g=this.U.getItem(y.c,{});return this.U.getItem(y.a,!1)?g:this.N(g)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$UN=l,e.$UN=l=y=ve([te(0,C.$PN),te(1,P.$Qk),te(2,A.$6h),te(3,s.$gk),te(4,M.$fj)],l);let v=p=class extends l{constructor(g,h,a,k,f){super(g,h,a,k,f),this.$=g}P(g){g.length?this.$.setItem(p.b,g.map(h=>({...h,location:this.w.extUri.basename(h.location)}))):this.$.removeItem(p.b)}O(){const g=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(g),this.$.setItem("userDataProfilesMigration",!0)),g}R(g){g.emptyWindows||g.workspaces?this.$.setItem(p.c,g):this.$.removeItem(p.c)}Q(){const g="workspaceAndProfileInfo",h=this.$.getItem(g,void 0);if(h){this.$.removeItem(g);const k=h.reduce((f,{workspace:i,profile:o})=>(f[S.URI.revive(i).toString()]=S.URI.revive(o).toString(),f),{});this.$.setItem(p.c,{workspaces:k})}const a=super.Q();return this.$.getItem(p.a,!1)||(this.R(a),this.$.setItem(p.a,!0)),a}};e.$VN=v,e.$VN=v=p=ve([te(0,C.$QN),te(1,P.$Qk),te(2,A.$6h),te(3,s.$gk),te(4,M.$fj)],v);let $=class extends v{constructor(g,h,a,k){super(new b.$TN(0,h,k,a),g,h,a,k)}async init(){return await this.$.init(),super.init()}};e.$WN=$,e.$WN=$=ve([te(0,P.$Qk),te(1,A.$6h),te(2,s.$gk),te(3,M.$fj)],$)}),define(se[54],re([0,1,37,16,6,5,40,41,281,34]),function(J,e,S,A,s,M,C,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g8b=e.$f8b=void 0,e.$f8b=(0,s.$Yh)(P.$Sk);let b=class extends d.$VN{constructor(p,l,v,$,w){super(p,l,v,$,w)}getAssociatedEmptyWindows(){const p=[];for(const l of this.C.emptyWindows.keys())p.push({id:l});return p}};e.$g8b=b,e.$g8b=b=ve([te(0,u.$QN),te(1,C.$Qk),te(2,S.$6h),te(3,A.$gk),te(4,M.$fj)],b)}),define(se[130],re([0,1,19,7,30]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w8b=e.$v8b=e.$u8b=void 0;async function M(d,u,b){for(const p of d){const l=p.openedWorkspace;if((0,s.$ai)(l)){const v=await b(l);if(v){if(v.folders.some($=>S.$sg.isEqualOrParent(u,$.uri)))return p}else if(S.$sg.isEqualOrParent(u,l.configPath))return p}}const y=d.filter(p=>(0,s.$8h)(p.openedWorkspace)&&S.$sg.isEqualOrParent(u,p.openedWorkspace.uri));if(y.length)return y.sort((p,l)=>-(p.openedWorkspace.uri.path.length-l.openedWorkspace.uri.path.length))[0]}e.$u8b=M;function C(d,u){for(const b of d)if((0,s.$ai)(b.openedWorkspace)&&S.$sg.isEqual(b.openedWorkspace.configPath,u)||(0,s.$8h)(b.openedWorkspace)&&S.$sg.isEqual(b.openedWorkspace.uri,u))return b}e.$v8b=C;function P(d,u){const b=y=>u.some(p=>S.$sg.isEqual(A.URI.file(p),A.URI.file(y)));for(const y of d)if(y.config?.extensionDevelopmentPath?.some(p=>b(p)))return y}e.$w8b=P}),define(se[97],re([0,1,33,44,139,47,13,9,4,19,7,6,59,30]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfb=e.$ifb=e.$hfb=e.$gfb=e.$ffb=e.$efb=e.$dfb=e.$cfb=e.$bfb=e.$afb=void 0,e.$afb=(0,y.$Xh)("workspacesService");function v(I){return I.hasOwnProperty("workspace")}e.$bfb=v;function $(I){return I.hasOwnProperty("folderUri")}e.$cfb=$;function w(I){return I.hasOwnProperty("fileUri")}e.$dfb=w;function g(I){return h(I)||a(I)}e.$efb=g;function h(I){const E=I;return typeof E?.path=="string"&&(!E.name||typeof E.name=="string")}function a(I){const E=I;return typeof E?.uri=="string"&&(!E.name||typeof E.name=="string")}function k(I,E,R,L,F){if(I.scheme!==L.scheme)return{name:R,uri:I.toString(!0)};let U=E?void 0:F.relativePath(L,I);if(U!==void 0)U.length===0?U=".":d.$i&&(U=f(U));else if(I.scheme===C.Schemas.file)U=I.fsPath,d.$i&&(U=f(U));else if(F.isEqualAuthority(I.authority,L.authority))U=I.path;else return{name:R,uri:I.toString(!0)};return{name:R,path:U}}e.$ffb=k;function f(I){return I=(0,M.$Bv)(I),(0,S.$Yf)(I)||(I=(0,S.$Vf)(I)),I}function i(I,E,R){const L=[],F=new Set,U=R.dirname(E);for(const x of I){let Y;if(h(x))x.path&&(Y=R.resolvePath(U,x.path));else if(a(x))try{Y=b.URI.parse(x.uri),Y.path[0]!==P.$fc.sep&&(Y=Y.with({path:P.$fc.sep+Y.path}))}catch(ae){console.warn(ae)}if(Y){const ae=R.getComparisonKey(Y);if(!F.has(ae)){F.add(ae);const oe=x.name||R.basenameOrAuthority(Y);L.push(new l.$fi({uri:Y,name:oe,index:L.length},x))}}}return L}e.$gfb=i;function o(I,E,R,L,F){const U=r(E,I),x=F.dirname(E),Y=F.dirname(L),ae=[];for(const K of U.folders){const V=h(K)?F.resolvePath(x,K.path):b.URI.parse(K.uri);let z;R?z=!1:z=!h(K)||(0,P.$hc)(K.path),ae.push(k(V,z,K.name,Y,F))}const oe={insertSpaces:!1,tabSize:4,eol:d.$k||d.$j?`
`:`\r
`},ce=s.$AT(I,["folders"],ae,oe);let Q=s.$DT(I,ce);return(0,u.$Gg)(U.remoteAuthority,(0,p.$3k)(L))&&(Q=s.$DT(Q,s.$zT(Q,["remoteAuthority"],oe))),Q}e.$hfb=o;function r(I,E){const R=A.$5m(E);if(R&&Array.isArray(R.folders))R.folders=R.folders.filter(L=>g(L));else throw new Error(`${I} looks like an invalid workspace file.`);return R}function t(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function n(I){return typeof I.folderUri=="string"}function c(I){return typeof I.fileUri=="string"}function m(I,E){const R={workspaces:[],files:[]};if(I){const L=function(U,x){for(let Y=0;Y<U.length;Y++)try{x(U[Y],Y)}catch(ae){E.warn(`Error restoring recent entry ${JSON.stringify(U[Y])}: ${ae.toString()}. Skip entry.`)}},F=I;Array.isArray(F.entries)&&L(F.entries,U=>{const x=U.label,Y=U.remoteAuthority;t(U)?R.workspaces.push({label:x,remoteAuthority:Y,workspace:{id:U.workspace.id,configPath:b.URI.parse(U.workspace.configPath)}}):n(U)?R.workspaces.push({label:x,remoteAuthority:Y,folderUri:b.URI.parse(U.folderUri)}):c(U)&&R.files.push({label:x,remoteAuthority:Y,fileUri:b.URI.parse(U.fileUri)})})}return R}e.$ifb=m;function D(I){const E={entries:[]};for(const R of I.workspaces)$(R)?E.entries.push({folderUri:R.folderUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority}):E.entries.push({workspace:{id:R.workspace.id,configPath:R.workspace.configPath.toString()},label:R.label,remoteAuthority:R.remoteAuthority});for(const R of I.files)E.entries.push({fileUri:R.fileUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority});return E}e.$jfb=D}),define(se[98],re([0,1,86,13,4,19]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A8b=e.$z8b=e.$y8b=e.$x8b=void 0,e.$x8b=128/4;function C(u){function b(){let y=u.scheme===A.Schemas.file?(0,M.$pg)(u):u.toString();return s.$k||(y=y.toLowerCase()),(0,S.createHash)("md5").update(y).digest("hex")}return{id:b(),configPath:u}}e.$y8b=C;function P(u,b){function y(){if(u.scheme!==A.Schemas.file)return(0,S.createHash)("md5").update(u.toString()).digest("hex");if(!b)return;let l;return s.$k?l=b.ino:s.$j?l=b.birthtime.getTime():s.$i&&(typeof b.birthtimeMs=="number"?l=Math.floor(b.birthtimeMs):l=b.birthtime.getTime()),(0,S.createHash)("md5").update(u.fsPath).update(l?String(l):"").digest("hex")}const p=y();if(typeof p=="string")return{id:p,uri:u}}e.$z8b=P;function d(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$A8b=d}),define(se[99],re([0,1,86,87,28,282,18,14,3,2,9,4,32,42,109]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=void 0;class ${traceSocketEvent(E,R){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,R)}constructor(E,R=""){this.f=!0,this.debugLabel=R,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,P.$Z)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const R=L=>{this.traceSocketEvent("read",L),E(C.$fe.wrap(L))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(E){const R=L=>{E({type:0,hadError:L,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(E){const R=()=>{E()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,P.$Z)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,P.$Z)(R)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$Mh=$;var w;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var g;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(g||(g={}));class h extends u.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,R){this.socket.traceSocketEvent(E,R)}constructor(E,R,L,F){super(),this.f=this.B(new d.$Rd),this.g=this.B(new d.$Rd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:L?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new a(this,R,L,F,this.f,(U,x)=>this.m(U,x))),this.B(this.a.onError(U=>{console.error(U),(0,P.$Z)(U),this.g.fire({type:0,hadError:!0,error:U})})),this.b=new v.$Hh,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await d.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let R=0;for(;R<E.byteLength;)this.a.writeMessage(E.slice(R,Math.min(R+262144,E.byteLength)),{compressed:!0,opcode:2}),R+=262144}m(E,{compressed:R,opcode:L}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let F=2;E.byteLength<126?F+=0:E.byteLength<2**16?F+=2:F+=8;const U=C.$fe.alloc(F),x=R?64:0,Y=L&15;if(U.writeUInt8(128|x|Y,0),E.byteLength<126)U.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){U.writeUInt8(126,1);let ae=1;U.writeUInt8(E.byteLength>>>8&255,++ae),U.writeUInt8(E.byteLength>>>0&255,++ae)}else{U.writeUInt8(127,1);let ae=1;U.writeUInt8(0,++ae),U.writeUInt8(0,++ae),U.writeUInt8(0,++ae),U.writeUInt8(0,++ae),U.writeUInt8(E.byteLength>>>24&255,++ae),U.writeUInt8(E.byteLength>>>16&255,++ae),U.writeUInt8(E.byteLength>>>8&255,++ae),U.writeUInt8(E.byteLength>>>0&255,++ae)}this.socket.write(C.$fe.concat([U,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const R=this.b.peek(this.j.readLen),L=R.readUInt8(0),F=(L&128)>>>7,U=(L&64)>>>6,x=L&15,Y=R.readUInt8(1),ae=(Y&128)>>>7,oe=Y&127;this.j.state=2,this.j.readLen=2+(ae?4:0)+(oe===126?2:0)+(oe===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const R=this.b.read(this.j.readLen),L=R.readUInt8(1),F=(L&128)>>>7;let U=L&127,x=1;U===126?U=R.readUInt8(++x)*2**8+R.readUInt8(++x):U===127&&(U=R.readUInt8(++x)*0+R.readUInt8(++x)*0+R.readUInt8(++x)*0+R.readUInt8(++x)*0+R.readUInt8(++x)*2**24+R.readUInt8(++x)*2**16+R.readUInt8(++x)*2**8+R.readUInt8(++x));let Y=0;F&&(Y=R.readUInt8(++x)*2**24+R.readUInt8(++x)*2**16+R.readUInt8(++x)*2**8+R.readUInt8(++x)),this.j.state=3,this.j.readLen=U,this.j.mask=Y,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const R=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",R),i(R,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",R),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(R,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(R,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await d.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Nh=h;class a extends u.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:C.$fe.alloc(0)}constructor(E,R,L,F,U,x){super(),this.n=E,this.r=U,this.s=x,this.a=this.B(new d.$Rd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new d.$Rd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new d.$Rd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,R?(this.b=this.B(new k(this.n,F,L,{windowBits:15})),this.f=this.B(new f(this.n,{windowBits:15})),this.B(this.b.onError(Y=>this.a.fire(Y))),this.B(this.f.onError(Y=>this.a.fire(Y)))):(this.b=null,this.f=null)}writeMessage(E,R){this.g.push({data:E,options:R}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:R}=this.g.shift();if(this.f&&R.compressed){const L=await this.w(this.f,E);this.s(L,R)}else this.s(E,{...R,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,R){return new Promise((L,F)=>{E.write(R),E.flush(U=>L(U))})}acceptFrame(E,R,L){this.h.push({data:E,isCompressed:R,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const R=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(R)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,R,L){return new Promise((F,U)=>{E.write(R),L&&E.write(C.$fe.fromByteArray([0,0,255,255])),E.flush(x=>F(x))})}}class k extends u.$Rc{get recordedInflateBytes(){return this.j?C.$fe.concat(this.f):C.$fe.alloc(0)}constructor(E,R,L,F){super(),this.h=E,this.j=R,this.a=this.B(new d.$Rd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(F),this.b.on("error",U=>{this.h.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent("zlibInflateData",U),this.g.push(C.$fe.wrap(U))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const R=C.$fe.concat(this.g);this.g.length=0,E(R)})}}class f extends u.$Rc{constructor(E,R){super(),this.g=E,this.a=this.B(new d.$Rd),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(C.$fe.wrap(L))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let R=C.$fe.concat(this.f);this.f.length=0,R=R.slice(0,R.byteLength-4),E(R)})}}function i(I,E){if(E===0)return;const R=I.byteLength>>>2;for(let ae=0;ae<R;ae++){const oe=I.readUInt32BE(ae*4);I.writeUInt32BE(oe^E,ae*4)}const L=R*4,F=I.byteLength-L,U=E>>>24&255,x=E>>>16&255,Y=E>>>8&255;F>=1&&I.writeUInt8(I.readUInt8(L)^U,L),F>=2&&I.writeUInt8(I.readUInt8(L+1)^x,L+1),F>=3&&I.writeUInt8(I.readUInt8(L+2)^Y,L+2)}e.$Oh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function r(){const I=(0,p.$kg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const E=process.platform!=="darwin"&&e.$Oh?e.$Oh:(0,s.tmpdir)(),R=(0,b.$ic)(E,`vscode-ipc-${I}.sock`);return n(R),R}e.$Ph=r;function t(I,E,R){const L=(0,S.createHash)("md5").update(I).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${R}-${E}-sock`;const F=R.substr(0,4),U=E.substr(0,6),x=L.substr(0,8);let Y;return process.platform!=="darwin"&&e.$Oh&&!process.env.VSCODE_PORTABLE?Y=(0,b.$ic)(e.$Oh,`vscode-${x}-${F}-${U}.sock`):Y=(0,b.$ic)(I,`${F}-${U}.sock`),n(Y),Y}e.$Qh=t;function n(I){const E=o[y.$u];typeof E=="number"&&I.length>=E&&console.warn(`WARNING: IPC handle "${I}" is longer than ${E} chars, try a shorter --user-data-dir`)}class c extends l.$Bh{static b(E){const R=d.Event.fromNodeEventEmitter(E,"connection");return d.Event.map(R,L=>({protocol:new v.$Ih(new $(L,"ipc-server-connection")),onDidClientDisconnect:d.Event.once(d.Event.fromNodeEventEmitter(L,"close"))}))}constructor(E){super(c.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Rh=c;function m(I){return new Promise((E,R)=>{const L=(0,A.createServer)();L.on("error",R),L.listen(I,()=>{L.removeListener("error",R),E(new c(L))})})}e.$Sh=m;function D(I,E){return new Promise((R,L)=>{const F=(0,A.createConnection)(I,()=>{F.removeListener("error",L),R(v.$Jh.fromSocket(new $(F,`ipc-client${E}`),E))});F.once("error",L)})}e.$Th=D}),define(se[24],re([0,1,56,9,4,99,37,90,6]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$7b=e.$07b=void 0,e.$07b=(0,d.$Yh)(C.$5h);class u extends P.$rm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,A.$ic)(this.userDataPath,"clp")}get backupHome(){return(0,A.$ic)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$Qh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,A.$ic)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const y in process.env)if(y.endsWith("_VSCODE_SNAP_ORIG")){const p=y.slice(0,-17);if(this.d[p])continue;process.env[p]&&(this.d[p]=process.env[p]),process.env[y]?process.env[p]=process.env[y]:delete process.env[p]}}}restoreSnapExportedVariables(){if(s.$k)for(const y in this.d)process.env[y]=this.d[y],delete this.d[y]}}e.$$7b=u,ve([S.$ph],u.prototype,"cachedLanguagesPath",null),ve([S.$ph],u.prototype,"backupHome",null),ve([S.$ph],u.prototype,"mainIPCHandle",null),ve([S.$ph],u.prototype,"mainLockfile",null),ve([S.$ph],u.prototype,"disableUpdates",null),ve([S.$ph],u.prototype,"crossOriginIsolated",null),ve([S.$ph],u.prototype,"codeCachePath",null),ve([S.$ph],u.prototype,"useCodeCache",null)}),define(se[283],re([0,1,86,33,13,9,4,19,21,196,17,24,34,16,5,195,30,98]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w,g){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$P8b=void 0;let a=class{static{h=this}static{this.a="backupWorkspaces"}constructor(f,i,o,r){this.j=f,this.k=i,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.$sg,this.i={isEqual:(t,n)=>(0,A.$1f)(t,n,!C.$k)}}async initialize(){const f=this.m.getItem(h.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(f.emptyWindows),this.d=await this.u((0,u.$o8b)(f)),this.e=await this.v((0,u.$p8b)(f)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==l.$Fk.OFF}q(){return this.s()===l.$Fk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||l.$Fk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(f,i){this.d.some(r=>f.workspace.id===r.workspace.id)||(this.d.push(f),this.C());const o=(0,M.$ic)(this.c,f.workspace.id);return i?this.t(o,i).then(()=>o):o}async t(f,i){if(await d.Promises.exists(f)&&await this.z(f),await d.Promises.exists(i))try{await d.Promises.rename(i,f,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(f){return this.e.some(i=>this.h.isEqual(f.folderUri,i.folderUri))||(this.e.push(f),this.C()),(0,M.$ic)(this.c,this.D(f))}registerEmptyWindowBackup(f){return this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,f.backupFolder))||(this.g.push(f),this.C()),(0,M.$ic)(this.c,f.backupFolder)}async u(f){if(!Array.isArray(f))return[];const i=new Set,o=[];for(const r of f){const t=r.workspace;if(!(0,w.$ai)(t))return[];if(!i.has(t.id)){i.add(t.id);const n=(0,M.$ic)(this.c,t.id);await this.B(n)?t.configPath.scheme!==s.Schemas.file||await d.Promises.exists(t.configPath.fsPath)?o.push(r):await this.z(n):await this.x(n)}}return o}async v(f){if(!Array.isArray(f))return[];const i=[],o=new Set;for(const r of f){const t=r.folderUri,n=this.h.getComparisonKey(t);if(!o.has(n)){o.add(n);const c=(0,M.$ic)(this.c,this.D(r));await this.B(c)?t.scheme!==s.Schemas.file||await d.Promises.exists(t.fsPath)?i.push(r):await this.z(c):await this.x(c)}}return i}async w(f){if(!Array.isArray(f))return[];const i=[],o=new Set;for(const r of f){const t=r.backupFolder;if(typeof t!="string")return[];if(!o.has(t)){o.add(t);const n=(0,M.$ic)(this.c,t);await this.B(n)?i.push(r):await this.x(n)}}return i}async x(f){try{await d.Promises.rm(f,d.RimRafMode.MOVE)}catch(i){this.l.error(`Backup: Could not delete stale backup: ${i.toString()}`)}}y(){let f=(0,g.$A8b)();for(;this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,f.id));)f=(0,g.$A8b)();return{backupFolder:f.id}}async z(f){const i=this.y(),o=(0,M.$ic)(this.c,i.backupFolder);try{await d.Promises.rename(f,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(i),!0}async getDirtyWorkspaces(){const f=[];for(const i of this.d)await this.A(i)&&f.push(i);for(const i of this.e)await this.A(i)&&f.push(i);return f}A(f){let i;return(0,u.$n8b)(f)?i=(0,M.$ic)(this.c,f.backupFolder):(0,$.$$eb)(f)?i=(0,M.$ic)(this.c,this.D(f)):i=(0,M.$ic)(this.c,f.workspace.id),this.B(i)}async B(f){try{const i=await d.Promises.readdir(f);for(const o of i)try{if((await d.Promises.readdir((0,M.$ic)(f,o))).length>0)return!0}catch{}}catch{}return!1}C(){const f={workspaces:this.d.map(({workspace:i,remoteAuthority:o})=>{const r={id:i.id,configURIPath:i.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:i,remoteAuthority:o})=>{const r={folderUri:i.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:i,remoteAuthority:o})=>{const r={backupFolder:i};return o&&(r.remoteAuthority=o),r})};this.m.setItem(h.a,f)}D(f){const i=f.folderUri;let o;return i.scheme===s.Schemas.file?o=C.$k?i.fsPath:i.fsPath.toLowerCase():o=i.toString().toLowerCase(),(0,S.createHash)("md5").update(o).digest("hex")}};e.$P8b=a,e.$P8b=a=h=ve([te(0,y.$07b),te(1,b.$ri),te(2,v.$fj),te(3,p.$QN)],a)}),define(se[20],re([0,1,15,36,8,3,2,4,35,12,6,5,34,24]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$a8b=e.LifecycleMainPhase=e.ShutdownReason=e.$_7b=void 0,e.$_7b=(0,b.$Xh)("lifecycleMainService");var $;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})($||(e.ShutdownReason=$={}));var w;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen",h[h.Eventually=4]="Eventually"})(w||(e.LifecycleMainPhase=w={}));let g=class extends C.$Rc{static{v=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(a,k,f){super(),this.F=a,this.G=k,this.H=f,this.c=this.B(new M.$Rd),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$Rd),this.onWillShutdown=this.f.event,this.g=this.B(new M.$Rd),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$Rd),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(v.b),this.m&&this.G.removeItem(v.b)}J(){const a=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.$j&&this.t===0&&this.L(1))};S.app.addListener("before-quit",a);const k=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!P.$j)&&S.app.quit()};S.app.addListener("window-all-closed",k),S.app.once("will-quit",f=>{this.S("Lifecycle#app.on(will-quit) - begin"),f.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),S.app.removeListener("before-quit",a),S.app.removeListener("window-all-closed",k),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),S.app.quit()})})}L(a){if(this.y)return this.y;const k=this.F;this.S("Lifecycle#onWillShutdown.fire()");const f=[];return this.f.fire({reason:a,join(i,o){k.trace(`Lifecycle#onWillShutdown - begin '${i}'`),f.push(o.finally(()=>{k.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(f)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(a){if(a<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===a)return;this.S(`lifecycle (main): phase changed (value: ${a})`),this.n=a;const k=this.C.get(this.n);k&&(k.open(),this.C.delete(this.n))}async when(a){if(a<=this.n)return;let k=this.C.get(a);k||(k=new s.$Yg,this.C.set(a,k)),await k.wait()}registerWindow(a){const k=new C.$Qc;this.t++,k.add(a.onWillLoad(i=>this.g.fire({window:a,workspace:i.workspace,reason:i.reason})));const f=(0,u.$Nf)(a.win);f.on("close",i=>{const o=a.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${a.id}`),i.preventDefault(),this.unload(a,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(a),a.close()})}),f.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${a.id}`),this.t--,k.dispose(),this.t===0&&(!P.$j||this.j)&&this.L(1)})}async reload(a,k){await this.unload(a,3)||a.reload(k)}unload(a,k){const f=this.z.get(a.id);if(f)return f;const i=this.M(a,k).finally(()=>{this.z.delete(a.id)});return this.z.set(a.id,i),i}async M(a,k){if(!a.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${a.id}`);const f=this.j?2:k,i=await this.P(a,f);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${a.id})`),this.N(i)):(await this.Q(a,f),!1)}N(a){return a?(this.O(!0),this.j=!1,!0):!1}O(a){this.w&&(this.w(a),this.w=void 0,this.u=void 0)}P(a,k){return new Promise(f=>{const i=this.s++,o=`vscode:ok${i}`,r=`vscode:cancel${i}`;A.$XT.once(o,()=>{f(!1)}),A.$XT.once(r,()=>{f(!0)}),a.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:k})})}Q(a,k){return new Promise(f=>{const o=`vscode:reply${this.s++}`;A.$XT.once(o,()=>f()),a.send("vscode:onWillUnload",{replyChannel:o,reason:k})})}quit(a){return this.R(a).then(k=>{if(!k&&a)try{if(P.$i){const f=(0,d.cwd)();f!==process.cwd()&&process.chdir(f)}}catch(f){this.F.error(f)}return k})}R(a){return this.S(`Lifecycle#quit() - begin (willRestart: ${a})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(a&&this.G.setItem(v.b,!0),this.u=new Promise(k=>{this.w=k,this.S("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.u)}S(a){this.H.args["enable-smoke-test-driver"]?this.F.info(a):this.F.trace(a)}setRelaunchHandler(a){this.D=a}async relaunch(a){this.S("Lifecycle#relaunch()");const k=process.argv.slice(1);if(a?.addArgs&&k.push(...a.addArgs),a?.removeArgs)for(const o of a.removeArgs){const r=k.indexOf(o);r>=0&&k.splice(r,1)}const f=()=>{this.D?.handleRelaunch(a)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:k}))};S.app.once("quit",f),await this.quit(!0)&&S.app.removeListener("quit",f)}async kill(a){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$1g)(1e3),(async()=>{for(const k of S.BrowserWindow.getAllWindows())if(k&&!k.isDestroyed()){let f;k.webContents&&!k.webContents.isDestroyed()?f=new Promise(i=>k.once("closed",i)):f=Promise.resolve(),k.destroy(),await f}})()]),S.app.exit(a)}};e.$a8b=g,e.$a8b=g=v=ve([te(0,y.$fj),te(1,p.$QN),te(2,l.$07b)],g)}),define(se[284],re([0,1,4,3,2,6,20]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a9b=e.$_8b=void 0,e.$_8b=(0,M.$Xh)("keyboardLayoutMainService");let P=class extends s.$Rc{constructor(b){super(),this.a=this.B(new A.$Rd),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,b.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const b=await new Promise((y,p)=>{J(["native-keymap"],y,p)});this.c=d(b),S.$t||b.onDidChangeKeyboardLayout(()=>{this.c=d(b),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$a9b=P,e.$a9b=P=ve([te(0,C.$_7b)],P);function d(u){const b=u.getKeyMap(),y=u.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:y}}}),define(se[285],re([0,1,246,8,18,14,12,17,37,94,5,51,245,282]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=void 0;let v=class extends y.$2o{constructor(h,a,k,f){super(f),this.m=h,this.n=a,this.r=k,this.s(),this.B(h.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const h=this.m.getValue("http");this.f=h?.proxy,this.g=!!h?.proxyStrictSSL,this.h=h?.proxyAuthorization}async request(h,a){const{f:k,g:f}=this;let i;try{i=await(0,u.$2l)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$9)(t)))}const o={...process.env,...i},r=h.agent?h.agent:await(0,p.$6q)(h.url||"",o,{proxyUrl:k,strictSSL:f});return h.agent=r,h.strictSSL=f,this.h&&(h.headers={...h.headers||{},"Proxy-Authorization":this.h}),this.c(h.isChromiumNetwork?"electron":"node",h,()=>w(h,a))}async resolveProxy(h){}async loadCertificates(){return(await new Promise((a,k)=>{J(["@vscode/proxy-agent"],a,k)})).loadSystemCertificates({log:this.r})}};e.$7q=v,e.$7q=v=ve([te(0,P.$ri),te(1,d.$6h),te(2,b.$fj),te(3,b.$gj)],v);async function $(g){return((0,S.parse)(g.url).protocol==="https:"?await new Promise((k,f)=>{J(["https"],k,f)}):await new Promise((k,f)=>{J(["http"],k,f)})).request}async function w(g,h){return A.Promises.withAsyncBody(async(a,k)=>{const f=(0,S.parse)(g.url),i=g.getRawRequest?g.getRawRequest(g):await $(g),o={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,C.$If)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(o.auth=g.user+":"+g.password);const r=i(o,t=>{const n=(0,C.$Gf)(g.followRedirects)?g.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)w({...g,url:t.headers.location,followRedirects:n-1},h).then(a,k);else{let c=t;!g.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(c=t.pipe((0,l.createGunzip)())),a({res:t,stream:(0,s.$ue)(c)})}});r.on("error",k),g.timeout&&r.setTimeout(g.timeout),g.isChromiumNetwork&&r.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&r.write(g.data),r.end(),h.onCancellationRequested(()=>{r.abort(),k(new M.$4)})})}e.$8q=w}),define(se[286],re([0,1,15,285]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c0b=void 0;function s(C){return S.net.request}class M extends A.$7q{request(P,d){return super.request({...P||{},getRawRequest:s,isChromiumNetwork:!0},d)}}e.$c0b=M}),define(se[82],re([0,1,7,3,2,37,16,6,20,5,96,279,41,54,40,13]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k8b=e.$j8b=e.$i8b=e.$h8b=void 0,e.$h8b=(0,P.$Xh)("storageMainService");let w=class extends s.$Rc{constructor(a,k,f,i,o,r){super(),this.c=a,this.f=k,this.g=f,this.h=i,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new A.$Rd),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(a=>{a.window.profile&&this.profileStorage(a.window.profile).init(),a.workspace&&this.workspaceStorage(a.workspace).init()})),this.B(this.h.onWillShutdown(a=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=a.reason,a.join("applicationStorage",this.applicationStorage.close());for(const[,k]of this.t)a.join("profileStorage",k.close());for(const[,k]of this.w)a.join("workspaceStorage",k.close())})),this.B(this.g.onWillCreateProfile(a=>{a.join((async()=>{await this.j.exists(a.profile.globalStorageHome)||await this.j.createFolder(a.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(a=>{const k=this.t.get(a.profile.id);k&&a.join(k.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const a=new y.$c8b(this.n(),this.g,this.c,this.j);return this.B(A.Event.once(a.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),a}profileStorage(a){if((0,b.$ep)(a))return this.applicationStorage;let k=this.t.get(a.id);if(!k){this.c.trace(`StorageMainService: creating profile storage (${a.name})`),k=this.B(this.u(a)),this.t.set(a.id,k);const f=this.B(k.onDidChangeStorage(i=>this.b.fire({...i,storage:k,profile:a})));this.B(A.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${a.name})`),this.t.delete(a.id),f.dispose()}))}return k}u(a){return this.a===2?new y.$e8b(this.c,this.j):new y.$b8b(a,this.n(),this.c,this.j)}workspaceStorage(a){let k=this.w.get(a.id);return k||(this.c.trace(`StorageMainService: creating workspace storage (${a.id})`),k=this.B(this.y(a)),this.w.set(a.id,k),this.B(A.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${a.id})`),this.w.delete(a.id)}))),k}y(a){return this.a===2?new y.$e8b(this.c,this.j):new y.$d8b(a,this.n(),this.c,this.f,this.j)}isUsed(a){const k=S.URI.file(a);for(const f of[this.applicationStorage,...this.t.values(),...this.w.values()])if(f.path&&this.m.extUri.isEqualOrParent(S.URI.file(f.path),k))return!0;return!1}};e.$i8b=w,e.$i8b=w=ve([te(0,u.$fj),te(1,M.$5h),te(2,l.$f8b),te(3,d.$_7b),te(4,C.$gk),te(5,v.$Qk)],w),e.$j8b=(0,P.$Xh)("applicationStorageMainService");let g=class extends b.$dp{constructor(a,k){super(),this.s=a,this.U=k,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(a){if(a===-1)return this.U.applicationStorage.storage}Q(a){if(a===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:$.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$k8b=g,e.$k8b=g=ve([te(0,p.$Sk),te(1,e.$h8b)],g)}),define(se[287],re([0,1,87,28,103,99,8,2,4,17,5,26,241,242,95,126,18]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b0b=e.$a0b=e.$_9b=e.$$9b=void 0;async function g(i,o,r,t,n){let c;for(let m=3;m&&(c?.dispose(),c=await new h(i,o,r,t,n).waitForReady(),!(n&&s.$ng[n]||!s.$ng[c.tunnelLocalPort]));m--);return c}class h extends P.$Rc{constructor(o,r,t,n,c){super(),this.m=r,this.n=c,this.privacy=$.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=S.createServer(),this.c=new C.$Yg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=m=>this.r(m),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,$.$mv)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,s.$og)(o,2,1e3,r),n=null;return this.b.listen(t,this.m),await this.c.wait(),n=this.b.address(),n||(t=0,this.b.listen(t,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(o){o.pause();const r=(0,$.$kv)(this.tunnelRemoteHost)||(0,$.$mv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,p.$bl)(this.a,r,this.tunnelRemotePort),n=t.getSocket(),c=t.readEntireBuffer();t.dispose(),c.byteLength>0&&o.write(c.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),n.end()}),o.on("close",()=>n.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),n instanceof M.$Mh?n.socket.destroy():n.end()}),n instanceof M.$Mh?this.t(o,n):this.s(o,n),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),n.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(t=>o.write(t.buffer)),o.on("data",t=>r.write(w.$fe.wrap(t))),o.resume()}t(o,r){const t=r.socket;t.on("end",()=>o.end()),t.on("close",()=>o.end()),t.on("error",()=>{o.destroy()}),t.pipe(o),o.pipe(t)}}e.$$9b=h;let a=class extends $.$pv{constructor(o,r,t,n,c){super(r,c),this.u=o,this.v=t,this.w=n}isPortPrivileged(o){return(0,$.$nv)(o,this.l,d.OS,A.release())}s(o,r,t,n,c,m,D,I){const E=this.r(r,t);if(E)return++E.refcount,E.value;if((0,$.$hv)(o))return this.t(o,r,t,c,m,D,I);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${t} on local port ${c}.`);const R={commit:this.w.commit,quality:this.w.quality,addressProvider:o,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},L=g(R,n,r,t,c);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,t,L),L}}};e.$_9b=a,e.$_9b=a=ve([te(0,l.$8k),te(1,b.$fj),te(2,v.$$k),te(3,y.$xj),te(4,u.$ri)],a);let k=class extends a{constructor(o,r,t,n,c){super(o,r,t,n,c)}};e.$a0b=k,e.$a0b=k=ve([te(0,l.$8k),te(1,b.$fj),te(2,v.$$k),te(3,y.$xj),te(4,u.$ri)],k);let f=class extends P.$Rc{constructor(o,r,t,n,c){super(),this.b=o,this.c=r,this.f=t,this.g=n,this.h=c,this.a=new Map}async openTunnel(o,r,t,n,c,m,D,I,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${n} on local port ${m}.`),!this.a.has(o)){const R=new k(this.b,this.c,this.g,this.f,this.h);this.B(R),this.a.set(o,R),R.onTunnelClosed(async()=>{(await R.tunnels).length===0&&(R.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,t,n,c,m,D,I,E)}};e.$b0b=f,e.$b0b=f=ve([te(0,l.$8k),te(1,b.$fj),te(2,y.$xj),te(3,v.$$k),te(4,u.$ri)],f)}),define(se[100],re([0,1,8,22,3,17,24,20,5,26,51,49]),function(J,e,S,A,s,M,C,P,d,u,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x9b=e.$w9b=void 0;function p(v,$,w){return`${w.updateUrl}/api/update/${v}/${$}/${w.commit}`}e.$w9b=p;let l=class{get state(){return this.b}d($){this.j.info("update#setState",$.type),this.b=$,this.c.fire($)}constructor($,w,g,h,a,k){this.f=$,this.g=w,this.h=g,this.i=h,this.j=a,this.k=k,this.b=y.$VU.Uninitialized,this.c=new s.$Rd,this.onStateChange=this.c.event,$.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(y.$VU.Disabled(0));return}if(this.h.disableUpdates){this.d(y.$VU.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(y.$VU.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const $=this.g.getValue("update.mode"),w=this.m($);if(!w){this.d(y.$VU.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(w),!this.a){this.d(y.$VU.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const g=new URL(this.a);g.searchParams.set("prss","true"),this.a=g.toString()}if(this.d(y.$VU.Idle(this.q())),$==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}$==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,g=>this.j.error(g))}m($){return $==="none"?void 0:this.k.quality}n($=60*60*1e3){return(0,S.$1g)($).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates($){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t($)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o($){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then($=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${$}`),!$&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},A.CancellationToken.None)).res.statusCode===204}catch(w){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(w);return}}async _applySpecificUpdate($){}q(){return 1}r(){}};e.$x9b=l,e.$x9b=l=ve([te(0,P.$_7b),te(1,M.$ri),te(2,C.$07b),te(3,b.$1o),te(4,d.$fj),te(5,u.$xj)],l)}),define(se[288],re([0,1,15,56,3,45,2,17,24,20,5,26,51,27,49,100]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y9b=void 0;let w=class extends $.$x9b{get v(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"error",(h,a)=>a)}get w(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(h,a,k)=>({url:a,version:k,productVersion:k}))}get y(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(h,a,k,f)=>({releaseNotes:a,version:k,productVersion:k,date:f}))}constructor(h,a,k,f,i,o,r){super(h,a,f,i,o,r),this.z=k,this.u=new C.$Qc,h.setRelaunchHandler(this)}handleRelaunch(h){return h?.addArgs||h?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(h){this.z.publicLog2("update:error",{messageHash:String((0,M.$Li)(String(h)))}),this.j.error("UpdateService error:",h);const a=this.state.type==="checking for updates"&&this.state.explicit?h:void 0;this.d(v.$VU.Idle(1,a))}s(h){let a;this.k.darwinUniversalAssetId?a=this.k.darwinUniversalAssetId:a=process.arch==="x64"?"darwin":"darwin-arm64";const k=(0,$.$w9b)(a,h,this.k);try{S.autoUpdater.setFeedURL({url:k})}catch(f){this.j.error("Failed to set update feed URL",f);return}return k}t(h){this.d(v.$VU.CheckingForUpdates(h)),S.autoUpdater.checkForUpdates()}E(h){this.state.type==="checking for updates"&&this.d(v.$VU.Downloading(h))}F(h){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:h.version}),this.d(v.$VU.Ready(h)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(v.$VU.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$y9b=w,ve([A.$ph],w.prototype,"v",null),ve([A.$ph],w.prototype,"w",null),ve([A.$ph],w.prototype,"x",null),ve([A.$ph],w.prototype,"y",null),e.$y9b=w=ve([te(0,u.$_7b),te(1,P.$ri),te(2,l.$kl),te(3,d.$07b),te(4,p.$1o),te(5,b.$fj),te(6,y.$xj)],w)}),define(se[289],re([0,1,48,46,8,3,9,24,20,5,27,49]),function(J,e,S,A,s,M,C,P,d,u,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A9b=void 0;let p=class{get state(){return this.a}d($){this.g.info("update#setState",$.type),this.a=$,this.b.fire($)}constructor($,w,g){if(this.f=$,this.g=g,this.a=y.$VU.Uninitialized,this.b=new M.$Rd,this.onStateChange=this.b.event,w.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(y.$VU.Idle(this.k())),this.h(30*1e3).then(void 0,h=>this.g.error(h))}h($=60*60*1e3){return(0,s.$1g)($).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates($){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m($)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i($){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then($=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${$}`),!$&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate($){}};p=ve([te(0,d.$_7b),te(1,P.$07b),te(2,u.$fj)],p);let l=class extends p{constructor($,w,g,h,a,k){super(g,h,a),this.o=$,this.p=w,this.q=k;const f=(0,A.watch)(C.$lc(this.o)),i=M.Event.fromNodeEventEmitter(f,"change",(n,c)=>c),o=M.Event.filter(i,n=>n==="current"),t=M.Event.debounce(o,(n,c)=>c,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{t.dispose(),f.close()})}m(){this.d(y.$VU.CheckingForUpdates(!1)),this.u().then($=>{$?this.d(y.$VU.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.$VU.Idle(2)))},$=>{this.g.error($),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.$VU.Idle(2,$.message||$))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+C.$mc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const $=await new Promise((g,h)=>(0,A.realpath)(`${C.$lc(this.o)}/current`,(a,k)=>a?h(a):g(k))),w=C.$mc($);return this.p!==w}isLatestVersion(){return this.u().then(void 0,$=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$A9b=l,e.$A9b=l=ve([te(2,d.$_7b),te(3,P.$07b),te(4,u.$fj),te(5,b.$kl)],l)}),define(se[29],re([0,1,4,6,60,69,26,17,24,9,64]),function(J,e,S,A,s,M,C,P,d,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N8b=e.$M8b=e.$L8b=e.OpenContext=e.$K8b=void 0,e.$K8b=(0,A.$Xh)("windowsMainService");var y;(function($){$[$.CLI=0]="CLI",$[$.DOCK=1]="DOCK",$[$.MENU=2]="MENU",$[$.DIALOG=3]="DIALOG",$[$.DESKTOP=4]="DESKTOP",$[$.API=5]="API"})(y||(e.OpenContext=y={}));function p($,w,g){const h=$.get(M.$l8b),a=$.get(C.$xj),k=$.get(P.$ri),f=$.get(d.$07b),i=k.getValue("window"),o={backgroundColor:h.getBackgroundColor(),minWidth:s.$oC.WIDTH,minHeight:s.$oC.HEIGHT,title:a.nameLong,...g,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$wC)(i?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...g?.webPreferences,sandbox:!0},experimentalDarkMode:!0};return w&&(o.x=w.x,o.y=w.y,o.width=w.width,o.height=w.height),S.$k?o.icon=(0,u.$ic)(f.appRoot,"resources/linux/code.png"):S.$i&&!f.isBuilt&&(o.icon=(0,u.$ic)(f.appRoot,"resources/win32/code_150x150.png")),S.$j&&(o.acceptFirstMouse=!0,i?.clickThroughInactive===!1&&(o.acceptFirstMouse=!1)),o}e.$L8b=p;function l($){const w=$.get(e.$K8b),g=$.get(b.$I8b),h=w.getFocusedWindow()??g.getFocusedWindow();if(h)return h;const a=w.getLastActiveWindow(),k=g.getLastActiveWindow();return a&&k?a.lastFocusTime<k.lastFocusTime?k:a:a??k}e.$M8b=l;function v($){let w,g=Number.MIN_VALUE;for(const h of $)h.lastFocusTime>g&&(g=h.lastFocusTime,w=h);return w}e.$N8b=v}),define(se[290],re([0,1,15,22,3,45,2,32,116,5,82,29]),function(J,e,S,A,s,M,C,P,d,u,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O8b=void 0;var p;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let l=class extends C.$Rc{constructor($,w,g,h){super(),this.g=$,this.h=w,this.j=g,this.m=h,this.a="proxy-credentials://",this.b=void 0,this.c=p.Initial,this.f=void 0,this.n()}n(){const $=s.Event.fromNodeEventEmitter(S.app,"login",(w,g,h,a,k)=>({event:w,webContents:g,req:h,authInfo:a,callback:k}));this.B($(this.r,this))}async r({event:$,authInfo:w,req:g,callback:h}){if(!w.isProxy)return;if(!this.b&&this.c===p.LoginDialogShown&&g.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}$.preventDefault();let a;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(w);try{a=await this.b}finally{this.b=void 0}}h(a?.username,a?.password)}async s($){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.t($);if(w)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t($){this.g.trace("auth#doResolveProxyCredentials - enter",$);const w=String((0,M.$Li)({scheme:$.scheme,host:$.host,port:$.port}));let g,h;try{const i=this.m.get(this.a+w,-1);if(i){const o=JSON.parse(await this.j.decrypt(i));g=o.username,h=o.password}}catch(i){this.g.error(i)}if(this.c!==p.StoredCredentialsUsed&&typeof g=="string"&&typeof h=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=p.StoredCredentialsUsed,{username:g,password:h};const a=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!a){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const k={authInfo:$,username:this.f?.username??g,password:this.f?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,P.$kg)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",A.CancellationToken.None,k),this.c=p.LoginDialogShown;const f=await new Promise(i=>{const o=async(r,t,n)=>{if(t===k.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",o),n){const c={username:n.username,password:n.password};try{if(n.remember){const m=await this.j.encrypt(JSON.stringify(c));this.m.store(this.a+w,m,-1,1)}else this.m.remove(this.a+w,-1)}catch(m){this.g.error(m)}i({username:c.username,password:c.password})}else i(void 0)};a.win?.webContents.on("ipc-message",o)});return this.f=f,f}};e.$O8b=l,e.$O8b=l=ve([te(0,u.$fj),te(1,y.$K8b),te(2,d.$GU),te(3,b.$j8b)],l)}),define(se[291],re([0,1,15,23,4,7,21,17,63,6,5,127,29]),function(J,e,S,A,s,M,C,P,d,u,b,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d9b=e.$c9b=e.ID=void 0,e.ID="launchMainService",e.$c9b=(0,u.$Xh)(e.ID);let l=class{constructor($,w,g,h){this.a=$,this.b=w,this.c=g,this.d=h}async start($,w){this.a.trace("Received data from other instance: ",$,w),s.$j&&S.app.focus({steal:!0});const g=this.e($);if(g.length){let h=Promise.resolve();if(this.b.getWindowCount()===0){const a=(0,A.$Nb)(await this.b.openEmptyWindow({context:4}));a&&(h=a.ready())}h.then(()=>{for(const{uri:a,originalUrl:k}of g)this.c.open(a,{originalUrl:k})})}else return this.f($,w)}e($){return $["open-url"]&&$._urls&&$._urls.length>0?(0,A.$Gb)($._urls.map(w=>{try{return{uri:M.URI.parse(w),originalUrl:w}}catch{return null}})):[]}async f($,w){const g=(0,d.$Vl)(w)?0:4;let h=[];const a=$.wait&&$.waitMarkerFilePath?M.URI.file($.waitMarkerFilePath):void 0,k=$.remote||void 0,f={context:g,cli:$,userEnv:w,waitMarkerFileURI:a,remoteAuthority:k,forceProfile:$.profile,forceTempProfile:$["profile-temp"]};if($.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow($.extensionDevelopmentPath,f);else if(!$._.length&&!$["folder-uri"]&&!$["file-uri"]){let i=!1;if($["new-window"]||$["unity-launch"]||f.forceProfile||f.forceTempProfile)i=!0;else if($["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!s.$j}if(i)h=await this.b.open({...f,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,f),h=[o]):h=await this.b.open({...f,forceEmpty:!0})}}else h=await this.b.open({...f,forceNewWindow:$["new-window"],preferNewWindow:!$["reuse-window"]&&!$.wait,forceReuseWindow:$["reuse-window"],diffMode:$.diff,mergeMode:$.merge,addMode:$.add,noRecentEntry:!!$["skip-add-to-recently-opened"],gotoLineMode:$.goto});if(a&&h.length===1&&h[0])return Promise.race([h[0].whenClosedOrLoaded,(0,C.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$d9b=l,e.$d9b=l=ve([te(0,b.$fj),te(1,p.$K8b),te(2,y.$MU),te(3,P.$ri)],l)}),define(se[292],re([0,1,2,20,54,30,8,29]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S9b=void 0;let d=class extends S.$Rc{constructor(b,y,p){super(),this.a=y,this.b=p,this.B(b.onWillLoadWindow(l=>{l.reason===2&&this.c(l.window)})),this.B(b.onBeforeCloseWindow(l=>this.c(l))),this.B(new C.$_g(()=>this.g(),30*1e3)).schedule()}async c(b){const y=this.f(b),p=this.a.getProfileForWorkspace(y);p?.isTransient&&(this.a.unsetWorkspace(y,p.isTransient),p.isTransient&&await this.a.cleanUpTransientProfiles())}f(b){return b.openedWorkspace??(0,M.$_h)(b.backupPath,b.isExtensionDevelopmentHost)}g(){const b=this.a.getAssociatedEmptyWindows();if(b.length===0)return;const y=this.b.getWindows().map(p=>this.f(p));for(const p of b)y.some(l=>l.id===p.id)||this.a.unsetWorkspace(p,!1)}};e.$S9b=d,e.$S9b=d=ve([te(0,A.$_7b),te(1,s.$f8b),te(2,P.$K8b)],d)}),define(se[61],re([0,1,15,2,3,5,312,8,13,29,74,27,20,76,38,4,131]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$S8b=e.$R8b=void 0;function h(f){return typeof f.responseWindowId=="number"}let a=class extends A.$Rc{static{g=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(g.b.values())}constructor(i,o,r){super(),this.u=i,this.w=o,this.y=r,this.c=String(++g.a),this.f=this.B(new s.$Rd),this.onStdout=this.f.event,this.g=this.B(new s.$Rd),this.onStderr=this.g.event,this.h=this.B(new s.$Rd),this.onMessage=this.h.event,this.j=this.B(new s.$Rd),this.onSpawn=this.j.event,this.m=this.B(new s.$Rd),this.onExit=this.m.event,this.n=this.B(new s.$Rd),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(i,o){let r;switch(this.t?.correlationId?r=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${i}`:r=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${i}`,o){case b.default.Error:this.u.error(r);break;case b.default.Warning:this.u.warn(r);break;case b.default.Info:this.u.trace(r);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",b.default.Error),!1):!0}start(i){const o=this.D(i);return o&&i.payload&&this.postMessage(i.payload),o}D(i){if(!this.C())return!1;this.t=i;const o=`${this.t.type}-${this.c}`,r=d.$ig.asFileUri("bootstrap-fork.js").fsPath,t=this.t.args??[],n=this.t.execArgv??[],c=this.t.allowLoadingUnsignedLibraries,m=this.t.forceAllocationsToV8Sandbox,D="pipe",I=this.F(i);return this.z("creating new...",b.default.Info),this.r=S.utilityProcess.fork(r,t,{serviceName:o,env:I,execArgv:n,allowLoadingUnsignedLibraries:c,forceAllocationsToV8Sandbox:m,stdio:D}),this.G(this.r,this.t,o),!0}F(i){const o=i.env?{...i.env}:{...(0,v.$cn)(process.env)};o.VSCODE_AMD_ENTRYPOINT=i.entryPoint,typeof i.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(i.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=i.type,$.$i&&((0,w.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,w.getUNCHostAllowlist)().join("\\")),(0,l.$Il)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}G(i,o,r){if(i.stdout){const t=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:t.write(n))))}if(i.stderr){const t=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:t.write(n))))}this.B(s.Event.fromNodeEventEmitter(i,"message")(t=>this.h.fire(t))),this.B(s.Event.fromNodeEventEmitter(i,"spawn")(()=>{this.s=i.pid,typeof i.pid=="number"&&g.b.set(i.pid,{pid:i.pid,name:h(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",b.default.Info),this.j.fire(i.pid)})),this.B(s.Event.fromNodeEventEmitter(i,"exit")(t=>{this.z(`received exit event with code ${t}`,b.default.Info),this.m.fire({pid:this.s,code:t,signal:"unknown"}),this.H()})),this.B(s.Event.fromNodeEventEmitter(S.app,"child-process-gone",(t,n)=>({event:t,details:n}))(({details:t})=>{t.type==="Utility"&&t.name===r&&(this.z(`crashed with code ${t.exitCode} and reason '${t.reason}'`,b.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:t.reason,code:t.exitCode}),this.n.fire({pid:this.s,code:t.exitCode,reason:t.reason}),this.H())}))}once(i,o){const r=this.B(this.h.event(t=>{t===i&&(r.dispose(),o())}))}postMessage(i,o){this.r&&this.r.postMessage(i,o)}connect(i){const{port1:o,port2:r}=new S.MessageChannelMain;return this.postMessage(i,[r]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",b.default.Info);const i=process;return typeof i._debugProcess=="function"?(i._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",b.default.Info),this.r.kill()?(this.z("successfully killed the process",b.default.Info),this.H()):this.z("unable to kill the process",b.default.Warning)}H(){typeof this.s=="number"&&g.b.delete(this.s),this.r=void 0}async waitForExit(i){this.r&&(this.z("waiting to exit...",b.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,P.$1g)(i)]),this.r&&(this.z(`did not exit within ${i}ms, will kill it now...`,b.default.Info),this.kill()))}};e.$R8b=a,e.$R8b=a=g=ve([te(0,M.$fj),te(1,y.$kl),te(2,p.$_7b)],a);let k=class extends a{constructor(i,o,r,t){super(i,r,t),this.I=o}start(i){const o=this.I.getWindowById(i.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",b.default.Error),!0;if(!super.D(i))return!1;this.J(o.win,i);const t=this.connect(i.payload);return o.win.webContents.postMessage(i.responseChannel,i.responseNonce,[t]),!0}J(i,o){o.windowLifecycleBound&&(this.B(s.Event.filter(this.y.onWillLoadWindow,r=>r.window.win===i)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(i,"closed")(()=>this.kill())))}};e.$S8b=k,e.$S8b=k=ve([te(0,M.$fj),te(1,u.$K8b),te(2,y.$kl),te(3,p.$_7b)],k)}),define(se[293],re([0,1,14,3,5,20,8,61,29,27]),function(J,e,S,A,s,M,C,P,d,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Z8b=void 0;let y=class{static{b=this}static{this.a=0}constructor(l,v,$,w){this.d=l,this.f=v,this.g=$,this.h=w,this.b=new Map,this.c=!1,this.f.onWillShutdown(g=>{this.c=!0,g.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(l){const v=this.b.get(l);if(!v)throw new Error("Unknown extension host!");return v}onDynamicStdout(l){return this.i(l).onStdout}onDynamicStderr(l){return this.i(l).onStderr}onDynamicMessage(l){return this.i(l).onMessage}onDynamicExit(l){return this.i(l).onExit}async createExtensionHost(){if(this.c)throw(0,S.$5)();const l=String(++b.a),v=new P.$S8b(this.d,this.g,this.h,this.f);return this.b.set(l,v),v.onExit(({pid:$,code:w,signal:g})=>{this.d.info(`Extension host with pid ${$} exited with code: ${w}, signal: ${g}.`),setTimeout(()=>{v.dispose(),this.b.delete(l)}),setTimeout(()=>{try{process.kill($,0),this.d.error(`Extension host with pid ${$} still exists, forcefully killing it...`),process.kill($)}catch{}},1e3)}),{id:l}}async start(l,v){if(this.c)throw(0,S.$5)();const $=this.i(l);return $.start({...v,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:v.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:l}),{pid:await A.Event.toPromise($.onSpawn)}}async enableInspectPort(l){if(this.c)throw(0,S.$5)();const v=this.b.get(l);return v?v.enableInspectPort():!1}async kill(l){if(this.c)throw(0,S.$5)();const v=this.b.get(l);v&&v.kill()}async _killAllNow(){for(const[,l]of this.b)l.kill()}async _waitForAllExit(l){const v=[];for(const[,$]of this.b)v.push($.waitForExit(l));return C.Promises.settled(v).then(()=>{})}};e.$Z8b=y,e.$Z8b=y=b=ve([te(0,s.$fj),te(1,M.$_7b),te(2,d.$K8b),te(3,u.$kl)],y)}),define(se[294],re([0,1,36,8,2,24,20,5,41,39,68,61,52,90,12,247]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q9b=void 0;let w=class extends s.$Rc{constructor(h,a,k,f,i,o,r,t){super(),this.c=h,this.f=a,this.g=k,this.h=f,this.j=i,this.m=o,this.n=r,this.r=t,this.a=new A.$Yg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){S.$XT.on($.$o9b.request,(h,a)=>this.t(h,a,$.$o9b.response)),S.$XT.on($.$p9b.request,(h,a)=>this.t(h,a,$.$p9b.response)),this.B(this.j.onWillShutdown(()=>this.u()))}async t(h,a,k){this.m.trace(`[SharedProcess] onWindowConnection for: ${k}`),this.a.isOpen()||this.a.open(),await this.whenReady();const f=await this.connect(k);if(h.sender.isDestroyed())return f.close();h.sender.postMessage(k,a,[f])}u(){this.m.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage($.$n9b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const h=new A.$kh;this.b?this.b.once($.$n9b.initDone,()=>h.complete()):S.$XT.once($.$n9b.initDone,()=>h.complete()),await h.p,this.m.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const h=new A.$kh;this.b?this.b.once($.$n9b.ipcReady,()=>h.complete()):S.$XT.once($.$n9b.ipcReady,()=>h.complete()),await h.p,this.m.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new y.$R8b(this.m,p.$to,this.j));const h=(0,l.$tm)(this.g.args,this.g.isBuilt);let a;h.port&&(a=["--nolazy"],h.break?a.push(`--inspect-brk=${h.port}`):a.push(`--inspect=${h.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:a})}D(){return{machineId:this.c,sqmId:this.f,codeCachePath:this.g.codeCachePath,profiles:{home:this.h.profilesHome,all:this.h.profiles},args:this.g.args,logLevel:this.n.getLogLevel(),loggers:this.n.getRegisteredLoggers(),policiesData:this.r.serialize()}}async connect(h){return await this.z,(0,v.$Nf)(this.b).connect(h)}};e.$q9b=w,e.$q9b=w=ve([te(2,M.$07b),te(3,d.$Sk),te(4,C.$_7b),te(5,P.$fj),te(6,b.$D8b),te(7,u.$qn)],w)}),define(se[295],re([0,1,24,90,20,5,52,61,110,36,2,3,38,17,13]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$39b=void 0;let $=class extends b.$Rc{constructor(g,h,a,k,f){super(),this.f=g,this.g=h,this.h=a,this.j=k,this.m=f,this.a=void 0,this.b=new y.$Rd,this.onRequestConnection=this.b.event,this.c=new y.$Rd,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),u.$XT.on("vscode:createPtyHostMessageChannel",(i,o)=>this.r(i,o)),this.B((0,b.$Pc)(()=>{u.$XT.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new P.$R8b(this.m,C.$to,this.j);const g=(0,A.$sm)(this.h.args,this.h.isBuilt),h=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:h,args:["--logsPath",this.h.logsHome.with({scheme:v.Schemas.file}).fsPath],env:this.n()});const a=this.a.connect(),k=new d.$6T(a,"ptyHost"),f=new b.$Qc;return f.add(k),f.add((0,b.$Pc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:k,store:f,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const g={...(0,p.$cn)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},h=this.g.getValue("terminal.integrated.developer.ptyHost.latency");h&&typeof h=="number"&&(g.VSCODE_LATENCY=String(h));const a=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return a&&typeof a=="number"&&(g.VSCODE_STARTUP_DELAY=String(a)),this.h.restoreSnapExportedVariables(),g}r(g,h){this.b.fire();const a=this.a.connect();if(g.sender.isDestroyed()){a.close();return}g.sender.postMessage("vscode:createPtyHostMessageChannelResult",h,[a])}};e.$39b=$,e.$39b=$=ve([te(1,l.$ri),te(2,S.$07b),te(3,s.$_7b),te(4,M.$fj)],$)}),define(se[296],re([0,1,2,6,5,29,61,27,45,3,8,20]),function(J,e,S,A,s,M,C,P,d,u,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$29b=e.$19b=void 0,e.$19b=(0,A.$Xh)("utilityProcessWorker");let p=class extends S.$Rc{constructor($,w,g,h){super(),this.b=$,this.c=w,this.f=g,this.g=h,this.a=new Map}async createWorker($){const w=`window: ${$.reply.windowId}, moduleId: ${$.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${w})`);const g=this.h($);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${w})`),this.disposeWorker($));const h=new l(this.b,this.c,this.f,this.g,$);if(!h.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,h);const a=new b.$kh;return u.Event.once(h.onDidTerminate)(k=>{k.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${k.code}, signal: ${k.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${k.code}, signal: ${k.signal}`),this.a.delete(g),a.complete({reason:k})}),a.p}h($){return(0,d.$Li)({moduleId:$.process.moduleId,windowId:$.reply.windowId})}async disposeWorker($){const w=this.h($),g=this.a.get(w);g&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${$.reply.windowId}, moduleId: ${$.process.moduleId})`),g.kill(),this.a.delete(w))}};e.$29b=p,e.$29b=p=ve([te(0,s.$fj),te(1,M.$K8b),te(2,P.$kl),te(3,y.$_7b)],p);let l=class extends S.$Rc{constructor($,w,g,h,a){super(),this.c=$,this.f=w,this.g=g,this.h=h,this.j=a,this.a=this.B(new u.$Rd),this.onDidTerminate=this.a.event,this.b=new C.$S8b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit($=>this.a.fire({code:$.code,signal:$.signal}))),this.B(this.b.onCrash($=>this.a.fire({code:$.code,signal:"ECRASH"})))}spawn(){const w=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:w,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};l=ve([te(0,s.$fj),te(1,M.$K8b),te(2,P.$kl),te(3,y.$_7b)],l)}),define(se[297],re([0,1,15,3,2,273,29]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I9b=void 0;let P=class extends s.$Rc{constructor(u){super(),this.b=u,this.a=this.B(new A.$Rd),this.onFoundInFrame=this.a.event,this.B(new M.$H9b)}async setIgnoreMenuShortcuts(u,b){let y;if(typeof u.windowId=="number"){const{windowId:p}=u,l=this.b.getWindowById(p);if(!l?.win)throw new Error(`Invalid windowId: ${p}`);y=l.win.webContents}else{const{webContentsId:p}=u;if(y=S.webContents.fromId(p),!y)throw new Error(`Invalid webContentsId: ${p}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(b)}async findInFrame(u,b,y,p){const v=this.c(u,b);if(typeof v.findInFrame=="function"){v.findInFrame(y,{findNext:p.findNext,forward:p.forward});const $=(w,g)=>{g.finalUpdate&&(this.a.fire(g),v.removeListener("found-in-frame",$))};v.on("found-in-frame",$)}}async stopFindInFrame(u,b,y){const l=this.c(u,b);typeof l.stopFindInFrame=="function"&&l.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}c(u,b){const y=this.b.getWindowById(u.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${u}`);const p=y.win.webContents.mainFrame.framesInSubtree.find(l=>l.name===b);if(!p)throw new Error(`Unknown frame: ${b}`);return p}};e.$I9b=P,e.$I9b=P=ve([te(0,C.$K8b)],P)}),define(se[298],re([0,1,15,2,4,19,7,17,20,5,34,29,128,30]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$L9b=e.$K9b=e.$J9b=void 0;let $=class extends A.$Rc{static{v=this}static{this.a="windowsState"}get state(){return this.b}constructor(f,i,o,r,t){super(),this.g=f,this.h=i,this.j=o,this.m=r,this.n=t,this.b=w(this.h.getItem(v.a)),this.c=void 0,this.f=!1,this.r()}r(){S.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(f=>this.u(f)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(f=>{f.newCount-f.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(f=>this.u(f))}s(){this.f=!0,this.t()}t(){const f=new Set,i={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!i.lastActiveWindow){let t=this.g.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),t&&(i.lastActiveWindow=this.w(t),i.lastActiveWindow.uiState.mode===3&&f.add(i.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(i.lastPluginDevelopmentHostWindow=this.w(o),i.lastPluginDevelopmentHostWindow.uiState.mode===3&&(f.has(i.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!o.win?.isSimpleFullScreen()&&(i.lastPluginDevelopmentHostWindow.uiState.mode=1):f.add(i.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(i.openedWindows=this.g.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>{const n=this.w(t);return n.uiState.mode===3&&(f.has(n.uiState.display)?s.$j&&n.windowId!==i.lastActiveWindow?.windowId&&!t.win?.isSimpleFullScreen()&&(n.uiState.mode=1):f.add(n.uiState.display)),n}));const r=h(i);this.h.setItem(v.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(f){if(this.j.quitRequested)return;const i=this.w(f);f.isExtensionDevelopmentHost&&!f.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=i:!f.isExtensionDevelopmentHost&&f.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,l.$ai)(f.openedWorkspace)&&o.workspace?.id===f.openedWorkspace.id,t=(0,l.$8h)(f.openedWorkspace)&&o.folderUri&&M.$sg.isEqual(o.folderUri,f.openedWorkspace.uri);(r||t)&&(o.uiState=i.uiState)}),this.g.getWindowCount()===1&&(this.c=i)}w(f){return{windowId:f.id,workspace:(0,l.$ai)(f.openedWorkspace)?f.openedWorkspace:void 0,folderUri:(0,l.$8h)(f.openedWorkspace)?f.openedWorkspace.uri:void 0,backupPath:f.backupPath,remoteAuthority:f.remoteAuthority,uiState:f.serializeWindowState()}}getNewWindowState(f){const i=this.z(f),o=this.n.getValue("window");if(i.mode===3){let r;i.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(i.mode=1)}return i}z(f){const i=this.g.getLastActiveWindow();if(!f.extensionTestsPath){if(f.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const m=f.workspace;if((0,l.$ai)(m)){const I=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===m.id).map(E=>E.uiState);if(I.length)return I[0]}if((0,l.$8h)(m)){const I=this.state.openedWindows.filter(E=>E.folderUri&&M.$sg.isEqual(E.folderUri,m.uri)).map(E=>E.uiState);if(I.length)return I[0]}else if(f.backupPath){const I=this.state.openedWindows.filter(E=>E.backupPath===f.backupPath).map(E=>E.uiState);if(I.length)return I[0]}const D=this.c||this.state.lastActiveWindow;if(!i&&D)return D.uiState}let o;const r=S.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(s.$j){const m=S.screen.getCursorScreenPoint();o=S.screen.getDisplayNearestPoint(m)}!o&&i&&(o=S.screen.getDisplayMatching(i.getBounds())),o||(o=S.screen.getPrimaryDisplay()||r[0])}let t=(0,p.$97b)();t.x=Math.round(o.bounds.x+o.bounds.width/2-t.width/2),t.y=Math.round(o.bounds.y+o.bounds.height/2-t.height/2);const n=this.n.getValue("window");let c=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")t.mode=0,c=!1;else if(n.newWindowDimensions==="fullscreen")t.mode=3,c=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&i){const m=i.serializeWindowState();m.mode===3?t.mode=3:t=m,c=t.mode!==3&&n.newWindowDimensions==="offset"}}return c&&(t=this.C(t)),t.hasDefaultState=!0,t}C(f){if(this.g.getWindows().length===0)return f;f.x=typeof f.x=="number"?f.x:0,f.y=typeof f.y=="number"?f.y:0;const i=this.g.getWindows().map(o=>o.getBounds());for(;i.some(o=>o.x===f.x||o.y===f.y);)f.x+=30,f.y+=30;return f}};e.$J9b=$,e.$J9b=$=v=ve([te(0,y.$K8b),te(1,b.$QN),te(2,d.$_7b),te(3,u.$fj),te(4,P.$ri)],$);function w(k){const f={openedWindows:[]},i=k||{openedWindows:[]};return i.lastActiveWindow&&(f.lastActiveWindow=g(i.lastActiveWindow)),i.lastPluginDevelopmentHostWindow&&(f.lastPluginDevelopmentHostWindow=g(i.lastPluginDevelopmentHostWindow)),Array.isArray(i.openedWindows)&&(f.openedWindows=i.openedWindows.map(o=>g(o))),f}e.$K9b=w;function g(k){const f={uiState:k.uiState};return k.backupPath&&(f.backupPath=k.backupPath),k.remoteAuthority&&(f.remoteAuthority=k.remoteAuthority),k.folder&&(f.folderUri=C.URI.parse(k.folder)),k.workspaceIdentifier&&(f.workspace={id:k.workspaceIdentifier.id,configPath:C.URI.parse(k.workspaceIdentifier.configURIPath)}),f}function h(k){return{lastActiveWindow:k.lastActiveWindow&&a(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&a(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(f=>a(f))}}e.$L9b=h;function a(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(se[55],re([0,1,15,3,44,2,13,9,19,21,194,65,53,24,6,5,54,130,30,97,98]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w,g,h,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C8b=e.$B8b=void 0,e.$B8b=(0,v.$Xh)("workspacesManagementMainService");let f=class extends M.$Rc{constructor(o,r,t,n,c){super(),this.g=o,this.h=r,this.j=t,this.m=n,this.n=c,this.a=this.B(new A.$Rd),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new A.$Rd),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await u.Promises.readdir(this.c.with({scheme:C.Schemas.file}).fsPath)).map(r=>(0,d.$Bg)(this.c,r,h.$ki));for(const r of o){const t=(0,k.$y8b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:t,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(t)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>u.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===C.Schemas.file)try{const t=r(o.fsPath);return t instanceof Promise?t.then(n=>this.t(o,n),n=>{}):this.t(o,t)}catch{return}}s(o){return(0,h.$li)(o,this.g)||(0,h.$qi)(o)}t(o,r){try{const t=this.u(o,r),n=(0,k.$y8b)(o);return{id:n.id,configPath:n.configPath,folders:(0,a.$gfb)(t.folders,n.configPath,d.$sg),remoteAuthority:t.remoteAuthority,transient:t.transient}}catch(t){this.h.warn(t.toString())}}u(o,r){const t=(0,s.$5m)(r);if(t&&Array.isArray(t.folders))t.folders=t.folders.filter(n=>(0,a.$efb)(n));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return t}async createUntitledWorkspace(o,r){const{workspace:t,storedWorkspace:n}=this.w(o,r),c=t.configPath.fsPath;return await u.Promises.mkdir((0,P.$lc)(c),{recursive:!0}),await u.Promises.writeFile(c,JSON.stringify(n,null,"	")),this.f.push({workspace:t,remoteAuthority:r}),t}w(o=[],r){const t=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,d.$Bg)(this.c,t),c=(0,d.$Bg)(n,h.$ki),m=[];for(const D of o)m.push((0,a.$ffb)(D.uri,!0,D.name,n,d.$sg));return{workspace:(0,k.$y8b)(c),storedWorkspace:{folders:m,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,k.$y8b)(o)}isUntitledWorkspace(o){return(0,h.$li)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,d.$pg)(o.configPath);try{await u.Promises.rm((0,P.$lc)(r));const t=(0,P.$ic)(this.g.workspaceStorageHome.with({scheme:C.Schemas.file}).fsPath,o.id);await u.Promises.exists(t)&&await u.Promises.writeFile((0,P.$ic)(t,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==o.id)}catch(t){this.h.warn(`Unable to delete untitled workspace ${r} (${t}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,t){if(!o||!o.win||!o.isReady||!await this.z(o,r,t))return;const c=await this.C(o,(0,k.$y8b)(t));if(c)return this.b.fire({window:o,workspace:c.workspace}),c}async z(o,r,t){return t?(0,h.$ai)(o.openedWorkspace)&&d.$sg.isEqual(o.openedWorkspace.configPath,t)?!1:(0,g.$v8b)(r,t)?(await this.n.showMessageBox({type:"info",buttons:[(0,b.localize)(0,null)],message:(0,b.localize)(1,null,(0,d.$yg)(t)),detail:(0,b.localize)(2,null)},S.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let t;return o.config.extensionDevelopmentPath||(o.config.backupPath?t=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):t=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,h.$ai)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=t,{workspace:r,backupPath:t}}};e.$C8b=f,e.$C8b=f=ve([te(0,l.$07b),te(1,$.$fj),te(2,w.$f8b),te(3,y.$q8b),te(4,p.$r8b)],f)}),define(se[132],re([0,1,15,36,22,6,29,30,55,12,5,61]),function(J,e,S,A,s,M,C,P,d,u,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V8b=e.$U8b=e.ID=void 0,e.ID="diagnosticsMainService",e.$U8b=(0,M.$Xh)(e.ID);let p=class{constructor(v,$,w){this.a=v,this.b=$,this.c=w}async getRemoteDiagnostics(v){const $=this.a.getWindows();return(await Promise.all($.map(async g=>{const h=g.remoteAuthority;if(!h)return;const a=`vscode:getDiagnosticInfoResponse${g.id}`,k={includeProcesses:v.includeProcesses,folders:v.includeWorkspaceMetadata?await this.f(g):void 0};return new Promise(f=>{g.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:a,args:k}),A.$XT.once(a,(i,o)=>{o||f({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),f(o)}),setTimeout(()=>{f({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const v=[];for(const w of S.BrowserWindow.getAllWindows()){const g=this.a.getWindowById(w.id);g?v.push(await this.d(g)):v.push(this.e(w))}const $=[];for(const{pid:w,name:g}of y.$R8b.getAll())$.push({pid:w,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:v,pidToNames:$,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async d(v){const $=await this.f(v),w=(0,u.$Nf)(v.win);return this.e(w,$,v.remoteAuthority)}e(v,$=[],w){return{id:v.id,pid:v.webContents.getOSProcessId(),title:v.getTitle(),folderURIs:$,remoteAuthority:w}}async f(v){const $=[],w=v.openedWorkspace;if((0,P.$8h)(w))$.push(w.uri);else if((0,P.$ai)(w)){const g=await this.b.resolveLocalWorkspace(w.configPath);g&&g.folders.forEach(a=>{$.push(a.uri)})}return $}};e.$V8b=p,e.$V8b=p=ve([te(0,C.$K8b),te(1,d.$B8b),te(2,b.$fj)],p)}),define(se[70],re([0,1,48,15,28,156,56,3,2,13,9,4,7,105,88,21,103,182,53,24,6,20,5,26,69,29,30,55,18,243,235,64]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w,g,h,a,k,f,i,o,r,t,n,c,m,D,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$08b=e.$98b=void 0,e.$98b=(0,k.$Xh)("nativeHostMainService");let R=class extends d.$Rc{constructor(F,U,x,Y,ae,oe,ce,Q,K,V){super(),this.a=F,this.b=U,this.c=x,this.f=Y,this.g=ae,this.h=oe,this.j=ce,this.m=Q,this.n=K,this.r=V,this.onDidOpenMainWindow=P.Event.map(this.a.onDidOpenWindow,z=>z.id),this.onDidTriggerMainWindowSystemContextMenu=P.Event.filter(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:z,x:W,y:H})=>({windowId:z.id,x:W,y:H})),({windowId:z})=>!!this.a.getWindowById(z)),this.onDidMaximizeMainWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-maximize",(z,W)=>W.id),z=>!!this.a.getWindowById(z)),this.onDidUnmaximizeMainWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-unmaximize",(z,W)=>W.id),z=>!!this.a.getWindowById(z)),this.onDidBlurMainWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(z,W)=>W.id),z=>!!this.a.getWindowById(z)),this.onDidFocusMainWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),z=>!!z),z=>z.id),P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(z,W)=>W.id),z=>!!this.a.getWindowById(z))),this.onDidBlurMainOrAuxiliaryWindow=P.Event.any(this.onDidBlurMainWindow,P.Event.map(P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(z,W)=>W),z=>(0,E.$J8b)(z.webContents)),z=>z.id)),this.onDidFocusMainOrAuxiliaryWindow=P.Event.any(this.onDidFocusMainWindow,P.Event.map(P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(z,W)=>W),z=>(0,E.$J8b)(z.webContents)),z=>z.id)),this.onDidResumeOS=P.Event.fromNodeEventEmitter(A.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.s=this.B(new P.$Rd),this.onDidChangePassword=this.s.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(A.screen,"display-metrics-changed",(z,W,H)=>H),z=>!(Array.isArray(z)&&z.length===1&&z[0]==="workArea")),P.Event.fromNodeEventEmitter(A.screen,"display-added"),P.Event.fromNodeEventEmitter(A.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(F,U){const x=this.a.getWindows().map(ae=>({id:ae.id,workspace:ae.openedWorkspace??(0,n.$_h)(ae.backupPath,ae.isExtensionDevelopmentHost),title:ae.win?.getTitle()??"",filename:ae.getRepresentedFilename(),dirty:ae.isDocumentEdited()})),Y=[];return U.includeAuxiliaryWindows&&Y.push(...this.b.getWindows().map(ae=>({id:ae.id,parentId:ae.parentId,title:ae.win?.getTitle()??"",filename:ae.getRepresentedFilename()}))),[...x,...Y]}async getWindowCount(F){return this.a.getWindowCount()}async getActiveWindowId(F){const U=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(U)return U.id}openWindow(F,U,x){return Array.isArray(U)?this.t(F,U,x):this.u(F,U)}async t(F,U,x=Object.create(null)){U.length>0&&await this.a.open({context:5,contextWindowId:F,urisToOpen:U,cli:this.g.args,forceNewWindow:x.forceNewWindow,forceReuseWindow:x.forceReuseWindow,preferNewWindow:x.preferNewWindow,diffMode:x.diffMode,mergeMode:x.mergeMode,addMode:x.addMode,gotoLineMode:x.gotoLineMode,noRecentEntry:x.noRecentEntry,waitMarkerFileURI:x.waitMarkerFileURI,remoteAuthority:x.remoteAuthority||void 0,forceProfile:x.forceProfile,forceTempProfile:x.forceTempProfile})}async u(F,U){await this.a.openEmptyWindow({context:5,contextWindowId:F},U)}async toggleFullScreen(F,U){this.D(U?.targetWindowId,F)?.toggleFullScreen()}async handleTitleDoubleClick(F){this.F(F)?.handleTitleDoubleClick()}async getCursorScreenPoint(F){const U=A.screen.getCursorScreenPoint(),x=A.screen.getDisplayNearestPoint(U);return{point:U,display:x.bounds}}async isMaximized(F){const U=this.F(F);return U?.win?U.win.isMaximized():!1}async maximizeWindow(F){const U=this.F(F);U?.win&&U.win.maximize()}async unmaximizeWindow(F){const U=this.F(F);U?.win&&U.win.unmaximize()}async minimizeWindow(F){const U=this.F(F);U?.win&&U.win.minimize()}async moveWindowTop(F,U){const x=this.D(U?.targetWindowId,F);x?.win&&x.win.moveTop()}async positionWindow(F,U,x){const Y=this.D(x?.targetWindowId,F);if(Y?.win){if(Y.win.isFullScreen()){const ae=P.Event.toPromise(P.Event.once(P.Event.fromNodeEventEmitter(Y.win,"leave-full-screen")));Y.win.setFullScreen(!1),await ae}Y.win.setBounds(U)}}async updateWindowControls(F,U){const x=this.F(F);x&&x.updateWindowControls(U)}async focusWindow(F,U){this.D(U?.targetWindowId,F)?.focus({force:U?.force??!1})}async setMinimumSize(F,U,x){const Y=this.F(F);if(Y?.win){const[ae,oe]=Y.win.getSize(),[ce,Q]=Y.win.getMinimumSize(),[K,V]=[U??ce,x??Q],[z,W]=[Math.max(ae,K),Math.max(oe,V)];(ce!==K||Q!==V)&&Y.win.setMinimumSize(K,V),(ae!==z||oe!==W)&&Y.win.setSize(z,W)}}async saveWindowSplash(F,U){this.m.saveWindowSplash(F,U)}async installShellCommand(F){const{source:U,target:x}=await this.w();try{const{symbolicLink:Y}=await $.SymlinkSupport.stat(U);if(Y&&!Y.dangling){const ae=await(0,l.$cq)(U);if(x===ae)return}await $.Promises.unlink(U)}catch(Y){if(Y.code!=="ENOENT")throw Y}try{await $.Promises.symlink(x,U)}catch(Y){if(Y.code!=="EACCES"&&Y.code!=="ENOENT")throw Y;const{response:ae}=await this.showMessageBox(F,{type:"info",message:(0,g.localize)(0,null,this.j.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(ae===0)try{const oe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${x}' '${U}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(oe)}catch{throw new Error((0,g.localize)(3,null,U))}}}async uninstallShellCommand(F){const{source:U}=await this.w();try{await $.Promises.unlink(U)}catch(x){switch(x.code){case"EACCES":{const{response:Y}=await this.showMessageBox(F,{type:"info",message:(0,g.localize)(4,null,this.j.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(Y===0)try{const ae=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(ae)}catch{throw new Error((0,g.localize)(7,null,U))}break}case"ENOENT":break;default:throw x}}}async w(){const F=(0,b.$jc)(this.g.appRoot,"bin","code"),U=`/usr/local/bin/${this.j.applicationName}`;if(!await $.Promises.exists(F))throw new Error((0,g.localize)(8,null,F));return{source:U,target:F}}async showMessageBox(F,U){const x=this.H(F);return this.c.showMessageBox(U,x?.win??void 0)}async showSaveDialog(F,U){const x=this.H(F);return this.c.showSaveDialog(U,x?.win??void 0)}async showOpenDialog(F,U){const x=this.H(F);return this.c.showOpenDialog(U,x?.win??void 0)}async pickFileFolderAndOpen(F,U){const x=await this.c.pickFileFolder(U);x&&await this.z(await Promise.all(x.map(async Y=>await $.SymlinkSupport.existsDirectory(Y)?{folderUri:p.URI.file(Y)}:{fileUri:p.URI.file(Y)})),U,F)}async pickFolderAndOpen(F,U){const x=await this.c.pickFolder(U);x&&await this.z(x.map(Y=>({folderUri:p.URI.file(Y)})),U,F)}async pickFileAndOpen(F,U){const x=await this.c.pickFile(U);x&&await this.z(x.map(Y=>({fileUri:p.URI.file(Y)})),U,F)}async pickWorkspaceAndOpen(F,U){const x=await this.c.pickWorkspace(U);x&&await this.z(x.map(Y=>({workspaceUri:p.URI.file(Y)})),U,F)}async z(F,U,x){await this.a.open({context:3,contextWindowId:x,cli:this.g.args,urisToOpen:F,forceNewWindow:U.forceNewWindow})}async showItemInFolder(F,U){A.shell.showItemInFolder(U)}async setRepresentedFilename(F,U,x){this.D(x?.targetWindowId,F)?.setRepresentedFilename(U)}async setDocumentEdited(F,U,x){this.D(x?.targetWindowId,F)?.setDocumentEdited(U)}async openExternal(F,U){return this.g.unsetSnapExportedVariables(),A.shell.openExternal(U),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(F,U){return A.shell.trashItem(U)}async isAdmin(){let F;return y.$i?F=(await new Promise((U,x)=>{J(["native-is-elevated"],U,x)}))():F=process.getuid?.()===0,F}async writeElevated(F,U,x,Y){const ae=await new Promise((oe,ce)=>{J(["@vscode/sudo-prompt"],oe,ce)});return new Promise((oe,ce)=>{const Q=[`"${this.C}"`];Y?.unlock&&Q.push("--file-chmod"),Q.push("--file-write",`"${U.fsPath}"`,`"${x.fsPath}"`);const K={name:this.j.nameLong.replace("-",""),icns:y.$j&&this.g.isBuilt?(0,b.$ic)((0,b.$lc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};ae.exec(Q.join(" "),K,(V,z,W)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),W&&this.h.trace(`[sudo-prompt] received stderr: ${W}`),V?ce(V):oe(void 0)})})}async isRunningUnderARM64Translation(){return y.$k||y.$i?!1:A.app.runningUnderARM64Translation}get C(){return y.$i?this.g.isBuilt?(0,b.$ic)((0,b.$lc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,b.$ic)(this.g.appRoot,"scripts","code-cli.bat"):y.$k?this.g.isBuilt?(0,b.$ic)((0,b.$lc)(process.execPath),"bin",`${this.j.applicationName}`):(0,b.$ic)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,b.$ic)(this.g.appRoot,"bin","code"):(0,b.$ic)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return v.$Zm.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return y.$i&&(0,D.$78b)()}async killProcess(F,U,x){process.kill(U,x)}async readClipboardText(F,U){return A.clipboard.readText(U)}async writeClipboardText(F,U,x){return A.clipboard.writeText(U,x)}async readClipboardFindText(F){return A.clipboard.readFindText()}async writeClipboardFindText(F,U){return A.clipboard.writeFindText(U)}async writeClipboardBuffer(F,U,x,Y){return A.clipboard.writeBuffer(U,Buffer.from(x.buffer),Y)}async readClipboardBuffer(F,U){return m.$fe.wrap(A.clipboard.readBuffer(U))}async hasClipboard(F,U,x){return A.clipboard.has(U,x)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){A.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){A.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){A.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){A.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){A.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,U){this.F(F)?.updateTouchBar(U)}async notifyReady(F){this.F(F)?.setReady()}async relaunch(F,U){return this.f.relaunch(U)}async reload(F,U){const x=this.F(F);if(x){if((0,n.$ai)(x.openedWorkspace)){const Y=x.openedWorkspace.configPath;if(Y.scheme===u.Schemas.file&&(await this.n.resolveLocalWorkspace(Y))?.transient)return this.openWindow(x.id,{forceReuseWindow:!0})}return this.f.reload(x,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(F){this.closeWindowById(F,F)}async closeWindowById(F,U){return(this.D(U)??this.F(U))?.win?.close()}async quit(F){const U=this.a.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&U.win?U.win.close():this.f.quit()}async exit(F,U){await this.f.kill(U)}async resolveProxy(F,U){return this.F(F)?.win?.webContents?.session?.resolveProxy(U)}async loadCertificates(F){return(await new Promise((x,Y)=>{J(["@vscode/proxy-agent"],x,Y)})).loadSystemCertificates({log:this.h})}findFreePort(F,U,x,Y,ae=1){return(0,w.$mg)(U,x,Y,ae)}async openDevTools(F,U){this.H(F)?.win?.webContents.openDevTools(U)}async toggleDevTools(F){this.H(F)?.win?.webContents.toggleDevTools()}async profileRenderer(F,U,x){const Y=this.F(F);if(!Y||!Y.win)throw new Error;return await new I.$88b(Y.win,U,this.h).inspect(x)}async windowsGetStringRegKey(F,U,x,Y){if(!y.$i)return;const ae=await new Promise((oe,ce)=>{J(["@vscode/windows-registry"],oe,ce)});try{return ae.GetStringRegKey(U,x,Y)}catch{return}}D(F,U){return this.F(F)??this.G(F)??this.F(U)}F(F){if(typeof F=="number")return this.a.getWindowById(F)}G(F){if(typeof F=="number")return this.b.getWindowById(F)}H(F){let U=this.r.invokeFunction(t.$M8b);return U||(U=this.D(F)),U}};e.$08b=R,ve([C.$ph],R.prototype,"C",null),e.$08b=R=ve([te(0,t.$K8b),te(1,E.$I8b),te(2,h.$r8b),te(3,f.$_7b),te(4,a.$07b),te(5,i.$fj),te(6,o.$xj),te(7,r.$l8b),te(8,c.$B8b),te(9,k.$Wh)],R)}),define(se[299],re([0,1,15,28,8,22,33,2,13,4,7,107,36,180,91,132,53,24,5,70,79,26,80,34,61,60,29]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w,g,h,a,k,f,i,o,r,t,n){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$$8b=void 0;const m="issue.processExplorerWindowState";let D=class{static{c=this}static{this.a="#1E1E1E"}constructor(R,L,F,U,x,Y,ae,oe,ce,Q,K){this.g=R,this.h=L,this.i=F,this.j=U,this.k=x,this.l=Y,this.m=ae,this.n=oe,this.o=ce,this.p=Q,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){p.$XT.on("vscode:listProcesses",async R=>{const L=[];try{L.push({name:(0,l.localize)(0,null),rootProcess:await(0,y.$Kr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(U=>{(0,v.$zm)(U)?L.push({name:U.hostName,rootProcess:U}):U.processes&&L.push({name:U.hostName,rootProcess:U.processes})})}catch(F){this.i.error(`Listing processes failed: ${F}`)}this.t(R,"vscode:listProcessesResponse",L)}),p.$XT.on("vscode:workbenchCommand",(R,L)=>{const{id:F,from:U,args:x}=L;let Y;switch(U){case"processExplorer":Y=this.f;break;default:throw new Error(`Unexpected command source: ${U}`)}Y?.webContents.send("vscode:runAction",{id:F,from:U,args:x})}),p.$XT.on("vscode:closeProcessExplorer",R=>{this.d?.close()}),p.$XT.on("vscode:pidToNameRequest",async R=>{const L=await this.k.getMainDiagnostics(),F=[];for(const U of L.windows)F.push([U.pid,`window [${U.id}] (${U.title})`]);for(const{pid:U,name:x}of r.$R8b.getAll())F.push([U,x]);this.t(R,"vscode:pidToNameResponse",F)})}async openReporter(R){if(!this.b&&(this.c=S.BrowserWindow.getFocusedWindow(),this.c)){const L=new P.$Qc,F=L.add(this.n.createIPCObjectUrl()),U=this.v(this.c,700,800);this.b=this.u(U,F,{backgroundColor:R.styles.backgroundColor,title:(0,l.localize)(1,null),zoomLevel:R.zoomLevel,alwaysOnTop:!1},"issue-reporter"),F.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:R,disableExtensions:!!this.h.disableExtensions,os:{type:(0,A.type)(),arch:(0,A.arch)(),release:(0,A.release)()},product:k.default}),this.b.loadURL(d.$ig.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,L.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,L.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(R){if(!this.d&&(this.f=S.BrowserWindow.getFocusedWindow(),this.f)){const L=new P.$Qc,F=L.add(this.n.createIPCObjectUrl()),U=this.p.getItem(m,void 0),x=I(U)?U:this.v(this.f,800,500);this.d=this.u(x,F,{backgroundColor:R.styles.backgroundColor,title:(0,l.localize)(2,null),zoomLevel:R.zoomLevel,alwaysOnTop:!0},"process-explorer"),F.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:R,product:k.default}),this.d.loadURL(d.$ig.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,L.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,L.dispose())});const Y=()=>{if(!this.d)return;const ae=this.d.getSize(),oe=this.d.getPosition();if(!ae||!oe)return;const ce={width:ae[0],height:ae[1],x:oe[0],y:oe[1]};this.p.setItem(m,ce)};this.d.on("moved",Y),this.d.on("resized",Y)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const R=await S.contentTracing.stopRecording(`${(0,C.$0f)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,l.localize)(3,null),detail:(0,l.localize)(4,null,R),buttons:[(0,l.localize)(5,null)]},S.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,R)}async getSystemStatus(){const[R,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(R,L)}async $getSystemInfo(){const[R,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(R,L)}async $getPerformanceInfo(){try{const[R,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(R,L)}catch(R){throw this.i.warn("issueService#getPerformanceInfo ",R.message),R}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(R){this.i.error(R)}}async $showConfirmCloseDialog(){if(this.b){const{response:R}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(6,null),buttons:[(0,l.localize)(7,null),(0,l.localize)(8,null)]},this.b);R===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:R}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(9,null),buttons:[(0,l.localize)(10,null),(0,l.localize)(11,null)]},this.b);return R===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const R=this.q.getWindowById(this.c.id);if(!R)throw new Error("Window not found");return R}async $getIssueReporterUri(R){const L=this.issueReporterWindowCheck(),F=`vscode:triggerIssueUriRequestHandlerResponse${L.id}`;return s.Promises.withAsyncBody(async(U,x)=>{const Y=new M.$2d;L.sendWhenReady("vscode:triggerIssueUriRequestHandler",Y.token,{replyChannel:F,extensionId:R}),p.$XT.once(F,(ae,oe)=>{U(b.URI.parse(oe))});try{await(0,s.$1g)(5e3),Y.cancel(),x(new Error("Timed out waiting for issue reporter URI"))}finally{p.$XT.removeHandler(F)}})}async $getIssueReporterData(R){const L=this.issueReporterWindowCheck(),F=`vscode:triggerIssueDataProviderResponse${L.id}`;return s.Promises.withAsyncBody(async U=>{const x=new M.$2d;L.sendWhenReady("vscode:triggerIssueDataProvider",x.token,{replyChannel:F,extensionId:R}),p.$XT.once(F,(Y,ae)=>{U(ae)});try{await(0,s.$1g)(5e3),x.cancel(),U("Error: Extension timed out waiting for issue reporter data")}finally{p.$XT.removeHandler(F)}})}async $getIssueReporterTemplate(R){const L=this.issueReporterWindowCheck(),F=`vscode:triggerIssueDataTemplateResponse${L.id}`;return s.Promises.withAsyncBody(async U=>{const x=new M.$2d;L.sendWhenReady("vscode:triggerIssueDataTemplate",x.token,{replyChannel:F,extensionId:R}),p.$XT.once(F,(Y,ae)=>{U(ae)});try{await(0,s.$1g)(5e3),x.cancel(),U("Error: Extension timed out waiting for issue reporter template")}finally{p.$XT.removeHandler(F)}})}async $getReporterStatus(R,L){const F=[!1,!1],U=this.issueReporterWindowCheck(),x="vscode:triggerReporterStatus",Y=new M.$2d;return U.sendWhenReady(x,Y.token,{replyChannel:x,extensionId:R,extensionName:L}),await(0,s.$Rg)(new Promise(oe=>p.$XT.once("vscode:triggerReporterStatusResponse",(ce,Q)=>oe(Q))),2e3,()=>{this.i.error("Error: Extension timed out waiting for reporter status"),Y.cancel()})??F}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(R){R.isMinimized()&&R.restore(),R.focus()}t(R,L,...F){R.sender.isDestroyed()||R.sender.send(L,...F)}u(R,L,F,U){const x=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:R.width,height:R.height,minWidth:300,minHeight:200,x:R.x,y:R.y,title:F.title,backgroundColor:F.backgroundColor||c.a,webPreferences:{preload:d.$ig.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${L.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,t.$wC)(F.zoomLevel),sandbox:!0},alwaysOnTop:F.alwaysOnTop,experimentalDarkMode:!0});return x.setMenuBarVisibility(!1),x}v(R,L,F){let U;const x=S.screen.getAllDisplays();if(x.length===1)U=x[0];else{if(u.$j){const oe=S.screen.getCursorScreenPoint();U=S.screen.getDisplayNearestPoint(oe)}!U&&R&&(U=S.screen.getDisplayMatching(R.getBounds())),U||(U=S.screen.getPrimaryDisplay()||x[0])}const Y=U.bounds,ae={width:L,height:F,x:Y.x+Y.width/2-L/2,y:Y.y+Y.height/2-F/2};return Y.width>0&&Y.height>0&&(ae.x<Y.x&&(ae.x=Y.x),ae.y<Y.y&&(ae.y=Y.y),ae.x>Y.x+Y.width&&(ae.x=Y.x),ae.y>Y.y+Y.height&&(ae.y=Y.y),ae.width>Y.width&&(ae.width=Y.width),ae.height>Y.height&&(ae.height=Y.height)),ae}};e.$$8b=D,e.$$8b=D=c=ve([te(1,g.$07b),te(2,h.$fj),te(3,v.$ym),te(4,$.$U8b),te(5,w.$r8b),te(6,a.$98b),te(7,i.$t8b),te(8,f.$xj),te(9,o.$QN),te(10,n.$K8b)],D);function I(E){return typeof E!="object"||E===null?!1:"x"in E&&"y"in E&&"width"in E&&"height"in E}}),define(se[300],re([0,1,22,17,24,20,5,70,26,51,27,49,100]),function(J,e,S,A,s,M,C,P,d,u,b,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z9b=void 0;let l=class extends p.$x9b{constructor($,w,g,h,a,k,f,i){super($,w,h,a,k,i),this.e=g,this.u=f}s($){return(0,p.$w9b)(`linux-${process.arch}`,$,this.k)}t($){this.a&&(this.d(y.$VU.CheckingForUpdates($)),this.i.request({url:this.a},S.CancellationToken.None).then(u.$7o).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!$}),this.d(y.$VU.Idle(1))):this.d(y.$VU.AvailableForDownload(w))}).then(void 0,w=>{this.j.error(w);const g=$?w.message||w:void 0;this.d(y.$VU.Idle(1,g))}))}async o($){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):$.update.url&&this.u.openExternal(void 0,$.update.url),this.d(y.$VU.Idle(1))}};e.$z9b=l,e.$z9b=l=ve([te(0,M.$_7b),te(1,A.$ri),te(2,b.$kl),te(3,s.$07b),te(4,u.$1o),te(5,C.$fj),te(6,P.$98b),te(7,d.$xj)],l)}),define(se[301],re([0,1,48,46,28,8,22,56,45,9,7,144,21,17,24,16,20,5,70,26,51,27,49,100]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w,g,h,a,k,f,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B9b=void 0;async function r(m,D=1e3){for(;!m();)await(0,M.$1g)(D)}let t;function n(){return typeof t>"u"&&(t=A.existsSync(u.$ic(u.$lc(process.execPath),"unins000.exe"))?0:1),t}let c=class extends o.$x9b{get cachePath(){const D=u.$ic((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return p.Promises.mkdir(D,{recursive:!0}).then(()=>D)}constructor(D,I,E,R,L,F,U,x,Y){super(D,I,R,L,F,Y),this.u=E,this.v=U,this.w=x,D.setRelaunchHandler(this)}handleRelaunch(D){return D?.addArgs||D?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(i.$VU.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(D){let I=`win32-${process.arch}`;return n()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,o.$w9b)(I,D,this.k)}t(D){this.a&&(this.d(i.$VU.CheckingForUpdates(D)),this.i.request({url:this.a},C.CancellationToken.None).then(k.$7o).then(I=>{const E=n();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!D}),this.d(i.$VU.Idle(E)),Promise.resolve(null)):E===1?(this.d(i.$VU.AvailableForDownload(I)),Promise.resolve(null)):(this.d(i.$VU.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(R=>p.Promises.exists(R).then(L=>{if(L)return Promise.resolve(R);const F=I.url,U=I.hash,x=`${R}.tmp`;return this.i.request({url:F},C.CancellationToken.None).then(Y=>this.v.writeFile(b.URI.file(x),Y.stream)).then(U?()=>(0,y.$ST)(x,I.hash):()=>{}).then(()=>p.Promises.rename(x,R,!1)).then(()=>R)})).then(R=>{const L=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:R},L?this.k.target==="user"?this.p():this.d(i.$VU.Downloaded(I)):this.d(i.$VU.Ready(I))})))}).then(void 0,I=>{this.u.publicLog2("update:error",{messageHash:String((0,d.$Li)(String(I)))}),this.j.error(I);const E=D?I.message||I:void 0;this.d(i.$VU.Idle(n(),E))}))}async o(D){D.update.url&&this.w.openExternal(void 0,D.update.url),this.d(i.$VU.Idle(n()))}async B(D){const I=await this.cachePath;return u.$ic(I,`CodeSetup-${this.k.quality}-${D}.exe`)}async C(D=null){const I=D?F=>!new RegExp(`${this.k.quality}-${D}\\.exe$`).test(F):()=>!0,E=await this.cachePath,L=(await p.Promises.readdir(E)).filter(I).map(async F=>{try{await p.Promises.unlink(u.$ic(E,F))}catch{}});await Promise.all(L)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const D=this.state.update;this.d(i.$VU.Updating(D));const I=await this.cachePath;this.e.updateFilePath=u.$ic(I,`CodeSetup-${this.k.quality}-${D.version}.flag`),await p.Promises.writeFile(this.e.updateFilePath,"flag"),(0,S.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(i.$VU.Idle(n()))});const R=`${this.k.win32MutexName}-ready`,L=await new Promise((F,U)=>{J(["@vscode/windows-mutex"],F,U)});r(()=>L.isActive(R)).then(()=>this.d(i.$VU.Ready(D)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?A.unlinkSync(this.e.updateFilePath):(0,S.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return n()}async _applySpecificUpdate(D){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),E={version:"unknown",productVersion:"unknown"};this.d(i.$VU.Downloading(E)),this.e={packagePath:D},I?this.k.target==="user"?this.p():this.d(i.$VU.Downloaded(E)):this.d(i.$VU.Ready(E))}};e.$B9b=c,ve([P.$ph],c.prototype,"cachePath",null),e.$B9b=c=ve([te(0,w.$_7b),te(1,l.$ri),te(2,f.$kl),te(3,v.$07b),te(4,k.$1o),te(5,g.$fj),te(6,$.$gk),te(7,h.$98b),te(8,a.$xj)],c)}),define(se[133],re([0,1,15,8,22,50,3,2,13,67,4,7,190,65,17,53,24,63,16,20,5,26,80,252,82,27,102,69,60,29,30,55,128,136,39,34,54,68,23,6]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w,g,h,a,k,f,i,o,r,t,n,c,m,D,I,E,R,L,F,U,x,Y,ae,oe){"use strict";var ce;Object.defineProperty(e,"__esModule",{value:!0}),e.$G8b=e.$F8b=void 0;var Q;(function(z){z[z.NONE=0]="NONE",z[z.NAVIGATING=1]="NAVIGATING",z[z.READY=2]="READY"})(Q||(Q={}));class K extends P.$Rc{constructor(W){super(),this.a=W,this.f=void 0,this.g=void 0}setRepresentedFilename(W){b.$j?this.win?.setRepresentedFilename(W):this.b=W}getRepresentedFilename(){return b.$j?this.win?.getRepresentedFilename():this.b}setDocumentEdited(W){b.$j&&this.win?.setDocumentEdited(W),this.c=W}isDocumentEdited(){return b.$j?!!this.win?.isDocumentEdited():!!this.c}focus(W){b.$j&&W?.force&&S.app.focus({steal:!0});const H=this.win;H&&(H.isMinimized()&&H.restore(),H.focus())}toggleFullScreen(){this.h(!this.isFullScreen)}h(W){this.r()?this.j(W):this.n(W)}get isFullScreen(){if(b.$j&&typeof this.f=="boolean")return this.f;const W=this.win,H=W?.isFullScreen(),q=W?.isSimpleFullScreen();return!!(H||q)}j(W){const H=this.win;H?.isSimpleFullScreen()&&H?.setSimpleFullScreen(!1),this.m(W)}m(W){b.$j&&(this.f=W,this.g=new A.$kh,Promise.race([this.g.p,(0,A.$1g)(1e4)]).finally(()=>{this.f=void 0})),this.win?.setFullScreen(W)}n(W){const H=this.win;H?.isFullScreen()&&this.m(!1),H?.setSimpleFullScreen(W),H?.webContents.focus()}r(){const W=this.a.getValue("window");return!W||typeof W.nativeFullScreen!="boolean"||W.nativeTabs?!0:W.nativeFullScreen!==!1}}e.$F8b=K;let V=class extends K{static{ce=this}static{this.s="windowControlHeight"}get id(){return this.D}get win(){return this.F}get lastFocusTime(){return this.G}get backupPath(){return this.H?.backupPath}get openedWorkspace(){return this.H?.workspace}get profile(){if(!this.config)return;const W=this.Z.profiles.find(H=>H.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&W?W:this.Z.getProfileForWorkspace(this.config.workspace??(0,I.$_h)(this.backupPath,this.isExtensionDevelopmentHost))??this.Z.defaultProfile}get remoteAuthority(){return this.H?.remoteAuthority}get config(){return this.H}get isExtensionDevelopmentHost(){return!!this.H?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.H?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.H?.debugId}constructor(W,H,q,_,ne,X,O,N,G,j,B,T,Z,he,de,le,we,be,Ee,Se,je){super(j),this.U=H,this.W=q,this.X=_,this.Y=ne,this.Z=X,this.$=O,this.ab=N,this.bb=G,this.db=B,this.eb=T,this.fb=Z,this.gb=he,this.hb=de,this.ib=le,this.jb=we,this.kb=be,this.lb=Ee,this.mb=Se,this.t=this.B(new C.$Rd),this.onWillLoad=this.t.event,this.u=this.B(new C.$Rd),this.onDidSignalReady=this.u.event,this.w=this.B(new C.$Rd),this.onDidTriggerSystemContextMenu=this.w.event,this.z=this.B(new C.$Rd),this.onDidClose=this.z.event,this.C=this.B(new C.$Rd),this.onDidDestroy=this.C.event,this.G=-1,this.L=!1,this.M=[],this.N=[],this.O=void 0,this.P=void 0,this.Q=this.B(this.kb.createIPCObjectUrl()),this.S=!1,this.nb=0;{const[ke,pe]=this.xb(W.state);this.I=ke,this.U.trace("window#ctor: using window state",ke);const ee=this.I.mode===0||this.I.mode===3,ue=this.a.getValue("window"),ge=je.invokeFunction(D.$L8b,this.I,{show:!ee,webPreferences:{preload:d.$ig.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.Q.resource.toString()}`],v8CacheOptions:this.X.useCodeCache?"bypassHeatCheck":"none"}});b.$j&&!this.r()&&(ge.fullscreenable=!1);const Re=b.$j&&ue?.nativeTabs===!0;Re&&(ge.tabbingIdentifier=this.jb.nameShort);const De=(0,m.$uC)(this.a)==="custom";if(De&&(ge.titleBarStyle="hidden",b.$j||(ge.frame=!1),(0,m.$vC)(this.a))){const Fe=this.db.getWindowSplash()?.colorInfo.titleBarBackground??this.db.getBackgroundColor(),Me=L.$6s.fromHex(Fe).isDarker()?"#FFFFFF":"#000000";ge.titleBarOverlay={height:29,color:Fe,symbolColor:Me},this.L=!0}if((0,u.mark)("code/willCreateCodeBrowserWindow"),this.F=new S.BrowserWindow(ge),(0,u.mark)("code/didCreateCodeBrowserWindow"),this.D=this.F.id,b.$j&&De&&this.F.setSheetOffset(22),De&&(b.$i&&(0,m.$vC)(this.a)||b.$j)){const Fe=this.mb.getItem(ce.s);Fe&&this.updateWindowControls({height:Fe})}b.$i&&De&&this.F.hookWindowMessage(278,()=>{const[Me,Ve]=this.F.getPosition(),ze=S.screen.getCursorScreenPoint(),ie=ze.x-Me,fe=ze.y-Ve;return(()=>!(ie>30&&fe>=0&&fe<=Math.max(this.F.getBounds().height*.15,35)))()||(this.F.setEnabled(!1),this.F.setEnabled(!0),this.w.fire({x:ie,y:fe})),0}),(b.$j||b.$i)&&pe&&(!Re||S.BrowserWindow.getAllWindows().length===1)&&[this.I.width,this.I.height,this.I.x,this.I.y].every(Fe=>typeof Fe=="number")&&this.F.setBounds({width:this.I.width,height:this.I.height,x:this.I.x,y:this.I.y}),ee&&((0,u.mark)("code/willMaximizeCodeWindow"),this.F.maximize(),this.I.mode===3&&this.h(!0),this.F.show(),(0,u.mark)("code/didMaximizeCodeWindow")),this.G=Date.now()}this.X.args["open-devtools"]===!0&&this.F.webContents.openDevTools(),this.ub(),this.Eb(),this.ob()}setReady(){for(this.U.trace(`window#load: window reported ready (id: ${this.D})`),this.nb=2;this.M.length;)this.M.pop()(this);this.u.fire()}ready(){return new Promise(W=>{if(this.isReady)return W(this);this.M.push(W)})}get isReady(){return this.nb===2}get whenClosedOrLoaded(){return new Promise(W=>{function H(){q.dispose(),_.dispose(),W()}const q=this.onDidClose(()=>H()),_=this.onWillLoad(()=>H())})}ob(){this.F.on("unresponsive",()=>this.rb(1)),this.F.webContents.on("render-process-gone",(H,q)=>this.rb(2,{...q})),this.F.webContents.on("did-fail-load",(H,q,_)=>this.rb(3,{reason:_,exitCode:q})),this.F.webContents.on("will-prevent-unload",H=>{H.preventDefault()}),this.F.on("closed",()=>{this.z.fire(),this.dispose()}),this.F.webContents.on("did-finish-load",()=>{this.R&&(this.H=this.R,this.R=void 0)}),this.F.on("focus",()=>{this.G=Date.now()}),this.F.on("maximize",H=>{this.H&&(this.H.maximized=!0),S.app.emit("browser-window-maximize",H,this.F)}),this.F.on("unmaximize",H=>{this.H&&(this.H.maximized=!1),S.app.emit("browser-window-unmaximize",H,this.F)}),this.F.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.g?.complete(),this.g=void 0}),this.F.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.g?.complete(),this.g=void 0}),this.B(this.a.onDidChangeConfiguration(H=>this.ub(H))),this.B(this.eb.onDidDeleteUntitledWorkspace(H=>this.tb(H)));const W=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.F.webContents.session.webRequest.onBeforeSendHeaders({urls:W},async(H,q)=>{const _=await this.qb();q({cancel:!1,requestHeaders:Object.assign(H.requestHeaders,_)})})}qb(){return this.pb||(this.pb=(0,o.$ip)(this.jb.version,this.jb,this.X,this.a,this.$,this.ab,this.gb)),this.pb}async rb(W,H){switch(W){case 2:this.U.error(`CodeWindow: renderer process gone (reason: ${H?.reason||"<unknown>"}, code: ${H?.exitCode||"<unknown>"})`);break;case 1:this.U.error("CodeWindow: detected unresponsive");break;case 3:this.U.error(`CodeWindow: failed to load (reason: ${H?.reason||"<unknown>"}, code: ${H?.exitCode||"<unknown>"})`);break}switch(this.gb.publicLog2("windowerror",{type:W,reason:H?.reason,code:H?.exitCode}),W){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.ib.kill(1);return}if(this.X.args["enable-smoke-test-driver"]){await this.sb(!1,!1),this.ib.quit();return}if(W===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.F&&this.F.webContents&&this.F.webContents.isDevToolsOpened())return;const{response:q,checkboxChecked:_}=await this.hb.showMessageBox({type:"warning",buttons:[(0,p.localize)(0,null),(0,p.localize)(1,null),(0,p.localize)(2,null)],message:(0,p.localize)(3,null),detail:(0,p.localize)(4,null),checkboxLabel:this.H?.workspace?(0,p.localize)(5,null):void 0},this.F);if(q!==2){const ne=q===0;await this.sb(ne,_)}}else if(W===2){let q;H?q=(0,p.localize)(7,null,H.reason,H.exitCode??"<unknown>"):q=(0,p.localize)(6,null);const{response:_,checkboxChecked:ne}=await this.hb.showMessageBox({type:"warning",buttons:[this.H?.workspace?(0,p.localize)(8,null):(0,p.localize)(9,null),(0,p.localize)(10,null)],message:q,detail:this.H?.workspace?(0,p.localize)(11,null):(0,p.localize)(12,null),checkboxLabel:this.H?.workspace?(0,p.localize)(13,null):void 0},this.F),X=_===0;await this.sb(X,ne)}break}}async sb(W,H){const q=this.H?.workspace;if(H&&q)try{const _=this.bb.workspaceStorage(q);await _.init(),_.delete("memento/workbench.parts.editor"),await _.close()}catch(_){this.U.error(_)}if(this.C.fire(),this.F?.destroy(),W&&this.H){let _,ne;(0,I.$8h)(q)?_={folderUri:q.uri}:(0,I.$ai)(q)?_={workspaceUri:q.configPath}:ne=!0,(0,ae.$Nb)(await this.lb.open({context:5,userEnv:this.H.userEnv,cli:{...this.X.args,_:[]},urisToOpen:_?[_]:void 0,forceEmpty:ne,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}tb(W){this.H?.workspace?.id===W.id&&(this.H.workspace=void 0)}ub(W){if(!W||W.affectsConfiguration("window.menuBarVisibility")){const H=this.Bb();H!==this.J&&(this.J=H,this.Cb(H))}if(!W||W.affectsConfiguration("http.proxy")){let H=(this.a.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;H?.endsWith("/")&&(H=H.substr(0,H.length-1));const q=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((H||"").indexOf("@")===-1&&(H!==this.O||q!==this.P)){this.O=H,this.P=q;const _=H||"",ne=q?`${q},<local>`:"<local>";this.U.trace(`Setting proxy to '${_}', bypassing '${ne}'`),this.F.webContents.session.setProxy({proxyRules:_,proxyBypassRules:ne,pacScript:""})}}}addTabbedWindow(W){b.$j&&W.win&&this.F.addTabbedWindow(W.win)}load(W,H=Object.create(null)){this.U.trace(`window#load: attempt to load window (id: ${this.D})`),this.isDocumentEdited()&&(!H.isReload||!this.fb.isHotExitEnabled())&&this.setDocumentEdited(!1),H.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.F.setTitle(this.jb.nameLong)),this.vb(W,H),this.nb===0?this.H=W:this.R=W,this.nb=1,this.F.loadURL(d.$ig.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.X.isBuilt?"":"-dev"}.html`).toString(!0));const q=this.S;this.S=!0,!this.X.isBuilt&&!this.X.extensionTestsLocationURI&&this.B(new A.$_g(()=>{this.F&&!this.F.isVisible()&&!this.F.isMinimized()&&(this.F.show(),this.focus({force:!0}),this.F.webContents.openDevTools())},1e4)).schedule(),this.t.fire({workspace:W.workspace,reason:H.isReload?3:q?2:1})}vb(W,H){const q=(this.H??this.R)?.userEnv;if(q){const _=(0,g.$Vl)(q)&&!(0,g.$Vl)(W.userEnv),ne=this.isExtensionDevelopmentHost;(_||ne)&&(W.userEnv={...q,...W.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(W.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),H.disableExtensions!==void 0&&(W["disable-extensions"]=H.disableExtensions),W.fullscreen=this.isFullScreen,W.maximized=this.F.isMaximized(),W.partsSplash=this.db.getWindowSplash(),(0,u.mark)("code/willOpenNewWindow"),W.perfMarks=(0,u.getMarks)(),this.Q.update(W)}async reload(W){const H=Object.assign({},this.H);H.workspace=await this.wb(H),delete H.filesToOpenOrCreate,delete H.filesToDiff,delete H.filesToMerge,delete H.filesToWait,this.isExtensionDevelopmentHost&&W&&(H.verbose=W.verbose,H.debugId=W.debugId,H.extensionEnvironment=W.extensionEnvironment,H["inspect-extensions"]=W["inspect-extensions"],H["inspect-brk-extensions"]=W["inspect-brk-extensions"],H["extensions-dir"]=W["extensions-dir"]),H.accessibilitySupport=S.app.isAccessibilitySupportEnabled(),H.isInitialStartup=!1,H.policiesData=this.Y.serialize(),H.continueOn=this.X.continueOn,H.profiles={all:this.Z.profiles,profile:this.profile||this.Z.defaultProfile,home:this.Z.profilesHome},H.logLevel=this.W.getLogLevel(),H.loggers={window:this.W.getRegisteredLoggers(this.id),global:this.W.getRegisteredLoggers()},this.load(H,{isReload:!0,disableExtensions:W?.["disable-extensions"]})}async wb(W){if((0,I.$ai)(W.workspace)){const H=W.workspace.configPath;if(H.scheme===d.Schemas.file&&!await this.$.exists(H))return}else if((0,I.$8h)(W.workspace)){const H=W.workspace.uri;if(H.scheme===d.Schemas.file&&!await this.$.exists(H))return}return W.workspace}serializeWindowState(){if(!this.F)return(0,R.$97b)();if(this.isFullScreen){let q;try{q=S.screen.getDisplayMatching(this.getBounds())}catch{}const _=(0,R.$97b)();return{mode:3,display:q?q.id:void 0,width:this.I.width||_.width,height:this.I.height||_.height,x:this.I.x||0,y:this.I.y||0}}const W=Object.create(null);let H;if(!b.$j&&this.F.isMaximized()?H=0:H=1,H===0?W.mode=0:W.mode=1,H===1||H===0){let q;H===1?q=this.getBounds():q=this.F.getNormalBounds(),W.x=q.x,W.y=q.y,W.width=q.width,W.height=q.height}return W}updateWindowControls(W){if(W.height&&this.mb.setItem(ce.s,W.height),b.$i&&this.L)this.F.setTitleBarOverlay({color:W.backgroundColor?.trim()===""?void 0:W.backgroundColor,symbolColor:W.foregroundColor?.trim()===""?void 0:W.foregroundColor,height:W.height?W.height-1:void 0});else if(b.$j&&W.height!==void 0){const H=(W.height-15)/2;H?this.F.setWindowButtonPosition({x:H,y:H}):this.F.setWindowButtonPosition(null)}}xb(W){(0,u.mark)("code/willRestoreCodeWindowState");let H=!1;if(W)try{const q=S.screen.getAllDisplays();H=q.length>1,W=this.yb(W,q)}catch(q){this.U.warn(`Unexpected error validating window state: ${q}
${q.stack}`)}return(0,u.mark)("code/didRestoreCodeWindowState"),[W||(0,R.$97b)(),H]}yb(W,H){if(this.U.trace(`window#validateWindowState: validating window state on ${H.length} display(s)`,W),typeof W.x!="number"||typeof W.y!="number"||typeof W.width!="number"||typeof W.height!="number"){this.U.trace("window#validateWindowState: unexpected type of state values");return}if(W.width<=0||W.height<=0){this.U.trace("window#validateWindowState: unexpected negative values");return}if(H.length===1){const ne=this.zb(H[0]);if(ne){let X=function(){!W||typeof W.x!="number"||typeof W.y!="number"||!ne||(W.x<ne.x&&(W.x=ne.x),W.y<ne.y&&(W.y=ne.y))};this.U.trace("window#validateWindowState: 1 monitor working area",ne),X(),W.width>ne.width&&(W.width=ne.width),W.height>ne.height&&(W.height=ne.height),W.x>ne.x+ne.width-128&&(W.x=ne.x+ne.width-W.width),W.y>ne.y+ne.height-128&&(W.y=ne.y+ne.height-W.height),X()}return W}if(W.display&&W.mode===3){const ne=H.find(X=>X.id===W.display);if(ne&&typeof ne.bounds?.x=="number"&&typeof ne.bounds?.y=="number"){this.U.trace("window#validateWindowState: restoring fullscreen to previous display");const X=(0,R.$97b)(3);return X.x=ne.bounds.x,X.y=ne.bounds.y,X}}let q,_;try{q=S.screen.getDisplayMatching({x:W.x,y:W.y,width:W.width,height:W.height}),_=this.zb(q)}catch{}if(q&&_&&W.x+W.width>_.x&&W.y+W.height>_.y&&W.x<_.x+_.width&&W.y<_.y+_.height)return this.U.trace("window#validateWindowState: multi-monitor working area",_),W}zb(W){if(W.workArea.width>0&&W.workArea.height>0)return W.workArea;if(W.bounds.width>0&&W.bounds.height>0)return W.bounds}getBounds(){const[W,H]=this.F.getPosition(),[q,_]=this.F.getSize();return{x:W,y:H,width:q,height:_}}h(W){super.h(W),this.sendWhenReady(W?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.J&&this.Cb(this.J,!1)}Bb(){let W=(0,m.$tC)(this.a);return["visible","toggle","hidden"].indexOf(W)<0&&(W="classic"),W}Cb(W,H=!0){b.$j||(W==="toggle"&&H&&this.send("vscode:showInfoMessage",(0,p.localize)(14,null)),W==="hidden"?setTimeout(()=>{this.Db(W)}):this.Db(W))}Db(W){const H=this.isFullScreen;switch(W){case"classic":this.F.setMenuBarVisibility(!H),this.F.autoHideMenuBar=H;break;case"visible":this.F.setMenuBarVisibility(!0),this.F.autoHideMenuBar=!1;break;case"toggle":this.F.setMenuBarVisibility(!1),this.F.autoHideMenuBar=!0;break;case"hidden":this.F.setMenuBarVisibility(!1),this.F.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(b.$j)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.F.minimize();break;case"None":break;case"Maximize":default:this.F.isMaximized()?this.F.unmaximize():this.F.maximize()}else this.F.isMaximized()?this.F.unmaximize():this.F.maximize()}close(){this.F?.close()}sendWhenReady(W,H,...q){this.isReady?this.send(W,...q):this.ready().then(()=>{H.isCancellationRequested||this.send(W,...q)})}send(W,...H){if(this.F){if(this.F.isDestroyed()||this.F.webContents.isDestroyed()){this.U.warn(`Sending IPC message to channel '${W}' for window that is destroyed`);return}try{this.F.webContents.send(W,...H)}catch(q){this.U.warn(`Error sending IPC message to channel '${W}' of window ${this.D}: ${(0,M.$Ii)(q)}`)}}}updateTouchBar(W){b.$j&&this.N.forEach((H,q)=>{const _=W[q];H.segments=this.Gb(_)})}Eb(){if(b.$j){for(let W=0;W<10;W++){const H=this.Fb();this.N.push(H)}this.F.setTouchBar(new S.TouchBar({items:this.N}))}}Fb(W=[]){const H=this.Gb(W),q=new S.TouchBar.TouchBarSegmentedControl({segments:H,mode:"buttons",segmentStyle:"automatic",change:_=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:q.segments[_].id,from:"touchbar"})}});return q}Gb(W=[]){return W.map(q=>{let _;q.icon&&!n.ThemeIcon.isThemeIcon(q.icon)&&q.icon?.dark?.scheme===d.Schemas.file&&(_=S.nativeImage.createFromPath(y.URI.revive(q.icon.dark).fsPath),_.isEmpty()&&(_=void 0));let ne;return typeof q.title=="string"?ne=q.title:ne=q.title.value,{id:q.id,label:_?void 0:ne,icon:_}})}dispose(){super.dispose(),this.W.deregisterLoggers(this.id),this.F=null}};e.$G8b=V,e.$G8b=V=ce=ve([te(1,k.$fj),te(2,Y.$D8b),te(3,w.$07b),te(4,F.$qn),te(5,x.$f8b),te(6,h.$gk),te(7,r.$j8b),te(8,r.$h8b),te(9,v.$ri),te(10,c.$l8b),te(11,E.$B8b),te(12,l.$q8b),te(13,t.$kl),te(14,$.$r8b),te(15,a.$_7b),te(16,f.$xj),te(17,i.$t8b),te(18,D.$K8b),te(19,U.$QN),te(20,oe.$Wh)],V)}),define(se[302],re([0,1,15,3,17,24,5,133]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H8b=void 0;let d=class extends P.$F8b{get win(){return this.t||this.tryClaimWindow(),this.t}get lastFocusTime(){return this.u}constructor(b,y,p,l){super(l),this.w=b,this.z=y,this.C=p,this.s=this.B(new A.$Rd),this.onDidClose=this.s.event,this.id=this.w.id,this.parentId=-1,this.t=null,this.u=Date.now(),this.D()}D(){this.z.args["open-devtools"]===!0&&this.w.openDevTools({mode:"bottom"}),this.tryClaimWindow()}tryClaimWindow(){if(this.t||this.q.isDisposed||this.w.isDestroyed())return;const b=S.BrowserWindow.fromWebContents(this.w);b&&(this.C.trace("[aux window] Claimed browser window instance"),this.t=b,b.setMenu(null),this.F(b))}F(b){b.on("closed",()=>{this.C.trace("[aux window] Closed window"),this.s.fire(),this.dispose()}),b.on("focus",()=>{this.u=Date.now()})}dispose(){super.dispose(),this.t=null}};e.$H8b=d,e.$H8b=d=ve([te(1,M.$07b),te(2,C.$fj),te(3,s.$ri)],d)}),define(se[303],re([0,1,15,3,13,36,302,6,5,29]),function(J,e,S,A,s,M,C,P,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$79b=void 0;let b=class{constructor(p,l){this.b=p,this.c=l,this.a=new Map,this.d()}d(){S.app.on("browser-window-created",(p,l)=>{const v=this.getWindowById(l.id);v&&(this.c.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),v.tryClaimWindow())}),M.$XT.handle("vscode:registerAuxiliaryWindow",async(p,l)=>{const v=this.getWindowById(p.sender.id);return v&&(this.c.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),v.parentId=l),p.sender.id})}createWindow(){return this.b.invokeFunction(u.$L8b,void 0,{webPreferences:{preload:s.$ig.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}registerWindow(p){const l=this.b.createInstance(C.$H8b,p);this.a.set(l.id,l),A.Event.once(l.onDidClose)(()=>this.a.delete(l.id))}getWindowById(p){return this.a.get(p)}getFocusedWindow(){const p=S.BrowserWindow.getFocusedWindow();if(p)return this.getWindowById(p.id)}getLastActiveWindow(){return(0,u.$N8b)(Array.from(this.a.values()))}getWindows(){return Array.from(this.a.values())}};e.$79b=b,e.$79b=b=ve([te(0,P.$Wh),te(1,d.$fj)],b)}),define(se[83],re([0,1,15,23,8,3,47,2,13,4,19,7,21,193,6,20,5,82,97,30,55,31,53]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w,g,h,a,k,f,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$j9b=e.$i9b=void 0,e.$i9b=(0,v.$Xh)("workspacesHistoryMainService");let r=class extends P.$Rc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(n,c,m,D,I){super(),this.f=n,this.g=c,this.h=m,this.j=D,this.m=I,this.c=this.B(new M.$Rd),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new s.$Xg(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let c=[],m=[];for(const I of n)if((0,h.$bfb)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.w(c,I.workspace)&&c.push(I);else if((0,h.$cfb)(I))this.y(c,I.folderUri)||c.push(I);else{const E=this.z(m,I.fileUri),R=I.fileUri.scheme===d.Schemas.file&&o.G.indexOf((0,b.$yg)(I.fileUri))>=0;!E&&!R&&(m.push(I),u.$i&&I.fileUri.scheme===d.Schemas.file&&S.app.addRecentDocument(I.fileUri.fsPath))}const D=await this.r({workspaces:c,files:m});c=D.workspaces,m=D.files,c.length>o.a&&(c.length=o.a),m.length>o.a&&(m.length=o.a),await this.t({workspaces:c,files:m}),this.c.fire(),u.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(n){const c=E=>{const R=this.u(E);for(const L of n)if(b.$sg.isEqual(L,R))return!1;return!0},m=await this.getRecentlyOpened(),D=m.workspaces.filter(c),I=m.files.filter(c);(D.length!==m.workspaces.length||I.length!==m.files.length)&&(await this.t({files:I,workspaces:D}),this.c.fire(),u.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(n){if(n?.confirm){const{response:c}=await this.m.showMessageBox({type:"warning",buttons:[(0,l.localize)(0,null),(0,l.localize)(1,null)],message:(0,l.localize)(2,null),detail:(0,l.localize)(3,null),cancelId:1});if(c!==0)return}await this.t({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(n){const c=new f.$zc(I=>b.$sg.getComparisonKey(I));if(n?.workspaces)for(const I of n.workspaces)c.set(this.u(I),I);const m=new f.$zc(I=>b.$sg.getComparisonKey(I));if(n?.files)for(const I of n.files)m.set(this.u(I),I);const D=await this.s();for(const I of D.workspaces){const E=c.get(this.u(I));E?E.label=E.label??I.label:c.set(this.u(I),I)}for(const I of D.files){const E=m.get(this.u(I));E?E.label=E.label??I.label:m.set(this.u(I),I)}return{workspaces:[...c.values()],files:[...m.values()]}}async s(){await this.j.whenReady;let n;const c=this.j.get(o.b,-1);if(typeof c=="string")try{n=JSON.parse(c)}catch(m){this.f.error("Unexpected error parsing opened paths list",m)}return(0,h.$ifb)(n,this.f)}async t(n){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,h.$jfb)(n)),-1,1)}u(n){return(0,h.$cfb)(n)?n.folderUri:(0,h.$dfb)(n)?n.fileUri:n.workspace.configPath}w(n,c){return!!n.find(m=>(0,h.$bfb)(m)&&m.workspace.id===c.id)}y(n,c){return!!n.find(m=>(0,h.$cfb)(m)&&b.$sg.isEqual(m.folderUri,c))}z(n,c){return!!n.find(m=>b.$sg.isEqual(m.fileUri,c))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){u.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!u.$i)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,l.localize)(4,null),description:(0,l.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const c=[];for(const I of S.app.getJumpListSettings().removedItems){const E=I.args;if(E){const R=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(E);R&&c.push(y.URI.parse(R[2]))}}await this.removeRecentlyOpened(c);let m=!1;const D=(0,A.$Gb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(I=>{const E=(0,h.$bfb)(I)?I.workspace:I.folderUri,{title:R,description:L}=this.L(E,I.label);let F;return y.URI.isUri(E)?F=`--folder-uri "${E.toString()}"`:(m=!0,F=`--file-uri "${E.configPath.toString()}"`),{type:"task",title:R.substr(0,255),description:L.substr(0,255),program:process.execPath,args:F,iconPath:"explorer.exe",iconIndex:0}}));D.length>0&&n.push({type:"custom",name:m?(0,l.localize)(6,null):(0,l.localize)(7,null),items:D})}n.push({type:"recent"});try{const c=S.app.setJumpList(n);c&&c!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${c}`)}catch(c){this.f.warn("updateWindowsJumpList#setJumpList",c)}}L(n,c){if(c)return{title:(0,C.$Jv)(c).name,description:c};if(y.URI.isUri(n))return{title:(0,b.$yg)(n),description:this.M(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,l.localize)(8,null),description:""};let m=(0,b.$yg)(n.configPath);return m.endsWith(a.$hi)&&(m=m.substr(0,m.length-a.$hi.length-1)),{title:(0,l.localize)(9,null,m),description:this.M(n.configPath)}}M(n){return n.scheme==="file"?(0,C.$Bv)(n.fsPath):n.toString()}async N(){if(!u.$j)return;S.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),c=[];let m=0;for(let I=0;I<n.workspaces.length&&m<o.C;I++){const E=this.u(n.workspaces[I]);if(E.scheme===d.Schemas.file){const R=(0,b.$pg)(E);await p.Promises.exists(R)&&(c.push(R),m++)}}const D=[];for(let I=0;I<n.files.length&&m<o.D;I++){const E=this.u(n.files[I]);if(E.scheme===d.Schemas.file){const R=(0,b.$pg)(E);if(o.G.includes((0,b.$yg)(E))||c.includes(R))continue;await p.Promises.exists(R)&&(D.push(R),m++)}}D.reverse().forEach(I=>S.app.addRecentDocument(I)),c.reverse().forEach(I=>S.app.addRecentDocument(I))}};e.$j9b=r,e.$j9b=r=o=ve([te(0,w.$fj),te(1,k.$B8b),te(2,$.$_7b),te(3,g.$j8b),te(4,i.$r8b)],r)}),define(se[304],re([0,1,15,8,22,47,4,7,181,64,17,24,20,5,231,70,26,34,27,49,60,29,83]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w,g,h,a,k,f,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$k9b=void 0;const r="menu";let t=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(m,D,I,E,R,L,F,U,x,Y,ae,oe){this.n=m,this.o=D,this.p=I,this.q=E,this.r=R,this.s=L,this.t=F,this.u=U,this.v=x,this.w=Y,this.x=ae,this.y=oe,this.m=Object.create(null),this.g=new A.$_g(()=>this.F(),0),this.h=new A.$_g(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(C.$j||(0,k.$uC)(this.o)==="native")&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const m=this.t.getItem(o.a);m&&(m.menus&&(this.k=m.menus),m.keybindings&&(this.l=m.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(L,F,U)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:F?.id})},this.m["workbench.action.newWindow"]=(L,F,U)=>this.p.openEmptyWindow({context:2,contextWindowId:F?.id}),this.m["workbench.action.files.openFileFolder"]=(L,F,U)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(U),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(L,F,U)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(U),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(L,F,U)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(U),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const m=this.x.youTubeUrl;m&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(m,"openYouTubeUrl"));const D=this.x.requestFeatureUrl;D&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(D,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(I,"openReportIssues"));const E=this.x.licenseUrl;E&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(C.$w){const L=E.indexOf("?")>0?"&":"?";this.ab(`${E}${L}lang=${C.$w}`,"openLicenseUrl")}else this.ab(E,"openLicenseUrl")});const R=this.x.privacyStatementUrl;R&&E&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(R,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(m=>this.G(m)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const m=this.o.getValue("window.enableMenuBarMnemonics");return typeof m!="boolean"?!0:m}get D(){if(!C.$j)return!1;const m=this.o.getValue("window.nativeTabs");return typeof m!="boolean"?!1:m}updateMenu(m,D){this.k=m.menus,this.l=m.keybindings,this.t.setItem(o.a,m),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(m){C.$j&&(m.oldCount===0&&m.newCount>0||m.oldCount>0&&m.newCount===0)&&(this.d=m.newCount===0,this.E())}H(){if(!C.$j)return;const m=S.BrowserWindow.getFocusedWindow();this.f=!m||!!this.y.getWindowById(m.id),this.E()}I(){const m=S.Menu.getApplicationMenu();if(m&&this.j.push(m),Object.keys(this.k).length===0){this.J(C.$j?new S.Menu:null);return}const D=new S.Menu;let I;if(C.$j){const R=new S.Menu;I=new S.MenuItem({label:this.x.nameShort,submenu:R}),this.K(R),D.append(I)}if(C.$j&&!this.c){this.c=!0;const R=new S.Menu;R.append(new S.MenuItem({label:this.cb(d.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),S.app.dock.setMenu(R)}if(this.M("File")){const R=new S.Menu,L=new S.MenuItem({label:this.cb(d.localize(1,null)),submenu:R});this.O(R,"File"),D.append(L)}if(this.M("Edit")){const R=new S.Menu,L=new S.MenuItem({label:this.cb(d.localize(2,null)),submenu:R});this.O(R,"Edit"),D.append(L)}if(this.M("Selection")){const R=new S.Menu,L=new S.MenuItem({label:this.cb(d.localize(3,null)),submenu:R});this.O(R,"Selection"),D.append(L)}if(this.M("View")){const R=new S.Menu,L=new S.MenuItem({label:this.cb(d.localize(4,null)),submenu:R});this.O(R,"View"),D.append(L)}if(this.M("Go")){const R=new S.Menu,L=new S.MenuItem({label:this.cb(d.localize(5,null)),submenu:R});this.O(R,"Go"),D.append(L)}if(this.M("Run")){const R=new S.Menu,L=new S.MenuItem({label:this.cb(d.localize(6,null)),submenu:R});this.O(R,"Run"),D.append(L)}if(this.M("Terminal")){const R=new S.Menu,L=new S.MenuItem({label:this.cb(d.localize(7,null)),submenu:R});this.O(R,"Terminal"),D.append(L)}let E;if(this.M("Window")){const R=new S.Menu;E=new S.MenuItem({label:this.cb(d.localize(8,null)),submenu:R,role:"window"}),this.U(R)}if(E&&D.append(E),this.M("Help")){const R=new S.Menu,L=new S.MenuItem({label:this.cb(d.localize(9,null)),submenu:R,role:"help"});this.O(R,"Help"),D.append(L)}D.items&&D.items.length>0?this.J(D):this.J(null),this.h.schedule()}J(m){if(S.Menu.setApplicationMenu(m),m)for(const D of this.y.getWindows())D.win?.setMenu(null)}K(m){const D=this.W(d.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.V();let E;if(this.M("Preferences")){const oe=new S.Menu;this.O(oe,"Preferences"),E=new S.MenuItem({label:this.cb(d.localize(11,null)),submenu:oe})}const R=new S.Menu,L=new S.MenuItem({label:d.localize(12,null),role:"services",submenu:R}),F=new S.MenuItem({label:d.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),U=new S.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new S.MenuItem({label:d.localize(15,null),role:"unhide"}),Y=new S.MenuItem(this.$("workbench.action.quit",{label:d.localize(16,null,this.x.nameLong),click:async(oe,ce,Q)=>{const K=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||S.BrowserWindow.getFocusedWindow()||K?.win?.isMinimized())&&await this.L(Q)&&this.w.quit(void 0)}})),ae=[D];ae.push(...I),E&&ae.push(n(),E),ae.push(n(),L,n(),F,U,x,n(),Y),ae.forEach(oe=>m.append(oe))}async L(m){if(this.p.getWindowCount()===0)return!0;const D=this.o.getValue("window.confirmBeforeClose");if(D==="always"||D==="keyboardOnly"&&this.S(m)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[d.localize(17,null),d.localize(18,null)],message:d.localize(19,null)});return I===0}return!0}M(m){if(!C.$j&&(0,k.$uC)(this.o)==="custom")return!1;switch(m){case"File":case"Help":if(C.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[m];case"Window":if(C.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[m]}}N(m,D){D.forEach(I=>{if((0,v.$f9b)(I))m.append(n());else if((0,v.$e9b)(I)){const E=new S.Menu,R=new S.MenuItem({label:this.cb(I.label),submenu:E});this.N(E,I.submenu.items),m.append(R)}else(0,v.$g9b)(I)?m.append(this.Q(I)):(0,v.$h9b)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.P(m),C.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?m.append(new S.MenuItem(this.$(I.id,{label:this.cb(I.label),click:this.m[I.id]}))):m.append(this.W(I.label,I.id,!1,I.checked)):m.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)):m.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)))})}O(m,D){this.k&&this.k[D]&&this.N(m,this.k[D].items)}P(m){const D=this.V();D.length&&(D.forEach(I=>m.append(I)),m.append(n()))}Q(m){const D=P.URI.revive(m.uri),I=m.id,E=I==="openRecentFile"?{fileUri:D}:I==="openRecentWorkspace"?{workspaceUri:D}:{folderUri:D};return new S.MenuItem(this.$(I,{label:m.label,click:async(R,L,F)=>{const U=this.R(F);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[E],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:m.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([D])}},!1))}R(m){return!!(m&&(!C.$j&&(m.ctrlKey||m.shiftKey)||C.$j&&(m.metaKey||m.altKey)))}S(m){return!!(m.triggeredByAccelerator||m.altKey||m.ctrlKey||m.metaKey||m.shiftKey)}T(m,D,I){const E={label:this.cb(m),role:I,enabled:!0};return new S.MenuItem(this.Z(D,E))}U(m){const D=new S.MenuItem({label:d.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new S.MenuItem({label:d.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),E=new S.MenuItem({label:d.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),R=this.W(d.localize(23,null),"workbench.action.switchWindow"),L=[];this.D&&(L.push(n()),L.push(this.W(d.localize(24,null),"workbench.action.newWindowTab")),L.push(this.T(d.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.T(d.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.T(d.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.T(d.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[D,I,n(),R,...L,n(),E].forEach(F=>m.append(F))}V(){switch(this.n.state.type){case"idle":return[new S.MenuItem({label:this.cb(d.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:d.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.cb(d.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:d.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.cb(d.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new S.MenuItem({label:d.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.cb(d.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(m,D,I,E){const R=this.cb(m),L=typeof D=="function"?D:(ae,oe,ce)=>{const Q=ae?ae.userSettingsLabel:null;let K=D;Array.isArray(D)&&(K=this.R(ce)?D[1]:D[0]),Q&&ce.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:Q}):this.Y({type:"commandId",commandId:K})},F=typeof I=="boolean"?I:this.p.getWindowCount()>0,U=typeof E=="boolean"?E:!1,x={label:R,click:L,enabled:F};U&&(x.type="checkbox",x.checked=U);let Y;return typeof D=="string"?Y=D:Array.isArray(D)&&(Y=D[0]),C.$j&&(Y==="editor.action.clipboardCutAction"?x.role="cut":Y==="editor.action.clipboardCopyAction"?x.role="copy":Y==="editor.action.clipboardPasteAction"&&(x.role="paste"),Y==="undo"?x.click=this.X(L,{inDevTools:ae=>ae.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):Y==="redo"?x.click=this.X(L,{inDevTools:ae=>ae.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):Y==="editor.action.selectAll"&&(x.click=this.X(L,{inDevTools:ae=>ae.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.Z(Y,x))}X(m,D){return(I,E,R)=>{const L=S.BrowserWindow.getFocusedWindow();if(!L)return D.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return D.inDevTools(L.webContents.devToolsWebContents);m(I,E||L,R)}}Y(m){let D=S.BrowserWindow.getFocusedWindow();if(D){const E=this.y.getWindowById(D.id);E&&(D=this.p.getWindowById(E.parentId)?.win??null)}if(!D){const E=this.p.getLastActiveWindow();E?.win?.isMinimized()&&(D=E.win)}const I=D?this.p.getWindowById(D.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",m),C.$j&&!this.q.isBuilt&&!I.isReady&&(m.type==="commandId"&&m.commandId==="workbench.action.toggleDevTools"||m.type!=="commandId"&&m.userSettingsLabel==="alt+cmd+i"))return!1;if(m.type==="commandId"){const E={id:m.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,E)}else{const E={userSettingsLabel:m.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,E)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",m),!1}Z(m,D){const I=typeof m=="string"?this.l[m]:void 0;if(I?.label){if(I.isNative!==!1)D.accelerator=I.label,D.userSettingsLabel=I.userSettingsLabel;else if(typeof D.label=="string"){const E=D.label.indexOf("[");E>=0?D.label=`${D.label.substr(0,E)} [${I.label}]`:D.label=`${D.label} [${I.label}]`}}else D.accelerator=void 0;return D}$(m,D,I=!D.accelerator){I&&(D=this.Z(m,D));const E=D.click;return D.click=(R,L,F)=>{this.bb(m),E?.(R,L,F)},D}ab(m,D){this.w.openExternal(void 0,m),this.bb(D)}bb(m){this.r.publicLog2("workbenchActionExecuted",{id:m,from:r})}cb(m){return(0,M.$Gv)(m,!this.C)}};e.$k9b=t,e.$k9b=t=o=ve([te(0,a.$WU),te(1,b.$ri),te(2,f.$K8b),te(3,y.$07b),te(4,h.$kl),te(5,i.$i9b),te(6,g.$QN),te(7,p.$_7b),te(8,l.$fj),te(9,$.$98b),te(10,w.$xj),te(11,u.$I8b)],t);function n(){return new S.MenuItem({type:"separator"})}}),define(se[305],re([0,1,6,20,5,304]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m9b=e.$l9b=void 0,e.$l9b=(0,S.$Xh)("menubarMainService");let C=class{constructor(d,u,b){this.b=d,this.c=u,this.d=b,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$k9b)}async updateMenubar(d,u){this.d.trace("menubarService#updateMenubar",d),(await this.a).updateMenu(u,d)}};e.$m9b=C,e.$m9b=C=ve([te(0,S.$Wh),te(1,A.$_7b),te(2,s.$fj)],C)}),define(se[306],re([0,1,15,21,131,28,23,22,3,33,47,2,13,9,67,4,35,19,12,7,191,65,17,53,24,16,6,20,5,79,80,59,34,60,133,29,130,298,30,98,83,55,69,39,54,68,64]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w,g,h,a,k,f,i,o,r,t,n,c,m,D,I,E,R,L,F,U,x,Y,ae,oe,ce,Q,K,V,z,W,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M9b=void 0;function q(X){return(0,ae.$ai)(X?.workspace)}function _(X){return(0,ae.$8h)(X?.workspace)}let ne=class extends y.$Rc{constructor(O,N,G,j,B,T,Z,he,de,le,we,be,Ee,Se,je,ke,pe,ee,ue,ge){super(),this.m=O,this.n=N,this.r=G,this.s=j,this.t=B,this.u=T,this.w=Z,this.z=he,this.C=de,this.D=le,this.F=we,this.G=be,this.H=Ee,this.I=Se,this.J=je,this.L=ke,this.M=pe,this.N=ee,this.O=ue,this.P=ge,this.a=this.B(new d.$Rd),this.onDidOpenWindow=this.a.event,this.b=this.B(new d.$Rd),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new d.$Rd),this.onDidDestroyWindow=this.c.event,this.f=this.B(new d.$Rd),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new d.$Rd),this.onDidTriggerSystemContextMenu=this.g.event,this.h=new Map,this.j=this.B(new Y.$J9b(this,this.u,this.D,this.s,this.G)),this.Q()}Q(){this.B(this.I.onDidEnterWorkspace(O=>this.b.fire(O.window))),this.B(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const N=new y.$Qc;if(N.add(d.Event.any(O.onDidClose,O.onDidDestroy)(()=>N.dispose())),O.config.extensionDevelopmentPath)for(const G of O.config.extensionDevelopmentPath)N.add(this.N.addValidFileRoot(G));O.config.extensionTestsPath&&N.add(this.N.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,N){const G=this.z.args,j=N?.remoteAuthority||void 0,B=!0,T=N?.forceReuseWindow,Z=!T;return this.open({...O,cli:G,forceEmpty:B,forceNewWindow:Z,forceReuseWindow:T,remoteAuthority:j})}openExistingWindow(O,N){O.focus(),this.R(N,[O])}async open(O){this.s.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const N=[],G=[],j=[],B=[],T=[];let Z,he=0;const de=await this.$(O);this.s.trace("windowsManager#open pathsToOpen",de);for(const Se of de)_(Se)?O.addMode?N.push(Se):G.push(Se):q(Se)?j.push(Se):Se.fileUri?(Z||(Z={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Se.remoteAuthority}),Z.filesToOpenOrCreate.push(Se)):Se.backupPath?T.push({backupFolder:(0,l.$mc)(Se.backupPath),remoteAuthority:Se.remoteAuthority}):he++;O.diffMode&&Z&&Z.filesToOpenOrCreate.length>=2&&(Z.filesToDiff=Z.filesToOpenOrCreate.slice(0,2),Z.filesToOpenOrCreate=[]),O.mergeMode&&Z&&Z.filesToOpenOrCreate.length===4&&(Z.filesToMerge=Z.filesToOpenOrCreate.slice(0,4),Z.filesToOpenOrCreate=[],Z.filesToDiff=[]),Z&&O.waitMarkerFileURI&&(Z.filesToWait={paths:(0,C.$Gb)([...Z.filesToDiff,Z.filesToMerge[3],...Z.filesToOpenOrCreate]),waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(B.push(...this.I.getUntitledWorkspaces()),j.push(...B),T.push(...this.F.getEmptyWindowBackups())):T.length=0;const{windows:le,filesOpenedInWindow:we}=await this.S(O,j,G,T,he,Z,N);if(this.s.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${j.length}, foldersToOpen: ${G.length}, emptyToRestore: ${T.length}, emptyToOpen: ${he})`),le.length>1)if(we)we.focus();else{const Se=this.j.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let je=!0,ke=!0;if(Se){const pe=le.filter(ee=>this.j.state.lastActiveWindow&&ee.backupPath===this.j.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),je=!1,ke=!1)}if(je)for(let pe=le.length-1;pe>=0;pe--){const ee=le[pe];if(!(ee.openedWorkspace&&B.some(ue=>ee.openedWorkspace&&ue.workspace.id===ee.openedWorkspace.id)||ee.backupPath&&T.some(ue=>ee.backupPath&&ue.backupFolder===(0,l.$mc)(ee.backupPath)))){ee.focus(),ke=!1;break}}ke&&le[le.length-1].focus()}const be=Z&&Z.filesToDiff.length>0,Ee=Z&&Z.filesToMerge.length>0;if(!le.some(Se=>Se.isExtensionDevelopmentHost)&&!be&&!Ee&&!O.noRecentEntry){const Se=[];for(const je of de)q(je)&&!je.transient?Se.push({label:je.label,workspace:je.workspace,remoteAuthority:je.remoteAuthority}):_(je)?Se.push({label:je.label,folderUri:je.workspace.uri,remoteAuthority:je.remoteAuthority}):je.fileUri&&Se.push({label:je.label,fileUri:je.fileUri,remoteAuthority:je.remoteAuthority});this.H.addRecentlyOpened(Se)}return this.R(O,le),le}R(O,N){const G=O.waitMarkerFileURI;O.context===0&&G&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.M.del(G)}catch{}})()}async S(O,N,G,j,B,T,Z){const he=[];let de;function le(pe,ee){he.push(pe),ee&&(de=pe,T=void 0)}let{openFolderInNewWindow:we,openFilesInNewWindow:be}=this.lb(O);if(!O.initialStartup&&Z.length>0){const pe=Z[0].remoteAuthority,ee=this.qb(pe);ee&&le(this.X(ee,Z.map(ue=>ue.workspace.uri)))}const Ee=G.length+N.length+j.length;if(T&&Ee===0){const pe=T.filesToOpenOrCreate[0]||T.filesToDiff[0]||T.filesToMerge[3],ee=this.getWindows().filter(ge=>T&&(0,g.$Gg)(ge.remoteAuthority,T.remoteAuthority));let ue;pe?.fileUri&&!be&&((O.context===4||O.context===0||O.context===1)&&(ue=await(0,x.$u8b)(ee,pe.fileUri,async ge=>ge.configPath.scheme===p.Schemas.file?this.I.resolveLocalWorkspace(ge.configPath):void 0)),ue||(ue=this.rb(ee))),ue?(0,ae.$ai)(ue.openedWorkspace)?N.push({workspace:ue.openedWorkspace,remoteAuthority:ue.remoteAuthority}):(0,ae.$8h)(ue.openedWorkspace)?G.push({workspace:ue.openedWorkspace,remoteAuthority:ue.remoteAuthority}):le(this.U(O,ue,T),!0):le(await this.mb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:T,forceNewWindow:!0,remoteAuthority:T.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile}),!0)}const Se=(0,C.$Lb)(N,pe=>pe.workspace.id);if(Se.length>0){const pe=(0,C.$Gb)(Se.map(ee=>(0,x.$v8b)(this.getWindows(),ee.workspace.configPath)));if(pe.length>0){const ee=pe[0],ue=(0,g.$Gg)(T?.remoteAuthority,ee.remoteAuthority)?T:void 0;le(this.U(O,ee,ue),!!ue),we=!0}for(const ee of Se){if(pe.some(Re=>Re.openedWorkspace&&Re.openedWorkspace.id===ee.workspace.id))continue;const ue=ee.remoteAuthority,ge=(0,g.$Gg)(T?.remoteAuthority,ue)?T:void 0;le(await this.Z(O,ee,we,ge),!!ge),we=!0}}const je=(0,C.$Lb)(G,pe=>g.$sg.getComparisonKey(pe.workspace.uri));if(je.length>0){const pe=(0,C.$Gb)(je.map(ee=>(0,x.$v8b)(this.getWindows(),ee.workspace.uri)));if(pe.length>0){const ee=pe[0],ue=(0,g.$Gg)(T?.remoteAuthority,ee.remoteAuthority)?T:void 0;le(this.U(O,ee,ue),!!ue),we=!0}for(const ee of je){if(pe.some(Re=>(0,ae.$8h)(Re.openedWorkspace)&&g.$sg.isEqual(Re.openedWorkspace.uri,ee.workspace.uri)))continue;const ue=ee.remoteAuthority,ge=(0,g.$Gg)(T?.remoteAuthority,ue)?T:void 0;le(await this.Z(O,ee,we,ge),!!ge),we=!0}}const ke=(0,C.$Lb)(j,pe=>pe.backupFolder);if(ke.length>0)for(const pe of ke){const ee=pe.remoteAuthority,ue=(0,g.$Gg)(T?.remoteAuthority,ee)?T:void 0;le(await this.Y(O,!0,ee,ue,pe),!!ue),we=!0}if(he.length===0||T){T&&!B&&B++;const pe=T?T.remoteAuthority:O.remoteAuthority;for(let ee=0;ee<B;ee++)le(await this.Y(O,we,pe,T),!!T),we=!0}return{windows:(0,C.$Lb)(he),filesOpenedInWindow:de}}U(O,N,G){this.s.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:G}),this.W(N);const j={filesToOpenOrCreate:G?.filesToOpenOrCreate,filesToDiff:G?.filesToDiff,filesToMerge:G?.filesToMerge,filesToWait:G?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",P.CancellationToken.None,j),N}W(O){let N=O;const G=S.BrowserWindow.getFocusedWindow();if(G&&G.id!==O.id){const j=this.P.getWindowById(G.id);j&&j.parentId===O.id&&(N=j)}N.focus()}X(O,N){this.s.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),O.focus();const G={foldersToAdd:N};return O.sendWhenReady("vscode:addFolders",P.CancellationToken.None,G),O}Y(O,N,G,j,B){this.s.trace("windowsManager#doOpenEmpty",{restore:!!B,remoteAuthority:G,filesToOpen:j,forceNewWindow:N});let T;return!N&&typeof O.contextWindowId=="number"&&(T=this.getWindowById(O.contextWindowId)),this.mb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:G,forceNewWindow:N,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:j,windowToUse:T,emptyWindowBackupInfo:B,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}Z(O,N,G,j,B){return this.s.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:j}),!G&&!B&&typeof O.contextWindowId=="number"&&(B=this.getWindowById(O.contextWindowId)),this.mb({workspace:N.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:G,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:j,windowToUse:B,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}async $(O){let N,G=!1,j=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(N=await this.ab(O),G=!0):O.forceEmpty?N=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(N=await this.bb(O.cli),N.length===0&&N.push(Object.create(null)),G=!0):(N=await this.db(),N.length===0&&N.push(Object.create(null)),j=!0),!O.addMode&&G){const B=N.filter(T=>_(T));if(B.length>1){const T=B[0].remoteAuthority;if(B.every(Z=>(0,g.$Gg)(Z.remoteAuthority,T))){const Z=await this.I.createUntitledWorkspace(B.map(he=>({uri:he.workspace.uri})));N.push({workspace:Z,remoteAuthority:T}),N=N.filter(he=>!_(he))}}}if(O.initialStartup&&!j&&this.G.getValue("window")?.restoreWindows==="preserve"){const B=await this.db();N.unshift(...B.filter(T=>q(T)||_(T)||T.backupPath))}return N}async ab(O){const N={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority},G=await Promise.all((0,C.$Gb)(O.urisToOpen||[]).map(async j=>{const B=await this.fb(j,N);if(B)return B.label=j.label,B;const T=this.hb(j);this.L.showMessageBox({type:"info",buttons:[(0,k.localize)(0,null)],message:T.scheme===p.Schemas.file?(0,k.localize)(1,null):(0,k.localize)(2,null),detail:T.scheme===p.Schemas.file?(0,k.localize)(3,null,(0,b.$Av)(T,{os:$.OS,tildify:this.z})):(0,k.localize)(4,null,T.toString(!0))},S.BrowserWindow.getFocusedWindow()??void 0)}));return(0,C.$Gb)(G)}async bb(O){const N=[],G={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:O.diff&&O._.length===2||O.merge&&O._.length===4},j=O["folder-uri"];if(j){const Z=await Promise.all(j.map(he=>{const de=this.cb(he);if(de)return this.fb({folderUri:de},G)}));N.push(...(0,C.$Gb)(Z))}const B=O["file-uri"];if(B){const Z=await Promise.all(B.map(he=>{const de=this.cb(he);if(de)return this.fb((0,ae.$qi)(he)?{workspaceUri:de}:{fileUri:de},G)}));N.push(...(0,C.$Gb)(Z))}const T=await Promise.all(O._.map(Z=>G.remoteAuthority?this.kb(Z,G):this.ib(Z,G)));return N.push(...(0,C.$Gb)(T)),N}cb(O){try{const N=a.URI.parse(O);if(!N.scheme){this.s.error(`Invalid URI input string, scheme missing: ${O}`);return}return N.path?N:N.with({path:"/"})}catch(N){this.s.error(`Invalid URI input string: ${O}, ${N.message}`)}}async db(){const O=this.eb();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];O!=="one"&&N.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&N.push(this.j.state.lastActiveWindow);const G=await Promise.all(N.map(async j=>{if(j.workspace){const B=await this.fb({workspaceUri:j.workspace.configPath},{remoteAuthority:j.remoteAuthority,rejectTransientWorkspaces:!0});if(q(B))return B}else if(j.folderUri){const B=await this.fb({folderUri:j.folderUri},{remoteAuthority:j.remoteAuthority});if(_(B))return B}else if(O!=="folders"&&j.backupPath)return{backupPath:j.backupPath,remoteAuthority:j.remoteAuthority}}));return(0,C.$Gb)(G)}}}eb(){let O;return this.D.wasRestarted?O="all":(O=this.G.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}async fb(O,N=Object.create(null)){const G=this.hb(O);return G.scheme===p.Schemas.file?((0,L.$sC)(O)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.ib(G.fsPath,N)):this.gb(O,N)}gb(O,N){let G=this.hb(O);const j=(0,E.$3k)(G)||N.remoteAuthority;if(G=(0,g.$Ig)((0,g.$Cg)(G)),(0,L.$sC)(O)){if(N.gotoLineMode){const{path:B,line:T,column:Z}=(0,u.$9f)(G.path);return{fileUri:G.with({path:B}),options:{selection:T?{startLineNumber:T,startColumn:Z||1}:void 0},remoteAuthority:j}}return{fileUri:G,remoteAuthority:j}}else if((0,L.$qC)(O))return{workspace:(0,oe.$y8b)(G),remoteAuthority:j};return{workspace:(0,oe.$z8b)(G),remoteAuthority:j}}hb(O){return(0,L.$qC)(O)?O.workspaceUri:(0,L.$rC)(O)?O.folderUri:O.fileUri}async ib(O,N,G){let j,B;N.gotoLineMode&&({path:O,line:j,column:B}=(0,u.$9f)(O)),O=(0,u.$4f)((0,l.$gc)(O),(0,w.cwd)());try{const T=await A.Promises.stat(O);if(T.isFile()){if(!N.forceOpenWorkspaceAsFile){const Z=await this.I.resolveLocalWorkspace(a.URI.file(O));if(Z)return Z.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:Z.id,configPath:Z.configPath},type:t.FileType.File,exists:!0,remoteAuthority:Z.remoteAuthority,transient:Z.transient}}return{fileUri:a.URI.file(O),type:t.FileType.File,exists:!0,options:{selection:j?{startLineNumber:j,startColumn:B||1}:void 0}}}else{if(T.isDirectory())return{workspace:(0,oe.$z8b)(a.URI.file(O),T),type:t.FileType.Directory,exists:!0};if(!$.$i&&O==="/dev/null")return{fileUri:a.URI.file(O),type:t.FileType.File,exists:!0}}}catch(T){if(T.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!G)return this.jb(O,N);const Z=a.URI.file(O);if(this.H.removeRecentlyOpened([Z]),N.ignoreFileNotFound)return{fileUri:Z,type:t.FileType.File,exists:!1}}}async jb(O,N){const G=a.URI.file(O),{response:j,checkboxChecked:B}=await this.L.showMessageBox({type:"warning",buttons:[(0,k.localize)(5,null),(0,k.localize)(6,null),(0,k.localize)(7,null)],message:(0,k.localize)(8,null,G.authority),detail:(0,k.localize)(9,null,(0,b.$Av)(G,{os:$.OS,tildify:this.z})),checkboxLabel:(0,k.localize)(10,null,G.authority),cancelId:1});if(j===0){if((0,s.addUNCHostToAllowlist)(G.authority),B){const T={channel:"vscode:configureAllowedUNCHost",args:G.authority};this.sendToFocused(T.channel,T.args),this.sendToOpeningWindow(T.channel,T.args)}return this.ib(O,N,!0)}if(j===2)return S.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.jb(O,N)}kb(O,N){const G=O.charCodeAt(0),j=N.remoteAuthority;let B,T;N.gotoLineMode&&({path:O,line:B,column:T}=(0,u.$9f)(O)),G!==47&&((0,u.$3f)(G)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,u.$Vf)(O)),O=`/${O}`);const Z=a.URI.from({scheme:p.Schemas.vscodeRemote,authority:j,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,ae.$qi)(O))return N.forceOpenWorkspaceAsFile?{fileUri:Z,options:{selection:B?{startLineNumber:B,startColumn:T||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,oe.$y8b)(Z),remoteAuthority:j};if(N.gotoLineMode||l.$fc.basename(O).indexOf(".")!==-1)return{fileUri:Z,options:{selection:B?{startLineNumber:B,startColumn:T||1}:void 0},remoteAuthority:j}}return{workspace:(0,oe.$z8b)(Z),remoteAuthority:j}}lb(O){const N=this.G.getValue("window"),G=N?.openFoldersInNewWindow||"default",j=N?.openFilesInNewWindow||"off";let B=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(G==="on"||G==="off")&&(B=G==="on");let T=!1;return O.forceNewWindow||O.forceReuseWindow?T=!!O.forceNewWindow&&!O.forceReuseWindow:($.$j?O.context===1&&(T=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(T=!0),!O.cli.extensionDevelopmentPath&&(j==="on"||j==="off")&&(T=j==="on")),{openFolderInNewWindow:!!B,openFilesInNewWindow:T}}async openExtensionDevelopmentHostWindow(O,N){const G=(0,x.$w8b)(this.getWindows(),O);if(G)return this.D.reload(G,N.cli),G.focus(),[G];let j=N.cli["folder-uri"]||[],B=N.cli["file-uri"]||[],T=N.cli._;if(!T.length&&!j.length&&!B.length&&!N.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,le=de?.workspace??de?.folderUri;le&&(a.URI.isUri(le)?le.scheme===p.Schemas.file?T=[le.fsPath]:j=[le.toString()]:le.configPath.scheme===p.Schemas.file?T=[(0,g.$pg)(le.configPath)]:B=[le.configPath.toString()])}let Z=N.remoteAuthority;for(const de of O)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const le=a.URI.parse(de),we=(0,E.$3k)(le);we&&(Z?(0,g.$Gg)(we,Z)||this.s.error("more than one extension development path authority"):Z=we)}T=T.filter(de=>{const le=a.URI.file(de);return(0,x.$v8b)(this.getWindows(),le)?!1:(0,g.$Gg)((0,E.$3k)(le),Z)}),j=j.filter(de=>{const le=this.cb(de);return le&&(0,x.$v8b)(this.getWindows(),le)?!1:le?(0,g.$Gg)((0,E.$3k)(le),Z):!1}),B=B.filter(de=>{const le=this.cb(de);return le&&(0,x.$v8b)(this.getWindows(),le)?!1:le?(0,g.$Gg)((0,E.$3k)(le),Z):!1}),N.cli._=T,N.cli["folder-uri"]=j,N.cli["file-uri"]=B;const he={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:!T.length&&!j.length&&!B.length,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:Z,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile};return this.open(he)}async mb(O){const N=this.G.getValue("window"),G=this.getLastActiveWindow(),j=G?.profile??this.C.defaultProfile;let B;!O.forceNewWindow&&!O.forceNewTabbedWindow&&(B=O.windowToUse||G,B&&B.focus());const T={...this.z.args,...O.cli,machineId:this.m,sqmId:this.n,windowId:-1,mainPid:process.pid,appRoot:this.z.appRoot,execPath:process.execPath,codeCachePath:this.z.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,l.$ic)(this.z.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.C.profilesHome,all:this.C.profiles,profile:j},homeDir:this.z.userHome.with({scheme:p.Schemas.file}).fsPath,tmpDir:this.z.tmpDir.with({scheme:p.Schemas.file}).fsPath,userDataDir:this.z.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.r,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToMerge:O.filesToOpen?.filesToMerge,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.t.getLogLevel(),loggers:{window:[],global:this.t.getRegisteredLoggers()},logsPath:this.z.logsHome.with({scheme:p.Schemas.file}).fsPath,product:D.default,isInitialStartup:O.initialStartup,perfMarks:(0,v.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},zoomLevel:typeof N?.zoomLevel=="number"?N.zoomLevel:void 0,autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.O.getColorScheme(),policiesData:this.w.serialize(),continueOn:this.z.continueOn};if(B){const Z=B.config;!T.extensionDevelopmentPath&&Z?.extensionDevelopmentPath&&(T.extensionDevelopmentPath=Z.extensionDevelopmentPath,T.extensionDevelopmentKind=Z.extensionDevelopmentKind,T["enable-proposed-api"]=Z["enable-proposed-api"],T.verbose=Z.verbose,T["inspect-extensions"]=Z["inspect-extensions"],T["inspect-brk-extensions"]=Z["inspect-brk-extensions"],T.debugId=Z.debugId,T.extensionEnvironment=Z.extensionEnvironment,T["extensions-dir"]=Z["extensions-dir"],T["disable-extensions"]=Z["disable-extensions"]),T.loggers={global:T.loggers.global,window:Z?.loggers.window??T.loggers.window}}else{const Z=this.j.getNewWindowState(T);(0,v.mark)("code/willCreateCodeWindow");const he=B=this.J.createInstance(F.$G8b,{state:Z,extensionDevelopmentPath:T.extensionDevelopmentPath,isExtensionTestHost:!!T.extensionTestsPath});(0,v.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(he),this.h.set(he.id,he),this.a.fire(he),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const de=new y.$Qc;de.add(he.onDidSignalReady(()=>this.b.fire(he))),de.add(d.Event.once(he.onDidClose)(()=>this.pb(he,de))),de.add(d.Event.once(he.onDidDestroy)(()=>this.c.fire(he))),de.add(he.onDidTriggerSystemContextMenu(({x:we,y:be})=>this.g.fire({window:he,x:we,y:be})));const le=(0,h.$Nf)(he.win?.webContents);le.removeAllListeners("devtools-reload-page"),le.on("devtools-reload-page",()=>this.D.reload(he)),this.D.registerWindow(he)}return T.windowId=B.id,B.isReady?this.D.unload(B,4).then(async Z=>{Z||await this.nb(B,T,O,j)}):await this.nb(B,T,O,j),B}async nb(O,N,G,j){if(N.extensionDevelopmentPath||((0,ae.$ai)(N.workspace)?N.backupPath=this.F.registerWorkspaceBackup({workspace:N.workspace,remoteAuthority:N.remoteAuthority}):(0,ae.$8h)(N.workspace)?N.backupPath=this.F.registerFolderBackup({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority}):N.backupPath=this.F.registerEmptyWindowBackup({backupFolder:G.emptyWindowBackupInfo?.backupFolder??(0,oe.$A8b)().id,remoteAuthority:N.remoteAuthority})),this.C.isEnabled()){const B=N.workspace??(0,ae.$_h)(N.backupPath,!1),T=this.ob(G,B,j),Z=T instanceof Promise?await T:T;N.profiles.profile=Z,N.extensionDevelopmentPath||await this.C.setProfileForWorkspace(B,Z)}O.load(N)}ob(O,N,G){return O.forceProfile?this.C.profiles.find(j=>j.name===O.forceProfile)??this.C.createNamedProfile(O.forceProfile):O.forceTempProfile?this.C.createTransientProfile():this.C.getProfileForWorkspace(N)??G}pb(O,N){this.h.delete(O.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),N.dispose()}getFocusedWindow(){const O=S.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.rb(this.getWindows())}qb(O){return this.rb(this.getWindows().filter(N=>(0,g.$Gg)(N.remoteAuthority,O)))}rb(O){return(0,U.$N8b)(O)}sendToFocused(O,...N){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(O,P.CancellationToken.None,...N)}sendToOpeningWindow(O,...N){this.B(d.Event.once(this.onDidSignalReadyWindow)(G=>{G.sendWhenReady(O,P.CancellationToken.None,...N)}))}sendToAll(O,N,G){for(const j of this.getWindows())G&&G.indexOf(j.id)>=0||j.sendWhenReady(O,P.CancellationToken.None,N)}getWindows(){return Array.from(this.h.values())}getWindowCount(){return this.h.size}getWindowById(O){return this.h.get(O)}getWindowByWebContents(O){const N=S.BrowserWindow.fromWebContents(O);if(N)return this.getWindowById(N.id)}};e.$M9b=ne,e.$M9b=ne=ve([te(3,m.$fj),te(4,W.$D8b),te(5,R.$QN),te(6,V.$qn),te(7,r.$07b),te(8,z.$f8b),te(9,c.$_7b),te(10,f.$q8b),te(11,i.$ri),te(12,ce.$i9b),te(13,Q.$B8b),te(14,n.$Wh),te(15,o.$r8b),te(16,t.$gk),te(17,I.$t8b),te(18,K.$l8b),te(19,H.$I8b)],ne)}),define(se[307],re([0,1,65,29,83,55]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O9b=void 0;let C=class{constructor(d,u,b,y){this.a=d,this.b=u,this.c=b,this.d=y,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(d,u){const b=this.b.getWindowById(d);if(b)return this.a.enterWorkspace(b,this.b.getWindows(),u)}createUntitledWorkspace(d,u,b){return this.a.createUntitledWorkspace(u,b)}deleteUntitledWorkspace(d,u){return this.a.deleteUntitledWorkspace(u)}getWorkspaceIdentifier(d,u){return this.a.getWorkspaceIdentifier(u)}getRecentlyOpened(d){return this.c.getRecentlyOpened()}addRecentlyOpened(d,u){return this.c.addRecentlyOpened(u)}removeRecentlyOpened(d,u){return this.c.removeRecentlyOpened(u)}clearRecentlyOpened(d){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$O9b=C,e.$O9b=C=ve([te(0,M.$B8b),te(1,A.$K8b),te(2,s.$i9b),te(3,S.$q8b)],C)}),define(se[308],re([0,1,15,131,36,28,18,50,14,33,3,44,47,2,13,9,4,12,7,32,158,42,159,110,290,162,65,283,17,200,91,132,53,116,220,24,63,94,209,293,211,212,213,16,224,93,78,6,92,219,299,284,291,20,5,305,70,26,59,294,95,34,275,82,122,27,251,253,52,49,265,288,300,289,301,127,267,268,269,272,297,60,29,306,274,30,97,83,307,55,39,233,54,244,51,81,129,277,292,280,8,255,276,228,68,296,271,23,125,295,263,239,72,64,303]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w,g,h,a,k,f,i,o,r,t,n,c,m,D,I,E,R,L,F,U,x,Y,ae,oe,ce,Q,K,V,z,W,H,q,_,ne,X,O,N,G,j,B,T,Z,he,de,le,we,be,Ee,Se,je,ke,pe,ee,ue,ge,Re,De,Fe,Me,Ve,ze,ie,fe,$e,ye,Ce,Ue,Le,We,qe,Ge,Xe,_e,Ye,it,st,rt,bt,pt,yt,vt,kt,Et,Pt,ot,dt,St,It,Rt,at,Ct,gt,ct,Dt,At,lt,Ot,ut,Mt){"use strict";var ht;Object.defineProperty(e,"__esModule",{value:!0}),e.$89b=void 0;let ft=class extends l.$Rc{static{ht=this}static{this.a={[v.Schemas.file]:"security.promptForLocalFileProtocolHandling",[v.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Pe,Ie,Oe,me,Ae,Be,He,Je,Ne,Te,Ke,Qe){super(),this.g=Pe,this.h=Ie,this.j=Oe,this.m=me,this.n=Ae,this.s=Be,this.t=He,this.u=Je,this.w=Ne,this.y=Te,this.z=Ke,this.C=Qe,this.D(),this.F()}D(){const Pe=Ne=>Ne?.startsWith(`${v.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((Ne,Te,Ke,Qe)=>Pe(Qe.requestingUrl)?Ke(Ie.has(Te)):Ke(!1)),S.session.defaultSession.setPermissionCheckHandler((Ne,Te,Ke,Qe)=>Pe(Qe.requestingUrl)?Ie.has(Te):!1);const Oe=new Set([v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemoteResource,v.Schemas.vscodeManagedRemoteResource,"devtools"]),me=Ne=>{for(let Te=Ne;Te;Te=Te.parent)if(Te.url.startsWith(`${v.Schemas.vscodeWebview}://`))return!0;return!1},Ae=Ne=>Ne.resourceType==="xhr"||me(Ne.frame),Be=Ne=>{const Te=Ne.frame;if(!Te||!this.b)return!1;const Ke=S.BrowserWindow.getAllWindows();for(const Qe of Ke)if(Te.processId===Qe.webContents.mainFrame.processId)return!0;return!1},He=(Ne,Te)=>{if(Ne.path!=="/index.html")return!0;const Ke=Te.frame;if(!Ke||!this.b)return!1;for(const Qe of this.b.getWindows())if(Qe.win&&Ke.processId===Qe.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((Ne,Te)=>{const Ke=h.URI.parse(Ne.url);return Ke.scheme===v.Schemas.vscodeWebview&&!He(Ke,Ne)?(this.m.error("Blocked vscode-webview request",Ne.url),Te({cancel:!0})):Ke.scheme===v.Schemas.vscodeFileResource&&!Be(Ne)?(this.m.error("Blocked vscode-file request",Ne.url),Te({cancel:!0})):Ke.path.endsWith(".svg")&&!Oe.has(Ke.scheme)?Te({cancel:!Ae(Ne)}):Te({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((Ne,Te)=>{const Ke=Ne.responseHeaders,Qe=Ke["content-type"]||Ke["Content-Type"];if(Qe&&Array.isArray(Qe)){const Ze=h.URI.parse(Ne.url);if(Ze.path.endsWith(".svg")&&Oe.has(Ze.scheme))return Ke["Content-Type"]=["image/svg+xml"],Te({cancel:!1,responseHeaders:Ke});if(!Ze.path.endsWith(v.Schemas.vscodeRemoteResource)&&Qe.some(et=>et.toLowerCase().includes("image/svg")))return Te({cancel:!Ae(Ne)})}return Te({cancel:!1})});const Je=S.session.defaultSession;typeof Je.setCodeCachePath=="function"&&this.s.codeCachePath&&Je.setCodeCachePath((0,$.$ic)(this.s.codeCachePath,"chrome")),w.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,A.disableUNCAccessRestrictions)():(0,A.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,d.setUnexpectedErrorHandler)(Oe=>this.H(Oe)),process.on("uncaughtException",Oe=>{(0,d.$Y)(Oe)||(0,d.$Z)(Oe)}),process.on("unhandledRejection",Oe=>(0,d.$Z)(Oe)),this.t.onWillShutdown(()=>this.dispose()),(0,k.$YT)(),S.app.on("accessibility-support-changed",(Oe,me)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",me)}),S.app.on("activate",async(Oe,me)=>{this.m.trace("app#activate"),me||await this.b?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(Oe,me)=>{(0,ut.$J8b)(me)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(me)),me.on("will-navigate",Ae=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ae.preventDefault()}),me.setWindowOpenHandler(Ae=>Ae.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow()}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ae.url}}`),this.f?.openExternal(void 0,Ae.url),{action:"deny"}))});let Pe=[],Ie;S.app.on("open-file",(Oe,me)=>{this.m.trace("app#open-file: ",me),Oe.preventDefault(),Pe.push((0,qe.$qi)(me)?{workspaceUri:h.URI.file(me)}:{fileUri:h.URI.file(me)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],Ie=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$XT.handle("vscode:fetchShellEnv",Oe=>{const me=this.b?.getWindowByWebContents(Oe.sender);let Ae,Be;return me?.config?(Ae=me.config,Be={...process.env,...me.config.userEnv}):(Ae=this.s.args,Be=process.env),this.X(Ae,Be,!1)}),s.$XT.handle("vscode:writeNlsFile",(Oe,me,Ae)=>{const Be=this.G([me]);if(!Be||typeof Ae!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(Be,C.$fe.fromString(Ae))}),s.$XT.handle("vscode:readNlsFile",async(Oe,...me)=>{const Ae=this.G(me);if(!Ae)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ae)).value.toString()}),s.$XT.on("vscode:toggleDevTools",Oe=>Oe.sender.toggleDevTools()),s.$XT.on("vscode:openDevTools",Oe=>Oe.sender.openDevTools()),s.$XT.on("vscode:reloadWindow",Oe=>Oe.sender.reload())}G(Pe){let Ie;for(const Oe of Pe)typeof Oe=="string"&&(typeof Ie!="string"?Ie=Oe:Ie=(0,$.$ic)(Ie,Oe));if(!(typeof Ie!="string"||!(0,$.$hc)(Ie)||!(0,u.$2f)(Ie,this.s.cachedLanguagesPath,!w.$k)))return h.URI.file(Ie)}H(Pe){if(Pe){const Ie={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.m.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.m.error(Pe.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Pe=this.z.win32AppUserModelId;w.$i&&Pe&&S.app.setAppUserModelId(Pe);try{w.$j&&this.u.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.m.error(Te)}const Ie=new i.$5T;this.t.onWillShutdown(Te=>{Te.reason===2&&Ie.dispose()}),this.m.trace("Resolving machine identifier...");const[Oe,me]=await Promise.all([(0,dt.$W9b)(this.w,this.m),(0,dt.$X9b)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Oe}`);const{sharedProcessReady:Ae,sharedProcessClient:Be}=this.P(Oe,me),He=await this.Q(Oe,me,Ae);this.B(He.createInstance(r.$O8b)),this.B(He.createInstance(Et.$S9b)),He.invokeFunction(Te=>this.R(Te,Ie,Be));const Je=await He.invokeFunction(Te=>this.I(Te,Ie));this.J(Ie),this.t.phase=2,await He.invokeFunction(Te=>this.S(Te,Je)),this.t.phase=3,this.U(),this.B(new ot.$_g(()=>{this.B((0,ot.$dh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Pe,Ie){const Oe=this.b=Pe.get(Ue.$K8b),me=Pe.get(Ve.$MU),Ae=this.f=Pe.get(T.$98b),Be=Pe.get(R.$r8b),He=this;me.registerHandler({async handleURL(Ze,et){return He.O(Oe,Be,me,Ze,et)}});const Je=this.B(new We.$N9b({onDidOpenMainWindow:Ae.onDidOpenMainWindow,onDidFocusMainWindow:Ae.onDidFocusMainWindow,getActiveWindowId:()=>Ae.getActiveWindowId(-1)})),Ne=new f.$Fh(Ze=>Je.getActiveClientId().then(et=>Ze===et)),Te=new ze.$E9b(Ne,this.m),Ke=Ie.getChannel("urlHandler",Te);me.registerHandler(new ze.$D9b(Ke));const Qe=await this.L(Oe,Be);return this.B(new fe.$F9b(Qe?.urls,me,Oe,this.s,this.z,this.m)),Qe}J(Pe){const Ie=()=>({statusCode:404,data:"Not found"}),Oe=new Ot.$U(()=>Pe.getChannel(lt.$59b,new lt.$69b));S.protocol.registerBufferProtocol(v.Schemas.vscodeManagedRemoteResource,(me,Ae)=>{const Be=h.URI.parse(me.url);if(!Be.authority.startsWith("window:"))return Ae(Ie());Oe.value.call(lt.$49b,[Be]).then(He=>Ae({...He,data:Buffer.from(He.body,"base64")}),He=>{this.m.warn("error dispatching remote resource call",He),Ae({statusCode:500,data:String(He)})})})}async L(Pe,Ie){const Oe=this.s.args["open-url"]?this.s.args._urls||[]:[];Oe.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Oe);const me=global.getOpenUrls()||[];if(me.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",me),Oe.length+me.length===0)return;const Ae=[...Oe,...me].map(Je=>{try{return{uri:h.URI.parse(Je),originalUrl:Je}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Je);return}}),Be=[],He=[];for(const Je of Ae){if(!Je)continue;const Ne=this.N(Je.uri);if(Ne)if(await this.M(Ne,Pe,Ie)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Je.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Je.uri.toString(!0),Ne),Be.push(Ne);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Je.uri.toString(!0)),He.push(Je)}return{urls:He,openables:Be}}async M(Pe,Ie,Oe){let me,Ae;if((0,Ce.$qC)(Pe)?(me=Pe.workspaceUri,Ae=(0,t.localize)(0,null,me.scheme===v.Schemas.file?(0,p.$Av)(me,{os:w.OS,tildify:this.s}):me.toString(!0),this.z.nameShort)):(0,Ce.$rC)(Pe)?(me=Pe.folderUri,Ae=(0,t.localize)(1,null,me.scheme===v.Schemas.file?(0,p.$Av)(me,{os:w.OS,tildify:this.s}):me.toString(!0),this.z.nameShort)):(me=Pe.fileUri,Ae=(0,t.localize)(2,null,me.scheme===v.Schemas.file?(0,p.$Av)(me,{os:w.OS,tildify:this.s}):me.toString(!0),this.z.nameShort)),me.scheme!==v.Schemas.file&&me.scheme!==v.Schemas.vscodeRemote||this.u.getValue(ht.a[me.scheme])===!1)return!1;const{response:He,checkboxChecked:Je}=await Oe.showMessageBox({type:"warning",buttons:[(0,t.localize)(3,null),(0,t.localize)(4,null)],message:Ae,detail:(0,t.localize)(5,null),checkboxLabel:me.scheme===v.Schemas.file?(0,t.localize)(6,null):(0,t.localize)(7,null),cancelId:1});if(He!==0)return!0;if(Je){const Ne={channel:"vscode:disablePromptForProtocolHandling",args:me.scheme===v.Schemas.file?"local":"remote"};Ie.sendToFocused(Ne.channel,Ne.args),Ie.sendToOpeningWindow(Ne.channel,Ne.args)}return!1}N(Pe){if(Pe.path){if(Pe.authority===v.Schemas.file){const Ie=h.URI.file(Pe.fsPath);return(0,qe.$qi)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(Pe.authority===v.Schemas.vscodeRemote){const Ie=Pe.path.indexOf($.$fc.sep,1);if(Ie!==-1){const Oe=Pe.path.substring(1,Ie),me=Pe.path.substring(Ie);let Ae=Pe.query;const Be=new URLSearchParams(Pe.query);Be.get("windowId")==="_blank"&&(Be.delete("windowId"),Ae=Be.toString());const He=h.URI.from({scheme:v.Schemas.vscodeRemote,authority:Oe,path:me,query:Ae,fragment:Pe.fragment});return(0,qe.$qi)(me)?{workspaceUri:He}:/:[\d]+$/.test(me)?{fileUri:He}:{folderUri:He}}}}}async O(Pe,Ie,Oe,me,Ae){this.m.trace("app#handleProtocolUrl():",me.toString(!0),Ae),me.scheme===this.z.urlProtocol&&me.path==="workspace"&&(me=me.with({authority:"file",path:h.URI.parse(me.query).path,query:""}));let Be=!1;const He=new URLSearchParams(me.query);He.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",me.toString(!0)),He.delete("windowId"),me=me.with({query:He.toString()}),Be=!0):w.$j&&Pe.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",me.toString(!0)),Be=!0);const Je=He.get("continueOn");Je!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",me.toString(!0)),He.delete("continueOn"),me=me.with({query:He.toString()}),this.s.continueOn=Je??void 0);const Ne=this.N(me);return Ne?await this.M(Ne,Pe,Ie)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",me.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Ne,me.toString(!0)),(0,gt.$Nb)(await Pe.open({context:5,cli:{...this.s.args},urisToOpen:[Ne],forceNewWindow:Be,gotoLineMode:!0}))?.focus(),!0):Be?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",me.toString(!0)),await(0,gt.$Nb)(await Pe.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,he.$3k)(me)}))?.ready(),Oe.open(me,Ae)):(this.m.trace("app#handleProtocolUrl(): not handled",me.toString(!0),Ae),!1)}P(Pe,Ie){const Oe=this.B(this.j.createInstance(de.$q9b,Pe,Ie)),me=(async()=>{this.m.trace("Main->SharedProcess#connect");const Be=await Oe.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$6T(Be,"main")})();return{sharedProcessReady:(async()=>(await Oe.whenReady(),me))(),sharedProcessClient:me}}async Q(Pe,Ie,Oe){const me=new _.$Vh;switch(process.platform){case"win32":me.set(ue.$WU,new H.$Uh(Me.$B9b));break;case"linux":w.$l?me.set(ue.$WU,new H.$Uh(Fe.$A9b,[process.env.SNAP,process.env.SNAP_REVISION])):me.set(ue.$WU,new H.$Uh(De.$z9b));break;case"darwin":me.set(ue.$WU,new H.$Uh(Re.$y9b));break}me.set(Ue.$K8b,new H.$Uh(Le.$M9b,[Pe,Ie,this.h],!1)),me.set(ut.$I8b,new H.$Uh(Mt.$79b,void 0,!1));const Ae=new R.$s8b(this.m,this.z);me.set(R.$r8b,Ae),me.set(N.$c9b,new H.$Uh(N.$d9b,void 0,!1)),me.set(E.$U8b,new H.$Uh(E.$V8b,void 0,!1)),me.set(I.$ym,f.ProxyChannel.toService((0,f.$Dh)(Oe.then(Te=>Te.getChannel("diagnostics"))))),me.set(ne.$ayb,new H.$Uh(X.$$8b,[this.h])),me.set(L.$GU,new H.$Uh(F.$W8b)),me.set(O.$_8b,new H.$Uh(O.$a9b)),me.set(T.$98b,new H.$Uh(T.$08b,void 0,!1)),me.set($e.$G9b,new H.$Uh(ye.$I9b)),me.set(B.$l9b,new H.$Uh(B.$m9b)),me.set(ae.$X8b,new H.$Uh(oe.$Z8b)),me.set(Ee.$h8b,new H.$Uh(Ee.$i8b)),me.set(Ee.$j8b,new H.$Uh(Ee.$k8b));const Be=new Dt.$39b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),He=new At.$Dr(Be,this.u,this.m,this.n);me.set(ct.$er,He),w.$i?me.set(ce.$18b,new H.$Uh(Q.$28b)):w.$j?me.set(ce.$18b,new H.$Uh(Q.$38b)):w.$k&&me.set(ce.$18b,new H.$Uh(Q.$48b));const Je=new c.$P8b(this.s,this.u,this.m,this.w);me.set(n.$q8b,Je);const Ne=new Ye.$C8b(this.s,this.m,this.C,Je,Ae);if(me.set(Ye.$B8b,Ne),me.set(Ge.$afb,new H.$Uh(_e.$O9b,void 0,!1)),me.set(Xe.$i9b,new H.$Uh(Xe.$j9b,void 0,!1)),me.set(Ve.$MU,new H.$Uh(ie.$OU,void 0,!1)),(0,ee.$zo)(this.z,this.s)){const Te=(0,ee.$Eo)(this.z,this.u),Ke=(0,f.$Dh)(Oe.then(nt=>nt.getChannel("telemetryAppender"))),Qe=new ke.$t9b(Ke),Ze=(0,Se.$po)((0,M.release)(),(0,M.hostname)(),process.arch,this.z.commit,this.z.version,Pe,Ie,Te),et=(0,ee.$Fo)(this.s),tt={appenders:[Qe],commonProperties:Ze,piiPaths:et,sendErrorTelemetry:!0};me.set(je.$kl,new H.$Uh(pe.$9q,[tt],!1))}else me.set(je.$kl,ee.$to);return me.set(yt.$Cp,new H.$Uh(St.$XN,void 0,!0)),me.set(vt.$Gp,new H.$Uh(kt.$R9b,void 0,!0)),me.set(at.$19b,new H.$Uh(at.$29b,void 0,!0)),await ot.Promises.settled([Je.initialize(),Ne.initialize()]),this.j.createChild(me)}R(Pe,Ie,Oe){const me=this.B(new l.$Qc),Ae=f.ProxyChannel.fromService(Pe.get(N.$c9b),me,{disableMarshalling:!0});this.g.registerChannel("launch",Ae);const Be=f.ProxyChannel.fromService(Pe.get(E.$U8b),me,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Be);const He=new st.$P9b(Pe.get(it.$qn));Ie.registerChannel("policy",He),Oe.then(xe=>xe.registerChannel("policy",He));const Je=this.y.getProvider(v.Schemas.file);(0,g.$Mf)(Je instanceof W.$iq);const Ne=new z.$58b(Je,this.m,this.s);Ie.registerChannel(K.$GN,Ne),Oe.then(xe=>xe.registerChannel(K.$GN,Ne));const Te=f.ProxyChannel.fromService(Pe.get(rt.$f8b),me);Ie.registerChannel("userDataProfiles",Te),Oe.then(xe=>xe.registerChannel("userDataProfiles",Te));const Ke=new bt.$4q(Pe.get(pt.$1o));Oe.then(xe=>xe.registerChannel("request",Ke));const Qe=new ge.$u9b(Pe.get(ue.$WU));Ie.registerChannel("update",Qe);const Ze=f.ProxyChannel.fromService(Pe.get(ne.$ayb),me);Ie.registerChannel("issue",Ze);const et=f.ProxyChannel.fromService(Pe.get(L.$GU),me);Ie.registerChannel("encryption",et);const tt=f.ProxyChannel.fromService(Pe.get(le.$$k),me);Ie.registerChannel("sign",tt);const nt=f.ProxyChannel.fromService(Pe.get(O.$_8b),me);Ie.registerChannel("keyboardLayout",nt),this.f=Pe.get(T.$98b);const $t=f.ProxyChannel.fromService(this.f,me);Ie.registerChannel("nativeHost",$t),Oe.then(xe=>xe.registerChannel("nativeHost",$t));const Lt=f.ProxyChannel.fromService(Pe.get(Ge.$afb),me);Ie.registerChannel("workspaces",Lt);const jt=f.ProxyChannel.fromService(Pe.get(B.$l9b),me);Ie.registerChannel("menubar",jt);const Ft=f.ProxyChannel.fromService(Pe.get(Ve.$MU),me);Ie.registerChannel("url",Ft);const Ut=f.ProxyChannel.fromService(Pe.get($e.$G9b),me);Ie.registerChannel("webview",Ut);const mt=this.B(new be.$r9b(this.m,Pe.get(Ee.$h8b)));Ie.registerChannel("storage",mt),Oe.then(xe=>xe.registerChannel("storage",mt));const Nt=this.B(new Pt.$T9b(Pe.get(Ee.$h8b),Pe.get(rt.$f8b),this.m));Oe.then(xe=>xe.registerChannel("profileStorageListener",Nt));const Wt=f.ProxyChannel.fromService(Pe.get(ct.$er),me);Ie.registerChannel(ct.TerminalIpcChannels.LocalPty,Wt);const Tt=f.ProxyChannel.fromService(Pe.get(ce.$18b),me);Ie.registerChannel("externalTerminal",Tt);const wt=new It.$Y9b(Pe.get(Rt.$D8b));Ie.registerChannel("logger",wt),Oe.then(xe=>xe.registerChannel("logger",wt));const zt=new D.$Q8b(Pe.get(Ue.$K8b));Ie.registerChannel("extensionhostdebugservice",zt);const Bt=f.ProxyChannel.fromService(Pe.get(ae.$X8b),me);Ie.registerChannel(ae.$Y8b,Bt);const qt=f.ProxyChannel.fromService(Pe.get(at.$19b),me);Ie.registerChannel(Ct.$Z9b,qt)}async S(Pe,Ie){const Oe=this.b=Pe.get(Ue.$K8b);this.c=Pe.get(ut.$I8b);const me=(0,x.$Vl)(process.env)?0:4,Ae=this.s.args;if(Ie){if(Ie.openables.length>0)return Oe.open({context:me,cli:Ae,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const tt of Ie.urls){const nt=new URLSearchParams(tt.uri.query);if(nt.get("windowId")==="_blank")return nt.delete("windowId"),tt.originalUrl=tt.uri.toString(!0),tt.uri=tt.uri.with({query:nt.toString()}),Oe.open({context:me,cli:Ae,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Be=global.macOpenFiles,He=Ae._.length,Je=!!Ae["folder-uri"],Ne=!!Ae["file-uri"],Te=Ae["skip-add-to-recently-opened"]===!0,Ke=Ae.wait&&Ae.waitMarkerFilePath?h.URI.file(Ae.waitMarkerFilePath):void 0,Qe=Ae.remote||void 0,Ze=Ae.profile,et=Ae["profile-temp"];if(!He&&!Je&&!Ne){if(Ae["new-window"]||Ze||et)return Oe.open({context:me,cli:Ae,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Te,waitMarkerFileURI:Ke,initialStartup:!0,remoteAuthority:Qe,forceProfile:Ze,forceTempProfile:et});if(Be.length)return Oe.open({context:1,cli:Ae,urisToOpen:Be.map(tt=>(0,qe.$qi)(tt)?{workspaceUri:h.URI.file(tt)}:{fileUri:h.URI.file(tt)}),noRecentEntry:Te,waitMarkerFileURI:Ke,initialStartup:!0})}return Oe.open({context:me,cli:Ae,forceNewWindow:Ae["new-window"]||!He&&Ae["unity-launch"],diffMode:Ae.diff,mergeMode:Ae.merge,noRecentEntry:Te,waitMarkerFileURI:Ke,gotoLineMode:Ae.goto,initialStartup:!0,remoteAuthority:Qe,forceProfile:Ze,forceTempProfile:et})}U(){this.W(),S.protocol.registerHttpProtocol(v.Schemas.vscodeRemoteResource,(Pe,Ie)=>{Ie({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})}),this.X(this.s.args,process.env,!0),this.Y(),w.$j&&S.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Pe=this.z.win32MutexName;if(w.$i&&Pe)try{const Ie=await new Promise((me,Ae)=>{J(["@vscode/windows-mutex"],me,Ae)}),Oe=new Ie.Mutex(Pe);b.Event.once(this.t.onWillShutdown)(()=>Oe.release())}catch(Ie){this.m.error(Ie)}}async X(Pe,Ie,Oe){try{return await(0,Y.$2l)(this.u,this.m,Pe,Ie)}catch(me){const Ae=(0,P.$Ii)(me);Oe?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ae):this.m.error(Ae)}return{}}async Y(){try{const Ie=(await this.y.readFile(this.s.argvResource)).value.toString(),Oe=JSON.parse((0,y.$an)(Ie)),Ae=(0,ee.$Bo)(this.u)>=1;if(Oe["enable-crash-reporter"]===void 0){const Be=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ae},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,a.$kg)()}"`,"}"],He=Ie.substring(0,Ie.length-2).concat(`,
`,Be.join(`
`));await this.y.writeFile(this.s.argvResource,C.$fe.fromString(He))}else{const Be=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ae},`);Be!==Ie&&await this.y.writeFile(this.s.argvResource,C.$fe.fromString(Be))}}catch(Pe){this.m.error(Pe)}}};e.$89b=ft,e.$89b=ft=ht=ve([te(2,q.$Wh),te(3,j.$fj),te(4,j.$gj),te(5,U.$07b),te(6,G.$_7b),te(7,m.$ri),te(8,we.$QN),te(9,V.$gk),te(10,Z.$xj),te(11,rt.$f8b)],ft)}),define(se[313],re([0,1,15,46,7,23,8,50,14,33,3,47,13,9,67,4,35,25,21,42,99,308,10,17,238,250,24,63,202,16,222,93,78,218,92,20,225,5,79,26,80,278,126,287,51,286,95,249,34,52,69,54,39,234,232,2,40,266,68,227,115,121,270,264]),function(J,e,S,A,s,M,C,P,d,u,b,y,p,l,v,$,w,g,h,a,k,f,i,o,r,t,n,c,m,D,I,E,R,L,F,U,x,Y,ae,oe,ce,Q,K,V,z,W,H,q,_,ne,X,O,N,G,j,B,T,Z,he,de,le,we,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ee{main(){try{this.a()}catch(ke){console.error(ke.message),S.app.exit(1)}}async a(){(0,d.setUnexpectedErrorHandler)(Me=>console.error(Me));const[ke,pe,ee,ue,ge,Re,De,Fe]=this.b();try{try{await this.d(ee,Fe,ue,ge,De)}catch(Me){throw this.f(ee,De,Me),Me}await ke.invokeFunction(async Me=>{const Ve=Me.get(Y.$fj),ze=Me.get(U.$_7b),ie=Me.get(D.$gk),fe=Me.get(Y.$gj),$e=await this.e(Ve,ee,ze,ke,De,!0);return h.Promises.writeFile(ee.mainLockfile,String(process.pid)).catch(ye=>{Ve.warn(`app#startup(): Error writing main lockfile: ${ye.stack}`)}),Re.logger=fe.createLogger("main",{name:(0,i.localize)(0,null)}),b.Event.once(ze.onWillShutdown)(ye=>{ie.dispose(),ue.dispose(),ye.join("instanceLockfile",h.Promises.unlink(ee.mainLockfile).catch(()=>{}))}),ke.createInstance(f.$89b,$e,pe).startup()})}catch(Me){ke.invokeFunction(this.i,Me)}}b(){const ke=new F.$Vh,pe=new B.$Qc;process.once("exit",()=>pe.dispose());const ee={_serviceBrand:void 0,...ae.default};ke.set(oe.$xj,ee);const ue=new n.$$7b(this.j(),ee),ge=this.c(ue);ke.set(n.$07b,ue);const Re=new he.$E8b((0,Y.$tj)(ue),ue.logsHome);ke.set(he.$D8b,Re);const De=new x.$Q5b(Re.getLogLevel()),Fe=pe.add(new de.$YN(De,[new Y.$mj(Re.getLogLevel())]));ke.set(Y.$fj,Fe);const Me=new I.$Vp(Fe);ke.set(D.$gk,Me);const Ve=new E.$iq(Fe);Me.registerProvider(p.Schemas.file,Ve);const ze=new Z.$Hr(Me);ke.set(T.$Qk,ze);const ie=new we.$TN(1,ue,Fe,Me);ke.set(_.$PN,ie),ke.set(_.$QN,ie);const fe=new O.$g8b(ie,ze,ue,Me,Fe);ke.set(O.$f8b,fe),Me.registerProvider(p.Schemas.vscodeUserData,new be.$g0b(p.Schemas.file,Ve,p.Schemas.vscodeUserData,fe,ze,Fe));const $e=$.$i&&ee.win32RegValueName?pe.add(new G.$e0b(Fe,ee.win32RegValueName)):ue.policyFile?pe.add(new j.$f0b(ue.policyFile,Me,Fe)):new N.$sn;ke.set(N.$qn,$e);const ye=new r.$Sn(fe.defaultProfile.settingsResource,Me,$e,Fe);return ke.set(o.$ri,ye),ke.set(U.$_7b,new R.$Uh(U.$a8b,void 0,!1)),ke.set(z.$1o,new R.$Uh(W.$c0b,void 0,!0)),ke.set(X.$l8b,new R.$Uh(X.$m8b)),ke.set(H.$$k,new R.$Uh(q.$d0b,void 0,!1)),ke.set(K.$fv,new R.$Uh(V.$a0b)),ke.set(ce.$t8b,new Q.$09b(ue,fe,Fe)),[new L.$lq(ke,!0),ge,ue,ye,ie,De,ee,fe]}c(ke){const pe={VSCODE_IPC_HOOK:ke.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ee=>{const ue=process.env[ee];typeof ue=="string"&&(pe[ee]=ue)}),Object.assign(process.env,pe),pe}async d(ke,pe,ee,ue,ge){await C.Promises.settled([Promise.all([ke.extensionsPath,ke.codeCachePath,ke.logsHome.with({scheme:p.Schemas.file}).fsPath,pe.defaultProfile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,ke.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,ke.localHistoryHome.with({scheme:p.Schemas.file}).fsPath,ke.backupHome].map(Re=>Re?h.Promises.mkdir(Re,{recursive:!0}):void 0)),ue.init(),ee.initialize()]),pe.init()}async e(ke,pe,ee,ue,ge,Re){let De;try{(0,v.mark)("code/willStartMainServer"),De=await(0,k.$Sh)(pe.mainIPCHandle),(0,v.mark)("code/didStartMainServer"),b.Event.once(ee.onWillShutdown)(()=>De.dispose())}catch(Fe){if(Fe.code!=="EADDRINUSE")throw this.f(pe,ge,Fe),Fe;let Me;try{Me=await(0,k.$Th)(pe.mainIPCHandle,"main")}catch(fe){if(!Re||$.$i||fe.code!=="ECONNREFUSED")throw fe.code==="EPERM"&&this.g((0,i.localize)(1,null,ge.nameShort),(0,i.localize)(2,null),ge),fe;try{(0,A.unlinkSync)(pe.mainIPCHandle)}catch($e){throw ke.warn("Could not delete obsolete instance handle",$e),$e}return this.e(ke,pe,ee,ue,ge,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const fe=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw ke.error(fe),Me.dispose(),new Error(fe)}let Ve;!pe.args.wait&&!pe.args.status&&(Ve=setTimeout(()=>{this.g((0,i.localize)(3,null,ge.nameShort),(0,i.localize)(4,null),ge)},1e4));const ze=a.ProxyChannel.toService(Me.getChannel("launch"),{disableMarshalling:!0}),ie=a.ProxyChannel.toService(Me.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return ue.invokeFunction(async()=>{const fe=new t.$Or(ne.$to,ge),$e=await ie.getMainDiagnostics(),ye=await ie.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ce=await fe.getDiagnostics($e,ye);throw console.log(Ce),new d.$_});throw $.$i&&await this.h(ze,ke),ke.trace("Sending env to running instance..."),await ze.start(pe.args,process.env),Me.dispose(),Ve&&clearTimeout(Ve),new d.$_("Sent env to running instance. Terminating...")}if(pe.args.status)throw console.log((0,i.localize)(5,null,ge.nameShort)),new d.$_("Terminating...");return process.env.VSCODE_PID=String(process.pid),De}f(ke,pe,ee){if(ee.code==="EACCES"||ee.code==="EPERM"){const ue=(0,M.$Gb)([ke.userDataPath,ke.extensionsPath,k.$Oh]).map(ge=>(0,y.$Av)(s.URI.file(ge),{os:$.OS,tildify:ke}));this.g((0,i.localize)(6,null),(0,i.localize)(7,null,(0,P.$Ii)(ee),ue.join(`
`)),pe)}}g(ke,pe,ee){S.dialog.showMessageBoxSync((0,le.$Ov)({type:"warning",buttons:[(0,i.localize)(8,null)],message:ke,detail:pe},ee).options)}async h(ke,pe){if($.$i){const ee=await ke.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",ee);try{(await new Promise((ue,ge)=>{J(["windows-foreground-love"],ue,ge)})).allowSetForegroundWindow(ee)}catch(ue){pe.error(ue)}}}i(ke,pe){const ee=ke.get(Y.$fj),ue=ke.get(U.$_7b);let ge=0;pe&&(pe.isExpected?pe.message&&ee.trace(pe.message):(ge=1,pe.stack?ee.error(pe.stack):ee.error(`Startup error: ${pe.toString()}`))),ue.kill(ge)}j(){const ke=this.k((0,c.$Sl)(process.argv));if(ke.wait&&!ke.waitMarkerFilePath){const pe=(0,m.$99b)(ke.verbose);pe&&((0,c.$Ul)(process.argv,"--waitMarkerFilePath",pe),ke.waitMarkerFilePath=pe)}return ke}k(ke){if(ke["open-url"]&&(ke._urls=ke._,ke._=[]),!ke.remote){const pe=this.l(ke._,ke.goto);ke._=pe}return ke}l(ke,pe){const ee=(0,w.cwd)(),ue=ke.map(De=>{let Fe=String(De),Me;pe&&(Me=(0,u.$9f)(Fe),Fe=Me.path),Fe&&(Fe=this.m(ee,Fe));const Ve=(0,u.$4f)(Fe,ee),ze=(0,l.$mc)(Ve);return ze&&!(0,u.$Zf)(ze)?null:pe&&Me?(Me.path=Ve,this.n(Me)):Ve}),ge=$.$i||$.$j,Re=(0,M.$Lb)(ue,De=>De&&ge?De.toLowerCase():De||"");return(0,M.$Gb)(Re)}m(ke,pe){return $.$i&&(pe=(0,g.$Oe)(pe,'"')),pe=(0,g.$Me)((0,g.$Me)(pe," "),"	"),$.$i&&(pe=(0,l.$jc)(ke,pe),pe=(0,g.$Oe)(pe,".")),pe}n(ke){const pe=[ke.path];return typeof ke.line=="number"&&pe.push(String(ke.line)),typeof ke.column=="number"&&pe.push(String(ke.column)),pe.join(":")}}new Ee().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/da5ab29656a9f0bef63602fbce10968a7f4db2b5/core/vs/code/electron-main/main.js.map
