/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],$e=function(ae){for(var t=[],v=0,N=ae.length;v<N;v++)t[v]=be[ae[v]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:jt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:it,seal:ht,create:ri}=Object,{apply:Ft,construct:Nt}=typeof Reflect<"u"&&Reflect;Ft||(Ft=function(t,v,N){return t.apply(v,N)}),it||(it=function(t){return t}),ht||(ht=function(t){return t}),Nt||(Nt=function(t,v){return new t(...v)});const oi=at(Array.prototype.forEach),Ht=at(Array.prototype.pop),$t=at(Array.prototype.push),yt=at(String.prototype.toLowerCase),Rt=at(String.prototype.toString),li=at(String.prototype.match),ut=at(String.prototype.replace),ai=at(String.prototype.indexOf),hi=at(String.prototype.trim),ot=at(RegExp.prototype.test),pt=ui(TypeError);function at(ae){return function(t){for(var v=arguments.length,N=new Array(v>1?v-1:0),i=1;i<v;i++)N[i-1]=arguments[i];return Ft(ae,t,N)}}function ui(ae){return function(){for(var t=arguments.length,v=new Array(t),N=0;N<t;N++)v[N]=arguments[N];return Nt(ae,v)}}function He(ae,t,v){var N;v=(N=v)!==null&&N!==void 0?N:yt,jt&&jt(ae,null);let i=t.length;for(;i--;){let U=t[i];if(typeof U=="string"){const p=v(U);p!==U&&(ii(t)||(t[i]=p),U=p)}ae[U]=!0}return ae}function mt(ae){const t=ri(null);for(const[v,N]of zt(ae))t[v]=N;return t}function Et(ae,t){for(;ae!==null;){const N=si(ae,t);if(N){if(N.get)return at(N.get);if(typeof N.value=="function")return at(N.value)}ae=ni(ae)}function v(N){return console.warn("fallback value for",N),null}return v}const Ut=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Lt=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ot=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=it(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Tt=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=it(["#text"]),qt=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),It=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),_t=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),At=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ht(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ht(/<%[\w\W]*|[\w\W]*%>/gm),mi=ht(/\${[\w\W]*}/gm),bi=ht(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ht(/^aria-[\-\w]+$/),Vt=ht(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ht(/^(?:\w+script|data):/i),wi=ht(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Kt=ht(/^html$/i);var Qt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:Vt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Kt});const vi=()=>typeof window>"u"?null:window,Di=function(t,v){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let N=null;const i="data-tt-policy-suffix";v&&v.hasAttribute(i)&&(N=v.getAttribute(i));const U="dompurify"+(N?"#"+N:"");try{return t.createPolicy(U,{createHTML(p){return p},createScriptURL(p){return p}})}catch{return console.warn("TrustedTypes policy "+U+" could not be created."),null}};function xt(){let ae=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=Ie=>xt(Ie);if(t.version="3.0.5",t.removed=[],!ae||!ae.document||ae.document.nodeType!==9)return t.isSupported=!1,t;const v=ae.document,N=v.currentScript;let{document:i}=ae;const{DocumentFragment:U,HTMLTemplateElement:p,Node:D,Element:c,NodeFilter:g,NamedNodeMap:m=ae.NamedNodeMap||ae.MozNamedAttrMap,HTMLFormElement:T,DOMParser:n,trustedTypes:o}=ae,e=c.prototype,h=Et(e,"cloneNode"),a=Et(e,"nextSibling"),f=Et(e,"childNodes"),s=Et(e,"parentNode");if(typeof p=="function"){const Ie=i.createElement("template");Ie.content&&Ie.content.ownerDocument&&(i=Ie.content.ownerDocument)}let r,b="";const{implementation:u,createNodeIterator:l,createDocumentFragment:F,getElementsByTagName:z}=i,{importNode:L}=v;let d={};t.isSupported=typeof zt=="function"&&typeof s=="function"&&u&&u.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:y,ERB_EXPR:M,TMPLIT_EXPR:V,DATA_ATTR:x,ARIA_ATTR:R,IS_SCRIPT_OR_DATA:B,ATTR_WHITESPACE:j}=Qt;let{IS_ALLOWED_URI:ie}=Qt,te=null;const ue=He({},[...Ut,...Lt,...Ot,...Tt,...Wt]);let le=null;const oe=He({},[...qt,...It,..._t,...At]);let we=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Fe=null,ke=null,Le=!0,de=!0,ne=!1,ce=!0,Z=!1,q=!1,X=!1,C=!1,_=!1,$=!1,W=!1,Q=!0,w=!1;const A="user-content-";let E=!0,I=!1,k={},O=null;const S=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let P=null;const H=He({},["audio","video","img","source","image","track"]);let G=null;const ee=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),se="http://www.w3.org/1998/Math/MathML",me="http://www.w3.org/2000/svg",ve="http://www.w3.org/1999/xhtml";let Ne=ve,Ce=!1,De=null;const Te=He({},[se,me,ve],Rt);let Se;const Ve=["application/xhtml+xml","text/html"],je="text/html";let Me,Qe=null;const J=i.createElement("form"),he=function(fe){return fe instanceof RegExp||fe instanceof Function},pe=function(fe){if(!(Qe&&Qe===fe)){if((!fe||typeof fe!="object")&&(fe={}),fe=mt(fe),Se=Ve.indexOf(fe.PARSER_MEDIA_TYPE)===-1?Se=je:Se=fe.PARSER_MEDIA_TYPE,Me=Se==="application/xhtml+xml"?Rt:yt,te="ALLOWED_TAGS"in fe?He({},fe.ALLOWED_TAGS,Me):ue,le="ALLOWED_ATTR"in fe?He({},fe.ALLOWED_ATTR,Me):oe,De="ALLOWED_NAMESPACES"in fe?He({},fe.ALLOWED_NAMESPACES,Rt):Te,G="ADD_URI_SAFE_ATTR"in fe?He(mt(ee),fe.ADD_URI_SAFE_ATTR,Me):ee,P="ADD_DATA_URI_TAGS"in fe?He(mt(H),fe.ADD_DATA_URI_TAGS,Me):H,O="FORBID_CONTENTS"in fe?He({},fe.FORBID_CONTENTS,Me):S,Fe="FORBID_TAGS"in fe?He({},fe.FORBID_TAGS,Me):{},ke="FORBID_ATTR"in fe?He({},fe.FORBID_ATTR,Me):{},k="USE_PROFILES"in fe?fe.USE_PROFILES:!1,Le=fe.ALLOW_ARIA_ATTR!==!1,de=fe.ALLOW_DATA_ATTR!==!1,ne=fe.ALLOW_UNKNOWN_PROTOCOLS||!1,ce=fe.ALLOW_SELF_CLOSE_IN_ATTR!==!1,Z=fe.SAFE_FOR_TEMPLATES||!1,q=fe.WHOLE_DOCUMENT||!1,_=fe.RETURN_DOM||!1,$=fe.RETURN_DOM_FRAGMENT||!1,W=fe.RETURN_TRUSTED_TYPE||!1,C=fe.FORCE_BODY||!1,Q=fe.SANITIZE_DOM!==!1,w=fe.SANITIZE_NAMED_PROPS||!1,E=fe.KEEP_CONTENT!==!1,I=fe.IN_PLACE||!1,ie=fe.ALLOWED_URI_REGEXP||Vt,Ne=fe.NAMESPACE||ve,we=fe.CUSTOM_ELEMENT_HANDLING||{},fe.CUSTOM_ELEMENT_HANDLING&&he(fe.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(we.tagNameCheck=fe.CUSTOM_ELEMENT_HANDLING.tagNameCheck),fe.CUSTOM_ELEMENT_HANDLING&&he(fe.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(we.attributeNameCheck=fe.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),fe.CUSTOM_ELEMENT_HANDLING&&typeof fe.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(we.allowCustomizedBuiltInElements=fe.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),Z&&(de=!1),$&&(_=!0),k&&(te=He({},[...Wt]),le=[],k.html===!0&&(He(te,Ut),He(le,qt)),k.svg===!0&&(He(te,Lt),He(le,It),He(le,At)),k.svgFilters===!0&&(He(te,Ot),He(le,It),He(le,At)),k.mathMl===!0&&(He(te,Tt),He(le,_t),He(le,At))),fe.ADD_TAGS&&(te===ue&&(te=mt(te)),He(te,fe.ADD_TAGS,Me)),fe.ADD_ATTR&&(le===oe&&(le=mt(le)),He(le,fe.ADD_ATTR,Me)),fe.ADD_URI_SAFE_ATTR&&He(G,fe.ADD_URI_SAFE_ATTR,Me),fe.FORBID_CONTENTS&&(O===S&&(O=mt(O)),He(O,fe.FORBID_CONTENTS,Me)),E&&(te["#text"]=!0),q&&He(te,["html","head","body"]),te.table&&(He(te,["tbody"]),delete Fe.tbody),fe.TRUSTED_TYPES_POLICY){if(typeof fe.TRUSTED_TYPES_POLICY.createHTML!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof fe.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');r=fe.TRUSTED_TYPES_POLICY,b=r.createHTML("")}else r===void 0&&(r=Di(o,N)),r!==null&&typeof b=="string"&&(b=r.createHTML(""));it&&it(fe),Qe=fe}},Ee=He({},["mi","mo","mn","ms","mtext"]),Pe=He({},["foreignobject","desc","title","annotation-xml"]),Be=He({},["title","style","font","a","script"]),Ue=He({},Lt);He(Ue,Ot),He(Ue,ci);const Ze=He({},Tt);He(Ze,fi);const Je=function(fe){let Ae=s(fe);(!Ae||!Ae.tagName)&&(Ae={namespaceURI:Ne,tagName:"template"});const Re=yt(fe.tagName),We=yt(Ae.tagName);return De[fe.namespaceURI]?fe.namespaceURI===me?Ae.namespaceURI===ve?Re==="svg":Ae.namespaceURI===se?Re==="svg"&&(We==="annotation-xml"||Ee[We]):!!Ue[Re]:fe.namespaceURI===se?Ae.namespaceURI===ve?Re==="math":Ae.namespaceURI===me?Re==="math"&&Pe[We]:!!Ze[Re]:fe.namespaceURI===ve?Ae.namespaceURI===me&&!Pe[We]||Ae.namespaceURI===se&&!Ee[We]?!1:!Ze[Re]&&(Be[Re]||!Ue[Re]):!!(Se==="application/xhtml+xml"&&De[fe.namespaceURI]):!1},xe=function(fe){$t(t.removed,{element:fe});try{fe.parentNode.removeChild(fe)}catch{fe.remove()}},qe=function(fe,Ae){try{$t(t.removed,{attribute:Ae.getAttributeNode(fe),from:Ae})}catch{$t(t.removed,{attribute:null,from:Ae})}if(Ae.removeAttribute(fe),fe==="is"&&!le[fe])if(_||$)try{xe(Ae)}catch{}else try{Ae.setAttribute(fe,"")}catch{}},tt=function(fe){let Ae,Re;if(C)fe="<remove></remove>"+fe;else{const rt=li(fe,/^[\r\n\t ]+/);Re=rt&&rt[0]}Se==="application/xhtml+xml"&&Ne===ve&&(fe='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+fe+"</body></html>");const We=r?r.createHTML(fe):fe;if(Ne===ve)try{Ae=new n().parseFromString(We,Se)}catch{}if(!Ae||!Ae.documentElement){Ae=u.createDocument(Ne,"template",null);try{Ae.documentElement.innerHTML=Ce?b:We}catch{}}const et=Ae.body||Ae.documentElement;return fe&&Re&&et.insertBefore(i.createTextNode(Re),et.childNodes[0]||null),Ne===ve?z.call(Ae,q?"html":"body")[0]:q?Ae.documentElement:et},nt=function(fe){return l.call(fe.ownerDocument||fe,fe,g.SHOW_ELEMENT|g.SHOW_COMMENT|g.SHOW_TEXT,null,!1)},dt=function(fe){return fe instanceof T&&(typeof fe.nodeName!="string"||typeof fe.textContent!="string"||typeof fe.removeChild!="function"||!(fe.attributes instanceof m)||typeof fe.removeAttribute!="function"||typeof fe.setAttribute!="function"||typeof fe.namespaceURI!="string"||typeof fe.insertBefore!="function"||typeof fe.hasChildNodes!="function")},ft=function(fe){return typeof D=="object"?fe instanceof D:fe&&typeof fe=="object"&&typeof fe.nodeType=="number"&&typeof fe.nodeName=="string"},ct=function(fe,Ae,Re){d[fe]&&oi(d[fe],We=>{We.call(t,Ae,Re,Qe)})},gt=function(fe){let Ae;if(ct("beforeSanitizeElements",fe,null),dt(fe))return xe(fe),!0;const Re=Me(fe.nodeName);if(ct("uponSanitizeElement",fe,{tagName:Re,allowedTags:te}),fe.hasChildNodes()&&!ft(fe.firstElementChild)&&(!ft(fe.content)||!ft(fe.content.firstElementChild))&&ot(/<[/\w]/g,fe.innerHTML)&&ot(/<[/\w]/g,fe.textContent))return xe(fe),!0;if(!te[Re]||Fe[Re]){if(!Fe[Re]&&Ct(Re)&&(we.tagNameCheck instanceof RegExp&&ot(we.tagNameCheck,Re)||we.tagNameCheck instanceof Function&&we.tagNameCheck(Re)))return!1;if(E&&!O[Re]){const We=s(fe)||fe.parentNode,et=f(fe)||fe.childNodes;if(et&&We){const rt=et.length;for(let Ke=rt-1;Ke>=0;--Ke)We.insertBefore(h(et[Ke],!0),a(fe))}}return xe(fe),!0}return fe instanceof c&&!Je(fe)||(Re==="noscript"||Re==="noembed"||Re==="noframes")&&ot(/<\/no(script|embed|frames)/i,fe.innerHTML)?(xe(fe),!0):(Z&&fe.nodeType===3&&(Ae=fe.textContent,Ae=ut(Ae,y," "),Ae=ut(Ae,M," "),Ae=ut(Ae,V," "),fe.textContent!==Ae&&($t(t.removed,{element:fe.cloneNode()}),fe.textContent=Ae)),ct("afterSanitizeElements",fe,null),!1)},kt=function(fe,Ae,Re){if(Q&&(Ae==="id"||Ae==="name")&&(Re in i||Re in J))return!1;if(!(de&&!ke[Ae]&&ot(x,Ae))){if(!(Le&&ot(R,Ae))){if(!le[Ae]||ke[Ae]){if(!(Ct(fe)&&(we.tagNameCheck instanceof RegExp&&ot(we.tagNameCheck,fe)||we.tagNameCheck instanceof Function&&we.tagNameCheck(fe))&&(we.attributeNameCheck instanceof RegExp&&ot(we.attributeNameCheck,Ae)||we.attributeNameCheck instanceof Function&&we.attributeNameCheck(Ae))||Ae==="is"&&we.allowCustomizedBuiltInElements&&(we.tagNameCheck instanceof RegExp&&ot(we.tagNameCheck,Re)||we.tagNameCheck instanceof Function&&we.tagNameCheck(Re))))return!1}else if(!G[Ae]){if(!ot(ie,ut(Re,j,""))){if(!((Ae==="src"||Ae==="xlink:href"||Ae==="href")&&fe!=="script"&&ai(Re,"data:")===0&&P[fe])){if(!(ne&&!ot(B,ut(Re,j,"")))){if(Re)return!1}}}}}}return!0},Ct=function(fe){return fe.indexOf("-")>0},wt=function(fe){let Ae,Re,We,et;ct("beforeSanitizeAttributes",fe,null);const{attributes:rt}=fe;if(!rt)return;const Ke={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:le};for(et=rt.length;et--;){Ae=rt[et];const{name:lt,namespaceURI:vt}=Ae;if(Re=lt==="value"?Ae.value:hi(Ae.value),We=Me(lt),Ke.attrName=We,Ke.attrValue=Re,Ke.keepAttr=!0,Ke.forceKeepAttr=void 0,ct("uponSanitizeAttribute",fe,Ke),Re=Ke.attrValue,Ke.forceKeepAttr||(qe(lt,fe),!Ke.keepAttr))continue;if(!ce&&ot(/\/>/i,Re)){qe(lt,fe);continue}Z&&(Re=ut(Re,y," "),Re=ut(Re,M," "),Re=ut(Re,V," "));const St=Me(fe.nodeName);if(kt(St,We,Re)){if(w&&(We==="id"||We==="name")&&(qe(lt,fe),Re=A+Re),r&&typeof o=="object"&&typeof o.getAttributeType=="function"&&!vt)switch(o.getAttributeType(St,We)){case"TrustedHTML":{Re=r.createHTML(Re);break}case"TrustedScriptURL":{Re=r.createScriptURL(Re);break}}try{vt?fe.setAttributeNS(vt,lt,Re):fe.setAttribute(lt,Re),Ht(t.removed)}catch{}}}ct("afterSanitizeAttributes",fe,null)},Mt=function Ie(fe){let Ae;const Re=nt(fe);for(ct("beforeSanitizeShadowDOM",fe,null);Ae=Re.nextNode();)ct("uponSanitizeShadowNode",Ae,null),!gt(Ae)&&(Ae.content instanceof U&&Ie(Ae.content),wt(Ae));ct("afterSanitizeShadowDOM",fe,null)};return t.sanitize=function(Ie){let fe=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Ae,Re,We,et;if(Ce=!Ie,Ce&&(Ie="<!-->"),typeof Ie!="string"&&!ft(Ie))if(typeof Ie.toString=="function"){if(Ie=Ie.toString(),typeof Ie!="string")throw pt("dirty is not a string, aborting")}else throw pt("toString is not a function");if(!t.isSupported)return Ie;if(X||pe(fe),t.removed=[],typeof Ie=="string"&&(I=!1),I){if(Ie.nodeName){const lt=Me(Ie.nodeName);if(!te[lt]||Fe[lt])throw pt("root node is forbidden and cannot be sanitized in-place")}}else if(Ie instanceof D)Ae=tt("<!---->"),Re=Ae.ownerDocument.importNode(Ie,!0),Re.nodeType===1&&Re.nodeName==="BODY"||Re.nodeName==="HTML"?Ae=Re:Ae.appendChild(Re);else{if(!_&&!Z&&!q&&Ie.indexOf("<")===-1)return r&&W?r.createHTML(Ie):Ie;if(Ae=tt(Ie),!Ae)return _?null:W?b:""}Ae&&C&&xe(Ae.firstChild);const rt=nt(I?Ie:Ae);for(;We=rt.nextNode();)gt(We)||(We.content instanceof U&&Mt(We.content),wt(We));if(I)return Ie;if(_){if($)for(et=F.call(Ae.ownerDocument);Ae.firstChild;)et.appendChild(Ae.firstChild);else et=Ae;return(le.shadowroot||le.shadowrootmode)&&(et=L.call(v,et,!0)),et}let Ke=q?Ae.outerHTML:Ae.innerHTML;return q&&te["!doctype"]&&Ae.ownerDocument&&Ae.ownerDocument.doctype&&Ae.ownerDocument.doctype.name&&ot(Kt,Ae.ownerDocument.doctype.name)&&(Ke="<!DOCTYPE "+Ae.ownerDocument.doctype.name+`>
`+Ke),Z&&(Ke=ut(Ke,y," "),Ke=ut(Ke,M," "),Ke=ut(Ke,V," ")),r&&W?r.createHTML(Ke):Ke},t.setConfig=function(Ie){pe(Ie),X=!0},t.clearConfig=function(){Qe=null,X=!1},t.isValidAttribute=function(Ie,fe,Ae){Qe||pe({});const Re=Me(Ie),We=Me(fe);return kt(Re,We,Ae)},t.addHook=function(Ie,fe){typeof fe=="function"&&(d[Ie]=d[Ie]||[],$t(d[Ie],fe))},t.removeHook=function(Ie){if(d[Ie])return Ht(d[Ie])},t.removeHooks=function(Ie){d[Ie]&&(d[Ie]=[])},t.removeAllHooks=function(){d={}},t}var yi=xt();define("vs/base/browser/dompurify/dompurify",function(){return yi}),define(be[41],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EQ=t.$DQ=void 0;class v{constructor(p){this.domNode=p,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(p){const D=N(p);this.a!==D&&(this.a=D,this.domNode.style.maxWidth=this.a)}setWidth(p){const D=N(p);this.b!==D&&(this.b=D,this.domNode.style.width=this.b)}setHeight(p){const D=N(p);this.c!==D&&(this.c=D,this.domNode.style.height=this.c)}setTop(p){const D=N(p);this.d!==D&&(this.d=D,this.domNode.style.top=this.d)}setLeft(p){const D=N(p);this.e!==D&&(this.e=D,this.domNode.style.left=this.e)}setBottom(p){const D=N(p);this.f!==D&&(this.f=D,this.domNode.style.bottom=this.f)}setRight(p){const D=N(p);this.g!==D&&(this.g=D,this.domNode.style.right=this.g)}setPaddingTop(p){const D=N(p);this.h!==D&&(this.h=D,this.domNode.style.paddingTop=this.h)}setPaddingLeft(p){const D=N(p);this.i!==D&&(this.i=D,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(p){const D=N(p);this.j!==D&&(this.j=D,this.domNode.style.paddingBottom=this.j)}setPaddingRight(p){const D=N(p);this.k!==D&&(this.k=D,this.domNode.style.paddingRight=this.k)}setFontFamily(p){this.l!==p&&(this.l=p,this.domNode.style.fontFamily=this.l)}setFontWeight(p){this.m!==p&&(this.m=p,this.domNode.style.fontWeight=this.m)}setFontSize(p){const D=N(p);this.n!==D&&(this.n=D,this.domNode.style.fontSize=this.n)}setFontStyle(p){this.o!==p&&(this.o=p,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(p){this.p!==p&&(this.p=p,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(p){this.q!==p&&(this.q=p,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(p){this.r!==p&&(this.r=p,this.domNode.style.textDecoration=this.r)}setLineHeight(p){const D=N(p);this.s!==D&&(this.s=D,this.domNode.style.lineHeight=this.s)}setLetterSpacing(p){const D=N(p);this.t!==D&&(this.t=D,this.domNode.style.letterSpacing=this.t)}setClassName(p){this.u!==p&&(this.u=p,this.domNode.className=this.u)}toggleClassName(p,D){this.domNode.classList.toggle(p,D),this.u=this.domNode.className}setDisplay(p){this.v!==p&&(this.v=p,this.domNode.style.display=this.v)}setPosition(p){this.w!==p&&(this.w=p,this.domNode.style.position=this.w)}setVisibility(p){this.x!==p&&(this.x=p,this.domNode.style.visibility=this.x)}setColor(p){this.y!==p&&(this.y=p,this.domNode.style.color=this.y)}setBackgroundColor(p){this.z!==p&&(this.z=p,this.domNode.style.backgroundColor=this.z)}setLayerHinting(p){this.A!==p&&(this.A=p,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(p){this.C!==p&&(this.C=p,this.domNode.style.boxShadow=p)}setContain(p){this.B!==p&&(this.B=p,this.domNode.style.contain=this.B)}setAttribute(p,D){this.domNode.setAttribute(p,D)}removeAttribute(p){this.domNode.removeAttribute(p)}appendChild(p){this.domNode.appendChild(p.domNode)}removeChild(p){this.domNode.removeChild(p.domNode)}}t.$DQ=v;function N(U){return typeof U=="number"?`${U}px`:U}function i(U){return new v(U)}t.$EQ=i}),define(be[69],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VO=t.$UO=void 0;const v=new WeakMap;function N(D){if(!D.parent||D.parent===D)return null;try{const c=D.location,g=D.parent.location;if(c.origin!=="null"&&g.origin!=="null"&&c.origin!==g.origin)return null}catch{return null}return D.parent}class i{static a(c){let g=v.get(c);if(!g){g=[],v.set(c,g);let m=c,T;do T=N(m),T?g.push({window:new WeakRef(m),iframeElement:m.frameElement||null}):g.push({window:new WeakRef(m),iframeElement:null}),m=T;while(m)}return g.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(c,g){if(!g||c===g)return{top:0,left:0};let m=0,T=0;const n=this.a(c);for(const o of n){const e=o.window.deref();if(m+=e?.scrollY??0,T+=e?.scrollX??0,e===g||!o.iframeElement)break;const h=o.iframeElement.getBoundingClientRect();m+=h.top,T+=h.left}return{top:m,left:T}}}t.$UO=i;async function U(D,c){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const g=JSON.stringify({parentOrigin:D,salt:c}),T=new TextEncoder().encode(g),n=await crypto.subtle.digest("sha-256",T);return p(n)}t.$VO=U;function p(D){const g=Array.from(new Uint8Array(D)).map(m=>m.toString(16).padStart(2,"0")).join("");return BigInt(`0x${g}`).toString(32).padStart(52,"0")}}),define(be[70],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bR=t.$aR=t.$_Q=t.ListDragOverEffect=void 0;var v;(function(U){U[U.Copy=0]="Copy",U[U.Move=1]="Move"})(v||(t.ListDragOverEffect=v={})),t.$_Q={reject(){return{accept:!1}},accept(){return{accept:!0}}};class N extends Error{constructor(p,D){super(`ListError [${p}] ${D}`)}}t.$aR=N;class i{constructor(){this.c=new WeakMap}getHeight(p){return this.c.get(p)??this.d(p)}setDynamicHeight(p,D){D>0&&this.c.set(p,D)}}t.$bR=i}),define(be[71],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$Q=void 0;class v{constructor(i){this.a=i}splice(i,U,p){this.a.forEach(D=>D.splice(i,U,p))}}t.$$Q=v}),define(be[42],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JQ=void 0;const v=20;class N{constructor(U,p,D,c,g,m){this.a=Math.round(p),this.b=Math.round(D),this.c=Math.round(U),this.d=c,this.e=g,this.f=m,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new N(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(U){const p=Math.round(U);return this.d!==p?(this.d=p,this.m(),!0):!1}setScrollSize(U){const p=Math.round(U);return this.e!==p?(this.e=p,this.m(),!0):!1}setScrollPosition(U){const p=Math.round(U);return this.f!==p?(this.f=p,this.m(),!0):!1}setScrollbarSize(U){this.a=Math.round(U)}setOppositeScrollbarSize(U){this.b=Math.round(U)}static l(U,p,D,c,g){const m=Math.max(0,D-U),T=Math.max(0,m-2*p),n=c>0&&c>D;if(!n)return{computedAvailableSize:Math.round(m),computedIsNeeded:n,computedSliderSize:Math.round(T),computedSliderRatio:0,computedSliderPosition:0};const o=Math.round(Math.max(v,Math.floor(D*T/c))),e=(T-o)/(c-D),h=g*e;return{computedAvailableSize:Math.round(m),computedIsNeeded:n,computedSliderSize:Math.round(o),computedSliderRatio:e,computedSliderPosition:Math.round(h)}}m(){const U=N.l(this.b,this.c,this.d,this.e,this.f);this.g=U.computedAvailableSize,this.h=U.computedIsNeeded,this.i=U.computedSliderSize,this.j=U.computedSliderRatio,this.k=U.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(U){if(!this.h)return 0;const p=U-this.c-this.i/2;return Math.round(p/this.j)}getDesiredScrollPositionFromOffsetPaged(U){if(!this.h)return 0;const p=U-this.c;let D=this.f;return p<this.k?D-=this.d:D+=this.d,D}getDesiredScrollPositionFromDelta(U){if(!this.h)return 0;const p=this.k+U;return Math.round(p/this.j)}}t.$JQ=N}),define(be[25],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8S=t.$7S=t.$6S=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var v;(function(c){c[c.Hidden=0]="Hidden",c[c.Visible=1]="Visible",c[c.Recurse=2]="Recurse"})(v||(t.TreeVisibility=v={}));var N;(function(c){c[c.Expanded=0]="Expanded",c[c.Collapsed=1]="Collapsed",c[c.PreserveOrExpanded=2]="PreserveOrExpanded",c[c.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(N||(t.ObjectTreeElementCollapseState=N={}));var i;(function(c){c[c.Unknown=0]="Unknown",c[c.Twistie=1]="Twistie",c[c.Element=2]="Element",c[c.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var U;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(U||(t.TreeDragOverBubble=U={})),t.$6S={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(c=!1){return{accept:!0,bubble:0,autoExpand:c}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(c=!1){return{accept:!0,bubble:0,effect:0,autoExpand:c}}};class p extends Error{constructor(g,m){super(`TreeError [${g}] ${m}`)}}t.$7S=p;class D{constructor(g){this.a=g,this.b=new WeakMap}map(g){let m=this.b.get(g);return m||(m=this.a(g),this.b.set(g,m)),m}}t.$8S=D}),define(be[21],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zO=t.$window=t.$xO=t.$wO=void 0;function v(i,U){const p=i;typeof p.vscodeWindowId!="number"&&Object.defineProperty(p,"vscodeWindowId",{get:()=>U})}t.$wO=v,t.$xO=window,t.$window=t.$xO;function N(i){return i===t.$xO?!1:typeof i?.vscodeWindowId=="number"}t.$zO=N}),define(be[72],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=void 0;function v(h,a,f){const s=N(h,a);if(s!==-1)return h[s]}t.$eb=v;function N(h,a,f=h.length-1){for(let s=f;s>=0;s--){const r=h[s];if(a(r))return s}return-1}t.$fb=N;function i(h,a){const f=U(h,a);return f===-1?void 0:h[f]}t.$gb=i;function U(h,a,f=0,s=h.length){let r=f,b=s;for(;r<b;){const u=Math.floor((r+b)/2);a(h[u])?r=u+1:b=u}return r-1}t.$hb=U;function p(h,a){const f=D(h,a);return f===h.length?void 0:h[f]}t.$ib=p;function D(h,a,f=0,s=h.length){let r=f,b=s;for(;r<b;){const u=Math.floor((r+b)/2);a(h[u])?b=u:r=u+1}return r}t.$jb=D;function c(h,a,f=0,s=h.length){const r=D(h,a,f,s);return r===h.length?-1:r}t.$kb=c;class g{static{this.assertInvariants=!1}constructor(a){this.e=a,this.c=0}findLastMonotonous(a){if(g.assertInvariants){if(this.d){for(const s of this.e)if(this.d(s)&&!a(s))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=a}const f=U(this.e,a,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}t.$lb=g;function m(h,a){if(h.length===0)return;let f=h[0];for(let s=1;s<h.length;s++){const r=h[s];a(r,f)>0&&(f=r)}return f}t.$mb=m;function T(h,a){if(h.length===0)return;let f=h[0];for(let s=1;s<h.length;s++){const r=h[s];a(r,f)>=0&&(f=r)}return f}t.$nb=T;function n(h,a){return m(h,(f,s)=>-a(f,s))}t.$ob=n;function o(h,a){if(h.length===0)return-1;let f=0;for(let s=1;s<h.length;s++){const r=h[s];a(r,h[f])>0&&(f=s)}return f}t.$pb=o;function e(h,a){for(const f of h){const s=a(f);if(s!==void 0)return s}}t.$qb=e}),define(be[73],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$M=t.$L=t.$K=t.$J=void 0;function v(p,D){const c=Object.create(null);for(const g of p){const m=D(g);let T=c[m];T||(T=c[m]=[]),T.push(g)}return c}t.$J=v;function N(p,D){const c=[],g=[];for(const m of p)D.has(m)||c.push(m);for(const m of D)p.has(m)||g.push(m);return{removed:c,added:g}}t.$K=N;function i(p,D){const c=[],g=[];for(const[m,T]of p)D.has(m)||c.push(T);for(const[m,T]of D)p.has(m)||g.push(T);return{removed:c,added:g}}t.$L=i;function U(p,D){const c=new Set;for(const g of D)p.has(g)&&c.add(g);return c}t.$M=U}),define(be[74],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6s=t.$5s=t.$4s=t.$3s=void 0;function v(D,c){const g=Math.pow(10,c);return Math.round(D*g)/g}class N{constructor(c,g,m,T=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,m))|0,this.a=v(Math.max(Math.min(1,T),0),3)}static equals(c,g){return c.r===g.r&&c.g===g.g&&c.b===g.b&&c.a===g.a}}t.$3s=N;class i{constructor(c,g,m,T){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=v(Math.max(Math.min(1,g),0),3),this.l=v(Math.max(Math.min(1,m),0),3),this.a=v(Math.max(Math.min(1,T),0),3)}static equals(c,g){return c.h===g.h&&c.s===g.s&&c.l===g.l&&c.a===g.a}static fromRGBA(c){const g=c.r/255,m=c.g/255,T=c.b/255,n=c.a,o=Math.max(g,m,T),e=Math.min(g,m,T);let h=0,a=0;const f=(e+o)/2,s=o-e;if(s>0){switch(a=Math.min(f<=.5?s/(2*f):s/(2-2*f),1),o){case g:h=(m-T)/s+(m<T?6:0);break;case m:h=(T-g)/s+2;break;case T:h=(g-m)/s+4;break}h*=60,h=Math.round(h)}return new i(h,a,f,n)}static i(c,g,m){return m<0&&(m+=1),m>1&&(m-=1),m<1/6?c+(g-c)*6*m:m<1/2?g:m<2/3?c+(g-c)*(2/3-m)*6:c}static toRGBA(c){const g=c.h/360,{s:m,l:T,a:n}=c;let o,e,h;if(m===0)o=e=h=T;else{const a=T<.5?T*(1+m):T+m-T*m,f=2*T-a;o=i.i(f,a,g+1/3),e=i.i(f,a,g),h=i.i(f,a,g-1/3)}return new N(Math.round(o*255),Math.round(e*255),Math.round(h*255),n)}}t.$4s=i;class U{constructor(c,g,m,T){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=v(Math.max(Math.min(1,g),0),3),this.v=v(Math.max(Math.min(1,m),0),3),this.a=v(Math.max(Math.min(1,T),0),3)}static equals(c,g){return c.h===g.h&&c.s===g.s&&c.v===g.v&&c.a===g.a}static fromRGBA(c){const g=c.r/255,m=c.g/255,T=c.b/255,n=Math.max(g,m,T),o=Math.min(g,m,T),e=n-o,h=n===0?0:e/n;let a;return e===0?a=0:n===g?a=((m-T)/e%6+6)%6:n===m?a=(T-g)/e+2:a=(g-m)/e+4,new U(Math.round(a*60),h,n,c.a)}static toRGBA(c){const{h:g,s:m,v:T,a:n}=c,o=T*m,e=o*(1-Math.abs(g/60%2-1)),h=T-o;let[a,f,s]=[0,0,0];return g<60?(a=o,f=e):g<120?(a=e,f=o):g<180?(f=o,s=e):g<240?(f=e,s=o):g<300?(a=e,s=o):g<=360&&(a=o,s=e),a=Math.round((a+h)*255),f=Math.round((f+h)*255),s=Math.round((s+h)*255),new N(a,f,s,n)}}t.$5s=U;class p{static fromHex(c){return p.Format.CSS.parseHex(c)||p.red}static equals(c,g){return!c&&!g?!0:!c||!g?!1:c.equals(g)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:U.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof N)this.rgba=c;else if(c instanceof i)this.i=c,this.rgba=i.toRGBA(c);else if(c instanceof U)this.j=c,this.rgba=U.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&N.equals(this.rgba,c.rgba)&&i.equals(this.hsla,c.hsla)&&U.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=p.k(this.rgba.r),g=p.k(this.rgba.g),m=p.k(this.rgba.b),T=.2126*c+.7152*g+.0722*m;return v(T,4)}static k(c){const g=c/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(c){const g=this.getRelativeLuminance(),m=c.getRelativeLuminance();return g>m?(g+.05)/(m+.05):(m+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const g=this.getRelativeLuminance(),m=c.getRelativeLuminance();return g>m}isDarkerThan(c){const g=this.getRelativeLuminance(),m=c.getRelativeLuminance();return g<m}lighten(c){return new p(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new p(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:g,g:m,b:T,a:n}=this.rgba;return new p(new N(g,m,T,n*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new p(new N(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const g=c.rgba,m=this.rgba.a,T=g.a,n=m+T*(1-m);if(n<1e-6)return p.transparent;const o=this.rgba.r*m/n+g.r*T*(1-m)/n,e=this.rgba.g*m/n+g.g*T*(1-m)/n,h=this.rgba.b*m/n+g.b*T*(1-m)/n;return new p(new N(o,e,h,n))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:g,g:m,b:T,a:n}=this.rgba;return new p(new N(c.rgba.r-n*(c.rgba.r-g),c.rgba.g-n*(c.rgba.g-m),c.rgba.b-n*(c.rgba.b-T),1))}flatten(...c){const g=c.reduceRight((m,T)=>p.o(T,m));return p.o(this,g)}static o(c,g){const m=1-c.rgba.a;return new p(new N(m*g.rgba.r+c.rgba.a*c.rgba.r,m*g.rgba.g+c.rgba.a*c.rgba.g,m*g.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this.u||(this.u=p.Format.CSS.format(this)),this.u}static getLighterColor(c,g,m){if(c.isLighterThan(g))return c;m=m||.5;const T=c.getRelativeLuminance(),n=g.getRelativeLuminance();return m=m*(n-T)/n,c.lighten(m)}static getDarkerColor(c,g,m){if(c.isDarkerThan(g))return c;m=m||.5;const T=c.getRelativeLuminance(),n=g.getRelativeLuminance();return m=m*(T-n)/T,c.darken(m)}static{this.white=new p(new N(255,255,255,1))}static{this.black=new p(new N(0,0,0,1))}static{this.red=new p(new N(255,0,0,1))}static{this.blue=new p(new N(0,0,255,1))}static{this.green=new p(new N(0,255,0,1))}static{this.cyan=new p(new N(0,255,255,1))}static{this.lightgrey=new p(new N(211,211,211,1))}static{this.transparent=new p(new N(0,0,0,0))}}t.$6s=p,function(D){let c;(function(g){let m;(function(T){function n(l){return l.rgba.a===1?`rgb(${l.rgba.r}, ${l.rgba.g}, ${l.rgba.b})`:D.Format.CSS.formatRGBA(l)}T.formatRGB=n;function o(l){return`rgba(${l.rgba.r}, ${l.rgba.g}, ${l.rgba.b}, ${+l.rgba.a.toFixed(2)})`}T.formatRGBA=o;function e(l){return l.hsla.a===1?`hsl(${l.hsla.h}, ${(l.hsla.s*100).toFixed(2)}%, ${(l.hsla.l*100).toFixed(2)}%)`:D.Format.CSS.formatHSLA(l)}T.formatHSL=e;function h(l){return`hsla(${l.hsla.h}, ${(l.hsla.s*100).toFixed(2)}%, ${(l.hsla.l*100).toFixed(2)}%, ${l.hsla.a.toFixed(2)})`}T.formatHSLA=h;function a(l){const F=l.toString(16);return F.length!==2?"0"+F:F}function f(l){return`#${a(l.rgba.r)}${a(l.rgba.g)}${a(l.rgba.b)}`}T.formatHex=f;function s(l,F=!1){return F&&l.rgba.a===1?D.Format.CSS.formatHex(l):`#${a(l.rgba.r)}${a(l.rgba.g)}${a(l.rgba.b)}${a(Math.round(l.rgba.a*255))}`}T.formatHexA=s;function r(l){return l.isOpaque()?D.Format.CSS.formatHex(l):D.Format.CSS.formatRGBA(l)}T.format=r;function b(l){const F=l.length;if(F===0||l.charCodeAt(0)!==35)return null;if(F===7){const z=16*u(l.charCodeAt(1))+u(l.charCodeAt(2)),L=16*u(l.charCodeAt(3))+u(l.charCodeAt(4)),d=16*u(l.charCodeAt(5))+u(l.charCodeAt(6));return new D(new N(z,L,d,1))}if(F===9){const z=16*u(l.charCodeAt(1))+u(l.charCodeAt(2)),L=16*u(l.charCodeAt(3))+u(l.charCodeAt(4)),d=16*u(l.charCodeAt(5))+u(l.charCodeAt(6)),y=16*u(l.charCodeAt(7))+u(l.charCodeAt(8));return new D(new N(z,L,d,y/255))}if(F===4){const z=u(l.charCodeAt(1)),L=u(l.charCodeAt(2)),d=u(l.charCodeAt(3));return new D(new N(16*z+z,16*L+L,16*d+d))}if(F===5){const z=u(l.charCodeAt(1)),L=u(l.charCodeAt(2)),d=u(l.charCodeAt(3)),y=u(l.charCodeAt(4));return new D(new N(16*z+z,16*L+L,16*d+d,(16*y+y)/255))}return null}T.parseHex=b;function u(l){switch(l){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(m=g.CSS||(g.CSS={}))})(c=D.Format||(D.Format={}))}(p||(t.$6s=p={}))}),define(be[26],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rh=t.$qh=t.$ph=void 0;function v(p){return(D,c,g)=>{let m=null,T=null;if(typeof g.value=="function"?(m="value",T=g.value):typeof g.get=="function"&&(m="get",T=g.get),!T)throw new Error("not supported");g[m]=p(T,c)}}function N(p,D,c){let g=null,m=null;if(typeof c.value=="function"?(g="value",m=c.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(g="get",m=c.get),!m)throw new Error("not supported");const T=`$memoize$${D}`;c[g]=function(...n){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,n)}),this[T]}}t.$ph=N;function i(p,D,c){return v((g,m)=>{const T=`$debounce$${m}`,n=`$debounce$result$${m}`;return function(...o){this[n]||(this[n]=c?c():void 0),clearTimeout(this[T]),D&&(this[n]=D(this[n],...o),o=[this[n]]),this[T]=setTimeout(()=>{g.apply(this,o),this[n]=c?c():void 0},p)}})}t.$qh=i;function U(p,D,c){return v((g,m)=>{const T=`$throttle$timer$${m}`,n=`$throttle$result$${m}`,o=`$throttle$lastRun$${m}`,e=`$throttle$pending$${m}`;return function(...h){if(this[n]||(this[n]=c?c():void 0),(this[o]===null||this[o]===void 0)&&(this[o]=-Number.MAX_VALUE),D&&(this[n]=D(this[n],...h)),this[e])return;const a=this[o]+p;a<=Date.now()?(this[o]=Date.now(),g.apply(this,[this[n]]),this[n]=c?c():void 0):(this[e]=!0,this[T]=setTimeout(()=>{this[e]=!1,this[o]=Date.now(),g.apply(this,[this[n]]),this[n]=c?c():void 0},a-Date.now()))}})}t.$rh=U}),define(be[75],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Es=void 0;class v{constructor(i,U,p,D){this.originalStart=i,this.originalLength=U,this.modifiedStart=p,this.modifiedLength=D}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Es=v}),define(be[6],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.setUnexpectedErrorHandler=t.$W=t.$V=void 0;class v{constructor(){this.b=[],this.a=function(l){setTimeout(()=>{throw l.stack?r.isErrorNoTelemetry(l)?new r(l.message+`

`+l.stack):new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.b.push(l),()=>{this.d(l)}}c(l){this.b.forEach(F=>{F(l)})}d(l){this.b.splice(this.b.indexOf(l),1)}setUnexpectedErrorHandler(l){this.a=l}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(l){this.a(l),this.c(l)}onUnexpectedExternalError(l){this.a(l)}}t.$V=v,t.$W=new v;function N(u){t.$W.setUnexpectedErrorHandler(u)}t.setUnexpectedErrorHandler=N;function i(u){if(!u||typeof u!="object")return!1;const l=u;return l.code==="EPIPE"&&l.syscall?.toUpperCase()==="WRITE"}t.$Y=i;function U(u){g(u)||t.$W.onUnexpectedError(u)}t.$Z=U;function p(u){g(u)||t.$W.onUnexpectedExternalError(u)}t.$1=p;function D(u){if(u instanceof Error){const{name:l,message:F}=u,z=u.stacktrace||u.stack;return{$isError:!0,name:l,message:F,stack:z,noTelemetry:r.isErrorNoTelemetry(u)}}return u}t.$2=D;const c="Canceled";function g(u){return u instanceof m?!0:u instanceof Error&&u.name===c&&u.message===c}t.$3=g;class m extends Error{constructor(){super(c),this.name=this.message}}t.$4=m;function T(){const u=new Error(c);return u.name=u.message,u}t.$5=T;function n(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}t.$6=n;function o(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}t.$7=o;class e extends TypeError{constructor(l){super(l?`${l} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$8=e;function h(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}t.$9=h;class a extends Error{constructor(l){super("NotImplemented"),l&&(this.message=l)}}t.$0=a;class f extends Error{constructor(l){super("NotSupported"),l&&(this.message=l)}}t.$$=f;class s extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=s;class r extends Error{constructor(l){super(l),this.name="CodeExpectedError"}static fromError(l){if(l instanceof r)return l;const F=new r;return F.message=l.message,F.stack=l.stack,F}static isErrorNoTelemetry(l){return l.name==="CodeExpectedError"}}t.$ab=r;class b extends Error{constructor(l){super(l||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}t.$bb=b}),define(be[12],$e([1,0,6,72]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.CompareResult=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.top=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=void 0;function i(w,A=0){return w[w.length-(1+A)]}t.$rb=i;function U(w){if(w.length===0)throw new Error("Invalid tail call");return[w.slice(0,w.length-1),w[w.length-1]]}t.$sb=U;function p(w,A,E=(I,k)=>I===k){if(w===A)return!0;if(!w||!A||w.length!==A.length)return!1;for(let I=0,k=w.length;I<k;I++)if(!E(w[I],A[I]))return!1;return!0}t.$tb=p;function D(w,A){const E=w.length-1;A<E&&(w[A]=w[E]),w.pop()}t.$ub=D;function c(w,A,E){return g(w.length,I=>E(w[I],A))}t.$vb=c;function g(w,A){let E=0,I=w-1;for(;E<=I;){const k=(E+I)/2|0,O=A(k);if(O<0)E=k+1;else if(O>0)I=k-1;else return k}return-(E+1)}t.$wb=g;function m(w,A,E){if(w=w|0,w>=A.length)throw new TypeError("invalid index");const I=A[Math.floor(A.length*Math.random())],k=[],O=[],S=[];for(const P of A){const H=E(P,I);H<0?k.push(P):H>0?O.push(P):S.push(P)}return w<k.length?m(w,k,E):w<k.length+S.length?S[0]:m(w-(k.length+S.length),O,E)}t.$xb=m;function T(w,A){const E=[];let I;for(const k of w.slice(0).sort(A))!I||A(I[0],k)!==0?(I=[k],E.push(I)):I.push(k);return E}t.$yb=T;function*n(w,A){let E,I;for(const k of w)I!==void 0&&A(I,k)?E.push(k):(E&&(yield E),E=[k]),I=k;E&&(yield E)}t.$zb=n;function o(w,A){for(let E=0;E<=w.length;E++)A(E===0?void 0:w[E-1],E===w.length?void 0:w[E])}t.$Ab=o;function e(w,A){for(let E=0;E<w.length;E++)A(E===0?void 0:w[E-1],w[E],E+1===w.length?void 0:w[E+1])}t.$Bb=e;function h(w,A,E){const I=[];function k(P,H,G){if(H===0&&G.length===0)return;const ee=I[I.length-1];ee&&ee.start+ee.deleteCount===P?(ee.deleteCount+=H,ee.toInsert.push(...G)):I.push({start:P,deleteCount:H,toInsert:G})}let O=0,S=0;for(;;){if(O===w.length){k(O,0,A.slice(S));break}if(S===A.length){k(O,w.length-O,[]);break}const P=w[O],H=A[S],G=E(P,H);G===0?(O+=1,S+=1):G<0?(k(O,1,[]),O+=1):G>0&&(k(O,0,[H]),S+=1)}return I}t.$Cb=h;function a(w,A,E){const I=h(w,A,E),k=[],O=[];for(const S of I)k.push(...w.slice(S.start,S.start+S.deleteCount)),O.push(...S.toInsert);return{removed:k,added:O}}t.$Db=a;function f(w,A,E){if(E===0)return[];const I=w.slice(0,E).sort(A);return r(w,A,I,E,w.length),I}t.top=f;function s(w,A,E,I,k){return E===0?Promise.resolve([]):new Promise((O,S)=>{(async()=>{const P=w.length,H=w.slice(0,E).sort(A);for(let G=E,ee=Math.min(E+I,P);G<P;G=ee,ee=Math.min(ee+I,P)){if(G>E&&await new Promise(se=>setTimeout(se)),k&&k.isCancellationRequested)throw new v.$4;r(w,A,H,G,ee)}return H})().then(O,S)})}t.$Fb=s;function r(w,A,E,I,k){for(const O=E.length;I<k;I++){const S=w[I];if(A(S,E[O-1])<0){E.pop();const P=(0,N.$jb)(E,H=>A(S,H)<0);E.splice(P,0,S)}}}function b(w){return w.filter(A=>!!A)}t.$Gb=b;function u(w){let A=0;for(let E=0;E<w.length;E++)w[E]&&(w[A]=w[E],A+=1);w.length=A}t.$Hb=u;function l(w,A,E){w.splice(E,0,w.splice(A,1)[0])}t.$Ib=l;function F(w){return!Array.isArray(w)||w.length===0}t.$Jb=F;function z(w){return Array.isArray(w)&&w.length>0}t.$Kb=z;function L(w,A=E=>E){const E=new Set;return w.filter(I=>{const k=A(I);return E.has(k)?!1:(E.add(k),!0)})}t.$Lb=L;function d(w){const A=new Set;return E=>{const I=w(E);return A.has(I)?!1:(A.add(I),!0)}}t.$Mb=d;function y(w,A){return w.length>0?w[0]:A}t.$Nb=y;function M(w,A){return w.length>0?w[w.length-1]:A}t.$Ob=M;function V(w,A,E=(I,k)=>I===k){let I=0;for(let k=0,O=Math.min(w.length,A.length);k<O&&E(w[k],A[k]);k++)I++;return I}t.$Pb=V;function x(w){return[].concat(...w)}t.$Qb=x;function R(w,A){let E=typeof A=="number"?w:0;typeof A=="number"?E=w:(E=0,A=w);const I=[];if(E<=A)for(let k=E;k<A;k++)I.push(k);else for(let k=E;k>A;k--)I.push(k);return I}t.$Rb=R;function B(w,A,E){return w.reduce((I,k)=>(I[A(k)]=E?E(k):k,I),Object.create(null))}t.$Sb=B;function j(w,A){return w.push(A),()=>ie(w,A)}t.$Tb=j;function ie(w,A){const E=w.indexOf(A);if(E>-1)return w.splice(E,1),A}t.$Ub=ie;function te(w,A,E){const I=w.slice(0,A),k=w.slice(A);return I.concat(E,k)}t.$Vb=te;function ue(w,A){let E;if(typeof A=="number"){let I=A;E=()=>{const k=Math.sin(I++)*179426549;return k-Math.floor(k)}}else E=Math.random;for(let I=w.length-1;I>0;I-=1){const k=Math.floor(E()*(I+1)),O=w[I];w[I]=w[k],w[k]=O}}t.$Wb=ue;function le(w,A){const E=w.indexOf(A);E>-1&&(w.splice(E,1),w.unshift(A))}t.$Xb=le;function oe(w,A){const E=w.indexOf(A);E>-1&&(w.splice(E,1),w.push(A))}t.$Yb=oe;function we(w,A){for(const E of A)w.push(E)}t.$Zb=we;function Fe(w,A){return Array.isArray(w)?w.map(A):A(w)}t.$1b=Fe;function ke(w){return Array.isArray(w)?w:[w]}t.$2b=ke;function Le(w){return w[Math.floor(Math.random()*w.length)]}t.$3b=Le;function de(w,A,E){const I=ce(w,A),k=w.length,O=E.length;w.length=k+O;for(let S=k-1;S>=I;S--)w[S+O]=w[S];for(let S=0;S<O;S++)w[S+I]=E[S]}t.$4b=de;function ne(w,A,E,I){const k=ce(w,A);let O=w.splice(k,E);return O===void 0&&(O=[]),de(w,k,I),O}t.$5b=ne;function ce(w,A){return A<0?Math.max(A+w.length,0):Math.min(A,w.length)}var Z;(function(w){function A(O){return O<0}w.isLessThan=A;function E(O){return O<=0}w.isLessThanOrEqual=E;function I(O){return O>0}w.isGreaterThan=I;function k(O){return O===0}w.isNeitherLessOrGreaterThan=k,w.greaterThan=1,w.lessThan=-1,w.neitherLessOrGreaterThan=0})(Z||(t.CompareResult=Z={}));function q(w,A){return(E,I)=>A(w(E),w(I))}t.$6b=q;function X(...w){return(A,E)=>{for(const I of w){const k=I(A,E);if(!Z.isNeitherLessOrGreaterThan(k))return k}return Z.neitherLessOrGreaterThan}}t.$7b=X;const C=(w,A)=>w-A;t.$8b=C;const _=(w,A)=>(0,t.$8b)(w?1:0,A?1:0);t.$9b=_;function $(w){return(A,E)=>-w(A,E)}t.$0b=$;class W{constructor(A){this.g=A,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(A){let E=this.c;for(;E<this.g.length&&A(this.g[E]);)E++;const I=E===this.c?null:this.g.slice(this.c,E);return this.c=E,I}takeFromEndWhile(A){let E=this.d;for(;E>=0&&A(this.g[E]);)E--;const I=E===this.d?null:this.g.slice(E+1,this.d+1);return this.d=E,I}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const A=this.g[this.c];return this.c++,A}removeLast(){const A=this.g[this.d];return this.d--,A}takeCount(A){const E=this.g.slice(this.c,this.c+A);return this.c+=A,E}}t.$$b=W;class Q{static{this.empty=new Q(A=>{})}constructor(A){this.iterate=A}forEach(A){this.iterate(E=>(A(E),!0))}toArray(){const A=[];return this.iterate(E=>(A.push(E),!0)),A}filter(A){return new Q(E=>this.iterate(I=>A(I)?E(I):!0))}map(A){return new Q(E=>this.iterate(I=>E(A(I))))}some(A){let E=!1;return this.iterate(I=>(E=A(I),!E)),E}findFirst(A){let E;return this.iterate(I=>A(I)?(E=I,!1):!0),E}findLast(A){let E;return this.iterate(I=>(A(I)&&(E=I),!0)),E}findLastMaxBy(A){let E,I=!0;return this.iterate(k=>((I||Z.isGreaterThan(A(k,E)))&&(I=!1,E=k),!0)),E}}t.$_b=Q}),define(be[76],$e([1,0,6]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7c=t.$6c=t.$5c=t.$4c=t.ok=void 0;function N(c,g){if(!c)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}t.ok=N;function i(c,g="Unreachable"){throw new Error(g)}t.$4c=i;function U(c){if(!c)throw new v.$bb("Assertion Failed")}t.$5c=U;function p(c){if(!c()){debugger;c(),(0,v.$Z)(new v.$bb("Assertion Failed"))}}t.$6c=p;function D(c,g){let m=0;for(;m<c.length-1;){const T=c[m],n=c[m+1];if(!g(T,n))return!1;m++}return!0}t.$7c=D}),define(be[43],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=void 0;function v(N,i){const U=this;let p=!1,D;return function(){if(p)return D;if(p=!0,i)try{D=N.apply(U,arguments)}finally{i()}else D=N.apply(U,arguments);return D}}t.$cb=v}),define(be[77],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HM=t.$GM=void 0;class v{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.$GM=v,t.$HM=new v("id#")}),define(be[27],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var v;(function(N){function i(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}N.is=i;const U=Object.freeze([]);function p(){return U}N.empty=p;function*D(u){yield u}N.single=D;function c(u){return i(u)?u:D(u)}N.wrap=c;function g(u){return u||U}N.from=g;function*m(u){for(let l=u.length-1;l>=0;l--)yield u[l]}N.reverse=m;function T(u){return!u||u[Symbol.iterator]().next().done===!0}N.isEmpty=T;function n(u){return u[Symbol.iterator]().next().value}N.first=n;function o(u,l){for(const F of u)if(l(F))return!0;return!1}N.some=o;function e(u,l){for(const F of u)if(l(F))return F}N.find=e;function*h(u,l){for(const F of u)l(F)&&(yield F)}N.filter=h;function*a(u,l){let F=0;for(const z of u)yield l(z,F++)}N.map=a;function*f(...u){for(const l of u)for(const F of l)yield F}N.concat=f;function s(u,l,F){let z=F;for(const L of u)z=l(z,L);return z}N.reduce=s;function*r(u,l,F=u.length){for(l<0&&(l+=u.length),F<0?F+=u.length:F>u.length&&(F=u.length);l<F;l++)yield u[l]}N.slice=r;function b(u,l=Number.POSITIVE_INFINITY){const F=[];if(l===0)return[F,u];const z=u[Symbol.iterator]();for(let L=0;L<l;L++){const d=z.next();if(d.done)return[F,N.empty()];F.push(d.value)}return[F,{[Symbol.iterator](){return z}}]}N.consume=b})(v||(t.Iterable=v={}))}),define(be[44],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nq=t.KeyMod=t.KeyCodeUtils=t.$Mq=t.$Lq=t.$Kq=t.$Jq=t.$Iq=t.ScanCode=t.KeyCode=void 0;var v;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(v||(t.KeyCode=v={}));var N;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(N||(t.ScanCode=N={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,a){this._keyCodeToStr[h]=a,this._strToKeyCode[a.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const U=new i,p=new i,D=new i;t.$Iq=new Array(230),t.$Jq={};const c=[],g=Object.create(null),m=Object.create(null);t.$Kq={lowerCaseToEnum:e=>m[e]||0,toEnum:e=>g[e]||0,toString:e=>c[e]||"None"},t.$Lq=[],t.$Mq=[];for(let e=0;e<=193;e++)t.$Lq[e]=-1;for(let e=0;e<=132;e++)t.$Mq[e]=-1;(function(){const e="",h=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],a=[],f=[];for(const s of h){const[r,b,u,l,F,z,L,d,y]=s;if(f[b]||(f[b]=!0,c[b]=u,g[u]=b,m[u.toLowerCase()]=b,r&&(t.$Lq[b]=l,l!==0&&l!==3&&l!==5&&l!==4&&l!==6&&l!==57&&(t.$Mq[l]=b))),!a[l]){if(a[l]=!0,!F)throw new Error(`String representation missing for key code ${l} around scan code ${u}`);U.define(l,F),p.define(l,d||F),D.define(l,y||d||F)}z&&(t.$Iq[z]=l),L&&(t.$Jq[L]=l)}t.$Mq[3]=46})();var T;(function(e){function h(u){return U.keyCodeToStr(u)}e.toString=h;function a(u){return U.strToKeyCode(u)}e.fromString=a;function f(u){return p.keyCodeToStr(u)}e.toUserSettingsUS=f;function s(u){return D.keyCodeToStr(u)}e.toUserSettingsGeneral=s;function r(u){return p.strToKeyCode(u)||D.strToKeyCode(u)}e.fromUserSettings=r;function b(u){if(u>=98&&u<=113)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return U.keyCodeToStr(u)}e.toElectronAccelerator=b})(T||(t.KeyCodeUtils=T={}));var n;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(n||(t.KeyMod=n={}));function o(e,h){const a=(h&65535)<<16>>>0;return(e|a)>>>0}t.$Nq=o}),define(be[78],$e([1,0,6]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uq=t.$Tq=t.$Sq=t.$Rq=t.$Qq=t.$Pq=t.$Oq=void 0;var N;(function(T){T[T.CtrlCmd=2048]="CtrlCmd",T[T.Shift=1024]="Shift",T[T.Alt=512]="Alt",T[T.WinCtrl=256]="WinCtrl",T[T.KeyCode=255]="KeyCode"})(N||(N={}));function i(T,n){if(typeof T=="number"){if(T===0)return null;const o=(T&65535)>>>0,e=(T&4294901760)>>>16;return e!==0?new c([U(o,n),U(e,n)]):new c([U(o,n)])}else{const o=[];for(let e=0;e<T.length;e++)o.push(U(T[e],n));return new c(o)}}t.$Oq=i;function U(T,n){const o=!!(T&2048),e=!!(T&256),h=n===2?e:o,a=!!(T&1024),f=!!(T&512),s=n===2?o:e,r=T&255;return new p(h,a,f,s,r)}t.$Pq=U;class p{constructor(n,o,e,h,a){this.ctrlKey=n,this.shiftKey=o,this.altKey=e,this.metaKey=h,this.keyCode=a}equals(n){return n instanceof p&&this.ctrlKey===n.ctrlKey&&this.shiftKey===n.shiftKey&&this.altKey===n.altKey&&this.metaKey===n.metaKey&&this.keyCode===n.keyCode}getHashCode(){const n=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",e=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`K${n}${o}${e}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new c([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Qq=p;class D{constructor(n,o,e,h,a){this.ctrlKey=n,this.shiftKey=o,this.altKey=e,this.metaKey=h,this.scanCode=a}equals(n){return n instanceof D&&this.ctrlKey===n.ctrlKey&&this.shiftKey===n.shiftKey&&this.altKey===n.altKey&&this.metaKey===n.metaKey&&this.scanCode===n.scanCode}getHashCode(){const n=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",e=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`S${n}${o}${e}${h}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Rq=D;class c{constructor(n){if(n.length===0)throw(0,v.$6)("chords");this.chords=n}getHashCode(){let n="";for(let o=0,e=this.chords.length;o<e;o++)o!==0&&(n+=";"),n+=this.chords[o].getHashCode();return n}equals(n){if(n===null||this.chords.length!==n.chords.length)return!1;for(let o=0;o<this.chords.length;o++)if(!this.chords[o].equals(n.chords[o]))return!1;return!0}}t.$Sq=c;class g{constructor(n,o,e,h,a,f){this.ctrlKey=n,this.shiftKey=o,this.altKey=e,this.metaKey=h,this.keyLabel=a,this.keyAriaLabel=f}}t.$Tq=g;class m{}t.$Uq=m}),define(be[28],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U=void 0;class v{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$U=v}),define(be[45],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2c=void 0;class v{static{this.Undefined=new v(void 0)}constructor(U){this.element=U,this.next=v.Undefined,this.prev=v.Undefined}}class N{constructor(){this.a=v.Undefined,this.b=v.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===v.Undefined}clear(){let U=this.a;for(;U!==v.Undefined;){const p=U.next;U.prev=v.Undefined,U.next=v.Undefined,U=p}this.a=v.Undefined,this.b=v.Undefined,this.c=0}unshift(U){return this.d(U,!1)}push(U){return this.d(U,!0)}d(U,p){const D=new v(U);if(this.a===v.Undefined)this.a=D,this.b=D;else if(p){const g=this.b;this.b=D,D.prev=g,g.next=D}else{const g=this.a;this.a=D,D.next=g,g.prev=D}this.c+=1;let c=!1;return()=>{c||(c=!0,this.e(D))}}shift(){if(this.a!==v.Undefined){const U=this.a.element;return this.e(this.a),U}}pop(){if(this.b!==v.Undefined){const U=this.b.element;return this.e(this.b),U}}e(U){if(U.prev!==v.Undefined&&U.next!==v.Undefined){const p=U.prev;p.next=U.next,U.next.prev=p}else U.prev===v.Undefined&&U.next===v.Undefined?(this.a=v.Undefined,this.b=v.Undefined):U.next===v.Undefined?(this.b=this.b.prev,this.b.next=v.Undefined):U.prev===v.Undefined&&(this.a=this.a.next,this.a.prev=v.Undefined);this.c-=1}*[Symbol.iterator](){let U=this.a;for(;U!==v.Undefined;)yield U.element,U=U.next}}t.$2c=N}),define(be[32],$e([1,0]),function(ae,t){"use strict";var v,N,i;Object.defineProperty(t,"__esModule",{value:!0}),t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.$Bc=t.Touch=t.$Ac=t.$zc=t.$yc=t.$xc=t.$wc=void 0;function U(s,r,b){let u=s.get(r);return u===void 0&&(u=b,s.set(r,u)),u}t.$wc=U;function p(s){const r=[];return s.forEach((b,u)=>{r.push(`${u} => ${b}`)}),`Map(${s.size}) {${r.join(", ")}}`}t.$xc=p;function D(s){const r=[];return s.forEach(b=>{r.push(b)}),`Set(${s.size}) {${r.join(", ")}}`}t.$yc=D;class c{constructor(r,b){this.uri=r,this.value=b}}function g(s){return Array.isArray(s)}class m{static{this.a=r=>r.toString()}constructor(r,b){if(this[v]="ResourceMap",r instanceof m)this.b=new Map(r.b),this.c=b??m.a;else if(g(r)){this.b=new Map,this.c=b??m.a;for(const[u,l]of r)this.set(u,l)}else this.b=new Map,this.c=r??m.a}set(r,b){return this.b.set(this.c(r),new c(r,b)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,b){typeof b<"u"&&(r=r.bind(b));for(const[u,l]of this.b)r(l.value,l.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}t.$zc=m;class T{constructor(r,b){this[N]="ResourceSet",!r||typeof r=="function"?this.a=new m(r):(this.a=new m(b),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,b){this.a.forEach((u,l)=>r.call(b,l,l,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Ac=T;var n;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(n||(t.Touch=n={}));class o{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,b=0){const u=this.a.get(r);if(u)return b!==0&&this.j(u,b),u.value}set(r,b,u=0){let l=this.a.get(r);if(l)l.value=b,u!==0&&this.j(l,u);else{switch(l={key:r,value:b,next:void 0,previous:void 0},u){case 0:this.h(l);break;case 1:this.g(l);break;case 2:this.h(l);break;default:this.h(l);break}this.a.set(r,l),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const b=this.a.get(r);if(b)return this.a.delete(r),this.i(b),this.d--,b.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,b){const u=this.e;let l=this.b;for(;l;){if(b?r.bind(b)(l.value,l.key,this):r(l.value,l.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const r=this,b=this.e;let u=this.b;const l={[Symbol.iterator](){return l},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const F={value:u.key,done:!1};return u=u.next,F}else return{value:void 0,done:!0}}};return l}values(){const r=this,b=this.e;let u=this.b;const l={[Symbol.iterator](){return l},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const F={value:u.value,done:!1};return u=u.next,F}else return{value:void 0,done:!0}}};return l}entries(){const r=this,b=this.e;let u=this.b;const l={[Symbol.iterator](){return l},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const F={value:[u.key,u.value],done:!1};return u=u.next,F}else return{value:void 0,done:!0}}};return l}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let b=this.b,u=this.size;for(;b&&u>r;)this.a.delete(b.key),b=b.next,u--;this.b=b,this.d=u,b&&(b.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const b=r.next,u=r.previous;if(!b||!u)throw new Error("Invalid list");b.previous=u,u.next=b}r.next=void 0,r.previous=void 0,this.e++}j(r,b){if(!this.b||!this.c)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(r===this.b)return;const u=r.next,l=r.previous;r===this.c?(l.next=void 0,this.c=l):(u.previous=l,l.next=u),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(b===2){if(r===this.c)return;const u=r.next,l=r.previous;r===this.b?(u.previous=void 0,this.b=u):(u.previous=l,l.next=u),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((b,u)=>{r.push([u,b])}),r}fromJSON(r){this.clear();for(const[b,u]of r)this.set(b,u)}}t.$Bc=o;class e extends o{constructor(r,b=1){super(),this.k=r,this.l=Math.min(Math.max(0,b),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,b=2){return super.get(r,b)}peek(r){return super.get(r,0)}set(r,b){return super.set(r,b,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Cc=e;class h{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let b=this.a.get(r)||0;return b===0?!1:(b--,b===0?this.a.delete(r):this.a.set(r,b),!0)}has(r){return this.a.has(r)}}t.$Dc=h;class a{constructor(r){if(this.a=new Map,this.b=new Map,r)for(const[b,u]of r)this.set(b,u)}clear(){this.a.clear(),this.b.clear()}set(r,b){this.a.set(r,b),this.b.set(b,r)}get(r){return this.a.get(r)}getKey(r){return this.b.get(r)}delete(r){const b=this.a.get(r);return b===void 0?!1:(this.a.delete(r),this.b.delete(b),!0)}forEach(r,b){this.a.forEach((u,l)=>{r.call(b,u,l,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Ec=a;class f{constructor(){this.a=new Map}add(r,b){let u=this.a.get(r);u||(u=new Set,this.a.set(r,u)),u.add(b)}delete(r,b){const u=this.a.get(r);u&&(u.delete(b),u.size===0&&this.a.delete(r))}forEach(r,b){const u=this.a.get(r);u&&u.forEach(b)}get(r){const b=this.a.get(r);return b||new Set}}t.$Fc=f}),define(be[2],$e([1,0,12,73,32,43,27]),function(ae,t,v,N,i,U,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=void 0;const D=!1;let c=null;class g{constructor(){this.b=new Map}static{this.a=0}c(j){let ie=this.b.get(j);return ie||(ie={parent:null,source:null,isSingleton:!1,value:j,idx:g.a++},this.b.set(j,ie)),ie}trackDisposable(j){const ie=this.c(j);ie.source||(ie.source=new Error().stack)}setParent(j,ie){const te=this.c(j);te.parent=ie}markAsDisposed(j){this.b.delete(j)}markAsSingleton(j){this.c(j).isSingleton=!0}f(j,ie){const te=ie.get(j);if(te)return te;const ue=j.parent?this.f(this.c(j.parent),ie):j;return ie.set(j,ue),ue}getTrackedDisposables(){const j=new Map;return[...this.b.entries()].filter(([,te])=>te.source!==null&&!this.f(te,j).isSingleton).flatMap(([te])=>te)}computeLeakingDisposables(j=10,ie){let te;if(ie)te=ie;else{const Fe=new Map,ke=[...this.b.values()].filter(de=>de.source!==null&&!this.f(de,Fe).isSingleton);if(ke.length===0)return;const Le=new Set(ke.map(de=>de.value));if(te=ke.filter(de=>!(de.parent&&Le.has(de.parent))),te.length===0)throw new Error("There are cyclic diposable chains!")}if(!te)return;function ue(Fe){function ke(de,ne){for(;de.length>0&&ne.some(ce=>typeof ce=="string"?ce===de[0]:de[0].match(ce));)de.shift()}const Le=Fe.source.split(`
`).map(de=>de.trim().replace("at ","")).filter(de=>de!=="");return ke(Le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Le.reverse()}const le=new i.$Fc;for(const Fe of te){const ke=ue(Fe);for(let Le=0;Le<=ke.length;Le++)le.add(ke.slice(0,Le).join(`
`),Fe)}te.sort((0,v.$6b)(Fe=>Fe.idx,v.$8b));let oe="",we=0;for(const Fe of te.slice(0,j)){we++;const ke=ue(Fe),Le=[];for(let de=0;de<ke.length;de++){let ne=ke[de];ne=`(shared with ${le.get(ke.slice(0,de+1).join(`
`)).size}/${te.length} leaks) at ${ne}`;const Z=le.get(ke.slice(0,de).join(`
`)),q=(0,N.$J)([...Z].map(X=>ue(X)[de]),X=>X);delete q[ke[de]];for(const[X,C]of Object.entries(q))Le.unshift(`    - stacktraces of ${C.length} other leaks continue with ${X}`);Le.unshift(ne)}oe+=`


==================== Leaking disposable ${we}/${te.length}: ${Fe.value.constructor.name} ====================
${Le.join(`
`)}
============================================================

`}return te.length>j&&(oe+=`


... and ${te.length-j} more leaking disposables

`),{leaks:te,details:oe}}}t.$Gc=g;function m(B){c=B}if(t.$Hc=m,D){const B="__is_disposable_tracked__";m(new class{trackDisposable(j){const ie=new Error("Potentially leaked disposable").stack;setTimeout(()=>{j[B]||console.log(ie)},3e3)}setParent(j,ie){if(j&&j!==l.None)try{j[B]=!0}catch{}}markAsDisposed(j){if(j&&j!==l.None)try{j[B]=!0}catch{}}markAsSingleton(j){}})}function T(B){return c?.trackDisposable(B),B}t.$Ic=T;function n(B){c?.markAsDisposed(B)}t.$Jc=n;function o(B,j){c?.setParent(B,j)}function e(B,j){if(c)for(const ie of B)c.setParent(ie,j)}function h(B){return c?.markAsSingleton(B),B}t.$Kc=h;function a(B){return typeof B.dispose=="function"&&B.dispose.length===0}t.$Lc=a;function f(B){if(p.Iterable.is(B)){const j=[];for(const ie of B)if(ie)try{ie.dispose()}catch(te){j.push(te)}if(j.length===1)throw j[0];if(j.length>1)throw new AggregateError(j,"Encountered errors while disposing of store");return Array.isArray(B)?[]:B}else if(B)return B.dispose(),B}t.$Mc=f;function s(B){for(const j of B)a(j)&&j.dispose();return[]}t.$Nc=s;function r(...B){const j=b(()=>f(B));return e(B,j),j}t.$Oc=r;function b(B){const j=T({dispose:(0,U.$cb)(()=>{n(j),B()})});return j}t.$Pc=b;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,T(this)}dispose(){this.g||(n(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(j){if(!j)return j;if(j===this)throw new Error("Cannot register a disposable on itself!");return o(j,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(j),j}delete(j){if(j){if(j===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(j),j.dispose()}}deleteAndLeak(j){j&&this.f.has(j)&&(this.f.delete(j),o(j,null))}}t.$Qc=u;class l{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,T(this),o(this.q,this)}dispose(){n(this),this.q.dispose()}B(j){if(j===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(j)}}t.$Rc=l;class F{constructor(){this.b=!1,T(this)}get value(){return this.b?void 0:this.a}set value(j){this.b||j===this.a||(this.a?.dispose(),j&&o(j,this),this.a=j)}clear(){this.value=void 0}dispose(){this.b=!0,n(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const j=this.a;return this.a=void 0,j&&o(j,null),j}}t.$Sc=F;class z{constructor(j){this.a=new F,this.b=!1,this.a.value=j}get value(){return this.a.value}set value(j){this.b||j===this.a.value||(this.a.value=j)}dispose(){this.b=!0,this.a.dispose()}}t.$Tc=z;class L{constructor(j){this.b=j,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Uc=L;class d{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(j){let ie=j;return this.unset=()=>ie=void 0,this.isset=()=>ie!==void 0,this.dispose=()=>{ie&&(ie(),ie=void 0,n(this))},this}}t.$Vc=d;class y{constructor(){this.a=new Map}acquire(j,...ie){let te=this.a.get(j);te||(te={counter:0,object:this.b(j,...ie)},this.a.set(j,te));const{object:ue}=te,le=(0,U.$cb)(()=>{--te.counter===0&&(this.c(j,te.object),this.a.delete(j))});return te.counter++,{object:ue,dispose:le}}}t.$Wc=y;class M{constructor(j){this.a=j}async acquire(j,...ie){const te=this.a.acquire(j,...ie);try{return{object:await te.object,dispose:()=>te.dispose()}}catch(ue){throw te.dispose(),ue}}}t.$Xc=M;class V{constructor(j){this.object=j}dispose(){}}t.$Yc=V;function x(B){const j=new u;try{B(j)}finally{j.dispose()}}t.$Zc=x;class R{constructor(){this.a=new Map,this.b=!1,T(this)}dispose(){n(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(j){return this.a.has(j)}get size(){return this.a.size}get(j){return this.a.get(j)}set(j,ie,te=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),te||this.a.get(j)?.dispose(),this.a.set(j,ie)}deleteAndDispose(j){this.a.get(j)?.dispose(),this.a.delete(j)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$1c=R}),function(ae,t){typeof define=="function"&&define.amd?define(be[79],$e([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ae=typeof globalThis<"u"?globalThis:ae||self,t(ae.marked={}))}(this,function(ae){"use strict";function t(A,E){for(var I=0;I<E.length;I++){var k=E[I];k.enumerable=k.enumerable||!1,k.configurable=!0,"value"in k&&(k.writable=!0),Object.defineProperty(A,k.key,k)}}function v(A,E,I){return E&&t(A.prototype,E),I&&t(A,I),Object.defineProperty(A,"prototype",{writable:!1}),A}function N(A,E){if(A){if(typeof A=="string")return i(A,E);var I=Object.prototype.toString.call(A).slice(8,-1);if(I==="Object"&&A.constructor&&(I=A.constructor.name),I==="Map"||I==="Set")return Array.from(A);if(I==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(I))return i(A,E)}}function i(A,E){(E==null||E>A.length)&&(E=A.length);for(var I=0,k=new Array(E);I<E;I++)k[I]=A[I];return k}function U(A,E){var I=typeof Symbol<"u"&&A[Symbol.iterator]||A["@@iterator"];if(I)return(I=I.call(A)).next.bind(I);if(Array.isArray(A)||(I=N(A))||E&&A&&typeof A.length=="number"){I&&(A=I);var k=0;return function(){return k>=A.length?{done:!0}:{done:!1,value:A[k++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function p(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ae.defaults=p();function D(A){ae.defaults=A}var c=/[&<>"']/,g=/[&<>"']/g,m=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},o=function(E){return n[E]};function e(A,E){if(E){if(c.test(A))return A.replace(g,o)}else if(m.test(A))return A.replace(T,o);return A}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(A){return A.replace(h,function(E,I){return I=I.toLowerCase(),I==="colon"?":":I.charAt(0)==="#"?I.charAt(1)==="x"?String.fromCharCode(parseInt(I.substring(2),16)):String.fromCharCode(+I.substring(1)):""})}var f=/(^|[^\[])\^/g;function s(A,E){A=typeof A=="string"?A:A.source,E=E||"";var I={replace:function(O,S){return S=S.source||S,S=S.replace(f,"$1"),A=A.replace(O,S),I},getRegex:function(){return new RegExp(A,E)}};return I}var r=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(A,E,I){if(A){var k;try{k=decodeURIComponent(a(I)).replace(r,"").toLowerCase()}catch{return null}if(k.indexOf("javascript:")===0||k.indexOf("vbscript:")===0||k.indexOf("data:")===0)return null}E&&!b.test(I)&&(I=d(E,I));try{I=encodeURI(I).replace(/%25/g,"%")}catch{return null}return I}var l={},F=/^[^:]+:\/*[^/]*$/,z=/^([^:]+:)[\s\S]*$/,L=/^([^:]+:\/*[^/]*)[\s\S]*$/;function d(A,E){l[" "+A]||(F.test(A)?l[" "+A]=A+"/":l[" "+A]=x(A,"/",!0)),A=l[" "+A];var I=A.indexOf(":")===-1;return E.substring(0,2)==="//"?I?E:A.replace(z,"$1")+E:E.charAt(0)==="/"?I?E:A.replace(L,"$1")+E:A+E}var y={exec:function(){}};function M(A){for(var E=1,I,k;E<arguments.length;E++){I=arguments[E];for(k in I)Object.prototype.hasOwnProperty.call(I,k)&&(A[k]=I[k])}return A}function V(A,E){var I=A.replace(/\|/g,function(S,P,H){for(var G=!1,ee=P;--ee>=0&&H[ee]==="\\";)G=!G;return G?"|":" |"}),k=I.split(/ \|/),O=0;if(k[0].trim()||k.shift(),k.length>0&&!k[k.length-1].trim()&&k.pop(),k.length>E)k.splice(E);else for(;k.length<E;)k.push("");for(;O<k.length;O++)k[O]=k[O].trim().replace(/\\\|/g,"|");return k}function x(A,E,I){var k=A.length;if(k===0)return"";for(var O=0;O<k;){var S=A.charAt(k-O-1);if(S===E&&!I)O++;else if(S!==E&&I)O++;else break}return A.slice(0,k-O)}function R(A,E){if(A.indexOf(E[1])===-1)return-1;for(var I=A.length,k=0,O=0;O<I;O++)if(A[O]==="\\")O++;else if(A[O]===E[0])k++;else if(A[O]===E[1]&&(k--,k<0))return O;return-1}function B(A){A&&A.sanitize&&!A.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(A,E){if(E<1)return"";for(var I="";E>1;)E&1&&(I+=A),E>>=1,A+=A;return I+A}function ie(A,E,I,k){var O=E.href,S=E.title?e(E.title):null,P=A[1].replace(/\\([\[\]])/g,"$1");if(A[0].charAt(0)!=="!"){k.state.inLink=!0;var H={type:"link",raw:I,href:O,title:S,text:P,tokens:k.inlineTokens(P)};return k.state.inLink=!1,H}return{type:"image",raw:I,href:O,title:S,text:e(P)}}function te(A,E){var I=A.match(/^(\s+)(?:```)/);if(I===null)return E;var k=I[1];return E.split(`
`).map(function(O){var S=O.match(/^\s+/);if(S===null)return O;var P=S[0];return P.length>=k.length?O.slice(k.length):O}).join(`
`)}var ue=function(){function A(I){this.options=I||ae.defaults}var E=A.prototype;return E.space=function(k){var O=this.rules.block.newline.exec(k);if(O&&O[0].length>0)return{type:"space",raw:O[0]}},E.code=function(k){var O=this.rules.block.code.exec(k);if(O){var S=O[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:O[0],codeBlockStyle:"indented",text:this.options.pedantic?S:x(S,`
`)}}},E.fences=function(k){var O=this.rules.block.fences.exec(k);if(O){var S=O[0],P=te(S,O[3]||"");return{type:"code",raw:S,lang:O[2]?O[2].trim():O[2],text:P}}},E.heading=function(k){var O=this.rules.block.heading.exec(k);if(O){var S=O[2].trim();if(/#$/.test(S)){var P=x(S,"#");(this.options.pedantic||!P||/ $/.test(P))&&(S=P.trim())}return{type:"heading",raw:O[0],depth:O[1].length,text:S,tokens:this.lexer.inline(S)}}},E.hr=function(k){var O=this.rules.block.hr.exec(k);if(O)return{type:"hr",raw:O[0]}},E.blockquote=function(k){var O=this.rules.block.blockquote.exec(k);if(O){var S=O[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:O[0],tokens:this.lexer.blockTokens(S,[]),text:S}}},E.list=function(k){var O=this.rules.block.list.exec(k);if(O){var S,P,H,G,ee,se,me,ve,Ne,Ce,De,Te,Se=O[1].trim(),Ve=Se.length>1,je={type:"list",raw:"",ordered:Ve,start:Ve?+Se.slice(0,-1):"",loose:!1,items:[]};Se=Ve?"\\d{1,9}\\"+Se.slice(-1):"\\"+Se,this.options.pedantic&&(Se=Ve?Se:"[*+-]");for(var Me=new RegExp("^( {0,3}"+Se+")((?:[	 ][^\\n]*)?(?:\\n|$))");k&&(Te=!1,!(!(O=Me.exec(k))||this.rules.block.hr.test(k)));){if(S=O[0],k=k.substring(S.length),ve=O[2].split(`
`,1)[0],Ne=k.split(`
`,1)[0],this.options.pedantic?(G=2,De=ve.trimLeft()):(G=O[2].search(/[^ ]/),G=G>4?1:G,De=ve.slice(G),G+=O[1].length),se=!1,!ve&&/^ *$/.test(Ne)&&(S+=Ne+`
`,k=k.substring(Ne.length+1),Te=!0),!Te)for(var Qe=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),J=new RegExp("^ {0,"+Math.min(3,G-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),he=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:```|~~~)"),pe=new RegExp("^ {0,"+Math.min(3,G-1)+"}#");k&&(Ce=k.split(`
`,1)[0],ve=Ce,this.options.pedantic&&(ve=ve.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(he.test(ve)||pe.test(ve)||Qe.test(ve)||J.test(k)));){if(ve.search(/[^ ]/)>=G||!ve.trim())De+=`
`+ve.slice(G);else if(!se)De+=`
`+ve;else break;!se&&!ve.trim()&&(se=!0),S+=Ce+`
`,k=k.substring(Ce.length+1)}je.loose||(me?je.loose=!0:/\n *\n *$/.test(S)&&(me=!0)),this.options.gfm&&(P=/^\[[ xX]\] /.exec(De),P&&(H=P[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:S,task:!!P,checked:H,loose:!1,text:De}),je.raw+=S}je.items[je.items.length-1].raw=S.trimRight(),je.items[je.items.length-1].text=De.trimRight(),je.raw=je.raw.trimRight();var Ee=je.items.length;for(ee=0;ee<Ee;ee++){this.lexer.state.top=!1,je.items[ee].tokens=this.lexer.blockTokens(je.items[ee].text,[]);var Pe=je.items[ee].tokens.filter(function(Ue){return Ue.type==="space"}),Be=Pe.every(function(Ue){for(var Ze=Ue.raw.split(""),Je=0,xe=U(Ze),qe;!(qe=xe()).done;){var tt=qe.value;if(tt===`
`&&(Je+=1),Je>1)return!0}return!1});!je.loose&&Pe.length&&Be&&(je.loose=!0,je.items[ee].loose=!0)}return je}},E.html=function(k){var O=this.rules.block.html.exec(k);if(O){var S={type:"html",raw:O[0],pre:!this.options.sanitizer&&(O[1]==="pre"||O[1]==="script"||O[1]==="style"),text:O[0]};if(this.options.sanitize){var P=this.options.sanitizer?this.options.sanitizer(O[0]):e(O[0]);S.type="paragraph",S.text=P,S.tokens=this.lexer.inline(P)}return S}},E.def=function(k){var O=this.rules.block.def.exec(k);if(O){O[3]&&(O[3]=O[3].substring(1,O[3].length-1));var S=O[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:S,raw:O[0],href:O[2],title:O[3]}}},E.table=function(k){var O=this.rules.block.table.exec(k);if(O){var S={type:"table",header:V(O[1]).map(function(me){return{text:me}}),align:O[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:O[3]&&O[3].trim()?O[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(S.header.length===S.align.length){S.raw=O[0];var P=S.align.length,H,G,ee,se;for(H=0;H<P;H++)/^ *-+: *$/.test(S.align[H])?S.align[H]="right":/^ *:-+: *$/.test(S.align[H])?S.align[H]="center":/^ *:-+ *$/.test(S.align[H])?S.align[H]="left":S.align[H]=null;for(P=S.rows.length,H=0;H<P;H++)S.rows[H]=V(S.rows[H],S.header.length).map(function(me){return{text:me}});for(P=S.header.length,G=0;G<P;G++)S.header[G].tokens=this.lexer.inline(S.header[G].text);for(P=S.rows.length,G=0;G<P;G++)for(se=S.rows[G],ee=0;ee<se.length;ee++)se[ee].tokens=this.lexer.inline(se[ee].text);return S}}},E.lheading=function(k){var O=this.rules.block.lheading.exec(k);if(O)return{type:"heading",raw:O[0],depth:O[2].charAt(0)==="="?1:2,text:O[1],tokens:this.lexer.inline(O[1])}},E.paragraph=function(k){var O=this.rules.block.paragraph.exec(k);if(O){var S=O[1].charAt(O[1].length-1)===`
`?O[1].slice(0,-1):O[1];return{type:"paragraph",raw:O[0],text:S,tokens:this.lexer.inline(S)}}},E.text=function(k){var O=this.rules.block.text.exec(k);if(O)return{type:"text",raw:O[0],text:O[0],tokens:this.lexer.inline(O[0])}},E.escape=function(k){var O=this.rules.inline.escape.exec(k);if(O)return{type:"escape",raw:O[0],text:e(O[1])}},E.tag=function(k){var O=this.rules.inline.tag.exec(k);if(O)return!this.lexer.state.inLink&&/^<a /i.test(O[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(O[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(O[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(O[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:O[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(O[0]):e(O[0]):O[0]}},E.link=function(k){var O=this.rules.inline.link.exec(k);if(O){var S=O[2].trim();if(!this.options.pedantic&&/^</.test(S)){if(!/>$/.test(S))return;var P=x(S.slice(0,-1),"\\");if((S.length-P.length)%2===0)return}else{var H=R(O[2],"()");if(H>-1){var G=O[0].indexOf("!")===0?5:4,ee=G+O[1].length+H;O[2]=O[2].substring(0,H),O[0]=O[0].substring(0,ee).trim(),O[3]=""}}var se=O[2],me="";if(this.options.pedantic){var ve=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(se);ve&&(se=ve[1],me=ve[3])}else me=O[3]?O[3].slice(1,-1):"";return se=se.trim(),/^</.test(se)&&(this.options.pedantic&&!/>$/.test(S)?se=se.slice(1):se=se.slice(1,-1)),ie(O,{href:se&&se.replace(this.rules.inline._escapes,"$1"),title:me&&me.replace(this.rules.inline._escapes,"$1")},O[0],this.lexer)}},E.reflink=function(k,O){var S;if((S=this.rules.inline.reflink.exec(k))||(S=this.rules.inline.nolink.exec(k))){var P=(S[2]||S[1]).replace(/\s+/g," ");if(P=O[P.toLowerCase()],!P||!P.href){var H=S[0].charAt(0);return{type:"text",raw:H,text:H}}return ie(S,P,S[0],this.lexer)}},E.emStrong=function(k,O,S){S===void 0&&(S="");var P=this.rules.inline.emStrong.lDelim.exec(k);if(P&&!(P[3]&&S.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var H=P[1]||P[2]||"";if(!H||H&&(S===""||this.rules.inline.punctuation.exec(S))){var G=P[0].length-1,ee,se,me=G,ve=0,Ne=P[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ne.lastIndex=0,O=O.slice(-1*k.length+G);(P=Ne.exec(O))!=null;)if(ee=P[1]||P[2]||P[3]||P[4]||P[5]||P[6],!!ee){if(se=ee.length,P[3]||P[4]){me+=se;continue}else if((P[5]||P[6])&&G%3&&!((G+se)%3)){ve+=se;continue}if(me-=se,!(me>0)){if(se=Math.min(se,se+me+ve),Math.min(G,se)%2){var Ce=k.slice(1,G+P.index+se);return{type:"em",raw:k.slice(0,G+P.index+se+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var De=k.slice(2,G+P.index+se-1);return{type:"strong",raw:k.slice(0,G+P.index+se+1),text:De,tokens:this.lexer.inlineTokens(De)}}}}}},E.codespan=function(k){var O=this.rules.inline.code.exec(k);if(O){var S=O[2].replace(/\n/g," "),P=/[^ ]/.test(S),H=/^ /.test(S)&&/ $/.test(S);return P&&H&&(S=S.substring(1,S.length-1)),S=e(S,!0),{type:"codespan",raw:O[0],text:S}}},E.br=function(k){var O=this.rules.inline.br.exec(k);if(O)return{type:"br",raw:O[0]}},E.del=function(k){var O=this.rules.inline.del.exec(k);if(O)return{type:"del",raw:O[0],text:O[2],tokens:this.lexer.inlineTokens(O[2])}},E.autolink=function(k,O){var S=this.rules.inline.autolink.exec(k);if(S){var P,H;return S[2]==="@"?(P=e(this.options.mangle?O(S[1]):S[1]),H="mailto:"+P):(P=e(S[1]),H=P),{type:"link",raw:S[0],text:P,href:H,tokens:[{type:"text",raw:P,text:P}]}}},E.url=function(k,O){var S;if(S=this.rules.inline.url.exec(k)){var P,H;if(S[2]==="@")P=e(this.options.mangle?O(S[0]):S[0]),H="mailto:"+P;else{var G;do G=S[0],S[0]=this.rules.inline._backpedal.exec(S[0])[0];while(G!==S[0]);P=e(S[0]),S[1]==="www."?H="http://"+P:H=P}return{type:"link",raw:S[0],text:P,href:H,tokens:[{type:"text",raw:P,text:P}]}}},E.inlineText=function(k,O){var S=this.rules.inline.text.exec(k);if(S){var P;return this.lexer.state.inRawBlock?P=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(S[0]):e(S[0]):S[0]:P=e(this.options.smartypants?O(S[0]):S[0]),{type:"text",raw:S[0],text:P}}},A}(),le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=s(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=s(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=s(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=s(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=s(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=s(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=M({},le),le.gfm=M({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=s(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.gfm.paragraph=s(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",le.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=M({},le.normal,{html:s(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:y,paragraph:s(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=s(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=s(le._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=s(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=s(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=s(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=s(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=s(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=s(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=s(oe.reflink).replace("label",oe._label).replace("ref",le._label).getRegex(),oe.nolink=s(oe.nolink).replace("ref",le._label).getRegex(),oe.reflinkSearch=s(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=M({},oe),oe.pedantic=M({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:s(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:s(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=M({},oe.normal,{escape:s(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=s(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=M({},oe.gfm,{br:s(oe.br).replace("{2,}","*").getRegex(),text:s(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function we(A){return A.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Fe(A){var E="",I,k,O=A.length;for(I=0;I<O;I++)k=A.charCodeAt(I),Math.random()>.5&&(k="x"+k.toString(16)),E+="&#"+k+";";return E}var ke=function(){function A(I){this.tokens=[],this.tokens.links=Object.create(null),this.options=I||ae.defaults,this.options.tokenizer=this.options.tokenizer||new ue,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var k={block:le.normal,inline:oe.normal};this.options.pedantic?(k.block=le.pedantic,k.inline=oe.pedantic):this.options.gfm&&(k.block=le.gfm,this.options.breaks?k.inline=oe.breaks:k.inline=oe.gfm),this.tokenizer.rules=k}A.lex=function(k,O){var S=new A(O);return S.lex(k)},A.lexInline=function(k,O){var S=new A(O);return S.inlineTokens(k)};var E=A.prototype;return E.lex=function(k){k=k.replace(/\r\n|\r/g,`
`),this.blockTokens(k,this.tokens);for(var O;O=this.inlineQueue.shift();)this.inlineTokens(O.src,O.tokens);return this.tokens},E.blockTokens=function(k,O){var S=this;O===void 0&&(O=[]),this.options.pedantic?k=k.replace(/\t/g,"    ").replace(/^ +$/gm,""):k=k.replace(/^( *)(\t+)/gm,function(me,ve,Ne){return ve+"    ".repeat(Ne.length)});for(var P,H,G,ee;k;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(me){return(P=me.call({lexer:S},k,O))?(k=k.substring(P.raw.length),O.push(P),!0):!1}))){if(P=this.tokenizer.space(k)){k=k.substring(P.raw.length),P.raw.length===1&&O.length>0?O[O.length-1].raw+=`
`:O.push(P);continue}if(P=this.tokenizer.code(k)){k=k.substring(P.raw.length),H=O[O.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+P.raw,H.text+=`
`+P.text,this.inlineQueue[this.inlineQueue.length-1].src=H.text):O.push(P);continue}if(P=this.tokenizer.fences(k)){k=k.substring(P.raw.length),O.push(P);continue}if(P=this.tokenizer.heading(k)){k=k.substring(P.raw.length),O.push(P);continue}if(P=this.tokenizer.hr(k)){k=k.substring(P.raw.length),O.push(P);continue}if(P=this.tokenizer.blockquote(k)){k=k.substring(P.raw.length),O.push(P);continue}if(P=this.tokenizer.list(k)){k=k.substring(P.raw.length),O.push(P);continue}if(P=this.tokenizer.html(k)){k=k.substring(P.raw.length),O.push(P);continue}if(P=this.tokenizer.def(k)){k=k.substring(P.raw.length),H=O[O.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+P.raw,H.text+=`
`+P.raw,this.inlineQueue[this.inlineQueue.length-1].src=H.text):this.tokens.links[P.tag]||(this.tokens.links[P.tag]={href:P.href,title:P.title});continue}if(P=this.tokenizer.table(k)){k=k.substring(P.raw.length),O.push(P);continue}if(P=this.tokenizer.lheading(k)){k=k.substring(P.raw.length),O.push(P);continue}if(G=k,this.options.extensions&&this.options.extensions.startBlock&&function(){var me=1/0,ve=k.slice(1),Ne=void 0;S.options.extensions.startBlock.forEach(function(Ce){Ne=Ce.call({lexer:this},ve),typeof Ne=="number"&&Ne>=0&&(me=Math.min(me,Ne))}),me<1/0&&me>=0&&(G=k.substring(0,me+1))}(),this.state.top&&(P=this.tokenizer.paragraph(G))){H=O[O.length-1],ee&&H.type==="paragraph"?(H.raw+=`
`+P.raw,H.text+=`
`+P.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):O.push(P),ee=G.length!==k.length,k=k.substring(P.raw.length);continue}if(P=this.tokenizer.text(k)){k=k.substring(P.raw.length),H=O[O.length-1],H&&H.type==="text"?(H.raw+=`
`+P.raw,H.text+=`
`+P.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):O.push(P);continue}if(k){var se="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(se);break}else throw new Error(se)}}return this.state.top=!0,O},E.inline=function(k,O){return O===void 0&&(O=[]),this.inlineQueue.push({src:k,tokens:O}),O},E.inlineTokens=function(k,O){var S=this;O===void 0&&(O=[]);var P,H,G,ee=k,se,me,ve;if(this.tokens.links){var Ne=Object.keys(this.tokens.links);if(Ne.length>0)for(;(se=this.tokenizer.rules.inline.reflinkSearch.exec(ee))!=null;)Ne.includes(se[0].slice(se[0].lastIndexOf("[")+1,-1))&&(ee=ee.slice(0,se.index)+"["+j("a",se[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(se=this.tokenizer.rules.inline.blockSkip.exec(ee))!=null;)ee=ee.slice(0,se.index)+"["+j("a",se[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(se=this.tokenizer.rules.inline.escapedEmSt.exec(ee))!=null;)ee=ee.slice(0,se.index)+"++"+ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;k;)if(me||(ve=""),me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(P=De.call({lexer:S},k,O))?(k=k.substring(P.raw.length),O.push(P),!0):!1}))){if(P=this.tokenizer.escape(k)){k=k.substring(P.raw.length),O.push(P);continue}if(P=this.tokenizer.tag(k)){k=k.substring(P.raw.length),H=O[O.length-1],H&&P.type==="text"&&H.type==="text"?(H.raw+=P.raw,H.text+=P.text):O.push(P);continue}if(P=this.tokenizer.link(k)){k=k.substring(P.raw.length),O.push(P);continue}if(P=this.tokenizer.reflink(k,this.tokens.links)){k=k.substring(P.raw.length),H=O[O.length-1],H&&P.type==="text"&&H.type==="text"?(H.raw+=P.raw,H.text+=P.text):O.push(P);continue}if(P=this.tokenizer.emStrong(k,ee,ve)){k=k.substring(P.raw.length),O.push(P);continue}if(P=this.tokenizer.codespan(k)){k=k.substring(P.raw.length),O.push(P);continue}if(P=this.tokenizer.br(k)){k=k.substring(P.raw.length),O.push(P);continue}if(P=this.tokenizer.del(k)){k=k.substring(P.raw.length),O.push(P);continue}if(P=this.tokenizer.autolink(k,Fe)){k=k.substring(P.raw.length),O.push(P);continue}if(!this.state.inLink&&(P=this.tokenizer.url(k,Fe))){k=k.substring(P.raw.length),O.push(P);continue}if(G=k,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,Te=k.slice(1),Se=void 0;S.options.extensions.startInline.forEach(function(Ve){Se=Ve.call({lexer:this},Te),typeof Se=="number"&&Se>=0&&(De=Math.min(De,Se))}),De<1/0&&De>=0&&(G=k.substring(0,De+1))}(),P=this.tokenizer.inlineText(G,we)){k=k.substring(P.raw.length),P.raw.slice(-1)!=="_"&&(ve=P.raw.slice(-1)),me=!0,H=O[O.length-1],H&&H.type==="text"?(H.raw+=P.raw,H.text+=P.text):O.push(P);continue}if(k){var Ce="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return O},v(A,null,[{key:"rules",get:function(){return{block:le,inline:oe}}}]),A}(),Le=function(){function A(I){this.options=I||ae.defaults}var E=A.prototype;return E.code=function(k,O,S){var P=(O||"").match(/\S*/)[0];if(this.options.highlight){var H=this.options.highlight(k,P);H!=null&&H!==k&&(S=!0,k=H)}return k=k.replace(/\n$/,"")+`
`,P?'<pre><code class="'+this.options.langPrefix+e(P,!0)+'">'+(S?k:e(k,!0))+`</code></pre>
`:"<pre><code>"+(S?k:e(k,!0))+`</code></pre>
`},E.blockquote=function(k){return`<blockquote>
`+k+`</blockquote>
`},E.html=function(k){return k},E.heading=function(k,O,S,P){if(this.options.headerIds){var H=this.options.headerPrefix+P.slug(S);return"<h"+O+' id="'+H+'">'+k+"</h"+O+`>
`}return"<h"+O+">"+k+"</h"+O+`>
`},E.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},E.list=function(k,O,S){var P=O?"ol":"ul",H=O&&S!==1?' start="'+S+'"':"";return"<"+P+H+`>
`+k+"</"+P+`>
`},E.listitem=function(k){return"<li>"+k+`</li>
`},E.checkbox=function(k){return"<input "+(k?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},E.paragraph=function(k){return"<p>"+k+`</p>
`},E.table=function(k,O){return O&&(O="<tbody>"+O+"</tbody>"),`<table>
<thead>
`+k+`</thead>
`+O+`</table>
`},E.tablerow=function(k){return`<tr>
`+k+`</tr>
`},E.tablecell=function(k,O){var S=O.header?"th":"td",P=O.align?"<"+S+' align="'+O.align+'">':"<"+S+">";return P+k+("</"+S+`>
`)},E.strong=function(k){return"<strong>"+k+"</strong>"},E.em=function(k){return"<em>"+k+"</em>"},E.codespan=function(k){return"<code>"+k+"</code>"},E.br=function(){return this.options.xhtml?"<br/>":"<br>"},E.del=function(k){return"<del>"+k+"</del>"},E.link=function(k,O,S){if(k=u(this.options.sanitize,this.options.baseUrl,k),k===null)return S;var P='<a href="'+e(k)+'"';return O&&(P+=' title="'+O+'"'),P+=">"+S+"</a>",P},E.image=function(k,O,S){if(k=u(this.options.sanitize,this.options.baseUrl,k),k===null)return S;var P='<img src="'+k+'" alt="'+S+'"';return O&&(P+=' title="'+O+'"'),P+=this.options.xhtml?"/>":">",P},E.text=function(k){return k},A}(),de=function(){function A(){}var E=A.prototype;return E.strong=function(k){return k},E.em=function(k){return k},E.codespan=function(k){return k},E.del=function(k){return k},E.html=function(k){return k},E.text=function(k){return k},E.link=function(k,O,S){return""+S},E.image=function(k,O,S){return""+S},E.br=function(){return""},A}(),ne=function(){function A(){this.seen={}}var E=A.prototype;return E.serialize=function(k){return k.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},E.getNextSafeSlug=function(k,O){var S=k,P=0;if(this.seen.hasOwnProperty(S)){P=this.seen[k];do P++,S=k+"-"+P;while(this.seen.hasOwnProperty(S))}return O||(this.seen[k]=P,this.seen[S]=0),S},E.slug=function(k,O){O===void 0&&(O={});var S=this.serialize(k);return this.getNextSafeSlug(S,O.dryrun)},A}(),ce=function(){function A(I){this.options=I||ae.defaults,this.options.renderer=this.options.renderer||new Le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new ne}A.parse=function(k,O){var S=new A(O);return S.parse(k)},A.parseInline=function(k,O){var S=new A(O);return S.parseInline(k)};var E=A.prototype;return E.parse=function(k,O){O===void 0&&(O=!0);var S="",P,H,G,ee,se,me,ve,Ne,Ce,De,Te,Se,Ve,je,Me,Qe,J,he,pe,Ee=k.length;for(P=0;P<Ee;P++){if(De=k[P],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(pe=this.options.extensions.renderers[De.type].call({parser:this},De),pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){S+=pe||"";continue}switch(De.type){case"space":continue;case"hr":{S+=this.renderer.hr();continue}case"heading":{S+=this.renderer.heading(this.parseInline(De.tokens),De.depth,a(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{S+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(Ne="",ve="",ee=De.header.length,H=0;H<ee;H++)ve+=this.renderer.tablecell(this.parseInline(De.header[H].tokens),{header:!0,align:De.align[H]});for(Ne+=this.renderer.tablerow(ve),Ce="",ee=De.rows.length,H=0;H<ee;H++){for(me=De.rows[H],ve="",se=me.length,G=0;G<se;G++)ve+=this.renderer.tablecell(this.parseInline(me[G].tokens),{header:!1,align:De.align[G]});Ce+=this.renderer.tablerow(ve)}S+=this.renderer.table(Ne,Ce);continue}case"blockquote":{Ce=this.parse(De.tokens),S+=this.renderer.blockquote(Ce);continue}case"list":{for(Te=De.ordered,Se=De.start,Ve=De.loose,ee=De.items.length,Ce="",H=0;H<ee;H++)Me=De.items[H],Qe=Me.checked,J=Me.task,je="",Me.task&&(he=this.renderer.checkbox(Qe),Ve?Me.tokens.length>0&&Me.tokens[0].type==="paragraph"?(Me.tokens[0].text=he+" "+Me.tokens[0].text,Me.tokens[0].tokens&&Me.tokens[0].tokens.length>0&&Me.tokens[0].tokens[0].type==="text"&&(Me.tokens[0].tokens[0].text=he+" "+Me.tokens[0].tokens[0].text)):Me.tokens.unshift({type:"text",text:he}):je+=he),je+=this.parse(Me.tokens,Ve),Ce+=this.renderer.listitem(je,J,Qe);S+=this.renderer.list(Ce,Te,Se);continue}case"html":{S+=this.renderer.html(De.text);continue}case"paragraph":{S+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Ce=De.tokens?this.parseInline(De.tokens):De.text;P+1<Ee&&k[P+1].type==="text";)De=k[++P],Ce+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);S+=O?this.renderer.paragraph(Ce):Ce;continue}default:{var Pe='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return S},E.parseInline=function(k,O){O=O||this.renderer;var S="",P,H,G,ee=k.length;for(P=0;P<ee;P++){if(H=k[P],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(G=this.options.extensions.renderers[H.type].call({parser:this},H),G!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(H.type))){S+=G||"";continue}switch(H.type){case"escape":{S+=O.text(H.text);break}case"html":{S+=O.html(H.text);break}case"link":{S+=O.link(H.href,H.title,this.parseInline(H.tokens,O));break}case"image":{S+=O.image(H.href,H.title,H.text);break}case"strong":{S+=O.strong(this.parseInline(H.tokens,O));break}case"em":{S+=O.em(this.parseInline(H.tokens,O));break}case"codespan":{S+=O.codespan(H.text);break}case"br":{S+=O.br();break}case"del":{S+=O.del(this.parseInline(H.tokens,O));break}case"text":{S+=O.text(H.text);break}default:{var se='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return S},A}();function Z(A,E,I){if(typeof A>"u"||A===null)throw new Error("marked(): input parameter is undefined or null");if(typeof A!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(A)+", string expected");if(typeof E=="function"&&(I=E,E=null),E=M({},Z.defaults,E||{}),B(E),I){var k=E.highlight,O;try{O=ke.lex(A,E)}catch(ee){return I(ee)}var S=function(se){var me;if(!se)try{E.walkTokens&&Z.walkTokens(O,E.walkTokens),me=ce.parse(O,E)}catch(ve){se=ve}return E.highlight=k,se?I(se):I(null,me)};if(!k||k.length<3||(delete E.highlight,!O.length))return S();var P=0;Z.walkTokens(O,function(ee){ee.type==="code"&&(P++,setTimeout(function(){k(ee.text,ee.lang,function(se,me){if(se)return S(se);me!=null&&me!==ee.text&&(ee.text=me,ee.escaped=!0),P--,P===0&&S()})},0))}),P===0&&S();return}function H(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,E.silent)return"<p>An error occurred:</p><pre>"+e(ee.message+"",!0)+"</pre>";throw ee}try{var G=ke.lex(A,E);if(E.walkTokens){if(E.async)return Promise.all(Z.walkTokens(G,E.walkTokens)).then(function(){return ce.parse(G,E)}).catch(H);Z.walkTokens(G,E.walkTokens)}return ce.parse(G,E)}catch(ee){H(ee)}}Z.options=Z.setOptions=function(A){return M(Z.defaults,A),D(Z.defaults),Z},Z.getDefaults=p,Z.defaults=ae.defaults,Z.use=function(){for(var A=arguments.length,E=new Array(A),I=0;I<A;I++)E[I]=arguments[I];var k=M.apply(void 0,[{}].concat(E)),O=Z.defaults.extensions||{renderers:{},childTokens:{}},S;E.forEach(function(P){if(P.extensions&&(S=!0,P.extensions.forEach(function(G){if(!G.name)throw new Error("extension name required");if(G.renderer){var ee=O.renderers?O.renderers[G.name]:null;ee?O.renderers[G.name]=function(){for(var se=arguments.length,me=new Array(se),ve=0;ve<se;ve++)me[ve]=arguments[ve];var Ne=G.renderer.apply(this,me);return Ne===!1&&(Ne=ee.apply(this,me)),Ne}:O.renderers[G.name]=G.renderer}if(G.tokenizer){if(!G.level||G.level!=="block"&&G.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");O[G.level]?O[G.level].unshift(G.tokenizer):O[G.level]=[G.tokenizer],G.start&&(G.level==="block"?O.startBlock?O.startBlock.push(G.start):O.startBlock=[G.start]:G.level==="inline"&&(O.startInline?O.startInline.push(G.start):O.startInline=[G.start]))}G.childTokens&&(O.childTokens[G.name]=G.childTokens)})),P.renderer&&function(){var G=Z.defaults.renderer||new Le,ee=function(ve){var Ne=G[ve];G[ve]=function(){for(var Ce=arguments.length,De=new Array(Ce),Te=0;Te<Ce;Te++)De[Te]=arguments[Te];var Se=P.renderer[ve].apply(G,De);return Se===!1&&(Se=Ne.apply(G,De)),Se}};for(var se in P.renderer)ee(se);k.renderer=G}(),P.tokenizer&&function(){var G=Z.defaults.tokenizer||new ue,ee=function(ve){var Ne=G[ve];G[ve]=function(){for(var Ce=arguments.length,De=new Array(Ce),Te=0;Te<Ce;Te++)De[Te]=arguments[Te];var Se=P.tokenizer[ve].apply(G,De);return Se===!1&&(Se=Ne.apply(G,De)),Se}};for(var se in P.tokenizer)ee(se);k.tokenizer=G}(),P.walkTokens){var H=Z.defaults.walkTokens;k.walkTokens=function(G){var ee=[];return ee.push(P.walkTokens.call(this,G)),H&&(ee=ee.concat(H.call(this,G))),ee}}S&&(k.extensions=O),Z.setOptions(k)})},Z.walkTokens=function(A,E){for(var I=[],k=function(){var H=S.value;switch(I=I.concat(E.call(Z,H)),H.type){case"table":{for(var G=U(H.header),ee;!(ee=G()).done;){var se=ee.value;I=I.concat(Z.walkTokens(se.tokens,E))}for(var me=U(H.rows),ve;!(ve=me()).done;)for(var Ne=ve.value,Ce=U(Ne),De;!(De=Ce()).done;){var Te=De.value;I=I.concat(Z.walkTokens(Te.tokens,E))}break}case"list":{I=I.concat(Z.walkTokens(H.items,E));break}default:Z.defaults.extensions&&Z.defaults.extensions.childTokens&&Z.defaults.extensions.childTokens[H.type]?Z.defaults.extensions.childTokens[H.type].forEach(function(Se){I=I.concat(Z.walkTokens(H[Se],E))}):H.tokens&&(I=I.concat(Z.walkTokens(H.tokens,E)))}},O=U(A),S;!(S=O()).done;)k();return I},Z.parseInline=function(A,E){if(typeof A>"u"||A===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof A!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(A)+", string expected");E=M({},Z.defaults,E||{}),B(E);try{var I=ke.lexInline(A,E);return E.walkTokens&&Z.walkTokens(I,E.walkTokens),ce.parseInline(I,E)}catch(k){if(k.message+=`
Please report this to https://github.com/markedjs/marked.`,E.silent)return"<p>An error occurred:</p><pre>"+e(k.message+"",!0)+"</pre>";throw k}},Z.Parser=ce,Z.parser=ce.parse,Z.Renderer=Le,Z.TextRenderer=de,Z.Lexer=ke,Z.lexer=ke.lex,Z.Tokenizer=ue,Z.Slugger=ne,Z.parse=Z;var q=Z.options,X=Z.setOptions,C=Z.use,_=Z.walkTokens,$=Z.parseInline,W=Z,Q=ce.parse,w=ke.lex;ae.Lexer=ke,ae.Parser=ce,ae.Renderer=Le,ae.Slugger=ne,ae.TextRenderer=de,ae.Tokenizer=ue,ae.getDefaults=p,ae.lexer=w,ae.marked=Z,ae.options=q,ae.parse=W,ae.parseInline=$,ae.parser=Q,ae.setOptions=X,ae.use=C,ae.walkTokens=_,Object.defineProperty(ae,"__esModule",{value:!0})}),define(be[80],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mS=void 0;class v{constructor(i,U=0,p=i.length,D=U-1){this.a=i,this.b=U,this.c=p,this.d=D}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$mS=v}),define(be[81],$e([1,0,80]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oS=t.$nS=void 0;class N{constructor(p=[],D=10){this.h(p),this.b=D,this.d()}getHistory(){return this.j}add(p){this.a.delete(p),this.a.add(p),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(p){return this.a.has(p)}clear(){this.h([]),this.d()}d(){this.f();const p=this.j;this.c=new v.$mS(p,0,p.length,p.length)}f(){const p=this.j;p.length>this.b&&this.h(p.slice(p.length-this.b))}g(){const p=this.c.current();return p?this.j.indexOf(p):-1}h(p){this.a=new Set;for(const D of p)this.a.add(D)}get j(){const p=[];return this.a.forEach(D=>p.push(D)),p}}t.$nS=N;class i{get size(){return this.f}constructor(p,D=10){if(this.g=D,p.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:p[0],previous:void 0,next:void 0},this.a=new Set([p[0]]);for(let c=1;c<p.length;c++)this.add(p[c])}add(p){const D={value:p,previous:this.c,next:void 0};for(this.c.next=D,this.c=D,this.d=this.c,this.f++,this.a.has(p)?this.h(p):this.a.add(p);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(p){if(this.c.value===p)return p;const D=this.c.value;return this.a.delete(D),this.c.value=p,this.a.has(p)?this.h(p):this.a.add(p),D}prepend(p){if(this.f===this.g||this.a.has(p))return;const D={value:p,previous:void 0,next:this.b};this.b.previous=D,this.b=D,this.f++,this.a.add(p)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(p){return this.a.has(p)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let p=this.b;for(;p;)yield p.value,p=p.next}h(p){let D=this.b;for(;D!==this.c;)D.value===p&&(D===this.b?(this.b=this.b.next,this.b.previous=void 0):(D.previous.next=D.next,D.next.previous=D.previous),this.f--),D=D.next}}t.$oS=i}),define(be[46],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1l=t.$Zl=t.$Yl=t.rot=t.$Wl=void 0;function v(D,c,g){return Math.min(Math.max(D,c),g)}t.$Wl=v;function N(D,c){return(c+D%c)%c}t.rot=N;class i{constructor(){this.a=0}getNext(){return this.a++}}t.$Yl=i;class U{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Zl=U;class p{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const g=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$1l=p}),define(be[47],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var v;(function(N){function i(c,g){if(c.start>=g.end||g.start>=c.end)return{start:0,end:0};const m=Math.max(c.start,g.start),T=Math.min(c.end,g.end);return T-m<=0?{start:0,end:0}:{start:m,end:T}}N.intersect=i;function U(c){return c.end-c.start<=0}N.isEmpty=U;function p(c,g){return!U(i(c,g))}N.intersects=p;function D(c,g){const m=[],T={start:c.start,end:Math.min(g.start,c.end)},n={start:Math.max(g.end,c.start),end:c.end};return U(T)||m.push(T),U(n)||m.push(n),m}N.relativeComplement=D})(v||(t.Range=v={}))}),define(be[82],$e([1,0,47]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fR=t.$eR=t.$dR=t.$cR=void 0;function N(c,g){const m=[];for(const T of g){if(c.start>=T.range.end)continue;if(c.end<T.range.start)break;const n=v.Range.intersect(c,T.range);v.Range.isEmpty(n)||m.push({range:n,size:T.size})}return m}t.$cR=N;function i({start:c,end:g},m){return{start:c+m,end:g+m}}t.$dR=i;function U(c){const g=[];let m=null;for(const T of c){const n=T.range.start,o=T.range.end,e=T.size;if(m&&e===m.size){m.range.end=o;continue}m={range:{start:n,end:o},size:e},g.push(m)}return g}t.$eR=U;function p(...c){return U(c.reduce((g,m)=>g.concat(m),[]))}class D{get paddingTop(){return this.c}set paddingTop(g){this.b=this.b+g-this.c,this.c=g}constructor(g){this.a=[],this.b=0,this.c=0,this.c=g??0,this.b=this.c}splice(g,m,T=[]){const n=T.length-m,o=N({start:0,end:g},this.a),e=N({start:g+m,end:Number.POSITIVE_INFINITY},this.a).map(a=>({range:i(a.range,n),size:a.size})),h=T.map((a,f)=>({range:{start:g+f,end:g+f+1},size:a.size}));this.a=p(o,h,e),this.b=this.c+this.a.reduce((a,f)=>a+f.size*(f.range.end-f.range.start),0)}get count(){const g=this.a.length;return g?this.a[g-1].range.end:0}get size(){return this.b}indexAt(g){if(g<0)return-1;if(g<this.c)return 0;let m=0,T=this.c;for(const n of this.a){const o=n.range.end-n.range.start,e=T+o*n.size;if(g<e)return m+Math.floor((g-T)/n.size);m+=o,T=e}return m}indexAfter(g){return Math.min(this.indexAt(g)+1,this.count)}positionAt(g){if(g<0)return-1;let m=0,T=0;for(const n of this.a){const o=n.range.end-n.range.start,e=T+o;if(g<e)return this.c+m+(g-T)*n.size;m+=o*n.size,T=e}return-1}}t.$fR=D}),define(be[83],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nd=void 0;const v=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(U){return new N(U)}constructor(U){this.c=v&&U===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Nd=N}),define(be[4],$e([1,0,6,43,2,45,83]),function(ae,t,v,N,i,U,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.Event=void 0;const D=!1,c=!1;var g;(function(x){x.None=()=>i.$Rc.None;function R(O){if(c){const{onDidAddListener:S}=O,P=e.create();let H=0;O.onDidAddListener=()=>{++H===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),P.print()),S?.()}}}function B(O,S){return Le(O,()=>{},0,void 0,!0,void 0,S)}x.defer=B;function j(O){return(S,P=null,H)=>{let G=!1,ee;return ee=O(se=>{if(!G)return ee?ee.dispose():G=!0,S.call(P,se)},null,H),G&&ee.dispose(),ee}}x.once=j;function ie(O,S,P){return Fe((H,G=null,ee)=>O(se=>H.call(G,S(se)),null,ee),P)}x.map=ie;function te(O,S,P){return Fe((H,G=null,ee)=>O(se=>{S(se),H.call(G,se)},null,ee),P)}x.forEach=te;function ue(O,S,P){return Fe((H,G=null,ee)=>O(se=>S(se)&&H.call(G,se),null,ee),P)}x.filter=ue;function le(O){return O}x.signal=le;function oe(...O){return(S,P=null,H)=>{const G=(0,i.$Oc)(...O.map(ee=>ee(se=>S.call(P,se))));return ke(G,H)}}x.any=oe;function we(O,S,P,H){let G=P;return ie(O,ee=>(G=S(G,ee),G),H)}x.reduce=we;function Fe(O,S){let P;const H={onWillAddFirstListener(){P=O(G.fire,G)},onDidRemoveLastListener(){P?.dispose()}};S||R(H);const G=new r(H);return S?.add(G),G.event}function ke(O,S){return S instanceof Array?S.push(O):S&&S.add(O),O}function Le(O,S,P=100,H=!1,G=!1,ee,se){let me,ve,Ne,Ce=0,De;const Te={leakWarningThreshold:ee,onWillAddFirstListener(){me=O(Ve=>{Ce++,ve=S(ve,Ve),H&&!Ne&&(Se.fire(ve),ve=void 0),De=()=>{const je=ve;ve=void 0,Ne=void 0,(!H||Ce>1)&&Se.fire(je),Ce=0},typeof P=="number"?(clearTimeout(Ne),Ne=setTimeout(De,P)):Ne===void 0&&(Ne=0,queueMicrotask(De))})},onWillRemoveListener(){G&&Ce>0&&De?.()},onDidRemoveLastListener(){De=void 0,me.dispose()}};se||R(Te);const Se=new r(Te);return se?.add(Se),Se.event}x.debounce=Le;function de(O,S=0,P){return x.debounce(O,(H,G)=>H?(H.push(G),H):[G],S,void 0,!0,void 0,P)}x.accumulate=de;function ne(O,S=(H,G)=>H===G,P){let H=!0,G;return ue(O,ee=>{const se=H||!S(ee,G);return H=!1,G=ee,se},P)}x.latch=ne;function ce(O,S,P){return[x.filter(O,S,P),x.filter(O,H=>!S(H),P)]}x.split=ce;function Z(O,S=!1,P=[],H){let G=P.slice(),ee=O(ve=>{G?G.push(ve):me.fire(ve)});H&&H.add(ee);const se=()=>{G?.forEach(ve=>me.fire(ve)),G=null},me=new r({onWillAddFirstListener(){ee||(ee=O(ve=>me.fire(ve)),H&&H.add(ee))},onDidAddFirstListener(){G&&(S?setTimeout(se):se())},onDidRemoveLastListener(){ee&&ee.dispose(),ee=null}});return H&&H.add(me),me.event}x.buffer=Z;function q(O,S){return(H,G,ee)=>{const se=S(new C);return O(function(me){const ve=se.evaluate(me);ve!==X&&H.call(G,ve)},void 0,ee)}}x.chain=q;const X=Symbol("HaltChainable");class C{constructor(){this.f=[]}map(S){return this.f.push(S),this}forEach(S){return this.f.push(P=>(S(P),P)),this}filter(S){return this.f.push(P=>S(P)?P:X),this}reduce(S,P){let H=P;return this.f.push(G=>(H=S(H,G),H)),this}latch(S=(P,H)=>P===H){let P=!0,H;return this.f.push(G=>{const ee=P||!S(G,H);return P=!1,H=G,ee?G:X}),this}evaluate(S){for(const P of this.f)if(S=P(S),S===X)break;return S}}function _(O,S,P=H=>H){const H=(...me)=>se.fire(P(...me)),G=()=>O.on(S,H),ee=()=>O.removeListener(S,H),se=new r({onWillAddFirstListener:G,onDidRemoveLastListener:ee});return se.event}x.fromNodeEventEmitter=_;function $(O,S,P=H=>H){const H=(...me)=>se.fire(P(...me)),G=()=>O.addEventListener(S,H),ee=()=>O.removeEventListener(S,H),se=new r({onWillAddFirstListener:G,onDidRemoveLastListener:ee});return se.event}x.fromDOMEventEmitter=$;function W(O){return new Promise(S=>j(O)(S))}x.toPromise=W;function Q(O){const S=new r;return O.then(P=>{S.fire(P)},()=>{S.fire(void 0)}).finally(()=>{S.dispose()}),S.event}x.fromPromise=Q;function w(O,S,P){return S(P),O(H=>S(H))}x.runAndSubscribe=w;function A(O,S){let P=null;function H(ee){P?.dispose(),P=new i.$Qc,S(ee,P)}H(void 0);const G=O(ee=>H(ee));return(0,i.$Pc)(()=>{G.dispose(),P?.dispose()})}x.runAndSubscribeWithStore=A;class E{constructor(S,P){this._observable=S,this.f=0,this.g=!1;const H={onWillAddFirstListener:()=>{S.addObserver(this)},onDidRemoveLastListener:()=>{S.removeObserver(this)}};P||R(H),this.emitter=new r(H),P&&P.add(this.emitter)}beginUpdate(S){this.f++}handlePossibleChange(S){}handleChange(S,P){this.g=!0}endUpdate(S){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function I(O,S){return new E(O,S).emitter.event}x.fromObservable=I;function k(O){return S=>{let P=0,H=!1;const G={beginUpdate(){P++},endUpdate(){P--,P===0&&(O.reportChanges(),H&&(H=!1,S()))},handlePossibleChange(){},handleChange(){H=!0}};return O.addObserver(G),O.reportChanges(),{dispose(){O.removeObserver(G)}}}}x.fromObservableLight=k})(g||(t.Event=g={}));class m{static{this.all=new Set}static{this.f=0}constructor(R){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${R}_${m.f++}`,m.all.add(this)}start(R){this.g=new p.$Nd,this.listenerCount=R}stop(){if(this.g){const R=this.g.elapsed();this.durations.push(R),this.elapsedOverall+=R,this.invocationCount+=1,this.g=void 0}}}t.$Pd=m;let T=-1;function n(x){const R=T;return T=x,{dispose(){T=R}}}t.$Qd=n;class o{constructor(R,B=Math.random().toString(18).slice(2,5)){this.threshold=R,this.name=B,this.g=0}dispose(){this.f?.clear()}check(R,B){const j=this.threshold;if(j<=0||B<j)return;this.f||(this.f=new Map);const ie=this.f.get(R.value)||0;if(this.f.set(R.value,ie+1),this.g-=1,this.g<=0){this.g=j*.5;let te,ue=0;for(const[le,oe]of this.f)(!te||ue<oe)&&(te=le,ue=oe);console.warn(`[${this.name}] potential listener LEAK detected, having ${B} listeners already. MOST frequent listener (${ue}):`),console.warn(te)}return()=>{const te=this.f.get(R.value)||0;this.f.set(R.value,te-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(R){this.value=R}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let h=0;class a{constructor(R){this.value=R,this.id=h++}}const f=2,s=(x,R)=>{if(x instanceof a)R(x);else for(let B=0;B<x.length;B++){const j=x[B];j&&R(j)}};class r{constructor(R){this.w=0,this.f=R,this.g=T>0||this.f?.leakWarningThreshold?new o(this.f?.leakWarningThreshold??T):void 0,this.j=this.f?._profName?new m(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(D){const R=this.t;queueMicrotask(()=>{s(R,B=>B.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(R,B,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$Rc.None;if(this.m)return i.$Rc.None;B&&(R=R.bind(B));const ie=new a(R);let te,ue;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ie.stack=e.create(),te=this.g.check(ie.stack,this.w+1)),D&&(ie.stack=ue??e.create()),this.t?this.t instanceof a?(this.u??=new u,this.t=[this.t,ie]):this.t.push(ie):(this.f?.onWillAddFirstListener?.(this),this.t=ie,this.f?.onDidAddFirstListener?.(this)),this.w++;const le=(0,i.$Pc)(()=>{te?.(),this.x(ie)});return j instanceof i.$Qc?j.add(le):Array.isArray(j)&&j.push(le),le},this.q}x(R){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const B=this.t,j=B.indexOf(R);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,B[j]=void 0;const ie=this.u.current===this;if(this.w*f<=B.length){let te=0;for(let ue=0;ue<B.length;ue++)B[ue]?B[te++]=B[ue]:ie&&(this.u.end--,te<this.u.i&&this.u.i--);B.length=te}}y(R,B){if(!R)return;const j=this.f?.onListenerError||v.$Z;if(!j){R.value(B);return}try{R.value(B)}catch(ie){j(ie)}}z(R){const B=R.current.t;for(;R.i<R.end;)this.y(B[R.i++],R.value);R.reset()}fire(R){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof a)this.y(this.t,R);else{const B=this.u;B.enqueue(this,R,this.t.length),this.z(B)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Rd=r;const b=()=>new u;t.$Sd=b;class u{constructor(){this.i=-1,this.end=0}enqueue(R,B,j){this.i=0,this.end=j,this.current=R,this.value=B}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class l extends r{async fireAsync(R,B,j){if(this.t)for(this.h||(this.h=new U.$2c),s(this.t,ie=>this.h.push([ie.value,R]));this.h.size>0&&!B.isCancellationRequested;){const[ie,te]=this.h.shift(),ue=[],le={...te,token:B,waitUntil:oe=>{if(Object.isFrozen(ue))throw new Error("waitUntil can NOT be called asynchronous");j&&(oe=j(oe,ie)),ue.push(oe)}};try{ie(le)}catch(oe){(0,v.$Z)(oe);continue}Object.freeze(ue),await Promise.allSettled(ue).then(oe=>{for(const we of oe)we.status==="rejected"&&(0,v.$Z)(we.reason)})}}}t.$Td=l;class F extends r{get isPaused(){return this.h!==0}constructor(R){super(R),this.h=0,this.s=new U.$2c,this.A=R?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const R=Array.from(this.s);this.s.clear(),super.fire(this.A(R))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(R){this.w&&(this.h!==0?this.s.push(R):super.fire(R))}}t.$Ud=F;class z extends F{constructor(R){super(R),this.k=R.delay??100}fire(R){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(R)}}t.$Vd=z;class L extends r{constructor(R){super(R),this.h=[],this.k=R?.merge}fire(R){this.hasListeners()&&(this.h.push(R),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(B=>super.fire(B)),this.h=[]}))}}t.$Wd=L;class d{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(R){const B={event:R,listener:null};this.h.push(B),this.g&&this.m(B);const j=()=>{this.g&&this.o(B);const ie=this.h.indexOf(B);this.h.splice(ie,1)};return(0,i.$Pc)((0,N.$cb)(j))}j(){this.g=!0,this.h.forEach(R=>this.m(R))}k(){this.g=!1,this.h.forEach(R=>this.o(R))}m(R){R.listener=R.event(B=>this.f.fire(B))}o(R){R.listener&&R.listener.dispose(),R.listener=null}dispose(){this.f.dispose()}}t.$Xd=d;class y{constructor(R,B,j,ie){this.f=new i.$Qc;const te=this.f.add(new d),ue=this.f.add(new i.$1c);function le(oe){ue.set(oe,te.add(ie(oe)))}for(const oe of R)le(oe);this.f.add(B(oe=>{le(oe)})),this.f.add(j(oe=>{ue.deleteAndDispose(oe)})),this.event=te.event}dispose(){this.f.dispose()}}t.$Yd=y;class M{constructor(){this.f=[]}wrapEvent(R){return(B,j,ie)=>R(te=>{const ue=this.f[this.f.length-1];ue?ue.push(()=>B.call(j,te)):B.call(j,te)},void 0,ie)}bufferEvents(R){const B=[];this.f.push(B);const j=R();return this.f.pop(),B.forEach(ie=>ie()),j}}t.$Zd=M;class V{constructor(){this.f=!1,this.g=g.None,this.h=i.$Rc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(R){this.g=R,this.f&&(this.h.dispose(),this.h=R(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$1d=V}),define(be[16],$e([1,0,21,4,2]),function(ae,t,v,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SO=t.$RO=t.$QO=t.$PO=t.$OO=t.$NO=t.$MO=t.$LO=t.$KO=t.$JO=t.$IO=t.$HO=t.$GO=t.$FO=t.$EO=t.$DO=t.$CO=t.$BO=void 0;class U{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new N.$Rd,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new U}getZoomLevel(){return this.a}setZoomLevel(u){this.a!==u&&(this.a=u)}getZoomFactor(){return this.b}setZoomFactor(u){this.b=u}setFullscreen(u){this.c!==u&&(this.c=u,this.d.fire())}isFullscreen(){return this.c}}class p extends i.$Rc{constructor(){super(),this.a=this.B(new N.$Rd),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(u){this.c?.removeEventListener("change",this.b),this.c=v.$window.matchMedia(`(resolution: ${v.$window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),u&&this.a.fire()}}class D extends i.$Rc{get value(){return this.b}constructor(){super(),this.a=this.B(new N.$Rd),this.onDidChange=this.a.event,this.b=this.c();const u=this.B(new p);this.B(u.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const u=document.createElement("canvas").getContext("2d"),l=v.$window.devicePixelRatio||1,F=u.webkitBackingStorePixelRatio||u.mozBackingStorePixelRatio||u.msBackingStorePixelRatio||u.oBackingStorePixelRatio||u.backingStorePixelRatio||1;return l/F}}class c{constructor(){this.a=null}b(){return this.a||(this.a=(0,i.$Kc)(new D)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function g(b,u){typeof b=="string"&&(b=v.$window.matchMedia(b)),b.addEventListener("change",u)}t.$BO=g,t.$CO=new c;function m(b){U.INSTANCE.setZoomLevel(b)}t.$DO=m;function T(){return U.INSTANCE.getZoomLevel()}t.$EO=T;function n(){return U.INSTANCE.getZoomFactor()}t.$FO=n;function o(b){U.INSTANCE.setZoomFactor(b)}t.$GO=o;function e(b){U.INSTANCE.setFullscreen(b)}t.$HO=e;function h(){return U.INSTANCE.isFullscreen()}t.$IO=h,t.$JO=U.INSTANCE.onDidChangeFullscreen;const a=navigator.userAgent;t.$KO=a.indexOf("Firefox")>=0,t.$LO=a.indexOf("AppleWebKit")>=0,t.$MO=a.indexOf("Chrome")>=0,t.$NO=!t.$MO&&a.indexOf("Safari")>=0,t.$OO=!t.$MO&&!t.$NO&&t.$LO,t.$PO=a.indexOf("Electron/")>=0,t.$QO=a.indexOf("Android")>=0;let f=!1;if(v.$window.matchMedia){const b=v.$window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),u=v.$window.matchMedia("(display-mode: fullscreen)");f=b.matches,g(b,({matches:l})=>{f&&u.matches||(f=l)})}function s(){return f}t.$RO=s;function r(){return navigator?.windowControlsOverlay?.visible}t.$SO=r}),define(be[22],$e([1,0,4]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7Q=void 0;class N{get event(){return this.a.event}constructor(U,p,D){const c=g=>this.a.fire(g);this.a=new v.$Rd({onWillAddFirstListener:()=>U.addEventListener(p,c,D),onDidRemoveLastListener:()=>U.removeEventListener(p,c,D)})}dispose(){this.a.dispose()}}t.$7Q=N}),define(be[29],$e([1,0,4]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2d=t.CancellationToken=void 0;const N=Object.freeze(function(D,c){const g=setTimeout(D.bind(c),0);return{dispose(){clearTimeout(g)}}});var i;(function(D){function c(g){return g===D.None||g===D.Cancelled||g instanceof U?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}D.isCancellationToken=c,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(i||(t.CancellationToken=i={}));class U{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new v.$Rd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class p{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new U),this.f}cancel(){this.f?this.f instanceof U&&this.f.cancel():this.f=i.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof U&&this.f.dispose():this.f=i.None}}t.$2d=p}),define(be[84],$e([1,0,29]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ce=t.$Be=t.$Ae=void 0;class N{constructor(D){this.b=D,this.a=null}get(){if(this.a)return this.a;const D=new v.$2d,c=this.b(D.token);return this.a={promise:c,dispose:()=>{this.a=null,D.cancel(),D.dispose()}},this.a}}t.$Ae=N;class i{constructor(D){this.c=D,this.a=void 0,this.b=void 0}get(D){const c=JSON.stringify(D);return this.b!==c&&(this.b=c,this.a=this.c(D)),this.a}}t.$Be=i;class U{get cachedValues(){return this.a}constructor(D){this.b=D,this.a=new Map}get(D){if(this.a.has(D))return this.a.get(D);const c=this.b(D);return this.a.set(D,c),c}}t.$Ce=U}),define(be[48],$e([1,0,4,2]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6r=t.$5r=t.$4r=t.$3r=t.ScrollbarVisibility=void 0;var i;(function(o){o[o.Auto=1]="Auto",o[o.Hidden=2]="Hidden",o[o.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class U{constructor(e,h,a,f,s,r,b){this.c=e,this._scrollStateBrand=void 0,this.c&&(h=h|0,a=a|0,f=f|0,s=s|0,r=r|0,b=b|0),this.rawScrollLeft=f,this.rawScrollTop=b,h<0&&(h=0),f+h>a&&(f=a-h),f<0&&(f=0),s<0&&(s=0),b+s>r&&(b=r-s),b<0&&(b=0),this.width=h,this.scrollWidth=a,this.scrollLeft=f,this.height=s,this.scrollHeight=r,this.scrollTop=b}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,h){return new U(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,h?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,h?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new U(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,h){const a=this.width!==e.width,f=this.scrollWidth!==e.scrollWidth,s=this.scrollLeft!==e.scrollLeft,r=this.height!==e.height,b=this.scrollHeight!==e.scrollHeight,u=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:h,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:a,scrollWidthChanged:f,scrollLeftChanged:s,heightChanged:r,scrollHeightChanged:b,scrollTopChanged:u}}}t.$3r=U;class p extends N.$Rc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$Rd),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new U(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,h){const a=this.g.withScrollDimensions(e,h);this.n(a,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const h=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(h,!1)}setScrollPositionSmooth(e,h){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const a=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===a.scrollLeft&&this.h.to.scrollTop===a.scrollTop)return;let f;h?f=new m(this.h.from,a,this.h.startTime,this.h.duration):f=this.h.combine(this.g,a,this.c),this.h.dispose(),this.h=f}else{const a=this.g.withScrollPosition(e);this.h=m.start(this.g,a,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),h=this.g.withScrollPosition(e);if(this.n(h,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,h){const a=this.g;a.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(a,h)))}}t.$4r=p;class D{constructor(e,h,a){this.scrollLeft=e,this.scrollTop=h,this.isDone=a}}t.$5r=D;function c(o,e){const h=e-o;return function(a){return o+h*n(a)}}function g(o,e,h){return function(a){return a<h?o(a/h):e((a-h)/(1-h))}}class m{constructor(e,h,a,f){this.from=e,this.to=h,this.duration=f,this.startTime=a,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,h,a){if(Math.abs(e-h)>2.5*a){let s,r;return e<h?(s=e+.75*a,r=h-.75*a):(s=e-.75*a,r=h+.75*a),g(c(e,s),c(r,h),.33)}return c(e,h)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const h=(e-this.startTime)/this.duration;if(h<1){const a=this.c(h),f=this.d(h);return new D(a,f,!1)}return new D(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,h,a){return m.start(e,h,a)}static start(e,h,a){a=a+10;const f=Date.now()-10;return new m(e,h,f,a)}}t.$6r=m;function T(o){return Math.pow(o,3)}function n(o){return 1-T(1-o)}}),define(be[85],$e([1,0,6,2]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ee=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=void 0;function i(b){const u=b;return u?typeof u.read=="function":!1}t.$3d=i;function U(b){const u=b;return u?[u.on,u.pause,u.resume,u.destroy].every(l=>typeof l=="function"):!1}t.$4d=U;function p(b){const u=b;return u?U(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}t.$5d=p;function D(b,u){return new c(b,u)}t.$6d=D;class c{constructor(u,l){this.e=u,this.f=l,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(l=>this.d.push(l))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(l=>l(u))}h(u){this.c.error.length===0?(0,v.$Z)(u):this.c.error.slice(0).forEach(l=>l(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,l){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(l),this.resume();break;case"end":this.c.end.push(l),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(l),this.a.flowing&&this.k();break}}removeListener(u,l){if(this.a.destroyed)return;let F;switch(u){case"data":F=this.c.data;break;case"end":F=this.c.end;break;case"error":F=this.c.error;break}if(F){const z=F.indexOf(l);z>=0&&F.splice(z,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const l=[...this.d];this.d.length=0,l.forEach(F=>F())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(b,u){const l=[];let F;for(;(F=b.read())!==null;)l.push(F);return u(l)}t.$7d=g;function m(b,u,l){const F=[];let z;for(;(z=b.read())!==null&&F.length<l;)F.push(z);return z===null&&F.length>0?u(F):{read:()=>{if(F.length>0)return F.shift();if(typeof z<"u"){const L=z;return z=void 0,L}return b.read()}}}t.$8d=m;function T(b,u){return new Promise((l,F)=>{const z=[];n(b,{onData:L=>{u&&z.push(L)},onError:L=>{u?F(L):l(void 0)},onEnd:()=>{l(u?u(z):void 0)}})})}t.$9d=T;function n(b,u,l){b.on("error",F=>{l?.isCancellationRequested||u.onError(F)}),b.on("end",()=>{l?.isCancellationRequested||u.onEnd()}),b.on("data",F=>{l?.isCancellationRequested||u.onData(F)})}t.$0d=n;function o(b,u){return new Promise((l,F)=>{const z=new N.$Qc,L=[],d=V=>{if(L.push(V),L.length>u)return z.dispose(),b.pause(),l({stream:b,buffer:L,ended:!1})},y=V=>(z.dispose(),F(V)),M=()=>(z.dispose(),l({stream:b,buffer:L,ended:!0}));z.add((0,N.$Pc)(()=>b.removeListener("error",y))),b.on("error",y),z.add((0,N.$Pc)(()=>b.removeListener("end",M))),b.on("end",M),z.add((0,N.$Pc)(()=>b.removeListener("data",d))),b.on("data",d)})}t.$$d=o;function e(b,u){const l=D(u);return l.end(b),l}t.$_d=e;function h(){const b=D(()=>{throw new Error("not supported")});return b.end(),b}t.$ae=h;function a(b){let u=!1;return{read:()=>u?null:(u=!0,b)}}t.$be=a;function f(b,u,l){const F=D(l);return n(b,{onData:z=>F.write(u.data(z)),onError:z=>F.error(u.error?u.error(z):z),onEnd:()=>F.end()}),F}t.$ce=f;function s(b,u,l){let F=!1;return{read:()=>{const z=u.read();return F?z:(F=!0,z!==null?l([b,z]):b)}}}t.$de=s;function r(b,u,l){let F=!1;const z=D(l);return n(u,{onData:L=>F?z.write(L):(F=!0,z.write(l([b,L]))),onError:L=>z.error(L),onEnd:()=>{F||(F=!0,z.write(b)),z.end()}}),z}t.$ee=r}),define(be[33],$e([1,0,28,85]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=void 0;const i=typeof Buffer<"u",U=new v.$U(()=>new Uint8Array(256));let p,D;class c{static alloc(B){return i?new c(Buffer.allocUnsafe(B)):new c(new Uint8Array(B))}static wrap(B){return i&&!Buffer.isBuffer(B)&&(B=Buffer.from(B.buffer,B.byteOffset,B.byteLength)),new c(B)}static fromString(B,j){return!(j?.dontUseNodeBuffer||!1)&&i?new c(Buffer.from(B)):(p||(p=new TextEncoder),new c(p.encode(B)))}static fromByteArray(B){const j=c.alloc(B.length);for(let ie=0,te=B.length;ie<te;ie++)j.buffer[ie]=B[ie];return j}static concat(B,j){if(typeof j>"u"){j=0;for(let ue=0,le=B.length;ue<le;ue++)j+=B[ue].byteLength}const ie=c.alloc(j);let te=0;for(let ue=0,le=B.length;ue<le;ue++){const oe=B[ue];ie.set(oe,te),te+=oe.byteLength}return ie}constructor(B){this.buffer=B,this.byteLength=this.buffer.byteLength}clone(){const B=c.alloc(this.byteLength);return B.set(this),B}toString(){return i?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(B,j){return new c(this.buffer.subarray(B,j))}set(B,j){if(B instanceof c)this.buffer.set(B.buffer,j);else if(B instanceof Uint8Array)this.buffer.set(B,j);else if(B instanceof ArrayBuffer)this.buffer.set(new Uint8Array(B),j);else if(ArrayBuffer.isView(B))this.buffer.set(new Uint8Array(B.buffer,B.byteOffset,B.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(B){return n(this.buffer,B)}writeUInt32BE(B,j){o(this.buffer,B,j)}readUInt32LE(B){return e(this.buffer,B)}writeUInt32LE(B,j){h(this.buffer,B,j)}readUInt8(B){return a(this.buffer,B)}writeUInt8(B,j){f(this.buffer,B,j)}indexOf(B,j=0){return g(this.buffer,B instanceof c?B.buffer:B,j)}}t.$fe=c;function g(R,B,j=0){const ie=B.byteLength,te=R.byteLength;if(ie===0)return 0;if(ie===1)return R.indexOf(B[0]);if(ie>te-j)return-1;const ue=U.value;ue.fill(B.length);for(let Fe=0;Fe<B.length;Fe++)ue[B[Fe]]=B.length-Fe-1;let le=j+B.length-1,oe=le,we=-1;for(;le<te;)if(R[le]===B[oe]){if(oe===0){we=le;break}le--,oe--}else le+=Math.max(B.length-oe,ue[R[le]]),oe=B.length-1;return we}t.$ge=g;function m(R,B){return R[B+0]<<0>>>0|R[B+1]<<8>>>0}t.$he=m;function T(R,B,j){R[j+0]=B&255,B=B>>>8,R[j+1]=B&255}t.$ie=T;function n(R,B){return R[B]*2**24+R[B+1]*2**16+R[B+2]*2**8+R[B+3]}t.$je=n;function o(R,B,j){R[j+3]=B,B=B>>>8,R[j+2]=B,B=B>>>8,R[j+1]=B,B=B>>>8,R[j]=B}t.$ke=o;function e(R,B){return R[B+0]<<0>>>0|R[B+1]<<8>>>0|R[B+2]<<16>>>0|R[B+3]<<24>>>0}t.$le=e;function h(R,B,j){R[j+0]=B&255,B=B>>>8,R[j+1]=B&255,B=B>>>8,R[j+2]=B&255,B=B>>>8,R[j+3]=B&255}t.$me=h;function a(R,B){return R[B]}t.$ne=a;function f(R,B,j){R[j]=B}t.$oe=f;function s(R){return N.$7d(R,B=>c.concat(B))}t.$pe=s;function r(R){return N.$be(R)}t.$qe=r;function b(R){return N.$9d(R,B=>c.concat(B))}t.$re=b;async function u(R){return R.ended?c.concat(R.buffer):c.concat([...R.buffer,await b(R.stream)])}t.$se=u;function l(R){return N.$_d(R,B=>c.concat(B))}t.$te=l;function F(R){return N.$ce(R,{data:B=>typeof B=="string"?c.fromString(B):c.wrap(B)},B=>c.concat(B))}t.$ue=F;function z(R){return N.$6d(B=>c.concat(B),R)}t.$ve=z;function L(R,B){return N.$de(R,B,j=>c.concat(j))}t.$we=L;function d(R,B){return N.$ee(R,B,j=>c.concat(j))}t.$xe=d;function y(R){let B=0,j=0,ie=0;const te=new Uint8Array(Math.floor(R.length/4*3)),ue=oe=>{switch(j){case 3:te[ie++]=B|oe,j=0;break;case 2:te[ie++]=B|oe>>>2,B=oe<<6,j=3;break;case 1:te[ie++]=B|oe>>>4,B=oe<<4,j=2;break;default:B=oe<<2,j=1}};for(let oe=0;oe<R.length;oe++){const we=R.charCodeAt(oe);if(we>=65&&we<=90)ue(we-65);else if(we>=97&&we<=122)ue(we-97+26);else if(we>=48&&we<=57)ue(we-48+52);else if(we===43||we===45)ue(62);else if(we===47||we===95)ue(63);else{if(we===61)break;throw new SyntaxError(`Unexpected base64 character ${R[oe]}`)}}const le=ie;for(;j>0;)ue(0);return c.wrap(te).slice(0,le)}t.$ye=y;const M="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",V="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function x({buffer:R},B=!0,j=!1){const ie=j?V:M;let te="";const ue=R.byteLength%3;let le=0;for(;le<R.byteLength-ue;le+=3){const oe=R[le+0],we=R[le+1],Fe=R[le+2];te+=ie[oe>>>2],te+=ie[(oe<<4|we>>>4)&63],te+=ie[(we<<2|Fe>>>6)&63],te+=ie[Fe&63]}if(ue===1){const oe=R[le+0];te+=ie[oe>>>2],te+=ie[oe<<4&63],B&&(te+="==")}else if(ue===2){const oe=R[le+0],we=R[le+1];te+=ie[oe>>>2],te+=ie[(oe<<4|we>>>4)&63],te+=ie[we<<2&63],B&&(te+="=")}return te}t.$ze=x}),define(be[10],$e([1,0,84,28]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bf=t.$Af=t.$zf=t.$yf=t.GraphemeBreakType=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=void 0;function i(J){return!J||typeof J!="string"?!0:J.trim().length===0}t.$Fe=i;const U=/{(\d+)}/g;function p(J,...he){return he.length===0?J:J.replace(U,function(pe,Ee){const Pe=parseInt(Ee,10);return isNaN(Pe)||Pe<0||Pe>=he.length?pe:he[Pe]})}t.$Ge=p;const D=/{([^}]+)}/g;function c(J,he){return Object.keys(he).length===0?J:J.replace(D,(pe,Ee)=>he[Ee]??pe)}t.$He=c;function g(J){return J.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}t.$Ie=g;function m(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Je=m;function T(J,he){let pe=0;const Ee=he.charCodeAt(0);for(let Pe=J.length-1;Pe>=0;Pe--)J.charCodeAt(Pe)===Ee&&pe++;return pe}t.$Ke=T;function n(J,he,pe="\u2026"){return J.length<=he?J:`${J.substr(0,he)}${pe}`}t.$Le=n;function o(J,he=" "){const pe=e(J,he);return h(pe,he)}t.$Me=o;function e(J,he){if(!J||!he)return J;const pe=he.length;if(pe===0||J.length===0)return J;let Ee=0;for(;J.indexOf(he,Ee)===Ee;)Ee=Ee+pe;return J.substring(Ee)}t.$Ne=e;function h(J,he){if(!J||!he)return J;const pe=he.length,Ee=J.length;if(pe===0||Ee===0)return J;let Pe=Ee,Be=-1;for(;Be=J.lastIndexOf(he,Pe-1),!(Be===-1||Be+pe!==Pe);){if(Be===0)return"";Pe=Be}return J.substring(0,Pe)}t.$Oe=h;function a(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Pe=a;function f(J){return J.replace(/\*/g,"")}t.$Qe=f;function s(J,he,pe={}){if(!J)throw new Error("Cannot create regex from empty string");he||(J=m(J)),pe.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let Ee="";return pe.global&&(Ee+="g"),pe.matchCase||(Ee+="i"),pe.multiline&&(Ee+="m"),pe.unicode&&(Ee+="u"),new RegExp(J,Ee)}t.$Re=s;function r(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}t.$Se=r;function b(J){return J.split(/\r\n|\r|\n/)}t.$Te=b;function u(J){for(let he=0,pe=J.length;he<pe;he++){const Ee=J.charCodeAt(he);if(Ee!==32&&Ee!==9)return he}return-1}t.$Ue=u;function l(J,he=0,pe=J.length){for(let Ee=he;Ee<pe;Ee++){const Pe=J.charCodeAt(Ee);if(Pe!==32&&Pe!==9)return J.substring(he,Ee)}return J.substring(he,pe)}t.$Ve=l;function F(J,he=J.length-1){for(let pe=he;pe>=0;pe--){const Ee=J.charCodeAt(pe);if(Ee!==32&&Ee!==9)return pe}return-1}t.$We=F;function z(J,he,pe){const Ee=[];let Pe=0;for(const Be of J.matchAll(he)){if(Ee.push(J.slice(Pe,Be.index)),Be.index===void 0)throw new Error("match.index should be defined");Pe=Be.index+Be[0].length,Ee.push(pe(Be[0],...Be.slice(1),Be.index,J,Be.groups))}return Ee.push(J.slice(Pe)),Promise.all(Ee).then(Be=>Be.join(""))}t.$Xe=z;function L(J,he){return J<he?-1:J>he?1:0}t.$Ye=L;function d(J,he,pe=0,Ee=J.length,Pe=0,Be=he.length){for(;pe<Ee&&Pe<Be;pe++,Pe++){const Je=J.charCodeAt(pe),xe=he.charCodeAt(Pe);if(Je<xe)return-1;if(Je>xe)return 1}const Ue=Ee-pe,Ze=Be-Pe;return Ue<Ze?-1:Ue>Ze?1:0}t.$Ze=d;function y(J,he){return M(J,he,0,J.length,0,he.length)}t.$1e=y;function M(J,he,pe=0,Ee=J.length,Pe=0,Be=he.length){for(;pe<Ee&&Pe<Be;pe++,Pe++){let Je=J.charCodeAt(pe),xe=he.charCodeAt(Pe);if(Je===xe)continue;if(Je>=128||xe>=128)return d(J.toLowerCase(),he.toLowerCase(),pe,Ee,Pe,Be);x(Je)&&(Je-=32),x(xe)&&(xe-=32);const qe=Je-xe;if(qe!==0)return qe}const Ue=Ee-pe,Ze=Be-Pe;return Ue<Ze?-1:Ue>Ze?1:0}t.$2e=M;function V(J){return J>=48&&J<=57}t.$3e=V;function x(J){return J>=97&&J<=122}t.$4e=x;function R(J){return J>=65&&J<=90}t.$5e=R;function B(J,he){return J.length===he.length&&M(J,he)===0}t.$6e=B;function j(J,he){const pe=he.length;return he.length>J.length?!1:M(J,he,0,pe)===0}t.$7e=j;function ie(J,he){const pe=Math.min(J.length,he.length);let Ee;for(Ee=0;Ee<pe;Ee++)if(J.charCodeAt(Ee)!==he.charCodeAt(Ee))return Ee;return pe}t.$8e=ie;function te(J,he){const pe=Math.min(J.length,he.length);let Ee;const Pe=J.length-1,Be=he.length-1;for(Ee=0;Ee<pe;Ee++)if(J.charCodeAt(Pe-Ee)!==he.charCodeAt(Be-Ee))return Ee;return pe}t.$9e=te;function ue(J){return 55296<=J&&J<=56319}t.$0e=ue;function le(J){return 56320<=J&&J<=57343}t.$$e=le;function oe(J,he){return(J-55296<<10)+(he-56320)+65536}t.$_e=oe;function we(J,he,pe){const Ee=J.charCodeAt(pe);if(ue(Ee)&&pe+1<he){const Pe=J.charCodeAt(pe+1);if(le(Pe))return oe(Ee,Pe)}return Ee}t.$af=we;function Fe(J,he){const pe=J.charCodeAt(he-1);if(le(pe)&&he>1){const Ee=J.charCodeAt(he-2);if(ue(Ee))return oe(Ee,pe)}return pe}class ke{get offset(){return this.e}constructor(he,pe=0){this.c=he,this.d=he.length,this.e=pe}setOffset(he){this.e=he}prevCodePoint(){const he=Fe(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=we(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}t.$bf=ke;class Le{get offset(){return this.c.offset}constructor(he,pe=0){this.c=new ke(he,pe)}nextGraphemeLength(){const he=Ce.getInstance(),pe=this.c,Ee=pe.offset;let Pe=he.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Be=pe.offset,Ue=he.getGraphemeBreakType(pe.nextCodePoint());if(ve(Pe,Ue)){pe.setOffset(Be);break}Pe=Ue}return pe.offset-Ee}prevGraphemeLength(){const he=Ce.getInstance(),pe=this.c,Ee=pe.offset;let Pe=he.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Be=pe.offset,Ue=he.getGraphemeBreakType(pe.prevCodePoint());if(ve(Ue,Pe)){pe.setOffset(Be);break}Pe=Ue}return Ee-pe.offset}eol(){return this.c.eol()}}t.$cf=Le;function de(J,he){return new Le(J,he).nextGraphemeLength()}t.$df=de;function ne(J,he){return new Le(J,he).prevGraphemeLength()}t.$ef=ne;function ce(J,he){he>0&&le(J.charCodeAt(he))&&he--;const pe=he+de(J,he);return[pe-ne(J,pe),pe]}t.$ff=ce;function Z(J){const he=new Le(J);let pe=0;for(;!he.eol();)pe++,he.nextGraphemeLength();return pe}t.$gf=Z;let q;function X(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function C(J){return q||(q=X()),q.test(J)}t.$hf=C;const _=/^[\t\n\r\x20-\x7E]*$/;function $(J){return _.test(J)}t.$if=$,t.$jf=/[\u2028\u2029]/;function W(J){return t.$jf.test(J)}t.$kf=W;function Q(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}t.$lf=Q;function w(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}t.$mf=w;function A(J,he){if(J.length<he)return J;const pe=/\b/g;let Ee=0;for(;pe.test(J)&&!(J.length-pe.lastIndex<he);)Ee=pe.lastIndex,pe.lastIndex+=1;return J.substring(Ee).replace(/^\s/,"")}t.$nf=A;const E=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,I=/\x1b\].*?\x07/g;function k(J){return J&&(J=J.replace(E,"").replace(I,"")),J}t.$of=k,t.$pf=String.fromCharCode(65279);function O(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}t.$qf=O;function S(J){return O(J)?J.substr(1):J}t.$rf=S;function P(J,he){if(!J||!he||J.length<he.length)return!1;const pe=he.length,Ee=J.toLowerCase();let Pe=0,Be=-1;for(;Pe<pe;){const Ue=Ee.indexOf(he[Pe],Be+1);if(Ue<0)return!1;Be=Ue,Pe++}return!0}t.$sf=P;function H(J,he=!1){return J?(he&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}t.$tf=H;function G(J){return J.charAt(0).toUpperCase()+J.slice(1)}t.$uf=G;function ee(J,he=1){if(he===0)return"";let pe=-1;do pe=J.indexOf(`
`,pe+1),he--;while(he>0&&pe>=0);return pe===-1?J:(J[pe-1]==="\r"&&pe--,J.substr(0,pe))}t.$vf=ee;function se(J){return J=J%(2*26),J<26?String.fromCharCode(97+J):String.fromCharCode(65+J-26)}t.$wf=se;function me(J){return Ce.getInstance().getGraphemeBreakType(J)}t.$xf=me;function ve(J,he){return J===0?he!==5&&he!==7:J===2&&he===3?!1:J===4||J===2||J===3||he===4||he===2||he===3?!0:!(J===8&&(he===8||he===9||he===11||he===12)||(J===11||J===9)&&(he===9||he===10)||(J===12||J===10)&&he===10||he===5||he===13||he===7||J===1||J===13&&he===14||J===6&&he===6)}var Ne;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(Ne||(t.GraphemeBreakType=Ne={}));class Ce{static{this.c=null}static getInstance(){return Ce.c||(Ce.c=new Ce),Ce.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const pe=this.d,Ee=pe.length/3;let Pe=1;for(;Pe<=Ee;)if(he<pe[3*Pe])Pe=2*Pe;else if(he>pe[3*Pe+1])Pe=2*Pe+1;else return pe[3*Pe+2];return 0}}function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(J,he){if(J===0)return 0;const pe=Se(J,he);if(pe!==void 0)return pe;const Ee=new ke(he,J);return Ee.prevCodePoint(),Ee.offset}t.$yf=Te;function Se(J,he){const pe=new ke(he,J);let Ee=pe.prevCodePoint();for(;Ve(Ee)||Ee===65039||Ee===8419;){if(pe.offset===0)return;Ee=pe.prevCodePoint()}if(!w(Ee))return;let Pe=pe.offset;return Pe>0&&pe.prevCodePoint()===8205&&(Pe=pe.offset),Pe}function Ve(J){return 127995<=J&&J<=127999}var je;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),t.$zf="\xA0";class Me{static{this.c=new N.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new v.$Be(he=>{function pe(qe){const tt=new Map;for(let nt=0;nt<qe.length;nt+=2)tt.set(qe[nt],qe[nt+1]);return tt}function Ee(qe,tt){const nt=new Map(qe);for(const[dt,ft]of tt)nt.set(dt,ft);return nt}function Pe(qe,tt){if(!qe)return tt;const nt=new Map;for(const[dt,ft]of qe)tt.has(dt)&&nt.set(dt,ft);return nt}const Be=this.c.value;let Ue=he.filter(qe=>!qe.startsWith("_")&&qe in Be);Ue.length===0&&(Ue=["_default"]);let Ze;for(const qe of Ue){const tt=pe(Be[qe]);Ze=Pe(Ze,tt)}const Je=pe(Be._common),xe=Ee(Je,Ze);return new Me(xe)})}static getInstance(he){return Me.d.get(Array.from(he))}static{this.e=new N.$U(()=>Object.keys(Me.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return Me.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Af=Me;class Qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Qe.c())),this.d}static isInvisibleCharacter(he){return Qe.e().has(he)}static get codePoints(){return Qe.e()}}t.$Bf=Qe}),define(be[34],$e([1,0,32,10]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zj=t.$Yj=t.$Xj=t.$Wj=t.FuzzyScore=t.$Vj=t.$Uj=t.$Tj=t.$Sj=t.$Rj=t.$Qj=t.$Pj=t.$Oj=t.$Nj=t.$Mj=t.$Lj=t.$Kj=t.or=void 0;function i(...S){return function(P,H){for(let G=0,ee=S.length;G<ee;G++){const se=S[G](P,H);if(se)return se}return null}}t.or=i,t.$Kj=U.bind(void 0,!1),t.$Lj=U.bind(void 0,!0);function U(S,P,H){if(!H||H.length<P.length)return null;let G;return S?G=N.$7e(H,P):G=H.indexOf(P)===0,G?P.length>0?[{start:0,end:P.length}]:[]:null}function p(S,P){const H=P.toLowerCase().indexOf(S.toLowerCase());return H===-1?null:[{start:H,end:H+S.length}]}t.$Mj=p;function D(S,P){return c(S.toLowerCase(),P.toLowerCase(),0,0)}t.$Nj=D;function c(S,P,H,G){if(H===S.length)return[];if(G===P.length)return null;if(S[H]===P[G]){let ee=null;return(ee=c(S,P,H+1,G+1))?f({start:G,end:G+1},ee):null}return c(S,P,H,G+1)}function g(S){return 97<=S&&S<=122}function m(S){return 65<=S&&S<=90}t.$Oj=m;function T(S){return 48<=S&&S<=57}function n(S){return S===32||S===9||S===10||S===13}const o=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(S=>o.add(S.charCodeAt(0)));function e(S){return n(S)||o.has(S)}function h(S,P){return S===P||e(S)&&e(P)}function a(S){return g(S)||m(S)||T(S)}function f(S,P){return P.length===0?P=[S]:S.end===P[0].start?P[0].start=S.start:P.unshift(S),P}function s(S,P){for(let H=P;H<S.length;H++){const G=S.charCodeAt(H);if(m(G)||T(G)||H>0&&!a(S.charCodeAt(H-1)))return H}return S.length}function r(S,P,H,G){if(H===S.length)return[];if(G===P.length)return null;if(S[H]!==P[G].toLowerCase())return null;{let ee=null,se=G+1;for(ee=r(S,P,H+1,G+1);!ee&&(se=s(P,se))<P.length;)ee=r(S,P,H+1,se),se++;return ee===null?null:f({start:G,end:G+1},ee)}}function b(S){let P=0,H=0,G=0,ee=0,se=0;for(let De=0;De<S.length;De++)se=S.charCodeAt(De),m(se)&&P++,g(se)&&H++,a(se)&&G++,T(se)&&ee++;const me=P/S.length,ve=H/S.length,Ne=G/S.length,Ce=ee/S.length;return{upperPercent:me,lowerPercent:ve,alphaPercent:Ne,numericPercent:Ce}}function u(S){const{upperPercent:P,lowerPercent:H}=S;return H===0&&P>.6}function l(S){const{upperPercent:P,lowerPercent:H,alphaPercent:G,numericPercent:ee}=S;return H>.2&&P<.8&&G>.6&&ee<.2}function F(S){let P=0,H=0,G=0,ee=0;for(let se=0;se<S.length;se++)G=S.charCodeAt(se),m(G)&&P++,g(G)&&H++,n(G)&&ee++;return(P===0||H===0)&&ee===0?S.length<=30:P<=5}function z(S,P){if(!P||(P=P.trim(),P.length===0)||!F(S)||P.length>60)return null;const H=b(P);if(!l(H)){if(!u(H))return null;P=P.toLowerCase()}let G=null,ee=0;for(S=S.toLowerCase();ee<P.length&&(G=r(S,P,0,ee))===null;)ee=s(P,ee+1);return G}t.$Pj=z;function L(S,P,H=!1){if(!P||P.length===0)return null;let G=null,ee=0;for(S=S.toLowerCase(),P=P.toLowerCase();ee<P.length&&(G=d(S,P,0,ee,H))===null;)ee=y(P,ee+1);return G}t.$Qj=L;function d(S,P,H,G,ee){if(H===S.length)return[];if(G===P.length)return null;if(h(S.charCodeAt(H),P.charCodeAt(G))){let se=null,me=G+1;if(se=d(S,P,H+1,G+1,ee),!ee)for(;!se&&(me=y(P,me))<P.length;)se=d(S,P,H+1,me,ee),me++;return se?S.charCodeAt(H)!==P.charCodeAt(G)?se:f({start:G,end:G+1},se):null}else return null}function y(S,P){for(let H=P;H<S.length;H++)if(e(S.charCodeAt(H))||H>0&&e(S.charCodeAt(H-1)))return H;return S.length}const M=i(t.$Lj,z,p),V=i(t.$Lj,z,D),x=new v.$Cc(1e4);function R(S,P,H=!1){if(typeof S!="string"||typeof P!="string")return null;let G=x.get(S);G||(G=new RegExp(N.$Pe(S),"i"),x.set(S,G));const ee=G.exec(P);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:H?V(S,P):M(S,P)}t.$Rj=R;function B(S,P){const H=Q(S,S.toLowerCase(),0,P,P.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?ie(H):null}t.$Sj=B;function j(S,P,H,G,ee,se){const me=Math.min(13,S.length);for(;H<me;H++){const ve=Q(S,P,H,G,ee,se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ve)return ve}return[0,se]}t.$Tj=j;function ie(S){if(typeof S>"u")return[];const P=[],H=S[1];for(let G=S.length-1;G>1;G--){const ee=S[G]+H,se=P[P.length-1];se&&se.end===ee?se.end=ee+1:P.push({start:ee,end:ee+1})}return P}t.$Uj=ie;const te=128;function ue(){const S=[],P=[];for(let H=0;H<=te;H++)P[H]=0;for(let H=0;H<=te;H++)S.push(P.slice(0));return S}function le(S){const P=[];for(let H=0;H<=S;H++)P[H]=0;return P}const oe=le(2*te),we=le(2*te),Fe=ue(),ke=ue(),Le=ue(),de=!1;function ne(S,P,H,G,ee){function se(ve,Ne,Ce=" "){for(;ve.length<Ne;)ve=Ce+ve;return ve}let me=` |   |${G.split("").map(ve=>se(ve,3)).join("|")}
`;for(let ve=0;ve<=H;ve++)ve===0?me+=" |":me+=`${P[ve-1]}|`,me+=S[ve].slice(0,ee+1).map(Ne=>se(Ne.toString(),3)).join("|")+`
`;return me}function ce(S,P,H,G){S=S.substr(P),H=H.substr(G),console.log(ne(ke,S,S.length,H,H.length)),console.log(ne(Le,S,S.length,H,H.length)),console.log(ne(Fe,S,S.length,H,H.length))}function Z(S,P){if(P<0||P>=S.length)return!1;const H=S.codePointAt(P);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!N.$mf(H)}}function q(S,P){if(P<0||P>=S.length)return!1;switch(S.charCodeAt(P)){case 32:case 9:return!0;default:return!1}}function X(S,P,H){return P[S]!==H[S]}function C(S,P,H,G,ee,se,me=!1){for(;P<H&&ee<se;)S[P]===G[ee]&&(me&&(oe[P]=ee),P+=1),ee+=1;return P===H}t.$Vj=C;var _;(function(S){S[S.Diag=1]="Diag",S[S.Left=2]="Left",S[S.LeftLeft=3]="LeftLeft"})(_||(_={}));var $;(function(S){S.Default=[-100,0];function P(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}S.isDefault=P})($||(t.FuzzyScore=$={}));class W{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(P,H){this.firstMatchCanBeWeak=P,this.boostFullMatch=H}}t.$Wj=W;function Q(S,P,H,G,ee,se,me=W.default){const ve=S.length>te?te:S.length,Ne=G.length>te?te:G.length;if(H>=ve||se>=Ne||ve-H>Ne-se||!C(P,H,ve,ee,se,Ne,!0))return;w(ve,Ne,H,se,P,ee);let Ce=1,De=1,Te=H,Se=se;const Ve=[!1];for(Ce=1,Te=H;Te<ve;Ce++,Te++){const he=oe[Te],pe=we[Te],Ee=Te+1<ve?we[Te+1]:Ne;for(De=he-se+1,Se=he;Se<Ee;De++,Se++){let Pe=Number.MIN_SAFE_INTEGER,Be=!1;Se<=pe&&(Pe=A(S,P,Te,H,G,ee,Se,Ne,se,Fe[Ce-1][De-1]===0,Ve));let Ue=0;Pe!==Number.MAX_SAFE_INTEGER&&(Be=!0,Ue=Pe+ke[Ce-1][De-1]);const Ze=Se>he,Je=Ze?ke[Ce][De-1]+(Fe[Ce][De-1]>0?-5:0):0,xe=Se>he+1&&Fe[Ce][De-1]>0,qe=xe?ke[Ce][De-2]+(Fe[Ce][De-2]>0?-5:0):0;if(xe&&(!Ze||qe>=Je)&&(!Be||qe>=Ue))ke[Ce][De]=qe,Le[Ce][De]=3,Fe[Ce][De]=0;else if(Ze&&(!Be||Je>=Ue))ke[Ce][De]=Je,Le[Ce][De]=2,Fe[Ce][De]=0;else if(Be)ke[Ce][De]=Ue,Le[Ce][De]=1,Fe[Ce][De]=Fe[Ce-1][De-1]+1;else throw new Error("not possible")}}if(de&&ce(S,H,G,se),!Ve[0]&&!me.firstMatchCanBeWeak)return;Ce--,De--;const je=[ke[Ce][De],se];let Me=0,Qe=0;for(;Ce>=1;){let he=De;do{const pe=Le[Ce][he];if(pe===3)he=he-2;else if(pe===2)he=he-1;else break}while(he>=1);Me>1&&P[H+Ce-1]===ee[se+De-1]&&!X(he+se-1,G,ee)&&Me+1>Fe[Ce][he]&&(he=De),he===De?Me++:Me=1,Qe||(Qe=he),Ce--,De=he-1,je.push(De)}Ne===ve&&me.boostFullMatch&&(je[0]+=2);const J=Qe-ve;return je[0]-=J,je}t.$Xj=Q;function w(S,P,H,G,ee,se){let me=S-1,ve=P-1;for(;me>=H&&ve>=G;)ee[me]===se[ve]&&(we[me]=ve,me--),ve--}function A(S,P,H,G,ee,se,me,ve,Ne,Ce,De){if(P[H]!==se[me])return Number.MIN_SAFE_INTEGER;let Te=1,Se=!1;return me===H-G?Te=S[H]===ee[me]?7:5:X(me,ee,se)&&(me===0||!X(me-1,ee,se))?(Te=S[H]===ee[me]?7:5,Se=!0):Z(se,me)&&(me===0||!Z(se,me-1))?Te=5:(Z(se,me-1)||q(se,me-1))&&(Te=5,Se=!0),Te>1&&H===G&&(De[0]=!0),Se||(Se=X(me,ee,se)||Z(se,me-1)||q(se,me-1)),H===G?me>Ne&&(Te-=Se?3:5):Ce?Te+=Se?2:0:Te+=Se?0:1,me+1===ve&&(Te-=Se?3:5),Te}function E(S,P,H,G,ee,se,me){return k(S,P,H,G,ee,se,!0,me)}t.$Yj=E;function I(S,P,H,G,ee,se,me){return k(S,P,H,G,ee,se,!1,me)}t.$Zj=I;function k(S,P,H,G,ee,se,me,ve){let Ne=Q(S,P,H,G,ee,se,ve);if(Ne&&!me)return Ne;if(S.length>=3){const Ce=Math.min(7,S.length-1);for(let De=H+1;De<Ce;De++){const Te=O(S,De);if(Te){const Se=Q(Te,Te.toLowerCase(),H,G,ee,se,ve);Se&&(Se[0]-=3,(!Ne||Se[0]>Ne[0])&&(Ne=Se))}}}return Ne}function O(S,P){if(P+1>=S.length)return;const H=S[P],G=S[P+1];if(H!==G)return S.slice(0,P)+G+H+S.slice(P+2)}}),define(be[49],$e([1,0,10]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ri=t.$Qi=t.$Pi=t.$Oi=t.$Ni=t.$Mi=t.$Li=void 0;function N(f){return i(f,0)}t.$Li=N;function i(f,s){switch(typeof f){case"object":return f===null?U(349,s):Array.isArray(f)?c(f,s):g(f,s);case"string":return D(f,s);case"boolean":return p(f,s);case"number":return U(f,s);case"undefined":return U(937,s);default:return U(617,s)}}t.$Mi=i;function U(f,s){return(s<<5)-s+f|0}t.$Ni=U;function p(f,s){return U(f?433:863,s)}function D(f,s){s=U(149417,s);for(let r=0,b=f.length;r<b;r++)s=U(f.charCodeAt(r),s);return s}t.$Oi=D;function c(f,s){return s=U(104579,s),f.reduce((r,b)=>i(b,r),s)}function g(f,s){return s=U(181387,s),Object.keys(f).sort().reduce((r,b)=>(r=D(b,r),i(f[b],r)),s)}class m{constructor(){this.g=0}get value(){return this.g}hash(s){return this.g=i(s,this.g),this.g}}t.$Pi=m;var T;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function n(f,s,r=32){const b=r-s,u=~((1<<b)-1);return(f<<s|(u&f)>>>b)>>>0}function o(f,s=0,r=f.byteLength,b=0){for(let u=0;u<r;u++)f[s+u]=b}function e(f,s,r="0"){for(;f.length<s;)f=r+f;return f}function h(f,s=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(r=>r.toString(16).padStart(2,"0")).join(""):e((f>>>0).toString(16),s/4)}t.$Qi=h;class a{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(s){const r=s.length;if(r===0)return;const b=this.p;let u=this.r,l=this.u,F,z;for(l!==0?(F=l,z=-1,l=0):(F=s.charCodeAt(0),z=0);;){let L=F;if(v.$0e(F))if(z+1<r){const d=s.charCodeAt(z+1);v.$$e(d)?(z++,L=v.$_e(F,d)):L=65533}else{l=F;break}else v.$$e(F)&&(L=65533);if(u=this.w(b,u,L),z++,z<r)F=s.charCodeAt(z);else break}this.r=u,this.u=l}w(s,r,b){return b<128?s[r++]=b:b<2048?(s[r++]=192|(b&1984)>>>6,s[r++]=128|(b&63)>>>0):b<65536?(s[r++]=224|(b&61440)>>>12,s[r++]=128|(b&4032)>>>6,s[r++]=128|(b&63)>>>0):(s[r++]=240|(b&1835008)>>>18,s[r++]=128|(b&258048)>>>12,s[r++]=128|(b&4032)>>>6,s[r++]=128|(b&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,s[0]=s[64+0],s[1]=s[64+1],s[2]=s[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,o(this.p,this.r),this.r>56&&(this.y(),o(this.p));const s=8*this.t;this.q.setUint32(56,Math.floor(s/4294967296),!1),this.q.setUint32(60,s%4294967296,!1),this.y()}y(){const s=a.g,r=this.q;for(let M=0;M<64;M+=4)s.setUint32(M,r.getUint32(M,!1),!1);for(let M=64;M<320;M+=4)s.setUint32(M,n(s.getUint32(M-12,!1)^s.getUint32(M-32,!1)^s.getUint32(M-56,!1)^s.getUint32(M-64,!1),1),!1);let b=this.h,u=this.l,l=this.m,F=this.n,z=this.o,L,d,y;for(let M=0;M<80;M++)M<20?(L=u&l|~u&F,d=1518500249):M<40?(L=u^l^F,d=1859775393):M<60?(L=u&l|u&F|l&F,d=2400959708):(L=u^l^F,d=3395469782),y=n(b,5)+L+z+d+s.getUint32(M*4,!1)&4294967295,z=F,F=l,l=n(u,30),u=b,b=y;this.h=this.h+b&4294967295,this.l=this.l+u&4294967295,this.m=this.m+l&4294967295,this.n=this.n+F&4294967295,this.o=this.o+z&4294967295}}t.$Ri=a}),define(be[86],$e([1,0,75,49]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hs=t.$Gs=t.$Fs=void 0;class i{constructor(n){this.a=n}getElements(){const n=this.a,o=new Int32Array(n.length);for(let e=0,h=n.length;e<h;e++)o[e]=n.charCodeAt(e);return o}}t.$Fs=i;function U(T,n,o){return new m(new i(T),new i(n)).ComputeDiff(o).changes}t.$Gs=U;class p{static Assert(n,o){if(!n)throw new Error(o)}}class D{static Copy(n,o,e,h,a){for(let f=0;f<a;f++)e[h+f]=n[o+f]}static Copy2(n,o,e,h,a){for(let f=0;f<a;f++)e[h+f]=n[o+f]}}var c;(function(T){T[T.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(c||(c={}));class g{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new v.$Es(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(n,o){this.b=Math.min(this.b,n),this.c=Math.min(this.c,o),this.d++}AddModifiedElement(n,o){this.b=Math.min(this.b,n),this.c=Math.min(this.c,o),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class m{constructor(n,o,e=null){this.a=e,this.b=n,this.c=o;const[h,a,f]=m.o(n),[s,r,b]=m.o(o);this.d=f&&b,this.e=h,this.f=a,this.g=s,this.h=r,this.k=[],this.m=[]}static n(n){return n.length>0&&typeof n[0]=="string"}static o(n){const o=n.getElements();if(m.n(o)){const e=new Int32Array(o.length);for(let h=0,a=o.length;h<a;h++)e[h]=(0,N.$Oi)(o[h],0);return[o,e,!0]}return o instanceof Int32Array?[[],o,!1]:[[],new Int32Array(o),!1]}p(n,o){return this.f[n]!==this.h[o]?!1:this.d?this.e[n]===this.g[o]:!0}q(n,o){if(!this.p(n,o))return!1;const e=m.r(this.b,n),h=m.r(this.c,o);return e===h}static r(n,o){return typeof n.getStrictElement=="function"?n.getStrictElement(o):null}s(n,o){return this.f[n]!==this.f[o]?!1:this.d?this.e[n]===this.e[o]:!0}u(n,o){return this.h[n]!==this.h[o]?!1:this.d?this.g[n]===this.g[o]:!0}ComputeDiff(n){return this.v(0,this.f.length-1,0,this.h.length-1,n)}v(n,o,e,h,a){const f=[!1];let s=this.w(n,o,e,h,f);return a&&(s=this.z(s)),{quitEarly:f[0],changes:s}}w(n,o,e,h,a){for(a[0]=!1;n<=o&&e<=h&&this.p(n,e);)n++,e++;for(;o>=n&&h>=e&&this.p(o,h);)o--,h--;if(n>o||e>h){let l;return e<=h?(p.Assert(n===o+1,"originalStart should only be one more than originalEnd"),l=[new v.$Es(n,0,e,h-e+1)]):n<=o?(p.Assert(e===h+1,"modifiedStart should only be one more than modifiedEnd"),l=[new v.$Es(n,o-n+1,e,0)]):(p.Assert(n===o+1,"originalStart should only be one more than originalEnd"),p.Assert(e===h+1,"modifiedStart should only be one more than modifiedEnd"),l=[]),l}const f=[0],s=[0],r=this.y(n,o,e,h,f,s,a),b=f[0],u=s[0];if(r!==null)return r;if(!a[0]){const l=this.w(n,b,e,u,a);let F=[];return a[0]?F=[new v.$Es(b+1,o-(b+1)+1,u+1,h-(u+1)+1)]:F=this.w(b+1,o,u+1,h,a),this.H(l,F)}return[new v.$Es(n,o-n+1,e,h-e+1)]}x(n,o,e,h,a,f,s,r,b,u,l,F,z,L,d,y,M,V){let x=null,R=null,B=new g,j=o,ie=e,te=z[0]-y[0]-h,ue=-1073741824,le=this.k.length-1;do{const oe=te+n;oe===j||oe<ie&&b[oe-1]<b[oe+1]?(l=b[oe+1],L=l-te-h,l<ue&&B.MarkNextChange(),ue=l,B.AddModifiedElement(l+1,L),te=oe+1-n):(l=b[oe-1]+1,L=l-te-h,l<ue&&B.MarkNextChange(),ue=l-1,B.AddOriginalElement(l,L+1),te=oe-1-n),le>=0&&(b=this.k[le],n=b[0],j=1,ie=b.length-1)}while(--le>=-1);if(x=B.getReverseChanges(),V[0]){let oe=z[0]+1,we=y[0]+1;if(x!==null&&x.length>0){const Fe=x[x.length-1];oe=Math.max(oe,Fe.getOriginalEnd()),we=Math.max(we,Fe.getModifiedEnd())}R=[new v.$Es(oe,F-oe+1,we,d-we+1)]}else{B=new g,j=f,ie=s,te=z[0]-y[0]-r,ue=1073741824,le=M?this.m.length-1:this.m.length-2;do{const oe=te+a;oe===j||oe<ie&&u[oe-1]>=u[oe+1]?(l=u[oe+1]-1,L=l-te-r,l>ue&&B.MarkNextChange(),ue=l+1,B.AddOriginalElement(l+1,L+1),te=oe+1-a):(l=u[oe-1],L=l-te-r,l>ue&&B.MarkNextChange(),ue=l,B.AddModifiedElement(l+1,L+1),te=oe-1-a),le>=0&&(u=this.m[le],a=u[0],j=1,ie=u.length-1)}while(--le>=-1);R=B.getChanges()}return this.H(x,R)}y(n,o,e,h,a,f,s){let r=0,b=0,u=0,l=0,F=0,z=0;n--,e--,a[0]=0,f[0]=0,this.k=[],this.m=[];const L=o-n+(h-e),d=L+1,y=new Int32Array(d),M=new Int32Array(d),V=h-e,x=o-n,R=n-e,B=o-h,ie=(x-V)%2===0;y[V]=n,M[x]=o,s[0]=!1;for(let te=1;te<=L/2+1;te++){let ue=0,le=0;u=this.J(V-te,te,V,d),l=this.J(V+te,te,V,d);for(let we=u;we<=l;we+=2){we===u||we<l&&y[we-1]<y[we+1]?r=y[we+1]:r=y[we-1]+1,b=r-(we-V)-R;const Fe=r;for(;r<o&&b<h&&this.p(r+1,b+1);)r++,b++;if(y[we]=r,r+b>ue+le&&(ue=r,le=b),!ie&&Math.abs(we-x)<=te-1&&r>=M[we])return a[0]=r,f[0]=b,Fe<=M[we]&&1447>0&&te<=1447+1?this.x(V,u,l,R,x,F,z,B,y,M,r,o,a,b,h,f,ie,s):null}const oe=(ue-n+(le-e)-te)/2;if(this.a!==null&&!this.a(ue,oe))return s[0]=!0,a[0]=ue,f[0]=le,oe>0&&1447>0&&te<=1447+1?this.x(V,u,l,R,x,F,z,B,y,M,r,o,a,b,h,f,ie,s):(n++,e++,[new v.$Es(n,o-n+1,e,h-e+1)]);F=this.J(x-te,te,x,d),z=this.J(x+te,te,x,d);for(let we=F;we<=z;we+=2){we===F||we<z&&M[we-1]>=M[we+1]?r=M[we+1]-1:r=M[we-1],b=r-(we-x)-B;const Fe=r;for(;r>n&&b>e&&this.p(r,b);)r--,b--;if(M[we]=r,ie&&Math.abs(we-V)<=te&&r<=y[we])return a[0]=r,f[0]=b,Fe>=y[we]&&1447>0&&te<=1447+1?this.x(V,u,l,R,x,F,z,B,y,M,r,o,a,b,h,f,ie,s):null}if(te<=1447){let we=new Int32Array(l-u+2);we[0]=V-u+1,D.Copy2(y,u,we,1,l-u+1),this.k.push(we),we=new Int32Array(z-F+2),we[0]=x-F+1,D.Copy2(M,F,we,1,z-F+1),this.m.push(we)}}return this.x(V,u,l,R,x,F,z,B,y,M,r,o,a,b,h,f,ie,s)}z(n){for(let o=0;o<n.length;o++){const e=n[o],h=o<n.length-1?n[o+1].originalStart:this.f.length,a=o<n.length-1?n[o+1].modifiedStart:this.h.length,f=e.originalLength>0,s=e.modifiedLength>0;for(;e.originalStart+e.originalLength<h&&e.modifiedStart+e.modifiedLength<a&&(!f||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!s||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const b=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!b)break;e.originalStart++,e.modifiedStart++}const r=[null];if(o<n.length-1&&this.I(n[o],n[o+1],r)){n[o]=r[0],n.splice(o+1,1),o--;continue}}for(let o=n.length-1;o>=0;o--){const e=n[o];let h=0,a=0;if(o>0){const l=n[o-1];h=l.originalStart+l.originalLength,a=l.modifiedStart+l.modifiedLength}const f=e.originalLength>0,s=e.modifiedLength>0;let r=0,b=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let l=1;;l++){const F=e.originalStart-l,z=e.modifiedStart-l;if(F<h||z<a||f&&!this.s(F,F+e.originalLength)||s&&!this.u(z,z+e.modifiedLength))break;const d=(F===h&&z===a?5:0)+this.G(F,e.originalLength,z,e.modifiedLength);d>b&&(b=d,r=l)}e.originalStart-=r,e.modifiedStart-=r;const u=[null];if(o>0&&this.I(n[o-1],n[o],u)){n[o-1]=u[0],n.splice(o,1),o++;continue}}if(this.d)for(let o=1,e=n.length;o<e;o++){const h=n[o-1],a=n[o],f=a.originalStart-h.originalStart-h.originalLength,s=h.originalStart,r=a.originalStart+a.originalLength,b=r-s,u=h.modifiedStart,l=a.modifiedStart+a.modifiedLength,F=l-u;if(f<5&&b<20&&F<20){const z=this.A(s,b,u,F,f);if(z){const[L,d]=z;(L!==h.originalStart+h.originalLength||d!==h.modifiedStart+h.modifiedLength)&&(h.originalLength=L-h.originalStart,h.modifiedLength=d-h.modifiedStart,a.originalStart=L+f,a.modifiedStart=d+f,a.originalLength=r-a.originalStart,a.modifiedLength=l-a.modifiedStart)}}}return n}A(n,o,e,h,a){if(o<a||h<a)return null;const f=n+o-a+1,s=e+h-a+1;let r=0,b=0,u=0;for(let l=n;l<f;l++)for(let F=e;F<s;F++){const z=this.B(l,F,a);z>0&&z>r&&(r=z,b=l,u=F)}return r>0?[b,u]:null}B(n,o,e){let h=0;for(let a=0;a<e;a++){if(!this.p(n+a,o+a))return 0;h+=this.e[n+a].length}return h}C(n){return n<=0||n>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[n])}D(n,o){if(this.C(n)||this.C(n-1))return!0;if(o>0){const e=n+o;if(this.C(e-1)||this.C(e))return!0}return!1}E(n){return n<=0||n>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[n])}F(n,o){if(this.E(n)||this.E(n-1))return!0;if(o>0){const e=n+o;if(this.E(e-1)||this.E(e))return!0}return!1}G(n,o,e,h){const a=this.D(n,o)?1:0,f=this.F(e,h)?1:0;return a+f}H(n,o){const e=[];if(n.length===0||o.length===0)return o.length>0?o:n;if(this.I(n[n.length-1],o[0],e)){const h=new Array(n.length+o.length-1);return D.Copy(n,0,h,0,n.length-1),h[n.length-1]=e[0],D.Copy(o,1,h,n.length,o.length-1),h}else{const h=new Array(n.length+o.length);return D.Copy(n,0,h,0,n.length),D.Copy(o,0,h,n.length,o.length),h}}I(n,o,e){if(p.Assert(n.originalStart<=o.originalStart,"Left change is not less than or equal to right change"),p.Assert(n.modifiedStart<=o.modifiedStart,"Left change is not less than or equal to right change"),n.originalStart+n.originalLength>=o.originalStart||n.modifiedStart+n.modifiedLength>=o.modifiedStart){const h=n.originalStart;let a=n.originalLength;const f=n.modifiedStart;let s=n.modifiedLength;return n.originalStart+n.originalLength>=o.originalStart&&(a=o.originalStart+o.originalLength-n.originalStart),n.modifiedStart+n.modifiedLength>=o.modifiedStart&&(s=o.modifiedStart+o.modifiedLength-n.modifiedStart),e[0]=new v.$Es(h,a,f,s),!0}else return e[0]=null,!1}J(n,o,e,h){if(n>=0&&n<h)return n;const a=e,f=h-e-1,s=o%2===0;if(n<0){const r=a%2===0;return s===r?0:1}else{const r=f%2===0;return s===r?h-1:h-2}}}t.$Hs=m}),define(be[50],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Od=void 0,t.$Od=Symbol("MicrotaskDelay")}),define(be[87],$e([1,0,12,10]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4h=t.$3h=t.$2h=t.$1h=t.$Zh=void 0;class i{constructor(){this.b="",this.c=0}reset(o){return this.b=o,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(o){const e=o.charCodeAt(0),h=this.b.charCodeAt(this.c);return e-h}value(){return this.b[this.c]}}t.$Zh=i;class U{constructor(o=!0){this.e=o}reset(o){return this.b=o,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let o=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(o)this.c++;else break;else o=!1;return this}cmp(o){return this.e?(0,N.$Ze)(o,this.b,0,o.length,this.c,this.d):(0,N.$2e)(o,this.b,0,o.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$1h=U;class p{constructor(o=!0,e=!0){this.f=o,this.g=e}reset(o){this.d=0,this.e=0,this.b=o,this.c=o.length;for(let e=o.length-1;e>=0;e--,this.c--){const h=this.b.charCodeAt(e);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let o=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(o)this.d++;else break;else o=!1}return this}cmp(o){return this.g?(0,N.$Ze)(o,this.b,0,o.length,this.d,this.e):(0,N.$2e)(o,this.b,0,o.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$2h=p;var D;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(D||(D={}));class c{constructor(o,e){this.f=o,this.g=e,this.d=[],this.e=0}reset(o){return this.c=o,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new p(!1,!this.f(o)),this.b.reset(o.path),this.b.value()&&this.d.push(3)),this.g(o)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(o){if(this.d[this.e]===1)return(0,N.$1e)(o,this.c.scheme);if(this.d[this.e]===2)return(0,N.$1e)(o,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(o);if(this.d[this.e]===4)return(0,N.$Ye)(o,this.c.query);if(this.d[this.e]===5)return(0,N.$Ye)(o,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$3h=c;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const o=this.right;return this.right=o.left,o.left=this,this.updateHeight(),o.updateHeight(),o}rotateRight(){const o=this.left;return this.left=o.right,o.right=this,this.updateHeight(),o.updateHeight(),o}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(m||(m={}));class T{static forUris(o=()=>!1,e=()=>!1){return new T(new c(o,e))}static forPaths(o=!1){return new T(new p(void 0,!o))}static forStrings(){return new T(new i)}static forConfigKeys(){return new T(new U)}constructor(o){this.b=o}clear(){this.c=void 0}fill(o,e){if(e){const h=e.slice(0);(0,v.$Wb)(h);for(const a of h)this.set(a,o)}else{const h=o.slice(0);(0,v.$Wb)(h);for(const a of h)this.set(a[0],a[1])}}set(o,e){const h=this.b.reset(o);let a;this.c||(this.c=new g,this.c.segment=h.value());const f=[];for(a=this.c;;){const r=h.cmp(a.segment);if(r>0)a.left||(a.left=new g,a.left.segment=h.value()),f.push([-1,a]),a=a.left;else if(r<0)a.right||(a.right=new g,a.right.segment=h.value()),f.push([1,a]),a=a.right;else if(h.hasNext())h.next(),a.mid||(a.mid=new g,a.mid.segment=h.value()),f.push([0,a]),a=a.mid;else break}const s=a.value;a.value=e,a.key=o;for(let r=f.length-1;r>=0;r--){const b=f[r][1];b.updateHeight();const u=b.balanceFactor();if(u<-1||u>1){const l=f[r][0],F=f[r+1][0];if(l===1&&F===1)f[r][1]=b.rotateLeft();else if(l===-1&&F===-1)f[r][1]=b.rotateRight();else if(l===1&&F===-1)b.right=f[r+1][1]=f[r+1][1].rotateRight(),f[r][1]=b.rotateLeft();else if(l===-1&&F===1)b.left=f[r+1][1]=f[r+1][1].rotateLeft(),f[r][1]=b.rotateRight();else throw new Error;if(r>0)switch(f[r-1][0]){case-1:f[r-1][1].left=f[r][1];break;case 1:f[r-1][1].right=f[r][1];break;case 0:f[r-1][1].mid=f[r][1];break}else this.c=f[0][1]}}return s}get(o){return this.d(o)?.value}d(o){const e=this.b.reset(o);let h=this.c;for(;h;){const a=e.cmp(h.segment);if(a>0)h=h.left;else if(a<0)h=h.right;else if(e.hasNext())e.next(),h=h.mid;else break}return h}has(o){const e=this.d(o);return!(e?.value===void 0&&e?.mid===void 0)}delete(o){return this.e(o,!1)}deleteSuperstr(o){return this.e(o,!0)}e(o,e){const h=this.b.reset(o),a=[];let f=this.c;for(;f;){const s=h.cmp(f.segment);if(s>0)a.push([-1,f]),f=f.left;else if(s<0)a.push([1,f]),f=f.right;else if(h.hasNext())h.next(),a.push([0,f]),f=f.mid;else break}if(f){if(e?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const s=this.f(f.right);if(s.key){const{key:r,value:b,segment:u}=s;this.e(s.key,!1),f.key=r,f.value=b,f.segment=u}}else{const s=f.left??f.right;if(a.length>0){const[r,b]=a[a.length-1];switch(r){case-1:b.left=s;break;case 0:b.mid=s;break;case 1:b.right=s;break}}else this.c=s}for(let s=a.length-1;s>=0;s--){const r=a[s][1];r.updateHeight();const b=r.balanceFactor();if(b>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),a[s][1]=r.rotateLeft()):b<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),a[s][1]=r.rotateRight()),s>0)switch(a[s-1][0]){case-1:a[s-1][1].left=a[s][1];break;case 1:a[s-1][1].right=a[s][1];break;case 0:a[s-1][1].mid=a[s][1];break}else this.c=a[0][1]}}}f(o){for(;o.left;)o=o.left;return o}findSubstr(o){const e=this.b.reset(o);let h=this.c,a;for(;h;){const f=e.cmp(h.segment);if(f>0)h=h.left;else if(f<0)h=h.right;else if(e.hasNext())e.next(),a=h.value||a,h=h.mid;else break}return h&&h.value||a}findSuperstr(o){return this.g(o,!1)}g(o,e){const h=this.b.reset(o);let a=this.c;for(;a;){const f=h.cmp(a.segment);if(f>0)a=a.left;else if(f<0)a=a.right;else if(h.hasNext())h.next(),a=a.mid;else return a.mid?this.h(a.mid):e?a.value:void 0}}hasElementOrSubtree(o){return this.g(o,!0)!==void 0}forEach(o){for(const[e,h]of this)o(h,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(o){const e=[];return this.j(o,e),e[Symbol.iterator]()}j(o,e){o&&(o.left&&this.j(o.left,e),o.value&&e.push([o.key,o.value]),o.mid&&this.j(o.mid,e),o.right&&this.j(o.right,e))}_isBalanced(){const o=e=>{if(!e)return!0;const h=e.balanceFactor();return h<-1||h>1?!1:o(e.left)&&o(e.right)};return o(this.c)}}t.$4h=T}),define(be[7],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=void 0;function v(u){return typeof u=="string"}t.$Cf=v;function N(u){return Array.isArray(u)&&u.every(l=>v(l))}t.$Df=N;function i(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}t.$Ef=i;function U(u){const l=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof l}t.$Ff=U;function p(u){return typeof u=="number"&&!isNaN(u)}t.$Gf=p;function D(u){return!!u&&typeof u[Symbol.iterator]=="function"}t.$Hf=D;function c(u){return u===!0||u===!1}t.$If=c;function g(u){return typeof u>"u"}t.$Jf=g;function m(u){return!T(u)}t.$Kf=m;function T(u){return g(u)||u===null}t.$Lf=T;function n(u,l){if(!u)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}t.$Mf=n;function o(u){if(T(u))throw new Error("Assertion Failed: argument is undefined or null");return u}t.$Nf=o;function e(...u){const l=[];for(let F=0;F<u.length;F++){const z=u[F];if(T(z))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);l.push(z)}return l}t.$Of=e;const h=Object.prototype.hasOwnProperty;function a(u){if(!i(u))return!1;for(const l in u)if(h.call(u,l))return!1;return!0}t.$Pf=a;function f(u){return typeof u=="function"}t.$Qf=f;function s(...u){return u.length>0&&u.every(f)}t.$Rf=s;function r(u,l){const F=Math.min(u.length,l.length);for(let z=0;z<F;z++)b(u[z],l[z])}t.$Sf=r;function b(u,l){if(v(l)){if(typeof u!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(f(l)){try{if(u instanceof l)return}catch{}if(!T(u)&&u.constructor===l||l.length===1&&l.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Tf=b}),define(be[17],$e([1,0,7]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3j=t.$2j=t.$1j=void 0;const N=Object.create(null);function i(D,c){if((0,v.$Cf)(c)){const g=N[c];if(g===void 0)throw new Error(`${D} references an unknown codicon: ${c}`);c=g}return N[D]=c,{id:D}}function U(){return N}t.$1j=U;function p(){return Object.values(t.$3j)}t.$2j=p,t.$3j={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),thumbsDownFilled:i("thumbsdown-filled",60435),thumbsUpFilled:i("thumbsup-filled",60436),coffee:i("coffee",60437),snake:i("snake",60438),game:i("game",60439),vr:i("vr",60440),chip:i("chip",60441),piano:i("piano",60442),music:i("music",60443),micFilled:i("mic-filled",60444),gitFetch:i("git-fetch",60445),copilot:i("copilot",60446),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(be[51],$e([1,0,7]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nn=t.$mn=t.$ln=t.$kn=t.$jn=t.$in=t.$hn=t.$gn=t.$fn=t.$en=t.$dn=t.$cn=void 0;function N(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const s=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([r,b])=>{s[r]=b&&typeof b=="object"?N(b):b}),s}t.$cn=N;function i(f){if(!f||typeof f!="object")return f;const s=[f];for(;s.length>0;){const r=s.shift();Object.freeze(r);for(const b in r)if(U.call(r,b)){const u=r[b];typeof u=="object"&&!Object.isFrozen(u)&&!(0,v.$Ff)(u)&&s.push(u)}}return f}t.$dn=i;const U=Object.prototype.hasOwnProperty;function p(f,s){return D(f,s,new Set)}t.$en=p;function D(f,s,r){if((0,v.$Lf)(f))return f;const b=s(f);if(typeof b<"u")return b;if(Array.isArray(f)){const u=[];for(const l of f)u.push(D(l,s,r));return u}if((0,v.$Ef)(f)){if(r.has(f))throw new Error("Cannot clone recursive data-structure");r.add(f);const u={};for(const l in f)U.call(f,l)&&(u[l]=D(f[l],s,r));return r.delete(f),u}return f}function c(f,s,r=!0){return(0,v.$Ef)(f)?((0,v.$Ef)(s)&&Object.keys(s).forEach(b=>{b in f?r&&((0,v.$Ef)(f[b])&&(0,v.$Ef)(s[b])?c(f[b],s[b],r):f[b]=s[b]):f[b]=s[b]}),f):s}t.$fn=c;function g(f,s){if(f===s)return!0;if(f==null||s===null||s===void 0||typeof f!=typeof s||typeof f!="object"||Array.isArray(f)!==Array.isArray(s))return!1;let r,b;if(Array.isArray(f)){if(f.length!==s.length)return!1;for(r=0;r<f.length;r++)if(!g(f[r],s[r]))return!1}else{const u=[];for(b in f)u.push(b);u.sort();const l=[];for(b in s)l.push(b);if(l.sort(),!g(u,l))return!1;for(r=0;r<u.length;r++)if(!g(f[u[r]],s[u[r]]))return!1}return!0}t.$gn=g;function m(f){const s=new Set;return JSON.stringify(f,(r,b)=>{if((0,v.$Ef)(b)||Array.isArray(b)){if(s.has(b))return"[Circular]";s.add(b)}return b})}t.$hn=m;function T(f,s){const r=Object.create(null);return!f||!s||Object.keys(s).forEach(u=>{const l=f[u],F=s[u];g(l,F)||(r[u]=F)}),r}t.$in=T;function n(f,s){const r=s.toLowerCase(),b=Object.keys(f).find(u=>u.toLowerCase()===r);return b?f[b]:f[s]}t.$jn=n;function o(f,s){const r=Object.create(null);for(const[b,u]of Object.entries(f))s(b,u)&&(r[b]=u);return r}t.$kn=o;function e(f){let s=[];for(;Object.prototype!==f;)s=s.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return s}t.$ln=e;function h(f){const s=[];for(const r of e(f))typeof f[r]=="function"&&s.push(r);return s}t.$mn=h;function a(f,s){const r=u=>function(){const l=Array.prototype.slice.call(arguments,0);return s(u,l)},b={};for(const u of f)b[u]=r(u);return b}t.$nn=a}),define(be[18],$e([1,0,17]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$4j=t.ThemeColor=void 0;var N;(function(p){function D(c){return c&&typeof c=="object"&&typeof c.id=="string"}p.isThemeColor=D})(N||(t.ThemeColor=N={}));function i(p){return{id:p}}t.$4j=i;var U;(function(p){p.iconNameSegment="[A-Za-z0-9]+",p.iconNameExpression="[A-Za-z0-9-]+",p.iconModifierExpression="~[A-Za-z]+",p.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${p.iconNameExpression})(${p.iconModifierExpression})?$`);function c(s){const r=D.exec(s.id);if(!r)return c(v.$3j.error);const[,b,u]=r,l=["codicon","codicon-"+b];return u&&l.push("codicon-modifier-"+u.substring(1)),l}p.asClassNameArray=c;function g(s){return c(s).join(" ")}p.asClassName=g;function m(s){return"."+c(s).join(".")}p.asCSSSelector=m;function T(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||N.isThemeColor(s.color))}p.isThemeIcon=T;const n=new RegExp(`^\\$\\((${p.iconNameExpression}(?:${p.iconModifierExpression})?)\\)$`);function o(s){const r=n.exec(s);if(!r)return;const[,b]=r;return{id:b}}p.fromString=o;function e(s){return{id:s}}p.fromId=e;function h(s,r){let b=s.id;const u=b.lastIndexOf("~");return u!==-1&&(b=b.substring(0,u)),r&&(b=`${b}~${r}`),{id:b}}p.modify=h;function a(s){const r=s.id.lastIndexOf("~");if(r!==-1)return s.id.substring(r+1)}p.getModifier=a;function f(s,r){return s.id===r.id&&s.color?.id===r.color?.id}p.isEqual=f})(U||(t.ThemeIcon=U={}))}),define(be[35],$e([1,0,34,10,18]),function(ae,t,v,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0j=t.$9j=t.$8j=t.$7j=t.$6j=t.$5j=void 0;const U="$(",p=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(`(\\\\)?${p.source}`,"g");function c(f){return f.replace(D,(s,r)=>r?s:`\\${s}`)}t.$5j=c;const g=new RegExp(`\\\\${p.source}`,"g");function m(f){return f.replace(g,s=>`\\${s}`)}t.$6j=m;const T=new RegExp(`(\\s)?(\\\\)?${p.source}(\\s)?`,"g");function n(f){return f.indexOf(U)===-1?f:f.replace(T,(s,r,b,u)=>b?s:r||u||"")}t.$7j=n;function o(f){return f?f.replace(/\$\((.*?)\)/g,(s,r)=>` ${r} `).trim():""}t.$8j=o;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(f){e.lastIndex=0;let s="";const r=[];let b=0;for(;;){const u=e.lastIndex,l=e.exec(f),F=f.substring(u,l?.index);if(F.length>0){s+=F;for(let z=0;z<F.length;z++)r.push(b)}if(!l)break;b+=l[0].length}return{text:s,iconOffsets:r}}t.$9j=h;function a(f,s,r=!1){const{text:b,iconOffsets:u}=s;if(!u||u.length===0)return(0,v.$Rj)(f,b,r);const l=(0,N.$Ne)(b," "),F=b.length-l.length,z=(0,v.$Rj)(f,l,r);if(z)for(const L of z){const d=u[L.start+F]+F;L.start+=d,L.end+=d}return z}t.$0j=a}),define(be[88],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WT=t.$VT=void 0,t.$VT="vscode:contextmenu",t.$WT="vscode:onCloseContextMenu"}),define(be[89],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4T=void 0;class v{constructor(i,U){this.a=i,this.onMessage=U}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$4T=v}),define(be[30],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$R=t.$Q=t.$P=t.$O=t.$N=void 0;const v=globalThis.vscode;t.$N=v.ipcRenderer,t.$O=v.ipcMessagePort,t.$P=v.webFrame,t.$Q=v.process,t.$R=v.context}),define(be[90],$e([1,0,88,30]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZT=void 0;let i=0;function U(D,c,g){const m=[],T=i++,n=`vscode:onContextMenu${T}`,o=(e,h,a)=>{m[h].click?.(a)};N.$N.once(n,o),N.$N.once(v.$WT,(e,h)=>{h===T&&(N.$N.removeListener(n,o),g?.())}),N.$N.send(v.$VT,T,D.map(e=>p(e,m)),n,c)}t.$ZT=U;function p(D,c){const g={id:c.length,label:D.label,type:D.type,accelerator:D.accelerator,checked:D.checked,enabled:typeof D.enabled=="boolean"?D.enabled:!0,visible:typeof D.visible=="boolean"?D.visible:!0};return c.push(D),Array.isArray(D.submenu)&&(g.submenu=D.submenu.map(m=>p(m,c))),g}}),define(be[52],$e([8]),{}),define(be[91],$e([8]),{}),define(be[92],$e([8]),{}),define(be[93],$e([8]),{}),define(be[94],$e([1,0,92,93]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[95],$e([8]),{}),define(be[96],$e([8]),{}),define(be[97],$e([8]),{}),define(be[98],$e([8]),{}),define(be[99],$e([8]),{}),define(be[100],$e([8]),{}),define(be[101],$e([8]),{}),define(be[102],$e([8]),{}),define(be[103],$e([8]),{}),define(be[104],$e([13,11]),function(ae,t){return ae.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[105],$e([13,11]),function(ae,t){return ae.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[106],$e([13,11]),function(ae,t){return ae.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[107],$e([13,11]),function(ae,t){return ae.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[108],$e([13,11]),function(ae,t){return ae.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[109],$e([13,11]),function(ae,t){return ae.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[110],$e([13,11]),function(ae,t){return ae.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[111],$e([13,11]),function(ae,t){return ae.create("vs/base/common/actions",t)}),define(be[36],$e([1,0,4,2,111]),function(ae,t,v,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hi=t.$Gi=t.$Fi=t.$Ei=t.$Di=t.$Ci=void 0;class U extends N.$Rc{constructor(n,o="",e="",h=!0,a){super(),this.h=this.B(new v.$Rd),this.onDidChange=this.h.event,this.w=!0,this.j=n,this.m=o,this.u=e,this.w=h,this.C=a}get id(){return this.j}get label(){return this.m}set label(n){this.D(n)}D(n){this.m!==n&&(this.m=n,this.h.fire({label:n}))}get tooltip(){return this.n||""}set tooltip(n){this.F(n)}F(n){this.n!==n&&(this.n=n,this.h.fire({tooltip:n}))}get class(){return this.u}set class(n){this.G(n)}G(n){this.u!==n&&(this.u=n,this.h.fire({class:n}))}get enabled(){return this.w}set enabled(n){this.H(n)}H(n){this.w!==n&&(this.w=n,this.h.fire({enabled:n}))}get checked(){return this.z}set checked(n){this.I(n)}I(n){this.z!==n&&(this.z=n,this.h.fire({checked:n}))}async run(n,o){this.C&&await this.C(n)}}t.$Ci=U;class p extends N.$Rc{constructor(){super(...arguments),this.f=this.B(new v.$Rd),this.onWillRun=this.f.event,this.m=this.B(new v.$Rd),this.onDidRun=this.m.event}async run(n,o){if(!n.enabled)return;this.f.fire({action:n});let e;try{await this.u(n,o)}catch(h){e=h}this.m.fire({action:n,error:e})}async u(n,o){await n.run(o)}}t.$Di=p;class D{constructor(){this.id=D.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...n){let o=[];for(const e of n)e.length&&(o.length?o=[...o,new D,...e]:o=e);return o}static{this.ID="vs.actions.separator"}async run(){}}t.$Ei=D;class c{get actions(){return this.a}constructor(n,o,e,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=n,this.label=o,this.class=h,this.a=e}async run(){}}t.$Fi=c;class g extends U{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,i.localize(0,null),void 0,!1)}}t.$Gi=g;function m(T){return{id:T.id,label:T.label,class:void 0,enabled:T.enabled??!0,checked:T.checked??!1,run:async(...n)=>T.run(...n),tooltip:T.label}}t.$Hi=m}),define(be[112],$e([13,11]),function(ae,t){return ae.create("vs/base/common/platform",t)}),define(be[5],$e([1,0,112]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let N=!1,i=!1,U=!1,p=!1,D=!1,c=!1,g=!1,m=!1,T=!1,n=!1,o,e=t.$g,h=t.$g,a,f;const s=globalThis;let r;typeof s.vscode<"u"&&typeof s.vscode.process<"u"?r=s.vscode.process:typeof process<"u"&&(r=process);const b=typeof r?.versions?.electron=="string",u=b&&r?.type==="renderer";if(typeof navigator=="object"&&!u)f=navigator.userAgent,N=f.indexOf("Windows")>=0,i=f.indexOf("Macintosh")>=0,m=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=f.indexOf("Linux")>=0,n=f?.indexOf("Mobi")>=0,c=!0,o=v.getConfiguredDefaultLocale(v.localize(0,null))||t.$g,e=o,h=navigator.language;else if(typeof r=="object"){N=r.platform==="win32",i=r.platform==="darwin",U=r.platform==="linux",p=U&&!!r.env.SNAP&&!!r.env.SNAP_REVISION,g=b,T=!!r.env.CI||!!r.env.BUILD_ARTIFACTSTAGINGDIRECTORY,o=t.$g,e=t.$g;const x=r.env.VSCODE_NLS_CONFIG;if(x)try{const R=JSON.parse(x),B=R.availableLanguages["*"];o=R.locale,h=R.osLocale,e=B||t.$g,a=R._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var l;(function(x){x[x.Web=0]="Web",x[x.Mac=1]="Mac",x[x.Linux=2]="Linux",x[x.Windows=3]="Windows"})(l||(t.Platform=l={}));function F(x){switch(x){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=F;let z=0;i?z=1:N?z=3:U&&(z=2),t.$i=N,t.$j=i,t.$k=U,t.$l=p,t.$m=D,t.$n=g,t.$o=c,t.$p=c&&typeof s.importScripts=="function",t.$q=t.$p?s.origin:void 0,t.$r=m,t.$s=n,t.$t=T,t.$u=z,t.$v=f,t.$w=e;var L;(function(x){function R(){return t.$w}x.value=R;function B(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}x.isDefaultVariant=B;function j(){return t.$w==="en"}x.isDefault=j})(L||(t.Language=L={})),t.$x=o,t.$y=h,t.$z=a,t.$A=typeof s.postMessage=="function"&&!s.importScripts,t.$B=(()=>{if(t.$A){const x=[];s.addEventListener("message",B=>{if(B.data&&B.data.vscodeScheduleAsyncWork)for(let j=0,ie=x.length;j<ie;j++){const te=x[j];if(te.id===B.data.vscodeScheduleAsyncWork){x.splice(j,1),te.callback();return}}});let R=0;return B=>{const j=++R;x.push({id:j,callback:B}),s.postMessage({vscodeScheduleAsyncWork:j},"*")}}return x=>setTimeout(x)})();var d;(function(x){x[x.Windows=1]="Windows",x[x.Macintosh=2]="Macintosh",x[x.Linux=3]="Linux"})(d||(t.OperatingSystem=d={})),t.OS=i||m?2:N?1:3;let y=!0,M=!1;function V(){if(!M){M=!0;const x=new Uint8Array(2);x[0]=1,x[1]=2,y=new Uint16Array(x.buffer)[0]===(2<<8)+1}return y}t.$D=V,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0)}),define(be[113],$e([1,0,16,21,5]),function(ae,t,v,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TO=t.KeyboardSupport=void 0;var U;(function(p){p[p.Always=0]="Always",p[p.FullScreen=1]="FullScreen",p[p.None=2]="None"})(U||(t.KeyboardSupport=U={})),t.$TO={clipboard:{writeText:i.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.$m||v.$RO()?0:navigator.keyboard||v.$NO?1:2)(),touch:"ontouchstart"in N.$xO||navigator.maxTouchPoints>0,pointerEvents:N.$xO.PointerEvent&&("ontouchstart"in N.$xO||navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(be[14],$e([1,0,16,44,78,5]),function(ae,t,v,N,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2O=t.$1O=t.$ZO=void 0;function p(e){if(e.charCode){const a=String.fromCharCode(e.charCode).toUpperCase();return N.KeyCodeUtils.fromString(a)}const h=e.keyCode;if(h===3)return 7;if(v.$KO)switch(h){case 59:return 85;case 60:if(U.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(U.$j)return 57;break}else if(v.$LO){if(U.$j&&h===93)return 57;if(!U.$j&&h===92)return 57}return N.$Iq[h]||0}const D=U.$j?256:2048,c=512,g=1024,m=U.$j?2048:256;function T(e){const h=[];return e.ctrlKey&&h.push("ctrl"),e.shiftKey&&h.push("shift"),e.altKey&&h.push("alt"),e.metaKey&&h.push("meta"),`modifiers: [${h.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$ZO=T;function n(e){const h=[];return e.ctrlKey&&h.push("ctrl"),e.shiftKey&&h.push("shift"),e.altKey&&h.push("alt"),e.metaKey&&h.push("meta"),`modifiers: [${h.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${N.KeyCodeUtils.toString(e.keyCode)}')`}t.$1O=n;class o{constructor(h){this._standardKeyboardEventBrand=!0;const a=h;this.browserEvent=a,this.target=a.target,this.ctrlKey=a.ctrlKey,this.shiftKey=a.shiftKey,this.altKey=a.altKey,this.metaKey=a.metaKey,this.altGraphKey=a.getModifierState("AltGraph"),this.keyCode=p(a),this.code=a.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(h){return this.a===h}c(){let h=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(h=this.keyCode);let a=0;return this.ctrlKey&&(a|=D),this.altKey&&(a|=c),this.shiftKey&&(a|=g),this.metaKey&&(a|=m),a|=h,a}d(){let h=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(h=this.keyCode),new i.$Qq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,h)}}t.$2O=o}),define(be[19],$e([1,0,16,69,5]),function(ae,t,v,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YO=t.$XO=t.$WO=void 0;class U{constructor(g,m){this.timestamp=Date.now(),this.browserEvent=m,this.leftButton=m.button===0,this.middleButton=m.button===1,this.rightButton=m.button===2,this.buttons=m.buttons,this.target=m.target,this.detail=m.detail||1,m.type==="dblclick"&&(this.detail=2),this.ctrlKey=m.ctrlKey,this.shiftKey=m.shiftKey,this.altKey=m.altKey,this.metaKey=m.metaKey,typeof m.pageX=="number"?(this.posx=m.pageX,this.posy=m.pageY):(this.posx=m.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=m.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const T=N.$UO.getPositionOfChildWindowRelativeToAncestorWindow(g,m.view);this.posx-=T.left,this.posy-=T.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$WO=U;class p extends U{constructor(g,m){super(g,m),this.dataTransfer=m.dataTransfer}}t.$XO=p;class D{constructor(g,m=0,T=0){if(this.browserEvent=g||null,this.target=g?g.target||g.targetNode||g.srcElement:null,this.deltaY=T,this.deltaX=m,g){const n=g,o=g;if(typeof n.wheelDeltaY<"u")this.deltaY=n.wheelDeltaY/120;else if(typeof o.VERTICAL_AXIS<"u"&&o.axis===o.VERTICAL_AXIS)this.deltaY=-o.detail/3;else if(g.type==="wheel"){const e=g;e.deltaMode===e.DOM_DELTA_LINE?v.$KO&&!i.$j?this.deltaY=-g.deltaY/3:this.deltaY=-g.deltaY:this.deltaY=-g.deltaY/40}if(typeof n.wheelDeltaX<"u")v.$NO&&i.$i?this.deltaX=-(n.wheelDeltaX/120):this.deltaX=n.wheelDeltaX/120;else if(typeof o.HORIZONTAL_AXIS<"u"&&o.axis===o.HORIZONTAL_AXIS)this.deltaX=-g.detail/3;else if(g.type==="wheel"){const e=g;e.deltaMode===e.DOM_DELTA_LINE?v.$KO&&!i.$j?this.deltaX=-g.deltaX/3:this.deltaX=-g.deltaX:this.deltaX=-g.deltaX/40}this.deltaY===0&&this.deltaX===0&&g.wheelDelta&&(this.deltaY=g.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$YO=D}),define(be[114],$e([1,0,5]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dc=t.$cc=t.env=t.cwd=void 0;let N;const i=globalThis.vscode;if(typeof i<"u"&&typeof i.process<"u"){const U=i.process;N={get platform(){return U.platform},get arch(){return U.arch},get env(){return U.env},cwd(){return U.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return v.$i?"win32":v.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=N.cwd,t.env=N.env,t.$cc=N.platform,t.$dc=N.arch}),define(be[23],$e([1,0,114]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sc=t.sep=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=void 0;const N=65,i=97,U=90,p=122,D=46,c=47,g=92,m=58,T=63;class n extends Error{constructor(F,z,L){let d;typeof z=="string"&&z.indexOf("not ")===0?(d="must not be",z=z.replace(/^not /,"")):d="must be";const y=F.indexOf(".")!==-1?"property":"argument";let M=`The "${F}" ${y} ${d} of type ${z}`;M+=`. Received type ${typeof L}`,super(M),this.code="ERR_INVALID_ARG_TYPE"}}function o(l,F){if(l===null||typeof l!="object")throw new n(F,"Object",l)}function e(l,F){if(typeof l!="string")throw new n(F,"string",l)}const h=v.$cc==="win32";function a(l){return l===c||l===g}function f(l){return l===c}function s(l){return l>=N&&l<=U||l>=i&&l<=p}function r(l,F,z,L){let d="",y=0,M=-1,V=0,x=0;for(let R=0;R<=l.length;++R){if(R<l.length)x=l.charCodeAt(R);else{if(L(x))break;x=c}if(L(x)){if(!(M===R-1||V===1))if(V===2){if(d.length<2||y!==2||d.charCodeAt(d.length-1)!==D||d.charCodeAt(d.length-2)!==D){if(d.length>2){const B=d.lastIndexOf(z);B===-1?(d="",y=0):(d=d.slice(0,B),y=d.length-1-d.lastIndexOf(z)),M=R,V=0;continue}else if(d.length!==0){d="",y=0,M=R,V=0;continue}}F&&(d+=d.length>0?`${z}..`:"..",y=2)}else d.length>0?d+=`${z}${l.slice(M+1,R)}`:d=l.slice(M+1,R),y=R-M-1;M=R,V=0}else x===D&&V!==-1?++V:V=-1}return d}function b(l,F){o(F,"pathObject");const z=F.dir||F.root,L=F.base||`${F.name||""}${F.ext||""}`;return z?z===F.root?`${z}${L}`:`${z}${l}${L}`:L}t.$ec={resolve(...l){let F="",z="",L=!1;for(let d=l.length-1;d>=-1;d--){let y;if(d>=0){if(y=l[d],e(y,"path"),y.length===0)continue}else F.length===0?y=v.cwd():(y=v.env[`=${F}`]||v.cwd(),(y===void 0||y.slice(0,2).toLowerCase()!==F.toLowerCase()&&y.charCodeAt(2)===g)&&(y=`${F}\\`));const M=y.length;let V=0,x="",R=!1;const B=y.charCodeAt(0);if(M===1)a(B)&&(V=1,R=!0);else if(a(B))if(R=!0,a(y.charCodeAt(1))){let j=2,ie=j;for(;j<M&&!a(y.charCodeAt(j));)j++;if(j<M&&j!==ie){const te=y.slice(ie,j);for(ie=j;j<M&&a(y.charCodeAt(j));)j++;if(j<M&&j!==ie){for(ie=j;j<M&&!a(y.charCodeAt(j));)j++;(j===M||j!==ie)&&(x=`\\\\${te}\\${y.slice(ie,j)}`,V=j)}}}else V=1;else s(B)&&y.charCodeAt(1)===m&&(x=y.slice(0,2),V=2,M>2&&a(y.charCodeAt(2))&&(R=!0,V=3));if(x.length>0)if(F.length>0){if(x.toLowerCase()!==F.toLowerCase())continue}else F=x;if(L){if(F.length>0)break}else if(z=`${y.slice(V)}\\${z}`,L=R,R&&F.length>0)break}return z=r(z,!L,"\\",a),L?`${F}\\${z}`:`${F}${z}`||"."},normalize(l){e(l,"path");const F=l.length;if(F===0)return".";let z=0,L,d=!1;const y=l.charCodeAt(0);if(F===1)return f(y)?"\\":l;if(a(y))if(d=!0,a(l.charCodeAt(1))){let V=2,x=V;for(;V<F&&!a(l.charCodeAt(V));)V++;if(V<F&&V!==x){const R=l.slice(x,V);for(x=V;V<F&&a(l.charCodeAt(V));)V++;if(V<F&&V!==x){for(x=V;V<F&&!a(l.charCodeAt(V));)V++;if(V===F)return`\\\\${R}\\${l.slice(x)}\\`;V!==x&&(L=`\\\\${R}\\${l.slice(x,V)}`,z=V)}}}else z=1;else s(y)&&l.charCodeAt(1)===m&&(L=l.slice(0,2),z=2,F>2&&a(l.charCodeAt(2))&&(d=!0,z=3));let M=z<F?r(l.slice(z),!d,"\\",a):"";return M.length===0&&!d&&(M="."),M.length>0&&a(l.charCodeAt(F-1))&&(M+="\\"),L===void 0?d?`\\${M}`:M:d?`${L}\\${M}`:`${L}${M}`},isAbsolute(l){e(l,"path");const F=l.length;if(F===0)return!1;const z=l.charCodeAt(0);return a(z)||F>2&&s(z)&&l.charCodeAt(1)===m&&a(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let F,z;for(let y=0;y<l.length;++y){const M=l[y];e(M,"path"),M.length>0&&(F===void 0?F=z=M:F+=`\\${M}`)}if(F===void 0)return".";let L=!0,d=0;if(typeof z=="string"&&a(z.charCodeAt(0))){++d;const y=z.length;y>1&&a(z.charCodeAt(1))&&(++d,y>2&&(a(z.charCodeAt(2))?++d:L=!1))}if(L){for(;d<F.length&&a(F.charCodeAt(d));)d++;d>=2&&(F=`\\${F.slice(d)}`)}return t.$ec.normalize(F)},relative(l,F){if(e(l,"from"),e(F,"to"),l===F)return"";const z=t.$ec.resolve(l),L=t.$ec.resolve(F);if(z===L||(l=z.toLowerCase(),F=L.toLowerCase(),l===F))return"";let d=0;for(;d<l.length&&l.charCodeAt(d)===g;)d++;let y=l.length;for(;y-1>d&&l.charCodeAt(y-1)===g;)y--;const M=y-d;let V=0;for(;V<F.length&&F.charCodeAt(V)===g;)V++;let x=F.length;for(;x-1>V&&F.charCodeAt(x-1)===g;)x--;const R=x-V,B=M<R?M:R;let j=-1,ie=0;for(;ie<B;ie++){const ue=l.charCodeAt(d+ie);if(ue!==F.charCodeAt(V+ie))break;ue===g&&(j=ie)}if(ie!==B){if(j===-1)return L}else{if(R>B){if(F.charCodeAt(V+ie)===g)return L.slice(V+ie+1);if(ie===2)return L.slice(V+ie)}M>B&&(l.charCodeAt(d+ie)===g?j=ie:ie===2&&(j=3)),j===-1&&(j=0)}let te="";for(ie=d+j+1;ie<=y;++ie)(ie===y||l.charCodeAt(ie)===g)&&(te+=te.length===0?"..":"\\..");return V+=j,te.length>0?`${te}${L.slice(V,x)}`:(L.charCodeAt(V)===g&&++V,L.slice(V,x))},toNamespacedPath(l){if(typeof l!="string"||l.length===0)return l;const F=t.$ec.resolve(l);if(F.length<=2)return l;if(F.charCodeAt(0)===g){if(F.charCodeAt(1)===g){const z=F.charCodeAt(2);if(z!==T&&z!==D)return`\\\\?\\UNC\\${F.slice(2)}`}}else if(s(F.charCodeAt(0))&&F.charCodeAt(1)===m&&F.charCodeAt(2)===g)return`\\\\?\\${F}`;return l},dirname(l){e(l,"path");const F=l.length;if(F===0)return".";let z=-1,L=0;const d=l.charCodeAt(0);if(F===1)return a(d)?l:".";if(a(d)){if(z=L=1,a(l.charCodeAt(1))){let V=2,x=V;for(;V<F&&!a(l.charCodeAt(V));)V++;if(V<F&&V!==x){for(x=V;V<F&&a(l.charCodeAt(V));)V++;if(V<F&&V!==x){for(x=V;V<F&&!a(l.charCodeAt(V));)V++;if(V===F)return l;V!==x&&(z=L=V+1)}}}}else s(d)&&l.charCodeAt(1)===m&&(z=F>2&&a(l.charCodeAt(2))?3:2,L=z);let y=-1,M=!0;for(let V=F-1;V>=L;--V)if(a(l.charCodeAt(V))){if(!M){y=V;break}}else M=!1;if(y===-1){if(z===-1)return".";y=z}return l.slice(0,y)},basename(l,F){F!==void 0&&e(F,"ext"),e(l,"path");let z=0,L=-1,d=!0,y;if(l.length>=2&&s(l.charCodeAt(0))&&l.charCodeAt(1)===m&&(z=2),F!==void 0&&F.length>0&&F.length<=l.length){if(F===l)return"";let M=F.length-1,V=-1;for(y=l.length-1;y>=z;--y){const x=l.charCodeAt(y);if(a(x)){if(!d){z=y+1;break}}else V===-1&&(d=!1,V=y+1),M>=0&&(x===F.charCodeAt(M)?--M===-1&&(L=y):(M=-1,L=V))}return z===L?L=V:L===-1&&(L=l.length),l.slice(z,L)}for(y=l.length-1;y>=z;--y)if(a(l.charCodeAt(y))){if(!d){z=y+1;break}}else L===-1&&(d=!1,L=y+1);return L===-1?"":l.slice(z,L)},extname(l){e(l,"path");let F=0,z=-1,L=0,d=-1,y=!0,M=0;l.length>=2&&l.charCodeAt(1)===m&&s(l.charCodeAt(0))&&(F=L=2);for(let V=l.length-1;V>=F;--V){const x=l.charCodeAt(V);if(a(x)){if(!y){L=V+1;break}continue}d===-1&&(y=!1,d=V+1),x===D?z===-1?z=V:M!==1&&(M=1):z!==-1&&(M=-1)}return z===-1||d===-1||M===0||M===1&&z===d-1&&z===L+1?"":l.slice(z,d)},format:b.bind(null,"\\"),parse(l){e(l,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return F;const z=l.length;let L=0,d=l.charCodeAt(0);if(z===1)return a(d)?(F.root=F.dir=l,F):(F.base=F.name=l,F);if(a(d)){if(L=1,a(l.charCodeAt(1))){let j=2,ie=j;for(;j<z&&!a(l.charCodeAt(j));)j++;if(j<z&&j!==ie){for(ie=j;j<z&&a(l.charCodeAt(j));)j++;if(j<z&&j!==ie){for(ie=j;j<z&&!a(l.charCodeAt(j));)j++;j===z?L=j:j!==ie&&(L=j+1)}}}}else if(s(d)&&l.charCodeAt(1)===m){if(z<=2)return F.root=F.dir=l,F;if(L=2,a(l.charCodeAt(2))){if(z===3)return F.root=F.dir=l,F;L=3}}L>0&&(F.root=l.slice(0,L));let y=-1,M=L,V=-1,x=!0,R=l.length-1,B=0;for(;R>=L;--R){if(d=l.charCodeAt(R),a(d)){if(!x){M=R+1;break}continue}V===-1&&(x=!1,V=R+1),d===D?y===-1?y=R:B!==1&&(B=1):y!==-1&&(B=-1)}return V!==-1&&(y===-1||B===0||B===1&&y===V-1&&y===M+1?F.base=F.name=l.slice(M,V):(F.name=l.slice(M,y),F.base=l.slice(M,V),F.ext=l.slice(y,V))),M>0&&M!==L?F.dir=l.slice(0,M-1):F.dir=F.root,F},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(h){const l=/\\/g;return()=>{const F=v.cwd().replace(l,"/");return F.slice(F.indexOf("/"))}}return()=>v.cwd()})();t.$fc={resolve(...l){let F="",z=!1;for(let L=l.length-1;L>=-1&&!z;L--){const d=L>=0?l[L]:u();e(d,"path"),d.length!==0&&(F=`${d}/${F}`,z=d.charCodeAt(0)===c)}return F=r(F,!z,"/",f),z?`/${F}`:F.length>0?F:"."},normalize(l){if(e(l,"path"),l.length===0)return".";const F=l.charCodeAt(0)===c,z=l.charCodeAt(l.length-1)===c;return l=r(l,!F,"/",f),l.length===0?F?"/":z?"./":".":(z&&(l+="/"),F?`/${l}`:l)},isAbsolute(l){return e(l,"path"),l.length>0&&l.charCodeAt(0)===c},join(...l){if(l.length===0)return".";let F;for(let z=0;z<l.length;++z){const L=l[z];e(L,"path"),L.length>0&&(F===void 0?F=L:F+=`/${L}`)}return F===void 0?".":t.$fc.normalize(F)},relative(l,F){if(e(l,"from"),e(F,"to"),l===F||(l=t.$fc.resolve(l),F=t.$fc.resolve(F),l===F))return"";const z=1,L=l.length,d=L-z,y=1,M=F.length-y,V=d<M?d:M;let x=-1,R=0;for(;R<V;R++){const j=l.charCodeAt(z+R);if(j!==F.charCodeAt(y+R))break;j===c&&(x=R)}if(R===V)if(M>V){if(F.charCodeAt(y+R)===c)return F.slice(y+R+1);if(R===0)return F.slice(y+R)}else d>V&&(l.charCodeAt(z+R)===c?x=R:R===0&&(x=0));let B="";for(R=z+x+1;R<=L;++R)(R===L||l.charCodeAt(R)===c)&&(B+=B.length===0?"..":"/..");return`${B}${F.slice(y+x)}`},toNamespacedPath(l){return l},dirname(l){if(e(l,"path"),l.length===0)return".";const F=l.charCodeAt(0)===c;let z=-1,L=!0;for(let d=l.length-1;d>=1;--d)if(l.charCodeAt(d)===c){if(!L){z=d;break}}else L=!1;return z===-1?F?"/":".":F&&z===1?"//":l.slice(0,z)},basename(l,F){F!==void 0&&e(F,"ext"),e(l,"path");let z=0,L=-1,d=!0,y;if(F!==void 0&&F.length>0&&F.length<=l.length){if(F===l)return"";let M=F.length-1,V=-1;for(y=l.length-1;y>=0;--y){const x=l.charCodeAt(y);if(x===c){if(!d){z=y+1;break}}else V===-1&&(d=!1,V=y+1),M>=0&&(x===F.charCodeAt(M)?--M===-1&&(L=y):(M=-1,L=V))}return z===L?L=V:L===-1&&(L=l.length),l.slice(z,L)}for(y=l.length-1;y>=0;--y)if(l.charCodeAt(y)===c){if(!d){z=y+1;break}}else L===-1&&(d=!1,L=y+1);return L===-1?"":l.slice(z,L)},extname(l){e(l,"path");let F=-1,z=0,L=-1,d=!0,y=0;for(let M=l.length-1;M>=0;--M){const V=l.charCodeAt(M);if(V===c){if(!d){z=M+1;break}continue}L===-1&&(d=!1,L=M+1),V===D?F===-1?F=M:y!==1&&(y=1):F!==-1&&(y=-1)}return F===-1||L===-1||y===0||y===1&&F===L-1&&F===z+1?"":l.slice(F,L)},format:b.bind(null,"/"),parse(l){e(l,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return F;const z=l.charCodeAt(0)===c;let L;z?(F.root="/",L=1):L=0;let d=-1,y=0,M=-1,V=!0,x=l.length-1,R=0;for(;x>=L;--x){const B=l.charCodeAt(x);if(B===c){if(!V){y=x+1;break}continue}M===-1&&(V=!1,M=x+1),B===D?d===-1?d=x:R!==1&&(R=1):d!==-1&&(R=-1)}if(M!==-1){const B=y===0&&z?1:y;d===-1||R===0||R===1&&d===M-1&&d===y+1?F.base=F.name=l.slice(B,M):(F.name=l.slice(B,d),F.base=l.slice(B,M),F.ext=l.slice(d,M))}return y>0?F.dir=l.slice(0,y-1):z&&(F.dir="/"),F},sep:"/",delimiter:":",win32:null,posix:null},t.$fc.win32=t.$ec.win32=t.$ec,t.$fc.posix=t.$ec.posix=t.$fc,t.$gc=h?t.$ec.normalize:t.$fc.normalize,t.$hc=h?t.$ec.isAbsolute:t.$fc.isAbsolute,t.$ic=h?t.$ec.join:t.$fc.join,t.$jc=h?t.$ec.resolve:t.$fc.resolve,t.$kc=h?t.$ec.relative:t.$fc.relative,t.$lc=h?t.$ec.dirname:t.$fc.dirname,t.$mc=h?t.$ec.basename:t.$fc.basename,t.$nc=h?t.$ec.extname:t.$fc.extname,t.$oc=h?t.$ec.format:t.$fc.format,t.$pc=h?t.$ec.parse:t.$fc.parse,t.$qc=h?t.$ec.toNamespacedPath:t.$fc.toNamespacedPath,t.sep=h?t.$ec.sep:t.$fc.sep,t.$sc=h?t.$ec.delimiter:t.$fc.delimiter}),define(be[115],$e([1,0,23,5,10,7]),function(ae,t,v,N,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=void 0;function p(y){return y===47||y===92}t.$Uf=p;function D(y){return y.replace(/[\\/]/g,v.$fc.sep)}t.$Vf=D;function c(y){return y.indexOf("/")===-1&&(y=D(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}t.$Wf=c;function g(y,M=v.$fc.sep){if(!y)return"";const V=y.length,x=y.charCodeAt(0);if(p(x)){if(p(y.charCodeAt(1))&&!p(y.charCodeAt(2))){let B=3;const j=B;for(;B<V&&!p(y.charCodeAt(B));B++);if(j!==B&&!p(y.charCodeAt(B+1))){for(B+=1;B<V;B++)if(p(y.charCodeAt(B)))return y.slice(0,B+1).replace(/[\\/]/g,M)}}return M}else if(f(x)&&y.charCodeAt(1)===58)return p(y.charCodeAt(2))?y.slice(0,2)+M:y.slice(0,2);let R=y.indexOf("://");if(R!==-1){for(R+=3;R<V;R++)if(p(y.charCodeAt(R)))return y.slice(0,R+1)}return""}t.$Xf=g;function m(y){if(!N.$i||!y||y.length<5)return!1;let M=y.charCodeAt(0);if(M!==92||(M=y.charCodeAt(1),M!==92))return!1;let V=2;const x=V;for(;V<y.length&&(M=y.charCodeAt(V),M!==92);V++);return!(x===V||(M=y.charCodeAt(V+1),isNaN(M)||M===92))}t.$Yf=m;const T=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,o=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(y,M=N.$i){const V=M?T:n;return!(!y||y.length===0||/^\s+$/.test(y)||(V.lastIndex=0,V.test(y))||M&&o.test(y)||y==="."||y===".."||M&&y[y.length-1]==="."||M&&y.length!==y.trim().length||y.length>255)}t.$Zf=e;function h(y,M,V){const x=y===M;return!V||x?x:!y||!M?!1:(0,i.$6e)(y,M)}t.$1f=h;function a(y,M,V,x=v.sep){if(y===M)return!0;if(!y||!M||M.length>y.length)return!1;if(V){if(!(0,i.$7e)(y,M))return!1;if(M.length===y.length)return!0;let B=M.length;return M.charAt(M.length-1)===x&&B--,y.charAt(B)===x}return M.charAt(M.length-1)!==x&&(M+=x),y.indexOf(M)===0}t.$2f=a;function f(y){return y>=65&&y<=90||y>=97&&y<=122}t.$3f=f;function s(y,M){return N.$i&&y.endsWith(":")&&(y+=v.sep),(0,v.$hc)(y)||(y=(0,v.$ic)(M,y)),y=(0,v.$gc)(y),N.$i?(y=(0,i.$Oe)(y,v.sep),y.endsWith(":")&&(y+=v.sep)):(y=(0,i.$Oe)(y,v.sep),y||(y=v.sep)),y}t.$4f=s;function r(y){const M=(0,v.$gc)(y);return N.$i?y.length>3?!1:b(M)&&(y.length===2||M.charCodeAt(2)===92):M===v.$fc.sep}t.$5f=r;function b(y,M=N.$i){return M?f(y.charCodeAt(0))&&y.charCodeAt(1)===58:!1}t.$6f=b;function u(y,M=N.$i){return b(y,M)?y[0]:void 0}t.$7f=u;function l(y,M,V){return M.length>y.length?-1:y===M?0:(V&&(y=y.toLowerCase(),M=M.toLowerCase()),y.indexOf(M))}t.$8f=l;function F(y){const M=y.split(":");let V,x,R;for(const B of M){const j=Number(B);(0,U.$Gf)(j)?x===void 0?x=j:R===void 0&&(R=j):V=V?[V,B].join(":"):B}if(!V)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:V,line:x!==void 0?x:void 0,column:R!==void 0?R:x!==void 0?1:void 0}}t.$9f=F;const z="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",L="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function d(y,M,V=8){let x="";for(let B=0;B<V;B++){let j;B===0&&N.$i&&!M&&(V===3||V===4)?j=L:j=z,x+=j.charAt(Math.floor(Math.random()*j.length))}let R;return M?R=`${M}-${x}`:R=x,y?(0,v.$ic)(y,R):R}t.$0f=d}),define(be[116],$e([1,0,23]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2r=t.$1r=t.$Zr=t.$Yr=t.$Xr=void 0,t.$Xr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function U(m){const T=(0,v.$nc)(m),n=N[T.toLowerCase()];return n!==void 0?n:p(m)}t.$Yr=U;function p(m){const T=(0,v.$nc)(m);return i[T.toLowerCase()]}t.$Zr=p;function D(m){for(const T in i)if(i[T]===m)return T}t.$1r=D;const c=/^(.+)\/(.+?)(;.+)?$/;function g(m,T){const n=c.exec(m);return n?`${n[1].toLowerCase()}/${n[2].toLowerCase()}${n[3]??""}`:T?void 0:m}t.$2r=g}),define(be[15],$e([1,0,23,5]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vc=t.$uc=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,U=/^\//,p=/^\/\//;function D(L,d){if(!L.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${L.authority}", path: "${L.path}", query: "${L.query}", fragment: "${L.fragment}"}`);if(L.scheme&&!i.test(L.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(L.path){if(L.authority){if(!U.test(L.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(L.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(L,d){return!L&&!d?"file":L}function g(L,d){switch(L){case"https":case"http":case"file":d?d[0]!==T&&(d=T+d):d=T;break}return d}const m="",T="/",n=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class o{static isUri(d){return d instanceof o?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}constructor(d,y,M,V,x,R=!1){typeof d=="object"?(this.scheme=d.scheme||m,this.authority=d.authority||m,this.path=d.path||m,this.query=d.query||m,this.fragment=d.fragment||m):(this.scheme=c(d,R),this.authority=y||m,this.path=g(this.scheme,M||m),this.query=V||m,this.fragment=x||m,D(this,R))}get fsPath(){return b(this,!1)}with(d){if(!d)return this;let{scheme:y,authority:M,path:V,query:x,fragment:R}=d;return y===void 0?y=this.scheme:y===null&&(y=m),M===void 0?M=this.authority:M===null&&(M=m),V===void 0?V=this.path:V===null&&(V=m),x===void 0?x=this.query:x===null&&(x=m),R===void 0?R=this.fragment:R===null&&(R=m),y===this.scheme&&M===this.authority&&V===this.path&&x===this.query&&R===this.fragment?this:new a(y,M,V,x,R)}static parse(d,y=!1){const M=n.exec(d);return M?new a(M[2]||m,z(M[4]||m),z(M[5]||m),z(M[7]||m),z(M[9]||m),y):new a(m,m,m,m,m)}static file(d){let y=m;if(N.$i&&(d=d.replace(/\\/g,T)),d[0]===T&&d[1]===T){const M=d.indexOf(T,2);M===-1?(y=d.substring(2),d=T):(y=d.substring(2,M),d=d.substring(M)||T)}return new a("file",y,d,m,m)}static from(d,y){return new a(d.scheme,d.authority,d.path,d.query,d.fragment,y)}static joinPath(d,...y){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return N.$i&&d.scheme==="file"?M=o.file(v.$ec.join(b(d,!0),...y)).path:M=v.$fc.join(d.path,...y),d.with({path:M})}toString(d=!1){return u(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof o)return d;{const y=new a(d);return y._formatted=d.external??null,y._fsPath=d._sep===h?d.fsPath??null:null,y}}else return d}}t.URI=o;function e(L){return!L||typeof L!="object"?!1:typeof L.scheme=="string"&&(typeof L.authority=="string"||typeof L.authority>"u")&&(typeof L.path=="string"||typeof L.path>"u")&&(typeof L.query=="string"||typeof L.query>"u")&&(typeof L.fragment=="string"||typeof L.fragment>"u")}t.$uc=e;const h=N.$i?1:void 0;class a extends o{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(d=!1){return d?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const d={$mid:1};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=h),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function s(L,d,y){let M,V=-1;for(let x=0;x<L.length;x++){const R=L.charCodeAt(x);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||d&&R===47||y&&R===91||y&&R===93||y&&R===58)V!==-1&&(M+=encodeURIComponent(L.substring(V,x)),V=-1),M!==void 0&&(M+=L.charAt(x));else{M===void 0&&(M=L.substr(0,x));const B=f[R];B!==void 0?(V!==-1&&(M+=encodeURIComponent(L.substring(V,x)),V=-1),M+=B):V===-1&&(V=x)}}return V!==-1&&(M+=encodeURIComponent(L.substring(V))),M!==void 0?M:L}function r(L){let d;for(let y=0;y<L.length;y++){const M=L.charCodeAt(y);M===35||M===63?(d===void 0&&(d=L.substr(0,y)),d+=f[M]):d!==void 0&&(d+=L[y])}return d!==void 0?d:L}function b(L,d){let y;return L.authority&&L.path.length>1&&L.scheme==="file"?y=`//${L.authority}${L.path}`:L.path.charCodeAt(0)===47&&(L.path.charCodeAt(1)>=65&&L.path.charCodeAt(1)<=90||L.path.charCodeAt(1)>=97&&L.path.charCodeAt(1)<=122)&&L.path.charCodeAt(2)===58?d?y=L.path.substr(1):y=L.path[1].toLowerCase()+L.path.substr(2):y=L.path,N.$i&&(y=y.replace(/\//g,"\\")),y}t.$vc=b;function u(L,d){const y=d?r:s;let M="",{scheme:V,authority:x,path:R,query:B,fragment:j}=L;if(V&&(M+=V,M+=":"),(x||V==="file")&&(M+=T,M+=T),x){let ie=x.indexOf("@");if(ie!==-1){const te=x.substr(0,ie);x=x.substr(ie+1),ie=te.lastIndexOf(":"),ie===-1?M+=y(te,!1,!1):(M+=y(te.substr(0,ie),!1,!1),M+=":",M+=y(te.substr(ie+1),!1,!0)),M+="@"}x=x.toLowerCase(),ie=x.lastIndexOf(":"),ie===-1?M+=y(x,!1,!0):(M+=y(x.substr(0,ie),!1,!0),M+=x.substr(ie))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const ie=R.charCodeAt(1);ie>=65&&ie<=90&&(R=`/${String.fromCharCode(ie+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const ie=R.charCodeAt(0);ie>=65&&ie<=90&&(R=`${String.fromCharCode(ie+32)}:${R.substr(2)}`)}M+=y(R,!0,!1)}return B&&(M+="?",M+=y(B,!1,!1)),j&&(M+="#",M+=d?j:s(j,!1,!1)),M}function l(L){try{return decodeURIComponent(L)}catch{return L.length>3?L.substr(0,3)+l(L.substr(3)):L}}const F=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function z(L){return L.match(F)?L.replace(F,d=>l(d)):L}}),define(be[53],$e([1,0,33,15]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uh=t.$th=t.$sh=void 0;function i(c){return JSON.stringify(c,p)}t.$sh=i;function U(c){let g=JSON.parse(c);return g=D(g),g}t.$th=U;function p(c,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function D(c,g=0){if(!c||g>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return N.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 17:return new Date(c.source)}if(c instanceof v.$fe||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let m=0;m<c.length;++m)c[m]=D(c[m],g+1);else for(const m in c)Object.hasOwnProperty.call(c,m)&&(c[m]=D(c[m],g+1))}return c}t.$uh=D}),define(be[31],$e([1,0,6,5,10,15]),function(ae,t,v,N,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$ig=t.$hg=t.$gg=t.$fg=t.$eg=t.$dg=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.Schemas=void 0;var p;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.vscodeManagedRemoteResource="vscode-managed-remote-resource",n.vscodeUserData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.vscodeChatSesssion="vscode-chat-editor",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp",n.vsls="vsls",n.vscodeSourceControl="vscode-scm"})(p||(t.Schemas=p={}));function D(n,o){return U.URI.isUri(n)?(0,i.$6e)(n.scheme,o):(0,i.$7e)(n,o+":")}t.$$f=D;function c(n,...o){return o.some(e=>D(n,e))}t.$_f=c,t.$ag="vscode-tkn",t.$bg="tkn";class g{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${p.vscodeRemoteResource}`}setPreferredWebSchema(o){this.d=o}setDelegate(o){this.e=o}setServerRootPath(o){this.f=`${o}/${p.vscodeRemoteResource}`}set(o,e,h){this.a[o]=e,this.b[o]=h}setConnectionToken(o,e){this.c[o]=e}getPreferredWebSchema(){return this.d}rewrite(o){if(this.e)try{return this.e(o)}catch(r){return v.$Z(r),o}const e=o.authority;let h=this.a[e];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const a=this.b[e],f=this.c[e];let s=`path=${encodeURIComponent(o.path)}`;return typeof f=="string"&&(s+=`&${t.$bg}=${encodeURIComponent(f)}`),U.URI.from({scheme:N.$o?this.d:p.vscodeRemoteResource,authority:`${h}:${a}`,path:this.f,query:s})}}t.$cg=new g,t.$dg="vs/../../extensions",t.$eg="vs/../../node_modules",t.$fg="vs/../../node_modules.asar",t.$gg="vs/../../node_modules.asar.unpacked",t.$hg="vscode-app";class m{static{this.a=t.$hg}asBrowserUri(o){const e=this.b(o,ae);return this.uriToBrowserUri(e)}uriToBrowserUri(o){return o.scheme===p.vscodeRemote?t.$cg.rewrite(o):o.scheme===p.file&&(N.$m||N.$q===`${p.vscodeFileResource}://${m.a}`)?o.with({scheme:p.vscodeFileResource,authority:o.authority||m.a,query:null,fragment:null}):o}asFileUri(o){const e=this.b(o,ae);return this.uriToFileUri(e)}uriToFileUri(o){return o.scheme===p.vscodeFileResource?o.with({scheme:p.file,authority:o.authority!==m.a?o.authority:null,query:null,fragment:null}):o}b(o,e){return U.URI.isUri(o)?o:U.URI.parse(e.toUrl(o))}}t.$ig=new m;var T;(function(n){const o=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);n.CoopAndCoep=Object.freeze(o.get("3"));const e="vscode-coi";function h(f){let s;typeof f=="string"?s=new URL(f).searchParams:f instanceof URL?s=f.searchParams:U.URI.isUri(f)&&(s=new URL(f.toString(!0)).searchParams);const r=s?.get(e);if(r)return o.get(r)}n.getHeadersFromQuery=h;function a(f,s,r){if(!globalThis.crossOriginIsolated)return;const b=s&&r?"3":r?"2":"1";f instanceof URLSearchParams?f.set(e,b):f[e]=b}n.addSearchParam=a})(T||(t.COI=T={}))}),define(be[37],$e([1,0,115,31,23,5,10,15]),function(ae,t,v,N,i,U,p,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lg=t.DataUri=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=t.$sg=t.$rg=t.$qg=t.$pg=void 0;function c(o){return(0,D.$vc)(o,!0)}t.$pg=c;class g{constructor(e){this.a=e}compare(e,h,a=!1){return e===h?0:(0,p.$Ye)(this.getComparisonKey(e,a),this.getComparisonKey(h,a))}isEqual(e,h,a=!1){return e===h?!0:!e||!h?!1:this.getComparisonKey(e,a)===this.getComparisonKey(h,a)}getComparisonKey(e,h=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,h,a=!1){if(e.scheme===h.scheme){if(e.scheme===N.Schemas.file)return v.$2f(c(e),c(h),this.a(e))&&e.query===h.query&&(a||e.fragment===h.fragment);if((0,t.$Gg)(e.authority,h.authority))return v.$2f(e.path,h.path,this.a(e),"/")&&e.query===h.query&&(a||e.fragment===h.fragment)}return!1}joinPath(e,...h){return D.URI.joinPath(e,...h)}basenameOrAuthority(e){return(0,t.$yg)(e)||e.authority}basename(e){return i.$fc.basename(e.path)}extname(e){return i.$fc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let h;return e.scheme===N.Schemas.file?h=D.URI.file(i.$lc(c(e))).path:(h=i.$fc.dirname(e.path),e.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),h="/")),e.with({path:h})}normalizePath(e){if(!e.path.length)return e;let h;return e.scheme===N.Schemas.file?h=D.URI.file(i.$gc(c(e))).path:h=i.$fc.normalize(e.path),e.with({path:h})}relativePath(e,h){if(e.scheme!==h.scheme||!(0,t.$Gg)(e.authority,h.authority))return;if(e.scheme===N.Schemas.file){const s=i.$kc(c(e),c(h));return U.$i?v.$Vf(s):s}let a=e.path||"/";const f=h.path||"/";if(this.a(e)){let s=0;for(const r=Math.min(a.length,f.length);s<r&&!(a.charCodeAt(s)!==f.charCodeAt(s)&&a.charAt(s).toLowerCase()!==f.charAt(s).toLowerCase());s++);a=f.substr(0,s)+a.substr(s)}return i.$fc.relative(a,f)}resolvePath(e,h){if(e.scheme===N.Schemas.file){const a=D.URI.file(i.$jc(c(e),h));return e.with({authority:a.authority,path:a.path})}return h=v.$Wf(h),e.with({path:i.$fc.resolve(e.path,h)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,h){return e===h||e!==void 0&&h!==void 0&&(0,p.$6e)(e,h)}hasTrailingPathSeparator(e,h=i.sep){if(e.scheme===N.Schemas.file){const a=c(e);return a.length>v.$Xf(a).length&&a[a.length-1]===h}else{const a=e.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,h=i.sep){return(0,t.$Hg)(e,h)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,h=i.sep){let a=!1;if(e.scheme===N.Schemas.file){const f=c(e);a=f!==void 0&&f.length===v.$Xf(f).length&&f[f.length-1]===h}else{h="/";const f=e.path;a=f.length===1&&f.charCodeAt(f.length-1)===47}return!a&&!(0,t.$Hg)(e,h)?e.with({path:e.path+"/"}):e}}t.$qg=g,t.$rg=new g(()=>!1),t.$sg=new g(o=>o.scheme===N.Schemas.file?!U.$k:!0),t.$tg=new g(o=>!0),t.$ug=t.$rg.isEqual.bind(t.$rg),t.$vg=t.$rg.isEqualOrParent.bind(t.$rg),t.$wg=t.$rg.getComparisonKey.bind(t.$rg),t.$xg=t.$rg.basenameOrAuthority.bind(t.$rg),t.$yg=t.$rg.basename.bind(t.$rg),t.$zg=t.$rg.extname.bind(t.$rg),t.$Ag=t.$rg.dirname.bind(t.$rg),t.$Bg=t.$rg.joinPath.bind(t.$rg),t.$Cg=t.$rg.normalizePath.bind(t.$rg),t.$Dg=t.$rg.relativePath.bind(t.$rg),t.$Eg=t.$rg.resolvePath.bind(t.$rg),t.$Fg=t.$rg.isAbsolutePath.bind(t.$rg),t.$Gg=t.$rg.isEqualAuthority.bind(t.$rg),t.$Hg=t.$rg.hasTrailingPathSeparator.bind(t.$rg),t.$Ig=t.$rg.removeTrailingPathSeparator.bind(t.$rg),t.$Jg=t.$rg.addTrailingPathSeparator.bind(t.$rg);function m(o,e){const h=[];for(let a=0;a<o.length;a++){const f=e(o[a]);o.some((s,r)=>r===a?!1:(0,t.$vg)(f,e(s)))||h.push(o[a])}return h}t.$Kg=m;var T;(function(o){o.META_DATA_LABEL="label",o.META_DATA_DESCRIPTION="description",o.META_DATA_SIZE="size",o.META_DATA_MIME="mime";function e(h){const a=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(r=>{const[b,u]=r.split(":");b&&u&&a.set(b,u)});const s=h.path.substring(0,h.path.indexOf(";"));return s&&a.set(o.META_DATA_MIME,s),a}o.parseMetaData=e})(T||(t.DataUri=T={}));function n(o,e,h){if(e){let a=o.path;return a&&a[0]!==i.$fc.sep&&(a=i.$fc.sep+a),o.with({scheme:h,authority:e,path:a})}return o.with({scheme:h})}t.$Lg=n}),define(be[9],$e([1,0,29,6,4,2,37,5,50]),function(ae,t,v,N,i,U,p,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oh=t.$nh=t.$mh=t.$lh=t.Promises=t.$kh=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=void 0;function g(Q){return!!Q&&typeof Q.then=="function"}t.$Mg=g;function m(Q){const w=new v.$2d,A=Q(w.token),E=new Promise((I,k)=>{const O=w.token.onCancellationRequested(()=>{O.dispose(),w.dispose(),k(new N.$4)});Promise.resolve(A).then(S=>{O.dispose(),w.dispose(),I(S)},S=>{O.dispose(),w.dispose(),k(S)})});return new class{cancel(){w.cancel()}then(I,k){return E.then(I,k)}catch(I){return this.then(void 0,I)}finally(I){return E.finally(I)}}}t.$Ng=m;function T(Q,w,A){return new Promise((E,I)=>{const k=w.onCancellationRequested(()=>{k.dispose(),E(A)});Q.then(E,I).finally(()=>k.dispose())})}t.$Og=T;function n(Q,w){return new Promise((A,E)=>{const I=w.onCancellationRequested(()=>{I.dispose(),E(new N.$4)});Q.then(A,E).finally(()=>I.dispose())})}t.$Pg=n;async function o(Q){let w=-1;const A=Q.map((E,I)=>E.then(k=>(w=I,k)));try{return await Promise.race(A)}finally{Q.forEach((E,I)=>{I!==w&&E.cancel()})}}t.$Qg=o;function e(Q,w,A){let E;const I=setTimeout(()=>{E?.(void 0),A?.()},w);return Promise.race([Q.finally(()=>clearTimeout(I)),new Promise(k=>E=k)])}t.$Rg=e;function h(Q){return new Promise((w,A)=>{const E=Q();g(E)?E.then(w,A):w(E)})}t.$Sg=h;class a{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(w){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=w,!this.b){const A=()=>{if(this.b=null,this.f)return;const E=this.queue(this.d);return this.d=null,E};this.b=new Promise(E=>{this.a.then(A,A).then(E)})}return new Promise((A,E)=>{this.b.then(A,E)})}return this.a=w(),new Promise((A,E)=>{this.a.then(I=>{this.a=null,A(I)},I=>{this.a=null,E(I)})})}dispose(){this.f=!0}}t.$Tg=a;class f{constructor(){this.a=Promise.resolve(null)}queue(w){return this.a=this.a.then(()=>w(),()=>w())}}t.$Ug=f;class s{constructor(){this.a=new Map}queue(w,A){const I=(this.a.get(w)??Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.a.get(w)===I&&this.a.delete(w)});return this.a.set(w,I),I}}t.$Vg=s;const r=(Q,w)=>{let A=!0;const E=setTimeout(()=>{A=!1,w()},Q);return{isTriggered:()=>A,dispose:()=>{clearTimeout(E),A=!1}}},b=Q=>{let w=!0;return queueMicrotask(()=>{w&&(w=!1,Q())}),{isTriggered:()=>w,dispose:()=>{w=!1}}};class u{constructor(w){this.defaultDelay=w,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(w,A=this.defaultDelay){this.g=w,this.h(),this.b||(this.b=new Promise((I,k)=>{this.d=I,this.f=k}).then(()=>{if(this.b=null,this.d=null,this.g){const I=this.g;return this.g=null,I()}}));const E=()=>{this.a=null,this.d?.(null)};return this.a=A===c.$Od?b(E):r(A,E),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Wg=u;class l{constructor(w){this.a=new u(w),this.b=new a}trigger(w,A){return this.a.trigger(()=>this.b.queue(w),A)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Xg=l;class F{constructor(){this.a=!1,this.b=new Promise((w,A)=>{this.d=w})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Yg=F;class z extends F{constructor(w){super(),this.f=setTimeout(()=>this.open(),w)}open(){clearTimeout(this.f),super.open()}}t.$Zg=z;function L(Q,w){return w?new Promise((A,E)=>{const I=setTimeout(()=>{k.dispose(),A()},Q),k=w.onCancellationRequested(()=>{clearTimeout(I),k.dispose(),E(new N.$4)})}):m(A=>L(Q,A))}t.$1g=L;function d(Q,w=0,A){const E=setTimeout(()=>{Q(),A&&I.dispose()},w),I=(0,U.$Pc)(()=>{clearTimeout(E),A?.deleteAndLeak(I)});return A?.add(I),I}t.$2g=d;function y(Q){const w=[];let A=0;const E=Q.length;function I(){return A<E?Q[A++]():null}function k(O){O!=null&&w.push(O);const S=I();return S?S.then(k):Promise.resolve(w)}return Promise.resolve(null).then(k)}t.$3g=y;function M(Q,w=E=>!!E,A=null){let E=0;const I=Q.length,k=()=>{if(E>=I)return Promise.resolve(A);const O=Q[E++];return Promise.resolve(O()).then(P=>w(P)?Promise.resolve(P):k())};return k()}t.$4g=M;function V(Q,w=E=>!!E,A=null){if(Q.length===0)return Promise.resolve(A);let E=Q.length;const I=()=>{E=-1;for(const k of Q)k.cancel?.()};return new Promise((k,O)=>{for(const S of Q)S.then(P=>{--E>=0&&w(P)?(I(),k(P)):E===0&&k(A)}).catch(P=>{--E>=0&&(I(),O(P))})})}t.$5g=V;class x{constructor(w){this.a=0,this.d=w,this.f=[],this.b=0,this.g=new i.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(w){return this.a++,new Promise((A,E)=>{this.f.push({factory:w,c:A,e:E}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const w=this.f.shift();this.b++;const A=w.factory();A.then(w.c,w.e),A.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$6g=x;class R extends x{constructor(){super(1)}}t.$7g=R;class B{constructor(){this.a=new de,this.b=0}queue(w){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,w())):this.a.run(this.b++,w())}}t.$8g=B;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const w=new Z;return this.b.add(w),w.p}g(){for(const[,w]of this.a)if(w.size>0)return!1;return!0}queueFor(w,A=p.$rg){const E=A.getComparisonKey(w);let I=this.a.get(E);if(!I){I=new R;const k=this.f++,O=i.Event.once(I.onDrained)(()=>{I?.dispose(),this.a.delete(E),this.h(),this.d?.deleteAndDispose(k),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new U.$1c),this.d.set(k,O),this.a.set(E,I)}return I}h(){this.g()&&this.j()}j(){for(const w of this.b)w.complete();this.b.clear()}dispose(){for(const[,w]of this.a)w.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$9g=j;class ie{constructor(w,A){this.a=-1,typeof w=="function"&&typeof A=="number"&&this.setIfNotSet(w,A)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(w,A){this.cancel(),this.a=setTimeout(()=>{this.a=-1,w()},A)}setIfNotSet(w,A){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,w()},A))}}t.$0g=ie;class te{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(w,A,E=globalThis){this.cancel();const I=E.setInterval(()=>{w()},A);this.d=(0,U.$Pc)(()=>{E.clearInterval(I),this.d=void 0})}dispose(){this.cancel()}}t.$$g=te;class ue{constructor(w,A){this.b=-1,this.a=w,this.d=A,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(w=this.d){this.cancel(),this.b=setTimeout(this.f,w)}get delay(){return this.d}set delay(w){this.d=w}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$_g=ue;class le{constructor(w,A){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.a=w,this.b=A,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(w=this.b){w%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${w}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(w/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$ah=le;class oe extends ue{constructor(w,A){super(w,A),this.j=[]}work(w){this.j.push(w),this.isScheduled()||this.schedule()}h(){const w=this.j;this.j=[],this.a?.(w)}dispose(){this.j=[],super.dispose()}}t.$bh=oe;class we extends U.$Rc{constructor(w,A){super(),this.g=w,this.h=A,this.a=[],this.b=this.B(new U.$Sc),this.f=!1}get pending(){return this.a.length}work(w){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+w.length>this.g.maxBufferedWork)return!1}else if(this.pending+w.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const A of w)this.a.push(A);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ue(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$ch=we,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$eh=(Q,w)=>{(0,D.$B)(()=>{if(A)return;const E=Date.now()+15;w(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,E-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:t.$eh=(Q,w,A)=>{const E=Q.requestIdleCallback(w,typeof A=="number"?{timeout:A}:void 0);let I=!1;return{dispose(){I||(I=!0,Q.cancelIdleCallback(E))}}},t.$dh=Q=>(0,t.$eh)(globalThis,Q)}();class Fe{constructor(w,A){this.g=!1,this.d=()=>{try{this.j=A()}catch(E){this.l=E}finally{this.g=!0}},this.f=(0,t.$eh)(w,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$fh=Fe;class ke extends Fe{constructor(w){super(globalThis,w)}}t.$gh=ke;async function Le(Q,w,A){let E;for(let I=0;I<A;I++)try{return await Q()}catch(k){E=k,await L(w)}throw E}t.$hh=Le;class de{isRunning(w){return typeof w=="number"?this.a?.taskId===w:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(w,A,E){return this.a={taskId:w,cancel:()=>E?.(),promise:A},A.then(()=>this.d(w),()=>this.d(w)),A}d(w){this.a&&w===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const w=this.b;this.b=void 0,w.run().then(w.promiseResolve,w.promiseReject)}}queue(w){if(this.b)this.b.run=w;else{let A,E;const I=new Promise((k,O)=>{A=k,E=O});this.b={run:w,promise:I,promiseResolve:A,promiseReject:E}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$ih=de;class ne{constructor(w,A=()=>Date.now()){this.d=w,this.f=A,this.a=0,this.b=0}increment(){const w=this.f();return w-this.a>this.d&&(this.a=w,this.b=0),this.b++,this.b}}t.$jh=ne;var ce;(function(Q){Q[Q.Resolved=0]="Resolved",Q[Q.Rejected=1]="Rejected"})(ce||(ce={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((w,A)=>{this.a=w,this.b=A})}complete(w){return new Promise(A=>{this.a(w),this.d={outcome:0,value:w},A()})}error(w){return new Promise(A=>{this.b(w),this.d={outcome:1,value:w},A()})}cancel(){return this.error(new N.$4)}}t.$kh=Z;var q;(function(Q){async function w(E){let I;const k=await Promise.all(E.map(O=>O.then(S=>S,S=>{I||(I=S)})));if(typeof I<"u")throw I;return k}Q.settled=w;function A(E){return new Promise(async(I,k)=>{try{await E(I,k)}catch(O){k(O)}})}Q.withAsyncBody=A})(q||(t.Promises=q={}));var X;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(X||(X={}));class C{static fromArray(w){return new C(A=>{A.emitMany(w)})}static fromPromise(w){return new C(async A=>{A.emitMany(await w)})}static fromPromises(w){return new C(async A=>{await Promise.all(w.map(async E=>A.emitOne(await E)))})}static merge(w){return new C(async A=>{await Promise.all(w.map(async E=>{for await(const I of E)A.emitOne(I)}))})}static{this.EMPTY=C.fromArray([])}constructor(w){this.a=0,this.b=[],this.d=null,this.f=new i.$Rd,queueMicrotask(async()=>{const A={emitOne:E=>this.g(E),emitMany:E=>this.h(E),reject:E=>this.k(E)};try{await Promise.resolve(w(A)),this.j()}catch(E){this.k(E)}finally{A.emitOne=void 0,A.emitMany=void 0,A.reject=void 0}})}[Symbol.asyncIterator](){let w=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(w<this.b.length)return{done:!1,value:this.b[w++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(w,A){return new C(async E=>{for await(const I of w)E.emitOne(A(I))})}map(w){return C.map(this,w)}static filter(w,A){return new C(async E=>{for await(const I of w)A(I)&&E.emitOne(I)})}filter(w){return C.filter(this,w)}static coalesce(w){return C.filter(w,A=>!!A)}coalesce(){return C.coalesce(this)}static async toPromise(w){const A=[];for await(const E of w)A.push(E);return A}toPromise(){return C.toPromise(this)}g(w){this.a===0&&(this.b.push(w),this.f.fire())}h(w){this.a===0&&(this.b=this.b.concat(w),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(w){this.a===0&&(this.a=2,this.d=w,this.f.fire())}}t.$lh=C;class _ extends C{constructor(w,A){super(A),this.l=w}cancel(){this.l.cancel()}}t.$mh=_;function $(Q){const w=new v.$2d,A=Q(w.token);return new _(w,async E=>{const I=w.token.onCancellationRequested(()=>{I.dispose(),w.dispose(),E.reject(new N.$4)});try{for await(const k of A){if(w.token.isCancellationRequested)return;E.emitOne(k)}I.dispose(),w.dispose()}catch(k){I.dispose(),w.dispose(),E.reject(k)}})}t.$nh=$;class W{constructor(){this.a=new Z,this.b=new C(E=>{if(w){E.reject(w);return}return A&&E.emitMany(A),this.d=I=>E.reject(I),this.f=I=>E.emitOne(I),this.a.p});let w,A;this.f=E=>{A||(A=[]),A.push(E)},this.d=E=>{w||(w=E)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(w){this.d(w),this.a.complete()}emitOne(w){this.f(w)}}t.$oh=W}),define(be[3],$e([1,0,16,113,14,19,9,6,4,117,2,31,5,15,49,21]),function(ae,t,v,N,i,U,p,D,c,g,m,T,n,o,e,h){"use strict";var a;Object.defineProperty(t,"__esModule",{value:!0}),t.$yQ=t.$xQ=t.h=t.$vQ=t.$uQ=t.$tQ=t.$sQ=t.$rQ=t.$qQ=t.$pQ=t.$oQ=t.DetectedFullscreenMode=t.$nQ=t.$mQ=t.$lQ=t.$kQ=t.$jQ=t.$iQ=t.$hQ=t.$gQ=t.$fQ=t.$eQ=t.$dQ=t.$cQ=t.$bQ=t.$aQ=t.$_P=t.$$P=t.$0P=t.$=t.Namespace=t.$8P=t.$7P=t.$6P=t.$5P=t.$4P=t.$3P=t.$2P=t.$1P=t.$ZP=t.$YP=t.$XP=t.$WP=t.$VP=t.$UP=t.$TP=t.$SP=t.$RP=t.$QP=t.$PP=t.$OP=t.$NP=t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=t.$wP=t.$vP=t.$uP=t.$tP=t.$sP=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.$jP=t.$iP=t.$hP=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$4O=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.getWindowId=t.getWindowsCount=t.getWindows=t.registerWindow=void 0,a=function(){const K=new Map;(0,h.$wO)(h.$xO,1),K.set(h.$xO.vscodeWindowId,{window:h.$xO,disposables:new m.$Qc});const Y=new c.$Rd,re=new c.$Rd,ge=new c.$Rd;return{onDidRegisterWindow:Y.event,onWillUnregisterWindow:ge.event,onDidUnregisterWindow:re.event,registerWindow(ye){if(K.has(ye.vscodeWindowId))return m.$Rc.None;const Oe=new m.$Qc,ze={window:ye,disposables:Oe.add(new m.$Qc)};return K.set(ye.vscodeWindowId,ze),Oe.add((0,m.$Pc)(()=>{K.delete(ye.vscodeWindowId),re.fire(ye)})),Oe.add(r(ye,t.$YP.BEFORE_UNLOAD,()=>{ge.fire(ye)})),Y.fire(ze),Oe},getWindows(){return K.values()},getWindowsCount(){return K.size},getWindowId(ye){return ye.vscodeWindowId}}}(),t.registerWindow=a.registerWindow,t.getWindows=a.getWindows,t.getWindowsCount=a.getWindowsCount,t.getWindowId=a.getWindowId,t.onDidRegisterWindow=a.onDidRegisterWindow,t.onWillUnregisterWindow=a.onWillUnregisterWindow,t.onDidUnregisterWindow=a.onDidUnregisterWindow;function f(K){for(;K.firstChild;)K.firstChild.remove()}t.$4O=f;class s{constructor(Y,re,ge,ye){this.f=Y,this.g=re,this.d=ge,this.j=ye||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function r(K,Y,re,ge){return new s(K,Y,re,ge)}t.$5O=r;function b(K,Y){return function(re){return Y(new U.$WO(K,re))}}function u(K){return function(Y){return K(new i.$2O(Y))}}const l=function(Y,re,ge,ye){let Oe=ge;return re==="click"||re==="mousedown"?Oe=b(Se(Y),ge):(re==="keydown"||re==="keypress"||re==="keyup")&&(Oe=u(ge)),r(Y,re,Oe,ye)};t.$6O=l;const F=function(Y,re,ge){const ye=b(Se(Y),re);return L(Y,ye,ge)};t.$7O=F;const z=function(Y,re,ge){const ye=b(Se(Y),re);return y(Y,ye,ge)};t.$8O=z;function L(K,Y,re){return r(K,n.$r&&N.$TO.pointerEvents?t.$YP.POINTER_DOWN:t.$YP.MOUSE_DOWN,Y,re)}t.$9O=L;function d(K,Y,re){return r(K,n.$r&&N.$TO.pointerEvents?t.$YP.POINTER_MOVE:t.$YP.MOUSE_MOVE,Y,re)}t.$0O=d;function y(K,Y,re){return r(K,n.$r&&N.$TO.pointerEvents?t.$YP.POINTER_UP:t.$YP.MOUSE_UP,Y,re)}t.$$O=y;function M(K,Y,re){return(0,p.$eh)(K,Y,re)}t.$_O=M;class V extends p.$fh{constructor(Y,re){super(Y,re)}}t.$aP=V;function x(K,Y,re,ge){let ye=0;const Oe=K.setInterval(()=>{ye++,(typeof ge=="number"&&ye>=ge||Y()===!0)&&ze.dispose()},re),ze=(0,m.$Pc)(()=>{K.clearInterval(Oe)});return ze}t.$dP=x;class R extends p.$$g{cancelAndSet(Y,re,ge){return super.cancelAndSet(Y,re,ge)}}t.$eP=R;class B{constructor(Y,re=0){this.d=Y,this.priority=re,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(Y){(0,D.$Z)(Y)}}static sort(Y,re){return re.priority-Y.priority}}(function(){const K=new Map,Y=new Map,re=new Map,ge=new Map,ye=Oe=>{re.set(Oe,!1);const ze=K.get(Oe)??[];for(Y.set(Oe,ze),K.set(Oe,[]),ge.set(Oe,!0);ze.length>0;)ze.sort(B.sort),ze.shift().execute();ge.set(Oe,!1)};t.$cP=(Oe,ze,Ge=0)=>{const Ye=(0,t.getWindowId)(Oe),_e=new B(ze,Ge);let st=K.get(Ye);return st||(st=[],K.set(Ye,st)),st.push(_e),re.get(Ye)||(re.set(Ye,!0),Oe.requestAnimationFrame(()=>ye(Ye))),_e},t.$bP=(Oe,ze,Ge)=>{const Ye=(0,t.getWindowId)(Oe);if(ge.get(Ye)){const _e=new B(ze,Ge);let st=Y.get(Ye);return st||(st=[],Y.set(Ye,st)),st.push(_e),_e}else return(0,t.$cP)(Oe,ze,Ge)}})();function j(K,Y){return(0,t.$cP)(K,Y,1e4)}t.$fP=j;function ie(K,Y){return(0,t.$cP)(K,Y,-1e4)}t.$gP=ie;const te=8,ue=function(K,Y){return Y};class le extends m.$Rc{constructor(Y,re,ge,ye=ue,Oe=te){super();let ze=null,Ge=0;const Ye=this.B(new p.$0g),_e=()=>{Ge=new Date().getTime(),ge(ze),ze=null};this.B(r(Y,re,st=>{ze=ye(ze,st);const Pt=new Date().getTime()-Ge;Pt>=Oe?(Ye.cancel(),_e()):Ye.setIfNotSet(_e,Oe-Pt)}))}}function oe(K,Y,re,ge,ye){return new le(K,Y,re,ge,ye)}t.$hP=oe;function we(K){return Se(K).getComputedStyle(K,null)}t.$iP=we;function Fe(K){const Y=K.ownerDocument,re=Y.defaultView?.window;if(K!==Y.body)return new Le(K.clientWidth,K.clientHeight);if(n.$r&&re?.visualViewport)return new Le(re.visualViewport.width,re.visualViewport.height);if(re?.innerWidth&&re.innerHeight)return new Le(re.innerWidth,re.innerHeight);if(Y.body&&Y.body.clientWidth&&Y.body.clientHeight)return new Le(Y.body.clientWidth,Y.body.clientHeight);if(Y.documentElement&&Y.documentElement.clientWidth&&Y.documentElement.clientHeight)return new Le(Y.documentElement.clientWidth,Y.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.$jP=Fe;class ke{static d(Y,re){return parseFloat(re)||0}static f(Y,re,ge){const ye=we(Y),Oe=ye?ye.getPropertyValue(re):"0";return ke.d(Y,Oe)}static getBorderLeftWidth(Y){return ke.f(Y,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Y){return ke.f(Y,"border-right-width","borderRightWidth")}static getBorderTopWidth(Y){return ke.f(Y,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Y){return ke.f(Y,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Y){return ke.f(Y,"padding-left","paddingLeft")}static getPaddingRight(Y){return ke.f(Y,"padding-right","paddingRight")}static getPaddingTop(Y){return ke.f(Y,"padding-top","paddingTop")}static getPaddingBottom(Y){return ke.f(Y,"padding-bottom","paddingBottom")}static getMarginLeft(Y){return ke.f(Y,"margin-left","marginLeft")}static getMarginTop(Y){return ke.f(Y,"margin-top","marginTop")}static getMarginRight(Y){return ke.f(Y,"margin-right","marginRight")}static getMarginBottom(Y){return ke.f(Y,"margin-bottom","marginBottom")}}class Le{static{this.None=new Le(0,0)}constructor(Y,re){this.width=Y,this.height=re}with(Y=this.width,re=this.height){return Y!==this.width||re!==this.height?new Le(Y,re):this}static is(Y){return typeof Y=="object"&&typeof Y.height=="number"&&typeof Y.width=="number"}static lift(Y){return Y instanceof Le?Y:new Le(Y.width,Y.height)}static equals(Y,re){return Y===re?!0:!Y||!re?!1:Y.width===re.width&&Y.height===re.height}}t.$kP=Le;function de(K){let Y=K.offsetParent,re=K.offsetTop,ge=K.offsetLeft;for(;(K=K.parentNode)!==null&&K!==K.ownerDocument.body&&K!==K.ownerDocument.documentElement;){re-=K.scrollTop;const ye=H(K)?null:we(K);ye&&(ge-=ye.direction!=="rtl"?K.scrollLeft:-K.scrollLeft),K===Y&&(ge+=ke.getBorderLeftWidth(K),re+=ke.getBorderTopWidth(K),re+=K.offsetTop,ge+=K.offsetLeft,Y=K.offsetParent)}return{left:ge,top:re}}t.$lP=de;function ne(K,Y,re){typeof Y=="number"&&(K.style.width=`${Y}px`),typeof re=="number"&&(K.style.height=`${re}px`)}t.$mP=ne;function ce(K,Y,re,ge,ye,Oe="absolute"){typeof Y=="number"&&(K.style.top=`${Y}px`),typeof re=="number"&&(K.style.right=`${re}px`),typeof ge=="number"&&(K.style.bottom=`${ge}px`),typeof ye=="number"&&(K.style.left=`${ye}px`),K.style.position=Oe}t.$nP=ce;function Z(K){const Y=K.getBoundingClientRect(),re=Se(K);return{left:Y.left+re.scrollX,top:Y.top+re.scrollY,width:Y.width,height:Y.height}}t.$oP=Z;function q(K){let Y=K,re=1;do{const ge=we(Y).zoom;ge!=null&&ge!=="1"&&(re*=ge),Y=Y.parentElement}while(Y!==null&&Y!==Y.ownerDocument.documentElement);return re}t.$pP=q;function X(K){const Y=ke.getMarginLeft(K)+ke.getMarginRight(K);return K.offsetWidth+Y}t.$qP=X;function C(K){const Y=ke.getBorderLeftWidth(K)+ke.getBorderRightWidth(K),re=ke.getPaddingLeft(K)+ke.getPaddingRight(K);return K.offsetWidth-Y-re}t.$rP=C;function _(K){const Y=ke.getMarginLeft(K)+ke.getMarginRight(K);return K.scrollWidth+Y}t.$sP=_;function $(K){const Y=ke.getBorderTopWidth(K)+ke.getBorderBottomWidth(K),re=ke.getPaddingTop(K)+ke.getPaddingBottom(K);return K.offsetHeight-Y-re}t.$tP=$;function W(K){const Y=ke.getMarginTop(K)+ke.getMarginBottom(K);return K.offsetHeight+Y}t.$uP=W;function Q(K,Y){if(K===null)return 0;const re=de(K),ge=de(Y);return re.left-ge.left}function w(K,Y){const re=Y.map(ye=>Math.max(_(ye),X(ye))+Q(ye,K)||0);return Math.max(...re)}t.$vP=w;function A(K,Y){return!!Y?.contains(K)}t.$wP=A;const E="parentFlowToElementId";function I(K,Y){K.dataset[E]=Y.id}t.$xP=I;function k(K){const Y=K.dataset[E];return typeof Y=="string"?K.ownerDocument.getElementById(Y):null}function O(K,Y){let re=K;for(;re;){if(re===Y)return!0;if(re instanceof HTMLElement){const ge=k(re);if(ge){re=ge;continue}}re=re.parentNode}return!1}t.$yP=O;function S(K,Y,re){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(K.classList.contains(Y))return K;if(re){if(typeof re=="string"){if(K.classList.contains(re))return null}else if(K===re)return null}K=K.parentNode}return null}t.$zP=S;function P(K,Y,re){return!!S(K,Y,re)}t.$AP=P;function H(K){return K&&!!K.host&&!!K.mode}t.$BP=H;function G(K){return!!ee(K)}t.$CP=G;function ee(K){for(;K.parentNode;){if(K===K.ownerDocument?.body)return null;K=K.parentNode}return H(K)?K:null}t.$DP=ee;function se(){let K=Ce().activeElement;for(;K?.shadowRoot;)K=K.shadowRoot.activeElement;return K}t.$EP=se;function me(K){return K.ownerDocument.activeElement===K}t.$FP=me;function ve(K){return A(K.ownerDocument.activeElement,K)}t.$GP=ve;function Ne(K){return K.ownerDocument===Ce()}t.$HP=Ne;function Ce(){return(0,t.getWindowsCount)()<=1?document:Array.from((0,t.getWindows)()).map(({window:Y})=>Y.document).find(Y=>Y.hasFocus())??document}t.$IP=Ce;function De(K){return Se(K).document}t.$JP=De;function Te(){return Ce().defaultView?.window??h.$xO}t.$KP=Te;function Se(K){const Y=K;if(Y?.ownerDocument?.defaultView)return Y.ownerDocument.defaultView.window;const re=K;return re?.view?re.view.window:h.$xO}t.$LP=Se;function Ve(K){const Y=Se(K);Y!==Te()&&Y.focus()}t.$MP=Ve;const je=new Map;function Me(K){return je.has(K)}t.$NP=Me;function Qe(K=h.$xO.document.head,Y,re){const ge=document.createElement("style");if(ge.type="text/css",ge.media="screen",Y?.(ge),K.appendChild(ge),re&&re.add((0,m.$Pc)(()=>K.removeChild(ge))),K===h.$xO.document.head){const ye=new Set;je.set(ge,ye);for(const{window:Oe,disposables:ze}of(0,t.getWindows)()){if(Oe===h.$xO)continue;const Ge=ze.add(he(ge,ye,Oe));re?.add(Ge)}}return ge}t.$OP=Qe;function J(K){const Y=new m.$Qc;for(const[re,ge]of je)Y.add(he(re,ge,K));return Y}t.$PP=J;function he(K,Y,re){const ge=new m.$Qc,ye=K.cloneNode(!0);re.document.head.appendChild(ye),ge.add((0,m.$Pc)(()=>re.document.head.removeChild(ye)));for(const Oe of Be(K))ye.sheet?.insertRule(Oe.cssText,ye.sheet?.cssRules.length);return ge.add(t.$QP.observe(K,ge,{childList:!0})(()=>{ye.textContent=K.textContent})),Y.add(ye),ge.add((0,m.$Pc)(()=>Y.delete(ye))),ge}t.$QP=new class{constructor(){this.mutationObservers=new Map}observe(K,Y,re){let ge=this.mutationObservers.get(K);ge||(ge=new Map,this.mutationObservers.set(K,ge));const ye=(0,e.$Li)(re);let Oe=ge.get(ye);if(Oe)Oe.users+=1;else{const ze=new c.$Rd,Ge=new MutationObserver(_e=>ze.fire(_e));Ge.observe(K,re);const Ye=Oe={users:1,observer:Ge,onDidMutate:ze.event};Y.add((0,m.$Pc)(()=>{Ye.users-=1,Ye.users===0&&(ze.dispose(),Ge.disconnect(),ge?.delete(ye),ge?.size===0&&this.mutationObservers.delete(K))})),ge.set(ye,Oe)}return Oe.onDidMutate}};function pe(K=h.$xO.document.head){const Y=document.createElement("meta");return K.appendChild(Y),Y}t.$RP=pe;let Ee=null;function Pe(){return Ee||(Ee=Qe()),Ee}function Be(K){return K?.sheet?.rules?K.sheet.rules:K?.sheet?.cssRules?K.sheet.cssRules:[]}function Ue(K,Y,re=Pe()){if(!(!re||!Y)){re.sheet?.insertRule(`${K} {${Y}}`,0);for(const ge of je.get(re)??[])Ue(K,Y,ge)}}t.$SP=Ue;function Ze(K,Y=Pe()){if(!Y)return;const re=Be(Y),ge=[];for(let ye=0;ye<re.length;ye++){const Oe=re[ye];Je(Oe)&&Oe.selectorText.indexOf(K)!==-1&&ge.push(ye)}for(let ye=ge.length-1;ye>=0;ye--)Y.sheet?.deleteRule(ge[ye]);for(const ye of je.get(Y)??[])Ze(K,ye)}t.$TP=Ze;function Je(K){return typeof K.selectorText=="string"}function xe(K){return K instanceof MouseEvent||K instanceof Se(K).MouseEvent}t.$UP=xe;function qe(K){return K instanceof KeyboardEvent||K instanceof Se(K).KeyboardEvent}t.$VP=qe;function tt(K){return K instanceof PointerEvent||K instanceof Se(K).PointerEvent}t.$WP=tt;function nt(K){return K instanceof DragEvent||K instanceof Se(K).DragEvent}t.$XP=nt,t.$YP={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:v.$LO?"webkitAnimationStart":"animationstart",ANIMATION_END:v.$LO?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:v.$LO?"webkitAnimationIteration":"animationiteration"};function dt(K){const Y=K;return!!(Y&&typeof Y.preventDefault=="function"&&typeof Y.stopPropagation=="function")}t.$ZP=dt,t.$1P={stop:(K,Y)=>(K.preventDefault(),Y&&K.stopPropagation(),K)};function ft(K){const Y=[];for(let re=0;K&&K.nodeType===K.ELEMENT_NODE;re++)Y[re]=K.scrollTop,K=K.parentNode;return Y}t.$2P=ft;function ct(K,Y){for(let re=0;K&&K.nodeType===K.ELEMENT_NODE;re++)K.scrollTop!==Y[re]&&(K.scrollTop=Y[re]),K=K.parentNode}t.$3P=ct;class gt extends m.$Rc{static m(Y){if(Y instanceof HTMLElement){const re=ee(Y),ge=re?re.activeElement:Y.ownerDocument.activeElement;return A(ge,Y)}else{const re=Y;return A(re.document.activeElement,re.document)}}constructor(Y){super(),this.f=this.B(new c.$Rd),this.onDidFocus=this.f.event,this.g=this.B(new c.$Rd),this.onDidBlur=this.g.event;let re=gt.m(Y),ge=!1;const ye=()=>{ge=!1,re||(re=!0,this.f.fire())},Oe=()=>{re&&(ge=!0,(Y instanceof HTMLElement?Se(Y):Y).setTimeout(()=>{ge&&(ge=!1,re=!1,this.g.fire())},0))};this.j=()=>{gt.m(Y)!==re&&(re?Oe():ye())},this.B(r(Y,t.$YP.FOCUS,ye,!0)),this.B(r(Y,t.$YP.BLUR,Oe,!0)),Y instanceof HTMLElement&&(this.B(r(Y,t.$YP.FOCUS_IN,()=>this.j())),this.B(r(Y,t.$YP.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function kt(K){return new gt(K)}t.$4P=kt;function Ct(K,Y){return K.after(Y),Y}t.$5P=Ct;function wt(K,...Y){if(K.append(...Y),Y.length===1&&typeof Y[0]!="string")return Y[0]}t.$6P=wt;function Mt(K,Y){return K.insertBefore(Y,K.firstChild),Y}t.$7P=Mt;function Ie(K,...Y){K.innerText="",wt(K,...Y)}t.$8P=Ie;const fe=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Ae;(function(K){K.HTML="http://www.w3.org/1999/xhtml",K.SVG="http://www.w3.org/2000/svg"})(Ae||(t.Namespace=Ae={}));function Re(K,Y,re,...ge){const ye=fe.exec(Y);if(!ye)throw new Error("Bad use of emmet");const Oe=ye[1]||"div";let ze;return K!==Ae.HTML?ze=document.createElementNS(K,Oe):ze=document.createElement(Oe),ye[3]&&(ze.id=ye[3]),ye[4]&&(ze.className=ye[4].replace(/\./g," ").trim()),re&&Object.entries(re).forEach(([Ge,Ye])=>{typeof Ye>"u"||(/^on\w+$/.test(Ge)?ze[Ge]=Ye:Ge==="selected"?Ye&&ze.setAttribute(Ge,"true"):ze.setAttribute(Ge,Ye))}),ze.append(...ge),ze}function We(K,Y,...re){return Re(Ae.HTML,K,Y,...re)}t.$=We,We.SVG=function(K,Y,...re){return Re(Ae.SVG,K,Y,...re)};function et(K,Y){const re=[];return K.forEach((ge,ye)=>{ye>0&&(Y instanceof Node?re.push(Y.cloneNode()):re.push(document.createTextNode(Y))),re.push(ge)}),re}t.$0P=et;function rt(K,...Y){K?Ke(...Y):lt(...Y)}t.$$P=rt;function Ke(...K){for(const Y of K)Y.style.display="",Y.removeAttribute("aria-hidden")}t.$_P=Ke;function lt(...K){for(const Y of K)Y.style.display="none",Y.setAttribute("aria-hidden","true")}t.$aQ=lt;function vt(K,Y){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(K instanceof HTMLElement&&K.hasAttribute(Y))return K;K=K.parentNode}return null}function St(K){!K||!K.hasAttribute("tabIndex")||(K.ownerDocument.activeElement===K&&vt(K.parentElement,"tabIndex")?.focus(),K.removeAttribute("tabindex"))}t.$bQ=St;function Gt(K){return Y=>{Y.preventDefault(),Y.stopPropagation(),K(Y)}}t.$cQ=Gt;function Ai(K){return new Promise(Y=>{if(K.document.readyState==="complete"||K.document&&K.document.body!==null)Y(void 0);else{const ge=()=>{K.window.removeEventListener("DOMContentLoaded",ge,!1),Y()};K.window.addEventListener("DOMContentLoaded",ge,!1)}})}t.$dQ=Ai;function ki(K,Y){const re=K.devicePixelRatio*Y;return Math.max(1,Math.floor(re))/K.devicePixelRatio}t.$eQ=ki;function Ci(K){h.$xO.open(K,"_blank","noopener")}t.$fQ=Ci;const Yt=780,Xt=640;function Si(K){const Y=Math.floor(h.$xO.screenLeft+h.$xO.innerWidth/2-Yt/2),re=Math.floor(h.$xO.screenTop+h.$xO.innerHeight/2-Xt/2);h.$xO.open(K,"_blank",`width=${Yt},height=${Xt},top=${re},left=${Y}`)}t.$gQ=Si;function Pi(K,Y=!0){const re=h.$xO.open();return re?(Y&&(re.opener=null),re.location.href=K,!0):!1}t.$hQ=Pi;function Fi(K,Y){const re=()=>{Y(),ge=(0,t.$cP)(K,re)};let ge=(0,t.$cP)(K,re);return(0,m.$Pc)(()=>ge.dispose())}t.$iQ=Fi,T.$cg.setPreferredWebSchema(/^https:/.test(h.$xO.location.href)?"https":"http");function Ni(K){return K?`url('${T.$ig.uriToBrowserUri(K).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$jQ=Ni;function Ri(K){return`'${K.replace(/'/g,"%27")}'`}t.$kQ=Ri;function Zt(K,Y){if(K!==void 0){const re=K.match(/^\s*var\((.+)\)$/);if(re){const ge=re[1].split(",",2);return ge.length===2&&(Y=Zt(ge[1].trim(),Y)),`var(${ge[0]}, ${Y})`}return K}return Y}t.$lQ=Zt;function Li(K,Y){let re;if(o.URI.isUri(K))re=K.toString(!0);else{const Oe=new Blob([K]);re=URL.createObjectURL(Oe),setTimeout(()=>URL.revokeObjectURL(re))}const ge=Te(),ye=document.createElement("a");ge.document.body.appendChild(ye),ye.download=Y,ye.href=re,ye.click(),setTimeout(()=>ge.document.body.removeChild(ye))}t.$mQ=Li;function Oi(){return new Promise(K=>{const Y=Te(),re=document.createElement("input");Y.document.body.appendChild(re),re.type="file",re.multiple=!0,c.Event.once(c.Event.fromDOMEventEmitter(re,"input"))(()=>{K(re.files??void 0)}),re.click(),setTimeout(()=>Y.document.body.removeChild(re))})}t.$nQ=Oi;var Dt;(function(K){K[K.DOCUMENT=1]="DOCUMENT",K[K.BROWSER=2]="BROWSER"})(Dt||(t.DetectedFullscreenMode=Dt={}));function Ti(K){return K.document.fullscreenElement||K.document.webkitFullscreenElement||K.document.webkitIsFullScreen?{mode:Dt.DOCUMENT,guess:!1}:K.innerHeight===K.screen.height?{mode:Dt.BROWSER,guess:!1}:(n.$j||n.$k)&&K.outerHeight===K.screen.height&&K.outerWidth===K.screen.width?{mode:Dt.BROWSER,guess:!0}:null}t.$oQ=Ti;function Jt(K,Y=!1){const re=document.createElement("a");return g.addHook("afterSanitizeAttributes",ge=>{for(const ye of["href","src"])if(ge.hasAttribute(ye)){const Oe=ge.getAttribute(ye);if(ye==="href"&&Oe.startsWith("#"))continue;if(re.href=Oe,!K.includes(re.protocol.replace(/:$/,""))){if(Y&&ye==="src"&&re.href.startsWith("data:"))continue;ge.removeAttribute(ye)}}}),(0,m.$Pc)(()=>{g.removeHook("afterSanitizeAttributes")})}t.$pQ=Jt;const Ii=[T.Schemas.http,T.Schemas.https,T.Schemas.command];t.$qQ=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Mi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Bi(K,Y){const re=Jt(Ii);try{const ge=g.sanitize(Y,Mi);K.innerHTML=ge}finally{re.dispose()}}t.$rQ=Bi;function zi(K){const Y=new Uint16Array(K.length);for(let ye=0;ye<Y.length;ye++)Y[ye]=K.charCodeAt(ye);let re="";const ge=new Uint8Array(Y.buffer);for(let ye=0;ye<ge.length;ye++)re+=String.fromCharCode(ge[ye]);return re}function ji(K){return btoa(zi(K))}t.$sQ=ji;class bt extends c.$Rd{constructor(){super(),this.o=new m.$Qc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(c.Event.runAndSubscribe(t.onDidRegisterWindow,({window:Y,disposables:re})=>this.B(Y,re),{window:h.$xO,disposables:this.o}))}B(Y,re){re.add(r(Y,"keydown",ge=>{if(ge.defaultPrevented)return;const ye=new i.$2O(ge);if(!(ye.keyCode===6&&ge.repeat)){if(ge.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(ge.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(ge.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(ge.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(ye.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=ge.altKey,this.s.ctrlKey=ge.ctrlKey,this.s.metaKey=ge.metaKey,this.s.shiftKey=ge.shiftKey,this.s.lastKeyPressed&&(this.s.event=ge,this.fire(this.s))}},!0)),re.add(r(Y,"keyup",ge=>{ge.defaultPrevented||(!ge.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!ge.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!ge.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!ge.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=ge.altKey,this.s.ctrlKey=ge.ctrlKey,this.s.metaKey=ge.metaKey,this.s.shiftKey=ge.shiftKey,this.s.lastKeyReleased&&(this.s.event=ge,this.fire(this.s)))},!0)),re.add(r(Y.document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),re.add(r(Y.document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),re.add(r(Y.document.body,"mousemove",ge=>{ge.buttons&&(this.s.lastKeyPressed=void 0)},!0)),re.add(r(Y,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.C(),this.fire(this.s)}C(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return bt.A||(bt.A=new bt),bt.A}dispose(){super.dispose(),this.o.dispose()}}t.$tQ=bt;function Hi(K){const Y=document.cookie.match("(^|[^;]+)\\s*"+K+"\\s*=\\s*([^;]+)");return Y?Y.pop():void 0}t.$uQ=Hi;class Ui extends m.$Rc{constructor(Y,re){super(),this.j=Y,this.m=re,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(r(this.j,t.$YP.DRAG_START,Y=>{this.m.onDragStart?.(Y)})),this.m.onDrag&&this.B(r(this.j,t.$YP.DRAG,Y=>{this.m.onDrag?.(Y)})),this.B(r(this.j,t.$YP.DRAG_ENTER,Y=>{this.f++,this.g=Y.timeStamp,this.m.onDragEnter?.(Y)})),this.B(r(this.j,t.$YP.DRAG_OVER,Y=>{Y.preventDefault(),this.m.onDragOver?.(Y,Y.timeStamp-this.g)})),this.B(r(this.j,t.$YP.DRAG_LEAVE,Y=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(Y))})),this.B(r(this.j,t.$YP.DRAG_END,Y=>{this.f=0,this.g=0,this.m.onDragEnd?.(Y)})),this.B(r(this.j,t.$YP.DROP,Y=>{this.f=0,this.g=0,this.m.onDrop?.(Y)}))}}t.$vQ=Ui;const Wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function qi(K,...Y){let re,ge;Array.isArray(Y[0])?(re={},ge=Y[0]):(re=Y[0]||{},ge=Y[1]);const ye=Wi.exec(K);if(!ye||!ye.groups)throw new Error("Bad use of h");const Oe=ye.groups.tag||"div",ze=document.createElement(Oe);ye.groups.id&&(ze.id=ye.groups.id);const Ge=[];if(ye.groups.class)for(const _e of ye.groups.class.split("."))_e!==""&&Ge.push(_e);if(re.className!==void 0)for(const _e of re.className.split("."))_e!==""&&Ge.push(_e);Ge.length>0&&(ze.className=Ge.join(" "));const Ye={};if(ye.groups.name&&(Ye[ye.groups.name]=ze),ge)for(const _e of ge)_e instanceof HTMLElement?ze.appendChild(_e):typeof _e=="string"?ze.append(_e):"root"in _e&&(Object.assign(Ye,_e),ze.appendChild(_e.root));for(const[_e,st]of Object.entries(re))if(_e!=="className")if(_e==="style")for(const[Pt,Bt]of Object.entries(st))ze.style.setProperty(ei(Pt),typeof Bt=="number"?Bt+"px":""+Bt);else _e==="tabIndex"?ze.tabIndex=st:ze.setAttribute(ei(_e),st.toString());return Ye.root=ze,Ye}t.h=qi;function ei(K){return K.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(K,Y){for(const{name:re,value:ge}of K.attributes)Y.setAttribute(re,ge)}t.$xQ=ti;function _i(K,Y,re){const ge=K.getAttribute(re);ge?Y.setAttribute(re,ge):Y.removeAttribute(re)}function Vi(K,Y,re){ti(K,Y);const ge=new m.$Qc;return ge.add(t.$QP.observe(K,ge,{attributes:!0,attributeFilter:re})(ye=>{for(const Oe of ye)Oe.type==="attributes"&&Oe.attributeName&&_i(K,Y,Oe.attributeName)})),ge}t.$yQ=Vi}),define(be[54],$e([1,0,3,2,116]),function(ae,t,v,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BQ=t.$AQ=t.$zQ=void 0;class U extends N.$Rc{constructor(c,g){super(),this.B((0,v.$5O)(c,"dragover",m=>{m.preventDefault(),this.a||(this.a=setTimeout(()=>{g(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(m=>{this.B((0,v.$5O)(c,m,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$zQ=U,t.$AQ={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.$Xr.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function p(D,c,g,m,T){const n=document.createElement("div");if(n.className=g,n.textContent=c,T&&(n.style.color=T),m&&(n.style.background=m),D.dataTransfer){const o=(0,v.$LP)(D).document;o.body.appendChild(n),D.dataTransfer.setDragImage(n,-10,-10),setTimeout(()=>o.body.removeChild(n),0)}}t.$BQ=p}),define(be[55],$e([1,0,3]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6Q=t.$5Q=t.$4Q=void 0;function N(n,o={}){const e=U(o);return e.textContent=n,e}t.$4Q=N;function i(n,o={}){const e=U(o);return c(e,g(n,!!o.renderCodeSegments),o.actionHandler,o.renderCodeSegments),e}t.$5Q=i;function U(n){const o=n.inline?"span":"div",e=document.createElement(o);return n.className&&(e.className=n.className),e}t.$6Q=U;class p{constructor(o){this.b=o,this.c=0}eos(){return this.c>=this.b.length}next(){const o=this.peek();return this.advance(),o}peek(){return this.b[this.c]}advance(){this.c++}}var D;(function(n){n[n.Invalid=0]="Invalid",n[n.Root=1]="Root",n[n.Text=2]="Text",n[n.Bold=3]="Bold",n[n.Italics=4]="Italics",n[n.Action=5]="Action",n[n.ActionClose=6]="ActionClose",n[n.Code=7]="Code",n[n.NewLine=8]="NewLine"})(D||(D={}));function c(n,o,e,h){let a;if(o.type===2)a=document.createTextNode(o.content||"");else if(o.type===3)a=document.createElement("b");else if(o.type===4)a=document.createElement("i");else if(o.type===7&&h)a=document.createElement("code");else if(o.type===5&&e){const f=document.createElement("a");e.disposables.add(v.$6O(f,"click",s=>{e.callback(String(o.index),s)})),a=f}else o.type===8?a=document.createElement("br"):o.type===1&&(a=n);a&&n!==a&&n.appendChild(a),a&&Array.isArray(o.children)&&o.children.forEach(f=>{c(a,f,e,h)})}function g(n,o){const e={type:1,children:[]};let h=0,a=e;const f=[],s=new p(n);for(;!s.eos();){let r=s.next();const b=r==="\\"&&T(s.peek(),o)!==0;if(b&&(r=s.next()),!b&&m(r,o)&&r===s.peek()){s.advance(),a.type===2&&(a=f.pop());const u=T(r,o);if(a.type===u||a.type===5&&u===6)a=f.pop();else{const l={type:u,children:[]};u===5&&(l.index=h,h++),a.children.push(l),f.push(a),a=l}}else if(r===`
`)a.type===2&&(a=f.pop()),a.children.push({type:8});else if(a.type!==2){const u={type:2,content:r};a.children.push(u),f.push(a),a=u}else a.content+=r}return a.type===2&&(a=f.pop()),f.length,e}function m(n,o){return T(n,o)!==0}function T(n,o){switch(n){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return o?7:0;default:return 0}}}),define(be[56],$e([1,0,3,2]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FQ=void 0;class i{constructor(){this.a=new N.$Qc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(p,D){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const c=this.c;this.c=null,p&&c&&c(D)}isMonitoring(){return!!this.b}startMonitoring(p,D,c,g,m){this.isMonitoring()&&this.stopMonitoring(!1),this.b=g,this.c=m;let T=p;try{p.setPointerCapture(D),this.a.add((0,N.$Pc)(()=>{try{p.releasePointerCapture(D)}catch{}}))}catch{T=v.$LP(p)}this.a.add(v.$5O(T,v.$YP.POINTER_MOVE,n=>{if(n.buttons!==c){this.stopMonitoring(!0);return}n.preventDefault(),this.b(n)})),this.a.add(v.$5O(T,v.$YP.POINTER_UP,n=>this.stopMonitoring(!0)))}}t.$FQ=i});var Xe=this&&this.__decorate||function(ae,t,v,N){var i=arguments.length,U=i<3?t:N===null?N=Object.getOwnPropertyDescriptor(t,v):N,p;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(ae,t,v,N);else for(var D=ae.length-1;D>=0;D--)(p=ae[D])&&(U=(i<3?p(U):i>3?p(t,v,U):p(t,v))||U);return i>3&&U&&Object.defineProperty(t,v,U),U};define(be[24],$e([1,0,3,21,12,26,4,2,45]),function(ae,t,v,N,i,U,p,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CQ=t.EventType=void 0;var g;(function(T){T.Tap="-monaco-gesturetap",T.Change="-monaco-gesturechange",T.Start="-monaco-gesturestart",T.End="-monaco-gesturesend",T.Contextmenu="-monaco-gesturecontextmenu"})(g||(t.EventType=g={}));class m extends D.$Rc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new c.$2c,this.h=new c.$2c,this.m={},this.j=null,this.n=0,this.B(p.Event.runAndSubscribe(v.onDidRegisterWindow,({window:n,disposables:o})=>{o.add(v.$5O(n.document,"touchstart",e=>this.s(e),{passive:!1})),o.add(v.$5O(n.document,"touchend",e=>this.u(n,e))),o.add(v.$5O(n.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:N.$xO,disposables:this.q}))}static addTarget(n){if(!m.isTouchDevice())return D.$Rc.None;m.b||(m.b=(0,D.$Kc)(new m));const o=m.b.g.push(n);return(0,D.$Pc)(o)}static ignoreTarget(n){if(!m.isTouchDevice())return D.$Rc.None;m.b||(m.b=(0,D.$Kc)(new m));const o=m.b.h.push(n);return(0,D.$Pc)(o)}static isTouchDevice(){return"ontouchstart"in N.$xO||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(n){const o=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,h=n.targetTouches.length;e<h;e++){const a=n.targetTouches.item(e);this.m[a.identifier]={id:a.identifier,initialTarget:a.target,initialTimeStamp:o,initialPageX:a.pageX,initialPageY:a.pageY,rollingTimestamps:[o],rollingPageX:[a.pageX],rollingPageY:[a.pageY]};const f=this.w(g.Start,a.target);f.pageX=a.pageX,f.pageY=a.pageY,this.z(f)}this.f&&(n.preventDefault(),n.stopPropagation(),this.f=!1)}u(n,o){const e=Date.now(),h=Object.keys(this.m).length;for(let a=0,f=o.changedTouches.length;a<f;a++){const s=o.changedTouches.item(a);if(!this.m.hasOwnProperty(String(s.identifier))){console.warn("move of an UNKNOWN touch",s);continue}const r=this.m[s.identifier],b=Date.now()-r.initialTimeStamp;if(b<m.c&&Math.abs(r.initialPageX-i.$rb(r.rollingPageX))<30&&Math.abs(r.initialPageY-i.$rb(r.rollingPageY))<30){const u=this.w(g.Tap,r.initialTarget);u.pageX=i.$rb(r.rollingPageX),u.pageY=i.$rb(r.rollingPageY),this.z(u)}else if(b>=m.c&&Math.abs(r.initialPageX-i.$rb(r.rollingPageX))<30&&Math.abs(r.initialPageY-i.$rb(r.rollingPageY))<30){const u=this.w(g.Contextmenu,r.initialTarget);u.pageX=i.$rb(r.rollingPageX),u.pageY=i.$rb(r.rollingPageY),this.z(u)}else if(h===1){const u=i.$rb(r.rollingPageX),l=i.$rb(r.rollingPageY),F=i.$rb(r.rollingTimestamps)-r.rollingTimestamps[0],z=u-r.rollingPageX[0],L=l-r.rollingPageY[0],d=[...this.g].filter(y=>r.initialTarget instanceof Node&&y.contains(r.initialTarget));this.C(n,d,e,Math.abs(z)/F,z>0?1:-1,u,Math.abs(L)/F,L>0?1:-1,l)}this.z(this.w(g.End,r.initialTarget)),delete this.m[s.identifier]}this.f&&(o.preventDefault(),o.stopPropagation(),this.f=!1)}w(n,o){const e=document.createEvent("CustomEvent");return e.initEvent(n,!1,!0),e.initialTarget=o,e.tapCount=0,e}z(n){if(n.type===g.Tap){const o=new Date().getTime();let e=0;o-this.n>m.r?e=1:e=2,this.n=o,n.tapCount=e}else(n.type===g.Change||n.type===g.Contextmenu)&&(this.n=0);if(n.initialTarget instanceof Node){for(const o of this.h)if(o.contains(n.initialTarget))return;for(const o of this.g)o.contains(n.initialTarget)&&(o.dispatchEvent(n),this.f=!0)}}C(n,o,e,h,a,f,s,r,b){this.j=v.$cP(n,()=>{const u=Date.now(),l=u-e;let F=0,z=0,L=!0;h+=m.a*l,s+=m.a*l,h>0&&(L=!1,F=a*h*l),s>0&&(L=!1,z=r*s*l);const d=this.w(g.Change);d.translationX=F,d.translationY=z,o.forEach(y=>y.dispatchEvent(d)),L||this.C(n,o,u,h,a,f+F,s,r,b+z)})}D(n){const o=Date.now();for(let e=0,h=n.changedTouches.length;e<h;e++){const a=n.changedTouches.item(e);if(!this.m.hasOwnProperty(String(a.identifier))){console.warn("end of an UNKNOWN touch",a);continue}const f=this.m[a.identifier],s=this.w(g.Change,f.initialTarget);s.translationX=a.pageX-i.$rb(f.rollingPageX),s.translationY=a.pageY-i.$rb(f.rollingPageY),s.pageX=a.pageX,s.pageY=a.pageY,this.z(s),f.rollingPageX.length>3&&(f.rollingPageX.shift(),f.rollingPageY.shift(),f.rollingTimestamps.shift()),f.rollingPageX.push(a.pageX),f.rollingPageY.push(a.pageY),f.rollingTimestamps.push(o)}this.f&&(n.preventDefault(),n.stopPropagation(),this.f=!1)}}t.$CQ=m,Xe([U.$ph],m,"isTouchDevice",null)}),define(be[57],$e([1,0,3,91]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0Q=t.$9Q=t.$8Q=void 0;const N=2e4;let i,U,p,D,c;function g(o){i=document.createElement("div"),i.className="monaco-aria-container";const e=()=>{const a=document.createElement("div");return a.className="monaco-alert",a.setAttribute("role","alert"),a.setAttribute("aria-atomic","true"),i.appendChild(a),a};U=e(),p=e();const h=()=>{const a=document.createElement("div");return a.className="monaco-status",a.setAttribute("aria-live","polite"),a.setAttribute("aria-atomic","true"),i.appendChild(a),a};D=h(),c=h(),o.appendChild(i)}t.$8Q=g;function m(o){i&&(U.textContent!==o?(v.$4O(p),n(U,o)):(v.$4O(U),n(p,o)))}t.$9Q=m;function T(o){i&&(D.textContent!==o?(v.$4O(c),n(D,o)):(v.$4O(D),n(c,o)))}t.$0Q=T;function n(o,e){v.$4O(o),e.length>N&&(e=e.substr(0,N)),o.textContent=e,o.style.visibility="hidden",o.style.visibility="visible"}}),define(be[118],$e([1,0,3,18]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wR=t.$vR=void 0;const i=new RegExp(`(\\\\)?\\$\\((${N.ThemeIcon.iconNameExpression}(?:${N.ThemeIcon.iconModifierExpression})?)\\)`,"g");function U(D){const c=new Array;let g,m=0,T=0;for(;(g=i.exec(D))!==null;){T=g.index||0,m<T&&c.push(D.substring(m,T)),m=(g.index||0)+g[0].length;const[,n,o]=g;c.push(n?`$(${o})`:p({id:o}))}return m<D.length&&c.push(D.substring(m)),c}t.$vR=U;function p(D){const c=v.$("span");return c.classList.add(...N.ThemeIcon.asClassNameArray(D)),c}t.$wR=p}),define(be[119],$e([1,0,3]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gR=void 0;function N(U){try{U.parentElement?.removeChild(U)}catch{}}class i{constructor(p){this.d=p,this.a=new Map,this.b=new Set,this.c=!1}alloc(p){let D=this.h(p).pop(),c=!1;if(D)c=this.b.has(D.domNode),c&&this.b.delete(D.domNode);else{const g=(0,v.$)(".monaco-list-row"),T=this.i(p).renderTemplate(g);D={domNode:g,templateId:p,templateData:T}}return{row:D,isReusingConnectedDomNode:c}}release(p){p&&this.f(p)}transact(p){if(this.c)throw new Error("Already in transaction");this.c=!0;try{p()}finally{for(const D of this.b)this.g(D);this.b.clear(),this.c=!1}}f(p){const{domNode:D,templateId:c}=p;D&&(this.c?this.b.add(D):this.g(D)),this.h(c).push(p)}g(p){p.classList.remove("scrolling"),N(p)}h(p){let D=this.a.get(p);return D||(D=[],this.a.set(p,D)),D}dispose(){this.a.forEach((p,D)=>{for(const c of p)this.i(D).disposeTemplate(c.templateData),c.templateData=null}),this.a.clear(),this.b.clear()}i(p){const D=this.d.get(p);if(!D)throw new Error(`No renderer found for ${p}`);return D}}t.$gR=i}),define(be[120],$e([1,0,9,2]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KQ=void 0;class i extends N.$Rc{constructor(p,D,c){super(),this.a=p,this.b=D,this.c=c,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new v.$0g)}setVisibility(p){this.a!==p&&(this.a=p,this.s())}setShouldBeVisible(p){this.g=p,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const p=this.r();this.h!==p&&(this.h=p,this.ensureVisibility())}setIsNeeded(p){this.j!==p&&(this.j=p,this.ensureVisibility())}setDomNode(p){this.f=p,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(p){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(p?" fade":"")))}}t.$KQ=i}),define(be[121],$e([1,0,3,24,12,4,2,5]),function(ae,t,v,N,i,U,p,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DR=void 0;class c extends p.$Rc{constructor(m,T,n,o){super(),this.f=0,this.b=o||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new U.$Rd),this.h=n,this.j(),this.setOptions(m,T)}j(){this.B(N.$CQ.addTarget(this.a)),[N.EventType.Tap].forEach(m=>{this.B(v.$5O(this.a,m,T=>{this.a.focus()}))}),this.B(v.$6O(this.a,"click",m=>{v.$1P.stop(m,!0)})),this.B(v.$6O(this.a,"change",m=>{this.a.title=m.target.value,this.g.fire({index:m.target.selectedIndex,selected:m.target.value})})),this.B(v.$6O(this.a,"keydown",m=>{let T=!1;D.$j?(m.keyCode===18||m.keyCode===16||m.keyCode===10)&&(T=!0):(m.keyCode===18&&m.altKey||m.keyCode===10||m.keyCode===3)&&(T=!0),T&&m.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(m,T){(!this.c||!i.$tb(this.c,m))&&(this.c=m,this.a.options.length=0,this.c.forEach((n,o)=>{this.a.add(this.m(n.text,o,n.isDisabled))})),T!==void 0&&this.select(T)}select(m){this.c.length===0?this.f=0:m>=0&&m<this.c.length?this.f=m:m>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(m){this.b.ariaLabel=m,this.a.setAttribute("aria-label",m)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(m){this.a.tabIndex=m?0:-1}render(m){m.classList.add("select-container"),m.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(m){this.h=m,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(m,T,n){const o=document.createElement("option");return o.value=m,o.text=m,o.disabled=!!n,o}}t.$DR=c}),define(be[58],$e([1,0,25,12,9,50,86,4,27]),function(ae,t,v,N,i,U,p,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$S=t.$0S=t.$9S=void 0;function g(o){return typeof o=="object"&&"visibility"in o&&"data"in o}t.$9S=g;function m(o){switch(o){case!0:return 1;case!1:return 0;default:return o}}t.$0S=m;function T(o){return typeof o.collapsible=="boolean"}class n{constructor(e,h,a,f={}){this.o=e,this.p=h,this.rootRef=[],this.d=new D.$Zd,this.f=new D.$Rd,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new D.$Rd,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new D.$Rd,this.onDidSplice=this.l.event,this.m=new i.$Wg(U.$Od),this.h=typeof f.collapseByDefault>"u"?!1:f.collapseByDefault,this.j=f.filter,this.k=typeof f.autoExpandSingleChildren>"u"?!1:f.autoExpandSingleChildren,this.c={parent:void 0,element:a,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,h,a=c.Iterable.empty(),f={}){if(e.length===0)throw new v.$7S(this.o,"Invalid tree location");f.diffIdentityProvider?this.q(f.diffIdentityProvider,e,h,a,f):this.s(e,h,a,f)}q(e,h,a,f=c.Iterable.empty(),s,r=s.diffDepth??0){const{parentNode:b}=this.G(h);if(!b.lastDiffIds)return this.s(h,a,f,s);const u=[...f],l=h[h.length-1],F=new p.$Hs({getElements:()=>b.lastDiffIds},{getElements:()=>[...b.children.slice(0,l),...u,...b.children.slice(l+a)].map(M=>e.getId(M.element).toString())}).ComputeDiff(!1);if(F.quitEarly)return b.lastDiffIds=void 0,this.s(h,a,u,s);const z=h.slice(0,-1),L=(M,V,x)=>{if(r>0)for(let R=0;R<x;R++)M--,V--,this.q(e,[...z,M,0],Number.MAX_SAFE_INTEGER,u[V].children,s,r-1)};let d=Math.min(b.children.length,l+a),y=u.length;for(const M of F.changes.sort((V,x)=>x.originalStart-V.originalStart))L(d,y,d-(M.originalStart+M.originalLength)),d=M.originalStart,y=M.modifiedStart-l,this.s([...z,d],M.originalLength,c.Iterable.slice(u,y,y+M.modifiedLength),s);L(d,y,d)}s(e,h,a=c.Iterable.empty(),{onDidCreateNode:f,onDidDeleteNode:s,diffIdentityProvider:r}){const{parentNode:b,listIndex:u,revealed:l,visible:F}=this.G(e),z=[],L=c.Iterable.map(a,ue=>this.w(ue,b,b.visible?1:0,l,z,f)),d=e[e.length-1],y=b.children.length>0;let M=0;for(let ue=d;ue>=0&&ue<b.children.length;ue--){const le=b.children[ue];if(le.visible){M=le.visibleChildIndex;break}}const V=[];let x=0,R=0;for(const ue of L)V.push(ue),R+=ue.renderNodeCount,ue.visible&&(ue.visibleChildIndex=M+x++);const B=(0,N.$5b)(b.children,d,h,V);r?b.lastDiffIds?(0,N.$5b)(b.lastDiffIds,d,h,V.map(ue=>r.getId(ue.element).toString())):b.lastDiffIds=b.children.map(ue=>r.getId(ue.element).toString()):b.lastDiffIds=void 0;let j=0;for(const ue of B)ue.visible&&j++;if(j!==0)for(let ue=d+V.length;ue<b.children.length;ue++){const le=b.children[ue];le.visible&&(le.visibleChildIndex-=j)}if(b.visibleChildrenCount+=x-j,l&&F){const ue=B.reduce((le,oe)=>le+(oe.visible?oe.renderNodeCount:0),0);this.B(b,R-ue),this.p.splice(u,ue,z)}if(B.length>0&&s){const ue=le=>{s(le),le.children.forEach(ue)};B.forEach(ue)}this.l.fire({insertedNodes:V,deletedNodes:B});const ie=b.children.length>0;y!==ie&&this.setCollapsible(e.slice(0,-1),ie);let te=b;for(;te;){if(te.visibility===2){this.m.trigger(()=>this.refilter());break}te=te.parent}}rerender(e){if(e.length===0)throw new v.$7S(this.o,"Invalid tree location");const{node:h,listIndex:a,revealed:f}=this.F(e);h.visible&&f&&this.p.splice(a,1,[h])}updateElementHeight(e,h){if(e.length===0)throw new v.$7S(this.o,"Invalid tree location");const{listIndex:a}=this.F(e);this.p.updateElementHeight(a,h)}has(e){return this.D(e)}getListIndex(e){const{listIndex:h,visible:a,revealed:f}=this.F(e);return a&&f?h:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,h){const a=this.E(e);typeof h>"u"&&(h=!a.collapsible);const f={collapsible:h};return this.d.bufferEvents(()=>this.t(e,f))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,h,a){const f=this.E(e);typeof h>"u"&&(h=!f.collapsed);const s={collapsed:h,recursive:a||!1};return this.d.bufferEvents(()=>this.t(e,s))}t(e,h){const{node:a,listIndex:f,revealed:s}=this.F(e),r=this.u(a,f,s,h);if(a!==this.c&&this.k&&r&&!T(h)&&a.collapsible&&!a.collapsed&&!h.recursive){let b=-1;for(let u=0;u<a.children.length;u++)if(a.children[u].visible)if(b>-1){b=-1;break}else b=u;b>-1&&this.t([...e,b],h)}return r}u(e,h,a,f){const s=this.v(e,f,!1);if(!a||!e.visible||!s)return s;const r=e.renderNodeCount,b=this.x(e),u=r-(h===-1?0:1);return this.p.splice(h+1,u,b.slice(1)),s}v(e,h,a){let f;if(e===this.c?f=!1:(T(h)?(f=e.collapsible!==h.collapsible,e.collapsible=h.collapsible):e.collapsible?(f=e.collapsed!==h.collapsed,e.collapsed=h.collapsed):f=!1,f&&this.f.fire({node:e,deep:a})),!T(h)&&h.recursive)for(const s of e.children)f=this.v(s,h,!0)||f;return f}expandTo(e){this.d.bufferEvents(()=>{let h=this.E(e);for(;h.parent;)h=h.parent,e=e.slice(0,e.length-1),h.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,h=this.z(this.c);this.p.splice(0,e,h),this.m.cancel()}w(e,h,a,f,s,r){const b={parent:h,element:e.element,children:[],depth:h.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},u=this.C(b,a);b.visibility=u,f&&s.push(b);const l=e.children||c.Iterable.empty(),F=f&&u!==0&&!b.collapsed;let z=0,L=1;for(const d of l){const y=this.w(d,b,u,F,s,r);b.children.push(y),L+=y.renderNodeCount,y.visible&&(y.visibleChildIndex=z++)}return b.collapsible=b.collapsible||b.children.length>0,b.visibleChildrenCount=z,b.visible=u===2?z>0:u===1,b.visible?b.collapsed||(b.renderNodeCount=L):(b.renderNodeCount=0,f&&s.pop()),r?.(b),b}x(e){const h=e.renderNodeCount,a=[];return this.y(e,a),this.B(e.parent,a.length-h),a}y(e,h){if(e.visible===!1)return 0;if(h.push(e),e.renderNodeCount=1,!e.collapsed)for(const a of e.children)e.renderNodeCount+=this.y(a,h);return this.g.fire(e),e.renderNodeCount}z(e){const h=e.renderNodeCount,a=[];return this.A(e,e.visible?1:0,a),this.B(e.parent,a.length-h),a}A(e,h,a,f=!0){let s;if(e!==this.c){if(s=this.C(e,h),s===0)return e.visible=!1,e.renderNodeCount=0,!1;f&&a.push(e)}const r=a.length;e.renderNodeCount=e===this.c?0:1;let b=!1;if(!e.collapsed||s!==0){let u=0;for(const l of e.children)b=this.A(l,s,a,f&&!e.collapsed)||b,l.visible&&(l.visibleChildIndex=u++);e.visibleChildrenCount=u}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=s===2?b:s===1,e.visibility=s),e.visible?e.collapsed||(e.renderNodeCount+=a.length-r):(e.renderNodeCount=0,f&&a.pop()),this.g.fire(e),e.visible}B(e,h){if(h!==0)for(;e;)e.renderNodeCount+=h,this.g.fire(e),e=e.parent}C(e,h){const a=this.j?this.j.filter(e.element,h):1;return typeof a=="boolean"?(e.filterData=void 0,a?1:0):g(a)?(e.filterData=a.data,m(a.visibility)):(e.filterData=void 0,m(a))}D(e,h=this.c){if(!e||e.length===0)return!0;const[a,...f]=e;return a<0||a>h.children.length?!1:this.D(f,h.children[a])}E(e,h=this.c){if(!e||e.length===0)return h;const[a,...f]=e;if(a<0||a>h.children.length)throw new v.$7S(this.o,"Invalid tree location");return this.E(f,h.children[a])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:h,listIndex:a,revealed:f,visible:s}=this.G(e),r=e[e.length-1];if(r<0||r>h.children.length)throw new v.$7S(this.o,"Invalid tree location");const b=h.children[r];return{node:b,listIndex:a,revealed:f,visible:s&&b.visible}}G(e,h=this.c,a=0,f=!0,s=!0){const[r,...b]=e;if(r<0||r>h.children.length)throw new v.$7S(this.o,"Invalid tree location");for(let u=0;u<r;u++)a+=h.children[u].renderNodeCount;return f=f&&!h.collapsed,s=s&&h.visible,b.length===0?{parentNode:h,listIndex:a,revealed:f,visible:s}:this.G(b,h.children[r],a+1,f,s)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const h=[];let a=e;for(;a.parent;)h.push(a.parent.children.indexOf(a)),a=a.parent;return h.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,N.$sb)(e)[0]}getFirstElementChild(e){const h=this.E(e);if(h.children.length!==0)return h.children[0].element}getLastElementAncestor(e=[]){const h=this.E(e);if(h.children.length!==0)return this.H(h)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$$S=n}),define(be[122],$e([1,0,58,25,27]),function(ae,t,v,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eT=void 0;class U{get size(){return this.d.size}constructor(D,c,g={}){this.k=D,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new v.$$S(D,c,null,g),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,g.sorter&&(this.j={compare(m,T){return g.sorter.compare(m.element,T.element)}}),this.h=g.identityProvider}setChildren(D,c=i.Iterable.empty(),g={}){const m=this.o(D);this.l(m,this.m(c),g)}l(D,c=i.Iterable.empty(),g){const m=new Set,T=new Set,n=e=>{if(e.element===null)return;const h=e;if(m.add(h.element),this.d.set(h.element,h),this.h){const a=this.h.getId(h.element).toString();T.add(a),this.f.set(a,h)}g.onDidCreateNode?.(h)},o=e=>{if(e.element===null)return;const h=e;if(m.has(h.element)||this.d.delete(h.element),this.h){const a=this.h.getId(h.element).toString();T.has(a)||this.f.delete(a)}g.onDidDeleteNode?.(h)};this.c.splice([...D,0],Number.MAX_VALUE,c,{...g,onDidCreateNode:n,onDidDeleteNode:o})}m(D=i.Iterable.empty()){return this.j&&(D=[...D].sort(this.j.compare.bind(this.j))),i.Iterable.map(D,c=>{let g=this.d.get(c.element);if(!g&&this.h){const n=this.h.getId(c.element).toString();g=this.f.get(n)}if(!g){let n;return typeof c.collapsed>"u"?n=void 0:c.collapsed===N.ObjectTreeElementCollapseState.Collapsed||c.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed?n=!0:c.collapsed===N.ObjectTreeElementCollapseState.Expanded||c.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?n=!1:n=!!c.collapsed,{...c,children:this.m(c.children),collapsed:n}}const m=typeof c.collapsible=="boolean"?c.collapsible:g.collapsible;let T;return typeof c.collapsed>"u"||c.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed||c.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?T=g.collapsed:c.collapsed===N.ObjectTreeElementCollapseState.Collapsed?T=!0:c.collapsed===N.ObjectTreeElementCollapseState.Expanded?T=!1:T=!!c.collapsed,{...c,collapsible:m,collapsed:T,children:this.m(c.children)}})}rerender(D){const c=this.o(D);this.c.rerender(c)}updateElementHeight(D,c){const g=this.o(D);this.c.updateElementHeight(g,c)}resort(D=null,c=!0){if(!this.j)return;const g=this.o(D),m=this.c.getNode(g);this.l(g,this.n(m,c),{})}n(D,c,g=!0){let m=[...D.children];return(c||g)&&(m=m.sort(this.j.compare.bind(this.j))),i.Iterable.map(m,T=>({element:T.element,collapsible:T.collapsible,collapsed:T.collapsed,children:this.n(T,c,!1)}))}getFirstElementChild(D=null){const c=this.o(D);return this.c.getFirstElementChild(c)}getLastElementAncestor(D=null){const c=this.o(D);return this.c.getLastElementAncestor(c)}has(D){return this.d.has(D)}getListIndex(D){const c=this.o(D);return this.c.getListIndex(c)}getListRenderCount(D){const c=this.o(D);return this.c.getListRenderCount(c)}isCollapsible(D){const c=this.o(D);return this.c.isCollapsible(c)}setCollapsible(D,c){const g=this.o(D);return this.c.setCollapsible(g,c)}isCollapsed(D){const c=this.o(D);return this.c.isCollapsed(c)}setCollapsed(D,c,g){const m=this.o(D);return this.c.setCollapsed(m,c,g)}expandTo(D){const c=this.o(D);this.c.expandTo(c)}refilter(){this.c.refilter()}getNode(D=null){if(D===null)return this.c.getNode(this.c.rootRef);const c=this.d.get(D);if(!c)throw new N.$7S(this.k,`Tree element not found: ${D}`);return c}getNodeLocation(D){return D.element}getParentNodeLocation(D){if(D===null)throw new N.$7S(this.k,"Invalid getParentNodeLocation call");const c=this.d.get(D);if(!c)throw new N.$7S(this.k,`Tree element not found: ${D}`);const g=this.c.getNodeLocation(c),m=this.c.getParentNodeLocation(g);return this.c.getNode(m).element}o(D){if(D===null)return[];const c=this.d.get(D);if(!c)throw new N.$7S(this.k,`Tree element not found: ${D}`);return this.c.getNodeLocation(c)}}t.$eT=U}),define(be[20],$e([1,0,3,14,19,24,2]),function(ae,t,v,N,i,U,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GQ=void 0;class D extends p.$Rc{f(g,m){this.B(v.$5O(g,v.$YP.CLICK,T=>m(new i.$WO(v.$LP(g),T))))}j(g,m){this.B(v.$5O(g,v.$YP.MOUSE_DOWN,T=>m(new i.$WO(v.$LP(g),T))))}m(g,m){this.B(v.$5O(g,v.$YP.MOUSE_OVER,T=>m(new i.$WO(v.$LP(g),T))))}u(g,m){this.B(v.$5O(g,v.$YP.MOUSE_LEAVE,T=>m(new i.$WO(v.$LP(g),T))))}z(g,m){this.B(v.$5O(g,v.$YP.KEY_DOWN,T=>m(new N.$2O(T))))}C(g,m){this.B(v.$5O(g,v.$YP.KEY_UP,T=>m(new N.$2O(T))))}D(g,m){this.B(v.$5O(g,v.$YP.INPUT,m))}F(g,m){this.B(v.$5O(g,v.$YP.BLUR,m))}G(g,m){this.B(v.$5O(g,v.$YP.FOCUS,m))}H(g,m){this.B(v.$5O(g,v.$YP.CHANGE,m))}I(g){return U.$CQ.ignoreTarget(g)}}t.$GQ=D}),define(be[38],$e([1,0,56,20,9,18,3]),function(ae,t,v,N,i,U,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IQ=t.$HQ=void 0,t.$HQ=11;class D extends N.$GQ{constructor(g){super(),this.a=g.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=g.bgWidth+"px",this.bgDomNode.style.height=g.bgHeight+"px",typeof g.top<"u"&&(this.bgDomNode.style.top="0px"),typeof g.left<"u"&&(this.bgDomNode.style.left="0px"),typeof g.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof g.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=g.className,this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(g.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$HQ+"px",this.domNode.style.height=t.$HQ+"px",typeof g.top<"u"&&(this.domNode.style.top=g.top+"px"),typeof g.left<"u"&&(this.domNode.style.left=g.left+"px"),typeof g.bottom<"u"&&(this.domNode.style.bottom=g.bottom+"px"),typeof g.right<"u"&&(this.domNode.style.right=g.right+"px"),this.g=this.B(new v.$FQ),this.B(p.$6O(this.bgDomNode,p.$YP.POINTER_DOWN,m=>this.h(m))),this.B(p.$6O(this.domNode,p.$YP.POINTER_DOWN,m=>this.h(m))),this.b=this.B(new p.$eP),this.c=this.B(new i.$0g)}h(g){if(!g.target||!(g.target instanceof Element))return;const m=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,p.$LP(g))};this.a(),this.b.cancel(),this.c.cancelAndSet(m,200),this.g.startMonitoring(g.target,g.pointerId,g.buttons,T=>{},()=>{this.b.cancel(),this.c.cancel()}),g.preventDefault()}}t.$IQ=D}),define(be[59],$e([1,0,3,41,56,38,120,20,5]),function(ae,t,v,N,i,U,p,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LQ=void 0;const g=140;class m extends D.$GQ{constructor(n){super(),this.g=n.lazyRender,this.a=n.host,this.b=n.scrollable,this.c=n.scrollByPage,this.h=n.scrollbarState,this.n=this.B(new p.$KQ(n.visibility,"visible scrollbar "+n.extraScrollbarClassName,"invisible scrollbar "+n.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new i.$FQ),this.s=!0,this.domNode=(0,N.$EQ)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(v.$5O(this.domNode.domNode,v.$YP.POINTER_DOWN,o=>this.M(o)))}t(n){const o=this.B(new U.$IQ(n));this.domNode.domNode.appendChild(o.bgDomNode),this.domNode.domNode.appendChild(o.domNode)}w(n,o,e,h){this.slider=(0,N.$EQ)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(n),this.slider.setLeft(o),typeof e=="number"&&this.slider.setWidth(e),typeof h=="number"&&this.slider.setHeight(h),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(v.$5O(this.slider.domNode,v.$YP.POINTER_DOWN,a=>{a.button===0&&(a.preventDefault(),this.O(a))})),this.f(this.slider.domNode,a=>{a.leftButton&&a.stopPropagation()})}y(n){return this.h.setVisibleSize(n)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(n){return this.h.setScrollSize(n)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(n){return this.h.setScrollPosition(n)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(n){n.target===this.domNode.domNode&&this.N(n)}delegatePointerDown(n){const o=this.domNode.domNode.getClientRects()[0].top,e=o+this.h.getSliderPosition(),h=o+this.h.getSliderPosition()+this.h.getSliderSize(),a=this.U(n);e<=a&&a<=h?n.button===0&&(n.preventDefault(),this.O(n)):this.N(n)}N(n){let o,e;if(n.target===this.domNode.domNode&&typeof n.offsetX=="number"&&typeof n.offsetY=="number")o=n.offsetX,e=n.offsetY;else{const a=v.$oP(this.domNode.domNode);o=n.pageX-a.left,e=n.pageY-a.top}const h=this.S(o,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(h):this.h.getDesiredScrollPositionFromOffset(h)),n.button===0&&(n.preventDefault(),this.O(n))}O(n){if(!n.target||!(n.target instanceof Element))return;const o=this.U(n),e=this.W(n),h=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(n.target,n.pointerId,n.buttons,a=>{const f=this.W(a),s=Math.abs(f-e);if(c.$i&&s>g){this.P(h.getScrollPosition());return}const b=this.U(a)-o;this.P(h.getDesiredScrollPositionFromDelta(b))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(n){const o={};this.writeScrollPosition(o,n),this.b.setScrollPositionNow(o)}updateScrollbarSize(n){this.X(n),this.h.setScrollbarSize(n),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$LQ=m}),define(be[123],$e([1,0,19,59,38,42,17]),function(ae,t,v,N,i,U,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MQ=void 0;class D extends N.$LQ{constructor(g,m,T){const n=g.getScrollDimensions(),o=g.getCurrentScrollPosition();if(super({lazyRender:m.lazyRender,host:T,scrollbarState:new U.$JQ(m.horizontalHasArrows?m.arrowSize:0,m.horizontal===2?0:m.horizontalScrollbarSize,m.vertical===2?0:m.verticalScrollbarSize,n.width,n.scrollWidth,o.scrollLeft),visibility:m.horizontal,extraScrollbarClassName:"horizontal",scrollable:g,scrollByPage:m.scrollByPage}),m.horizontalHasArrows){const e=(m.arrowSize-i.$HQ)/2,h=(m.horizontalScrollbarSize-i.$HQ)/2;this.t({className:"scra",icon:p.$3j.scrollbarButtonLeft,top:h,left:e,bottom:void 0,right:void 0,bgWidth:m.arrowSize,bgHeight:m.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.$YO(null,1,0))}),this.t({className:"scra",icon:p.$3j.scrollbarButtonRight,top:h,left:void 0,bottom:void 0,right:e,bgWidth:m.arrowSize,bgHeight:m.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.$YO(null,-1,0))})}this.w(Math.floor((m.horizontalScrollbarSize-m.horizontalSliderSize)/2),0,void 0,m.horizontalSliderSize)}R(g,m){this.slider.setWidth(g),this.slider.setLeft(m)}Q(g,m){this.domNode.setWidth(g),this.domNode.setHeight(m),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(g){return this.s=this.J(g.scrollWidth)||this.s,this.s=this.L(g.scrollLeft)||this.s,this.s=this.y(g.width)||this.s,this.s}S(g,m){return g}U(g){return g.pageX}W(g){return g.pageY}X(g){this.slider.setHeight(g)}writeScrollPosition(g,m){g.scrollLeft=m}updateOptions(g){this.updateScrollbarSize(g.horizontal===2?0:g.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.n.setVisibility(g.horizontal),this.c=g.scrollByPage}}t.$MQ=D}),define(be[124],$e([1,0,19,59,38,42,17]),function(ae,t,v,N,i,U,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NQ=void 0;class D extends N.$LQ{constructor(g,m,T){const n=g.getScrollDimensions(),o=g.getCurrentScrollPosition();if(super({lazyRender:m.lazyRender,host:T,scrollbarState:new U.$JQ(m.verticalHasArrows?m.arrowSize:0,m.vertical===2?0:m.verticalScrollbarSize,0,n.height,n.scrollHeight,o.scrollTop),visibility:m.vertical,extraScrollbarClassName:"vertical",scrollable:g,scrollByPage:m.scrollByPage}),m.verticalHasArrows){const e=(m.arrowSize-i.$HQ)/2,h=(m.verticalScrollbarSize-i.$HQ)/2;this.t({className:"scra",icon:p.$3j.scrollbarButtonUp,top:e,left:h,bottom:void 0,right:void 0,bgWidth:m.verticalScrollbarSize,bgHeight:m.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.$YO(null,0,1))}),this.t({className:"scra",icon:p.$3j.scrollbarButtonDown,top:void 0,left:h,bottom:e,right:void 0,bgWidth:m.verticalScrollbarSize,bgHeight:m.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.$YO(null,0,-1))})}this.w(0,Math.floor((m.verticalScrollbarSize-m.verticalSliderSize)/2),m.verticalSliderSize,void 0)}R(g,m){this.slider.setHeight(g),this.slider.setTop(m)}Q(g,m){this.domNode.setWidth(m),this.domNode.setHeight(g),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(g){return this.s=this.J(g.scrollHeight)||this.s,this.s=this.L(g.scrollTop)||this.s,this.s=this.y(g.height)||this.s,this.s}S(g,m){return m}U(g){return g.pageY}W(g){return g.pageX}X(g){this.slider.setWidth(g)}writeScrollPosition(g,m){g.scrollTop=m}updateOptions(g){this.updateScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(g.vertical),this.c=g.scrollByPage}}t.$NQ=D}),define(be[60],$e([1,0,16,3,41,19,123,124,20,9,4,2,5,48,98]),function(ae,t,v,N,i,U,p,D,c,g,m,T,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SQ=t.$RQ=t.$QQ=t.$PQ=t.$OQ=void 0;const e=500,h=50,a=!0;class f{constructor(L,d,y){this.timestamp=L,this.deltaX=d,this.deltaY=y,this.score=0}}class s{static{this.INSTANCE=new s}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let L=1,d=0,y=1,M=this.d;do{const V=M===this.c?L:Math.pow(2,-y);if(L-=V,d+=this.b[M].score*V,M===this.c)break;M=(this.a+M-1)%this.a,y++}while(!0);return d<=.5}acceptStandardWheelEvent(L){const d=N.$LP(L.browserEvent).devicePixelRatio/(0,v.$FO)();n.$i||n.$k?this.accept(Date.now(),L.deltaX/d,L.deltaY/d):this.accept(Date.now(),L.deltaX,L.deltaY)}accept(L,d,y){const M=new f(L,d,y);M.score=this.f(M),this.c===-1&&this.d===-1?(this.b[0]=M,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=M)}f(L){if(Math.abs(L.deltaX)>0&&Math.abs(L.deltaY)>0)return 1;let d=.5;const y=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(L.deltaX)||!this.g(L.deltaY))&&(d+=.25),Math.min(Math.max(d,0),1)}g(L){return Math.abs(Math.round(L)-L)<.01}}t.$OQ=s;class r extends c.$GQ{get options(){return this.a}constructor(L,d,y){super(),this.O=this.B(new m.$Rd),this.onScroll=this.O.event,this.P=this.B(new m.$Rd),this.onWillScroll=this.P.event,L.style.overflow="hidden",this.a=F(d),this.b=y,this.B(this.b.onScroll(V=>{this.P.fire(V),this.S(V),this.O.fire(V)}));const M={onMouseWheel:V=>this.R(V),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new D.$NQ(this.b,this.a,M)),this.g=this.B(new p.$MQ(this.b,this.a,M)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(L),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,i.$EQ)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,i.$EQ)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,i.$EQ)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,V=>this.Z(V)),this.u(this.t,V=>this.Y(V)),this.L=this.B(new g.$0g),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,T.$Mc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(L){this.c.delegatePointerDown(L)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(L){this.b.setScrollDimensions(L,!1)}updateClassName(L){this.a.className=L,n.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(L){typeof L.handleMouseWheel<"u"&&(this.a.handleMouseWheel=L.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof L.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=L.mouseWheelScrollSensitivity),typeof L.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=L.fastScrollSensitivity),typeof L.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=L.scrollPredominantAxis),typeof L.horizontal<"u"&&(this.a.horizontal=L.horizontal),typeof L.vertical<"u"&&(this.a.vertical=L.vertical),typeof L.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=L.horizontalScrollbarSize),typeof L.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=L.verticalScrollbarSize),typeof L.scrollByPage<"u"&&(this.a.scrollByPage=L.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(L){this.N=L}delegateScrollFromMouseWheelEvent(L){this.R(new U.$YO(L))}Q(L){if(this.w.length>0!==L&&(this.w=(0,T.$Mc)(this.w),L)){const y=M=>{this.R(new U.$YO(M))};this.w.push(N.$5O(this.t,N.$YP.MOUSE_WHEEL,y,{passive:!1}))}}R(L){if(L.browserEvent?.defaultPrevented)return;const d=s.INSTANCE;a&&d.acceptStandardWheelEvent(L);let y=!1;if(L.deltaY||L.deltaX){let V=L.deltaY*this.a.mouseWheelScrollSensitivity,x=L.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&x+V===0?x=V=0:Math.abs(V)>=Math.abs(x)?x=0:V=0),this.a.flipAxes&&([V,x]=[x,V]);const R=!n.$j&&L.browserEvent&&L.browserEvent.shiftKey;(this.a.scrollYToX||R)&&!x&&(x=V,V=0),L.browserEvent&&L.browserEvent.altKey&&(x=x*this.a.fastScrollSensitivity,V=V*this.a.fastScrollSensitivity);const B=this.b.getFutureScrollPosition();let j={};if(V){const ie=h*V,te=B.scrollTop-(ie<0?Math.floor(ie):Math.ceil(ie));this.c.writeScrollPosition(j,te)}if(x){const ie=h*x,te=B.scrollLeft-(ie<0?Math.floor(ie):Math.ceil(ie));this.g.writeScrollPosition(j,te)}j=this.b.validateScrollPosition(j),(B.scrollLeft!==j.scrollLeft||B.scrollTop!==j.scrollTop)&&(a&&this.a.mouseWheelSmoothScroll&&d.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(j):this.b.setScrollPositionNow(j),y=!0)}let M=y;!M&&this.a.alwaysConsumeMouseWheel&&(M=!0),!M&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(M=!0),M&&(L.preventDefault(),L.stopPropagation())}S(L){this.M=this.g.onDidScroll(L)||this.M,this.M=this.c.onDidScroll(L)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const L=this.b.getCurrentScrollPosition(),d=L.scrollTop>0,y=L.scrollLeft>0,M=y?" left":"",V=d?" top":"",x=y||d?" top-left-corner":"";this.n.setClassName(`shadow${M}`),this.r.setClassName(`shadow${V}`),this.s.setClassName(`shadow${x}${V}${M}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(L){this.J=!1,this.ab()}Z(L){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$PQ=r;class b extends r{constructor(L,d){d=d||{},d.mouseWheelSmoothScroll=!1;const y=new o.$4r({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:M=>N.$cP(N.$LP(L),M)});super(L,d,y),this.B(y)}setScrollPosition(L){this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$QQ=b;class u extends r{constructor(L,d,y){super(L,d,y)}setScrollPosition(L){L.reuseAnimation?this.b.setScrollPositionSmooth(L,L.reuseAnimation):this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$RQ=u;class l extends r{constructor(L,d){d=d||{},d.mouseWheelSmoothScroll=!1;const y=new o.$4r({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:M=>N.$cP(N.$LP(L),M)});super(L,d,y),this.B(y),this.cb=L,this.B(this.onScroll(M=>{M.scrollTopChanged&&(this.cb.scrollTop=M.scrollTop),M.scrollLeftChanged&&(this.cb.scrollLeft=M.scrollLeft)})),this.scanDomNode()}setScrollPosition(L){this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$SQ=l;function F(z){const L={lazyRender:typeof z.lazyRender<"u"?z.lazyRender:!1,className:typeof z.className<"u"?z.className:"",useShadows:typeof z.useShadows<"u"?z.useShadows:!0,handleMouseWheel:typeof z.handleMouseWheel<"u"?z.handleMouseWheel:!0,flipAxes:typeof z.flipAxes<"u"?z.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof z.consumeMouseWheelIfScrollbarIsNeeded<"u"?z.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof z.alwaysConsumeMouseWheel<"u"?z.alwaysConsumeMouseWheel:!1,scrollYToX:typeof z.scrollYToX<"u"?z.scrollYToX:!1,mouseWheelScrollSensitivity:typeof z.mouseWheelScrollSensitivity<"u"?z.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof z.fastScrollSensitivity<"u"?z.fastScrollSensitivity:5,scrollPredominantAxis:typeof z.scrollPredominantAxis<"u"?z.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof z.mouseWheelSmoothScroll<"u"?z.mouseWheelSmoothScroll:!0,arrowSize:typeof z.arrowSize<"u"?z.arrowSize:11,listenOnDomNode:typeof z.listenOnDomNode<"u"?z.listenOnDomNode:null,horizontal:typeof z.horizontal<"u"?z.horizontal:1,horizontalScrollbarSize:typeof z.horizontalScrollbarSize<"u"?z.horizontalScrollbarSize:10,horizontalSliderSize:typeof z.horizontalSliderSize<"u"?z.horizontalSliderSize:0,horizontalHasArrows:typeof z.horizontalHasArrows<"u"?z.horizontalHasArrows:!1,vertical:typeof z.vertical<"u"?z.vertical:1,verticalScrollbarSize:typeof z.verticalScrollbarSize<"u"?z.verticalScrollbarSize:10,verticalHasArrows:typeof z.verticalHasArrows<"u"?z.verticalHasArrows:!1,verticalSliderSize:typeof z.verticalSliderSize<"u"?z.verticalSliderSize:0,scrollByPage:typeof z.scrollByPage<"u"?z.scrollByPage:!1};return L.horizontalSliderSize=typeof z.horizontalSliderSize<"u"?z.horizontalSliderSize:L.horizontalScrollbarSize,L.verticalSliderSize=typeof z.verticalSliderSize<"u"?z.verticalSliderSize:L.verticalScrollbarSize,n.$j&&(L.className+=" mac"),L}}),define(be[61],$e([1,0,54,3,22,24,60,12,9,26,4,2,47,48,82,119,6]),function(ae,t,v,N,i,U,p,D,c,g,m,T,n,o,e,h,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kR=t.$jR=t.$iR=t.$hR=void 0;const f={CurrentDragAndDropData:void 0},s={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(L){return[L]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this.d}set context(d){this.d=d}constructor(d){this.elements=d}update(){}getData(){return this.elements}}t.$hR=r;class b{constructor(d){this.elements=d}update(){}getData(){return this.elements}}t.$iR=b;class u{constructor(){this.types=[],this.files=[]}update(d){if(d.types&&this.types.splice(0,this.types.length,...d.types),d.files){this.files.splice(0,this.files.length);for(let y=0;y<d.files.length;y++){const M=d.files.item(y);M&&(M.size||M.type)&&this.files.push(M)}}}getData(){return{types:this.types,files:this.files}}}t.$jR=u;function l(L,d){return Array.isArray(L)&&Array.isArray(d)?(0,D.$tb)(L,d):L===d}class F{constructor(d){d?.getSetSize?this.getSetSize=d.getSetSize.bind(d):this.getSetSize=(y,M,V)=>V,d?.getPosInSet?this.getPosInSet=d.getPosInSet.bind(d):this.getPosInSet=(y,M)=>M+1,d?.getRole?this.getRole=d.getRole.bind(d):this.getRole=y=>"listitem",d?.isChecked?this.isChecked=d.isChecked.bind(d):this.isChecked=y=>{}}}class z{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(d){if(d!==this.O){if(d&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=d,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const y of this.d)this.Y(y);this.V(),this.q.setScrollDimensions({width:(0,N.$rP)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(d,y,M,V=s){if(this.Q=y,this.domId=`list_id_${++z.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new c.$Wg(50),this.v=!1,this.x=T.$Rc.None,this.y=0,this.G=!1,this.J=T.$Rc.None,this.K=T.$Rc.None,this.L=new T.$Qc,this.M=new m.$Rd,this.N=new m.$Rd,this.onDidChangeContentHeight=m.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=m.Event.latch(this.N.event,void 0,this.L),this.O=!1,V.horizontalScrolling&&V.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$fR(V.paddingTop??0);for(const R of M)this.j.set(R.templateId,R);this.h=this.L.add(new h.$gR(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof V.mouseSupport=="boolean"?V.mouseSupport:!0),this.O=V.horizontalScrolling??s.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof V.paddingBottom>"u"?0:V.paddingBottom,this.D=new F(V.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(V.transformOptimization??s.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(U.$CQ.addTarget(this.o)),this.p=this.L.add(new o.$4r({forceIntegerValues:!0,smoothScrollDuration:V.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:R=>(0,N.$cP)((0,N.$LP)(this.domNode),R)})),this.q=this.L.add(new p.$RQ(this.o,{alwaysConsumeMouseWheel:V.alwaysConsumeMouseWheel??s.alwaysConsumeMouseWheel,horizontal:1,vertical:V.verticalScrollMode??s.verticalScrollMode,useShadows:V.useShadows??s.useShadows,mouseWheelScrollSensitivity:V.mouseWheelScrollSensitivity,fastScrollSensitivity:V.fastScrollSensitivity,scrollByPage:V.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),d.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,N.$5O)(this.o,U.EventType.Change,R=>this.hb(R))),this.L.add((0,N.$5O)(this.q.getDomNode(),"scroll",R=>R.target.scrollTop=0)),this.L.add((0,N.$5O)(this.domNode,"dragover",R=>this.jb(this.fb(R)))),this.L.add((0,N.$5O)(this.domNode,"drop",R=>this.lb(this.fb(R)))),this.L.add((0,N.$5O)(this.domNode,"dragleave",R=>this.kb(this.fb(R)))),this.L.add((0,N.$5O)(this.domNode,"dragend",R=>this.mb(R))),this.z=V.setRowLineHeight??s.setRowLineHeight,this.A=V.setRowHeight??s.setRowHeight,this.B=V.supportDynamicHeights??s.supportDynamicHeights,this.F=V.dnd??this.L.add(s.dnd),this.layout(V.initialSize?.height,V.initialSize?.width)}updateOptions(d){d.paddingBottom!==void 0&&(this.C=d.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),d.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(d.smoothScrolling?125:0),d.horizontalScrolling!==void 0&&(this.P=d.horizontalScrolling);let y;if(d.scrollByPage!==void 0&&(y={...y??{},scrollByPage:d.scrollByPage}),d.mouseWheelScrollSensitivity!==void 0&&(y={...y??{},mouseWheelScrollSensitivity:d.mouseWheelScrollSensitivity}),d.fastScrollSensitivity!==void 0&&(y={...y??{},fastScrollSensitivity:d.fastScrollSensitivity}),y&&this.q.updateOptions(y),d.paddingTop!==void 0&&d.paddingTop!==this.g.paddingTop){const M=this.sb(this.k,this.m),V=d.paddingTop-this.g.paddingTop;this.g.paddingTop=d.paddingTop,this.W(M,Math.max(0,this.k+V),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(d){this.q.delegateScrollFromMouseWheelEvent(d)}delegateVerticalScrollbarPointerDown(d){this.q.delegateVerticalScrollbarPointerDown(d)}updateElementHeight(d,y,M){if(d<0||d>=this.d.length)return;const V=this.d[d].size;if(typeof y>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[d].lastDynamicHeightWidth=void 0,y=V+this.ub(d)}if(V===y)return;const x=this.sb(this.k,this.m);let R=0;d<x.start||M!==null&&M>d&&M<x.end?R=y-V:R=0,this.g.splice(d,1,[{size:y}]),this.d[d].size=y,this.W(x,Math.max(0,this.k+R),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(d,y,M=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(d,y,M)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(d,y,M=[]){const V=this.sb(this.k,this.m),x={start:d,end:d+y},R=n.Range.intersect(V,x),B=new Map;for(let q=R.end-1;q>=R.start;q--){const X=this.d[q];if(X.dragStartDisposable.dispose(),X.checkedDisposable.dispose(),X.row){let C=B.get(X.templateId);C||(C=[],B.set(X.templateId,C));const _=this.j.get(X.templateId);_&&_.disposeElement&&_.disposeElement(X.element,q,X.row.templateData,X.size),C.push(X.row)}X.row=null}const j={start:d+y,end:this.d.length},ie=n.Range.intersect(j,V),te=n.Range.relativeComplement(j,V),ue=M.map(q=>({id:String(this.f++),element:q,templateId:this.Q.getTemplateId(q),size:this.Q.getHeight(q),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(q),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:T.$Rc.None,checkedDisposable:T.$Rc.None}));let le;d===0&&y>=this.d.length?(this.g=new e.$fR(this.g.paddingTop),this.g.splice(0,0,ue),le=this.d,this.d=ue):(this.g.splice(d,y,ue),le=this.d.splice(d,y,...ue));const oe=M.length-y,we=this.sb(this.k,this.m),Fe=(0,e.$dR)(ie,oe),ke=n.Range.intersect(we,Fe);for(let q=ke.start;q<ke.end;q++)this.Z(this.d[q],q);const Le=n.Range.relativeComplement(Fe,we);for(const q of Le)for(let X=q.start;X<q.end;X++)this.ab(X);const de=te.map(q=>(0,e.$dR)(q,oe)),ce=[{start:d,end:d+M.length},...de].map(q=>n.Range.intersect(we,q)),Z=this.vb(ce);for(const q of ce)for(let X=q.start;X<q.end;X++){const C=this.d[X],$=B.get(C.templateId)?.pop();this.X(X,Z,$)}for(const q of B.values())for(const X of q)this.h.release(X);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),le.map(q=>q.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,N.$cP)((0,N.$LP)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let d=0;for(const y of this.d)typeof y.width<"u"&&(d=Math.max(d,y.width));this.E=d,this.q.setScrollDimensions({scrollWidth:d===0?0:d+10}),this.N.fire(this.E)}updateWidth(d){if(!this.P||typeof this.E>"u")return;const y=this.d[d];this.Y(y),typeof y.width<"u"&&y.width>this.E&&(this.E=y.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const d of this.d)d.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const d=this.sb(this.k,this.m),y=this.g.positionAt(d.start),M=this.g.positionAt(d.start+1);return M!==-1&&(M-y)/2+y<this.scrollTop?d.start+1:d.start}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(d){return this.d[d].element}indexOf(d){return this.d.findIndex(y=>y.element===d)}domElement(d){const y=this.d[d].row;return y&&y.domNode}elementHeight(d){return this.d[d].size}elementTop(d){return this.g.positionAt(d)}indexAt(d){return this.g.indexAt(d)}indexAfter(d){return this.g.indexAfter(d)}layout(d,y){const M={height:typeof d=="number"?d:(0,N.$tP)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,M.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(M),typeof y<"u"&&(this.n=y,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof y=="number"?y:(0,N.$rP)(this.domNode)})}W(d,y,M,V,x,R=!1){const B=this.sb(y,M),j=n.Range.relativeComplement(B,d),ie=n.Range.relativeComplement(d,B),te=this.vb(j);if(R){const ue=n.Range.intersect(d,B);for(let le=ue.start;le<ue.end;le++)this.Z(this.d[le],le)}this.h.transact(()=>{for(const ue of ie)for(let le=ue.start;le<ue.end;le++)this.ab(le);for(const ue of j)for(let le=ue.start;le<ue.end;le++)this.X(le,te)}),V!==void 0&&(this.o.style.left=`-${V}px`),this.o.style.top=`-${y}px`,this.P&&x!==void 0&&(this.o.style.width=`${Math.max(x,this.n)}px`),this.k=y,this.m=M}X(d,y,M){const V=this.d[d];let x=!1;if(!V.row)if(M)V.row=M;else{const te=this.h.alloc(V.templateId);V.row=te.row,x=te.isReusingConnectedDomNode}const R=this.D.getRole(V.element)||"listitem";V.row.domNode.setAttribute("role",R);const B=this.D.isChecked(V.element);if(typeof B=="boolean")V.row.domNode.setAttribute("aria-checked",String(!!B));else if(B){const te=ue=>V.row.domNode.setAttribute("aria-checked",String(!!ue));te(B.value),V.checkedDisposable=B.onDidChange(te)}(x||!V.row.domNode.parentElement)&&(y?this.o.insertBefore(V.row.domNode,y):this.o.appendChild(V.row.domNode)),this.Z(V,d);const j=this.j.get(V.templateId);if(!j)throw new Error(`No renderer found for template id ${V.templateId}`);j?.renderElement(V.element,d,V.row.templateData,V.size);const ie=this.F.getDragURI(V.element);V.dragStartDisposable.dispose(),V.row.domNode.draggable=!!ie,ie&&(V.dragStartDisposable=(0,N.$5O)(V.row.domNode,"dragstart",te=>this.ib(V.element,ie,te))),this.P&&(this.Y(V),this.U())}Y(d){if(!d.row||!d.row.domNode)return;d.row.domNode.style.width="fit-content",d.width=(0,N.$rP)(d.row.domNode);const y=(0,N.$LP)(d.row.domNode).getComputedStyle(d.row.domNode);y.paddingLeft&&(d.width+=parseFloat(y.paddingLeft)),y.paddingRight&&(d.width+=parseFloat(y.paddingRight)),d.row.domNode.style.width=""}Z(d,y){d.row.domNode.style.top=`${this.elementTop(y)}px`,this.A&&(d.row.domNode.style.height=`${d.size}px`),this.z&&(d.row.domNode.style.lineHeight=`${d.size}px`),d.row.domNode.setAttribute("data-index",`${y}`),d.row.domNode.setAttribute("data-last-element",y===this.length-1?"true":"false"),d.row.domNode.setAttribute("data-parity",y%2===0?"even":"odd"),d.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(d.element,y,this.length))),d.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(d.element,y))),d.row.domNode.setAttribute("id",this.getElementDomId(y)),d.row.domNode.classList.toggle("drop-target",d.dropTarget)}ab(d){const y=this.d[d];if(y.dragStartDisposable.dispose(),y.checkedDisposable.dispose(),y.row){const M=this.j.get(y.templateId);M&&M.disposeElement&&M.disposeElement(y.element,d,y.row.templateData,y.size),this.h.release(y.row),y.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(d,y){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:d,reuseAnimation:y})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(d){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:d})}get scrollTop(){return this.getScrollTop()}set scrollTop(d){this.setScrollTop(d)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return m.Event.map(this.L.add(new i.$7Q(this.domNode,"click")).event,d=>this.bb(d),this.L)}get onMouseDblClick(){return m.Event.map(this.L.add(new i.$7Q(this.domNode,"dblclick")).event,d=>this.bb(d),this.L)}get onMouseMiddleClick(){return m.Event.filter(m.Event.map(this.L.add(new i.$7Q(this.domNode,"auxclick")).event,d=>this.bb(d),this.L),d=>d.browserEvent.button===1,this.L)}get onMouseUp(){return m.Event.map(this.L.add(new i.$7Q(this.domNode,"mouseup")).event,d=>this.bb(d),this.L)}get onMouseDown(){return m.Event.map(this.L.add(new i.$7Q(this.domNode,"mousedown")).event,d=>this.bb(d),this.L)}get onMouseOver(){return m.Event.map(this.L.add(new i.$7Q(this.domNode,"mouseover")).event,d=>this.bb(d),this.L)}get onMouseMove(){return m.Event.map(this.L.add(new i.$7Q(this.domNode,"mousemove")).event,d=>this.bb(d),this.L)}get onMouseOut(){return m.Event.map(this.L.add(new i.$7Q(this.domNode,"mouseout")).event,d=>this.bb(d),this.L)}get onContextMenu(){return m.Event.any(m.Event.map(this.L.add(new i.$7Q(this.domNode,"contextmenu")).event,d=>this.bb(d),this.L),m.Event.map(this.L.add(new i.$7Q(this.domNode,U.EventType.Contextmenu)).event,d=>this.eb(d),this.L))}get onTouchStart(){return m.Event.map(this.L.add(new i.$7Q(this.domNode,"touchstart")).event,d=>this.db(d),this.L)}get onTap(){return m.Event.map(this.L.add(new i.$7Q(this.o,U.EventType.Tap)).event,d=>this.eb(d),this.L)}bb(d){const y=this.rb(d.target||null),M=typeof y>"u"?void 0:this.d[y],V=M&&M.element;return{browserEvent:d,index:y,element:V}}db(d){const y=this.rb(d.target||null),M=typeof y>"u"?void 0:this.d[y],V=M&&M.element;return{browserEvent:d,index:y,element:V}}eb(d){const y=this.rb(d.initialTarget||null),M=typeof y>"u"?void 0:this.d[y],V=M&&M.element;return{browserEvent:d,index:y,element:V}}fb(d){const y=this.rb(d.target||null),M=typeof y>"u"?void 0:this.d[y],V=M&&M.element;return{browserEvent:d,index:y,element:V}}gb(d){try{const y=this.sb(this.k,this.m);this.W(y,d.scrollTop,d.height,d.scrollLeft,d.scrollWidth),this.B&&this.tb(d.scrollTop,d.height,d.inSmoothScrolling)}catch(y){throw console.error("Got bad scroll event:",d),y}}hb(d){d.preventDefault(),d.stopPropagation(),this.scrollTop-=d.translationY}ib(d,y,M){if(!M.dataTransfer)return;const V=this.F.getDragElements(d);if(M.dataTransfer.effectAllowed="copyMove",M.dataTransfer.setData(v.$AQ.TEXT,y),M.dataTransfer.setDragImage){let x;this.F.getDragLabel&&(x=this.F.getDragLabel(V,M)),typeof x>"u"&&(x=String(V.length));const R=(0,N.$)(".monaco-drag-image");R.textContent=x;const j=(ie=>{for(;ie&&!ie.classList.contains("monaco-workbench");)ie=ie.parentElement;return ie||this.domNode.ownerDocument})(this.domNode);j.appendChild(R),M.dataTransfer.setDragImage(R,-10,-10),setTimeout(()=>j.removeChild(R),0)}this.domNode.classList.add("dragging"),this.H=new r(V),f.CurrentDragAndDropData=new b(V),this.F.onDragStart?.(this.H,M)}jb(d){if(d.browserEvent.preventDefault(),this.K.dispose(),f.CurrentDragAndDropData&&f.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(d.browserEvent),!d.browserEvent.dataTransfer))return!1;if(!this.H)if(f.CurrentDragAndDropData)this.H=f.CurrentDragAndDropData;else{if(!d.browserEvent.dataTransfer.types)return!1;this.H=new u}const y=this.F.onDragOver(this.H,d.element,d.index,d.browserEvent);if(this.G=typeof y=="boolean"?y:y.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;d.browserEvent.dataTransfer.dropEffect=typeof y!="boolean"&&y.effect===0?"copy":"move";let M;if(typeof y!="boolean"&&y.feedback?M=y.feedback:typeof d.index>"u"?M=[-1]:M=[d.index],M=(0,D.$Lb)(M).filter(V=>V>=-1&&V<this.length).sort((V,x)=>V-x),M=M[0]===-1?[-1]:M,l(this.I,M))return!0;if(this.I=M,this.J.dispose(),M[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,T.$Pc)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const V of M){const x=this.d[V];x.dropTarget=!0,x.row?.domNode.classList.add("drop-target")}this.J=(0,T.$Pc)(()=>{for(const V of M){const x=this.d[V];x.dropTarget=!1,x.row?.domNode.classList.remove("drop-target")}})}return!0}kb(d){this.K.dispose(),this.K=(0,c.$2g)(()=>this.nb(),100,this.L),this.H&&this.F.onDragLeave?.(this.H,d.element,d.index,d.browserEvent)}lb(d){if(!this.G)return;const y=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,f.CurrentDragAndDropData=void 0,!(!y||!d.browserEvent.dataTransfer)&&(d.browserEvent.preventDefault(),y.update(d.browserEvent.dataTransfer),this.F.drop(y,d.element,d.index,d.browserEvent))}mb(d){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,f.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(d)}nb(){this.I=void 0,this.J.dispose(),this.J=T.$Rc.None}ob(d){if(!this.w){const y=(0,N.$lP)(this.domNode).top;this.w=(0,N.$iQ)((0,N.$LP)(this.domNode),this.pb.bind(this,y))}this.x.dispose(),this.x=(0,c.$2g)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.L),this.y=d.pageY}pb(d){if(this.y===void 0)return;const y=this.y-d,M=this.renderHeight-35;y<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(y-35))):y>M&&(this.scrollTop+=Math.min(14,Math.floor(.3*(y-M))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(d){const y=this.q.getDomNode();let M=d;for(;M instanceof HTMLElement&&M!==this.o&&y.contains(M);){const V=M.getAttribute("data-index");if(V){const x=Number(V);if(!isNaN(x))return x}M=M.parentElement}}sb(d,y){return{start:this.g.indexAt(d),end:this.g.indexAfter(d+y-1)}}tb(d,y,M){const V=this.sb(d,y);let x,R;d===this.elementTop(V.start)?(x=V.start,R=0):V.end-V.start>1&&(x=V.start+1,R=this.elementTop(x)-d);let B=0;for(;;){const j=this.sb(d,y);let ie=!1;for(let te=j.start;te<j.end;te++){const ue=this.ub(te);ue!==0&&this.g.splice(te,1,[this.d[te]]),B+=ue,ie=ie||ue!==0}if(!ie){B!==0&&this.S();const te=n.Range.relativeComplement(V,j);for(const le of te)for(let oe=le.start;oe<le.end;oe++)this.d[oe].row&&this.ab(oe);const ue=n.Range.relativeComplement(j,V);for(const le of ue)for(let oe=le.start;oe<le.end;oe++){const we=oe+1,Fe=we<this.d.length?this.d[we].row:null,ke=Fe?Fe.domNode:null;this.X(oe,ke)}for(let le=j.start;le<j.end;le++)this.d[le].row&&this.Z(this.d[le],le);if(typeof x=="number"){const le=this.p.getFutureScrollPosition().scrollTop-d,oe=this.elementTop(x)-R+le;this.setScrollTop(oe,M)}this.M.fire(this.contentHeight);return}}}ub(d){const y=this.d[d];if(this.Q.getDynamicHeight){const R=this.Q.getDynamicHeight(y.element);if(R!==null){const B=y.size;return y.size=R,y.lastDynamicHeightWidth=this.n,R-B}}if(!y.hasDynamicHeight||y.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(y.element))return 0;const M=y.size;if(y.row)return y.row.domNode.style.height="",y.size=y.row.domNode.offsetHeight,y.lastDynamicHeightWidth=this.n,y.size-M;const{row:V}=this.h.alloc(y.templateId);V.domNode.style.height="",this.o.appendChild(V.domNode);const x=this.j.get(y.templateId);if(!x)throw new a.$bb("Missing renderer for templateId: "+y.templateId);return x.renderElement(y.element,d,V.templateData,void 0),y.size=V.domNode.offsetHeight,x.disposeElement?.(y.element,d,V.templateData,void 0),this.Q.setDynamicHeight?.(y.element,y.size),y.lastDynamicHeightWidth=this.n,this.o.removeChild(V.domNode),this.h.release(V),y.size-M}vb(d){const y=d[d.length-1];if(!y)return null;const M=this.d[y.end];return!M||!M.row?null:M.row.domNode}getElementDomId(d){return`${this.domId}_${d}`}dispose(){for(const d of this.d)if(d.dragStartDisposable.dispose(),d.checkedDisposable.dispose(),d.row){const y=this.j.get(d.row.templateId);y&&(y.disposeElement?.(d.element,-1,d.row.templateData,void 0),y.disposeTemplate(d.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.L.dispose()}}t.$kR=z,Xe([g.$ph],z.prototype,"onMouseClick",null),Xe([g.$ph],z.prototype,"onMouseDblClick",null),Xe([g.$ph],z.prototype,"onMouseMiddleClick",null),Xe([g.$ph],z.prototype,"onMouseUp",null),Xe([g.$ph],z.prototype,"onMouseDown",null),Xe([g.$ph],z.prototype,"onMouseOver",null),Xe([g.$ph],z.prototype,"onMouseMove",null),Xe([g.$ph],z.prototype,"onMouseOut",null),Xe([g.$ph],z.prototype,"onContextMenu",null),Xe([g.$ph],z.prototype,"onTouchStart",null),Xe([g.$ph],z.prototype,"onTap",null)}),define(be[39],$e([1,0,3,22,14,24,57,71,12,9,74,26,4,34,2,46,5,7,70,61,19,97]),function(ae,t,v,N,i,U,p,D,c,g,m,T,n,o,e,h,a,f,s,r,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uR=t.$tR=t.$sR=t.$rR=t.$qR=t.$pR=t.$oR=t.TypeNavigationMode=t.$nR=t.$mR=t.$lR=void 0;class u{constructor(C){this.d=C,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(C){return C}renderElement(C,_,$){const W=this.c.findIndex(Q=>Q.templateData===$);if(W>=0){const Q=this.c[W];this.d.unrender($),Q.index=_}else{const Q={index:_,templateData:$};this.c.push(Q)}this.d.renderIndex(_,$)}splice(C,_,$){const W=[];for(const Q of this.c)Q.index<C?W.push(Q):Q.index>=C+_&&W.push({index:Q.index+$-_,templateData:Q.templateData});this.c=W}renderIndexes(C){for(const{index:_,templateData:$}of this.c)C.indexOf(_)>-1&&this.d.renderIndex(_,$)}disposeTemplate(C){const _=this.c.findIndex($=>$.templateData===C);_<0||this.c.splice(_,1)}}class l{get name(){return this.h}get renderer(){return new u(this)}constructor(C){this.h=C,this.c=0,this.d=[],this.f=[],this.g=new n.$Rd,this.onChange=this.g.event}splice(C,_,$){_=Math.max(0,Math.min(_,this.c-C));const W=$.length-_,Q=C+_,w=[];let A=0;for(;A<this.f.length&&this.f[A]<C;)w.push(this.f[A++]);for(let I=0;I<$.length;I++)$[I]&&w.push(I+C);for(;A<this.f.length&&this.f[A]>=Q;)w.push(this.f[A++]+W);const E=this.c+W;if(this.f.length>0&&w.length===0&&E>0){const I=this.f.find(k=>k>=C)??E-1;w.push(Math.min(I,E-1))}this.renderer.splice(C,_,$.length),this.k(w,w),this.c=E}renderIndex(C,_){_.classList.toggle(this.h,this.contains(C))}unrender(C){C.classList.remove(this.h)}set(C,_){return this.k(C,[...C].sort(de),_)}k(C,_,$){const W=this.d,Q=this.f;this.d=C,this.f=_;const w=ke(Q,C);return this.renderer.renderIndexes(w),this.g.fire({indexes:C,browserEvent:$}),W}get(){return this.d}contains(C){return(0,c.$vb)(this.f,C,de)>=0}dispose(){(0,e.$Mc)(this.g)}}Xe([T.$ph],l.prototype,"renderer",null);class F extends l{constructor(C){super("selected"),this.l=C}renderIndex(C,_){super.renderIndex(C,_),this.l&&(this.contains(C)?_.setAttribute("aria-selected","true"):_.setAttribute("aria-selected","false"))}}class z{constructor(C,_,$){this.c=C,this.d=_,this.f=$}splice(C,_,$){if(!this.f)return this.c.splice(C,_,new Array($.length).fill(!1));const W=this.c.get().map(A=>this.f.getId(this.d.element(A)).toString());if(W.length===0)return this.c.splice(C,_,new Array($.length).fill(!1));const Q=new Set(W),w=$.map(A=>Q.has(this.f.getId(A).toString()));this.c.splice(C,_,w)}}function L(X){return X.tagName==="INPUT"||X.tagName==="TEXTAREA"}t.$lR=L;function d(X){return X.classList.contains("monaco-editor")?!0:X.classList.contains("monaco-list")||!X.parentElement?!1:d(X.parentElement)}t.$mR=d;function y(X){return X.tagName==="A"&&X.classList.contains("monaco-button")||X.tagName==="DIV"&&X.classList.contains("monaco-button-dropdown")?!0:X.classList.contains("monaco-list")||!X.parentElement?!1:y(X.parentElement)}t.$nR=y;class M{get g(){return n.Event.chain(this.c.add(new N.$7Q(this.k.domNode,"keydown")).event,C=>C.filter(_=>!L(_.target)).map(_=>new i.$2O(_)))}constructor(C,_,$){this.h=C,this.k=_,this.c=new e.$Qc,this.d=new e.$Qc,this.f=$.multipleSelectionSupport,this.c.add(this.g(W=>{switch(W.keyCode){case 3:return this.l(W);case 16:return this.o(W);case 18:return this.p(W);case 11:return this.q(W);case 12:return this.s(W);case 9:return this.u(W);case 31:this.f&&(a.$j?W.metaKey:W.ctrlKey)&&this.t(W)}}))}updateOptions(C){C.multipleSelectionSupport!==void 0&&(this.f=C.multipleSelectionSupport)}l(C){C.preventDefault(),C.stopPropagation(),this.h.setSelection(this.h.getFocus(),C.browserEvent)}o(C){C.preventDefault(),C.stopPropagation(),this.h.focusPrevious(1,!1,C.browserEvent);const _=this.h.getFocus()[0];this.h.setAnchor(_),this.h.reveal(_),this.k.domNode.focus()}p(C){C.preventDefault(),C.stopPropagation(),this.h.focusNext(1,!1,C.browserEvent);const _=this.h.getFocus()[0];this.h.setAnchor(_),this.h.reveal(_),this.k.domNode.focus()}q(C){C.preventDefault(),C.stopPropagation(),this.h.focusPreviousPage(C.browserEvent);const _=this.h.getFocus()[0];this.h.setAnchor(_),this.h.reveal(_),this.k.domNode.focus()}s(C){C.preventDefault(),C.stopPropagation(),this.h.focusNextPage(C.browserEvent);const _=this.h.getFocus()[0];this.h.setAnchor(_),this.h.reveal(_),this.k.domNode.focus()}t(C){C.preventDefault(),C.stopPropagation(),this.h.setSelection((0,c.$Rb)(this.h.length),C.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(C){this.h.getSelection().length&&(C.preventDefault(),C.stopPropagation(),this.h.setSelection([],C.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Xe([T.$ph],M.prototype,"g",null);var V;(function(X){X[X.Automatic=0]="Automatic",X[X.Trigger=1]="Trigger"})(V||(t.TypeNavigationMode=V={}));var x;(function(X){X[X.Idle=0]="Idle",X[X.Typing=1]="Typing"})(x||(x={})),t.$oR=new class{mightProducePrintableCharacter(X){return X.ctrlKey||X.metaKey||X.altKey?!1:X.keyCode>=31&&X.keyCode<=56||X.keyCode>=21&&X.keyCode<=30||X.keyCode>=98&&X.keyCode<=107||X.keyCode>=85&&X.keyCode<=95}};class R{constructor(C,_,$,W,Q){this.o=C,this.p=_,this.q=$,this.s=W,this.t=Q,this.c=!1,this.d=x.Idle,this.f=V.Automatic,this.g=!1,this.h=-1,this.k=new e.$Qc,this.l=new e.$Qc,this.updateOptions(C.options)}updateOptions(C){C.typeNavigationEnabled??!0?this.u():this.v(),this.f=C.typeNavigationMode??V.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let C=!1;const _=n.Event.chain(this.k.add(new N.$7Q(this.p.domNode,"keydown")).event,Q=>Q.filter(w=>!L(w.target)).filter(()=>this.f===V.Automatic||this.g).map(w=>new i.$2O(w)).filter(w=>C||this.s(w)).filter(w=>this.t.mightProducePrintableCharacter(w)).forEach(w=>v.$1P.stop(w,!0)).map(w=>w.browserEvent.key)),$=n.Event.debounce(_,()=>null,800,void 0,void 0,void 0,this.k);n.Event.reduce(n.Event.any(_,$),(Q,w)=>w===null?null:(Q||"")+w,void 0,this.k)(this.x,this,this.k),$(this.w,this,this.k),_(()=>C=!0,void 0,this.k),$(()=>C=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const C=this.o.getFocus();if(C.length>0&&C[0]===this.h){const _=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(C[0]));_&&(0,p.$9Q)(_)}this.h=-1}x(C){if(!C){this.d=x.Idle,this.g=!1;return}const _=this.o.getFocus(),$=_.length>0?_[0]:0,W=this.d===x.Idle?1:0;this.d=x.Typing;for(let Q=0;Q<this.o.length;Q++){const w=($+Q+W)%this.o.length,A=this.q.getKeyboardNavigationLabel(this.p.element(w)),E=A&&A.toString();if(this.o.options.typeNavigationEnabled){if(typeof E<"u"){if((0,o.$Lj)(C,E)){this.h=$,this.o.setFocus([w]),this.o.reveal(w);return}const I=(0,o.$Sj)(C,E);if(I&&I[0].end-I[0].start>1&&I.length===1){this.h=$,this.o.setFocus([w]),this.o.reveal(w);return}}}else if(typeof E>"u"||(0,o.$Lj)(C,E)){this.h=$,this.o.setFocus([w]),this.o.reveal(w);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class B{constructor(C,_){this.d=C,this.f=_,this.c=new e.$Qc;const $=n.Event.chain(this.c.add(new N.$7Q(_.domNode,"keydown")).event,Q=>Q.filter(w=>!L(w.target)).map(w=>new i.$2O(w)));n.Event.chain($,Q=>Q.filter(w=>w.keyCode===2&&!w.ctrlKey&&!w.metaKey&&!w.shiftKey&&!w.altKey))(this.g,this,this.c)}g(C){if(C.target!==this.f.domNode)return;const _=this.d.getFocus();if(_.length===0)return;const $=this.f.domElement(_[0]);if(!$)return;const W=$.querySelector("[tabIndex]");if(!W||!(W instanceof HTMLElement)||W.tabIndex===-1)return;const Q=(0,v.$LP)(W).getComputedStyle(W);Q.visibility==="hidden"||Q.display==="none"||(C.preventDefault(),C.stopPropagation(),W.focus())}dispose(){this.c.dispose()}}function j(X){return a.$j?X.browserEvent.metaKey:X.browserEvent.ctrlKey}t.$pR=j;function ie(X){return X.browserEvent.shiftKey}t.$qR=ie;function te(X){return(0,v.$UP)(X)&&X.button===2}const ue={isSelectionSingleChangeEvent:j,isSelectionRangeChangeEvent:ie};class le{constructor(C){this.k=C,this.f=new e.$Qc,this.g=new n.$Rd,this.onPointer=this.g.event,C.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ue),this.d=typeof C.options.mouseSupport>"u"||!!C.options.mouseSupport,this.d&&(C.onMouseDown(this.s,this,this.f),C.onContextMenu(this.t,this,this.f),C.onMouseDblClick(this.v,this,this.f),C.onTouchStart(this.s,this,this.f),this.f.add(U.$CQ.addTarget(C.getHTMLElement()))),n.Event.any(C.onMouseClick,C.onMouseMiddleClick,C.onTap)(this.u,this,this.f)}updateOptions(C){C.multipleSelectionSupport!==void 0&&(this.c=void 0,C.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ue))}o(C){return this.c?this.c.isSelectionSingleChangeEvent(C):!1}p(C){return this.c?this.c.isSelectionRangeChangeEvent(C):!1}q(C){return this.o(C)||this.p(C)}s(C){d(C.browserEvent.target)||(0,v.$EP)()!==C.browserEvent.target&&this.k.domFocus()}t(C){if(L(C.browserEvent.target)||d(C.browserEvent.target))return;const _=typeof C.index>"u"?[]:[C.index];this.k.setFocus(_,C.browserEvent)}u(C){if(!this.d||L(C.browserEvent.target)||d(C.browserEvent.target)||C.browserEvent.isHandledByList)return;C.browserEvent.isHandledByList=!0;const _=C.index;if(typeof _>"u"){this.k.setFocus([],C.browserEvent),this.k.setSelection([],C.browserEvent),this.k.setAnchor(void 0);return}if(this.q(C))return this.w(C);this.k.setFocus([_],C.browserEvent),this.k.setAnchor(_),te(C.browserEvent)||this.k.setSelection([_],C.browserEvent),this.g.fire(C)}v(C){if(L(C.browserEvent.target)||d(C.browserEvent.target)||this.q(C)||C.browserEvent.isHandledByList)return;C.browserEvent.isHandledByList=!0;const _=this.k.getFocus();this.k.setSelection(_,C.browserEvent)}w(C){const _=C.index;let $=this.k.getAnchor();if(this.p(C)){typeof $>"u"&&($=this.k.getFocus()[0]??_,this.k.setAnchor($));const W=Math.min($,_),Q=Math.max($,_),w=(0,c.$Rb)(W,Q+1),A=this.k.getSelection(),E=Fe(ke(A,[$]),$);if(E.length===0)return;const I=ke(w,Le(A,E));this.k.setSelection(I,C.browserEvent),this.k.setFocus([_],C.browserEvent)}else if(this.o(C)){const W=this.k.getSelection(),Q=W.filter(w=>w!==_);this.k.setFocus([_]),this.k.setAnchor(_),W.length===Q.length?this.k.setSelection([...Q,_],C.browserEvent):this.k.setSelection(Q,C.browserEvent)}}dispose(){this.f.dispose()}}t.$rR=le;class oe{constructor(C,_){this.c=C,this.d=_}style(C){const _=this.d&&`.${this.d}`,$=[];C.listBackground&&$.push(`.monaco-list${_} .monaco-list-rows { background: ${C.listBackground}; }`),C.listFocusBackground&&($.push(`.monaco-list${_}:focus .monaco-list-row.focused { background-color: ${C.listFocusBackground}; }`),$.push(`.monaco-list${_}:focus .monaco-list-row.focused:hover { background-color: ${C.listFocusBackground}; }`)),C.listFocusForeground&&$.push(`.monaco-list${_}:focus .monaco-list-row.focused { color: ${C.listFocusForeground}; }`),C.listActiveSelectionBackground&&($.push(`.monaco-list${_}:focus .monaco-list-row.selected { background-color: ${C.listActiveSelectionBackground}; }`),$.push(`.monaco-list${_}:focus .monaco-list-row.selected:hover { background-color: ${C.listActiveSelectionBackground}; }`)),C.listActiveSelectionForeground&&$.push(`.monaco-list${_}:focus .monaco-list-row.selected { color: ${C.listActiveSelectionForeground}; }`),C.listActiveSelectionIconForeground&&$.push(`.monaco-list${_}:focus .monaco-list-row.selected .codicon { color: ${C.listActiveSelectionIconForeground}; }`),C.listFocusAndSelectionBackground&&$.push(`
				.monaco-drag-image,
				.monaco-list${_}:focus .monaco-list-row.selected.focused { background-color: ${C.listFocusAndSelectionBackground}; }
			`),C.listFocusAndSelectionForeground&&$.push(`
				.monaco-drag-image,
				.monaco-list${_}:focus .monaco-list-row.selected.focused { color: ${C.listFocusAndSelectionForeground}; }
			`),C.listInactiveFocusForeground&&($.push(`.monaco-list${_} .monaco-list-row.focused { color:  ${C.listInactiveFocusForeground}; }`),$.push(`.monaco-list${_} .monaco-list-row.focused:hover { color:  ${C.listInactiveFocusForeground}; }`)),C.listInactiveSelectionIconForeground&&$.push(`.monaco-list${_} .monaco-list-row.focused .codicon { color:  ${C.listInactiveSelectionIconForeground}; }`),C.listInactiveFocusBackground&&($.push(`.monaco-list${_} .monaco-list-row.focused { background-color:  ${C.listInactiveFocusBackground}; }`),$.push(`.monaco-list${_} .monaco-list-row.focused:hover { background-color:  ${C.listInactiveFocusBackground}; }`)),C.listInactiveSelectionBackground&&($.push(`.monaco-list${_} .monaco-list-row.selected { background-color:  ${C.listInactiveSelectionBackground}; }`),$.push(`.monaco-list${_} .monaco-list-row.selected:hover { background-color:  ${C.listInactiveSelectionBackground}; }`)),C.listInactiveSelectionForeground&&$.push(`.monaco-list${_} .monaco-list-row.selected { color: ${C.listInactiveSelectionForeground}; }`),C.listHoverBackground&&$.push(`.monaco-list${_}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${C.listHoverBackground}; }`),C.listHoverForeground&&$.push(`.monaco-list${_}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${C.listHoverForeground}; }`);const W=(0,v.$lQ)(C.listFocusAndSelectionOutline,(0,v.$lQ)(C.listSelectionOutline,C.listFocusOutline??""));W&&$.push(`.monaco-list${_}:focus .monaco-list-row.focused.selected { outline: 1px solid ${W}; outline-offset: -1px;}`),C.listFocusOutline&&$.push(`
				.monaco-drag-image,
				.monaco-list${_}:focus .monaco-list-row.focused { outline: 1px solid ${C.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${_}.last-focused .monaco-list-row.focused { outline: 1px solid ${C.listFocusOutline}; outline-offset: -1px; }
			`);const Q=(0,v.$lQ)(C.listSelectionOutline,C.listInactiveFocusOutline??"");Q&&$.push(`.monaco-list${_} .monaco-list-row.focused.selected { outline: 1px dotted ${Q}; outline-offset: -1px; }`),C.listSelectionOutline&&$.push(`.monaco-list${_} .monaco-list-row.selected { outline: 1px dotted ${C.listSelectionOutline}; outline-offset: -1px; }`),C.listInactiveFocusOutline&&$.push(`.monaco-list${_} .monaco-list-row.focused { outline: 1px dotted ${C.listInactiveFocusOutline}; outline-offset: -1px; }`),C.listHoverOutline&&$.push(`.monaco-list${_} .monaco-list-row:hover { outline: 1px dashed ${C.listHoverOutline}; outline-offset: -1px; }`),C.listDropBackground&&$.push(`
				.monaco-list${_}.drop-target,
				.monaco-list${_} .monaco-list-rows.drop-target,
				.monaco-list${_} .monaco-list-row.drop-target { background-color: ${C.listDropBackground} !important; color: inherit !important; }
			`),C.tableColumnsBorder&&$.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${C.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),C.tableOddRowsBackgroundColor&&$.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${C.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=$.join(`
`)}}t.$sR=oe,t.$tR={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:m.$6s.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:m.$6s.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:m.$6s.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const we={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function Fe(X,C){const _=X.indexOf(C);if(_===-1)return[];const $=[];let W=_-1;for(;W>=0&&X[W]===C-(_-W);)$.push(X[W--]);for($.reverse(),W=_;W<X.length&&X[W]===C+(W-_);)$.push(X[W++]);return $}function ke(X,C){const _=[];let $=0,W=0;for(;$<X.length||W<C.length;)if($>=X.length)_.push(C[W++]);else if(W>=C.length)_.push(X[$++]);else if(X[$]===C[W]){_.push(X[$]),$++,W++;continue}else X[$]<C[W]?_.push(X[$++]):_.push(C[W++]);return _}function Le(X,C){const _=[];let $=0,W=0;for(;$<X.length||W<C.length;)if($>=X.length)_.push(C[W++]);else if(W>=C.length)_.push(X[$++]);else if(X[$]===C[W]){$++,W++;continue}else X[$]<C[W]?_.push(X[$++]):W++;return _}const de=(X,C)=>X-C;class ne{constructor(C,_){this.c=C,this.d=_}get templateId(){return this.c}renderTemplate(C){return this.d.map(_=>_.renderTemplate(C))}renderElement(C,_,$,W){let Q=0;for(const w of this.d)w.renderElement(C,_,$[Q++],W)}disposeElement(C,_,$,W){let Q=0;for(const w of this.d)w.disposeElement?.(C,_,$[Q],W),Q+=1}disposeTemplate(C){let _=0;for(const $ of this.d)$.disposeTemplate(C[_++])}}class ce{constructor(C){this.c=C,this.templateId="a18n"}renderTemplate(C){return C}renderElement(C,_,$){const W=this.c.getAriaLabel(C);W?$.setAttribute("aria-label",W):$.removeAttribute("aria-label");const Q=this.c.getAriaLevel&&this.c.getAriaLevel(C);typeof Q=="number"?$.setAttribute("aria-level",`${Q}`):$.removeAttribute("aria-level")}disposeTemplate(C){}}class Z{constructor(C,_){this.c=C,this.d=_}getDragElements(C){const _=this.c.getSelectedElements();return _.indexOf(C)>-1?_:[C]}getDragURI(C){return this.d.getDragURI(C)}getDragLabel(C,_){if(this.d.getDragLabel)return this.d.getDragLabel(C,_)}onDragStart(C,_){this.d.onDragStart?.(C,_)}onDragOver(C,_,$,W){return this.d.onDragOver(C,_,$,W)}onDragLeave(C,_,$,W){this.d.onDragLeave?.(C,_,$,W)}onDragEnd(C){this.d.onDragEnd?.(C)}drop(C,_,$,W){this.d.drop(C,_,$,W)}dispose(){this.d.dispose()}}class q{get onDidChangeFocus(){return n.Event.map(this.g.wrapEvent(this.c.onChange),C=>this.G(C),this.y)}get onDidChangeSelection(){return n.Event.map(this.g.wrapEvent(this.d.onChange),C=>this.G(C),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let C=!1;const _=n.Event.chain(this.y.add(new N.$7Q(this.k.domNode,"keydown")).event,Q=>Q.map(w=>new i.$2O(w)).filter(w=>C=w.keyCode===58||w.shiftKey&&w.keyCode===68).map(w=>v.$1P.stop(w,!0)).filter(()=>!1)),$=n.Event.chain(this.y.add(new N.$7Q(this.k.domNode,"keyup")).event,Q=>Q.forEach(()=>C=!1).map(w=>new i.$2O(w)).filter(w=>w.keyCode===58||w.shiftKey&&w.keyCode===68).map(w=>v.$1P.stop(w,!0)).map(({browserEvent:w})=>{const A=this.getFocus(),E=A.length?A[0]:void 0,I=typeof E<"u"?this.k.element(E):void 0,k=typeof E<"u"?this.k.domElement(E):this.k.domNode;return{index:E,element:I,anchor:k,browserEvent:w}})),W=n.Event.chain(this.k.onContextMenu,Q=>Q.filter(w=>!C).map(({element:w,index:A,browserEvent:E})=>({element:w,index:A,anchor:new b.$WO((0,v.$LP)(this.k.domNode),E),browserEvent:E})));return n.Event.any(_,$,W)}get onKeyDown(){return this.y.add(new N.$7Q(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new N.$7Q(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new N.$7Q(this.k.domNode,"keypress")).event}get onDidFocus(){return n.Event.signal(this.y.add(new N.$7Q(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return n.Event.signal(this.y.add(new N.$7Q(this.k.domNode,"blur",!0)).event)}constructor(C,_,$,W,Q=we){this.A=C,this.B=Q,this.c=new l("focused"),this.f=new l("anchor"),this.g=new n.$Zd,this.x="",this.y=new e.$Qc,this.z=new n.$Rd,this.onDidDispose=this.z.event;const w=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new F(w!=="listbox");const A=[this.c.renderer,this.d.renderer];this.u=Q.accessibilityProvider,this.u&&(A.push(new ce(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),W=W.map(I=>new ne(I.templateId,[...A,I]));const E={...Q,dnd:Q.dnd&&new Z(this,Q.dnd)};if(this.k=this.C(_,$,W,E),this.k.domNode.setAttribute("role",w),Q.styleController)this.q=Q.styleController(this.k.domId);else{const I=(0,v.$OP)(this.k.domNode);this.q=new oe(I,this.k.domId)}if(this.o=new D.$$Q([new z(this.c,this.k,Q.identityProvider),new z(this.d,this.k,Q.identityProvider),new z(this.f,this.k,Q.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new B(this,this.k)),(typeof Q.keyboardSupport!="boolean"||Q.keyboardSupport)&&(this.v=new M(this,this.k,Q),this.y.add(this.v)),Q.keyboardNavigationLabelProvider){const I=Q.keyboardNavigationDelegate||t.$oR;this.t=new R(this,this.k,Q.keyboardNavigationLabelProvider,Q.keyboardNavigationEventFilter??(()=>!0),I),this.y.add(this.t)}this.w=this.D(Q),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(C,_,$,W){return new r.$kR(C,_,$,W)}D(C){return new le(this)}updateOptions(C={}){this.B={...this.B,...C},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(C),this.v?.updateOptions(C),this.k.updateOptions(C)}get options(){return this.B}splice(C,_,$=[]){if(C<0||C>this.k.length)throw new s.$aR(this.A,`Invalid start index: ${C}`);if(_<0)throw new s.$aR(this.A,`Invalid delete count: ${_}`);_===0&&$.length===0||this.g.bufferEvents(()=>this.o.splice(C,_,$))}updateWidth(C){this.k.updateWidth(C)}updateElementHeight(C,_){this.k.updateElementHeight(C,_,null)}rerender(){this.k.rerender()}element(C){return this.k.element(C)}indexOf(C){return this.k.indexOf(C)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(C){this.k.setScrollTop(C)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(C){this.k.setScrollLeft(C)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(C){this.x=C,this.k.domNode.setAttribute("aria-label",C)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(C,_){this.k.layout(C,_)}triggerTypeNavigation(){this.t?.trigger()}setSelection(C,_){for(const $ of C)if($<0||$>=this.length)throw new s.$aR(this.A,`Invalid index ${$}`);this.d.set(C,_)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(C=>this.k.element(C))}setAnchor(C){if(typeof C>"u"){this.f.set([]);return}if(C<0||C>=this.length)throw new s.$aR(this.A,`Invalid index ${C}`);this.f.set([C])}getAnchor(){return(0,c.$Nb)(this.f.get(),void 0)}getAnchorElement(){const C=this.getAnchor();return typeof C>"u"?void 0:this.element(C)}setFocus(C,_){for(const $ of C)if($<0||$>=this.length)throw new s.$aR(this.A,`Invalid index ${$}`);this.c.set(C,_)}focusNext(C=1,_=!1,$,W){if(this.length===0)return;const Q=this.c.get(),w=this.E(Q.length>0?Q[0]+C:0,_,W);w>-1&&this.setFocus([w],$)}focusPrevious(C=1,_=!1,$,W){if(this.length===0)return;const Q=this.c.get(),w=this.F(Q.length>0?Q[0]-C:0,_,W);w>-1&&this.setFocus([w],$)}async focusNextPage(C,_){let $=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);$=$===0?0:$-1;const W=this.getFocus()[0];if(W!==$&&(W===void 0||$>W)){const Q=this.F($,!1,_);Q>-1&&W!==Q?this.setFocus([Q],C):this.setFocus([$],C)}else{const Q=this.k.getScrollTop();let w=Q+this.k.renderHeight;$>W&&(w-=this.k.elementHeight($)),this.k.setScrollTop(w),this.k.getScrollTop()!==Q&&(this.setFocus([]),await(0,g.$1g)(0),await this.focusNextPage(C,_))}}async focusPreviousPage(C,_){let $;const W=this.k.getScrollTop();W===0?$=this.k.indexAt(W):$=this.k.indexAfter(W-1);const Q=this.getFocus()[0];if(Q!==$&&(Q===void 0||Q>=$)){const w=this.E($,!1,_);w>-1&&Q!==w?this.setFocus([w],C):this.setFocus([$],C)}else{const w=W;this.k.setScrollTop(W-this.k.renderHeight),this.k.getScrollTop()!==w&&(this.setFocus([]),await(0,g.$1g)(0),await this.focusPreviousPage(C,_))}}focusLast(C,_){if(this.length===0)return;const $=this.F(this.length-1,!1,_);$>-1&&this.setFocus([$],C)}focusFirst(C,_){this.focusNth(0,C,_)}focusNth(C,_,$){if(this.length===0)return;const W=this.E(C,!1,$);W>-1&&this.setFocus([W],_)}E(C,_=!1,$){for(let W=0;W<this.length;W++){if(C>=this.length&&!_)return-1;if(C=C%this.length,!$||$(this.element(C)))return C;C++}return-1}F(C,_=!1,$){for(let W=0;W<this.length;W++){if(C<0&&!_)return-1;if(C=(this.length+C%this.length)%this.length,!$||$(this.element(C)))return C;C--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(C=>this.k.element(C))}reveal(C,_){if(C<0||C>=this.length)throw new s.$aR(this.A,`Invalid index ${C}`);const $=this.k.getScrollTop(),W=this.k.elementTop(C),Q=this.k.elementHeight(C);if((0,f.$Gf)(_)){const w=Q-this.k.renderHeight;this.k.setScrollTop(w*(0,h.$Wl)(_,0,1)+W)}else{const w=W+Q,A=$+this.k.renderHeight;W<$&&w>=A||(W<$||w>=A&&Q>=this.k.renderHeight?this.k.setScrollTop(W):w>=A&&this.k.setScrollTop(w-this.k.renderHeight))}}getRelativeTop(C){if(C<0||C>=this.length)throw new s.$aR(this.A,`Invalid index ${C}`);const _=this.k.getScrollTop(),$=this.k.elementTop(C),W=this.k.elementHeight(C);if($<_||$+W>_+this.k.renderHeight)return null;const Q=W-this.k.renderHeight;return Math.abs((_-$)/Q)}isDOMFocused(){return(0,v.$FP)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getElementID(C){return this.k.getElementDomId(C)}style(C){this.q.style(C)}G({indexes:C,browserEvent:_}){return{indexes:C,elements:C.map($=>this.k.element($)),browserEvent:_}}H(){const C=this.c.get();this.k.domNode.classList.toggle("element-focused",C.length>0),this.I()}I(){const C=this.c.get();if(C.length>0){let _;this.u?.getActiveDescendantId&&(_=this.u.getActiveDescendantId(this.k.element(C[0]))),this.k.domNode.setAttribute("aria-activedescendant",_||this.k.getElementDomId(C[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const C=this.d.get();this.k.domNode.classList.toggle("selection-none",C.length===0),this.k.domNode.classList.toggle("selection-single",C.length===1),this.k.domNode.classList.toggle("selection-multiple",C.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$uR=q,Xe([T.$ph],q.prototype,"onDidChangeFocus",null),Xe([T.$ph],q.prototype,"onDidChangeSelection",null),Xe([T.$ph],q.prototype,"onContextMenu",null),Xe([T.$ph],q.prototype,"onKeyDown",null),Xe([T.$ph],q.prototype,"onKeyUp",null),Xe([T.$ph],q.prototype,"onKeyPress",null),Xe([T.$ph],q.prototype,"onDidFocus",null),Xe([T.$ph],q.prototype,"onDidBlur",null)}),define(be[62],$e([1,0,6,35,37,10,15]),function(ae,t,v,N,i,U,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fk=t.$ek=t.$dk=t.$ck=t.$bk=t.$ak=t.$_j=t.$$j=t.MarkdownStringTextNewlineStyle=void 0;var D;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(D||(t.MarkdownStringTextNewlineStyle=D={}));class c{constructor(f="",s=!1){if(this.value=f,typeof this.value!="string")throw(0,v.$6)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(f,s=0){return this.value+=n(this.supportThemeIcons?(0,N.$5j)(f):f).replace(/([ \t]+)/g,(r,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,s){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}appendLink(f,s,r){return this.value+="[",this.value+=this.c(s,"]"),this.value+="](",this.value+=this.c(String(f),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(f,s){const r=new RegExp((0,U.$Je)(s),"g");return f.replace(r,(b,u)=>f.charAt(u-1)!=="\\"?`\\${b}`:b)}}t.$$j=c;function g(a){return m(a)?!a.value:Array.isArray(a)?a.every(g):!0}t.$_j=g;function m(a){return a instanceof c?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}t.$ak=m;function T(a,f){return a===f?!0:!a||!f?!1:a.value===f.value&&a.isTrusted===f.isTrusted&&a.supportThemeIcons===f.supportThemeIcons&&a.supportHtml===f.supportHtml&&(a.baseUri===f.baseUri||!!a.baseUri&&!!f.baseUri&&(0,i.$ug)(p.URI.from(a.baseUri),p.URI.from(f.baseUri)))}t.$bk=T;function n(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$ck=n;function o(a){return a.replace(/"/g,"&quot;")}t.$dk=o;function e(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$ek=e;function h(a){const f=[],s=a.split("|").map(b=>b.trim());a=s[0];const r=s[1];if(r){const b=/height=(\d+)/.exec(r),u=/width=(\d+)/.exec(r),l=b?b[1]:"",F=u?u[1]:"",z=isFinite(parseInt(F)),L=isFinite(parseInt(l));z&&f.push(`width="${F}"`),L&&f.push(`height="${l}"`)}return{href:a,dimensions:f}}t.$fk=h}),define(be[125],$e([1,0,3,117,22,55,14,19,118,6,4,62,35,77,28,2,79,53,31,51,37,10,15]),function(ae,t,v,N,i,U,p,D,c,g,m,T,n,o,e,h,a,f,s,r,b,u,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BR=t.$AR=t.$zR=t.$yR=t.$xR=void 0;const F=Object.freeze({image:(Z,q,X)=>{let C=[],_=[];return Z&&({href:Z,dimensions:C}=(0,T.$fk)(Z),_.push(`src="${(0,T.$dk)(Z)}"`)),X&&_.push(`alt="${(0,T.$dk)(X)}"`),q&&_.push(`title="${(0,T.$dk)(q)}"`),C.length&&(_=_.concat(C)),"<img "+_.join(" ")+">"},paragraph:Z=>`<p>${Z}</p>`,link:(Z,q,X)=>typeof Z!="string"?"":(Z===X&&(X=(0,T.$ek)(X)),q=typeof q=="string"?(0,T.$dk)((0,T.$ek)(q)):"",Z=(0,T.$ek)(Z),Z=Z.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Z}" title="${q||Z}" draggable="false">${X}</a>`)});function z(Z,q={},X={}){const C=new h.$Qc;let _=!1;const $=(0,U.$6Q)(q),W=function(P){let H;try{H=(0,f.$th)(decodeURIComponent(P))}catch{}return H?(H=(0,r.$en)(H,G=>{if(Z.uris&&Z.uris[G])return l.URI.revive(Z.uris[G])}),encodeURIComponent(JSON.stringify(H))):P},Q=function(P,H){const G=Z.uris&&Z.uris[P];let ee=l.URI.revive(G);return H?P.startsWith(s.Schemas.data+":")?P:(ee||(ee=l.URI.parse(P)),s.$ig.uriToBrowserUri(ee).toString(!0)):!ee||l.URI.parse(P).toString()===ee.toString()?P:(ee.query&&(ee=ee.with({query:W(ee.query)})),ee.toString())},w=new a.marked.Renderer;w.image=F.image,w.link=F.link,w.paragraph=F.paragraph;const A=[],E=[];if(q.codeBlockRendererSync?w.code=(P,H)=>{const G=o.$HM.nextId(),ee=q.codeBlockRendererSync(L(H),P);return E.push([G,ee]),`<div class="code" data-code="${G}">${(0,u.$Ie)(P)}</div>`}:q.codeBlockRenderer&&(w.code=(P,H)=>{const G=o.$HM.nextId(),ee=q.codeBlockRenderer(L(H),P);return A.push(ee.then(se=>[G,se])),`<div class="code" data-code="${G}">${(0,u.$Ie)(P)}</div>`}),q.actionHandler){const P=function(ee){let se=ee.target;if(!(se.tagName!=="A"&&(se=se.parentElement,!se||se.tagName!=="A")))try{let me=se.dataset.href;me&&(Z.baseUri&&(me=d(l.URI.from(Z.baseUri),me)),q.actionHandler.callback(me,ee))}catch(me){(0,g.$Z)(me)}finally{ee.preventDefault()}},H=q.actionHandler.disposables.add(new i.$7Q($,"click")),G=q.actionHandler.disposables.add(new i.$7Q($,"auxclick"));q.actionHandler.disposables.add(m.Event.any(H.event,G.event)(ee=>{const se=new D.$WO(v.$LP($),ee);!se.leftButton&&!se.middleButton||P(se)})),q.actionHandler.disposables.add(v.$5O($,"keydown",ee=>{const se=new p.$2O(ee);!se.equals(10)&&!se.equals(3)||P(se)}))}Z.supportHtml||(X.sanitizer=P=>(Z.isTrusted?P.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?P:"",X.sanitize=!0,X.silent=!0),X.renderer=w;let I=Z.value??"";I.length>1e5&&(I=`${I.substr(0,1e5)}\u2026`),Z.supportThemeIcons&&(I=(0,n.$6j)(I));let k;if(q.fillInIncompleteTokens){const P={...a.marked.defaults,...X},H=a.marked.lexer(I,P),G=te(H);k=a.marked.parser(G,P)}else k=a.marked.parse(I,X);Z.supportThemeIcons&&(k=(0,c.$vR)(k).map(H=>typeof H=="string"?H:H.outerHTML).join(""));const S=new DOMParser().parseFromString(y(Z,k),"text/html");if(S.body.querySelectorAll("img").forEach(P=>{const H=P.getAttribute("src");if(H){let G=H;try{Z.baseUri&&(G=d(l.URI.from(Z.baseUri),G))}catch{}P.src=Q(G,!0)}}),S.body.querySelectorAll("a").forEach(P=>{const H=P.getAttribute("href");if(P.setAttribute("href",""),!H||/^data:|javascript:/i.test(H)||/^command:/i.test(H)&&!Z.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(H))P.replaceWith(...P.childNodes);else{let G=Q(H,!1);Z.baseUri&&(G=d(l.URI.from(Z.baseUri),H)),P.dataset.href=G}}),$.innerHTML=y(Z,S.body.innerHTML),A.length>0)Promise.all(A).then(P=>{if(_)return;const H=new Map(P),G=$.querySelectorAll("div[data-code]");for(const ee of G){const se=H.get(ee.dataset.code??"");se&&v.$8P(ee,se)}q.asyncRenderCallback?.()});else if(E.length>0){const P=new Map(E),H=$.querySelectorAll("div[data-code]");for(const G of H){const ee=P.get(G.dataset.code??"");ee&&v.$8P(G,ee)}}if(q.asyncRenderCallback)for(const P of $.getElementsByTagName("img")){const H=C.add(v.$5O(P,"load",()=>{H.dispose(),q.asyncRenderCallback()}))}return{element:$,dispose:()=>{_=!0,C.dispose()}}}t.$xR=z;function L(Z){if(!Z)return"";const q=Z.split(/[\s+|:|,|\{|\?]/,1);return q.length?q[0]:Z}function d(Z,q){return/^\w[\w\d+.-]*:/.test(q)?q:Z.path.endsWith("/")?(0,b.$Eg)(Z,q).toString():(0,b.$Eg)((0,b.$Ag)(Z),q).toString()}function y(Z,q){const{config:X,allowedSchemes:C}=M(Z);N.addHook("uponSanitizeAttribute",($,W)=>{if(W.attrName==="style"||W.attrName==="class"){if($.tagName==="SPAN"){if(W.attrName==="style"){W.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(W.attrValue);return}else if(W.attrName==="class"){W.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(W.attrValue);return}}W.keepAttr=!1;return}});const _=v.$pQ(C);try{return N.sanitize(q,{...X,RETURN_TRUSTED_TYPE:!0})}finally{N.removeHook("uponSanitizeAttribute"),_.dispose()}}t.$yR=["align","autoplay","alt","class","controls","data-code","data-href","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function M(Z){const q=[s.Schemas.http,s.Schemas.https,s.Schemas.mailto,s.Schemas.data,s.Schemas.file,s.Schemas.vscodeFileResource,s.Schemas.vscodeRemote,s.Schemas.vscodeRemoteResource];return Z.isTrusted&&q.push(s.Schemas.command),{config:{ALLOWED_TAGS:[...v.$qQ],ALLOWED_ATTR:t.$yR,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:q}}function V(Z){return typeof Z=="string"?Z:x(Z)}t.$zR=V;function x(Z){let q=Z.value??"";q.length>1e5&&(q=`${q.substr(0,1e5)}\u2026`);const X=a.marked.parse(q,{renderer:B.value}).replace(/&(#\d+|[a-zA-Z]+);/g,C=>R.get(C)??C);return y({isTrusted:!1},X).toString()}t.$AR=x;const R=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),B=new e.$U(()=>{const Z=new a.marked.Renderer;return Z.code=q=>q,Z.blockquote=q=>q,Z.html=q=>"",Z.heading=(q,X,C)=>q+`
`,Z.hr=()=>"",Z.list=(q,X)=>q,Z.listitem=q=>q+`
`,Z.paragraph=q=>q+`
`,Z.table=(q,X)=>q+X+`
`,Z.tablerow=q=>q,Z.tablecell=(q,X)=>q+" ",Z.strong=q=>q,Z.em=q=>q,Z.codespan=q=>q,Z.br=()=>`
`,Z.del=q=>q,Z.image=(q,X,C)=>"",Z.text=q=>q,Z.link=(q,X,C)=>C,Z});function j(Z){let q="";return Z.forEach(X=>{q+=X.raw}),q}function ie(Z){for(const q of Z.tokens)if(q.type==="text"){const X=q.raw.split(`
`),C=X[X.length-1];if(C.includes("`"))return le(Z);if(C.includes("**"))return Le(Z);if(C.match(/\*\w/))return oe(Z);if(C.match(/(^|\s)__\w/))return de(Z);if(C.match(/(^|\s)_\w/))return we(Z);if(C.match(/(^|\s)\[.*\]\(\w*/))return Fe(Z);if(C.match(/(^|\s)\[\w/))return ke(Z)}}function te(Z){let q,X;for(q=0;q<Z.length;q++){const C=Z[q];if(C.type==="paragraph"&&C.raw.match(/(\n|^)```/)){X=ue(Z.slice(q));break}if(C.type==="paragraph"&&C.raw.match(/(\n|^)\|/)){X=ce(Z.slice(q));break}if(q===Z.length-1&&C.type==="paragraph"){const _=ie(C);if(_){X=[_];break}}}if(X){const C=[...Z.slice(0,q),...X];return C.links=Z.links,C}return Z}t.$BR=te;function ue(Z){const q=j(Z);return a.marked.lexer(q+"\n```")}function le(Z){return ne(Z,"`")}function oe(Z){return ne(Z,"*")}function we(Z){return ne(Z,"_")}function Fe(Z){return ne(Z,")")}function ke(Z){return ne(Z,"](about:blank)")}function Le(Z){return ne(Z,"**")}function de(Z){return ne(Z,"__")}function ne(Z,q){const X=j(Array.isArray(Z)?Z:[Z]);return a.marked.lexer(X+q)[0]}function ce(Z){const q=j(Z),X=q.split(`
`);let C,_=!1;for(let $=0;$<X.length;$++){const W=X[$].trim();if(typeof C>"u"&&W.match(/^\s*\|/)){const Q=W.match(/(\|[^\|]+)(?=\||$)/g);Q&&(C=Q.length)}else if(typeof C=="number")if(W.match(/^\s*\|/)){if($!==X.length-1)return;_=!0}else return}if(typeof C=="number"&&C>0){const $=_?X.slice(0,-1).join(`
`):q,W=!!$.match(/\|\s*$/),Q=$+(W?"":"|")+`
|${" --- |".repeat(C)}`;return a.marked.lexer(Q)}}}),define(be[126],$e([1,0,3,9,29,62,35,2,7,107]),function(ae,t,v,N,i,U,p,D,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XQ=t.$WQ=void 0;function m(o,e){(0,c.$Cf)(e)?o.title=(0,p.$7j)(e):e?.markdownNotSupportedFallback?o.title=e.markdownNotSupportedFallback:o.removeAttribute("title")}t.$WQ=m;class T{constructor(e,h,a){this.c=e,this.d=h,this.f=a}async update(e,h,a){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let f;if(e===void 0||(0,c.$Cf)(e)||e instanceof HTMLElement)f=e;else if(!(0,c.$Qf)(e.markdown))f=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,g.localize)(0,null),h),this.b=new i.$2d;const s=this.b.token;if(f=await e.markdown(s),f===void 0&&(f=e.markdownNotSupportedFallback),this.isDisposed||s.isCancellationRequested)return}this.g(f,h,a)}g(e,h,a){const f=this.a;if(this.h(e)){const s={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!f,...a};this.a=this.c.showHover(s,h)}f?.dispose()}h(e){return e?(0,U.$ak)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function n(o,e,h,a){let f,s;const r=(z,L)=>{const d=s!==void 0;z&&(s?.dispose(),s=void 0),L&&(f?.dispose(),f=void 0),d&&o.onDidHideHover?.()},b=(z,L,d)=>new N.$0g(async()=>{(!s||s.isDisposed)&&(s=new T(o,d||e,z>0),await s.update(h,L,a))},z),u=()=>{if(f)return;const z=new D.$Qc,L=M=>r(!1,M.fromElement===e);z.add(v.$5O(e,v.$YP.MOUSE_LEAVE,L,!0));const d=()=>r(!0,!0);z.add(v.$5O(e,v.$YP.MOUSE_DOWN,d,!0));const y={targetElements:[e],dispose:()=>{}};if(o.placement===void 0||o.placement==="mouse"){const M=V=>{y.x=V.x+10,V.target instanceof HTMLElement&&V.target.classList.contains("action-label")&&r(!0,!0)};z.add(v.$5O(e,v.$YP.MOUSE_MOVE,M,!0))}z.add(b(o.delay,!1,y)),f=z},l=v.$5O(e,v.$YP.MOUSE_OVER,u,!0);return{show:z=>{r(!1,!0),b(0,z)},hide:()=>{r(!0,!0)},update:async(z,L)=>{h=z,await s?.update(h,void 0,L)},dispose:()=>{l.dispose(),r(!0,!0)}}}t.$XQ=n}),define(be[127],$e([1,0,3,22,14,125,39,12,4,44,2,5,109,100]),function(ae,t,v,N,i,U,p,D,c,g,m,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CR=void 0;const o=v.$,e="selectOption.entry.template";class h{get templateId(){return e}renderTemplate(s){const r=Object.create(null);return r.root=s,r.text=v.$6P(s,o(".option-text")),r.detail=v.$6P(s,o(".option-detail")),r.decoratorRight=v.$6P(s,o(".option-decorator-right")),r}renderElement(s,r,b){const u=b,l=s.text,F=s.detail,z=s.decoratorRight,L=s.isDisabled;u.text.textContent=l,u.detail.textContent=F||"",u.decoratorRight.innerText=z||"",L?u.root.classList.add("option-disabled"):u.root.classList.remove("option-disabled")}disposeTemplate(s){}}class a extends m.$Rc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(s,r,b,u,l){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=u,this.g=l||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=a.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new c.$Rd,this.B(this.r),this.O(),this.N(b),this.n=r||0,s&&this.setOptions(s,r),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(s){this.u=s,this.w=v.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=v.$6P(this.w,o(".select-box-details-pane"));const r=v.$6P(this.w,o(".select-box-dropdown-container-width-control")),b=v.$6P(r,o(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",v.$6P(b,this.D),this.G=0,this.y=v.$OP(this.w),this.w.setAttribute("draggable","true"),this.B(v.$5O(this.w,v.$YP.DRAG_START,u=>{v.$1P.stop(u,!0)}))}O(){this.B(v.$6O(this.h,"change",r=>{this.n=r.target.selectedIndex,this.r.fire({index:r.target.selectedIndex,selected:r.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(v.$5O(this.h,v.$YP.CLICK,r=>{v.$1P.stop(r),this.f?this.X(!0):this.W()})),this.B(v.$5O(this.h,v.$YP.MOUSE_DOWN,r=>{v.$1P.stop(r)}));let s;this.B(v.$5O(this.h,"touchstart",r=>{s=this.f})),this.B(v.$5O(this.h,"touchend",r=>{v.$1P.stop(r),s?this.X(!0):this.W()})),this.B(v.$5O(this.h,v.$YP.KEY_DOWN,r=>{const b=new i.$2O(r);let u=!1;T.$j?(b.keyCode===18||b.keyCode===16||b.keyCode===10||b.keyCode===3)&&(u=!0):(b.keyCode===18&&b.altKey||b.keyCode===16&&b.altKey||b.keyCode===10||b.keyCode===3)&&(u=!0),u&&(this.W(),v.$1P.stop(r,!0))}))}get onDidSelect(){return this.r.event}setOptions(s,r){D.$tb(this.m,s)||(this.m=s,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((b,u)=>{this.h.add(this.U(b.text,u,b.isDisabled)),typeof b.description=="string"&&(this.H=!0)})),r!==void 0&&(this.select(r),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(s){s>=0&&s<this.m.length?this.n=s:s>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(s){this.g.ariaLabel=s,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(s){this.h.tabIndex=s?0:-1}render(s){this.j=s,s.classList.add("select-container"),s.appendChild(this.h),this.R()}Q(){const s=[];this.s.listFocusBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(s.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=s.join(`
`)}R(){const s=this.s.selectBackground??"",r=this.s.selectForeground??"",b=this.s.selectBorder??"";this.h.style.backgroundColor=s,this.h.style.color=r,this.h.style.borderColor=b}S(){const s=this.s.selectBackground??"",r=v.$lQ(this.s.selectListBackground,s);this.C.style.backgroundColor=r,this.I.style.backgroundColor=r;const b=this.s.focusBorder??"";this.w.style.outlineColor=b,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(s,r,b){const u=document.createElement("option");return u.value=s,u.text=s,u.disabled=!!b,u}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:s=>this.Y(s,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:s=>this.Y(s),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(s){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),s&&this.h.focus(),this.u.hideContextView())}Y(s,r){return s.appendChild(this.w),this.ab(r),{dispose:()=>{try{s.removeChild(this.w)}catch{}}}}Z(){let s=0;return this.m.forEach((r,b)=>{this.hb(b),this.I.offsetHeight>s&&(s=this.I.offsetHeight)}),s}ab(s){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const r=v.$LP(this.h),b=v.$oP(this.h),u=v.$LP(this.h).getComputedStyle(this.h),l=parseFloat(u.getPropertyValue("--dropdown-padding-top"))+parseFloat(u.getPropertyValue("--dropdown-padding-bottom")),F=r.innerHeight-b.top-b.height-(this.g.minBottomMargin||0),z=b.top-a.b,L=this.h.offsetWidth,d=this.bb(this.D),y=Math.max(d,Math.round(L)).toString()+"px";this.w.style.width=y,this.z.getHTMLElement().style.height="",this.z.layout();let M=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const V=this.H?this.L:0,x=M+l+V,R=Math.floor((F-l-V)/this.getHeight()),B=Math.floor((z-l-V)/this.getHeight());if(s)return b.top+b.height>r.innerHeight-22||b.top<a.b||R<1&&B<1?!1:(R<a.c&&B>R&&this.m.length>R?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(b.top+b.height>r.innerHeight-22||b.top<a.b||this.G===0&&R<1||this.G===1&&B<1)return this.X(!0),!1;if(this.G===0){if(this.f&&R+B<1)return this.X(!0),!1;x>F&&(M=R*this.getHeight())}else x>z&&(M=B*this.getHeight());return this.z.layout(M),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=M+l+"px",this.w.style.height=""):this.w.style.height=M+l+"px",this.hb(this.n),this.w.style.width=y,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(s){let r=0;if(s){let b=0,u=0;this.m.forEach((l,F)=>{const z=l.detail?l.detail.length:0,L=l.decoratorRight?l.decoratorRight.length:0,d=l.text.length+z+L;d>u&&(b=F,u=d)}),s.textContent=this.m[b].text+(this.m[b].decoratorRight?this.m[b].decoratorRight+" ":""),r=v.$qP(s)}return r}cb(s){if(this.z)return;this.C=v.$6P(s,o(".select-box-dropdown-list-container")),this.t=new h,this.z=new p.$uR("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:u=>{let l=u.text;return u.detail&&(l+=`. ${u.detail}`),u.decoratorRight&&(l+=`. ${u.decoratorRight}`),u.description&&(l+=`. ${u.description}`),l},getWidgetAriaLabel:()=>(0,n.localize)(0,null),getRole:()=>T.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const r=this.B(new N.$7Q(this.C,"keydown")),b=c.Event.chain(r.event,u=>u.filter(()=>this.z.length>0).map(l=>new i.$2O(l)));this.B(c.Event.chain(b,u=>u.filter(l=>l.keyCode===3))(this.jb,this)),this.B(c.Event.chain(b,u=>u.filter(l=>l.keyCode===2))(this.jb,this)),this.B(c.Event.chain(b,u=>u.filter(l=>l.keyCode===9))(this.ib,this)),this.B(c.Event.chain(b,u=>u.filter(l=>l.keyCode===16))(this.lb,this)),this.B(c.Event.chain(b,u=>u.filter(l=>l.keyCode===18))(this.kb,this)),this.B(c.Event.chain(b,u=>u.filter(l=>l.keyCode===12))(this.nb,this)),this.B(c.Event.chain(b,u=>u.filter(l=>l.keyCode===11))(this.mb,this)),this.B(c.Event.chain(b,u=>u.filter(l=>l.keyCode===14))(this.ob,this)),this.B(c.Event.chain(b,u=>u.filter(l=>l.keyCode===13))(this.pb,this)),this.B(c.Event.chain(b,u=>u.filter(l=>l.keyCode>=21&&l.keyCode<=56||l.keyCode>=85&&l.keyCode<=113))(this.qb,this)),this.B(v.$5O(this.z.getHTMLElement(),v.$YP.POINTER_UP,u=>this.db(u))),this.B(this.z.onMouseOver(u=>typeof u.index<"u"&&this.z.setFocus([u.index]))),this.B(this.z.onDidChangeFocus(u=>this.gb(u))),this.B(v.$5O(this.w,v.$YP.FOCUS_OUT,u=>{!this.f||v.$wP(u.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(s){if(!this.z.length)return;v.$1P.stop(s);const r=s.target;if(!r||r.classList.contains("slider"))return;const b=r.closest(".monaco-list-row");if(!b)return;const u=Number(b.getAttribute("data-index")),l=b.classList.contains("option-disabled");u>=0&&u<this.m.length&&!l&&(this.n=u,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(s,r){const b=l=>{for(let F=0;F<l.childNodes.length;F++){const z=l.childNodes.item(F);(z.tagName&&z.tagName.toLowerCase())==="img"?l.removeChild(z):b(z)}},u=(0,U.$xR)({value:s,supportThemeIcons:!0},{actionHandler:r});return u.element.classList.add("select-box-description-markdown"),b(u.element),u.element}gb(s){!this.f||!this.H||this.hb(s.indexes[0])}hb(s){this.I.innerText="";const r=this.m[s],b=r?.description??"",u=r?.descriptionIsMarkdown??!1;if(b){if(u){const l=r.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(b,l))}else this.I.innerText=b;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(s){v.$1P.stop(s),this.select(this.F),this.X(!0)}jb(s){v.$1P.stop(s),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(s){if(this.n<this.m.length-1){v.$1P.stop(s,!0);const r=this.m[this.n+1].isDisabled;if(r&&this.m.length>this.n+2)this.n+=2;else{if(r)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(s){this.n>0&&(v.$1P.stop(s,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(s){v.$1P.stop(s),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(s){v.$1P.stop(s),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(s){v.$1P.stop(s),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(s){v.$1P.stop(s),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(s){const r=g.KeyCodeUtils.toString(s.keyCode);let b=-1;for(let u=0;u<this.m.length-1;u++)if(b=(u+this.n+1)%this.m.length,this.m[b].text.charAt(0).toUpperCase()===r&&!this.m[b].isDisabled){this.select(b),this.z.setFocus([b]),this.z.reveal(this.z.getFocus()[0]),v.$1P.stop(s);break}}dispose(){this.X(!1),super.dispose()}}t.$CR=a}),define(be[128],$e([1,0,39,127,121,20,5,99]),function(ae,t,v,N,i,U,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FR=t.$ER=void 0,t.$ER={...v.$tR,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class D extends U.$GQ{constructor(g,m,T,n,o){super(),p.$j&&!o?.useCustomDrawn?this.a=new i.$DR(g,m,n,o):this.a=new N.$CR(g,m,T,n,o),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(g,m){this.a.setOptions(g,m)}select(g){this.a.select(g)}setAriaLabel(g){this.a.setAriaLabel(g)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(g){this.a.setFocusable(g)}render(g){this.a.render(g)}}t.$FR=D}),define(be[63],$e([1,0,16,54,3,24,126,128,36,2,5,7,104,52]),function(ae,t,v,N,i,U,p,D,c,g,m,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MR=t.$LR=t.$KR=void 0;class o extends g.$Rc{get action(){return this._action}constructor(f,s,r={}){super(),this.m=r,this._context=f||this,this._action=s,s instanceof c.$Ci&&this.B(s.onDidChange(b=>{this.element&&this.t(b)}))}t(f){f.enabled!==void 0&&this.u(),f.checked!==void 0&&this.G(),f.class!==void 0&&this.F(),f.label!==void 0&&(this.w(),this.C()),f.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new c.$Di)),this.j}set actionRunner(f){this.j=f}isEnabled(){return this._action.enabled}setActionContext(f){this._context=f}render(f){const s=this.element=f;this.B(U.$CQ.addTarget(f));const r=this.m&&this.m.draggable;r&&(f.draggable=!0,v.$KO&&this.B((0,i.$5O)(f,i.$YP.DRAG_START,b=>b.dataTransfer?.setData(N.$AQ.TEXT,this._action.label)))),this.B((0,i.$5O)(s,U.EventType.Tap,b=>this.onClick(b,!0))),this.B((0,i.$5O)(s,i.$YP.MOUSE_DOWN,b=>{r||i.$1P.stop(b,!0),this._action.enabled&&b.button===0&&s.classList.add("active")})),m.$j&&this.B((0,i.$5O)(s,i.$YP.CONTEXT_MENU,b=>{b.button===0&&b.ctrlKey===!0&&this.onClick(b)})),this.B((0,i.$5O)(s,i.$YP.CLICK,b=>{i.$1P.stop(b,!0),this.m&&this.m.isMenu||this.onClick(b)})),this.B((0,i.$5O)(s,i.$YP.DBLCLICK,b=>{i.$1P.stop(b,!0)})),[i.$YP.MOUSE_UP,i.$YP.MOUSE_OUT].forEach(b=>{this.B((0,i.$5O)(s,b,u=>{i.$1P.stop(u),s.classList.remove("active")}))})}onClick(f,s=!1){i.$1P.stop(f,!0);const r=T.$Lf(this._context)?this.m?.useEventAsContext?f:{preserveFocus:s}:this._context;this.actionRunner.run(this._action,r)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(f){this.element&&(this.element.tabIndex=f?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const f=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(f):(this.f=(0,p.$XQ)(this.m.hoverDelegate,this.element,f),this.q.add(this.f))):this.element.title=f}D(){if(this.element){const f=this.z()??"";this.element.setAttribute("aria-label",f)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$KR=o;class e extends o{constructor(f,s,r){super(f,s,r),this.m=r,this.m.icon=r.icon!==void 0?r.icon:!1,this.m.label=r.label!==void 0?r.label:!0,this.J=""}render(f){super.render(f),T.$Mf(this.element);const s=document.createElement("a");if(s.classList.add("action-label"),s.setAttribute("role",this.L()),this.H=s,this.element.appendChild(s),this.m.label&&this.m.keybinding){const r=document.createElement("span");r.classList.add("keybinding"),r.textContent=this.m.keybinding,this.element.appendChild(r)}this.F(),this.w(),this.C(),this.u(),this.G()}L(){return this._action.id===c.$Ei.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.H&&(this.H.tabIndex=0,this.H.focus())}isFocused(){return!!this.H&&this.H?.tabIndex===0}blur(){this.H&&(this.H.tabIndex=-1)}setFocusable(f){this.H&&(this.H.tabIndex=f?0:-1)}w(){this.m.label&&this.H&&(this.H.textContent=this.action.label)}z(){let f=null;return this.action.tooltip?f=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(f=this.action.label,this.m.keybinding&&(f=n.localize(0,null,f,this.m.keybinding))),f??void 0}F(){this.J&&this.H&&this.H.classList.remove(...this.J.split(" ")),this.m.icon?(this.J=this.action.class,this.H&&(this.H.classList.add("codicon"),this.J&&this.H.classList.add(...this.J.split(" "))),this.u()):this.H?.classList.remove("codicon")}u(){this.action.enabled?(this.H&&(this.H.removeAttribute("aria-disabled"),this.H.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.H&&(this.H.setAttribute("aria-disabled","true"),this.H.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.H){const f=this.z()??"";this.H.setAttribute("aria-label",f)}}G(){this.H&&(this.action.checked!==void 0?(this.H.classList.toggle("checked",this.action.checked),this.H.setAttribute("aria-checked",this.action.checked?"true":"false"),this.H.setAttribute("role","checkbox")):(this.H.classList.remove("checked"),this.H.removeAttribute("aria-checked"),this.H.setAttribute("role",this.L())))}}t.$LR=e;class h extends o{constructor(f,s,r,b,u,l,F){super(f,s),this.b=new D.$FR(r,b,u,l,F),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(f,s){this.b.setOptions(f,s)}select(f){this.b.select(f)}g(){this.B(this.b.onDidSelect(f=>this.n(f.selected,f.index)))}n(f,s){this.actionRunner.run(this._action,this.r(f,s))}r(f,s){return f}setFocusable(f){this.b.setFocusable(f)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(f){this.b.render(f)}}t.$MR=h}),define(be[64],$e([1,0,3,14,63,36,4,2,7,52]),function(ae,t,v,N,i,U,p,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZQ=t.$YQ=t.ActionsOrientation=void 0;var g;(function(n){n[n.HORIZONTAL=0]="HORIZONTAL",n[n.VERTICAL=1]="VERTICAL"})(g||(t.ActionsOrientation=g={}));class m extends D.$Rc{constructor(o,e={}){super(),this.g=this.B(new D.$Qc),this.r=this.B(new D.$1c),this.w=!1,this.y=!0,this.C=this.B(new p.$Rd),this.onDidBlur=this.C.event,this.D=this.B(new p.$Rd({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new p.$Rd),this.onDidRun=this.G.event,this.H=this.B(new p.$Rd),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new U.$Di,this.g.add(this.f)),this.g.add(this.f.onDidRun(f=>this.G.fire(f))),this.g.add(this.f.onWillRun(f=>this.H.fire(f))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let h,a;switch(this.m){case 0:h=[15],a=[17];break;case 1:h=[16],a=[18],this.domNode.className+=" vertical";break}this.B(v.$5O(this.domNode,v.$YP.KEY_DOWN,f=>{const s=new N.$2O(f);let r=!0;const b=typeof this.t=="number"?this.viewItems[this.t]:void 0;h&&(s.equals(h[0])||s.equals(h[1]))?r=this.P():a&&(s.equals(a[0])||s.equals(a[1]))?r=this.O():s.equals(9)&&this.F?this.D.fire():s.equals(14)?r=this.M():s.equals(13)?r=this.N():s.equals(2)&&b instanceof i.$KR&&b.trapsArrowNavigation?r=this.O():this.J(s)?this.n.keyDown?this.R(s):this.w=!0:r=!1,r&&(s.preventDefault(),s.stopPropagation())})),this.B(v.$5O(this.domNode,v.$YP.KEY_UP,f=>{const s=new N.$2O(f);this.J(s)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(s)),s.preventDefault(),s.stopPropagation()):(s.equals(2)||s.equals(1026))&&this.L()})),this.u=this.B(v.$4P(this.domNode)),this.B(this.u.onDidBlur(()=>{(v.$EP()===this.domNode||!v.$wP(v.$EP(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),o.appendChild(this.domNode)}I(){this.length()>=2?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(o){o?this.z.setAttribute("aria-label",o):this.z.removeAttribute("aria-label")}setFocusable(o){if(this.y=o,this.y){const e=this.viewItems.find(h=>h instanceof i.$KR&&h.isEnabled());e instanceof i.$KR&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.$KR&&e.setFocusable(!1)})}J(o){let e=!1;return this.n.keys.forEach(h=>{e=e||o.equals(h)}),e}L(){for(let o=0;o<this.z.children.length;o++){const e=this.z.children[o];if(v.$wP(v.$EP(),e)){this.t=o,this.viewItems[this.t]?.showHover?.();break}}}get context(){return this.j}set context(o){this.j=o,this.viewItems.forEach(e=>e.setActionContext(o))}get actionRunner(){return this.f}set actionRunner(o){this.f=o,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=o)}getContainer(){return this.domNode}hasAction(o){return this.viewItems.findIndex(e=>e.action.id===o.id)!==-1}getAction(o){if(typeof o=="number")return this.viewItems[o]?.action;if(o instanceof HTMLElement){for(;o.parentElement!==this.z;){if(!o.parentElement)return;o=o.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===o)return this.viewItems[e].action}}push(o,e={}){const h=Array.isArray(o)?o:[o];let a=c.$Gf(e.index)?e.index:null;h.forEach(f=>{const s=document.createElement("li");s.className="action-item",s.setAttribute("role","presentation");let r;const b={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(r=this.b.actionViewItemProvider(f,b)),r||(r=new i.$LR(this.context,f,b)),this.b.allowContextMenu||this.r.set(r,v.$5O(s,v.$YP.CONTEXT_MENU,u=>{v.$1P.stop(u,!0)})),r.actionRunner=this.f,r.setActionContext(this.context),r.render(s),this.y&&r instanceof i.$KR&&this.viewItems.length===0&&r.setFocusable(!0),a===null||a<0||a>=this.z.children.length?(this.z.appendChild(s),this.viewItems.push(r)):(this.z.insertBefore(s,this.z.children[a]),this.viewItems.splice(a,0,r),a++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(o){if(o>=0&&o<this.z.children.length){const e=this.z.children.item(o);if(e)return e.clientWidth}return 0}getHeight(o){if(o>=0&&o<this.z.children.length){const e=this.z.children.item(o);if(e)return e.clientHeight}return 0}pull(o){o>=0&&o<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[o]),this.r.deleteAndDispose(this.viewItems[o]),(0,D.$Mc)(this.viewItems.splice(o,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,D.$Mc)(this.viewItems),this.r.clearAndDisposeAll(),v.$4O(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(o){let e=!1,h;if(o===void 0?e=!0:typeof o=="number"?h=o:typeof o=="boolean"&&(e=o),e&&typeof this.t>"u"){const a=this.viewItems.findIndex(f=>f.isEnabled());this.t=a===-1?void 0:a,this.Q(void 0,void 0,!0)}else h!==void 0&&(this.t=h),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(o){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let h;do{if(!o&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,h=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===U.$Ei.ID));return this.Q(),!0}P(o){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let h;do{if(this.t=this.t-1,this.t<0){if(!o&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}h=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===U.$Ei.ID));return this.Q(!0),!0}Q(o,e,h=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const a=this.t!==void 0?this.viewItems[this.t]:void 0;if(a){let f=!0;c.$Qf(a.focus)||(f=!1),this.b.focusOnlyEnabledItems&&c.$Qf(a.isEnabled)&&!a.isEnabled()&&(f=!1),a.action.id===U.$Ei.ID&&(f=!1),f&&a.showHover?.(),f?(h||this.s!==this.t)&&(a.focus(o),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0)}}R(o){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof i.$KR){const h=e._context===null||e._context===void 0?o:e._context;this.run(e._action,h)}}async run(o,e){await this.f.run(o,e)}dispose(){this.j=void 0,this.viewItems=(0,D.$Mc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$YQ=m;function T(n){if(!n.length)return n;let o=-1;for(let h=0;h<n.length;h++)if(n[h].id!==U.$Ei.ID){o=h;break}if(o===-1)return[];n=n.slice(o);for(let h=n.length-1;h>=0&&n[h].id===U.$Ei.ID;h--)n.splice(h,1);let e=!1;for(let h=n.length-1;h>=0;h--){const a=n[h].id===U.$Ei.ID;a&&!e?n.splice(h,1):a?a&&(e=!1):e=!0}return n}t.$ZQ=T}),define(be[65],$e([1,0,3,22,55,64,57,60,20,4,81,51,108,96]),function(ae,t,v,N,i,U,p,D,c,g,m,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rS=t.$qS=t.$pS=t.MessageType=void 0;const o=v.$;var e;(function(f){f[f.INFO=1]="INFO",f[f.WARNING=2]="WARNING",f[f.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$pS={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class h extends c.$GQ{constructor(s,r,b){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new g.$Rd),this.onDidChange=this.O.event,this.P=this.B(new g.$Rd),this.onDidHeightChange=this.P.event,this.a=r,this.g=b,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=v.$6P(s,o(".monaco-inputbox.idle"));const u=this.g.flexibleHeight?"textarea":"input",l=v.$6P(this.element,o(".ibwrapper"));if(this.b=v.$6P(l,o(u+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=v.$6P(l,o("div.mirror")),this.y.innerText="\xA0",this.N=new D.$QQ(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),v.$6P(s,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(L=>this.b.scrollTop=L.scrollTop));const F=this.B(new N.$7Q(s.ownerDocument,"selectionchange")),z=g.Event.filter(F.event,()=>s.ownerDocument.getSelection()?.anchorNode===l);this.B(z(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new U.$YQ(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(s){this.n=s,this.b.setAttribute("placeholder",s)}setTooltip(s){this.r=s,this.b.title=s}setAriaLabel(s){this.s=s,s?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(s){this.b.value!==s&&(this.b.value=s,this.Y())}get step(){return this.b.step}set step(s){this.b.step=s}get height(){return typeof this.J=="number"?this.J:v.$uP(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return v.$FP(this.b)}select(s=null){this.b.select(),s&&(this.b.setSelectionRange(s.start,s.end),s.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(s){s?this.enable():this.disable()}get width(){return v.$qP(this.b)}set width(s){if(this.g.flexibleHeight&&this.g.flexibleWidth){let r=0;if(this.y){const b=parseFloat(this.y.style.paddingLeft||"")||0,u=parseFloat(this.y.style.paddingRight||"")||0;r=b+u}this.b.style.width=s-r+"px"}else this.b.style.width=s+"px";this.y&&(this.y.style.width=s+"px")}set paddingRight(s){this.b.style.width=`calc(100% - ${s}px)`,this.y&&(this.y.style.paddingRight=s+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const s=this.L,r=this.J,b=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:s,height:r}),this.N.setScrollPosition({scrollTop:b})}showMessage(s,r){if(this.w==="open"&&(0,T.$gn)(this.h,s))return;this.h=s,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(s.type));const b=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${v.$lQ(b.border,"transparent")}`,this.h.content&&(this.hasFocus()||r)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let s=null;return this.t&&(s=this.t(this.value),s?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(s)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),s?.type}stylesForType(s){const r=this.g.inputBoxStyles;switch(s){case 1:return{border:r.inputValidationInfoBorder,background:r.inputValidationInfoBackground,foreground:r.inputValidationInfoForeground};case 2:return{border:r.inputValidationWarningBorder,background:r.inputValidationWarningBackground,foreground:r.inputValidationWarningForeground};default:return{border:r.inputValidationErrorBorder,background:r.inputValidationErrorBackground,foreground:r.inputValidationErrorForeground}}}U(s){switch(s){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let s;const r=()=>s.style.width=v.$qP(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:u=>{if(!this.h)return null;s=v.$6P(u,o(".monaco-inputbox-container")),r();const l={inline:!0,className:"monaco-inputbox-message"},F=this.h.formatContent?(0,i.$5Q)(this.h.content,l):(0,i.$4Q)(this.h.content,l);F.classList.add(this.U(this.h.type));const z=this.stylesForType(this.h.type);return F.style.backgroundColor=z.background??"",F.style.color=z.foreground??"",F.style.border=z.border?`1px solid ${z.border}`:"",v.$6P(s,F),null},onHide:()=>{this.w="closed"},layout:r});let b;this.h.type===3?b=n.localize(0,null,this.h.content):this.h.type===2?b=n.localize(1,null,this.h.content):b=n.localize(2,null,this.h.content),p.$9Q(b),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const s=this.value,b=s.charCodeAt(s.length-1)===10?" ":"";(s+b).replace(/\u000c/g,"")?this.y.textContent=s+b:this.y.innerText="\xA0",this.layout()}ab(){const s=this.g.inputBoxStyles,r=s.inputBackground??"",b=s.inputForeground??"",u=s.inputBorder??"";this.element.style.backgroundColor=r,this.element.style.color=b,this.b.style.backgroundColor="inherit",this.b.style.color=b,this.element.style.border=`1px solid ${v.$lQ(u,"transparent")}`}layout(){if(!this.y)return;const s=this.L;this.L=v.$uP(this.y),s!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(s){const r=this.inputElement,b=r.selectionStart,u=r.selectionEnd,l=r.value;b!==null&&u!==null&&(this.value=l.substr(0,b)+s+l.substr(u),r.setSelectionRange(b+1,b+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$qS=h;class a extends h{constructor(s,r,b){const u=n.localize(3,null,"\u21C5"),l=n.localize(4,null,"\u21C5");super(s,r,b),this.db=this.B(new g.$Rd),this.onDidFocus=this.db.event,this.eb=this.B(new g.$Rd),this.onDidBlur=this.eb.event,this.bb=new m.$nS(b.history,100);const F=()=>{if(b.showHistoryHint&&b.showHistoryHint()&&!this.n.endsWith(u)&&!this.n.endsWith(l)&&this.bb.getHistory().length){const z=this.n.endsWith(")")?u:l,L=this.n+z;b.showPlaceholderOnFocus&&!v.$FP(this.b)?this.n=L:this.setPlaceHolder(L)}};this.cb=new MutationObserver((z,L)=>{z.forEach(d=>{d.target.textContent||F()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>F()),this.F(this.b,()=>{const z=L=>{if(this.n.endsWith(L)){const d=this.n.slice(0,this.n.length-L.length);return b.showPlaceholderOnFocus?this.n=d:this.setPlaceHolder(d),!0}else return!1};z(l)||z(u)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(s){this.value&&(s||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(s){const r=this.getHistory();this.clearHistory(),s.forEach(b=>{this.bb.add(b)}),r.forEach(b=>{this.bb.add(b)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let s=this.jb();s&&(s=s===this.value?this.jb():s),this.value=s??"",p.$0Q(this.value?this.value:n.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let s=this.ib();s&&(s=s===this.value?this.ib():s),s&&(this.value=s,p.$0Q(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(s){super.setPlaceHolder(s),this.setTooltip(s)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let s=this.bb.current();return s||(s=this.bb.last(),this.bb.next()),s}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$rS=a}),define(be[66],$e([1,0,63,20,17,18,4,3,101]),function(ae,t,v,N,i,U,p,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JR=t.$IR=t.$HR=t.$GR=void 0,t.$GR={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class c extends v.$KR{constructor(n,o,e){super(n,o,e),this.a=this.B(new g({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:e.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:e.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:e.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(n){this.element=n,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(n){this.a.domNode.tabIndex=n?0:-1}}t.$HR=c;class g extends N.$GQ{constructor(n){super(),this.a=this.B(new p.$Rd),this.onChange=this.a.event,this.b=this.B(new p.$Rd),this.onKeyDown=this.b.event,this.c=n,this.s=this.c.isChecked;const o=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,o.push(...U.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&o.push(...this.c.actionClassName.split(" ")),this.s&&o.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...o),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,e=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),e.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this.s,this.a.fire(!0),e.preventDefault(),e.stopPropagation();return}this.b.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(n){this.s=n,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(n){this.g&&this.domNode.classList.remove(...U.ThemeIcon.asClassNameArray(this.g)),this.g=n,this.g&&this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(n){this.domNode.title=n,this.domNode.setAttribute("aria-label",n)}}t.$IR=g;class m extends N.$GQ{constructor(n,o,e){super(),this.c=n,this.g=o,this.a=new g({title:this.c,isChecked:this.g,icon:i.$3j.check,actionClassName:"monaco-checkbox",...t.$GR}),this.domNode=this.a.domNode,this.b=e,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(n){this.a.checked=n,this.h()}focus(){this.domNode.focus()}hasFocus(){return(0,D.$FP)(this.domNode)}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.$JR=m}),define(be[129],$e([1,0,66,17,106]),function(ae,t,v,N,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ES=t.$DS=t.$CS=void 0;const U=i.localize(0,null),p=i.localize(1,null),D=i.localize(2,null);class c extends v.$IR{constructor(n){super({icon:N.$3j.caseSensitive,title:U+n.appendTitle,isChecked:n.isChecked,inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}t.$CS=c;class g extends v.$IR{constructor(n){super({icon:N.$3j.wholeWord,title:p+n.appendTitle,isChecked:n.isChecked,inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}t.$DS=g;class m extends v.$IR{constructor(n){super({icon:N.$3j.regex,title:D+n.appendTitle,isChecked:n.isChecked,inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}t.$ES=m}),define(be[130],$e([1,0,3,129,65,20,4,105,2,95]),function(ae,t,v,N,i,U,p,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FS=void 0;const g=D.localize(0,null);class m extends U.$GQ{static{this.OPTION_CHANGE="optionChange"}constructor(n,o,e){super(),this.n=!0,this.s=!1,this.w=this.B(new c.$Sc),this.N=[],this.O=this.B(new p.$Rd),this.onDidOptionChange=this.O.event,this.P=this.B(new p.$Rd),this.onKeyDown=this.P.event,this.Q=this.B(new p.$Rd),this.onMouseDown=this.Q.event,this.R=this.B(new p.$Rd),this.onInput=this.R.event,this.S=this.B(new p.$Rd),this.onKeyUp=this.S.event,this.U=this.B(new p.$Rd),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new p.$Rd),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||g,this.h=!!e.showCommonFindToggles;const h=e.appendCaseSensitiveLabel||"",a=e.appendWholeWordsLabel||"",f=e.appendRegexLabel||"",s=e.history||[],r=!!e.flexibleHeight,b=!!e.flexibleWidth,u=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.$rS(this.domNode,o,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:s,showHistoryHint:e.showHistoryHint,flexibleHeight:r,flexibleWidth:b,flexibleMaxHeight:u,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new N.$ES({appendTitle:f,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(F=>{this.W.fire(F)})),this.L=this.B(new N.$DS({appendTitle:a,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new N.$CS({appendTitle:h,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(F=>{this.U.fire(F)}));const l=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,F=>{if(F.equals(15)||F.equals(17)||F.equals(9)){const z=l.indexOf(this.domNode.ownerDocument.activeElement);if(z>=0){let L=-1;F.equals(17)?L=(z+1)%l.length:F.equals(15)&&(z===0?L=l.length-1:L=z-1),F.equals(9)?(l[z].blur(),this.inputBox.focus()):L>=0&&l[L].focus(),v.$1P.stop(F,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),n?.appendChild(this.domNode),this.B(v.$5O(this.inputBox.inputElement,"compositionstart",l=>{this.s=!0})),this.B(v.$5O(this.inputBox.inputElement,"compositionend",l=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,l=>this.P.fire(l)),this.C(this.inputBox.inputElement,l=>this.S.fire(l)),this.D(this.inputBox.inputElement,l=>this.R.fire()),this.j(this.inputBox.inputElement,l=>this.Q.fire(l))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(n){this.inputBox.layout(),this.X(n.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const n of this.N)n.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const n of this.N)n.disable()}setFocusInputOnOptionClick(n){this.n=n}setEnabled(n){n?this.enable():this.disable()}setAdditionalToggles(n){for(const o of this.N)o.domNode.remove();this.N=[],this.w.value=new c.$Qc;for(const o of n??[])this.w.value.add(o),this.y.appendChild(o.domNode),this.w.value.add(o.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(o);this.N.length>0&&(this.y.style.display=""),this.X()}X(n=!1){n?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((o,e)=>o+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(n){this.inputBox.value!==n&&(this.inputBox.value=n)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(n){this.M&&(this.M.checked=n)}getWholeWords(){return this.L?.checked??!1}setWholeWords(n){this.L&&(this.L.checked=n)}getRegex(){return this.J?.checked??!1}setRegex(n){this.J&&(this.J.checked=n,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(n){this.inputBox.showMessage(n)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$FS=m}),define(be[131],$e([1,0,3,22,14,64,130,65,61,39,66,58,25,36,12,9,17,18,32,4,34,2,46,7,110,102]),function(ae,t,v,N,i,U,p,D,c,g,m,T,n,o,e,h,a,f,s,r,b,u,l,F,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dT=t.TreeFindMatchType=t.TreeFindMode=t.$cT=t.$bT=t.RenderIndentGuides=t.$aT=t.$_S=void 0;class L extends c.$hR{set context($){this.c.context=$}get context(){return this.c.context}constructor($){super($.elements.map(W=>W.element)),this.c=$}}function d(_){return _ instanceof c.$hR?new L(_):_}class y{constructor($,W){this.d=$,this.f=W,this.b=u.$Rc.None,this.c=new u.$Qc}getDragURI($){return this.f.getDragURI($.element)}getDragLabel($,W){if(this.f.getDragLabel)return this.f.getDragLabel($.map(Q=>Q.element),W)}onDragStart($,W){this.f.onDragStart?.(d($),W)}onDragOver($,W,Q,w,A=!0){const E=this.f.onDragOver(d($),W&&W.element,Q,w),I=this.a!==W;if(I&&(this.b.dispose(),this.a=W),typeof W>"u")return E;if(I&&typeof E!="boolean"&&E.autoExpand&&(this.b=(0,h.$2g)(()=>{const H=this.d(),G=H.getNodeLocation(W);H.isCollapsed(G)&&H.setCollapsed(G,!1),this.a=void 0},500,this.c)),typeof E=="boolean"||!E.accept||typeof E.bubble>"u"||E.feedback){if(!A){const H=typeof E=="boolean"?E:E.accept,G=typeof E=="boolean"?void 0:E.effect;return{accept:H,effect:G,feedback:[Q]}}return E}if(E.bubble===1){const H=this.d(),G=H.getNodeLocation(W),ee=H.getParentNodeLocation(G),se=H.getNode(ee),me=ee&&H.getListIndex(ee);return this.onDragOver($,se,me,w,!1)}const k=this.d(),O=k.getNodeLocation(W),S=k.getListIndex(O),P=k.getListRenderCount(O);return{...E,feedback:(0,e.$Rb)(S,S+P)}}drop($,W,Q,w){this.b.dispose(),this.a=void 0,this.f.drop(d($),W&&W.element,Q,w)}onDragEnd($){this.f.onDragEnd?.($)}dispose(){this.c.dispose(),this.f.dispose()}}function M(_,$){return $&&{...$,identityProvider:$.identityProvider&&{getId(W){return $.identityProvider.getId(W.element)}},dnd:$.dnd&&new y(_,$.dnd),multipleSelectionController:$.multipleSelectionController&&{isSelectionSingleChangeEvent(W){return $.multipleSelectionController.isSelectionSingleChangeEvent({...W,element:W.element})},isSelectionRangeChangeEvent(W){return $.multipleSelectionController.isSelectionRangeChangeEvent({...W,element:W.element})}},accessibilityProvider:$.accessibilityProvider&&{...$.accessibilityProvider,getSetSize(W){const Q=_(),w=Q.getNodeLocation(W),A=Q.getParentNodeLocation(w);return Q.getNode(A).visibleChildrenCount},getPosInSet(W){return W.visibleChildIndex+1},isChecked:$.accessibilityProvider&&$.accessibilityProvider.isChecked?W=>$.accessibilityProvider.isChecked(W.element):void 0,getRole:$.accessibilityProvider&&$.accessibilityProvider.getRole?W=>$.accessibilityProvider.getRole(W.element):()=>"treeitem",getAriaLabel(W){return $.accessibilityProvider.getAriaLabel(W.element)},getWidgetAriaLabel(){return $.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:$.accessibilityProvider&&$.accessibilityProvider.getWidgetRole?()=>$.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:$.accessibilityProvider&&$.accessibilityProvider.getAriaLevel?W=>$.accessibilityProvider.getAriaLevel(W.element):W=>W.depth,getActiveDescendantId:$.accessibilityProvider.getActiveDescendantId&&(W=>$.accessibilityProvider.getActiveDescendantId(W.element))},keyboardNavigationLabelProvider:$.keyboardNavigationLabelProvider&&{...$.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(W){return $.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(W.element)}}}}class V{constructor($){this.a=$}getHeight($){return this.a.getHeight($.element)}getTemplateId($){return this.a.getTemplateId($.element)}hasDynamicHeight($){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight($.element)}setDynamicHeight($,W){this.a.setDynamicHeight?.($.element,W)}}t.$_S=V;class x{static lift($){return $ instanceof x?$:new x($)}static empty($=0){return new x({focus:[],selection:[],expanded:Object.create(null),scrollTop:$})}constructor($){if(this.focus=new Set($.focus),this.selection=new Set($.selection),$.expanded instanceof Array){this.expanded=Object.create(null);for(const W of $.expanded)this.expanded[W]=1}else this.expanded=$.expanded;this.expanded=$.expanded,this.scrollTop=$.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$aT=x;var R;(function(_){_.None="none",_.OnHover="onHover",_.Always="always"})(R||(t.RenderIndentGuides=R={}));class B{get elements(){return this.b}constructor($,W=[]){this.b=W,this.a=new u.$Qc,this.onDidChange=r.Event.forEach($,Q=>this.b=Q,this.a)}dispose(){this.a.dispose()}}class j{static{this.a=8}constructor($,W,Q,w,A,E={}){this.o=$,this.p=W,this.q=w,this.s=A,this.b=new Map,this.c=new Map,this.d=j.a,this.f=!1,this.g=!1,this.j=new Set,this.k=u.$Rc.None,this.m=new u.$Qc,this.templateId=$.templateId,this.updateOptions(E),r.Event.map(Q,I=>I.node)(this.u,this,this.m),$.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions($={}){if(typeof $.indent<"u"){const W=(0,l.$Wl)($.indent,0,40);if(W!==this.d){this.d=W;for(const[Q,w]of this.c)this.v(Q,w)}}if(typeof $.renderIndentGuides<"u"){const W=$.renderIndentGuides!==R.None;if(W!==this.g){this.g=W;for(const[Q,w]of this.c)this.w(Q,w);if(this.k.dispose(),W){const Q=new u.$Qc;this.q.onDidChange(this.x,this,Q),this.k=Q,this.x(this.q.elements)}}}typeof $.hideTwistiesOfChildlessElements<"u"&&(this.f=$.hideTwistiesOfChildlessElements)}renderTemplate($){const W=(0,v.$6P)($,(0,v.$)(".monaco-tl-row")),Q=(0,v.$6P)(W,(0,v.$)(".monaco-tl-indent")),w=(0,v.$6P)(W,(0,v.$)(".monaco-tl-twistie")),A=(0,v.$6P)(W,(0,v.$)(".monaco-tl-contents")),E=this.o.renderTemplate(A);return{container:$,indent:Q,twistie:w,indentGuidesDisposable:u.$Rc.None,templateData:E}}renderElement($,W,Q,w){this.c.set($,Q),this.b.set($.element,$),this.v($,Q),this.o.renderElement($,W,Q.templateData,w)}disposeElement($,W,Q,w){Q.indentGuidesDisposable.dispose(),this.o.disposeElement?.($,W,Q.templateData,w),typeof w=="number"&&(this.c.delete($),this.b.delete($.element))}disposeTemplate($){this.o.disposeTemplate($.templateData)}t($){const W=this.b.get($);W&&this.u(W)}u($){const W=this.c.get($);W&&(this.x(this.q.elements),this.v($,W))}v($,W){const Q=j.a+($.depth-1)*this.d;W.twistie.style.paddingLeft=`${Q}px`,W.indent.style.width=`${Q+this.d-16}px`,$.collapsible?W.container.setAttribute("aria-expanded",String(!$.collapsed)):W.container.removeAttribute("aria-expanded"),W.twistie.classList.remove(...f.ThemeIcon.asClassNameArray(a.$3j.treeItemExpanded));let w=!1;this.o.renderTwistie&&(w=this.o.renderTwistie($.element,W.twistie)),$.collapsible&&(!this.f||$.visibleChildrenCount>0)?(w||W.twistie.classList.add(...f.ThemeIcon.asClassNameArray(a.$3j.treeItemExpanded)),W.twistie.classList.add("collapsible"),W.twistie.classList.toggle("collapsed",$.collapsed)):W.twistie.classList.remove("collapsible","collapsed"),this.w($,W)}w($,W){if((0,v.$4O)(W.indent),W.indentGuidesDisposable.dispose(),!this.g)return;const Q=new u.$Qc,w=this.p();for(;;){const A=w.getNodeLocation($),E=w.getParentNodeLocation(A);if(!E)break;const I=w.getNode(E),k=(0,v.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(I)&&k.classList.add("active"),W.indent.childElementCount===0?W.indent.appendChild(k):W.indent.insertBefore(k,W.indent.firstElementChild),this.s.add(I,k),Q.add((0,u.$Pc)(()=>this.s.delete(I,k))),$=I}W.indentGuidesDisposable=Q}x($){if(!this.g)return;const W=new Set,Q=this.p();$.forEach(w=>{const A=Q.getNodeLocation(w);try{const E=Q.getParentNodeLocation(A);w.collapsible&&w.children.length>0&&!w.collapsed?W.add(w):E&&W.add(Q.getNode(E))}catch{}}),this.j.forEach(w=>{W.has(w)||this.s.forEach(w,A=>A.classList.remove("active"))}),W.forEach(w=>{this.j.has(w)||this.s.forEach(w,A=>A.classList.add("active"))}),this.j=W}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,u.$Mc)(this.m)}}class ie{get totalCount(){return this.a}get matchCount(){return this.b}set pattern($){this.c=$,this.d=$.toLowerCase()}constructor($,W,Q){this.g=$,this.j=W,this.k=Q,this.a=0,this.b=0,this.c="",this.d="",this.f=new u.$Qc,$.onWillRefilter(this.m,this,this.f)}filter($,W){let Q=1;if(this.k){const E=this.k.filter($,W);if(typeof E=="boolean"?Q=E?1:0:(0,T.$9S)(E)?Q=(0,T.$0S)(E.visibility):Q=E,Q===0)return!1}if(this.a++,!this.c)return this.b++,{data:b.FuzzyScore.Default,visibility:Q};const w=this.j.getKeyboardNavigationLabel($),A=Array.isArray(w)?w:[w];for(const E of A){const I=E&&E.toString();if(typeof I>"u")return{data:b.FuzzyScore.Default,visibility:Q};let k;if(this.g.findMatchType===we.Contiguous){const O=I.toLowerCase().indexOf(this.d);if(O>-1){k=[Number.MAX_SAFE_INTEGER,0];for(let S=this.d.length;S>0;S--)k.push(O+S-1)}}else k=(0,b.$Xj)(this.c,this.d,0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(k)return this.b++,A.length===1?{data:k,visibility:Q}:{data:{label:I,score:k},visibility:Q}}return this.g.findMode===oe.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility($):2:{data:b.FuzzyScore.Default,visibility:Q}}m(){this.a=0,this.b=0}dispose(){(0,u.$Mc)(this.f)}}class te extends m.$IR{constructor($){super({icon:a.$3j.listFilter,title:(0,z.localize)(0,null),isChecked:$.isChecked??!1,inputActiveOptionBorder:$.inputActiveOptionBorder,inputActiveOptionForeground:$.inputActiveOptionForeground,inputActiveOptionBackground:$.inputActiveOptionBackground})}}t.$bT=te;class ue extends m.$IR{constructor($){super({icon:a.$3j.searchFuzzy,title:(0,z.localize)(1,null),isChecked:$.isChecked??!1,inputActiveOptionBorder:$.inputActiveOptionBorder,inputActiveOptionForeground:$.inputActiveOptionForeground,inputActiveOptionBackground:$.inputActiveOptionBackground})}}t.$cT=ue;const le={inputBoxStyles:D.$pS,toggleStyles:m.$GR,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var oe;(function(_){_[_.Highlight=0]="Highlight",_[_.Filter=1]="Filter"})(oe||(t.TreeFindMode=oe={}));var we;(function(_){_[_.Fuzzy=0]="Fuzzy",_[_.Contiguous=1]="Contiguous"})(we||(t.TreeFindMatchType=we={}));class Fe extends u.$Rc{set mode($){this.b.checked=$===oe.Filter,this.f.inputBox.setPlaceHolder($===oe.Filter?(0,z.localize)(2,null):(0,z.localize)(3,null))}set matchType($){this.c.checked=$===we.Fuzzy}get value(){return this.f.inputBox.value}set value($){this.f.inputBox.value=$}constructor($,W,Q,w,A,E){super(),this.t=W,this.a=(0,v.h)(".monaco-tree-type-filter",[(0,v.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,v.h)(".monaco-tree-type-filter-input@findInput"),(0,v.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new r.$Rd,this.onDidDisable=this._onDidDisable.event,$.appendChild(this.a.root),this.B((0,u.$Pc)(()=>$.removeChild(this.a.root)));const I=E?.styles??le;I.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=I.listFilterWidgetBackground),I.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${I.listFilterWidgetShadow}`),this.b=this.B(new te({...I.toggleStyles,isChecked:w===oe.Filter})),this.c=this.B(new ue({...I.toggleStyles,isChecked:A===we.Fuzzy})),this.onDidChangeMode=r.Event.map(this.b.onChange,()=>this.b.checked?oe.Filter:oe.Highlight,this.q),this.onDidChangeMatchType=r.Event.map(this.c.onChange,()=>this.c.checked?we.Fuzzy:we.Contiguous,this.q),this.f=this.B(new p.$FS(this.a.findInput,Q,{label:(0,z.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:I.inputBoxStyles,toggleStyles:I.toggleStyles,history:E?.history})),this.g=this.B(new U.$YQ(this.a.actionbar)),this.mode=w;const k=this.B(new N.$7Q(this.f.inputBox.inputElement,"keydown")),O=r.Event.chain(k.event,G=>G.map(ee=>new i.$2O(ee)));this.B(O(G=>{if(G.equals(3)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(G.equals(18)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(G.equals(16)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const S=this.B(new o.$Ci("close",(0,z.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(S,{icon:!0,label:!1});const P=this.B(new N.$7Q(this.a.grab,"mousedown"));this.B(P.event(G=>{const ee=new u.$Qc,se=ee.add(new N.$7Q((0,v.$LP)(G),"mousemove")),me=ee.add(new N.$7Q((0,v.$LP)(G),"mouseup")),ve=this.m,Ne=G.pageX,Ce=this.s,De=G.pageY;this.a.grab.classList.add("grabbing");const Te=this.a.root.style.transition;this.a.root.style.transition="unset";const Se=Ve=>{const je=Ve.pageX-Ne;this.m=ve-je;const Me=Ve.pageY-De;this.s=Ce+Me,this.layout()};ee.add(se.event(Se)),ee.add(me.event(Ve=>{Se(Ve),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Te,ee.dispose()}))}));const H=r.Event.chain(this.B(new N.$7Q(this.a.grab,"keydown")).event,G=>G.map(ee=>new i.$2O(ee)));this.B(H(G=>{let ee,se;if(G.keyCode===15?ee=Number.POSITIVE_INFINITY:G.keyCode===17?ee=0:G.keyCode===10&&(ee=this.m===0?Number.POSITIVE_INFINITY:0),G.keyCode===16?se=0:G.keyCode===18&&(se=Number.POSITIVE_INFINITY),ee!==void 0&&(G.preventDefault(),G.stopPropagation(),this.m=ee,this.layout()),se!==void 0){G.preventDefault(),G.stopPropagation(),this.s=se;const me=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=me},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout($=this.j){this.j=$,this.m=(0,l.$Wl)(this.m,0,Math.max(0,$-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,l.$Wl)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage($){this.f.showMessage($)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,h.$1g)(300),super.dispose()}}class ke{get pattern(){return this.b}get mode(){return this.d}set mode($){$!==this.d&&(this.d=$,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire($))}get matchType(){return this.f}set matchType($){$!==this.f&&(this.f=$,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire($))}constructor($,W,Q,w,A,E={}){this.t=$,this.u=Q,this.v=w,this.w=A,this.x=E,this.b="",this.c="",this.j=0,this.k=new r.$Rd,this.onDidChangeMode=this.k.event,this.m=new r.$Rd,this.onDidChangeMatchType=this.m.event,this.o=new r.$Rd,this.onDidChangePattern=this.o.event,this.p=new r.$Rd,this.onDidChangeOpenState=this.p.event,this.q=new u.$Qc,this.s=new u.$Qc,this.d=$.options.defaultFindMode??oe.Highlight,this.f=$.options.defaultFindMatchType??we.Fuzzy,W.onDidSplice(this.z,this,this.s)}updateOptions($={}){$.defaultFindMode!==void 0&&(this.mode=$.defaultFindMode),$.defaultFindMatchType!==void 0&&(this.matchType=$.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Fe(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode($=>this.mode=$,void 0,this.q),this.g.onDidChangeMatchType($=>this.matchType=$,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y($){this.b=$,this.o.fire($),this.v.pattern=$,this.t.refilter(),$&&this.t.focusNext(0,!0,void 0,Q=>!b.FuzzyScore.isDefault(Q.filterData));const W=this.t.getFocus();if(W.length>0){const Q=W[0];this.t.getRelativeTop(Q)===null&&this.t.reveal(Q,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const $=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&$?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,z.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus($){return!this.g||!this.pattern||this.d===oe.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!b.FuzzyScore.isDefault($.filterData)}layout($){this.j=$,this.g?.layout($)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Le(_){let $=n.TreeMouseEventTarget.Unknown;return(0,v.$AP)(_.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?$=n.TreeMouseEventTarget.Twistie:(0,v.$AP)(_.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?$=n.TreeMouseEventTarget.Element:(0,v.$AP)(_.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&($=n.TreeMouseEventTarget.Filter),{browserEvent:_.browserEvent,element:_.element?_.element.element:null,target:$}}function de(_){return{element:_.element?_.element.element:null,browserEvent:_.browserEvent,anchor:_.anchor}}function ne(_,$){$(_),_.children.forEach(W=>ne(W,$))}class ce{get f(){return this.d||(this.d=this.m()),this.d}constructor($,W){this.g=$,this.j=W,this.a=[],this.c=new r.$Rd,this.onDidChange=this.c.event}set($,W){!W?.__forceEvent&&(0,e.$tb)(this.a,$)||this.k($,!1,W)}k($,W,Q){if(this.a=[...$],this.b=void 0,this.d=void 0,!W){const w=this;this.c.fire({get elements(){return w.get()},browserEvent:Q})}}get(){return this.b||(this.b=this.a.map($=>$.element)),[...this.b]}getNodes(){return this.a}has($){return this.f.has($)}onDidModelSplice({insertedNodes:$,deletedNodes:W}){if(!this.j){const k=this.m(),O=S=>k.delete(S);W.forEach(S=>ne(S,O)),this.set([...k.values()]);return}const Q=new Set,w=k=>Q.add(this.j.getId(k.element).toString());W.forEach(k=>ne(k,w));const A=new Map,E=k=>A.set(this.j.getId(k.element).toString(),k);$.forEach(k=>ne(k,E));const I=[];for(const k of this.a){const O=this.j.getId(k.element).toString();if(!Q.has(O))I.push(k);else{const P=A.get(O);P&&P.visible&&I.push(P)}}if(this.a.length>0&&I.length===0){const k=this.g();k&&I.push(k)}this.k(I,!0)}m(){const $=new Set;for(const W of this.a)$.add(W);return $}}class Z extends g.$rR{constructor($,W){super($),this.x=W}u($){if((0,g.$nR)($.browserEvent.target)||(0,g.$lR)($.browserEvent.target)||(0,g.$mR)($.browserEvent.target)||$.browserEvent.isHandledByList)return;const W=$.element;if(!W)return super.u($);if(this.p($)||this.o($))return super.u($);const Q=$.browserEvent.target,w=Q.classList.contains("monaco-tl-twistie")||Q.classList.contains("monaco-icon-label")&&Q.classList.contains("folder-icon")&&$.browserEvent.offsetX<16;let A=!1;if(typeof this.x.expandOnlyOnTwistieClick=="function"?A=this.x.expandOnlyOnTwistieClick(W.element):A=!!this.x.expandOnlyOnTwistieClick,A&&!w&&$.browserEvent.detail!==2)return super.u($);if(!this.x.expandOnDoubleClick&&$.browserEvent.detail===2)return super.u($);if(W.collapsible){const E=this.x.getNodeLocation(W),I=$.browserEvent.altKey;if(this.x.setFocus([E]),this.x.toggleCollapsed(E,I),A&&w){$.browserEvent.isHandledByList=!0;return}}super.u($)}v($){$.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||$.browserEvent.isHandledByList||super.v($)}}class q extends g.$uR{constructor($,W,Q,w,A,E,I,k){super($,W,Q,w,k),this.p=A,this.s=E,this.K=I}D($){return new Z(this,$.tree)}splice($,W,Q=[]){if(super.splice($,W,Q),Q.length===0)return;const w=[],A=[];let E;Q.forEach((I,k)=>{this.p.has(I)&&w.push($+k),this.s.has(I)&&A.push($+k),this.K.has(I)&&(E=$+k)}),w.length>0&&super.setFocus((0,e.$Lb)([...super.getFocus(),...w])),A.length>0&&super.setSelection((0,e.$Lb)([...super.getSelection(),...A])),typeof E=="number"&&super.setAnchor(E)}setFocus($,W,Q=!1){super.setFocus($,W),Q||this.p.set($.map(w=>this.element(w)),W)}setSelection($,W,Q=!1){super.setSelection($,W),Q||this.s.set($.map(w=>this.element(w)),W)}setAnchor($,W=!1){super.setAnchor($),W||(typeof $>"u"?this.K.set([]):this.K.set([this.element($)]))}}class X{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return r.Event.map(this.j.onMouseClick,Le)}get onMouseDblClick(){return r.Event.filter(r.Event.map(this.j.onMouseDblClick,Le),$=>$.target!==n.TreeMouseEventTarget.Filter)}get onContextMenu(){return r.Event.map(this.j.onContextMenu,de)}get onTap(){return r.Event.map(this.j.onTap,Le)}get onPointer(){return r.Event.map(this.j.onPointer,Le)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return r.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??oe.Highlight}set findMode($){this.x&&(this.x.mode=$)}get findMatchType(){return this.x?.matchType??we.Fuzzy}set findMatchType($){this.x&&(this.x.matchType=$)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:r.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor($,W,Q,w,A={}){this.D=$,this.E=A,this.w=new r.$Zd,this.onDidChangeFindOpenState=r.Event.None,this.A=new u.$Qc,this.B=new r.$Rd,this.onWillRefilter=this.B.event,this.C=new r.$Rd,this.onDidUpdateOptions=this.C.event;const E=new V(Q),I=new r.$1d,k=new r.$1d,O=this.A.add(new B(k.event)),S=new s.$Fc;this.k=w.map(se=>new j(se,()=>this.o,I.event,O,S,A));for(const se of this.k)this.A.add(se);let P;A.keyboardNavigationLabelProvider&&(P=new ie(this,A.keyboardNavigationLabelProvider,A.filter),A={...A,filter:P},this.A.add(P)),this.p=new ce(()=>this.j.getFocusedElements()[0],A.identityProvider),this.q=new ce(()=>this.j.getSelectedElements()[0],A.identityProvider),this.u=new ce(()=>this.j.getAnchorElement(),A.identityProvider),this.j=new q($,W,E,this.k,this.p,this.q,this.u,{...M(()=>this.o,A),tree:this}),this.o=this.I($,this.j,A),I.input=this.o.onDidChangeCollapseState;const H=r.Event.forEach(this.o.onDidSplice,se=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(se),this.q.onDidModelSplice(se)})},this.A);H(()=>null,null,this.A);const G=this.A.add(new r.$Rd),ee=this.A.add(new h.$Wg(0));if(this.A.add(r.Event.any(H,this.p.onDidChange,this.q.onDidChange)(()=>{ee.trigger(()=>{const se=new Set;for(const me of this.p.getNodes())se.add(me);for(const me of this.q.getNodes())se.add(me);G.fire([...se.values()])})})),k.input=G.event,A.keyboardSupport!==!1){const se=r.Event.chain(this.j.onKeyDown,me=>me.filter(ve=>!(0,g.$lR)(ve.target)).map(ve=>new i.$2O(ve)));r.Event.chain(se,me=>me.filter(ve=>ve.keyCode===15))(this.F,this,this.A),r.Event.chain(se,me=>me.filter(ve=>ve.keyCode===17))(this.G,this,this.A),r.Event.chain(se,me=>me.filter(ve=>ve.keyCode===10))(this.H,this,this.A)}if((A.findWidgetEnabled??!0)&&A.keyboardNavigationLabelProvider&&A.contextViewProvider){const se=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new ke(this,this.o,this.j,P,A.contextViewProvider,se),this.y=me=>this.x.shouldAllowFocus(me),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=r.Event.None,this.onDidChangeFindMatchType=r.Event.None;this.z=(0,v.$OP)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===R.Always)}updateOptions($={}){this.E={...this.E,...$};for(const W of this.k)W.updateOptions($);this.j.updateOptions(this.E),this.x?.updateOptions($),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===R.Always)}get options(){return this.E}updateWidth($){const W=this.o.getListIndex($);W!==-1&&this.j.updateWidth(W)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop($){this.j.scrollTop=$}get scrollLeft(){return this.j.scrollLeft}set scrollLeft($){this.j.scrollLeft=$}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const $=this.j.firstVisibleIndex;return $<0||$>=this.j.length?void 0:this.j.element($).element}get lastVisibleElement(){const $=this.j.lastVisibleIndex;return this.j.element($).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel($){this.j.ariaLabel=$}get selectionSize(){return this.q.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return(0,v.$FP)(this.getHTMLElement())}layout($,W){this.j.layout($,W),(0,F.$Gf)(W)&&this.x?.layout(W)}style($){const W=`.${this.j.domId}`,Q=[];$.treeIndentGuidesStroke&&(Q.push(`.monaco-list${W}:hover .monaco-tl-indent > .indent-guide, .monaco-list${W}.always .monaco-tl-indent > .indent-guide  { border-color: ${$.treeInactiveIndentGuidesStroke}; }`),Q.push(`.monaco-list${W} .monaco-tl-indent > .indent-guide.active { border-color: ${$.treeIndentGuidesStroke}; }`)),this.z.textContent=Q.join(`
`),this.j.style($)}getParentElement($){const W=this.o.getParentNodeLocation($);return this.o.getNode(W).element}getFirstElementChild($){return this.o.getFirstElementChild($)}getNode($){return this.o.getNode($)}getNodeLocation($){return this.o.getNodeLocation($)}collapse($,W=!1){return this.o.setCollapsed($,!0,W)}expand($,W=!1){return this.o.setCollapsed($,!1,W)}toggleCollapsed($,W=!1){return this.o.setCollapsed($,void 0,W)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible($){return this.o.isCollapsible($)}setCollapsible($,W){return this.o.setCollapsible($,W)}isCollapsed($){return this.o.isCollapsed($)}expandTo($){this.o.expandTo($)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor($){if(typeof $>"u")return this.j.setAnchor(void 0);const W=this.o.getNode($);this.u.set([W]);const Q=this.o.getListIndex($);Q>-1&&this.j.setAnchor(Q,!0)}getAnchor(){return(0,e.$Nb)(this.u.get(),void 0)}setSelection($,W){const Q=$.map(A=>this.o.getNode(A));this.q.set(Q,W);const w=$.map(A=>this.o.getListIndex(A)).filter(A=>A>-1);this.j.setSelection(w,W,!0)}getSelection(){return this.q.get()}setFocus($,W){const Q=$.map(A=>this.o.getNode(A));this.p.set(Q,W);const w=$.map(A=>this.o.getListIndex(A)).filter(A=>A>-1);this.j.setFocus(w,W,!0)}focusNext($=1,W=!1,Q,w=this.y){this.j.focusNext($,W,Q,w)}focusPrevious($=1,W=!1,Q,w=this.y){this.j.focusPrevious($,W,Q,w)}focusNextPage($,W=this.y){return this.j.focusNextPage($,W)}focusPreviousPage($,W=this.y){return this.j.focusPreviousPage($,W)}focusLast($,W=this.y){this.j.focusLast($,W)}focusFirst($,W=this.y){this.j.focusFirst($,W)}getFocus(){return this.p.get()}reveal($,W){this.o.expandTo($);const Q=this.o.getListIndex($);Q!==-1&&this.j.reveal(Q,W)}getRelativeTop($){const W=this.o.getListIndex($);return W===-1?null:this.j.getRelativeTop(W)}getViewState($=this.options.identityProvider){if(!$)throw new n.$7S(this.D,"Can't get tree view state without an identity provider");const W=E=>$.getId(E).toString(),Q=x.empty(this.scrollTop);for(const E of this.getFocus())Q.focus.add(W(E));for(const E of this.getSelection())Q.selection.add(W(E));const w=this.o.getNode(),A=[w];for(;A.length>0;){const E=A.shift();E!==w&&E.collapsible&&(Q.expanded[W(E.element)]=E.collapsed?0:1),A.push(...E.children)}return Q}F($){$.preventDefault(),$.stopPropagation();const W=this.j.getFocusedElements();if(W.length===0)return;const Q=W[0],w=this.o.getNodeLocation(Q);if(!this.o.setCollapsed(w,!0)){const E=this.o.getParentNodeLocation(w);if(!E)return;const I=this.o.getListIndex(E);this.j.reveal(I),this.j.setFocus([I])}}G($){$.preventDefault(),$.stopPropagation();const W=this.j.getFocusedElements();if(W.length===0)return;const Q=W[0],w=this.o.getNodeLocation(Q);if(!this.o.setCollapsed(w,!1)){if(!Q.children.some(k=>k.visible))return;const[E]=this.j.getFocus(),I=E+1;this.j.reveal(I),this.j.setFocus([I])}}H($){$.preventDefault(),$.stopPropagation();const W=this.j.getFocusedElements();if(W.length===0)return;const Q=W[0],w=this.o.getNodeLocation(Q),A=$.browserEvent.altKey;this.o.setCollapsed(w,void 0,A)}navigate($){return new C(this.j,this.o,$)}dispose(){(0,u.$Mc)(this.A),this.j.dispose()}}t.$dT=X;class C{constructor($,W,Q){this.b=$,this.c=W,Q?this.a=this.c.getListIndex(Q):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[132],$e([1,0,131,122,25,27]),function(ae,t,v,N,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oT=void 0;class p extends v.$dT{constructor(c,g,m,T,n,o={}){super(c,g,m,T,o),this.f=c,this.g=n,this.d=new Map,this.c=o.identityProvider}getInput(){return this.b}setInput(c,g){if(g&&!this.c)throw new i.$7S(this.f,"Can't restore tree view state without an identity provider");if(this.b=c,!c){this.d.clear(),this.o.setChildren(null,U.Iterable.empty());return}if(!g){this.m(c);return}const m=[],T=[],n=e=>{const h=this.c.getId(e).toString();return!g.expanded[h]},o=e=>{const h=this.c.getId(e.element).toString();g.focus.has(h)&&m.push(e.element),g.selection.has(h)&&T.push(e.element)};this.m(c,n,o),this.setFocus(m),this.setSelection(T),g&&typeof g.scrollTop=="number"&&(this.scrollTop=g.scrollTop)}updateChildren(c=this.b){if(typeof this.b>"u")throw new i.$7S(this.f,"Tree input not set");let g;this.c&&(g=m=>{const T=this.c.getId(m).toString(),n=this.d.get(T);if(n)return n.collapsed}),this.m(c,g)}resort(c=this.b,g=!0){this.o.resort(c===this.b?null:c,g)}refresh(c){if(c===void 0){this.j.rerender();return}this.o.rerender(c)}m(c,g,m){let T;if(this.c){const n=new Set,o=m;m=e=>{const h=this.c.getId(e.element).toString();n.add(h),this.d.set(h,e),o?.(e)},T=e=>{const h=this.c.getId(e.element).toString();n.has(h)||this.d.delete(h)}}this.o.setChildren(c===this.b?null:c,this.s(c,g).elements,{onDidCreateNode:m,onDidDeleteNode:T})}s(c,g){const m=[...this.g.getChildren(c)];return{elements:U.Iterable.map(m,n=>{const{elements:o,size:e}=this.s(n,g),h=this.g.hasChildren?this.g.hasChildren(n):void 0,a=e===0?void 0:g&&g(n);return{element:n,children:o,collapsible:h,collapsed:a}}),size:m.length}}I(c,g,m){return new N.$eT(c,g,m)}}t.$oT=p}),define(be[67],$e([1,0,12,9,33,29,26,6,4,2,53,10,7]),function(ae,t,v,N,i,U,p,D,c,g,m,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gh=t.ProxyChannel=t.$Fh=t.$Eh=t.$Dh=t.$Ch=t.$Bh=t.$Ah=t.RequestInitiator=t.$zh=t.$yh=t.$xh=t.$wh=t.$vh=void 0;var o;(function(de){de[de.Promise=100]="Promise",de[de.PromiseCancel=101]="PromiseCancel",de[de.EventListen=102]="EventListen",de[de.EventDispose=103]="EventDispose"})(o||(o={}));function e(de){switch(de){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(de){de[de.Initialize=200]="Initialize",de[de.PromiseSuccess=201]="PromiseSuccess",de[de.PromiseError=202]="PromiseError",de[de.PromiseErrorObj=203]="PromiseErrorObj",de[de.EventFire=204]="EventFire"})(h||(h={}));function a(de){switch(de){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(de){de[de.Uninitialized=0]="Uninitialized",de[de.Idle=1]="Idle"})(f||(f={}));function s(de){let ne=0;for(let ce=0;;ce+=7){const Z=de.read(1);if(ne|=(Z.buffer[0]&127)<<ce,!(Z.buffer[0]&128))return ne}}const r=z(0);function b(de,ne){if(ne===0){de.write(r);return}let ce=0;for(let q=ne;q!==0;q=q>>>7)ce++;const Z=i.$fe.alloc(ce);for(let q=0;ne!==0;q++)Z.buffer[q]=ne&127,ne=ne>>>7,ne>0&&(Z.buffer[q]|=128);de.write(Z)}class u{constructor(ne){this.b=ne,this.a=0}read(ne){const ce=this.b.slice(this.a,this.a+ne);return this.a+=ce.byteLength,ce}}t.$vh=u;class l{constructor(){this.a=[]}get buffer(){return i.$fe.concat(this.a)}write(ne){this.a.push(ne)}}t.$wh=l;var F;(function(de){de[de.Undefined=0]="Undefined",de[de.String=1]="String",de[de.Buffer=2]="Buffer",de[de.VSBuffer=3]="VSBuffer",de[de.Array=4]="Array",de[de.Object=5]="Object",de[de.Int=6]="Int"})(F||(F={}));function z(de){const ne=i.$fe.alloc(1);return ne.writeUInt8(de,0),ne}const L={Undefined:z(F.Undefined),String:z(F.String),Buffer:z(F.Buffer),VSBuffer:z(F.VSBuffer),Array:z(F.Array),Object:z(F.Object),Uint:z(F.Int)},d=typeof Buffer<"u";function y(de,ne){if(typeof ne>"u")de.write(L.Undefined);else if(typeof ne=="string"){const ce=i.$fe.fromString(ne);de.write(L.String),b(de,ce.byteLength),de.write(ce)}else if(d&&Buffer.isBuffer(ne)){const ce=i.$fe.wrap(ne);de.write(L.Buffer),b(de,ce.byteLength),de.write(ce)}else if(ne instanceof i.$fe)de.write(L.VSBuffer),b(de,ne.byteLength),de.write(ne);else if(Array.isArray(ne)){de.write(L.Array),b(de,ne.length);for(const ce of ne)y(de,ce)}else if(typeof ne=="number"&&(ne|0)===ne)de.write(L.Uint),b(de,ne);else{const ce=i.$fe.fromString(JSON.stringify(ne));de.write(L.Object),b(de,ce.byteLength),de.write(ce)}}t.$xh=y;function M(de){switch(de.read(1).readUInt8(0)){case F.Undefined:return;case F.String:return de.read(s(de)).toString();case F.Buffer:return de.read(s(de)).buffer;case F.VSBuffer:return de.read(s(de));case F.Array:{const ce=s(de),Z=[];for(let q=0;q<ce;q++)Z.push(M(de));return Z}case F.Object:return JSON.parse(de.read(s(de)).toString());case F.Int:return s(de)}}t.$yh=M;class V{constructor(ne,ce,Z=null,q=1e3){this.h=ne,this.j=ce,this.k=Z,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.q(X)),this.m({type:200})}registerChannel(ne,ce){this.b.set(ne,ce),setTimeout(()=>this.w(ne),0)}m(ne){switch(ne.type){case 200:{const ce=this.o([ne.type]);this.k?.logOutgoing(ce,0,1,a(ne.type));return}case 201:case 202:case 204:case 203:{const ce=this.o([ne.type,ne.id],ne.data);this.k?.logOutgoing(ce,ne.id,1,a(ne.type),ne.data);return}}}o(ne,ce=void 0){const Z=new l;return y(Z,ne),y(Z,ce),this.p(Z.buffer)}p(ne){try{return this.h.send(ne),ne.byteLength}catch{return 0}}q(ne){const ce=new u(ne),Z=M(ce),q=M(ce),X=Z[0];switch(X){case 100:return this.k?.logIncoming(ne.byteLength,Z[1],1,`${e(X)}: ${Z[2]}.${Z[3]}`,q),this.s({type:X,id:Z[1],channelName:Z[2],name:Z[3],arg:q});case 102:return this.k?.logIncoming(ne.byteLength,Z[1],1,`${e(X)}: ${Z[2]}.${Z[3]}`,q),this.t({type:X,id:Z[1],channelName:Z[2],name:Z[3],arg:q});case 101:return this.k?.logIncoming(ne.byteLength,Z[1],1,`${e(X)}`),this.u({type:X,id:Z[1]});case 103:return this.k?.logIncoming(ne.byteLength,Z[1],1,`${e(X)}`),this.u({type:X,id:Z[1]})}}s(ne){const ce=this.b.get(ne.channelName);if(!ce){this.v(ne);return}const Z=new U.$2d;let q;try{q=ce.call(this.j,ne.name,ne.arg,Z.token)}catch(_){q=Promise.reject(_)}const X=ne.id;q.then(_=>{this.m({id:X,data:_,type:201})},_=>{_ instanceof Error?this.m({id:X,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.m({id:X,data:_,type:203})}).finally(()=>{C.dispose(),this.d.delete(ne.id)});const C=(0,g.$Pc)(()=>Z.cancel());this.d.set(ne.id,C)}t(ne){const ce=this.b.get(ne.channelName);if(!ce){this.v(ne);return}const Z=ne.id,X=ce.listen(this.j,ne.name,ne.arg)(C=>this.m({id:Z,data:C,type:204}));this.d.set(ne.id,X)}u(ne){const ce=this.d.get(ne.id);ce&&(ce.dispose(),this.d.delete(ne.id))}v(ne){let ce=this.g.get(ne.channelName);ce||(ce=[],this.g.set(ne.channelName,ce));const Z=setTimeout(()=>{console.error(`Unknown channel: ${ne.channelName}`),ne.type===100&&this.m({id:ne.id,data:{name:"Unknown channel",message:`Channel name '${ne.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ce.push({request:ne,timeoutTimer:Z})}w(ne){const ce=this.g.get(ne);if(ce){for(const Z of ce)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(ne)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}t.$zh=V;var x;(function(de){de[de.LocalSide=0]="LocalSide",de[de.OtherSide=1]="OtherSide"})(x||(t.RequestInitiator=x={}));class R{constructor(ne,ce=null){this.l=ne,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new c.$Rd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=ce}getChannel(ne){const ce=this;return{call(Z,q,X){return ce.a?Promise.reject(new D.$4):ce.m(ne,Z,q,X)},listen(Z,q){return ce.a?c.Event.None:ce.o(ne,Z,q)}}}m(ne,ce,Z,q=U.CancellationToken.None){const X=this.g++,_={id:X,type:100,channelName:ne,name:ce,arg:Z};if(q.isCancellationRequested)return Promise.reject(new D.$4);let $;return new Promise((Q,w)=>{if(q.isCancellationRequested)return w(new D.$4);const A=()=>{const O=S=>{switch(S.type){case 201:this.f.delete(X),Q(S.data);break;case 202:{this.f.delete(X);const P=new Error(S.data.message);P.stack=Array.isArray(S.data.stack)?S.data.stack.join(`
`):S.data.stack,P.name=S.data.name,w(P);break}case 203:this.f.delete(X),w(S.data);break}};this.f.set(X,O),this.p(_)};let E=null;this.b===f.Idle?A():(E=(0,N.$Ng)(O=>this.u()),E.then(()=>{E=null,A()}));const I=()=>{E?(E.cancel(),E=null):this.p({id:X,type:101}),w(new D.$4)},k=q.onCancellationRequested(I);$=(0,g.$Oc)((0,g.$Pc)(I),k),this.d.add($)}).finally(()=>{$.dispose(),this.d.delete($)})}o(ne,ce,Z){const q=this.g++,C={id:q,type:102,channelName:ne,name:ce,arg:Z};let _=null;const $=new c.$Rd({onWillAddFirstListener:()=>{_=(0,N.$Ng)(Q=>this.u()),_.then(()=>{_=null,this.d.add($),this.p(C)})},onDidRemoveLastListener:()=>{_?(_.cancel(),_=null):(this.d.delete($),this.p({id:q,type:103}))}}),W=Q=>$.fire(Q.data);return this.f.set(q,W),$.event}p(ne){switch(ne.type){case 100:case 102:{const ce=this.q([ne.type,ne.id,ne.channelName,ne.name],ne.arg);this.j?.logOutgoing(ce,ne.id,0,`${e(ne.type)}: ${ne.channelName}.${ne.name}`,ne.arg);return}case 101:case 103:{const ce=this.q([ne.type,ne.id]);this.j?.logOutgoing(ce,ne.id,0,e(ne.type));return}}}q(ne,ce=void 0){const Z=new l;return y(Z,ne),y(Z,ce),this.r(Z.buffer)}r(ne){try{return this.l.send(ne),ne.byteLength}catch{return 0}}s(ne){const ce=new u(ne),Z=M(ce),q=M(ce),X=Z[0];switch(X){case 200:return this.j?.logIncoming(ne.byteLength,0,0,a(X)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ne.byteLength,Z[1],0,a(X),q),this.t({type:Z[0],id:Z[1],data:q})}}t(ne){if(ne.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(ne.id)?.(ne)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}t.$Ah=R,Xe([p.$ph],R.prototype,"onDidInitializePromise",null);class B{get connections(){const ne=[];return this.f.forEach(ce=>ne.push(ce)),ne}constructor(ne){this.a=new Map,this.f=new Set,this.g=new c.$Rd,this.onDidAddConnection=this.g.event,this.h=new c.$Rd,this.onDidRemoveConnection=this.h.event,this.j=new g.$Qc,this.j.add(ne(({protocol:ce,onDidClientDisconnect:Z})=>{const q=c.Event.once(ce.onMessage);this.j.add(q(X=>{const C=new u(X),_=M(C),$=new V(ce,_),W=new R(ce);this.a.forEach((w,A)=>$.registerChannel(A,w));const Q={channelServer:$,channelClient:W,ctx:_};this.f.add(Q),this.g.fire(Q),this.j.add(Z(()=>{$.dispose(),W.dispose(),this.f.delete(Q),this.h.fire(Q)}))}))}))}getChannel(ne,ce){const Z=this;return{call(q,X,C){let _;if((0,n.$Qf)(ce)){const W=(0,v.$3b)(Z.connections.filter(ce));_=W?Promise.resolve(W):c.Event.toPromise(c.Event.filter(Z.onDidAddConnection,ce))}else _=ce.routeCall(Z,q,X);const $=_.then(W=>W.channelClient.getChannel(ne));return ie($).call(q,X,C)},listen(q,X){if((0,n.$Qf)(ce))return Z.k(ne,ce,q,X);const C=ce.routeEvent(Z,q,X).then(_=>_.channelClient.getChannel(ne));return ie(C).listen(q,X)}}}k(ne,ce,Z,q){const X=this;let C;const _=new c.$Rd({onWillAddFirstListener:()=>{C=new g.$Qc;const $=new c.$Xd,W=new Map,Q=A=>{const I=A.channelClient.getChannel(ne).listen(Z,q),k=$.add(I);W.set(A,k)},w=A=>{const E=W.get(A);E&&(E.dispose(),W.delete(A))};X.connections.filter(ce).forEach(Q),c.Event.filter(X.onDidAddConnection,ce)(Q,void 0,C),X.onDidRemoveConnection(w,void 0,C),$.event(_.fire,_,C),C.add($)},onDidRemoveLastListener:()=>{C?.dispose(),C=void 0}});return _.event}registerChannel(ne,ce){this.a.set(ne,ce);for(const Z of this.f)Z.channelServer.registerChannel(ne,ce)}dispose(){this.j.dispose();for(const ne of this.f)ne.channelClient.dispose(),ne.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$Bh=B;class j{constructor(ne,ce,Z=null){const q=new l;y(q,ce),ne.send(q.buffer),this.a=new R(ne,Z),this.d=new V(ne,ce,Z)}getChannel(ne){return this.a.getChannel(ne)}registerChannel(ne,ce){this.d.registerChannel(ne,ce)}dispose(){this.a.dispose(),this.d.dispose()}}t.$Ch=j;function ie(de){return{call(ne,ce,Z){return de.then(q=>q.call(ne,ce,Z))},listen(ne,ce){const Z=new c.$1d;return de.then(q=>Z.input=q.listen(ne,ce)),Z.event}}}t.$Dh=ie;function te(de){let ne=!1;return{call(ce,Z,q){return ne?de.call(ce,Z,q):(0,N.$1g)(0).then(()=>ne=!0).then(()=>de.call(ce,Z,q))},listen(ce,Z){if(ne)return de.listen(ce,Z);const q=new c.$1d;return(0,N.$1g)(0).then(()=>ne=!0).then(()=>q.input=de.listen(ce,Z)),q.event}}}t.$Eh=te;class ue{constructor(ne){this.a=ne}routeCall(ne){return this.b(ne)}routeEvent(ne){return this.b(ne)}async b(ne){for(const ce of ne.connections)if(await Promise.resolve(this.a(ce.ctx)))return Promise.resolve(ce);return await c.Event.toPromise(ne.onDidAddConnection),await this.b(ne)}}t.$Fh=ue;var le;(function(de){function ne(X,C,_){const $=X,W=_&&_.disableMarshalling,Q=new Map;for(const w in $)Z(w)&&Q.set(w,c.Event.buffer($[w],!0,void 0,C));return new class{listen(w,A,E){const I=Q.get(A);if(I)return I;if(q(A)){const k=$[A];if(typeof k=="function")return k.call($,E)}throw new D.$ab(`Event not found: ${A}`)}call(w,A,E){const I=$[A];if(typeof I=="function"){if(!W&&Array.isArray(E))for(let O=0;O<E.length;O++)E[O]=(0,m.$uh)(E[O]);let k=I.apply($,E);return k instanceof Promise||(k=Promise.resolve(k)),k}throw new D.$ab(`Method not found: ${A}`)}}}de.fromService=ne;function ce(X,C){const _=C&&C.disableMarshalling;return new Proxy({},{get($,W){if(typeof W=="string")return C?.properties?.has(W)?C.properties.get(W):q(W)?function(Q){return X.listen(W,Q)}:Z(W)?X.listen(W):async function(...Q){let w;C&&!(0,n.$Lf)(C.context)?w=[C.context,...Q]:w=Q;const A=await X.call(W,w);return _?A:(0,m.$uh)(A)};throw new D.$ab(`Property not found: ${String(W)}`)}})}de.toService=ce;function Z(X){return X[0]==="o"&&X[1]==="n"&&T.$5e(X.charCodeAt(2))}function q(X){return/^onDynamic/.test(X)&&T.$5e(X.charCodeAt(9))}})(le||(t.ProxyChannel=le={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function we(de){if(Array.isArray(de))return de;if(de&&typeof de=="object"&&typeof de.toString=="function"){const ne=de.toString();if(ne!=="[object Object]")return ne}return de}function Fe(de){return Array.isArray(de)?de.map(we):we(de)}function ke(de,ne,ce,Z,q,X,C){C=Fe(C);const _=oe[q],$=_[Z%_.length];let W=[`%c[${de}]%c[${String(ne).padStart(7," ")}]%c[len: ${String(ce).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(X)?(W=W.concat(C),W.push(")")):W.push(C),console.log.apply(console,W)}class Le{constructor(ne,ce){this.d=ne,this.f=ce,this.a=0,this.b=0}logOutgoing(ne,ce,Z,q,X){this.b+=ne,ke(this.d,this.b,ne,ce,Z,q,X)}logIncoming(ne,ce,Z,q,X){this.a+=ne,ke(this.f,this.a,ne,ce,Z,q,X)}}t.$Gh=Le}),define(be[133],$e([1,0,33,4,67,89,30]),function(ae,t,v,N,i,U,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8T=void 0;class D extends i.$Ch{static f(){const g=N.Event.fromNodeEventEmitter(p.$N,"vscode:message",(m,T)=>v.$fe.wrap(T));return p.$N.send("vscode:hello"),new U.$4T(p.$N,g)}constructor(g){const m=D.f();super(m,g),this.b=m}dispose(){this.b.disconnect()}}t.$8T=D}),define(be[134],$e([13,11]),function(ae,t){return ae.create("vs/platform/files/common/files",t)}),define(be[135],$e([13,11]),function(ae,t){return ae.create("vs/platform/theme/common/iconRegistry",t)}),define(be[40],$e([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yh=t.$Xh=t.$Wh=t._util=void 0;var v;(function(p){p.serviceIds=new Map,p.DI_TARGET="$di$target",p.DI_DEPENDENCIES="$di$dependencies";function D(c){return c[p.DI_DEPENDENCIES]||[]}p.getServiceDependencies=D})(v||(t._util=v={})),t.$Wh=i("instantiationService");function N(p,D,c){D[v.DI_TARGET]===D?D[v.DI_DEPENDENCIES].push({id:p,index:c}):(D[v.DI_DEPENDENCIES]=[{id:p,index:c}],D[v.DI_TARGET]=D)}function i(p){if(v.serviceIds.has(p))return v.serviceIds.get(p);const D=function(c,g,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(D,c,m)};return D.toString=()=>p,v.serviceIds.set(p,D),D}t.$Xh=i;function U(p){return p}t.$Yh=U}),define(be[136],$e([1,0,40]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Am=t.$zm=t.$ym=t.ID=void 0,t.ID="diagnosticsService",t.$ym=(0,v.$Xh)(t.ID);function N(U){return!!U.hostName&&!!U.errorMessage}t.$zm=N;class i{async getPerformanceInfo(p,D){return{}}async getSystemInfo(p,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(p,D){return""}async getWorkspaceFileExtensions(p){return{extensions:[]}}async reportWorkspaceStats(p){}}t.$Am=i}),define(be[137],$e([1,0,87,23,10,7,15,134,40,5,31,28]),function(ae,t,v,N,i,U,p,D,c,g,m,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pk=t.$Ok=t.$Nk=t.$Mk=t.$Lk=t.FileKind=t.$Kk=t.$Jk=t.$Ik=t.$Hk=t.$Gk=t.$Fk=t.$Ek=t.FileOperationResult=t.$Dk=t.$Ck=t.$Bk=t.$Ak=t.$zk=t.FileChangeType=t.$yk=t.FileOperation=t.$xk=t.$wk=t.$vk=t.$uk=t.$tk=t.$sk=t.FileSystemProviderErrorCode=t.$rk=t.$qk=t.$pk=t.$ok=t.$nk=t.$mk=t.$lk=t.$kk=t.$jk=t.FileSystemProviderCapabilities=t.$ik=t.FilePermission=t.FileType=t.$hk=t.$gk=void 0,t.$gk=(0,c.$Xh)("fileService");function n(q){return q.create===!0}t.$hk=n;var o;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(o||(t.FileType=o={}));var e;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function h(q){const X=q;return!!X&&typeof X.onDidChange=="function"}t.$ik=h;var a;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(a||(t.FileSystemProviderCapabilities=a={}));function f(q){return!!(q.capabilities&2)}t.$jk=f;function s(q){return!!(q.capabilities&8)}t.$kk=s;function r(q){return!!(q.capabilities&131072)}t.$lk=r;function b(q){return!!(q.capabilities&4)}t.$mk=b;function u(q){return!!(q.capabilities&16)}t.$nk=u;function l(q){return f(q)?!!(q.capabilities&16384):!1}t.$ok=l;function F(q){return f(q)?!!(q.capabilities&32768):!1}t.$pk=F;function z(q){return!!(q.capabilities&65536)}t.$qk=z;function L(q){return!!(q.capabilities&2048)}t.$rk=L;var d;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(d||(t.FileSystemProviderErrorCode=d={}));class y extends Error{static create(X,C){const _=new y(X.toString(),C);return x(_,C),_}constructor(X,C){super(X),this.code=C}}t.$sk=y;function M(q,X){return y.create(q,X)}t.$tk=M;function V(q){return q||M((0,D.localize)(0,null),d.Unknown)}t.$uk=V;function x(q,X){return q.name=X?`${X} (FileSystemError)`:"FileSystemError",q}t.$vk=x;function R(q){if(!q)return d.Unknown;if(q instanceof y)return q.code;const X=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!X)return d.Unknown;switch(X[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}t.$wk=R;function B(q){if(q instanceof oe)return q.fileOperationResult;switch(R(q)){case d.FileNotFound:return 1;case d.FileIsADirectory:return 0;case d.FileNotADirectory:return 9;case d.FileWriteLocked:return 5;case d.NoPermissions:return 6;case d.FileExists:return 4;case d.FileTooLarge:return 7;default:return 10}}t.$xk=B;var j;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(j||(t.FileOperation=j={}));class ie{constructor(X,C,_){this.resource=X,this.operation=C,this.target=_}isOperation(X){return this.operation===X}}t.$yk=ie;var te;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(te||(t.FileChangeType=te={}));class ue{static{this.a=null}constructor(X,C){this.c=C,this.b=void 0,this.d=new T.$U(()=>{const _=v.$4h.forUris(()=>this.c);return _.fill(this.rawAdded.map($=>[$,!0])),_}),this.f=new T.$U(()=>{const _=v.$4h.forUris(()=>this.c);return _.fill(this.rawUpdated.map($=>[$,!0])),_}),this.g=new T.$U(()=>{const _=v.$4h.forUris(()=>this.c);return _.fill(this.rawDeleted.map($=>[$,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of X){switch(_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}this.b!==ue.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=ue.a):this.b!==void 0&&(this.b=ue.a))}}contains(X,...C){return this.h(X,{includeChildren:!1},...C)}affects(X,...C){return this.h(X,{includeChildren:!0},...C)}h(X,C,..._){if(!X)return!1;const $=_.length>0;return!!((!$||_.includes(1))&&(this.d.value.get(X)||C.includeChildren&&this.d.value.findSuperstr(X))||(!$||_.includes(0))&&(this.f.value.get(X)||C.includeChildren&&this.f.value.findSuperstr(X))||(!$||_.includes(2))&&(this.g.value.findSubstr(X)||C.includeChildren&&this.g.value.findSuperstr(X)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(X){return this.b===X}hasCorrelation(){return typeof this.b=="number"}}t.$zk=ue;function le(q,X,C){return!q||!X||q===X||X.length>q.length?!1:(X.charAt(X.length-1)!==N.sep&&(X+=N.sep),C?(0,i.$7e)(q,X):q.indexOf(X)===0)}t.$Ak=le;class oe extends Error{constructor(X,C,_){super(X),this.fileOperationResult=C,this.options=_}}t.$Bk=oe;class we extends oe{constructor(X,C,_,$){super(X,C,$),this.fileOperationResult=C,this.size=_}}t.$Ck=we;class Fe extends oe{constructor(X,C,_){super(X,2,_),this.stat=C}}t.$Dk=Fe;var ke;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ke||(t.FileOperationResult=ke={})),t.$Ek={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$Fk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$Gk="files.associations",t.$Hk="files.exclude",t.$Ik="files.readonlyInclude",t.$Jk="files.readonlyExclude",t.$Kk="files.readonlyFromPermissions";var Le;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(Le||(t.FileKind=Le={})),t.$Lk="";function de(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}t.$Mk=de;async function ne(q,X){if(!X.hasProvider(p.URI.from({scheme:q.scheme})))return new Promise(C=>{const _=X.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===q.scheme&&$.added&&(_.dispose(),C())})})}t.$Nk=ne;class ce{static{this.KB=1024}static{this.MB=ce.KB*ce.KB}static{this.GB=ce.MB*ce.KB}static{this.TB=ce.GB*ce.KB}static formatSize(X){return(0,U.$Gf)(X)||(X=0),X<ce.KB?(0,D.localize)(1,null,X.toFixed(0)):X<ce.MB?(0,D.localize)(2,null,(X/ce.KB).toFixed(2)):X<ce.GB?(0,D.localize)(3,null,(X/ce.MB).toFixed(2)):X<ce.TB?(0,D.localize)(4,null,(X/ce.GB).toFixed(2)):(0,D.localize)(5,null,(X/ce.TB).toFixed(2))}}t.$Ok=ce;function Z(q){const X=typeof q=="string"||q?.scheme===m.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===m.Schemas.file?1024*ce.MB:X?10*ce.MB:g.$o?50*ce.MB:1024*ce.MB}t.$Pk=Z}),define(be[138],$e([1,0,40]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$i0b=t.$h0b=void 0,t.$h0b=(0,v.$Xh)("mainProcessService");class N{constructor(U,p){this.a=U,this.b=p}getChannel(U){return this.a.getChannel(U,this.b)}registerChannel(U,p){this.a.registerChannel(U,p)}}t.$i0b=N}),define(be[139],$e([1,0,2,133]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$j0b=void 0;class i extends v.$Rc{constructor(p){super(),this.a=this.B(new N.$8T(`window:${p}`))}getChannel(p){return this.a.getChannel(p)}registerChannel(p,D){this.a.registerChannel(p,D)}}t.$j0b=i});var Ei=this&&this.__param||function(ae,t){return function(v,N){t(v,N,ae)}};define(be[140],$e([1,0,67,138]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$n0b=void 0;let i=class{constructor(p,D){return this.windowId=p,v.ProxyChannel.toService(D.getChannel("nativeHost"),{context:p,properties:(()=>{const c=new Map;return c.set("windowId",p),c})()})}};t.$n0b=i,t.$n0b=i=Xe([Ei(1,N.$h0b)],i)}),define(be[68],$e([1,0,76,7]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$on=void 0;class i{constructor(){this.a=new Map}add(p,D){v.ok(N.$Cf(p)),v.ok(N.$Ef(D)),v.ok(!this.a.has(p),"There is already an extension with this id"),this.a.set(p,D)}knows(p){return this.a.has(p)}as(p){return this.a.get(p)||null}}t.$on=new i}),define(be[141],$e([1,0,4,68]),function(ae,t,v,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pn=void 0,t.$pn={JSONContribution:"base.contributions.json"};function i(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class U{constructor(){this.b=new v.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,g){this.a[i(c)]=g,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}}const p=new U;N.$on.add(t.$pn.JSONContribution,p)}),define(be[142],$e([1,0,9,17,18,4,7,15,135,141,68]),function(ae,t,v,N,i,U,p,D,c,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jw=t.$iw=t.$hw=t.$gw=t.$fw=t.$ew=t.$dw=t.$cw=t.IconFontDefinition=t.IconContribution=t.$bw=void 0,t.$bw={IconContribution:"base.contributions.icons"};var T;(function(b){function u(l,F){let z=l.defaults;for(;i.ThemeIcon.isThemeIcon(z);){const L=e.getIcon(z.id);if(!L)return;z=L.defaults}return z}b.getDefinition=u})(T||(t.IconContribution=T={}));var n;(function(b){function u(F){return{weight:F.weight,style:F.style,src:F.src.map(z=>({format:z.format,location:z.location.toString()}))}}b.toJSONObject=u;function l(F){const z=L=>(0,p.$Cf)(L)?L:void 0;if(F&&Array.isArray(F.src)&&F.src.every(L=>(0,p.$Cf)(L.format)&&(0,p.$Cf)(L.location)))return{weight:z(F.weight),style:z(F.style),src:F.src.map(L=>({format:L.format,location:D.URI.parse(L.location)}))}}b.fromJSONObject=l})(n||(t.IconFontDefinition=n={}));class o{constructor(){this.a=new U.$Rd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(u,l,F,z){const L=this.b[u];if(L){if(F&&!L.description){L.description=F,this.d.properties[u].markdownDescription=`${F} $(${u})`;const M=this.e.enum.indexOf(u);M!==-1&&(this.e.enumDescriptions[M]=F),this.a.fire()}return L}const d={id:u,description:F,defaults:l,deprecationMessage:z};this.b[u]=d;const y={$ref:"#/definitions/icons"};return z&&(y.deprecationMessage=z),F&&(y.markdownDescription=`${F}: $(${u})`),this.d.properties[u]=y,this.e.enum.push(u),this.e.enumDescriptions.push(F||""),this.a.fire(),{id:u}}deregisterIcon(u){delete this.b[u],delete this.d.properties[u];const l=this.e.enum.indexOf(u);l!==-1&&(this.e.enum.splice(l,1),this.e.enumDescriptions.splice(l,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(u=>this.b[u])}getIcon(u){return this.b[u]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(u,l){const F=this.f[u];return F||(this.f[u]=l,this.a.fire(),l)}deregisterIconFont(u){delete this.f[u]}getIconFont(u){return this.f[u]}toString(){const u=(L,d)=>L.id.localeCompare(d.id),l=L=>{for(;i.ThemeIcon.isThemeIcon(L.defaults);)L=this.b[L.defaults.id];return`codicon codicon-${L?L.id:""}`},F=[];F.push("| preview     | identifier                        | default codicon ID                | description"),F.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const z=Object.keys(this.b).map(L=>this.b[L]);for(const L of z.filter(d=>!!d.description).sort(u))F.push(`|<i class="${l(L)}"></i>|${L.id}|${i.ThemeIcon.isThemeIcon(L.defaults)?L.defaults.id:L.id}|${L.description||""}|`);F.push("| preview     | identifier                        "),F.push("| ----------- | --------------------------------- |");for(const L of z.filter(d=>!i.ThemeIcon.isThemeIcon(d.defaults)).sort(u))F.push(`|<i class="${l(L)}"></i>|${L.id}|`);return F.join(`
`)}}const e=new o;m.$on.add(t.$bw.IconContribution,e);function h(b,u,l,F){return e.registerIcon(b,u,l,F)}t.$cw=h;function a(){return e}t.$dw=a;function f(){const b=(0,N.$1j)();for(const u in b){const l="\\"+b[u].toString(16);e.registerIcon(u,{fontCharacter:l})}}f(),t.$ew="vscode://schemas/icons";const s=m.$on.as(g.$pn.JSONContribution);s.registerSchema(t.$ew,e.getIconSchema());const r=new v.$_g(()=>s.notifySchemaChanged(t.$ew),200);e.onDidChange(()=>{r.isScheduled()||r.schedule()}),t.$fw=h("widget-close",N.$3j.close,(0,c.localize)(2,null)),t.$gw=h("goto-previous-location",N.$3j.arrowUp,(0,c.localize)(3,null)),t.$hw=h("goto-next-location",N.$3j.arrowDown,(0,c.localize)(4,null)),t.$iw=i.ThemeIcon.modify(N.$3j.sync,"spin"),t.$jw=i.ThemeIcon.modify(N.$3j.loading,"spin")}),define(be[143],$e([1,0,3,4,2,18,142]),function(ae,t,v,N,i,U,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NDb=t.$MDb=void 0;function D(g){const m=new i.$Qc,T=m.add(new N.$Rd),n=(0,p.$dw)();return m.add(n.onDidChange(()=>T.fire())),g&&m.add(g.onDidProductIconThemeChange(()=>T.fire())),{dispose:()=>m.dispose(),onDidChange:T.event,getCSS(){const o=g?g.getProductIconTheme():new c,e={},h=f=>{const s=o.getIcon(f);if(!s)return;const r=s.font;return r?(e[r.id]=r.definition,`.codicon-${f.id}:before { content: '${s.fontCharacter}'; font-family: ${(0,v.$kQ)(r.id)}; }`):`.codicon-${f.id}:before { content: '${s.fontCharacter}'; }`},a=[];for(const f of n.getIcons()){const s=h(f);s&&a.push(s)}for(const f in e){const s=e[f],r=s.weight?`font-weight: ${s.weight};`:"",b=s.style?`font-style: ${s.style};`:"",u=s.src.map(l=>`${(0,v.$jQ)(l.location)} format('${l.format}')`).join(", ");a.push(`@font-face { src: ${u}; font-family: ${(0,v.$kQ)(f)};${r}${b} font-display: block; }`)}return a.join(`
`)}}}t.$MDb=D;class c{getIcon(m){const T=(0,p.$dw)();let n=m.defaults;for(;U.ThemeIcon.isThemeIcon(n);){const o=T.getIcon(n.id);if(!o)return;n=o.defaults}return n}}t.$NDb=c}),define(be[144],$e([1,0,5]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wC=t.$vC=t.$uC=t.$tC=t.$sC=t.$rC=t.$qC=t.$pC=t.$oC=void 0,t.$oC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function N(T){return typeof T.parentId=="number"}t.$pC=N;function i(T){return!!T.workspaceUri}t.$qC=i;function U(T){return!!T.folderUri}t.$rC=U;function p(T){return!!T.fileUri}t.$sC=p;function D(T){const n=c(T),o=T.getValue("window.menuBarVisibility");return o==="default"||n==="native"&&o==="compact"||v.$j&&v.$m?"classic":o}t.$tC=D;function c(T){if(v.$o)return"custom";const n=T.getValue("window");if(n){if(v.$j&&n.nativeTabs===!0||v.$j&&n.nativeFullScreen===!1)return"native";const h=n.titleBarStyle;if(h==="native"||h==="custom")return h}return v.$k?"native":"custom"}t.$uC=c;function g(T){return!(!v.$i||v.$o||c(T)==="native")}t.$vC=g;function m(T=0){return Math.pow(1.2,T)}t.$wC=m}),define(be[145],$e([1,0,16,3,21,30,144]),function(ae,t,v,N,i,U,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$r0b=t.$q0b=t.$p0b=void 0;function D(T){for(const{window:n}of(0,N.getWindows)())c(n)?.webFrame?.setZoomLevel(T);(0,v.$GO)((0,p.$wC)(T)),(0,v.$DO)(T)}t.$p0b=D;function c(T){if(T===i.$xO)return{ipcRenderer:U.$N,webFrame:U.$P};{const n=T;if(n?.vscode?.ipcRenderer&&n?.vscode?.webFrame)return n.vscode}}function g(){D((0,v.$EO)()+1)}t.$q0b=g;function m(){D((0,v.$EO)()-1)}t.$r0b=m}),define(be[146],$e([1,0,11,3,132,9,90,30,136,137,139,140,143,145,14,21,103,94]),function(ae,t,v,N,i,U,p,D,c,g,m,T,n,o,e,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const a=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,f=/\s--inspect-port=(?<port>\d+)/;class s{getHeight(R){return 22}getTemplateId(R){return d(R)?"process":z(R)?"machine":(0,c.$zm)(R)?"error":L(R)?"header":""}}class r{hasChildren(R){return(0,c.$zm)(R)?!1:d(R)?!!R.children?.length:!0}getChildren(R){return d(R)?R.children?R.children:[]:(0,c.$zm)(R)?[]:L(R)?R.processRoots.length>1?R.processRoots:[R.processRoots[0].rootProcess]:z(R)?[R.rootProcess]:[R.processes]}}class b{constructor(){this.templateId="header"}renderTemplate(R){const B=(0,N.$6P)(R,(0,N.$)(".row")),j=(0,N.$6P)(B,(0,N.$)(".nameLabel")),ie=(0,N.$6P)(B,(0,N.$)(".cpu")),te=(0,N.$6P)(B,(0,N.$)(".memory")),ue=(0,N.$6P)(B,(0,N.$)(".pid"));return{name:j,CPU:ie,memory:te,PID:ue}}renderElement(R,B,j,ie){j.name.textContent=(0,v.localize)(0,null),j.CPU.textContent=(0,v.localize)(1,null),j.PID.textContent=(0,v.localize)(2,null),j.memory.textContent=(0,v.localize)(3,null)}disposeTemplate(R){}}class u{constructor(){this.templateId="machine"}renderTemplate(R){const B=Object.create(null),j=(0,N.$6P)(R,(0,N.$)(".row"));return B.name=(0,N.$6P)(j,(0,N.$)(".nameLabel")),B}renderElement(R,B,j,ie){j.name.textContent=R.element.name}disposeTemplate(R){}}class l{constructor(){this.templateId="error"}renderTemplate(R){const B=Object.create(null),j=(0,N.$6P)(R,(0,N.$)(".row"));return B.name=(0,N.$6P)(j,(0,N.$)(".nameLabel")),B}renderElement(R,B,j,ie){j.name.textContent=R.element.errorMessage}disposeTemplate(R){}}class F{constructor(R,B,j){this.a=R,this.b=B,this.c=j,this.templateId="process"}renderTemplate(R){const B=(0,N.$6P)(R,(0,N.$)(".row")),j=(0,N.$6P)(B,(0,N.$)(".nameLabel")),ie=(0,N.$6P)(B,(0,N.$)(".cpu")),te=(0,N.$6P)(B,(0,N.$)(".memory")),ue=(0,N.$6P)(B,(0,N.$)(".pid"));return{name:j,CPU:ie,PID:ue,memory:te}}renderElement(R,B,j,ie){const{element:te}=R,ue=te.pid.toFixed(0);let le=te.name;this.c.has(te.pid)&&(le=this.c.get(te.pid)),j.name.textContent=le,j.name.title=te.cmd,j.CPU.textContent=te.load.toFixed(0),j.PID.textContent=ue,j.PID.parentElement.id=`pid-${ue}`;const oe=this.a==="win32"?te.mem:this.b*(te.mem/100);j.memory.textContent=(oe/g.$Ok.MB).toFixed(0)}disposeTemplate(R){}}function z(x){return!!x.name&&!!x.rootProcess}function L(x){return!!x.processRoots}function d(x){return!!x.pid}class y{constructor(R,B){this.f=B,this.b=new Map;const j=new m.$j0b(R);this.c=new T.$n0b(R,j),this.k(B.styles),this.g(B),D.$N.on("vscode:pidToNameResponse",(ie,te)=>{this.b=new Map;for(const[ue,le]of te)this.b.set(ue,le)}),D.$N.on("vscode:listProcessesResponse",async(ie,te)=>{te.forEach((ue,le)=>{d(ue.rootProcess)&&(ue.rootProcess.name=le===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:te}}),this.d.layout(h.$xO.innerHeight,h.$xO.innerWidth)):await this.h(te),this.m(0)}),this.a=Date.now(),D.$N.send("vscode:pidToNameRequest"),D.$N.send("vscode:listProcesses")}g(R){h.$xO.document.onkeydown=B=>{const j=R.platform==="darwin"?B.metaKey:B.ctrlKey;j&&B.keyCode===87&&(B.stopPropagation(),B.preventDefault(),D.$N.send("vscode:closeProcessExplorer")),j&&B.keyCode===187&&(0,o.$q0b)(),j&&B.keyCode===189&&(0,o.$r0b)()}}async h(R){const B=h.$xO.document.getElementById("process-list");if(!B)return;const{totalmem:j}=await this.c.getOSStatistics(),ie=[new F(this.f.platform,j,this.b),new b,new u,new l];this.d=new i.$oT("processExplorer",B,new s,ie,new r,{identityProvider:{getId:te=>d(te)?te.pid.toString():(0,c.$zm)(te)?te.hostName:L(te)?"processes":z(te)?te.name:"header"}}),this.d.setInput({processes:{processRoots:R}}),this.d.layout(h.$xO.innerHeight,h.$xO.innerWidth),this.d.onKeyDown(te=>{const ue=new e.$2O(te);if(ue.keyCode===35&&ue.altKey){const le=this.n();Promise.all(le.map(oe=>this.c.killProcess(oe,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(te=>{d(te.element)&&this.l(te.element,!0)}),B.style.height=`${h.$xO.innerHeight}px`,h.$xO.addEventListener("resize",()=>{B.style.height=`${h.$xO.innerHeight}px`,this.d?.layout(h.$xO.innerHeight,h.$xO.innerWidth)})}i(R){const B=a.exec(R);return B&&B.groups.port!=="0"||R.indexOf("node ")>=0||R.indexOf("node.exe")>=0}j(R){const B={type:"node",request:"attach",name:`process ${R.pid}`};let j=a.exec(R.cmd);j?B.port=Number(j.groups.port):B.processId=String(R.pid),j=f.exec(R.cmd),j&&(B.port=Number(j.groups.port)),D.$N.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[B]})}k(R){const B=(0,N.$OP)(),j=[];R.listFocusBackground&&(j.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${R.listFocusBackground}; }`),j.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${R.listFocusBackground}; }`)),R.listFocusForeground&&j.push(`.monaco-list:focus .monaco-list-row.focused { color: ${R.listFocusForeground}; }`),R.listActiveSelectionBackground&&(j.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${R.listActiveSelectionBackground}; }`),j.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${R.listActiveSelectionBackground}; }`)),R.listActiveSelectionForeground&&j.push(`.monaco-list:focus .monaco-list-row.selected { color: ${R.listActiveSelectionForeground}; }`),R.listHoverBackground&&j.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${R.listHoverBackground}; }`),R.listHoverForeground&&j.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${R.listHoverForeground}; }`),R.listFocusOutline&&j.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${R.listFocusOutline}; outline-offset: -1px; }`),R.listHoverOutline&&j.push(`.monaco-list-row:hover { outline: 1px dashed ${R.listHoverOutline}; outline-offset: -1px; }`),R.scrollbarShadowColor&&j.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${R.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${R.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${R.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),R.scrollbarSliderBackgroundColor&&j.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${R.scrollbarSliderBackgroundColor};
				}
			`),R.scrollbarSliderHoverBackgroundColor&&j.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${R.scrollbarSliderHoverBackgroundColor};
				}
			`),R.scrollbarSliderActiveBackgroundColor&&j.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${R.scrollbarSliderActiveBackgroundColor};
				}
			`),B.textContent=j.join(`
`),R.color&&(h.$xO.document.body.style.color=R.color)}l(R,B){const j=[],ie=Number(R.pid);B&&(j.push({accelerator:"Alt+E",label:(0,v.localize)(4,null),click:()=>{this.c.killProcess(ie,"SIGTERM")}}),j.push({label:(0,v.localize)(5,null),click:()=>{this.c.killProcess(ie,"SIGKILL")}}),j.push({type:"separator"})),j.push({label:(0,v.localize)(6,null),click:()=>{const te=this.n();te?.includes(ie)||(te.length=0,te.push(ie));const ue=te?.map(le=>h.$xO.document.getElementById(`pid-${le}`)).filter(le=>!!le);if(ue){const le=ue.map(oe=>oe.innerText).filter(oe=>!!oe);this.c.writeClipboardText(le.join(`
`))}}}),j.push({label:(0,v.localize)(7,null),click:()=>{const te=h.$xO.document.getElementById("process-list");te&&this.c.writeClipboardText(te.innerText)}}),R&&B&&this.i(R.cmd)&&(j.push({type:"separator"}),j.push({label:(0,v.localize)(8,null),click:()=>{this.j(R)}})),(0,p.$ZT)(j)}m(R){setTimeout(()=>{const B=Date.now(),j=R+B-this.a;this.a=B,j>1e3?(D.$N.send("vscode:pidToNameRequest"),D.$N.send("vscode:listProcesses")):this.m(j)},200)}n(){return this.d?.getSelection()?.map(R=>{if(!(!R||!("pid"in R)))return R.pid}).filter(R=>!!R)}}function M(){const x=(0,N.$OP)();x.id="codiconStyles";const R=(0,n.$MDb)(void 0);function B(){x.textContent=R.getCSS()}const j=new U.$_g(B,0);R.onDidChange(()=>j.schedule()),j.schedule()}function V(x){const R=x.data.platform==="win32"?"windows":x.data.platform==="linux"?"linux":"mac";h.$xO.document.body.classList.add(R),M(),(0,o.$p0b)(x.data.zoomLevel),new y(x.windowId,x.data)}t.startup=V})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/da5ab29656a9f0bef63602fbce10968a7f4db2b5/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
