/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ce=function(ie){for(var e=[],D=0,A=ie.length;D<A;D++)e[D]=ae[ie[D]];return e};define(ae[123],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class D{static get(){const L=new Map,j=new Map,O=new Map,P=new Map;function S(c,$){c.has($.detail)||c.set($.detail,-$.timestamp)}function b(c,$){const p=c.get($.detail);p&&(p>=0||c.set($.detail,p+$.timestamp))}let C=[];typeof ie=="function"&&typeof ie.getStats=="function"&&(C=ie.getStats().slice(0).sort((c,$)=>c.timestamp-$.timestamp));for(const c of C)switch(c.type){case 10:S(L,c);break;case 11:case 12:b(L,c);break;case 21:S(j,c);break;case 22:b(j,c);break;case 33:S(O,c);break;case 34:b(O,c);break;case 31:S(P,c);break;case 32:b(P,c);break}let k=0;O.forEach(c=>k+=c);function g(c){const $=[];return c.forEach((p,w)=>$.push([w,p])),$}return{amdLoad:g(L),amdInvoke:g(j),nodeRequire:g(O),nodeEval:g(P),nodeRequireTotal:k}}static toMarkdownTable(L,j){let O="";const P=[];return L.forEach((S,b)=>{P[b]=S.length}),j.forEach(S=>{S.forEach((b,C)=>{typeof b>"u"&&(b=S[C]="-");const k=b.toString().length;P[C]=Math.max(k,P[C])})}),L.forEach((S,b)=>{O+=`| ${S+" ".repeat(P[b]-S.toString().length)} `}),O+=`|
`,L.forEach((S,b)=>{O+=`| ${"-".repeat(P[b])} `}),O+=`|
`,j.forEach(S=>{S.forEach((b,C)=>{typeof b<"u"&&(O+=`| ${b+" ".repeat(P[C]-b.toString().length)} `)}),O+=`|
`}),O}}e.$T=D}),define(ae[124],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function D(p,w,l){const u=A(p,w);if(u!==-1)return p[u]}e.$eb=D;function A(p,w,l=p.length-1){for(let u=l;u>=0;u--){const h=p[u];if(w(h))return u}return-1}e.$fb=A;function L(p,w){const l=j(p,w);return l===-1?void 0:p[l]}e.$gb=L;function j(p,w,l=0,u=p.length){let h=l,d=u;for(;h<d;){const E=Math.floor((h+d)/2);w(p[E])?h=E+1:d=E}return h-1}e.$hb=j;function O(p,w){const l=P(p,w);return l===p.length?void 0:p[l]}e.$ib=O;function P(p,w,l=0,u=p.length){let h=l,d=u;for(;h<d;){const E=Math.floor((h+d)/2);w(p[E])?d=E:h=E+1}return h}e.$jb=P;function S(p,w,l=0,u=p.length){const h=P(p,w,l,u);return h===p.length?-1:h}e.$kb=S;class b{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(b.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!w(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const l=j(this.e,w,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}e.$lb=b;function C(p,w){if(p.length===0)return;let l=p[0];for(let u=1;u<p.length;u++){const h=p[u];w(h,l)>0&&(l=h)}return l}e.$mb=C;function k(p,w){if(p.length===0)return;let l=p[0];for(let u=1;u<p.length;u++){const h=p[u];w(h,l)>=0&&(l=h)}return l}e.$nb=k;function g(p,w){return C(p,(l,u)=>-w(l,u))}e.$ob=g;function c(p,w){if(p.length===0)return-1;let l=0;for(let u=1;u<p.length;u++){const h=p[u];w(h,p[l])>0&&(l=u)}return l}e.$pb=c;function $(p,w){for(const l of p){const u=w(l);if(u!==void 0)return u}}e.$qb=$}),define(ae[125],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function D(O,P){const S=Object.create(null);for(const b of O){const C=P(b);let k=S[C];k||(k=S[C]=[]),k.push(b)}return S}e.$J=D;function A(O,P){const S=[],b=[];for(const C of O)P.has(C)||S.push(C);for(const C of P)O.has(C)||b.push(C);return{removed:S,added:b}}e.$K=A;function L(O,P){const S=[],b=[];for(const[C,k]of O)P.has(C)||S.push(k);for(const[C,k]of P)O.has(C)||b.push(k);return{removed:S,added:b}}e.$L=L;function j(O,P){const S=new Set;for(const b of P)O.has(b)&&S.add(b);return S}e.$M=j}),define(ae[84],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=void 0;function D(O){return(P,S,b)=>{let C=null,k=null;if(typeof b.value=="function"?(C="value",k=b.value):typeof b.get=="function"&&(C="get",k=b.get),!k)throw new Error("not supported");b[C]=O(k,S)}}function A(O,P,S){let b=null,C=null;if(typeof S.value=="function"?(b="value",C=S.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(b="get",C=S.get),!C)throw new Error("not supported");const k=`$memoize$${P}`;S[b]=function(...g){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,g)}),this[k]}}e.$ph=A;function L(O,P,S){return D((b,C)=>{const k=`$debounce$${C}`,g=`$debounce$result$${C}`;return function(...c){this[g]||(this[g]=S?S():void 0),clearTimeout(this[k]),P&&(this[g]=P(this[g],...c),c=[this[g]]),this[k]=setTimeout(()=>{b.apply(this,c),this[g]=S?S():void 0},O)}})}e.$qh=L;function j(O,P,S){return D((b,C)=>{const k=`$throttle$timer$${C}`,g=`$throttle$result$${C}`,c=`$throttle$lastRun$${C}`,$=`$throttle$pending$${C}`;return function(...p){if(this[g]||(this[g]=S?S():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),P&&(this[g]=P(this[g],...p)),this[$])return;const w=this[c]+O;w<=Date.now()?(this[c]=Date.now(),b.apply(this,[this[g]]),this[g]=S?S():void 0):(this[$]=!0,this[k]=setTimeout(()=>{this[$]=!1,this[c]=Date.now(),b.apply(this,[this[g]]),this[g]=S?S():void 0},w-Date.now()))}})}e.$rh=j}),define(ae[7],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class D{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?h.isErrorNoTelemetry(s)?new h(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(o=>{o(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.$V=D,e.$W=new D;function A(E){e.$W.setUnexpectedErrorHandler(E)}e.setUnexpectedErrorHandler=A;function L(E){if(!E||typeof E!="object")return!1;const s=E;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.$Y=L;function j(E){b(E)||e.$W.onUnexpectedError(E)}e.$Z=j;function O(E){b(E)||e.$W.onUnexpectedExternalError(E)}e.$1=O;function P(E){if(E instanceof Error){const{name:s,message:o}=E,n=E.stacktrace||E.stack;return{$isError:!0,name:s,message:o,stack:n,noTelemetry:h.isErrorNoTelemetry(E)}}return E}e.$2=P;const S="Canceled";function b(E){return E instanceof C?!0:E instanceof Error&&E.name===S&&E.message===S}e.$3=b;class C extends Error{constructor(){super(S),this.name=this.message}}e.$4=C;function k(){const E=new Error(S);return E.name=E.message,E}e.$5=k;function g(E){return E?new Error(`Illegal argument: ${E}`):new Error("Illegal argument")}e.$6=g;function c(E){return E?new Error(`Illegal state: ${E}`):new Error("Illegal state")}e.$7=c;class $ extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=$;function p(E){return E?E.message?E.message:E.stack?E.stack.split(`
`)[0]:String(E):"Error"}e.$9=p;class w extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.$0=w;class l extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.$$=l;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=u;class h extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof h)return s;const o=new h;return o.message=s.message,o.stack=s.stack,o}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.$ab=h;class d extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}e.$bb=d}),define(ae[18],ce([0,1,7,124]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function L(N,V=0){return N[N.length-(1+V)]}e.$rb=L;function j(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.$sb=j;function O(N,V,G=(te,oe)=>te===oe){if(N===V)return!0;if(!N||!V||N.length!==V.length)return!1;for(let te=0,oe=N.length;te<oe;te++)if(!G(N[te],V[te]))return!1;return!0}e.$tb=O;function P(N,V){const G=N.length-1;V<G&&(N[V]=N[G]),N.pop()}e.$ub=P;function S(N,V,G){return b(N.length,te=>G(N[te],V))}e.$vb=S;function b(N,V){let G=0,te=N-1;for(;G<=te;){const oe=(G+te)/2|0,ue=V(oe);if(ue<0)G=oe+1;else if(ue>0)te=oe-1;else return oe}return-(G+1)}e.$wb=b;function C(N,V,G){if(N=N|0,N>=V.length)throw new TypeError("invalid index");const te=V[Math.floor(V.length*Math.random())],oe=[],ue=[],he=[];for(const ge of V){const de=G(ge,te);de<0?oe.push(ge):de>0?ue.push(ge):he.push(ge)}return N<oe.length?C(N,oe,G):N<oe.length+he.length?he[0]:C(N-(oe.length+he.length),ue,G)}e.$xb=C;function k(N,V){const G=[];let te;for(const oe of N.slice(0).sort(V))!te||V(te[0],oe)!==0?(te=[oe],G.push(te)):te.push(oe);return G}e.$yb=k;function*g(N,V){let G,te;for(const oe of N)te!==void 0&&V(te,oe)?G.push(oe):(G&&(yield G),G=[oe]),te=oe;G&&(yield G)}e.$zb=g;function c(N,V){for(let G=0;G<=N.length;G++)V(G===0?void 0:N[G-1],G===N.length?void 0:N[G])}e.$Ab=c;function $(N,V){for(let G=0;G<N.length;G++)V(G===0?void 0:N[G-1],N[G],G+1===N.length?void 0:N[G+1])}e.$Bb=$;function p(N,V,G){const te=[];function oe(ge,de,we){if(de===0&&we.length===0)return;const ve=te[te.length-1];ve&&ve.start+ve.deleteCount===ge?(ve.deleteCount+=de,ve.toInsert.push(...we)):te.push({start:ge,deleteCount:de,toInsert:we})}let ue=0,he=0;for(;;){if(ue===N.length){oe(ue,0,V.slice(he));break}if(he===V.length){oe(ue,N.length-ue,[]);break}const ge=N[ue],de=V[he],we=G(ge,de);we===0?(ue+=1,he+=1):we<0?(oe(ue,1,[]),ue+=1):we>0&&(oe(ue,0,[de]),he+=1)}return te}e.$Cb=p;function w(N,V,G){const te=p(N,V,G),oe=[],ue=[];for(const he of te)oe.push(...N.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:oe,added:ue}}e.$Db=w;function l(N,V,G){if(G===0)return[];const te=N.slice(0,G).sort(V);return h(N,V,te,G,N.length),te}e.top=l;function u(N,V,G,te,oe){return G===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const ge=N.length,de=N.slice(0,G).sort(V);for(let we=G,ve=Math.min(G+te,ge);we<ge;we=ve,ve=Math.min(ve+te,ge)){if(we>G&&await new Promise(Ie=>setTimeout(Ie)),oe&&oe.isCancellationRequested)throw new D.$4;h(N,V,de,we,ve)}return de})().then(ue,he)})}e.$Fb=u;function h(N,V,G,te,oe){for(const ue=G.length;te<oe;te++){const he=N[te];if(V(he,G[ue-1])<0){G.pop();const ge=(0,A.$jb)(G,de=>V(he,de)<0);G.splice(ge,0,he)}}}function d(N){return N.filter(V=>!!V)}e.$Gb=d;function E(N){let V=0;for(let G=0;G<N.length;G++)N[G]&&(N[V]=N[G],V+=1);N.length=V}e.$Hb=E;function s(N,V,G){N.splice(G,0,N.splice(V,1)[0])}e.$Ib=s;function o(N){return!Array.isArray(N)||N.length===0}e.$Jb=o;function n(N){return Array.isArray(N)&&N.length>0}e.$Kb=n;function i(N,V=G=>G){const G=new Set;return N.filter(te=>{const oe=V(te);return G.has(oe)?!1:(G.add(oe),!0)})}e.$Lb=i;function t(N){const V=new Set;return G=>{const te=N(G);return V.has(te)?!1:(V.add(te),!0)}}e.$Mb=t;function r(N,V){return N.length>0?N[0]:V}e.$Nb=r;function a(N,V){return N.length>0?N[N.length-1]:V}e.$Ob=a;function v(N,V,G=(te,oe)=>te===oe){let te=0;for(let oe=0,ue=Math.min(N.length,V.length);oe<ue&&G(N[oe],V[oe]);oe++)te++;return te}e.$Pb=v;function m(N){return[].concat(...N)}e.$Qb=m;function f(N,V){let G=typeof V=="number"?N:0;typeof V=="number"?G=N:(G=0,V=N);const te=[];if(G<=V)for(let oe=G;oe<V;oe++)te.push(oe);else for(let oe=G;oe>V;oe--)te.push(oe);return te}e.$Rb=f;function y(N,V,G){return N.reduce((te,oe)=>(te[V(oe)]=G?G(oe):oe,te),Object.create(null))}e.$Sb=y;function I(N,V){return N.push(V),()=>T(N,V)}e.$Tb=I;function T(N,V){const G=N.indexOf(V);if(G>-1)return N.splice(G,1),V}e.$Ub=T;function M(N,V,G){const te=N.slice(0,V),oe=N.slice(V);return te.concat(G,oe)}e.$Vb=M;function U(N,V){let G;if(typeof V=="number"){let te=V;G=()=>{const oe=Math.sin(te++)*179426549;return oe-Math.floor(oe)}}else G=Math.random;for(let te=N.length-1;te>0;te-=1){const oe=Math.floor(G()*(te+1)),ue=N[te];N[te]=N[oe],N[oe]=ue}}e.$Wb=U;function q(N,V){const G=N.indexOf(V);G>-1&&(N.splice(G,1),N.unshift(V))}e.$Xb=q;function Y(N,V){const G=N.indexOf(V);G>-1&&(N.splice(G,1),N.push(V))}e.$Yb=Y;function K(N,V){for(const G of V)N.push(G)}e.$Zb=K;function x(N,V){return Array.isArray(N)?N.map(V):V(N)}e.$1b=x;function H(N){return Array.isArray(N)?N:[N]}e.$2b=H;function Q(N){return N[Math.floor(Math.random()*N.length)]}e.$3b=Q;function J(N,V,G){const te=ee(N,V),oe=N.length,ue=G.length;N.length=oe+ue;for(let he=oe-1;he>=te;he--)N[he+ue]=N[he];for(let he=0;he<ue;he++)N[he+te]=G[he]}e.$4b=J;function W(N,V,G,te){const oe=ee(N,V);let ue=N.splice(oe,G);return ue===void 0&&(ue=[]),J(N,oe,te),ue}e.$5b=W;function ee(N,V){return V<0?Math.max(V+N.length,0):Math.min(V,N.length)}var ne;(function(N){function V(ue){return ue<0}N.isLessThan=V;function G(ue){return ue<=0}N.isLessThanOrEqual=G;function te(ue){return ue>0}N.isGreaterThan=te;function oe(ue){return ue===0}N.isNeitherLessOrGreaterThan=oe,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function _(N,V){return(G,te)=>V(N(G),N(te))}e.$6b=_;function se(...N){return(V,G)=>{for(const te of N){const oe=te(V,G);if(!ne.isNeitherLessOrGreaterThan(oe))return oe}return ne.neitherLessOrGreaterThan}}e.$7b=se;const X=(N,V)=>N-V;e.$8b=X;const z=(N,V)=>(0,e.$8b)(N?1:0,V?1:0);e.$9b=z;function R(N){return(V,G)=>-N(V,G)}e.$0b=R;class F{constructor(V){this.g=V,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(V){let G=this.c;for(;G<this.g.length&&V(this.g[G]);)G++;const te=G===this.c?null:this.g.slice(this.c,G);return this.c=G,te}takeFromEndWhile(V){let G=this.d;for(;G>=0&&V(this.g[G]);)G--;const te=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,te}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const V=this.g[this.c];return this.c++,V}removeLast(){const V=this.g[this.d];return this.d--,V}takeCount(V){const G=this.g.slice(this.c,this.c+V);return this.c+=V,G}}e.$$b=F;class B{static{this.empty=new B(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(G=>(V(G),!0))}toArray(){const V=[];return this.iterate(G=>(V.push(G),!0)),V}filter(V){return new B(G=>this.iterate(te=>V(te)?G(te):!0))}map(V){return new B(G=>this.iterate(te=>G(V(te))))}some(V){let G=!1;return this.iterate(te=>(G=V(te),!G)),G}findFirst(V){let G;return this.iterate(te=>V(te)?(G=te,!1):!0),G}findLast(V){let G;return this.iterate(te=>(V(te)&&(G=te),!0)),G}findLastMaxBy(V){let G,te=!0;return this.iterate(oe=>((te||ne.isGreaterThan(V(oe,G)))&&(te=!1,G=oe),!0)),G}}e.$_b=B}),define(ae[126],ce([0,1,7]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function A(S,b){if(!S)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=A;function L(S,b="Unreachable"){throw new Error(b)}e.$4c=L;function j(S){if(!S)throw new D.$bb("Assertion Failed")}e.$5c=j;function O(S){if(!S()){debugger;S(),(0,D.$Z)(new D.$bb("Assertion Failed"))}}e.$6c=O;function P(S,b){let C=0;for(;C<S.length-1;){const k=S[C],g=S[C+1];if(!b(k,g))return!1;C++}return!0}e.$7c=P}),define(ae[85],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function D(A,L){const j=this;let O=!1,P;return function(){if(O)return P;if(O=!0,L)try{P=A.apply(j,arguments)}finally{L()}else P=A.apply(j,arguments);return P}}e.$cb=D}),define(ae[60],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(A){function L(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}A.is=L;const j=Object.freeze([]);function O(){return j}A.empty=O;function*P(E){yield E}A.single=P;function S(E){return L(E)?E:P(E)}A.wrap=S;function b(E){return E||j}A.from=b;function*C(E){for(let s=E.length-1;s>=0;s--)yield E[s]}A.reverse=C;function k(E){return!E||E[Symbol.iterator]().next().done===!0}A.isEmpty=k;function g(E){return E[Symbol.iterator]().next().value}A.first=g;function c(E,s){for(const o of E)if(s(o))return!0;return!1}A.some=c;function $(E,s){for(const o of E)if(s(o))return o}A.find=$;function*p(E,s){for(const o of E)s(o)&&(yield o)}A.filter=p;function*w(E,s){let o=0;for(const n of E)yield s(n,o++)}A.map=w;function*l(...E){for(const s of E)for(const o of s)yield o}A.concat=l;function u(E,s,o){let n=o;for(const i of E)n=s(n,i);return n}A.reduce=u;function*h(E,s,o=E.length){for(s<0&&(s+=E.length),o<0?o+=E.length:o>E.length&&(o=E.length);s<o;s++)yield E[s]}A.slice=h;function d(E,s=Number.POSITIVE_INFINITY){const o=[];if(s===0)return[o,E];const n=E[Symbol.iterator]();for(let i=0;i<s;i++){const t=n.next();if(t.done)return[o,A.empty()];o.push(t.value)}return[o,{[Symbol.iterator](){return n}}]}A.consume=d})(D||(e.Iterable=D={}))}),define(ae[35],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var A;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var L;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var j;(function(s){s.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function O(s,o=!1){let n=0;const i=s.length;let t="",r=0,a=16,v=0;function m(q){let Y=0,K=0;for(;Y<q;){const x=s.charCodeAt(n);if(x>=48&&x<=57)K=K*16+x-48;else if(x>=65&&x<=70)K=K*16+x-65+10;else if(x>=97&&x<=102)K=K*16+x-97+10;else break;n++,Y++}return Y<q&&(K=-1),K}function f(q){n=q,t="",r=0,a=16,v=0}function y(){const q=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&b(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&b(s.charCodeAt(n)))for(n++;n<s.length&&b(s.charCodeAt(n));)n++;else return v=3,s.substring(q,n);let Y=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&b(s.charCodeAt(n))){for(n++;n<s.length&&b(s.charCodeAt(n));)n++;Y=n}else v=3;return s.substring(q,Y)}function I(){let q="",Y=n;for(;;){if(n>=i){q+=s.substring(Y,n),v=2;break}const K=s.charCodeAt(n);if(K===34){q+=s.substring(Y,n),n++;break}if(K===92){if(q+=s.substring(Y,n),n++,n>=i){v=2;break}switch(s.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const H=m(4);H>=0?q+=String.fromCharCode(H):v=4;break}default:v=5}Y=n;continue}if(K>=0&&K<=31)if(S(K)){q+=s.substring(Y,n),v=2;break}else v=6;n++}return q}function T(){if(t="",v=0,r=n,n>=i)return r=i,a=17;let q=s.charCodeAt(n);if(P(q)){do n++,t+=String.fromCharCode(q),q=s.charCodeAt(n);while(P(q));return a=15}if(S(q))return n++,t+=String.fromCharCode(q),q===13&&s.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(q){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=I(),a=10;case 47:{const Y=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!S(s.charCodeAt(n));)n++;return t=s.substring(Y,n),a=12}if(s.charCodeAt(n+1)===42){n+=2;const K=i-1;let x=!1;for(;n<K;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,v=1),t=s.substring(Y,n),a=13}return t+=String.fromCharCode(q),n++,a=16}case 45:if(t+=String.fromCharCode(q),n++,n===i||!b(s.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=y(),a=11;default:for(;n<i&&M(q);)n++,q=s.charCodeAt(n);if(r!==n){switch(t=s.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(q),n++,a=16}}function M(q){if(P(q)||S(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let q;do q=T();while(q>=12&&q<=15);return q}return{setPosition:f,getPosition:()=>n,scan:o?U:T,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}e.$3m=O;function P(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function b(s){return s>=48&&s<=57}var C;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(C||(C={}));function k(s,o){const n=[],i=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function v(m,f,y,I){r.value=m,r.offset=f,r.length=y,r.type=I,r.colonOffset=void 0,t=r}try{h(s,{onObjectBegin:(m,f)=>{if(o<=m)throw i;t=void 0,a=o>m,n.push("")},onObjectProperty:(m,f,y)=>{if(o<f||(v(m,f,y,"property"),n[n.length-1]=m,o<=f+y))throw i},onObjectEnd:(m,f)=>{if(o<=m)throw i;t=void 0,n.pop()},onArrayBegin:(m,f)=>{if(o<=m)throw i;t=void 0,n.push(0)},onArrayEnd:(m,f)=>{if(o<=m)throw i;t=void 0,n.pop()},onLiteralValue:(m,f,y)=>{if(o<f||(v(m,f,y,E(m)),o<=f+y))throw i},onSeparator:(m,f,y)=>{if(o<=f)throw i;if(m===":"&&t&&t.type==="property")t.colonOffset=f,a=!1,t=void 0;else if(m===","){const I=n[n.length-1];typeof I=="number"?n[n.length-1]=I+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(m){if(m!==i)throw m}return{path:n,previousNode:t,isAtPropertyKey:a,matches:m=>{let f=0;for(let y=0;f<m.length&&y<n.length;y++)if(m[f]===n[y]||m[f]==="*")f++;else if(m[f]!=="**")return!1;return f===m.length}}}e.$4m=k;function g(s,o=[],n=j.DEFAULT){let i=null,t=[];const r=[];function a(m){Array.isArray(t)?t.push(m):i!==null&&(t[i]=m)}return h(s,{onObjectBegin:()=>{const m={};a(m),r.push(t),t=m,i=null},onObjectProperty:m=>{i=m},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const m=[];a(m),r.push(t),t=m,i=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(m,f,y)=>{o.push({error:m,offset:f,length:y})}},n),t[0]}e.$5m=g;function c(s,o=[],n=j.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(m){i.type==="property"&&(i.length=m-i.offset,i=i.parent)}function r(m){return i.children.push(m),m}h(s,{onObjectBegin:m=>{i=r({type:"object",offset:m,length:-1,parent:i,children:[]})},onObjectProperty:(m,f,y)=>{i=r({type:"property",offset:f,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:m,offset:f,length:y,parent:i})},onObjectEnd:(m,f)=>{i.length=m+f-i.offset,i=i.parent,t(m+f)},onArrayBegin:(m,f)=>{i=r({type:"array",offset:m,length:-1,parent:i,children:[]})},onArrayEnd:(m,f)=>{i.length=m+f-i.offset,i=i.parent,t(m+f)},onLiteralValue:(m,f,y)=>{r({type:E(m),offset:f,length:y,parent:i,value:m}),t(f+y)},onSeparator:(m,f,y)=>{i.type==="property"&&(m===":"?i.colonOffset=f:m===","&&t(f))},onError:(m,f,y)=>{o.push({error:m,offset:f,length:y})}},n);const v=i.children[0];return v&&delete v.parent,v}e.$6m=c;function $(s,o){if(!s)return;let n=s;for(const i of o)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===i){n=r.children[1],t=!0;break}if(!t)return}else{const t=i;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$7m=$;function p(s){if(!s.parent||!s.parent.children)return[];const o=p(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;o.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&o.push(n)}return o}e.$8m=p;function w(s){switch(s.type){case"array":return s.children.map(w);case"object":{const o=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(o[n.children[0].value]=w(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$9m=w;function l(s,o,n=!1){return o>=s.offset&&o<s.offset+s.length||n&&o===s.offset+s.length}e.$0m=l;function u(s,o,n=!1){if(l(s,o,n)){const i=s.children;if(Array.isArray(i))for(let t=0;t<i.length&&i[t].offset<=o;t++){const r=u(i[t],o,n);if(r)return r}return s}}e.$$m=u;function h(s,o,n=j.DEFAULT){const i=O(s,!1);function t(_){return _?()=>_(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(_){return _?se=>_(se,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),v=r(o.onObjectProperty),m=t(o.onObjectEnd),f=t(o.onArrayBegin),y=t(o.onArrayEnd),I=r(o.onLiteralValue),T=r(o.onSeparator),M=t(o.onComment),U=r(o.onError),q=n&&n.disallowComments,Y=n&&n.allowTrailingComma;function K(){for(;;){const _=i.scan();switch(i.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:q||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(_){case 12:case 13:q?x(10):M();break;case 16:x(1);break;case 15:case 14:break;default:return _}}}function x(_,se=[],X=[]){if(U(_),se.length+X.length>0){let z=i.getToken();for(;z!==17;){if(se.indexOf(z)!==-1){K();break}else if(X.indexOf(z)!==-1)break;z=K()}}}function H(_){const se=i.getTokenValue();return _?I(se):v(se),K(),!0}function Q(){switch(i.getToken()){case 11:{let _=0;try{_=JSON.parse(i.getTokenValue()),typeof _!="number"&&(x(2),_=0)}catch{x(2)}I(_);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return K(),!0}function J(){return i.getToken()!==10?(x(3,[],[2,5]),!1):(H(!1),i.getToken()===6?(T(":"),K(),ne()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function W(){a(),K();let _=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),T(","),K(),i.getToken()===2&&Y)break}else _&&x(6,[],[]);J()||x(4,[],[2,5]),_=!0}return m(),i.getToken()!==2?x(7,[2],[]):K(),!0}function ee(){f(),K();let _=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),T(","),K(),i.getToken()===4&&Y)break}else _&&x(6,[],[]);ne()||x(4,[],[4,5]),_=!0}return y(),i.getToken()!==4?x(8,[4],[]):K(),!0}function ne(){switch(i.getToken()){case 3:return ee();case 1:return W();case 10:return H(!0);default:return Q()}}return K(),i.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):ne()?(i.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$_m=h;function d(s,o){const n=O(s),i=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&i.push(s.substring(r,a)),o!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return i.join("")}e.$an=d;function E(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$bn=E}),define(ae[42],ce([0,1,35]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yT=e.$xT=e.$wT=e.$vT=void 0;function A(b,C,k){let g,c,$,p,w;if(C){for(p=C.offset,w=p+C.length,$=p;$>0&&!S(b,$-1);)$--;let a=w;for(;a<b.length&&!S(b,a);)a++;c=b.substring($,a),g=O(c,k)}else c=b,g=0,$=0,p=0,w=b.length;const l=P(k,b);let u=!1,h=0,d;k.insertSpaces?d=j(" ",k.tabSize||4):d="	";const E=(0,D.$3m)(c,!1);let s=!1;function o(){return l+j(d,g+h)}function n(){let a=E.scan();for(u=!1;a===15||a===14;)u=u||a===14,a=E.scan();return s=a===16||E.getTokenError()!==0,a}const i=[];function t(a,v,m){!s&&v<w&&m>p&&b.substring(v,m)!==a&&i.push({offset:v,length:m-v,content:a})}let r=n();if(r!==17){const a=E.getTokenOffset()+$,v=j(d,g);t(v,$,a)}for(;r!==17;){let a=E.getTokenOffset()+E.getTokenLength()+$,v=n(),m="";for(;!u&&(v===12||v===13);){const y=E.getTokenOffset()+$;t(" ",a,y),a=E.getTokenOffset()+E.getTokenLength()+$,m=v===12?o():"",v=n()}if(v===2)r!==1&&(h--,m=o());else if(v===4)r!==3&&(h--,m=o());else{switch(r){case 3:case 1:h++,m=o();break;case 5:case 12:m=o();break;case 13:u?m=o():m=" ";break;case 6:m=" ";break;case 10:if(v===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?m=" ":v!==5&&v!==17&&(s=!0);break;case 16:s=!0;break}u&&(v===12||v===13)&&(m=o())}const f=E.getTokenOffset()+$;t(m,a,f),r=v}return i}e.$vT=A;function L(b,C){const k=JSON.stringify(b,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?k.replace(/\r\n|\r|\n/g,C.eol):k}e.$wT=L;function j(b,C){let k="";for(let g=0;g<C;g++)k+=b;return k}function O(b,C){let k=0,g=0;const c=C.tabSize||4;for(;k<b.length;){const $=b.charAt(k);if($===" ")g++;else if($==="	")g+=c;else break;k++}return Math.floor(g/c)}function P(b,C){for(let k=0;k<C.length;k++){const g=C.charAt(k);if(g==="\r")return k+1<C.length&&C.charAt(k+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return b&&b.eol||`
`}e.$xT=P;function S(b,C){return`\r
`.indexOf(b.charAt(C))!==-1}e.$yT=S}),define(ae[86],ce([0,1,35,42]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DT=e.$CT=e.$BT=e.$AT=e.$zT=void 0;function L(b,C,k){return j(b,C,void 0,k)}e.$zT=L;function j(b,C,k,g,c){const $=C.slice(),p=[],w=(0,D.$6m)(b,p);let l,u;for(;$.length>0&&(u=$.pop(),l=(0,D.$7m)(w,$),l===void 0&&k!==void 0);)typeof u=="string"?k={[u]:k}:k=[k];if(l)if(l.type==="object"&&typeof u=="string"&&Array.isArray(l.children)){const h=(0,D.$7m)(l,[u]);if(h!==void 0)if(k===void 0){if(!h.parent)throw new Error("Malformed AST");const d=l.children.indexOf(h.parent);let E,s=h.parent.offset+h.parent.length;if(d>0){const o=l.children[d-1];E=o.offset+o.length}else E=l.offset+1,l.children.length>1&&(s=l.children[1].offset);return O(b,{offset:E,length:s-E,content:""},g)}else return O(b,{offset:h.offset,length:h.length,content:JSON.stringify(k)},g);else{if(k===void 0)return[];const d=`${JSON.stringify(u)}: ${JSON.stringify(k)}`,E=c?c(l.children.map(o=>o.children[0].value)):l.children.length;let s;if(E>0){const o=l.children[E-1];s={offset:o.offset+o.length,length:0,content:","+d}}else l.children.length===0?s={offset:l.offset+1,length:0,content:d}:s={offset:l.offset+1,length:0,content:d+","};return O(b,s,g)}}else if(l.type==="array"&&typeof u=="number"&&Array.isArray(l.children))if(k!==void 0){const h=`${JSON.stringify(k)}`;let d;if(l.children.length===0||u===0)d={offset:l.offset+1,length:0,content:l.children.length===0?h:h+","};else{const E=u===-1||u>l.children.length?l.children.length:u,s=l.children[E-1];d={offset:s.offset+s.length,length:0,content:","+h}}return O(b,d,g)}else{const h=u,d=l.children[h];let E;if(l.children.length===1)E={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===h){const s=l.children[h-1],o=s.offset+s.length,n=l.offset+l.length;E={offset:o,length:n-2-o,content:""}}else E={offset:d.offset,length:l.children[h+1].offset-d.offset,content:""};return O(b,E,g)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${l.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return O(b,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(k)},g)}}e.$AT=j;function O(b,C,k){let g=P(b,C),c=C.offset,$=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;c>0&&!(0,A.$yT)(g,c-1);)c--;for(;$<g.length&&!(0,A.$yT)(g,$);)$++}const p=(0,A.$vT)(g,{offset:c,length:$-c},k);for(let l=p.length-1;l>=0;l--){const u=p[l];g=P(g,u),c=Math.min(c,u.offset),$=Math.max($,u.offset+u.length),$+=u.content.length-u.length}const w=b.length-(g.length-$)-c;return[{offset:c,length:w,content:g.substring(c,$)}]}e.$BT=O;function P(b,C){return b.substring(0,C.offset)+C.content+b.substring(C.offset+C.length)}e.$CT=P;function S(b,C){const k=C.slice(0).sort((c,$)=>{const p=c.offset-$.offset;return p===0?c.length-$.length:p});let g=b.length;for(let c=k.length-1;c>=0;c--){const $=k[c];if($.offset+$.length<=g)b=P(b,$);else throw new Error("Overlapping edit");g=$.offset}return b}e.$DT=S}),define(ae[61],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class D{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=D}),define(ae[87],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(j){this.element=j,this.next=D.Undefined,this.prev=D.Undefined}}class A{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let j=this.a;for(;j!==D.Undefined;){const O=j.next;j.prev=D.Undefined,j.next=D.Undefined,j=O}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,O){const P=new D(j);if(this.a===D.Undefined)this.a=P,this.b=P;else if(O){const b=this.b;this.b=P,P.prev=b,b.next=P}else{const b=this.a;this.a=P,P.next=b,b.prev=P}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(P))}}shift(){if(this.a!==D.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==D.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==D.Undefined&&j.next!==D.Undefined){const O=j.prev;O.next=j.next,j.next.prev=O}else j.prev===D.Undefined&&j.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):j.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):j.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==D.Undefined;)yield j.element,j=j.next}}e.$2c=A}),define(ae[34],ce([0,1]),function(ie,e){"use strict";var D,A,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function j(u,h,d){let E=u.get(h);return E===void 0&&(E=d,u.set(h,E)),E}e.$wc=j;function O(u){const h=[];return u.forEach((d,E)=>{h.push(`${E} => ${d}`)}),`Map(${u.size}) {${h.join(", ")}}`}e.$xc=O;function P(u){const h=[];return u.forEach(d=>{h.push(d)}),`Set(${u.size}) {${h.join(", ")}}`}e.$yc=P;class S{constructor(h,d){this.uri=h,this.value=d}}function b(u){return Array.isArray(u)}class C{static{this.a=h=>h.toString()}constructor(h,d){if(this[D]="ResourceMap",h instanceof C)this.b=new Map(h.b),this.c=d??C.a;else if(b(h)){this.b=new Map,this.c=d??C.a;for(const[E,s]of h)this.set(E,s)}else this.b=new Map,this.c=h??C.a}set(h,d){return this.b.set(this.c(h),new S(h,d)),this}get(h){return this.b.get(this.c(h))?.value}has(h){return this.b.has(this.c(h))}get size(){return this.b.size}clear(){this.b.clear()}delete(h){return this.b.delete(this.c(h))}forEach(h,d){typeof d<"u"&&(h=h.bind(d));for(const[E,s]of this.b)h(s.value,s.uri,this)}*values(){for(const h of this.b.values())yield h.value}*keys(){for(const h of this.b.values())yield h.uri}*entries(){for(const h of this.b.values())yield[h.uri,h.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.b)yield[h.uri,h.value]}}e.$zc=C;class k{constructor(h,d){this[A]="ResourceSet",!h||typeof h=="function"?this.a=new C(h):(this.a=new C(d),h.forEach(this.add,this))}get size(){return this.a.size}add(h){return this.a.set(h,h),this}clear(){this.a.clear()}delete(h){return this.a.delete(h)}forEach(h,d){this.a.forEach((E,s)=>h.call(d,s,s,this))}has(h){return this.a.has(h)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=k;var g;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(g||(e.Touch=g={}));class c{constructor(){this[L]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(h){return this.a.has(h)}get(h,d=0){const E=this.a.get(h);if(E)return d!==0&&this.j(E,d),E.value}set(h,d,E=0){let s=this.a.get(h);if(s)s.value=d,E!==0&&this.j(s,E);else{switch(s={key:h,value:d,next:void 0,previous:void 0},E){case 0:this.h(s);break;case 1:this.g(s);break;case 2:this.h(s);break;default:this.h(s);break}this.a.set(h,s),this.d++}return this}delete(h){return!!this.remove(h)}remove(h){const d=this.a.get(h);if(d)return this.a.delete(h),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const h=this.b;return this.a.delete(h.key),this.i(h),this.d--,h.value}forEach(h,d){const E=this.e;let s=this.b;for(;s;){if(d?h.bind(d)(s.value,s.key,this):h(s.value,s.key,this),this.e!==E)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const h=this,d=this.e;let E=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==d)throw new Error("LinkedMap got modified during iteration.");if(E){const o={value:E.key,done:!1};return E=E.next,o}else return{value:void 0,done:!0}}};return s}values(){const h=this,d=this.e;let E=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==d)throw new Error("LinkedMap got modified during iteration.");if(E){const o={value:E.value,done:!1};return E=E.next,o}else return{value:void 0,done:!0}}};return s}entries(){const h=this,d=this.e;let E=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==d)throw new Error("LinkedMap got modified during iteration.");if(E){const o={value:[E.key,E.value],done:!1};return E=E.next,o}else return{value:void 0,done:!0}}};return s}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(h){if(h>=this.size)return;if(h===0){this.clear();return}let d=this.b,E=this.size;for(;d&&E>h;)this.a.delete(d.key),d=d.next,E--;this.b=d,this.d=E,d&&(d.previous=void 0),this.e++}g(h){if(!this.b&&!this.c)this.c=h;else if(this.b)h.next=this.b,this.b.previous=h;else throw new Error("Invalid list");this.b=h,this.e++}h(h){if(!this.b&&!this.c)this.b=h;else if(this.c)h.previous=this.c,this.c.next=h;else throw new Error("Invalid list");this.c=h,this.e++}i(h){if(h===this.b&&h===this.c)this.b=void 0,this.c=void 0;else if(h===this.b){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.b=h.next}else if(h===this.c){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.c=h.previous}else{const d=h.next,E=h.previous;if(!d||!E)throw new Error("Invalid list");d.previous=E,E.next=d}h.next=void 0,h.previous=void 0,this.e++}j(h,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(h===this.b)return;const E=h.next,s=h.previous;h===this.c?(s.next=void 0,this.c=s):(E.previous=s,s.next=E),h.previous=void 0,h.next=this.b,this.b.previous=h,this.b=h,this.e++}else if(d===2){if(h===this.c)return;const E=h.next,s=h.previous;h===this.b?(E.previous=void 0,this.b=E):(E.previous=s,s.next=E),h.next=void 0,h.previous=this.c,this.c.next=h,this.c=h,this.e++}}}toJSON(){const h=[];return this.forEach((d,E)=>{h.push([E,d])}),h}fromJSON(h){this.clear();for(const[d,E]of h)this.set(d,E)}}e.$Bc=c;class $ extends c{constructor(h,d=1){super(),this.k=h,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(h){this.k=h,this.m()}get ratio(){return this.l}set ratio(h){this.l=Math.min(Math.max(0,h),1),this.m()}get(h,d=2){return super.get(h,d)}peek(h){return super.get(h,0)}set(h,d){return super.set(h,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=$;class p{constructor(){this.a=new Map}add(h){return this.a.set(h,(this.a.get(h)||0)+1),this}delete(h){let d=this.a.get(h)||0;return d===0?!1:(d--,d===0?this.a.delete(h):this.a.set(h,d),!0)}has(h){return this.a.has(h)}}e.$Dc=p;class w{constructor(h){if(this.a=new Map,this.b=new Map,h)for(const[d,E]of h)this.set(d,E)}clear(){this.a.clear(),this.b.clear()}set(h,d){this.a.set(h,d),this.b.set(d,h)}get(h){return this.a.get(h)}getKey(h){return this.b.get(h)}delete(h){const d=this.a.get(h);return d===void 0?!1:(this.a.delete(h),this.b.delete(d),!0)}forEach(h,d){this.a.forEach((E,s)=>{h.call(d,E,s,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=w;class l{constructor(){this.a=new Map}add(h,d){let E=this.a.get(h);E||(E=new Set,this.a.set(h,E)),E.add(d)}delete(h,d){const E=this.a.get(h);E&&(E.delete(d),E.size===0&&this.a.delete(h))}forEach(h,d){const E=this.a.get(h);E&&E.forEach(d)}get(h){const d=this.a.get(h);return d||new Set}}e.$Fc=l}),define(ae[2],ce([0,1,18,125,34,85,60]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const P=!1;let S=null;class b{constructor(){this.b=new Map}static{this.a=0}c(I){let T=this.b.get(I);return T||(T={parent:null,source:null,isSingleton:!1,value:I,idx:b.a++},this.b.set(I,T)),T}trackDisposable(I){const T=this.c(I);T.source||(T.source=new Error().stack)}setParent(I,T){const M=this.c(I);M.parent=T}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,T){const M=T.get(I);if(M)return M;const U=I.parent?this.f(this.c(I.parent),T):I;return T.set(I,U),U}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,M])=>M.source!==null&&!this.f(M,I).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables(I=10,T){let M;if(T)M=T;else{const x=new Map,H=[...this.b.values()].filter(J=>J.source!==null&&!this.f(J,x).isSingleton);if(H.length===0)return;const Q=new Set(H.map(J=>J.value));if(M=H.filter(J=>!(J.parent&&Q.has(J.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function U(x){function H(J,W){for(;J.length>0&&W.some(ee=>typeof ee=="string"?ee===J[0]:J[0].match(ee));)J.shift()}const Q=x.source.split(`
`).map(J=>J.trim().replace("at ","")).filter(J=>J!=="");return H(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const q=new L.$Fc;for(const x of M){const H=U(x);for(let Q=0;Q<=H.length;Q++)q.add(H.slice(0,Q).join(`
`),x)}M.sort((0,D.$6b)(x=>x.idx,D.$8b));let Y="",K=0;for(const x of M.slice(0,I)){K++;const H=U(x),Q=[];for(let J=0;J<H.length;J++){let W=H[J];W=`(shared with ${q.get(H.slice(0,J+1).join(`
`)).size}/${M.length} leaks) at ${W}`;const ne=q.get(H.slice(0,J).join(`
`)),_=(0,A.$J)([...ne].map(se=>U(se)[J]),se=>se);delete _[H[J]];for(const[se,X]of Object.entries(_))Q.unshift(`    - stacktraces of ${X.length} other leaks continue with ${se}`);Q.unshift(W)}Y+=`


==================== Leaking disposable ${K}/${M.length}: ${x.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return M.length>I&&(Y+=`


... and ${M.length-I} more leaking disposables

`),{leaks:M,details:Y}}}e.$Gc=b;function C(y){S=y}if(e.$Hc=C,P){const y="__is_disposable_tracked__";C(new class{trackDisposable(I){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[y]||console.log(T)},3e3)}setParent(I,T){if(I&&I!==s.None)try{I[y]=!0}catch{}}markAsDisposed(I){if(I&&I!==s.None)try{I[y]=!0}catch{}}markAsSingleton(I){}})}function k(y){return S?.trackDisposable(y),y}e.$Ic=k;function g(y){S?.markAsDisposed(y)}e.$Jc=g;function c(y,I){S?.setParent(y,I)}function $(y,I){if(S)for(const T of y)S.setParent(T,I)}function p(y){return S?.markAsSingleton(y),y}e.$Kc=p;function w(y){return typeof y.dispose=="function"&&y.dispose.length===0}e.$Lc=w;function l(y){if(O.Iterable.is(y)){const I=[];for(const T of y)if(T)try{T.dispose()}catch(M){I.push(M)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}e.$Mc=l;function u(y){for(const I of y)w(I)&&I.dispose();return[]}e.$Nc=u;function h(...y){const I=d(()=>l(y));return $(y,I),I}e.$Oc=h;function d(y){const I=k({dispose:(0,j.$cb)(()=>{g(I),y()})});return I}e.$Pc=d;class E{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,k(this)}dispose(){this.g||(g(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return c(I,this),this.g?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),c(I,null))}}e.$Qc=E;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new E,k(this),c(this.q,this)}dispose(){g(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Rc=s;class o{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&c(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&c(I,null),I}}e.$Sc=o;class n{constructor(I){this.a=new o,this.b=!1,this.a.value=I}get value(){return this.a.value}set value(I){this.b||I===this.a.value||(this.a.value=I)}dispose(){this.b=!0,this.a.dispose()}}e.$Tc=n;class i{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=i;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(I){let T=I;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,g(this))},this}}e.$Vc=t;class r{constructor(){this.a=new Map}acquire(I,...T){let M=this.a.get(I);M||(M={counter:0,object:this.b(I,...T)},this.a.set(I,M));const{object:U}=M,q=(0,j.$cb)(()=>{--M.counter===0&&(this.c(I,M.object),this.a.delete(I))});return M.counter++,{object:U,dispose:q}}}e.$Wc=r;class a{constructor(I){this.a=I}async acquire(I,...T){const M=this.a.acquire(I,...T);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(U){throw M.dispose(),U}}}e.$Xc=a;class v{constructor(I){this.object=I}dispose(){}}e.$Yc=v;function m(y){const I=new E;try{y(I)}finally{I.dispose()}}e.$Zc=m;class f{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,T,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(I)?.dispose(),this.a.set(I,T)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=f}),define(ae[88],ce([0,1,34]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=e.$wl=void 0;const A=new D.$Cc(1e4);function L(b){return S(b,"NFC",A)}e.$wl=L;const j=new D.$Cc(1e4);function O(b){return S(b,"NFD",j)}e.$xl=O;const P=/[^\u0000-\u0080]/;function S(b,C,k){if(!b)return b;const g=k.get(b);if(g)return g;let c;return P.test(b)?c=b.normalize(C):c=b,k.set(b,c),c}e.$yl=function(){const b=/[\u0300-\u036f]/g;return function(C){return O(C).replace(b,"")}}()}),function(){function ie(L){const j=[];typeof L=="number"&&j.push("code/timeOrigin",L);function O(S){j.push(S,Date.now())}function P(){const S=[];for(let b=0;b<j.length;b+=2)S.push({name:j[b],startTime:j[b+1]});return S}return{mark:O,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const O of performance.getEntriesByType("mark"))j.push({name:O.name,startTime:Math.round(L+O.startTime)});return j}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function D(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=D(A))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var A in D)(typeof exports=="object"?exports:ie)[A]=D[A]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function D(A){if(e[A])return e[A].exports;var L=e[A]={i:A,l:!1,exports:{}};return ie[A].call(L.exports,L,L.exports,D),L.l=!0,L.exports}return D.m=ie,D.c=e,D.d=function(A,L,j){D.o(A,L)||Object.defineProperty(A,L,{enumerable:!0,get:j})},D.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},D.t=function(A,L){if(1&L&&(A=D(A)),8&L||4&L&&typeof A=="object"&&A&&A.__esModule)return A;var j=Object.create(null);if(D.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:A}),2&L&&typeof A!="string")for(var O in A)D.d(j,O,function(P){return A[P]}.bind(null,O));return j},D.n=function(A){var L=A&&A.__esModule?function(){return A.default}:function(){return A};return D.d(L,"a",L),L},D.o=function(A,L){return Object.prototype.hasOwnProperty.call(A,L)},D.p="",D(D.s=0)}([function(ie,e,D){(function(A){var L;e=ie.exports=X,L=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],S=e.src=[],b=0,C=b++;S[C]="0|[1-9]\\d*";var k=b++;S[k]="[0-9]+";var g=b++;S[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var c=b++;S[c]="("+S[C]+")\\.("+S[C]+")\\.("+S[C]+")";var $=b++;S[$]="("+S[k]+")\\.("+S[k]+")\\.("+S[k]+")";var p=b++;S[p]="(?:"+S[C]+"|"+S[g]+")";var w=b++;S[w]="(?:"+S[k]+"|"+S[g]+")";var l=b++;S[l]="(?:-("+S[p]+"(?:\\."+S[p]+")*))";var u=b++;S[u]="(?:-?("+S[w]+"(?:\\."+S[w]+")*))";var h=b++;S[h]="[0-9A-Za-z-]+";var d=b++;S[d]="(?:\\+("+S[h]+"(?:\\."+S[h]+")*))";var E=b++,s="v?"+S[c]+S[l]+"?"+S[d]+"?";S[E]="^"+s+"$";var o="[v=\\s]*"+S[$]+S[u]+"?"+S[d]+"?",n=b++;S[n]="^"+o+"$";var i=b++;S[i]="((?:<|>)?=?)";var t=b++;S[t]=S[k]+"|x|X|\\*";var r=b++;S[r]=S[C]+"|x|X|\\*";var a=b++;S[a]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[l]+")?"+S[d]+"?)?)?";var v=b++;S[v]="[v=\\s]*("+S[t]+")(?:\\.("+S[t]+")(?:\\.("+S[t]+")(?:"+S[u]+")?"+S[d]+"?)?)?";var m=b++;S[m]="^"+S[i]+"\\s*"+S[a]+"$";var f=b++;S[f]="^"+S[i]+"\\s*"+S[v]+"$";var y=b++;S[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=b++;S[I]="(?:~>?)";var T=b++;S[T]="(\\s*)"+S[I]+"\\s+",P[T]=new RegExp(S[T],"g");var M=b++;S[M]="^"+S[I]+S[a]+"$";var U=b++;S[U]="^"+S[I]+S[v]+"$";var q=b++;S[q]="(?:\\^)";var Y=b++;S[Y]="(\\s*)"+S[q]+"\\s+",P[Y]=new RegExp(S[Y],"g");var K=b++;S[K]="^"+S[q]+S[a]+"$";var x=b++;S[x]="^"+S[q]+S[v]+"$";var H=b++;S[H]="^"+S[i]+"\\s*("+o+")$|^$";var Q=b++;S[Q]="^"+S[i]+"\\s*("+s+")$|^$";var J=b++;S[J]="(\\s*)"+S[i]+"\\s*("+o+"|"+S[a]+")",P[J]=new RegExp(S[J],"g");var W=b++;S[W]="^\\s*("+S[a]+")\\s+-\\s+("+S[a]+")\\s*$";var ee=b++;S[ee]="^\\s*("+S[v]+")\\s+-\\s+("+S[v]+")\\s*$";var ne=b++;S[ne]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)L(_,S[_]),P[_]||(P[_]=new RegExp(S[_]));function se(le,$e){if(le instanceof X)return le;if(typeof le!="string"||le.length>j||!($e?P[n]:P[E]).test(le))return null;try{return new X(le,$e)}catch{return null}}function X(le,$e){if(le instanceof X){if(le.loose===$e)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof X))return new X(le,$e);L("SemVer",le,$e),this.loose=$e;var be=le.trim().match($e?P[n]:P[E]);if(!be)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Ce=+Se;if(Ce>=0&&Ce<O)return Ce}return Se}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=se,e.valid=function(le,$e){var be=se(le,$e);return be?be.version:null},e.clean=function(le,$e){var be=se(le.trim().replace(/^[=v]+/,""),$e);return be?be.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(le){return L("SemVer.compare",this.version,this.loose,le),le instanceof X||(le=new X(le,this.loose)),this.compareMain(le)||this.comparePre(le)},X.prototype.compareMain=function(le){return le instanceof X||(le=new X(le,this.loose)),R(this.major,le.major)||R(this.minor,le.minor)||R(this.patch,le.patch)},X.prototype.comparePre=function(le){if(le instanceof X||(le=new X(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var $e=0;do{var be=this.prerelease[$e],Se=le.prerelease[$e];if(L("prerelease compare",$e,be,Se),be===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(be===void 0)return-1;if(be!==Se)return R(be,Se)}while(++$e)},X.prototype.inc=function(le,$e){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",$e);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",$e);break;case"prepatch":this.prerelease.length=0,this.inc("patch",$e),this.inc("pre",$e);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",$e),this.inc("pre",$e);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}$e&&(this.prerelease[0]===$e?isNaN(this.prerelease[1])&&(this.prerelease=[$e,0]):this.prerelease=[$e,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,$e,be,Se){typeof be=="string"&&(Se=be,be=void 0);try{return new X(le,be).inc($e,Se).version}catch{return null}},e.diff=function(le,$e){if(V(le,$e))return null;var be=se(le),Se=se($e);if(be.prerelease.length||Se.prerelease.length){for(var Ce in be)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&be[Ce]!==Se[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in be)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&be[Ce]!==Se[Ce])return Ce},e.compareIdentifiers=R;var z=/^[0-9]+$/;function R(le,$e){var be=z.test(le),Se=z.test($e);return be&&Se&&(le=+le,$e=+$e),be&&!Se?-1:Se&&!be?1:le<$e?-1:le>$e?1:0}function F(le,$e,be){return new X(le,be).compare(new X($e,be))}function B(le,$e,be){return F(le,$e,be)>0}function N(le,$e,be){return F(le,$e,be)<0}function V(le,$e,be){return F(le,$e,be)===0}function G(le,$e,be){return F(le,$e,be)!==0}function te(le,$e,be){return F(le,$e,be)>=0}function oe(le,$e,be){return F(le,$e,be)<=0}function ue(le,$e,be,Se){var Ce;switch($e){case"===":typeof le=="object"&&(le=le.version),typeof be=="object"&&(be=be.version),Ce=le===be;break;case"!==":typeof le=="object"&&(le=le.version),typeof be=="object"&&(be=be.version),Ce=le!==be;break;case"":case"=":case"==":Ce=V(le,be,Se);break;case"!=":Ce=G(le,be,Se);break;case">":Ce=B(le,be,Se);break;case">=":Ce=te(le,be,Se);break;case"<":Ce=N(le,be,Se);break;case"<=":Ce=oe(le,be,Se);break;default:throw new TypeError("Invalid operator: "+$e)}return Ce}function he(le,$e){if(le instanceof he){if(le.loose===$e)return le;le=le.value}if(!(this instanceof he))return new he(le,$e);L("comparator",le,$e),this.loose=$e,this.parse(le),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(le,$e){return R($e,le)},e.major=function(le,$e){return new X(le,$e).major},e.minor=function(le,$e){return new X(le,$e).minor},e.patch=function(le,$e){return new X(le,$e).patch},e.compare=F,e.compareLoose=function(le,$e){return F(le,$e,!0)},e.rcompare=function(le,$e,be){return F($e,le,be)},e.sort=function(le,$e){return le.sort(function(be,Se){return e.compare(be,Se,$e)})},e.rsort=function(le,$e){return le.sort(function(be,Se){return e.rcompare(be,Se,$e)})},e.gt=B,e.lt=N,e.eq=V,e.neq=G,e.gte=te,e.lte=oe,e.cmp=ue,e.Comparator=he;var ge={};function de(le,$e){if(le instanceof de)return le.loose===$e?le:new de(le.raw,$e);if(le instanceof he)return new de(le.value,$e);if(!(this instanceof de))return new de(le,$e);if(this.loose=$e,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function we(le){return!le||le.toLowerCase()==="x"||le==="*"}function ve(le,$e,be,Se,Ce,Ue,je,ze,Te,re,fe,me,ye){return(($e=we(be)?"":we(Se)?">="+be+".0.0":we(Ce)?">="+be+"."+Se+".0":">="+$e)+" "+(ze=we(Te)?"":we(re)?"<"+(+Te+1)+".0.0":we(fe)?"<"+Te+"."+(+re+1)+".0":me?"<="+Te+"."+re+"."+fe+"-"+me:"<="+ze)).trim()}function Ie(le,$e){for(var be=0;be<le.length;be++)if(!le[be].test($e))return!1;if($e.prerelease.length){for(be=0;be<le.length;be++)if(L(le[be].semver),le[be].semver!==ge&&le[be].semver.prerelease.length>0){var Se=le[be].semver;if(Se.major===$e.major&&Se.minor===$e.minor&&Se.patch===$e.patch)return!0}return!1}return!0}function Ne(le,$e,be){try{$e=new de($e,be)}catch{return!1}return $e.test(le)}function Me(le,$e,be,Se){var Ce,Ue,je,ze,Te;switch(le=new X(le,Se),$e=new de($e,Se),be){case">":Ce=B,Ue=oe,je=N,ze=">",Te=">=";break;case"<":Ce=N,Ue=te,je=B,ze="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(le,$e,Se))return!1;for(var re=0;re<$e.set.length;++re){var fe=$e.set[re],me=null,ye=null;if(fe.forEach(function(ke){ke.semver===ge&&(ke=new he(">=0.0.0")),me=me||ke,ye=ye||ke,Ce(ke.semver,me.semver,Se)?me=ke:je(ke.semver,ye.semver,Se)&&(ye=ke)}),me.operator===ze||me.operator===Te||(!ye.operator||ye.operator===ze)&&Ue(le,ye.semver)||ye.operator===Te&&je(le,ye.semver))return!1}return!0}he.prototype.parse=function(le){var $e=this.loose?P[H]:P[Q],be=le.match($e);if(!be)throw new TypeError("Invalid comparator: "+le);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new X(be[2],this.loose):this.semver=ge},he.prototype.toString=function(){return this.value},he.prototype.test=function(le){return L("Comparator.test",le,this.loose),this.semver===ge||(typeof le=="string"&&(le=new X(le,this.loose)),ue(le,this.operator,this.semver,this.loose))},he.prototype.intersects=function(le,$e){if(!(le instanceof he))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(le.value,$e),Ne(this.value,be,$e);if(le.operator==="")return be=new de(this.value,$e),Ne(le.semver,be,$e);var Se=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Ue=this.semver.version===le.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),ze=ue(this.semver,"<",le.semver,$e)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Te=ue(this.semver,">",le.semver,$e)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Se||Ce||Ue&&je||ze||Te},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(le){var $e=this.loose;le=le.trim(),L("range",le,$e);var be=$e?P[ee]:P[W];le=le.replace(be,ve),L("hyphen replace",le),le=le.replace(P[J],"$1$2$3"),L("comparator trim",le,P[J]),le=(le=(le=le.replace(P[T],"$1~")).replace(P[Y],"$1^")).split(/\s+/).join(" ");var Se=$e?P[H]:P[Q],Ce=le.split(" ").map(function(Ue){return function(je,ze){return L("comp",je),je=function(Te,re){return Te.trim().split(/\s+/).map(function(fe){return function(me,ye){L("caret",me,ye);var ke=ye?P[x]:P[K];return me.replace(ke,function(Pe,Re,Oe,De,Ae){var Fe;return L("caret",me,Pe,Re,Oe,De,Ae),we(Re)?Fe="":we(Oe)?Fe=">="+Re+".0.0 <"+(+Re+1)+".0.0":we(De)?Fe=Re==="0"?">="+Re+"."+Oe+".0 <"+Re+"."+(+Oe+1)+".0":">="+Re+"."+Oe+".0 <"+(+Re+1)+".0.0":Ae?(L("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Fe=Re==="0"?Oe==="0"?">="+Re+"."+Oe+"."+De+Ae+" <"+Re+"."+Oe+"."+(+De+1):">="+Re+"."+Oe+"."+De+Ae+" <"+Re+"."+(+Oe+1)+".0":">="+Re+"."+Oe+"."+De+Ae+" <"+(+Re+1)+".0.0"):(L("no pr"),Fe=Re==="0"?Oe==="0"?">="+Re+"."+Oe+"."+De+" <"+Re+"."+Oe+"."+(+De+1):">="+Re+"."+Oe+"."+De+" <"+Re+"."+(+Oe+1)+".0":">="+Re+"."+Oe+"."+De+" <"+(+Re+1)+".0.0"),L("caret return",Fe),Fe})}(fe,re)}).join(" ")}(je,ze),L("caret",je),je=function(Te,re){return Te.trim().split(/\s+/).map(function(fe){return function(me,ye){var ke=ye?P[U]:P[M];return me.replace(ke,function(Pe,Re,Oe,De,Ae){var Fe;return L("tilde",me,Pe,Re,Oe,De,Ae),we(Re)?Fe="":we(Oe)?Fe=">="+Re+".0.0 <"+(+Re+1)+".0.0":we(De)?Fe=">="+Re+"."+Oe+".0 <"+Re+"."+(+Oe+1)+".0":Ae?(L("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Fe=">="+Re+"."+Oe+"."+De+Ae+" <"+Re+"."+(+Oe+1)+".0"):Fe=">="+Re+"."+Oe+"."+De+" <"+Re+"."+(+Oe+1)+".0",L("tilde return",Fe),Fe})}(fe,re)}).join(" ")}(je,ze),L("tildes",je),je=function(Te,re){return L("replaceXRanges",Te,re),Te.split(/\s+/).map(function(fe){return function(me,ye){me=me.trim();var ke=ye?P[f]:P[m];return me.replace(ke,function(Pe,Re,Oe,De,Ae,Fe){L("xRange",me,Pe,Re,Oe,De,Ae,Fe);var Be=we(Oe),qe=Be||we(De),We=qe||we(Ae);return Re==="="&&We&&(Re=""),Be?Pe=Re===">"||Re==="<"?"<0.0.0":"*":Re&&We?(qe&&(De=0),We&&(Ae=0),Re===">"?(Re=">=",qe?(Oe=+Oe+1,De=0,Ae=0):We&&(De=+De+1,Ae=0)):Re==="<="&&(Re="<",qe?Oe=+Oe+1:De=+De+1),Pe=Re+Oe+"."+De+"."+Ae):qe?Pe=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":We&&(Pe=">="+Oe+"."+De+".0 <"+Oe+"."+(+De+1)+".0"),L("xRange return",Pe),Pe})}(fe,re)}).join(" ")}(je,ze),L("xrange",je),je=function(Te,re){return L("replaceStars",Te,re),Te.trim().replace(P[ne],"")}(je,ze),L("stars",je),je}(Ue,$e)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Ue){return!!Ue.match(Se)})),Ce=Ce.map(function(Ue){return new he(Ue,$e)})},de.prototype.intersects=function(le,$e){if(!(le instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Se){return le.set.some(function(Ce){return Ce.every(function(Ue){return Se.intersects(Ue,$e)})})})})},e.toComparators=function(le,$e){return new de(le,$e).set.map(function(be){return be.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},de.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new X(le,this.loose));for(var $e=0;$e<this.set.length;$e++)if(Ie(this.set[$e],le))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(le,$e,be){var Se=null,Ce=null;try{var Ue=new de($e,be)}catch{return null}return le.forEach(function(je){Ue.test(je)&&(Se&&Ce.compare(je)!==-1||(Ce=new X(Se=je,be)))}),Se},e.minSatisfying=function(le,$e,be){var Se=null,Ce=null;try{var Ue=new de($e,be)}catch{return null}return le.forEach(function(je){Ue.test(je)&&(Se&&Ce.compare(je)!==1||(Ce=new X(Se=je,be)))}),Se},e.validRange=function(le,$e){try{return new de(le,$e).range||"*"}catch{return null}},e.ltr=function(le,$e,be){return Me(le,$e,"<",be)},e.gtr=function(le,$e,be){return Me(le,$e,">",be)},e.outside=Me,e.prerelease=function(le,$e){var be=se(le,$e);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(le,$e,be){return le=new de(le,be),$e=new de($e,be),le.intersects($e)},e.coerce=function(le){if(le instanceof X)return le;if(typeof le!="string")return null;var $e=le.match(P[y]);return $e==null?null:se(($e[1]||"0")+"."+($e[2]||"0")+"."+($e[3]||"0"))}}).call(this,D(1))},function(ie,e){var D,A,L=ie.exports={};function j(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function P(w){if(D===setTimeout)return setTimeout(w,0);if((D===j||!D)&&setTimeout)return D=setTimeout,setTimeout(w,0);try{return D(w,0)}catch{try{return D.call(null,w,0)}catch{return D.call(this,w,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:j}catch{D=j}try{A=typeof clearTimeout=="function"?clearTimeout:O}catch{A=O}})();var S,b=[],C=!1,k=-1;function g(){C&&S&&(C=!1,S.length?b=S.concat(b):k=-1,b.length&&c())}function c(){if(!C){var w=P(g);C=!0;for(var l=b.length;l;){for(S=b,b=[];++k<l;)S&&S[k].run();k=-1,l=b.length}S=null,C=!1,function(u){if(A===clearTimeout)return clearTimeout(u);if((A===O||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(u);try{A(u)}catch{try{return A.call(null,u)}catch{return A.call(this,u)}}}(w)}}function $(w,l){this.fun=w,this.array=l}function p(){}L.nextTick=function(w){var l=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)l[u-1]=arguments[u];b.push(new $(w,l)),b.length!==1||C||P(c)},$.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=p,L.addListener=p,L.once=p,L.off=p,L.removeListener=p,L.removeAllListeners=p,L.emit=p,L.prependListener=p,L.prependOnceListener=p,L.listeners=function(w){return[]},L.binding=function(w){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(w){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ae[127],ce([0,1]),function(ie,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=void 0;class A{constructor(P,S,b){this.level=P,this.key=S,this.value=b,this.forward=[]}}const L=void 0;class j{constructor(P,S=2**16){this.comparator=P,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(S)|0),this.e=new A(this.c,L,L)}get size(){return this.f}clear(){this.e=new A(this.c,L,L),this.f=0}has(P){return!!j.g(this,P,this.comparator)}get(P){return j.g(this,P,this.comparator)?.value}set(P,S){return j.h(this,P,S,this.comparator)&&(this.f+=1),this}delete(P){const S=j.k(this,P,this.comparator);return S&&(this.f-=1),S}forEach(P,S){let b=this.e.forward[0];for(;b;)P.call(S,b.value,b.key,this),b=b.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",S=this.e.forward[0];for(;S;)P+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return P}static g(P,S,b){let C=P.e;for(let k=P.d-1;k>=0;k--)for(;C.forward[k]&&b(C.forward[k].key,S)<0;)C=C.forward[k];if(C=C.forward[0],C&&b(C.key,S)===0)return C}static h(P,S,b,C){const k=[];let g=P.e;for(let c=P.d-1;c>=0;c--){for(;g.forward[c]&&C(g.forward[c].key,S)<0;)g=g.forward[c];k[c]=g}if(g=g.forward[0],g&&C(g.key,S)===0)return g.value=b,!1;{const c=j.j(P);if(c>P.d){for(let $=P.d;$<c;$++)k[$]=P.e;P.d=c}g=new A(c,S,b);for(let $=0;$<c;$++)g.forward[$]=k[$].forward[$],k[$].forward[$]=g;return!0}}static j(P,S=.5){let b=1;for(;Math.random()<S&&b<P.c;)b+=1;return b}static k(P,S,b){const C=[];let k=P.e;for(let g=P.d-1;g>=0;g--){for(;k.forward[g]&&b(k.forward[g].key,S)<0;)k=k.forward[g];C[g]=k}if(k=k.forward[0],!k||b(k.key,S)!==0)return!1;for(let g=0;g<P.d&&C[g].forward[g]===k;g++)C[g].forward[g]=k.forward[g];for(;P.d>0&&P.e.forward[P.d-1]===L;)P.d-=1;return!0}}e.$Gr=j}),define(ae[62],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(j){return new A(j)}constructor(j){this.c=D&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Nd=A}),define(ae[3],ce([0,1,7,85,2,87,62]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.Event=void 0;const P=!1,S=!1;var b;(function(m){m.None=()=>L.$Rc.None;function f(ue){if(S){const{onDidAddListener:he}=ue,ge=$.create();let de=0;ue.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ge.print()),he?.()}}}function y(ue,he){return Q(ue,()=>{},0,void 0,!0,void 0,he)}m.defer=y;function I(ue){return(he,ge=null,de)=>{let we=!1,ve;return ve=ue(Ie=>{if(!we)return ve?ve.dispose():we=!0,he.call(ge,Ie)},null,de),we&&ve.dispose(),ve}}m.once=I;function T(ue,he,ge){return x((de,we=null,ve)=>ue(Ie=>de.call(we,he(Ie)),null,ve),ge)}m.map=T;function M(ue,he,ge){return x((de,we=null,ve)=>ue(Ie=>{he(Ie),de.call(we,Ie)},null,ve),ge)}m.forEach=M;function U(ue,he,ge){return x((de,we=null,ve)=>ue(Ie=>he(Ie)&&de.call(we,Ie),null,ve),ge)}m.filter=U;function q(ue){return ue}m.signal=q;function Y(...ue){return(he,ge=null,de)=>{const we=(0,L.$Oc)(...ue.map(ve=>ve(Ie=>he.call(ge,Ie))));return H(we,de)}}m.any=Y;function K(ue,he,ge,de){let we=ge;return T(ue,ve=>(we=he(we,ve),we),de)}m.reduce=K;function x(ue,he){let ge;const de={onWillAddFirstListener(){ge=ue(we.fire,we)},onDidRemoveLastListener(){ge?.dispose()}};he||f(de);const we=new h(de);return he?.add(we),we.event}function H(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function Q(ue,he,ge=100,de=!1,we=!1,ve,Ie){let Ne,Me,le,$e=0,be;const Se={leakWarningThreshold:ve,onWillAddFirstListener(){Ne=ue(Ue=>{$e++,Me=he(Me,Ue),de&&!le&&(Ce.fire(Me),Me=void 0),be=()=>{const je=Me;Me=void 0,le=void 0,(!de||$e>1)&&Ce.fire(je),$e=0},typeof ge=="number"?(clearTimeout(le),le=setTimeout(be,ge)):le===void 0&&(le=0,queueMicrotask(be))})},onWillRemoveListener(){we&&$e>0&&be?.()},onDidRemoveLastListener(){be=void 0,Ne.dispose()}};Ie||f(Se);const Ce=new h(Se);return Ie?.add(Ce),Ce.event}m.debounce=Q;function J(ue,he=0,ge){return m.debounce(ue,(de,we)=>de?(de.push(we),de):[we],he,void 0,!0,void 0,ge)}m.accumulate=J;function W(ue,he=(de,we)=>de===we,ge){let de=!0,we;return U(ue,ve=>{const Ie=de||!he(ve,we);return de=!1,we=ve,Ie},ge)}m.latch=W;function ee(ue,he,ge){return[m.filter(ue,he,ge),m.filter(ue,de=>!he(de),ge)]}m.split=ee;function ne(ue,he=!1,ge=[],de){let we=ge.slice(),ve=ue(Me=>{we?we.push(Me):Ne.fire(Me)});de&&de.add(ve);const Ie=()=>{we?.forEach(Me=>Ne.fire(Me)),we=null},Ne=new h({onWillAddFirstListener(){ve||(ve=ue(Me=>Ne.fire(Me)),de&&de.add(ve))},onDidAddFirstListener(){we&&(he?setTimeout(Ie):Ie())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return de&&de.add(Ne),Ne.event}m.buffer=ne;function _(ue,he){return(de,we,ve)=>{const Ie=he(new X);return ue(function(Ne){const Me=Ie.evaluate(Ne);Me!==se&&de.call(we,Me)},void 0,ve)}}m.chain=_;const se=Symbol("HaltChainable");class X{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push(ge=>(he(ge),ge)),this}filter(he){return this.f.push(ge=>he(ge)?ge:se),this}reduce(he,ge){let de=ge;return this.f.push(we=>(de=he(de,we),de)),this}latch(he=(ge,de)=>ge===de){let ge=!0,de;return this.f.push(we=>{const ve=ge||!he(we,de);return ge=!1,de=we,ve?we:se}),this}evaluate(he){for(const ge of this.f)if(he=ge(he),he===se)break;return he}}function z(ue,he,ge=de=>de){const de=(...Ne)=>Ie.fire(ge(...Ne)),we=()=>ue.on(he,de),ve=()=>ue.removeListener(he,de),Ie=new h({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Ie.event}m.fromNodeEventEmitter=z;function R(ue,he,ge=de=>de){const de=(...Ne)=>Ie.fire(ge(...Ne)),we=()=>ue.addEventListener(he,de),ve=()=>ue.removeEventListener(he,de),Ie=new h({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Ie.event}m.fromDOMEventEmitter=R;function F(ue){return new Promise(he=>I(ue)(he))}m.toPromise=F;function B(ue){const he=new h;return ue.then(ge=>{he.fire(ge)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}m.fromPromise=B;function N(ue,he,ge){return he(ge),ue(de=>he(de))}m.runAndSubscribe=N;function V(ue,he){let ge=null;function de(ve){ge?.dispose(),ge=new L.$Qc,he(ve,ge)}de(void 0);const we=ue(ve=>de(ve));return(0,L.$Pc)(()=>{we.dispose(),ge?.dispose()})}m.runAndSubscribeWithStore=V;class G{constructor(he,ge){this._observable=he,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};ge||f(de),this.emitter=new h(de),ge&&ge.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,ge){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function te(ue,he){return new G(ue,he).emitter.event}m.fromObservable=te;function oe(ue){return he=>{let ge=0,de=!1;const we={beginUpdate(){ge++},endUpdate(){ge--,ge===0&&(ue.reportChanges(),de&&(de=!1,he()))},handlePossibleChange(){},handleChange(){de=!0}};return ue.addObserver(we),ue.reportChanges(),{dispose(){ue.removeObserver(we)}}}}m.fromObservableLight=oe})(b||(e.Event=b={}));class C{static{this.all=new Set}static{this.f=0}constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${C.f++}`,C.all.add(this)}start(f){this.g=new O.$Nd,this.listenerCount=f}stop(){if(this.g){const f=this.g.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.g=void 0}}}e.$Pd=C;let k=-1;function g(m){const f=k;return k=m,{dispose(){k=f}}}e.$Qd=g;class c{constructor(f,y=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=y,this.g=0}dispose(){this.f?.clear()}check(f,y){const I=this.threshold;if(I<=0||y<I)return;this.f||(this.f=new Map);const T=this.f.get(f.value)||0;if(this.f.set(f.value,T+1),this.g-=1,this.g<=0){this.g=I*.5;let M,U=0;for(const[q,Y]of this.f)(!M||U<Y)&&(M=q,U=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${U}):`),console.warn(M)}return()=>{const M=this.f.get(f.value)||0;this.f.set(f.value,M-1)}}}class ${static create(){return new $(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class w{constructor(f){this.value=f,this.id=p++}}const l=2,u=(m,f)=>{if(m instanceof w)f(m);else for(let y=0;y<m.length;y++){const I=m[y];I&&f(I)}};class h{constructor(f){this.w=0,this.f=f,this.g=k>0||this.f?.leakWarningThreshold?new c(this.f?.leakWarningThreshold??k):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const f=this.t;queueMicrotask(()=>{u(f,y=>y.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(f,y,I)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Rc.None;if(this.m)return L.$Rc.None;y&&(f=f.bind(y));const T=new w(f);let M,U;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=$.create(),M=this.g.check(T.stack,this.w+1)),P&&(T.stack=U??$.create()),this.t?this.t instanceof w?(this.u??=new E,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const q=(0,L.$Pc)(()=>{M?.(),this.x(T)});return I instanceof L.$Qc?I.add(q):Array.isArray(I)&&I.push(q),q},this.q}x(f){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const y=this.t,I=y.indexOf(f);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,y[I]=void 0;const T=this.u.current===this;if(this.w*l<=y.length){let M=0;for(let U=0;U<y.length;U++)y[U]?y[M++]=y[U]:T&&(this.u.end--,M<this.u.i&&this.u.i--);y.length=M}}y(f,y){if(!f)return;const I=this.f?.onListenerError||D.$Z;if(!I){f.value(y);return}try{f.value(y)}catch(T){I(T)}}z(f){const y=f.current.t;for(;f.i<f.end;)this.y(y[f.i++],f.value);f.reset()}fire(f){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof w)this.y(this.t,f);else{const y=this.u;y.enqueue(this,f,this.t.length),this.z(y)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Rd=h;const d=()=>new E;e.$Sd=d;class E{constructor(){this.i=-1,this.end=0}enqueue(f,y,I){this.i=0,this.end=I,this.current=f,this.value=y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends h{async fireAsync(f,y,I){if(this.t)for(this.h||(this.h=new j.$2c),u(this.t,T=>this.h.push([T.value,f]));this.h.size>0&&!y.isCancellationRequested;){const[T,M]=this.h.shift(),U=[],q={...M,token:y,waitUntil:Y=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");I&&(Y=I(Y,T)),U.push(Y)}};try{T(q)}catch(Y){(0,D.$Z)(Y);continue}Object.freeze(U),await Promise.allSettled(U).then(Y=>{for(const K of Y)K.status==="rejected"&&(0,D.$Z)(K.reason)})}}}e.$Td=s;class o extends h{get isPaused(){return this.h!==0}constructor(f){super(f),this.h=0,this.s=new j.$2c,this.A=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.A(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.w&&(this.h!==0?this.s.push(f):super.fire(f))}}e.$Ud=o;class n extends o{constructor(f){super(f),this.k=f.delay??100}fire(f){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(f)}}e.$Vd=n;class i extends h{constructor(f){super(f),this.h=[],this.k=f?.merge}fire(f){this.hasListeners()&&(this.h.push(f),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(y=>super.fire(y)),this.h=[]}))}}e.$Wd=i;class t{constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(f){const y={event:f,listener:null};this.h.push(y),this.g&&this.m(y);const I=()=>{this.g&&this.o(y);const T=this.h.indexOf(y);this.h.splice(T,1)};return(0,L.$Pc)((0,A.$cb)(I))}j(){this.g=!0,this.h.forEach(f=>this.m(f))}k(){this.g=!1,this.h.forEach(f=>this.o(f))}m(f){f.listener=f.event(y=>this.f.fire(y))}o(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.f.dispose()}}e.$Xd=t;class r{constructor(f,y,I,T){this.f=new L.$Qc;const M=this.f.add(new t),U=this.f.add(new L.$1c);function q(Y){U.set(Y,M.add(T(Y)))}for(const Y of f)q(Y);this.f.add(y(Y=>{q(Y)})),this.f.add(I(Y=>{U.deleteAndDispose(Y)})),this.event=M.event}dispose(){this.f.dispose()}}e.$Yd=r;class a{constructor(){this.f=[]}wrapEvent(f){return(y,I,T)=>f(M=>{const U=this.f[this.f.length-1];U?U.push(()=>y.call(I,M)):y.call(I,M)},void 0,T)}bufferEvents(f){const y=[];this.f.push(y);const I=f();return this.f.pop(),y.forEach(T=>T()),I}}e.$Zd=a;class v{constructor(){this.f=!1,this.g=b.None,this.h=L.$Rc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(f){this.g=f,this.f&&(this.h.dispose(),this.h=f(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$1d=v}),define(ae[26],ce([0,1,3]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.CancellationToken=void 0;const A=Object.freeze(function(P,S){const b=setTimeout(P.bind(S),0);return{dispose(){clearTimeout(b)}}});var L;(function(P){function S(b){return b===P.None||b===P.Cancelled||b instanceof j?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}P.isCancellationToken=S,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(L||(e.CancellationToken=L={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new D.$Rd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(S){this.f=void 0,this.g=void 0,this.g=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=L.Cancelled}dispose(S=!1){S&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=L.None}}e.$2d=O}),define(ae[128],ce([0,1,26]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=void 0;class A{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new D.$2d,S=this.b(P.token);return this.a={promise:S,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$Ae=A;class L{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const S=JSON.stringify(P);return this.b!==S&&(this.b=S,this.a=this.c(P)),this.a}}e.$Be=L;class j{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const S=this.b(P);return this.a.set(P,S),S}}e.$Ce=j}),define(ae[46],ce([0,1,7,2]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function L(d){const E=d;return E?typeof E.read=="function":!1}e.$3d=L;function j(d){const E=d;return E?[E.on,E.pause,E.resume,E.destroy].every(s=>typeof s=="function"):!1}e.$4d=j;function O(d){const E=d;return E?j(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.$5d=O;function P(d,E){return new S(d,E)}e.$6d=P;class S{constructor(E,s){this.e=E,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(s=>s(E))}h(E){this.c.error.length===0?(0,D.$Z)(E):this.c.error.slice(0).forEach(s=>s(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,s){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(E,s){if(this.a.destroyed)return;let o;switch(E){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(s);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(d,E){const s=[];let o;for(;(o=d.read())!==null;)s.push(o);return E(s)}e.$7d=b;function C(d,E,s){const o=[];let n;for(;(n=d.read())!==null&&o.length<s;)o.push(n);return n===null&&o.length>0?E(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return d.read()}}}e.$8d=C;function k(d,E){return new Promise((s,o)=>{const n=[];g(d,{onData:i=>{E&&n.push(i)},onError:i=>{E?o(i):s(void 0)},onEnd:()=>{s(E?E(n):void 0)}})})}e.$9d=k;function g(d,E,s){d.on("error",o=>{s?.isCancellationRequested||E.onError(o)}),d.on("end",()=>{s?.isCancellationRequested||E.onEnd()}),d.on("data",o=>{s?.isCancellationRequested||E.onData(o)})}e.$0d=g;function c(d,E){return new Promise((s,o)=>{const n=new A.$Qc,i=[],t=v=>{if(i.push(v),i.length>E)return n.dispose(),d.pause(),s({stream:d,buffer:i,ended:!1})},r=v=>(n.dispose(),o(v)),a=()=>(n.dispose(),s({stream:d,buffer:i,ended:!0}));n.add((0,A.$Pc)(()=>d.removeListener("error",r))),d.on("error",r),n.add((0,A.$Pc)(()=>d.removeListener("end",a))),d.on("end",a),n.add((0,A.$Pc)(()=>d.removeListener("data",t))),d.on("data",t)})}e.$$d=c;function $(d,E){const s=P(E);return s.end(d),s}e.$_d=$;function p(){const d=P(()=>{throw new Error("not supported")});return d.end(),d}e.$ae=p;function w(d){let E=!1;return{read:()=>E?null:(E=!0,d)}}e.$be=w;function l(d,E,s){const o=P(s);return g(d,{onData:n=>o.write(E.data(n)),onError:n=>o.error(E.error?E.error(n):n),onEnd:()=>o.end()}),o}e.$ce=l;function u(d,E,s){let o=!1;return{read:()=>{const n=E.read();return o?n:(o=!0,n!==null?s([d,n]):d)}}}e.$de=u;function h(d,E,s){let o=!1;const n=P(s);return g(E,{onData:i=>o?n.write(i):(o=!0,n.write(s([d,i]))),onError:i=>n.error(i),onEnd:()=>{o||(o=!0,n.write(d)),n.end()}}),n}e.$ee=h}),define(ae[15],ce([0,1,61,46]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const L=typeof Buffer<"u",j=new D.$U(()=>new Uint8Array(256));let O,P;class S{static alloc(y){return L?new S(Buffer.allocUnsafe(y)):new S(new Uint8Array(y))}static wrap(y){return L&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new S(y)}static fromString(y,I){return!(I?.dontUseNodeBuffer||!1)&&L?new S(Buffer.from(y)):(O||(O=new TextEncoder),new S(O.encode(y)))}static fromByteArray(y){const I=S.alloc(y.length);for(let T=0,M=y.length;T<M;T++)I.buffer[T]=y[T];return I}static concat(y,I){if(typeof I>"u"){I=0;for(let U=0,q=y.length;U<q;U++)I+=y[U].byteLength}const T=S.alloc(I);let M=0;for(let U=0,q=y.length;U<q;U++){const Y=y[U];T.set(Y,M),M+=Y.byteLength}return T}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=S.alloc(this.byteLength);return y.set(this),y}toString(){return L?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(y,I){return new S(this.buffer.subarray(y,I))}set(y,I){if(y instanceof S)this.buffer.set(y.buffer,I);else if(y instanceof Uint8Array)this.buffer.set(y,I);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),I);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return g(this.buffer,y)}writeUInt32BE(y,I){c(this.buffer,y,I)}readUInt32LE(y){return $(this.buffer,y)}writeUInt32LE(y,I){p(this.buffer,y,I)}readUInt8(y){return w(this.buffer,y)}writeUInt8(y,I){l(this.buffer,y,I)}indexOf(y,I=0){return b(this.buffer,y instanceof S?y.buffer:y,I)}}e.$fe=S;function b(f,y,I=0){const T=y.byteLength,M=f.byteLength;if(T===0)return 0;if(T===1)return f.indexOf(y[0]);if(T>M-I)return-1;const U=j.value;U.fill(y.length);for(let x=0;x<y.length;x++)U[y[x]]=y.length-x-1;let q=I+y.length-1,Y=q,K=-1;for(;q<M;)if(f[q]===y[Y]){if(Y===0){K=q;break}q--,Y--}else q+=Math.max(y.length-Y,U[f[q]]),Y=y.length-1;return K}e.$ge=b;function C(f,y){return f[y+0]<<0>>>0|f[y+1]<<8>>>0}e.$he=C;function k(f,y,I){f[I+0]=y&255,y=y>>>8,f[I+1]=y&255}e.$ie=k;function g(f,y){return f[y]*2**24+f[y+1]*2**16+f[y+2]*2**8+f[y+3]}e.$je=g;function c(f,y,I){f[I+3]=y,y=y>>>8,f[I+2]=y,y=y>>>8,f[I+1]=y,y=y>>>8,f[I]=y}e.$ke=c;function $(f,y){return f[y+0]<<0>>>0|f[y+1]<<8>>>0|f[y+2]<<16>>>0|f[y+3]<<24>>>0}e.$le=$;function p(f,y,I){f[I+0]=y&255,y=y>>>8,f[I+1]=y&255,y=y>>>8,f[I+2]=y&255,y=y>>>8,f[I+3]=y&255}e.$me=p;function w(f,y){return f[y]}e.$ne=w;function l(f,y,I){f[I]=y}e.$oe=l;function u(f){return A.$7d(f,y=>S.concat(y))}e.$pe=u;function h(f){return A.$be(f)}e.$qe=h;function d(f){return A.$9d(f,y=>S.concat(y))}e.$re=d;async function E(f){return f.ended?S.concat(f.buffer):S.concat([...f.buffer,await d(f.stream)])}e.$se=E;function s(f){return A.$_d(f,y=>S.concat(y))}e.$te=s;function o(f){return A.$ce(f,{data:y=>typeof y=="string"?S.fromString(y):S.wrap(y)},y=>S.concat(y))}e.$ue=o;function n(f){return A.$6d(y=>S.concat(y),f)}e.$ve=n;function i(f,y){return A.$de(f,y,I=>S.concat(I))}e.$we=i;function t(f,y){return A.$ee(f,y,I=>S.concat(I))}e.$xe=t;function r(f){let y=0,I=0,T=0;const M=new Uint8Array(Math.floor(f.length/4*3)),U=Y=>{switch(I){case 3:M[T++]=y|Y,I=0;break;case 2:M[T++]=y|Y>>>2,y=Y<<6,I=3;break;case 1:M[T++]=y|Y>>>4,y=Y<<4,I=2;break;default:y=Y<<2,I=1}};for(let Y=0;Y<f.length;Y++){const K=f.charCodeAt(Y);if(K>=65&&K<=90)U(K-65);else if(K>=97&&K<=122)U(K-97+26);else if(K>=48&&K<=57)U(K-48+52);else if(K===43||K===45)U(62);else if(K===47||K===95)U(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${f[Y]}`)}}const q=T;for(;I>0;)U(0);return S.wrap(M).slice(0,q)}e.$ye=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:f},y=!0,I=!1){const T=I?v:a;let M="";const U=f.byteLength%3;let q=0;for(;q<f.byteLength-U;q+=3){const Y=f[q+0],K=f[q+1],x=f[q+2];M+=T[Y>>>2],M+=T[(Y<<4|K>>>4)&63],M+=T[(K<<2|x>>>6)&63],M+=T[x&63]}if(U===1){const Y=f[q+0];M+=T[Y>>>2],M+=T[Y<<4&63],y&&(M+="==")}else if(U===2){const Y=f[q+0],K=f[q+1];M+=T[Y>>>2],M+=T[(Y<<4|K>>>4)&63],M+=T[K<<2&63],y&&(M+="=")}return M}e.$ze=m}),define(ae[27],ce([0,1,128,61]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bf=e.$Af=e.$zf=e.$yf=e.GraphemeBreakType=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=void 0;function L(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.$Fe=L;const j=/{(\d+)}/g;function O(re,...fe){return fe.length===0?re:re.replace(j,function(me,ye){const ke=parseInt(ye,10);return isNaN(ke)||ke<0||ke>=fe.length?me:fe[ke]})}e.$Ge=O;const P=/{([^}]+)}/g;function S(re,fe){return Object.keys(fe).length===0?re:re.replace(P,(me,ye)=>fe[ye]??me)}e.$He=S;function b(re){return re.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$Ie=b;function C(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Je=C;function k(re,fe){let me=0;const ye=fe.charCodeAt(0);for(let ke=re.length-1;ke>=0;ke--)re.charCodeAt(ke)===ye&&me++;return me}e.$Ke=k;function g(re,fe,me="\u2026"){return re.length<=fe?re:`${re.substr(0,fe)}${me}`}e.$Le=g;function c(re,fe=" "){const me=$(re,fe);return p(me,fe)}e.$Me=c;function $(re,fe){if(!re||!fe)return re;const me=fe.length;if(me===0||re.length===0)return re;let ye=0;for(;re.indexOf(fe,ye)===ye;)ye=ye+me;return re.substring(ye)}e.$Ne=$;function p(re,fe){if(!re||!fe)return re;const me=fe.length,ye=re.length;if(me===0||ye===0)return re;let ke=ye,Pe=-1;for(;Pe=re.lastIndexOf(fe,ke-1),!(Pe===-1||Pe+me!==ke);){if(Pe===0)return"";ke=Pe}return re.substring(0,ke)}e.$Oe=p;function w(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Pe=w;function l(re){return re.replace(/\*/g,"")}e.$Qe=l;function u(re,fe,me={}){if(!re)throw new Error("Cannot create regex from empty string");fe||(re=C(re)),me.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let ye="";return me.global&&(ye+="g"),me.matchCase||(ye+="i"),me.multiline&&(ye+="m"),me.unicode&&(ye+="u"),new RegExp(re,ye)}e.$Re=u;function h(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.$Se=h;function d(re){return re.split(/\r\n|\r|\n/)}e.$Te=d;function E(re){for(let fe=0,me=re.length;fe<me;fe++){const ye=re.charCodeAt(fe);if(ye!==32&&ye!==9)return fe}return-1}e.$Ue=E;function s(re,fe=0,me=re.length){for(let ye=fe;ye<me;ye++){const ke=re.charCodeAt(ye);if(ke!==32&&ke!==9)return re.substring(fe,ye)}return re.substring(fe,me)}e.$Ve=s;function o(re,fe=re.length-1){for(let me=fe;me>=0;me--){const ye=re.charCodeAt(me);if(ye!==32&&ye!==9)return me}return-1}e.$We=o;function n(re,fe,me){const ye=[];let ke=0;for(const Pe of re.matchAll(fe)){if(ye.push(re.slice(ke,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");ke=Pe.index+Pe[0].length,ye.push(me(Pe[0],...Pe.slice(1),Pe.index,re,Pe.groups))}return ye.push(re.slice(ke)),Promise.all(ye).then(Pe=>Pe.join(""))}e.$Xe=n;function i(re,fe){return re<fe?-1:re>fe?1:0}e.$Ye=i;function t(re,fe,me=0,ye=re.length,ke=0,Pe=fe.length){for(;me<ye&&ke<Pe;me++,ke++){const De=re.charCodeAt(me),Ae=fe.charCodeAt(ke);if(De<Ae)return-1;if(De>Ae)return 1}const Re=ye-me,Oe=Pe-ke;return Re<Oe?-1:Re>Oe?1:0}e.$Ze=t;function r(re,fe){return a(re,fe,0,re.length,0,fe.length)}e.$1e=r;function a(re,fe,me=0,ye=re.length,ke=0,Pe=fe.length){for(;me<ye&&ke<Pe;me++,ke++){let De=re.charCodeAt(me),Ae=fe.charCodeAt(ke);if(De===Ae)continue;if(De>=128||Ae>=128)return t(re.toLowerCase(),fe.toLowerCase(),me,ye,ke,Pe);m(De)&&(De-=32),m(Ae)&&(Ae-=32);const Fe=De-Ae;if(Fe!==0)return Fe}const Re=ye-me,Oe=Pe-ke;return Re<Oe?-1:Re>Oe?1:0}e.$2e=a;function v(re){return re>=48&&re<=57}e.$3e=v;function m(re){return re>=97&&re<=122}e.$4e=m;function f(re){return re>=65&&re<=90}e.$5e=f;function y(re,fe){return re.length===fe.length&&a(re,fe)===0}e.$6e=y;function I(re,fe){const me=fe.length;return fe.length>re.length?!1:a(re,fe,0,me)===0}e.$7e=I;function T(re,fe){const me=Math.min(re.length,fe.length);let ye;for(ye=0;ye<me;ye++)if(re.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return me}e.$8e=T;function M(re,fe){const me=Math.min(re.length,fe.length);let ye;const ke=re.length-1,Pe=fe.length-1;for(ye=0;ye<me;ye++)if(re.charCodeAt(ke-ye)!==fe.charCodeAt(Pe-ye))return ye;return me}e.$9e=M;function U(re){return 55296<=re&&re<=56319}e.$0e=U;function q(re){return 56320<=re&&re<=57343}e.$$e=q;function Y(re,fe){return(re-55296<<10)+(fe-56320)+65536}e.$_e=Y;function K(re,fe,me){const ye=re.charCodeAt(me);if(U(ye)&&me+1<fe){const ke=re.charCodeAt(me+1);if(q(ke))return Y(ye,ke)}return ye}e.$af=K;function x(re,fe){const me=re.charCodeAt(fe-1);if(q(me)&&fe>1){const ye=re.charCodeAt(fe-2);if(U(ye))return Y(ye,me)}return me}class H{get offset(){return this.e}constructor(fe,me=0){this.c=fe,this.d=fe.length,this.e=me}setOffset(fe){this.e=fe}prevCodePoint(){const fe=x(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=K(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$bf=H;class Q{get offset(){return this.c.offset}constructor(fe,me=0){this.c=new H(fe,me)}nextGraphemeLength(){const fe=$e.getInstance(),me=this.c,ye=me.offset;let ke=fe.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Pe=me.offset,Re=fe.getGraphemeBreakType(me.nextCodePoint());if(Me(ke,Re)){me.setOffset(Pe);break}ke=Re}return me.offset-ye}prevGraphemeLength(){const fe=$e.getInstance(),me=this.c,ye=me.offset;let ke=fe.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Pe=me.offset,Re=fe.getGraphemeBreakType(me.prevCodePoint());if(Me(Re,ke)){me.setOffset(Pe);break}ke=Re}return ye-me.offset}eol(){return this.c.eol()}}e.$cf=Q;function J(re,fe){return new Q(re,fe).nextGraphemeLength()}e.$df=J;function W(re,fe){return new Q(re,fe).prevGraphemeLength()}e.$ef=W;function ee(re,fe){fe>0&&q(re.charCodeAt(fe))&&fe--;const me=fe+J(re,fe);return[me-W(re,me),me]}e.$ff=ee;function ne(re){const fe=new Q(re);let me=0;for(;!fe.eol();)me++,fe.nextGraphemeLength();return me}e.$gf=ne;let _;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function X(re){return _||(_=se()),_.test(re)}e.$hf=X;const z=/^[\t\n\r\x20-\x7E]*$/;function R(re){return z.test(re)}e.$if=R,e.$jf=/[\u2028\u2029]/;function F(re){return e.$jf.test(re)}e.$kf=F;function B(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.$lf=B;function N(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.$mf=N;function V(re,fe){if(re.length<fe)return re;const me=/\b/g;let ye=0;for(;me.test(re)&&!(re.length-me.lastIndex<fe);)ye=me.lastIndex,me.lastIndex+=1;return re.substring(ye).replace(/^\s/,"")}e.$nf=V;const G=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,te=/\x1b\].*?\x07/g;function oe(re){return re&&(re=re.replace(G,"").replace(te,"")),re}e.$of=oe,e.$pf=String.fromCharCode(65279);function ue(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.$qf=ue;function he(re){return ue(re)?re.substr(1):re}e.$rf=he;function ge(re,fe){if(!re||!fe||re.length<fe.length)return!1;const me=fe.length,ye=re.toLowerCase();let ke=0,Pe=-1;for(;ke<me;){const Re=ye.indexOf(fe[ke],Pe+1);if(Re<0)return!1;Pe=Re,ke++}return!0}e.$sf=ge;function de(re,fe=!1){return re?(fe&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.$tf=de;function we(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.$uf=we;function ve(re,fe=1){if(fe===0)return"";let me=-1;do me=re.indexOf(`
`,me+1),fe--;while(fe>0&&me>=0);return me===-1?re:(re[me-1]==="\r"&&me--,re.substr(0,me))}e.$vf=ve;function Ie(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}e.$wf=Ie;function Ne(re){return $e.getInstance().getGraphemeBreakType(re)}e.$xf=Ne;function Me(re,fe){return re===0?fe!==5&&fe!==7:re===2&&fe===3?!1:re===4||re===2||re===3||fe===4||fe===2||fe===3?!0:!(re===8&&(fe===8||fe===9||fe===11||fe===12)||(re===11||re===9)&&(fe===9||fe===10)||(re===12||re===10)&&fe===10||fe===5||fe===13||fe===7||re===1||re===13&&fe===14||re===6&&fe===6)}var le;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(le||(e.GraphemeBreakType=le={}));class $e{static{this.c=null}static getInstance(){return $e.c||($e.c=new $e),$e.c}constructor(){this.d=be()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const me=this.d,ye=me.length/3;let ke=1;for(;ke<=ye;)if(fe<me[3*ke])ke=2*ke;else if(fe>me[3*ke+1])ke=2*ke+1;else return me[3*ke+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(re,fe){if(re===0)return 0;const me=Ce(re,fe);if(me!==void 0)return me;const ye=new H(fe,re);return ye.prevCodePoint(),ye.offset}e.$yf=Se;function Ce(re,fe){const me=new H(fe,re);let ye=me.prevCodePoint();for(;Ue(ye)||ye===65039||ye===8419;){if(me.offset===0)return;ye=me.prevCodePoint()}if(!N(ye))return;let ke=me.offset;return ke>0&&me.prevCodePoint()===8205&&(ke=me.offset),ke}function Ue(re){return 127995<=re&&re<=127999}var je;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.$zf="\xA0";class ze{static{this.c=new A.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Be(fe=>{function me(Fe){const Be=new Map;for(let qe=0;qe<Fe.length;qe+=2)Be.set(Fe[qe],Fe[qe+1]);return Be}function ye(Fe,Be){const qe=new Map(Fe);for(const[We,_e]of Be)qe.set(We,_e);return qe}function ke(Fe,Be){if(!Fe)return Be;const qe=new Map;for(const[We,_e]of Fe)Be.has(We)&&qe.set(We,_e);return qe}const Pe=this.c.value;let Re=fe.filter(Fe=>!Fe.startsWith("_")&&Fe in Pe);Re.length===0&&(Re=["_default"]);let Oe;for(const Fe of Re){const Be=me(Pe[Fe]);Oe=ke(Oe,Be)}const De=me(Pe._common),Ae=ye(De,Oe);return new ze(Ae)})}static getInstance(fe){return ze.d.get(Array.from(fe))}static{this.e=new A.$U(()=>Object.keys(ze.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return ze.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Af=ze;class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(fe){return Te.e().has(fe)}static get codePoints(){return Te.e()}}e.$Bf=Te}),define(ae[52],ce([0,1,27]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=void 0;function A(l){return L(l,0)}e.$Li=A;function L(l,u){switch(typeof l){case"object":return l===null?j(349,u):Array.isArray(l)?S(l,u):b(l,u);case"string":return P(l,u);case"boolean":return O(l,u);case"number":return j(l,u);case"undefined":return j(937,u);default:return j(617,u)}}e.$Mi=L;function j(l,u){return(u<<5)-u+l|0}e.$Ni=j;function O(l,u){return j(l?433:863,u)}function P(l,u){u=j(149417,u);for(let h=0,d=l.length;h<d;h++)u=j(l.charCodeAt(h),u);return u}e.$Oi=P;function S(l,u){return u=j(104579,u),l.reduce((h,d)=>L(d,h),u)}function b(l,u){return u=j(181387,u),Object.keys(l).sort().reduce((h,d)=>(h=P(d,h),L(l[d],h)),u)}class C{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=L(u,this.g),this.g}}e.$Pi=C;var k;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function g(l,u,h=32){const d=h-u,E=~((1<<d)-1);return(l<<u|(E&l)>>>d)>>>0}function c(l,u=0,h=l.byteLength,d=0){for(let E=0;E<h;E++)l[u+E]=d}function $(l,u,h="0"){for(;l.length<u;)l=h+l;return l}function p(l,u=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(h=>h.toString(16).padStart(2,"0")).join(""):$((l>>>0).toString(16),u/4)}e.$Qi=p;class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const h=u.length;if(h===0)return;const d=this.p;let E=this.r,s=this.u,o,n;for(s!==0?(o=s,n=-1,s=0):(o=u.charCodeAt(0),n=0);;){let i=o;if(D.$0e(o))if(n+1<h){const t=u.charCodeAt(n+1);D.$$e(t)?(n++,i=D.$_e(o,t)):i=65533}else{s=o;break}else D.$$e(o)&&(i=65533);if(E=this.w(d,E,i),n++,n<h)o=u.charCodeAt(n);else break}this.r=E,this.u=s}w(u,h,d){return d<128?u[h++]=d:d<2048?(u[h++]=192|(d&1984)>>>6,u[h++]=128|(d&63)>>>0):d<65536?(u[h++]=224|(d&61440)>>>12,u[h++]=128|(d&4032)>>>6,u[h++]=128|(d&63)>>>0):(u[h++]=240|(d&1835008)>>>18,u[h++]=128|(d&258048)>>>12,u[h++]=128|(d&4032)>>>6,u[h++]=128|(d&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,c(this.p,this.r),this.r>56&&(this.y(),c(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=w.g,h=this.q;for(let a=0;a<64;a+=4)u.setUint32(a,h.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)u.setUint32(a,g(u.getUint32(a-12,!1)^u.getUint32(a-32,!1)^u.getUint32(a-56,!1)^u.getUint32(a-64,!1),1),!1);let d=this.h,E=this.l,s=this.m,o=this.n,n=this.o,i,t,r;for(let a=0;a<80;a++)a<20?(i=E&s|~E&o,t=1518500249):a<40?(i=E^s^o,t=1859775393):a<60?(i=E&s|E&o|s&o,t=2400959708):(i=E^s^o,t=3395469782),r=g(d,5)+i+n+t+u.getUint32(a*4,!1)&4294967295,n=o,o=s,s=g(E,30),E=d,d=r;this.h=this.h+d&4294967295,this.l=this.l+E&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$Ri=w}),define(ae[89],ce([0,1,27]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(A||(A={})),function(L){const j="error",O="warning",P="warn",S="info",b="ignore";function C(g){return g?D.$6e(j,g)?L.Error:D.$6e(O,g)||D.$6e(P,g)?L.Warning:D.$6e(S,g)?L.Info:L.Ignore:L.Ignore}L.fromValue=C;function k(g){switch(g){case L.Error:return j;case L.Warning:return O;case L.Info:return S;default:return b}}L.toString=k}(A||(A={})),e.default=A}),define(ae[129],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(ae[47],ce([0,1,18,27]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=void 0;class L{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const $=c.charCodeAt(0),p=this.b.charCodeAt(this.c);return $-p}value(){return this.b[this.c]}}e.$Zh=L;class j{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,A.$Ze)(c,this.b,0,c.length,this.c,this.d):(0,A.$2e)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$1h=j;class O{constructor(c=!0,$=!0){this.f=c,this.g=$}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let $=c.length-1;$>=0;$--,this.c--){const p=this.b.charCodeAt($);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,A.$Ze)(c,this.b,0,c.length,this.d,this.e):(0,A.$2e)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$2h=O;var P;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(P||(P={}));class S{constructor(c,$){this.f=c,this.g=$,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(3)),this.g(c)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===1)return(0,A.$1e)(c,this.c.scheme);if(this.d[this.e]===2)return(0,A.$1e)(c,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(c);if(this.d[this.e]===4)return(0,A.$Ye)(c,this.c.query);if(this.d[this.e]===5)return(0,A.$Ye)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$3h=S;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(C||(C={}));class k{static forUris(c=()=>!1,$=()=>!1){return new k(new S(c,$))}static forPaths(c=!1){return new k(new O(void 0,!c))}static forStrings(){return new k(new L)}static forConfigKeys(){return new k(new j)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,$){if($){const p=$.slice(0);(0,D.$Wb)(p);for(const w of p)this.set(w,c)}else{const p=c.slice(0);(0,D.$Wb)(p);for(const w of p)this.set(w[0],w[1])}}set(c,$){const p=this.b.reset(c);let w;this.c||(this.c=new b,this.c.segment=p.value());const l=[];for(w=this.c;;){const h=p.cmp(w.segment);if(h>0)w.left||(w.left=new b,w.left.segment=p.value()),l.push([-1,w]),w=w.left;else if(h<0)w.right||(w.right=new b,w.right.segment=p.value()),l.push([1,w]),w=w.right;else if(p.hasNext())p.next(),w.mid||(w.mid=new b,w.mid.segment=p.value()),l.push([0,w]),w=w.mid;else break}const u=w.value;w.value=$,w.key=c;for(let h=l.length-1;h>=0;h--){const d=l[h][1];d.updateHeight();const E=d.balanceFactor();if(E<-1||E>1){const s=l[h][0],o=l[h+1][0];if(s===1&&o===1)l[h][1]=d.rotateLeft();else if(s===-1&&o===-1)l[h][1]=d.rotateRight();else if(s===1&&o===-1)d.right=l[h+1][1]=l[h+1][1].rotateRight(),l[h][1]=d.rotateLeft();else if(s===-1&&o===1)d.left=l[h+1][1]=l[h+1][1].rotateLeft(),l[h][1]=d.rotateRight();else throw new Error;if(h>0)switch(l[h-1][0]){case-1:l[h-1][1].left=l[h][1];break;case 1:l[h-1][1].right=l[h][1];break;case 0:l[h-1][1].mid=l[h][1];break}else this.c=l[0][1]}}return u}get(c){return this.d(c)?.value}d(c){const $=this.b.reset(c);let p=this.c;for(;p;){const w=$.cmp(p.segment);if(w>0)p=p.left;else if(w<0)p=p.right;else if($.hasNext())$.next(),p=p.mid;else break}return p}has(c){const $=this.d(c);return!($?.value===void 0&&$?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,$){const p=this.b.reset(c),w=[];let l=this.c;for(;l;){const u=p.cmp(l.segment);if(u>0)w.push([-1,l]),l=l.left;else if(u<0)w.push([1,l]),l=l.right;else if(p.hasNext())p.next(),w.push([0,l]),l=l.mid;else break}if(l){if($?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const u=this.f(l.right);if(u.key){const{key:h,value:d,segment:E}=u;this.e(u.key,!1),l.key=h,l.value=d,l.segment=E}}else{const u=l.left??l.right;if(w.length>0){const[h,d]=w[w.length-1];switch(h){case-1:d.left=u;break;case 0:d.mid=u;break;case 1:d.right=u;break}}else this.c=u}for(let u=w.length-1;u>=0;u--){const h=w[u][1];h.updateHeight();const d=h.balanceFactor();if(d>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),w[u][1]=h.rotateLeft()):d<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),w[u][1]=h.rotateRight()),u>0)switch(w[u-1][0]){case-1:w[u-1][1].left=w[u][1];break;case 1:w[u-1][1].right=w[u][1];break;case 0:w[u-1][1].mid=w[u][1];break}else this.c=w[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const $=this.b.reset(c);let p=this.c,w;for(;p;){const l=$.cmp(p.segment);if(l>0)p=p.left;else if(l<0)p=p.right;else if($.hasNext())$.next(),w=p.value||w,p=p.mid;else break}return p&&p.value||w}findSuperstr(c){return this.g(c,!1)}g(c,$){const p=this.b.reset(c);let w=this.c;for(;w;){const l=p.cmp(w.segment);if(l>0)w=w.left;else if(l<0)w=w.right;else if(p.hasNext())p.next(),w=w.mid;else return w.mid?this.h(w.mid):$?w.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[$,p]of this)c(p,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const $=[];return this.j(c,$),$[Symbol.iterator]()}j(c,$){c&&(c.left&&this.j(c.left,$),c.value&&$.push([c.key,c.value]),c.mid&&this.j(c.mid,$),c.right&&this.j(c.right,$))}_isBalanced(){const c=$=>{if(!$)return!0;const p=$.balanceFactor();return p<-1||p>1?!1:c($.left)&&c($.right)};return c(this.c)}}e.$4h=k}),define(ae[12],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=void 0;function D(E){return typeof E=="string"}e.$Cf=D;function A(E){return Array.isArray(E)&&E.every(s=>D(s))}e.$Df=A;function L(E){return typeof E=="object"&&E!==null&&!Array.isArray(E)&&!(E instanceof RegExp)&&!(E instanceof Date)}e.$Ef=L;function j(E){const s=Object.getPrototypeOf(Uint8Array);return typeof E=="object"&&E instanceof s}e.$Ff=j;function O(E){return typeof E=="number"&&!isNaN(E)}e.$Gf=O;function P(E){return!!E&&typeof E[Symbol.iterator]=="function"}e.$Hf=P;function S(E){return E===!0||E===!1}e.$If=S;function b(E){return typeof E>"u"}e.$Jf=b;function C(E){return!k(E)}e.$Kf=C;function k(E){return b(E)||E===null}e.$Lf=k;function g(E,s){if(!E)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.$Mf=g;function c(E){if(k(E))throw new Error("Assertion Failed: argument is undefined or null");return E}e.$Nf=c;function $(...E){const s=[];for(let o=0;o<E.length;o++){const n=E[o];if(k(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);s.push(n)}return s}e.$Of=$;const p=Object.prototype.hasOwnProperty;function w(E){if(!L(E))return!1;for(const s in E)if(p.call(E,s))return!1;return!0}e.$Pf=w;function l(E){return typeof E=="function"}e.$Qf=l;function u(...E){return E.length>0&&E.every(l)}e.$Rf=u;function h(E,s){const o=Math.min(E.length,s.length);for(let n=0;n<o;n++)d(E[n],s[n])}e.$Sf=h;function d(E,s){if(D(s)){if(typeof E!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(l(s)){try{if(E instanceof s)return}catch{}if(!k(E)&&E.constructor===s||s.length===1&&s.call(void 0,E)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Tf=d}),define(ae[30],ce([0,1,12]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=void 0;function A(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const u=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([h,d])=>{u[h]=d&&typeof d=="object"?A(d):d}),u}e.$cn=A;function L(l){if(!l||typeof l!="object")return l;const u=[l];for(;u.length>0;){const h=u.shift();Object.freeze(h);for(const d in h)if(j.call(h,d)){const E=h[d];typeof E=="object"&&!Object.isFrozen(E)&&!(0,D.$Ff)(E)&&u.push(E)}}return l}e.$dn=L;const j=Object.prototype.hasOwnProperty;function O(l,u){return P(l,u,new Set)}e.$en=O;function P(l,u,h){if((0,D.$Lf)(l))return l;const d=u(l);if(typeof d<"u")return d;if(Array.isArray(l)){const E=[];for(const s of l)E.push(P(s,u,h));return E}if((0,D.$Ef)(l)){if(h.has(l))throw new Error("Cannot clone recursive data-structure");h.add(l);const E={};for(const s in l)j.call(l,s)&&(E[s]=P(l[s],u,h));return h.delete(l),E}return l}function S(l,u,h=!0){return(0,D.$Ef)(l)?((0,D.$Ef)(u)&&Object.keys(u).forEach(d=>{d in l?h&&((0,D.$Ef)(l[d])&&(0,D.$Ef)(u[d])?S(l[d],u[d],h):l[d]=u[d]):l[d]=u[d]}),l):u}e.$fn=S;function b(l,u){if(l===u)return!0;if(l==null||u===null||u===void 0||typeof l!=typeof u||typeof l!="object"||Array.isArray(l)!==Array.isArray(u))return!1;let h,d;if(Array.isArray(l)){if(l.length!==u.length)return!1;for(h=0;h<l.length;h++)if(!b(l[h],u[h]))return!1}else{const E=[];for(d in l)E.push(d);E.sort();const s=[];for(d in u)s.push(d);if(s.sort(),!b(E,s))return!1;for(h=0;h<E.length;h++)if(!b(l[E[h]],u[E[h]]))return!1}return!0}e.$gn=b;function C(l){const u=new Set;return JSON.stringify(l,(h,d)=>{if((0,D.$Ef)(d)||Array.isArray(d)){if(u.has(d))return"[Circular]";u.add(d)}return d})}e.$hn=C;function k(l,u){const h=Object.create(null);return!l||!u||Object.keys(u).forEach(E=>{const s=l[E],o=u[E];b(s,o)||(h[E]=o)}),h}e.$in=k;function g(l,u){const h=u.toLowerCase(),d=Object.keys(l).find(E=>E.toLowerCase()===h);return d?l[d]:l[u]}e.$jn=g;function c(l,u){const h=Object.create(null);for(const[d,E]of Object.entries(l))u(d,E)&&(h[d]=E);return h}e.$kn=c;function $(l){let u=[];for(;Object.prototype!==l;)u=u.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return u}e.$ln=$;function p(l){const u=[];for(const h of $(l))typeof l[h]=="function"&&u.push(h);return u}e.$mn=p;function w(l,u){const h=E=>function(){const s=Array.prototype.slice.call(arguments,0);return u(E,s)},d={};for(const E of l)d[E]=h(E);return d}e.$nn=w}),define(ae[32],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kg=e.$jg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(L){return D.test(L)}e.$jg=A,e.$kg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(P){for(let S=0;S<P.length;S++)P[S]=Math.floor(Math.random()*256);return P};const j=new Uint8Array(16),O=[];for(let P=0;P<256;P++)O.push(P.toString(16).padStart(2,"0"));return function(){L(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let S=0,b="";return b+=O[j[S++]],b+=O[j[S++]],b+=O[j[S++]],b+=O[j[S++]],b+="-",b+=O[j[S++]],b+=O[j[S++]],b+="-",b+=O[j[S++]],b+=O[j[S++]],b+="-",b+=O[j[S++]],b+=O[j[S++]],b+="-",b+=O[j[S++]],b+=O[j[S++]],b+=O[j[S++]],b+=O[j[S++]],b+=O[j[S++]],b+=O[j[S++]],b}}()}),define(ae[130],ce([0,1,36]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(O){const P=O.replace(/\-/g,":").toLowerCase();return!A.has(P)}function j(){const O=(0,D.networkInterfaces)();for(const P in O){const S=O[P];if(S){for(const{mac:b}of S)if(L(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Ym=j}),define(ae[131],ce([0,1,267,15]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TT=void 0;class L extends D.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const P=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=P.length===1?P[0]:P,this.c=P.length}}_transform(O,P,S){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let b=0;for(;b<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,b):(0,A.$ge)(this.a,this.b,b);if(C===-1)break;this.push(this.a.slice(b,C+this.c)),b=C+this.c}this.a=b===this.a.length?void 0:this.a.slice(b),S()}_flush(O){this.a&&this.push(this.a),O()}}e.$TT=L}),define(ae[132],ce([0,1,63]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=e.$ng=e.$mg=void 0;function A(P,S,b,C=1){let k=!1;return new Promise(g=>{const c=setTimeout(()=>{if(!k)return k=!0,g(0)},b);L(P,S,C,$=>{if(!k)return k=!0,clearTimeout(c),g($)})})}e.$mg=A;function L(P,S,b,C){if(S===0)return C(0);const k=new D.Socket;k.once("connect",()=>(O(k),L(P+b,S-1,b,C))),k.once("data",()=>{}),k.once("error",g=>(O(k),g.code!=="ECONNREFUSED"?L(P+b,S-1,b,C):C(P))),k.connect(P,"127.0.0.1")}e.$ng={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(P,S,b,C="127.0.0.1"){let k=!1,g,c=1;const $=D.createServer({pauseOnConnect:!0});function p(w,l){k||(k=!0,$.removeAllListeners(),$.close(),g&&clearTimeout(g),l(w))}return new Promise(w=>{g=setTimeout(()=>{p(0,w)},b),$.on("listening",()=>{p(P,w)}),$.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&c<S?(P++,c++,$.listen(P,C)):p(0,w)}),$.on("close",()=>{p(0,w)}),$.listen(P,C)})}e.$og=j;function O(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(S){console.error(S)}}}),define(ae[133],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0T=void 0;function D(A){return!!A.parentPort}e.$0T=D}),define(ae[134],ce([13,9]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(ae[64],ce([0,1,134]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=void 0;const A=60,L=A*60,j=L*24,O=j*7,P=j*30,S=j*365;function b(k,g,c,$){typeof k!="number"&&(k=k.getTime());const p=Math.round((new Date().getTime()-k)/1e3);if(p<-30)return(0,D.localize)(0,null,b(new Date().getTime()+p*1e3,!1));if(!$&&p<30)return(0,D.localize)(1,null);let w;return p<A?(w=p,g?w===1?c?(0,D.localize)(2,null,w):(0,D.localize)(3,null,w):c?(0,D.localize)(4,null,w):(0,D.localize)(5,null,w):w===1?c?(0,D.localize)(6,null,w):(0,D.localize)(7,null,w):c?(0,D.localize)(8,null,w):(0,D.localize)(9,null,w)):p<L?(w=Math.floor(p/A),g?w===1?c?(0,D.localize)(10,null,w):(0,D.localize)(11,null,w):c?(0,D.localize)(12,null,w):(0,D.localize)(13,null,w):w===1?c?(0,D.localize)(14,null,w):(0,D.localize)(15,null,w):c?(0,D.localize)(16,null,w):(0,D.localize)(17,null,w)):p<j?(w=Math.floor(p/L),g?w===1?c?(0,D.localize)(18,null,w):(0,D.localize)(19,null,w):c?(0,D.localize)(20,null,w):(0,D.localize)(21,null,w):w===1?c?(0,D.localize)(22,null,w):(0,D.localize)(23,null,w):c?(0,D.localize)(24,null,w):(0,D.localize)(25,null,w)):p<O?(w=Math.floor(p/j),g?w===1?(0,D.localize)(26,null,w):(0,D.localize)(27,null,w):w===1?(0,D.localize)(28,null,w):(0,D.localize)(29,null,w)):p<P?(w=Math.floor(p/O),g?w===1?c?(0,D.localize)(30,null,w):(0,D.localize)(31,null,w):c?(0,D.localize)(32,null,w):(0,D.localize)(33,null,w):w===1?c?(0,D.localize)(34,null,w):(0,D.localize)(35,null,w):c?(0,D.localize)(36,null,w):(0,D.localize)(37,null,w)):p<S?(w=Math.floor(p/P),g?w===1?c?(0,D.localize)(38,null,w):(0,D.localize)(39,null,w):c?(0,D.localize)(40,null,w):(0,D.localize)(41,null,w):w===1?c?(0,D.localize)(42,null,w):(0,D.localize)(43,null,w):c?(0,D.localize)(44,null,w):(0,D.localize)(45,null,w)):(w=Math.floor(p/S),g?w===1?c?(0,D.localize)(46,null,w):(0,D.localize)(47,null,w):c?(0,D.localize)(48,null,w):(0,D.localize)(49,null,w):w===1?c?(0,D.localize)(50,null,w):(0,D.localize)(51,null,w):c?(0,D.localize)(52,null,w):(0,D.localize)(53,null,w))}e.$lm=b;function C(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$mm=C}),define(ae[135],ce([13,9]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(ae[38],ce([0,1,18,12,135]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=void 0;function j(k,g){return g&&(k.stack||k.stacktrace)?L.localize(0,null,P(k),O(k.stack)||O(k.stacktrace)):P(k)}function O(k){return Array.isArray(k)?k.join(`
`):k}function P(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?L.localize(1,null,k.message):k.message||L.localize(2,null)}function S(k=null,g=!1){if(!k)return L.localize(3,null);if(Array.isArray(k)){const c=D.$Gb(k),$=S(c[0],g);return c.length>1?L.localize(4,null,$,c.length):$}if(A.$Cf(k))return k;if(k.detail){const c=k.detail;if(c.error)return j(c.error,g);if(c.exception)return j(c.exception,g)}return k.stack?j(k,g):k.message?k.message:L.localize(5,null)}e.$Ii=S;function b(k){const g=k;return g instanceof Error&&Array.isArray(g.actions)}e.$Ji=b;function C(k,g){let c;return typeof k=="string"?c=new Error(k):c=k,c.actions=g,c}e.$Ki=C}),define(ae[136],ce([13,9]),function(ie,e){return ie.create("vs/base/common/jsonErrorMessages",e)}),define(ae[137],ce([0,1,136]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;function A(L){switch(L){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.$Ep=A}),define(ae[138],ce([13,9]),function(ie,e){return ie.create("vs/base/common/platform",e)}),define(ae[5],ce([0,1,138]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let A=!1,L=!1,j=!1,O=!1,P=!1,S=!1,b=!1,C=!1,k=!1,g=!1,c,$=e.$g,p=e.$g,w,l;const u=globalThis;let h;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?h=u.vscode.process:typeof process<"u"&&(h=process);const d=typeof h?.versions?.electron=="string",E=d&&h?.type==="renderer";if(typeof navigator=="object"&&!E)l=navigator.userAgent,A=l.indexOf("Windows")>=0,L=l.indexOf("Macintosh")>=0,C=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=l.indexOf("Linux")>=0,g=l?.indexOf("Mobi")>=0,S=!0,c=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,$=c,p=navigator.language;else if(typeof h=="object"){A=h.platform==="win32",L=h.platform==="darwin",j=h.platform==="linux",O=j&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,b=d,k=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=e.$g,$=e.$g;const m=h.env.VSCODE_NLS_CONFIG;if(m)try{const f=JSON.parse(m),y=f.availableLanguages["*"];c=f.locale,p=f.osLocale,$=y||e.$g,w=f._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var s;(function(m){m[m.Web=0]="Web",m[m.Mac=1]="Mac",m[m.Linux=2]="Linux",m[m.Windows=3]="Windows"})(s||(e.Platform=s={}));function o(m){switch(m){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let n=0;L?n=1:A?n=3:j&&(n=2),e.$i=A,e.$j=L,e.$k=j,e.$l=O,e.$m=P,e.$n=b,e.$o=S,e.$p=S&&typeof u.importScripts=="function",e.$q=e.$p?u.origin:void 0,e.$r=C,e.$s=g,e.$t=k,e.$u=n,e.$v=l,e.$w=$;var i;(function(m){function f(){return e.$w}m.value=f;function y(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}m.isDefaultVariant=y;function I(){return e.$w==="en"}m.isDefault=I})(i||(e.Language=i={})),e.$x=c,e.$y=p,e.$z=w,e.$A=typeof u.postMessage=="function"&&!u.importScripts,e.$B=(()=>{if(e.$A){const m=[];u.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let I=0,T=m.length;I<T;I++){const M=m[I];if(M.id===y.data.vscodeScheduleAsyncWork){m.splice(I,1),M.callback();return}}});let f=0;return y=>{const I=++f;m.push({id:I,callback:y}),u.postMessage({vscodeScheduleAsyncWork:I},"*")}}return m=>setTimeout(m)})();var t;(function(m){m[m.Windows=1]="Windows",m[m.Macintosh=2]="Macintosh",m[m.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=L||C?2:A?1:3;let r=!0,a=!1;function v(){if(!a){a=!0;const m=new Uint8Array(2);m[0]=1,m[1]=2,r=new Uint16Array(m.buffer)[0]===(2<<8)+1}return r}e.$D=v,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ae[37],ce([0,1,5]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let A;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const j=L.process;A={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$cc=A.platform,e.$dc=A.arch}),define(ae[16],ce([0,1,37]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const A=65,L=97,j=90,O=122,P=46,S=47,b=92,C=58,k=63;class g extends Error{constructor(o,n,i){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof i}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function c(s,o){if(s===null||typeof s!="object")throw new g(o,"Object",s)}function $(s,o){if(typeof s!="string")throw new g(o,"string",s)}const p=D.$cc==="win32";function w(s){return s===S||s===b}function l(s){return s===S}function u(s){return s>=A&&s<=j||s>=L&&s<=O}function h(s,o,n,i){let t="",r=0,a=-1,v=0,m=0;for(let f=0;f<=s.length;++f){if(f<s.length)m=s.charCodeAt(f);else{if(i(m))break;m=S}if(i(m)){if(!(a===f-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==P||t.charCodeAt(t.length-2)!==P){if(t.length>2){const y=t.lastIndexOf(n);y===-1?(t="",r=0):(t=t.slice(0,y),r=t.length-1-t.lastIndexOf(n)),a=f,v=0;continue}else if(t.length!==0){t="",r=0,a=f,v=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${s.slice(a+1,f)}`:t=s.slice(a+1,f),r=f-a-1;a=f,v=0}else m===P&&v!==-1?++v:v=-1}return t}function d(s,o){c(o,"pathObject");const n=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${i}`:`${n}${s}${i}`:i}e.$ec={resolve(...s){let o="",n="",i=!1;for(let t=s.length-1;t>=-1;t--){let r;if(t>=0){if(r=s[t],$(r,"path"),r.length===0)continue}else o.length===0?r=D.cwd():(r=D.env[`=${o}`]||D.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===b)&&(r=`${o}\\`));const a=r.length;let v=0,m="",f=!1;const y=r.charCodeAt(0);if(a===1)w(y)&&(v=1,f=!0);else if(w(y))if(f=!0,w(r.charCodeAt(1))){let I=2,T=I;for(;I<a&&!w(r.charCodeAt(I));)I++;if(I<a&&I!==T){const M=r.slice(T,I);for(T=I;I<a&&w(r.charCodeAt(I));)I++;if(I<a&&I!==T){for(T=I;I<a&&!w(r.charCodeAt(I));)I++;(I===a||I!==T)&&(m=`\\\\${M}\\${r.slice(T,I)}`,v=I)}}}else v=1;else u(y)&&r.charCodeAt(1)===C&&(m=r.slice(0,2),v=2,a>2&&w(r.charCodeAt(2))&&(f=!0,v=3));if(m.length>0)if(o.length>0){if(m.toLowerCase()!==o.toLowerCase())continue}else o=m;if(i){if(o.length>0)break}else if(n=`${r.slice(v)}\\${n}`,i=f,f&&o.length>0)break}return n=h(n,!i,"\\",w),i?`${o}\\${n}`:`${o}${n}`||"."},normalize(s){$(s,"path");const o=s.length;if(o===0)return".";let n=0,i,t=!1;const r=s.charCodeAt(0);if(o===1)return l(r)?"\\":s;if(w(r))if(t=!0,w(s.charCodeAt(1))){let v=2,m=v;for(;v<o&&!w(s.charCodeAt(v));)v++;if(v<o&&v!==m){const f=s.slice(m,v);for(m=v;v<o&&w(s.charCodeAt(v));)v++;if(v<o&&v!==m){for(m=v;v<o&&!w(s.charCodeAt(v));)v++;if(v===o)return`\\\\${f}\\${s.slice(m)}\\`;v!==m&&(i=`\\\\${f}\\${s.slice(m,v)}`,n=v)}}}else n=1;else u(r)&&s.charCodeAt(1)===C&&(i=s.slice(0,2),n=2,o>2&&w(s.charCodeAt(2))&&(t=!0,n=3));let a=n<o?h(s.slice(n),!t,"\\",w):"";return a.length===0&&!t&&(a="."),a.length>0&&w(s.charCodeAt(o-1))&&(a+="\\"),i===void 0?t?`\\${a}`:a:t?`${i}\\${a}`:`${i}${a}`},isAbsolute(s){$(s,"path");const o=s.length;if(o===0)return!1;const n=s.charCodeAt(0);return w(n)||o>2&&u(n)&&s.charCodeAt(1)===C&&w(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let o,n;for(let r=0;r<s.length;++r){const a=s[r];$(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let i=!0,t=0;if(typeof n=="string"&&w(n.charCodeAt(0))){++t;const r=n.length;r>1&&w(n.charCodeAt(1))&&(++t,r>2&&(w(n.charCodeAt(2))?++t:i=!1))}if(i){for(;t<o.length&&w(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$ec.normalize(o)},relative(s,o){if($(s,"from"),$(o,"to"),s===o)return"";const n=e.$ec.resolve(s),i=e.$ec.resolve(o);if(n===i||(s=n.toLowerCase(),o=i.toLowerCase(),s===o))return"";let t=0;for(;t<s.length&&s.charCodeAt(t)===b;)t++;let r=s.length;for(;r-1>t&&s.charCodeAt(r-1)===b;)r--;const a=r-t;let v=0;for(;v<o.length&&o.charCodeAt(v)===b;)v++;let m=o.length;for(;m-1>v&&o.charCodeAt(m-1)===b;)m--;const f=m-v,y=a<f?a:f;let I=-1,T=0;for(;T<y;T++){const U=s.charCodeAt(t+T);if(U!==o.charCodeAt(v+T))break;U===b&&(I=T)}if(T!==y){if(I===-1)return i}else{if(f>y){if(o.charCodeAt(v+T)===b)return i.slice(v+T+1);if(T===2)return i.slice(v+T)}a>y&&(s.charCodeAt(t+T)===b?I=T:T===2&&(I=3)),I===-1&&(I=0)}let M="";for(T=t+I+1;T<=r;++T)(T===r||s.charCodeAt(T)===b)&&(M+=M.length===0?"..":"\\..");return v+=I,M.length>0?`${M}${i.slice(v,m)}`:(i.charCodeAt(v)===b&&++v,i.slice(v,m))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const o=e.$ec.resolve(s);if(o.length<=2)return s;if(o.charCodeAt(0)===b){if(o.charCodeAt(1)===b){const n=o.charCodeAt(2);if(n!==k&&n!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(u(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===b)return`\\\\?\\${o}`;return s},dirname(s){$(s,"path");const o=s.length;if(o===0)return".";let n=-1,i=0;const t=s.charCodeAt(0);if(o===1)return w(t)?s:".";if(w(t)){if(n=i=1,w(s.charCodeAt(1))){let v=2,m=v;for(;v<o&&!w(s.charCodeAt(v));)v++;if(v<o&&v!==m){for(m=v;v<o&&w(s.charCodeAt(v));)v++;if(v<o&&v!==m){for(m=v;v<o&&!w(s.charCodeAt(v));)v++;if(v===o)return s;v!==m&&(n=i=v+1)}}}}else u(t)&&s.charCodeAt(1)===C&&(n=o>2&&w(s.charCodeAt(2))?3:2,i=n);let r=-1,a=!0;for(let v=o-1;v>=i;--v)if(w(s.charCodeAt(v))){if(!a){r=v;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return s.slice(0,r)},basename(s,o){o!==void 0&&$(o,"ext"),$(s,"path");let n=0,i=-1,t=!0,r;if(s.length>=2&&u(s.charCodeAt(0))&&s.charCodeAt(1)===C&&(n=2),o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let a=o.length-1,v=-1;for(r=s.length-1;r>=n;--r){const m=s.charCodeAt(r);if(w(m)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(m===o.charCodeAt(a)?--a===-1&&(i=r):(a=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=n;--r)if(w(s.charCodeAt(r))){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){$(s,"path");let o=0,n=-1,i=0,t=-1,r=!0,a=0;s.length>=2&&s.charCodeAt(1)===C&&u(s.charCodeAt(0))&&(o=i=2);for(let v=s.length-1;v>=o;--v){const m=s.charCodeAt(v);if(w(m)){if(!r){i=v+1;break}continue}t===-1&&(r=!1,t=v+1),m===P?n===-1?n=v:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===i+1?"":s.slice(n,t)},format:d.bind(null,"\\"),parse(s){$(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const n=s.length;let i=0,t=s.charCodeAt(0);if(n===1)return w(t)?(o.root=o.dir=s,o):(o.base=o.name=s,o);if(w(t)){if(i=1,w(s.charCodeAt(1))){let I=2,T=I;for(;I<n&&!w(s.charCodeAt(I));)I++;if(I<n&&I!==T){for(T=I;I<n&&w(s.charCodeAt(I));)I++;if(I<n&&I!==T){for(T=I;I<n&&!w(s.charCodeAt(I));)I++;I===n?i=I:I!==T&&(i=I+1)}}}}else if(u(t)&&s.charCodeAt(1)===C){if(n<=2)return o.root=o.dir=s,o;if(i=2,w(s.charCodeAt(2))){if(n===3)return o.root=o.dir=s,o;i=3}}i>0&&(o.root=s.slice(0,i));let r=-1,a=i,v=-1,m=!0,f=s.length-1,y=0;for(;f>=i;--f){if(t=s.charCodeAt(f),w(t)){if(!m){a=f+1;break}continue}v===-1&&(m=!1,v=f+1),t===P?r===-1?r=f:y!==1&&(y=1):r!==-1&&(y=-1)}return v!==-1&&(r===-1||y===0||y===1&&r===v-1&&r===a+1?o.base=o.name=s.slice(a,v):(o.name=s.slice(a,r),o.base=s.slice(a,v),o.ext=s.slice(r,v))),a>0&&a!==i?o.dir=s.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const E=(()=>{if(p){const s=/\\/g;return()=>{const o=D.cwd().replace(s,"/");return o.slice(o.indexOf("/"))}}return()=>D.cwd()})();e.$fc={resolve(...s){let o="",n=!1;for(let i=s.length-1;i>=-1&&!n;i--){const t=i>=0?s[i]:E();$(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===S)}return o=h(o,!n,"/",l),n?`/${o}`:o.length>0?o:"."},normalize(s){if($(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===S,n=s.charCodeAt(s.length-1)===S;return s=h(s,!o,"/",l),s.length===0?o?"/":n?"./":".":(n&&(s+="/"),o?`/${s}`:s)},isAbsolute(s){return $(s,"path"),s.length>0&&s.charCodeAt(0)===S},join(...s){if(s.length===0)return".";let o;for(let n=0;n<s.length;++n){const i=s[n];$(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$fc.normalize(o)},relative(s,o){if($(s,"from"),$(o,"to"),s===o||(s=e.$fc.resolve(s),o=e.$fc.resolve(o),s===o))return"";const n=1,i=s.length,t=i-n,r=1,a=o.length-r,v=t<a?t:a;let m=-1,f=0;for(;f<v;f++){const I=s.charCodeAt(n+f);if(I!==o.charCodeAt(r+f))break;I===S&&(m=f)}if(f===v)if(a>v){if(o.charCodeAt(r+f)===S)return o.slice(r+f+1);if(f===0)return o.slice(r+f)}else t>v&&(s.charCodeAt(n+f)===S?m=f:f===0&&(m=0));let y="";for(f=n+m+1;f<=i;++f)(f===i||s.charCodeAt(f)===S)&&(y+=y.length===0?"..":"/..");return`${y}${o.slice(r+m)}`},toNamespacedPath(s){return s},dirname(s){if($(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===S;let n=-1,i=!0;for(let t=s.length-1;t>=1;--t)if(s.charCodeAt(t)===S){if(!i){n=t;break}}else i=!1;return n===-1?o?"/":".":o&&n===1?"//":s.slice(0,n)},basename(s,o){o!==void 0&&$(o,"ext"),$(s,"path");let n=0,i=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let a=o.length-1,v=-1;for(r=s.length-1;r>=0;--r){const m=s.charCodeAt(r);if(m===S){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(m===o.charCodeAt(a)?--a===-1&&(i=r):(a=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===S){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){$(s,"path");let o=-1,n=0,i=-1,t=!0,r=0;for(let a=s.length-1;a>=0;--a){const v=s.charCodeAt(a);if(v===S){if(!t){n=a+1;break}continue}i===-1&&(t=!1,i=a+1),v===P?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||i===-1||r===0||r===1&&o===i-1&&o===n+1?"":s.slice(o,i)},format:d.bind(null,"/"),parse(s){$(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const n=s.charCodeAt(0)===S;let i;n?(o.root="/",i=1):i=0;let t=-1,r=0,a=-1,v=!0,m=s.length-1,f=0;for(;m>=i;--m){const y=s.charCodeAt(m);if(y===S){if(!v){r=m+1;break}continue}a===-1&&(v=!1,a=m+1),y===P?t===-1?t=m:f!==1&&(f=1):t!==-1&&(f=-1)}if(a!==-1){const y=r===0&&n?1:r;t===-1||f===0||f===1&&t===a-1&&t===r+1?o.base=o.name=s.slice(y,a):(o.name=s.slice(y,t),o.base=s.slice(y,a),o.ext=s.slice(t,a))}return r>0?o.dir=s.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=p?e.$ec.normalize:e.$fc.normalize,e.$hc=p?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=p?e.$ec.join:e.$fc.join,e.$jc=p?e.$ec.resolve:e.$fc.resolve,e.$kc=p?e.$ec.relative:e.$fc.relative,e.$lc=p?e.$ec.dirname:e.$fc.dirname,e.$mc=p?e.$ec.basename:e.$fc.basename,e.$nc=p?e.$ec.extname:e.$fc.extname,e.$oc=p?e.$ec.format:e.$fc.format,e.$pc=p?e.$ec.parse:e.$fc.parse,e.$qc=p?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=p?e.$ec.sep:e.$fc.sep,e.$sc=p?e.$ec.delimiter:e.$fc.delimiter}),define(ae[48],ce([0,1,16,5,27,12]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function O(r){return r===47||r===92}e.$Uf=O;function P(r){return r.replace(/[\\/]/g,D.$fc.sep)}e.$Vf=P;function S(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Wf=S;function b(r,a=D.$fc.sep){if(!r)return"";const v=r.length,m=r.charCodeAt(0);if(O(m)){if(O(r.charCodeAt(1))&&!O(r.charCodeAt(2))){let y=3;const I=y;for(;y<v&&!O(r.charCodeAt(y));y++);if(I!==y&&!O(r.charCodeAt(y+1))){for(y+=1;y<v;y++)if(O(r.charCodeAt(y)))return r.slice(0,y+1).replace(/[\\/]/g,a)}}return a}else if(l(m)&&r.charCodeAt(1)===58)return O(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<v;f++)if(O(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.$Xf=b;function C(r){if(!A.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let v=2;const m=v;for(;v<r.length&&(a=r.charCodeAt(v),a!==92);v++);return!(m===v||(a=r.charCodeAt(v+1),isNaN(a)||a===92))}e.$Yf=C;const k=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(r,a=A.$i){const v=a?k:g;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||a&&c.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$Zf=$;function p(r,a,v){const m=r===a;return!v||m?m:!r||!a?!1:(0,L.$6e)(r,a)}e.$1f=p;function w(r,a,v,m=D.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(v){if(!(0,L.$7e)(r,a))return!1;if(a.length===r.length)return!0;let y=a.length;return a.charAt(a.length-1)===m&&y--,r.charAt(y)===m}return a.charAt(a.length-1)!==m&&(a+=m),r.indexOf(a)===0}e.$2f=w;function l(r){return r>=65&&r<=90||r>=97&&r<=122}e.$3f=l;function u(r,a){return A.$i&&r.endsWith(":")&&(r+=D.sep),(0,D.$hc)(r)||(r=(0,D.$ic)(a,r)),r=(0,D.$gc)(r),A.$i?(r=(0,L.$Oe)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,L.$Oe)(r,D.sep),r||(r=D.sep)),r}e.$4f=u;function h(r){const a=(0,D.$gc)(r);return A.$i?r.length>3?!1:d(a)&&(r.length===2||a.charCodeAt(2)===92):a===D.$fc.sep}e.$5f=h;function d(r,a=A.$i){return a?l(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$6f=d;function E(r,a=A.$i){return d(r,a)?r[0]:void 0}e.$7f=E;function s(r,a,v){return a.length>r.length?-1:r===a?0:(v&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$8f=s;function o(r){const a=r.split(":");let v,m,f;for(const y of a){const I=Number(y);(0,j.$Gf)(I)?m===void 0?m=I:f===void 0&&(f=I):v=v?[v,y].join(":"):y}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:m!==void 0?m:void 0,column:f!==void 0?f:m!==void 0?1:void 0}}e.$9f=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,v=8){let m="";for(let y=0;y<v;y++){let I;y===0&&A.$i&&!a&&(v===3||v===4)?I=i:I=n,m+=I.charAt(Math.floor(Math.random()*I.length))}let f;return a?f=`${a}-${m}`:f=m,r?(0,D.$ic)(r,f):f}e.$0f=t}),define(ae[139],ce([0,1,16]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.$Zr=e.$Yr=e.$Xr=void 0,e.$Xr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(C){const k=(0,D.$nc)(C),g=A[k.toLowerCase()];return g!==void 0?g:O(C)}e.$Yr=j;function O(C){const k=(0,D.$nc)(C);return L[k.toLowerCase()]}e.$Zr=O;function P(C){for(const k in L)if(L[k]===C)return k}e.$1r=P;const S=/^(.+)\/(.+?)(;.+)?$/;function b(C,k){const g=S.exec(C);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:k?void 0:C}e.$2r=b}),define(ae[90],ce([0,1,5]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.TerminateResponseCode=e.Source=void 0;var A;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(A||(e.Source=A={}));var L;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function j(P,...S){const b=S.reduce((g,c)=>(g[c]=!0,g),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(g=>!b[g]).forEach(g=>{for(let c=0;c<C.length;c++)if(g.search(C[c])!==-1){delete P[g];break}})}e.$Hl=j;function O(P){P&&(delete P.DEBUG,D.$j&&delete P.DYLD_LIBRARY_PATH,D.$k&&delete P.LD_PRELOAD)}e.$Il=O}),define(ae[10],ce([0,1,16,5]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,j=/^\//,O=/^\/\//;function P(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!j.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(i,t){return!i&&!t?"file":i}function b(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==k&&(t=k+t):t=k;break}return t}const C="",k="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(t){return t instanceof c?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,v,m,f=!1){typeof t=="object"?(this.scheme=t.scheme||C,this.authority=t.authority||C,this.path=t.path||C,this.query=t.query||C,this.fragment=t.fragment||C):(this.scheme=S(t,f),this.authority=r||C,this.path=b(this.scheme,a||C),this.query=v||C,this.fragment=m||C,P(this,f))}get fsPath(){return d(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:v,query:m,fragment:f}=t;return r===void 0?r=this.scheme:r===null&&(r=C),a===void 0?a=this.authority:a===null&&(a=C),v===void 0?v=this.path:v===null&&(v=C),m===void 0?m=this.query:m===null&&(m=C),f===void 0?f=this.fragment:f===null&&(f=C),r===this.scheme&&a===this.authority&&v===this.path&&m===this.query&&f===this.fragment?this:new w(r,a,v,m,f)}static parse(t,r=!1){const a=g.exec(t);return a?new w(a[2]||C,n(a[4]||C),n(a[5]||C),n(a[7]||C),n(a[9]||C),r):new w(C,C,C,C,C)}static file(t){let r=C;if(A.$i&&(t=t.replace(/\\/g,k)),t[0]===k&&t[1]===k){const a=t.indexOf(k,2);a===-1?(r=t.substring(2),t=k):(r=t.substring(2,a),t=t.substring(a)||k)}return new w("file",r,t,C,C)}static from(t,r){return new w(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return A.$i&&t.scheme==="file"?a=c.file(D.$ec.join(d(t,!0),...r)).path:a=D.$fc.join(t.path,...r),t.with({path:a})}toString(t=!1){return E(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof c)return t;{const r=new w(t);return r._formatted=t.external??null,r._fsPath=t._sep===p?t.fsPath??null:null,r}}else return t}}e.URI=c;function $(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$uc=$;const p=A.$i?1:void 0;class w extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(t=!1){return t?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=p),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const l={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,t,r){let a,v=-1;for(let m=0;m<i.length;m++){const f=i.charCodeAt(m);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47||r&&f===91||r&&f===93||r&&f===58)v!==-1&&(a+=encodeURIComponent(i.substring(v,m)),v=-1),a!==void 0&&(a+=i.charAt(m));else{a===void 0&&(a=i.substr(0,m));const y=l[f];y!==void 0?(v!==-1&&(a+=encodeURIComponent(i.substring(v,m)),v=-1),a+=y):v===-1&&(v=m)}}return v!==-1&&(a+=encodeURIComponent(i.substring(v))),a!==void 0?a:i}function h(i){let t;for(let r=0;r<i.length;r++){const a=i.charCodeAt(r);a===35||a===63?(t===void 0&&(t=i.substr(0,r)),t+=l[a]):t!==void 0&&(t+=i[r])}return t!==void 0?t:i}function d(i,t){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,A.$i&&(r=r.replace(/\//g,"\\")),r}e.$vc=d;function E(i,t){const r=t?h:u;let a="",{scheme:v,authority:m,path:f,query:y,fragment:I}=i;if(v&&(a+=v,a+=":"),(m||v==="file")&&(a+=k,a+=k),m){let T=m.indexOf("@");if(T!==-1){const M=m.substr(0,T);m=m.substr(T+1),T=M.lastIndexOf(":"),T===-1?a+=r(M,!1,!1):(a+=r(M.substr(0,T),!1,!1),a+=":",a+=r(M.substr(T+1),!1,!0)),a+="@"}m=m.toLowerCase(),T=m.lastIndexOf(":"),T===-1?a+=r(m,!1,!0):(a+=r(m.substr(0,T),!1,!0),a+=m.substr(T))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const T=f.charCodeAt(1);T>=65&&T<=90&&(f=`/${String.fromCharCode(T+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const T=f.charCodeAt(0);T>=65&&T<=90&&(f=`${String.fromCharCode(T+32)}:${f.substr(2)}`)}a+=r(f,!0,!1)}return y&&(a+="?",a+=r(y,!1,!1)),I&&(a+="#",a+=t?I:u(I,!1,!1)),a}function s(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(o)?i.replace(o,t=>s(t)):i}}),define(ae[140],ce([0,1,10]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$8p=e.$7p=e.$6p=void 0;function A(b){const C=b;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$6p=A;function L(b){const C=[];let k;try{const g=JSON.parse(b.arguments),c=g[g.length-1];c&&c.__$stack&&(g.pop(),k=c.__$stack),C.push(...g)}catch{C.push("Unable to log remote console arguments",b.arguments)}return{args:C,stack:k}}e.$7p=L;function j(b){if(typeof b!="string")return j(L(b).stack);const C=b;if(C){const k=O(C),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(g&&g.length===4)return{uri:D.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.$8p=j;function O(b){if(!b)return b;const C=b.indexOf(`
`);return C===-1?b:b.substring(0,C)}function P(b,C){const{args:k,stack:g}=L(b),c=typeof k[0]=="string"&&k.length===1;let $=O(g);$&&($=`(${$.trim()})`);let p=[];if(typeof k[0]=="string"?$&&c?p=[`%c[${C}] %c${k[0]} %c${$}`,S("blue"),S(""),S("grey")]:p=[`%c[${C}] %c${k[0]}`,S("blue"),S(""),...k.slice(1)]:p=[`%c[${C}]%`,S("blue"),...k],$&&!c&&p.push($),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,p)}e.log=P;function S(b){return`color: ${b}`}}),define(ae[65],ce([0,1,15,10]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uh=e.$th=e.$sh=void 0;function L(S){return JSON.stringify(S,O)}e.$sh=L;function j(S){let b=JSON.parse(S);return b=P(b),b}e.$th=j;function O(S,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function P(S,b=0){if(!S||b>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return A.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 17:return new Date(S.source)}if(S instanceof D.$fe||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let C=0;C<S.length;++C)S[C]=P(S[C],b+1);else for(const C in S)Object.hasOwnProperty.call(S,C)&&(S[C]=P(S[C],b+1))}return S}e.$uh=P}),define(ae[23],ce([0,1,7,5,27,10]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var O;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={}));function P(g,c){return j.URI.isUri(g)?(0,L.$6e)(g.scheme,c):(0,L.$7e)(g,c+":")}e.$$f=P;function S(g,...c){return c.some($=>P(g,$))}e.$_f=S,e.$ag="vscode-tkn",e.$bg="tkn";class b{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c){this.f=`${c}/${O.vscodeRemoteResource}`}set(c,$,p){this.a[c]=$,this.b[c]=p}setConnectionToken(c,$){this.c[c]=$}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(h){return D.$Z(h),c}const $=c.authority;let p=this.a[$];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const w=this.b[$],l=this.c[$];let u=`path=${encodeURIComponent(c.path)}`;return typeof l=="string"&&(u+=`&${e.$bg}=${encodeURIComponent(l)}`),j.URI.from({scheme:A.$o?this.d:O.vscodeRemoteResource,authority:`${p}:${w}`,path:this.f,query:u})}}e.$cg=new b,e.$dg="vs/../../extensions",e.$eg="vs/../../node_modules",e.$fg="vs/../../node_modules.asar",e.$gg="vs/../../node_modules.asar.unpacked",e.$hg="vscode-app";class C{static{this.a=e.$hg}asBrowserUri(c){const $=this.b(c,ie);return this.uriToBrowserUri($)}uriToBrowserUri(c){return c.scheme===O.vscodeRemote?e.$cg.rewrite(c):c.scheme===O.file&&(A.$m||A.$q===`${O.vscodeFileResource}://${C.a}`)?c.with({scheme:O.vscodeFileResource,authority:c.authority||C.a,query:null,fragment:null}):c}asFileUri(c){const $=this.b(c,ie);return this.uriToFileUri($)}uriToFileUri(c){return c.scheme===O.vscodeFileResource?c.with({scheme:O.file,authority:c.authority!==C.a?c.authority:null,query:null,fragment:null}):c}b(c,$){return j.URI.isUri(c)?c:j.URI.parse($.toUrl(c))}}e.$ig=new C;var k;(function(g){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(c.get("3"));const $="vscode-coi";function p(l){let u;typeof l=="string"?u=new URL(l).searchParams:l instanceof URL?u=l.searchParams:j.URI.isUri(l)&&(u=new URL(l.toString(!0)).searchParams);const h=u?.get($);if(h)return c.get(h)}g.getHeadersFromQuery=p;function w(l,u,h){if(!globalThis.crossOriginIsolated)return;const d=u&&h?"3":h?"2":"1";l instanceof URLSearchParams?l.set($,d):l[$]=d}g.addSearchParam=w})(k||(e.COI=k={}))}),define(ae[141],ce([0,1,123,23,5,10]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QC=void 0;class O{constructor(g,c,$){this.id=g,this.dependencies=c,this.callback=$}}class P{static{this.INSTANCE=new P}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,c,$)=>{typeof g!="string"&&($=c,c=g,g=null),(typeof c!="object"||!Array.isArray(c))&&($=c,c=null),this.c.push(new O(g,c,$))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const c=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!c)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(c.dependencies)&&c.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${c.dependencies.join(", ")}`);return typeof c.callback=="function"?c.callback([]):c.callback}h(g){return new Promise((c,$)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const w=()=>{p.removeEventListener("load",l),p.removeEventListener("error",u)},l=h=>{w(),c(this.c.pop())},u=h=>{w(),$(h)};p.addEventListener("load",l),p.addEventListener("error",u),this.f&&(g=this.f.createScriptURL(g)),p.setAttribute("src",g),window.document.getElementsByTagName("head")[0].appendChild(p)})}i(g){return new Promise((c,$)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),c(this.c.pop())}catch(p){$(p)}})}async j(g){try{const c=globalThis._VSCODE_NODE_MODULES.fs,$=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,w=j.URI.parse(g).fsPath,l=c.readFileSync(w).toString(),u=p.wrap(l.replace(/^#!.*/,""));return new $.Script(u).runInThisContext().apply(),this.c.pop()}catch(c){throw c}}}const S=new Map;let b={};typeof globalThis.require=="object"&&(b=globalThis.require.paths??{});async function C(k,g,c){if(D.$S){c===void 0&&(c=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),b[k]&&(k=b[k]);const $=`${k}/${g}`;if(S.has($))return S.get($);let p;if(/^\w[\w\d+.-]*:\/\//.test($))p=$;else{const h=`${c&&!L.$o?A.$fg:A.$eg}/${$}`;p=A.$ig.asBrowserUri(h).toString(!0)}const w=P.INSTANCE.load(p);return S.set($,w),w}else return await new Promise(($,p)=>{ie([k],$,p)})}e.$QC=C}),define(ae[19],ce([0,1,48,23,16,5,27,10]),function(ie,e,D,A,L,j,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lg=e.DataUri=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=void 0;function S(c){return(0,P.$vc)(c,!0)}e.$pg=S;class b{constructor($){this.a=$}compare($,p,w=!1){return $===p?0:(0,O.$Ye)(this.getComparisonKey($,w),this.getComparisonKey(p,w))}isEqual($,p,w=!1){return $===p?!0:!$||!p?!1:this.getComparisonKey($,w)===this.getComparisonKey(p,w)}getComparisonKey($,p=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,p,w=!1){if($.scheme===p.scheme){if($.scheme===A.Schemas.file)return D.$2f(S($),S(p),this.a($))&&$.query===p.query&&(w||$.fragment===p.fragment);if((0,e.$Gg)($.authority,p.authority))return D.$2f($.path,p.path,this.a($),"/")&&$.query===p.query&&(w||$.fragment===p.fragment)}return!1}joinPath($,...p){return P.URI.joinPath($,...p)}basenameOrAuthority($){return(0,e.$yg)($)||$.authority}basename($){return L.$fc.basename($.path)}extname($){return L.$fc.extname($.path)}dirname($){if($.path.length===0)return $;let p;return $.scheme===A.Schemas.file?p=P.URI.file(L.$lc(S($))).path:(p=L.$fc.dirname($.path),$.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),p="/")),$.with({path:p})}normalizePath($){if(!$.path.length)return $;let p;return $.scheme===A.Schemas.file?p=P.URI.file(L.$gc(S($))).path:p=L.$fc.normalize($.path),$.with({path:p})}relativePath($,p){if($.scheme!==p.scheme||!(0,e.$Gg)($.authority,p.authority))return;if($.scheme===A.Schemas.file){const u=L.$kc(S($),S(p));return j.$i?D.$Vf(u):u}let w=$.path||"/";const l=p.path||"/";if(this.a($)){let u=0;for(const h=Math.min(w.length,l.length);u<h&&!(w.charCodeAt(u)!==l.charCodeAt(u)&&w.charAt(u).toLowerCase()!==l.charAt(u).toLowerCase());u++);w=l.substr(0,u)+w.substr(u)}return L.$fc.relative(w,l)}resolvePath($,p){if($.scheme===A.Schemas.file){const w=P.URI.file(L.$jc(S($),p));return $.with({authority:w.authority,path:w.path})}return p=D.$Wf(p),$.with({path:L.$fc.resolve($.path,p)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,p){return $===p||$!==void 0&&p!==void 0&&(0,O.$6e)($,p)}hasTrailingPathSeparator($,p=L.sep){if($.scheme===A.Schemas.file){const w=S($);return w.length>D.$Xf(w).length&&w[w.length-1]===p}else{const w=$.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,p=L.sep){return(0,e.$Hg)($,p)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,p=L.sep){let w=!1;if($.scheme===A.Schemas.file){const l=S($);w=l!==void 0&&l.length===D.$Xf(l).length&&l[l.length-1]===p}else{p="/";const l=$.path;w=l.length===1&&l.charCodeAt(l.length-1)===47}return!w&&!(0,e.$Hg)($,p)?$.with({path:$.path+"/"}):$}}e.$qg=b,e.$rg=new b(()=>!1),e.$sg=new b(c=>c.scheme===A.Schemas.file?!j.$k:!0),e.$tg=new b(c=>!0),e.$ug=e.$rg.isEqual.bind(e.$rg),e.$vg=e.$rg.isEqualOrParent.bind(e.$rg),e.$wg=e.$rg.getComparisonKey.bind(e.$rg),e.$xg=e.$rg.basenameOrAuthority.bind(e.$rg),e.$yg=e.$rg.basename.bind(e.$rg),e.$zg=e.$rg.extname.bind(e.$rg),e.$Ag=e.$rg.dirname.bind(e.$rg),e.$Bg=e.$rg.joinPath.bind(e.$rg),e.$Cg=e.$rg.normalizePath.bind(e.$rg),e.$Dg=e.$rg.relativePath.bind(e.$rg),e.$Eg=e.$rg.resolvePath.bind(e.$rg),e.$Fg=e.$rg.isAbsolutePath.bind(e.$rg),e.$Gg=e.$rg.isEqualAuthority.bind(e.$rg),e.$Hg=e.$rg.hasTrailingPathSeparator.bind(e.$rg),e.$Ig=e.$rg.removeTrailingPathSeparator.bind(e.$rg),e.$Jg=e.$rg.addTrailingPathSeparator.bind(e.$rg);function C(c,$){const p=[];for(let w=0;w<c.length;w++){const l=$(c[w]);c.some((u,h)=>h===w?!1:(0,e.$vg)(l,$(u)))||p.push(c[w])}return p}e.$Kg=C;var k;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function $(p){const w=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(h=>{const[d,E]=h.split(":");d&&E&&w.set(d,E)});const u=p.path.substring(0,p.path.indexOf(";"));return u&&w.set(c.META_DATA_MIME,u),w}c.parseMetaData=$})(k||(e.DataUri=k={}));function g(c,$,p){if($){let w=c.path;return w&&w[0]!==L.$fc.sep&&(w=L.$fc.sep+w),c.with({scheme:p,authority:$,path:w})}return c.with({scheme:p})}e.$Lg=g}),define(ae[6],ce([0,1,26,7,3,2,19,5,129]),function(ie,e,D,A,L,j,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oh=e.$nh=e.$mh=e.$lh=e.Promises=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=void 0;function b(B){return!!B&&typeof B.then=="function"}e.$Mg=b;function C(B){const N=new D.$2d,V=B(N.token),G=new Promise((te,oe)=>{const ue=N.token.onCancellationRequested(()=>{ue.dispose(),N.dispose(),oe(new A.$4)});Promise.resolve(V).then(he=>{ue.dispose(),N.dispose(),te(he)},he=>{ue.dispose(),N.dispose(),oe(he)})});return new class{cancel(){N.cancel()}then(te,oe){return G.then(te,oe)}catch(te){return this.then(void 0,te)}finally(te){return G.finally(te)}}}e.$Ng=C;function k(B,N,V){return new Promise((G,te)=>{const oe=N.onCancellationRequested(()=>{oe.dispose(),G(V)});B.then(G,te).finally(()=>oe.dispose())})}e.$Og=k;function g(B,N){return new Promise((V,G)=>{const te=N.onCancellationRequested(()=>{te.dispose(),G(new A.$4)});B.then(V,G).finally(()=>te.dispose())})}e.$Pg=g;async function c(B){let N=-1;const V=B.map((G,te)=>G.then(oe=>(N=te,oe)));try{return await Promise.race(V)}finally{B.forEach((G,te)=>{te!==N&&G.cancel()})}}e.$Qg=c;function $(B,N,V){let G;const te=setTimeout(()=>{G?.(void 0),V?.()},N);return Promise.race([B.finally(()=>clearTimeout(te)),new Promise(oe=>G=oe)])}e.$Rg=$;function p(B){return new Promise((N,V)=>{const G=B();b(G)?G.then(N,V):N(G)})}e.$Sg=p;class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(N){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=N,!this.b){const V=()=>{if(this.b=null,this.f)return;const G=this.queue(this.d);return this.d=null,G};this.b=new Promise(G=>{this.a.then(V,V).then(G)})}return new Promise((V,G)=>{this.b.then(V,G)})}return this.a=N(),new Promise((V,G)=>{this.a.then(te=>{this.a=null,V(te)},te=>{this.a=null,G(te)})})}dispose(){this.f=!0}}e.$Tg=w;class l{constructor(){this.a=Promise.resolve(null)}queue(N){return this.a=this.a.then(()=>N(),()=>N())}}e.$Ug=l;class u{constructor(){this.a=new Map}queue(N,V){const te=(this.a.get(N)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.a.get(N)===te&&this.a.delete(N)});return this.a.set(N,te),te}}e.$Vg=u;const h=(B,N)=>{let V=!0;const G=setTimeout(()=>{V=!1,N()},B);return{isTriggered:()=>V,dispose:()=>{clearTimeout(G),V=!1}}},d=B=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,B())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class E{constructor(N){this.defaultDelay=N,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(N,V=this.defaultDelay){this.g=N,this.h(),this.b||(this.b=new Promise((te,oe)=>{this.d=te,this.f=oe}).then(()=>{if(this.b=null,this.d=null,this.g){const te=this.g;return this.g=null,te()}}));const G=()=>{this.a=null,this.d?.(null)};return this.a=V===S.$Od?d(G):h(V,G),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Wg=E;class s{constructor(N){this.a=new E(N),this.b=new w}trigger(N,V){return this.a.trigger(()=>this.b.queue(N),V)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Xg=s;class o{constructor(){this.a=!1,this.b=new Promise((N,V)=>{this.d=N})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Yg=o;class n extends o{constructor(N){super(),this.f=setTimeout(()=>this.open(),N)}open(){clearTimeout(this.f),super.open()}}e.$Zg=n;function i(B,N){return N?new Promise((V,G)=>{const te=setTimeout(()=>{oe.dispose(),V()},B),oe=N.onCancellationRequested(()=>{clearTimeout(te),oe.dispose(),G(new A.$4)})}):C(V=>i(B,V))}e.$1g=i;function t(B,N=0,V){const G=setTimeout(()=>{B(),V&&te.dispose()},N),te=(0,j.$Pc)(()=>{clearTimeout(G),V?.deleteAndLeak(te)});return V?.add(te),te}e.$2g=t;function r(B){const N=[];let V=0;const G=B.length;function te(){return V<G?B[V++]():null}function oe(ue){ue!=null&&N.push(ue);const he=te();return he?he.then(oe):Promise.resolve(N)}return Promise.resolve(null).then(oe)}e.$3g=r;function a(B,N=G=>!!G,V=null){let G=0;const te=B.length,oe=()=>{if(G>=te)return Promise.resolve(V);const ue=B[G++];return Promise.resolve(ue()).then(ge=>N(ge)?Promise.resolve(ge):oe())};return oe()}e.$4g=a;function v(B,N=G=>!!G,V=null){if(B.length===0)return Promise.resolve(V);let G=B.length;const te=()=>{G=-1;for(const oe of B)oe.cancel?.()};return new Promise((oe,ue)=>{for(const he of B)he.then(ge=>{--G>=0&&N(ge)?(te(),oe(ge)):G===0&&oe(V)}).catch(ge=>{--G>=0&&(te(),ue(ge))})})}e.$5g=v;class m{constructor(N){this.a=0,this.d=N,this.f=[],this.b=0,this.g=new L.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(N){return this.a++,new Promise((V,G)=>{this.f.push({factory:N,c:V,e:G}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const N=this.f.shift();this.b++;const V=N.factory();V.then(N.c,N.e),V.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$6g=m;class f extends m{constructor(){super(1)}}e.$7g=f;class y{constructor(){this.a=new J,this.b=0}queue(N){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,N())):this.a.run(this.b++,N())}}e.$8g=y;class I{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const N=new ne;return this.b.add(N),N.p}g(){for(const[,N]of this.a)if(N.size>0)return!1;return!0}queueFor(N,V=O.$rg){const G=V.getComparisonKey(N);let te=this.a.get(G);if(!te){te=new f;const oe=this.f++,ue=L.Event.once(te.onDrained)(()=>{te?.dispose(),this.a.delete(G),this.h(),this.d?.deleteAndDispose(oe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$1c),this.d.set(oe,ue),this.a.set(G,te)}return te}h(){this.g()&&this.j()}j(){for(const N of this.b)N.complete();this.b.clear()}dispose(){for(const[,N]of this.a)N.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$9g=I;class T{constructor(N,V){this.a=-1,typeof N=="function"&&typeof V=="number"&&this.setIfNotSet(N,V)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(N,V){this.cancel(),this.a=setTimeout(()=>{this.a=-1,N()},V)}setIfNotSet(N,V){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,N()},V))}}e.$0g=T;class M{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(N,V,G=globalThis){this.cancel();const te=G.setInterval(()=>{N()},V);this.d=(0,j.$Pc)(()=>{G.clearInterval(te),this.d=void 0})}dispose(){this.cancel()}}e.$$g=M;class U{constructor(N,V){this.b=-1,this.a=N,this.d=V,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(N=this.d){this.cancel(),this.b=setTimeout(this.f,N)}get delay(){return this.d}set delay(N){this.d=N}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$_g=U;class q{constructor(N,V){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.a=N,this.b=V,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(N=this.b){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(N/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ah=q;class Y extends U{constructor(N,V){super(N,V),this.j=[]}work(N){this.j.push(N),this.isScheduled()||this.schedule()}h(){const N=this.j;this.j=[],this.a?.(N)}dispose(){this.j=[],super.dispose()}}e.$bh=Y;class K extends j.$Rc{constructor(N,V){super(),this.g=N,this.h=V,this.a=[],this.b=this.B(new j.$Sc),this.f=!1}get pending(){return this.a.length}work(N){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+N.length>this.g.maxBufferedWork)return!1}else if(this.pending+N.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const V of N)this.a.push(V);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ch=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$eh=(B,N)=>{(0,P.$B)(()=>{if(V)return;const G=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,G-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.$eh=(B,N,V)=>{const G=B.requestIdleCallback(N,typeof V=="number"?{timeout:V}:void 0);let te=!1;return{dispose(){te||(te=!0,B.cancelIdleCallback(G))}}},e.$dh=B=>(0,e.$eh)(globalThis,B)}();class x{constructor(N,V){this.g=!1,this.d=()=>{try{this.j=V()}catch(G){this.l=G}finally{this.g=!0}},this.f=(0,e.$eh)(N,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$fh=x;class H extends x{constructor(N){super(globalThis,N)}}e.$gh=H;async function Q(B,N,V){let G;for(let te=0;te<V;te++)try{return await B()}catch(oe){G=oe,await i(N)}throw G}e.$hh=Q;class J{isRunning(N){return typeof N=="number"?this.a?.taskId===N:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(N,V,G){return this.a={taskId:N,cancel:()=>G?.(),promise:V},V.then(()=>this.d(N),()=>this.d(N)),V}d(N){this.a&&N===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const N=this.b;this.b=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}queue(N){if(this.b)this.b.run=N;else{let V,G;const te=new Promise((oe,ue)=>{V=oe,G=ue});this.b={run:N,promise:te,promiseResolve:V,promiseReject:G}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ih=J;class W{constructor(N,V=()=>Date.now()){this.d=N,this.f=V,this.a=0,this.b=0}increment(){const N=this.f();return N-this.a>this.d&&(this.a=N,this.b=0),this.b++,this.b}}e.$jh=W;var ee;(function(B){B[B.Resolved=0]="Resolved",B[B.Rejected=1]="Rejected"})(ee||(ee={}));class ne{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((N,V)=>{this.a=N,this.b=V})}complete(N){return new Promise(V=>{this.a(N),this.d={outcome:0,value:N},V()})}error(N){return new Promise(V=>{this.b(N),this.d={outcome:1,value:N},V()})}cancel(){return this.error(new A.$4)}}e.$kh=ne;var _;(function(B){async function N(G){let te;const oe=await Promise.all(G.map(ue=>ue.then(he=>he,he=>{te||(te=he)})));if(typeof te<"u")throw te;return oe}B.settled=N;function V(G){return new Promise(async(te,oe)=>{try{await G(te,oe)}catch(ue){oe(ue)}})}B.withAsyncBody=V})(_||(e.Promises=_={}));var se;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(se||(se={}));class X{static fromArray(N){return new X(V=>{V.emitMany(N)})}static fromPromise(N){return new X(async V=>{V.emitMany(await N)})}static fromPromises(N){return new X(async V=>{await Promise.all(N.map(async G=>V.emitOne(await G)))})}static merge(N){return new X(async V=>{await Promise.all(N.map(async G=>{for await(const te of G)V.emitOne(te)}))})}static{this.EMPTY=X.fromArray([])}constructor(N){this.a=0,this.b=[],this.d=null,this.f=new L.$Rd,queueMicrotask(async()=>{const V={emitOne:G=>this.g(G),emitMany:G=>this.h(G),reject:G=>this.k(G)};try{await Promise.resolve(N(V)),this.j()}catch(G){this.k(G)}finally{V.emitOne=void 0,V.emitMany=void 0,V.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(N<this.b.length)return{done:!1,value:this.b[N++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.f.event)}while(!0)}}}static map(N,V){return new X(async G=>{for await(const te of N)G.emitOne(V(te))})}map(N){return X.map(this,N)}static filter(N,V){return new X(async G=>{for await(const te of N)V(te)&&G.emitOne(te)})}filter(N){return X.filter(this,N)}static coalesce(N){return X.filter(N,V=>!!V)}coalesce(){return X.coalesce(this)}static async toPromise(N){const V=[];for await(const G of N)V.push(G);return V}toPromise(){return X.toPromise(this)}g(N){this.a===0&&(this.b.push(N),this.f.fire())}h(N){this.a===0&&(this.b=this.b.concat(N),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(N){this.a===0&&(this.a=2,this.d=N,this.f.fire())}}e.$lh=X;class z extends X{constructor(N,V){super(V),this.l=N}cancel(){this.l.cancel()}}e.$mh=z;function R(B){const N=new D.$2d,V=B(N.token);return new z(N,async G=>{const te=N.token.onCancellationRequested(()=>{te.dispose(),N.dispose(),G.reject(new A.$4)});try{for await(const oe of V){if(N.token.isCancellationRequested)return;G.emitOne(oe)}te.dispose(),N.dispose()}catch(oe){te.dispose(),N.dispose(),G.reject(oe)}})}e.$nh=R;class F{constructor(){this.a=new ne,this.b=new X(G=>{if(N){G.reject(N);return}return V&&G.emitMany(V),this.d=te=>G.reject(te),this.f=te=>G.emitOne(te),this.a.p});let N,V;this.f=G=>{V||(V=[]),V.push(G)},this.d=G=>{N||(N=G)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(N){this.d(N),this.a.complete()}emitOne(N){this.f(N)}}e.$oh=F}),define(ae[91],ce([0,1,18,6,48,34,16,5,27]),function(ie,e,D,A,L,j,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=void 0;function b(){return Object.create(null)}e.$zj=b,e.$Aj="**",e.$Bj="/";const C="[/\\\\]",k="[^/\\\\]",g=/\//g;function c(Q,J){switch(Q){case 0:return"";case 1:return`${k}*?`;default:return`(?:${C}|${k}+${C}${J?`|${C}${k}+`:""})*?`}}function $(Q,J){if(!Q)return[];const W=[];let ee=!1,ne=!1,_="";for(const se of Q){switch(se){case J:if(!ee&&!ne){W.push(_),_="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}_+=se}return _&&W.push(_),W}e.$Cj=$;function p(Q){if(!Q)return"";let J="";const W=$(Q,e.$Bj);if(W.every(ee=>ee===e.$Aj))J=".*";else{let ee=!1;W.forEach((ne,_)=>{if(ne===e.$Aj){if(ee)return;J+=c(2,_===W.length-1)}else{let se=!1,X="",z=!1,R="";for(const F of ne){if(F!=="}"&&se){X+=F;continue}if(z&&(F!=="]"||!R)){let B;F==="-"?B=F:(F==="^"||F==="!")&&!R?B="^":F===e.$Bj?B="":B=(0,S.$Je)(F),R+=B;continue}switch(F){case"{":se=!0;continue;case"[":z=!0;continue;case"}":{const N=`(?:${$(X,",").map(V=>p(V)).join("|")})`;J+=N,se=!1,X="";break}case"]":{J+="["+R+"]",z=!1,R="";break}case"?":J+=k;continue;case"*":J+=c(1);continue;default:J+=(0,S.$Je)(F)}}_<W.length-1&&(W[_+1]!==e.$Aj||_+2<W.length)&&(J+=C)}ee=ne===e.$Aj})}return J}const w=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,E=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new j.$Cc(1e4),o=function(){return!1},n=function(){return null};function i(Q,J){if(!Q)return n;let W;typeof Q!="string"?W=Q.pattern:W=Q,W=W.trim();const ee=`${W}_${!!J.trimForExclusions}`;let ne=s.get(ee);if(ne)return t(ne,Q);let _;return w.test(W)?ne=a(W.substr(4),W):(_=l.exec(r(W,J)))?ne=v(_[1],W):(J.trimForExclusions?h:u).test(W)?ne=m(W,J):(_=d.exec(r(W,J)))?ne=f(_[1].substr(1),W,!0):(_=E.exec(r(W,J)))?ne=f(_[1],W,!1):ne=y(W),s.set(ee,ne),t(ne,Q)}function t(Q,J){if(typeof J=="string")return Q;const W=function(ee,ne){return(0,L.$2f)(ee,J.base,!P.$k)?Q((0,S.$Ne)(ee.substr(J.base.length),O.sep),ne):null};return W.allBasenames=Q.allBasenames,W.allPaths=Q.allPaths,W.basenames=Q.basenames,W.patterns=Q.patterns,W}function r(Q,J){return J.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function a(Q,J){return function(W,ee){return typeof W=="string"&&W.endsWith(Q)?J:null}}function v(Q,J){const W=`/${Q}`,ee=`\\${Q}`,ne=function(se,X){return typeof se!="string"?null:X?X===Q?J:null:se===Q||se.endsWith(W)||se.endsWith(ee)?J:null},_=[Q];return ne.basenames=_,ne.patterns=[J],ne.allBasenames=_,ne}function m(Q,J){const W=x(Q.slice(1,-1).split(",").map(X=>i(X,J)).filter(X=>X!==n),Q),ee=W.length;if(!ee)return n;if(ee===1)return W[0];const ne=function(X,z){for(let R=0,F=W.length;R<F;R++)if(W[R](X,z))return Q;return null},_=W.find(X=>!!X.allBasenames);_&&(ne.allBasenames=_.allBasenames);const se=W.reduce((X,z)=>z.allPaths?X.concat(z.allPaths):X,[]);return se.length&&(ne.allPaths=se),ne}function f(Q,J,W){const ee=O.sep===O.$fc.sep,ne=ee?Q:Q.replace(g,O.sep),_=O.sep+ne,se=O.$fc.sep+Q;let X;return W?X=function(z,R){return typeof z=="string"&&(z===ne||z.endsWith(_)||!ee&&(z===Q||z.endsWith(se)))?J:null}:X=function(z,R){return typeof z=="string"&&(z===ne||!ee&&z===Q)?J:null},X.allPaths=[(W?"*/":"./")+Q],X}function y(Q){try{const J=new RegExp(`^${p(Q)}$`);return function(W){return J.lastIndex=0,typeof W=="string"&&J.test(W)?Q:null}}catch{return n}}function I(Q,J,W){return!Q||typeof J!="string"?!1:T(Q)(J,void 0,W)}e.$Dj=I;function T(Q,J={}){if(!Q)return o;if(typeof Q=="string"||M(Q)){const W=i(Q,J);if(W===n)return o;const ee=function(ne,_){return!!W(ne,_)};return W.allBasenames&&(ee.allBasenames=W.allBasenames),W.allPaths&&(ee.allPaths=W.allPaths),ee}return Y(Q,J)}e.$Ej=T;function M(Q){const J=Q;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.$Fj=M;function U(Q){return Q.allBasenames||[]}e.$Gj=U;function q(Q){return Q.allPaths||[]}e.$Hj=q;function Y(Q,J){const W=x(Object.getOwnPropertyNames(Q).map(X=>K(X,Q[X],J)).filter(X=>X!==n)),ee=W.length;if(!ee)return n;if(!W.some(X=>!!X.requiresSiblings)){if(ee===1)return W[0];const X=function(F,B){let N;for(let V=0,G=W.length;V<G;V++){const te=W[V](F,B);if(typeof te=="string")return te;(0,A.$Mg)(te)&&(N||(N=[]),N.push(te))}return N?(async()=>{for(const V of N){const G=await V;if(typeof G=="string")return G}return null})():null},z=W.find(F=>!!F.allBasenames);z&&(X.allBasenames=z.allBasenames);const R=W.reduce((F,B)=>B.allPaths?F.concat(B.allPaths):F,[]);return R.length&&(X.allPaths=R),X}const ne=function(X,z,R){let F,B;for(let N=0,V=W.length;N<V;N++){const G=W[N];G.requiresSiblings&&R&&(z||(z=(0,O.$mc)(X)),F||(F=z.substr(0,z.length-(0,O.$nc)(X).length)));const te=G(X,z,F,R);if(typeof te=="string")return te;(0,A.$Mg)(te)&&(B||(B=[]),B.push(te))}return B?(async()=>{for(const N of B){const V=await N;if(typeof V=="string")return V}return null})():null},_=W.find(X=>!!X.allBasenames);_&&(ne.allBasenames=_.allBasenames);const se=W.reduce((X,z)=>z.allPaths?X.concat(z.allPaths):X,[]);return se.length&&(ne.allPaths=se),ne}function K(Q,J,W){if(J===!1)return n;const ee=i(Q,W);if(ee===n)return n;if(typeof J=="boolean")return ee;if(J){const ne=J.when;if(typeof ne=="string"){const _=(se,X,z,R)=>{if(!R||!ee(se,X))return null;const F=ne.replace("$(basename)",()=>z),B=R(F);return(0,A.$Mg)(B)?B.then(N=>N?Q:null):B?Q:null};return _.requiresSiblings=!0,_}}return ee}function x(Q,J){const W=Q.filter(X=>!!X.basenames);if(W.length<2)return Q;const ee=W.reduce((X,z)=>{const R=z.basenames;return R?X.concat(R):X},[]);let ne;if(J){ne=[];for(let X=0,z=ee.length;X<z;X++)ne.push(J)}else ne=W.reduce((X,z)=>{const R=z.patterns;return R?X.concat(R):X},[]);const _=function(X,z){if(typeof X!="string")return null;if(!z){let F;for(F=X.length;F>0;F--){const B=X.charCodeAt(F-1);if(B===47||B===92)break}z=X.substr(F)}const R=ee.indexOf(z);return R!==-1?ne[R]:null};_.basenames=ee,_.patterns=ne,_.allBasenames=ee;const se=Q.filter(X=>!X.basenames);return se.push(_),se}function H(Q,J){return(0,D.$tb)(Q,J,(W,ee)=>typeof W=="string"&&typeof ee=="string"?W===ee:typeof W!="string"&&typeof ee!="string"?W.base===ee.base&&W.pattern===ee.pattern:!1)}e.$Ij=H}),define(ae[92],ce([0,1,15,10]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=void 0;function L(k){return k.toJSON()}class j{constructor(g){this.a=g}transformIncoming(g){const c=this.a.transformIncoming(g);return c===g?g:L(A.URI.from(c))}transformOutgoing(g){const c=this.a.transformOutgoing(g);return c===g?g:L(A.URI.from(c))}transformOutgoingURI(g){const c=this.a.transformOutgoing(g);return c===g?g:A.URI.from(c)}transformOutgoingScheme(g){return this.a.transformOutgoingScheme(g)}}e.$Tm=j,e.$Um=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function O(k,g,c){if(!k||c>200)return null;if(typeof k=="object"){if(k instanceof A.URI)return g.transformOutgoing(k);for(const $ in k)if(Object.hasOwnProperty.call(k,$)){const p=O(k[$],g,c+1);p!==null&&(k[$]=p)}}return null}function P(k,g){const c=O(k,g,0);return c===null?k:c}e.$Vm=P;function S(k,g,c,$){if(!k||$>200)return null;if(typeof k=="object"){if(k.$mid===1)return c?A.URI.revive(g.transformIncoming(k)):g.transformIncoming(k);if(k instanceof D.$fe)return null;for(const p in k)if(Object.hasOwnProperty.call(k,p)){const w=S(k[p],g,c,$+1);w!==null&&(k[p]=w)}}return null}function b(k,g){const c=S(k,g,!1,0);return c===null?k:c}e.$Wm=b;function C(k,g){const c=S(k,g,!0,0);return c===null?k:c}e.$Xm=C}),define(ae[142],ce([0,1,36,47,32,130,5]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=e.$Zm=void 0,e.$Zm=new class{c(g){return this.a||(this.a=A.$4h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(g)}value(){if(this.b===void 0){let g=0,c=0;const $=(0,D.networkInterfaces)();for(const p in $){const w=$[p];if(w)for(const{mac:l,internal:u}of w)u||(c+=1,this.c(l.toUpperCase())&&(g+=1))}this.b=c>0?g/c:0}return this.b}};let P;async function S(g){return P||(P=(async()=>await b(g)||L.$kg())()),P}e.$1m=S;async function b(g){try{const c=await new Promise((p,w)=>{ie(["crypto"],p,w)}),$=(0,j.$Ym)();return c.createHash("sha256").update($,"utf8").digest("hex")}catch(c){g(c);return}}const C="Software\\Microsoft\\SQMClient";async function k(g){if(O.$i){const c=await new Promise(($,p)=>{ie(["@vscode/windows-registry"],$,p)});try{return c.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch($){return g($),""}}return""}e.$2m=k}),define(ae[31],ce([0,1,53,36,268,6,48,88,16,5,19,10]),function(ie,e,D,A,L,j,O,P,S,b,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function c(K,x=g.UNLINK,H){if((0,O.$5f)(K))throw new Error("rimraf - will refuse to recursively delete root");return x===g.UNLINK?p(K):$(K,H)}async function $(K,x=(0,O.$0f)((0,A.tmpdir)())){try{try{await D.promises.rename(K,x)}catch(H){return H.code==="ENOENT"?void 0:p(K)}p(x).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function p(K){return(0,L.promisify)(D.rm)(K,{recursive:!0,force:!0,maxRetries:3})}function w(K){if((0,O.$5f)(K))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function l(K,x){return d(await(x?u(K):(0,L.promisify)(D.readdir)(K)))}async function u(K){try{return await(0,L.promisify)(D.readdir)(K,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const x=[],H=await l(K);for(const Q of H){let J=!1,W=!1,ee=!1;try{const ne=await e.Promises.lstat((0,S.$ic)(K,Q));J=ne.isFile(),W=ne.isDirectory(),ee=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}x.push({name:Q,isFile:()=>J,isDirectory:()=>W,isSymbolicLink:()=>ee})}return x}function h(K){return d(D.readdirSync(K))}e.readdirSync=h;function d(K){return K.map(x=>typeof x=="string"?b.$j?(0,P.$wl)(x):x:(x.name=b.$j?(0,P.$wl)(x.name):x.name,x))}async function E(K){const x=await l(K),H=[];for(const Q of x)await o.existsDirectory((0,S.$ic)(K,Q))&&H.push(Q);return H}function s(K,x=1e3){return new Promise(H=>{let Q=!1;const J=setInterval(()=>{Q||(Q=!0,D.access(K,W=>{Q=!1,W&&(clearInterval(J),H(void 0))}))},x)})}e.whenDeleted=s;var o;(function(K){async function x(J){let W;try{if(W=await e.Promises.lstat(J),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(b.$i&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw ne}throw ee}}K.stat=x;async function H(J){try{const{stat:W,symbolicLink:ee}=await K.stat(J);return W.isFile()&&ee?.dangling!==!0}catch{}return!1}K.existsFile=H;async function Q(J){try{const{stat:W,symbolicLink:ee}=await K.stat(J);return W.isDirectory()&&ee?.dangling!==!0}catch{}return!1}K.existsDirectory=Q})(o||(e.SymlinkSupport=o={}));const n=new j.$9g;function i(K,x,H){return n.queueFor(k.URI.file(K),C.$sg).queue(()=>{const Q=m(H);return new Promise((J,W)=>a(K,x,Q,ee=>ee?W(ee):J()))})}let t=!0;function r(K){t=K}e.configureFlushOnWrite=r;function a(K,x,H,Q){if(!t)return D.writeFile(K,x,{mode:H.mode,flag:H.flag},Q);D.open(K,H.flag,H.mode,(J,W)=>{if(J)return Q(J);D.writeFile(W,x,ee=>{if(ee)return D.close(W,()=>Q(ee));D.fdatasync(W,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),D.close(W,_=>Q(_))))})})}function v(K,x,H){const Q=m(H);if(!t)return D.writeFileSync(K,x,{mode:Q.mode,flag:Q.flag});const J=D.openSync(K,Q.flag,Q.mode);try{D.writeFileSync(J,x);try{D.fdatasyncSync(J)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),r(!1)}}finally{D.closeSync(J)}}e.writeFileSync=v;function m(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function f(K,x,H=6e4){if(K!==x)try{b.$i&&typeof H=="number"?await y(K,x,Date.now(),H):await(0,L.promisify)(D.rename)(K,x)}catch(Q){if(K.toLowerCase()!==x.toLowerCase()&&Q.code==="EXDEV"||K.endsWith("."))await I(K,x,{preserveSymlinks:!1}),await c(K,g.MOVE);else throw Q}}async function y(K,x,H,Q,J=0){try{return await(0,L.promisify)(D.rename)(K,x)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-H>=Q)throw console.error(`[node.js fs] rename failed after ${J} retries with error: ${W}`),W;if(J===0){let ee=!1;try{const{stat:ne}=await o.stat(x);ne.isFile()||(ee=!0)}catch{}if(ee)throw W}return await(0,j.$1g)(Math.min(100,J*10)),y(K,x,H,Q,J+1)}}async function I(K,x,H){return M(K,x,{root:{source:K,target:x},options:H,handledSourcePaths:new Set})}const T=511;async function M(K,x,H){if(H.handledSourcePaths.has(K))return;H.handledSourcePaths.add(K);const{stat:Q,symbolicLink:J}=await o.stat(K);if(J){if(H.options.preserveSymlinks)try{return await Y(K,x,H)}catch{}if(J.dangling)return}return Q.isDirectory()?U(K,x,Q.mode&T,H):q(K,x,Q.mode&T)}async function U(K,x,H,Q){await e.Promises.mkdir(x,{recursive:!0,mode:H});const J=await l(K);for(const W of J)await M((0,S.$ic)(K,W),(0,S.$ic)(x,W),Q)}async function q(K,x,H){await e.Promises.copyFile(K,x),await e.Promises.chmod(x,H)}async function Y(K,x,H){let Q=await e.Promises.readlink(K);(0,O.$2f)(Q,H.root.source,!b.$k)&&(Q=(0,S.$ic)(H.root.target,Q.substr(H.root.source.length+1))),await e.Promises.symlink(Q,x)}e.Promises=new class{get access(){return(0,L.promisify)(D.access)}get stat(){return(0,L.promisify)(D.stat)}get lstat(){return(0,L.promisify)(D.lstat)}get utimes(){return(0,L.promisify)(D.utimes)}get read(){return(K,x,H,Q,J)=>new Promise((W,ee)=>{D.read(K,x,H,Q,J,(ne,_,se)=>ne?ee(ne):W({bytesRead:_,buffer:se}))})}get readFile(){return(0,L.promisify)(D.readFile)}get write(){return(K,x,H,Q,J)=>new Promise((W,ee)=>{D.write(K,x,H,Q,J,(ne,_,se)=>ne?ee(ne):W({bytesWritten:_,buffer:se}))})}get appendFile(){return(0,L.promisify)(D.appendFile)}get fdatasync(){return(0,L.promisify)(D.fdatasync)}get truncate(){return(0,L.promisify)(D.truncate)}get copyFile(){return(0,L.promisify)(D.copyFile)}get open(){return(0,L.promisify)(D.open)}get close(){return(0,L.promisify)(D.close)}get symlink(){return(0,L.promisify)(D.symlink)}get readlink(){return(0,L.promisify)(D.readlink)}get chmod(){return(0,L.promisify)(D.chmod)}get mkdir(){return(0,L.promisify)(D.mkdir)}get unlink(){return(0,L.promisify)(D.unlink)}get rmdir(){return(0,L.promisify)(D.rmdir)}get realpath(){return(0,L.promisify)(D.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return E}get writeFile(){return i}get rm(){return c}get rename(){return f}get copy(){return I}}}),define(ae[143],ce([0,1,53,16,5,27,31]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=e.$bq=e.$aq=void 0;function P(g){if(L.$k)return g;const c=(0,A.$lc)(g);if(g===c)return g;const $=((0,A.$mc)(g)||g).toLowerCase();try{const w=(0,O.readdirSync)(c).filter(l=>l.toLowerCase()===$);if(w.length===1){const l=P(c);if(l)return(0,A.$ic)(l,w[0])}else if(w.length>1){const l=w.indexOf($);if(l>=0){const u=P(c);if(u)return(0,A.$ic)(u,w[l])}}}catch{}return null}e.$aq=P;async function S(g){if(L.$k)return g;const c=(0,A.$lc)(g);if(g===c)return g;const $=((0,A.$mc)(g)||g).toLowerCase();try{const w=(await O.Promises.readdir(c)).filter(l=>l.toLowerCase()===$);if(w.length===1){const l=await S(c);if(l)return(0,A.$ic)(l,w[0])}else if(w.length>1){const l=w.indexOf($);if(l>=0){const u=await S(c);if(u)return(0,A.$ic)(u,w[l])}}}catch{}return null}e.$bq=S;async function b(g){try{return await O.Promises.realpath(g)}catch{const $=k(g);return await O.Promises.access($,D.constants.R_OK),$}}e.$cq=b;function C(g){try{return D.realpathSync(g)}catch{const $=k(g);return D.accessSync($,D.constants.R_OK),$}}e.$dq=C;function k(g){return(0,j.$Oe)((0,A.$gc)(g),A.sep)}}),define(ae[144],ce([0,1,16,5,37,90,12,31]),function(ie,e,D,A,L,j,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Kl=e.$Jl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function S(k=L.env){return k.comspec||"cmd.exe"}e.$Jl=S;function b(k){let g=[],c=!1;const $=function(p){if(c){g.push(p);return}(!k.send(p,l=>{if(l&&console.error(l),c=!1,g.length>0){const u=g.slice(0);g=[],u.forEach(h=>$(h))}})||A.$i)&&(c=!0)};return{send:$}}e.$Kl=b;var C;(function(k){async function g(c,$,p){if(D.$hc(c))return c;if($===void 0&&($=L.cwd()),D.$lc(c)!=="."||(p===void 0&&O.$Cf(L.env.PATH)&&(p=L.env.PATH.split(D.$sc)),p===void 0||p.length===0))return D.$ic($,c);async function l(u){if(await P.Promises.exists(u)){let h;try{h=await P.Promises.stat(u)}catch(d){d.message.startsWith("EACCES")&&(h=await P.Promises.lstat(u))}return h?!h.isDirectory():!1}return!1}for(const u of p){let h;if(D.$hc(u)?h=D.$ic(u,c):h=D.$ic($,u,c),await l(h))return h;let d=h+".com";if(await l(d)||(d=h+".exe",await l(d)))return d}return D.$ic($,c)}k.findExecutable=g})(C||(e.win32=C={}))}),define(ae[145],ce([0,1,66,23]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=void 0;function L(O){return new Promise((P,S)=>{let b;const C=new Map;function k(c,$,p,w,l){const u=C.get($);if(c===O||u){const h={name:g(p),cmd:p,pid:c,ppid:$,load:w,mem:l};C.set(c,h),c===O&&(b=h),u&&(u.children||(u.children=[]),u.children.push(h),u.children.length>1&&(u.children=u.children.sort((d,E)=>d.pid-E.pid)))}}function g(c){const $=/--utility-sub-type=network/i,p=/--ms-enable-electron-run-as-node/i,w=/--crashes-directory/i,l=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,h=/--type=([a-zA-Z-]+)/;if(w.exec(c))return"electron-crash-reporter";if(l.exec(c))return"winpty-agent";if(u.exec(c))return"conpty-agent";let d=h.exec(c);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?$.exec(c)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const E=/[a-zA-Z-]+\.js/g;let s="";do d=E.exec(c),d&&(s+=d+" ");while(d);return s&&c.indexOf("node ")<0&&c.indexOf("node.exe")<0?`electron-nodejs (${s})`:p.exec(c)?`electron-nodejs (${c})`:c}if(process.platform==="win32"){const c=$=>$.indexOf("\\\\?\\")===0||$.indexOf("\\??\\")===0?$.substring(4):$.indexOf('"\\\\?\\')===0||$.indexOf('"\\??\\')===0?'"'+$.substring(5):$;new Promise(($,p)=>{ie(["@vscode/windows-process-tree"],$,p)}).then($=>{$.getProcessList(O,p=>{if(!p){S(new Error(`Root process ${O} not found`));return}$.getProcessCpuUsage(p,w=>{const l=new Map;w.forEach(u=>{const h=c(u.commandLine||"");l.set(u.pid,{name:g(h),cmd:h,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),b=l.get(O),b?(l.forEach(u=>{const h=l.get(u.ppid);h&&(h.children||(h.children=[]),h.children.push(u))}),l.forEach(u=>{u.children&&(u.children=u.children.sort((h,d)=>h.pid-d.pid))}),P(b)):S(new Error(`Root process ${O} not found`))})},$.ProcessDataFlag.CommandLine|$.ProcessDataFlag.Memory)})}else{let c=function(){let $=[b];const p=[];for(;$.length;){const l=$.shift();l&&(p.push(l.pid),l.children&&($=$.concat(l.children)))}let w=JSON.stringify(A.$ig.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+p.join(" "),(0,D.exec)(w,{},(l,u,h)=>{if(l||h)S(l||new Error(h.toString()));else{const d=u.toString().split(`
`);for(let E=0;E<p.length;E++){const s=C.get(p[E]);s.load=parseFloat(d[E])}if(!b){S(new Error(`Root process ${O} not found`));return}P(b)}})};(0,D.exec)("which ps",{},($,p,w)=>{if($||w)if(process.platform!=="linux")S($||new Error(w.toString()));else{const l=JSON.stringify(A.$ig.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(l,{},(u,h,d)=>{u||d?S(u||new Error(d.toString())):(j(h,k),c())})}else{const l=p.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${l} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,d,E)=>{h||E&&!E.includes("screen size is bogus")?S(h||new Error(E.toString())):(j(d,k),process.platform==="linux"?c():b?P(b):S(new Error(`Root process ${O} not found`)))})}})}})}e.$Kr=L;function j(O,P){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=O.toString().split(`
`);for(const C of b){const k=S.exec(C.trim());k&&k.length===6&&P(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}});var pe=this&&this.__decorate||function(ie,e,D,A){var L=arguments.length,j=L<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,D):A,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(ie,e,D,A);else for(var P=ie.length-1;P>=0;P--)(O=ie[P])&&(j=(L<3?O(j):L>3?O(e,D,j):O(e,D))||j);return L>3&&j&&Object.defineProperty(e,D,j),j};define(ae[40],ce([0,1,18,6,15,26,84,7,3,2,65,27,12]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gh=e.ProxyChannel=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.RequestInitiator=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=void 0;var c;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(c||(c={}));function $(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(p||(p={}));function w(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(l||(l={}));function u(J){let W=0;for(let ee=0;;ee+=7){const ne=J.read(1);if(W|=(ne.buffer[0]&127)<<ee,!(ne.buffer[0]&128))return W}}const h=n(0);function d(J,W){if(W===0){J.write(h);return}let ee=0;for(let _=W;_!==0;_=_>>>7)ee++;const ne=L.$fe.alloc(ee);for(let _=0;W!==0;_++)ne.buffer[_]=W&127,W=W>>>7,W>0&&(ne.buffer[_]|=128);J.write(ne)}class E{constructor(W){this.b=W,this.a=0}read(W){const ee=this.b.slice(this.a,this.a+W);return this.a+=ee.byteLength,ee}}e.$vh=E;class s{constructor(){this.a=[]}get buffer(){return L.$fe.concat(this.a)}write(W){this.a.push(W)}}e.$wh=s;var o;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(o||(o={}));function n(J){const W=L.$fe.alloc(1);return W.writeUInt8(J,0),W}const i={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(J,W){if(typeof W>"u")J.write(i.Undefined);else if(typeof W=="string"){const ee=L.$fe.fromString(W);J.write(i.String),d(J,ee.byteLength),J.write(ee)}else if(t&&Buffer.isBuffer(W)){const ee=L.$fe.wrap(W);J.write(i.Buffer),d(J,ee.byteLength),J.write(ee)}else if(W instanceof L.$fe)J.write(i.VSBuffer),d(J,W.byteLength),J.write(W);else if(Array.isArray(W)){J.write(i.Array),d(J,W.length);for(const ee of W)r(J,ee)}else if(typeof W=="number"&&(W|0)===W)J.write(i.Uint),d(J,W);else{const ee=L.$fe.fromString(JSON.stringify(W));J.write(i.Object),d(J,ee.byteLength),J.write(ee)}}e.$xh=r;function a(J){switch(J.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return J.read(u(J)).toString();case o.Buffer:return J.read(u(J)).buffer;case o.VSBuffer:return J.read(u(J));case o.Array:{const ee=u(J),ne=[];for(let _=0;_<ee;_++)ne.push(a(J));return ne}case o.Object:return JSON.parse(J.read(u(J)).toString());case o.Int:return u(J)}}e.$yh=a;class v{constructor(W,ee,ne=null,_=1e3){this.h=W,this.j=ee,this.k=ne,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:200})}registerChannel(W,ee){this.b.set(W,ee),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const ee=this.o([W.type]);this.k?.logOutgoing(ee,0,1,w(W.type));return}case 201:case 202:case 204:case 203:{const ee=this.o([W.type,W.id],W.data);this.k?.logOutgoing(ee,W.id,1,w(W.type),W.data);return}}}o(W,ee=void 0){const ne=new s;return r(ne,W),r(ne,ee),this.p(ne.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const ee=new E(W),ne=a(ee),_=a(ee),se=ne[0];switch(se){case 100:return this.k?.logIncoming(W.byteLength,ne[1],1,`${$(se)}: ${ne[2]}.${ne[3]}`,_),this.s({type:se,id:ne[1],channelName:ne[2],name:ne[3],arg:_});case 102:return this.k?.logIncoming(W.byteLength,ne[1],1,`${$(se)}: ${ne[2]}.${ne[3]}`,_),this.t({type:se,id:ne[1],channelName:ne[2],name:ne[3],arg:_});case 101:return this.k?.logIncoming(W.byteLength,ne[1],1,`${$(se)}`),this.u({type:se,id:ne[1]});case 103:return this.k?.logIncoming(W.byteLength,ne[1],1,`${$(se)}`),this.u({type:se,id:ne[1]})}}s(W){const ee=this.b.get(W.channelName);if(!ee){this.v(W);return}const ne=new j.$2d;let _;try{_=ee.call(this.j,W.name,W.arg,ne.token)}catch(z){_=Promise.reject(z)}const se=W.id;_.then(z=>{this.m({id:se,data:z,type:201})},z=>{z instanceof Error?this.m({id:se,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:se,data:z,type:203})}).finally(()=>{X.dispose(),this.d.delete(W.id)});const X=(0,b.$Pc)(()=>ne.cancel());this.d.set(W.id,X)}t(W){const ee=this.b.get(W.channelName);if(!ee){this.v(W);return}const ne=W.id,se=ee.listen(this.j,W.name,W.arg)(X=>this.m({id:ne,data:X,type:204}));this.d.set(W.id,se)}u(W){const ee=this.d.get(W.id);ee&&(ee.dispose(),this.d.delete(W.id))}v(W){let ee=this.g.get(W.channelName);ee||(ee=[],this.g.set(W.channelName,ee));const ne=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ee.push({request:W,timeoutTimer:ne})}w(W){const ee=this.g.get(W);if(ee){for(const ne of ee)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$Mc)(this.d.values()),this.d.clear()}}e.$zh=v;var m;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));class f{constructor(W,ee=null){this.l=W,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.$Rd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=ee}getChannel(W){const ee=this;return{call(ne,_,se){return ee.a?Promise.reject(new P.$4):ee.m(W,ne,_,se)},listen(ne,_){return ee.a?S.Event.None:ee.o(W,ne,_)}}}m(W,ee,ne,_=j.CancellationToken.None){const se=this.g++,z={id:se,type:100,channelName:W,name:ee,arg:ne};if(_.isCancellationRequested)return Promise.reject(new P.$4);let R;return new Promise((B,N)=>{if(_.isCancellationRequested)return N(new P.$4);const V=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(se),B(he.data);break;case 202:{this.f.delete(se);const ge=new Error(he.data.message);ge.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,ge.name=he.data.name,N(ge);break}case 203:this.f.delete(se),N(he.data);break}};this.f.set(se,ue),this.p(z)};let G=null;this.b===l.Idle?V():(G=(0,A.$Ng)(ue=>this.u()),G.then(()=>{G=null,V()}));const te=()=>{G?(G.cancel(),G=null):this.p({id:se,type:101}),N(new P.$4)},oe=_.onCancellationRequested(te);R=(0,b.$Oc)((0,b.$Pc)(te),oe),this.d.add(R)}).finally(()=>{R.dispose(),this.d.delete(R)})}o(W,ee,ne){const _=this.g++,X={id:_,type:102,channelName:W,name:ee,arg:ne};let z=null;const R=new S.$Rd({onWillAddFirstListener:()=>{z=(0,A.$Ng)(B=>this.u()),z.then(()=>{z=null,this.d.add(R),this.p(X)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(R),this.p({id:_,type:103}))}}),F=B=>R.fire(B.data);return this.f.set(_,F),R.event}p(W){switch(W.type){case 100:case 102:{const ee=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(ee,W.id,0,`${$(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const ee=this.q([W.type,W.id]);this.j?.logOutgoing(ee,W.id,0,$(W.type));return}}}q(W,ee=void 0){const ne=new s;return r(ne,W),r(ne,ee),this.r(ne.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const ee=new E(W),ne=a(ee),_=a(ee),se=ne[0];switch(se){case 200:return this.j?.logIncoming(W.byteLength,0,0,w(se)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,ne[1],0,w(se),_),this.t({type:ne[0],id:ne[1],data:_})}}t(W){if(W.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$Mc)(this.d.values()),this.d.clear()}}e.$Ah=f,pe([O.$ph],f.prototype,"onDidInitializePromise",null);class y{get connections(){const W=[];return this.f.forEach(ee=>W.push(ee)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new S.$Rd,this.onDidAddConnection=this.g.event,this.h=new S.$Rd,this.onDidRemoveConnection=this.h.event,this.j=new b.$Qc,this.j.add(W(({protocol:ee,onDidClientDisconnect:ne})=>{const _=S.Event.once(ee.onMessage);this.j.add(_(se=>{const X=new E(se),z=a(X),R=new v(ee,z),F=new f(ee);this.a.forEach((N,V)=>R.registerChannel(V,N));const B={channelServer:R,channelClient:F,ctx:z};this.f.add(B),this.g.fire(B),this.j.add(ne(()=>{R.dispose(),F.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel(W,ee){const ne=this;return{call(_,se,X){let z;if((0,g.$Qf)(ee)){const F=(0,D.$3b)(ne.connections.filter(ee));z=F?Promise.resolve(F):S.Event.toPromise(S.Event.filter(ne.onDidAddConnection,ee))}else z=ee.routeCall(ne,_,se);const R=z.then(F=>F.channelClient.getChannel(W));return T(R).call(_,se,X)},listen(_,se){if((0,g.$Qf)(ee))return ne.k(W,ee,_,se);const X=ee.routeEvent(ne,_,se).then(z=>z.channelClient.getChannel(W));return T(X).listen(_,se)}}}k(W,ee,ne,_){const se=this;let X;const z=new S.$Rd({onWillAddFirstListener:()=>{X=new b.$Qc;const R=new S.$Xd,F=new Map,B=V=>{const te=V.channelClient.getChannel(W).listen(ne,_),oe=R.add(te);F.set(V,oe)},N=V=>{const G=F.get(V);G&&(G.dispose(),F.delete(V))};se.connections.filter(ee).forEach(B),S.Event.filter(se.onDidAddConnection,ee)(B,void 0,X),se.onDidRemoveConnection(N,void 0,X),R.event(z.fire,z,X),X.add(R)},onDidRemoveLastListener:()=>{X?.dispose(),X=void 0}});return z.event}registerChannel(W,ee){this.a.set(W,ee);for(const ne of this.f)ne.channelServer.registerChannel(W,ee)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Bh=y;class I{constructor(W,ee,ne=null){const _=new s;r(_,ee),W.send(_.buffer),this.a=new f(W,ne),this.d=new v(W,ee,ne)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,ee){this.d.registerChannel(W,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Ch=I;function T(J){return{call(W,ee,ne){return J.then(_=>_.call(W,ee,ne))},listen(W,ee){const ne=new S.$1d;return J.then(_=>ne.input=_.listen(W,ee)),ne.event}}}e.$Dh=T;function M(J){let W=!1;return{call(ee,ne,_){return W?J.call(ee,ne,_):(0,A.$1g)(0).then(()=>W=!0).then(()=>J.call(ee,ne,_))},listen(ee,ne){if(W)return J.listen(ee,ne);const _=new S.$1d;return(0,A.$1g)(0).then(()=>W=!0).then(()=>_.input=J.listen(ee,ne)),_.event}}}e.$Eh=M;class U{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const ee of W.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await S.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$Fh=U;var q;(function(J){function W(se,X,z){const R=se,F=z&&z.disableMarshalling,B=new Map;for(const N in R)ne(N)&&B.set(N,S.Event.buffer(R[N],!0,void 0,X));return new class{listen(N,V,G){const te=B.get(V);if(te)return te;if(_(V)){const oe=R[V];if(typeof oe=="function")return oe.call(R,G)}throw new P.$ab(`Event not found: ${V}`)}call(N,V,G){const te=R[V];if(typeof te=="function"){if(!F&&Array.isArray(G))for(let ue=0;ue<G.length;ue++)G[ue]=(0,C.$uh)(G[ue]);let oe=te.apply(R,G);return oe instanceof Promise||(oe=Promise.resolve(oe)),oe}throw new P.$ab(`Method not found: ${V}`)}}}J.fromService=W;function ee(se,X){const z=X&&X.disableMarshalling;return new Proxy({},{get(R,F){if(typeof F=="string")return X?.properties?.has(F)?X.properties.get(F):_(F)?function(B){return se.listen(F,B)}:ne(F)?se.listen(F):async function(...B){let N;X&&!(0,g.$Lf)(X.context)?N=[X.context,...B]:N=B;const V=await se.call(F,N);return z?V:(0,C.$uh)(V)};throw new P.$ab(`Property not found: ${String(F)}`)}})}J.toService=ee;function ne(se){return se[0]==="o"&&se[1]==="n"&&k.$5e(se.charCodeAt(2))}function _(se){return/^onDynamic/.test(se)&&k.$5e(se.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const W=J.toString();if(W!=="[object Object]")return W}return J}function x(J){return Array.isArray(J)?J.map(K):K(J)}function H(J,W,ee,ne,_,se,X){X=x(X);const z=Y[_],R=z[ne%z.length];let F=[`%c[${J}]%c[${String(W).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${R}`];/\($/.test(se)?(F=F.concat(X),F.push(")")):F.push(X),console.log.apply(console,F)}class Q{constructor(W,ee){this.d=W,this.f=ee,this.a=0,this.b=0}logOutgoing(W,ee,ne,_,se){this.b+=W,H(this.d,this.b,W,ee,ne,_,se)}logIncoming(W,ee,ne,_,se){this.a+=W,H(this.f,this.a,W,ee,ne,_,se)}}e.$Gh=Q}),define(ae[67],ce([0,1,15,3,2,40]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.ProtocolConstants=e.$Hh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const t=new WeakMap;let r=0;function a(m,f){if(!t.has(m)){const y=String(++r);t.set(m,y)}return t.get(m)}function v(m,f,y,I){if(!i.enableDiagnostics)return;const T=a(m,f);if(I instanceof D.$fe||I instanceof Uint8Array||I instanceof ArrayBuffer||ArrayBuffer.isView(I)){const M=D.$fe.alloc(I.byteLength);M.set(I),i.records.push({timestamp:Date.now(),id:T,label:f,type:y,buff:M})}else i.records.push({timestamp:Date.now(),id:T,label:f,type:y,data:I})}i.traceSocketEvent=v})(P||(e.SocketDiagnostics=P={}));var S;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let b=null;function C(){return b||(b=D.$fe.alloc(0)),b}class k{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return C();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const f=this.a[0];return r&&(this.a.shift(),this.b-=t),f}if(this.a[0].byteLength>t){const f=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),f}const a=D.$fe.alloc(t);let v=0,m=0;for(;t>0;){const f=this.a[m];if(f.byteLength>t){const y=f.slice(0,t);a.set(y,v),v+=t,r&&(this.a[m]=f.slice(t),this.b-=t),t-=t}else a.set(f,v),v+=f.byteLength,r?(this.a.shift(),this.b-=f.byteLength):m++,t-=f.byteLength}return a}}e.$Hh=k;var g;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(g||(g={}));function c(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var $;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})($||(e.ProtocolConstants=$={}));class p{constructor(t,r,a,v){this.type=t,this.id=r,this.ack=a,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends L.$Rc{constructor(t){super(),this.f=this.B(new A.$Rd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new k,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:c(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,v=this.g.id,m=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new p(a,v,m,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=D.$fe.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:c(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=D.$fe.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class u extends L.$Rc{constructor(t){super(),this.f=new A.$Rd,this.onMessage=this.f.event,this.g=new A.$Rd,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new l(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new p(1,0,0,t))}}e.$Ih=u;class h extends j.$Ch{static fromSocket(t,r){return new h(new u(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Jh=h;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$Rd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Kh=d;class E{constructor(t){this.data=t,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new E(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let v=0;v<o.a;v++)t-this.c[v]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new d,this.onControlMessage=this.u.event,this.v=new d,this.onMessage=this.v.event,this.w=new d,this.onDidDispose=this.w.event,this.x=new d,this.onSocketClose=this.x.event,this.y=new d,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Qc,this.o=t.socket,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new p(5,0,0,C());this.p.write(t),this.p.flush()}sendPause(){const t=new p(7,0,0,C());this.p.write(t)}sendResume(){const t=new p(8,0,0,C());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new L.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new p(3,0,this.h,C());this.p.write(t);const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new p(6,0,0,C())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new p(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new p(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&a>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const m=Math.max(2e4-r,2e4-a,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},m)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new p(3,0,this.h,C());this.p.write(t)}D(){this.h=this.g;const t=new p(9,0,this.h,C());this.p.write(t)}}e.$Lh=n}),define(ae[93],ce([0,1,66,6,15,26,140,7,3,2,30,144,90,40]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=void 0;class $ extends c.$zh{constructor(l){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",u=>L.$fe.wrap(Buffer.from(u,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$0p=$;class p{constructor(l,u){this.i=l,this.j=u,this.c=new Set,this.g=new Map,this.h=new S.$Rd,this.onDidProcessExit=this.h.event;const h=u&&u.timeout?u.timeout:6e4;this.b=new A.$Wg(h),this.d=null,this.f=null}getChannel(l){const u=this;return{call(h,d,E){return u.k(l,h,d,E)},listen(h,d){return u.l(l,h,d)}}}k(l,u,h,d=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(P.$5());this.b.cancel();const E=this.n(l),s=(0,A.$Ng)(i=>E.call(u,h,i)),o=d.onCancellationRequested(()=>s.cancel()),n=(0,b.$Pc)(()=>s.cancel());return this.c.add(n),s.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(l,u,h){if(!this.b)return S.Event.None;this.b.cancel();let d;const E=new S.$Rd({onWillAddFirstListener:()=>{d=this.n(l).listen(u,h)(E.fire,E),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return E.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,C.$cn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,g.$Il)(u.env),this.d=(0,D.fork)(this.i,l,u);const h=new S.$Rd;S.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,O.$6p)(t)){(0,O.log)(t,`IPC Library: ${this.j.serverName}`);return}h.fire(L.$fe.wrap(Buffer.from(t,"base64")))});const E=this.j.useQueue?(0,k.$Kl)(this.d):this.d,s=t=>this.d&&this.d.connected&&E.send(t.buffer.toString("base64")),o=h.event,n={send:s,onMessage:o};this.f=new c.$Ah(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",i),this.c.forEach(a=>(0,b.$Mc)(a)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(l){let u=this.g.get(l);return u||(u=this.m.getChannel(l),this.g.set(l,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$$p=p}),define(ae[146],ce([0,1,133,15,40,3,12,18]),function(ie,e,D,A,L,j,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_T=e.$$T=void 0;class S{constructor(g){this.a=g,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",c=>A.$fe.wrap(c.data)),g.start()}send(g){this.a.postMessage(g.buffer)}disconnect(){this.a.close()}}class b extends L.$Bh{static b(g){(0,O.$Mf)((0,D.$0T)(process),"Electron Utility Process");const c=new j.$Rd;return process.parentPort.on("message",$=>{if(g?.handledClientConnection($))return;const p=(0,P.$Nb)($.ports);p&&c.fire(p)}),j.Event.map(c.event,$=>({protocol:new S($),onDidClientDisconnect:j.Event.fromNodeEventEmitter($,"close")}))}constructor(g){super(b.b(g))}}e.$$T=b;function C(k,g,c){const $=p=>{p.data===g&&(k.removeListener("message",$),c())};k.on("message",$)}e.$_T=C}),define(ae[68],ce([0,1,6,3,2,65,12]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.StorageState=e.$9o=e.StorageHint=void 0;var P;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function S(g){const c=g;return c?.changed instanceof Map||c?.deleted instanceof Set}e.$9o=S;var b;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(b||(e.StorageState=b={}));class C extends L.$Rc{static{this.a=100}constructor(c,$=Object.create(null)){super(),this.r=c,this.s=$,this.b=this.B(new A.$Ud),this.onDidChangeStorage=this.b.event,this.c=b.None,this.f=new Map,this.g=this.B(new D.$Xg(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(c=>this.u(c)))}u(c){this.b.pause();try{c.changed?.forEach(($,p)=>this.w(p,$)),c.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(c,$){if(this.c===b.Closed)return;let p=!1;(0,O.$Lf)($)?p=this.f.delete(c):this.f.get(c)!==$&&(this.f.set(c,$),p=!0),p&&this.b.fire({key:c,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===b.None&&(this.c=b.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(c,$){const p=this.f.get(c);return(0,O.$Lf)(p)?$:p}getBoolean(c,$){const p=this.get(c);return(0,O.$Lf)(p)?$:p==="true"}getNumber(c,$){const p=this.get(c);return(0,O.$Lf)(p)?$:parseInt(p,10)}getObject(c,$){const p=this.get(c);return(0,O.$Lf)(p)?$:(0,j.$th)(p)}async set(c,$,p=!1){if(this.c===b.Closed)return;if((0,O.$Lf)($))return this.delete(c,p);const w=(0,O.$Ef)($)||Array.isArray($)?(0,j.$sh)($):String($);if(this.f.get(c)!==w)return this.f.set(c,w),this.j.set(c,w),this.h.delete(c),this.b.fire({key:c,external:p}),this.D()}async delete(c,$=!1){if(!(this.c===b.Closed||!this.f.delete(c)))return this.h.has(c)||this.h.add(c),this.j.delete(c),this.b.fire({key:c,external:$}),this.D()}async optimize(){if(this.c!==b.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=b.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const c={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(c).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(c){if(this.z)return this.D(c)}async D(c){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),c)}async whenFlushed(){if(this.z)return new Promise(c=>this.n.push(c))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$0o=C;class k{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(c){c.insert?.forEach(($,p)=>this.a.set(p,$)),c.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$$o=k}),define(ae[147],ce([13,9]),function(ie,e){return ie.create("vs/base/node/zip",e)}),define(ae[69],ce([0,1,53,6,16,12,31,147]),function(ie,e,D,A,L,j,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.zip=e.$tp=e.$sp=void 0,e.$sp="end of central directory record signature not found";const S=new RegExp(e.$sp);class b extends Error{constructor(E,s){let o=s.message;switch(E){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=E,this.cause=s}}e.$tp=b;function C(d){const E=d.externalFileAttributes>>16||33188;return[448,56,7].map(s=>E&s).reduce((s,o)=>s+o,E&61440)}function k(d){if(d instanceof b)return d;let E;return S.test(d.message)&&(E="CorruptZip"),new b(E,d)}function g(d,E,s,o,n,i){const t=L.$lc(E),r=L.$ic(o,t);if(!r.startsWith(o))return Promise.reject(new Error(P.localize(0,null,E)));const a=L.$ic(o,E);let v;return i.onCancellationRequested(()=>{v?.destroy()}),Promise.resolve(O.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((m,f)=>{if(!i.isCancellationRequested)try{v=(0,D.createWriteStream)(a,{mode:s}),v.once("close",()=>m()),v.once("error",f),d.once("error",f),d.pipe(v)}catch(y){f(y)}}))}function c(d,E,s,o){let n=(0,A.$Ng)(()=>Promise.resolve()),i=0;const t=o.onCancellationRequested(()=>{n.cancel(),d.close()});return new Promise((r,a)=>{const v=new A.$Ug,m=f=>{f.isCancellationRequested||(i++,d.readEntry())};d.once("error",a),d.once("close",()=>n.then(()=>{o.isCancellationRequested||d.entryCount===i?r():a(new b("Incomplete",new Error(P.localize(1,null,i,d.entryCount))))},a)),d.readEntry(),d.on("entry",f=>{if(o.isCancellationRequested)return;if(!s.sourcePathRegex.test(f.fileName)){m(o);return}const y=f.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(y)){const M=L.$ic(E,y);n=(0,A.$Ng)(U=>O.Promises.mkdir(M,{recursive:!0}).then(()=>m(U)).then(void 0,a));return}const I=p(d,f),T=C(f);n=(0,A.$Ng)(M=>v.queue(()=>I.then(U=>g(U,y,T,E,s,M).then(()=>m(M)))).then(null,a))})}).finally(()=>t.dispose())}async function $(d,E=!1){const{open:s}=await new Promise((o,n)=>{ie(["yauzl"],o,n)});return new Promise((o,n)=>{s(d,E?{lazyEntries:!0}:void 0,(i,t)=>{i?n(k(i)):o((0,j.$Nf)(t))})})}function p(d,E){return new Promise((s,o)=>{d.openReadStream(E,(n,i)=>{n?o(k(n)):s((0,j.$Nf)(i))})})}async function w(d,E){const{ZipFile:s}=await new Promise((o,n)=>{ie(["yazl"],o,n)});return new Promise((o,n)=>{const i=new s;E.forEach(r=>{r.contents?i.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&i.addFile(r.localPath,r.path)}),i.end();const t=(0,D.createWriteStream)(d);i.outputStream.pipe(t),i.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(d))})}e.zip=w;function l(d,E,s={},o){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let i=$(d,!0);return s.overwrite&&(i=i.then(t=>O.Promises.rm(E).then(()=>t))),i.then(t=>c(t,E,{sourcePathRegex:n},o))}e.$vp=l;function u(d,E){return $(d).then(s=>new Promise((o,n)=>{s.on("entry",i=>{i.fileName===E&&p(s,i).then(t=>o(t),t=>n(t))}),s.once("close",()=>n(new Error(P.localize(2,null,E))))}))}function h(d,E){return u(d,E).then(s=>new Promise((o,n)=>{const i=[];s.once("error",n),s.on("data",t=>i.push(t)),s.on("end",()=>o(Buffer.concat(i)))}))}e.$wp=h}),define(ae[148],ce([13,9]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[149],ce([13,9]),function(ie,e){return ie.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[150],ce([13,9]),function(ie,e){return ie.create("vs/platform/contextkey/common/scanner",e)}),define(ae[151],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ae[152],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[153],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[154],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[155],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ae[156],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ae[157],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[158],ce([13,9]),function(ie,e){return ie.create("vs/platform/files/common/fileService",e)}),define(ae[159],ce([13,9]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(ae[160],ce([13,9]),function(ie,e){return ie.create("vs/platform/files/common/io",e)}),define(ae[161],ce([13,9]),function(ie,e){return ie.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[162],ce([13,9]),function(ie,e){return ie.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ae[163],ce([13,9]),function(ie,e){return ie.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ae[164],ce([13,9]),function(ie,e){return ie.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ae[165],ce([13,9]),function(ie,e){return ie.create("vs/platform/request/common/request",e)}),define(ae[166],ce([13,9]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ae[167],ce([13,9]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[168],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[169],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ae[170],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ae[171],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ae[172],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ae[173],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ae[174],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ae[175],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ae[176],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ae[177],ce([13,9]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(ae[178],ce([0,1,7,150]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.TokenType=void 0;var L;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(L||(e.TokenType=L={}));function j(...b){switch(b.length){case 1:return(0,A.localize)(0,null,b[0]);case 2:return(0,A.localize)(1,null,b[0],b[1]);case 3:return(0,A.localize)(2,null,b[0],b[1],b[2]);default:return}}const O=(0,A.localize)(3,null),P=(0,A.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,D.$7)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const k=this.d,g=this.c.substring(this.d,this.e),c={type:19,offset:this.d,lexeme:g};this.g.push({offset:k,lexeme:g,additionalInfo:C}),this.f.push(c)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const k=this.c.substring(this.d,this.e),g=S.b.get(k);g?this.k(g):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,k=!1,g=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(P);return}const $=this.c.charCodeAt(C);if(k)k=!1;else if($===47&&!g){C++;break}else $===91?g=!0:$===92?k=!0:$===93&&(g=!1);C++}for(;C<this.c.length&&S.a.has(this.c.charCodeAt(C));)C++;this.e=C;const c=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:c,offset:this.d})}r(){return this.e>=this.c.length}}e.$Si=S}),define(ae[179],ce([0,1,64,84,23,16,37,19,10]),function(ie,e,D,A,L,j,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=e.$om=e.$nm=void 0,e.$nm=/^([^.]+\..+):(.+)$/;class b{get appRoot(){return(0,j.$lc)(L.$ig.asFileUri("").fsPath)}get userHome(){return S.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return S.URI.file((0,j.$ic)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.b.tmpDir)}get cacheHome(){return S.URI.file(this.userDataPath)}get stateResource(){return(0,P.$Bg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$Bg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const c=(0,D.$mm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$ic)(this.userDataPath,"logs",c)}return S.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$Bg)(S.URI.file((0,j.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$Bg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$Bg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$Bg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=O.env.VSCODE_PORTABLE;return c?S.URI.file((0,j.$ic)(c,"argv.json")):(0,P.$Bg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,j.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,j.$jc)(c):(0,j.$gc)((0,j.$ic)(L.$ig.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const c=this.args["extensions-download-dir"];return c?S.URI.file((0,j.$jc)(c)):S.URI.file((0,j.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,j.$jc)(c);const $=O.env.VSCODE_EXTENSIONS;if($)return $;const p=O.env.VSCODE_PORTABLE;return p?(0,j.$ic)(p,"extensions"):(0,P.$Bg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map($=>/^[^:/?#]+?:\/\//.test($)?S.URI.parse($):S.URI.file((0,j.$gc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?S.URI.parse(c):S.URI.file((0,j.$gc)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(c=>!e.$nm.test(c))}get extensionLogLevel(){const c=[];for(const $ of this.args.log||[]){const p=e.$nm.exec($);p&&p[1]&&p[2]&&c.push([p[1],p[2]])}return c.length?c:void 0}get serviceMachineIdResource(){return(0,P.$Bg)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const c=O.env.VSCODE_PORTABLE;return c?S.URI.file((0,j.$ic)(c,"policy.json")):(0,P.$Bg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(c){this.args.continueOn=c}get args(){return this.a}constructor(c,$,p){this.a=c,this.b=$,this.c=p,this.editSessionId=this.args.editSessionId}}e.$om=b,pe([A.$ph],b.prototype,"appRoot",null),pe([A.$ph],b.prototype,"userHome",null),pe([A.$ph],b.prototype,"userDataPath",null),pe([A.$ph],b.prototype,"appSettingsHome",null),pe([A.$ph],b.prototype,"tmpDir",null),pe([A.$ph],b.prototype,"cacheHome",null),pe([A.$ph],b.prototype,"stateResource",null),pe([A.$ph],b.prototype,"userRoamingDataHome",null),pe([A.$ph],b.prototype,"userDataSyncHome",null),pe([A.$ph],b.prototype,"sync",null),pe([A.$ph],b.prototype,"machineSettingsResource",null),pe([A.$ph],b.prototype,"workspaceStorageHome",null),pe([A.$ph],b.prototype,"localHistoryHome",null),pe([A.$ph],b.prototype,"keyboardLayoutResource",null),pe([A.$ph],b.prototype,"argvResource",null),pe([A.$ph],b.prototype,"isExtensionDevelopment",null),pe([A.$ph],b.prototype,"untitledWorkspacesHome",null),pe([A.$ph],b.prototype,"builtinExtensionsPath",null),pe([A.$ph],b.prototype,"extensionsPath",null),pe([A.$ph],b.prototype,"extensionDevelopmentLocationURI",null),pe([A.$ph],b.prototype,"extensionDevelopmentKind",null),pe([A.$ph],b.prototype,"extensionTestsLocationURI",null),pe([A.$ph],b.prototype,"debugExtensionHost",null),pe([A.$ph],b.prototype,"logLevel",null),pe([A.$ph],b.prototype,"extensionLogLevel",null),pe([A.$ph],b.prototype,"serviceMachineIdResource",null),pe([A.$ph],b.prototype,"disableTelemetry",null),pe([A.$ph],b.prototype,"disableWorkspaceTrust",null),pe([A.$ph],b.prototype,"useInMemorySecretStorage",null),pe([A.$ph],b.prototype,"policyFile",null);function C(g,c){return k(g["inspect-extensions"],g["inspect-brk-extensions"],5870,c,g.debugId,g.extensionEnvironment)}e.$pm=C;function k(g,c,$,p,w,l){const h=Number(c||g)||(p?null:$),d=h?!!c:!1;let E;if(l)try{E=JSON.parse(l)}catch{}return{port:h,break:d,debugId:w,env:E}}e.$qm=k}),function(){"use strict";function ie(e,D,A){function L(O,P){const S=j(O,P),b=[S];return e.isAbsolute(S)||b.unshift(A),e.resolve(...b)}function j(O,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,P);const C=O["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(k,"AppData","Roaming")}break;case"darwin":b=e.join(D.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,P)}return{getUserDataPath:L}}if(typeof define=="function")define(ae[180],ce([269,36,37]),function(e,D,A){return ie(e,D,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=ie(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[181],ce([0,1,36,179,180]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=void 0;class j extends A.$om{constructor(b,C){super(b,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,L.getUserDataPath)(b,C.nameShort)},C)}}e.$rm=j;function O(S,b){return(0,A.$qm)(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,b,S.extensionEnvironment)}e.$sm=O;function P(S,b){return(0,A.$qm)(S["inspect-sharedprocess"],S["inspect-brk-sharedprocess"],5879,b,S.extensionEnvironment)}e.$tm=P}),define(ae[182],ce([0,1,12,153]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=void 0;function L(O,P,S,b){try{j(O,P,S,b)}catch(C){O.error(C?.message??C)}return P}e.$Fp=L;function j(O,P,S,b){const C=(k,g,c)=>{const $=k[g];if((0,D.$Cf)($)){const p=$,w=p.length;if(w>1&&p[0]==="%"&&p[w-1]==="%"){const l=p.substr(1,w-2);let u=S[l];u===void 0&&b&&(u=b[l]);const h=typeof u=="string"?u:u?.message,d=b?.[l],E=typeof d=="string"?d:d?.message;if(!h){E||O.warn(`[${P.name}]: ${(0,A.localize)(0,null,l)}`);return}if(c&&(g==="title"||g==="category")&&E&&E!==h){const s={value:h,original:E};k[g]=s}else k[g]=h}}else if((0,D.$Ef)($))for(const p in $)$.hasOwnProperty(p)&&(p==="commands"?C($,p,!0):C($,p,c));else if(Array.isArray($))for(let p=0;p<$.length;p++)C($,p,c)};for(const k in P)P.hasOwnProperty(k)&&C(P,k)}}),define(ae[183],ce([0,1,69,156]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;function L(j){return(0,D.$wp)(j,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,A.localize)(0,null))}})}e.$Np=L}),define(ae[184],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b$b=e.$a$b=void 0;class D{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$a$b=D;class A{constructor(j){this.a=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,P){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(P[0])}throw new Error(`Call not found: ${O}`)}}e.$b$b=A}),define(ae[70],ce([0,1,19,89,157,54]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function S(l){return l=l.trim(),l==="*"||O.test(l)}e.$To=S;function b(l){if(!S(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=l.match(O);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$Uo=b;function C(l){if(!l)return null;const u=l.majorBase,h=l.majorMustEqual,d=l.minorBase;let E=l.minorMustEqual;const s=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(u===0||(E=!1),o=!1);let n=0;if(l.preRelease){const i=P.exec(l.preRelease);if(i){const[,t,r,a]=i;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:u,majorMustEqual:h,minorBase:d,minorMustEqual:E,patchBase:s,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:n}}e.$Vo=C;function k(l,u,h){let d;typeof l=="string"?d=C(b(l)):d=l;let E;u instanceof Date?E=u.getTime():typeof u=="string"&&(E=new Date(u).getTime());let s;if(typeof h=="string"?s=C(b(h)):s=h,!d||!s)return!1;const o=d.majorBase,n=d.minorBase,i=d.patchBase;let t=s.majorBase,r=s.minorBase,a=s.patchBase;const v=s.notBefore;let m=s.majorMustEqual,f=s.minorMustEqual,y=s.patchMustEqual;return s.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||E&&E<v?!1:i>=a:(o===1&&t===0&&(!m||!f||!y)&&(t=1,r=0,a=0,m=!0,f=!1,y=!1),o<t?!1:o>t?!m:n<r?!1:n>r?!f:i<a?!1:i>a?!y:!(E&&E<v))}e.$Wo=k;function g(l,u,h,d,E){const s=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return s.push([A.default.Error,L.localize(0,null)]),s;if(typeof d.name!="string")return s.push([A.default.Error,L.localize(1,null,"name")]),s;if(typeof d.version!="string")return s.push([A.default.Error,L.localize(2,null,"version")]),s;if(!d.engines)return s.push([A.default.Error,L.localize(3,null,"engines")]),s;if(typeof d.engines.vscode!="string")return s.push([A.default.Error,L.localize(4,null,"engines.vscode")]),s;if(typeof d.extensionDependencies<"u"&&!w(d.extensionDependencies))return s.push([A.default.Error,L.localize(5,null,"extensionDependencies")]),s;if(typeof d.activationEvents<"u"){if(!w(d.activationEvents))return s.push([A.default.Error,L.localize(6,null,"activationEvents")]),s;if(typeof d.main>"u"&&typeof d.browser>"u")return s.push([A.default.Error,L.localize(7,null,"activationEvents","main","browser")]),s}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&s.push([A.default.Warning,L.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return s.push([A.default.Error,L.localize(9,null,"main")]),s;{const i=(0,D.$Bg)(h,d.main);(0,D.$vg)(i,h)||s.push([A.default.Warning,L.localize(10,null,i.path,h.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return s.push([A.default.Error,L.localize(11,null,"browser")]),s;{const i=(0,D.$Bg)(h,d.browser);(0,D.$vg)(i,h)||s.push([A.default.Warning,L.localize(12,null,i.path,h.path)])}}if(!j.valid(d.version))return s.push([A.default.Error,L.localize(13,null)]),s;const o=[];if(!c(l,u,d,E,o))for(const i of o)s.push([A.default.Error,i]);return s}e.$Xo=g;function c(l,u,h,d,E){return d||typeof h.main>"u"&&typeof h.browser>"u"?!0:p(l,u,h.engines.vscode,E)}e.$Yo=c;function $(l,u,h){return l==="*"||p(u,h,l)}e.$Zo=$;function p(l,u,h,d=[]){const E=C(b(h));if(!E)return d.push(L.localize(14,null,h)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return d.push(L.localize(15,null,h)),!1}else if(!E.majorMustEqual)return d.push(L.localize(16,null,h)),!1;return k(l,u,E)?!0:(d.push(L.localize(17,null,l,h)),!1)}function w(l){if(!Array.isArray(l))return!1;for(let u=0,h=l.length;u<h;u++)if(typeof l[u]!="string")return!1;return!0}}),define(ae[43],ce([0,1,15,32]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=void 0;async function L(j,O,P){let S=P&&P.get("storage.serviceMachineId",-1)||null;if(S)return S;try{const C=(await O.readFile(j.serviceMachineIdResource)).value.toString();S=(0,A.$jg)(C)?C:null}catch{S=null}if(!S){S=(0,A.$kg)();try{await O.writeFile(j.serviceMachineIdResource,D.$fe.fromString(S))}catch{}}return P?.store("storage.serviceMachineId",S,-1,1),S}e.$hp=L}),define(ae[71],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=void 0;class D{constructor(L,j=[],O=!1){this.ctor=L,this.staticArguments=j,this.supportsDelayedInstantiation=O}}e.$Uh=D}),define(ae[185],ce([0,1,71]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=e.InstantiationType=void 0;const A=[];var L;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function j(P,S,b){S instanceof D.$Uh||(S=new D.$Uh(S,[],!!b)),A.push([P,S])}e.$Er=j;function O(){return A}e.$Fr=O}),define(ae[186],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;class D{constructor(j,O){this.key=j,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$jq=D;class A{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const O of this.a.values())O.outgoing.size===0&&j.push(O);return j}insertEdge(j,O){const P=this.lookupOrInsertNode(j),S=this.lookupOrInsertNode(O);P.outgoing.set(S.key,S),S.incoming.set(P.key,P)}removeNode(j){const O=this.b(j);this.a.delete(O);for(const P of this.a.values())P.outgoing.delete(O),P.incoming.delete(O)}lookupOrInsertNode(j){const O=this.b(j);let P=this.a.get(O);return P||(P=new D(O,j),this.a.set(O,P)),P}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[O,P]of this.a)j.push(`${O}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,O]of this.a){const P=new Set([j]),S=this.c(O,P);if(S)return S}}c(j,O){for(const[P,S]of j.outgoing){if(O.has(P))return[...O,P].join(" -> ");O.add(P);const b=this.c(S,O);if(b)return b;O.delete(P)}}}e.$kq=A}),define(ae[4],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=e.$Wh=e._util=void 0;var D;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function P(S){return S[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=P})(D||(e._util=D={})),e.$Wh=L("instantiationService");function A(O,P,S){P[D.DI_TARGET]===P?P[D.DI_DEPENDENCIES].push({id:O,index:S}):(P[D.DI_DEPENDENCIES]=[{id:O,index:S}],P[D.DI_TARGET]=P)}function L(O){if(D.serviceIds.has(O))return D.serviceIds.get(O);const P=function(S,b,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,S,C)};return P.toString=()=>O,D.serviceIds.set(O,P),P}e.$Xh=L;function j(O){return O}e.$Yh=j}),define(ae[187],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J0b=void 0,e.$J0b=(0,D.$Xh)("checksumService")}),define(ae[20],ce([0,1,12,10,4]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.ConfigurationTarget=e.$ti=e.$si=e.$ri=void 0,e.$ri=(0,L.$Xh)("configurationService");function j(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof A.URI)}e.$si=j;function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof A.URI)}e.$ti=O;var P;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function S(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ui=S;function b(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.$vi=b;function C(l,u){const h=Object.create(null);for(const d in l)k(h,d,l[d],u);return h}e.$wi=C;function k(l,u,h,d){const E=u.split("."),s=E.pop();let o=l;for(let n=0;n<E.length;n++){const i=E[n];let t=o[i];switch(typeof t){case"undefined":t=o[i]=Object.create(null);break;case"object":break;default:d(`Ignoring ${u} as ${E.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[s]=h}catch{d(`Ignoring ${u} as ${E.join(".")} is ${JSON.stringify(o)}`)}else d(`Ignoring ${u} as ${E.join(".")} is ${JSON.stringify(o)}`)}e.$xi=k;function g(l,u){const h=u.split(".");c(l,h)}e.$yi=g;function c(l,u){const h=u.shift();if(u.length===0){delete l[h];return}if(Object.keys(l).indexOf(h)!==-1){const d=l[h];typeof d=="object"&&!Array.isArray(d)&&(c(d,u),Object.keys(d).length===0&&delete l[h])}}function $(l,u,h){function d(o,n){let i=o;for(const t of n){if(typeof i!="object"||i===null)return;i=i[t]}return i}const E=u.split("."),s=d(l,E);return typeof s>"u"?h:s}e.$zi=$;function p(l,u,h){Object.keys(u).forEach(d=>{d!=="__proto__"&&(d in l?D.$Ef(l[d])&&D.$Ef(u[d])?p(l[d],u[d],h):h&&(l[d]=u[d]):l[d]=u[d])})}e.$Ai=p;function w(l){return l.replace(/[\[\]]/g,"")}e.$Bi=w}),define(ae[94],ce([0,1,5,27,178,4,149,7]),function(ie,e,D,A,L,j,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.ContextKeyExprType=e.$Ti=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",D.$j),S.set("isLinux",D.$k),S.set("isWindows",D.$i),S.set("isWeb",D.$o),S.set("isMacNative",D.$j&&!D.$o),S.set("isEdge",D.$H),S.set("isFirefox",D.$F),S.set("isChrome",D.$E),S.set("isSafari",D.$G);function b(z,R){if(S.get(z)!==void 0)throw(0,P.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(z,R)}e.$Ti=b;const C=Object.prototype.hasOwnProperty;var k;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const g={regexParsingWithErrorRecovery:!0},c=(0,O.localize)(0,null),$=(0,O.localize)(1,null),p=(0,O.localize)(2,null),w=(0,O.localize)(3,null),l=(0,O.localize)(4,null),u=(0,O.localize)(5,null),h=(0,O.localize)(6,null),d=(0,O.localize)(7,null);class E{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(R=g){this.k=R,this.d=new L.$Si,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(R){if(R===""){this.h.push({message:c,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(R).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const B=this.D(),N=B.type===17?u:void 0;throw this.h.push({message:l,offset:B.offset,lexeme:L.$Si.getLexeme(B),additionalInfo:N}),E.c}return F}catch(F){if(F!==E.c)throw F;return}}l(){return this.m()}m(){const R=[this.o()];for(;this.y(16);){const F=this.o();R.push(F)}return R.length===1?R[0]:s.or(...R)}o(){const R=[this.s()];for(;this.y(15);){const F=this.s();R.push(F)}return R.length===1?R[0]:s.and(...R)}s(){if(this.y(2)){const R=this.D();switch(R.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,w),F?.negate()}case 17:return this.z(),I.create(R.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",R)}}return this.t()}t(){const R=this.D();switch(R.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const F=this.l();return this.A(1,w),F}case 17:{const F=R.lexeme;if(this.z(),this.y(9)){const N=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),N.type!==10)throw this.B("REGEX",N);const V=N.lexeme,G=V.lastIndexOf("/"),te=G===V.length-1?void 0:this.w(V.substring(G+1));let oe;try{oe=new RegExp(V.substring(1,G),te)}catch{throw this.B("REGEX",N)}return K.create(F,oe)}switch(N.type){case 10:case 19:{const V=[N.lexeme];this.z();let G=this.D(),te=0;for(let de=0;de<N.lexeme.length;de++)N.lexeme.charCodeAt(de)===40?te++:N.lexeme.charCodeAt(de)===41&&te--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let de=0;de<G.lexeme.length;de++)G.lexeme.charCodeAt(de)===40?te++:N.lexeme.charCodeAt(de)===41&&te--}if(te<0)break;V.push(L.$Si.getLexeme(G)),this.z(),G=this.D()}const oe=V.join(""),ue=oe.lastIndexOf("/"),he=ue===oe.length-1?void 0:this.w(oe.substring(ue+1));let ge;try{ge=new RegExp(oe.substring(1,ue),he)}catch{throw this.B("REGEX",N)}return s.regex(F,ge)}case 18:{const V=N.lexeme;this.z();let G=null;if(!(0,A.$Fe)(V)){const te=V.indexOf("/"),oe=V.lastIndexOf("/");if(te!==oe&&te>=0){const ue=V.slice(te+1,oe),he=V[oe+1]==="i"?"i":"";try{G=new RegExp(ue,he)}catch{throw this.B("REGEX",N)}}}if(G===null)throw this.B("REGEX",N);return K.create(F,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const N=this.u();return s.notIn(F,N)}switch(this.D().type){case 3:{this.z();const N=this.u();if(this.x().type===18)return s.equals(F,N);switch(N){case"true":return s.has(F);case"false":return s.not(F);default:return s.equals(F,N)}}case 4:{this.z();const N=this.u();if(this.x().type===18)return s.notEquals(F,N);switch(N){case"true":return s.not(F);case"false":return s.has(F);default:return s.notEquals(F,N)}}case 5:return this.z(),q.create(F,this.u());case 6:return this.z(),Y.create(F,this.u());case 7:return this.z(),M.create(F,this.u());case 8:return this.z(),U.create(F,this.u());case 13:return this.z(),s.in(F,this.u());default:return s.has(F)}}case 20:throw this.h.push({message:h,offset:R.offset,lexeme:"",additionalInfo:d}),E.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const R=this.D();switch(R.type){case 17:case 18:return this.z(),R.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(R){return R.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(R){return this.C(R)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(R,F){if(this.C(R))return this.z();throw this.B(F,this.D())}B(R,F,B){const N=(0,O.localize)(8,null,R,L.$Si.getLexeme(F)),V=F.offset,G=L.$Si.getLexeme(F);return this.h.push({message:N,offset:V,lexeme:G,additionalInfo:B}),E.c}C(R){return this.D().type===R}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ui=E;class s{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(R){return a.create(R)}static equals(R,F){return v.create(R,F)}static notEquals(R,F){return y.create(R,F)}static regex(R,F){return K.create(R,F)}static in(R,F){return m.create(R,F)}static notIn(R,F){return f.create(R,F)}static not(R){return I.create(R)}static and(...R){return Q.create(R,null,!0)}static or(...R){return J.create(R,null,!0)}static greater(R,F){return M.create(R,F)}static greaterEquals(R,F){return U.create(R,F)}static smaller(R,F){return q.create(R,F)}static smallerEquals(R,F){return Y.create(R,F)}static{this.c=new E({regexParsingWithErrorRecovery:!1})}static deserialize(R){return R==null?void 0:this.c.parse(R)}}e.$Vi=s;function o(z){const R=new E({regexParsingWithErrorRecovery:!1});return z.map(F=>(R.parse(F),R.lexingErrors.length>0?R.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,O.localize)(9,null,B.additionalInfo):(0,O.localize)(10,null),offset:B.offset,length:B.lexeme.length})):R.parsingErrors.length>0?R.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}e.$Wi=o;function n(z,R){const F=z?z.substituteConstants():void 0,B=R?R.substituteConstants():void 0;return!F&&!B?!0:!F||!B?!1:F.equals(B)}e.$Xi=n;function i(z,R){return z.cmp(R)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return r.INSTANCE}}e.$Yi=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return t.INSTANCE}}e.$Zi=r;class a{static create(R,F=null){const B=S.get(R);return typeof B=="boolean"?B?r.INSTANCE:t.INSTANCE:new a(R,F)}constructor(R,F){this.key=R,this.c=F,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:ee(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=S.get(this.key);return typeof R=="boolean"?R?r.INSTANCE:t.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.c||(this.c=I.create(this.key,this)),this.c}}e.$1i=a;class v{static create(R,F,B=null){if(typeof F=="boolean")return F?a.create(R,B):I.create(R,B);const N=S.get(R);return typeof N=="boolean"?F===(N?"true":"false")?r.INSTANCE:t.INSTANCE:new v(R,F,B)}constructor(R,F,B){this.c=R,this.d=F,this.f=B,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:ne(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=S.get(this.c);if(typeof R=="boolean"){const F=R?"true":"false";return this.d===F?r.INSTANCE:t.INSTANCE}return this}evaluate(R){return R.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(R){return R.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$2i=v;class m{static create(R,F){return new m(R,F)}constructor(R,F){this.d=R,this.f=F,this.type=10,this.c=null}cmp(R){return R.type!==this.type?this.type-R.type:ne(this.d,this.f,R.d,R.f)}equals(R){return R.type===this.type?this.d===R.d&&this.f===R.f:!1}substituteConstants(){return this}evaluate(R){const F=R.getValue(this.f),B=R.getValue(this.d);return Array.isArray(F)?F.includes(B):typeof B=="string"&&typeof F=="object"&&F!==null?C.call(F,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(R){return R.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$3i=m;class f{static create(R,F){return new f(R,F)}constructor(R,F){this.d=R,this.f=F,this.type=11,this.c=m.create(R,F)}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(R){return R.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$4i=f;class y{static create(R,F,B=null){if(typeof F=="boolean")return F?I.create(R,B):a.create(R,B);const N=S.get(R);return typeof N=="boolean"?F===(N?"true":"false")?t.INSTANCE:r.INSTANCE:new y(R,F,B)}constructor(R,F,B){this.c=R,this.d=F,this.f=B,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:ne(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=S.get(this.c);if(typeof R=="boolean"){const F=R?"true":"false";return this.d===F?t.INSTANCE:r.INSTANCE}return this}evaluate(R){return R.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(R){return R.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$5i=y;class I{static create(R,F=null){const B=S.get(R);return typeof B=="boolean"?B?t.INSTANCE:r.INSTANCE:new I(R,F)}constructor(R,F){this.c=R,this.d=F,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:ee(this.c,R.c)}equals(R){return R.type===this.type?this.c===R.c:!1}substituteConstants(){const R=S.get(this.c);return typeof R=="boolean"?R?t.INSTANCE:r.INSTANCE:this}evaluate(R){return!R.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(R){return R.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$6i=I;function T(z,R){if(typeof z=="string"){const F=parseFloat(z);isNaN(F)||(z=F)}return typeof z=="string"||typeof z=="number"?R(z):t.INSTANCE}class M{static create(R,F,B=null){return T(F,N=>new M(R,N,B))}constructor(R,F,B){this.c=R,this.d=F,this.f=B,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:ne(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$7i=M;class U{static create(R,F,B=null){return T(F,N=>new U(R,N,B))}constructor(R,F,B){this.c=R,this.d=F,this.f=B,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:ne(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$8i=U;class q{static create(R,F,B=null){return T(F,N=>new q(R,N,B))}constructor(R,F,B){this.c=R,this.d=F,this.f=B,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:ne(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$9i=q;class Y{static create(R,F,B=null){return T(F,N=>new Y(R,N,B))}constructor(R,F,B){this.c=R,this.d=F,this.f=B,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:ne(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$0i=Y;class K{static create(R,F){return new K(R,F)}constructor(R,F){this.d=R,this.f=F,this.type=7,this.c=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.d<R.d)return-1;if(this.d>R.d)return 1;const F=this.f?this.f.source:"",B=R.f?R.f.source:"";return F<B?-1:F>B?1:0}equals(R){if(R.type===this.type){const F=this.f?this.f.source:"",B=R.f?R.f.source:"";return this.d===R.d&&F===B}return!1}substituteConstants(){return this}evaluate(R){const F=R.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const R=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${R}`}keys(){return[this.d]}map(R){return R.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$$i=K;class x{static create(R){return new x(R)}constructor(R){this.c=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(R){return new x(this.c.map(R))}negate(){return this.c}}e.$_i=x;function H(z){let R=null;for(let F=0,B=z.length;F<B;F++){const N=z[F].substituteConstants();if(z[F]!==N&&R===null){R=[];for(let V=0;V<F;V++)R[V]=z[V]}R!==null&&(R[F]=N)}return R===null?z:R}class Q{static create(R,F,B){return Q.d(R,F,B)}constructor(R,F){this.expr=R,this.c=F,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const N=i(this.expr[F],R.expr[F]);if(N!==0)return N}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(R.expr[F]))return!1;return!0}return!1}substituteConstants(){const R=H(this.expr);return R===this.expr?this:Q.create(R,this.c,!1)}evaluate(R){for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].evaluate(R))return!1;return!0}static d(R,F,B){const N=[];let V=!1;for(const G of R)if(G){if(G.type===1){V=!0;continue}if(G.type===0)return t.INSTANCE;if(G.type===6){N.push(...G.expr);continue}N.push(G)}if(N.length===0&&V)return r.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(i);for(let G=1;G<N.length;G++)N[G-1].equals(N[G])&&(N.splice(G,1),G--);if(N.length===1)return N[0];for(;N.length>1;){const G=N[N.length-1];if(G.type!==9)break;N.pop();const te=N.pop(),oe=N.length===0,ue=J.create(G.expr.map(he=>Q.create([he,te],null,B)),null,oe);ue&&(N.push(ue),N.sort(i))}if(N.length===1)return N[0];if(B){for(let G=0;G<N.length;G++)for(let te=G+1;te<N.length;te++)if(N[G].negate().equals(N[te]))return t.INSTANCE;if(N.length===1)return N[0]}return new Q(N,F)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const F of this.expr)R.push(...F.keys());return R}map(R){return new Q(this.expr.map(F=>F.map(R)),null)}negate(){if(!this.c){const R=[];for(const F of this.expr)R.push(F.negate());this.c=J.create(R,this,!0)}return this.c}}e.$aj=Q;class J{static create(R,F,B){return J.d(R,F,B)}constructor(R,F){this.expr=R,this.c=F,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const N=i(this.expr[F],R.expr[F]);if(N!==0)return N}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(R.expr[F]))return!1;return!0}return!1}substituteConstants(){const R=H(this.expr);return R===this.expr?this:J.create(R,this.c,!1)}evaluate(R){for(let F=0,B=this.expr.length;F<B;F++)if(this.expr[F].evaluate(R))return!0;return!1}static d(R,F,B){let N=[],V=!1;if(R){for(let G=0,te=R.length;G<te;G++){const oe=R[G];if(oe){if(oe.type===0){V=!0;continue}if(oe.type===1)return r.INSTANCE;if(oe.type===9){N=N.concat(oe.expr);continue}N.push(oe)}}if(N.length===0&&V)return t.INSTANCE;N.sort(i)}if(N.length!==0){if(N.length===1)return N[0];for(let G=1;G<N.length;G++)N[G-1].equals(N[G])&&(N.splice(G,1),G--);if(N.length===1)return N[0];if(B){for(let G=0;G<N.length;G++)for(let te=G+1;te<N.length;te++)if(N[G].negate().equals(N[te]))return r.INSTANCE;if(N.length===1)return N[0]}return new J(N,F)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const F of this.expr)R.push(...F.keys());return R}map(R){return new J(this.expr.map(F=>F.map(R)),null)}negate(){if(!this.c){const R=[];for(const F of this.expr)R.push(F.negate());for(;R.length>1;){const F=R.shift(),B=R.shift(),N=[];for(const V of X(F))for(const G of X(B))N.push(Q.create([V,G],null,!1));R.unshift(J.create(N,null,!1))}this.c=J.create(R,this,!0)}return this.c}}e.$bj=J;class W extends a{static{this.d=[]}static all(){return W.d.values()}constructor(R,F,B){super(R,null),this.f=F,typeof B=="object"?W.d.push({...B,key:R}):B!==!0&&W.d.push({key:R,description:B,type:F!=null?typeof F:void 0})}bindTo(R){return R.createKey(this.key,this.f)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return v.create(this.key,R)}notEqualsTo(R){return y.create(this.key,R)}}e.$cj=W,e.$dj=(0,j.$Xh)("contextKeyService");function ee(z,R){return z<R?-1:z>R?1:0}function ne(z,R,F,B){return z<F?-1:z>F?1:R<B?-1:R>B?1:0}function _(z,R){if(z.type===0||R.type===1)return!0;if(z.type===9)return R.type===9?se(z.expr,R.expr):!1;if(R.type===9){for(const F of R.expr)if(_(z,F))return!0;return!1}if(z.type===6){if(R.type===6)return se(R.expr,z.expr);for(const F of z.expr)if(_(F,R))return!0;return!1}return z.equals(R)}e.$ej=_;function se(z,R){let F=0,B=0;for(;F<z.length&&B<R.length;){const N=z[F].cmp(R[B]);if(N<0)return!1;N===0&&F++,B++}return F===z.length}function X(z){return z.type===9?z.expr:[z]}}),define(ae[95],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=e.$ym=e.ID=void 0,e.ID="diagnosticsService",e.$ym=(0,D.$Xh)(e.ID);function A(j){return!!j.hostName&&!!j.errorMessage}e.$zm=A;class L{async getPerformanceInfo(O,P){return{}}async getSystemInfo(O,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,P){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$Am=L}),define(ae[96],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=void 0,e.$Wn=(0,D.$Xh)("downloadService")}),define(ae[14],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=void 0,e.$5h=(0,D.$Xh)("environmentService"),e.$6h=(0,D.$Yh)(e.$5h)}),define(ae[29],ce([0,1,152,4]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$fo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=void 0,e.$6n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$7n=new RegExp(e.$6n),e.$8n="__web_extension",e.$9n="skipWalkthrough",e.$0n="extensionsSync",e.$$n="dependecyOrPackExtensionInstall";function L(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$_n=L;function j(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$ao=j;function O(l,u){switch(l){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$bo=O;function P(l,u){return u==="web"&&!l.includes("web")}e.$co=P;function S(l,u,h){return P(u,h)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===h}e.$do=S;function b(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.$eo=b;var C;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var k;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var g;(function(l){l.Install="install",l.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var c;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(c||(e.InstallOperation=c={})),e.$fo=(0,A.$Xh)("extensionGalleryService");var $;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var p;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class w extends Error{constructor(u,h){super(u),this.code=h,this.name=h}}e.$go=w,e.$ho=(0,A.$Xh)("extensionManagementService"),e.$io="extensionsIdentifiers/disabled",e.$jo="extensionsIdentifiers/enabled",e.$ko=(0,A.$Xh)("IGlobalExtensionEnablementService"),e.$lo=(0,A.$Xh)("IExtensionTipsService"),e.$mo=(0,D.localize)(0,null),e.$no={value:e.$mo,original:"Extensions"},e.$oo={value:(0,D.localize)(1,null),original:"Preferences"}}),define(ae[188],ce([0,1,3,2,30,10,92,29]),function(ie,e,D,A,L,j,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=void 0;function S(w,l){return w?j.URI.revive(l?l.transformIncoming(w):w):void 0}function b(w,l){return l?l.transformOutgoingURI(w):w}function C(w,l){l=l||O.$Um;const u=w.manifest;return{...(0,O.$Xm)({...w,manifest:void 0},l),manifest:u}}function k(w,l){return w?.profileLocation?(0,O.$Xm)(w,l??O.$Um):w}function g(w,l){return l?(0,L.$en)(w,u=>u instanceof j.URI?l.transformOutgoingURI(u):void 0):w}class c{constructor(l,u){this.a=l,this.b=u,this.onInstallExtension=D.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,u){const h=this.b(l);switch(u){case"onInstallExtension":return D.Event.map(this.onInstallExtension,d=>({...d,profileLocation:d.profileLocation?b(d.profileLocation,h):d.profileLocation}));case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,d=>d.map(E=>({...E,local:E.local?g(E.local,h):E.local,profileLocation:E.profileLocation?b(E.profileLocation,h):E.profileLocation})));case"onUninstallExtension":return D.Event.map(this.onUninstallExtension,d=>({...d,profileLocation:d.profileLocation?b(d.profileLocation,h):d.profileLocation}));case"onDidUninstallExtension":return D.Event.map(this.onDidUninstallExtension,d=>({...d,profileLocation:d.profileLocation?b(d.profileLocation,h):d.profileLocation}));case"onDidUpdateExtensionMetadata":return D.Event.map(this.onDidUpdateExtensionMetadata,d=>g(d,h))}throw new Error("Invalid listen")}async call(l,u,h){const d=this.b(l);switch(u){case"zip":{const E=C(h[0],d),s=await this.a.zip(E);return b(s,d)}case"unzip":return this.a.unzip(S(h[0],d));case"install":return this.a.install(S(h[0],d),k(h[1],d));case"installFromLocation":return this.a.installFromLocation(S(h[0],d),S(h[1],d));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(h[0],S(h[1],d),S(h[2],d));case"getManifest":return this.a.getManifest(S(h[0],d));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(h[0]);case"installFromGallery":return this.a.installFromGallery(h[0],k(h[1],d));case"installGalleryExtensions":{const E=h[0];return this.a.installGalleryExtensions(E.map(({extension:s,options:o})=>({extension:s,options:k(o,d)??{}})))}case"uninstall":return this.a.uninstall(C(h[0],d),k(h[1],d));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(h[0],d));case"getInstalled":return(await this.a.getInstalled(h[0],S(h[1],d))).map(s=>g(s,d));case"toggleAppliationScope":{const E=await this.a.toggleAppliationScope(C(h[0],d),S(h[1],d));return g(E,d)}case"copyExtensions":return this.a.copyExtensions(S(h[0],d),S(h[1],d));case"updateMetadata":{const E=await this.a.updateMetadata(C(h[0],d),h[1],S(h[2],d));return g(E,d)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(h[0],h[1],h[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$pp=c;class $ extends A.$Rc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(l){super(),this.m=l,this.c=this.B(new D.$Rd),this.f=this.B(new D.$Rd),this.g=this.B(new D.$Rd),this.h=this.B(new D.$Rd),this.j=this.B(new D.$Rd),this.B(this.m.listen("onInstallExtension")(u=>this.n(this.c,{...u,source:this.r(u.source)?j.URI.revive(u.source):u.source,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(u=>this.n(this.f,u.map(h=>({...h,local:h.local?C(h.local,null):h.local,source:this.r(h.source)?j.URI.revive(h.source):h.source,profileLocation:j.URI.revive(h.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(u=>this.n(this.g,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(u=>this.n(this.h,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(C(u,null))))}n(l,u){l.fire(u)}r(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(l){const u=await this.getTargetPlatform();return l.allTargetPlatforms.some(h=>(0,P.$do)(h,l.allTargetPlatforms,u))}zip(l){return Promise.resolve(this.m.call("zip",[l]).then(u=>j.URI.revive(u)))}unzip(l){return Promise.resolve(this.m.call("unzip",[l]))}install(l,u){return Promise.resolve(this.m.call("install",[l,u])).then(h=>C(h,null))}installFromLocation(l,u){return Promise.resolve(this.m.call("installFromLocation",[l,u])).then(h=>C(h,null))}async installExtensionsFromProfile(l,u,h){return(await this.m.call("installExtensionsFromProfile",[l,u,h])).map(E=>C(E,null))}getManifest(l){return Promise.resolve(this.m.call("getManifest",[l]))}installFromGallery(l,u){return Promise.resolve(this.m.call("installFromGallery",[l,u])).then(h=>C(h,null))}async installGalleryExtensions(l){return(await this.m.call("installGalleryExtensions",[l])).map(h=>({...h,local:h.local?C(h.local,null):h.local,source:this.r(h.source)?j.URI.revive(h.source):h.source,profileLocation:j.URI.revive(h.profileLocation)}))}uninstall(l,u){return Promise.resolve(this.m.call("uninstall",[l,u]))}reinstallFromGallery(l){return Promise.resolve(this.m.call("reinstallFromGallery",[l])).then(u=>C(u,null))}getInstalled(l=null,u){return Promise.resolve(this.m.call("getInstalled",[l,u])).then(h=>h.map(d=>C(d,null)))}updateMetadata(l,u,h){return Promise.resolve(this.m.call("updateMetadata",[l,u,h])).then(d=>C(d,null))}toggleAppliationScope(l,u){return this.m.call("toggleAppliationScope",[l,u]).then(h=>C(h,null))}copyExtensions(l,u){return this.m.call("copyExtensions",[l,u])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(l,u,h){const d=await this.m.call("download",[l,u,h]);return j.URI.revive(d)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$qp=$;class p{constructor(l){this.a=l}listen(l,u){throw new Error("Invalid listen")}call(l,u,h){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive(h[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$rp=p}),define(ae[97],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=void 0,e.$mp=(0,D.$Xh)("IExtensionSignatureVerificationService");class A{b(){return this.a||(this.a=new Promise((j,O)=>ie(["node-vsce-sign"],async P=>j(P),O))),this.a}async verify(j,O,P){let S;try{S=await this.b()}catch{return!1}return S.verify(j,O,P)}}e.$np=A}),define(ae[98],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vXb=e.RecommendationsNotificationResult=e.$uXb=e.RecommendationSource=void 0;var A;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(A||(e.RecommendationSource=A={}));function L(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$uXb=L;var j;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$vXb=(0,D.$Xh)("IExtensionRecommendationNotificationService")}),define(ae[11],ce([0,1,47,16,27,12,10,159,4,5,23,61]),function(ie,e,D,A,L,j,O,P,S,b,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileKind=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileOperationResult=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.FileChangeType=e.$yk=e.FileOperation=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileSystemProviderErrorCode=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.FileSystemProviderCapabilities=e.$ik=e.FilePermission=e.FileType=e.$hk=e.$gk=void 0,e.$gk=(0,S.$Xh)("fileService");function g(_){return _.create===!0}e.$hk=g;var c;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var $;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})($||(e.FilePermission=$={}));function p(_){const se=_;return!!se&&typeof se.onDidChange=="function"}e.$ik=p;var w;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function l(_){return!!(_.capabilities&2)}e.$jk=l;function u(_){return!!(_.capabilities&8)}e.$kk=u;function h(_){return!!(_.capabilities&131072)}e.$lk=h;function d(_){return!!(_.capabilities&4)}e.$mk=d;function E(_){return!!(_.capabilities&16)}e.$nk=E;function s(_){return l(_)?!!(_.capabilities&16384):!1}e.$ok=s;function o(_){return l(_)?!!(_.capabilities&32768):!1}e.$pk=o;function n(_){return!!(_.capabilities&65536)}e.$qk=n;function i(_){return!!(_.capabilities&2048)}e.$rk=i;var t;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(se,X){const z=new r(se.toString(),X);return m(z,X),z}constructor(se,X){super(se),this.code=X}}e.$sk=r;function a(_,se){return r.create(_,se)}e.$tk=a;function v(_){return _||a((0,P.localize)(0,null),t.Unknown)}e.$uk=v;function m(_,se){return _.name=se?`${se} (FileSystemError)`:"FileSystemError",_}e.$vk=m;function f(_){if(!_)return t.Unknown;if(_ instanceof r)return _.code;const se=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!se)return t.Unknown;switch(se[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$wk=f;function y(_){if(_ instanceof Y)return _.fileOperationResult;switch(f(_)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$xk=y;var I;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class T{constructor(se,X,z){this.resource=se,this.operation=X,this.target=z}isOperation(se){return this.operation===se}}e.$yk=T;var M;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class U{static{this.a=null}constructor(se,X){this.c=X,this.b=void 0,this.d=new k.$U(()=>{const z=D.$4h.forUris(()=>this.c);return z.fill(this.rawAdded.map(R=>[R,!0])),z}),this.f=new k.$U(()=>{const z=D.$4h.forUris(()=>this.c);return z.fill(this.rawUpdated.map(R=>[R,!0])),z}),this.g=new k.$U(()=>{const z=D.$4h.forUris(()=>this.c);return z.fill(this.rawDeleted.map(R=>[R,!0])),z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const z of se){switch(z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}this.b!==U.a&&(typeof z.cId=="number"?this.b===void 0?this.b=z.cId:this.b!==z.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(se,...X){return this.h(se,{includeChildren:!1},...X)}affects(se,...X){return this.h(se,{includeChildren:!0},...X)}h(se,X,...z){if(!se)return!1;const R=z.length>0;return!!((!R||z.includes(1))&&(this.d.value.get(se)||X.includeChildren&&this.d.value.findSuperstr(se))||(!R||z.includes(0))&&(this.f.value.get(se)||X.includeChildren&&this.f.value.findSuperstr(se))||(!R||z.includes(2))&&(this.g.value.findSubstr(se)||X.includeChildren&&this.g.value.findSuperstr(se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(se){return this.b===se}hasCorrelation(){return typeof this.b=="number"}}e.$zk=U;function q(_,se,X){return!_||!se||_===se||se.length>_.length?!1:(se.charAt(se.length-1)!==A.sep&&(se+=A.sep),X?(0,L.$7e)(_,se):_.indexOf(se)===0)}e.$Ak=q;class Y extends Error{constructor(se,X,z){super(se),this.fileOperationResult=X,this.options=z}}e.$Bk=Y;class K extends Y{constructor(se,X,z,R){super(se,X,R),this.fileOperationResult=X,this.size=z}}e.$Ck=K;class x extends Y{constructor(se,X,z){super(se,2,z),this.stat=X}}e.$Dk=x;var H;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(H||(e.FileOperationResult=H={})),e.$Ek={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Fk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Gk="files.associations",e.$Hk="files.exclude",e.$Ik="files.readonlyInclude",e.$Jk="files.readonlyExclude",e.$Kk="files.readonlyFromPermissions";var Q;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$Lk="";function J(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Mk=J;async function W(_,se){if(!se.hasProvider(O.URI.from({scheme:_.scheme})))return new Promise(X=>{const z=se.onDidChangeFileSystemProviderRegistrations(R=>{R.scheme===_.scheme&&R.added&&(z.dispose(),X())})})}e.$Nk=W;class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(se){return(0,j.$Gf)(se)||(se=0),se<ee.KB?(0,P.localize)(1,null,se.toFixed(0)):se<ee.MB?(0,P.localize)(2,null,(se/ee.KB).toFixed(2)):se<ee.GB?(0,P.localize)(3,null,(se/ee.MB).toFixed(2)):se<ee.TB?(0,P.localize)(4,null,(se/ee.GB).toFixed(2)):(0,P.localize)(5,null,(se/ee.TB).toFixed(2))}}e.$Ok=ee;function ne(_){const se=typeof _=="string"||_?.scheme===C.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===C.Schemas.file?1024*ee.MB:se?10*ee.MB:b.$o?50*ee.MB:1024*ee.MB}e.$Pk=ne});var Z=this&&this.__param||function(ie,e){return function(D,A){e(D,A,ie)}};define(ae[189],ce([0,1,72,46,11]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K0b=void 0;let j=class{constructor(P){this.a=P}async checksum(P){const S=(await this.a.readFileStream(P)).value;return new Promise((b,C)=>{const k=(0,D.createHash)("md5");(0,A.$0d)(S,{onData:g=>k.update(g.buffer),onError:g=>C(g),onEnd:()=>b(k.digest("base64").replace(/=+$/,""))})})}};e.$K0b=j,e.$K0b=j=pe([Z(0,L.$gk)],j)}),define(ae[99],ce([0,1,15,7,160,11]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=void 0;async function O(C,k,g,c,$,p){let w;try{await P(C,k,g,c,$,p)}catch(l){w=l}finally{w&&$.errorTransformer&&(w=$.errorTransformer(w)),typeof w<"u"&&g.error(w),g.end()}}e.$Up=O;async function P(C,k,g,c,$,p){S(p);const w=await C.open(k,{create:!1});try{S(p);let l=0,u=0,h=$&&typeof $.length=="number"?$.length:void 0,d=D.$fe.alloc(Math.min($.bufferSize,typeof h=="number"?h:$.bufferSize)),E=$&&typeof $.position=="number"?$.position:0,s=0;do u=await C.read(w,E,d.buffer,s,d.byteLength-s),E+=u,s+=u,l+=u,typeof h=="number"&&(h-=u),s===d.byteLength&&(await g.write(c(d)),d=D.$fe.alloc(Math.min($.bufferSize,typeof h=="number"?h:$.bufferSize)),s=0);while(u>0&&(typeof h!="number"||h>0)&&S(p)&&b(l,$));if(s>0){let o=s;typeof h=="number"&&(o=Math.min(s,h)),g.write(c(d.slice(0,o)))}}catch(l){throw(0,j.$uk)(l)}finally{await C.close(w)}}function S(C){if(C.isCancellationRequested)throw(0,A.$5)();return!0}function b(C,k){if(typeof k?.limits?.size=="number"&&C>k.limits.size)throw(0,j.$tk)((0,L.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[49],ce([0,1,91,2,16,5,10,11]),function(ie,e,D,A,L,j,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=e.$2p=e.$1p=e.$Zp=e.$Yp=e.$Xp=e.$Wp=void 0;function S(l){return l.recursive===!0}e.$Wp=S;class b extends A.$Rc{static{this.a=5}constructor(u,h,d,E){super(),this.h=u,this.j=h,this.m=d,this.n=E,this.c=this.B(new A.$Sc),this.f=void 0,this.g=0}s(){const u=new A.$Qc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(h=>this.h(h))),u.add(this.b.onDidLogMessage(h=>this.j(h))),u.add(this.b.onDidError(h=>this.t(h)))}t(u){this.n.restartOnError?this.g<b.a&&this.f?(this.w(`restarting watcher after error: ${u}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${u}`):this.w(u)}u(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}w(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}y(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Xp=b;class C extends b{constructor(u,h,d){super(u,h,d,{type:"node.js",restartOnError:!1})}}e.$Yp=C;class k extends b{constructor(u,h,d){super(u,h,d,{type:"universal",restartOnError:!0})}}e.$Zp=k;function g(l){return l.map(u=>({type:u.type,resource:O.URI.revive(u.resource),cId:u.cId}))}e.$1p=g;function c(l){const u=new w;for(const h of l)u.processEvent(h);return u.coalesce()}e.$2p=c;function $(l,u){return typeof u=="string"&&!u.startsWith(D.$Aj)&&!(0,L.$hc)(u)?{base:l,pattern:u}:u}e.$3p=$;function p(l,u){const h=[];for(const d of u)h.push((0,D.$Ej)($(l,d)));return h}e.$4p=p;class w{constructor(){this.a=new Set,this.b=new Map}c(u){return j.$k?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const h=this.b.get(this.c(u));let d=!1;if(h){const E=h.type,s=u.type;h.resource.fsPath!==u.resource.fsPath&&(u.type===2||u.type===1)?d=!0:E===1&&s===2?(this.b.delete(this.c(u)),this.a.delete(h)):E===2&&s===1?h.type=0:E===1&&s===0||(h.type=s)}else d=!0;d&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],h=[];return Array.from(this.a).filter(d=>d.type!==2?(u.push(d),!1):!0).sort((d,E)=>d.resource.fsPath.length-E.resource.fsPath.length).filter(d=>h.some(E=>(0,P.$Ak)(d.resource.fsPath,E,!j.$k))?!1:(h.push(d.resource.fsPath),!0)).concat(u)}}}),define(ae[190],ce([0,1,15,38,7,3,2,46,32,11,49]),function(ie,e,D,A,L,j,O,P,S,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HN=e.$GN=void 0,e.$GN="localFilesystem";class k extends O.$Rc{constructor(c,$){super(),this.a=c,this.b=$,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$Rd),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$Rd),this.onDidWatchError=this.g.event,this.h=(0,S.$kg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(c){return this.a.call("stat",[c])}readdir(c){return this.a.call("readdir",[c])}async readFile(c,$){const{buffer:p}=await this.a.call("readFile",[c,$]);return p}readFileStream(c,$,p){const w=(0,P.$6d)(u=>D.$fe.concat(u.map(h=>D.$fe.wrap(h))).buffer),l=new O.$Qc;return l.add(this.a.listen("readFileStream",[c,$])(u=>{if(u instanceof D.$fe)w.write(u.buffer);else{if(u==="end")w.end();else{let h;if(u instanceof Error)h=u;else{const d=u;h=(0,b.$tk)(d.message??(0,A.$Ii)(d),d.code??b.FileSystemProviderErrorCode.Unknown)}w.error(h),w.end()}l.dispose()}})),l.add(p.onCancellationRequested(()=>{w.error((0,L.$5)()),w.end(),l.dispose()})),w}writeFile(c,$,p){return this.a.call("writeFile",[c,D.$fe.wrap($),p])}open(c,$){return this.a.call("open",[c,$])}close(c){return this.a.call("close",[c])}async read(c,$,p,w,l){const[u,h]=await this.a.call("read",[c,$,l]);return p.set(u.buffer.slice(0,h),w),h}write(c,$,p,w,l){return this.a.call("write",[c,$,D.$fe.wrap(p),w,l])}mkdir(c){return this.a.call("mkdir",[c])}delete(c,$){return this.a.call("delete",[c,$])}rename(c,$,p){return this.a.call("rename",[c,$,p])}copy(c,$,p){return this.a.call("copy",[c,$,p])}cloneFile(c,$){return this.a.call("cloneFile",[c,$])}j(){this.B(this.a.listen("fileChange",[this.h])(c=>{if(Array.isArray(c)){const $=c;this.f.fire((0,C.$1p)($))}else{const $=c;this.g.fire($)}}))}watch(c,$){const p=(0,S.$kg)();return this.a.call("watch",[this.h,p,c,$]),(0,O.$Pc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$HN=k}),define(ae[191],ce([0,1,53,6,26,48,2,88,16,5,19,10,143,31,49]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;class p extends O.$Rc{static{this.a=100}static{this.b=75}constructor(u,h,d,E){super(),this.m=u,this.n=h,this.r=d,this.s=E,this.c=this.B(new A.$ch({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.n(s))),this.f=this.B(new A.$bh(s=>this.z(s),p.b)),this.g=(0,$.$4p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,$.$4p)(this.m.path,this.m.includes):void 0,this.j=new L.$2d,this.ready=this.t()}async t(){try{const u=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await c.Promises.stat(u);this.B(await this.w(u,h.isDirectory()))}catch(u){u.code!=="ENOENT"?this.D(u):this.G(u)}}async u(u){let h=u.path;try{h=await c.Promises.realpath(u.path),u.path===h&&(h=await(0,g.$bq)(u.path)??u.path),u.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${h})`)}catch{}return h}async w(u,h){if(b.$j&&(0,j.$2f)(u,"/Volumes/",!0))return this.D(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.$Rc.None;const d=new L.$2d(this.j.token),E=new O.$Qc;try{const s=k.URI.file(this.m.path),o=(0,S.$mc)(u),n=(0,D.watch)(u);E.add((0,O.$Pc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${u}'`);const i=new Set;if(h)try{for(const r of await c.Promises.readdir(u))i.add(r)}catch(r){this.D(r)}const t=new Map;E.add((0,O.$Pc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.D(`Failed to watch ${u} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),n.on("change",(r,a)=>{if(d.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${a}`);let v="";if(a&&(v=a.toString(),b.$j&&(v=(0,P.$wl)(v))),!(!v||r!=="change"&&r!=="rename"))if(h)if(r==="rename"){t.get(v)?.dispose();const m=setTimeout(async()=>{if(t.delete(v),v===o&&!await c.Promises.exists(u)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const f=await this.C((0,S.$ic)(u,v));if(d.token.isCancellationRequested)return;let y;f?i.has(v)?y=0:(y=1,i.add(v)):(i.delete(v),y=2),this.y({resource:(0,C.$Bg)(s,v),type:y,cId:this.m.correlationId})},p.a);t.set(v,(0,O.$Pc)(()=>clearTimeout(m)))}else{let m;i.has(v)?m=0:(m=1,i.add(v)),this.y({resource:(0,C.$Bg)(s,v),type:m,cId:this.m.correlationId})}else if(r==="rename"||v!==o){const m=setTimeout(async()=>{const f=await c.Promises.exists(u);d.token.isCancellationRequested||(f?(this.y({resource:s,type:0,cId:this.m.correlationId},!0),E.add(await this.w(u,!1))):(this.y({resource:s,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},p.a);E.clear(),E.add((0,O.$Pc)(()=>clearTimeout(m)))}else this.y({resource:s,type:0,cId:this.m.correlationId},!0)})}catch(s){await c.Promises.exists(u)&&!d.token.isCancellationRequested&&this.D(`Failed to watch ${u} for changes using fs.watch() (${s.toString()})`)}return(0,O.$Pc)(()=>{d.dispose(!0),E.dispose()})}y(u,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!h&&this.g.some(d=>d(u.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${u.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(d=>d(u.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}z(u){const h=(0,$.$2p)(u);if(h.length>0){if(this.s)for(const E of h)this.G(` >> normalized ${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(u){if(b.$k)return c.Promises.exists(u);try{const h=(0,S.$mc)(u);return(await c.Promises.readdir((0,S.$lc)(u))).some(E=>E===h)}catch(h){return this.G(h),!1}}setVerboseLogging(u){this.s=u}D(u){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}F(u){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}G(u){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$eq=p;async function w(l,u,h,d,E=512){const s=await c.Promises.open(l,"r"),o=Buffer.allocUnsafe(E),n=new L.$2d(d);let i,t=!1;const r={path:l,excludes:[],recursive:!1},a=new p(r,v=>{(async()=>{for(const{type:m}of v)if(m===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:f}=await c.Promises.read(s,o,0,E,null);if(!f||n.token.isCancellationRequested)break;u(o.slice(0,f))}}catch(f){i=new Error(f),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,h(),new Promise((v,m)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await c.Promises.close(s)}catch(f){i=new Error(f)}i?m(i):v()})})}e.$fq=w}),define(ae[192],ce([0,1,3,91,2,5,191]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0;class P extends L.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Rd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Rd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(b){const C=this.j(b),k=C.filter(c=>{const $=this.c.get(c.path);return $?!(0,A.$Ij)($.request.excludes,c.excludes)||!(0,A.$Ij)($.request.includes,c.includes):!0}),g=Array.from(this.c.values()).filter(({request:c})=>!C.find($=>$.path===c.path&&(0,A.$Ij)($.excludes,c.excludes)&&(0,A.$Ij)($.includes,c.includes))).map(({request:c})=>c.path);k.length&&this.m(`Request to start watching: ${k.map(c=>`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`).join(",")}`),g.length&&this.m(`Request to stop watching: ${g.join(",")}`);for(const c of g)this.h(c);for(const c of k)this.g(c)}g(b){const C=new O.$eq(b,g=>this.a.fire(g),g=>this.b.fire(g),this.f),k={request:b,instance:C};this.c.set(b.path,k)}async stop(){for(const[b]of this.c)this.h(b);this.c.clear()}h(b){const C=this.c.get(b);C&&(this.c.delete(b),C.instance.dispose())}j(b){const C=new Map;for(const k of b){const g=j.$k?k.path:k.path.toLowerCase();let c=C.get(k.correlationId);c||(c=new Map,C.set(k.correlationId,c)),c.set(g,k)}return Array.from(C.values()).map(k=>Array.from(k.values())).flat()}async setVerboseLogging(b){this.f=b;for(const[,C]of this.c)C.instance.setVerboseLogging(b)}m(b){this.f&&this.b.fire({type:"trace",message:this.n(b)})}n(b,C){return C?`[File Watcher (node.js)] ${b} (path: ${C.request.path})`:`[File Watcher (node.js)] ${b}`}}e.$gq=P}),define(ae[193],ce([0,1,49,192]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=void 0;class L extends D.$Yp{constructor(O,P,S){super(O,P,S),this.s()}r(O){return O.add(new A.$gq)}}e.$hq=L}),define(ae[194],ce([0,1,23,40,93,49]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;class O extends j.$Zp{constructor(S,b,C){super(S,b,C),this.s()}r(S){const b=S.add(new L.$$p(D.$ig.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(b.onDidProcessExit(({code:C,signal:k})=>this.t(`terminated by itself with code ${C}, signal: ${k}`))),A.ProxyChannel.toService((0,A.$Eh)(b.getChannel("watcher")))}}e.$_p=O}),define(ae[73],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=void 0;class D{constructor(...L){this.a=new Map;for(const[j,O]of L)this.set(j,O)}set(L,j){const O=this.a.get(L);return this.a.set(L,j),O}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$Vh=D}),define(ae[195],ce([0,1,6,7,2,71,186,4,73,87]),function(ie,e,D,A,L,j,O,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=void 0;const C=!1;class k extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class g{constructor(w=new S.$Vh,l=!1,u,h=C){this.f=w,this.g=l,this.h=u,this.i=h,this.o=new Set,this.f.set(P.$Wh,this),this._globalGraph=h?u?._globalGraph??new O.$kq(d=>d):void 0}createChild(w){return new g(w,this.g,this,this.i)}invokeFunction(w,...l){const u=$.traceInvocation(this.i,w);let h=!1;try{return w({get:E=>{if(h)throw(0,A.$7)("service accessor is only valid during the invocation of its target method");const s=this.m(E,u);if(!s)throw new Error(`[invokeFunction] unknown service '${E}'`);return s}},...l)}finally{h=!0,u.stop()}}createInstance(w,...l){let u,h;return w instanceof j.$Uh?(u=$.traceCreation(this.i,w.ctor),h=this.j(w.ctor,w.staticArguments.concat(l),u)):(u=$.traceCreation(this.i,w),h=this.j(w,l,u)),u.stop(),h}j(w,l=[],u){const h=P._util.getServiceDependencies(w).sort((s,o)=>s.index-o.index),d=[];for(const s of h){const o=this.m(s.id,u);o||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${s.id}.`,!1),d.push(o)}const E=h.length>0?h[0].index:l.length;if(l.length!==E){console.trace(`[createInstance] First service dependency of ${w.name} at position ${E+1} conflicts with ${l.length} static arguments`);const s=E-l.length;s>0?l=l.concat(new Array(s)):l=l.slice(0,E)}return Reflect.construct(w,l.concat(d))}k(w,l){if(this.f.get(w)instanceof j.$Uh)this.f.set(w,l);else if(this.h)this.h.k(w,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const l=this.f.get(w);return!l&&this.h?this.h.l(w):l}m(w,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const u=this.l(w);return u instanceof j.$Uh?this.q(w,u,l.branch(w,!0)):(l.branch(w,!1),u)}q(w,l,u){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,l,u)}finally{this.o.delete(w)}}r(w,l,u){const h=new O.$kq(s=>s.id.toString());let d=0;const E=[{id:w,desc:l,_trace:u}];for(;E.length;){const s=E.pop();if(h.lookupOrInsertNode(s),d++>1e3)throw new k(h);for(const o of P._util.getServiceDependencies(s.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),n instanceof j.$Uh){const i={id:o.id,desc:n,_trace:s._trace.branch(o.id,!0)};h.insertEdge(s,i),E.push(i)}}}for(;;){const s=h.roots();if(s.length===0){if(!h.isEmpty())throw new k(h);break}for(const{data:o}of s){if(this.l(o.id)instanceof j.$Uh){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}h.removeNode(o)}}return this.l(w)}s(w,l,u=[],h,d){if(this.f.get(w)instanceof j.$Uh)return this.t(w,l,u,h,d);if(this.h)return this.h.s(w,l,u,h,d);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(w,l,u=[],h,d){if(h){const E=new g(void 0,this.g,this,this.i);E.c=String(w);const s=new Map,o=new D.$gh(()=>{const n=E.j(l,u,d);for(const[i,t]of s){const r=n[i];if(typeof r=="function")for(const a of t)r.apply(n,a)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let a=s.get(i);return a||(a=new b.$2c,s.set(i,a)),(m,f,y)=>{const I=a.push([m,f,y]);return(0,L.$Pc)(I)}}if(i in n)return n[i];const t=o.value;let r=t[i];return typeof r!="function"||(r=r.bind(t),n[i]=r),r},set(n,i,t){return o.value[i]=t,!0},getPrototypeOf(n){return l.prototype}})}else return this.j(l,u,d)}u(w,l){if(l&&console.warn(w),this.g)throw new Error(w)}}e.$lq=g;var c;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(c||(c={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,l){return w?new $(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(w,l){return w?new $(1,l.name):$.c}static{this.f=0}constructor(w,l){this.type=w,this.name=l,this.g=Date.now(),this.h=[]}branch(w,l){const u=new $(3,w.toString());return this.h.push([w,l,u]),u}stop(){const w=Date.now()-this.g;$.f+=w;let l=!1;function u(d,E){const s=[],o=new Array(d+1).join("	");for(const[n,i,t]of E.h)if(i&&t){l=!0,s.push(`${o}CREATES -> ${n}`);const r=u(d+1,t);r&&s.push(r)}else s.push(`${o}uses -> ${n}`);return s.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(w>2||l)&&$.all.add(h.join(`
`))}}e.$mq=$}),define(ae[55],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i0b=e.$h0b=void 0,e.$h0b=(0,D.$Xh)("mainProcessService");class A{constructor(j,O){this.a=j,this.b=O}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,O){this.a.registerChannel(j,O)}}e.$i0b=A}),define(ae[74],ce([0,1,26,2,5,162,29,4]),function(ie,e,D,A,L,j,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=e.$1q=e.$Zq=void 0;function S(C){return C.tags.find(k=>k.startsWith("lp-"))?.split("lp-")[1]}e.$Zq=S,e.$1q=(0,P.$Xh)("languagePackService");let b=class extends A.$Rc{constructor(k){super(),this.c=k}async getAvailableLanguages(){const k=new D.$2d;setTimeout(()=>k.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},k.token)}catch{return[]}const $=g.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(w=>w.startsWith("lp-"))).map(p=>{const w=p.properties.localizedLanguages?.[0],l=S(p);return{...this.f(l,w,p),extensionId:p.identifier.id,galleryExtension:p}});return $.push(this.f("en","English")),$}f(k,g,c){const $=g??k;let p;if($!==k&&(p=`(${k})`),k.toLowerCase()===L.$w.toLowerCase()&&(p??="",p+=(0,j.localize)(0,null)),c?.installCount){p??="";const w=c.installCount;let l;w>1e6?l=`${Math.floor(w/1e5)/10}M`:w>1e3?l=`${Math.floor(w/1e3)}K`:l=String(w),p+=` $(cloud-download) ${l}`}return{id:k,label:$,description:p}}};e.$2q=b,e.$2q=b=pe([Z(0,O.$fo)],b)}),define(ae[196],ce([0,1,2,74]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G0b=void 0;let L=class extends D.$Rc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$G0b=L,e.$G0b=L=pe([Z(0,A.$1q)],L)}),define(ae[8],ce([0,1,38,3,52,2,34,5,19,12,10,94,4]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.log=e.$ij=e.LogLevel=e.$hj=e.$gj=e.$fj=void 0,e.$fj=(0,g.$Xh)("logService"),e.$gj=(0,g.$Xh)("loggerService");function c(){return new Date().toISOString()}function $(m){return(0,b.$Gf)(m)}e.$hj=$;var p;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$ij=p.Info;function w(m,f,y){switch(f){case p.Trace:m.trace(y);break;case p.Debug:m.debug(y);break;case p.Info:m.info(y);break;case p.Warning:m.warn(y);break;case p.Error:m.error(y);break;case p.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=w;function l(m,f=!1){let y="";for(let I=0;I<m.length;I++){let T=m[I];if(T instanceof Error&&(T=(0,D.$Ii)(T,f)),typeof T=="object")try{T=JSON.stringify(T)}catch{}y+=(I>0?" ":"")+T}return y}class u extends j.$Rc{constructor(){super(...arguments),this.b=e.$ij,this.c=this.B(new A.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==p.Off&&this.b<=f}}e.$kj=u;class h extends u{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...y){this.f(p.Trace)&&this.g(p.Trace,l([f,...y],!0))}debug(f,...y){this.f(p.Debug)&&this.g(p.Debug,l([f,...y]))}info(f,...y){this.f(p.Info)&&this.g(p.Info,l([f,...y]))}warn(f,...y){this.f(p.Warning)&&this.g(p.Warning,l([f,...y]))}error(f,...y){if(this.f(p.Error))if(f instanceof Error){const I=Array.prototype.slice.call(arguments);I[0]=f.stack,this.g(p.Error,l(I))}else this.g(p.Error,l([f,...y]))}flush(){}}e.$lj=h;class d extends u{constructor(f=e.$ij){super(),this.setLevel(f),this.g=!P.$i}trace(f,...y){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...y):console.log(`[main ${c()}]`,f,...y))}debug(f,...y){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...y):console.log(`[main ${c()}]`,f,...y))}info(f,...y){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...y):console.log(`[main ${c()}]`,f,...y))}warn(f,...y){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,f,...y):console.warn(`[main ${c()}]`,f,...y))}error(f,...y){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,f,...y):console.error(`[main ${c()}]`,f,...y))}dispose(){}flush(){}}e.$mj=d;class E extends u{constructor(f=e.$ij,y=!0){super(),this.g=y,this.setLevel(f)}trace(f,...y){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...y):console.log(f,...y))}debug(f,...y){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...y):console.log(f,...y))}info(f,...y){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...y):console.log(f,...y))}warn(f,...y){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...y):console.log(f,...y))}error(f,...y){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...y):console.error(f,...y))}dispose(){}flush(){}}e.$nj=E;class s extends u{constructor(f,y=e.$ij){super(),this.g=f,this.setLevel(y)}trace(f,...y){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(f),...y])}debug(f,...y){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(f),...y])}info(f,...y){this.f(p.Info)&&this.g.log(p.Info,[this.h(f),...y])}warn(f,...y){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(f),...y])}error(f,...y){this.f(p.Error)&&this.g.log(p.Error,[this.h(f),...y])}h(f){return typeof f=="string"?f:(0,D.$Ii)(f,this.f(p.Trace))}dispose(){}flush(){}}e.$oj=s;class o extends u{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const y of this.g)y.setLevel(f);super.setLevel(f)}trace(f,...y){for(const I of this.g)I.trace(f,...y)}debug(f,...y){for(const I of this.g)I.debug(f,...y)}info(f,...y){for(const I of this.g)I.info(f,...y)}warn(f,...y){for(const I of this.g)I.warn(f,...y)}error(f,...y){for(const I of this.g)I.error(f,...y)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.$pj=o;class n extends j.$Rc{constructor(f,y,I){if(super(),this.h=f,this.j=y,this.b=new O.$zc,this.c=this.B(new A.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$Rd),this.onDidChangeVisibility=this.g.event,I)for(const T of I)this.b.set(T.resource,{logger:void 0,info:T})}m(f){return(0,b.$Cf)(f)?[...this.b.values()].find(y=>y.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,y){const I=this.n(f),T=(0,b.$Cf)(f)?f:y?.id??(0,L.$Li)(I.toString()).toString(16);let M=this.b.get(I)?.logger;const U=y?.logLevel==="always"?p.Trace:y?.logLevel;M||(M=this.s(I,U??this.getLogLevel(I)??this.h,{...y,id:T}));const q={logger:M,info:{resource:I,id:T,logLevel:U,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(q.info),this.b.set(I,q),M}n(f){return(0,b.$Cf)(f)?(0,S.$Bg)(this.j,`${f}.log`):f}setLogLevel(f,y){if(C.URI.isUri(f)){const I=f,T=y,M=this.b.get(I);M&&T!==M.info.logLevel&&(M.info.logLevel=T===this.h?void 0:T,M.logger?.setLevel(T),this.b.set(M.info.resource,M),this.f.fire([I,T]))}else{this.h=f;for(const[I,T]of this.b.entries())this.b.get(I)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,y){const I=this.m(f);I&&y!==!I.info.hidden&&(I.info.hidden=!y,this.b.set(I.info.resource,I),this.g.fire([I.info.resource,y]))}getLogLevel(f){let y;return f&&(y=this.b.get(f)?.info.logLevel),y??this.h}registerLogger(f){const y=this.b.get(f.resource);y?y.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const y=this.b.get(f);y&&(y.logger&&y.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$qj=n;class i{constructor(){this.onDidChangeLogLevel=new A.$Rd().event}setLevel(f){}getLevel(){return p.Info}trace(f,...y){}debug(f,...y){}info(f,...y){}warn(f,...y){}error(f,...y){}critical(f,...y){}dispose(){}flush(){}}e.$rj=i;class t extends i{}e.$sj=t;function r(m){if(m.verbose)return p.Trace;if(typeof m.logLevel=="string"){const f=v(m.logLevel.toLowerCase());if(f!==void 0)return f}return e.$ij}e.$tj=r;function a(m){switch(m){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$uj=a;function v(m){switch(m){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$vj=v,e.$wj=new k.$cj("logLevel",a(p.Info))}),define(ae[197],ce([0,1,6,7,2,23,16,19,31,14,8]),function(ie,e,D,A,L,j,O,P,S,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H0b=void 0;let k=class extends L.$Rc{constructor(c,$){super(),this.a=c,this.b=$,this.B(new D.$_g(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const c=(0,P.$yg)(this.a.logsHome),$=(0,P.$Ag)(this.a.logsHome.with({scheme:j.Schemas.file})).fsPath,l=(await S.Promises.readdir($)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==c),u=l.slice(0,Math.max(0,l.length-9));u.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${u.join(", ")}'`),await Promise.all(u.map(h=>S.Promises.rm((0,O.$ic)($,h)))))}catch(c){(0,A.$Z)(c)}}};e.$H0b=k,e.$H0b=k=pe([Z(0,b.$5h),Z(1,C.$fj)],k)}),define(ae[198],ce([0,1,18,6,7,3,2,16,49,8]),function(ie,e,D,A,L,j,O,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0;class C extends O.$Rc{constructor(g,c){super(),this.a=g,this.b=c,this.c=this.B(new j.$Rd),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$Rd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$Xg(0)),this.w=[],this.y=this.B(new A.$Xg(0))}watch(g,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n(g,c):this.z(g,c)}n(g,c){const $={path:this.H(g),excludes:c.excludes,includes:c.includes,recursive:c.recursive,correlationId:c.correlationId},p=(0,D.$Tb)(this.j,$);return this.r(),(0,O.$Pc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,L.$Z)(g))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,S.$1p)(c)),c=>this.G(c),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const c of this.j)(0,S.$Wp)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const c of this.j)(0,S.$Wp)(c)&&g.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,c){const $={path:this.H(g),excludes:c.excludes,includes:c.includes,recursive:!1,correlationId:c.correlationId},p=(0,D.$Tb)(this.w,$);return this.C(),(0,O.$Pc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,L.$Z)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,S.$1p)(g)),g=>this.G(g),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}H(g){return(0,P.$gc)(g.fsPath)}}e.$5p=C}),define(ae[199],ce([0,1,18,6,15,26,3,52,60,2,47,23,100,19,46,158,11,99,8,7]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l,u,h){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=void 0;let E=class extends b.$Rc{static{d=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new O.$Rd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$Rd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$Rd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$Rd),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$Rd),this.Y=this.B(new O.$Rd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$Rd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$9g)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${o}`);const i=new b.$Qc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),i.add(n.onDidChangeFile(t=>{const r=new w.$zk(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&i.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),i.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,b.$Pc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,b.$Mc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(i){n.push(i)}}),!this.h.has(o)&&await A.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&n)}listCapabilities(){return S.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,c.$Fg)(o))throw new w.$Bk((0,p.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const i=new h.$ab;throw i.message=(0,p.localize)(1,null,o.toString()),i}return n}async m(o){const n=await this.j(o);if((0,w.$mk)(n)||(0,w.$jk)(n)||(0,w.$nk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,w.$mk)(n)||(0,w.$jk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(i){throw(0,w.$wk)(i)===w.FileSystemProviderErrorCode.FileNotFound?new w.$Bk((0,p.localize)(2,null,this.sb(o)),1):(0,w.$uk)(i)}}async s(o,n){const i=await this.j(o),t=this.S(i),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,v=n?.resolveMetadata,m=await i.stat(o);let f;return this.t(i,o,m,void 0,!!v,(y,I)=>(f||(f=C.$4h.forUris(()=>!t),f.set(o,!0),r&&f.fill(!0,r)),f.get(y.resource)||f.findSuperstr(y.resource.with({query:null,fragment:null}))?!0:y.isDirectory&&a?I===1:!1))}async t(o,n,i,t,r,a){const{providerExtUri:v}=this.R(o),m={resource:n,name:v.basename(n),isFile:(i.type&w.FileType.File)!==0,isDirectory:(i.type&w.FileType.Directory)!==0,isSymbolicLink:(i.type&w.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&w.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&w.FilePermission.Locked),etag:(0,w.$Mk)({mtime:i.mtime,size:i.size}),children:void 0};if(m.isDirectory&&a(m,t)){try{const f=await o.readdir(n),y=await A.Promises.settled(f.map(async([I,T])=>{try{const M=v.joinPath(n,I),U=r?await o.stat(M):{type:T};return await this.t(o,M,U,f.length,r,a)}catch(M){return this.b.trace(M),null}}));m.children=(0,D.$Gb)(y)}catch(f){this.b.trace(f),m.children=[]}return m}return m}async resolveAll(o){return A.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),i=await n.stat(o);return this.t(n,o,i,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(i){return i}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new w.$Bk((0,p.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=L.$fe.fromString(""),i){await this.u(o,i);const t=await this.writeFile(o,n);return this.r.fire(new w.$yk(o,0,t)),t}async writeFile(o,n,i){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=i;if((0,w.$pk)(t)&&!a?.atomic){const v=t.enforceAtomicWriteFile?.(o);v&&(a={...i,atomic:v})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let m;if((0,w.$jk)(t)&&!(n instanceof L.$fe))if((0,$.$4d)(n)){const f=await(0,$.$$d)(n,3);f.ended?m=L.$fe.concat(f.buffer):m=f}else m=(0,$.$8d)(n,f=>L.$fe.concat(f),3);else m=n;!(0,w.$mk)(t)||(0,w.$jk)(t)&&m instanceof L.$fe||(0,w.$jk)(t)&&(0,w.$pk)(t)&&a?.atomic?await this.hb(t,o,a,m):await this.db(t,o,a,m instanceof L.$fe?(0,L.$qe)(m):m),this.r.fire(new w.$yk(o,4))}catch(v){throw new w.$Bk((0,p.localize)(4,null,this.sb(o),(0,w.$uk)(v).toString()),(0,w.$xk)(v),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,i){const t=!!i?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,p.localize)(5,null,this.sb(n)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,p.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,p.localize)(7,null,this.sb(n)));if(t)throw new Error((0,p.localize)(8,null,this.sb(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&w.FileType.Directory)throw new w.$Bk((0,p.localize)(9,null,this.sb(n)),0,i);if(this.rb(n,a),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==w.$Lk&&typeof a.mtime=="number"&&typeof a.size=="number"&&i.mtime<a.mtime&&i.etag!==(0,w.$Mk)({mtime:i.mtime,size:a.size}))throw new w.$Bk((0,p.localize)(10,null),3,i);return a}async readFile(o,n,i){const t=await this.m(o);return n?.atomic?this.z(t,o,n,i):this.C(t,o,n,i)}async z(o,n,i,t){return new Promise((r,a)=>{this.cb.queueFor(n,this.R(o).providerExtUri).queue(async()=>{try{const v=await this.C(o,n,i,t);r(v)}catch(v){a(v)}})})}async C(o,n,i,t){const r=await this.D(o,n,{...i,preferUnbuffered:!0},t);return{...r,value:await(0,L.$re)(r.value)}}async readFileStream(o,n,i){const t=await this.m(o);return this.D(t,o,n,i)}async D(o,n,i,t){const r=new j.$2d(t);let a=i;(0,w.$ok)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...i,atomic:!0});const v=this.J(n,a).then(f=>f,f=>{throw r.dispose(!0),f});let m;try{return typeof a?.etag=="string"&&a.etag!==w.$Lk&&await v,a?.atomic&&(0,w.$ok)(o)||!((0,w.$mk)(o)||(0,w.$nk)(o))||(0,w.$jk)(o)&&a?.preferUnbuffered?m=this.I(o,n,a):(0,w.$nk)(o)?m=this.G(o,n,r.token,a):m=this.H(o,n,r.token,a),m.on("end",()=>r.dispose()),m.on("error",()=>r.dispose()),{...await v,value:m}}catch(f){throw m&&await(0,$.$9d)(m),this.F(f,n,a)}}F(o,n,i){const t=(0,p.localize)(11,null,this.sb(n),(0,w.$uk)(o).toString());return o instanceof w.$Dk?new w.$Dk(t,o.stat,i):o instanceof w.$Ck?new w.$Ck(t,o.fileOperationResult,o.size,o.options):new w.$Bk(t,(0,w.$xk)(o),i)}G(o,n,i,t=Object.create(null)){const r=o.readFileStream(n,t,i);return(0,$.$ce)(r,{data:a=>a instanceof L.$fe?a:L.$fe.wrap(a),error:a=>this.F(a,n,t)},a=>L.$fe.concat(a))}H(o,n,i,t=Object.create(null)){const r=(0,L.$ve)();return(0,l.$Up)(o,n,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,n,t)},i),r}I(o,n,i){const t=(0,$.$6d)(r=>L.$fe.concat(r));return(async()=>{try{let r;i?.atomic&&(0,w.$ok)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(n,r.byteLength,i),t.end(L.$fe.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,n){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new w.$Bk((0,p.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==w.$Lk&&n.etag===i.etag)throw new w.$Dk((0,p.localize)(13,null),i,n);return this.L(o,i.size,n),i}L(o,n,i){if(typeof i?.limits?.size=="number"&&n>i.limits.size)throw new w.$Ck((0,p.localize)(14,null,this.sb(o)),7,n,i)}async canMove(o,n,i){return this.M(o,n,"move",i)}async canCopy(o,n,i){return this.M(o,n,"copy",i)}async M(o,n,i,t){if(o.toString()!==n.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(n),n);await this.Q(r,o,a,n,i,t)}catch(r){return r}return!0}async move(o,n,i){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"move",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$yk(o,a==="move"?2:3,v)),v}async copy(o,n,i){const t=await this.m(o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"copy",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$yk(o,a==="copy"?3:2,v)),v}async N(o,n,i,t,r,a){if(n.toString()===t.toString())return r;const{exists:v,isSameResourceWithDifferentPathCase:m}=await this.Q(o,n,i,t,r,a);if(v&&!m&&a&&await this.del(t,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(t)),r==="copy"){if(o===i&&(0,w.$kk)(o))await o.copy(n,t,{overwrite:a});else{const f=await this.resolve(n);f.isDirectory?await this.P(o,f,i,t):await this.O(o,n,i,t)}return r}else return o===i?(await o.rename(n,t,{overwrite:a}),r):(await this.N(o,n,i,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(o,n,i,t){if((0,w.$mk)(o)&&(0,w.$mk)(i))return this.jb(o,n,i,t);if((0,w.$mk)(o)&&(0,w.$jk)(i))return this.pb(o,n,i,t);if((0,w.$jk)(o)&&(0,w.$mk)(i))return this.nb(o,n,i,t);if((0,w.$jk)(o)&&(0,w.$jk)(i))return this.lb(o,n,i,t)}async P(o,n,i,t){await i.mkdir(t),Array.isArray(n.children)&&await A.Promises.settled(n.children.map(async r=>{const a=this.R(i).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,a):this.O(o,r.resource,i,a)}))}async Q(o,n,i,t,r,a){let v=!1;if(o===i){const{providerExtUri:f,isPathCaseSensitive:y}=this.R(o);if(y||(v=f.isEqual(n,t)),v&&r==="copy")throw new Error((0,p.localize)(15,null,this.sb(n),this.sb(t)));if(!v&&f.isEqualOrParent(t,n))throw new Error((0,p.localize)(16,null,this.sb(n),this.sb(t)))}const m=await this.exists(t);if(m&&!v){if(!a)throw new w.$Bk((0,p.localize)(17,null,this.sb(n),this.sb(t)),4);if(o===i){const{providerExtUri:f}=this.R(o);if(f.isEqualOrParent(n,t))throw new Error((0,p.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:m,isSameResourceWithDifferentPathCase:v}}R(o){const n=this.S(o);return{providerExtUri:n?c.$rg:c.$tg,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new w.$yk(o,0,i)),i}async U(o,n){const i=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&w.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(n)));break}catch(r){if((0,w.$wk)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(t.basename(n)),n=t.dirname(n)}for(let r=i.length-1;r>=0;r--){n=t.joinPath(n,i[r]);try{await o.mkdir(n)}catch(a){if((0,w.$wk)(a)!==w.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.W(o,n)}catch(i){return i}return!0}async W(o,n){const i=this.qb(await this.j(o),o),t=!!n?.useTrash;if(t&&!(i.capabilities&4096))throw new Error((0,p.localize)(20,null,this.sb(o)));const r=n?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,p.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,p.localize)(22,null,this.sb(o)));let a;try{a=await i.stat(o)}catch{}if(a)this.rb(o,a);else throw new w.$Bk((0,p.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const m=await this.resolve(o);if(m.isDirectory&&Array.isArray(m.children)&&m.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(o)))}return i}async del(o,n){const i=await this.W(o,n);let t=n;if((0,w.$qk)(i)&&!t?.atomic){const m=i.enforceAtomicDelete?.(o);m&&(t={...n,atomic:m})}const r=!!t?.useTrash,a=!!t?.recursive,v=t?.atomic??!1;await i.delete(o,{recursive:a,useTrash:r,atomic:v}),this.r.fire(new w.$yk(o,1))}async cloneFile(o,n){const i=await this.j(o),t=this.qb(await this.n(n),n);if(i===t&&this.R(i).providerExtUri.isEqual(o,n))return;if(i===t&&(0,w.$lk)(i))return i.cloneFile(o,n);await this.U(t,this.R(t).providerExtUri.dirname(n));const r=this.cb.queueFor(o,this.R(i).providerExtUri);return i===t&&(0,w.$kk)(i)?r.queue(()=>i.copy(o,n,{overwrite:!0})):r.queue(()=>this.O(i,o,t,n))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:d.ab++})}watch(o,n={recursive:!1,excludes:[]}){const i=new b.$Qc;let t=!1,r=()=>{t=!0};i.add((0,b.$Pc)(()=>r())),(async()=>{try{const v=await this.bb(o,n);t?(0,b.$Mc)(v):r=()=>(0,b.$Mc)(v)}catch(v){this.b.error(v)}})();const a=n.correlationId;if(typeof a=="number"){const v=i.add(new O.$Rd);return i.add(this.X.event(f=>{f.correlates(a)&&v.fire(f)})),{onDidChange:v.event,dispose:()=>i.dispose()}}return i}async bb(o,n){const i=await this.j(o),t=(0,P.$Li)([this.R(i).providerExtUri.getComparisonKey(o),n]);let r=this.$.get(t);return r||(r={count:0,disposable:i.watch(o,n)},this.$.set(t,r)),r.count+=1,(0,b.$Pc)(()=>{r&&(r.count--,r.count===0&&((0,b.$Mc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,b.$Mc)(o.disposable);this.$.clear()}async db(o,n,i,t){return this.cb.queueFor(n,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(n,{create:!0,unlock:i?.unlock??!1});try{(0,$.$4d)(t)||(0,$.$5d)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,w.$uk)(a)}finally{await o.close(r)}})}async eb(o,n,i){let t=0,r;if((0,$.$5d)(i)){if(i.buffer.length>0){const a=L.$fe.concat(i.buffer);await this.gb(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((a,v)=>{(0,$.$0d)(r,{onData:async m=>{r.pause();try{await this.gb(o,n,m,m.byteLength,t,0)}catch(f){return v(f)}t+=m.byteLength,setTimeout(()=>r.resume())},onError:m=>v(m),onEnd:()=>a()})})}async fb(o,n,i){let t=0,r;for(;(r=i.read())!==null;)await this.gb(o,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,n,i,t,r,a){let v=0;for(;v<t;){const m=await o.write(n,r+v,i.buffer,a+v,t-v);v+=m}}async hb(o,n,i,t){return this.cb.queueFor(n,this.R(o).providerExtUri).queue(()=>this.ib(o,n,i,t))}async ib(o,n,i,t){let r;t instanceof L.$fe?r=t:(0,$.$4d)(t)?r=await(0,L.$re)(t):(0,$.$5d)(t)?r=await(0,L.$se)(t):r=(0,L.$pe)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.kb(o,n,i,t))}async kb(o,n,i,t){let r,a;try{r=await o.open(n,{create:!1}),a=await i.open(t,{create:!0,unlock:!1});const v=L.$fe.alloc(this.a);let m=0,f=0,y=0;do y=await o.read(r,m,v.buffer,f,v.byteLength-f),await this.gb(i,a,v,y,m,f),m+=y,f+=y,f===v.byteLength&&(f=0);while(y>0)}catch(v){throw(0,w.$uk)(v)}finally{await A.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?i.close(a):Promise.resolve()])}}async lb(o,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.mb(o,n,i,t))}async mb(o,n,i,t){return i.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.ob(o,n,i,t))}async ob(o,n,i,t){const r=await i.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.gb(i,r,L.$fe.wrap(a),a.byteLength,0,0)}catch(a){throw(0,w.$uk)(a)}finally{await i.close(r)}}async pb(o,n,i,t){const r=await(0,L.$re)(this.H(o,n,j.CancellationToken.None));await this.hb(i,t,void 0,r)}qb(o,n){if(o.capabilities&2048)throw new w.$Bk((0,p.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.$Bk((0,p.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===k.Schemas.file?o.fsPath:o.toString(!0)}};e.$Vp=E,e.$Vp=E=d=pe([Z(0,u.$fj)],E)}),define(ae[200],ce([0,1,53,270,6,34,15,3,48,2,16,5,19,46,31,161,11,99,198,38,194,193]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l,u,h,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=void 0,(()=>{try{(0,A.gracefulify)(D)}catch(o){console.error(`Error enabling graceful-fs: ${(0,h.$Ii)(o)}`)}})();class s extends u.$5p{static{this.I=!1}constructor(n,i){super(n,i),this.onDidChangeCapabilities=P.Event.None,this.N=new j.$zc(t=>g.$sg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,k.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:i,symbolicLink:t}=await $.SymlinkSupport.stat(this.H(n));return{type:this.M(i,t),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:w.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await $.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(i.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,g.$Bg)(n,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(i){throw this.fb(i)}}M(n,i){let t;return i?.dangling?t=w.FileType.Unknown:n.isFile()?t=w.FileType.File:n.isDirectory()?t=w.FileType.Directory:t=w.FileType.Unknown,i&&(t|=w.FileType.SymbolicLink),t}async O(n){const i=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await t.wait();const r=new L.$Yg;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,b.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(n,i){let t;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await $.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){s.I&&this.a.trace(n)}readFileStream(n,i,t){const r=(0,c.$6d)(a=>O.$fe.concat(a.map(v=>O.$fe.wrap(v))).buffer);return(0,l.$Up)(this,n,r,a=>a.buffer,{...i,bufferSize:256*1024},t),r}async writeFile(n,i,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,g.$Bg)((0,g.$Ag)(n),`${(0,g.$yg)(n)}${t.atomic.postfix}`),i,t):this.S(n,i,t)}async Q(n){try{const i=this.H(n),{symbolicLink:t}=await $.SymlinkSupport.stat(i);if(t)return!1}catch{}return!0}async R(n,i,t,r){const a=new b.$Qc;try{a.add(await this.O(n)),a.add(await this.O(i)),await this.S(i,t,r,!0);try{await this.rename(i,n,{overwrite:!0})}catch(v){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{a.dispose()}}async S(n,i,t,r){let a;try{const v=this.H(n);if(!t.create||!t.overwrite){if(await $.Promises.exists(v)){if(!t.overwrite)throw(0,w.$tk)((0,p.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,w.$tk)((0,p.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,i,0,i.byteLength)}catch(v){throw await this.gb(n,v)}finally{typeof a=="number"&&await this.close(a)}}static{this.Y=!0}static configureFlushOnWrite(n){s.Y=n}async open(n,i,t){const r=this.H(n);let a;(0,w.$hk)(i)&&!t&&(a=await this.O(n));let v;try{if((0,w.$hk)(i)&&i.unlock)try{const{stat:f}=await $.SymlinkSupport.stat(r);f.mode&128||await $.Promises.chmod(r,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let m;if((0,w.$hk)(i)){if(k.$i)try{await $.Promises.truncate(r,0),m="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}m||(m="w")}else m="r";v=await $.Promises.open(r,m)}catch(m){throw a?.dispose(),(0,w.$hk)(i)?await this.gb(n,m):this.fb(m)}if(this.U.set(v,0),(0,w.$hk)(i)&&this.X.set(v,n),a){const m=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,a),m&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),m.dispose())}return v}async close(n){const i=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&s.Y)try{await $.Promises.fdatasync(n)}catch(t){s.configureFlushOnWrite(!1),this.a.error(t)}return await $.Promises.close(n)}catch(t){throw this.fb(t)}finally{i&&(this.W.get(n)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,t,r,a){const v=this.Z(n,i);let m=null;try{m=(await $.Promises.read(n,t,r,a,v)).bytesRead}catch(f){throw this.fb(f)}finally{this.$(n,v,m)}return m}Z(n,i){return i===this.U.get(n)?null:i}$(n,i,t){const r=this.U.get(n);typeof r=="number"&&(typeof i=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,i,t,r,a){return(0,L.$hh)(()=>this.ab(n,i,t,r,a),100,3)}async ab(n,i,t,r,a){const v=this.Z(n,i);let m=null;try{m=(await $.Promises.write(n,t,r,a,v)).bytesWritten}catch(f){throw await this.gb(this.X.get(n),f)}finally{this.$(n,v,m)}return m}async mkdir(n){try{await $.Promises.mkdir(this.H(n))}catch(i){throw this.fb(i)}}async delete(n,i){try{const t=this.H(n);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,C.$ic)((0,C.$lc)(t),`${(0,C.$mc)(t)}${i.atomic.postfix}`)),await $.Promises.rm(t,$.RimRafMode.MOVE,r)}else try{await $.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:v,symbolicLink:m}=await $.SymlinkSupport.stat(t);a=v.isDirectory()&&!m}catch{}if(a)await $.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,i,t){const r=this.H(n),a=this.H(i);if(r!==a)try{await this.bb(n,i,"move",t.overwrite),await $.Promises.rename(r,a)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(2,null,(0,C.$mc)(r),(0,C.$mc)((0,C.$lc)(a)),v.toString()))),this.fb(v)}}async copy(n,i,t){const r=this.H(n),a=this.H(i);if(r!==a)try{await this.bb(n,i,"copy",t.overwrite),await $.Promises.copy(r,a,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(3,null,(0,C.$mc)(r),(0,C.$mc)((0,C.$lc)(a)),v.toString()))),this.fb(v)}}async bb(n,i,t,r){const a=this.H(n),v=this.H(i);let m=!1;if(!!(this.capabilities&1024)||(m=(0,S.$1f)(a,v,!0)),m){if(t==="copy")throw(0,w.$tk)((0,p.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const y=await this.L(n);if(!y)throw(0,w.$tk)((0,p.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const I=await this.L(i);if(I){if(!r)throw(0,w.$tk)((0,p.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);y.type&w.FileType.File&&I.type&w.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.cb(n,i,!1)}async cb(n,i,t){const r=this.H(n),a=this.H(i),v=!!(this.capabilities&1024);if((0,S.$1f)(r,a,!v))return;const m=new b.$Qc;try{m.add(await this.O(n)),m.add(await this.O(i)),t&&await $.Promises.mkdir((0,C.$lc)(a),{recursive:!0}),await $.Promises.copyFile(r,a)}catch(f){if(f.code==="ENOENT"&&!t)return this.cb(n,i,!0);throw this.fb(f)}finally{m.dispose()}}t(n,i,t){return new d.$_p(r=>n(r),r=>i(r),t)}F(n,i,t){return new E.$hq(r=>n(r),r=>i(r),t)}fb(n){if(n instanceof w.$sk)return n;let i=n,t;switch(n.code){case"ENOENT":t=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=w.FileSystemProviderErrorCode.Unknown;break;default:t=w.FileSystemProviderErrorCode.Unknown}return(0,w.$tk)(i,t)}async gb(n,i){let t=this.fb(i);if(n&&t.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await $.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,w.$tk)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$iq=s}),define(ae[101],ce([0,1,3,2,4,8]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$0b=e.$00b=void 0,e.$00b=(0,L.$Xh)("sharedProcessLifecycleService");let O=class extends A.$Rc{constructor(S){super(),this.b=S,this.a=this.B(new D.$Rd),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$$0b=O,e.$$0b=O=pe([Z(0,j.$fj)],O)}),define(ae[201],ce([0,1,10,3,8,2]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=e.$gr=void 0;class O extends L.$qj{constructor(k,g,c,$,p){super(g,c,$),this.r=k,this.t=p,this.B(p.listen("onDidChangeLogLevel",k)(w=>{(0,L.$hj)(w)?super.setLogLevel(w):super.setLogLevel(D.URI.revive(w[0]),w[1])})),this.B(p.listen("onDidChangeVisibility",k)(([w,l])=>super.setVisibility(D.URI.revive(w),l))),this.B(p.listen("onDidChangeLoggers",k)(({added:w,removed:l})=>{for(const u of w)super.registerLogger({...u,resource:D.URI.revive(u.resource)});for(const u of l)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new L.$oj({log:(k,g)=>{this.t.call("consoleLog",[k,g])}})}registerLogger(k){super.registerLogger(k),this.t.call("registerLogger",[k,this.r])}deregisterLogger(k){super.deregisterLogger(k),this.t.call("deregisterLogger",[k,this.r])}setLogLevel(k,g){super.setLogLevel(k,g),this.t.call("setLogLevel",[k,g])}setVisibility(k,g){super.setVisibility(k,g),this.t.call("setVisibility",[this.n(k),g])}s(k,g,c){return new P(this.t,k,g,c,this.r)}static setLogLevel(k,g,c){return k.call("setLogLevel",[g,c])}}e.$gr=O;class P extends L.$lj{constructor(k,g,c,$,p){super($?.logLevel==="always"),this.r=k,this.s=g,this.m=!1,this.n=[],this.setLevel(c),this.r.call("createLogger",[g,$,p]).then(()=>{this.u(this.n),this.m=!0})}g(k,g){const c=[[k,g]];this.m?this.u(c):this.n.push(...c)}u(k){this.r.call("log",[this.s,k])}}class S{constructor(k,g){this.a=k,this.b=g}listen(k,g){const c=this.b(k);switch(g){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,$=>({added:[...$.added].map(p=>this.c(p,c)),removed:[...$.removed].map(p=>this.c(p,c))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,$=>[c.transformOutgoingURI($[0]),$[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,$=>(0,L.$hj)($)?$:[c.transformOutgoingURI($[0]),$[1]])}throw new Error(`Event not found: ${g}`)}async call(k,g,c){const $=this.b(k);switch(g){case"setLogLevel":return(0,L.$hj)(c[0])?this.a.setLogLevel(c[0]):this.a.setLogLevel(D.URI.revive($.transformIncoming(c[0][0])),c[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,$)))}throw new Error(`Call not found: ${g}`)}c(k,g){return{...k,resource:g.transformOutgoingURI(k.resource)}}}e.$hr=S;class b extends j.$Rc{constructor(k,g){super(),g.call("setLogLevel",[k.getLogLevel()]),this.B(k.onDidChangeLogLevel(c=>g.call("setLogLevel",[c]))),g.call("getRegisteredLoggers").then(c=>{for(const $ of c)k.registerLogger({...$,resource:D.URI.revive($.resource)})}),this.B(g.listen("onDidChangeVisibility")(([c,$])=>k.setVisibility(D.URI.revive(c),$))),this.B(g.listen("onDidChangeLoggers")(({added:c,removed:$})=>{for(const p of c)k.registerLogger({...p,resource:D.URI.revive(p.resource)});for(const p of $)k.deregisterLogger(p.resource)}))}}e.$ir=b}),define(ae[202],ce([0,1,2,8]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YN=void 0;class L extends D.$Rc{constructor(O,P=[]){super(),this.a=new A.$pj([O,...P]),this.B(O.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...P){this.a.trace(O,...P)}debug(O,...P){this.a.debug(O,...P)}info(O,...P){this.a.info(O,...P)}warn(O,...P){this.a.warn(O,...P)}error(O,...P){this.a.error(O,...P)}flush(){this.a.flush()}}e.$YN=L}),define(ae[56],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$68b=void 0,e.$68b=(0,D.$Xh)("nativeHostService")}),define(ae[203],ce([0,1,40,55]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n0b=void 0;let L=class{constructor(O,P){return this.windowId=O,D.ProxyChannel.toService(P.getChannel("nativeHost"),{context:O,properties:(()=>{const S=new Map;return S.set("windowId",O),S})()})}};e.$n0b=L,e.$n0b=L=pe([Z(1,A.$h0b)],L)}),define(ae[57],ce([0,1,3,60,2,4]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=e.$rn=e.$qn=void 0,e.$qn=(0,j.$Xh)("policy");class O extends L.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$Rd),this.onDidChange=this.h.event}async updatePolicyDefinitions(b){const C=Object.keys(this.f).length;return this.f={...b,...this.f},C!==Object.keys(this.f).length&&await this.j(b),A.Iterable.reduce(this.g.entries(),(k,[g,c])=>({...k,[g]:c}),{})}getPolicyValue(b){return this.g.get(b)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(b,[C,k])=>({...b,[C]:{definition:k,value:this.g.get(C)}}),{})}}e.$rn=O;class P{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$sn=P}),define(ae[204],ce([0,1,3,2,57]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q9b=e.$P9b=void 0;class j{constructor(S){this.b=S,this.a=new A.$Qc}listen(S,b){switch(b){case"onDidChange":return D.Event.map(this.b.onDidChange,C=>C.reduce((k,g)=>({...k,[g]:this.b.getPolicyValue(g)??null}),{}),this.a)}throw new Error(`Event not found: ${b}`)}call(S,b,C){switch(b){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${b}`)}dispose(){this.a.dispose()}}e.$P9b=j;class O extends L.$rn{constructor(S,b){super(),this.a=b;for(const C in S){const{definition:k,value:g}=S[C];this.f[C]=k,g!==void 0&&this.g.set(C,g)}this.a.listen("onDidChange")(C=>{for(const k in C){const g=C[k];g===null?this.g.delete(k):this.g.set(k,g)}this.h.fire(Object.keys(C))})}async j(S){const b=await this.a.call("updatePolicyDefinitions",S);for(const C in b)this.g.set(C,b[C])}}e.$Q9b=O}),define(ae[102],ce([0,1,37]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const j=L.context.configuration();if(j)A=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:j.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(ae[25],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=void 0,e.$xj=(0,D.$Xh)("productService"),e.$yj="vscode://schemas/vscode-product"}),define(ae[205],ce([0,1,6,7,2,16,31,8,25]),function(ie,e,D,A,L,j,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E0b=void 0;let b=class extends L.$Rc{constructor(k,g,c){super(),this.b=g,this.c=c,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,k&&this.B(new D.$_g(()=>{this.f(k)},3e4)).schedule()}async f(k){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),c=(0,j.$lc)(k),$=(0,j.$mc)(k),p=await O.Promises.readdir(c);await Promise.all(p.map(async w=>{if(w===$)return;const l=(0,j.$ic)(c,w),u=await O.Promises.stat(l);if(u.isDirectory()&&g-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),O.Promises.rm(l)}))}catch(g){(0,A.$Z)(g)}}};e.$E0b=b,e.$E0b=b=pe([Z(1,S.$xj),Z(2,P.$fj)],b)}),define(ae[206],ce([0,1,6,7,2,16,31,14,8,25]),function(ie,e,D,A,L,j,O,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F0b=void 0;let C=class extends L.$Rc{constructor(g,c,$){super(),this.b=g,this.c=c,this.f=$,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new D.$_g(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),c=JSON.parse(await O.Promises.readFile((0,j.$ic)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(c)){const h=c[u];g[`${h.hash}.${u}`]=!0}const $=(0,j.$ic)(this.b.userDataPath,"clp");if(!await O.Promises.exists($))return;const w=await O.Promises.readdir($);for(const u of w){if(g[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await O.Promises.rm((0,j.$ic)($,u))}const l=Date.now();for(const u of Object.keys(g)){const h=(0,j.$ic)($,u),d=await O.Promises.readdir(h);for(const E of d){if(E==="tcf.json")continue;const s=(0,j.$ic)(h,E),o=await O.Promises.stat(s);o.isDirectory()&&l-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$ic)(u,E)}`),await O.Promises.rm(s))}}}catch(g){(0,A.$Z)(g)}}};e.$F0b=C,e.$F0b=C=pe([Z(0,P.$6h),Z(1,S.$fj),Z(2,b.$xj)],C)}),define(ae[207],ce([0,1,16,4]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$AF=void 0,e.$AF=(0,A.$Xh)("IV8InspectProfilingService");var L;(function(j){function O(S){return!!(S.samples&&S.timeDeltas)}j.isValidProfile=O;function P(S,b="noAbsolutePaths"){for(const C of S.nodes)C.callFrame&&C.callFrame.url&&((0,D.$hc)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,D.$ic)(b,(0,D.$mc)(C.callFrame.url)));return S}j.rewriteAbsolutePaths=P})(L||(e.Utils=L={}))}),define(ae[208],ce([0,1,32]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z0b=void 0;class A{constructor(){this.a=new Map}async startProfiling(j){const P=await(await new Promise((b,C)=>{ie(["v8-inspect-profiler"],b,C)})).startProfiling({port:j.port,checkForPaused:!0}),S=(0,D.$kg)();return this.a.set(S,P),S}async stopProfiling(j){const O=this.a.get(j);if(!O)throw new Error(`UNKNOWN session '${j}'`);const P=await O.stop();return this.a.delete(j),P.profile}}e.$Z0b=A}),define(ae[41],ce([0,1,126,12]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=void 0;class L{constructor(){this.a=new Map}add(O,P){D.ok(A.$Cf(O)),D.ok(A.$Ef(P)),D.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,P)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$on=new L}),define(ae[103],ce([0,1,3,41]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=void 0,e.$pn={JSONContribution:"base.contributions.json"};function L(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class j{constructor(){this.b=new D.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,b){this.a[L(S)]=b,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const O=new j;A.$on.add(e.$pn.JSONContribution,O)}),define(ae[50],ce([0,1,18,3,12,148,20,103,41]),function(ie,e,D,A,L,j,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.ConfigurationScope=e.$tn=e.EditPresentationTypes=void 0;var b;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$tn={Configuration:"base.contributions.configuration"};var C;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn={properties:{},patternProperties:{}},e.$zn={properties:{},patternProperties:{}},e.$An="vscode://schemas/settings/resourceLanguage",e.$Bn="vscode://schemas/settings/configurationDefaults";const k=S.$on.as(P.$pn.JSONContribution);class g{constructor(){this.h=new Set,this.i=new A.$Rd,this.onDidSchemaChange=this.i.event,this.j=new A.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$An,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const n=new Set;this.n(s,o,n),k.registerSchema(e.$An,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(s){const o=new Set;this.o(s,o),k.registerSchema(e.$An,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const n=new Set;this.o(o,n),this.n(s,!1,n),k.registerSchema(e.$An,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const n=[];for(const{overrides:i,source:t}of s)for(const r in i)if(o.add(r),e.$Dn.test(r)){const a=this.a.get(r),v=a?.valuesSources??new Map;if(t)for(const I of Object.keys(i[r]))v.set(I,t);const m={...a?.value||{},...i[r]};this.a.set(r,{source:t,value:m,valuesSources:v});const f=(0,O.$Bi)(r),y={type:"object",default:m,description:j.localize(1,null,f),$ref:e.$An,defaultDefaultValue:m,source:L.$Cf(t)?void 0:t,defaultValueSource:t};n.push(...p(r)),this.d[r]=y,this.b.properties[r]=y}else{this.a.set(r,{value:i[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:n,source:i}of s)for(const t in n){const r=this.a.get(t),a=L.$Cf(i)?i:i?.id,v=L.$Cf(r?.source)?r?.source:r?.source?.id;if(a===v)if(o.add(t),this.a.delete(t),e.$Dn.test(t))delete this.d[t],delete this.b.properties[t];else{const m=this.d[t];m&&(this.w(t,m),this.r(t,m))}}this.u()}deltaConfiguration(s){let o=!1;const n=new Set;s.removedDefaults&&(this.l(s.removedDefaults,n),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,n),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,n),s.addedConfigurations&&this.n(s.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,n){s.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(s,o){const n=i=>{if(i.properties)for(const t in i.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,i.properties[t])}i.allOf?.forEach(t=>n(t))};for(const i of s){n(i);const t=this.c.indexOf(i);t!==-1&&this.c.splice(t,1)}}p(s,o=!0,n,i,t=3,r){t=L.$Lf(s.scope)?t:s.scope;const a=s.properties;if(a)for(const m in a){const f=a[m];if(o&&h(m,f)){delete a[m];continue}if(f.source=n,f.defaultDefaultValue=a[m].default,this.w(m,f),e.$Dn.test(m)?f.scope=void 0:(f.scope=L.$Lf(f.scope)?t:f.scope,f.restricted=L.$Lf(f.restricted)?!!i?.includes(m):f.restricted),a[m].hasOwnProperty("included")&&!a[m].included){this.f[m]=a[m],delete a[m];continue}else this.d[m]=a[m],a[m].policy?.name&&this.e.set(a[m].policy.name,m);!a[m].deprecationMessage&&a[m].markdownDeprecationMessage&&(a[m].deprecationMessage=a[m].markdownDeprecationMessage),r.add(m)}const v=s.allOf;if(v)for(const m of v)this.p(m,o,n,i,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=n=>{const i=n.properties;if(i)for(const r in i)this.r(r,i[r]);n.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$un.properties[s]=o,o.scope){case 1:e.$vn.properties[s]=o;break;case 2:e.$wn.properties[s]=o;break;case 6:e.$xn.properties[s]=o;break;case 3:e.$yn.properties[s]=o;break;case 4:e.$zn.properties[s]=o;break;case 5:e.$zn.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$un.properties[s],o.scope){case 1:delete e.$vn.properties[s];break;case 2:delete e.$wn.properties[s];break;case 6:delete e.$xn.properties[s];break;case 3:delete e.$yn.properties[s];break;case 4:case 5:delete e.$zn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,n={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$An};this.w(o,n),e.$un.properties[o]=n,e.$vn.properties[o]=n,e.$wn.properties[o]=n,e.$xn.properties[o]=n,e.$yn.properties[o]=n,e.$zn.properties[o]=n}}v(){const s={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$An};e.$un.patternProperties[e.$Cn]=s,e.$vn.patternProperties[e.$Cn]=s,e.$wn.patternProperties[e.$Cn]=s,e.$xn.patternProperties[e.$Cn]=s,e.$yn.patternProperties[e.$Cn]=s,e.$zn.patternProperties[e.$Cn]=s,this.i.fire()}w(s,o){const n=this.a.get(s);let i=n?.value,t=n?.source;L.$Jf(i)&&(i=o.defaultDefaultValue,t=void 0),L.$Jf(i)&&(i=l(o.type)),o.default=i,o.defaultValueSource=t}}const c="\\[([^\\]]+)\\]",$=new RegExp(c,"g");e.$Cn=`^(${c})+$`,e.$Dn=new RegExp(e.$Cn);function p(E){const s=[];if(e.$Dn.test(E)){let o=$.exec(E);for(;o?.length;){const n=o[1].trim();n&&s.push(n),o=$.exec(E)}}return(0,D.$Lb)(s)}e.$En=p;function w(E){return E.reduce((s,o)=>`${s}[${o}]`,"")}e.$Fn=w;function l(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Gn=l;const u=new g;S.$on.add(e.$tn.Configuration,u);function h(E,s){return E.trim()?e.$Dn.test(E)?j.localize(7,null,E):u.getConfigurationProperties()[E]!==void 0?j.localize(8,null,E):s.policy?.name&&u.getPolicyConfigurations().get(s.policy?.name)!==void 0?j.localize(9,null,E,s.policy?.name,u.getPolicyConfigurations().get(s.policy?.name)):null:j.localize(6,null)}e.$Hn=h;function d(){const E=[],s=u.getConfigurationProperties();for(const o of Object.keys(s))E.push([o,s[o].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.$In=d}),define(ae[75],ce([0,1,18,3,35,2,34,30,12,10,20,50,41]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=void 0;function c(o){return Object.isFrozen(o)?o:P.$dn(o)}class ${constructor(n={},i=[],t=[],r){this.b=n,this.c=i,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof $)return i;const t=new p("");return t.parseRaw(i),t.configurationModel});this.f=n.reduce((i,t)=>t===i?t:i.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$zi)(this.contents,n):this.contents}inspect(n,i){const t=this.rawConfiguration.getValue(n),r=i?this.rawConfiguration.getOverrideValue(n,i):void 0,a=i?this.rawConfiguration.override(i).getValue(n):t;return{value:t,override:r,merged:a}}getOverrideValue(n,i){const t=this.i(i);return t?n?(0,C.$zi)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const t of this.overrides)t.identifiers.includes(n)&&i.push(...t.keys);return D.$Lb(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return D.$Lb(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=P.$cn(this.contents),t=P.$cn(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const v of n)if(a.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(i,v.contents);for(const m of v.overrides){const[f]=t.filter(y=>D.$tb(y.identifiers,m.identifiers));f?(this.h(f.contents,m.contents),f.keys.push(...m.keys),f.keys=D.$Lb(f.keys)):t.push(P.$cn(m))}for(const m of v.keys)r.indexOf(m)===-1&&r.push(m)}return new $(i,r,t,a.every(v=>v instanceof $)?void 0:a)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const t={};for(const r of D.$Lb([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r];const v=i[r];v&&(typeof a=="object"&&typeof v=="object"?(a=P.$cn(a),this.h(a,v)):a=v),t[r]=a}return new $(t,this.keys,this.overrides)}h(n,i){for(const t of Object.keys(i)){if(t in n&&S.$Ef(n[t])&&S.$Ef(i[t])){this.h(n[t],i[t]);continue}n[t]=P.$cn(i[t])}}i(n){let i=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=P.$cn(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?i=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(i),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,C.$yi)(this.contents,n),k.$Dn.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>D.$tb(t.identifiers,(0,k.$En)(n))),1))}j(n,i,t){(0,C.$xi)(this.contents,n,i,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),k.$Dn.test(n)&&this.overrides.push({identifiers:(0,k.$En)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$wi)(this.contents[n],r=>console.error(r))})}}e.$Jn=$;class p{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!S.$Lf(n)){const t=this.g(n);this.parseRaw(t,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:t,keys:r,overrides:a,restricted:v,hasExcludedProperties:m}=this.h(n,i);this.b=new $(t,r,a,m?[n]:void 0),this.c=v||[]}g(n){let i={},t=null,r=[];const a=[],v=[];function m(y){Array.isArray(r)?r.push(y):t!==null&&(r[t]=y)}const f={onObjectBegin:()=>{const y={};m(y),a.push(r),r=y,t=null},onObjectProperty:y=>{t=y},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const y=[];m(y),a.push(r),r=y,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:m,onError:(y,I,T)=>{v.push({error:y,offset:I,length:T})}};if(n)try{L.$_m(n,f),i=r[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return i}h(n,i){const t=g.$on.as(k.$tn.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,i);n=r.raw;const a=(0,C.$wi)(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),v=Object.keys(n),m=this.j(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:a,keys:v,overrides:m,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,i,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const v={},m=[];for(const f in n)if(k.$Dn.test(f)&&t){const y=this.i(n[f],i,!1,r);v[f]=y.raw,a=a||y.hasExcludedProperties,m.push(...y.restricted)}else{const y=i[f],I=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&m.push(f),!r.exclude?.includes(f)&&(r.include?.includes(f)||(I===void 0||r.scopes===void 0||r.scopes.includes(I))&&!(r.skipRestricted&&y?.restricted))?v[f]=n[f]:a=!0}return{raw:v,restricted:m,hasExcludedProperties:a}}j(n,i){const t=[];for(const r of Object.keys(n))if(k.$Dn.test(r)){const a={};for(const v in n[r])a[v]=n[r][v];t.push({identifiers:(0,k.$En)(r),keys:Object.keys(a),contents:(0,C.$wi)(a,i)})}return t}}e.$Kn=p;class w extends j.$Rc{constructor(n,i,t,r){super(),this.c=n,this.f=i,this.g=r,this.b=this.B(new A.$Rd),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Ln=w;class l{constructor(n,i,t,r,a,v,m,f,y,I,T,M,U){this.a=n,this.b=i,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=v,this.g=m,this.h=f,this.i=y,this.j=I,this.k=T,this.l=M,this.m=U}get value(){return c(this.c)}n(n,i,t){const r=n.inspect(i,t);return{get value(){return c(r.value)},get override(){return c(r.override)},get merged(){return c(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(n,i,t,r,a=new $,v=new $,m=new O.$zc,f=new $,y=new O.$zc){this.c=n,this.d=i,this.f=t,this.g=r,this.h=a,this.i=v,this.j=m,this.l=f,this.m=y,this.a=null,this.b=new O.$zc,this.n=null}getValue(n,i,t){return this.p(n,i,t).getValue(n)}updateValue(n,i,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new $,this.m.set(t.resource,r))):r=this.l,i===void 0?r.removeValue(n):r.setValue(n,i),t.resource||(this.a=null)}inspect(n,i,t){const r=this.p(n,i,t),a=this.t(i.resource,t),v=i.resource?this.m.get(i.resource)||this.l:this.l,m=new Set;for(const f of r.overrides)for(const y of f.identifiers)r.getOverrideValue(n,y)!==void 0&&m.add(y);return new l(n,i,r.getValue(n),m.size?[...m]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,v)}keys(n){const i=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const t=[];if(!i){const{added:r,updated:a,removed:v}=E(this.c,n);i=[...r,...a,...v]}for(const r of i)for(const a of(0,k.$En)(r)){const v=this.c.getKeysForOverrideIdentifier(a),m=n.getKeysForOverrideIdentifier(a),f=[...m.filter(y=>v.indexOf(y)===-1),...v.filter(y=>m.indexOf(y)===-1),...v.filter(y=>!P.$gn(this.c.override(a).getValue(y),n.override(a).getValue(y)))];t.push([a,f])}return this.updateDefaultConfiguration(n),{keys:i,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:t,removed:r}=E(this.d,n),a=[...i,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.applicationConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.localUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.remoteUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.workspaceConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:a}}compareAndUpdateFolderConfiguration(n,i){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:v,overrides:m}=E(t,i),f=[...r,...a,...v];return(f.length||!t)&&this.updateFolderConfiguration(n,i),{keys:f,overrides:m}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:v}=E(i,void 0);return{keys:[...t,...r,...a],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,i,t){let r=this.q(i,t);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}q({resource:n},i){let t=this.r();if(i&&n){const r=i.getFolder(n);r&&(t=this.s(r.uri)||t);const a=this.m.get(n);a&&(t=t.merge(a))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let i=this.b.get(n);if(!i){const t=this.r(),r=this.j.get(n);r?(i=t.merge(r),this.b.set(n,i)):i=t}return i}t(n,i){if(i&&n){const t=i.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:t,overrides:r,keys:a}=this.j.get(i);return n.push([i,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(t=>n.add(t))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}v(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r))),[...i.values()]}static parse(n){const i=this.w(n.defaults),t=this.w(n.policy),r=this.w(n.application),a=this.w(n.user),v=this.w(n.workspace),m=n.folders.reduce((f,y)=>(f.set(b.URI.revive(y[0]),this.w(y[1])),f),new O.$zc);return new u(i,t,r,a,new $,v,m,new $,new O.$zc)}static w(n){return new $(n.contents,n.keys,n.overrides)}}e.$Mn=u;function h(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,i=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,v])=>{const m=(0,O.$wc)(i,a,new Set);v.forEach(f=>m.add(f))});const t=[];return i.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$Nn=h;class d{constructor(n,i,t,r){this.change=n,this.f=i,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const v of a)this.affectedKeys.add(v);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(n,i){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const v=this.d.charCodeAt(a);if(v!==this.b&&v!==this.c)return!1;if(i){const m=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,f=this.g.getValue(n,i,this.h);return!P.$gn(m,f)}return!0}}e.$On=d;function E(o,n){const{added:i,removed:t,updated:r}=s(n?.rawConfiguration,o?.rawConfiguration),a=[],v=o?.getAllOverrideIdentifiers()||[],m=n?.getAllOverrideIdentifiers()||[];if(n){const f=m.filter(y=>!v.includes(y));for(const y of f)a.push([y,n.getKeysForOverrideIdentifier(y)])}if(o){const f=v.filter(y=>!m.includes(y));for(const y of f)a.push([y,o.getKeysForOverrideIdentifier(y)])}if(n&&o){for(const f of v)if(m.includes(f)){const y=s({contents:o.getOverrideValue(void 0,f)||{},keys:o.getKeysForOverrideIdentifier(f)},{contents:n.getOverrideValue(void 0,f)||{},keys:n.getKeysForOverrideIdentifier(f)});a.push([f,[...y.added,...y.removed,...y.updated]])}}return{added:i,removed:t,updated:r,overrides:a}}function s(o,n){const i=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const v=(0,C.$zi)(n.contents,a),m=(0,C.$zi)(o.contents,a);P.$gn(v,m)||r.push(a)}}return{added:i,removed:t,updated:r}}}),define(ae[209],ce([0,1,18,3,2,30,12,75,50,8,57,41]),function(ie,e,D,A,L,j,O,P,S,b,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=e.$Qn=e.$Pn=void 0;class g extends L.$Rc{constructor(){super(...arguments),this.a=this.B(new A.$Rd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$Jn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(k.$on.as(S.$tn.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:l})=>this.c(Array.from(w),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,l){this.h(w,k.$on.as(S.$tn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new P.$Jn;const w=k.$on.as(S.$tn.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,l){const u=this.f();for(const h of w){const d=u[h],E=l[h];d!==void 0?this.b.addValue(h,d):E?this.b.addValue(h,E.default):this.b.removeValue(h)}}}e.$Pn=g;class c{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new P.$Jn}async initialize(){return this.configurationModel}}e.$Qn=c;let $=class extends L.$Rc{get configurationModel(){return this.b}constructor(w,l,u){super(),this.c=w,this.f=l,this.g=u,this.a=this.B(new A.$Rd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$Jn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const l={},u=[],h=k.$on.as(S.$tn.Configuration).getConfigurationProperties();for(const d of w){const E=h[d];if(!E){u.push(d);continue}if(E.policy){if(E.type!=="string"&&E.type!=="number"){this.g.warn(`Policy ${E.policy.name} has unsupported type ${E.type}`);continue}u.push(d),l[E.policy.name]={type:E.type}}}return(0,O.$Pf)(l)||await this.f.updatePolicyDefinitions(l),u}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const l=k.$on.as(S.$tn.Configuration).getPolicyConfigurations(),u=(0,D.$Gb)(w.map(h=>l.get(h)));this.m(u,!0)}m(w,l){this.g.trace("PolicyConfiguration#update",w);const u=k.$on.as(S.$tn.Configuration).getConfigurationProperties(),h=[],d=this.b.isEmpty();for(const E of w){const s=u[E]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(d?o!==void 0:!(0,j.$gn)(this.b.getValue(E),o))&&h.push([E,o])}else this.b.getValue(E)!==void 0&&h.push([E,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const E=this.b;this.b=new P.$Jn;for(const s of E.keys)this.b.setValue(s,E.getValue(s));for(const[s,o]of h)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);l&&this.a.fire(this.b)}}};e.$Rn=$,e.$Rn=$=pe([Z(1,C.$qn),Z(2,b.$fj)],$)}),define(ae[210],ce([0,1,6,3,2,19,20,75,209,57]),function(ie,e,D,A,L,j,O,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=void 0;class C extends L.$Rc{constructor(g,c,$,p){super(),this.j=g,this.h=this.B(new A.$Rd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new S.$Pn),this.c=$ instanceof b.$sn?new S.$Qn:this.B(new S.$Rn(this.b,$,p)),this.f=this.B(new P.$Ln(this.j,{},j.$sg,c)),this.a=new P.$Mn(this.b.configurationModel,this.c.configurationModel,new P.$Jn,new P.$Jn),this.g=this.B(new D.$_g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:w,properties:l})=>this.n(w,l))),this.B(this.c.onDidChangeConfiguration(w=>this.r(w))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,c,$]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.$Mn(g,c,new P.$Jn,$)}getConfigurationData(){return this.a.toData()}getValue(g,c){const $=typeof g=="string"?g:void 0,p=(0,O.$si)(g)?g:(0,O.$si)(c)?c:{};return this.a.getValue($,p,void 0)}updateValue(g,c,$,p){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.m(g)}m(g){const c=this.a.toData(),$=this.a.compareAndUpdateLocalUserConfiguration(g);this.s($,c,2)}n(g,c){const $=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(g,c);this.s(p,$,7)}r(g){const c=this.a.toData(),$=this.a.compareAndUpdatePolicyConfiguration(g);this.s($,c,7)}s(g,c,$){const p=new P.$On(g,{data:c},this.a);p.source=$,p.sourceConfig=this.t($),this.h.fire(p)}t(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Sn=C}),define(ae[211],ce([0,1,15,3,2,67]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hqb=e.$gqb=e.$fqb=e.$eqb=void 0;const O=(b,C,k)=>{const g=new Uint8Array(16);for(let p=0;p<16;p++)g[p]=Math.round(Math.random()*256);const c=(0,D.$ze)(D.$fe.wrap(g));return[`GET ws://localhost${b}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${c}`].join(`\r
`)+`\r
\r
`};e.$eqb=O,e.$fqb=D.$fe.fromString(`\r
\r
`);async function P(b,C,k,g,c){b.write(D.$fe.fromString((0,e.$eqb)(C,k,g)));const $=new L.$Qc;try{return await new Promise((p,w)=>{let l;$.add(b.onData(u=>{l?l=D.$fe.concat([l,u],l.byteLength+u.byteLength):l=u;const h=l.indexOf(e.$fqb);if(h===-1)return;p(b),b.pauseData();const d=l.slice(h+e.$fqb.byteLength);d.byteLength&&c.onData.fire(d)})),$.add(b.onClose(u=>w(u??new Error("socket closed")))),$.add(b.onEnd(()=>w(new Error("socket ended"))))})}catch(p){throw b.dispose(),p}finally{$.dispose()}}e.$gqb=P;class S extends L.$Rc{constructor(C,k){super(),this.g=C,this.a=this.B(new A.$Ud),this.onData=(...g)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...g)),this.b=this.B(new A.$Rd),this.onDidDispose=this.b.event,this.f=!1,this.B(k.onData),this.B(k.onData.event(g=>this.a.fire(g))),this.onClose=this.B(k.onClose).event,this.onEnd=this.B(k.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,k){j.SocketDiagnostics.traceSocketEvent(this,this.g,C,k)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$hqb=S}),define(ae[212],ce([0,1,7,4]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.RemoteAuthorityResolverErrorCode=e.$Zk=e.$Yk=e.RemoteConnectionType=e.$Xk=void 0,e.$Xk=(0,A.$Xh)("remoteAuthorityResolverService");var L;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class j{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$Yk=j;class O{constructor(k,g){this.host=k,this.port=g,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Zk=O;var P;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class S extends D.$ab{static isNotAvailable(k){return k instanceof S&&k._code===P.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof S&&k._code===P.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof S&&k._code===P.NoResolverFound}static isInvalidAuthority(k){return k instanceof S&&k._code===P.InvalidAuthority}static isHandled(k){return k instanceof S&&k.isHandled}constructor(k,g=P.Unknown,c){super(k),this._message=k,this._code=g,this._detail=c,this.isHandled=g===P.NotAvailable&&c===!0,Object.setPrototypeOf(this,S.prototype)}}e.$1k=S;function b(C){const k=C.indexOf("+");return k===-1?C:C.substring(0,k)}e.$2k=b}),define(ae[76],ce([0,1,23]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=void 0;function A(b){return b.scheme===D.Schemas.vscodeRemote?b.authority:void 0}e.$3k=A;function L(b){if(!b)return;const C=b.indexOf("+");return C<0?b:b.substr(0,C)}e.$4k=L;function j(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.$5k=j;function O(b){const{host:C,port:k}=S(b);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:k}}e.$6k=O;function P(b,C){let{host:k,port:g}=S(b);return typeof g>"u"&&(g=C),{host:k,port:g}}e.$7k=P;function S(b){const C=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const k=b.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const g=b.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:b,port:void 0}}}),define(ae[44],ce([0,1,27,4,76]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.TargetPlatform=e.ExtensionType=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l="extensions.user.cache",e.$9l="extensions.builtin.cache",e.$0l="undefined_publisher",e.$$l=["ui","workspace","web"];function j(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$_l=j,e.$am=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(O||(e.ExtensionType=O={}));var P;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class S{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,l){if(typeof w>"u"||w===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof w=="string"||typeof l=="string"){const u=typeof w=="string"?w:w.value,h=typeof l=="string"?l:l.value;return D.$6e(u,h)}return w._lower===l._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$bm=S;class b{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const l of w)this.add(l)}add(w){this.c.add(S.toKey(w))}delete(w){return this.c.delete(S.toKey(w))}has(w){return this.c.has(S.toKey(w))}}e.$cm=b;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(S.toKey(w))}get(w){return this.c.get(S.toKey(w))}has(w){return this.c.has(S.toKey(w))}set(w,l){this.c.set(S.toKey(w),l)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$dm=C;function k(p){return g(p)}e.$em=k;function g(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$fm=g;function c(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$gm=c;function $(p,w){if(w){const l=`onResolveRemoteAuthority:${(0,L.$4k)(w)}`;return!!p.activationEvents?.includes(l)}return!1}e.$hm=$,e.$im=(0,A.$Xh)("IBuiltinExtensionsScannerService")}),define(ae[213],ce([0,1,2,44,11]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;class j extends D.$Rc{constructor(P,S,b,C,k){super(),this.a=P,this.b=S,this.c=b,this.f=k,this.B(C.onDidInstallExtensions(g=>this.g(g))),this.B(C.onDidUninstallExtension(g=>this.h(g)))}g(P){for(const S of P)S.local&&this.invalidate(S.profileLocation)}h(P){P.error||this.invalidate(P.profileLocation)}async invalidate(P){if(P)for(const S of this.a.profiles)this.c.extUri.isEqual(S.extensionsResource,P)&&await this.j(S);else await this.j(this.a.defaultProfile)}async j(P){try{await this.b.del(this.c.extUri.joinPath(P.cacheHome,A.$8l))}catch(S){(0,L.$xk)(S)!==1&&this.f.error(S)}}}e.$Op=j}),define(ae[214],ce([0,1,6,15,26,7,3,2,100,62,32,67,212,76]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.PersistentConnectionEventType=e.$bl=e.$al=e.$_k=e.ConnectionType=void 0;const $=30*1e3;var p;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function w(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(z){const R=new L.$2d;return setTimeout(()=>R.cancel(),z),R.token}function u(z,R){if(z.isCancellationRequested||R.isCancellationRequested)return L.CancellationToken.Cancelled;const F=new L.$2d;return z.onCancellationRequested(()=>F.cancel()),R.onCancellationRequested(()=>F.cancel()),F.token}class h{get didTimeout(){return this.c==="timedout"}constructor(R){this.c="pending",this.d=new P.$Qc,this.promise=new Promise((F,B)=>{this.f=F,this.g=B}),R.isCancellationRequested?this.h():this.d.add(R.onCancellationRequested(()=>this.h()))}registerDisposable(R){this.c==="pending"?this.d.add(R):R.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const R=new Error("Time limit reached");return R.code="ETIMEDOUT",R.syscall="connect",R}resolve(R){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(R))}reject(R){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(R))}}function d(z,R){const F=new h(R);return F.registerDisposable(z.onControlMessage(B=>{const N=JSON.parse(B.toString()),V=W(N);V?F.reject(V):F.resolve(N)})),F.promise}function E(z,R,F,B,N,V,G,te){const oe=new h(te),ue=b.$Nd.create(!1);return z.info(`Creating a socket (${G})...`),S.mark(`code/willCreateSocket/${V}`),R.connect(F,B,N,G).then(he=>{oe.didTimeout?(S.mark(`code/didCreateSocketError/${V}`),z.info(`Creating a socket (${G}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(S.mark(`code/didCreateSocketOK/${V}`),z.info(`Creating a socket (${G}) was successful after ${ue.elapsed()} ms.`),oe.resolve(he))},he=>{S.mark(`code/didCreateSocketError/${V}`),z.info(`Creating a socket (${G}) returned an error after ${ue.elapsed()} ms.`),z.error(he),oe.reject(he)}),oe.promise}function s(z,R){const F=new h(R);return z.then(B=>{F.didTimeout||F.resolve(B)},B=>{F.didTimeout||F.reject(B)}),F.promise}async function o(z,R,F,B){const N=se(z,R);z.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let V;try{V=await E(z.logService,z.remoteSocketFactoryService,z.connectTo,(0,c.$5k)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,w(R),`renderer-${w(R)}-${z.reconnectionToken}`,B)}catch(he){throw z.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),z.logService.error(he),he}z.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let G,te;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(V,null),G=z.reconnectionProtocol,te=!1):(G=new k.$Lh({socket:V}),te=!0),z.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const oe=await s(z.signService.createNewMessage((0,C.$kg)()),B),ue={type:"auth",auth:z.connectionToken||"00000000000000000000",data:oe.data};G.sendControl(A.$fe.fromString(JSON.stringify(ue)));try{const he=await d(G,u(B,l(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}if(z.logService.trace(`${N} 4/6. received SignRequest control message.`),!await s(z.signService.validate(oe,he.signedData),B)){const ve=new Error("Refused to connect to unsupported server");throw ve.code="VSCODE_CONNECTION_ERROR",ve}const de=await s(z.signService.sign(he.data),B),we={type:"connectionType",commit:z.commit,signedData:de,desiredConnectionType:R};return F&&(we.args=F),z.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(A.$fe.fromString(JSON.stringify(we))),{protocol:G,ownsProtocol:te}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(z.logService.error(`${N} the handshake timed out. Error:`),z.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${N} received error control message when negotiating connection. Error:`),z.logService.error(he)),te&&J(G),he}}async function n(z,R,F,B){const N=Date.now(),V=se(z,R),{protocol:G,ownsProtocol:te}=await o(z,R,F,B),oe=new h(B);return oe.registerDisposable(G.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),ge=W(he);ge?(z.logService.error(`${V} received error control message when negotiating connection. Error:`),z.logService.error(ge),te&&J(G),oe.reject(ge)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${X(N)}!`),oe.resolve({protocol:G,firstMessage:he}))})),oe.promise}async function i(z,R){const{protocol:F}=await n(z,1,void 0,R);return{protocol:F}}async function t(z,R,F){const{protocol:B,firstMessage:N}=await n(z,2,R,F),V=N&&N.debugPort;return{protocol:B,debugPort:V}}async function r(z,R,F){const B=Date.now(),N=se(z,3),{protocol:V}=await o(z,3,R,F);return z.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${X(B)}!`),V}async function a(z,R,F){const{connectTo:B,connectionToken:N}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,connectTo:B,connectionToken:N,reconnectionToken:R,reconnectionProtocol:F,remoteSocketFactoryService:z.remoteSocketFactoryService,signService:z.signService,logService:z.logService}}async function v(z,R,F){return f(z,async B=>{const{protocol:N}=await i(B,L.CancellationToken.None);return new H(z,R,F,B.reconnectionToken,N)})}e.$_k=v;async function m(z,R){return f(z,async F=>{const{protocol:B,debugPort:N}=await t(F,R,L.CancellationToken.None);return new Q(z,R,F.reconnectionToken,B,N)})}e.$al=m;async function f(z,R){for(let B=1;;B++)try{const N=(0,C.$kg)(),V=await a(z,N,null);return await R(V)}catch(N){if(B<5)z.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(N);else throw z.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(N),x.triggerPermanentFailure(0,0,g.$1k.isHandled(N)),N}}async function y(z,R,F){const B=await a(z,(0,C.$kg)(),null);return await r(B,{host:R,port:F},L.CancellationToken.None)}e.$bl=y;function I(z){return(0,D.$Ng)(R=>new Promise((F,B)=>{const N=setTimeout(F,z*1e3);R.onCancellationRequested(()=>{clearTimeout(N),F()})}))}var T;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class M{constructor(R,F){this.reconnectionToken=R,this.millisSinceLastIncomingData=F,this.type=0}}e.$cl=M;class U{constructor(R,F,B,N){this.reconnectionToken=R,this.millisSinceLastIncomingData=F,this.durationSeconds=B,this.c=N,this.type=1}skipWait(){this.c.cancel()}}e.$dl=U;class q{constructor(R,F,B){this.reconnectionToken=R,this.millisSinceLastIncomingData=F,this.attempt=B,this.type=2}}e.$el=q;class Y{constructor(R,F,B){this.reconnectionToken=R,this.millisSinceLastIncomingData=F,this.attempt=B,this.type=4}}e.$fl=Y;class K{constructor(R,F,B,N){this.reconnectionToken=R,this.millisSinceLastIncomingData=F,this.attempt=B,this.handled=N,this.type=3}}e.$gl=K;class x extends P.$Rc{static triggerPermanentFailure(R,F,B){this._permanentFailure=!0,this.f=R,this.g=F,this.h=B,this.j.forEach(N=>N.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(R=>R.y())}static debugPauseSocketWriting(){this.j.forEach(R=>R.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(R,F,B,N,V){super(),this.t=R,this.u=F,this.reconnectionToken=B,this.protocol=N,this.w=V,this.m=this.B(new O.$Rd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Y(this.reconnectionToken,0,0)),this.B(N.onSocketClose(G=>{const te=_(this.t,this.reconnectionToken,!0);G?G.type===0?(this.u.logService.info(`${te} received socket close event (hadError: ${G.hadError}).`),G.error&&this.u.logService.error(G.error)):(this.u.logService.info(`${te} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this.u.logService.error(G.event)):this.u.logService.info(`${te} received socket close event.`),this.y()})),this.B(N.onSocketTimeout(G=>{const te=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${te} received socket timeout event (unacknowledgedMsgCount: ${G.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${G.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${G.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,P.$Pc)(()=>{const G=x.j.indexOf(this);G>=0&&x.j.splice(G,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const R=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${R} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const N=B<F.length?F[B]:F[F.length-1];try{if(N>0){const G=I(N);this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,G)),this.u.logService.info(`${R} waiting for ${N} seconds before reconnecting...`);try{await G}catch{}}if(this.n){this.u.logService.error(`${R} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${R} resolving connection...`);const V=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${R} connecting to ${V.connectTo}...`),await this.G(V,l($)),this.u.logService.info(`${R} reconnected!`),this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${R} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${R} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(g.$1k.isTemporarilyNotAvailable(V)){this.u.logService.info(`${R} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this.u.logService.info(`${R} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if((0,j.$3)(V)){this.u.logService.info(`${R} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if(V instanceof g.$1k){this.u.logService.error(`${R} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,g.$1k.isHandled(V));break}this.u.logService.error(`${R} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(R,F,B){this.w?x.triggerPermanentFailure(R,F,B):this.D(R,F,B)}D(R,F,B){this.m.fire(new K(this.reconnectionToken,R,F,B)),J(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$hl=x;class H extends x{constructor(R,F,B,N,V){super(1,R,N,V,!0),this.client=this.B(new k.$Jh(V,{remoteAuthority:F,clientId:B},R.ipcLogger))}async G(R,F){await i(R,F)}}e.$il=H;class Q extends x{constructor(R,F,B,N,V){super(2,R,B,N,!1),this.H=F,this.debugPort=V}async G(R,F){await t(R,this.H,F)}}e.$jl=Q;function J(z){try{z.acceptDisconnect();const R=z.getSocket();z.dispose(),R.dispose()}catch(R){(0,j.$Z)(R)}}function W(z){if(z&&z.type==="error"){const R=new Error(`Connection error: ${z.reason}`);return R.code="VSCODE_CONNECTION_ERROR",R}return null}function ee(z,R){for(;z.length<R;)z+=" ";return z}function ne(z,R){return`[remote-connection][${ee(w(z),13)}][${R.substr(0,5)}\u2026]`}function _(z,R,F){return`${ne(z,R)}[${F?"reconnect":"initial"}]`}function se(z,R){return`${_(R,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.connectTo}]`}function X(z){return`${Date.now()-z} ms`}}),define(ae[104],ce([0,1,2,4]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=void 0,e.$8k=(0,A.$Xh)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(O,P){return this.a[O]??=[],this.a[O].push(P),(0,D.$Pc)(()=>{const S=this.a[O]?.indexOf(P);typeof S=="number"&&S>=0&&this.a[O]?.splice(S,1)})}b(O){return(this.a[O.type]||[]).find(S=>S.supports(O))}connect(O,P,S,b){const C=this.b(O);if(!C)throw new Error(`No socket factory found for ${O}`);return C.connect(O,P,S,b)}}e.$9k=L}),define(ae[215],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X0b=e.$W0b=void 0,e.$W0b=(0,D.$Xh)("sharedProcessTunnelService"),e.$X0b="sharedProcessTunnel"}),define(ae[105],ce([0,1,4,163]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$80b=e.$70b=e.$60b=e.$50b=e.$40b=e.TunnelStates=e.$30b=e.$20b=void 0,e.$20b=(0,D.$Xh)("IRemoteTunnelService"),e.$30b={active:!1};var L;(function(j){j.disconnected=O=>({type:"disconnected",onTokenFailed:O}),j.connected=(O,P)=>({type:"connected",info:O,serviceInstallFailed:P}),j.connecting=O=>({type:"connecting",progress:O}),j.uninitialized={type:"uninitialized"}})(L||(e.TunnelStates=L={})),e.$40b="remote.tunnels.access",e.$50b=e.$40b+".hostNameOverride",e.$60b=e.$40b+".preventSleep",e.$70b="remoteTunnelService",e.$80b=(0,A.localize)(0,null)}),define(ae[58],ce([0,1,15,7,2,165,50,4,8,41]),function(ie,e,D,A,L,j,O,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0,e.$1o=(0,P.$Xh)("requestService");class C{constructor(E){this.b=E}toJSON(){if(!this.a){const E=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?E[s]="*****":E[s]=this.b[s];this.a=E}return this.a}}class k extends L.$Rc{constructor(E){super(),this.b=0,this.a=E.createLogger("network",{name:(0,j.localize)(0,null),when:S.$wj.isEqualTo((0,S.$uj)(S.LogLevel.Trace)).serialize()})}async c(E,s,o){const n=`${E} #${++this.b}: ${s.url}`;this.a.trace(`${n} - begin`,s.type,new C(s.headers??{}));try{const i=await o();return this.a.trace(`${n} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,s.type,(0,A.$9)(i)),i}}}e.$2o=k;function g(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.$3o=g;function c(d){return d.res.statusCode===204}e.$4o=c;async function $(d){return c(d)?null:(await(0,D.$re)(d.stream)).toString()}e.$5o=$;async function p(d){if(!g(d))throw new Error("Server returned "+d.res.statusCode);return $(d)}e.$6o=p;async function w(d){if(!g(d))throw new Error("Server returned "+d.res.statusCode);if(c(d))return null;const s=(await(0,D.$re)(d.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$7o=w;function l(d){h(d)}e.$8o=l;let u;function h(d){const E=b.$on.as(O.$tn.Configuration),s=u;u={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},E.updateConfigurations({add:[u],remove:s?[s]:[]})}h(1)}),define(ae[216],ce([0,1,26,23,11,58]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bO=void 0;let O=class{constructor(S,b){this.a=S,this.b=b}async download(S,b,C=D.CancellationToken.None){if(S.scheme===A.Schemas.file||S.scheme===A.Schemas.vscodeRemote){await this.b.copy(S,b);return}const k={type:"GET",url:S.toString(!0)},g=await this.a.request(k,C);if(g.res.statusCode===200)await this.b.writeFile(b,g.stream);else{const c=await(0,j.$6o)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${c}`)}}};e.$bO=O,e.$bO=O=pe([Z(0,j.$1o),Z(1,L.$gk)],O)}),define(ae[217],ce([0,1,15,26]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=void 0;class L{constructor(P){this.a=P}listen(P,S){throw new Error("Invalid listen")}call(P,S,b,C=A.CancellationToken.None){switch(S){case"request":return this.a.request(b[0],C).then(async({res:k,stream:g})=>{const c=await(0,D.$re)(g);return[{statusCode:k.statusCode,headers:k.headers},c]});case"resolveProxy":return this.a.resolveProxy(b[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$4q=L;class j{constructor(P){this.a=P}async request(P,S){const[b,C]=await this.a.call("request",[P],S);return{res:b,stream:(0,D.$te)(C)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$5q=j}),define(ae[218],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p9b=e.$o9b=e.$n9b=void 0,e.$n9b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$o9b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$p9b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[219],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g5b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const j=await this.c();if(j){const O=String(D.a++);return this.b.set(O,j),{id:O,data:j.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,j){if(!L.id)return!0;const O=this.b.get(L.id);if(!O)return!1;this.b.delete(L.id);try{return O.validate(j)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$g5b=D}),define(ae[106],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=void 0,e.$0k="signService",e.$$k=(0,D.$Xh)(e.$0k)}),define(ae[220],ce([0,1,219]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d0b=void 0;class A extends D.$g5b{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(O=>new O.signer().sign(j))}h(){return new Promise((j,O)=>ie(["vsda"],j,O))}}e.$d0b=A}),define(ae[77],ce([0,1,3,2]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rEb=e.$qEb=e.$pEb=e.$oEb=void 0;class L extends A.$Rc{constructor(k,g,c){super(),this.a=k,this.b=g,this.c=c}async getItems(){const k={profile:this.b,workspace:this.c},g=await this.a.call("getItems",k);return new Map(g)}updateItems(k){const g={profile:this.b,workspace:this.c};return k.insert&&(g.insert=Array.from(k.insert.entries())),k.delete&&(g.delete=Array.from(k.delete.values())),this.a.call("updateItems",g)}optimize(){const k={profile:this.b,workspace:this.c};return this.a.call("optimize",k)}}class j extends L{constructor(k,g){super(k,g,void 0),this.f=this.B(new D.$Rd),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(k=>this.h(k)))}h(k){(Array.isArray(k.changed)||Array.isArray(k.deleted))&&this.f.fire({changed:k.changed?new Map(k.changed):void 0,deleted:k.deleted?new Set(k.deleted):void 0})}}class O extends j{constructor(k){super(k,void 0)}async close(){this.dispose()}}e.$oEb=O;class P extends j{constructor(k,g){super(k,g)}async close(){this.dispose()}}e.$pEb=P;class S extends L{constructor(k,g){super(k,void 0,g),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.$qEb=S;class b{constructor(k){this.a=k}isUsed(k){const g={payload:k,profile:void 0,workspace:void 0};return this.a.call("isUsed",g)}}e.$rEb=b}),define(ae[107],ce([0,1,5,37,32]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=void 0;function j(S){if(D.$u===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function O(S,b,C,k,g,c,$,p,w){const l=Object.create(null);l["common.machineId"]=c,l["common.sqmId"]=$,l.sessionID=(0,L.$kg)()+Date.now(),l.commitHash=k,l.version=g,l["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,D.$h)(D.$u),l["common.nodePlatform"]=A.$cc,l["common.nodeArch"]=C,l["common.product"]=w||"desktop",p&&(l["common.msftInternal"]=p);let u=0;const h=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),D.$l&&(l["common.snap"]="true");const d=j(b);return d&&(l["common.platformDetail"]=d),l}e.$po=O;function P(S){const b=A.env.USERDNSDOMAIN;if(!b)return!1;const C=b.toLowerCase();return S.some(k=>C===k)}e.$qo=P}),define(ae[22],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=void 0,e.$kl=(0,D.$Xh)("telemetryService"),e.$ll=(0,D.$Xh)("customEndpointTelemetryService"),e.$ml="telemetry.currentSessionDate",e.$nl="telemetry.firstSessionDate",e.$ol="telemetry.lastSessionDate",e.$pl="telemetry.machineId",e.$ql="telemetry.sqmId",e.$rl="telemetry",e.$sl="telemetry.telemetryLevel",e.$tl="telemetry.enableCrashReporter",e.$ul="telemetry.enableTelemetry";var A;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var L;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ae[221],ce([0,1,36,6,35,23,16,5,10,142,31,145,95,11,25,22]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=e.$Nr=e.$Mr=e.$Lr=void 0;const w=new Map;async function l(s,o){const n=`${s}::${o.join(":")}`,i=w.get(n);if(i)return i;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,v=2e4;function m(y,I,T,M){const U=I.substring(y.length+1);return A.Promises.withAsyncBody(async q=>{let Y;try{Y=await C.Promises.readdir(I,{withFileTypes:!0})}catch{q();return}if(M.count>=v){M.count+=Y.length,M.maxReached=!0,q();return}let K=Y.length;if(K===0){q();return}let x=Y;M.count+Y.length>v&&(M.maxReached=!0,K=v-M.count,x=Y.slice(0,K)),M.count+=Y.length;for(const H of x)if(H.isDirectory()){if(T.includes(H.name)||await m(y,(0,O.$ic)(I,H.name),T,M),--K===0){q();return}}else{const Q=H.name.lastIndexOf(".");if(Q>=0){const J=H.name.substring(Q+1);J&&r.set(J,(r.get(J)??0)+1)}for(const J of t)J.relativePathPattern?.test(U)!==!1&&J.filePattern.test(H.name)&&a.set(J.tag,(a.get(J.tag)??0)+1);if(--K===0){q();return}}})}const f=A.Promises.withAsyncBody(async y=>{const I={count:0,maxReached:!1};await m(s,s,o,I);const T=await d(s);y({configFiles:u(a),fileTypes:u(r),fileCount:I.count,maxFilesReached:I.maxReached,launchConfigFiles:T})});return w.set(n,f),f}e.$Lr=l;function u(s){return Array.from(s.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function h(){const s={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/c.$Ok.GB).toFixed(2)}GB (${(D.freemem()/c.$Ok.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.$Zm.value()*100)}%`},o=D.cpus();return o&&o.length>0&&(s.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),s}e.$Mr=h;async function d(s){try{const o=new Map,n=(0,O.$ic)(s,".vscode","launch.json"),i=await C.Promises.readFile(n),t=[],r=(0,L.$5m)(i.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,L.$bn)(r)==="object"&&r.configurations)for(const a of r.configurations){const v=a.type;v&&(o.has(v)?o.set(v,o.get(v)+1):o.set(v,1))}return u(o)}catch{return[]}}e.$Nr=d;let E=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const i=D.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(D.totalmem()/c.$Ok.GB).toFixed(2)}GB (${(D.freemem()/c.$Ok.GB).toFixed(2)}GB free)`),P.$i||n.push(`Load (avg):       ${D.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(b.$Zm.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,k.$Kr)(o.mainPID),this.k(o)]).then(async i=>{let[t,r]=i,a=this.m(o,t);return n.forEach(v=>{if((0,g.$zm)(v))a+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(a+=`

Remote: ${v.hostName}`,v.processes&&(a+=`
${this.m(o,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const m of Object.keys(v.workspaceMetadata)){const f=v.workspaceMetadata[m];let y=`${f.fileCount} files`;f.maxFilesReached&&(y=`more than ${y}`),r+=`|    Folder (${m}): ${y}`,r+=this.h(f)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:i,vmHint:t,os:r,cpus:a}=h(),v={os:r,memory:i,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return P.$i||(v.load=`${D.loadavg().map(m=>Math.round(m)).join(", ")}`),P.$k&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(o,n){const i=[];return(0,k.$Kr)(o.mainPID).then(async t=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),n.forEach(r=>{if((0,g.$zm)(r))i.push(`
${r.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${r.hostName}`),i.push(this.f(r.machineInfo)),r.processes&&i.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[a];let m=`${v.fileCount} files`;v.maxFilesReached&&(m=`more than ${m}`),i.push(`Folder (${a}): ${m}`),i.push(this.h(v))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const n=[];let t=0;const r=(f,y)=>{const I=` ${f}(${y})`;t+I.length>60?(n.push(a),a="|                 ",t=a.length):t+=I.length,a+=I};let a="|      File types:";const v=10,m=o.fileTypes.length>v?v:o.fileTypes.length;for(let f=0;f<m;f++){const y=o.fileTypes[f];r(y.name,y.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(f=>{r(f.name,f.count)}),n.push(a)),o.launchConfigFiles.length>0){let f="|      Launch Configs:";o.launchConfigFiles.forEach(y=>{const I=y.count>1?` ${y.name}(${y.count})`:` ${y.name}`;f+=I}),n.push(f)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const n=[],i=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=S.URI.revive(r);if(a.scheme===j.Schemas.file){const v=a.fsPath;i.push(l(v,["node_modules",".git"]).then(m=>{let f=`${m.fileCount} files`;m.maxFilesReached&&(f=`more than ${f}`),n.push(`|    Folder (${(0,O.$mc)(v)}): ${f}`),n.push(this.h(m))}).catch(m=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${m.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,n){const i=new Map;o.windows.forEach(r=>i.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>i.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,i,t,n,0),t.join(`
`)}n(o,n,i,t,r){const a=r===0;let v;a?v=t.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const m=process.platform==="win32"?t.mem:D.totalmem()*(t.mem/100);i.push(`${t.load.toFixed(0).padStart(5," ")}	${(m/c.$Ok.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(f=>this.n(o,n,i,f,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:i}of o.folders){const t=S.URI.revive(i);if(t.scheme!==j.Schemas.file)continue;const r=t.fsPath;try{(await l(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const i=S.URI.revive(n);if(i.scheme!==j.Schemas.file)continue;const t=i.fsPath;try{const r=await l(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$Or=E,e.$Or=E=pe([Z(0,p.$kl),Z(1,$.$xj)],E)}),define(ae[108],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t9b=e.$s9b=void 0;class D{constructor(j){this.b=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,{eventName:P,data:S}){return this.b.forEach(b=>b.log(P,S)),Promise.resolve(null)}}e.$s9b=D;class A{constructor(j){this.b=j}log(j,O){return this.b.call("log",{eventName:j,data:O}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$t9b=A}),define(ae[45],ce([0,1,30,12,3,20,76,107,22]),function(ie,e,D,A,L,j,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=void 0;class b{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$ro=b;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$so=C,e.$to=new C;class k{async publicLog(t,r,a){}async publicLogError(t,r,a){}}e.$uo=k,e.$vo="telemetry",e.$wo="extensionTelemetryLog",e.$xo={log:()=>null,flush:()=>Promise.resolve(null)};function g(i,t){return L.Event.debounce(t.onDidChangeConfiguration,(a,v)=>{const m=a?new Set([...a.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:m}},1e3,!0)(a=>{a.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,j.$ui)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.$yo=g;function c(i,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!i.enableTelemetry)}e.$zo=c;function $(i,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$Ao=$;function p(i){const t=i.getValue(S.$sl),r=i.getValue(S.$tl);if(i.getValue(S.$ul)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Bo=p;function w(i){const t={},r={},a={};h(i,a);for(let v in a){v=v.length>150?v.substr(v.length-149):v;const m=a[v];typeof m=="number"?r[v]=m:typeof m=="boolean"?r[v]=m?1:0:typeof m=="string"?(m.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${m.length}`),t[v]=m.substring(0,8191)):typeof m<"u"&&m!==null&&(t[v]=m)}return{properties:t,measurements:r}}e.$Co=w;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(i){if(!i)return"none";const t=(0,O.$4k)(i);return l.has(t)?t:"other"}e.$Do=u;function h(i,t,r=0,a){if(i)for(const v of Object.getOwnPropertyNames(i)){const m=i[v],f=a?a+v:v;Array.isArray(m)?t[f]=(0,D.$hn)(m):m instanceof Date?t[f]=m.toISOString():(0,A.$Ef)(m)?r<2?h(m,t,r+1,f+"."):t[f]=(0,D.$hn)(m):t[f]=m}}function d(i,t){const r=i.msftInternalDomains||[],a=t.getValue("telemetry.internalTesting");return(0,P.$qo)(r)||a}e.$Eo=d;function E(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Fo=E;function s(i,t){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const a=[];for(const y of t)for(;;){const I=y.exec(i);if(!I)break;a.push([I.index,y.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(r="";;){const y=m.exec(i);if(!y)break;const I=a.some(([T,M])=>y.index<M&&T<m.lastIndex);!v.test(y[0])&&!I&&(r+=i.substring(f,y.index)+"<REDACTED: user-file-path>",f=m.lastIndex)}return f<i.length&&(r+=i.substr(f)),r}function o(i){if(!i)return i;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function n(i,t){return(0,D.$en)(i,r=>{if(r instanceof b||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=s(a,t);for(const v of t)a=a.replace(v,"");return a=o(a),a}})}e.$Go=n}),define(ae[33],ce([0,1,27,29,44,5,10,7,37,45]),function(ie,e,D,A,L,j,O,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0;function C(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,D.$1e)(n.id,i.id)===0}e.$Ho=C;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(i){const t=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new g(i.identifier,t,r)}static parse(i){const t=k.exec(i);return t&&t[1]&&t[2]?new g({id:t[1]},t[2],t[4]||void 0):null}constructor(i,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof g?C(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Io=g;const c=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(n){const i=c.exec(n);return i&&i[1]?[w(i[1]),i[2]]:[w(n),void 0]}e.$Jo=$;function p(n,i){return`${n}.${i}`}e.$Ko=p;function w(n){return n.toLowerCase()}e.$Lo=w;function l(n,i){return w(p(n??L.$0l,i))}e.$Mo=l;function u(n,i){const t=[],r=a=>{for(const v of t)if(v.some(m=>C(i(m),i(a))))return v;return null};for(const a of n){const v=r(a);v?v.push(a):t.push([a])}return t}e.$No=u;function h(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$Oo=h;function d(n){return{id:new b.$ro(n.identifier.id),name:new b.$ro(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Po=d,e.$Qo=new L.$bm("pprice.better-merge");function E(n,i){const t=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(v=>!C(v.identifier,{id:a}))){const v=n.filter(m=>C(m.identifier,{id:a}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$Ro=E;async function s(n,i){if(!j.$k)return!1;let t;try{t=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){i.debug("Error while getting the os-release file.",(0,P.$9)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,i){const t=await s(n,i),r=(0,A.$bo)(t?"alpine":j.$u,S.$dc);return i.debug("ComputeTargetPlatform:",r),r}e.$So=o}),define(ae[222],ce([0,1,18,2,19,10,11,25,6,3,16,5,37,33]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o7b=e.$n7b=void 0;let $=class extends A.$Rc{constructor(h,d){super(),this.b=h,this.c=d,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,E])=>this.a.set(E.configPath,E))}getConfigBasedTips(h){return this.f(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(h){const d=[];for(const[E,s]of this.a)if(!(s.configScheme&&s.configScheme!==h.scheme))try{const o=(await this.b.readFile((0,L.$Bg)(h,E))).value.toString();for(const[n,i]of Object.entries(s.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(o))&&d.push({extensionId:n,extensionName:i.name,configName:s.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return d}};e.$n7b=$,e.$n7b=$=pe([Z(0,O.$gk),Z(1,P.$xj)],$);const p="extensionTips/promptedExecutableTips",w="extensionTips/lastPromptedMediumImpExeTime";class l extends ${constructor(h,d,E,s,o,n,i,t){super(i,t),this.r=h,this.s=d,this.t=E,this.u=s,this.w=o,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const v=[],m=[],f=[];Object.entries(a.recommendations).forEach(([y,I])=>{I.important?a.important?v.push({extensionId:y,extensionName:I.name,isExtensionPack:!!I.isExtensionPack}):m.push({extensionId:y,extensionName:I.name,isExtensionPack:!!I.isExtensionPack}):f.push({extensionId:y,extensionName:I.name,isExtensionPack:!!I.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v}),m.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:m}),f.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:f})}),(0,S.$2g)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const h=await this.O(this.g),d=await this.O(this.h);return[...h,...d]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const h=await this.O(this.g),d=await this.O(this.h),E=await this.u.getInstalled();this.m=this.D(h,E),this.n=this.D(d,E)}D(h,d){const E=new Map;h.forEach(t=>E.set(t.extensionId.toLowerCase(),t));const{installed:s,uninstalled:o}=this.N([...E.keys()],d);for(const t of s){const r=E.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=E.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),i=new Map;for(const t of o){const r=E.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=i.get(r.exeName);a||(a=[],i.set(r.exeName,a)),a.push(r)}}return i}F(){if(this.m.size===0)return;const[h,d]=[...this.m.entries()][0];this.H(d).then(E=>{switch(E){case"reacted":this.M(d[0].exeName,d);break;case"ignored":this.m.delete(h);break;case"incompatibleWindow":{const s=b.Event.once(b.Event.latch(b.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.F()));break}case"toomany":{const s=this.B(new A.$Sc);s.value=(0,S.$2g)(()=>{s.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const h=this.I(),d=Date.now()-h,E=7*24*60*60*1e3;if(d<E){const n=this.B(new A.$Sc);n.value=(0,S.$2g)(()=>{n.dispose(),this.G()},E-d);return}const[s,o]=[...this.n.entries()][0];this.H(o).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(s),this.M(o[0].exeName,o);const i=this.B(new A.$Sc);i.value=(0,S.$2g)(()=>{i.dispose(),this.G()},E);break}case"ignored":this.n.delete(s),this.G();break;case"incompatibleWindow":{const i=b.Event.once(b.Event.latch(b.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.G()));break}case"toomany":{const i=this.B(new A.$Sc);i.value=(0,S.$2g)(()=>{i.dispose(),this.G()},60*60*1e3);break}}})}async H(h){const d=await this.u.getInstalled(1),E=h.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(o=>d.every(n=>!(0,c.$Ho)(n.identifier,{id:o})))).map(({extensionId:s})=>s.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:E,source:3,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}I(){let h=this.w.getNumber(w,-1);return h||(h=Date.now(),this.J(h)),h}J(h){this.w.store(w,h,-1,1)}L(){return JSON.parse(this.w.get(p,-1,"{}"))}M(h,d){const E=this.L();E[h]=d.map(({extensionId:s})=>s.toLowerCase()),this.w.store(p,JSON.stringify(E),-1,0)}N(h,d){const E=[],s=[],o=d.reduce((n,i)=>(n.add(i.identifier.id.toLowerCase()),n),new Set);return h.forEach(n=>{o.has(n.toLowerCase())?E.push(n):s.push(n)}),{installed:E,uninstalled:s}}async O(h){const d=[],E=new Map;for(const s of h.keys()){const o=h.get(s);if(!o||!(0,D.$Kb)(o.recommendations))continue;const n=[];k.$i?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>g.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>g.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>g.env.ProgramFiles).replace("%APPDATA%",()=>g.env.APPDATA).replace("%WINDIR%",()=>g.env.WINDIR)):(n.push((0,C.$ic)("/usr/local/bin",s)),n.push((0,C.$ic)("/usr/bin",s)),n.push((0,C.$ic)(this.r.fsPath,s)));for(const i of n){let t=E.get(i);if(t===void 0&&(t=await this.b.exists(j.URI.file(i)),E.set(i,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:v,whenNotInstalled:m}of o.recommendations)d.push({extensionId:r,extensionName:a,isExtensionPack:v,exeName:s,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:m})}}return d}}e.$o7b=l}),define(ae[223],ce([0,1,26,33]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LXb=void 0;async function L(j,O,P,S,b){try{const C=await j.getExtensionsControlManifest();if(!C.deprecated)return;const k=await j.getInstalled(1);for(const[g,c]of Object.entries(C.deprecated)){if(!c?.extension)continue;const{id:$,autoMigrate:p,preRelease:w}=c.extension;if(!p)continue;const l=k.find(h=>(0,A.$Ho)(h.identifier,{id:g}));if(!l)continue;const u=(await O.getExtensions([{id:$,preRelease:w}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!u){b.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${$}' extension is not found`);continue}try{b.info(`Migrating '${l.identifier.id}' extension to '${$}' extension...`);const h=!S.getDisabledExtensions().some(E=>(0,A.$Ho)(E,l.identifier));await j.uninstall(l),b.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let d=k.find(E=>(0,A.$Ho)(E.identifier,{id:$}));(!d||!d.isPreReleaseVersion&&h)&&(d=await j.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),b.info(`Installed the pre-release extension '${d.identifier.id}'`),h||(await S.disableExtension(d.identifier),b.info(`Disabled the pre-release extension '${d.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),p.storage&&(P.addToMigrationList((0,A.$Ko)(l.manifest.publisher,l.manifest.name),(0,A.$Ko)(d.manifest.publisher,d.manifest.name)),b.info("Added pre-release extension to the storage migration list"))),b.info(`Migrated '${l.identifier.id}' extension to '${$}' extension.`)}catch(h){b.error(h)}}}catch(C){b.error(C)}}e.$LXb=L}),define(ae[224],ce([0,1,6,7,2,23,19,54,12,32,31,69,20,14,29,33,97,11,8]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l,u){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;let d=class extends L.$Rc{static{h=this}static{this.c=".sigzip"}constructor(s,o,n,i,t,r){super(),this.h=o,this.j=n,this.m=i,this.n=t,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,n){await this.g;const i=(0,O.$Bg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,o))}catch(r){throw new $.$go(r.message,$.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(s)){const r=await this.u(s);try{t=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===u.LogLevel.Trace)}catch(a){const v=a;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${v.output}`),t===$.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===$.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new $.$go(k.$sp,$.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${s.identifier.id}`),{location:i,verificationStatus:t}}t(s){if(!s.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,S.$If)(o)?o:!0}async u(s){await this.g;const o=(0,O.$Bg)(this.extensionsDownloadDir,`${this.z(s)}${h.c}`);return await this.w(s,o,n=>this.j.downloadSignatureArchive(s,n)),o}async w(s,o,n){if(await this.h.exists(o))return;if(o.scheme!==j.Schemas.file){await n(o);return}const i=(0,O.$Bg)(this.extensionsDownloadDir,`.${(0,b.$kg)()}`);await this.h.exists(i)||await n(i);try{await C.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(i)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,A.$9)(t)}. Deleted the file from downloaded location`,i.path),t}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],n=[],i=[];for(const a of s.children)if(a.name.endsWith(h.c))i.push(a.resource);else{const v=p.$Io.parse(a.name);v&&n.push([v,a])}const t=(0,p.$No)(n,([a])=>a),r=[];for(const a of t)a.sort((v,m)=>P.rcompare(v[0].version,m[0].version)),o.push(...a.slice(1).map(v=>v[1].resource)),r.push(a[0][1]);r.sort((a,v)=>a.mtime-v.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...i),await D.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(s){this.r.error(s)}}z(s){return this.f?p.$Io.create(s).toString().toLowerCase():(0,b.$kg)()}};e.$Lp=d,e.$Lp=d=h=pe([Z(0,c.$6h),Z(1,l.$gk),Z(2,$.$fo),Z(3,g.$ri),Z(4,w.$mp),Z(5,u.$fj)],d)}),define(ae[225],ce([0,1,3,2,34,33,44]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;class P extends A.$Rc{constructor(b,C,k,g,c,$,p){super(),this.f=b,this.g=C,this.h=k,this.j=g,this.m=c,this.n=$,this.r=p,this.a=this.B(new D.$Rd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.$1c),this.s().then(null,w=>p.error(w))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(b=>this.u(b.added))),this.B(this.j.onAddExtensions(b=>this.w(b))),this.B(this.j.onDidAddExtensions(b=>this.y(b))),this.B(this.j.onRemoveExtensions(b=>this.z(b))),this.B(this.j.onDidRemoveExtensions(b=>this.C(b))),this.B(this.n.onDidFilesChange(b=>this.D(b)))}async u(b){try{b.length&&await Promise.all(b.map(C=>(this.c.set(C.id,(0,A.$Oc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(b){for(const C of b.extensions)this.I(this.L(C.identifier,C.version),b.profileLocation)}async y(b){for(const C of b.extensions){const k=this.L(C.identifier,C.version);b.error?this.J(k,b.profileLocation):this.I(k,b.profileLocation)}}async z(b){for(const C of b.extensions)this.J(this.L(C.identifier,C.version),b.profileLocation)}async C(b){const C=[],k=[];for(const g of b.extensions){const c=this.L(g.identifier,g.version);b.error?this.I(c,b.profileLocation):(this.J(c,b.profileLocation),this.b.has(c)||(this.r.debug("Extension is removed from all profiles",g.identifier.id,g.version),k.push(this.f.scanInstalledExtensionAtLocation(g.location).then($=>{$?C.push($):this.r.info("Extension not found at the location",g.location.toString())},$=>this.r.error($)))))}try{await Promise.all(k),C.length&&await this.H(C)}catch(g){this.r.error(g)}}D(b){for(const C of this.h.profiles)b.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(b){const C=[],k=[],g=await this.j.scanProfileExtensions(b),c=new Set,$=new Set;for(const[p,w]of this.b)w.has(b)&&$.add(p);for(const p of g){const w=this.L(p.identifier,p.version);c.add(w),$.has(w)||(C.push(p.identifier),this.I(w,b))}for(const p of $)if(!c.has(p)){const w=this.M(p);w&&(k.push(w.identifier),this.J(p,b))}(C.length||k.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:b}:void 0,removed:k.length?{extensions:k,profileLocation:b}:void 0})}async G(b){const C=await this.j.scanProfileExtensions(b);for(const k of C)this.I(this.L(k.identifier,k.version),b)}async H(b){b||(b=(await this.f.scanAllUserInstalledExtensions()).filter(k=>!this.b.has(this.L(k.identifier,k.manifest.version)))),b.length&&await this.f.markAsUninstalled(...b)}I(b,C){let k=this.b.get(b);k||this.b.set(b,k=new L.$Ac(g=>this.m.extUri.getComparisonKey(g))),k.add(C)}J(b,C){const k=this.b.get(b);k&&k.delete(C),k?.size||this.b.delete(b)}L(b,C){return`${O.$bm.toKey(b.id)}@${C}`}M(b){const[C,k]=(0,j.$Jo)(b);return k?{identifier:{id:C},version:k}:void 0}}e.$Pp=P}),define(ae[226],ce([0,1,43,45]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=void 0;async function L(j,O,P,S,b,C,k){const g={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${O.nameShort})`};if((0,A.$zo)(O,P)&&(0,A.$Bo)(S)===3){const c=await(0,D.$hp)(P,b,C);g["X-Market-User-Id"]=c,g["VSCode-SessionId"]=k.machineId||c}return g}e.$ip=L}),define(ae[227],ce([0,1,72,18,6,2,23,16,31,14,29,33,8,74,10]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;let p=class extends c.$2q{constructor(h,d,E,s){super(E),this.h=h,this.j=s,this.g=this.B(new w(d,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(h,d){const s=(await this.g.getLanguagePacks())[d];if(!s){this.j.warn(`No language pack found for ${d}`);return}const o=s.translations[h];return o?$.URI.file(o):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),d=Object.keys(h).map(E=>{const s=h[E];return{...this.f(E,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return d.push(this.f("en","English")),d.sort((E,s)=>E.label.localeCompare(s.label)),d}async m(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",h.identifier.id),await this.update())}async n(h){const d=await this.g.getLanguagePacks();Object.keys(d).some(E=>d[E]&&d[E].extensions.some(s=>(0,k.$Ho)(s.extensionIdentifier,h.identifier)))&&(this.j.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,d]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),E=await this.g.update(d);return!(0,A.$tb)(Object.keys(h),Object.keys(E))}};e.$3q=p,e.$3q=p=pe([Z(0,C.$ho),Z(1,b.$6h),Z(2,C.$fo),Z(3,g.$fj)],p);let w=class extends j.$Rc{constructor(h,d){super(),this.j=d,this.c={},this.f=(0,P.$ic)(h.userDataPath,"languagepacks.json"),this.g=new L.$7g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.s(d=>{Object.keys(d).forEach(E=>delete d[E]),this.m(d,...h)}).then(()=>this.c)}m(h,...d){for(const E of d)E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&this.n(h,E);Object.keys(h).forEach(E=>this.r(h[E]))}n(h,d){const E=d.identifier,s=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const o of s)if(d.location.scheme===O.Schemas.file&&l(o)){let n=h[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},h[o.languageId]=n);const i=n.extensions.filter(t=>(0,k.$Ho)(t.extensionIdentifier,E))[0];i?i.version=d.manifest.version:n.extensions.push({extensionIdentifier:E,version:d.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,P.$ic)(d.location.fsPath,t.path)}}r(h){if(h){const d=(0,D.createHash)("md5");for(const E of h.extensions)d.update(E.extensionIdentifier.uuid||E.extensionIdentifier.id).update(E.version);h.hash=d.digest("hex")}}s(h=()=>null){return this.g.queue(()=>{let d=null;return S.Promises.readFile(this.f,"utf8").then(void 0,E=>E.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(E)).then(E=>{try{return JSON.parse(E)}catch{return{}}}).then(E=>(d=h(E),E)).then(E=>{for(const o of Object.keys(E))E[o]||delete E[o];this.c=E,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),S.Promises.writeFile(this.f,s)}).then(()=>d,E=>this.j.error(E))})}};w=pe([Z(0,b.$6h),Z(1,g.$fj)],w);function l(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const h of u.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(ae[228],ce([0,1,141,7,30,45]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",P="https://mobile.events.data.microsoft.com/ping";async function S(C,k,g){const c=await(0,D.$QC)("@microsoft/1ds-core-js","dist/ms.core.js"),$=await(0,D.$QC)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new c.AppInsightsCore,w=new $.PostChannel,l={instrumentationKey:C,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(g){l.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:g};l.extensionConfig[w.identifier]=u}return p.initialize(l,[]),p.addTelemetryInitializer(u=>{k&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),p}class b{constructor(k,g,c,$,p){this.e=k,this.f=g,this.g=c,this.h=p,this.c=O,this.d=P,this.g||(this.g={}),typeof $=="function"?this.a=$():this.a=$,this.b=null}i(k){if(this.a){if(typeof this.a!="string"){k(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(g=>{k(g)},g=>{(0,A.$Z)(g),console.error(g)})}}log(k,g){if(!this.a)return;g=(0,L.$fn)(g,this.g),g=(0,j.$Co)(g);const c=this.f+"/"+k;try{this.i($=>{$.pluginVersionString=g?.properties.version??"Unknown",$.track({name:c,baseData:{name:c,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this.a?new Promise(k=>{this.i(g=>{g.unload(!0,()=>{this.a=void 0,k(void 0)})})}):Promise.resolve(void 0)}}e.$LN=b}),define(ae[109],ce([0,1,2,166,14,8,25,45]),function(ie,e,D,A,L,j,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N6b=void 0;let S=class extends D.$Rc{constructor(C,k,g,c,$=""){super(),this.b=$;const p=k.getLogger(P.$vo);if(p)this.a=this.B(p);else{const l=(0,P.$Ao)(c,g)?" (Not Sent)":"",u=()=>(0,P.$zo)(c,g)&&C.getLevel()===j.LogLevel.Trace;this.a=this.B(k.createLogger(P.$vo,{name:(0,A.localize)(0,null,l),hidden:!u()})),this.B(C.onDidChangeLogLevel(()=>k.setVisibility(P.$vo,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,k){this.a.trace(`${this.b}telemetry/${C}`,(0,P.$Co)(k))}};e.$N6b=S,e.$N6b=S=pe([Z(0,j.$fj),Z(1,j.$gj),Z(2,L.$5h),Z(3,O.$xj)],S)}),define(ae[110],ce([0,1,2,30,5,27,167,20,50,102,25,41,22,45]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;let $=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,u,h){this.k=u,this.l=h,this.d={},this.i=new D.$Qc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,j.$Je)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$Je)(d.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(d=>{(d.affectsConfiguration(g.$sl)||d.affectsConfiguration(g.$ul)||d.affectsConfiguration(g.$tl))&&this.m()}))}setExperimentProperty(l,u){this.d[l]=u}m(){let l=(0,c.$Bo)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const h=u.usage?3:u.error?2:0;l=Math.min(l,h)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,u,h){this.g<u||(h=(0,A.$fn)(h,this.d),h=(0,c.$Go)(h,this.j),h=(0,A.$fn)(h,this.c),this.b.forEach(d=>d.log(l,h)))}publicLog(l,u){this.n(l,3,u)}publicLog2(l,u){this.publicLog(l,u)}publicLogError(l,u){this.h&&this.n(l,2,u)}publicLogError2(l,u){this.publicLogError(l,u)}};e.$9q=$,e.$9q=$=pe([Z(1,P.$ri),Z(2,C.$xj)],$);function p(){const w=(0,O.localize)(0,null,b.default.nameLong),l=b.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=L.$o?"":(0,O.localize)(3,null),h=(0,O.localize)(4,null),d=(0,O.localize)(5,null),E=(0,O.localize)(6,null),s=(0,O.localize)(7,null),o=`
|       | ${h} | ${d} | ${E} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${w} ${l} ${u}

&nbsp;

${s}
${o}

&nbsp;

${n}
`}k.$on.as(S.$tn.Configuration).registerConfiguration({id:g.$rl,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[g.$sl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),k.$on.as(S.$tn.Configuration).registerConfiguration({id:g.$rl,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[g.$ul]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,O.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,O.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${g.$sl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[229],ce([0,1,15,26,271,228]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=void 0;async function O(C,k){const g=await k.request(C,A.CancellationToken.None),c=(await(0,D.$re)(g.stream)).toString(),$=g.res.statusCode??200;return{headers:g.res.headers,statusCode:$,responseData:c}}async function P(C){const k={method:C.type,headers:C.headers};return new Promise((c,$)=>{const p=L.request(C.url??"",k,w=>{w.on("data",function(l){c({headers:w.headers,statusCode:w.statusCode??200,responseData:l.toString()})}),w.on("error",function(l){$(l)})});p.write(C.data,w=>{w&&$(w)}),p.end()})}async function S(C,k,g){const c=typeof k.data=="string"?k.data:new TextDecoder().decode(k.data),$={type:"POST",headers:{...k.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(k.data).toString()},url:k.urlString,data:c};try{const p=C?await O($,C):await P($);g(p.statusCode,p.headers,p.responseData)}catch{g(0,{})}}class b extends j.$LN{constructor(k,g,c,$,p){const w={sendPOST:(l,u)=>{S(k,l,u)}};super(g,c,$,p,w)}}e.$MN=b}),define(ae[230],ce([0,1,23,93,20,14,8,25,22,108,109,110]),function(ie,e,D,A,L,j,O,P,S,b,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L0b=void 0;let g=class{constructor($,p,w,l,u,h){this.b=$,this.c=p,this.d=w,this.e=l,this.f=u,this.g=h,this.a=new Map}h($){if(!this.a.has($.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const w=[$.id,JSON.stringify(p),$.aiKey],u=new A.$$p(D.$ig.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:w,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),h=[new b.$t9b(u),new C.$N6b(this.d,this.e,this.f,this.g,`[${$.id}] `)];this.a.set($.id,new k.$9q({appenders:h,sendErrorTelemetry:$.sendErrorTelemetry},this.b,this.g))}return this.a.get($.id)}publicLog($,p,w){this.h($).publicLog(p,w)}publicLogError($,p,w){this.h($).publicLogError(p,w)}};e.$L0b=g,e.$L0b=g=pe([Z(0,L.$ri),Z(1,S.$kl),Z(2,O.$fj),Z(3,O.$gj),Z(4,j.$5h),Z(5,P.$xj)],g)}),define(ae[78],ce([0,1,3,20,4,8]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.ProvidedOnAutoForward=e.$hv=e.TunnelPrivacyId=e.TunnelProtocol=e.$gv=e.$fv=void 0,e.$fv=(0,L.$Xh)("tunnelService"),e.$gv=(0,L.$Xh)("sharedTunnelsService");var O;(function(w){w.Http="http",w.Https="https"})(O||(e.TunnelProtocol=O={}));var P;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(P||(e.TunnelPrivacyId=P={}));function S(w){return!!w.forwardPort}e.$hv=S;var b;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function C(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(l)return{address:l[1],port:+l[2]}}e.$iv=C,e.$jv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(w){return e.$jv.indexOf(w)>=0}e.$kv=k,e.$lv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(w){return e.$lv.indexOf(w)>=0}e.$mv=g;function c(w,l,u,h){if(u===1)return!1;if(u===2&&g(l)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(d?.length===4&&parseInt(d[1])>=18)return!1}return w<1024}e.$nv=c;class ${constructor(l,u,h){this.remoteAddress=l,this.localAddress=u,this.b=h,this.a=new D.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$ov=$;let p=class{constructor(l,u){this.j=l,this.k=u,this.a=new D.$Rd,this.onTunnelOpened=this.a.event,this.b=new D.$Rd,this.onTunnelClosed=this.b.event,this.c=new D.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const l=this.k.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.f=l,l?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.g=l.elevation,this.h=l.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const l=[],u=Array.from(this.e.values());for(const h of u){const d=Array.from(h.values());for(const E of d){const s=await E.value;s&&typeof s!="string"&&l.push(s)}}return l}async dispose(){for(const l of this.e.values()){for(const{value:u}of l.values())await u.then(h=>typeof h!="string"?h?.dispose():void 0);l.clear()}this.e.clear()}setEnvironmentTunnel(l,u,h,d,E){this.p(l,u,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:u,localAddress:h,privacy:d,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,u){(g(l)||k(l))&&(l=e.$jv[0]);const h=this.r(l,u);if(h)return++h.refcount,h.value}openTunnel(l,u,h,d,E,s=!1,o,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${h} on local port ${E}.`);const i=this.f??l;if(!i)return;if(u||(u="localhost"),d||(d=this.l),this.f&&this.i.has(h)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.s(i,u,h,d,E,s,o,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(u,h),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(u,h);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.n(r);return(r.tunnelRemoteHost!==u||r.tunnelRemotePort!==h)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(a),a}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}n(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const u=this.e.get(l.tunnelRemoteHost);if(u){const h=u.get(l.tunnelRemotePort);h&&(h.refcount--,await this.o(l.tunnelRemoteHost,l.tunnelRemotePort,h))}}}}async o(l,u,h){if(h.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${u}.`);const d=h.value.then(async E=>{E&&typeof E!="string"&&(await E.dispose(!0),this.b.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this.e.has(l)&&this.e.get(l).delete(u),d}}async closeTunnel(l,u){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${u} `);const h=this.e.get(l);if(h&&h.has(u)){const d=h.get(u);d.refcount=0,await this.o(l,u,d)}}p(l,u,h){this.e.has(l)||this.e.set(l,new Map),this.e.get(l).set(u,{refcount:1,value:h})}async q(l,u){const h=this.e.get(l);if(h){const d=h.get(u),E=d?await d.value:void 0;(!E||typeof E=="string")&&h.delete(u),h.size===0&&this.e.delete(l)}}r(l,u){const h=[l];k(l)?(h.push(...e.$jv),h.push(...e.$lv)):g(l)&&h.push(...e.$lv);const d=h.map(E=>this.e.get(E));for(const E of d){const s=E?.get(u);if(s)return s}}canTunnel(l){return!!C(l)}t(l,u,h,d,E,s,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${h} on local port ${d}.`);const n=h;this.i.add(n);const i=d===void 0?h:d,t={elevationRequired:E?this.isPortPrivileged(i):!1},r={remoteAddress:{host:u,port:h},localAddressPort:d,privacy:s,public:s?s!==P.Private:void 0,protocol:o},a=l.forwardPort(r,t);return a?(this.p(u,h,a),a.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),a}};e.$pv=p,e.$pv=p=pe([Z(0,j.$fj),Z(1,A.$ri)],p)}),define(ae[231],ce([0,1,8,78,2,7,6]),function(ie,e,D,A,L,j,O){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Y0b=void 0;class S extends L.$Rc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$kh),this.b.p)}setAddress(k){this.a=k,this.b&&(this.b.complete(k),this.b=null)}setTunnel(k){this.B(k)}}let b=class extends L.$Rc{static{P=this}static{this.a=0}constructor(k,g){super(),this.f=k,this.g=g,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(k=>k.dispose())}async createTunnel(){return{id:String(++P.a)}}async startTunnel(k,g,c,$,p,w,l){const u=new S,h=await Promise.resolve(this.f.openTunnel(k,u,c,$,p,w,l));if(!h||typeof h=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${c}:${$} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(g))throw this.c.delete(g),u.dispose(),await h.dispose(),(0,j.$5)();return u.setTunnel(h),this.b.set(g,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${g}: ${h.localAddress} (local) to ${c}:${$} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(k,g){const c=this.b.get(k);c&&c.setAddress(g)}async destroyTunnel(k){const g=this.b.get(k);if(g){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${k}.`),this.b.delete(k),await g.dispose();return}this.c.add(k)}};e.$Y0b=b,e.$Y0b=b=P=pe([Z(0,A.$gv),Z(1,D.$fj)],b)}),define(ae[28],ce([0,1,4]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=void 0,e.$Qk=(0,D.$Xh)("IUriIdentityService")}),define(ae[232],ce([0,1,28,185,11,19,127,3,2]),function(ie,e,D,A,L,j,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=void 0;class b{static{this._clock=0}constructor(g){this.uri=g,this.time=b._clock++}touch(){return this.time=b._clock++,this}}let C=class{constructor(g){this.g=g,this.c=new S.$Qc,this.f=2**16;const c=new Map,$=p=>{let w=c.get(p.scheme);return w===void 0&&(w=g.hasProvider(p)&&!this.g.hasCapability(p,1024),c.set(p.scheme,w)),w};this.c.add(P.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(p=>{c.delete(p.scheme)})),this.extUri=new j.$qg($),this.d=new O.$Gr((p,w)=>this.extUri.compare(p,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,j.$Cg)(g));const c=this.d.get(g);return c?c.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new b(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort(($,p)=>$[1].time<p[1].time?1:$[1].time>p[1].time?-1:0);b._clock=0,this.d.clear();const c=this.f*.5;for(let $=0;$<c;$++)this.d.set(g[$][0],g[$][1].touch())}};e.$Hr=C,e.$Hr=C=pe([Z(0,L.$gk)],C),(0,A.$Er)(D.$Qk,C,1)}),define(ae[233],ce([0,1,3,2,11,47,34]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g0b=void 0;class P extends A.$Rc{constructor(b,C,k,g,c,$){super(),this.f=b,this.g=C,this.h=k,this.j=g,this.m=c,this.n=$,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new D.$Rd),this.onDidChangeFile=this.a.event,this.b=j.$4h.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Ac(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(g.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const b of this.j.profiles)this.c.add(b.settingsResource),this.c.add(b.keybindingsResource),this.c.add(b.tasksResource),this.c.add(b.extensionsResource)}open(b,C){return this.g.open(this.t(b),C)}close(b){return this.g.close(b)}read(b,C,k,g,c){return this.g.read(b,C,k,g,c)}write(b,C,k,g,c){return this.g.write(b,C,k,g,c)}watch(b,C){this.b.set(b,b);const k=this.g.watch(this.t(b),C);return(0,A.$Pc)(()=>{this.b.delete(b),k.dispose()})}stat(b){return this.g.stat(this.t(b))}mkdir(b){return this.g.mkdir(this.t(b))}rename(b,C,k){return this.g.rename(this.t(b),this.t(C),k)}readFile(b,C){return this.g.readFile(this.t(b),C)}readFileStream(b,C,k){return this.g.readFileStream(this.t(b),C,k)}readdir(b){return this.g.readdir(this.t(b))}enforceAtomicReadFile(b){return this.c.has(b)}writeFile(b,C,k){return this.g.writeFile(this.t(b),C,k)}enforceAtomicWriteFile(b){return this.c.has(b)?{postfix:".vsctmp"}:!1}delete(b,C){return this.g.delete(this.t(b),C)}copy(b,C,k){if((0,L.$kk)(this.g))return this.g.copy(this.t(b),this.t(C),k);throw new Error("copy not supported")}cloneFile(b,C){if((0,L.$lk)(this.g))return this.g.cloneFile(this.t(b),this.t(C));throw new Error("clone not supported")}s(b){const C=[];for(const k of b){if(k.resource.scheme!==this.f)continue;const g=this.u(k.resource);this.b.findSubstr(g)&&C.push({resource:g,type:k.type,cId:k.cId})}C.length&&(this.n.debug("User data changed"),this.a.fire(C))}t(b){return b.with({scheme:this.f})}u(b){return b.with({scheme:this.h})}}e.$g0b=P}),define(ae[79],ce([0,1,86]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Db=e.$7Db=e.edit=void 0;function A(O,P,S,b){const C=(0,D.$AT)(O,P,S,b)[0];return C&&(O=O.substring(0,C.offset)+C.content+O.substring(C.offset+C.length)),O}e.edit=A;function L(O,P,S){let b=S;for(;b>=0;){if(O.charAt(b)===P.charAt(P.length-1)&&P.length===1)return b+1;if(b--,P.length===2&&b>=0&&O.charAt(b)===P.charAt(0))return b+2}return 0}e.$7Db=L;function j(O,P,S){let b=S;for(;b>=0;)if(O.charAt(b)===P.charAt(P.length-1)&&P.length===1||(b++,P.length===2&&b>=0&&O.charAt(b)===P.charAt(1)))return b;return O.length-1}e.$8Db=j}),define(ae[234],ce([0,1,30,54,12]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t5b=void 0;function j(c,$,p,w,l,u){const h=[],d=[],E=[];if(!$){const q=c.filter(({identifier:Y})=>l.every(K=>K.toLowerCase()!==Y.id.toLowerCase()));return{local:{added:h,removed:d,updated:E},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}c=c.map(k),$=$.map(k),p=p?p.map(k):null;const s=new Map,o=q=>{q.uuid&&s.set(q.id.toLowerCase(),q.uuid)};c.forEach(({identifier:q})=>o(q)),$.forEach(({identifier:q})=>o(q)),p?.forEach(({identifier:q})=>o(q)),w?.forEach(({identifier:q})=>o(q)),u?.forEach(q=>o(q));const n=q=>{const Y=q.identifier.uuid||s.get(q.identifier.id.toLowerCase());return Y?`uuid:${Y}`:`id:${q.identifier.id.toLowerCase()}`},i=(q,Y)=>(q.set(n(Y),Y),q),t=c.reduce(i,new Map),r=$.reduce(i,new Map),a=$.reduce((q,Y)=>i(q,(0,D.$cn)(Y)),new Map),v=p?p.reduce(i,new Map):null,m=w.reduce(i,new Map),f=l.reduce((q,Y)=>{const K=s.get(Y.toLowerCase());return q.add(K?`uuid:${K}`:`id:${Y.toLowerCase()}`)},new Set),y=u?u.reduce((q,{id:Y,uuid:K})=>(K=K??s.get(Y.toLowerCase()),q.add(K?`uuid:${K}`:`id:${Y.toLowerCase()}`)),new Set):null,I=O(t,r,f,!1);if(I.added.size>0||I.removed.size>0||I.updated.size>0){const q=O(v,t,f,!1),Y=O(v,r,f,!0),K=(x,H,Q,J)=>{let W,ee,ne;return H.installed?(W=J.pinned,ne=J.preRelease,W&&(ee=J.version)):(W=Q.pinned,ne=Q.preRelease,W&&(ee=Q.version)),W===void 0&&(W=H.pinned,W&&(ee=H.version)),ne===void 0&&(ne=H.preRelease),{...J,installed:H.installed||Q.installed,pinned:W,preRelease:ne,version:ee??(Q.version&&(!H.installed||A.gt(Q.version,H.version))?Q.version:H.version),state:S(H,Q,v?.get(x))}};for(const x of Y.removed.values()){const H=t.get(x);if(!H)continue;const Q=(0,L.$Nf)(v?.get(x)),J=y&&!y.has(x)&&Q.installed;H.installed&&J?d.push(H.identifier):a.set(x,H)}for(const x of Y.added.values()){const H=(0,L.$Nf)(r.get(x)),Q=t.get(x);if(Q){if(I.updated.has(x)){const J=K(x,Q,H,H);P(Q,H,!1,!1)||E.push(g(J,x)),a.set(x,J)}}else H.installed&&h.push(g(H,x))}for(const x of Y.updated.values()){const H=(0,L.$Nf)(r.get(x)),Q=(0,L.$Nf)(v?.get(x)),J=t.get(x);if(J)if(y&&!y.has(x)&&Q.installed&&J.installed&&!H.installed)d.push(J.identifier);else{const ee=K(x,J,H,H);E.push(g(ee,x)),a.set(x,ee)}else H.installed&&h.push(g(H,x))}for(const x of q.added.values())Y.added.has(x)||a.set(x,(0,L.$Nf)(t.get(x)));for(const x of q.updated.values()){if(Y.removed.has(x)||Y.updated.has(x))continue;const H=(0,L.$Nf)(t.get(x)),Q=(0,L.$Nf)(r.get(x));a.set(x,K(x,H,Q,H))}for(const x of q.removed.values())Y.updated.has(x)||Y.removed.has(x)||m.has(x)||(0,L.$Nf)(r.get(x)).installed&&y&&(y.has(x)||!(0,L.$Nf)(v?.get(x)).installed||a.delete(x))}const T=[],M=O(r,a,new Set,!0),U=M.added.size>0||M.updated.size>0||M.removed.size>0;return U&&a.forEach((q,Y)=>T.push(g(q,Y))),{local:{added:h,removed:d,updated:E},remote:U?{added:[...M.added].map(q=>a.get(q)),updated:[...M.updated].map(q=>a.get(q)),removed:[...M.removed].map(q=>r.get(q)),all:T}:null}}e.$t5b=j;function O(c,$,p,w){const l=c?[...c.keys()].filter(s=>!p.has(s)):[],u=[...$.keys()].filter(s=>!p.has(s)),h=u.filter(s=>!l.includes(s)).reduce((s,o)=>(s.add(o),s),new Set),d=l.filter(s=>!u.includes(s)).reduce((s,o)=>(s.add(o),s),new Set),E=new Set;for(const s of l){if(d.has(s))continue;const o=c.get(s),n=$.get(s);(!n||!P(o,n,w,!0))&&E.add(s)}return{added:h,removed:d,updated:E}}function P(c,$,p,w){return!(c.disabled!==$.disabled||!!c.isApplicationScoped!=!!$.isApplicationScoped||w&&c.installed!==$.installed||c.installed&&$.installed&&(c.preRelease!==$.preRelease||c.pinned!==$.pinned||$.pinned&&c.version!==$.version)||!C(c.state,$.state)||p&&c.version!==$.version)}function S(c,$,p){const w=c.state,l=$.state,u=p?.state;if(!$.version||w&&A.gt(c.version,$.version))return w;if(l&&A.gt($.version,c.version)||!w)return l;if(!l)return w;const h=(0,D.$cn)(w),d=u?b(u,l):{added:Object.keys(l).reduce((s,o)=>(s.add(o),s),new Set),removed:new Set,updated:new Set},E=u?b(u,w):{added:Object.keys(w).reduce((s,o)=>(s.add(o),s),new Set),removed:new Set,updated:new Set};for(const s of[...d.added.values(),...d.updated.values()])h[s]=l[s];for(const s of d.removed.values())E.updated.has(s)||delete h[s];return h}function b(c,$){const p=Object.keys(c),w=Object.keys($),l=w.filter(d=>!p.includes(d)).reduce((d,E)=>(d.add(E),d),new Set),u=p.filter(d=>!w.includes(d)).reduce((d,E)=>(d.add(E),d),new Set),h=new Set;for(const d of p){if(u.has(d))continue;const E=c[d],s=$[d];(0,D.$gn)(E,s)||h.add(d)}return{added:l,removed:u,updated:h}}function C(c={},$={}){const{added:p,removed:w,updated:l}=b(c,$);return p.size===0&&w.size===0&&l.size===0}function k(c){return{...c,disabled:!!c.disabled,installed:!!c.installed}}function g(c,$){const p={...c,identifier:{id:c.identifier.id,uuid:$.startsWith("uuid:")?$.substring(5):void 0},preRelease:!!c.preRelease,pinned:!!c.pinned};return c.disabled||delete p.disabled,c.installed||delete p.installed,c.state||delete p.state,c.isApplicationScoped||delete p.isApplicationScoped,p}}),define(ae[111],ce([0,1,18,20,4]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Fb=e.$4Fb=void 0,e.$4Fb=(0,L.$Xh)("IIgnoredExtensionsManagementService");let j=class{constructor(P){this.a=P}hasToNeverSyncExtension(P){return this.b().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.b().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,S){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return b=b.filter(C=>C!==P&&C!==`-${P}`),S&&b.push(P.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}updateSynchronizedExtensions(P,S){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return b=b.filter(C=>C!==P&&C!==`-${P}`),S&&b.push(`-${P.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}getIgnoredExtensions(P){const S=P.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),b=this.b().map(g=>g.toLowerCase()),C=[],k=[];if(Array.isArray(b))for(const g of b)g.startsWith("-")?k.push(g.substring(1)):C.push(g);return(0,D.$Lb)([...S,...C].filter(g=>!k.includes(g)))}b(){let P=this.a.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.a.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};e.$5Fb=j,e.$5Fb=j=pe([Z(0,A.$ri)],j)}),define(ae[235],ce([0,1,18,35,30,94,79]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z5b=void 0;function P(d){return(0,A.$5m)(d)||[]}async function S(d,E,s,o,n){const i=P(d),t=P(E),r=s?P(s):null,a=[...i,...t,...r||[]].map(K=>K.key),v=await n.resolveUserBindings(a),m=C(i,t,r,v);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:E,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const f=g(i),y=g(t),I=r?g(r):null,T=$(f,y,v),M=I?$(I,f,v):{added:[...f.keys()].reduce((K,x)=>(K.add(x),K),new Set),removed:new Set,updated:new Set},U=I?$(I,y,v):{added:[...y.keys()].reduce((K,x)=>(K.add(x),K),new Set),removed:new Set,updated:new Set},q=b(T,M,U);let Y=d;for(const K of q.removed.values())q.conflicts.has(K)||(Y=u(Y,K,o));for(const K of q.added.values()){if(q.conflicts.has(K))continue;const x=y.get(K);if(x.some(H=>H.command!==`-${K}`&&m.conflicts.has(v[H.key]))){q.conflicts.add(K);continue}Y=l(Y,x,o)}for(const K of q.updated.values()){if(q.conflicts.has(K))continue;const x=y.get(K);if(x.some(H=>H.command!==`-${K}`&&m.conflicts.has(v[H.key]))){q.conflicts.add(K);continue}Y=h(Y,K,x,o)}return{mergeContent:Y,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.$z5b=S;function b(d,E,s){const o=new Set,n=new Set,i=new Set,t=new Set;for(const r of E.removed.values())s.updated.has(r)&&t.add(r);for(const r of s.removed.values())t.has(r)||(E.updated.has(r)?t.add(r):n.add(r));for(const r of E.added.values())t.has(r)||s.added.has(r)&&d.updated.has(r)&&t.add(r);for(const r of s.added.values())t.has(r)||(E.added.has(r)?d.updated.has(r)&&t.add(r):o.add(r));for(const r of E.updated.values())t.has(r)||s.updated.has(r)&&d.updated.has(r)&&t.add(r);for(const r of s.updated.values())t.has(r)||(E.updated.has(r)?d.updated.has(r)&&t.add(r):i.add(r));return{added:o,removed:n,updated:i,conflicts:t}}function C(d,E,s,o){const n=new Set,i=k(d,o),t=k(E,o),r=s?k(s,o):null,a=c(i,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?c(r,i):{added:[...i.keys()].reduce((M,U)=>(M.add(U),M),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const m=r?c(r,t):{added:[...t.keys()].reduce((M,U)=>(M.add(U),M),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:f,removed:y,updated:I,conflicts:T}=b(a,v,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:f,removed:y,updated:I,conflicts:T}}function k(d,E){const s=new Map;for(const o of d){const n=E[o.key];let i=s.get(n);i||(i=[],s.set(n,i)),i.push(o)}return s}function g(d){const E=new Map;for(const s of d){const o=s.command[0]==="-"?s.command.substring(1):s.command;let n=E.get(o);n||(n=[],E.set(o,n)),n.push(s)}return E}function c(d,E){const s=[...d.keys()],o=[...E.keys()],n=o.filter(r=>!s.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),i=s.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of s){if(i.has(r))continue;const a=d.get(r).map(m=>({...m,key:r})),v=E.get(r).map(m=>({...m,key:r}));(0,D.$tb)(a,v,(m,f)=>w(m,f))||t.add(r)}return{added:n,removed:i,updated:t}}function $(d,E,s){const o=[...d.keys()],n=[...E.keys()],i=n.filter(a=>!o.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const v=d.get(a).map(f=>({...f,key:s[f.key]})),m=E.get(a).map(f=>({...f,key:s[f.key]}));p(v,m)||r.add(a)}return{added:i,removed:t,updated:r}}function p(d,E){return!(!(0,D.$tb)(d.filter(({command:s})=>s[0]!=="-"),E.filter(({command:s})=>s[0]!=="-"),(s,o)=>w(s,o))||!(0,D.$tb)(d.filter(({command:s})=>s[0]==="-"),E.filter(({command:s})=>s[0]==="-"),(s,o)=>w(s,o)))}function w(d,E){if(d.command!==E.command||d.key!==E.key)return!1;const s=j.$Vi.deserialize(d.when),o=j.$Vi.deserialize(E.when);return!(s&&!o||!s&&o||s&&o&&!s.equals(o)||!L.$gn(d.args,E.args))}function l(d,E,s){for(const o of E)d=O.edit(d,[-1],o,s);return d}function u(d,E,s){const o=P(d);for(let n=o.length-1;n>=0;n--)(o[n].command===E||o[n].command===`-${E}`)&&(d=O.edit(d,[n],void 0,s));return d}function h(d,E,s,o){const n=P(d),i=n.findIndex(t=>t.command===E||t.command===`-${E}`);for(let t=n.length-1;t>=0;t--)(n[t].command===E||n[t].command===`-${E}`)&&(d=O.edit(d,[t],void 0,o));for(let t=s.length-1;t>=0;t--)d=O.edit(d,[i],s[t],o);return d}}),define(ae[236],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H5b=e.$G5b=void 0;function D(j,O,P){const S={},b={},C=new Set;if(!O)return{local:{added:S,updated:b,removed:[...C.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const k=A(j,O);if(k.added.size===0&&k.removed.size===0&&k.updated.size===0)return{local:{added:S,updated:b,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=A(P,j),c=A(P,O),$={},p={},w=new Set,l=new Set;for(const u of g.removed.values())c.updated.has(u)?S[u]=O[u]:w.add(u);for(const u of c.removed.values())l.has(u)||(g.updated.has(u)?l.add(u):C.add(u));for(const u of g.updated.values())l.has(u)||(c.updated.has(u)?k.updated.has(u)&&l.add(u):p[u]=j[u]);for(const u of c.updated.values())l.has(u)||(g.updated.has(u)?k.updated.has(u)&&l.add(u):j[u]!==void 0&&(b[u]=O[u]));for(const u of g.added.values())l.has(u)||(c.added.has(u)?k.updated.has(u)&&l.add(u):$[u]=j[u]);for(const u of c.added.values())l.has(u)||(g.added.has(u)?k.updated.has(u)&&l.add(u):S[u]=O[u]);return{local:{added:S,removed:[...C.values()],updated:b},remote:{added:$,removed:[...w.values()],updated:p},conflicts:[...l.values()]}}e.$G5b=D;function A(j,O){const P=j?Object.keys(j):[],S=O?Object.keys(O):[],b=S.filter(g=>!P.includes(g)).reduce((g,c)=>(g.add(c),g),new Set),C=P.filter(g=>!S.includes(g)).reduce((g,c)=>(g.add(c),g),new Set),k=new Set;for(const g of P){if(C.has(g))continue;const c=j[g],$=O[g];c!==$&&k.add(g)}return{added:b,removed:C,updated:k}}function L(j,O){const{added:P,removed:S,updated:b}=A(j,O);return P.size===0&&S.size===0&&b.size===0}e.$H5b=L}),define(ae[237],ce([0,1,30]),function(ie,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r7b=void 0;function A(j,O,P,S){const b={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!O){const g=j.filter(({id:c})=>!S.includes(c));return g.length?C.added=g:C=null,{local:b,remote:C}}const k=L(j,O,S);if(k.added.length>0||k.removed.length>0||k.updated.length>0){const g=L(P,j,S),c=L(P,O,S);for(const $ of c.removed){const p=j.find(w=>w.id===$);p&&b.removed.push(p)}for(const $ of c.added){const p=O.find(w=>w.id===$);g.added.includes($)?k.updated.includes($)&&b.updated.push(p):b.added.push(p)}for(const $ of c.updated)b.updated.push(O.find(p=>p.id===$));for(const $ of g.added)c.added.includes($)||C.added.push(j.find(p=>p.id===$));for(const $ of g.updated)c.removed.includes($)||c.updated.includes($)||C.updated.push(j.find(p=>p.id===$));for(const $ of g.removed){const p=O.find(w=>w.id===$);p&&C.removed.push(p)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:b,remote:C}}e.$r7b=A;function L(j,O,P){j=j?j.filter(({id:c})=>!P.includes(c)):[],O=O.filter(({id:c})=>!P.includes(c));const S=j.map(({id:c})=>c),b=O.map(({id:c})=>c),C=b.filter(c=>!S.includes(c)),k=S.filter(c=>!b.includes(c)),g=[];for(const{id:c,name:$,shortName:p,icon:w,useDefaultFlags:l}of j){if(k.includes(c))continue;const u=O.find(h=>h.id===c);(!u||u.name!==$||u.shortName!==p||u.icon!==w||!(0,D.$gn)(u.useDefaultFlags,l))&&g.push(c)}return{added:C,removed:k,updated:g}}}),define(ae[24],ce([0,1,18,12,173,50,29,4,103,41]),function(ie,e,D,A,L,j,O,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhb=e.$lhb=e.$khb=e.$jhb=e.$ihb=e.$hhb=e.$ghb=e.$fhb=e.$ehb=e.$dhb=e.$chb=e.MergeState=e.Change=e.SyncStatus=e.$bhb=e.$ahb=e.$_gb=e.UserDataSyncErrorCode=e.$$gb=e.$0gb=e.$9gb=e.$8gb=e.$7gb=e.$6gb=e.$5gb=e.$4gb=e.$3gb=e.SyncResource=e.$2gb=e.$1gb=e.$Zgb=e.$Ygb=e.$Xgb=e.$Wgb=void 0;function C(){const t=b.$on.as(j.$tn.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$Wgb=C;function k(){const t=b.$on.as(j.$tn.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(m=>!!t[m].ignoreSync),a=Object.keys(t).filter(m=>t[m].scope===2||t[m].scope===6),v=C();return(0,D.$Lb)([...r,...a,...v])}e.$Xgb=k,e.$Ygb="settingsSync",e.$Zgb="settingsSync.keybindingsPerPlatform";function g(){const t="vscode://schemas/ignoredSettings",r=b.$on.as(j.$tn.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{[e.$Zgb]:{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:O.$6n,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=b.$on.as(S.$pn.JSONContribution),v=()=>{const m=C(),f=k(),y=Object.keys(j.$un.properties).filter(M=>!f.includes(M)),I=f.filter(M=>!m.includes(M)),T={items:{type:"string",enum:[...y,...I.map(M=>`-${M}`)]}};a.registerSchema(t,T)};return r.onDidUpdateConfiguration(()=>v())}e.$1gb=g;function c(t){return t&&(0,A.$Ef)(t)&&(0,A.$Cf)(t.id)&&Array.isArray(t.scopes)}e.$2gb=c;var $;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})($||(e.SyncResource=$={})),e.$3gb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(t,...r){return t?[t,...r]:r}e.$4gb=p;function w(t,r,a,v){return v.joinPath(a.userDataSyncHome,...p(t,r,`lastSync${r}.json`))}e.$5gb=w,e.$6gb=(0,P.$Xh)("IUserDataSyncStoreManagementService"),e.$7gb=(0,P.$Xh)("IUserDataSyncStoreService"),e.$8gb=(0,P.$Xh)("IUserDataSyncLocalStoreService"),e.$9gb="x-operation-id",e.$0gb="X-Execution-Id";function l(t){const r={};return r[e.$0gb]=t,r}e.$$gb=l;var u;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class h extends Error{constructor(r,a,v,m){super(r),this.code=a,this.resource=v,this.operationId=m,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$_gb=h;class d extends h{constructor(r,a,v,m,f){super(r,v,void 0,f),this.url=a,this.serverCode=m}}e.$ahb=d;class E extends h{constructor(r,a){super(r,a)}}e.$bhb=E,function(t){function r(a){if(a instanceof t)return a;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(v&&v[1]){const m=v[2]==="unknown"?void 0:v[2],f=v[3]==="unknown"?void 0:v[3];return new t(a.message,v[1],m,f)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(h||(e.$_gb=h={}));var s;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(s||(e.SyncStatus=s={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$chb="sync.store.url.type";function i(t){return`sync.enable.${t}`}e.$dhb=i,e.$ehb=(0,P.$Xh)("IUserDataSyncEnablementService"),e.$fhb=(0,P.$Xh)("IUserDataSyncService"),e.$ghb=(0,P.$Xh)("IUserDataSyncResourceProviderService"),e.$hhb=(0,P.$Xh)("IUserDataAutoSyncService"),e.$ihb=(0,P.$Xh)("IUserDataSyncUtilService"),e.$jhb=(0,P.$Xh)("IUserDataSyncLogService"),e.$khb="userDataSync",e.$lhb="vscode-userdata-sync",e.$mhb="preview"}),define(ae[238],ce([0,1,30,24]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nFb=void 0;function L(O,P,S,b,C){if(!P)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const k=j(O,P);if(k.added.size===0&&k.removed.size===0&&k.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const g=S?j(S,P):{added:Object.keys(P).reduce((u,h)=>(u.add(h),u),new Set),removed:new Set,updated:new Set},c=S?j(S,O):{added:Object.keys(O).reduce((u,h)=>(u.add(h),u),new Set),removed:new Set,updated:new Set},$={added:{},removed:[],updated:{}},p=D.$cn(P),w=!S;for(const u of c.added.values())u!==A.$chb&&w&&g.added.has(u)||(p[u]=O[u]);for(const u of c.updated.values())p[u]=O[u];for(const u of c.removed.values())b.unregistered.includes(u)||delete p[u];for(const u of g.added.values()){const h=P[u];if(b.machine.includes(u)){C.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(S&&c.added.has(u))continue;const d=O[u];d&&d.value===h.value||u===A.$chb&&w&&c.added.has(u)||(d?$.updated[u]=h:$.added[u]=h)}for(const u of g.updated.values()){const h=P[u];if(b.machine.includes(u)){C.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(c.updated.has(u)||c.removed.has(u))continue;const d=O[u];d&&d.value===h.value||($.updated[u]=h)}for(const u of g.removed.values()){if(b.machine.includes(u)){C.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}c.updated.has(u)||c.removed.has(u)||$.removed.push(u)}const l=j(P,p);return{local:$,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:p}}}e.$nFb=L;function j(O,P){const S=Object.keys(O),b=Object.keys(P),C=b.filter(c=>!S.includes(c)).reduce((c,$)=>(c.add($),c),new Set),k=S.filter(c=>!b.includes(c)).reduce((c,$)=>(c.add($),c),new Set),g=new Set;for(const c of S){if(k.has(c))continue;const $=O[c],p=P[c];D.$gn($,p)||g.add(c)}return{added:C,removed:k,updated:g}}}),define(ae[239],ce([0,1,18,35,86,42,30,79,24]),function(ie,e,D,A,L,j,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bEb=e.$aEb=e.$_Db=e.$$Db=e.$0Db=e.$9Db=void 0;function b(a,v,m){let f=[];m?f=k(m):f=C(v);const y=[],I=[...(0,S.$Wgb)()];if(Array.isArray(f))for(const T of f)T.startsWith("-")?I.push(T.substring(1)):y.push(T);return(0,D.$Lb)([...a,...y].filter(T=>!I.includes(T)))}e.$9Db=b;function C(a){let v=a.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=a.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:a.getValue("settingsSync.ignoredSettings")||[]}function k(a){const v=(0,A.$5m)(a);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function g(a,v){const m=(0,A.$5m)(a)||{};let f="{}";for(const y of Object.keys(m)){const I=(0,L.$AT)(f,[y],m[y],v);f=(0,L.$DT)(f,I)}return f}e.$0Db=g;function c(a,v,m,f){if(m.length){const y=r(v),I=(0,A.$5m)(v)||{},T=(0,A.$5m)(a);if(!T)return a;const M=[];for(const U of m){const q=I[U],Y=T[U];q===void 0?a=P.edit(a,[U],void 0,f):Y!==void 0?a=P.edit(a,[U],q,f):M.push(s(U,y))}M.sort((U,q)=>U.startOffset-q.startOffset),M.forEach(U=>a=u(U.setting.key,v,a,f))}return a}e.$$Db=c;function $(a,v,m,f,y,I){const T=c(a,v,f,I),M=m!==T,U=m!==v;if(!M&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!U)return{conflictsSettings:[],localContent:null,remoteContent:T,hasConflicts:!1};if(U&&!M)return{conflictsSettings:[],localContent:c(v,a,f,I),remoteContent:null,hasConflicts:!1};if(m===null&&w(a)){const F=p(a,v,f)?null:c(v,a,f,I);return{conflictsSettings:[],localContent:F,remoteContent:null,hasConflicts:!1}}let q=a,Y=v;const K=(0,A.$5m)(a),x=(0,A.$5m)(v),H=m?(0,A.$5m)(m):null,Q=f.reduce((F,B)=>(F.add(B),F),new Set),J=l(K,x,Q),W=l(H,K,Q),ee=l(H,x,Q),ne=new Map,_=new Set,se=F=>{_.add(F);const B=y.filter(({key:N})=>N===F)[0];B?(q=P.edit(q,[F],B.value,I),Y=P.edit(Y,[F],B.value,I)):ne.set(F,{key:F,localValue:K[F],remoteValue:x[F]})};for(const F of W.removed.values())ee.updated.has(F)?se(F):Y=P.edit(Y,[F],void 0,I);for(const F of ee.removed.values())_.has(F)||(W.updated.has(F)?se(F):q=P.edit(q,[F],void 0,I));for(const F of W.updated.values())_.has(F)||(ee.updated.has(F)?J.updated.has(F)&&se(F):Y=P.edit(Y,[F],K[F],I));for(const F of ee.updated.values())_.has(F)||(W.updated.has(F)?J.updated.has(F)&&se(F):q=P.edit(q,[F],x[F],I));for(const F of W.added.values())_.has(F)||(ee.added.has(F)?J.updated.has(F)&&se(F):Y=u(F,q,Y,I));for(const F of ee.added.values())_.has(F)||(W.added.has(F)?J.updated.has(F)&&se(F):q=u(F,Y,q,I));const X=ne.size>0||!p(q,Y,f),z=X||!p(q,a,[]),R=X||!p(Y,v,[]);return{localContent:z?q:null,remoteContent:R?Y:null,conflictsSettings:[...ne.values()],hasConflicts:X}}e.$_Db=$;function p(a,v,m){if(a===v)return!0;const f=(0,A.$5m)(a),y=(0,A.$5m)(v),I=m.reduce((U,q)=>(U.add(q),U),new Set),T=r(a).filter(U=>!(U.setting&&I.has(U.setting.key))),M=r(v).filter(U=>!(U.setting&&I.has(U.setting.key)));if(T.length!==M.length)return!1;for(let U=0;U<T.length;U++){const q=T[U],Y=M[U];if(q.setting&&Y.setting){if(q.setting.key!==Y.setting.key||!O.$gn(f[q.setting.key],y[q.setting.key]))return!1}else if(!q.setting&&!Y.setting){if(q.value!==Y.value)return!1}else return!1}return!0}function w(a){return a?r(a).length===0:!0}e.$aEb=w;function l(a,v,m){const f=a?Object.keys(a).filter(U=>!m.has(U)):[],y=Object.keys(v).filter(U=>!m.has(U)),I=y.filter(U=>!f.includes(U)).reduce((U,q)=>(U.add(q),U),new Set),T=f.filter(U=>!y.includes(U)).reduce((U,q)=>(U.add(q),U),new Set),M=new Set;if(a)for(const U of f){if(T.has(U))continue;const q=a[U],Y=v[U];O.$gn(q,Y)||M.add(U)}return{added:I,removed:T,updated:M}}function u(a,v,m,f){const y=(0,A.$5m)(v),I=r(v),T=r(m),M=h(a,I,T);return d(m,a,y[a],M,T,f)}e.$bEb=u;function h(a,v,m){const f=v.findIndex(I=>I.setting?.key===a),y=v[f-1];if(y){if(y.setting){const T=s(y.setting.key,m);if(T)return{index:m.indexOf(T),insertAfter:!0}}else{const T=o(f,v);if(T){const M=s(T.setting.key,m);if(M){const U=n(m.indexOf(M),m),q=i(v,T,v[f]);if(U){const Y=i(m,M,U),K=t(q,Y);return K?{index:m.indexOf(K),insertAfter:!0}:{index:m.indexOf(U),insertAfter:!1}}else{const Y=i(m,M,m[m.length-1]),K=t(q,Y);return K?{index:m.indexOf(K),insertAfter:!0}:{index:m.length-1,insertAfter:!0}}}}}const I=v[f+1];if(I)if(I.setting){const T=s(I.setting.key,m);if(T)return{index:m.indexOf(T),insertAfter:!1}}else{const T=n(f,v);if(T){const M=s(T.setting.key,m);if(M){const U=o(m.indexOf(M),m),q=i(v,v[f],T);if(U){const Y=i(m,U,M),K=t(q.reverse(),Y.reverse());return K?{index:m.indexOf(K),insertAfter:!1}:{index:m.indexOf(U),insertAfter:!0}}else{const Y=i(m,m[0],M),K=t(q.reverse(),Y.reverse());return K?{index:m.indexOf(K),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:m.length-1,insertAfter:!0}}function d(a,v,m,f,y,I){let T;return f.index===-1?T=(0,L.$AT)(a,[v],m,I):T=E(a,v,m,f,y,I).map(M=>(0,L.$BT)(a,M,I)[0]),(0,L.$DT)(a,T)}function E(a,v,m,f,y,I){const T=`${JSON.stringify(v)}: ${JSON.stringify(m)}`,M=(0,j.$xT)(I,a),U=y[f.index];if(f.insertAfter){const q=[];if(U.setting)q.push({offset:U.endOffset,length:0,content:","+T});else{const Y=n(f.index,y),K=o(f.index,y),x=K?.setting?.commaOffset;K&&x===void 0&&q.push({offset:K.endOffset,length:0,content:","});const H=x!==void 0&&x>U.endOffset;q.push({offset:H?x+1:U.endOffset,length:0,content:Y?M+T+",":M+T})}return q}else{if(U.setting)return[{offset:U.startOffset,length:0,content:T+","}];const q=(y[f.index-1]&&!y[f.index-1].setting?M:"")+T+(n(f.index,y)?",":"")+M;return[{offset:U.startOffset,length:0,content:q}]}}function s(a,v){return v.filter(m=>m.setting?.key===a)[0]}function o(a,v){for(let m=a-1;m>=0;m--)if(v[m].setting)return v[m]}function n(a,v){for(let m=a+1;m<v.length;m++)if(v[m].setting)return v[m]}function i(a,v,m){const f=a.indexOf(v),y=a.indexOf(m);return a.filter((I,T)=>f<T&&T<y)}function t(a,v){if(a.length&&v.length){let m=0;for(;m<v.length&&m<a.length;m++)if(a[m].value!==v[m].value)return v[m-1];return v[m-1]}}function r(a){const v=[];let m=-1,f,y;const I={onObjectBegin:T=>{m++},onObjectProperty:(T,M,U)=>{m===0&&(f=M,y=T)},onObjectEnd:(T,M)=>{m--,m===0&&v.push({startOffset:f,endOffset:T+M,value:a.substring(f,T+M),setting:{key:y,commaOffset:void 0}})},onArrayBegin:(T,M)=>{m++},onArrayEnd:(T,M)=>{m--,m===0&&v.push({startOffset:f,endOffset:T+M,value:a.substring(f,T+M),setting:{key:y,commaOffset:void 0}})},onLiteralValue:(T,M,U)=>{m===0&&v.push({startOffset:f,endOffset:M+U,value:a.substring(f,M+U),setting:{key:y,commaOffset:void 0}})},onSeparator:(T,M,U)=>{if(m===0&&T===","){let q=v.length-1;for(;q>=0&&!v[q].setting;q--);const Y=v[q];Y&&v.splice(q,1,{startOffset:Y.startOffset,endOffset:Y.endOffset,value:Y.value,setting:{key:Y.setting.key,commaOffset:M}})}},onComment:(T,M)=>{m===0&&v.push({startOffset:T,endOffset:T+M,value:a.substring(T,T+M)})}};return(0,A.$_m)(a,I),v}}),define(ae[80],ce([0,1,3,2,4,24]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TDb=e.$SDb=void 0,e.$SDb=(0,L.$Xh)("IUserDataSyncAccountService");let O=class extends A.$Rc{get account(){return this.a}constructor(S,b){super(),this.g=S,this.h=b,this.b=this.B(new D.$Rd),this.onDidChangeAccount=this.b.event,this.c=this.B(new D.$Rd),this.onTokenFailed=this.c.event,this.f=!1,this.B(S.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(S.onTokenSucceed(()=>this.f=!1))}async updateAccount(S){(S&&this.a?S.token!==this.a.token||S.authenticationProviderId!==this.a.authenticationProviderId:S!==this.a)&&(this.a=S,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(S))}};e.$TDb=O,e.$TDb=O=pe([Z(0,j.$7gb),Z(1,j.$jhb)],O)}),define(ae[240],ce([0,1,2,10]),function(ie,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S0b=e.$R0b=e.$Q0b=e.$P0b=e.$O0b=e.$N0b=e.$M0b=void 0;class L{constructor(g){this.a=g}listen(g,c){switch(c){case"onError":return this.a.onError}throw new Error(`Event not found: ${c}`)}call(g,c,$){switch(c){case"triggerSync":return this.a.triggerSync($[0],$[1],$[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff($[0])}throw new Error("Invalid call")}}e.$M0b=L;class j{constructor(g){this.a=g}listen(g,c){throw new Error(`Event not found: ${c}`)}call(g,c,$){switch(c){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings($[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(A.URI.revive($[0]))}throw new Error("Invalid call")}}e.$N0b=j;class O{constructor(g){this.a=g}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.a.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.a.call("resolveFormattingOptions",[g])}}e.$O0b=O;class P{constructor(g){this.a=g}listen(g,c){switch(c){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${c}`)}async call(g,c,$){switch(c){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine($[0],$[1]);case"setEnablements":return this.a.setEnablements($)}throw new Error("Invalid call")}}e.$P0b=P;class S{constructor(g){this.a=g}listen(g,c){switch(c){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${c}`)}call(g,c,$){switch(c){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount($)}throw new Error("Invalid call")}}e.$Q0b=S;class b{constructor(g){this.a=g}listen(g,c){switch(c){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${c}`)}call(g,c,$){switch(c){case"switch":return this.a.switch($[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$R0b=b;class C extends D.$Rc{constructor(g){super(),this.a=g,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.a.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.a.call("getPreviousUserDataSyncStore");return this.b(g)}b(g){return{url:A.URI.revive(g.url),type:g.type,defaultUrl:A.URI.revive(g.defaultUrl),insidersUrl:A.URI.revive(g.insidersUrl),stableUrl:A.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.$S0b=C}),define(ae[241],ce([0,1,19,174,14,8,24]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Fb=void 0;let P=class extends j.$kj{constructor(b,C){super(),this.g=this.B(b.createLogger((0,D.$Bg)(C.logsHome,`${O.$khb}.log`),{id:O.$khb,name:(0,A.localize)(0,null)}))}trace(b,...C){this.g.trace(b,...C)}debug(b,...C){this.g.debug(b,...C)}info(b,...C){this.g.info(b,...C)}warn(b,...C){this.g.warn(b,...C)}error(b,...C){this.g.error(b,...C)}flush(){this.g.flush()}};e.$6Fb=P,e.$6Fb=P=pe([Z(0,j.$gj),Z(1,L.$5h)],P)}),define(ae[242],ce([0,1,6,3,2]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N9b=void 0;class j extends L.$Rc{constructor({onDidOpenMainWindow:P,onDidFocusMainWindow:S,getActiveWindowId:b}){super(),this.a=this.B(new L.$Qc),A.Event.latch(A.Event.any(P,S))(this.f,this,this.a),this.b=(0,D.$Ng)(()=>b()),(async()=>{try{const k=await this.b;this.c=typeof this.c=="number"?this.c:k}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$N9b=j}),define(ae[112],ce([0,1,177,16,47,19,10,4,23]),function(ie,e,D,A,L,j,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.WorkbenchState=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=void 0,e.$7h=(0,P.$Xh)("contextService");function b(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.uri)}e.$8h=b;function C(i){return typeof i?.id=="string"&&!b(i)&&!g(i)}e.$9h=C,e.$0h={id:"ext-dev"},e.$$h={id:"empty-window"};function k(i,t){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,A.$mc)(i)}:t?e.$0h:e.$$h;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$_h=k;function g(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.configPath)}e.$ai=g;function c(i){const t=i;if(t?.uri)return{id:t.id,uri:O.URI.revive(t.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$bi=c;var $;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function p(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$ci=p;function w(i){const t=i;return!!(t&&typeof t=="object"&&O.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$di=w;class l{constructor(t,r,a,v,m){this.h=t,this.j=a,this.k=v,this.l=m,this.c=L.$4h.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=L.$4h.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ei=l;class u{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,j.$Bg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$fi=u;function h(i){return new u({uri:i,index:0,name:(0,j.$xg)(i)},{uri:i.toString()})}e.$gi=h,e.$hi="code-workspace",e.$ii=`.${e.$hi}`,e.$ji=[{name:(0,D.localize)(0,null),extensions:[e.$hi]}],e.$ki="workspace.json";function d(i,t){return j.$sg.isEqualOrParent(i,t.untitledWorkspacesHome)}e.$li=d;function E(i){let t;return O.URI.isUri(i)?t=i:t=i.configuration,t?.scheme===S.Schemas.tmp}e.$mi=E,e.$ni="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$ni}e.$oi=s;function o(i,t){return!d(i,t)&&!E(i)}e.$pi=o;function n(i){return(typeof i=="string"?(0,A.$nc)(i):(0,j.$zg)(i))===e.$ii}e.$qi=n}),define(ae[17],ce([0,1,52,3,2,19,10,168,14,11,4,8,112,34,28,6,32,27,12]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.ProfileResourceType=void 0;var h;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function d(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&O.URI.isUri(t.location)&&O.URI.isUri(t.globalStorageHome)&&O.URI.isUri(t.settingsResource)&&O.URI.isUri(t.keybindingsResource)&&O.URI.isUri(t.tasksResource)&&O.URI.isUri(t.snippetsHome)&&O.URI.isUri(t.extensionsResource))}e.$Rk=d,e.$Sk=(0,C.$Xh)("IUserDataProfilesService");function E(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:O.URI.revive(i.location).with({scheme:t}),globalStorageHome:O.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:O.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:O.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:O.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:O.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:O.URI.revive(i.extensionsResource).with({scheme:t}),cacheHome:O.URI.revive(i.cacheHome).with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Tk=E;function s(i,t,r,a,v,m){return{id:i,name:t,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:m&&v?.useDefaultFlags?.globalState?m.globalStorageHome:(0,j.$Bg)(r,"globalStorage"),settingsResource:m&&v?.useDefaultFlags?.settings?m.settingsResource:(0,j.$Bg)(r,"settings.json"),keybindingsResource:m&&v?.useDefaultFlags?.keybindings?m.keybindingsResource:(0,j.$Bg)(r,"keybindings.json"),tasksResource:m&&v?.useDefaultFlags?.tasks?m.tasksResource:(0,j.$Bg)(r,"tasks.json"),snippetsHome:m&&v?.useDefaultFlags?.snippets?m.snippetsHome:(0,j.$Bg)(r,"snippets"),extensionsResource:m&&v?.useDefaultFlags?.extensions?m.extensionsResource:(0,j.$Bg)(r,"extensions.json"),cacheHome:(0,j.$Bg)(a,i),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$Uk=s;let o=class extends L.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,v){super(),this.t=t,this.u=r,this.w=a,this.y=v,this.f=!0,this.h=this.B(new A.$Rd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$Rd),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$Rd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$Rd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new c.$zc,emptyWindows:new Map},this.profilesHome=(0,j.$Bg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$Bg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const m of this.O()){if(!m.name||!(0,u.$Cf)(m.name)||!m.location){this.y.warn("Skipping the invalid stored profile",m.location||m.name);continue}r.push(s((0,j.$yg)(m.location),m.name,m.location,this.g,{shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags},t))}}catch(m){this.y.error(m)}const a=new c.$zc,v=new Map;if(r.length)try{const m=this.Q();if(m.workspaces)for(const[f,y]of Object.entries(m.workspaces)){const I=O.URI.parse(f),T=r.find(M=>M.id===y);T&&a.set(I,T)}if(m.emptyWindows)for(const[f,y]of Object.entries(m.emptyWindows)){const I=r.find(T=>T.id===y);I&&v.set(f,I)}}catch(m){this.y.error(m)}this.z={profiles:r,workspaces:a,emptyWindows:v}}return this.z}D(){const t=s("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,l.$Je)(r)}\\s(\\d+)`);let v=0;for(const f of this.profiles){const y=a.exec(f.name),I=y?parseInt(y[1]):0;v=I>v?I:v}const m=`${r} ${v+1}`;return this.createProfile((0,D.$Li)((0,w.$kg)()).toString(16),m,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,D.$Li)((0,w.$kg)()).toString(16),t,r,a)}async createProfile(t,r,a,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.F(t,r,a);return v&&await this.setProfileForWorkspace(v,m),m}async F(t,r,a){if(!(0,u.$Cf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const m=this.profiles.find(I=>I.name===r||I.id===t);if(m)return m;const f=s(t,r,(0,j.$Bg)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(f.location);const y=[];return this.j.fire({profile:f,join(I){y.push(I)}}),await p.Promises.settled(y),this.I([f],[],[]),f}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(v=>v.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=s(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(v){a.push(v)}});try{await Promise.allSettled(a)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,b.$xk)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(v=>v.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return O.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,g.$8h)(t)?t.uri:(0,g.$ai)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const v=[...this.profiles,...t],m=[];this.s.profiles=[];for(let f of v)f.isDefault||r.some(y=>f.id===y.id)||(f=a.find(y=>f.id===y.id)??f,f.isTransient?this.s.profiles.push(f):m.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.P(m),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const v=this.G(t),m=a?this.s:this.C;O.URI.isUri(v)?(m.workspaces.delete(v),r&&m.workspaces.set(v,r)):(m.emptyWindows.delete(v),r&&m.emptyWindows.set(v,r)),a||this.M()}M(){const t={};for(const[a,v]of this.C.workspaces.entries())t[a.toString()]=v.id;const r={};for(const[a,v]of this.C.emptyWindows.entries())r[a.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[m,f]of Object.entries(t.workspaces)){const y=O.URI.parse(f);r[m]=this.w.extUri.isEqual(y,a.location)?a.id:this.w.extUri.basename(y)}const v={};if(t.emptyWindows)for(const[m,f]of Object.entries(t.emptyWindows)){const y=O.URI.parse(f);v[m]=this.w.extUri.isEqual(y,a.location)?a.id:this.w.extUri.basename(y)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$Vk=o,e.$Vk=o=pe([Z(0,S.$5h),Z(1,b.$gk),Z(2,$.$Qk),Z(3,k.$fj)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$Wk=n}),define(ae[243],ce([0,1,6,2,17]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$10b=void 0;let j=class extends A.$Rc{constructor(P){super(),this.B(new D.$_g(()=>{P.cleanUp()},10*1e3)).schedule()}};e.$10b=j,e.$10b=j=pe([Z(0,L.$Sk)],j)}),define(ae[244],ce([0,1,18,6,26,7,3,2,5,12,10,151,29,33,44,8,25,22,28,17]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=void 0;let d=class extends P.$Rc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,v,m,f){super(),this.z=t,this.C=r,this.D=a,this.F=v,this.G=m,this.H=f,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$Rd),this.s=this.B(new O.$Rd),this.t=this.B(new O.$Rd),this.u=this.B(new O.$Rd),this.w=this.B(new O.$Rd),this.y=[],this.B((0,P.$Pc)(()=>{this.j.forEach(({task:y})=>y.cancel()),this.m.forEach(y=>y.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,g.$do)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:m})=>(0,c.$Ho)(m,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:s(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(a){throw s(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new g.$go(k.localize(0,null),g.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(t.map(async({extension:v,options:m})=>{try{const f=await this.O(v,!!m?.installGivenVersion,!!m?.installPreReleaseVersion);a.push({...f,options:m})}catch(f){r.push({identifier:v.identifier,operation:2,source:v,error:f})}})),a.length&&r.push(...await this.I(a));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!C.URI.isUri(v.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,c.$Po)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,r)}async toggleAppliationScope(t,r){if((0,$.$em)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.ab(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const m=(await this.getInstalled(1,v.extensionsResource)).find(f=>(0,c.$Ho)(f.identifier,t.identifier));m?this.w.fire(m):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[];return await Promise.allSettled(t.map(async a=>{try{const v=await this.J(a,(m,f)=>t.some(y=>(0,c.$Lo)(f.identifier.id)===(0,c.$Mo)(y.manifest.publisher,y.manifest.name))?!1:this.L(m,f));r.push(...v)}catch(v){r.push({identifier:{id:(0,c.$Mo)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:v})}})),this.s.fire(r),r}async J({manifest:t,extension:r,options:a},v){const m=a.isApplicationScoped||a.isBuiltin||(0,$.$em)(t),f={...a,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:m,profileLocation:m?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},y=Y=>`${c.$Io.create(Y).toString()}${f.profileLocation?`-${f.profileLocation.toString()}`:""}`;if(!C.URI.isUri(r)){const Y=this.j.get(y(r));if(Y)return this.F.info("Extensions is already requested to install",r.identifier.id),await Y.task.waitUntilTaskIsFinished(),[]}const I=[],T=[],M=[],U=this.Z(t,r,f);C.URI.isUri(r)||this.j.set(y(r),{task:U,waitingTasks:[]}),this.n.fire({identifier:U.identifier,source:r,profileLocation:f.profileLocation}),this.F.info("Installing extension:",U.identifier.id),I.push({task:U,manifest:t});let q=!1;try{if(f.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",U.identifier.id);else try{const K=await this.N(U.identifier,t,!!f.installOnlyNewlyAddedFromExtensionPack,!!f.installPreReleaseVersion,f.profileLocation),x=await this.getInstalled(void 0,f.profileLocation),H={...f,donotIncludePackAndDependencies:!0,context:{...f.context,[g.$$n]:!0}};for(const{gallery:Q,manifest:J}of(0,D.$Lb)(K,({gallery:W})=>W.identifier.id)){q=q||!!J.extensionDependencies?.some(ne=>(0,c.$Ho)({id:ne},U.identifier));const W=y(Q),ee=this.j.get(W);if(ee){if(v(U,ee.task)){const ne=ee.task.identifier;this.F.info("Waiting for already requested installing extension",ne.id,U.identifier.id),ee.waitingTasks.push(U),T.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,_=>_.some(se=>(0,c.$Ho)(se.identifier,ne)))).then(_=>{if(this.F.info("Finished waiting for already requested installing extension",ne.id,U.identifier.id),!_.find(X=>(0,c.$Ho)(X.identifier,ne))?.local)throw new Error(`Extension ${ne.id} is not installed`)}))}}else if(!x.some(({identifier:ne})=>(0,c.$Ho)(ne,Q.identifier))){const ne=this.Z(J,Q,H);this.j.set(W,{task:ne,waitingTasks:[U]}),this.n.fire({identifier:ne.identifier,source:Q,profileLocation:f.profileLocation}),this.F.info("Installing extension:",ne.identifier.id,U.identifier.id),I.push({task:ne,manifest:J})}}}catch(K){if(C.URI.isUri(U.source))(0,D.$Kb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",U.identifier.id,K.message),(0,D.$Kb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",U.identifier.id,K.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",U.identifier.id),K}const Y=I.reduce((K,{task:x,manifest:H})=>(K.set(x.identifier.id.toLowerCase(),{task:x,manifest:H}),K),new Map);for(;Y.size;){let K;const x=[...Y.values()].filter(({manifest:H})=>!H.extensionDependencies?.some(Q=>Y.has(Q.toLowerCase())));x.length?K=Y.size===1?x:x.filter(({task:H})=>!(H===U&&!q)):(this.F.info("Found extensions with circular dependencies",x.map(({task:H})=>H.identifier.id)),K=[...Y.values()]),await this.M(K.map(async({task:H})=>{const Q=new Date().getTime();try{const J=await H.run();if(await this.M(this.y.map(W=>W.postInstall(J,H.source,f,L.CancellationToken.None))),!C.URI.isUri(H.source)){const W=H.operation===3,ee=W?void 0:(new Date().getTime()-H.source.lastUpdated)/1e3;if(o(this.C,W?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$Po)(H.source),verificationStatus:H.verificationStatus,duration:new Date().getTime()-Q,durationSinceUpdate:ee}),S.$o&&H.operation!==3)try{await this.z.reportStatistic(J.manifest.publisher,J.manifest.name,J.manifest.version,"install")}catch{}}M.push({local:J,identifier:H.identifier,operation:H.operation,source:H.source,context:H.options.context,profileLocation:H.profileLocation,applicationScoped:J.isApplicationScoped})}catch(J){throw C.URI.isUri(H.source)||o(this.C,H.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$Po)(H.source),verificationStatus:H.verificationStatus,duration:new Date().getTime()-Q,error:J}),this.F.error("Error while installing the extension:",H.identifier.id),J}finally{Y.delete(H.identifier.id.toLowerCase())}}))}return T.length&&await this.M(T),M.forEach(({identifier:K})=>this.F.info("Extension installed successfully:",K.id)),M}catch(Y){if(I.forEach(({task:K})=>K.cancel()),M.length)try{const K=await Promise.allSettled(M.map(({local:x})=>this.$(x,{versionOnly:!0,profileLocation:f.profileLocation}).run()));for(let x=0;x<K.length;x++){const H=K[x],{identifier:Q}=M[x];H.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",Q.id):this.F.warn("Rollback: Error while uninstalling extension",Q.id,(0,j.$9)(H.reason))}}catch(K){this.F.warn("Error while rolling back extensions",(0,j.$9)(K),M.map(({identifier:x})=>x.id))}return I.map(({task:K})=>({identifier:K.identifier,operation:2,source:K.source,context:f.context,profileLocation:f.profileLocation,error:Y}))}finally{for(const{task:Y}of I)Y.source&&!C.URI.isUri(Y.source)&&this.j.delete(y(Y.source))}}L(t,r){for(const[,{task:a,waitingTasks:v}]of this.j.entries())if(a===t&&(v.includes(r)||v.some(m=>this.L(m,r)))||a===r&&v[0]&&!this.L(t,v[0]))return!1;return!0}async M(t){const r=[],a=[],v=await Promise.allSettled(t);for(const m of v)m.status==="fulfilled"?r.push(m.value):a.push(m.reason);if(a.length)throw E(a);return r}async N(t,r,a,v,m){if(!this.z.isEnabled())return[];const f=await this.getInstalled(void 0,m),y=[],I=[],T=async(M,U)=>{y.push(M);const q=U.extensionDependencies||[],Y=[...q];if(U.extensionPack){const K=a?f.find(x=>(0,c.$Ho)(x.identifier,M)):void 0;for(const x of U.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(H=>(0,c.$Ho)({id:H},{id:x}))||Y.every(H=>!(0,c.$Ho)({id:H},{id:x}))&&Y.push(x)}if(Y.length){const K=Y.filter(x=>y.every(H=>!(0,c.$Ho)(H,{id:x})));if(K.length){const x=await this.z.getExtensions(K.map(H=>({id:H,preRelease:v})),L.CancellationToken.None);for(const H of x){if(y.find(W=>(0,c.$Ho)(W,H.identifier)))continue;const Q=q.some(W=>(0,c.$Ho)({id:W},H.identifier));let J;try{J=await this.O(H,!1,v)}catch(W){if(Q)throw W;this.F.info("Skipping the packed extension as it cannot be installed",H.identifier.id,(0,j.$9)(W));continue}I.push({gallery:J.extension,manifest:J.manifest}),await T(J.extension.identifier,J.manifest)}}}};return await T(t,r),I}async O(t,r,a){let v;const m=await this.getExtensionsControlManifest();if(m.malicious.some(I=>(0,c.$Ho)(t.identifier,I)))throw new g.$go(k.localize(1,null,t.identifier.id),g.ExtensionManagementErrorCode.Malicious);const f=m.deprecated[t.identifier.id.toLowerCase()];if(f?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${f.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:f.extension.id,preRelease:f.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0],!v)throw new g.$go(k.localize(2,null,t.identifier.id,f.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const I=await this.getTargetPlatform();throw new g.$go(k.localize(3,null,t.identifier.id,this.G.nameLong,(0,g.$_n)(I)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.P(t,r,a),!v)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],L.CancellationToken.None))[0]?new g.$go(k.localize(4,null,t.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$go(k.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),g.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const y=await this.z.getManifest(v,L.CancellationToken.None);if(y===null)throw new g.$go(`Missing manifest for extension ${v.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(y.version!==v.version)throw new g.$go(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:y}}async P(t,r,a){const v=await this.getTargetPlatform();let m=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(m=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:v,compatible:!0},L.CancellationToken.None))[0]||null),!m&&await this.z.isExtensionCompatible(t,a,v)&&(m=t),m||(r?m=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0},L.CancellationToken.None))[0]||null:m=await this.z.getCompatibleExtension(t,a,v)),m}async Q(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},v=M=>`${M.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,m=this.m.get(v(t.identifier));if(m)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),m.waitUntilTaskIsFinished();const f=M=>{const U=this.$(M,a);return this.m.set(v(U.extension.identifier),U),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.t.fire({identifier:M.identifier,profileLocation:a.profileLocation,applicationScoped:M.isApplicationScoped}),U},y=(M,U)=>{U?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString(),U.message):this.F.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,U.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,c.$Oo)(M),error:U}),this.u.fire({identifier:M.identifier,error:U?.code,profileLocation:a.profileLocation,applicationScoped:M.isApplicationScoped})},I=[],T=[];try{I.push(f(t));const M=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const U=this.U(t,M);for(const q of U)this.m.has(v(q.identifier))?this.F.info("Extensions is already requested to uninstall",q.identifier.id):I.push(f(q))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(I.map(U=>U.extension),M,t),await this.M(I.map(async U=>{try{if(await U.run(),await this.M(this.y.map(q=>q.postUninstall(U.extension,a,L.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,"uninstall")}catch{}y(U.extension)}catch(q){const Y=q instanceof g.$go?q:new g.$go((0,j.$9)(q),g.ExtensionManagementErrorCode.Internal);throw y(U.extension,Y),Y}finally{T.push(U)}}))}catch(M){const U=M instanceof g.$go?M:new g.$go((0,j.$9)(M),g.ExtensionManagementErrorCode.Internal);for(const q of I){try{q.cancel()}catch{}T.includes(q)||y(q.extension,U)}throw U}finally{for(const M of I)this.m.delete(v(M.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}R(t,r,a){for(const v of t){const m=this.W(v,r);if(m.length){const f=m.filter(y=>!t.some(I=>(0,c.$Ho)(I.identifier,y.identifier)));if(f.length)throw new Error(this.S(v,f,a))}}}S(t,r,a){return a===t?r.length===1?k.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?k.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):k.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?k.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?k.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):k.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const m=r.filter(y=>!y.isBuiltin&&v.some(I=>(0,c.$Ho)({id:I},y.identifier))),f=[];for(const y of m)f.push(...this.U(y,r,a));return[...m,...f]}return[]}W(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(v=>(0,c.$Ho)({id:v},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$xp=d,e.$xp=d=pe([Z(0,g.$fo),Z(1,l.$kl),Z(2,u.$Qk),Z(3,p.$fj),Z(4,w.$xj),Z(5,h.$Sk)],d);function E(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$yp=E;function s(i){if(i instanceof g.$go)return i;const t=new g.$go(i.message,g.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}e.$zp=s;function o(i,t,{extensionData:r,verificationStatus:a,duration:v,error:m,durationSinceUpdate:f}){let y,I;(0,b.$Kf)(a)&&(a===!0?a="Verified":(a===!1||(y=g.ExtensionManagementErrorCode.Signature,I=a),a="Unverified")),m&&(m instanceof g.$go?(y=m.code,m.code===g.ExtensionManagementErrorCode.Signature&&(I=m.message)):y=g.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...r,verificationStatus:a,success:!m,duration:v,errorcode:y,errorcodeDetail:I,durationSinceUpdate:f})}class n{constructor(){this.d=new A.$Yg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,A.$Ng)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.$Ng)(t=>new Promise((r,a)=>{const v=t.onCancellationRequested(()=>{v.dispose(),a(new j.$4)})})),this.d.open()),this.g.cancel()}}e.$Ap=n}),define(ae[51],ce([0,1,6,15,2,3,34,10,29,33,11,4,8,17,28,12,7,22]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class h extends Error{constructor(n,i){super(n),this.code=i}}e.$Bp=h,e.$Cp=(0,k.$Xh)("IExtensionsProfileScannerService");let d=class extends L.$Rc{constructor(n,i,t,r,a,v){super(),this.j=n,this.m=i,this.n=t,this.r=r,this.s=a,this.t=v,this.b=this.B(new j.$Rd),this.onAddExtensions=this.b.event,this.c=this.B(new j.$Rd),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$Rd),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$Rd),this.onDidRemoveExtensions=this.g.event,this.h=new O.$zc}scanProfileExtensions(n,i){return this.u(n,void 0,i)}async addExtensionsToProfile(n,i){const t=[],r=[];try{return await this.u(i,a=>{const v=[];for(const m of a)n.some(([f])=>(0,b.$Ho)(f.identifier,m.identifier)&&f.manifest.version!==m.version)?t.push(m):v.push(m);for(const[m,f]of n){const y=v.findIndex(T=>(0,b.$Ho)(T.identifier,m.identifier)&&T.version===m.manifest.version),I={identifier:m.identifier,version:m.manifest.version,location:m.location,metadata:f};y===-1?(r.push(I),v.push(I)):v.splice(y,1,I)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),t.length&&this.f.fire({extensions:t,profileLocation:i}),v}),r.length&&this.c.fire({extensions:r,profileLocation:i}),t.length&&this.g.fire({extensions:t,profileLocation:i}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:i}),t.length&&this.g.fire({extensions:t,error:a,profileLocation:i}),a}}async updateMetadata(n,i){const t=[];return await this.u(i,r=>{const a=[];for(const v of r){const m=n.find(([f])=>(0,b.$Ho)(f.identifier,v.identifier)&&f.manifest.version===v.version);m&&(v.metadata={...v.metadata,...m[1]},t.push(v)),a.push(v)}return a}),t}async removeExtensionFromProfile(n,i){const t=[];try{await this.u(i,r=>{const a=[];for(const v of r)(0,b.$Ho)(v.identifier,n.identifier)?t.push(v):a.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:i}),a}),t.length&&this.g.fire({extensions:t,profileLocation:i})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:i}),r}}async u(n,i,t){return this.F(n).queue(async()=>{let r=[],a;try{const v=await this.m.readFile(n);a=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,C.$xk)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new h((0,w.$9)(v),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let v=!1;for(const m of a){E(m)||this.w(n);let f;if((0,p.$Cf)(m.relativeLocation)&&m.relativeLocation)f=this.z(m.relativeLocation);else if((0,p.$Cf)(m.location))f=this.z(m.location),v=!0,m.relativeLocation=m.location,m.location=f.toJSON();else{f=P.URI.revive(m.location);const y=this.y(f);y&&(v=!0,m.relativeLocation=y)}r.push({identifier:m.identifier,location:f,version:m.version,metadata:m.metadata})}v&&await this.m.writeFile(n,A.$fe.fromString(JSON.stringify(a)))}if(i){r=i(r);const v=r.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),relativeLocation:this.y(m.location),metadata:m.metadata}));await this.m.writeFile(n,A.$fe.fromString(JSON.stringify(v)))}return r})}w(n){const i=new h(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,C.$xk)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(v=>E(v))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$fe.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.$xk)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,C.$xk)(a)!==1&&this.t.error(a)}try{await this.m.del(i)}catch(a){(0,C.$xk)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let i=this.h.get(n);return i||(i=new D.$7g,this.h.set(n,i)),i}};e.$Dp=d,e.$Dp=d=pe([Z(1,C.$gk),Z(2,c.$Sk),Z(3,$.$Qk),Z(4,l.$kl),Z(5,g.$fj)],d);function E(o){return(0,p.$Ef)(o)&&(0,S.$eo)(o.identifier)&&(s(o.location)||(0,p.$Cf)(o.location)&&o.location)&&((0,p.$Jf)(o.relativeLocation)||(0,p.$Cf)(o.relativeLocation))&&o.version&&(0,p.$Cf)(o.version)}function s(o){return o?(0,p.$Cf)(o.path)&&(0,p.$Cf)(o.scheme):!1}}),define(ae[81],ce([0,1,18,6,30,15,7,35,137,2,23,16,5,19,54,89,12,10,154,14,33,44,70,11,4,8,25,3,65,51,17,28,182]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l,u,h,d,E,s,o,n,i,t,r,a,v,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.Translations=void 0;var I;(function(x){function H(Q,J){if(Q===J)return!0;const W=Object.keys(Q),ee=new Set;for(const ne of Object.keys(J))ee.add(ne);if(W.length!==ee.size)return!1;for(const ne of W){if(Q[ne]!==J[ne])return!1;ee.delete(ne)}return ee.size===0}x.equals=H})(I||(e.Translations=I={})),e.$Gp=(0,n.$Xh)("IExtensionsScannerService");let T=class extends b.$Rc{constructor(H,Q,J,W,ee,ne,_,se,X,z,R,F){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=Q,this.r=J,this.s=W,this.t=ee,this.u=ne,this.w=_,this.y=se,this.z=X,this.C=z,this.D=R,this.F=F,this.g=this.B(new r.$Rd),this.onDidChangeCache=this.g.event,this.h=(0,c.$Bg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(U,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,d.$So)(this.w,this.y)),this.G}async scanAllExtensions(H,Q,J){const[W,ee]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(Q)]),ne=J?await this.scanExtensionsUnderDevelopment(H,[...W,...ee]):[];return this.L(W,ee,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const Q=[];Q.push(this.M(!!H.useCache,H.language)),Q.push(this.N(H.language,!!H.checkControlFile));const[J,W]=await Promise.all(Q);return this.J([...J,...W],0,H,!1)}async scanUserExtensions(H){const Q=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const J=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(Q,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,J),ee=H.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let ne;try{ne=await ee.scanExtensions(W)}catch(_){if(_ instanceof v.$Bp&&_.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ne=await ee.scanExtensions(W);else throw _}return ne=await this.J(ne,1,H,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(H,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const J=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===C.Schemas.file).map(async W=>{const ee=await this.P(W,!1,1,!0,H.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(ee)).map(_=>(_.type=Q.find(se=>(0,d.$Ho)(se.identifier,_.identifier))?.type??_.type,this.n.validate(_,ee)))}))).flat();return this.J(J,"development",H,!0)}return[]}async scanExistingExtension(H,Q,J){const W=await this.P(H,!1,Q,!0,J.language,!0,void 0),ee=await this.n.scanExtension(W);return!ee||!J.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(H,Q,J){const W=await this.P(H,!1,Q,!0,J.language,!0,void 0),ee=await this.n.scanOneOrMultipleExtensions(W);return this.J(ee,Q,J,!0)}async scanMetadata(H){const Q=(0,c.$Bg)(H,"package.json"),J=(await this.w.readFile(Q)).value.toString();return JSON.parse(J).__metadata}async updateMetadata(H,Q){const J=(0,c.$Bg)(H,"package.json"),W=(await this.w.readFile(J)).value.toString(),ee=JSON.parse(W);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,ee.__metadata={...ee.__metadata,...Q},await this.w.writeFile((0,c.$Bg)(H,"package.json"),j.$fe.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof v.$Bp&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$fe.fromString(JSON.stringify([])))}catch(Q){(0,o.$xk)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$9)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,Q,J,W){return J.includeAllVersions||(H=this.L(Q===0?H:void 0,Q===1?H:void 0,Q==="development"?H:void 0,await this.getTargetPlatform(),W)),J.includeInvalid||(H=H.filter(ee=>ee.isValid)),H.sort((ee,ne)=>{const _=k.$mc(ee.location.fsPath),se=k.$mc(ne.location.fsPath);return _<se?-1:_>se?1:0})}L(H,Q,J,W,ee){const ne=(se,X,z)=>{if(se.isValid&&!X.isValid)return!1;if(se.isValid===X.isValid){if(ee&&$.gt(se.manifest.version,X.manifest.version))return this.y.debug(`Skipping extension ${X.location.path} with lower version ${X.manifest.version} in favour of ${se.location.path} with version ${se.manifest.version}`),!1;if($.eq(se.manifest.version,X.manifest.version)){if(se.type===0)return this.y.debug(`Skipping extension ${X.location.path} in favour of system extension ${se.location.path} with same version`),!1;if(se.targetPlatform===W)return this.y.debug(`Skipping extension ${X.location.path} from different target platform ${X.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${se.location.path} with ${X.location.path}.`):this.y.debug(`Overwriting user extension ${se.location.path} with ${X.location.path}.`),!0},_=new E.$dm;return H?.forEach(se=>{const X=_.get(se.identifier.id);(!X||ne(X,se,!1))&&_.set(se.identifier.id,se)}),Q?.forEach(se=>{const X=_.get(se.identifier.id);if(!X&&H&&se.type===0){this.y.debug(`Skipping obsolete system extension ${se.location.path}.`);return}(!X||ne(X,se,!1))&&_.set(se.identifier.id,se)}),J?.forEach(se=>{const X=_.get(se.identifier.id);(!X||ne(X,se,!0))&&_.set(se.identifier.id,se),_.set(se.identifier.id,se)}),[..._.values()]}async M(H,Q){this.y.trace("Started scanning system extensions");const J=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),ee=await(H&&!J.devMode?this.j:this.n).scanExtensions(J);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(H,Q){const J=this.z.isBuilt?[]:this.C.builtInExtensions;if(!J?.length)return[];this.y.trace("Started scanning dev system extensions");const W=Q?await this.O():{},ee=[],ne=l.URI.file(k.$gc(k.$ic(C.$ig.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const se of J){const X=W[se.name]||"marketplace";switch(X){case"disabled":break;case"marketplace":ee.push((0,c.$Bg)(ne,se.name));break;default:ee.push(l.URI.file(X));break}}const _=await Promise.all(ee.map(async se=>this.n.scanExtension(await this.P(se,!1,0,!0,H,!0,void 0))));return this.y.trace("Scanned dev system extensions:",_.length),(0,D.$Gb)(_)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,Q,J,W,ee,ne,_){const se=await this.f(ee??g.$w),X=await this.Q(H),z=Q&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,R=z?await this.Q(z):void 0;return new M(H,X,z,R,Q,_,J,W,ne,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,ee,se)}async Q(H){try{const Q=await this.w.stat(H);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$Hp=T,e.$Hp=T=pe([Z(4,m.$Sk),Z(5,v.$Cp),Z(6,o.$gk),Z(7,i.$fj),Z(8,h.$5h),Z(9,t.$xj),Z(10,f.$Qk),Z(11,n.$Wh)],T);class M{constructor(H,Q,J,W,ee,ne,_,se,X,z,R,F,B,N,V){this.location=H,this.mtime=Q,this.applicationExtensionslocation=J,this.applicationExtensionslocationMtime=W,this.profile=ee,this.profileScanOptions=ne,this.type=_,this.excludeObsolete=se,this.validate=X,this.productVersion=z,this.productDate=R,this.productCommit=F,this.devMode=B,this.language=N,this.translations=V}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,Q){return(0,c.$ug)(H.location,Q.location)&&H.mtime===Q.mtime&&(0,c.$ug)(H.applicationExtensionslocation,Q.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&H.profile===Q.profile&&L.$gn(H.profileScanOptions,Q.profileScanOptions)&&H.type===Q.type&&H.excludeObsolete===Q.excludeObsolete&&H.validate===Q.validate&&H.productVersion===Q.productVersion&&H.productDate===Q.productDate&&H.productCommit===Q.productCommit&&H.devMode===Q.devMode&&H.language===Q.language&&I.equals(H.translations,Q.translations)}}e.$Ip=M;let U=class extends b.$Rc{constructor(H,Q,J,W,ee){super(),this.f=H,this.g=Q,this.h=J,this.j=W,this.m=ee}async scanExtensions(H){const Q=H.profile?await this.r(H):await this.n(H);let J={};if(H.excludeObsolete&&H.type===1)try{const W=(await this.j.readFile(this.f)).value.toString();J=JSON.parse(W)}catch{}return(0,w.$Pf)(J)?Q:Q.filter(W=>!J[d.$Io.create(W).toString()])}async n(H){const Q=await this.j.resolve(H.location);if(!Q.children?.length)return[];const J=await Promise.all(Q.children.map(async W=>{if(!W.isDirectory||H.type===1&&(0,c.$yg)(W.resource).indexOf(".")===0)return null;const ee=new M(W.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ee)}));return(0,D.$Gb)(J).sort((W,ee)=>W.location.path<ee.location.path?-1:1)}async r(H){let Q=await this.s(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){Q=Q.filter(W=>!W.metadata?.isApplicationScoped);const J=await this.s(H.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,H);Q.push(...J)}return Q}async s(H,Q,J){const W=await this.g.scanProfileExtensions(H,J.profileScanOptions);if(!W.length)return[];const ee=await Promise.all(W.map(async ne=>{if(Q(ne)){const _=new M(ne.location,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(_,ne.metadata)}return null}));return(0,D.$Gb)(ee)}async scanOneOrMultipleExtensions(H){try{if(await this.j.exists((0,c.$Bg)(H.location,"package.json"))){const Q=await this.scanExtension(H);return Q?[Q]:[]}else return await this.scanExtensions(H)}catch(Q){return this.m.error(`Error scanning extensions at ${H.location.path}:`,(0,O.$9)(Q)),[]}}async scanExtension(H,Q){try{let J=await this.scanExtensionManifest(H.location);if(J){J.publisher||(J.publisher=E.$0l),Q=Q??J.__metadata,delete J.__metadata;const W=(0,d.$Mo)(J.publisher,J.name),ee=Q?.id?{id:W,uuid:Q.id}:{id:W},ne=Q?.isSystem?0:H.type,_=ne===0||!!Q?.isBuiltin;J=await this.t(H.location,J,M.createNlsConfiguration(H));const se={type:ne,identifier:ee,manifest:J,location:H.location,isBuiltin:_,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return H.validate?this.validate(se,H):se}}catch(J){H.type!==0&&this.m.error(J)}return null}validate(H,Q){let J=!0;const W=(0,s.$Xo)(Q.productVersion,Q.productDate,Q.location,H.manifest,H.isBuiltin);for(const[ee,ne]of W)ee===p.default.Error&&(J=!1,this.m.error(this.z(Q.location,ne)));return H.isValid=J,H.validations=W,H}async scanExtensionManifest(H){const Q=(0,c.$Bg)(H,"package.json");let J;try{J=(await this.j.readFile(Q)).value.toString()}catch(ee){return(0,o.$xk)(ee)!==1&&this.m.error(this.z(H,(0,u.localize)(0,null,Q.path,ee.message))),null}let W;try{W=JSON.parse(J)}catch{const ne=[];(0,P.$5m)(J,ne);for(const _ of ne)this.m.error(this.z(H,(0,u.localize)(1,null,Q.path,_.offset,_.length,(0,S.$Ep)(_.error))));return null}return(0,P.$bn)(W)!=="object"?(this.m.error(this.z(H,(0,u.localize)(2,null,Q.path))),null):W}async t(H,Q,J){const W=await this.u(H,Q,J);if(W)try{const ee=[],ne=await this.w(W.default,ee);if(ee.length>0)return ee.forEach(se=>{this.m.error(this.z(H,(0,u.localize)(3,null,W.default?.path,(0,S.$Ep)(se.error))))}),Q;if((0,P.$bn)(W)!=="object")return this.m.error(this.z(H,(0,u.localize)(4,null,W.default?.path))),Q;const _=W.values||Object.create(null);return(0,y.$Fp)(this.m,Q,_,ne)}catch{}return Q}async u(H,Q,J){const W=(0,c.$Bg)(H,"package.nls.json"),ee=(X,z)=>{z.forEach(R=>{this.m.error(this.z(H,(0,u.localize)(5,null,X?.path,(0,S.$Ep)(R.error))))})},ne=X=>{this.m.error(this.z(H,(0,u.localize)(6,null,X?.path)))},_=`${Q.publisher}.${Q.name}`,se=J.translations[_];if(se)try{const X=l.URI.file(se),z=(await this.j.readFile(X)).value.toString(),R=[],F=(0,P.$5m)(z,R);return R.length>0?(ee(X,R),{values:void 0,default:W}):(0,P.$bn)(F)!=="object"?(ne(X),{values:void 0,default:W}):{values:F.contents?F.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.j.exists(W))return;let z;try{z=await this.y(H,J)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const R=(await this.j.readFile(z.localized)).value.toString(),F=[],B=(0,P.$5m)(R,F);return F.length>0?(ee(z.localized,F),{values:void 0,default:z.original}):(0,P.$bn)(B)!=="object"?(ne(z.localized),{values:void 0,default:z.original}):{values:B,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(H,Q){if(H)try{const J=(await this.j.readFile(H)).value.toString();return(0,P.$5m)(J,Q)}catch{}}y(H,Q){return new Promise((J,W)=>{const ee=ne=>{const _=(0,c.$Bg)(H,`package.nls.${ne}.json`);this.j.exists(_).then(se=>{se&&J({localized:_,original:(0,c.$Bg)(H,"package.nls.json")});const X=ne.lastIndexOf("-");X===-1?J({localized:(0,c.$Bg)(H,"package.nls.json"),original:null}):(ne=ne.substring(0,X),ee(ne))})};if(Q.devMode||Q.pseudo||!Q.language)return J({localized:(0,c.$Bg)(H,"package.nls.json"),original:null});ee(Q.language)})}z(H,Q){return`[${H.path}]: ${Q}`}};U=pe([Z(1,v.$Cp),Z(2,f.$Qk),Z(3,o.$gk),Z(4,i.$fj)],U);let q=class extends U{constructor(H,Q,J,W,ee,ne,_){super(Q,W,ee,ne,_),this.G=H,this.H=J,this.D=this.B(new A.$Xg(3e3)),this.F=this.B(new r.$Rd),this.onDidChangeCache=this.F.event}async scanExtensions(H){const Q=this.M(H),J=await this.I(Q);if(this.C=H,J&&J.input&&M.equals(J.input,this.C))return this.m.debug("Using cached extensions scan result",H.location.toString()),this.D.trigger(()=>this.L()),J.result.map(ee=>(ee.location=l.URI.revive(ee.location),ee));const W=await super.scanExtensions(H);return await this.J(Q,{input:H,result:W}),W}async I(H){try{const Q=await this.j.readFile(H),J=JSON.parse(Q.value.toString());return{result:J.result,input:(0,a.$uh)(J.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",H.path,(0,O.$9)(Q))}return null}async J(H,Q){try{await this.j.writeFile(H,j.$fe.fromString(JSON.stringify(Q)))}catch(J){this.m.debug("Error while writing the extension cache file:",H.path,(0,O.$9)(J))}}async L(){if(!this.C)return;const H=this.M(this.C),Q=await this.I(H);if(!Q)return;const J=Q.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!L.$gn(W,J))try{this.m.info("Invalidating Cache",J,W),await this.j.del(H),this.F.fire()}catch(ee){this.m.error(ee)}}M(H){const Q=this.N(H);return this.h.extUri.joinPath(Q.cacheHome,H.type===0?E.$9l:E.$8l)}N(H){return H.type===0?this.H.defaultProfile:H.profile?this.h.extUri.isEqual(H.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(H.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};q=pe([Z(2,m.$Sk),Z(3,v.$Cp),Z(4,f.$Qk),Z(5,o.$gk),Z(6,i.$fj)],q);function Y(x,H){const Q=(0,d.$Ko)(x.manifest.publisher,x.manifest.name);return{id:Q,identifier:new E.$bm(Q),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:H,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$Jp=Y;class K extends T{constructor(H,Q,J,W,ee,ne,_,se,X,z,R,F){super(H,Q,(0,c.$Bg)(J,".vscode-oss-dev","extensions","control.json"),W,ee,ne,_,se,X,z,R,F),this.R=(async()=>{if(g.$z)try{const B=await this.w.readFile(l.URI.file(g.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(H){return this.R}}e.$Kp=K}),define(ae[245],ce([0,1,66,6,38,3,2,23,16,31,8,17]),function(ie,e,D,A,L,j,O,P,S,b,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;let g=class extends O.$Rc{constructor($,p){super(),this.b=$,this.f=p,this.a=new A.$6g(5)}async postUninstall($){const p=this.g($,"uninstall");p&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(w){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(w)}}));try{await b.Promises.rm(this.m($))}catch(w){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(w)}}g($,p){const w=`vscode:${p}`;if($.location.scheme===P.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[w]=="string"){const l=$.manifest.scripts[w].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn($.identifier.id,$.manifest.version,`${w} should be a node script`),null):{script:(0,S.$ic)($.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h($,p,w,l,u){return new Promise((h,d)=>{const E=this.j($,p,w,u);let s;const o=n=>{s&&(clearTimeout(s),s=null),n?d(n):h(void 0)};E.on("error",n=>{o((0,L.$Ii)(n)||"Unknown")}),E.on("exit",(n,i)=>{o(n?`post-${p} process exited with code ${n}`:void 0)}),l&&(s=setTimeout(()=>{s=null,E.kill(),d("timed out")},5e3))})}j($,p,w,l){const u={silent:!0,execArgv:void 0},h=(0,D.fork)($,[`--type=extension-post-${p}`,...w],u);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const d=j.Event.fromNodeEventEmitter(h.stdout,"data"),E=j.Event.fromNodeEventEmitter(h.stderr,"data");d(n=>this.f.info(l.identifier.id,l.manifest.version,`post-${p}`,n)),E(n=>this.f.error(l.identifier.id,l.manifest.version,`post-${p}`,n));const s=j.Event.any(j.Event.map(d,n=>({data:`%c${n}`,format:[""]})),j.Event.map(E,n=>({data:`%c${n}`,format:["color: red"]})));return j.Event.debounce(s,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(l.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),h}m($){return(0,S.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$Mp=g,e.$Mp=g=pe([Z(0,k.$Sk),Z(1,C.$fj)],g)}),define(ae[113],ce([0,1,6,15,26,38,7,3,52,2,34,23,16,19,54,12,10,32,31,69,155,96,14,244,29,33,51,81,224,245,183,213,225,70,11,4,8,25,22,28,17]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l,u,h,d,E,s,o,n,i,t,r,a,v,m,f,y,I,T,M,U,q,Y,K,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=e.$Rp=e.$Qp=void 0,e.$Qp=(0,M.$Yh)(n.$ho);const H=".vsctmp";let Q=class extends o.$xp{constructor(X,z,R,F,B,N,V,G,te,oe,ue,he){super(X,z,ue,R,oe,he),this.fb=B,this.gb=N,this.hb=V,this.ib=te,this.eb=new Map,this.rb=new C.$Ac;const ge=this.B(G.createInstance(v.$Mp));this.bb=this.B(G.createInstance(J,we=>ge.postUninstall(we))),this.cb=this.B(new f.$Op(he,te,ue,this,this.F)),this.db=this.B(G.createInstance(a.$Lp));const de=this.B(new y.$Pp(this,this.fb,he,N,ue,te,R));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$So)(this.ib,this.F)),this.jb}async zip(X){this.F.trace("ExtensionManagementService#zip",X.identifier.id);const z=await this.pb(X),R=await(0,h.zip)((0,c.$Bg)(this.db.extensionsDownloadDir,(0,l.$kg)()).fsPath,z);return w.URI.file(R)}async unzip(X){return this.F.trace("ExtensionManagementService#unzip",X.toString()),(await this.install(X)).identifier}async getManifest(X){const{location:z,cleanup:R}=await this.lb(X),F=g.$jc(z.fsPath);try{return await(0,m.$Np)(F)}finally{await R()}}getInstalled(X,z=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(X??null,z)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(X){return this.bb.scanUserExtensionAtLocation(X)}async install(X,z={}){this.F.trace("ExtensionManagementService#install",X.toString());const{location:R,cleanup:F}=await this.lb(X);try{const B=await(0,m.$Np)(g.$jc(R.fsPath)),N=(0,i.$Mo)(B.publisher,B.name);if(B.engines&&B.engines.vscode&&!(0,I.$Zo)(B.engines.vscode,this.G.version,this.G.date))throw new Error(d.localize(0,null,N,this.G.version));const G=(await this.I([{manifest:B,extension:R,options:z}])).find(({identifier:te})=>(0,i.$Ho)(te,{id:N}));if(G?.local)return G.local;throw G?.error?G.error:(0,o.$zp)(new Error(`Unknown error while installing extension ${N}`))}finally{await F()}}async installFromLocation(X,z){this.F.trace("ExtensionManagementService#installFromLocation",X.toString());const R=await this.bb.scanUserExtensionAtLocation(X);if(!R)throw new Error(`Cannot find a valid extension from the location ${X.toString()}`);return await this.ub([[R,void 0]],z),this.F.info("Successfully installed extension",R.identifier.id,z.toString()),R}async installExtensionsFromProfile(X,z,R){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",X,z.toString(),R.toString());const F=(await this.bb.scanExtensions(1,z)).filter(B=>X.some(N=>(0,i.$Ho)(N,B.identifier)));if(F.length){const B=await Promise.all(F.map(N=>this.bb.scanMetadata(N,z)));await this.ub(F.map((N,V)=>[N,B[V]]),R),this.F.info("Successfully installed extensions",F.map(N=>N.identifier.id),R.toString())}return F}async updateMetadata(X,z,R=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",X.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),X=await this.bb.updateMetadata(X,z,R),this.cb.invalidate(R),this.w.fire(X),X}async reinstallFromGallery(X){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",X.identifier.id),!this.z.isEnabled())throw new Error(d.localize(1,null));const z=await this.getTargetPlatform(),[R]=await this.z.getExtensions([{...X.identifier,preRelease:X.preRelease}],{targetPlatform:z,compatible:!0},L.CancellationToken.None);if(!R)throw new Error(d.localize(2,null));await this.bb.setUninstalled(X);try{await this.bb.removeUninstalledExtension(X)}catch(F){throw new Error(d.localize(3,null,(0,j.$Ii)(F)))}return this.installFromGallery(R)}ab(X,z,R,F){return this.bb.copyExtension(X,z,R,F)}copyExtensions(X,z){return this.bb.copyExtensions(X,z)}markAsUninstalled(...X){return this.bb.setUninstalled(...X)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(X){this.F.error(X)}}async download(X,z,R){const{location:F}=await this.db.download(X,z,!R);return F}async lb(X){if(X.scheme===k.Schemas.file)return{location:X,async cleanup(){}};this.F.trace("Downloading extension from",X.toString());const z=(0,c.$Bg)(this.db.extensionsDownloadDir,(0,l.$kg)());return await this.hb.download(X,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(F){this.F.error(F)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(X,z,R){if(w.URI.isUri(z))return new ne(X,z,R,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const F=i.$Io.create(z).toString();let B=this.eb.get(F);return B||(this.eb.set(F,B=new ee(X,z,R,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),B.waitUntilTaskIsFinished().finally(()=>this.eb.delete(F))),B}$(X,z){return new _(X,z.profileLocation,this.gb)}async pb(X){const z=async F=>{let B=await u.Promises.readdir(F);B=B.map(G=>g.$ic(F,G));const N=await Promise.all(B.map(G=>u.Promises.stat(G)));let V=Promise.resolve([]);return N.forEach((G,te)=>{const oe=B[te];G.isFile()&&(V=V.then(ue=>[...ue,oe])),G.isDirectory()&&(V=V.then(ue=>z(oe).then(he=>[...ue,...he])))}),V};return(await z(X.location.fsPath)).map(F=>({path:`extension/${g.$kc(X.location.fsPath,F)}`,localPath:F}))}async qb({added:X,removed:z}){if(z){const R=X&&this.D.extUri.isEqual(z.profileLocation,X.profileLocation)?z.extensions.filter(F=>X.extensions.every(B=>!(0,i.$Ho)(B,F))):z.extensions;for(const F of R)this.F.info("Extensions removed from another source",F.id,z.profileLocation.toString()),this.u.fire({identifier:F,profileLocation:z.profileLocation})}if(X){const F=(await this.bb.scanExtensions(1,X.profileLocation)).filter(B=>X.extensions.some(N=>(0,i.$Ho)(N,B.identifier)));this.s.fire(F.map(B=>(this.F.info("Extensions added from another source",B.identifier.id,X.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:X.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(z=>this.rb.add(z)));const X=await this.ib.resolve(this.fb.userExtensionsLocation);for(const z of X.children??[])z.isDirectory&&this.rb.add(z.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.tb(z)))}async tb(X){if(!X.affects(this.fb.userExtensionsLocation,1))return;const z=[];for(const R of X.rawAdded){if(this.rb.has(R)||!this.D.extUri.isEqual(this.D.extUri.dirname(R),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(R,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(R).startsWith(".")||!(await this.ib.stat(R)).isDirectory)continue;const F=await this.bb.scanUserExtensionAtLocation(R);F&&F.installedTimestamp===void 0&&(this.rb.add(R),z.push(F))}z.length&&(await this.ub(z.map(R=>[R,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(R=>R.identifier.id)))}async ub(X,z){const R=X.map(F=>F[0]);await this.vb(R),await this.gb.addExtensionsToProfile(X,z),this.s.fire(R.map(F=>({local:F,identifier:F.identifier,operation:1,profileLocation:z})))}async vb(X){const z=await this.bb.getUninstalledExtensions();for(const R of X){const F=i.$Io.create(R);z[F.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",F.id),await this.bb.setInstalled(F),this.F.info("Removed the extension from uninstalled list:",F.id))}}};e.$Rp=Q,e.$Rp=Q=pe([Z(0,n.$fo),Z(1,Y.$kl),Z(2,U.$fj),Z(3,s.$6h),Z(4,r.$Gp),Z(5,t.$Cp),Z(6,E.$Wn),Z(7,M.$Wh),Z(8,T.$gk),Z(9,q.$xj),Z(10,K.$Qk),Z(11,x.$Sk)],Q);let J=class extends b.$Rc{constructor(X,z,R,F,B,N){super(),this.j=X,this.m=z,this.n=R,this.s=F,this.t=B,this.u=N,this.h=this.B(new P.$Rd),this.onExtract=this.h.event,this.c=(0,c.$Bg)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$7g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(X,z){const R={includeInvalid:!0,profileLocation:z};let F=[];return X===null||X===0?F.push(...await this.n.scanAllExtensions({includeInvalid:!0},R,!1)):X===1&&F.push(...await this.n.scanUserExtensions(R)),F=X!==null?F.filter(B=>B.type===X):F,Promise.all(F.map(B=>this.F(B)))}async scanAllUserExtensions(X){const z=await this.n.scanUserExtensions({includeAllVersions:!X,includeInvalid:!0});return Promise.all(z.map(R=>this.F(R)))}async scanUserExtensionAtLocation(X){try{const z=await this.n.scanExistingExtension(X,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(X,z,R,F,B){const N=X.toString(),V=w.URI.file(g.$ic(this.n.userExtensionsLocation.fsPath,`.${(0,l.$kg)()}`)),G=w.URI.file(g.$ic(this.n.userExtensionsLocation.fsPath,N));let te=await this.m.exists(G);if(te&&F){try{await this.y(X.id,G,"removeExisting")}catch{throw new n.$go(d.localize(4,null,G.fsPath,X.id),n.ExtensionManagementErrorCode.Delete)}te=!1}if(!te)try{try{this.u.trace(`Started extracting the extension from ${z} to ${G.fsPath}`),await(0,h.$vp)(z,V.fsPath,{sourcePath:"extension",overwrite:!0},B),this.u.info(`Extracted extension to ${G}:`,X.id)}catch(oe){let ue=n.ExtensionManagementErrorCode.Extract;throw oe instanceof h.$tp&&(oe.type==="CorruptZip"?ue=n.ExtensionManagementErrorCode.CorruptZip:oe.type==="Incomplete"&&(ue=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$go(oe.message,ue)}await this.n.updateMetadata(V,R);try{this.u.trace(`Started renaming the extension from ${V.fsPath} to ${G.fsPath}`),await this.C(V.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(oe){if(oe.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",X.id);else throw this.u.info(`Rename failed because of ${(0,O.$9)(oe)}. Deleted from extracted location`,V),oe}this.h.fire(G)}catch(oe){try{await this.m.del(V,{recursive:!0})}catch{}throw oe}return this.D(G,1)}async scanMetadata(X,z){return z?(await this.w(X,z))?.metadata:this.n.scanMetadata(X.location)}async w(X,z){return(await this.s.scanProfileExtensions(z)).find(F=>(0,i.$Ho)(F.identifier,X.identifier))}async updateMetadata(X,z,R){return R?await this.s.updateMetadata([[X,z]],R):await this.n.updateMetadata(X.location,z),this.D(X.location,X.type,R)}getUninstalledExtensions(){return this.z()}async setUninstalled(...X){const z=X.map(R=>i.$Io.create(R));await this.z(R=>z.forEach(F=>{R[F.toString()]=!0,this.u.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(X){await this.z(z=>delete z[X.toString()])}async removeExtension(X,z){if(this.t.extUri.isEqualOrParent(X.location,this.n.userExtensionsLocation))return this.y(X.identifier.id,X.location,z)}async removeUninstalledExtension(X){await this.removeExtension(X,"uninstalled"),await this.z(z=>delete z[i.$Io.create(X).toString()])}async copyExtension(X,z,R,F){const B=await this.w(X,z),N=await this.w(X,R);return F={...B?.metadata,...F},N?await this.s.updateMetadata([[X,{...N.metadata,...F}]],R):await this.s.addExtensionsToProfile([[X,F]],R),this.D(X.location,X.type,R)}async copyExtensions(X,z){const R=await this.scanExtensions(1,X),F=await Promise.all(R.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,X)]));await this.s.addExtensionsToProfile(F,z)}async y(X,z,R){this.u.trace(`Deleting ${R} extension from disk`,X,z.fsPath);const F=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,S.$Li)((0,l.$kg)()).toString(16)}${H}`);await this.C(z.fsPath,F.fsPath),await this.m.del(F,{recursive:!0}),this.u.info(`Deleted ${R} extension from disk`,X,z.fsPath)}async z(X){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(F){if((0,T.$xk)(F)!==1)throw F}let R={};if(z)try{R=JSON.parse(z)}catch{}return X&&(X(R),Object.keys(R).length?await this.m.writeFile(this.c,A.$fe.fromString(JSON.stringify(R))):await this.m.del(this.c)),R})}async C(X,z){try{await u.Promises.rename(X,z,2*60*1e3)}catch(R){throw new n.$go(R.message||d.localize(5,null,X,z),R.code||n.ExtensionManagementErrorCode.Rename)}}async D(X,z,R){if(R){const B=(await this.n.scanUserExtensions({profileLocation:R})).find(N=>this.t.extUri.isEqual(N.location,X));if(B)return this.F(B)}else{const F=await this.n.scanExistingExtension(X,z,{includeInvalid:!0});if(F)return this.F(F)}throw new Error(d.localize(6,null,X.path))}async F(X){const z=await this.m.resolve(X.location);let R,F;return z.children&&(R=z.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,F=z.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:X.identifier,type:X.type,isBuiltin:X.isBuiltin||!!X.metadata?.isBuiltin,location:X.location,manifest:X.manifest,targetPlatform:X.targetPlatform,validations:X.validations,isValid:X.isValid,readmeUrl:R,changelogUrl:F,publisherDisplayName:X.metadata?.publisherDisplayName||null,publisherId:X.metadata?.publisherId||null,isApplicationScoped:!!X.metadata?.isApplicationScoped,isMachineScoped:!!X.metadata?.isMachineScoped,isPreReleaseVersion:!!X.metadata?.isPreReleaseVersion,preRelease:!!X.metadata?.preRelease,installedTimestamp:X.metadata?.installedTimestamp,updated:!!X.metadata?.updated,pinned:!!X.metadata?.pinned}}async G(){const X=await this.getUninstalledExtensions();if(Object.keys(X).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(X));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),R=new Set;for(const B of z)X[i.$Io.create(B).toString()]||R.add(B.identifier.id.toLowerCase());try{const B=(0,i.$No)(z,N=>N.identifier);await D.Promises.settled(B.map(async N=>{const V=N.sort((G,te)=>$.rcompare(G.manifest.version,te.manifest.version))[0];R.has(V.identifier.id.toLowerCase())||await this.j(await this.F(V))}))}catch(B){this.u.error(B)}const F=z.filter(B=>B.metadata&&X[i.$Io.create(B).toString()]);await Promise.allSettled(F.map(B=>this.removeUninstalledExtension(B)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let X;try{X=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,T.$xk)(z)!==1&&this.u.error(z);return}if(X?.children)try{await Promise.allSettled(X.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(H))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(R){(0,T.$xk)(R)!==1&&this.u.error(R)}}}))}catch{}}};e.$Sp=J,e.$Sp=J=pe([Z(1,T.$gk),Z(2,r.$Gp),Z(3,t.$Cp),Z(4,K.$Qk),Z(5,U.$fj)],J);class W extends o.$Ap{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.$Jf)(this.options.operation)?this.l:this.options.operation}constructor(X,z,R,F,B,N,V,G,te){super(),this.identifier=X,this.source=z,this.options=R,this.m=F,this.n=B,this.o=N,this.p=V,this.q=G,this.s=te,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(X){const[z,R]=await this.x(X);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,R]],this.j),z}async u({zipPath:X,key:z,metadata:R},F,B){let N=await this.v(z);return N||(this.s.trace("Extracting extension...",z.id),N=await this.m.extractUserExtension(z,X,R,F,B),this.s.info("Extracting extension completed.",z.id)),N}async v(X){return await this.w(X)?(this.s.trace("Removing the extension from uninstalled list:",X.id),await this.m.setInstalled(X),this.s.info("Removed the extension from uninstalled list:",X.id),(await this.m.scanAllUserExtensions(!0)).find(F=>i.$Io.create(F).equals(X))):void 0}async w(X){return!!(await this.m.getUninstalledExtensions())[X.toString()]}}class ee extends W{constructor(X,z,R,F,B,N,V,G,te,oe){super(z.identifier,z,R,B,N,V,G,te,oe),this.y=z,this.z=F}async x(X){const R=(await this.m.scanExtensions(null,this.options.profileLocation)).find(V=>(0,i.$Ho)(V.identifier,this.y.identifier));R&&(this.l=3);const F={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||R?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||R?.isMachineScoped,isBuiltin:this.options.isBuiltin||R?.isBuiltin,isSystem:R?.type===0?!0:void 0,updated:!!R,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,p.$If)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:R?.preRelease)};if(R?.manifest.version===this.y.version)return[await this.m.updateMetadata(R,F),F];const{location:B,verificationStatus:N}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=N,this.B(B.fsPath),[await this.u({zipPath:B.fsPath,key:i.$Io.create(this.y),metadata:F},!1,X),F]}catch(V){try{await this.z.delete(B)}catch(G){this.s.warn("Error while deleting the downloaded file",B.toString(),(0,O.$9)(G))}throw V}}async B(X){try{await(0,m.$Np)(X)}catch(z){throw new n.$go((0,o.$yp)(z).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Tp=ee;class ne extends W{constructor(X,z,R,F,B,N,V,G,te,oe){super({id:(0,i.$Mo)(X.publisher,X.name)},z,R,B,N,V,G,te,oe),this.y=X,this.z=z,this.A=F}async h(X){const z=await super.h(X);return this.D(z,X),z}async x(X){const z=new i.$Io(this.identifier,this.y.version),F=(await this.m.scanExtensions(1,this.options.profileLocation)).find(V=>(0,i.$Ho)(this.identifier,V.identifier)),B={isApplicationScoped:this.options.isApplicationScoped||F?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||F?.isMachineScoped,isBuiltin:this.options.isBuiltin||F?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(F)if(this.l=3,z.equals(new i.$Io(F.identifier,F.manifest.version)))try{await this.m.removeExtension(F,"existing")}catch{throw new Error(d.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&$.gt(F.manifest.version,this.y.version)&&await this.m.setUninstalled(F);else{const V=await this.v(z);if(V)try{await this.m.removeExtension(V,"existing")}catch{throw new Error(d.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:g.$jc(this.z.fsPath),key:z,metadata:B},!0,X),B]}async D(X,z){try{let[R]=await this.A.getExtensions([{id:X.identifier.id,version:X.manifest.version}],z);if(R||([R]=await this.A.getExtensions([{id:X.identifier.id}],z)),R){const F={id:R.identifier.uuid,publisherDisplayName:R.publisherDisplayName,publisherId:R.publisherId,isPreReleaseVersion:R.properties.isPreReleaseVersion,preRelease:R.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(X,F,this.options.profileLocation)}}catch{}}}class _ extends o.$Ap{constructor(X,z,R){super(),this.extension=X,this.j=z,this.k=R}async h(X){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ae[246],ce([0,1,8,17,28,22,51,11,14,10]),function(ie,e,D,A,L,j,O,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XN=void 0;let C=class extends O.$Dp{constructor(g,c,$,p,w,l){super(b.URI.file(g.extensionsPath),c,$,p,w,l)}};e.$XN=C,e.$XN=C=pe([Z(0,S.$6h),Z(1,P.$gk),Z(2,A.$Sk),Z(3,L.$Qk),Z(4,j.$kl),Z(5,D.$fj)],C)}),define(ae[247],ce([0,1,10,14,51,81,11,4,8,25,28,17]),function(ie,e,D,A,L,j,O,P,S,b,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R9b=void 0;let g=class extends j.$Kp{constructor($,p,w,l,u,h,d,E){super(D.URI.file(u.builtinExtensionsPath),D.URI.file(u.extensionsPath),u.userHome,$.defaultProfile,$,p,w,l,u,h,d,E)}};e.$R9b=g,e.$R9b=g=pe([Z(0,k.$Sk),Z(1,L.$Cp),Z(2,O.$gk),Z(3,S.$fj),Z(4,A.$6h),Z(5,b.$xj),Z(6,C.$Qk),Z(7,P.$Wh)],g)}),define(ae[21],ce([0,1,6,3,2,100,12,68,4,17]),function(ie,e,D,A,L,j,O,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$bp=e.$ap=e.$_o=void 0,e.$_o="__$__isNewStorageMarker",e.$ap="__$__targetStorageMarker",e.$bp=(0,S.$Xh)("storageService");var C;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var k;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(k||(e.StorageScope=k={}));var g;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function c(u){const h=u.get(e.$ap);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}e.$cp=c;class $ extends L.$Rc{static{this.a=60*1e3}constructor(h={flushInterval:$.a}){super(),this.m=h,this.b=this.B(new A.$Ud),this.c=this.B(new A.$Ud),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$Rd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$_g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,d,E){return A.Event.filter(this.b.event,s=>s.scope===h&&(d===void 0||s.key===d),E)}n(){this.j.value=(0,D.$dh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,d){const{key:E,external:s}=d;if(E===e.$ap){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:E,target:this.J(h)[E],external:s})}w(h){this.f.fire({reason:h})}get(h,d,E){return this.P(d)?.get(h,E)}getBoolean(h,d,E){return this.P(d)?.getBoolean(h,E)}getNumber(h,d,E){return this.P(d)?.getNumber(h,E)}getObject(h,d,E){return this.P(d)?.getObject(h,E)}storeAll(h,d){this.y(()=>{for(const E of h)this.store(E.key,E.value,E.scope,E.target,d)})}store(h,d,E,s,o=!1){if((0,O.$Lf)(d)){this.remove(h,E,o);return}this.y(()=>{this.z(h,E,s),this.P(E)?.set(h,d,o)})}remove(h,d,E=!1){this.y(()=>{this.z(h,d,void 0),this.P(d)?.delete(h,E)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,d){const E=[],s=this.J(h);for(const o of Object.keys(s))s[o]===d&&E.push(o);return E}z(h,d,E,s=!1){const o=this.J(d);typeof E=="number"?o[h]!==E&&(o[h]=E,this.P(d)?.set(e.$ap,JSON.stringify(o),s)):typeof o[h]=="number"&&(delete o[h],this.P(d)?.set(e.$ap,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const d=this.P(h);return d?c(d):Object.create(null)}isNew(h){return this.getBoolean(e.$_o,h)===!0}async flush(h=C.NONE){this.f.fire({reason:h});const d=this.P(-1),E=this.P(0),s=this.P(1);switch(h){case C.NONE:await D.Promises.settled([d?.whenFlushed()??Promise.resolve(),E?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await D.Promises.settled([d?.flush(0)??Promise.resolve(),E?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,d=this.P(0)?.items??new Map,E=this.P(1)?.items??new Map;return l(h,d,E,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,d){return this.w(C.NONE),(0,b.$Rk)(h)?this.R(h,d):this.S(h,d)}M(h,d){return!(h.id===d.id||p(d)&&p(h))}N(h,d,E){this.y(()=>{const s=new Set;for(const[o,n]of h)s.add(o),d.get(o)!==n&&this.u(E,{key:o,external:!0});for(const[o]of d.items)s.has(o)||this.u(E,{key:o,external:!0})})}}e.$dp=$;function p(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$ep=p;class w extends ${constructor(){super(),this.U=this.B(new P.$0o(new P.$$o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$0o(new P.$$o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$0o(new P.$$o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$fp=w;async function l(u,h,d,E,s,o){const n=I=>{try{return JSON.parse(I)}catch{return I}},i=new Map,t=new Map;u.forEach((I,T)=>{i.set(T,I),t.set(T,n(I))});const r=new Map,a=new Map;h.forEach((I,T)=>{r.set(T,I),a.set(T,n(I))});const v=new Map,m=new Map;d.forEach((I,T)=>{v.set(T,I),m.set(T,n(I))}),console.group(E!==s?`Storage: Application (path: ${E})`:`Storage: Application & Profile (path: ${E}, default profile)`);const f=[];if(i.forEach((I,T)=>{f.push({key:T,value:I})}),console.table(f),console.groupEnd(),console.log(t),E!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const I=[];r.forEach((T,M)=>{I.push({key:M,value:T})}),console.table(I),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const y=[];v.forEach((I,T)=>{y.push({key:T,value:I})}),console.table(y),console.groupEnd(),console.log(m)}e.$gp=l}),define(ae[114],ce([0,1,3,2,12,29,33,21]),function(ie,e,D,A,L,j,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RDb=e.$QDb=void 0;let S=class extends A.$Rc{constructor(k,g){super(),this.a=new D.$Rd,this.onDidChangeEnablement=this.a.event,this.b=this.B(new b(k)),this.B(this.b.onDidChange(c=>this.a.fire({extensions:c,source:"storage"}))),this.B(g.onDidInstallExtensions(c=>c.forEach(({local:$,operation:p})=>{$&&p===4&&this.f($.identifier)})))}async enableExtension(k,g){return this.f(k)?(this.a.fire({extensions:[k],source:g}),!0):!1}async disableExtension(k,g){return this.c(k)?(this.a.fire({extensions:[k],source:g}),!0):!1}getDisabledExtensions(){return this.h(j.$io)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(k){const g=this.getDisabledExtensions();return g.every(c=>!(0,O.$Ho)(c,k))?(g.push(k),this.g(g),!0):!1}f(k){const g=this.getDisabledExtensions();for(let c=0;c<g.length;c++){const $=g[c];if((0,O.$Ho)($,k))return g.splice(c,1),this.g(g),!0}return!1}g(k){this.j(j.$io,k)}h(k){return this.b.get(k,0)}j(k,g){this.b.set(k,g,0)}};e.$QDb=S,e.$QDb=S=pe([Z(0,P.$bp),Z(1,j.$ho)],S);class b extends A.$Rc{constructor(k){super(),this.c=k,this.a=Object.create(null),this.b=this.B(new D.$Rd),this.onDidChange=this.b.event,this.B(k.onDidChangeValue(0,void 0,this.B(new A.$Qc))(g=>this.f(g)))}get(k,g){let c;return g===0?((0,L.$Lf)(this.a[k])&&(this.a[k]=this.g(k,g)),c=this.a[k]):c=this.g(k,g),JSON.parse(c)}set(k,g,c){const $=JSON.stringify(g.map(({id:w,uuid:l})=>({id:w,uuid:l})));this.g(k,c)!==$&&(c===0&&(g.length?this.a[k]=$:delete this.a[k]),this.h(k,g.length?$:void 0,c))}f(k){if(!(0,L.$Lf)(this.a[k.key])&&this.g(k.key,k.scope)!==this.a[k.key]){const c=this.get(k.key,k.scope);delete this.a[k.key];const $=this.get(k.key,k.scope),p=c.filter(l=>!$.some(u=>(0,O.$Ho)(l,u))),w=$.filter(l=>!c.some(u=>(0,O.$Ho)(u,l)));(p.length||w.length)&&this.b.fire([...p,...w])}}g(k,g){return this.c.get(k,g,"[]")}h(k,g,c){g?this.c.store(k,g,c,1):this.c.remove(k,c)}}e.$RDb=b}),define(ae[248],ce([0,1,18,26,7,5,37,12,10,20,14,29,33,70,11,8,25,58,226,21,22,62]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l,u,h,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=void 0;const s=j.$o?"web":(0,k.$bo)(j.$u,O.$dc),o="X-Market-Search-Activity-Id";var n;(function(R){R[R.None=0]="None",R[R.IncludeVersions=1]="IncludeVersions",R[R.IncludeFiles=2]="IncludeFiles",R[R.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",R[R.IncludeSharedAccounts=8]="IncludeSharedAccounts",R[R.IncludeVersionProperties=16]="IncludeVersionProperties",R[R.ExcludeNonValidated=32]="ExcludeNonValidated",R[R.IncludeInstallationTargets=64]="IncludeInstallationTargets",R[R.IncludeAssetUri=128]="IncludeAssetUri",R[R.IncludeStatistics=256]="IncludeStatistics",R[R.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",R[R.Unpublished=4096]="Unpublished",R[R.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function i(...R){return String(R.reduce((F,B)=>F|B,0))}var t;(function(R){R[R.Tag=1]="Tag",R[R.ExtensionId=4]="ExtensionId",R[R.Category=5]="Category",R[R.ExtensionName=7]="ExtensionName",R[R.Target=8]="Target",R[R.Featured=9]="Featured",R[R.SearchText=10]="SearchText",R[R.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},m={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class f{constructor(F=m){this.d=F}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(F,B=this.d.pageSize){return new f({...this.d,pageNumber:F,pageSize:B})}withFilter(F,...B){const N=[...this.d.criteria,...B.length?B.map(V=>({filterType:F,value:V})):[{filterType:F}]];return new f({...this.d,criteria:N})}withSortBy(F){return new f({...this.d,sortBy:F})}withSortOrder(F){return new f({...this.d,sortOrder:F})}withFlags(...F){return new f({...this.d,flags:F.reduce((B,N)=>B|N,0)})}withAssetTypes(...F){return new f({...this.d,assetTypes:F})}withSource(F){return new f({...this.d,source:F})}get raw(){const{criteria:F,pageNumber:B,pageSize:N,sortBy:V,sortOrder:G,flags:te,assetTypes:oe}=this.d;return{filters:[{criteria:F,pageNumber:B,pageSize:N,sortBy:V,sortOrder:G}],assetTypes:oe,flags:te}}get searchText(){const F=this.d.criteria.filter(B=>B.filterType===t.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(F=>String(F.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function y(R,F){const B=(R||[]).filter(N=>N.statisticName===F)[0];return B?B.value:0}function I(R){const F="Microsoft.VisualStudio.Code.Translation.";return R.files.filter(N=>N.assetType.indexOf(F)===0).reduce((N,V)=>{const G=U(R,V.assetType);return G&&N.push([V.assetType.substring(F.length),G]),N},[])}function T(R){if(R.properties){const F=R.properties.filter(V=>V.key===r.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),N=F.filter(V=>B.test(V.value))[0];return N?{uri:N.value,fallbackUri:N.value}:null}return U(R,r.Repository)}function M(R){return{uri:`${R.fallbackAssetUri}/${r.VSIX}?redirect=true${R.targetPlatform?`&targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${r.VSIX}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}}function U(R,F){return R.files.filter(N=>N.assetType===F)[0]?{uri:`${R.assetUri}/${F}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${F}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}:null}function q(R,F){const B=R.properties?R.properties.filter(V=>V.key===F):[],N=B.length>0&&B[0].value;return N?N.split(",").map(V=>(0,g.$Lo)(V)):[]}function Y(R){const F=R.properties?R.properties.filter(B=>B.key===a.Engine):[];return F.length>0&&F[0].value||""}function K(R){const F=R.properties?R.properties.filter(B=>B.key===a.PreRelease):[];return F.length>0&&F[0].value==="true"}function x(R){const F=R.properties?R.properties.filter(N=>N.key===a.LocalizedLanguages):[],B=F.length>0&&F[0].value||"";return B?B.split(","):[]}function H(R){return R.properties?.find(F=>F.key===a.SponsorLink)?.value}function Q(R){return R.indexOf("preview")!==-1}function J(R){return R.targetPlatform?(0,k.$ao)(R.targetPlatform):"undefined"}function W(R){const F=(0,D.$Lb)(R.versions.map(J)),B=!!R.tags?.includes(k.$8n),N=F.indexOf("web");return B?N===-1&&F.push("web"):N!==-1&&F.splice(N,1),F}function ee(R,F){for(let B=0;B<R.length;B++){const N=R[B];if(N.version===R[B-1]?.version){let V=B;if(J(N)===F)for(;V>0&&R[V-1].version===N.version;)V--;V!==B&&(R.splice(B,1),R.splice(V,0,N))}}return R}e.$jp=ee;function ne(R,F,B){R.telemetryData={index:F,querySource:B,queryActivityId:R.queryContext?.[o]}}function _(R,F,B,N){const V=R.versions[0],G={manifest:U(F,r.Manifest),readme:U(F,r.Details),changelog:U(F,r.Changelog),license:U(F,r.License),repository:T(F),download:M(F),icon:U(F,r.Icon),signature:U(F,r.Signature),coreTranslations:I(F)};return{identifier:{id:(0,g.$Mo)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},name:R.extensionName,version:F.version,displayName:R.displayName,publisherId:R.publisher.publisherId,publisher:R.publisher.publisherName,publisherDisplayName:R.publisher.displayName,publisherDomain:R.publisher.domain?{link:R.publisher.domain,verified:!!R.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(V),description:R.shortDescription||"",installCount:y(R.statistics,"install"),rating:y(R.statistics,"averagerating"),ratingCount:y(R.statistics,"ratingcount"),categories:R.categories||[],tags:R.tags||[],releaseDate:Date.parse(R.releaseDate),lastUpdated:Date.parse(R.lastUpdated),allTargetPlatforms:B,assets:G,properties:{dependencies:q(F,a.Dependency),extensionPack:q(F,a.ExtensionPack),engine:Y(F),localizedLanguages:x(F),targetPlatform:J(F),isPreReleaseVersion:K(F)},hasPreReleaseVersion:K(V),hasReleaseVersion:!0,preview:Q(R.flags),isSigned:!!G.signature,queryContext:N}}let se=class{constructor(F,B,N,V,G,te,oe,ue){this.k=B,this.l=N,this.n=V,this.o=G,this.q=te,this.u=oe,this.w=ue;const he=oe.extensionsGallery,ge=he?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=ge?he.servicePPEUrl:he?.serviceUrl,this.g=ge?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,u.$ip)(oe.version,oe,this.n,this.w,this.q,F,this.o)}x(F=""){return`${this.d}${F}`}isEnabled(){return!!this.d}async getExtensions(F,B,N){const V=A.CancellationToken.isCancellationToken(B)?{}:B,G=A.CancellationToken.isCancellationToken(B)?B:N,te=[],oe=[],ue=[],he=[];let ge=!0;for(const ve of F){ve.uuid?oe.push(ve.uuid):te.push(ve.id);const Ie=!!(ve.version||ve.preRelease);ue.push({id:ve.id,uuid:ve.uuid,includePreRelease:Ie}),ve.version&&he.push({id:ve.id,uuid:ve.uuid,version:ve.version}),ge=ge&&!!ve.hasPreRelease&&!Ie}if(!oe.length&&!te.length)return[];let de=new f().withPage(1,F.length);oe.length&&(de=de.withFilter(t.ExtensionId,...oe)),te.length&&(de=de.withFilter(t.ExtensionName,...te)),(V.queryAllVersions||ge)&&(de=de.withFlags(de.flags,n.IncludeVersions)),V.source&&(de=de.withSource(V.source));const{extensions:we}=await this.z(de,{targetPlatform:V.targetPlatform??s,includePreRelease:ue,versions:he,compatible:!!V.compatible},G);return V.source&&we.forEach((ve,Ie)=>ne(ve,Ie,V.source)),we}async getCompatibleExtension(F,B,N){if((0,k.$co)(F.allTargetPlatforms,N))return null;if(await this.isExtensionCompatible(F,B,N))return F;const V=new f().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,F.identifier.uuid),{extensions:G}=await this.z(V,{targetPlatform:N,compatible:!0,includePreRelease:B},A.CancellationToken.None);return G[0]||null}async isExtensionCompatible(F,B,N){if(!(0,k.$do)(F.properties.targetPlatform,F.allTargetPlatforms,N)||!B&&F.properties.isPreReleaseVersion)return!1;let V=F.properties.engine;if(!V){const G=await this.getManifest(F,A.CancellationToken.None);if(!G)throw new Error("Manifest was not found");V=G.engines.vscode}return(0,c.$Zo)(V,this.u.version,this.u.date)}async y(F,B,N,V,G){if(!(0,k.$do)(J(F),V,G)||B!=="any"&&K(F)!==(B==="prerelease"))return!1;if(N)try{const te=await this.E(F);if(!(0,c.$Zo)(te,this.u.version,this.u.date))return!1}catch(te){return this.l.error(`Error while getting the engine for the version ${F.version}.`,(0,L.$9)(te)),!1}return!0}async query(F,B){let N=F.text||"";const V=F.pageSize??50;let G=new f().withPage(1,V);N?(N=N.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,de,we)=>(G=G.withFilter(t.Category,we||de),"")),N=N.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,de,we)=>(G=G.withFilter(t.Tag,we||de),"")),N=N.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(t.Featured),"")),N=N.trim(),N&&(N=N.length<200?N:N.substring(0,200),G=G.withFilter(t.SearchText,N)),G=G.withSortBy(0)):F.ids?G=G.withFilter(t.ExtensionId,...F.ids):F.names?G=G.withFilter(t.ExtensionName,...F.names):G=G.withSortBy(4),typeof F.sortBy=="number"&&(G=G.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(G=G.withSortOrder(F.sortOrder)),F.source&&(G=G.withSource(F.source));const te=async(ge,de)=>{const{extensions:we,total:ve}=await this.z(ge,{targetPlatform:s,compatible:!1,includePreRelease:!!F.includePreRelease},de);return we.forEach((Ie,Ne)=>ne(Ie,(ge.pageNumber-1)*ge.pageSize+Ne,F.source)),{extensions:we,total:ve}},{extensions:oe,total:ue}=await te(G,B),he=async(ge,de)=>{if(de.isCancellationRequested)throw new L.$4;const{extensions:we}=await te(G.withPage(ge+1),de);return we};return{firstPage:oe,total:ue,pageSize:G.pageSize,getPage:he}}async z(F,B,N){const V=F.flags;F.flags&n.IncludeLatestVersionOnly&&F.flags&n.IncludeVersions&&(F=F.withFlags(F.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(F.flags&n.IncludeLatestVersionOnly)&&!(F.flags&n.IncludeVersions)&&(F=F.withFlags(F.flags,n.IncludeLatestVersionOnly)),B.versions?.length&&(F=F.withFlags(F.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),F=F.withFlags(F.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:G,total:te,context:oe}=await this.B(F,N);if(!(F.flags&n.IncludeLatestVersionOnly)){const de=[];for(const we of G){const ve=await this.A(we,B,oe);ve&&de.push(ve)}return{extensions:de,total:te}}const he=[],ge=new Map;for(let de=0;de<G.length;de++){const we=G[de],ve={id:(0,g.$Mo)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Ie=(0,P.$If)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(Me=>(0,g.$Ho)(Me,ve))?.includePreRelease;if(B.compatible&&(0,k.$co)(W(we),B.targetPlatform))continue;const Ne=await this.A(we,B,oe);!Ne||Ne.properties.isPreReleaseVersion&&(!Ie||!Ne.hasReleaseVersion)||!Ne.properties.isPreReleaseVersion&&Ne.properties.targetPlatform!==B.targetPlatform&&Ne.hasPreReleaseVersion?ge.set(we.extensionId,de):he.push([de,Ne])}if(ge.size){const de=new E.$Nd,we=new f().withFlags(V&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,ge.size).withFilter(t.ExtensionId,...ge.keys()),{extensions:ve}=await this.z(we,B,N);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:ge.size});for(const Ie of ve){const Ne=ge.get(Ie.identifier.uuid);he.push([Ne,Ie])}}return{extensions:he.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:te}}async A(F,B,N){const V={id:(0,g.$Mo)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},G=B.versions?.find(he=>(0,g.$Ho)(he,V))?.version,te=(0,P.$If)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(he=>(0,g.$Ho)(he,V))?.includePreRelease,oe=W(F),ue=ee(F.versions,B.targetPlatform);if(B.compatible&&(0,k.$co)(oe,B.targetPlatform))return null;for(let he=0;he<ue.length;he++){const ge=ue[he];if(!(G&&ge.version!==G)){if(await this.y(ge,te?"any":"release",B.compatible,oe,B.targetPlatform))return _(F,ge,oe,N);if(G&&ge.version===G)return null}}return G||B.compatible?null:_(F,F.versions[0],oe)}async B(F,B){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(n.Unpublished));const N=await this.j,V=JSON.stringify(F.raw),G={...N,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(V.length)},te=new E.$Nd;let oe,ue,he=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&F.criteria.some(de=>de.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:V,headers:G},B),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:he};const ge=await(0,l.$7o)(oe);if(ge){const de=ge.results[0],we=de.extensions,ve=de.resultMetadata&&de.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return he=ve&&ve.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:he,context:{[o]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(ge){throw ue=ge,ge}finally{this.o.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(V.length),duration:te.elapsed(),success:!!oe&&(0,l.$3o)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:ue?(0,L.$3)(ue)?"canceled":(0,L.$9)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(F,B,N,V){if(!this.isEnabled())return;const G=j.$o?this.x(`/itemName/${F}.${B}/version/${N}/statType/${V==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${F}/extensions/${B}/${N}/stats?statType=${V}`),te=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:G,headers:ue},A.CancellationToken.None)}catch{}}async download(F,B,N){this.l.trace("ExtensionGalleryService#download",F.identifier.id);const V=(0,g.$Po)(F),G=new Date().getTime(),te=de=>this.o.publicLog("galleryService:downloadVSIX",{...V,duration:de}),oe=N===2?"install":N===3?"update":"",ue=oe?{uri:`${F.assets.download.uri}${S.URI.parse(F.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${F.assets.download.fallbackUri}${S.URI.parse(F.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:F.assets.download,he=F.queryContext?.[o]?{[o]:F.queryContext[o]}:void 0,ge=await this.D(ue,he?{headers:he}:void 0);await this.q.writeFile(B,ge.stream),te(new Date().getTime()-G)}async downloadSignatureArchive(F,B){if(!F.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",F.identifier.id);const N=await this.D(F.assets.signature);await this.q.writeFile(B,N.stream)}async getReadme(F,B){if(F.assets.readme){const N=await this.D(F.assets.readme,{},B);return await(0,l.$6o)(N)||""}return""}async getManifest(F,B){if(F.assets.manifest){const N=await this.D(F.assets.manifest,{},B),V=await(0,l.$6o)(N);return V?JSON.parse(V):null}return null}async C(F,B){const N=U(F,r.Manifest);if(!N)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},G=await this.D(N,{headers:V});return await(0,l.$7o)(G)}async getCoreTranslation(F,B){const N=F.assets.coreTranslations.filter(V=>V[0]===B.toUpperCase())[0];if(N){const V=await this.D(N[1]),G=await(0,l.$6o)(V);return G?JSON.parse(G):null}return null}async getChangelog(F,B){if(F.assets.changelog){const N=await this.D(F.assets.changelog,{},B);return await(0,l.$6o)(N)||""}return""}async getAllCompatibleVersions(F,B,N){let V=new f().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);F.identifier.uuid?V=V.withFilter(t.ExtensionId,F.identifier.uuid):V=V.withFilter(t.ExtensionName,F.identifier.id);const{galleryExtensions:G}=await this.B(V,A.CancellationToken.None);if(!G.length)return[];const te=W(G[0]);if((0,k.$co)(te,N))return[];const oe=[];await Promise.all(G[0].versions.map(async ge=>{try{await this.y(ge,B?"any":"release",!0,te,N)&&oe.push(ge)}catch{}}));const ue=[],he=new Set;for(const ge of ee(oe,N))he.has(ge.version)||(he.add(ge.version),ue.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:K(ge)}));return ue}async D(F,B={},N=A.CancellationToken.None){const V=await this.j,G={type:"GET"},te={...V,...B.headers||{}};B={...B,...G,headers:te};const oe=F.uri,ue=F.fallbackUri,he={...B,url:oe};try{const ge=await this.k.request(he,N);if(ge.res.statusCode===200)return ge;const de=await(0,l.$6o)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${de}`)}catch(ge){if((0,L.$3)(ge))throw ge;const de=(0,L.$9)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:de});const we={...B,url:ue};return this.k.request(we,N)}}async E(F){let B=Y(F);if(!B){const N=await this.C(F,A.CancellationToken.None);if(!N)throw new Error("Manifest was not found");B=N.engines.vscode}return B}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const F=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,l.$7o)(F),N=[],V={},G=[];if(B){for(const te of B.malicious)N.push({id:te});if(B.migrateToPreRelease)for(const[te,oe]of Object.entries(B.migrateToPreRelease))(!oe.engine||(0,c.$Zo)(oe.engine,this.u.version,this.u.date))&&(V[te.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(B.deprecated)for(const[te,oe]of Object.entries(B.deprecated))oe&&(V[te.toLowerCase()]=(0,P.$If)(oe)?{}:oe);if(B.search)for(const te of B.search)G.push(te)}return{malicious:N,deprecated:V,search:G}}};se=pe([Z(1,l.$1o),Z(2,p.$fj),Z(3,C.$5h),Z(4,d.$kl),Z(5,$.$gk),Z(6,w.$xj),Z(7,b.$ri)],se);let X=class extends se{constructor(F,B,N,V,G,te,oe,ue){super(F,B,N,V,G,te,oe,ue)}};e.$kp=X,e.$kp=X=pe([Z(0,h.$bp),Z(1,l.$1o),Z(2,p.$fj),Z(3,C.$5h),Z(4,d.$kl),Z(5,$.$gk),Z(6,w.$xj),Z(7,b.$ri)],X);let z=class extends se{constructor(F,B,N,V,G,te,oe){super(void 0,F,B,N,V,G,te,oe)}};e.$lp=z,e.$lp=z=pe([Z(0,l.$1o),Z(1,p.$fj),Z(2,C.$5h),Z(3,d.$kl),Z(4,$.$gk),Z(5,w.$xj),Z(6,b.$ri)],z)}),define(ae[82],ce([0,1,4,3,2,21,33,25,18,8,12]),function(ie,e,D,A,L,j,O,P,S,b,C){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$6u=e.$5u=void 0,e.$5u=(0,D.$Xh)("IExtensionStorageService");const g=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let c=class extends L.$Rc{static{k=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,O.$Lo)(p.id)}@${p.version}`}static c(p){const w=g.exec(p);if(w&&w[1])return{id:w[1],version:w[2]}}static async removeOutdatedExtensionVersions(p,w){const l=await p.getInstalled(),u=[];for(const[h,d]of k.f(w)){const E=l.find(s=>(0,O.$Ho)(s.identifier,{id:h}))?.manifest.version;for(const s of d)E!==s&&u.push(k.b({id:h,version:s}))}for(const h of u)w.remove(h,0)}static f(p){const w=new Map,l=p.keys(0,1);for(const u of l){const h=k.c(u);if(h){let d=w.get(h.id.toLowerCase());d||w.set(h.id.toLowerCase(),d=[]),d.push(h.version)}}return w}constructor(p,w,l){super(),this.j=p,this.m=w,this.n=l,this.g=this.B(new A.$Rd),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=k.f(p),this.B(this.j.onDidChangeValue(0,void 0,this.B(new L.$Qc))(u=>this.r(u)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const w=k.c(p.key);if(w){if(this.j.get(p.key,0)===void 0)this.h.delete(w.id.toLowerCase());else{let l=this.h.get(w.id.toLowerCase());l||this.h.set(w.id.toLowerCase(),l=[]),l.push(w.version),this.g.fire()}return}}s(p){if((0,C.$Cf)(p))return p;const w=p.manifest?p.manifest.publisher:p.publisher,l=p.manifest?p.manifest.name:p.name;return(0,O.$Ko)(w,l)}getExtensionState(p,w){const l=this.s(p),u=this.getExtensionStateRaw(p,w);if(u)try{return JSON.parse(u)}catch(h){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${l}, global: ${w}): ${h}`)}}getExtensionStateRaw(p,w){const l=this.s(p),u=this.j.get(l,w?0:1);return u&&u?.length>k.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${l}, global: ${w}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(p,w,l){const u=this.s(p);w===void 0?this.j.remove(u,l?0:1):this.j.store(u,JSON.stringify(w),l?0:1,1)}setKeysForSync(p,w){this.j.store(k.b(p),JSON.stringify(w),0,1)}getKeysForSync(p){const w=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],l=this.j.get(k.b(p),0),u=l?JSON.parse(l):void 0;return u&&w?(0,S.$Lb)([...u,...w]):u||w}addToMigrationList(p,w){if(p!==w){const l=this.t.filter(u=>!u.includes(p)&&!u.includes(w));l.push([p,w]),this.t=l}}getSourceExtensionToMigrate(p){const w=this.t.find(([,l])=>p===l);return w?w[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",-1,"[]");try{const w=JSON.parse(p);if(Array.isArray(w))return w}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$6u=c,e.$6u=c=k=pe([Z(0,j.$bp),Z(1,P.$xj),Z(2,b.$fj)],c)}),define(ae[249],ce([0,1,2,29,82,223,113,8,21]),function(ie,e,D,A,L,j,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$90b=void 0;let b=class extends D.$Rc{constructor(k,g,c,$,p,w){super(),k.cleanUp(),(0,j.$LXb)(k,g,c,$,w),L.$6u.removeOutdatedExtensionVersions(k,p)}};e.$90b=b,e.$90b=b=pe([Z(0,O.$Qp),Z(1,A.$fo),Z(2,L.$5u),Z(3,A.$ko),Z(4,S.$bp),Z(5,P.$fj)],b)}),define(ae[250],ce([0,1,29,11,25,14,98,56,21,22,222]),function(ie,e,D,A,L,j,O,P,S,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d$b=void 0;let k=class extends C.$o7b{constructor(c,$,p,w,l,u,h,d){super(c.userHome,l,$,p,w,u,h,d)}};e.$d$b=k,e.$d$b=k=pe([Z(0,j.$6h),Z(1,b.$kl),Z(2,D.$ho),Z(3,S.$bp),Z(4,P.$68b),Z(5,O.$vXb),Z(6,A.$gk),Z(7,L.$xj)],k)}),define(ae[251],ce([0,1,105,3,22,14,2,8,16,66,25,5,6,101,20,164,36,21,12,131,19]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l,u,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_0b=void 0;const E=[D.$50b,D.$60b],s="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends O.$Rc{constructor(a,v,m,f,y,I,T){super(),this.y=a,this.z=v,this.C=m,this.D=I,this.F=T,this.f=new A.$Rd,this.onDidTokenFailed=this.f.event,this.g=new A.$Rd,this.onDidChangeTunnelStatus=this.g.event,this.h=new A.$Rd,this.onDidChangeMode=this.h.event,this.n=D.$30b,this.w=!1,this.I=(M,U)=>{U?this.j.error(M):this.j.info(M)},this.j=this.B(f.createLogger((0,d.$Bg)(m.logsHome,`${D.$70b}.log`),{id:D.$70b,name:D.$80b})),this.t=new g.$Wg(100),this.B(this.j.onDidChangeLogLevel(M=>this.j.info("Log level changed to "+(0,P.$uj)(M)))),this.B(y.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(I.onDidChangeConfiguration(M=>{E.some(U=>M.affectsConfiguration(U))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=D.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let a;k.$j?a=this.C.appRoot:a=(0,S.$lc)((0,S.$lc)(this.C.appRoot)),this.u=(0,S.$ic)(a,"bin",`${this.z.tunnelApplicationName}${k.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const a=this.n.asService;this.H(D.$30b);try{a&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}try{await this.O("stop",["kill"])}catch(v){this.j.error(v)}this.G(D.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",v=!1;const m=(U,q)=>{q?this.j.error(U):a+=U,!this.C.isBuilt&&U.startsWith("   Compiling")&&this.G(D.TunnelStates.connecting((0,p.localize)(0,null)))},f=this.O("status",["status"],m);this.r=f;try{if(await f,this.r!==f)return;let U;try{U=JSON.parse(a.trim().split(`
`).find(q=>q.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(D.TunnelStates.disconnected());return}if(v=U.service_installed,this.j.info(U.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!U.tunnel&&!this.n.active){this.G(D.TunnelStates.disconnected());return}}catch(U){this.j.error(U),this.G(D.TunnelStates.disconnected());return}finally{this.r===f&&(this.r=void 0)}const y=this.n.active?this.n.session:void 0;if(y&&y.token){const U=y.token;this.G(D.TunnelStates.connecting((0,p.localize)(1,null,y.accountLabel,y.providerId)));const q=(K,x)=>{K=K.replaceAll(U,"*".repeat(4)),m(K,x)},Y=this.O("login",["user","login","--provider",y.providerId,"--access-token",U,"--log",(0,P.$uj)(this.j.getLevel())],q);this.r=Y;try{if(await Y,this.r!==Y)return}catch(K){this.j.error(K),this.r=void 0,this.f.fire(y),this.G(D.TunnelStates.disconnected(y));return}}const I=this.Q();I?this.G(D.TunnelStates.connecting((0,p.localize)(2,null,I))):this.G(D.TunnelStates.connecting((0,p.localize)(3,null)));const T=["--accept-server-license-terms","--log",(0,P.$uj)(this.j.getLevel())];I?T.push("--name",I):T.push("--random-name");let M=!1;return this.n.active&&this.n.asService&&!v&&(M=await this.M(T)===!1),this.N(y,T,M)}async M(a){let v;try{v=await this.O("serviceInstall",["service","install",...a])}catch(m){this.j.error(m),v=1}if(v!==0){const m=(0,p.localize)(4,null);return this.j.warn(m),this.G(D.TunnelStates.connecting(m)),!1}return!0}async N(a,v,m){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let f=!1;const y=this.O("tunnel",v,(I,T)=>{T?this.j.error(I):this.j.info(I),I.includes("Connected to an existing tunnel process")&&(f=!0);const M=I.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(M){const U={link:M[1],domain:M[2],tunnelName:M[4],isAttached:f};this.G(D.TunnelStates.connected(U,m))}else I.match(/error refreshing token/)&&(y.cancel(),this.f.fire(a),this.G(D.TunnelStates.disconnected(a)))});this.r=y,y.finally(()=>{y===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=D.$30b,this.G(D.TunnelStates.disconnected()))})}O(a,v,m=this.I){return(0,g.$Ng)(f=>new Promise((y,I)=>{f.isCancellationRequested&&y(-1);let T;const M=["ignore","pipe","pipe"];if(f.onCancellationRequested(()=>{T&&(this.j.info(`${a} terminating(${T.pid})`),T.kill())}),!this.C.isBuilt)m(`Building tunnel CLI from sources and run
`,!1),m(`${a} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),T=(0,b.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,S.$ic)(this.C.appRoot,"cli"),stdio:M});else{m(`Running tunnel CLI
`,!1);const U=this.J();m(`${a} Spawning: ${U} tunnel ${v.join(" ")}
`,!1),T=(0,b.spawn)(U,["tunnel",...v],{cwd:(0,w.homedir)(),stdio:M})}T.stdout.pipe(new h.$TT(`
`)).on("data",U=>{if(T){const q=U.toString();m(q,!1)}}),T.stderr.pipe(new h.$TT(`
`)).on("data",U=>{if(T){const q=U.toString();m(q,!0)}}),T.on("exit",U=>{T&&(m(`${a} exit(${T.pid}): + ${U} `,!1),T=void 0,y(U||0))}),T.on("error",U=>{T&&(m(`${a} error(${T.pid}): + ${U} `,!0),T=void 0,I())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(D.$60b)}Q(){let a=this.D.getValue(D.$50b)||(0,w.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(s,-1),v=this.F.getBoolean(o,-1,!1);if(a){const m=JSON.parse(a);if(m&&(0,u.$Cf)(m.accountLabel)&&(0,u.$Cf)(m.sessionId)&&(0,u.$Cf)(m.providerId))return{active:!0,session:m,asService:v};this.j.error("Problems restoring session from storage, invalid format",m)}}catch(a){this.j.error("Problems restoring session from storage",a)}return D.$30b}S(a){if(a.active){const v={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(s,JSON.stringify(v),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(s,-1),this.F.remove(o,-1)}};e.$_0b=n,e.$_0b=n=pe([Z(0,L.$kl),Z(1,C.$xj),Z(2,j.$6h),Z(3,P.$gj),Z(4,c.$00b),Z(5,$.$ri),Z(6,l.$bp)],n);function i(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&i(r.session,a.session):!0}),define(ae[252],ce([0,1,6,2,23,19,68,21,77,17]),function(ie,e,D,A,L,j,O,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e$b=void 0;class C extends P.$dp{constructor(g,c,$,p){super(),this.bb=g,this.cb=c,this.db=$,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new A.$Qc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new A.$Qc),this.ab=this.hb(this.bb)}fb(){const g=this.B(new S.$oEb(this.db.getChannel("storage"))),c=this.B(new O.$0o(g));return this.B(c.onDidChangeStorage($=>this.u(-1,$))),c}gb(g){this.X.clear(),this.W=g;let c;if((0,P.$ep)(g))c=this.U;else{const $=this.X.add(new S.$pEb(this.db.getChannel("storage"),g));c=this.X.add(new O.$0o($))}return this.X.add(c.onDidChangeStorage($=>this.u(0,$))),c}hb(g){this.$.clear(),this.Z=g?.id;let c;if(g){const $=this.$.add(new S.$qEb(this.db.getChannel("storage"),g));c=this.$.add(new O.$0o($)),this.$.add(c.onDidChangeStorage(p=>this.u(1,p)))}return c}async O(){await D.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(g){switch(g){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(g){switch(g){case-1:return this.s.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;default:return this.Z?`${(0,j.$Bg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:L.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(P.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(g){if(!this.M(this.W,g))return;const c=this.Y,$=c.items;c!==this.U&&await c.close(),this.Y=this.gb(g),await this.Y.init(),this.N($,this.Y,0)}async S(g,c){const $=this.ab,p=$?.items??new Map;await $?.close(),this.ab=this.hb(g),await this.ab.init(),this.N(p,this.ab,1)}hasScope(g){return(0,b.$Rk)(g)?this.W.id===g.id:this.Z===g.id}}e.$e$b=C}),define(ae[253],ce([0,1,3,2,17,92]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6N=e.$5N=void 0;class O{constructor(b,C){this.a=b,this.b=C}listen(b,C){const k=this.b(b);switch(C){case"onDidChangeProfiles":return D.Event.map(this.a.onDidChangeProfiles,g=>({all:g.all.map(c=>(0,j.$Vm)({...c},k)),added:g.added.map(c=>(0,j.$Vm)({...c},k)),removed:g.removed.map(c=>(0,j.$Vm)({...c},k)),updated:g.updated.map(c=>(0,j.$Vm)({...c},k))}))}throw new Error(`Invalid listen ${C}`)}async call(b,C,k){const g=this.b(b);switch(C){case"createProfile":{const c=await this.a.createProfile(k[0],k[1],k[2]);return(0,j.$Vm)({...c},g)}case"updateProfile":{let c=(0,L.$Tk)((0,j.$Wm)(k[0],g),this.a.profilesHome.scheme);return c=await this.a.updateProfile(c,k[1]),(0,j.$Vm)({...c},g)}case"removeProfile":{const c=(0,L.$Tk)((0,j.$Wm)(k[0],g),this.a.profilesHome.scheme);return this.a.removeProfile(c)}}throw new Error(`Invalid call ${C}`)}}e.$5N=O;class P extends A.$Rc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(b,C,k){super(),this.profilesHome=C,this.f=k,this.a=[],this.b=this.B(new D.$Rd),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=b.map(g=>(0,L.$Tk)(g,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(g=>{const c=g.added.map(w=>(0,L.$Tk)(w,this.profilesHome.scheme)),$=g.removed.map(w=>(0,L.$Tk)(w,this.profilesHome.scheme)),p=g.updated.map(w=>(0,L.$Tk)(w,this.profilesHome.scheme));this.a=g.all.map(w=>(0,L.$Tk)(w,this.profilesHome.scheme)),this.b.fire({added:c,removed:$,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(b){this.c=b}isEnabled(){return this.c}async createNamedProfile(b,C,k){const g=await this.f.call("createNamedProfile",[b,C,k]);return(0,L.$Tk)(g,this.profilesHome.scheme)}async createProfile(b,C,k,g){const c=await this.f.call("createProfile",[b,C,k,g]);return(0,L.$Tk)(c,this.profilesHome.scheme)}async createTransientProfile(b){const C=await this.f.call("createTransientProfile",[b]);return(0,L.$Tk)(C,this.profilesHome.scheme)}async setProfileForWorkspace(b,C){await this.f.call("setProfileForWorkspace",[b,C])}removeProfile(b){return this.f.call("removeProfile",[b])}async updateProfile(b,C){const k=await this.f.call("updateProfile",[b,C]);return(0,L.$Tk)(k,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$6N=P}),define(ae[59],ce([0,1,2,68,4,21,3,77,17]),function(ie,e,D,A,L,j,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uEb=e.$tEb=e.$sEb=void 0,e.$sEb=(0,L.$Xh)("IUserDataProfileStorageService");let b=class extends D.$Rc{constructor(c){super(),this.a=c}async readStorageData(c){return this.withProfileScopedStorageService(c,async $=>this.b($))}async updateStorageData(c,$,p){return this.withProfileScopedStorageService(c,async w=>this.c(w,$,p))}async withProfileScopedStorageService(c,$){if(this.a.hasScope(c))return $(this.a);const p=await this.g(c),w=new k(p);try{await w.initialize();const l=await $(w);return await w.flush(),l}finally{w.dispose(),await this.f(p)}}b(c){const $=new Map,p=w=>{for(const l of c.keys(0,w))$.set(l,{value:c.get(l,0),target:w})};return p(0),p(1),$}c(c,$,p){c.storeAll(Array.from($.entries()).map(([w,l])=>({key:w,value:l,scope:0,target:p})),!0)}async f(c){try{await c.close()}finally{(0,D.$Lc)(c)&&c.dispose()}}};e.$tEb=b,e.$tEb=b=pe([Z(0,j.$bp)],b);class C extends b{constructor(c,$,p,w){super(p),this.j=c;const l=c.getChannel("profileStorageListener"),u=this.B(new D.$Sc);this.h=this.B(new O.$Rd({onWillAddFirstListener:()=>{u.value=l.listen("onDidChange")(h=>{w.trace("profile storage changes",h),this.h.fire({targetChanges:h.targetChanges.map(d=>(0,S.$Tk)(d,$.profilesHome.scheme)),valueChanges:h.valueChanges.map(d=>({...d,profile:(0,S.$Tk)(d.profile,$.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(c){const $=this.j.getChannel("storage");return(0,j.$ep)(c)?new P.$oEb($):new P.$pEb($,c)}}e.$uEb=C;class k extends j.$dp{constructor(c){super({flushInterval:100}),this.s=this.B(new A.$0o(c))}O(){return this.s.init()}P(c){return c===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(ae[254],ce([0,1,21,8,17,55,59]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V0b=void 0;let P=class extends O.$uEb{constructor(b,C,k,g){super(b,C,k,g)}};e.$V0b=P,e.$V0b=P=pe([Z(0,j.$h0b),Z(1,L.$Sk),Z(2,D.$bp),Z(3,A.$fj)],P)}),define(ae[39],ce([0,1,18,6,15,26,3,35,2,27,12,169,20,14,11,8,43,21,22,28,24,17]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l,u,h,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mFb=e.$lFb=e.$kFb=e.$jFb=e.$iFb=e.$hFb=e.$gFb=void 0;function s(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||o(v.syncData)))}e.$gFb=s;function o(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$hFb=o;function n(v,m){return`${(0,b.$uf)(v)}${m.isDefault?"":` (${m.name})`}`}e.$iFb=n;let i=class extends S.$Rc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(m,f,y,I,T,M,U,q,Y,K,x,H){super(),this.syncResource=m,this.collection=f,this.G=y,this.H=I,this.I=T,this.J=M,this.L=U,this.M=q,this.N=Y,this.O=K,this.P=x,this.c=null,this.m="idle",this.n=this.B(new O.$Rd),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$Rd),this.onDidChangeConflicts=this.t.event,this.u=this.B(new A.$Xg(50)),this.w=this.B(new O.$Rd),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(m.syncResource,m.profile),this.h=H.extUri,this.f=this.h.joinPath(I.userDataSyncHome,...(0,d.$4gb)(m.profile.isDefault?void 0:m.profile.id,m.syncResource)),this.g=this.h.joinPath(this.f,d.$mhb),this.y=(0,d.$5gb)(m.profile.isDefault?void 0:m.profile.id,m.syncResource,I,this.h),this.j=(0,w.$hp)(I,y,T)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const m=await this.c;this.c=null;const f=await this.Y(m.remoteUserData,m.lastSyncUserData,!0,this.ob());this.S(f)}else{this.O.trace(`${this.D}: Checking for local changes...`);const m=await this.getLastSyncUserData();(m?await this.ub(m):!0)&&this.w.fire()}}S(m){this.m!==m&&(this.m=m,this.n.fire(m))}async sync(m,f={}){await this.U(m,!0,this.ob(),f)}async preview(m,f,y={}){return this.U(m,!1,f,y)}async apply(m,f={}){try{this.F={...f};const y=await this.ab(m);return this.S(y),this.c}finally{this.F={}}}async U(m,f,y,I){try{if(this.F={...I},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let T="idle";try{const M=await this.getLastSyncUserData(),U=await this.X(m,M);return T=await this.Y(U,M,f,y),T==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(T)}}finally{this.F={}}}async replace(m){const f=this.kb(m);if(!f)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const y=await this.getLastSyncUserData(),I=await this.X(null,y),T=await this.W(I),M=await this.qb({ref:I.ref,syncData:f},y,T,this.ob(),j.CancellationToken.None),U=[];for(const q of M){const Y=await this.sb(q,q.remoteResource,void 0,j.CancellationToken.None),{remoteChange:K}=await this.sb(q,q.previewResource,q.remoteContent,j.CancellationToken.None);U.push([q,{...Y,remoteChange:K!==0?K:2}])}await this.tb(I,y,U,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(m){const f=await this.j;return!!m.syncData?.machineId&&m.syncData.machineId===f}async X(m,f){if(f){const y=m?m[this.resource]:void 0;if(f.ref===y||y===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async Y(m,f,y,I){if(m.syncData&&m.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new d.$_gb((0,k.localize)(0,null,this.resource,this.pb,m.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(m,f,y,I)}catch(T){if(T instanceof d.$_gb)switch(T.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(m,f,y,I);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),m=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.Y(m,f,y,I)}throw T}}async Z(m,f,y,I){try{const T=await this.W(m),M=!T&&f===null&&this.gb()!==void 0,U=y&&!M;this.c||(this.c=(0,A.$Ng)(Y=>this.eb(m,f,T,U,I,Y)));let q=await this.c;if(y&&M){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Y of q.resourcePreviews)q=await this.accept(Y.remoteResource)||q}return this.cb(q.resourcePreviews),q.resourcePreviews.some(({mergeState:Y})=>Y==="conflict")?"hasConflicts":y?await this.ab(!1):"syncing"}catch(T){throw this.c=null,T}}async merge(m){return await this.$(m,async f=>{const y=await this.rb(f,j.CancellationToken.None);await this.G.writeFile(f.previewResource,L.$fe.fromString(y?.content||""));const I=y&&!y.hasConflicts?await this.sb(f,f.previewResource,void 0,j.CancellationToken.None):void 0;return f.acceptResult=I,f.mergeState=y.hasConflicts?"conflict":I?"accepted":"preview",f.localChange=I?I.localChange:y.localChange,f.remoteChange=I?I.remoteChange:y.remoteChange,f}),this.c}async accept(m,f){return await this.$(m,async y=>{const I=await this.sb(y,m,f,j.CancellationToken.None);return y.acceptResult=I,y.mergeState="accepted",y.localChange=I.localChange,y.remoteChange=I.remoteChange,y}),this.c}async discard(m){return await this.$(m,async f=>{const y=await this.rb(f,j.CancellationToken.None);return await this.G.writeFile(f.previewResource,L.$fe.fromString(y.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=y.localChange,f.remoteChange=y.remoteChange,f}),this.c}async $(m,f){if(!this.c)return;let y=await this.c;const I=y.resourcePreviews.findIndex(({localResource:T,remoteResource:M,previewResource:U})=>this.h.isEqual(T,m)||this.h.isEqual(M,m)||this.h.isEqual(U,m));I!==-1&&(this.c=(0,A.$Ng)(async T=>{const M=[...y.resourcePreviews];return M[I]=await f(M[I]),{...y,resourcePreviews:M}}),y=await this.c,this.cb(y.resourcePreviews),y.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(m){if(!this.c)return"idle";const f=await this.c;return f.resourcePreviews.some(({mergeState:y})=>y==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:y})=>y!=="accepted")?"syncing":(await this.tb(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(y=>[y,y.acceptResult]),m),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(m){const f=m.filter(({mergeState:y})=>y==="conflict");(0,D.$tb)(this.s,f,(y,I)=>this.h.isEqual(y.previewResource,I.previewResource))||(this.s=f,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const m=await this.getLastSyncUserData();return!!m&&m.syncData!==null}async db(m){const f=this.c?await this.c:null;if(f)for(const y of f.resourcePreviews){if(this.h.isEqual(y.acceptedResource,m))return y.acceptResult?y.acceptResult.content:null;if(this.h.isEqual(y.remoteResource,m))return y.remoteContent;if(this.h.isEqual(y.localResource,m))return y.localContent;if(this.h.isEqual(y.baseResource,m))return y.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(m){(0,$.$xk)(m)!==1&&this.O.error(m)}}async eb(m,f,y,I,T,M){const U=await this.qb(m,f,y,T,M),q=[];for(const Y of U){const K=Y.previewResource.with({scheme:d.$lhb,authority:"accepted"});if(Y.localChange===0&&Y.remoteChange===0)q.push({...Y,acceptedResource:K,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=I?await this.rb(Y,M):void 0;if(M.isCancellationRequested)break;await this.G.writeFile(Y.previewResource,L.$fe.fromString(x?.content||""));const H=x&&!x.hasConflicts?await this.sb(Y,Y.previewResource,void 0,M):void 0;q.push({...Y,acceptResult:H,mergeState:x?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:x?x.localChange:Y.localChange,remoteChange:H?H.remoteChange:x?x.remoteChange:Y.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:m,lastSyncUserData:f,resourcePreviews:q,isLastSyncFromCurrentMachine:y}}async getLastSyncUserData(){let m=this.gb();if(m||(m=await this.jb()),!m)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const f=JSON.parse(m),y=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!f.version&&!!y&&f.version!==y,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${y}.`),await this.resetLocal(),null;let I,T=1;for(;I===void 0&&T++<6;)try{const M=await this.hb();M&&(M.ref===f.ref?I=M.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof $.$Bk&&M.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(M instanceof d.$_gb)throw M;this.O.error(M,T)}}if(I===void 0)try{const M=await this.J.resolveResourceContent(this.resource,f.ref,this.collection,this.F);I=M===null?null:this.kb(M),await this.ib({ref:f.ref,syncData:I})}catch(M){if(M instanceof d.$_gb&&M.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw M}return I===void 0?null:{...f,syncData:I}}async fb(m,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const y=this.M.getResourceSyncStateVersion(this.resource),I={ref:m.ref,version:y,...f};this.I.store(this.z,JSON.stringify(I),-1,1),await this.ib(m)}gb(){return this.I.get(this.z,-1)}async hb(){const m=(await this.G.readFile(this.y)).value.toString();try{const f=m?JSON.parse(m):void 0;if(s(f))return f}catch(f){this.O.error(f)}}async ib(m){await this.G.writeFile(this.y,L.$fe.fromString(JSON.stringify(m)))}async jb(){try{const m=await this.G.readFile(this.y),f=JSON.parse(m.value.toString());await this.G.del(this.y),f.ref&&f.content!==void 0?(this.I.store(this.z,JSON.stringify({...f,content:void 0}),-1,1),await this.ib({ref:f.ref,syncData:f.content===null?null:JSON.parse(f.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,f)}catch(m){m instanceof $.$Bk&&m.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(m)}return this.I.get(this.z,-1)}async getRemoteUserData(m){const{ref:f,content:y}=await this.lb(m);let I=null;return y!==null&&(I=this.kb(y)),{ref:f,syncData:I}}kb(m){try{const f=JSON.parse(m);if(o(f))return f}catch(f){this.O.error(f)}throw new d.$_gb((0,k.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(m){const f=m?{ref:m.ref,content:m.syncData?JSON.stringify(m.syncData):null}:null;return this.J.readResource(this.resource,f,this.collection,this.F)}async mb(m,f){const y=await this.j,I={version:this.pb,machineId:y,content:m};try{return f=await this.J.writeResource(this.resource,JSON.stringify(I),f,this.collection,this.F),{ref:f,syncData:I}}catch(T){throw T instanceof d.$_gb&&T.code==="TooLarge"&&(T=new d.$_gb(T.message,T.code,this.resource)),T}}async nb(m){const f={version:this.pb,content:m};return this.L.writeResource(this.resource,JSON.stringify(f),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(d.$Ygb)}};e.$jFb=i,e.$jFb=i=pe([Z(2,$.$gk),Z(3,c.$5h),Z(4,l.$bp),Z(5,d.$7gb),Z(6,d.$8gb),Z(7,d.$ehb),Z(8,u.$kl),Z(9,d.$jhb),Z(10,g.$ri),Z(11,h.$Qk)],i);let t=class extends i{constructor(m,f,y,I,T,M,U,q,Y,K,x,H,Q){super(f,y,I,T,M,U,q,Y,K,x,H,Q),this.r=m,this.B(this.G.watch(this.h.dirname(m))),this.B(this.G.onDidFilesChange(J=>this.yb(J)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(m,f,y){try{f?await this.G.writeFile(this.r,L.$fe.fromString(m),y?void 0:f):await this.G.createFile(this.r,L.$fe.fromString(m),{overwrite:y})}catch(I){throw I instanceof $.$Bk&&I.fileOperationResult===1||I instanceof $.$Bk&&I.fileOperationResult===3?new d.$_gb(I.message,"LocalPreconditionFailed"):I}}async xb(){try{await this.G.del(this.r)}catch(m){if(!(m instanceof $.$Bk&&m.fileOperationResult===1))throw m}}yb(m){m.contains(this.r)&&this.Q()}};e.$kFb=t,e.$kFb=t=pe([Z(3,$.$gk),Z(4,c.$5h),Z(5,l.$bp),Z(6,d.$7gb),Z(7,d.$8gb),Z(8,d.$ehb),Z(9,u.$kl),Z(10,d.$jhb),Z(11,g.$ri),Z(12,h.$Qk)],t);let r=class extends t{constructor(m,f,y,I,T,M,U,q,Y,K,x,H,Q,J){super(m,f,y,I,T,M,U,q,Y,K,x,Q,J),this.zb=H,this.Bb=void 0}Ab(m,f){const y=[],I=(0,P.$5m)(m,y,{allowEmptyContent:!0,allowTrailingComma:!0});return y.length>0||!(0,C.$Jf)(I)&&f!==Array.isArray(I)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$lFb=r,e.$lFb=r=pe([Z(3,$.$gk),Z(4,c.$5h),Z(5,l.$bp),Z(6,d.$7gb),Z(7,d.$8gb),Z(8,d.$ehb),Z(9,u.$kl),Z(10,d.$jhb),Z(11,d.$ihb),Z(12,g.$ri),Z(13,h.$Qk)],r);let a=class{constructor(m,f,y,I,T,M,U){this.resource=m,this.g=f,this.h=y,this.j=I,this.k=T,this.l=M,this.d=U.extUri,this.f=(0,d.$5gb)(void 0,this.resource,y,this.d)}async initialize({ref:m,content:f}){if(!f){this.j.info("Remote content does not exist.",this.resource);return}const y=this.m(f);if(y)try{await this.o({ref:m,syncData:y})}catch(I){this.j.error(I)}}m(m){try{const f=JSON.parse(m);if(o(f))return f}catch(f){this.j.error(f)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(m,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const y={ref:m.ref,version:void 0,...f};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(y),-1,1),await this.k.writeFile(this.f,L.$fe.fromString(JSON.stringify(m)))}};e.$mFb=a,e.$mFb=a=pe([Z(1,E.$Sk),Z(2,c.$5h),Z(3,p.$fj),Z(4,$.$gk),Z(5,l.$bp),Z(6,h.$Qk)],a)}),define(ae[115],ce([0,1,6,26,7,3,42,2,27,20,14,114,29,33,82,44,11,4,73,8,21,22,28,17,39,234,111,24,59]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l,u,h,d,E,s,o,n,i,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y5b=e.$x5b=e.$w5b=e.$v5b=e.$u5b=void 0;async function v(M,U){const q=JSON.parse(M.content);if(M.version===1||M.version===2){const Y=(await U.getInstalled(0)).filter(K=>K.isBuiltin);for(const K of q)M.version===1&&(K.enabled===!1&&(K.disabled=!0),delete K.enabled),M.version===2&&Y.every(x=>!(0,c.$Ho)(x.identifier,K.identifier))&&(K.installed=!0)}return q}function m(M){return JSON.parse(M.content)}e.$u5b=m;function f(M,U){return M.sort((q,Y)=>!q.identifier.uuid&&Y.identifier.uuid?-1:q.identifier.uuid&&!Y.identifier.uuid?1:(0,S.$Ye)(q.identifier.id,Y.identifier.id)),U?(0,O.$wT)(M,{}):JSON.stringify(M)}e.$v5b=f;let y=class extends n.$jFb{constructor(U,q,Y,K,x,H,Q,J,W,ee,ne,_,se,X,z,R,F){super({syncResource:"extensions",profile:U},q,K,Y,x,H,Q,_,se,ee,ne,z),this.Cb=J,this.Db=W,this.Eb=F,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$lhb,authority:"base"}),this.yb=this.wb.with({scheme:r.$lhb,authority:"local"}),this.zb=this.wb.with({scheme:r.$lhb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$lhb,authority:"accepted"}),this.Bb=this.Eb.createInstance(I),this.B(j.Event.any(j.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:N})=>!!N)),j.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),j.Event.filter(R.onDidChange,B=>B.valueChanges.some(({profile:N,changes:V})=>this.syncResource.profile.id===N.id&&V.some(G=>G.key===g.$io))),X.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(U,q){const Y=U.syncData?await v(U.syncData,this.Cb):null,K=q?.skippedExtensions??[],x=q?.builtinExtensions??null,H=q?.syncData?await v(q.syncData,this.Cb):null,{localExtensions:Q,ignoredExtensions:J}=await this.Bb.getLocalExtensions(this.syncResource.profile);Y?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:W,remote:ee}=(0,i.$t5b)(Q,Y,H,K,J,x),ne={local:W,remote:ee,content:this.Hb(Q,W.added,W.updated,W.removed),localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:ee!==null?2:0},_=this.Ob(Q,!1);return[{skippedExtensions:K,builtinExtensions:x,baseResource:this.xb,baseContent:H?this.Ob(H,!1):_,localResource:this.yb,localContent:_,localExtensions:Q,remoteResource:this.zb,remoteExtensions:Y,remoteContent:Y?this.Ob(Y,!1):null,previewResource:this.wb,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.Ab}]}async ub(U){const q=U.syncData?await v(U.syncData,this.Cb):null,{localExtensions:Y,ignoredExtensions:K}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,i.$t5b)(Y,q,q,U.skippedExtensions||[],K,U.builtinExtensions||[]);return x!==null}Hb(U,q,Y,K){const x=[...q,...Y],H=new Set,Q=J=>{H.add(J.id.toLowerCase()),J.uuid&&H.add(J.uuid)};x.forEach(({identifier:J})=>Q(J)),K.forEach(Q);for(const J of U)H.has(J.identifier.id.toLowerCase())||J.identifier.uuid&&H.has(J.identifier.uuid)||x.push(J);return this.Ob(x,!1)}async rb(U,q){return{...U.previewResult,hasConflicts:!1}}async sb(U,q,Y,K){if(this.h.isEqual(q,this.yb))return this.Kb(U);if(this.h.isEqual(q,this.zb))return this.Lb(U);if(this.h.isEqual(q,this.wb))return U.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Kb(U){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),K=(0,i.$t5b)(U.localExtensions,null,null,U.skippedExtensions,Y,U.builtinExtensions),{local:x,remote:H}=K;return{content:U.localContent,local:x,remote:H,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:H!==null?2:0}}async Lb(U){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),K=U.remoteContent?JSON.parse(U.remoteContent):null;if(K!==null){const x=(0,i.$t5b)(U.localExtensions,K,U.localExtensions,[],Y,U.builtinExtensions),{local:H,remote:Q}=x;return{content:U.remoteContent,local:H,remote:Q,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:Q!==null?2:0}}else return{content:U.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(U,q,Y,K){let{skippedExtensions:x,builtinExtensions:H,localExtensions:Q}=Y[0][0];const{local:J,remote:W,localChange:ee,remoteChange:ne}=Y[0][1];if(ee===0&&ne===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ee!==0&&(await this.nb(JSON.stringify(Q)),x=await this.Bb.updateLocalExtensions(J.added,J.removed,J.updated,x,this.syncResource.profile)),W){this.O.trace(`${this.D}: Updating remote extensions...`);const _=JSON.stringify(W.all);U=await this.mb(_,K?null:U.ref),this.O.info(`${this.D}: Updated remote extensions.${W.added.length?` Added: ${JSON.stringify(W.added.map(se=>se.identifier.id))}.`:""}${W.updated.length?` Updated: ${JSON.stringify(W.updated.map(se=>se.identifier.id))}.`:""}${W.removed.length?` Removed: ${JSON.stringify(W.removed.map(se=>se.identifier.id))}.`:""}`)}q?.ref!==U.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(Q,H),await this.fb(U,{skippedExtensions:x,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(_=>_.identifier.id))}.`:""}`))}Nb(U,q){const Y=new Set,K=[];for(const x of U)Y.add(x.identifier.id.toLowerCase()),x.installed||K.push(x.identifier);if(q)for(const x of q)Y.has(x.id.toLowerCase())||K.push(x);return K}async resolveContent(U){if(this.h.isEqual(this.zb,U)||this.h.isEqual(this.xb,U)||this.h.isEqual(this.yb,U)||this.h.isEqual(this.Ab,U)){const q=await this.db(U);return q&&this.Ob(JSON.parse(q),!0)}return null}Ob(U,q){return f(U,q)}async hasLocalData(){try{const{localExtensions:U}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(U.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.$w5b=y,e.$w5b=y=pe([Z(2,C.$5h),Z(3,w.$gk),Z(4,d.$bp),Z(5,r.$7gb),Z(6,r.$8gb),Z(7,g.$ho),Z(8,t.$4Fb),Z(9,r.$jhb),Z(10,b.$ri),Z(11,r.$ehb),Z(12,E.$kl),Z(13,$.$5u),Z(14,s.$Qk),Z(15,a.$sEb),Z(16,l.$Wh)],y);let I=class{constructor(U,q,Y,K,x,H){this.a=U,this.b=q,this.c=Y,this.d=K,this.f=x,this.g=H}async getLocalExtensions(U){const q=await this.a.getInstalled(void 0,U.extensionsResource),Y=this.d.getIgnoredExtensions(q);return{localExtensions:await this.j(U,async(x,H)=>{const Q=x.getDisabledExtensions();return q.map(J=>{const{identifier:W,isBuiltin:ee,manifest:ne,preRelease:_,pinned:se,isApplicationScoped:X}=J,z={identifier:W,preRelease:_,version:ne.version,pinned:!!se};X&&!(0,p.$em)(ne)&&(z.isApplicationScoped=X),Q.some(R=>(0,c.$Ho)(R,W))&&(z.disabled=!0),ee||(z.installed=!0);try{const R=H.getKeysForSync({id:W.id,version:ne.version});if(R){const F=H.getExtensionState(J,!0)||{};z.state=Object.keys(F).reduce((B,N)=>(R.includes(N)&&(B[N]=F[N]),B),{})}}catch(R){this.g.info(`${(0,n.$iFb)("extensions",U)}: Error while parsing extension state`,(0,L.$9)(R))}return z})}),ignoredExtensions:Y}}async updateLocalExtensions(U,q,Y,K,x){const H=(0,n.$iFb)("extensions",x),Q=[],J=new Map,W=[],ee=[],ne=await this.a.getInstalled(void 0,x.extensionsResource);if((U.length||Y.length)&&await this.j(x,async(X,z)=>{await D.Promises.settled([...U,...Y].map(async R=>{const F=ne.find(V=>(0,c.$Ho)(V.identifier,R.identifier));if(F&&F.isBuiltin){R.state&&F.manifest.version===R.version&&this.h(R.state,F,F.manifest.version,z),X.getDisabledExtensions().some(G=>(0,c.$Ho)(G,R.identifier))!==!!R.disabled&&(R.disabled?(this.g.trace(`${H}: Disabling extension...`,R.identifier.id),await X.disableExtension(R.identifier),this.g.info(`${H}: Disabled extension`,R.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,R.identifier.id),await X.enableExtension(R.identifier),this.g.info(`${H}: Enabled extension`,R.identifier.id))),W.push(R.identifier);return}const B=R.pinned?R.version:void 0,N=(await this.c.getExtensions([{...R.identifier,version:B,preRelease:B?void 0:R.preRelease}],A.CancellationToken.None))[0];if(R.state&&(F?F.manifest.version===R.version:N)&&this.h(R.state,F||N,F?.manifest.version,z),N)try{X.getDisabledExtensions().some(G=>(0,c.$Ho)(G,R.identifier))!==!!R.disabled&&(R.disabled?(this.g.trace(`${H}: Disabling extension...`,R.identifier.id,N.version),await X.disableExtension(N.identifier),this.g.info(`${H}: Disabled extension`,R.identifier.id,N.version)):(this.g.trace(`${H}: Enabling extension...`,R.identifier.id,N.version),await X.enableExtension(N.identifier),this.g.info(`${H}: Enabled extension`,R.identifier.id,N.version))),(!F||F.preRelease!==R.preRelease||F.pinned!==R.pinned||B&&F.manifest.version!==B)&&(await this.a.canInstall(N)?(Q.push({extension:N,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:R.pinned&&!!R.version,installPreReleaseVersion:R.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:R.isApplicationScoped,context:{[g.$9n]:!0,[g.$0n]:!0}}}),J.set(N.identifier.id.toLowerCase(),R)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,N.displayName||N.identifier.id),ee.push(R)))}catch(V){ee.push(R),this.g.error(V),this.g.info(`${H}: Skipped synchronizing extension`,N.displayName||N.identifier.id)}else ee.push(R),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,R.identifier.id)}))}),q.length){const X=ne.filter(({identifier:z,isBuiltin:R})=>!R&&q.some(F=>(0,c.$Ho)(z,F)));await D.Promises.settled(X.map(async z=>{this.g.trace(`${H}: Uninstalling local extension...`,z.identifier.id),await this.a.uninstall(z,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,z.identifier.id),W.push(z.identifier)}))}const _=await this.a.installGalleryExtensions(Q);for(const{identifier:X,local:z,error:R,source:F}of _){const B=F;if(z)this.g.info(`${H}: Installed extension.`,X.id,B.version),W.push(X);else{const N=J.get(X.id.toLowerCase());N&&(ee.push(N),this.g.info(`${H}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),R instanceof g.$go&&[g.ExtensionManagementErrorCode.Incompatible,g.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(R.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):R&&this.g.error(R)}}const se=[];for(const X of K)W.some(z=>(0,c.$Ho)(z,X.identifier))||se.push(X);for(const X of ee)se.some(z=>(0,c.$Ho)(z.identifier,X.identifier))||se.push(X);return se}h(U,q,Y,K){const x=K.getExtensionState(q,!0)||{},H=Y?K.getKeysForSync({id:q.identifier.id,version:Y}):void 0;H?H.forEach(Q=>{x[Q]=U[Q]}):Object.keys(U).forEach(Q=>x[Q]=U[Q]),K.setExtensionState(q,x,!0)}async j(U,q){return this.b.withProfileScopedStorageService(U,async Y=>{const K=new P.$Qc,x=this.f.createChild(new u.$Vh([d.$bp,Y])),H=K.add(x.createInstance(k.$QDb)),Q=K.add(x.createInstance($.$6u));try{return await q(H,Q)}finally{K.dispose()}})}};e.$x5b=I,e.$x5b=I=pe([Z(0,g.$ho),Z(1,a.$sEb),Z(2,g.$fo),Z(3,t.$4Fb),Z(4,l.$Wh),Z(5,r.$jhb)],I);let T=class extends n.$mFb{constructor(U,q,Y,K,x,H,Q,J){super("extensions",K,x,H,Y,Q,J),this.p=U,this.q=q}async t(U){return U.syncData?await v(U.syncData,this.p):null}u(U,q){const Y=[],K=[],x=[];for(const H of U){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const Q=q.find(J=>(0,c.$Ho)(J.identifier,H.identifier));Q?(Y.push(Q),H.disabled&&x.push(H.identifier)):H.installed&&(K.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&x.push(H.identifier))}return{installedExtensions:Y,newExtensions:K,disabledExtensions:x,remoteExtensions:U}}};e.$y5b=T,e.$y5b=T=pe([Z(0,g.$ho),Z(1,t.$4Fb),Z(2,w.$gk),Z(3,o.$Sk),Z(4,C.$5h),Z(5,h.$fj),Z(6,d.$bp),Z(7,s.$Qk)],T)}),define(ae[116],ce([0,1,15,7,3,35,42,5,32,20,14,11,8,43,21,22,28,39,79,238,24,17,59,4]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l,u,h,d,E,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sFb=e.$rFb=e.$qFb=e.$pFb=e.$oFb=void 0;const n="globalState.argv.",i=["locale"];function t(y,I){const T=y.storage?Object.keys(y.storage).sort():[],M={};return T.forEach(U=>M[U]=y.storage[U]),y.storage=M,I?(0,O.$wT)(y,{}):JSON.stringify(y)}e.$oFb=t;const r=1;let a=class extends l.$jFb{constructor(I,T,M,U,q,Y,K,x,H,Q,J,W,ee,ne){super({syncResource:"globalState",profile:I},T,U,x,W,q,Y,H,Q,K,J,ee),this.Bb=M,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:d.$lhb,authority:"base"}),this.xb=this.vb.with({scheme:d.$lhb,authority:"local"}),this.yb=this.vb.with({scheme:d.$lhb,authority:"remote"}),this.zb=this.vb.with({scheme:d.$lhb,authority:"accepted"}),this.Ab=ne.createInstance(v),this.B(U.watch(this.h.dirname(this.H.argvResource))),this.B(L.Event.any(L.Event.filter(U.onDidFilesChange,_=>_.contains(this.H.argvResource)),L.Event.filter(M.onDidChange,_=>!!(_.targetChanges.some(se=>this.syncResource.profile.id===se.id)||_.valueChanges.some(({profile:se,changes:X})=>this.syncResource.profile.id===se.id&&X.some(z=>z.target===0)))))(()=>this.Q()))}async qb(I,T,M){const U=I.syncData?JSON.parse(I.syncData.content):null;T=T===null&&M?I:T;const q=T&&T.syncData?JSON.parse(T.syncData.content):null,Y=await this.Ab.getLocalGlobalState(this.syncResource.profile);U?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const K=await this.Jb(q),{local:x,remote:H}=(0,h.$nFb)(Y.storage,U?U.storage:null,q?q.storage:null,K,this.O),Q={content:null,local:x,remote:H,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:H.all!==null?2:0},J=t(Y,!1);return[{baseResource:this.wb,baseContent:q?t(q,!1):J,localResource:this.xb,localContent:J,localUserData:Y,remoteResource:this.yb,remoteContent:U?t(U,!1):null,previewResource:this.vb,previewResult:Q,localChange:Q.localChange,remoteChange:Q.remoteChange,acceptedResource:this.zb,storageKeys:K}]}async ub(I){const T=I.syncData?JSON.parse(I.syncData.content):null;if(T===null)return!0;const M=await this.Ab.getLocalGlobalState(this.syncResource.profile),U=await this.Jb(T),{remote:q}=(0,h.$nFb)(M.storage,T.storage,T.storage,U,this.O);return q.all!==null}async rb(I,T){return{...I.previewResult,hasConflicts:!1}}async sb(I,T,M,U){if(this.h.isEqual(T,this.xb))return this.Gb(I);if(this.h.isEqual(T,this.yb))return this.Hb(I);if(this.h.isEqual(T,this.vb))return I.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async Gb(I){return{content:I.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(I.localUserData.storage),removed:[],updated:[],all:I.localUserData.storage},localChange:0,remoteChange:2}}async Hb(I){if(I.remoteContent!==null){const T=JSON.parse(I.remoteContent),{local:M,remote:U}=(0,h.$nFb)(I.localUserData.storage,T.storage,null,I.storageKeys,this.O);return{content:I.remoteContent,local:M,remote:U,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:I.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(I,T,M,U){const{localUserData:q}=M[0][0],{local:Y,remote:K,localChange:x,remoteChange:H}=M[0][1];if(x===0&&H===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(q)),await this.Ab.writeLocalGlobalState(Y,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const Q=JSON.stringify({storage:K.all});I=await this.mb(Q,U?null:I.ref),this.O.info(`${this.D}: Updated remote ui state.${K.added.length?` Added: ${K.added}.`:""}${K.updated.length?` Updated: ${K.updated}.`:""}${K.removed.length?` Removed: ${K.removed}.`:""}`)}T?.ref!==I.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(I),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(I){if(this.h.isEqual(this.yb,I)||this.h.isEqual(this.wb,I)||this.h.isEqual(this.xb,I)||this.h.isEqual(this.zb,I)){const T=await this.db(I);return T&&t(JSON.parse(T),!0)}return null}async hasLocalData(){try{const{storage:I}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(I).length>1||I[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(I){const T=await this.Bb.readStorageData(this.syncResource.profile),M=[],U=[];for(const[K,x]of T)x.target===0?M.push(K):x.target===1&&U.push(K);const q=[...M,...U],Y=I?.storage?Object.keys(I.storage).filter(K=>!K.startsWith(n)&&!q.includes(K)&&T.get(K)!==void 0):[];if(!P.$o){const K=[...d.$3gb.map(x=>(0,d.$dhb)(x)),d.$chb];Y.push(...K),U.push(...K)}return{user:M,machine:U,unregistered:Y}}};e.$pFb=a,e.$pFb=a=pe([Z(2,s.$sEb),Z(3,k.$gk),Z(4,d.$7gb),Z(5,d.$8gb),Z(6,d.$jhb),Z(7,C.$5h),Z(8,d.$ehb),Z(9,p.$kl),Z(10,b.$ri),Z(11,$.$bp),Z(12,w.$Qk),Z(13,o.$Wh)],a);let v=class{constructor(I,T,M,U){this.a=I,this.b=T,this.c=M,this.d=U}async getLocalGlobalState(I){const T={};if(I.isDefault){const U=await this.f(),q=(0,j.$5m)(U);for(const Y of i)q[Y]!==void 0&&(T[`${n}${Y}`]={version:1,value:q[Y]})}const M=await this.c.readStorageData(I);for(const[U,q]of M)q.value&&q.target===0&&(T[U]={version:1,value:q.value});return{storage:T}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const I=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),I.value.toString()}catch(I){this.d.debug((0,A.$9)(I))}return"{}"}async writeLocalGlobalState({added:I,removed:T,updated:M},U){const q=(0,l.$iFb)("globalState",U),Y={},K=new Map,x=await this.c.readStorageData(U),H=(Q,J)=>{for(const W of Q){if(W.startsWith(n)){Y[W.substring(n.length)]=J?J[W].value:void 0;continue}if(J){const ee=J[W];ee.value!==x.get(W)?.value&&K.set(W,ee.value)}else x.get(W)!==void 0&&K.set(W,void 0)}};if(H(Object.keys(I),I),H(Object.keys(M),M),H(T),Object.keys(Y).length){this.d.trace(`${q}: Updating locale...`);const Q=await this.f();let J=Q;for(const W of Object.keys(Y))J=(0,u.edit)(J,[W],Y[W],{});Q!==J&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,D.$fe.fromString(J)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}K.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(U,K,0),this.d.info(`${q}: Updated global state`,[...K.keys()]))}};e.$qFb=v,e.$qFb=v=pe([Z(0,k.$gk),Z(1,C.$5h),Z(2,s.$sEb),Z(3,d.$jhb)],v);let m=class extends l.$mFb{constructor(I,T,M,U,q,Y){super("globalState",M,U,q,T,I,Y)}async o(I){const T=I.syncData?JSON.parse(I.syncData.content):null;if(!T){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const M={},U={};for(const q of Object.keys(T.storage))q.startsWith(n)?M[q.substring(n.length)]=T.storage[q].value:this.l.get(q,0)===void 0&&(U[q]=T.storage[q].value);if(Object.keys(M).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Y of Object.keys(M))q=(0,u.edit)(q,[Y],M[Y],{});await this.k.writeFile(this.h.argvResource,D.$fe.fromString(q))}if(Object.keys(U).length){const q=[];for(const Y of Object.keys(U))q.push({key:Y,value:U[Y],scope:0,target:0});this.l.storeAll(q,!0)}}};e.$rFb=m,e.$rFb=m=pe([Z(0,$.$bp),Z(1,k.$gk),Z(2,E.$Sk),Z(3,C.$5h),Z(4,d.$jhb),Z(5,w.$Qk)],m);let f=class{constructor(I,T,M,U,q){this.a=I,this.b=T,this.c=M,this.d=U,this.f=q}getSyncStoreType(I){return this.h(I)?.storage[d.$chb]?.value}async sync(I){const T=(0,d.$$gb)((0,S.$kg)());try{return await this.g(I,T)}catch(M){if(M instanceof d.$_gb)switch(M.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(I,T)}throw M}}async g(I,T){const M=await this.a.readResource("globalState",null,void 0,T),U=this.h(M)||{storage:{}};U.storage[d.$chb]={value:I,version:r};const q=await(0,c.$hp)(this.c,this.d,this.b),Y={version:r,machineId:q,content:t(U,!1)};await this.a.writeResource("globalState",JSON.stringify(Y),M.ref,void 0,T)}h({content:I}){if(!I)return null;const T=JSON.parse(I);if((0,l.$hFb)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};e.$sFb=f,e.$sFb=f=pe([Z(1,$.$bp),Z(2,C.$5h),Z(3,k.$gk),Z(4,g.$fj)],f)}),define(ae[117],ce([0,1,18,15,3,35,5,12,170,20,14,11,21,22,28,17,39,235,24]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C5b=e.$B5b=e.$A5b=void 0;function h(s,o,n){try{const i=JSON.parse(s);if(!o)return(0,P.$Jf)(i.all)?null:i.all;switch(O.OS){case 2:return(0,P.$Jf)(i.mac)?null:i.mac;case 3:return(0,P.$Jf)(i.linux)?null:i.linux;case 1:return(0,P.$Jf)(i.windows)?null:i.windows}}catch(i){return n.error(i),null}}e.$A5b=h;let d=class extends w.$lFb{constructor(o,n,i,t,r,a,v,m,f,y,I,T,M){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,m,f,y,i,t,v,T,r,I,a,M),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:u.$lhb,authority:"base"}),this.Gb=this.Eb.with({scheme:u.$lhb,authority:"local"}),this.Hb=this.Eb.with({scheme:u.$lhb,authority:"remote"}),this.Ib=this.Eb.with({scheme:u.$lhb,authority:"accepted"}),this.B(L.Event.filter(a.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,n,i,t){const r=o.syncData?h(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&i?o:n;const a=n?this.Ob(n):null,v=await this.vb(),m=await this.Cb();let f=null,y=!1,I=!1,T=!1;if(r){let q=v?v.value.toString():"[]";if(q=q||"[]",this.Ab(q,!0))throw new u.$_gb((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==q||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Y=await(0,l.$z5b)(q,r,a,m,this.zb);Y.hasChanges&&(f=Y.mergeContent,T=Y.hasConflicts,y=T||Y.mergeContent!==q,I=T||Y.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=v.value.toString(),I=!0);const M={content:T?a:f,localChange:y?v?2:1:0,remoteChange:I?2:0,hasConflicts:T},U=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:U,localChange:M.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:M.remoteChange,previewResource:this.Eb,previewResult:M,acceptedResource:this.Ib}]}async ub(o){const n=this.Ob(o);if(n===null)return!0;const i=await this.vb(),t=i?i.value.toString():"",r=await this.Cb(),a=await(0,l.$z5b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(o,n){return o.previewResult}async sb(o,n,i,t){if(this.h.isEqual(n,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return i===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(o,n,i,t){const{fileContent:r}=i[0][0];let{content:a,localChange:v,remoteChange:m}=i[0][1];if(v===0&&m===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new u.$_gb((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),m!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const f=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(f,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const n=(0,j.$5m)(o.value.toString());if((0,D.$Kb)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:h(o.syncData.content,this.Qb(),this.O)}Pb(o,n){let i={};try{i=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete i.all:i.all=o,O.OS){case 2:i.mac=o;break;case 3:i.linux=o;break;case 1:i.windows=o;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(u.$Zgb)}};e.$B5b=d,e.$B5b=d=pe([Z(2,u.$7gb),Z(3,u.$8gb),Z(4,u.$jhb),Z(5,b.$ri),Z(6,u.$ehb),Z(7,k.$gk),Z(8,C.$5h),Z(9,g.$bp),Z(10,u.$ihb),Z(11,c.$kl),Z(12,$.$Qk)],d);let E=class extends w.$mFb{constructor(o,n,i,t,r,a){super("keybindings",n,i,t,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,A.$fe.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,j.$5m)(o.value.toString());return!(0,D.$Kb)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return h(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$C5b=E,e.$C5b=E=pe([Z(0,k.$gk),Z(1,p.$Sk),Z(2,C.$5h),Z(3,u.$jhb),Z(4,g.$bp),Z(5,$.$Qk)],E)}),define(ae[118],ce([0,1,15,3,171,20,75,14,29,11,21,22,28,17,39,239,24]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F5b=e.$E5b=e.$D5b=void 0;function l(E){return E&&E.settings&&typeof E.settings=="string"&&Object.keys(E).length===1}function u(E){const s=JSON.parse(E);return l(s)?s:{settings:E}}e.$D5b=u;let h=class extends $.$lFb{constructor(s,o,n,i,t,r,a,v,m,f,y,I,T,M){super(s.settingsResource,{syncResource:"settings",profile:s},o,n,i,t,r,a,y,I,v,m,f,M),this.Eb=T,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$lhb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$lhb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$lhb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$lhb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(s){const o=await this.getLastSyncUserData(),n=await this.X(s,o),i=this.Lb(n),t=new O.$Kn(w.$Ygb);return i?.settings&&t.parse(i.settings),t.configurationModel.getValue(w.$Ygb)||{}}async qb(s,o,n){const i=await this.vb(),t=await this.Cb(),r=this.Lb(s);o=o===null&&n?s:o;const a=o?this.Lb(o):null,v=await this.Pb();let m=null,f=!1,y=!1,I=!1;if(r){let q=i?i.value.toString().trim():"{}";q=q||"{}",this.Qb(q),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Y=(0,p.$_Db)(q,r.settings,a?a.settings:null,v,[],t);m=Y.localContent||Y.remoteContent,f=Y.localContent!==null,y=Y.remoteContent!==null,I=Y.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),m=i.value.toString().trim()||"{}",this.Qb(m),y=!0);const T=i?i.value.toString():null,M=a?.settings??null,U={content:I?M:m,localChange:f?2:0,remoteChange:y?2:0,hasConflicts:I};return[{fileContent:i,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:T,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async ub(s){const o=this.Lb(s);if(o===null)return!0;const n=await this.vb(),i=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,p.$_Db)(i||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(s,o){const n=await this.Cb(),i=await this.Pb();return{...s.previewResult,content:s.previewResult.content?(0,p.$$Db)(s.previewResult.content,"{}",i,n):null}}async sb(s,o,n,i){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:s.fileContent?(0,p.$$Db)(s.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:s.remoteContent!==null?(0,p.$$Db)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,p.$$Db)(n,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(s,o,n,i){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:v}=n[0][1];if(a===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,i),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const m=await this.Cb(),f=this.Lb(s),y=await this.Pb(r);r=(0,p.$$Db)(r,f?f.settings:"{}",y,m),this.O.trace(`${this.D}: Updating remote settings...`),s=await this.mb(JSON.stringify(this.Nb(r)),i?null:s.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(s),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.vb();if(s)return!(0,p.$aEb)(s.value.toString())}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.remoteResource,s)||this.h.isEqual(this.localResource,s)||this.h.isEqual(this.acceptedResource,s)||this.h.isEqual(this.baseResource,s)?this.db(s):null}async db(s){let o=await super.db(s);if(o){const n=await this.Cb(),i=await this.Pb();o=(0,p.$$Db)(o,"{}",i,n)}return o}Lb(s){return s.syncData?this.Mb(s.syncData.content):null}Mb(s){try{return u(s)}catch(o){this.O.error(o)}return null}Nb(s){return{settings:s}}async Pb(s){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(A.Event.any(A.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:t})=>!!t)),A.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{n.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,p.$9Db)(o,this.P,s)}Qb(s){if(this.Ab(s,!1))throw new w.$_gb((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$E5b=h,e.$E5b=h=pe([Z(2,b.$gk),Z(3,P.$5h),Z(4,C.$bp),Z(5,w.$7gb),Z(6,w.$8gb),Z(7,w.$jhb),Z(8,w.$ihb),Z(9,j.$ri),Z(10,w.$ehb),Z(11,k.$kl),Z(12,S.$ho),Z(13,g.$Qk)],h);let d=class extends $.$mFb{constructor(s,o,n,i,t,r){super("settings",o,n,i,s,t,r)}async o(s){const o=s.syncData?this.p(s.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,D.$fe.fromString(o.settings)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,p.$aEb)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}p(s){try{return u(s)}catch(o){this.j.error(o)}return null}};e.$F5b=d,e.$F5b=d=pe([Z(0,b.$gk),Z(1,c.$Sk),Z(2,P.$5h),Z(3,w.$jhb),Z(4,C.$bp),Z(5,g.$Qk)],d)}),define(ae[119],ce([0,1,15,3,30,20,14,11,21,22,28,17,39,236,24]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K5b=e.$J5b=e.$I5b=void 0;function p(u){return JSON.parse(u.content)}e.$I5b=p;let w=class extends g.$jFb{constructor(h,d,E,s,o,n,i,t,r,a,v,m){super({syncResource:"snippets",profile:h},d,s,E,o,n,i,a,v,t,r,m),this.pb=1,this.vb=h.snippetsHome,this.B(this.G.watch(E.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(A.Event.filter(this.G.onDidFilesChange,f=>f.affects(this.vb))(()=>this.Q()))}async qb(h,d,E){const s=await this.Hb(),o=this.Gb(s),n=h.syncData?this.Fb(h.syncData):null;d=d===null&&E?h:d;const i=d&&d.syncData?this.Fb(d.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,c.$G5b)(o,n,i);return this.Bb(t,s,n||{},i||{})}async ub(h){const d=h.syncData?this.Fb(h.syncData):null;if(d===null)return!0;const E=await this.Hb(),s=this.Gb(E),o=(0,c.$G5b)(s,d,d);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(h,d){return h.previewResult}async sb(h,d,E,s){if(this.h.isEqualOrParent(d,this.g.with({scheme:$.$lhb,authority:"local"})))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:h.fileContent?h.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(d,this.g.with({scheme:$.$lhb,authority:"remote"})))return{content:h.remoteContent,localChange:h.remoteContent!==null?h.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(d,this.g))return E===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:E,localChange:E===null?h.fileContent!==null?3:0:2,remoteChange:E===null?h.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async tb(h,d,E,s){const o=E.map(([n,i])=>({...n,acceptResult:i}));o.every(({localChange:n,remoteChange:i})=>n===0&&i===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.Cb(o),await this.Db(o,s)),o.some(({remoteChange:n})=>n!==0)&&(h=await this.Eb(o,h,s)),d?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.G.del(n)}catch{}}Bb(h,d,E,s){const o=new Map;for(const n of Object.keys(h.local.added)){const i={content:h.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"accepted"})})}for(const n of Object.keys(h.local.updated)){const i={content:h.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"accepted"})})}for(const n of h.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"accepted"})})}for(const n of Object.keys(h.remote.added)){const i={content:h.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"accepted"})})}for(const n of Object.keys(h.remote.updated)){const i={content:h.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"accepted"})})}for(const n of h.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"accepted"})})}for(const n of h.conflicts){const i={content:s[n]??null,hasConflicts:!0,localChange:d[n]?2:1,remoteChange:E[n]?2:1},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"local"}),fileContent:d[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"remote"}),remoteContent:E[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"accepted"})})}for(const n of Object.keys(d))if(!o.has(n)){const i={content:d[n]?d[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"local"}),fileContent:d[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"remote"}),remoteContent:E[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$lhb,authority:"accepted"})})}return[...o.values()]}async resolveContent(h){return this.h.isEqualOrParent(h,this.g.with({scheme:$.$lhb,authority:"remote"}))||this.h.isEqualOrParent(h,this.g.with({scheme:$.$lhb,authority:"local"}))||this.h.isEqualOrParent(h,this.g.with({scheme:$.$lhb,authority:"base"}))||this.h.isEqualOrParent(h,this.g.with({scheme:$.$lhb,authority:"accepted"}))?this.db(h):null}async hasLocalData(){try{const h=await this.Hb();if(Object.keys(h).length)return!0}catch{}return!1}async Cb(h){const d={};for(const E of h)E.fileContent&&(d[this.h.basename(E.localResource)]=E.fileContent);await this.nb(JSON.stringify(this.Gb(d)))}async Db(h,d){for(const{fileContent:E,acceptResult:s,localResource:o,remoteResource:n,localChange:i}of h)if(i!==0){const t=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.vb,t);i===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):i===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,D.$fe.fromString(s.content),{overwrite:d}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,D.$fe.fromString(s.content),d?void 0:E),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(h,d,E){const s=d.syncData?this.Fb(d.syncData):{},o=(0,L.$cn)(s);for(const{acceptResult:n,localResource:i,remoteResource:t,remoteChange:r}of h)if(r!==0){const a=i?this.h.basename(i):this.h.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,c.$H5b)(s,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),d=await this.mb(JSON.stringify(o),E?null:d.ref),this.O.info(`${this.D}: Updated remote snippets`)),d}Fb(h){return p(h)}Gb(h){const d={};for(const E of Object.keys(h))d[E]=h[E].value.toString();return d}async Hb(){const h={};let d;try{d=await this.G.resolve(this.vb)}catch(E){if(E instanceof P.$Bk&&E.fileOperationResult===1)return h;throw E}for(const E of d.children||[]){const s=E.resource,o=this.h.extname(s);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.vb,s),i=await this.G.readFile(s);h[n]=i}}return h}};e.$J5b=w,e.$J5b=w=pe([Z(2,O.$5h),Z(3,P.$gk),Z(4,S.$bp),Z(5,$.$7gb),Z(6,$.$8gb),Z(7,$.$jhb),Z(8,j.$ri),Z(9,$.$ehb),Z(10,b.$kl),Z(11,C.$Qk)],w);let l=class extends g.$mFb{constructor(h,d,E,s,o,n){super("snippets",d,E,s,h,o,n)}async o(h){const d=h.syncData?JSON.parse(h.syncData.content):null;if(!d){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const s of Object.keys(d)){const o=d[s];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,s);await this.k.createFile(n,D.$fe.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(h)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(h){return h.fileOperationResult===1}}};e.$K5b=l,e.$K5b=l=pe([Z(0,P.$gk),Z(1,k.$Sk),Z(2,O.$5h),Z(3,$.$jhb),Z(4,S.$bp),Z(5,C.$Qk)],l)}),define(ae[120],ce([0,1,15,20,14,11,21,22,28,17,39,24]),function(ie,e,D,A,L,j,O,P,S,b,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N5b=e.$M5b=e.$L5b=void 0;function g(w,l){try{return JSON.parse(w).tasks??null}catch(u){return l.error(u),null}}e.$L5b=g;let c=class extends C.$kFb{constructor(l,u,h,d,E,s,o,n,i,t,r,a){super(l.tasksResource,{syncResource:"tasks",profile:l},u,n,i,t,h,d,o,r,E,s,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:k.$lhb,authority:"base"}),this.Cb=this.Ab.with({scheme:k.$lhb,authority:"local"}),this.Db=this.Ab.with({scheme:k.$lhb,authority:"remote"}),this.Eb=this.Ab.with({scheme:k.$lhb,authority:"accepted"})}async qb(l,u,h,d){const E=l.syncData?g(l.syncData.content,this.O):null;u=u===null&&h?l:u;const s=u?.syncData?g(u.syncData.content,this.O):null,o=await this.vb();let n=null,i=!1,t=!1,r=!1;if(l.syncData){const m=o?o.value.toString():null;if(!s||s!==m||s!==E){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const f=p(m,E,s);n=f.content,r=f.hasConflicts,i=f.hasLocalChanged,t=f.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?s:n,localChange:i?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:s,localResource:this.Cb,localContent:v,localChange:a.localChange,remoteResource:this.Db,remoteContent:E,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(l){const u=l?.syncData?g(l.syncData.content,this.O):null;if(u===null)return!0;const h=await this.vb(),d=h?h.value.toString():null,E=p(d,u,u);return E.hasLocalChanged||E.hasRemoteChanged}async rb(l,u){return l.previewResult}async sb(l,u,h,d){if(this.h.isEqual(u,this.Cb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.Db))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.Ab))return h===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:h,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async tb(l,u,h,d){const{fileContent:E}=h[0][0],{content:s,localChange:o,remoteChange:n}=h[0][1];if(o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),E&&await this.nb(JSON.stringify(this.Kb(E.value.toString()))),s?await this.wb(s,E,d):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(s));l=await this.mb(i,d?null:l.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(l){return this.h.isEqual(this.Db,l)||this.h.isEqual(this.Bb,l)||this.h.isEqual(this.Cb,l)||this.h.isEqual(this.Eb,l)?this.db(l):null}Kb(l){return l?{tasks:l}:{}}};e.$M5b=c,e.$M5b=c=pe([Z(2,k.$7gb),Z(3,k.$8gb),Z(4,k.$jhb),Z(5,A.$ri),Z(6,k.$ehb),Z(7,j.$gk),Z(8,L.$5h),Z(9,O.$bp),Z(10,P.$kl),Z(11,S.$Qk)],c);let $=class extends C.$mFb{constructor(l,u,h,d,E,s){super("tasks",u,h,d,l,E,s),this.c=this.g.defaultProfile.tasksResource}async o(l){const u=l.syncData?g(l.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,D.$fe.fromString(u)),await this.n(l)}async p(){return this.k.exists(this.c)}};e.$N5b=$,e.$N5b=$=pe([Z(0,j.$gk),Z(1,b.$Sk),Z(2,L.$5h),Z(3,k.$jhb),Z(4,O.$bp),Z(5,S.$Qk)],$);function p(w,l,u){if(w===null&&l===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const h=u!==w,d=u!==l;return!h&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:h&&!d?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!h?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ae[121],ce([0,1,42,20,14,11,21,22,28,17,39,237,24]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u7b=e.$t7b=e.$s7b=void 0;let c=class extends C.$jFb{constructor(l,u,h,d,E,s,o,n,i,t,r,a,v){super({syncResource:"profiles",profile:l},u,d,E,s,o,n,r,a,i,t,v),this.vb=h,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:g.$lhb,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.$lhb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.$lhb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.$lhb,authority:"accepted"}),this.B(h.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?p(l.syncData):null}async getRemoteSyncedProfiles(l){const u=await this.getLastSyncUserData(),h=await this.X(l,u);return h?.syncData?p(h.syncData):null}async qb(l,u,h){if(!this.vb.isEnabled())throw new g.$_gb("Cannot sync profiles because they are disabled","LocalError");const d=l.syncData?p(l.syncData):null,E=u?.syncData?p(u.syncData):null,s=this.Db(),{local:o,remote:n}=(0,k.$r7b)(s,d,E,[]),i={local:o,remote:n,content:E?this.Eb(E):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=$(s,!1);return[{baseResource:this.baseResource,baseContent:E?this.Eb(E):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:d?this.Eb(d):null,remoteProfiles:d,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(l){const u=l?.syncData?p(l.syncData):null,h=this.Db(),{remote:d}=(0,k.$r7b)(h,u,u,[]);return!!d?.added.length||!!d?.removed.length||!!d?.updated.length}async rb(l,u){return{...l.previewResult,hasConflicts:!1}}async sb(l,u,h,d){if(this.h.isEqual(u,this.localResource))return this.Ab(l);if(this.h.isEqual(u,this.remoteResource))return this.Bb(l);if(this.h.isEqual(u,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async Ab(l){const u=this.Db(),h=(0,k.$r7b)(u,null,null,[]),{local:d,remote:E}=h;return{content:l.localContent,local:d,remote:E,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:E!==null?2:0}}async Bb(l){const u=l.remoteContent?JSON.parse(l.remoteContent):null,h=[],d=[];for(const E of this.Db()){const s=u?.find(o=>o.id===E.id);s&&(h.push({id:E.id,name:E.name,collection:s.collection}),d.push(E))}if(u!==null){const E=(0,k.$r7b)(d,u,h,[]),{local:s,remote:o}=E;return{content:l.remoteContent,local:s,remote:o,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(l,u,h,d){const{local:E,remote:s,localChange:o,remoteChange:n}=h[0][1];o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=h[0][0].remoteProfiles||[];if(i.length+(s?.added.length??0)-(s?.removed.length??0)>20)throw new g.$_gb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.nb($(this.Db(),!1));const t=[];for(const r of E.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of E.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of E.updated){const a=this.vb.profiles.find(v=>v.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=i.length+(s?.added.length??0)<=20;if(r)for(const a of s?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),i.push({id:a.id,name:a.name,collection:v,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of s?.removed||[])i.splice(i.findIndex(({id:v})=>a.id===v),1);for(const a of s?.updated||[]){const v=i.find(({id:m})=>a.id===m);v&&i.splice(i.indexOf(v),1,{...v,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{l=await this.updateRemoteProfiles(i,d?null:l.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&s?.added.length?` Added: ${JSON.stringify(s.added.map(a=>a.name))}.`:""}${s?.updated.length?` Updated: ${JSON.stringify(s.updated.map(a=>a.name))}.`:""}${s?.removed.length?` Removed: ${JSON.stringify(s.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw a}for(const a of s?.removed||[])await this.J.deleteCollection(a.collection,this.F)}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,u){return this.mb(this.Eb(l),u)}async hasLocalData(){return this.Db().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const u=await this.db(l);return u&&(0,D.$wT)(JSON.parse(u),{})}return null}Db(){return this.vb.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Eb(l){return JSON.stringify([...l].sort((u,h)=>u.name.localeCompare(h.name)))}};e.$s7b=c,e.$s7b=c=pe([Z(2,b.$Sk),Z(3,j.$gk),Z(4,L.$5h),Z(5,O.$bp),Z(6,g.$7gb),Z(7,g.$8gb),Z(8,g.$jhb),Z(9,A.$ri),Z(10,g.$ehb),Z(11,P.$kl),Z(12,S.$Qk)],c);function $(w,l){const u=[...w].sort((h,d)=>h.name.localeCompare(d.name)).map(h=>({id:h.id,name:h.name}));return l?(0,D.$wT)(u,{}):JSON.stringify(u)}e.$t7b=$;function p(w){return JSON.parse(w.content)}e.$u7b=p}),define(ae[255],ce([0,1,3,2,5,14,21,22,24]),function(ie,e,D,A,L,j,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f7b=void 0;const b="sync.enable";let C=class extends A.$Rc{constructor(g,c,$,p){super(),this.c=g,this.f=c,this.g=$,this.h=p,this.a=new D.$Rd,this.onDidChangeEnablement=this.a.event,this.b=new D.$Rd,this.onDidChangeResourceEnablement=this.b.event,this.B(g.onDidChangeValue(-1,void 0,this.B(new A.$Qc))(w=>this.m(w)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(b,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(g){g&&!this.canToggleEnablement()||(this.f.publicLog2(b,{enabled:g}),this.c.store(b,g,-1,1))}isResourceEnabled(g){return this.c.getBoolean((0,S.$dhb)(g),-1,!0)}setResourceEnablement(g,c){if(this.isResourceEnabled(g)!==c){const $=(0,S.$dhb)(g);this.j($,c)}}getResourceSyncStateVersion(g){}j(g,c){this.c.store(g,c,-1,L.$o?0:1)}m(g){if(b===g.key){this.a.fire(this.isEnabled());return}const c=S.$3gb.filter($=>(0,S.$dhb)($)===g.key)[0];if(c){this.b.fire([c,this.isResourceEnabled(c)]);return}}};e.$f7b=C,e.$f7b=C=pe([Z(0,O.$bp),Z(1,P.$kl),Z(2,j.$5h),Z(3,S.$6gb)],C)}),define(ae[256],ce([0,1,6,15,64,2,19,20,14,11,17,24]),function(ie,e,D,A,L,j,O,P,S,b,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q7b=void 0;let g=class extends j.$Rc{constructor($,p,w,l,u){super(),this.a=$,this.b=p,this.c=w,this.f=l,this.g=u,this.h()}async h(){for(const p of this.g.profiles)for(const w of k.$3gb)try{await this.m(this.j(w,p.isDefault?void 0:p.id))}catch(l){this.f.error(l)}let $;try{$=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,b.$xk)(p)!==1&&this.f.error(p);return}if($.children){for(const p of $.children)if(p.isDirectory&&!this.g.profiles.some(w=>w.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(w){this.f.error(w)}}}async getAllResourceRefs($,p,w){const l=this.j($,p,w);try{const u=await this.b.resolve(l);if(u.children)return u.children.filter(d=>d.isFile&&!d.name.startsWith("lastSync")).sort().reverse().map(d=>({ref:d.name,created:this.n(d)}))}catch(u){if((0,b.$xk)(u)!==1)throw u}return[]}async resolveResourceContent($,p,w,l){const u=this.j($,w,l),h=(0,O.$Bg)(u,p);try{return(await this.b.readFile(h)).value.toString()}catch(d){return this.f.error(d),null}}async writeResource($,p,w,l,u){const h=this.j($,l,u),d=(0,O.$Bg)(h,`${(0,L.$mm)(w).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,A.$fe.fromString(p))}catch(E){this.f.error(E)}}j($,p,w=this.a.userDataSyncHome){return(0,O.$Bg)(w,...p?[p,$]:[$])}async m($){try{try{if(!await this.b.exists($))return}catch{return}const p=await this.b.resolve($);if(p.children){const w=p.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=w.filter(d=>Date.now()-this.n(d)>l);const h=w.length-u.length;h<10&&(u=u.slice(10-h)),await D.Promises.settled(u.map(async d=>{this.f.info("Deleting from backup",d.resource.path),await this.b.del(d.resource)}))}}catch(p){this.f.error(p)}}n($){return new Date(parseInt($.name.substring(0,4)),parseInt($.name.substring(4,6))-1,parseInt($.name.substring(6,8)),parseInt($.name.substring(9,11)),parseInt($.name.substring(11,13)),parseInt($.name.substring(13,15))).getTime()}};e.$q7b=g,e.$q7b=g=pe([Z(0,S.$5h),Z(1,b.$gk),Z(2,P.$ri),Z(3,k.$jhb),Z(4,C.$Sk)],g)}),define(ae[83],ce([0,1,3,2,5,27,175,14,11,4,25,43,21,24]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgb=e.$Ugb=e.$Tgb=void 0,e.$Tgb=(0,b.$Xh)("IUserDataSyncMachinesService");const p="sync.currentMachineName",w="Safari",l="Chrome",u="Edge",h="Firefox",d="Android";function E(n){switch(n){case w:case l:case u:case h:case d:case(0,L.$h)(0):return!0}return!1}e.$Ugb=E;function s(){return L.$G?w:L.$E?l:L.$H?u:L.$F?h:L.$I?d:(0,L.$h)(L.$o?0:L.$u)}let o=class extends A.$Rc{static{$=this}static{this.a=1}static{this.b="machines"}constructor(i,t,r,a,v,m){super(),this.h=r,this.j=a,this.m=v,this.n=m,this.c=this.B(new D.$Rd),this.onDidChange=this.c.event,this.g=null,this.f=(0,k.$hp)(i,t,r)}async getMachines(i){const t=await this.f;return(await this.s(i)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(i){const t=await this.f,r=await this.s(i);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:s()}),await this.t(r))}async removeCurrentMachine(i){const t=await this.f,r=await this.s(i),a=r.machines.filter(({id:v})=>v!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(i,t,r){const a=await this.s(r),v=a.machines.find(({id:m})=>m===i);if(v){v.name=t,await this.t(a);const m=await this.f;i===m&&this.h.store(p,t,-1,1)}}async setEnablements(i){const t=await this.s();for(const[r,a]of i){const v=t.machines.find(m=>m.id===r);v&&(v.disabled=a?void 0:!0)}await this.t(t)}r(i){const t=this.h.get(p,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${s()} (${this.n.nameShort})`,a=new RegExp(`${(0,j.$Je)(r)}\\s#(\\d+)`);let v=0;for(const m of i){const f=a.exec(m.name),y=f?parseInt(f[1]):0;v=y>v?y:v}return`${r} #${v+1}`}async s(i){this.g=await this.u(i);const t=this.w(this.g);if(t.version!==$.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return t}async t(i){const t=JSON.stringify(i),r=await this.j.writeResource($.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(i){if(this.g){const t=i&&i.latest?i.latest[$.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource($.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.m.error(t)}return{version:$.a,machines:[]}}};e.$Vgb=o,e.$Vgb=o=$=pe([Z(0,P.$5h),Z(1,S.$gk),Z(2,g.$bp),Z(3,c.$7gb),Z(4,c.$jhb),Z(5,C.$xj)],o)}),define(ae[257],ce([0,1,6,64,38,7,3,2,5,19,10,172,25,21,22,24,80,83]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=void 0;const u="sync.disableMachineEventually",h="sync.sessionId",d="sync.storeUrl",E="sync.productQuality";let s=class extends P.$Rc{get n(){const i=this.H.get(d,-1);return i?C.URI.parse(i):void 0}set n(i){i?this.H.store(d,i.toString(),-1,1):this.H.remove(d,-1)}get s(){return this.H.get(E,-1)}set s(i){i?this.H.store(E,i,-1,1):this.H.remove(E,-1)}constructor(i,t,r,a,v,m,f,y,I,T){super(),this.u=t,this.w=r,this.y=a,this.z=v,this.C=m,this.D=f,this.F=y,this.G=I,this.H=T,this.a=this.B(new P.$Sc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$Rd),this.onError=this.h.event,this.S=[],this.f=this.B(new D.$Xg(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,b.$ug)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(f.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:t}=this.L();i?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,A.$mm)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(h,-1),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const t=p.$_gb.toUserDataSyncError(i);t instanceof p.$bhb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?S.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(u,!0,-1,1),await(0,D.$1g)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(u,-1,!1)}R(){this.H.remove(u,-1)}async triggerSync(i,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$w7b=s,e.$w7b=s=pe([Z(0,g.$xj),Z(1,p.$6gb),Z(2,p.$7gb),Z(3,p.$ehb),Z(4,p.$fhb),Z(5,p.$jhb),Z(6,w.$SDb),Z(7,$.$kl),Z(8,l.$Tgb),Z(9,c.$bp)],s);class o extends P.$Rc{static{this.a="Interval"}constructor(i,t,r,a,v,m,f,y,I){super(),this.m=i,this.n=t,this.r=r,this.s=a,this.u=v,this.w=m,this.y=f,this.z=y,this.C=I,this.b=this.B(new P.$Sc),this.c=this.B(new O.$Rd),this.onDidStartSync=this.c.event,this.f=this.B(new O.$Rd),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,P.$Pc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,D.$2g)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(i,t){const r=(0,D.$Ng)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,j.$3)(v))return}return this.H(i,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,b.$ug)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!i&&(!(0,b.$ug)(t.defaultUrl,i.defaultUrl)||!(0,b.$ug)(t.insidersUrl,i.insidersUrl)||!(0,b.$ug)(t.stableUrl,i.stableUrl))}async H(i,t,r){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let a;try{await this.I(t,r)}catch(v){if(this.y.error(v),a=v,p.$_gb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(m){this.y.error(m),a=m}}this.f.fire(a)}async I(i,t){if(this.h=await this.u.createSyncTask(this.g,i),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$bhb((0,k.localize)(0,null),"DefaultServiceChanged"):new p.$bhb((0,k.localize)(1,null),"ServiceChanged"):new p.$bhb((0,k.localize)(2,null),"TurnedOff");const r=this.C.get(h,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new p.$bhb((0,k.localize)(3,null),"DefaultServiceChanged"):new p.$bhb((0,k.localize)(4,null),"ServiceChanged"):new p.$bhb((0,k.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=a.find(f=>f.isCurrent);if(v?.disabled)throw new p.$bhb((0,k.localize)(6,null),"TurnedOff");const m=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-m}),this.g===null)try{this.g=await this.s.manifest(null)}catch(f){throw new p.$bhb((0,L.$Ii)(f),f instanceof p.$_gb?f.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(h,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(ae[258],ce([0,1,10,176,14,11,43,21,28,24,17,39,119,118,117,20,120,115,116,4,121,42,27]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l,u,h,d,E,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$77b=void 0;let n=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,v,m,f,y,I,T,M){this.e=t,this.f=r,this.g=a,this.h=m,this.i=f,this.j=y,this.k=I,this.l=T,this.n=M,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,d.$u7b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const v=this.L(a,"profiles");return(0,d.$u7b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(m=>({...m,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:m})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:m,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:m,ref:f})=>({created:m,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:f,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,O.$hp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,v,m){if(t){const{content:f}=await this.M(r,v,a);return f}return this.f.resolveResourceContent(r,v,a,m)}q(t,r,a){const v=this.L(r,t);switch(t){case"settings":return this.t(v,a);case"keybindings":return this.v(v,a);case"tasks":return this.x(v,a);case"snippets":return this.z(v,a);case"globalState":return this.E(v,a);case"extensions":return this.B(v,a);case"profiles":return this.H(v,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(v=>v.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,c.$D5b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,$.$A5b)(t.content,!!this.l.getValue(b.$Zgb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,w.$L5b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const v=this.L(a,"snippets");if(v){const m=(0,g.$I5b)(v),f=[];for(const y of Object.keys(m)){const I=this.d.joinPath(t,y),T=r?this.d.joinPath(r.snippetsHome,y):this.d.joinPath(t,o.a);f.push({resource:I,comparableResource:T})}return f}}return[]}z(t,r){return(0,g.$I5b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,l.$v5b)((0,l.$u5b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(l.$x5b).getLocalExtensions(t);return(0,l.$v5b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,u.$oFb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(u.$qFb).getLocalGlobalState(t);return(0,u.$oFb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,E.$wT)(JSON.parse(t.content),{})}return null}async I(t){return(0,d.$t7b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,s.$Me)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(D.URI.from({scheme:b.$lhb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==b.$lhb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let v,m;const f=[];let y,I,T,M,U;for(;r.length;){const q=r.shift();q.startsWith("scheme:")?v=q.substring(7):q.startsWith("authority:")?m=q.substring(10):q.startsWith("syncResource:")?y=q.substring(13):q.startsWith("profile:")?I=q.substring(8):q.startsWith("collection:")?T=q.substring(11):q.startsWith("ref:")?M=q.substring(4):y?U=q:f.push(q)}return{remote:a,syncResource:y,profile:I,collection:T,ref:M,node:U,location:v&&m!==void 0?this.d.joinPath(D.URI.from({scheme:v,authority:m,query:t.query,fragment:t.fragment,path:"/"}),...f):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,k.$hFb)(a))return a}catch(a){this.g.error(a)}throw new b.$_gb((0,A.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const v=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:v}}};e.$77b=n,e.$77b=n=o=pe([Z(0,b.$7gb),Z(1,b.$8gb),Z(2,b.$jhb),Z(3,S.$Qk),Z(4,L.$5h),Z(5,P.$bp),Z(6,j.$gk),Z(7,C.$Sk),Z(8,p.$ri),Z(9,h.$Wh)],n)}),define(ae[259],ce([0,1,18,6,26,38,3,2,19,12,32,20,29,11,4,21,22,17,115,116,117,118,119,120,121,24]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l,u,h,d,E,s,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v7b=void 0;const t="sync.lastSyncTime";let r=class extends P.$Rc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(y,I,T,M,U,q,Y,K,x,H,Q){super(),this.C=y,this.D=I,this.F=T,this.G=M,this.H=U,this.I=q,this.J=Y,this.L=K,this.M=x,this.N=H,this.O=Q,this.f="uninitialized",this.g=this.B(new O.$Rd),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$Rd),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$Rd),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$Rd),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$Rd),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$Rd),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$Rd),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=T.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,P.$Pc)(()=>this.bb()))}async createSyncTask(y,I){this.cb(),this.H.info("Sync started.");const T=new Date().getTime(),M=(0,C.$kg)();try{const K=(0,i.$$gb)(M);I&&(K["Cache-Control"]="no-cache"),y=await this.D.manifest(y,K)}catch(K){const x=i.$_gb.toUserDataSyncError(K);throw m(x,M,this.F,this.I),x}const U=!1,q=this;let Y;return{manifest:y,async run(){if(U)throw new Error("Can run a task only once");Y=(0,A.$Ng)(K=>q.P(y,!1,M,K)),await Y.finally(()=>Y=void 0),q.H.info(`Sync done. Took ${new Date().getTime()-T}ms`),q.$()},stop(){return Y?.cancel(),q.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new i.$_gb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const y=new Date().getTime(),I=(0,C.$kg)(),T=(0,i.$$gb)(I);let M;try{M=await this.D.manifest(null,T)}catch(Y){const K=i.$_gb.toUserDataSyncError(Y);throw m(K,I,this.F,this.I),K}await this.resetLocal();const U=this,q=new L.$2d;return{id:I,async merge(){return U.P(M,!0,I,q.token)},async apply(){try{try{await U.R(M,I,q.token)}catch(Y){if(i.$_gb.toUserDataSyncError(Y).code==="MethodNotFound")U.H.info("Client is making invalid requests. Cleaning up data..."),await U.cleanUpRemoteData(),U.H.info("Applying manual sync again..."),await U.R(M,I,q.token);else throw Y}}catch(Y){throw U.H.error(Y),Y}U.H.info(`Sync done. Took ${new Date().getTime()-y}ms`),U.$()},async stop(){q.cancel(),await U.U(),await U.resetLocal()}}}async P(y,I,T,M){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const U=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(U,y,I,T,M));const q=U.enabled.find(Y=>Y.resource==="profiles");if(q){const Y=await q.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.Q(Y,y,I,T,M)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(y,I,T,M,U){for(const q of y){if(U.isCancellationRequested)return;const Y=this.M.profiles.find(x=>x.id===q.id);if(!Y){this.H.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",q.name);const K=this.getOrCreateActiveProfileSynchronizer(Y,q);this.n.push(...await this.S(K,I,T,M,U))}for(const[q,Y]of this.z.entries())this.M.profiles.some(K=>K.id===Y[0].profile.id)||(Y[1].dispose(),this.z.delete(q))}async R(y,I,T){const M=this.ab();for(const x of M){if(T.isCancellationRequested)return;await x.apply(I,T)}const U=M.find(x=>x.profile.isDefault);if(!U)return;const q=U.enabled.find(x=>x.resource==="profiles");if(!q)return;const K=(await q.getRemoteSyncedProfiles(y?.latest??null)||[]).filter(x=>M.every(H=>H.profile.id!==x.id));K.length&&await this.Q(K,y,!1,I,T)}async S(y,I,T,M,U){return(await y.sync(I,T,M,U)).map(([Y,K])=>({profile:y.profile,syncResource:Y,error:K}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(y=>y.stop()))}async resolveContent(y){const I=await this.N.resolveContent(y);if(I)return I;for(const T of this.ab())for(const M of T.enabled){const U=await M.resolveContent(y);if(U)return U}return null}async replace(y){this.cb();const I=this.N.resolveUserDataSyncResource(y);if(!I)return;const T=await this.resolveContent(y.uri);T&&await this.W(I.profile,async M=>{if(I.syncResource===M.resource)return await M.replace(T),!0})}async accept(y,I,T,M){this.cb(),await this.W(y.profile,async U=>{if(y.syncResource===U.resource)return await U.accept(I,T),M&&await U.apply((0,b.$If)(M)?!1:M.force,(0,i.$$gb)((0,C.$kg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async I=>{if(I.resource!=="globalState"&&await I.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async I=>{if(await I.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(y){this.H.error(y)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[y]of this.z.values())try{await y.resetLocal()}catch(I){this.H.error(I)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const y=await this.N.getRemoteSyncedProfiles(),I=y.map(q=>q.collection),T=await this.D.getAllCollections(),M=T.filter(q=>!I.includes(q));M.length&&(this.H.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(q=>this.D.deleteCollection(q))),this.H.info("Deleted redundant collections on server"));const U=y.filter(q=>T.includes(q.collection));if(U.length!==y.length){const q=this.G.createInstance(n.$s7b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(U,null),this.H.info("Updated remote profiles on server")}finally{q.dispose()}}}async saveRemoteActivityData(y){this.cb();const I=await this.D.getActivityData();await this.C.writeFile(y,I)}async extractActivityData(y,I){const T=(await this.C.readFile(y)).value.toString(),M=JSON.parse(T);if(M.resources)for(const U in M.resources)for(const q of M.resources[U])await this.O.writeResource(U,q.content,new Date(q.created*1e3),void 0,I);if(M.collections)for(const U in M.collections)for(const q in M.collections[U].resources)for(const Y of M.collections[U].resources?.[q]??[])await this.O.writeResource(q,Y.content,new Date(Y.created*1e3),U,I)}async W(y,I){const T=new P.$Qc;try{const M=this.z.get(y.id);if(M){const x=await this.X(M[0],I,T);return(0,b.$Jf)(x)?null:x}if(y.isDefault){const x=T.add(this.G.createInstance(a,y,void 0)),H=await this.X(x,I,T);return(0,b.$Jf)(H)?null:H}if(this.M.isEnabled())return null;const U=T.add(this.G.createInstance(n.$s7b,y,void 0)),q=await this.D.manifest(null),K=(await U.getRemoteSyncedProfiles(q?.latest??null)||[]).find(x=>x.id===y.id);if(K){const x=T.add(this.G.createInstance(a,y,K.collection)),H=await this.X(x,I,T);return(0,b.$Jf)(H)?null:H}return null}finally{T.dispose()}}async X(y,I,T){const M=[...y.enabled,...y.disabled.reduce((U,q)=>(q!=="workspaceState"&&U.push(T.add(y.createSynchronizer(q))),U),[])];for(const U of M){const q=await I(U);if(!(0,b.$Jf)(q))return q}}Y(y){const I=this.f;this.f!==y&&(this.f=y,this.g.fire(y),I==="hasConflicts"&&this.$())}Z(){const y=this.ab().map(I=>I.conflicts).flat();(0,D.$tb)(this.j,y,(I,T)=>I.profile.id===T.profile.id&&I.syncResource===T.syncResource&&(0,D.$tb)(I.conflicts,T.conflicts,(M,U)=>(0,S.$ug)(M.previewResource,U.previewResource)))||(this.j=y,this.m.fire(y))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(y,I){let T=this.z.get(y.id);if(T&&T[0].collection!==I?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),T[1].dispose(),T=void 0,this.z.delete(y.id)),!T){const M=new P.$Qc,U=M.add(this.G.createInstance(a,y,I?.collection));M.add(U.onDidChangeStatus(q=>this.Y(q))),M.add(U.onDidChangeConflicts(q=>this.Z())),M.add(U.onDidChangeLocal(q=>this.h.fire(q))),this.z.set(y.id,T=[U,M])}return T[0]}ab(){const y=[];for(const[I]of this.z.values())y.push(I);return y}bb(){this.z.forEach(([,y])=>y.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$v7b=r,e.$v7b=r=pe([Z(0,c.$gk),Z(1,i.$7gb),Z(2,i.$6gb),Z(3,$.$Wh),Z(4,i.$jhb),Z(5,w.$kl),Z(6,p.$bp),Z(7,i.$ehb),Z(8,l.$Sk),Z(9,i.$ghb),Z(10,i.$8gb)],r);let a=class extends P.$Rc{get enabled(){return this.f.sort((y,I)=>y[1]-I[1]).map(([y])=>y)}get disabled(){return i.$3gb.filter(y=>!this.r.isResourceEnabled(y))}get status(){return this.g}get conflicts(){return this.m}constructor(y,I,T,M,U,q,Y,K,x,H){super(),this.profile=y,this.collection=I,this.r=T,this.t=M,this.u=U,this.w=q,this.y=Y,this.z=K,this.C=x,this.D=H,this.f=[],this.g="idle",this.h=this.B(new O.$Rd),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$Rd),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$Rd),this.onDidChangeConflicts=this.n.event,this.B(T.onDidChangeResourceEnablement(([Q,J])=>this.F(Q,J))),this.B((0,P.$Pc)(()=>this.f.splice(0,this.f.length).forEach(([,,Q])=>Q.dispose())));for(const Q of i.$3gb)T.isResourceEnabled(Q)&&this.G(Q)}F(y,I){I?this.G(y):this.H(y)}G(y){if(this.f.some(([U])=>U.resource===y))return;if(y==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(y==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||y==="workspaceState")return;if(y!=="profiles"&&this.profile.useDefaultFlags?.[y]){this.z.debug(`Skipping syncing ${y} in ${this.profile.name} because it is already synced by default profile`);return}const I=new P.$Qc,T=I.add(this.createSynchronizer(y));I.add(T.onDidChangeStatus(()=>this.L())),I.add(T.onDidChangeConflicts(()=>this.M())),I.add(T.onDidChangeLocal(()=>this.j.fire(y)));const M=this.N(y);this.f.push([T,M,I])}H(y){const I=this.f.findIndex(([T])=>T.resource===y);if(I!==-1){const[[T,,M]]=this.f.splice(I,1);M.dispose(),this.L(),Promise.allSettled([T.stop(),T.resetLocal()]).then(null,U=>this.z.error(U))}}createSynchronizer(y){switch(y){case"settings":return this.t.createInstance(E.$E5b,this.profile,this.collection);case"keybindings":return this.t.createInstance(d.$B5b,this.profile,this.collection);case"snippets":return this.t.createInstance(s.$J5b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$M5b,this.profile,this.collection);case"globalState":return this.t.createInstance(h.$pFb,this.profile,this.collection);case"extensions":return this.t.createInstance(u.$w5b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$s7b,this.profile,this.collection)}}async sync(y,I,T,M){if(M.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const q=[],Y=(0,i.$$gb)(T),K=(this.collection?y?.collections?.[this.collection]?.latest:y?.latest)??null,x=I?await this.I(K):{};for(const H of U){if(M.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(I){const Q=await H.preview(K,x,Y);if(Q)for(const J of Q.resourcePreviews)(J.localChange!==0||J.remoteChange!==0)&&J.mergeState==="preview"&&await H.merge(J.previewResource)}else await H.sync(K,Y)}catch(Q){const J=i.$_gb.toUserDataSyncError(Q);if(m(J,T,this.w,this.y),v(Q))throw J;this.z.error(Q),this.z.error(`${H.resource}: ${(0,j.$Ii)(Q)}`),q.push([H.resource,J])}}return q}finally{this.L()}}async apply(y,I){const T=(0,i.$$gb)(y);for(const M of this.enabled){if(I.isCancellationRequested)return;try{await M.apply(!1,T)}catch(U){const q=i.$_gb.toUserDataSyncError(U);if(m(q,y,this.w,this.y),v(U))throw q;this.z.error(U),this.z.error(`${M.resource}: ${(0,j.$Ii)(U)}`)}}}async stop(){for(const y of this.enabled)try{y.status!=="idle"&&await y.stop()}catch(I){this.z.error(I)}}async resetLocal(){for(const y of this.enabled)try{await y.resetLocal()}catch(I){this.z.error(`${y.resource}: ${(0,j.$Ii)(I)}`),this.z.error(I)}}async I(y){if(!this.profile.isDefault)return{};const I=this.D.getValue(i.$Ygb),T=this.enabled.find(M=>M instanceof E.$E5b);if(T){const M=await T.getRemoteUserDataSyncConfiguration(y);return{...I,...M}}return I}J(y){this.g!==y&&(this.g=y,this.h.fire(y))}L(){return this.M(),this.enabled.some(y=>y.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(y=>y.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const y=this.enabled.filter(I=>I.status==="hasConflicts").filter(I=>I.conflicts.conflicts.length>0).map(I=>I.conflicts);(0,D.$tb)(this.m,y,(I,T)=>I.syncResource===T.syncResource&&(0,D.$tb)(I.conflicts,T.conflicts,(M,U)=>(0,S.$ug)(M.previewResource,U.previewResource)))||(this.m=y,this.n.fire(y))}N(y){switch(y){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=pe([Z(2,i.$ehb),Z(3,$.$Wh),Z(4,g.$fo),Z(5,i.$6gb),Z(6,w.$kl),Z(7,i.$jhb),Z(8,l.$Sk),Z(9,k.$ri)],a);function v(f){if(f instanceof i.$_gb)switch(f.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function m(f,y,I,T){T.publicLog2("sync/error",{code:f.code,serverCode:f instanceof i.$ahb?String(f.serverCode):void 0,url:f instanceof i.$ahb?f.url:void 0,resource:f.resource,executionId:y,service:I.userDataSyncStore.url.toString()})}}),define(ae[260],ce([0,1,3,2,10,17,24]),function(ie,e,D,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U0b=e.$T0b=void 0;function P(g,c){return{...g,profile:(0,j.$Tk)(g.profile,c.profilesHome.scheme)}}function S(g){return{created:g.created,uri:L.URI.revive(g.uri)}}class b{constructor(c,$,p){this.c=c,this.d=$,this.f=p,this.a=new Map,this.b=new D.$Rd}listen(c,$){switch($){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${$}`)}async call(c,$,p){try{return await this.g(c,$,p)}catch(w){throw this.f.error(w),w}}async g(c,$,p){switch($){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(L.URI.revive(p[0]));case"accept":return this.c.accept(P(p[0],this.d),L.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(S(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(L.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(L.URI.revive(p[0]),L.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if($.startsWith("manualSync/")){const w=$.substring(11),l=p[0],u=this.h(l);switch(p=p.slice(1),w){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(c){const $=this.a.get(this.j(c));if(!$)throw new Error(`Manual sync taks not found: ${c}`);return $}async i(){const c=await this.c.createManualSyncTask();return this.a.set(this.j(c.id),c),c.id}j(c){return`manualSyncTask-${c}`}}e.$T0b=b;let C=class extends A.$Rc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(c,$){super(),this.n=$,this.b="uninitialized",this.c=this.B(new D.$Rd),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new D.$Rd),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new D.$Rd),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new D.$Rd),this.onSyncErrors=this.m.event,this.a={call(p,w,l){return c.call(p,w,l).then(null,u=>{throw O.$_gb.toUserDataSyncError(u)})},listen(p,w){return c.listen(p,w)}},this.a.call("_getInitialData").then(([p,w,l])=>{this.s(p),this.t(w),l&&this.u(l),this.B(this.a.listen("onDidChangeStatus")(u=>this.s(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.u(u)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(w=>({...w,error:O.$_gb.toUserDataSyncError(w.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const c=await this.a.call("createManualSyncTask"),$=this;return new k(c,{async call(w,l,u){return $.a.call(`manualSync/${w}`,[c,...Array.isArray(l)?l:[l]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(c,$,p,w){return this.a.call("accept",[c,$,p,w])}resolveContent(c){return this.a.call("resolveContent",[c])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(c){return this.a.call("replace",[c])}saveRemoteActivityData(c){return this.a.call("getRemoteActivityData",[c])}extractActivityData(c,$){return this.a.call("extractActivityData",[c,$])}async s(c){this.b=c,this.c.fire(c)}async t(c){this.f=c.map($=>({syncResource:$.syncResource,profile:(0,j.$Tk)($.profile,this.n.profilesHome.scheme),conflicts:$.conflicts.map(p=>({...p,baseResource:L.URI.revive(p.baseResource),localResource:L.URI.revive(p.localResource),remoteResource:L.URI.revive(p.remoteResource),previewResource:L.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u(c){this.h!==c&&(this.h=c,this.j.fire(c))}};e.$U0b=C,e.$U0b=C=pe([Z(1,j.$Sk)],C);class k extends A.$Rc{constructor(c,$){super(),this.id=c,this.a=$}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(ae[261],ce([0,1,6,26,7,3,2,139,5,19,12,10,32,20,14,11,25,58,43,21,24]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l,u,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fFb=e.$eFb=e.$dFb=e.$cFb=e.$bFb=void 0;const E="configurationSync.store",s="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",i="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends O.$Rc{get userDataSyncStore(){return this.b}get c(){return this.h.get(d.$chb,-1)}set c(T){this.h.store(d.$chb,T,-1,S.$o?0:1)}constructor(T,M,U){super(),this.f=T,this.g=M,this.h=U,this.a=this.B(new j.$Rd),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const q=this.B(new O.$Qc);this.B(j.Event.filter(U.onDidChangeValue(-1,d.$chb,q),()=>this.c!==this.userDataSyncStore?.type,q)(()=>this.j()))}j(){this.b=this.m(this.f[E]),this.a.fire()}m(T){if(T&&(T=S.$o&&T.web?{...T,...T.web}:T,(0,C.$Cf)(T.url)&&(0,C.$Ef)(T.authenticationProviders)&&Object.keys(T.authenticationProviders).every(M=>Array.isArray(T.authenticationProviders[M].scopes)))){const M=T,U=!!M.canSwitch,q=M.url===M.insidersUrl?"insiders":"stable",Y=(U?this.c:void 0)||q,K=Y==="insiders"?M.insidersUrl:Y==="stable"?M.stableUrl:M.url;return{url:k.URI.parse(K),type:Y,defaultType:q,defaultUrl:k.URI.parse(M.url),stableUrl:k.URI.parse(M.stableUrl),insidersUrl:k.URI.parse(M.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(M.authenticationProviders).reduce((x,H)=>(x.push({id:H,scopes:M.authenticationProviders[H].scopes}),x),[])}}}};e.$bFb=a,e.$bFb=a=pe([Z(0,w.$xj),Z(1,c.$ri),Z(2,h.$bp)],a);let v=class extends a{constructor(T,M,U){super(T,M,U);const q=this.h.get(s,-1);q&&(this.n=JSON.parse(q));const Y=this.f[E];Y?this.h.store(s,JSON.stringify(Y),-1,1):this.h.remove(s,-1)}async switch(T){T!==this.c&&(this.c=T,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$cFb=v,e.$cFb=v=pe([Z(0,w.$xj),Z(1,c.$ri),Z(2,h.$bp)],v);let m=class extends O.$Rc{get donotMakeRequestsUntil(){return this.j}constructor(T,M,U,q,Y,K,x){super(),this.n=U,this.r=q,this.s=x,this.g=this.B(new j.$Rd),this.onTokenFailed=this.g.event,this.h=this.B(new j.$Rd),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new j.$Rd),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(T),this.c=(0,u.$hp)(Y,K,x).then(H=>{const Q={"X-Client-Name":`${M.applicationName}${S.$o?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(Q["X-Client-Commit"]=M.commit),Q}),this.f=new y(t,r,this.n,this.r),this.u(),this.B((0,O.$Pc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(T,M){this.b={token:T,type:M}}t(T){this.a=T?(0,b.$Bg)(T,"v1"):void 0}u(){const T=this.s.getNumber(o,-1);T&&Date.now()<T&&this.y(new Date(T))}y(T){this.j?.getTime()!==T?.getTime()&&(this.j=T,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,D.$Ng)(M=>(0,D.$1g)(this.j.getTime()-Date.now(),M).then(()=>this.y(void 0))),this.w.then(null,M=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,b.$Bg)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const U=await this.D(M,{type:"GET",headers:T},[],A.CancellationToken.None);return(await(0,l.$7o)(U))?.map(({id:q})=>q)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,b.$Bg)(this.a,"collection").toString();T={...T},T["Content-Type"]=P.$Xr.text;const U=await this.D(M,{type:"POST",headers:T},[],A.CancellationToken.None),q=await(0,l.$6o)(U);if(!q)throw new d.$ahb("Server did not return the collection id",M,"NoCollection",U.res.statusCode,U.res.headers[d.$9gb]);return q}async deleteCollection(T,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=T?(0,b.$Bg)(this.a,"collection",T).toString():(0,b.$Bg)(this.a,"collection").toString();M={...M},await this.D(U,{type:"DELETE",headers:M},[],A.CancellationToken.None)}async getAllResourceRefs(T,M){if(!this.a)throw new Error("No settings sync store url configured.");const U=this.z(this.a,M,T),q={},Y=await this.D(U.toString(),{type:"GET",headers:q},[],A.CancellationToken.None);return(await(0,l.$7o)(Y)||[]).map(({url:x,created:H})=>({ref:(0,b.$Dg)(U,U.with({path:x})),created:H*1e3}))}async resolveResourceContent(T,M,U,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,b.$Bg)(this.z(this.a,U,T),M).toString();q={...q},q["Cache-Control"]="no-cache";const K=await this.D(Y,{type:"GET",headers:q},[],A.CancellationToken.None);return await(0,l.$6o)(K)}async deleteResource(T,M,U){if(!this.a)throw new Error("No settings sync store url configured.");const q=M!==null?(0,b.$Bg)(this.z(this.a,U,T),M).toString():this.z(this.a,U,T).toString(),Y={};await this.D(q,{type:"DELETE",headers:Y},[],A.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,b.$Bg)(this.a,"resource").toString(),M={"Content-Type":P.$Xr.text};await this.D(T,{type:"DELETE",headers:M},[],A.CancellationToken.None)}async readResource(T,M,U,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,b.$Bg)(this.z(this.a,U,T),"latest").toString();q={...q},q["Cache-Control"]="no-cache",M&&(q["If-None-Match"]=M.ref);const K=await this.D(Y,{type:"GET",headers:q},[304],A.CancellationToken.None);let x=null;if(K.res.statusCode===304&&(x=M),x===null){const H=K.res.headers.etag;if(!H)throw new d.$ahb("Server did not return the ref",Y,"NoRef",K.res.statusCode,K.res.headers[d.$9gb]);const Q=await(0,l.$6o)(K);if(!Q&&K.res.statusCode===304)throw new d.$ahb("Empty response",Y,"EmptyResponse",K.res.statusCode,K.res.headers[d.$9gb]);x={ref:H,content:Q}}return x}async writeResource(T,M,U,q,Y={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=this.z(this.a,q,T).toString();Y={...Y},Y["Content-Type"]=P.$Xr.text,U&&(Y["If-Match"]=U);const x=await this.D(K,{type:"POST",data:M,headers:Y},[],A.CancellationToken.None),H=x.res.headers.etag;if(!H)throw new d.$ahb("Server did not return the ref",K,"NoRef",x.res.statusCode,x.res.headers[d.$9gb]);return H}async manifest(T,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,b.$Bg)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",T&&(M["If-None-Match"]=T.ref);const q=await this.D(U,{type:"GET",headers:M},[304],A.CancellationToken.None);let Y=null;if(q.res.statusCode===304&&(Y=T),!Y){const x=q.res.headers.etag;if(!x)throw new d.$ahb("Server did not return the ref",U,"NoRef",q.res.statusCode,q.res.headers[d.$9gb]);const H=await(0,l.$6o)(q);if(!H&&q.res.statusCode===304)throw new d.$ahb("Empty response",U,"EmptyResponse",q.res.statusCode,q.res.headers[d.$9gb]);H&&(Y={...JSON.parse(H),ref:x})}const K=this.s.get(n,-1);return K&&Y&&K!==Y.session&&this.C(),Y===null&&K&&this.C(),Y&&this.s.store(n,Y.session,-1,1),Y}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,b.$Bg)(this.a,"download").toString(),M={},U=await this.D(T,{type:"GET",headers:M},[],A.CancellationToken.None);if(!(0,l.$3o)(U))throw new d.$ahb("Server returned "+U.res.statusCode,T,"EmptyResponse",U.res.statusCode,U.res.headers[d.$9gb]);if((0,l.$4o)(U))throw new d.$ahb("Empty response",T,"EmptyResponse",U.res.statusCode,U.res.headers[d.$9gb]);return U.stream}z(T,M,U){return M?(0,b.$Bg)(T,"collection",M,"resource",U):(0,b.$Bg)(T,"resource",U)}C(){this.s.remove(n,-1),this.s.remove(i,-1)}async D(T,M,U,q){if(!this.b)throw new d.$ahb("No Auth Token Available",T,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new d.$ahb(`${M.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Y=await this.c;M.headers={...M.headers||{},...Y,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(M.headers),this.r.trace("Sending request to server",{url:T,type:M.type,headers:{...M.headers,authorization:void 0}});let K;try{K=await this.f.request(T,M,q)}catch(W){if(!(W instanceof d.$ahb)){let ee="RequestFailed";const ne=(0,L.$9)(W).toLowerCase();ne.includes("xhr timeout")?ee="RequestTimeout":ne.includes("protocol")&&ne.includes("not supported")?ee="RequestProtocolNotSupported":ne.includes("request path contains unescaped characters")?ee="RequestPathNotEscaped":ne.includes("headers must be an object")?ee="RequestHeadersNotObject":(0,L.$3)(W)&&(ee="RequestCanceled"),W=new d.$ahb(`Connection refused for the request '${T}'.`,T,ee,void 0,void 0)}throw this.r.info("Request failed",T),W}const x=K.res.headers[d.$9gb],H={url:T,status:K.res.statusCode,"execution-id":M.headers[d.$0gb],"operation-id":x},Q=(0,l.$3o)(K)||K.res.statusCode&&U.includes(K.res.statusCode);let J="";if(Q?this.r.trace("Request succeeded",H):(J=await(0,l.$5o)(K)||"",this.r.info("Request failed",H,J)),K.res.statusCode===401||K.res.statusCode===403){if(this.b=void 0,K.res.statusCode===401)throw this.g.fire("Unauthorized"),new d.$ahb(`${M.type} request '${T}' failed because of Unauthorized (401).`,T,"Unauthorized",K.res.statusCode,x);if(K.res.statusCode===403)throw this.g.fire("Forbidden"),new d.$ahb(`${M.type} request '${T}' failed because the access is forbidden (403).`,T,"Forbidden",K.res.statusCode,x)}if(this.h.fire(),K.res.statusCode===404)throw new d.$ahb(`${M.type} request '${T}' failed because the requested resource is not found (404).`,T,"NotFound",K.res.statusCode,x);if(K.res.statusCode===405)throw new d.$ahb(`${M.type} request '${T}' failed because the requested endpoint is not found (405). ${J}`,T,"MethodNotFound",K.res.statusCode,x);if(K.res.statusCode===409)throw new d.$ahb(`${M.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,"Conflict",K.res.statusCode,x);if(K.res.statusCode===410)throw new d.$ahb(`${M.type} request '${T}' failed because the requested resource is not longer available (410).`,T,"Gone",K.res.statusCode,x);if(K.res.statusCode===412)throw new d.$ahb(`${M.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,"PreconditionFailed",K.res.statusCode,x);if(K.res.statusCode===413)throw new d.$ahb(`${M.type} request '${T}' failed because of too large payload (413).`,T,"TooLarge",K.res.statusCode,x);if(K.res.statusCode===426)throw new d.$ahb(`${M.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,"UpgradeRequired",K.res.statusCode,x);if(K.res.statusCode===429){const W=K.res.headers["retry-after"];throw W?(this.y(new Date(Date.now()+parseInt(W)*1e3)),new d.$ahb(`${M.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",K.res.statusCode,x)):new d.$ahb(`${M.type} request '${T}' failed because of too many requests (429).`,T,"RemoteTooManyRequests",K.res.statusCode,x)}if(!Q)throw new d.$ahb("Server returned "+K.res.statusCode,T,"Unknown",K.res.statusCode,x);return K}F(T){let M=this.s.get(i,-1);M===void 0&&(M=(0,g.$kg)(),this.s.store(i,M,-1,1)),T["X-Machine-Session-Id"]=M;const U=this.s.get(n,-1);U!==void 0&&(T["X-User-Session-Id"]=U)}};e.$dFb=m,e.$dFb=m=pe([Z(1,w.$xj),Z(2,l.$1o),Z(3,d.$jhb),Z(4,$.$5h),Z(5,p.$gk),Z(6,h.$bp)],m);let f=class extends m{constructor(T,M,U,q,Y,K,x){super(T.userDataSyncStore?.url,M,U,q,Y,K,x),this.B(T.onDidChangeUserDataSyncStore(()=>this.t(T.userDataSyncStore?.url)))}};e.$eFb=f,e.$eFb=f=pe([Z(0,d.$6gb),Z(1,w.$xj),Z(2,l.$1o),Z(3,d.$jhb),Z(4,$.$5h),Z(5,p.$gk),Z(6,h.$bp)],f);class y{constructor(T,M,U,q){this.c=T,this.d=M,this.f=U,this.g=q,this.a=[],this.b=void 0}request(T,M,U){if(this.h()&&this.i(),M.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new d.$ahb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(M,U)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$fFb=y}),define(ae[262],ce([0,1,3,56,25,21,22,257,24,80,83]),function(ie,e,D,A,L,j,O,P,S,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c$b=void 0;let k=class extends P.$w7b{constructor(c,$,p,w,l,u,h,d,E,s,o){super(c,$,p,w,l,h,d,E,s,o),this.B(D.Event.debounce(D.Event.any(D.Event.map(u.onDidFocusMainWindow,()=>"windowFocus"),D.Event.map(u.onDidOpenMainWindow,()=>"windowOpen")),(n,i)=>n?[...n,i]:[i],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$c$b=k,e.$c$b=k=pe([Z(0,L.$xj),Z(1,S.$6gb),Z(2,S.$7gb),Z(3,S.$ehb),Z(4,S.$fhb),Z(5,A.$68b),Z(6,S.$jhb),Z(7,b.$SDb),Z(8,O.$kl),Z(9,C.$Tgb),Z(10,j.$bp)],k)}),define(ae[263],ce([0,1,72,23,5,19]),function(ie,e,D,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A8b=e.$z8b=e.$y8b=e.$x8b=void 0,e.$x8b=128/4;function O(b){function C(){let k=b.scheme===A.Schemas.file?(0,j.$pg)(b):b.toString();return L.$k||(k=k.toLowerCase()),(0,D.createHash)("md5").update(k).digest("hex")}return{id:C(),configPath:b}}e.$y8b=O;function P(b,C){function k(){if(b.scheme!==A.Schemas.file)return(0,D.createHash)("md5").update(b.toString()).digest("hex");if(!C)return;let c;return L.$k?c=C.ino:L.$j?c=C.birthtime.getTime():L.$i&&(typeof C.birthtimeMs=="number"?c=Math.floor(C.birthtimeMs):c=C.birthtime.getTime()),(0,D.createHash)("md5").update(b.fsPath).update(c?String(c):"").digest("hex")}const g=k();if(typeof g=="string")return{id:g,uri:b}}e.$z8b=P;function S(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$A8b=S}),define(ae[264],ce([0,1,6,7,2,16,31,14,8,77,112,263,56,55,23]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I0b=void 0;let p=class extends L.$Rc{constructor(l,u,h,d){super(),this.a=l,this.b=u,this.c=h,this.f=d,this.B(new D.$_g(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const l=this.a.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,u=await O.Promises.readdir(l),h=new b.$rEb(this.f.getChannel("storage"));await Promise.all(u.map(async d=>{const E=(0,j.$ic)(l,d);d.length===k.$x8b||d===C.$0h.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===d)||await h.isUsed(E)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await O.Promises.rm(E))}))}catch(l){(0,A.$Z)(l)}}};e.$I0b=p,e.$I0b=p=pe([Z(0,P.$6h),Z(1,S.$fj),Z(2,g.$68b),Z(3,c.$h0b)],p)}),define(ae[122],ce([0,1,72,63,36,272,15,7,3,2,16,5,32,40,67]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=void 0;class p{traceSocketEvent(f,y){$.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,y)}constructor(f,y=""){this.f=!0,this.debugLabel=y,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=I=>{if(this.traceSocketEvent("error",{code:I?.code,message:I?.message}),I){if(I.code==="EPIPE")return;(0,P.$Z)(I)}},this.socket.on("error",this.a),this.b=I=>{this.traceSocketEvent("close",{hadError:I}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const y=I=>{this.traceSocketEvent("read",I),f(O.$fe.wrap(I))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(f){const y=I=>{f({type:0,hadError:I,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(f){const y=()=>{f()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,P.$Z)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,P.$Z)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const I=()=>{this.socket.off("close",I),this.socket.off("end",I),this.socket.off("error",I),this.socket.off("timeout",I),this.socket.off("drain",I),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",I),this.socket.on("end",I),this.socket.on("error",I),this.socket.on("timeout",I),this.socket.on("drain",I)})}}e.$Mh=p;var w;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var l;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(l||(l={}));class u extends b.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,y){this.socket.traceSocketEvent(f,y)}constructor(f,y,I,T){super(),this.f=this.B(new S.$Rd),this.g=this.B(new S.$Rd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:I?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new h(this,y,I,T,this.f,(M,U)=>this.m(M,U))),this.B(this.a.onError(M=>{console.error(M),(0,P.$Z)(M),this.g.fire({type:0,hadError:!0,error:M})})),this.b=new $.$Hh,this.B(this.socket.onData(M=>this.n(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let y=0;for(;y<f.byteLength;)this.a.writeMessage(f.slice(y,Math.min(y+262144,f.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(f,{compressed:y,opcode:I}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let T=2;f.byteLength<126?T+=0:f.byteLength<2**16?T+=2:T+=8;const M=O.$fe.alloc(T),U=y?64:0,q=I&15;if(M.writeUInt8(128|U|q,0),f.byteLength<126)M.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){M.writeUInt8(126,1);let Y=1;M.writeUInt8(f.byteLength>>>8&255,++Y),M.writeUInt8(f.byteLength>>>0&255,++Y)}else{M.writeUInt8(127,1);let Y=1;M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(f.byteLength>>>24&255,++Y),M.writeUInt8(f.byteLength>>>16&255,++Y),M.writeUInt8(f.byteLength>>>8&255,++Y),M.writeUInt8(f.byteLength>>>0&255,++Y)}this.socket.write(O.$fe.concat([M,f]))}end(){this.h=!0,this.socket.end()}n(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),I=y.readUInt8(0),T=(I&128)>>>7,M=(I&64)>>>6,U=I&15,q=y.readUInt8(1),Y=(q&128)>>>7,K=q&127;this.j.state=2,this.j.readLen=2+(Y?4:0)+(K===126?2:0)+(K===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),I=y.readUInt8(1),T=(I&128)>>>7;let M=I&127,U=1;M===126?M=y.readUInt8(++U)*2**8+y.readUInt8(++U):M===127&&(M=y.readUInt8(++U)*0+y.readUInt8(++U)*0+y.readUInt8(++U)*0+y.readUInt8(++U)*0+y.readUInt8(++U)*2**24+y.readUInt8(++U)*2**16+y.readUInt8(++U)*2**8+y.readUInt8(++U));let q=0;T&&(q=y.readUInt8(++U)*2**24+y.readUInt8(++U)*2**16+y.readUInt8(++U)*2**8+y.readUInt8(++U)),this.j.state=3,this.j.readLen=M,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),s(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Nh=u;class h extends b.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$fe.alloc(0)}constructor(f,y,I,T,M,U){super(),this.n=f,this.r=M,this.s=U,this.a=this.B(new S.$Rd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new S.$Rd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new S.$Rd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new d(this.n,T,I,{windowBits:15})),this.f=this.B(new E(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(f,y){this.g.push({data:f,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:f,options:y}=this.g.shift();if(this.f&&y.compressed){const I=await this.w(this.f,f);this.s(I,y)}else this.s(f,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(f,y){return new Promise((I,T)=>{f.write(y),f.flush(M=>I(M))})}acceptFrame(f,y,I){this.h.push({data:f,isCompressed:y,isLastFrameOfMessage:I}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const y=await this.C(this.b,f.data,f.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(f.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(f,y,I){return new Promise((T,M)=>{f.write(y),I&&f.write(O.$fe.fromByteArray([0,0,255,255])),f.flush(U=>T(U))})}}class d extends b.$Rc{get recordedInflateBytes(){return this.j?O.$fe.concat(this.f):O.$fe.alloc(0)}constructor(f,y,I,T){super(),this.h=f,this.j=y,this.a=this.B(new S.$Rd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(T),this.b.on("error",M=>{this.h.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent("zlibInflateData",M),this.g.push(O.$fe.wrap(M))}),I&&(this.h.traceSocketEvent("zlibInflateInitialWrite",I.buffer),this.b.write(I.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=O.$fe.concat(this.g);this.g.length=0,f(y)})}}class E extends b.$Rc{constructor(f,y){super(),this.g=f,this.a=this.B(new S.$Rd),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",I=>{this.g.traceSocketEvent("zlibDeflateError",{message:I?.message,code:I?.code}),this.a.fire(I)}),this.b.on("data",I=>{this.g.traceSocketEvent("zlibDeflateData",I),this.f.push(O.$fe.wrap(I))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=O.$fe.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),f(y)})}}function s(m,f){if(f===0)return;const y=m.byteLength>>>2;for(let Y=0;Y<y;Y++){const K=m.readUInt32BE(Y*4);m.writeUInt32BE(K^f,Y*4)}const I=y*4,T=m.byteLength-I,M=f>>>24&255,U=f>>>16&255,q=f>>>8&255;T>=1&&m.writeUInt8(m.readUInt8(I)^M,I),T>=2&&m.writeUInt8(m.readUInt8(I+1)^U,I+1),T>=3&&m.writeUInt8(m.readUInt8(I+2)^q,I+2)}e.$Oh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function n(){const m=(0,g.$kg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const f=process.platform!=="darwin"&&e.$Oh?e.$Oh:(0,L.tmpdir)(),y=(0,C.$ic)(f,`vscode-ipc-${m}.sock`);return t(y),y}e.$Ph=n;function i(m,f,y){const I=(0,D.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${y}-${f}-sock`;const T=y.substr(0,4),M=f.substr(0,6),U=I.substr(0,8);let q;return process.platform!=="darwin"&&e.$Oh&&!process.env.VSCODE_PORTABLE?q=(0,C.$ic)(e.$Oh,`vscode-${U}-${T}-${M}.sock`):q=(0,C.$ic)(m,`${T}-${M}.sock`),t(q),q}e.$Qh=i;function t(m){const f=o[k.$u];typeof f=="number"&&m.length>=f&&console.warn(`WARNING: IPC handle "${m}" is longer than ${f} chars, try a shorter --user-data-dir`)}class r extends c.$Bh{static b(f){const y=S.Event.fromNodeEventEmitter(f,"connection");return S.Event.map(y,I=>({protocol:new $.$Ih(new p(I,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(I,"close"))}))}constructor(f){super(r.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Rh=r;function a(m){return new Promise((f,y)=>{const I=(0,A.createServer)();I.on("error",y),I.listen(m,()=>{I.removeListener("error",y),f(new r(I))})})}e.$Sh=a;function v(m,f){return new Promise((y,I)=>{const T=(0,A.createConnection)(m,()=>{T.removeListener("error",I),y($.$Jh.fromSocket(new p(T,`ipc-client${f}`),f))});T.once("error",I)})}e.$Th=v}),define(ae[265],ce([0,1,63,122,211]),function(ie,e,D,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f$b=void 0,e.$f$b=new class{supports(j){return!0}connect({host:j,port:O},P,S,b){return new Promise((C,k)=>{const g=D.createConnection({host:j,port:O},()=>{g.removeListener("error",k),g.write((0,L.$eqb)(P,S,b));const c=$=>{$.toString().indexOf(`\r
\r
`)>=0&&(g.off("data",c),C(new A.$Mh(g,b)))};g.on("data",c)});g.setNoDelay(!0),g.once("error",k)})}}}),define(ae[266],ce([0,1,63,36,132,122,6,2,5,20,8,25,214,104,106,78,15]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b0b=e.$a0b=e.$_9b=e.$$9b=void 0;async function l(s,o,n,i,t){let r;for(let a=3;a&&(r?.dispose(),r=await new u(s,o,n,i,t).waitForReady(),!(t&&L.$ng[t]||!L.$ng[r.tunnelLocalPort]));a--);return r}class u extends P.$Rc{constructor(o,n,i,t,r){super(),this.m=n,this.n=r,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=D.createServer(),this.c=new O.$Yg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,n=(0,p.$mv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,L.$og)(o,2,1e3,n),t=null;return this.b.listen(i,this.m),await this.c.wait(),t=this.b.address(),t||(i=0,this.b.listen(i,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const n=(0,p.$kv)(this.tunnelRemoteHost)||(0,p.$mv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,g.$bl)(this.a,n,this.tunnelRemotePort),t=i.getSocket(),r=i.readEntireBuffer();i.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof j.$Mh?t.socket.destroy():t.end()}),t instanceof j.$Mh?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(i=>o.write(i.buffer)),o.on("data",i=>n.write(w.$fe.wrap(i))),o.resume()}t(o,n){const i=n.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$$9b=u;let h=class extends p.$pv{constructor(o,n,i,t,r){super(n,r),this.u=o,this.v=i,this.w=t}isPortPrivileged(o){return(0,p.$nv)(o,this.l,S.OS,A.release())}s(o,n,i,t,r,a,v,m){const f=this.r(n,i);if(f)return++f.refcount,f.value;if((0,p.$hv)(o))return this.t(o,n,i,r,a,v,m);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${i} on local port ${r}.`);const y={commit:this.w.commit,quality:this.w.quality,addressProvider:o,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},I=l(y,t,n,i,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(n,i,I),I}}};e.$_9b=h,e.$_9b=h=pe([Z(0,c.$8k),Z(1,C.$fj),Z(2,$.$$k),Z(3,k.$xj),Z(4,b.$ri)],h);let d=class extends h{constructor(o,n,i,t,r){super(o,n,i,t,r)}};e.$a0b=d,e.$a0b=d=pe([Z(0,c.$8k),Z(1,C.$fj),Z(2,$.$$k),Z(3,k.$xj),Z(4,b.$ri)],d);let E=class extends P.$Rc{constructor(o,n,i,t,r){super(),this.b=o,this.c=n,this.f=i,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,n,i,t,r,a,v,m,f){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${t} on local port ${a}.`),!this.a.has(o)){const y=new d(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(o,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(n,i,t,r,a,v,m,f)}};e.$b0b=E,e.$b0b=E=pe([Z(0,c.$8k),Z(1,C.$fj),Z(2,k.$xj),Z(3,$.$$k),Z(4,b.$ri)],E)}),define(ae[273],ce([0,1,36,38,7,2,23,10,18,3,40,146,205,206,196,197,264,187,189,20,210,95,221,96,216,14,114,248,29,97,188,113,98,11,199,200,71,4,195,73,74,227,8,201,102,25,58,21,107,22,108,109,110,45,230,82,111,24,80,256,240,241,83,255,259,260,261,59,254,242,106,220,78,266,215,231,28,232,5,233,190,208,207,81,247,17,51,204,57,253,229,243,105,258,249,9,202,101,251,246,217,184,56,203,262,250,55,252,104,265,181,218]),function(ie,e,D,A,L,j,O,P,S,b,C,k,g,c,$,p,w,l,u,h,d,E,s,o,n,i,t,r,a,v,m,f,y,I,T,M,U,q,Y,K,x,H,Q,J,W,ee,ne,_,se,X,z,R,F,B,N,V,G,te,oe,ue,he,ge,de,we,ve,Ie,Ne,Me,le,$e,be,Se,Ce,Ue,je,ze,Te,re,fe,me,ye,ke,Pe,Re,Oe,De,Ae,Fe,Be,qe,We,_e,ut,yt,vt,Et,kt,ft,St,Rt,Ct,Pt,It,Ot,Dt,jt,dt,Lt,gt,At,Nt,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ft extends j.$Rc{constructor(Ee){super(),this.f=Ee,this.a=this.B(new k.$$T(this)),this.b=void 0,this.c=this.B(new b.$Rd),this.g()}g(){let Ee=!1;const Le=()=>{Ee||(Ee=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Le),(0,k.$_T)(process.parentPort,it.$n9b.exit,Le)}async init(){const Ee=await this.h();(0,te.$1gb)(),Ee.invokeFunction(Le=>{const Xe=Le.get(Q.$fj),Ve=Le.get(X.$kl),Ke=Le.get(De.$Sk);Xe.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Le),this.m(Xe),this.n(Ve,Ke),this.B(Ke.onDidChangeProfiles(()=>this.n(Ve,Ke)))}),this.B((0,j.$Oc)(Ee.createInstance(g.$E0b,this.f.codeCachePath),Ee.createInstance(c.$F0b),Ee.createInstance(w.$I0b),Ee.createInstance(p.$H0b),Ee.createInstance($.$G0b),Ee.createInstance(vt.$90b),Ee.createInstance(_e.$10b)))}async h(){const Ee=new K.$Vh,Le={_serviceBrand:void 0,...W.default};Ee.set(ee.$xj,Le);const Xe=new C.$Fh(He=>He==="main"),Ve=new dt.$i0b(this.a,Xe);Ee.set(dt.$h0b,Ve);const Ke=this.f.policiesData?new Fe.$Q9b(this.f.policiesData,Ve.getChannel("policy")):new Be.$sn;Ee.set(Be.$qn,Ke);const Ge=new Nt.$rm(this.f.args,Le);Ee.set(i.$6h,Ge);const xe=new J.$gr(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(He=>({...He,resource:P.URI.revive(He.resource)})),Ve.getChannel("logger"));Ee.set(Q.$gj,xe);const st=this.B(xe.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),ct=this.B(new Q.$nj(st.getLevel())),Je=this.B(new kt.$YN(st,[ct]));Ee.set(Q.$fj,Je),this.b=this.B(new ft.$$0b(Je)),Ee.set(ft.$00b,this.b);const Qe=this.B(new T.$Vp(Je));Ee.set(I.$gk,Qe);const lt=this.B(new M.$iq(Je));Qe.registerProvider(O.Schemas.file,lt);const rt=new re.$Hr(Qe);Ee.set(Te.$Qk,rt);const Ze=this.B(new qe.$6N(this.f.profiles.all,P.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));Ee.set(De.$Sk,Ze);const ht=this.B(new me.$g0b(O.Schemas.file,this.B(new ye.$HN(Ve.getChannel(ye.$GN),{pathCaseSensitive:fe.$k})),O.Schemas.vscodeUserData,Ze,rt,Je));Qe.registerProvider(O.Schemas.vscodeUserData,ht);const Ye=this.B(new d.$Sn(Ze.defaultProfile.settingsResource,Qe,Ke,Je));Ee.set(h.$ri,Ye);const et=new Lt.$e$b(void 0,{defaultProfile:Ze.defaultProfile,currentProfile:Ze.defaultProfile},Ve,Ge);Ee.set(_.$bp,et),this.B((0,j.$Pc)(()=>et.flush())),await Promise.all([Ye.initialize(),et.initialize()]);const mt=new Ct.$5q(Ve.getChannel("request"));Ee.set(ne.$1o,mt),Ee.set(l.$J0b,new U.$Uh(u.$K0b,void 0,!1)),Ee.set(Pe.$AF,new U.$Uh(ke.$Z0b,void 0,!1));const bt=new Ot.$n0b(-1,Ve);Ee.set(It.$68b,bt),Ee.set(o.$Wn,new U.$Uh(n.$bO,void 0,!0));const Tt=this.B(new $e.$N9b(bt)),Mt=new C.$Fh(He=>Tt.getActiveClientId().then(at=>He===at));Ee.set(y.$vXb,new Pt.$a$b(this.a.getChannel("extensionRecommendationNotification",Mt)));let ot;const tt=[],wt=(0,B.$Eo)(Le,Ye);if((0,B.$zo)(Le,Ge)){const He=new R.$N6b(Je,xe,Ge,Le);if(tt.push(He),!(0,B.$Ao)(Le,Ge)&&Le.aiConfig?.ariaKey){const at=new We.$MN(mt,wt,"monacoworkbench",null,Le.aiConfig.ariaKey);this.B((0,j.$Pc)(()=>at.flush())),tt.push(at)}ot=new F.$9q({appenders:tt,commonProperties:(0,se.$po)((0,D.release)(),(0,D.hostname)(),process.arch,Le.commit,Le.version,this.f.machineId,this.f.sqmId,wt),sendErrorTelemetry:!0,piiPaths:(0,B.$Fo)(Ge)},Ye,Le)}else{ot=B.$to;const He=B.$xo;tt.push(He)}this.a.registerChannel("telemetryAppender",new z.$s9b(tt)),Ee.set(X.$kl,ot);const Ut=new N.$L0b(Ye,ot,Je,xe,Ge,Le);Ee.set(X.$ll,Ut),Ee.set(Ae.$Cp,new U.$Uh(Rt.$XN,void 0,!0)),Ee.set(Re.$Gp,new U.$Uh(Oe.$R9b,void 0,!0)),Ee.set(v.$mp,new U.$Uh(v.$np,void 0,!0)),Ee.set(f.$Qp,new U.$Uh(f.$Rp,void 0,!0)),Ee.set(a.$fo,new U.$Uh(r.$kp,void 0,!0)),Ee.set(a.$lo,new U.$Uh(jt.$d$b,void 0,!1)),Ee.set(x.$1q,new U.$Uh(H.$3q,void 0,!1)),Ee.set(E.$ym,new U.$Uh(s.$Or,void 0,!1)),Ee.set(oe.$SDb,new U.$Uh(oe.$TDb,void 0,!0)),Ee.set(te.$jhb,new U.$Uh(ge.$6Fb,void 0,!0)),Ee.set(te.$ihb,new he.$O0b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),Ee.set(a.$ko,new U.$Uh(t.$QDb,void 0,!1)),Ee.set(G.$4Fb,new U.$Uh(G.$5Fb,void 0,!0)),Ee.set(V.$5u,new U.$Uh(V.$6u)),Ee.set(te.$6gb,new U.$Uh(Ne.$cFb,void 0,!0)),Ee.set(te.$7gb,new U.$Uh(Ne.$eFb,void 0,!0)),Ee.set(de.$Tgb,new U.$Uh(de.$Vgb,void 0,!0)),Ee.set(te.$8gb,new U.$Uh(ue.$q7b,void 0,!1)),Ee.set(te.$ehb,new U.$Uh(we.$f7b,void 0,!0)),Ee.set(te.$fhb,new U.$Uh(ve.$v7b,void 0,!1)),Ee.set(Me.$sEb,new U.$Uh(le.$V0b,void 0,!0)),Ee.set(te.$ghb,new U.$Uh(yt.$77b,void 0,!0)),Ee.set(be.$$k,new U.$Uh(Se.$d0b,void 0,!1));const pt=new gt.$9k;return Ee.set(gt.$8k,pt),pt.register(0,At.$f$b),Ee.set(Ce.$gv,new U.$Uh(Ue.$b0b)),Ee.set(je.$W0b,new U.$Uh(ze.$Y0b)),Ee.set(ut.$20b,new U.$Uh(St.$_0b)),new Y.$lq(Ee)}j(Ee){const Le=this.B(new j.$Qc),Xe=new m.$pp(Ee.get(a.$ho),()=>null);this.a.registerChannel("extensions",Xe);const Ve=C.ProxyChannel.fromService(Ee.get(x.$1q),Le);this.a.registerChannel("languagePacks",Ve);const Ke=C.ProxyChannel.fromService(Ee.get(E.$ym),Le);this.a.registerChannel("diagnostics",Ke);const Ge=new m.$rp(Ee.get(a.$lo));this.a.registerChannel("extensionTipsService",Ge);const xe=C.ProxyChannel.fromService(Ee.get(l.$J0b),Le);this.a.registerChannel("checksum",xe);const st=C.ProxyChannel.fromService(Ee.get(Pe.$AF),Le);this.a.registerChannel("v8InspectProfiling",st);const ct=new he.$P0b(Ee.get(de.$Tgb));this.a.registerChannel("userDataSyncMachines",ct);const Je=C.ProxyChannel.fromService(Ee.get(X.$ll),Le);this.a.registerChannel("customEndpointTelemetry",Je);const Qe=new he.$Q0b(Ee.get(oe.$SDb));this.a.registerChannel("userDataSyncAccount",Qe);const lt=new he.$R0b(Ee.get(te.$6gb));this.a.registerChannel("userDataSyncStoreManagement",lt);const rt=new Ie.$T0b(Ee.get(te.$fhb),Ee.get(De.$Sk),Ee.get(Q.$fj));this.a.registerChannel("userDataSync",rt);const Ze=this.B(Ee.get(q.$Wh).createInstance(Dt.$c$b)),ht=new he.$M0b(Ze);this.a.registerChannel("userDataAutoSync",ht),this.a.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(Ee.get(te.$ghb),Le));const Ye=C.ProxyChannel.fromService(Ee.get(je.$W0b),Le);this.a.registerChannel(je.$X0b,Ye);const et=C.ProxyChannel.fromService(Ee.get(ut.$20b),Le);this.a.registerChannel("remoteTunnel",et)}m(Ee){process.on("uncaughtException",Le=>(0,L.$Z)(Le)),process.on("unhandledRejection",Le=>(0,L.$Z)(Le)),(0,L.setUnexpectedErrorHandler)(Le=>{const Xe=(0,A.$Ii)(Le,!0);Xe&&Ee.error(`[uncaught exception in sharedProcess]: ${Xe}`)})}n(Ee,Le){Ee.publicLog2("profilesInfo",{count:Le.profiles.length})}handledClientConnection(Ee){if(Ee.data!==it.$p9b.response)return!1;const Le=(0,S.$Nb)(Ee.ports);return Le?(this.c.fire(Le),!0):!1}}async function $t(nt){const Ee=new Ft(nt);process.parentPort.postMessage(it.$n9b.ipcReady),await Ee.init(),process.parentPort.postMessage(it.$n9b.initDone)}e.main=$t,process.parentPort.once("message",nt=>{$t(nt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/da5ab29656a9f0bef63602fbce10968a7f4db2b5/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
