/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/path","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/lazy","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/core/position","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/workbench/api/worker/extensionHostWorker"],Re=function(we){for(var e=[],E=0,T=we.length;E<T;E++)e[E]=Ae[we[E]];return e};define(Ae[66],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=void 0;function E(P){return($,m,y)=>{let A=null,S=null;if(typeof y.value=="function"?(A="value",S=y.value):typeof y.get=="function"&&(A="get",S=y.get),!S)throw new Error("not supported");y[A]=P(S,m)}}function T(P,$,m){let y=null,A=null;if(typeof m.value=="function"?(y="value",A=m.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(y="get",A=m.get),!A)throw new Error("not supported");const S=`$memoize$${$}`;m[y]=function(...l){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,l)}),this[S]}}e.$ph=T;function C(P,$,m){return E((y,A)=>{const S=`$debounce$${A}`,l=`$debounce$result$${A}`;return function(...p){this[l]||(this[l]=m?m():void 0),clearTimeout(this[S]),$&&(this[l]=$(this[l],...p),p=[this[l]]),this[S]=setTimeout(()=>{y.apply(this,p),this[l]=m?m():void 0},P)}})}e.$qh=C;function M(P,$,m){return E((y,A)=>{const S=`$throttle$timer$${A}`,l=`$throttle$result$${A}`,p=`$throttle$lastRun$${A}`,w=`$throttle$pending$${A}`;return function(...a){if(this[l]||(this[l]=m?m():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),$&&(this[l]=$(this[l],...a)),this[w])return;const s=this[p]+P;s<=Date.now()?(this[p]=Date.now(),y.apply(this,[this[l]]),this[l]=m?m():void 0):(this[w]=!0,this[S]=setTimeout(()=>{this[w]=!1,this[p]=Date.now(),y.apply(this,[this[l]]),this[l]=m?m():void 0},s-Date.now()))}})}e.$rh=M}),define(Ae[89],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=e.$GM=void 0;class E{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$GM=E,e.$HM=new E("id#")}),define(Ae[118],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var C;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function P(i,r=!1){let u=0;const f=i.length;let v="",g=0,D=16,I=0;function h(R){let L=0,O=0;for(;L<R;){const X=i.charCodeAt(u);if(X>=48&&X<=57)O=O*16+X-48;else if(X>=65&&X<=70)O=O*16+X-65+10;else if(X>=97&&X<=102)O=O*16+X-97+10;else break;u++,L++}return L<R&&(O=-1),O}function b(R){u=R,v="",g=0,D=16,I=0}function k(){const R=u;if(i.charCodeAt(u)===48)u++;else for(u++;u<i.length&&y(i.charCodeAt(u));)u++;if(u<i.length&&i.charCodeAt(u)===46)if(u++,u<i.length&&y(i.charCodeAt(u)))for(u++;u<i.length&&y(i.charCodeAt(u));)u++;else return I=3,i.substring(R,u);let L=u;if(u<i.length&&(i.charCodeAt(u)===69||i.charCodeAt(u)===101))if(u++,(u<i.length&&i.charCodeAt(u)===43||i.charCodeAt(u)===45)&&u++,u<i.length&&y(i.charCodeAt(u))){for(u++;u<i.length&&y(i.charCodeAt(u));)u++;L=u}else I=3;return i.substring(R,L)}function F(){let R="",L=u;for(;;){if(u>=f){R+=i.substring(L,u),I=2;break}const O=i.charCodeAt(u);if(O===34){R+=i.substring(L,u),u++;break}if(O===92){if(R+=i.substring(L,u),u++,u>=f){I=2;break}switch(i.charCodeAt(u++)){case 34:R+='"';break;case 92:R+="\\";break;case 47:R+="/";break;case 98:R+="\b";break;case 102:R+="\f";break;case 110:R+=`
`;break;case 114:R+="\r";break;case 116:R+="	";break;case 117:{const he=h(4);he>=0?R+=String.fromCharCode(he):I=4;break}default:I=5}L=u;continue}if(O>=0&&O<=31)if(m(O)){R+=i.substring(L,u),I=2;break}else I=6;u++}return R}function W(){if(v="",I=0,g=u,u>=f)return g=f,D=17;let R=i.charCodeAt(u);if($(R)){do u++,v+=String.fromCharCode(R),R=i.charCodeAt(u);while($(R));return D=15}if(m(R))return u++,v+=String.fromCharCode(R),R===13&&i.charCodeAt(u)===10&&(u++,v+=`
`),D=14;switch(R){case 123:return u++,D=1;case 125:return u++,D=2;case 91:return u++,D=3;case 93:return u++,D=4;case 58:return u++,D=6;case 44:return u++,D=5;case 34:return u++,v=F(),D=10;case 47:{const L=u-1;if(i.charCodeAt(u+1)===47){for(u+=2;u<f&&!m(i.charCodeAt(u));)u++;return v=i.substring(L,u),D=12}if(i.charCodeAt(u+1)===42){u+=2;const O=f-1;let X=!1;for(;u<O;){if(i.charCodeAt(u)===42&&i.charCodeAt(u+1)===47){u+=2,X=!0;break}u++}return X||(u++,I=1),v=i.substring(L,u),D=13}return v+=String.fromCharCode(R),u++,D=16}case 45:if(v+=String.fromCharCode(R),u++,u===f||!y(i.charCodeAt(u)))return D=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=k(),D=11;default:for(;u<f&&J(R);)u++,R=i.charCodeAt(u);if(g!==u){switch(v=i.substring(g,u),v){case"true":return D=8;case"false":return D=9;case"null":return D=7}return D=16}return v+=String.fromCharCode(R),u++,D=16}}function J(R){if($(R)||m(R))return!1;switch(R){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let R;do R=W();while(R>=12&&R<=15);return R}return{setPosition:b,getPosition:()=>u,scan:r?N:W,getToken:()=>D,getTokenValue:()=>v,getTokenOffset:()=>g,getTokenLength:()=>u-g,getTokenError:()=>I}}e.$3m=P;function $(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function m(i){return i===10||i===13||i===8232||i===8233}function y(i){return i>=48&&i<=57}var A;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(A||(A={}));function S(i,r){const u=[],f=new Object;let v;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let D=!1;function I(h,b,k,F){g.value=h,g.offset=b,g.length=k,g.type=F,g.colonOffset=void 0,v=g}try{o(i,{onObjectBegin:(h,b)=>{if(r<=h)throw f;v=void 0,D=r>h,u.push("")},onObjectProperty:(h,b,k)=>{if(r<b||(I(h,b,k,"property"),u[u.length-1]=h,r<=b+k))throw f},onObjectEnd:(h,b)=>{if(r<=h)throw f;v=void 0,u.pop()},onArrayBegin:(h,b)=>{if(r<=h)throw f;v=void 0,u.push(0)},onArrayEnd:(h,b)=>{if(r<=h)throw f;v=void 0,u.pop()},onLiteralValue:(h,b,k)=>{if(r<b||(I(h,b,k,d(h)),r<=b+k))throw f},onSeparator:(h,b,k)=>{if(r<=b)throw f;if(h===":"&&v&&v.type==="property")v.colonOffset=b,D=!1,v=void 0;else if(h===","){const F=u[u.length-1];typeof F=="number"?u[u.length-1]=F+1:(D=!0,u[u.length-1]=""),v=void 0}}})}catch(h){if(h!==f)throw h}return{path:u,previousNode:v,isAtPropertyKey:D,matches:h=>{let b=0;for(let k=0;b<h.length&&k<u.length;k++)if(h[b]===u[k]||h[b]==="*")b++;else if(h[b]!=="**")return!1;return b===h.length}}}e.$4m=S;function l(i,r=[],u=M.DEFAULT){let f=null,v=[];const g=[];function D(h){Array.isArray(v)?v.push(h):f!==null&&(v[f]=h)}return o(i,{onObjectBegin:()=>{const h={};D(h),g.push(v),v=h,f=null},onObjectProperty:h=>{f=h},onObjectEnd:()=>{v=g.pop()},onArrayBegin:()=>{const h=[];D(h),g.push(v),v=h,f=null},onArrayEnd:()=>{v=g.pop()},onLiteralValue:D,onError:(h,b,k)=>{r.push({error:h,offset:b,length:k})}},u),v[0]}e.$5m=l;function p(i,r=[],u=M.DEFAULT){let f={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(h){f.type==="property"&&(f.length=h-f.offset,f=f.parent)}function g(h){return f.children.push(h),h}o(i,{onObjectBegin:h=>{f=g({type:"object",offset:h,length:-1,parent:f,children:[]})},onObjectProperty:(h,b,k)=>{f=g({type:"property",offset:b,length:-1,parent:f,children:[]}),f.children.push({type:"string",value:h,offset:b,length:k,parent:f})},onObjectEnd:(h,b)=>{f.length=h+b-f.offset,f=f.parent,v(h+b)},onArrayBegin:(h,b)=>{f=g({type:"array",offset:h,length:-1,parent:f,children:[]})},onArrayEnd:(h,b)=>{f.length=h+b-f.offset,f=f.parent,v(h+b)},onLiteralValue:(h,b,k)=>{g({type:d(h),offset:b,length:k,parent:f,value:h}),v(b+k)},onSeparator:(h,b,k)=>{f.type==="property"&&(h===":"?f.colonOffset=b:h===","&&v(b))},onError:(h,b,k)=>{r.push({error:h,offset:b,length:k})}},u);const I=f.children[0];return I&&delete I.parent,I}e.$6m=p;function w(i,r){if(!i)return;let u=i;for(const f of r)if(typeof f=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let v=!1;for(const g of u.children)if(Array.isArray(g.children)&&g.children[0].value===f){u=g.children[1],v=!0;break}if(!v)return}else{const v=f;if(u.type!=="array"||v<0||!Array.isArray(u.children)||v>=u.children.length)return;u=u.children[v]}return u}e.$7m=w;function a(i){if(!i.parent||!i.parent.children)return[];const r=a(i.parent);if(i.parent.type==="property"){const u=i.parent.children[0].value;r.push(u)}else if(i.parent.type==="array"){const u=i.parent.children.indexOf(i);u!==-1&&r.push(u)}return r}e.$8m=a;function s(i){switch(i.type){case"array":return i.children.map(s);case"object":{const r=Object.create(null);for(const u of i.children){const f=u.children[1];f&&(r[u.children[0].value]=s(f))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$9m=s;function t(i,r,u=!1){return r>=i.offset&&r<i.offset+i.length||u&&r===i.offset+i.length}e.$0m=t;function n(i,r,u=!1){if(t(i,r,u)){const f=i.children;if(Array.isArray(f))for(let v=0;v<f.length&&f[v].offset<=r;v++){const g=n(f[v],r,u);if(g)return g}return i}}e.$$m=n;function o(i,r,u=M.DEFAULT){const f=P(i,!1);function v(_){return _?()=>_(f.getTokenOffset(),f.getTokenLength()):()=>!0}function g(_){return _?Ce=>_(Ce,f.getTokenOffset(),f.getTokenLength()):()=>!0}const D=v(r.onObjectBegin),I=g(r.onObjectProperty),h=v(r.onObjectEnd),b=v(r.onArrayBegin),k=v(r.onArrayEnd),F=g(r.onLiteralValue),W=g(r.onSeparator),J=v(r.onComment),N=g(r.onError),R=u&&u.disallowComments,L=u&&u.allowTrailingComma;function O(){for(;;){const _=f.scan();switch(f.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:R||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(_){case 12:case 13:R?X(10):J();break;case 16:X(1);break;case 15:case 14:break;default:return _}}}function X(_,Ce=[],se=[]){if(N(_),Ce.length+se.length>0){let Q=f.getToken();for(;Q!==17;){if(Ce.indexOf(Q)!==-1){O();break}else if(se.indexOf(Q)!==-1)break;Q=O()}}}function he(_){const Ce=f.getTokenValue();return _?F(Ce):I(Ce),O(),!0}function $e(){switch(f.getToken()){case 11:{let _=0;try{_=JSON.parse(f.getTokenValue()),typeof _!="number"&&(X(2),_=0)}catch{X(2)}F(_);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return O(),!0}function De(){return f.getToken()!==10?(X(3,[],[2,5]),!1):(he(!1),f.getToken()===6?(W(":"),O(),Ee()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function ke(){D(),O();let _=!1;for(;f.getToken()!==2&&f.getToken()!==17;){if(f.getToken()===5){if(_||X(4,[],[]),W(","),O(),f.getToken()===2&&L)break}else _&&X(6,[],[]);De()||X(4,[],[2,5]),_=!0}return h(),f.getToken()!==2?X(7,[2],[]):O(),!0}function de(){b(),O();let _=!1;for(;f.getToken()!==4&&f.getToken()!==17;){if(f.getToken()===5){if(_||X(4,[],[]),W(","),O(),f.getToken()===4&&L)break}else _&&X(6,[],[]);Ee()||X(4,[],[4,5]),_=!0}return k(),f.getToken()!==4?X(8,[4],[]):O(),!0}function Ee(){switch(f.getToken()){case 3:return de();case 1:return ke();case 10:return he(!0);default:return $e()}}return O(),f.getToken()===17?u.allowEmptyContent?!0:(X(4,[],[]),!1):Ee()?(f.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.$_m=o;function c(i,r){const u=P(i),f=[];let v,g=0,D;do switch(D=u.getPosition(),v=u.scan(),v){case 12:case 13:case 17:g!==D&&f.push(i.substring(g,D)),r!==void 0&&f.push(u.getTokenValue().replace(/[^\r\n]/g,r)),g=u.getPosition();break}while(v!==17);return f.join("")}e.$an=c;function d(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$bn=d}),function(we,e){typeof define=="function"&&define.amd?define(Ae[119],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(we=typeof globalThis<"u"?globalThis:we||self,e(we.marked={}))}(this,function(we){"use strict";function e(le,ce){for(var be=0;be<ce.length;be++){var ee=ce[be];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(le,ee.key,ee)}}function E(le,ce,be){return ce&&e(le.prototype,ce),be&&e(le,be),Object.defineProperty(le,"prototype",{writable:!1}),le}function T(le,ce){if(le){if(typeof le=="string")return C(le,ce);var be=Object.prototype.toString.call(le).slice(8,-1);if(be==="Object"&&le.constructor&&(be=le.constructor.name),be==="Map"||be==="Set")return Array.from(le);if(be==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(be))return C(le,ce)}}function C(le,ce){(ce==null||ce>le.length)&&(ce=le.length);for(var be=0,ee=new Array(ce);be<ce;be++)ee[be]=le[be];return ee}function M(le,ce){var be=typeof Symbol<"u"&&le[Symbol.iterator]||le["@@iterator"];if(be)return(be=be.call(le)).next.bind(be);if(Array.isArray(le)||(be=T(le))||ce&&le&&typeof le.length=="number"){be&&(le=be);var ee=0;return function(){return ee>=le.length?{done:!0}:{done:!1,value:le[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function P(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}we.defaults=P();function $(le){we.defaults=le}var m=/[&<>"']/,y=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(ce){return l[ce]};function w(le,ce){if(ce){if(m.test(le))return le.replace(y,p)}else if(A.test(le))return le.replace(S,p);return le}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(le){return le.replace(a,function(ce,be){return be=be.toLowerCase(),be==="colon"?":":be.charAt(0)==="#"?be.charAt(1)==="x"?String.fromCharCode(parseInt(be.substring(2),16)):String.fromCharCode(+be.substring(1)):""})}var t=/(^|[^\[])\^/g;function n(le,ce){le=typeof le=="string"?le:le.source,ce=ce||"";var be={replace:function(fe,ie){return ie=ie.source||ie,ie=ie.replace(t,"$1"),le=le.replace(fe,ie),be},getRegex:function(){return new RegExp(le,ce)}};return be}var o=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(le,ce,be){if(le){var ee;try{ee=decodeURIComponent(s(be)).replace(o,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ce&&!c.test(be)&&(be=v(ce,be));try{be=encodeURI(be).replace(/%25/g,"%")}catch{return null}return be}var i={},r=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,f=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(le,ce){i[" "+le]||(r.test(le)?i[" "+le]=le+"/":i[" "+le]=h(le,"/",!0)),le=i[" "+le];var be=le.indexOf(":")===-1;return ce.substring(0,2)==="//"?be?ce:le.replace(u,"$1")+ce:ce.charAt(0)==="/"?be?ce:le.replace(f,"$1")+ce:le+ce}var g={exec:function(){}};function D(le){for(var ce=1,be,ee;ce<arguments.length;ce++){be=arguments[ce];for(ee in be)Object.prototype.hasOwnProperty.call(be,ee)&&(le[ee]=be[ee])}return le}function I(le,ce){var be=le.replace(/\|/g,function(ie,ae,me){for(var Pe=!1,z=ae;--z>=0&&me[z]==="\\";)Pe=!Pe;return Pe?"|":" |"}),ee=be.split(/ \|/),fe=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>ce)ee.splice(ce);else for(;ee.length<ce;)ee.push("");for(;fe<ee.length;fe++)ee[fe]=ee[fe].trim().replace(/\\\|/g,"|");return ee}function h(le,ce,be){var ee=le.length;if(ee===0)return"";for(var fe=0;fe<ee;){var ie=le.charAt(ee-fe-1);if(ie===ce&&!be)fe++;else if(ie!==ce&&be)fe++;else break}return le.slice(0,ee-fe)}function b(le,ce){if(le.indexOf(ce[1])===-1)return-1;for(var be=le.length,ee=0,fe=0;fe<be;fe++)if(le[fe]==="\\")fe++;else if(le[fe]===ce[0])ee++;else if(le[fe]===ce[1]&&(ee--,ee<0))return fe;return-1}function k(le){le&&le.sanitize&&!le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(le,ce){if(ce<1)return"";for(var be="";ce>1;)ce&1&&(be+=le),ce>>=1,le+=le;return be+le}function W(le,ce,be,ee){var fe=ce.href,ie=ce.title?w(ce.title):null,ae=le[1].replace(/\\([\[\]])/g,"$1");if(le[0].charAt(0)!=="!"){ee.state.inLink=!0;var me={type:"link",raw:be,href:fe,title:ie,text:ae,tokens:ee.inlineTokens(ae)};return ee.state.inLink=!1,me}return{type:"image",raw:be,href:fe,title:ie,text:w(ae)}}function J(le,ce){var be=le.match(/^(\s+)(?:```)/);if(be===null)return ce;var ee=be[1];return ce.split(`
`).map(function(fe){var ie=fe.match(/^\s+/);if(ie===null)return fe;var ae=ie[0];return ae.length>=ee.length?fe.slice(ee.length):fe}).join(`
`)}var N=function(){function le(be){this.options=be||we.defaults}var ce=le.prototype;return ce.space=function(ee){var fe=this.rules.block.newline.exec(ee);if(fe&&fe[0].length>0)return{type:"space",raw:fe[0]}},ce.code=function(ee){var fe=this.rules.block.code.exec(ee);if(fe){var ie=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:h(ie,`
`)}}},ce.fences=function(ee){var fe=this.rules.block.fences.exec(ee);if(fe){var ie=fe[0],ae=J(ie,fe[3]||"");return{type:"code",raw:ie,lang:fe[2]?fe[2].trim():fe[2],text:ae}}},ce.heading=function(ee){var fe=this.rules.block.heading.exec(ee);if(fe){var ie=fe[2].trim();if(/#$/.test(ie)){var ae=h(ie,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(ie=ae.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:ie,tokens:this.lexer.inline(ie)}}},ce.hr=function(ee){var fe=this.rules.block.hr.exec(ee);if(fe)return{type:"hr",raw:fe[0]}},ce.blockquote=function(ee){var fe=this.rules.block.blockquote.exec(ee);if(fe){var ie=fe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},ce.list=function(ee){var fe=this.rules.block.list.exec(ee);if(fe){var ie,ae,me,Pe,z,V,H,G,q,x,ue,Ne,Be=fe[1].trim(),Xe=Be.length>1,Je={type:"list",raw:"",ordered:Xe,start:Xe?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Xe?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Xe?Be:"[*+-]");for(var it=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&(Ne=!1,!(!(fe=it.exec(ee))||this.rules.block.hr.test(ee)));){if(ie=fe[0],ee=ee.substring(ie.length),G=fe[2].split(`
`,1)[0],q=ee.split(`
`,1)[0],this.options.pedantic?(Pe=2,ue=G.trimLeft()):(Pe=fe[2].search(/[^ ]/),Pe=Pe>4?1:Pe,ue=G.slice(Pe),Pe+=fe[1].length),V=!1,!G&&/^ *$/.test(q)&&(ie+=q+`
`,ee=ee.substring(q.length+1),Ne=!0),!Ne)for(var _e=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");ee&&(x=ee.split(`
`,1)[0],G=x,this.options.pedantic&&(G=G.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(G)||nt.test(G)||_e.test(G)||tt.test(ee)));){if(G.search(/[^ ]/)>=Pe||!G.trim())ue+=`
`+G.slice(Pe);else if(!V)ue+=`
`+G;else break;!V&&!G.trim()&&(V=!0),ie+=x+`
`,ee=ee.substring(x.length+1)}Je.loose||(H?Je.loose=!0:/\n *\n *$/.test(ie)&&(H=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(ue),ae&&(me=ae[0]!=="[ ] ",ue=ue.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:ie,task:!!ae,checked:me,loose:!1,text:ue}),Je.raw+=ie}Je.items[Je.items.length-1].raw=ie.trimRight(),Je.items[Je.items.length-1].text=ue.trimRight(),Je.raw=Je.raw.trimRight();var ze=Je.items.length;for(z=0;z<ze;z++){this.lexer.state.top=!1,Je.items[z].tokens=this.lexer.blockTokens(Je.items[z].text,[]);var ht=Je.items[z].tokens.filter(function(Z){return Z.type==="space"}),Y=ht.every(function(Z){for(var ye=Z.raw.split(""),Ue=0,He=M(ye),Ye;!(Ye=He()).done;){var st=Ye.value;if(st===`
`&&(Ue+=1),Ue>1)return!0}return!1});!Je.loose&&ht.length&&Y&&(Je.loose=!0,Je.items[z].loose=!0)}return Je}},ce.html=function(ee){var fe=this.rules.block.html.exec(ee);if(fe){var ie={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(fe[0]):w(fe[0]);ie.type="paragraph",ie.text=ae,ie.tokens=this.lexer.inline(ae)}return ie}},ce.def=function(ee){var fe=this.rules.block.def.exec(ee);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var ie=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:fe[0],href:fe[2],title:fe[3]}}},ce.table=function(ee){var fe=this.rules.block.table.exec(ee);if(fe){var ie={type:"table",header:I(fe[1]).map(function(H){return{text:H}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]&&fe[3].trim()?fe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=fe[0];var ae=ie.align.length,me,Pe,z,V;for(me=0;me<ae;me++)/^ *-+: *$/.test(ie.align[me])?ie.align[me]="right":/^ *:-+: *$/.test(ie.align[me])?ie.align[me]="center":/^ *:-+ *$/.test(ie.align[me])?ie.align[me]="left":ie.align[me]=null;for(ae=ie.rows.length,me=0;me<ae;me++)ie.rows[me]=I(ie.rows[me],ie.header.length).map(function(H){return{text:H}});for(ae=ie.header.length,Pe=0;Pe<ae;Pe++)ie.header[Pe].tokens=this.lexer.inline(ie.header[Pe].text);for(ae=ie.rows.length,Pe=0;Pe<ae;Pe++)for(V=ie.rows[Pe],z=0;z<V.length;z++)V[z].tokens=this.lexer.inline(V[z].text);return ie}}},ce.lheading=function(ee){var fe=this.rules.block.lheading.exec(ee);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:this.lexer.inline(fe[1])}},ce.paragraph=function(ee){var fe=this.rules.block.paragraph.exec(ee);if(fe){var ie=fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1];return{type:"paragraph",raw:fe[0],text:ie,tokens:this.lexer.inline(ie)}}},ce.text=function(ee){var fe=this.rules.block.text.exec(ee);if(fe)return{type:"text",raw:fe[0],text:fe[0],tokens:this.lexer.inline(fe[0])}},ce.escape=function(ee){var fe=this.rules.inline.escape.exec(ee);if(fe)return{type:"escape",raw:fe[0],text:w(fe[1])}},ce.tag=function(ee){var fe=this.rules.inline.tag.exec(ee);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):w(fe[0]):fe[0]}},ce.link=function(ee){var fe=this.rules.inline.link.exec(ee);if(fe){var ie=fe[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var ae=h(ie.slice(0,-1),"\\");if((ie.length-ae.length)%2===0)return}else{var me=b(fe[2],"()");if(me>-1){var Pe=fe[0].indexOf("!")===0?5:4,z=Pe+fe[1].length+me;fe[2]=fe[2].substring(0,me),fe[0]=fe[0].substring(0,z).trim(),fe[3]=""}}var V=fe[2],H="";if(this.options.pedantic){var G=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);G&&(V=G[1],H=G[3])}else H=fe[3]?fe[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(ie)?V=V.slice(1):V=V.slice(1,-1)),W(fe,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:H&&H.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},ce.reflink=function(ee,fe){var ie;if((ie=this.rules.inline.reflink.exec(ee))||(ie=this.rules.inline.nolink.exec(ee))){var ae=(ie[2]||ie[1]).replace(/\s+/g," ");if(ae=fe[ae.toLowerCase()],!ae||!ae.href){var me=ie[0].charAt(0);return{type:"text",raw:me,text:me}}return W(ie,ae,ie[0],this.lexer)}},ce.emStrong=function(ee,fe,ie){ie===void 0&&(ie="");var ae=this.rules.inline.emStrong.lDelim.exec(ee);if(ae&&!(ae[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var me=ae[1]||ae[2]||"";if(!me||me&&(ie===""||this.rules.inline.punctuation.exec(ie))){var Pe=ae[0].length-1,z,V,H=Pe,G=0,q=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,fe=fe.slice(-1*ee.length+Pe);(ae=q.exec(fe))!=null;)if(z=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!z){if(V=z.length,ae[3]||ae[4]){H+=V;continue}else if((ae[5]||ae[6])&&Pe%3&&!((Pe+V)%3)){G+=V;continue}if(H-=V,!(H>0)){if(V=Math.min(V,V+H+G),Math.min(Pe,V)%2){var x=ee.slice(1,Pe+ae.index+V);return{type:"em",raw:ee.slice(0,Pe+ae.index+V+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ue=ee.slice(2,Pe+ae.index+V-1);return{type:"strong",raw:ee.slice(0,Pe+ae.index+V+1),text:ue,tokens:this.lexer.inlineTokens(ue)}}}}}},ce.codespan=function(ee){var fe=this.rules.inline.code.exec(ee);if(fe){var ie=fe[2].replace(/\n/g," "),ae=/[^ ]/.test(ie),me=/^ /.test(ie)&&/ $/.test(ie);return ae&&me&&(ie=ie.substring(1,ie.length-1)),ie=w(ie,!0),{type:"codespan",raw:fe[0],text:ie}}},ce.br=function(ee){var fe=this.rules.inline.br.exec(ee);if(fe)return{type:"br",raw:fe[0]}},ce.del=function(ee){var fe=this.rules.inline.del.exec(ee);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2])}},ce.autolink=function(ee,fe){var ie=this.rules.inline.autolink.exec(ee);if(ie){var ae,me;return ie[2]==="@"?(ae=w(this.options.mangle?fe(ie[1]):ie[1]),me="mailto:"+ae):(ae=w(ie[1]),me=ae),{type:"link",raw:ie[0],text:ae,href:me,tokens:[{type:"text",raw:ae,text:ae}]}}},ce.url=function(ee,fe){var ie;if(ie=this.rules.inline.url.exec(ee)){var ae,me;if(ie[2]==="@")ae=w(this.options.mangle?fe(ie[0]):ie[0]),me="mailto:"+ae;else{var Pe;do Pe=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(Pe!==ie[0]);ae=w(ie[0]),ie[1]==="www."?me="http://"+ae:me=ae}return{type:"link",raw:ie[0],text:ae,href:me,tokens:[{type:"text",raw:ae,text:ae}]}}},ce.inlineText=function(ee,fe){var ie=this.rules.inline.text.exec(ee);if(ie){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):w(ie[0]):ie[0]:ae=w(this.options.smartypants?fe(ie[0]):ie[0]),{type:"text",raw:ie[0],text:ae}}},le}(),R={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};R._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,R._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,R.def=n(R.def).replace("label",R._label).replace("title",R._title).getRegex(),R.bullet=/(?:[*+-]|\d{1,9}[.)])/,R.listItemStart=n(/^( *)(bull) */).replace("bull",R.bullet).getRegex(),R.list=n(R.list).replace(/bull/g,R.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+R.def.source+")").getRegex(),R._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",R._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,R.html=n(R.html,"i").replace("comment",R._comment).replace("tag",R._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),R.paragraph=n(R._paragraph).replace("hr",R.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",R._tag).getRegex(),R.blockquote=n(R.blockquote).replace("paragraph",R.paragraph).getRegex(),R.normal=D({},R),R.gfm=D({},R.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),R.gfm.table=n(R.gfm.table).replace("hr",R.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",R._tag).getRegex(),R.gfm.paragraph=n(R._paragraph).replace("hr",R.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",R.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",R._tag).getRegex(),R.pedantic=D({},R.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",R._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:n(R.normal._paragraph).replace("hr",R.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",R.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var L={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};L._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",L.punctuation=n(L.punctuation).replace(/punctuation/g,L._punctuation).getRegex(),L.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,L.escapedEmSt=/\\\*|\\_/g,L._comment=n(R._comment).replace("(?:-->|$)","-->").getRegex(),L.emStrong.lDelim=n(L.emStrong.lDelim).replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimAst=n(L.emStrong.rDelimAst,"g").replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimUnd=n(L.emStrong.rDelimUnd,"g").replace(/punct/g,L._punctuation).getRegex(),L._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,L._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,L._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,L.autolink=n(L.autolink).replace("scheme",L._scheme).replace("email",L._email).getRegex(),L._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,L.tag=n(L.tag).replace("comment",L._comment).replace("attribute",L._attribute).getRegex(),L._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,L._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,L._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,L.link=n(L.link).replace("label",L._label).replace("href",L._href).replace("title",L._title).getRegex(),L.reflink=n(L.reflink).replace("label",L._label).replace("ref",R._label).getRegex(),L.nolink=n(L.nolink).replace("ref",R._label).getRegex(),L.reflinkSearch=n(L.reflinkSearch,"g").replace("reflink",L.reflink).replace("nolink",L.nolink).getRegex(),L.normal=D({},L),L.pedantic=D({},L.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",L._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",L._label).getRegex()}),L.gfm=D({},L.normal,{escape:n(L.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),L.gfm.url=n(L.gfm.url,"i").replace("email",L.gfm._extended_email).getRegex(),L.breaks=D({},L.gfm,{br:n(L.br).replace("{2,}","*").getRegex(),text:n(L.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(le){return le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function X(le){var ce="",be,ee,fe=le.length;for(be=0;be<fe;be++)ee=le.charCodeAt(be),Math.random()>.5&&(ee="x"+ee.toString(16)),ce+="&#"+ee+";";return ce}var he=function(){function le(be){this.tokens=[],this.tokens.links=Object.create(null),this.options=be||we.defaults,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:R.normal,inline:L.normal};this.options.pedantic?(ee.block=R.pedantic,ee.inline=L.pedantic):this.options.gfm&&(ee.block=R.gfm,this.options.breaks?ee.inline=L.breaks:ee.inline=L.gfm),this.tokenizer.rules=ee}le.lex=function(ee,fe){var ie=new le(fe);return ie.lex(ee)},le.lexInline=function(ee,fe){var ie=new le(fe);return ie.inlineTokens(ee)};var ce=le.prototype;return ce.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},ce.blockTokens=function(ee,fe){var ie=this;fe===void 0&&(fe=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(H,G,q){return G+"    ".repeat(q.length)});for(var ae,me,Pe,z;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(H){return(ae=H.call({lexer:ie},ee,fe))?(ee=ee.substring(ae.raw.length),fe.push(ae),!0):!1}))){if(ae=this.tokenizer.space(ee)){ee=ee.substring(ae.raw.length),ae.raw.length===1&&fe.length>0?fe[fe.length-1].raw+=`
`:fe.push(ae);continue}if(ae=this.tokenizer.code(ee)){ee=ee.substring(ae.raw.length),me=fe[fe.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=me.text):fe.push(ae);continue}if(ae=this.tokenizer.fences(ee)){ee=ee.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.heading(ee)){ee=ee.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.hr(ee)){ee=ee.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.blockquote(ee)){ee=ee.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.list(ee)){ee=ee.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.html(ee)){ee=ee.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.def(ee)){ee=ee.substring(ae.raw.length),me=fe[fe.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=me.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(ee)){ee=ee.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.lheading(ee)){ee=ee.substring(ae.raw.length),fe.push(ae);continue}if(Pe=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var H=1/0,G=ee.slice(1),q=void 0;ie.options.extensions.startBlock.forEach(function(x){q=x.call({lexer:this},G),typeof q=="number"&&q>=0&&(H=Math.min(H,q))}),H<1/0&&H>=0&&(Pe=ee.substring(0,H+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(Pe))){me=fe[fe.length-1],z&&me.type==="paragraph"?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):fe.push(ae),z=Pe.length!==ee.length,ee=ee.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(ee)){ee=ee.substring(ae.raw.length),me=fe[fe.length-1],me&&me.type==="text"?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):fe.push(ae);continue}if(ee){var V="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,fe},ce.inline=function(ee,fe){return fe===void 0&&(fe=[]),this.inlineQueue.push({src:ee,tokens:fe}),fe},ce.inlineTokens=function(ee,fe){var ie=this;fe===void 0&&(fe=[]);var ae,me,Pe,z=ee,V,H,G;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(z))!=null;)q.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(z=z.slice(0,V.index)+"["+F("a",V[0].length-2)+"]"+z.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(z))!=null;)z=z.slice(0,V.index)+"["+F("a",V[0].length-2)+"]"+z.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(z))!=null;)z=z.slice(0,V.index)+"++"+z.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(H||(G=""),H=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ue){return(ae=ue.call({lexer:ie},ee,fe))?(ee=ee.substring(ae.raw.length),fe.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(ee)){ee=ee.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.tag(ee)){ee=ee.substring(ae.raw.length),me=fe[fe.length-1],me&&ae.type==="text"&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):fe.push(ae);continue}if(ae=this.tokenizer.link(ee)){ee=ee.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(ae.raw.length),me=fe[fe.length-1],me&&ae.type==="text"&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):fe.push(ae);continue}if(ae=this.tokenizer.emStrong(ee,z,G)){ee=ee.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.codespan(ee)){ee=ee.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.br(ee)){ee=ee.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.del(ee)){ee=ee.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.autolink(ee,X)){ee=ee.substring(ae.raw.length),fe.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(ee,X))){ee=ee.substring(ae.raw.length),fe.push(ae);continue}if(Pe=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var ue=1/0,Ne=ee.slice(1),Be=void 0;ie.options.extensions.startInline.forEach(function(Xe){Be=Xe.call({lexer:this},Ne),typeof Be=="number"&&Be>=0&&(ue=Math.min(ue,Be))}),ue<1/0&&ue>=0&&(Pe=ee.substring(0,ue+1))}(),ae=this.tokenizer.inlineText(Pe,O)){ee=ee.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(G=ae.raw.slice(-1)),H=!0,me=fe[fe.length-1],me&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):fe.push(ae);continue}if(ee){var x="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return fe},E(le,null,[{key:"rules",get:function(){return{block:R,inline:L}}}]),le}(),$e=function(){function le(be){this.options=be||we.defaults}var ce=le.prototype;return ce.code=function(ee,fe,ie){var ae=(fe||"").match(/\S*/)[0];if(this.options.highlight){var me=this.options.highlight(ee,ae);me!=null&&me!==ee&&(ie=!0,ee=me)}return ee=ee.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+w(ae,!0)+'">'+(ie?ee:w(ee,!0))+`</code></pre>
`:"<pre><code>"+(ie?ee:w(ee,!0))+`</code></pre>
`},ce.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ce.html=function(ee){return ee},ce.heading=function(ee,fe,ie,ae){if(this.options.headerIds){var me=this.options.headerPrefix+ae.slug(ie);return"<h"+fe+' id="'+me+'">'+ee+"</h"+fe+`>
`}return"<h"+fe+">"+ee+"</h"+fe+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(ee,fe,ie){var ae=fe?"ol":"ul",me=fe&&ie!==1?' start="'+ie+'"':"";return"<"+ae+me+`>
`+ee+"</"+ae+`>
`},ce.listitem=function(ee){return"<li>"+ee+`</li>
`},ce.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(ee){return"<p>"+ee+`</p>
`},ce.table=function(ee,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+fe+`</table>
`},ce.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ce.tablecell=function(ee,fe){var ie=fe.header?"th":"td",ae=fe.align?"<"+ie+' align="'+fe.align+'">':"<"+ie+">";return ae+ee+("</"+ie+`>
`)},ce.strong=function(ee){return"<strong>"+ee+"</strong>"},ce.em=function(ee){return"<em>"+ee+"</em>"},ce.codespan=function(ee){return"<code>"+ee+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(ee){return"<del>"+ee+"</del>"},ce.link=function(ee,fe,ie){if(ee=d(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var ae='<a href="'+w(ee)+'"';return fe&&(ae+=' title="'+fe+'"'),ae+=">"+ie+"</a>",ae},ce.image=function(ee,fe,ie){if(ee=d(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var ae='<img src="'+ee+'" alt="'+ie+'"';return fe&&(ae+=' title="'+fe+'"'),ae+=this.options.xhtml?"/>":">",ae},ce.text=function(ee){return ee},le}(),De=function(){function le(){}var ce=le.prototype;return ce.strong=function(ee){return ee},ce.em=function(ee){return ee},ce.codespan=function(ee){return ee},ce.del=function(ee){return ee},ce.html=function(ee){return ee},ce.text=function(ee){return ee},ce.link=function(ee,fe,ie){return""+ie},ce.image=function(ee,fe,ie){return""+ie},ce.br=function(){return""},le}(),ke=function(){function le(){this.seen={}}var ce=le.prototype;return ce.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(ee,fe){var ie=ee,ae=0;if(this.seen.hasOwnProperty(ie)){ae=this.seen[ee];do ae++,ie=ee+"-"+ae;while(this.seen.hasOwnProperty(ie))}return fe||(this.seen[ee]=ae,this.seen[ie]=0),ie},ce.slug=function(ee,fe){fe===void 0&&(fe={});var ie=this.serialize(ee);return this.getNextSafeSlug(ie,fe.dryrun)},le}(),de=function(){function le(be){this.options=be||we.defaults,this.options.renderer=this.options.renderer||new $e,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new De,this.slugger=new ke}le.parse=function(ee,fe){var ie=new le(fe);return ie.parse(ee)},le.parseInline=function(ee,fe){var ie=new le(fe);return ie.parseInline(ee)};var ce=le.prototype;return ce.parse=function(ee,fe){fe===void 0&&(fe=!0);var ie="",ae,me,Pe,z,V,H,G,q,x,ue,Ne,Be,Xe,Je,it,_e,tt,rt,nt,ze=ee.length;for(ae=0;ae<ze;ae++){if(ue=ee[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(nt=this.options.extensions.renderers[ue.type].call({parser:this},ue),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ue.type))){ie+=nt||"";continue}switch(ue.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ue.tokens),ue.depth,s(this.parseInline(ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ue.text,ue.lang,ue.escaped);continue}case"table":{for(q="",G="",z=ue.header.length,me=0;me<z;me++)G+=this.renderer.tablecell(this.parseInline(ue.header[me].tokens),{header:!0,align:ue.align[me]});for(q+=this.renderer.tablerow(G),x="",z=ue.rows.length,me=0;me<z;me++){for(H=ue.rows[me],G="",V=H.length,Pe=0;Pe<V;Pe++)G+=this.renderer.tablecell(this.parseInline(H[Pe].tokens),{header:!1,align:ue.align[Pe]});x+=this.renderer.tablerow(G)}ie+=this.renderer.table(q,x);continue}case"blockquote":{x=this.parse(ue.tokens),ie+=this.renderer.blockquote(x);continue}case"list":{for(Ne=ue.ordered,Be=ue.start,Xe=ue.loose,z=ue.items.length,x="",me=0;me<z;me++)it=ue.items[me],_e=it.checked,tt=it.task,Je="",it.task&&(rt=this.renderer.checkbox(_e),Xe?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=rt+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=rt+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:rt}):Je+=rt),Je+=this.parse(it.tokens,Xe),x+=this.renderer.listitem(Je,tt,_e);ie+=this.renderer.list(x,Ne,Be);continue}case"html":{ie+=this.renderer.html(ue.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ue.tokens));continue}case"text":{for(x=ue.tokens?this.parseInline(ue.tokens):ue.text;ae+1<ze&&ee[ae+1].type==="text";)ue=ee[++ae],x+=`
`+(ue.tokens?this.parseInline(ue.tokens):ue.text);ie+=fe?this.renderer.paragraph(x):x;continue}default:{var ht='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(ht);return}else throw new Error(ht)}}}return ie},ce.parseInline=function(ee,fe){fe=fe||this.renderer;var ie="",ae,me,Pe,z=ee.length;for(ae=0;ae<z;ae++){if(me=ee[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[me.type]&&(Pe=this.options.extensions.renderers[me.type].call({parser:this},me),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(me.type))){ie+=Pe||"";continue}switch(me.type){case"escape":{ie+=fe.text(me.text);break}case"html":{ie+=fe.html(me.text);break}case"link":{ie+=fe.link(me.href,me.title,this.parseInline(me.tokens,fe));break}case"image":{ie+=fe.image(me.href,me.title,me.text);break}case"strong":{ie+=fe.strong(this.parseInline(me.tokens,fe));break}case"em":{ie+=fe.em(this.parseInline(me.tokens,fe));break}case"codespan":{ie+=fe.codespan(me.text);break}case"br":{ie+=fe.br();break}case"del":{ie+=fe.del(this.parseInline(me.tokens,fe));break}case"text":{ie+=fe.text(me.text);break}default:{var V='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return ie},le}();function Ee(le,ce,be){if(typeof le>"u"||le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");if(typeof ce=="function"&&(be=ce,ce=null),ce=D({},Ee.defaults,ce||{}),k(ce),be){var ee=ce.highlight,fe;try{fe=he.lex(le,ce)}catch(z){return be(z)}var ie=function(V){var H;if(!V)try{ce.walkTokens&&Ee.walkTokens(fe,ce.walkTokens),H=de.parse(fe,ce)}catch(G){V=G}return ce.highlight=ee,V?be(V):be(null,H)};if(!ee||ee.length<3||(delete ce.highlight,!fe.length))return ie();var ae=0;Ee.walkTokens(fe,function(z){z.type==="code"&&(ae++,setTimeout(function(){ee(z.text,z.lang,function(V,H){if(V)return ie(V);H!=null&&H!==z.text&&(z.text=H,z.escaped=!0),ae--,ae===0&&ie()})},0))}),ae===0&&ie();return}function me(z){if(z.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(z.message+"",!0)+"</pre>";throw z}try{var Pe=he.lex(le,ce);if(ce.walkTokens){if(ce.async)return Promise.all(Ee.walkTokens(Pe,ce.walkTokens)).then(function(){return de.parse(Pe,ce)}).catch(me);Ee.walkTokens(Pe,ce.walkTokens)}return de.parse(Pe,ce)}catch(z){me(z)}}Ee.options=Ee.setOptions=function(le){return D(Ee.defaults,le),$(Ee.defaults),Ee},Ee.getDefaults=P,Ee.defaults=we.defaults,Ee.use=function(){for(var le=arguments.length,ce=new Array(le),be=0;be<le;be++)ce[be]=arguments[be];var ee=D.apply(void 0,[{}].concat(ce)),fe=Ee.defaults.extensions||{renderers:{},childTokens:{}},ie;ce.forEach(function(ae){if(ae.extensions&&(ie=!0,ae.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var z=fe.renderers?fe.renderers[Pe.name]:null;z?fe.renderers[Pe.name]=function(){for(var V=arguments.length,H=new Array(V),G=0;G<V;G++)H[G]=arguments[G];var q=Pe.renderer.apply(this,H);return q===!1&&(q=z.apply(this,H)),q}:fe.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Pe.level]?fe[Pe.level].unshift(Pe.tokenizer):fe[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?fe.startBlock?fe.startBlock.push(Pe.start):fe.startBlock=[Pe.start]:Pe.level==="inline"&&(fe.startInline?fe.startInline.push(Pe.start):fe.startInline=[Pe.start]))}Pe.childTokens&&(fe.childTokens[Pe.name]=Pe.childTokens)})),ae.renderer&&function(){var Pe=Ee.defaults.renderer||new $e,z=function(G){var q=Pe[G];Pe[G]=function(){for(var x=arguments.length,ue=new Array(x),Ne=0;Ne<x;Ne++)ue[Ne]=arguments[Ne];var Be=ae.renderer[G].apply(Pe,ue);return Be===!1&&(Be=q.apply(Pe,ue)),Be}};for(var V in ae.renderer)z(V);ee.renderer=Pe}(),ae.tokenizer&&function(){var Pe=Ee.defaults.tokenizer||new N,z=function(G){var q=Pe[G];Pe[G]=function(){for(var x=arguments.length,ue=new Array(x),Ne=0;Ne<x;Ne++)ue[Ne]=arguments[Ne];var Be=ae.tokenizer[G].apply(Pe,ue);return Be===!1&&(Be=q.apply(Pe,ue)),Be}};for(var V in ae.tokenizer)z(V);ee.tokenizer=Pe}(),ae.walkTokens){var me=Ee.defaults.walkTokens;ee.walkTokens=function(Pe){var z=[];return z.push(ae.walkTokens.call(this,Pe)),me&&(z=z.concat(me.call(this,Pe))),z}}ie&&(ee.extensions=fe),Ee.setOptions(ee)})},Ee.walkTokens=function(le,ce){for(var be=[],ee=function(){var me=ie.value;switch(be=be.concat(ce.call(Ee,me)),me.type){case"table":{for(var Pe=M(me.header),z;!(z=Pe()).done;){var V=z.value;be=be.concat(Ee.walkTokens(V.tokens,ce))}for(var H=M(me.rows),G;!(G=H()).done;)for(var q=G.value,x=M(q),ue;!(ue=x()).done;){var Ne=ue.value;be=be.concat(Ee.walkTokens(Ne.tokens,ce))}break}case"list":{be=be.concat(Ee.walkTokens(me.items,ce));break}default:Ee.defaults.extensions&&Ee.defaults.extensions.childTokens&&Ee.defaults.extensions.childTokens[me.type]?Ee.defaults.extensions.childTokens[me.type].forEach(function(Be){be=be.concat(Ee.walkTokens(me[Be],ce))}):me.tokens&&(be=be.concat(Ee.walkTokens(me.tokens,ce)))}},fe=M(le),ie;!(ie=fe()).done;)ee();return be},Ee.parseInline=function(le,ce){if(typeof le>"u"||le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");ce=D({},Ee.defaults,ce||{}),k(ce);try{var be=he.lexInline(le,ce);return ce.walkTokens&&Ee.walkTokens(be,ce.walkTokens),de.parseInline(be,ce)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(ee.message+"",!0)+"</pre>";throw ee}},Ee.Parser=de,Ee.parser=de.parse,Ee.Renderer=$e,Ee.TextRenderer=De,Ee.Lexer=he,Ee.lexer=he.lex,Ee.Tokenizer=N,Ee.Slugger=ke,Ee.parse=Ee;var _=Ee.options,Ce=Ee.setOptions,se=Ee.use,Q=Ee.walkTokens,U=Ee.parseInline,ne=Ee,pe=de.parse,re=he.lex;we.Lexer=he,we.Parser=de,we.Renderer=$e,we.Slugger=ke,we.TextRenderer=De,we.Tokenizer=N,we.getDefaults=P,we.lexer=re,we.marked=Ee,we.options=_,we.parse=ne,we.parseInline=U,we.parser=pe,we.setOptions=Ce,we.use=se,we.walkTokens=Q,Object.defineProperty(we,"__esModule",{value:!0})}),define(Ae[120],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.rot=e.$Wl=void 0;function E($,m,y){return Math.min(Math.max($,m),y)}e.$Wl=E;function T($,m){return(m+$%m)%m}e.rot=T;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Yl=C;class M{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Zl=M;class P{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const y=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$1l=P}),function(){function we(C){const M=[];typeof C=="number"&&M.push("code/timeOrigin",C);function P(m){M.push(m,Date.now())}function $(){const m=[];for(let y=0;y<M.length;y+=2)m.push({name:M[y],startTime:M[y+1]});return m}return{mark:P,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?we():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const P of performance.getEntriesByType("mark"))M.push({name:P.name,startTime:Math.round(C+P.startTime)});return M}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return we(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),we()}function E(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=E(T))}(),function(we,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var T in E)(typeof exports=="object"?exports:we)[T]=E[T]}}(typeof self<"u"?self:this,function(){return function(we){var e={};function E(T){if(e[T])return e[T].exports;var C=e[T]={i:T,l:!1,exports:{}};return we[T].call(C.exports,C,C.exports,E),C.l=!0,C.exports}return E.m=we,E.c=e,E.d=function(T,C,M){E.o(T,C)||Object.defineProperty(T,C,{enumerable:!0,get:M})},E.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},E.t=function(T,C){if(1&C&&(T=E(T)),8&C||4&C&&typeof T=="object"&&T&&T.__esModule)return T;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:T}),2&C&&typeof T!="string")for(var P in T)E.d(M,P,function($){return T[$]}.bind(null,P));return M},E.n=function(T){var C=T&&T.__esModule?function(){return T.default}:function(){return T};return E.d(C,"a",C),C},E.o=function(T,C){return Object.prototype.hasOwnProperty.call(T,C)},E.p="",E(E.s=0)}([function(we,e,E){(function(T){var C;e=we.exports=se,C=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],m=e.src=[],y=0,A=y++;m[A]="0|[1-9]\\d*";var S=y++;m[S]="[0-9]+";var l=y++;m[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=y++;m[p]="("+m[A]+")\\.("+m[A]+")\\.("+m[A]+")";var w=y++;m[w]="("+m[S]+")\\.("+m[S]+")\\.("+m[S]+")";var a=y++;m[a]="(?:"+m[A]+"|"+m[l]+")";var s=y++;m[s]="(?:"+m[S]+"|"+m[l]+")";var t=y++;m[t]="(?:-("+m[a]+"(?:\\."+m[a]+")*))";var n=y++;m[n]="(?:-?("+m[s]+"(?:\\."+m[s]+")*))";var o=y++;m[o]="[0-9A-Za-z-]+";var c=y++;m[c]="(?:\\+("+m[o]+"(?:\\."+m[o]+")*))";var d=y++,i="v?"+m[p]+m[t]+"?"+m[c]+"?";m[d]="^"+i+"$";var r="[v=\\s]*"+m[w]+m[n]+"?"+m[c]+"?",u=y++;m[u]="^"+r+"$";var f=y++;m[f]="((?:<|>)?=?)";var v=y++;m[v]=m[S]+"|x|X|\\*";var g=y++;m[g]=m[A]+"|x|X|\\*";var D=y++;m[D]="[v=\\s]*("+m[g]+")(?:\\.("+m[g]+")(?:\\.("+m[g]+")(?:"+m[t]+")?"+m[c]+"?)?)?";var I=y++;m[I]="[v=\\s]*("+m[v]+")(?:\\.("+m[v]+")(?:\\.("+m[v]+")(?:"+m[n]+")?"+m[c]+"?)?)?";var h=y++;m[h]="^"+m[f]+"\\s*"+m[D]+"$";var b=y++;m[b]="^"+m[f]+"\\s*"+m[I]+"$";var k=y++;m[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=y++;m[F]="(?:~>?)";var W=y++;m[W]="(\\s*)"+m[F]+"\\s+",$[W]=new RegExp(m[W],"g");var J=y++;m[J]="^"+m[F]+m[D]+"$";var N=y++;m[N]="^"+m[F]+m[I]+"$";var R=y++;m[R]="(?:\\^)";var L=y++;m[L]="(\\s*)"+m[R]+"\\s+",$[L]=new RegExp(m[L],"g");var O=y++;m[O]="^"+m[R]+m[D]+"$";var X=y++;m[X]="^"+m[R]+m[I]+"$";var he=y++;m[he]="^"+m[f]+"\\s*("+r+")$|^$";var $e=y++;m[$e]="^"+m[f]+"\\s*("+i+")$|^$";var De=y++;m[De]="(\\s*)"+m[f]+"\\s*("+r+"|"+m[D]+")",$[De]=new RegExp(m[De],"g");var ke=y++;m[ke]="^\\s*("+m[D]+")\\s+-\\s+("+m[D]+")\\s*$";var de=y++;m[de]="^\\s*("+m[I]+")\\s+-\\s+("+m[I]+")\\s*$";var Ee=y++;m[Ee]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)C(_,m[_]),$[_]||($[_]=new RegExp(m[_]));function Ce(q,x){if(q instanceof se)return q;if(typeof q!="string"||q.length>M||!(x?$[u]:$[d]).test(q))return null;try{return new se(q,x)}catch{return null}}function se(q,x){if(q instanceof se){if(q.loose===x)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof se))return new se(q,x);C("SemVer",q,x),this.loose=x;var ue=q.trim().match(x?$[u]:$[d]);if(!ue)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Be=+Ne;if(Be>=0&&Be<P)return Be}return Ne}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=Ce,e.valid=function(q,x){var ue=Ce(q,x);return ue?ue.version:null},e.clean=function(q,x){var ue=Ce(q.trim().replace(/^[=v]+/,""),x);return ue?ue.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(q){return C("SemVer.compare",this.version,this.loose,q),q instanceof se||(q=new se(q,this.loose)),this.compareMain(q)||this.comparePre(q)},se.prototype.compareMain=function(q){return q instanceof se||(q=new se(q,this.loose)),U(this.major,q.major)||U(this.minor,q.minor)||U(this.patch,q.patch)},se.prototype.comparePre=function(q){if(q instanceof se||(q=new se(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var x=0;do{var ue=this.prerelease[x],Ne=q.prerelease[x];if(C("prerelease compare",x,ue,Ne),ue===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ue===void 0)return-1;if(ue!==Ne)return U(ue,Ne)}while(++x)},se.prototype.inc=function(q,x){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,x,ue,Ne){typeof ue=="string"&&(Ne=ue,ue=void 0);try{return new se(q,ue).inc(x,Ne).version}catch{return null}},e.diff=function(q,x){if(le(q,x))return null;var ue=Ce(q),Ne=Ce(x);if(ue.prerelease.length||Ne.prerelease.length){for(var Be in ue)if((Be==="major"||Be==="minor"||Be==="patch")&&ue[Be]!==Ne[Be])return"pre"+Be;return"prerelease"}for(var Be in ue)if((Be==="major"||Be==="minor"||Be==="patch")&&ue[Be]!==Ne[Be])return Be},e.compareIdentifiers=U;var Q=/^[0-9]+$/;function U(q,x){var ue=Q.test(q),Ne=Q.test(x);return ue&&Ne&&(q=+q,x=+x),ue&&!Ne?-1:Ne&&!ue?1:q<x?-1:q>x?1:0}function ne(q,x,ue){return new se(q,ue).compare(new se(x,ue))}function pe(q,x,ue){return ne(q,x,ue)>0}function re(q,x,ue){return ne(q,x,ue)<0}function le(q,x,ue){return ne(q,x,ue)===0}function ce(q,x,ue){return ne(q,x,ue)!==0}function be(q,x,ue){return ne(q,x,ue)>=0}function ee(q,x,ue){return ne(q,x,ue)<=0}function fe(q,x,ue,Ne){var Be;switch(x){case"===":typeof q=="object"&&(q=q.version),typeof ue=="object"&&(ue=ue.version),Be=q===ue;break;case"!==":typeof q=="object"&&(q=q.version),typeof ue=="object"&&(ue=ue.version),Be=q!==ue;break;case"":case"=":case"==":Be=le(q,ue,Ne);break;case"!=":Be=ce(q,ue,Ne);break;case">":Be=pe(q,ue,Ne);break;case">=":Be=be(q,ue,Ne);break;case"<":Be=re(q,ue,Ne);break;case"<=":Be=ee(q,ue,Ne);break;default:throw new TypeError("Invalid operator: "+x)}return Be}function ie(q,x){if(q instanceof ie){if(q.loose===x)return q;q=q.value}if(!(this instanceof ie))return new ie(q,x);C("comparator",q,x),this.loose=x,this.parse(q),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(q,x){return U(x,q)},e.major=function(q,x){return new se(q,x).major},e.minor=function(q,x){return new se(q,x).minor},e.patch=function(q,x){return new se(q,x).patch},e.compare=ne,e.compareLoose=function(q,x){return ne(q,x,!0)},e.rcompare=function(q,x,ue){return ne(x,q,ue)},e.sort=function(q,x){return q.sort(function(ue,Ne){return e.compare(ue,Ne,x)})},e.rsort=function(q,x){return q.sort(function(ue,Ne){return e.rcompare(ue,Ne,x)})},e.gt=pe,e.lt=re,e.eq=le,e.neq=ce,e.gte=be,e.lte=ee,e.cmp=fe,e.Comparator=ie;var ae={};function me(q,x){if(q instanceof me)return q.loose===x?q:new me(q.raw,x);if(q instanceof ie)return new me(q.value,x);if(!(this instanceof me))return new me(q,x);if(this.loose=x,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Pe(q){return!q||q.toLowerCase()==="x"||q==="*"}function z(q,x,ue,Ne,Be,Xe,Je,it,_e,tt,rt,nt,ze){return((x=Pe(ue)?"":Pe(Ne)?">="+ue+".0.0":Pe(Be)?">="+ue+"."+Ne+".0":">="+x)+" "+(it=Pe(_e)?"":Pe(tt)?"<"+(+_e+1)+".0.0":Pe(rt)?"<"+_e+"."+(+tt+1)+".0":nt?"<="+_e+"."+tt+"."+rt+"-"+nt:"<="+it)).trim()}function V(q,x){for(var ue=0;ue<q.length;ue++)if(!q[ue].test(x))return!1;if(x.prerelease.length){for(ue=0;ue<q.length;ue++)if(C(q[ue].semver),q[ue].semver!==ae&&q[ue].semver.prerelease.length>0){var Ne=q[ue].semver;if(Ne.major===x.major&&Ne.minor===x.minor&&Ne.patch===x.patch)return!0}return!1}return!0}function H(q,x,ue){try{x=new me(x,ue)}catch{return!1}return x.test(q)}function G(q,x,ue,Ne){var Be,Xe,Je,it,_e;switch(q=new se(q,Ne),x=new me(x,Ne),ue){case">":Be=pe,Xe=ee,Je=re,it=">",_e=">=";break;case"<":Be=re,Xe=be,Je=pe,it="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(H(q,x,Ne))return!1;for(var tt=0;tt<x.set.length;++tt){var rt=x.set[tt],nt=null,ze=null;if(rt.forEach(function(ht){ht.semver===ae&&(ht=new ie(">=0.0.0")),nt=nt||ht,ze=ze||ht,Be(ht.semver,nt.semver,Ne)?nt=ht:Je(ht.semver,ze.semver,Ne)&&(ze=ht)}),nt.operator===it||nt.operator===_e||(!ze.operator||ze.operator===it)&&Xe(q,ze.semver)||ze.operator===_e&&Je(q,ze.semver))return!1}return!0}ie.prototype.parse=function(q){var x=this.loose?$[he]:$[$e],ue=q.match(x);if(!ue)throw new TypeError("Invalid comparator: "+q);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new se(ue[2],this.loose):this.semver=ae},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(q){return C("Comparator.test",q,this.loose),this.semver===ae||(typeof q=="string"&&(q=new se(q,this.loose)),fe(q,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(q,x){if(!(q instanceof ie))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new me(q.value,x),H(this.value,ue,x);if(q.operator==="")return ue=new me(this.value,x),H(q.semver,ue,x);var Ne=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Xe=this.semver.version===q.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),it=fe(this.semver,"<",q.semver,x)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),_e=fe(this.semver,">",q.semver,x)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Ne||Be||Xe&&Je||it||_e},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(q){var x=this.loose;q=q.trim(),C("range",q,x);var ue=x?$[de]:$[ke];q=q.replace(ue,z),C("hyphen replace",q),q=q.replace($[De],"$1$2$3"),C("comparator trim",q,$[De]),q=(q=(q=q.replace($[W],"$1~")).replace($[L],"$1^")).split(/\s+/).join(" ");var Ne=x?$[he]:$[$e],Be=q.split(" ").map(function(Xe){return function(Je,it){return C("comp",Je),Je=function(_e,tt){return _e.trim().split(/\s+/).map(function(rt){return function(nt,ze){C("caret",nt,ze);var ht=ze?$[X]:$[O];return nt.replace(ht,function(Y,Z,ye,Ue,He){var Ye;return C("caret",nt,Y,Z,ye,Ue,He),Pe(Z)?Ye="":Pe(ye)?Ye=">="+Z+".0.0 <"+(+Z+1)+".0.0":Pe(Ue)?Ye=Z==="0"?">="+Z+"."+ye+".0 <"+Z+"."+(+ye+1)+".0":">="+Z+"."+ye+".0 <"+(+Z+1)+".0.0":He?(C("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ye=Z==="0"?ye==="0"?">="+Z+"."+ye+"."+Ue+He+" <"+Z+"."+ye+"."+(+Ue+1):">="+Z+"."+ye+"."+Ue+He+" <"+Z+"."+(+ye+1)+".0":">="+Z+"."+ye+"."+Ue+He+" <"+(+Z+1)+".0.0"):(C("no pr"),Ye=Z==="0"?ye==="0"?">="+Z+"."+ye+"."+Ue+" <"+Z+"."+ye+"."+(+Ue+1):">="+Z+"."+ye+"."+Ue+" <"+Z+"."+(+ye+1)+".0":">="+Z+"."+ye+"."+Ue+" <"+(+Z+1)+".0.0"),C("caret return",Ye),Ye})}(rt,tt)}).join(" ")}(Je,it),C("caret",Je),Je=function(_e,tt){return _e.trim().split(/\s+/).map(function(rt){return function(nt,ze){var ht=ze?$[N]:$[J];return nt.replace(ht,function(Y,Z,ye,Ue,He){var Ye;return C("tilde",nt,Y,Z,ye,Ue,He),Pe(Z)?Ye="":Pe(ye)?Ye=">="+Z+".0.0 <"+(+Z+1)+".0.0":Pe(Ue)?Ye=">="+Z+"."+ye+".0 <"+Z+"."+(+ye+1)+".0":He?(C("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ye=">="+Z+"."+ye+"."+Ue+He+" <"+Z+"."+(+ye+1)+".0"):Ye=">="+Z+"."+ye+"."+Ue+" <"+Z+"."+(+ye+1)+".0",C("tilde return",Ye),Ye})}(rt,tt)}).join(" ")}(Je,it),C("tildes",Je),Je=function(_e,tt){return C("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(rt){return function(nt,ze){nt=nt.trim();var ht=ze?$[b]:$[h];return nt.replace(ht,function(Y,Z,ye,Ue,He,Ye){C("xRange",nt,Y,Z,ye,Ue,He,Ye);var st=Pe(ye),pt=st||Pe(Ue),Te=pt||Pe(He);return Z==="="&&Te&&(Z=""),st?Y=Z===">"||Z==="<"?"<0.0.0":"*":Z&&Te?(pt&&(Ue=0),Te&&(He=0),Z===">"?(Z=">=",pt?(ye=+ye+1,Ue=0,He=0):Te&&(Ue=+Ue+1,He=0)):Z==="<="&&(Z="<",pt?ye=+ye+1:Ue=+Ue+1),Y=Z+ye+"."+Ue+"."+He):pt?Y=">="+ye+".0.0 <"+(+ye+1)+".0.0":Te&&(Y=">="+ye+"."+Ue+".0 <"+ye+"."+(+Ue+1)+".0"),C("xRange return",Y),Y})}(rt,tt)}).join(" ")}(Je,it),C("xrange",Je),Je=function(_e,tt){return C("replaceStars",_e,tt),_e.trim().replace($[Ee],"")}(Je,it),C("stars",Je),Je}(Xe,x)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Xe){return!!Xe.match(Ne)})),Be=Be.map(function(Xe){return new ie(Xe,x)})},me.prototype.intersects=function(q,x){if(!(q instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(Ne){return q.set.some(function(Be){return Be.every(function(Xe){return Ne.intersects(Xe,x)})})})})},e.toComparators=function(q,x){return new me(q,x).set.map(function(ue){return ue.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},me.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new se(q,this.loose));for(var x=0;x<this.set.length;x++)if(V(this.set[x],q))return!0;return!1},e.satisfies=H,e.maxSatisfying=function(q,x,ue){var Ne=null,Be=null;try{var Xe=new me(x,ue)}catch{return null}return q.forEach(function(Je){Xe.test(Je)&&(Ne&&Be.compare(Je)!==-1||(Be=new se(Ne=Je,ue)))}),Ne},e.minSatisfying=function(q,x,ue){var Ne=null,Be=null;try{var Xe=new me(x,ue)}catch{return null}return q.forEach(function(Je){Xe.test(Je)&&(Ne&&Be.compare(Je)!==1||(Be=new se(Ne=Je,ue)))}),Ne},e.validRange=function(q,x){try{return new me(q,x).range||"*"}catch{return null}},e.ltr=function(q,x,ue){return G(q,x,"<",ue)},e.gtr=function(q,x,ue){return G(q,x,">",ue)},e.outside=G,e.prerelease=function(q,x){var ue=Ce(q,x);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(q,x,ue){return q=new me(q,ue),x=new me(x,ue),q.intersects(x)},e.coerce=function(q){if(q instanceof se)return q;if(typeof q!="string")return null;var x=q.match($[k]);return x==null?null:Ce((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,E(1))},function(we,e){var E,T,C=we.exports={};function M(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function $(s){if(E===setTimeout)return setTimeout(s,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(s,0);try{return E(s,0)}catch{try{return E.call(null,s,0)}catch{return E.call(this,s,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{T=typeof clearTimeout=="function"?clearTimeout:P}catch{T=P}})();var m,y=[],A=!1,S=-1;function l(){A&&m&&(A=!1,m.length?y=m.concat(y):S=-1,y.length&&p())}function p(){if(!A){var s=$(l);A=!0;for(var t=y.length;t;){for(m=y,y=[];++S<t;)m&&m[S].run();S=-1,t=y.length}m=null,A=!1,function(n){if(T===clearTimeout)return clearTimeout(n);if((T===P||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(n);try{T(n)}catch{try{return T.call(null,n)}catch{return T.call(this,n)}}}(s)}}function w(s,t){this.fun=s,this.array=t}function a(){}C.nextTick=function(s){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];y.push(new w(s,t)),y.length!==1||A||$(p)},w.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=a,C.addListener=a,C.once=a,C.off=a,C.removeListener=a,C.removeAllListeners=a,C.emit=a,C.prependListener=a,C.prependOnceListener=a,C.listeners=function(s){return[]},C.binding=function(s){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(s){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ae[121],Re([1,0,11,6]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function C(c){const d=c;return d?typeof d.read=="function":!1}e.$3d=C;function M(c){const d=c;return d?[d.on,d.pause,d.resume,d.destroy].every(i=>typeof i=="function"):!1}e.$4d=M;function P(c){const d=c;return d?M(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.$5d=P;function $(c,d){return new m(c,d)}e.$6d=$;class m{constructor(d,i){this.e=d,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(d){if(!this.a.destroyed){if(this.a.flowing)this.g(d);else if(this.b.data.push(d),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(d){this.a.destroyed||(this.a.flowing?this.h(d):this.b.error.push(d))}end(d){this.a.destroyed||(typeof d<"u"&&this.write(d),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(d){this.c.data.slice(0).forEach(i=>i(d))}h(d){this.c.error.length===0?(0,E.$Z)(d):this.c.error.slice(0).forEach(i=>i(d))}i(){this.c.end.slice(0).forEach(d=>d())}on(d,i){if(!this.a.destroyed)switch(d){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(d,i){if(this.a.destroyed)return;let r;switch(d){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const u=r.indexOf(i);u>=0&&r.splice(u,1)}}j(){if(this.b.data.length>0){const d=this.e(this.b.data);this.g(d),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const d of this.b.error)this.h(d);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(c,d){const i=[];let r;for(;(r=c.read())!==null;)i.push(r);return d(i)}e.$7d=y;function A(c,d,i){const r=[];let u;for(;(u=c.read())!==null&&r.length<i;)r.push(u);return u===null&&r.length>0?d(r):{read:()=>{if(r.length>0)return r.shift();if(typeof u<"u"){const f=u;return u=void 0,f}return c.read()}}}e.$8d=A;function S(c,d){return new Promise((i,r)=>{const u=[];l(c,{onData:f=>{d&&u.push(f)},onError:f=>{d?r(f):i(void 0)},onEnd:()=>{i(d?d(u):void 0)}})})}e.$9d=S;function l(c,d,i){c.on("error",r=>{i?.isCancellationRequested||d.onError(r)}),c.on("end",()=>{i?.isCancellationRequested||d.onEnd()}),c.on("data",r=>{i?.isCancellationRequested||d.onData(r)})}e.$0d=l;function p(c,d){return new Promise((i,r)=>{const u=new T.$Qc,f=[],v=I=>{if(f.push(I),f.length>d)return u.dispose(),c.pause(),i({stream:c,buffer:f,ended:!1})},g=I=>(u.dispose(),r(I)),D=()=>(u.dispose(),i({stream:c,buffer:f,ended:!0}));u.add((0,T.$Pc)(()=>c.removeListener("error",g))),c.on("error",g),u.add((0,T.$Pc)(()=>c.removeListener("end",D))),c.on("end",D),u.add((0,T.$Pc)(()=>c.removeListener("data",v))),c.on("data",v)})}e.$$d=p;function w(c,d){const i=$(d);return i.end(c),i}e.$_d=w;function a(){const c=$(()=>{throw new Error("not supported")});return c.end(),c}e.$ae=a;function s(c){let d=!1;return{read:()=>d?null:(d=!0,c)}}e.$be=s;function t(c,d,i){const r=$(i);return l(c,{onData:u=>r.write(d.data(u)),onError:u=>r.error(d.error?d.error(u):u),onEnd:()=>r.end()}),r}e.$ce=t;function n(c,d,i){let r=!1;return{read:()=>{const u=d.read();return r?u:(r=!0,u!==null?i([c,u]):c)}}}e.$de=n;function o(c,d,i){let r=!1;const u=$(i);return l(d,{onData:f=>r?u.write(f):(r=!0,u.write(i([c,f]))),onError:f=>u.error(f),onEnd:()=>{r||(r=!0,u.write(c)),u.end()}}),u}e.$ee=o}),define(Ae[24],Re([1,0,44,121]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const C=typeof Buffer<"u",M=new E.$U(()=>new Uint8Array(256));let P,$;class m{static alloc(k){return C?new m(Buffer.allocUnsafe(k)):new m(new Uint8Array(k))}static wrap(k){return C&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new m(k)}static fromString(k,F){return!(F?.dontUseNodeBuffer||!1)&&C?new m(Buffer.from(k)):(P||(P=new TextEncoder),new m(P.encode(k)))}static fromByteArray(k){const F=m.alloc(k.length);for(let W=0,J=k.length;W<J;W++)F.buffer[W]=k[W];return F}static concat(k,F){if(typeof F>"u"){F=0;for(let N=0,R=k.length;N<R;N++)F+=k[N].byteLength}const W=m.alloc(F);let J=0;for(let N=0,R=k.length;N<R;N++){const L=k[N];W.set(L,J),J+=L.byteLength}return W}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=m.alloc(this.byteLength);return k.set(this),k}toString(){return C?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(k,F){return new m(this.buffer.subarray(k,F))}set(k,F){if(k instanceof m)this.buffer.set(k.buffer,F);else if(k instanceof Uint8Array)this.buffer.set(k,F);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),F);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),F);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return l(this.buffer,k)}writeUInt32BE(k,F){p(this.buffer,k,F)}readUInt32LE(k){return w(this.buffer,k)}writeUInt32LE(k,F){a(this.buffer,k,F)}readUInt8(k){return s(this.buffer,k)}writeUInt8(k,F){t(this.buffer,k,F)}indexOf(k,F=0){return y(this.buffer,k instanceof m?k.buffer:k,F)}}e.$fe=m;function y(b,k,F=0){const W=k.byteLength,J=b.byteLength;if(W===0)return 0;if(W===1)return b.indexOf(k[0]);if(W>J-F)return-1;const N=M.value;N.fill(k.length);for(let X=0;X<k.length;X++)N[k[X]]=k.length-X-1;let R=F+k.length-1,L=R,O=-1;for(;R<J;)if(b[R]===k[L]){if(L===0){O=R;break}R--,L--}else R+=Math.max(k.length-L,N[b[R]]),L=k.length-1;return O}e.$ge=y;function A(b,k){return b[k+0]<<0>>>0|b[k+1]<<8>>>0}e.$he=A;function S(b,k,F){b[F+0]=k&255,k=k>>>8,b[F+1]=k&255}e.$ie=S;function l(b,k){return b[k]*2**24+b[k+1]*2**16+b[k+2]*2**8+b[k+3]}e.$je=l;function p(b,k,F){b[F+3]=k,k=k>>>8,b[F+2]=k,k=k>>>8,b[F+1]=k,k=k>>>8,b[F]=k}e.$ke=p;function w(b,k){return b[k+0]<<0>>>0|b[k+1]<<8>>>0|b[k+2]<<16>>>0|b[k+3]<<24>>>0}e.$le=w;function a(b,k,F){b[F+0]=k&255,k=k>>>8,b[F+1]=k&255,k=k>>>8,b[F+2]=k&255,k=k>>>8,b[F+3]=k&255}e.$me=a;function s(b,k){return b[k]}e.$ne=s;function t(b,k,F){b[F]=k}e.$oe=t;function n(b){return T.$7d(b,k=>m.concat(k))}e.$pe=n;function o(b){return T.$be(b)}e.$qe=o;function c(b){return T.$9d(b,k=>m.concat(k))}e.$re=c;async function d(b){return b.ended?m.concat(b.buffer):m.concat([...b.buffer,await c(b.stream)])}e.$se=d;function i(b){return T.$_d(b,k=>m.concat(k))}e.$te=i;function r(b){return T.$ce(b,{data:k=>typeof k=="string"?m.fromString(k):m.wrap(k)},k=>m.concat(k))}e.$ue=r;function u(b){return T.$6d(k=>m.concat(k),b)}e.$ve=u;function f(b,k){return T.$de(b,k,F=>m.concat(F))}e.$we=f;function v(b,k){return T.$ee(b,k,F=>m.concat(F))}e.$xe=v;function g(b){let k=0,F=0,W=0;const J=new Uint8Array(Math.floor(b.length/4*3)),N=L=>{switch(F){case 3:J[W++]=k|L,F=0;break;case 2:J[W++]=k|L>>>2,k=L<<6,F=3;break;case 1:J[W++]=k|L>>>4,k=L<<4,F=2;break;default:k=L<<2,F=1}};for(let L=0;L<b.length;L++){const O=b.charCodeAt(L);if(O>=65&&O<=90)N(O-65);else if(O>=97&&O<=122)N(O-97+26);else if(O>=48&&O<=57)N(O-48+52);else if(O===43||O===45)N(62);else if(O===47||O===95)N(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${b[L]}`)}}const R=W;for(;F>0;)N(0);return m.wrap(J).slice(0,R)}e.$ye=g;const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:b},k=!0,F=!1){const W=F?I:D;let J="";const N=b.byteLength%3;let R=0;for(;R<b.byteLength-N;R+=3){const L=b[R+0],O=b[R+1],X=b[R+2];J+=W[L>>>2],J+=W[(L<<4|O>>>4)&63],J+=W[(O<<2|X>>>6)&63],J+=W[X&63]}if(N===1){const L=b[R+0];J+=W[L>>>2],J+=W[L<<4&63],k&&(J+="==")}else if(N===2){const L=b[R+0],O=b[R+1];J+=W[L>>>2],J+=W[(L<<4|O>>>4)&63],J+=W[O<<2&63],k&&(J+="=")}return J}e.$ze=h}),define(Ae[122],Re([1,0,28,12]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.FuzzyScore=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.or=void 0;function C(...ie){return function(ae,me){for(let Pe=0,z=ie.length;Pe<z;Pe++){const V=ie[Pe](ae,me);if(V)return V}return null}}e.or=C,e.$Kj=M.bind(void 0,!1),e.$Lj=M.bind(void 0,!0);function M(ie,ae,me){if(!me||me.length<ae.length)return null;let Pe;return ie?Pe=T.$7e(me,ae):Pe=me.indexOf(ae)===0,Pe?ae.length>0?[{start:0,end:ae.length}]:[]:null}function P(ie,ae){const me=ae.toLowerCase().indexOf(ie.toLowerCase());return me===-1?null:[{start:me,end:me+ie.length}]}e.$Mj=P;function $(ie,ae){return m(ie.toLowerCase(),ae.toLowerCase(),0,0)}e.$Nj=$;function m(ie,ae,me,Pe){if(me===ie.length)return[];if(Pe===ae.length)return null;if(ie[me]===ae[Pe]){let z=null;return(z=m(ie,ae,me+1,Pe+1))?t({start:Pe,end:Pe+1},z):null}return m(ie,ae,me,Pe+1)}function y(ie){return 97<=ie&&ie<=122}function A(ie){return 65<=ie&&ie<=90}e.$Oj=A;function S(ie){return 48<=ie&&ie<=57}function l(ie){return ie===32||ie===9||ie===10||ie===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>p.add(ie.charCodeAt(0)));function w(ie){return l(ie)||p.has(ie)}function a(ie,ae){return ie===ae||w(ie)&&w(ae)}function s(ie){return y(ie)||A(ie)||S(ie)}function t(ie,ae){return ae.length===0?ae=[ie]:ie.end===ae[0].start?ae[0].start=ie.start:ae.unshift(ie),ae}function n(ie,ae){for(let me=ae;me<ie.length;me++){const Pe=ie.charCodeAt(me);if(A(Pe)||S(Pe)||me>0&&!s(ie.charCodeAt(me-1)))return me}return ie.length}function o(ie,ae,me,Pe){if(me===ie.length)return[];if(Pe===ae.length)return null;if(ie[me]!==ae[Pe].toLowerCase())return null;{let z=null,V=Pe+1;for(z=o(ie,ae,me+1,Pe+1);!z&&(V=n(ae,V))<ae.length;)z=o(ie,ae,me+1,V),V++;return z===null?null:t({start:Pe,end:Pe+1},z)}}function c(ie){let ae=0,me=0,Pe=0,z=0,V=0;for(let ue=0;ue<ie.length;ue++)V=ie.charCodeAt(ue),A(V)&&ae++,y(V)&&me++,s(V)&&Pe++,S(V)&&z++;const H=ae/ie.length,G=me/ie.length,q=Pe/ie.length,x=z/ie.length;return{upperPercent:H,lowerPercent:G,alphaPercent:q,numericPercent:x}}function d(ie){const{upperPercent:ae,lowerPercent:me}=ie;return me===0&&ae>.6}function i(ie){const{upperPercent:ae,lowerPercent:me,alphaPercent:Pe,numericPercent:z}=ie;return me>.2&&ae<.8&&Pe>.6&&z<.2}function r(ie){let ae=0,me=0,Pe=0,z=0;for(let V=0;V<ie.length;V++)Pe=ie.charCodeAt(V),A(Pe)&&ae++,y(Pe)&&me++,l(Pe)&&z++;return(ae===0||me===0)&&z===0?ie.length<=30:ae<=5}function u(ie,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!r(ie)||ae.length>60)return null;const me=c(ae);if(!i(me)){if(!d(me))return null;ae=ae.toLowerCase()}let Pe=null,z=0;for(ie=ie.toLowerCase();z<ae.length&&(Pe=o(ie,ae,0,z))===null;)z=n(ae,z+1);return Pe}e.$Pj=u;function f(ie,ae,me=!1){if(!ae||ae.length===0)return null;let Pe=null,z=0;for(ie=ie.toLowerCase(),ae=ae.toLowerCase();z<ae.length&&(Pe=v(ie,ae,0,z,me))===null;)z=g(ae,z+1);return Pe}e.$Qj=f;function v(ie,ae,me,Pe,z){if(me===ie.length)return[];if(Pe===ae.length)return null;if(a(ie.charCodeAt(me),ae.charCodeAt(Pe))){let V=null,H=Pe+1;if(V=v(ie,ae,me+1,Pe+1,z),!z)for(;!V&&(H=g(ae,H))<ae.length;)V=v(ie,ae,me+1,H,z),H++;return V?ie.charCodeAt(me)!==ae.charCodeAt(Pe)?V:t({start:Pe,end:Pe+1},V):null}else return null}function g(ie,ae){for(let me=ae;me<ie.length;me++)if(w(ie.charCodeAt(me))||me>0&&w(ie.charCodeAt(me-1)))return me;return ie.length}const D=C(e.$Lj,u,P),I=C(e.$Lj,u,$),h=new E.$Cc(1e4);function b(ie,ae,me=!1){if(typeof ie!="string"||typeof ae!="string")return null;let Pe=h.get(ie);Pe||(Pe=new RegExp(T.$Pe(ie),"i"),h.set(ie,Pe));const z=Pe.exec(ae);return z?[{start:z.index,end:z.index+z[0].length}]:me?I(ie,ae):D(ie,ae)}e.$Rj=b;function k(ie,ae){const me=pe(ie,ie.toLowerCase(),0,ae,ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return me?W(me):null}e.$Sj=k;function F(ie,ae,me,Pe,z,V){const H=Math.min(13,ie.length);for(;me<H;me++){const G=pe(ie,ae,me,Pe,z,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(G)return G}return[0,V]}e.$Tj=F;function W(ie){if(typeof ie>"u")return[];const ae=[],me=ie[1];for(let Pe=ie.length-1;Pe>1;Pe--){const z=ie[Pe]+me,V=ae[ae.length-1];V&&V.end===z?V.end=z+1:ae.push({start:z,end:z+1})}return ae}e.$Uj=W;const J=128;function N(){const ie=[],ae=[];for(let me=0;me<=J;me++)ae[me]=0;for(let me=0;me<=J;me++)ie.push(ae.slice(0));return ie}function R(ie){const ae=[];for(let me=0;me<=ie;me++)ae[me]=0;return ae}const L=R(2*J),O=R(2*J),X=N(),he=N(),$e=N(),De=!1;function ke(ie,ae,me,Pe,z){function V(G,q,x=" "){for(;G.length<q;)G=x+G;return G}let H=` |   |${Pe.split("").map(G=>V(G,3)).join("|")}
`;for(let G=0;G<=me;G++)G===0?H+=" |":H+=`${ae[G-1]}|`,H+=ie[G].slice(0,z+1).map(q=>V(q.toString(),3)).join("|")+`
`;return H}function de(ie,ae,me,Pe){ie=ie.substr(ae),me=me.substr(Pe),console.log(ke(he,ie,ie.length,me,me.length)),console.log(ke($e,ie,ie.length,me,me.length)),console.log(ke(X,ie,ie.length,me,me.length))}function Ee(ie,ae){if(ae<0||ae>=ie.length)return!1;const me=ie.codePointAt(ae);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$mf(me)}}function _(ie,ae){if(ae<0||ae>=ie.length)return!1;switch(ie.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function Ce(ie,ae,me){return ae[ie]!==me[ie]}function se(ie,ae,me,Pe,z,V,H=!1){for(;ae<me&&z<V;)ie[ae]===Pe[z]&&(H&&(L[ae]=z),ae+=1),z+=1;return ae===me}e.$Vj=se;var Q;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(Q||(Q={}));var U;(function(ie){ie.Default=[-100,0];function ae(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}ie.isDefault=ae})(U||(e.FuzzyScore=U={}));class ne{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ae,me){this.firstMatchCanBeWeak=ae,this.boostFullMatch=me}}e.$Wj=ne;function pe(ie,ae,me,Pe,z,V,H=ne.default){const G=ie.length>J?J:ie.length,q=Pe.length>J?J:Pe.length;if(me>=G||V>=q||G-me>q-V||!se(ae,me,G,z,V,q,!0))return;re(G,q,me,V,ae,z);let x=1,ue=1,Ne=me,Be=V;const Xe=[!1];for(x=1,Ne=me;Ne<G;x++,Ne++){const rt=L[Ne],nt=O[Ne],ze=Ne+1<G?O[Ne+1]:q;for(ue=rt-V+1,Be=rt;Be<ze;ue++,Be++){let ht=Number.MIN_SAFE_INTEGER,Y=!1;Be<=nt&&(ht=le(ie,ae,Ne,me,Pe,z,Be,q,V,X[x-1][ue-1]===0,Xe));let Z=0;ht!==Number.MAX_SAFE_INTEGER&&(Y=!0,Z=ht+he[x-1][ue-1]);const ye=Be>rt,Ue=ye?he[x][ue-1]+(X[x][ue-1]>0?-5:0):0,He=Be>rt+1&&X[x][ue-1]>0,Ye=He?he[x][ue-2]+(X[x][ue-2]>0?-5:0):0;if(He&&(!ye||Ye>=Ue)&&(!Y||Ye>=Z))he[x][ue]=Ye,$e[x][ue]=3,X[x][ue]=0;else if(ye&&(!Y||Ue>=Z))he[x][ue]=Ue,$e[x][ue]=2,X[x][ue]=0;else if(Y)he[x][ue]=Z,$e[x][ue]=1,X[x][ue]=X[x-1][ue-1]+1;else throw new Error("not possible")}}if(De&&de(ie,me,Pe,V),!Xe[0]&&!H.firstMatchCanBeWeak)return;x--,ue--;const Je=[he[x][ue],V];let it=0,_e=0;for(;x>=1;){let rt=ue;do{const nt=$e[x][rt];if(nt===3)rt=rt-2;else if(nt===2)rt=rt-1;else break}while(rt>=1);it>1&&ae[me+x-1]===z[V+ue-1]&&!Ce(rt+V-1,Pe,z)&&it+1>X[x][rt]&&(rt=ue),rt===ue?it++:it=1,_e||(_e=rt),x--,ue=rt-1,Je.push(ue)}q===G&&H.boostFullMatch&&(Je[0]+=2);const tt=_e-G;return Je[0]-=tt,Je}e.$Xj=pe;function re(ie,ae,me,Pe,z,V){let H=ie-1,G=ae-1;for(;H>=me&&G>=Pe;)z[H]===V[G]&&(O[H]=G,H--),G--}function le(ie,ae,me,Pe,z,V,H,G,q,x,ue){if(ae[me]!==V[H])return Number.MIN_SAFE_INTEGER;let Ne=1,Be=!1;return H===me-Pe?Ne=ie[me]===z[H]?7:5:Ce(H,z,V)&&(H===0||!Ce(H-1,z,V))?(Ne=ie[me]===z[H]?7:5,Be=!0):Ee(V,H)&&(H===0||!Ee(V,H-1))?Ne=5:(Ee(V,H-1)||_(V,H-1))&&(Ne=5,Be=!0),Ne>1&&me===Pe&&(ue[0]=!0),Be||(Be=Ce(H,z,V)||Ee(V,H-1)||_(V,H-1)),me===Pe?H>q&&(Ne-=Be?3:5):x?Ne+=Be?2:0:Ne+=Be?0:1,H+1===G&&(Ne-=Be?3:5),Ne}function ce(ie,ae,me,Pe,z,V,H){return ee(ie,ae,me,Pe,z,V,!0,H)}e.$Yj=ce;function be(ie,ae,me,Pe,z,V,H){return ee(ie,ae,me,Pe,z,V,!1,H)}e.$Zj=be;function ee(ie,ae,me,Pe,z,V,H,G){let q=pe(ie,ae,me,Pe,z,V,G);if(q&&!H)return q;if(ie.length>=3){const x=Math.min(7,ie.length-1);for(let ue=me+1;ue<x;ue++){const Ne=fe(ie,ue);if(Ne){const Be=pe(Ne,Ne.toLowerCase(),me,Pe,z,V,G);Be&&(Be[0]-=3,(!q||Be[0]>q[0])&&(q=Be))}}}return q}function fe(ie,ae){if(ae+1>=ie.length)return;const me=ie[ae],Pe=ie[ae+1];if(me!==Pe)return ie.slice(0,ae)+Pe+me+ie.slice(ae+2)}}),define(Ae[31],Re([1,0,12]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(T||(T={})),function(C){const M="error",P="warning",$="warn",m="info",y="ignore";function A(l){return l?E.$6e(M,l)?C.Error:E.$6e(P,l)||E.$6e($,l)?C.Warning:E.$6e(m,l)?C.Info:C.Ignore:C.Ignore}C.fromValue=A;function S(l){switch(l){case C.Error:return M;case C.Warning:return P;case C.Info:return m;default:return y}}C.toString=S}(T||(T={})),e.default=T}),define(Ae[123],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(Ae[50],Re([1,0,18,12]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=void 0;class C{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const w=p.charCodeAt(0),a=this.b.charCodeAt(this.c);return w-a}value(){return this.b[this.c]}}e.$Zh=C;class M{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,T.$Ze)(p,this.b,0,p.length,this.c,this.d):(0,T.$2e)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$1h=M;class P{constructor(p=!0,w=!0){this.f=p,this.g=w}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let w=p.length-1;w>=0;w--,this.c--){const a=this.b.charCodeAt(w);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const w=this.b.charCodeAt(this.e);if(w===47||this.f&&w===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,T.$Ze)(p,this.b,0,p.length,this.d,this.e):(0,T.$2e)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$2h=P;var $;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})($||($={}));class m{constructor(p,w){this.f=p,this.g=w,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new P(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,T.$1e)(p,this.c.scheme);if(this.d[this.e]===2)return(0,T.$1e)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,T.$Ye)(p,this.c.query);if(this.d[this.e]===5)return(0,T.$Ye)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$3h=m;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(A||(A={}));class S{static forUris(p=()=>!1,w=()=>!1){return new S(new m(p,w))}static forPaths(p=!1){return new S(new P(void 0,!p))}static forStrings(){return new S(new C)}static forConfigKeys(){return new S(new M)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,w){if(w){const a=w.slice(0);(0,E.$Wb)(a);for(const s of a)this.set(s,p)}else{const a=p.slice(0);(0,E.$Wb)(a);for(const s of a)this.set(s[0],s[1])}}set(p,w){const a=this.b.reset(p);let s;this.c||(this.c=new y,this.c.segment=a.value());const t=[];for(s=this.c;;){const o=a.cmp(s.segment);if(o>0)s.left||(s.left=new y,s.left.segment=a.value()),t.push([-1,s]),s=s.left;else if(o<0)s.right||(s.right=new y,s.right.segment=a.value()),t.push([1,s]),s=s.right;else if(a.hasNext())a.next(),s.mid||(s.mid=new y,s.mid.segment=a.value()),t.push([0,s]),s=s.mid;else break}const n=s.value;s.value=w,s.key=p;for(let o=t.length-1;o>=0;o--){const c=t[o][1];c.updateHeight();const d=c.balanceFactor();if(d<-1||d>1){const i=t[o][0],r=t[o+1][0];if(i===1&&r===1)t[o][1]=c.rotateLeft();else if(i===-1&&r===-1)t[o][1]=c.rotateRight();else if(i===1&&r===-1)c.right=t[o+1][1]=t[o+1][1].rotateRight(),t[o][1]=c.rotateLeft();else if(i===-1&&r===1)c.left=t[o+1][1]=t[o+1][1].rotateLeft(),t[o][1]=c.rotateRight();else throw new Error;if(o>0)switch(t[o-1][0]){case-1:t[o-1][1].left=t[o][1];break;case 1:t[o-1][1].right=t[o][1];break;case 0:t[o-1][1].mid=t[o][1];break}else this.c=t[0][1]}}return n}get(p){return this.d(p)?.value}d(p){const w=this.b.reset(p);let a=this.c;for(;a;){const s=w.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(w.hasNext())w.next(),a=a.mid;else break}return a}has(p){const w=this.d(p);return!(w?.value===void 0&&w?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,w){const a=this.b.reset(p),s=[];let t=this.c;for(;t;){const n=a.cmp(t.segment);if(n>0)s.push([-1,t]),t=t.left;else if(n<0)s.push([1,t]),t=t.right;else if(a.hasNext())a.next(),s.push([0,t]),t=t.mid;else break}if(t){if(w?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const n=this.f(t.right);if(n.key){const{key:o,value:c,segment:d}=n;this.e(n.key,!1),t.key=o,t.value=c,t.segment=d}}else{const n=t.left??t.right;if(s.length>0){const[o,c]=s[s.length-1];switch(o){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=s.length-1;n>=0;n--){const o=s[n][1];o.updateHeight();const c=o.balanceFactor();if(c>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),s[n][1]=o.rotateLeft()):c<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),s[n][1]=o.rotateRight()),n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const w=this.b.reset(p);let a=this.c,s;for(;a;){const t=w.cmp(a.segment);if(t>0)a=a.left;else if(t<0)a=a.right;else if(w.hasNext())w.next(),s=a.value||s,a=a.mid;else break}return a&&a.value||s}findSuperstr(p){return this.g(p,!1)}g(p,w){const a=this.b.reset(p);let s=this.c;for(;s;){const t=a.cmp(s.segment);if(t>0)s=s.left;else if(t<0)s=s.right;else if(a.hasNext())a.next(),s=s.mid;else return s.mid?this.h(s.mid):w?s.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[w,a]of this)p(a,w)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const w=[];return this.j(p,w),w[Symbol.iterator]()}j(p,w){p&&(p.left&&this.j(p.left,w),p.value&&w.push([p.key,p.value]),p.mid&&this.j(p.mid,w),p.right&&this.j(p.right,w))}_isBalanced(){const p=w=>{if(!w)return!0;const a=w.balanceFactor();return a<-1||a>1?!1:p(w.left)&&p(w.right)};return p(this.c)}}e.$4h=S}),define(Ae[45],Re([1,0,90]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$4j=e.ThemeColor=void 0;var T;(function(P){function $(m){return m&&typeof m=="object"&&typeof m.id=="string"}P.isThemeColor=$})(T||(e.ThemeColor=T={}));function C(P){return{id:P}}e.$4j=C;var M;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function m(n){const o=$.exec(n.id);if(!o)return m(E.$3j.error);const[,c,d]=o,i=["codicon","codicon-"+c];return d&&i.push("codicon-modifier-"+d.substring(1)),i}P.asClassNameArray=m;function y(n){return m(n).join(" ")}P.asClassName=y;function A(n){return"."+m(n).join(".")}P.asCSSSelector=A;function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||T.isThemeColor(n.color))}P.isThemeIcon=S;const l=new RegExp(`^\\$\\((${P.iconNameExpression}(?:${P.iconModifierExpression})?)\\)$`);function p(n){const o=l.exec(n);if(!o)return;const[,c]=o;return{id:c}}P.fromString=p;function w(n){return{id:n}}P.fromId=w;function a(n,o){let c=n.id;const d=c.lastIndexOf("~");return d!==-1&&(c=c.substring(0,d)),o&&(c=`${c}~${o}`),{id:c}}P.modify=a;function s(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}P.getModifier=s;function t(n,o){return n.id===o.id&&n.color?.id===o.color?.id}P.isEqual=t})(M||(e.ThemeIcon=M={}))}),define(Ae[124],Re([1,0,122,12,45]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=void 0;const M="$(",P=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${P.source}`,"g");function m(t){return t.replace($,(n,o)=>o?n:`\\${n}`)}e.$5j=m;const y=new RegExp(`\\\\${P.source}`,"g");function A(t){return t.replace(y,n=>`\\${n}`)}e.$6j=A;const S=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function l(t){return t.indexOf(M)===-1?t:t.replace(S,(n,o,c,d)=>c?n:o||d||"")}e.$7j=l;function p(t){return t?t.replace(/\$\((.*?)\)/g,(n,o)=>` ${o} `).trim():""}e.$8j=p;const w=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(t){w.lastIndex=0;let n="";const o=[];let c=0;for(;;){const d=w.lastIndex,i=w.exec(t),r=t.substring(d,i?.index);if(r.length>0){n+=r;for(let u=0;u<r.length;u++)o.push(c)}if(!i)break;c+=i[0].length}return{text:n,iconOffsets:o}}e.$9j=a;function s(t,n,o=!1){const{text:c,iconOffsets:d}=n;if(!d||d.length===0)return(0,E.$Rj)(t,c,o);const i=(0,T.$Ne)(c," "),r=c.length-i.length,u=(0,E.$Rj)(t,i,o);if(u)for(const f of u){const v=d[f.start+r]+r;f.start+=v,f.end+=v}return u}e.$0j=s}),define(Ae[33],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kg=e.$jg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(C){return E.test(C)}e.$jg=T,e.$kg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function($){for(let m=0;m<$.length;m++)$[m]=Math.floor(Math.random()*256);return $};const M=new Uint8Array(16),P=[];for(let $=0;$<256;$++)P.push($.toString(16).padStart(2,"0"));return function(){C(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let m=0,y="";return y+=P[M[m++]],y+=P[M[m++]],y+=P[M[m++]],y+=P[M[m++]],y+="-",y+=P[M[m++]],y+=P[M[m++]],y+="-",y+=P[M[m++]],y+=P[M[m++]],y+="-",y+=P[M[m++]],y+=P[M[m++]],y+="-",y+=P[M[m++]],y+=P[M[m++]],y+=P[M[m++]],y+=P[M[m++]],y+=P[M[m++]],y+=P[M[m++]],y}}()}),define(Ae[125],Re([1,0,18,67,33]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$s=e.$0s=e.$9s=e.$8s=e.$7s=void 0;function M(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}e.$7s=M;function P(S,l,p){const w={id:(0,C.$kg)(),name:S,uri:l,data:p};return{asString:async()=>"",asFile:()=>w,value:void 0}}e.$8s=P;class ${constructor(){this.a=new Map}get size(){let l=0;for(const p of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const p=[...this.a.keys()];return T.Iterable.some(this,([w,a])=>a.asFile())&&p.push("files"),A(m(l),p)}get(l){return this.a.get(this.b(l))?.[0]}append(l,p){const w=this.a.get(l);w?w.push(p):this.a.set(this.b(l),[p])}replace(l,p){this.a.set(this.b(l),[p])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,p]of this.a)for(const w of p)yield[l,w]}b(l){return m(l)}}e.$9s=$;function m(S){return S.toLowerCase()}function y(S,l){return A(m(S),l.map(m))}e.$0s=y;function A(S,l){if(S==="*/*")return l.length>0;if(l.includes(S))return!0;const p=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[w,a,s]=p;return s==="*"?l.some(t=>t.startsWith(a+"/")):!1}e.$$s=Object.freeze({create:S=>(0,E.$Lb)(S.map(l=>l.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$$s.split(S).filter(l=>!l.startsWith("#"))})}),define(Ae[126],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=e.StringEOL=void 0;var E;(function(C){C[C.Unknown=0]="Unknown",C[C.Invalid=3]="Invalid",C[C.LF=1]="LF",C[C.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function T(C){let M=0,P=0,$=0,m=0;for(let y=0,A=C.length;y<A;y++){const S=C.charCodeAt(y);S===13?(M===0&&(P=y),M++,y+1<A&&C.charCodeAt(y+1)===10?(m|=2,y++):m|=3,$=y+1):S===10&&(m|=1,M===0&&(P=y),M++,$=y+1)}return M===0&&(P=C.length),[M,P,C.length-$,m]}e.$bt=T}),define(Ae[127],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=void 0,e.$$r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[128],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yt=e.$xt=e.IndentAction=void 0;var E;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class T{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let m=0,y=$.notIn.length;m<y;m++)switch($.notIn[m]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,m){if($.getTokenCount()===0)return!0;const y=$.findTokenIndexAtOffset(m-2),A=$.getStandardTokenType(y);return this.isOK(A)}g($,m){for(let y=$;y<=m;y++){const A=String.fromCharCode(y);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$xt=T;class C{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const m of $)M(this.autoClosingPairsOpenByStart,m.open.charAt(0),m),M(this.autoClosingPairsOpenByEnd,m.open.charAt(m.open.length-1),m),M(this.autoClosingPairsCloseByStart,m.close.charAt(0),m),M(this.autoClosingPairsCloseByEnd,m.close.charAt(m.close.length-1),m),m.close.length===1&&m.open.length===1&&M(this.autoClosingPairsCloseSingleChar,m.close,m)}}e.$yt=C;function M(P,$,m){P.has($)?P.get($).push(m):P.set($,[m])}}),define(Ae[129],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CB=e.$BB=e.$AB=e.$zB=e.$yB=e.$xB=e.$wB=e.$vB=e.$uB=e.NodeColor=e.$tB=void 0;class E{constructor(s,t){this.piece=s,this.color=t,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$uB)return C(this.right);let s=this;for(;s.parent!==e.$uB&&s.parent.left!==s;)s=s.parent;return s.parent===e.$uB?e.$uB:s.parent}prev(){if(this.left!==e.$uB)return M(this.left);let s=this;for(;s.parent!==e.$uB&&s.parent.right!==s;)s=s.parent;return s.parent===e.$uB?e.$uB:s.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$tB=E;var T;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$uB=new E(null,0),e.$uB.parent=e.$uB,e.$uB.left=e.$uB,e.$uB.right=e.$uB,e.$uB.color=0;function C(a){for(;a.left!==e.$uB;)a=a.left;return a}e.$vB=C;function M(a){for(;a.right!==e.$uB;)a=a.right;return a}e.$wB=M;function P(a){return a===e.$uB?0:a.size_left+a.piece.length+P(a.right)}function $(a){return a===e.$uB?0:a.lf_left+a.piece.lineFeedCnt+$(a.right)}function m(){e.$uB.parent=e.$uB}function y(a,s){const t=s.right;t.size_left+=s.size_left+(s.piece?s.piece.length:0),t.lf_left+=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),s.right=t.left,t.left!==e.$uB&&(t.left.parent=s),t.parent=s.parent,s.parent===e.$uB?a.root=t:s.parent.left===s?s.parent.left=t:s.parent.right=t,t.left=s,s.parent=t}e.$xB=y;function A(a,s){const t=s.left;s.left=t.right,t.right!==e.$uB&&(t.right.parent=s),t.parent=s.parent,s.size_left-=t.size_left+(t.piece?t.piece.length:0),s.lf_left-=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),s.parent===e.$uB?a.root=t:s===s.parent.right?s.parent.right=t:s.parent.left=t,t.right=s,s.parent=t}e.$yB=A;function S(a,s){let t,n;if(s.left===e.$uB?(n=s,t=n.right):s.right===e.$uB?(n=s,t=n.left):(n=C(s.right),t=n.right),n===a.root){a.root=t,t.color=0,s.detach(),m(),a.root.parent=e.$uB;return}const o=n.color===1;if(n===n.parent.left?n.parent.left=t:n.parent.right=t,n===s?(t.parent=n.parent,w(a,t)):(n.parent===s?t.parent=n:t.parent=n.parent,w(a,t),n.left=s.left,n.right=s.right,n.parent=s.parent,n.color=s.color,s===a.root?a.root=n:s===s.parent.left?s.parent.left=n:s.parent.right=n,n.left!==e.$uB&&(n.left.parent=n),n.right!==e.$uB&&(n.right.parent=n),n.size_left=s.size_left,n.lf_left=s.lf_left,w(a,n)),s.detach(),t.parent.left===t){const d=P(t),i=$(t);if(d!==t.parent.size_left||i!==t.parent.lf_left){const r=d-t.parent.size_left,u=i-t.parent.lf_left;t.parent.size_left=d,t.parent.lf_left=i,p(a,t.parent,r,u)}}if(w(a,t.parent),o){m();return}let c;for(;t!==a.root&&t.color===0;)t===t.parent.left?(c=t.parent.right,c.color===1&&(c.color=0,t.parent.color=1,y(a,t.parent),c=t.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.right.color===0&&(c.left.color=0,c.color=1,A(a,c),c=t.parent.right),c.color=t.parent.color,t.parent.color=0,c.right.color=0,y(a,t.parent),t=a.root)):(c=t.parent.left,c.color===1&&(c.color=0,t.parent.color=1,A(a,t.parent),c=t.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.left.color===0&&(c.right.color=0,c.color=1,y(a,c),c=t.parent.left),c.color=t.parent.color,t.parent.color=0,c.left.color=0,A(a,t.parent),t=a.root));t.color=0,m()}e.$zB=S;function l(a,s){for(w(a,s);s!==a.root&&s.parent.color===1;)if(s.parent===s.parent.parent.left){const t=s.parent.parent.right;t.color===1?(s.parent.color=0,t.color=0,s.parent.parent.color=1,s=s.parent.parent):(s===s.parent.right&&(s=s.parent,y(a,s)),s.parent.color=0,s.parent.parent.color=1,A(a,s.parent.parent))}else{const t=s.parent.parent.left;t.color===1?(s.parent.color=0,t.color=0,s.parent.parent.color=1,s=s.parent.parent):(s===s.parent.left&&(s=s.parent,A(a,s)),s.parent.color=0,s.parent.parent.color=1,y(a,s.parent.parent))}a.root.color=0}e.$AB=l;function p(a,s,t,n){for(;s!==a.root&&s!==e.$uB;)s.parent.left===s&&(s.parent.size_left+=t,s.parent.lf_left+=n),s=s.parent}e.$BB=p;function w(a,s){let t=0,n=0;if(s!==a.root){for(;s!==a.root&&s===s.parent.right;)s=s.parent;if(s!==a.root)for(s=s.parent,t=P(s.left)-s.size_left,n=$(s.left)-s.lf_left,s.size_left+=t,s.lf_left+=n;s!==a.root&&(t!==0||n!==0);)s.parent.left===s&&(s.parent.size_left+=t,s.parent.lf_left+=n),s=s.parent}}e.$CB=w}),define(Ae[91],Re([1,0,130,29,92,129,93]),function(we,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NB=e.$MB=e.$LB=e.$KB=e.$JB=void 0;const $=65535;function m(t){let n;return t[t.length-1]<65536?n=new Uint16Array(t.length):n=new Uint32Array(t.length),n.set(t,0),n}class y{constructor(n,o,c,d,i){this.lineStarts=n,this.cr=o,this.lf=c,this.crlf=d,this.isBasicASCII=i}}function A(t,n=!0){const o=[0];let c=1;for(let d=0,i=t.length;d<i;d++){const r=t.charCodeAt(d);r===13?d+1<i&&t.charCodeAt(d+1)===10?(o[c++]=d+2,d++):o[c++]=d+1:r===10&&(o[c++]=d+1)}return n?m(o):o}e.$JB=A;function S(t,n){t.length=0,t[0]=0;let o=1,c=0,d=0,i=0,r=!0;for(let f=0,v=n.length;f<v;f++){const g=n.charCodeAt(f);g===13?f+1<v&&n.charCodeAt(f+1)===10?(i++,t[o++]=f+2,f++):(c++,t[o++]=f+1):g===10?(d++,t[o++]=f+1):r&&g!==9&&(g<32||g>126)&&(r=!1)}const u=new y(m(t),c,d,i,r);return t.length=0,u}e.$KB=S;class l{constructor(n,o,c,d,i){this.bufferIndex=n,this.start=o,this.end=c,this.lineFeedCnt=d,this.length=i}}e.$LB=l;class p{constructor(n,o){this.buffer=n,this.lineStarts=o}}e.$MB=p;class w{constructor(n,o){this.a=[],this.c=n,this.d=o,this.b=0,n.root!==M.$uB&&n.iterate(n.root,c=>(c!==M.$uB&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class a{constructor(n){this.a=n,this.b=[]}get(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let o=!1;const c=this.b;for(let d=0;d<c.length;d++){const i=c[d];if(i.node.parent===null||i.nodeStartOffset>=n){c[d]=null,o=!0;continue}}if(o){const d=[];for(const i of c)i!==null&&d.push(i);this.b=d}}}class s{constructor(n,o,c){this.create(n,o,c)}create(n,o,c){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=M.$uB,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=c;let d=null;for(let i=0,r=n.length;i<r;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=A(n[i].buffer));const u=new l(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),d=this.S(d,u)}this.h=new a(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const o=$,c=o-Math.floor(o/3),d=c*2;let i="",r=0;const u=[];if(this.iterate(this.root,f=>{const v=this.R(f),g=v.length;if(r<=c||r+g<d)return i+=v,r+=g,!0;const D=i.replace(/\r\n|\r|\n/g,n);return u.push(new p(D,A(D))),i=v,r=g,!0}),r>0){const f=i.replace(/\r\n|\r|\n/g,n);u.push(new p(f,A(f)))}this.create(u,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new w(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,d=>{if(d===M.$uB)return!0;const i=this.R(d),r=i.length,u=n.G(o),f=n.G(o+r),v=n.getValueInRange2(u,f);return o+=r,i===v})}getOffsetAt(n,o){let c=0,d=this.root;for(;d!==M.$uB;)if(d.left!==M.$uB&&d.lf_left+1>=n)d=d.left;else if(d.lf_left+d.piece.lineFeedCnt+1>=n){c+=d.size_left;const i=this.B(d,n-d.lf_left-2);return c+=i+o-1}else n-=d.lf_left+d.piece.lineFeedCnt,c+=d.size_left+d.piece.length,d=d.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,c=0;const d=n;for(;o!==M.$uB;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const i=this.A(o,n-o.size_left);if(c+=o.lf_left+i.index,i.index===0){const r=this.getOffsetAt(c+1,1),u=d-r;return new E.$As(c+1,u+1)}return new E.$As(c+1,i.remainder+1)}else if(n-=o.size_left+o.piece.length,c+=o.lf_left+o.piece.lineFeedCnt,o.right===M.$uB){const i=this.getOffsetAt(c+1,1),r=d-n-i;return new E.$As(c+1,r+1)}else o=o.right;return new E.$As(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),d=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(c,d);return o?o!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,o):i}getValueInRange2(n,o){if(n.node===o.node){const u=n.node,f=this.a[u.piece.bufferIndex].buffer,v=this.u(u.piece.bufferIndex,u.piece.start);return f.substring(v+n.remainder,v+o.remainder)}let c=n.node;const d=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let r=d.substring(i+n.remainder,i+c.piece.length);for(c=c.next();c!==M.$uB;){const u=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);if(c===o.node){r+=u.substring(f,f+o.remainder);break}else r+=u.substr(f,c.piece.length);c=c.next()}return r}getLinesContent(){const n=[];let o=0,c="",d=!1;return this.iterate(this.root,i=>{if(i===M.$uB)return!0;const r=i.piece;let u=r.length;if(u===0)return!0;const f=this.a[r.bufferIndex].buffer,v=this.a[r.bufferIndex].lineStarts,g=r.start.line,D=r.end.line;let I=v[g]+r.start.column;if(d&&(f.charCodeAt(I)===10&&(I++,u--),n[o++]=c,c="",d=!1,u===0))return!0;if(g===D)return!this.f&&f.charCodeAt(I+u-1)===13?(d=!0,c+=f.substr(I,u-1)):c+=f.substr(I,u),!0;c+=this.f?f.substring(I,Math.max(I,v[g+1]-this.e)):f.substring(I,v[g+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;for(let h=g+1;h<D;h++)c=this.f?f.substring(v[h],v[h+1]-this.e):f.substring(v[h],v[h+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;return!this.f&&f.charCodeAt(v[D]+r.end.column-1)===13?(d=!0,r.end.column===0?o--:c=f.substr(v[D],r.end.column-1)):c=f.substr(v[D],r.end.column),!0}),d&&(n[o++]=c,c=""),n[o++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const c=this.a[o.piece.bufferIndex],d=this.u(o.piece.bufferIndex,o.piece.start);return c.buffer.charCodeAt(d)}else{const o=this.a[n.node.piece.bufferIndex],d=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(d)}}getLineCharCode(n,o){const c=this.H(n,o+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const o=this.G(n);return this.l(o)}findMatchesInNode(n,o,c,d,i,r,u,f,v,g,D){const I=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start),b=this.u(n.piece.bufferIndex,i),k=this.u(n.piece.bufferIndex,r);let F;const W={line:0,column:0};let J,N;o._wordSeparators?(J=I.buffer.substring(b,k),N=R=>R+b,o.reset(0)):(J=I.buffer,N=R=>R,o.reset(b));do if(F=o.next(J),F){if(N(F.index)>=k)return g;this.s(n,N(F.index)-h,W);const R=this.t(n.piece.bufferIndex,i,W),L=W.line===i.line?W.column-i.column+d:W.column+1,O=L+F[0].length;if(D[g++]=(0,P.$FB)(new T.$Bs(c+R,L,c+R,O),F,f),N(F.index)+F[0].length>=k||g>=v)return g}while(F);return g}findMatchesLineByLine(n,o,c,d){const i=[];let r=0;const u=new P.$IB(o.wordSeparators,o.regex);let f=this.H(n.startLineNumber,n.startColumn);if(f===null)return[];const v=this.H(n.endLineNumber,n.endColumn);if(v===null)return[];let g=this.s(f.node,f.remainder);const D=this.s(v.node,v.remainder);if(f.node===v.node)return this.findMatchesInNode(f.node,u,n.startLineNumber,n.startColumn,g,D,o,c,d,r,i),i;let I=n.startLineNumber,h=f.node;for(;h!==v.node;){const k=this.t(h.piece.bufferIndex,g,h.piece.end);if(k>=1){const W=this.a[h.piece.bufferIndex].lineStarts,J=this.u(h.piece.bufferIndex,h.piece.start),N=W[g.line+k],R=I===n.startLineNumber?n.startColumn:1;if(r=this.findMatchesInNode(h,u,I,R,g,this.s(h,N-J),o,c,d,r,i),r>=d)return i;I+=k}const F=I===n.startLineNumber?n.startColumn-1:0;if(I===n.endLineNumber){const W=this.getLineContent(I).substring(F,n.endColumn-1);return r=this.n(o,u,W,n.endLineNumber,F,r,i,c,d),i}if(r=this.n(o,u,this.getLineContent(I).substr(F),I,F,r,i,c,d),r>=d)return i;I++,f=this.H(I,1),h=f.node,g=this.s(f.node,f.remainder)}if(I===n.endLineNumber){const k=I===n.startLineNumber?n.startColumn-1:0,F=this.getLineContent(I).substring(k,n.endColumn-1);return r=this.n(o,u,F,n.endLineNumber,k,r,i,c,d),i}const b=I===n.startLineNumber?n.startColumn:1;return r=this.findMatchesInNode(v.node,u,I,b,g,D,o,c,d,r,i),i}n(n,o,c,d,i,r,u,f,v){const g=n.wordSeparators;if(!f&&n.simpleSearch){const I=n.simpleSearch,h=I.length,b=c.length;let k=-h;for(;(k=c.indexOf(I,k+h))!==-1;)if((!g||(0,P.$HB)(g,c,b,k,h))&&(u[r++]=new C.$Su(new T.$Bs(d,k+1+i,d,k+1+h+i),null),r>=v))return r;return r}let D;o.reset(0);do if(D=o.next(c),D&&(u[r++]=(0,P.$FB)(new T.$Bs(d,D.index+1+i,d,D.index+1+D[0].length+i),D,f),r>=v))return r;while(D);return r}insert(n,o,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==M.$uB){const{node:d,remainder:i,nodeStartOffset:r}=this.G(n),u=d.piece,f=u.bufferIndex,v=this.s(d,i);if(d.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&r+u.length===n&&o.length<$){this.F(d,o),this.y();return}if(r===n)this.o(o,d),this.h.validate(n);else if(r+d.piece.length>n){const g=[];let D=new l(u.bufferIndex,v,u.end,this.t(u.bufferIndex,v,u.end),this.u(f,u.end)-this.u(f,v));if(this.K()&&this.M(o)&&this.I(d,i)===10){const k={line:D.start.line+1,column:0};D=new l(D.bufferIndex,k,D.end,this.t(D.bufferIndex,k,D.end),D.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(d,i-1)===13){const k=this.s(d,i-1);this.C(d,k),o="\r"+o,d.piece.length===0&&g.push(d)}else this.C(d,v);else this.C(d,v);const I=this.w(o);D.length>0&&this.S(d,D);let h=d;for(let b=0;b<I.length;b++)h=this.S(h,I[b]);this.v(g)}else this.q(o,d)}else{const d=this.w(o);let i=this.T(null,d[0]);for(let r=1;r<d.length;r++)i=this.S(i,d[r])}this.y()}delete(n,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===M.$uB)return;const c=this.G(n),d=this.G(n+o),i=c.node,r=d.node;if(i===r){const I=this.s(i,c.remainder),h=this.s(i,d.remainder);if(c.nodeStartOffset===n){if(o===i.piece.length){const b=i.next();(0,M.$zB)(this,i),this.N(b),this.y();return}this.D(i,h),this.h.validate(n),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===n+o){this.C(i,I),this.O(i),this.y();return}this.E(i,I,h),this.y();return}const u=[],f=this.s(i,c.remainder);this.C(i,f),this.h.validate(n),i.piece.length===0&&u.push(i);const v=this.s(r,d.remainder);this.D(r,v),r.piece.length===0&&u.push(r);const g=i.next();for(let I=g;I!==M.$uB&&I!==r;I=I.next())u.push(I);const D=i.piece.length===0?i.prev():i;this.v(u),this.O(D),this.y()}o(n,o){const c=[];if(this.K()&&this.M(n)&&this.L(o)){const r=o.piece,u={line:r.start.line+1,column:0},f=new l(r.bufferIndex,u,r.end,this.t(r.bufferIndex,u,r.end),r.length-1);o.piece=f,n+=`
`,(0,M.$BB)(this,o,-1,-1),o.piece.length===0&&c.push(o)}const d=this.w(n);let i=this.T(o,d[d.length-1]);for(let r=d.length-2;r>=0;r--)i=this.T(i,d[r]);this.N(i),this.v(c)}q(n,o){this.Q(n,o)&&(n+=`
`);const c=this.w(n),d=this.S(o,c[0]);let i=d;for(let r=1;r<c.length;r++)i=this.S(i,c[r]);this.N(d)}s(n,o,c){const d=n.piece,i=n.piece.bufferIndex,r=this.a[i].lineStarts,f=r[d.start.line]+d.start.column+o;let v=d.start.line,g=d.end.line,D=0,I=0,h=0;for(;v<=g&&(D=v+(g-v)/2|0,h=r[D],D!==g);)if(I=r[D+1],f<h)g=D-1;else if(f>=I)v=D+1;else break;return c?(c.line=D,c.column=f-h,null):{line:D,column:f-h}}t(n,o,c){if(c.column===0)return c.line-o.line;const d=this.a[n].lineStarts;if(c.line===d.length-1)return c.line-o.line;const i=d[c.line+1],r=d[c.line]+c.column;if(i>r+1)return c.line-o.line;const u=r-1;return this.a[n].buffer.charCodeAt(u)===13?c.line-o.line+1:c.line-o.line}u(n,o){return this.a[n].lineStarts[o.line]+o.column}v(n){for(let o=0;o<n.length;o++)(0,M.$zB)(this,n[o])}w(n){if(n.length>$){const g=[];for(;n.length>$;){const I=n.charCodeAt($-1);let h;I===13||I>=55296&&I<=56319?(h=n.substring(0,$-1),n=n.substring($-1)):(h=n.substring(0,$),n=n.substring($));const b=A(h);g.push(new l(this.a.length,{line:0,column:0},{line:b.length-1,column:h.length-b[b.length-1]},b.length-1,h.length)),this.a.push(new p(h,b))}const D=A(n);return g.push(new l(this.a.length,{line:0,column:0},{line:D.length-1,column:n.length-D[D.length-1]},D.length-1,n.length)),this.a.push(new p(n,D)),g}let o=this.a[0].buffer.length;const c=A(n,!1);let d=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},d=this.g;for(let g=0;g<c.length;g++)c[g]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let g=0;g<c.length;g++)c[g]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,r=this.a[0].lineStarts.length-1,u=i-this.a[0].lineStarts[r],f={line:r,column:u},v=new l(0,d,f,this.t(0,d,f),i-o);return this.g=f,[v]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,o=0){let c=this.root,d="";const i=this.h.get2(n);if(i){c=i.node;const r=this.B(c,n-i.nodeStartLineNumber-1),u=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===n)d=u.substring(f+r,f+c.piece.length);else{const v=this.B(c,n-i.nodeStartLineNumber);return u.substring(f+r,f+v-o)}}else{let r=0;const u=n;for(;c!==M.$uB;)if(c.left!==M.$uB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const f=this.B(c,n-c.lf_left-2),v=this.B(c,n-c.lf_left-1),g=this.a[c.piece.bufferIndex].buffer,D=this.u(c.piece.bufferIndex,c.piece.start);return r+=c.size_left,this.h.set({node:c,nodeStartOffset:r,nodeStartLineNumber:u-(n-1-c.lf_left)}),g.substring(D+f,D+v-o)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const f=this.B(c,n-c.lf_left-2),v=this.a[c.piece.bufferIndex].buffer,g=this.u(c.piece.bufferIndex,c.piece.start);d=v.substring(g+f,g+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,r+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==M.$uB;){const r=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const u=this.B(c,0),f=this.u(c.piece.bufferIndex,c.piece.start);return d+=r.substring(f,f+u-o),d}else{const u=this.u(c.piece.bufferIndex,c.piece.start);d+=r.substr(u,c.piece.length)}c=c.next()}return d}y(){let n=this.root,o=1,c=0;for(;n!==M.$uB;)o+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=o,this.c=c,this.h.validate(this.c)}A(n,o){const c=n.piece,d=this.s(n,o),i=d.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===o){const r=this.t(n.piece.bufferIndex,c.start,d);if(r!==i)return{index:r,remainder:0}}return{index:i,remainder:d.column}}B(n,o){if(o<0)return 0;const c=n.piece,d=this.a[c.bufferIndex].lineStarts,i=c.start.line+o+1;return i>c.end.line?d[c.end.line]+c.end.column-d[c.start.line]-c.start.column:d[i]-d[c.start.line]-c.start.column}C(n,o){const c=n.piece,d=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),r=o,u=this.u(c.bufferIndex,r),f=this.t(c.bufferIndex,c.start,r),v=f-d,g=u-i,D=c.length+g;n.piece=new l(c.bufferIndex,c.start,r,f,D),(0,M.$BB)(this,n,g,v)}D(n,o){const c=n.piece,d=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),r=o,u=this.t(c.bufferIndex,r,c.end),f=this.u(c.bufferIndex,r),v=u-d,g=i-f,D=c.length+g;n.piece=new l(c.bufferIndex,r,c.end,u,D),(0,M.$BB)(this,n,g,v)}E(n,o,c){const d=n.piece,i=d.start,r=d.end,u=d.length,f=d.lineFeedCnt,v=o,g=this.t(d.bufferIndex,d.start,v),D=this.u(d.bufferIndex,o)-this.u(d.bufferIndex,i);n.piece=new l(d.bufferIndex,d.start,v,g,D),(0,M.$BB)(this,n,D-u,g-f);const I=new l(d.bufferIndex,c,r,this.t(d.bufferIndex,c,r),this.u(d.bufferIndex,r)-this.u(d.bufferIndex,c)),h=this.S(n,I);this.N(h)}F(n,o){this.Q(o,n)&&(o+=`
`);const c=this.K()&&this.L(o)&&this.M(n),d=this.a[0].buffer.length;this.a[0].buffer+=o;const i=A(o,!1);for(let h=0;h<i.length;h++)i[h]+=d;if(c){const h=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:d-h}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const r=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[r],f={line:r,column:u},v=n.piece.length+o.length,g=n.piece.lineFeedCnt,D=this.t(0,n.piece.start,f),I=D-g;n.piece=new l(n.piece.bufferIndex,n.piece.start,f,D,v),this.g=f,(0,M.$BB)(this,n,o.length,I)}G(n){let o=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let d=0;for(;o!==M.$uB;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){d+=o.size_left;const i={node:o,remainder:n-o.size_left,nodeStartOffset:d};return this.h.set(i),i}else n-=o.size_left+o.piece.length,d+=o.size_left+o.piece.length,o=o.right;return null}H(n,o){let c=this.root,d=0;for(;c!==M.$uB;)if(c.left!==M.$uB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const i=this.B(c,n-c.lf_left-2),r=this.B(c,n-c.lf_left-1);return d+=c.size_left,{node:c,remainder:Math.min(i+o-1,r),nodeStartOffset:d}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const i=this.B(c,n-c.lf_left-2);if(i+o-1<=c.piece.length)return{node:c,remainder:i+o-1,nodeStartOffset:d};o-=c.piece.length-i;break}else n-=c.lf_left+c.piece.lineFeedCnt,d+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==M.$uB;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),r=this.J(c);return{node:c,remainder:Math.min(o-1,i),nodeStartOffset:r}}else if(c.piece.length>=o-1){const i=this.J(c);return{node:c,remainder:o-1,nodeStartOffset:i}}else o-=c.piece.length;c=c.next()}return null}I(n,o){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],d=this.u(n.piece.bufferIndex,n.piece.start)+o;return c.buffer.charCodeAt(d)}J(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===M.$uB||n.piece.lineFeedCnt===0)return!1;const o=n.piece,c=this.a[o.bufferIndex].lineStarts,d=o.start.line,i=c[d]+o.start.column;return d===c.length-1||c[d+1]>i+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===M.$uB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const o=n.prev();this.M(o)&&this.P(o,n)}}O(n){if(this.K()&&this.M(n)){const o=n.next();this.L(o)&&this.P(n,o)}}P(n,o){const c=[],d=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:d[n.piece.end.line]-d[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const r=n.piece.length-1,u=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,i,u,r),(0,M.$BB)(this,n,-1,-1),n.piece.length===0&&c.push(n);const f={line:o.piece.start.line+1,column:0},v=o.piece.length-1,g=this.t(o.piece.bufferIndex,f,o.piece.end);o.piece=new l(o.piece.bufferIndex,f,o.piece.end,g,v),(0,M.$BB)(this,o,-1,-1),o.piece.length===0&&c.push(o);const D=this.w(`\r
`);this.S(n,D[0]);for(let I=0;I<c.length;I++)(0,M.$zB)(this,c[I])}Q(n,o){if(this.K()&&this.M(n)){const c=o.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,M.$zB)(this,c);else{const d=c.piece,i={line:d.start.line+1,column:0},r=d.length-1,u=this.t(d.bufferIndex,i,d.end);c.piece=new l(d.bufferIndex,i,d.end,u,r),(0,M.$BB)(this,c,-1,-1)}return!0}}return!1}iterate(n,o){if(n===M.$uB)return o(M.$uB);const c=this.iterate(n.left,o);return c&&o(n)&&this.iterate(n.right,o)}R(n){if(n===M.$uB)return"";const o=this.a[n.piece.bufferIndex],c=n.piece,d=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return o.buffer.substring(d,i)}getPieceContent(n){const o=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),d=this.u(n.bufferIndex,n.end);return o.buffer.substring(c,d)}S(n,o){const c=new M.$tB(o,1);if(c.left=M.$uB,c.right=M.$uB,c.parent=M.$uB,c.size_left=0,c.lf_left=0,this.root===M.$uB)this.root=c,c.color=0;else if(n.right===M.$uB)n.right=c,c.parent=n;else{const i=(0,M.$vB)(n.right);i.left=c,c.parent=i}return(0,M.$AB)(this,c),c}T(n,o){const c=new M.$tB(o,1);if(c.left=M.$uB,c.right=M.$uB,c.parent=M.$uB,c.size_left=0,c.lf_left=0,this.root===M.$uB)this.root=c,c.color=0;else if(n.left===M.$uB)n.left=c,c.parent=n;else{const d=(0,M.$wB)(n.left);d.right=c,c.parent=d}return(0,M.$AB)(this,c),c}U(n){let o="";return this.iterate(n,c=>(o+=this.R(c),!0)),o}}e.$NB=s}),define(Ae[131],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R7=e.$Q7=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const P=this.a.get(M);return this.a.delete(M),P}}addDragOperationTransfer(M,P){this.a.set(M,P)}}e.$Q7=E;class T{constructor(M){this.identifier=M}}e.$R7=T}),define(Ae[132],Re([9,10]),function(we,e){return we.create("vs/base/common/actions",e)}),define(Ae[133],Re([1,0,5,6,132]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class M extends T.$Rc{constructor(l,p="",w="",a=!0,s){super(),this.h=this.B(new E.$Rd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=p,this.u=w,this.w=a,this.C=s}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,p){this.C&&await this.C(l)}}e.$Ci=M;class P extends T.$Rc{constructor(){super(...arguments),this.f=this.B(new E.$Rd),this.onWillRun=this.f.event,this.m=this.B(new E.$Rd),this.onDidRun=this.m.event}async run(l,p){if(!l.enabled)return;this.f.fire({action:l});let w;try{await this.u(l,p)}catch(a){w=a}this.m.fire({action:l,error:w})}async u(l,p){await l.run(p)}}e.$Di=P;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let p=[];for(const w of l)w.length&&(p.length?p=[...p,new $,...w]:p=w);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$Ei=$;class m{get actions(){return this.a}constructor(l,p,w,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=p,this.class=a,this.a=w}async run(){}}e.$Fi=m;class y extends M{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,C.localize(0,null),void 0,!1)}}e.$Gi=y;function A(S){return{id:S.id,label:S.label,class:void 0,enabled:S.enabled??!0,checked:S.checked??!1,run:async(...l)=>S.run(...l),tooltip:S.label}}e.$Hi=A}),define(Ae[134],Re([9,10]),function(we,e){return we.create("vs/base/common/date",e)}),define(Ae[135],Re([1,0,134]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=void 0;const T=60,C=T*60,M=C*24,P=M*7,$=M*30,m=M*365;function y(S,l,p,w){typeof S!="number"&&(S=S.getTime());const a=Math.round((new Date().getTime()-S)/1e3);if(a<-30)return(0,E.localize)(0,null,y(new Date().getTime()+a*1e3,!1));if(!w&&a<30)return(0,E.localize)(1,null);let s;return a<T?(s=a,l?s===1?p?(0,E.localize)(2,null,s):(0,E.localize)(3,null,s):p?(0,E.localize)(4,null,s):(0,E.localize)(5,null,s):s===1?p?(0,E.localize)(6,null,s):(0,E.localize)(7,null,s):p?(0,E.localize)(8,null,s):(0,E.localize)(9,null,s)):a<C?(s=Math.floor(a/T),l?s===1?p?(0,E.localize)(10,null,s):(0,E.localize)(11,null,s):p?(0,E.localize)(12,null,s):(0,E.localize)(13,null,s):s===1?p?(0,E.localize)(14,null,s):(0,E.localize)(15,null,s):p?(0,E.localize)(16,null,s):(0,E.localize)(17,null,s)):a<M?(s=Math.floor(a/C),l?s===1?p?(0,E.localize)(18,null,s):(0,E.localize)(19,null,s):p?(0,E.localize)(20,null,s):(0,E.localize)(21,null,s):s===1?p?(0,E.localize)(22,null,s):(0,E.localize)(23,null,s):p?(0,E.localize)(24,null,s):(0,E.localize)(25,null,s)):a<P?(s=Math.floor(a/M),l?s===1?(0,E.localize)(26,null,s):(0,E.localize)(27,null,s):s===1?(0,E.localize)(28,null,s):(0,E.localize)(29,null,s)):a<$?(s=Math.floor(a/P),l?s===1?p?(0,E.localize)(30,null,s):(0,E.localize)(31,null,s):p?(0,E.localize)(32,null,s):(0,E.localize)(33,null,s):s===1?p?(0,E.localize)(34,null,s):(0,E.localize)(35,null,s):p?(0,E.localize)(36,null,s):(0,E.localize)(37,null,s)):a<m?(s=Math.floor(a/$),l?s===1?p?(0,E.localize)(38,null,s):(0,E.localize)(39,null,s):p?(0,E.localize)(40,null,s):(0,E.localize)(41,null,s):s===1?p?(0,E.localize)(42,null,s):(0,E.localize)(43,null,s):p?(0,E.localize)(44,null,s):(0,E.localize)(45,null,s)):(s=Math.floor(a/m),l?s===1?p?(0,E.localize)(46,null,s):(0,E.localize)(47,null,s):p?(0,E.localize)(48,null,s):(0,E.localize)(49,null,s):s===1?p?(0,E.localize)(50,null,s):(0,E.localize)(51,null,s):p?(0,E.localize)(52,null,s):(0,E.localize)(53,null,s))}e.$lm=y;function A(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$mm=A}),define(Ae[136],Re([9,10]),function(we,e){return we.create("vs/base/common/errorMessage",e)}),define(Ae[39],Re([1,0,18,16,136]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=void 0;function M(S,l){return l&&(S.stack||S.stacktrace)?C.localize(0,null,$(S),P(S.stack)||P(S.stacktrace)):$(S)}function P(S){return Array.isArray(S)?S.join(`
`):S}function $(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?C.localize(1,null,S.message):S.message||C.localize(2,null)}function m(S=null,l=!1){if(!S)return C.localize(3,null);if(Array.isArray(S)){const p=E.$Gb(S),w=m(p[0],l);return p.length>1?C.localize(4,null,w,p.length):w}if(T.$Cf(S))return S;if(S.detail){const p=S.detail;if(p.error)return M(p.error,l);if(p.exception)return M(p.exception,l)}return S.stack?M(S,l):S.message?S.message:C.localize(5,null)}e.$Ii=m;function y(S){const l=S;return l instanceof Error&&Array.isArray(l.actions)}e.$Ji=y;function A(S,l){let p;return typeof S=="string"?p=new Error(S):p=S,p.actions=l,p}e.$Ki=A}),define(Ae[137],Re([1,0,44,20]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=void 0;const C=new E.$U(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),M=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(I,h,b=!1){const k=I||"",F=h||"",W=C.value.collator.compare(k,F);return C.value.collatorIsNumeric&&W===0&&k!==F?k<F?-1:1:W}e.$pq=$;function m(I,h){const b=M.value.collator;return I=I||"",h=h||"",c(b,I,h)}e.$qq=m;function y(I,h){const b=M.value.collator;return I=I||"",h=h||"",u(I,h)||c(b,I,h)}e.$rq=y;function A(I,h){const b=M.value.collator;return I=I||"",h=h||"",r(I,h)||c(b,I,h)}e.$sq=A;function S(I,h){return I=I||"",h=h||"",I===h?0:I<h?-1:1}e.$tq=S;function l(I,h){const[b,k]=n(I),[F,W]=n(h);let J=C.value.collator.compare(k,W);if(J===0){if(C.value.collatorIsNumeric&&k!==W)return k<W?-1:1;if(J=C.value.collator.compare(b,F),C.value.collatorIsNumeric&&J===0&&b!==F)return b<F?-1:1}return J}e.$uq=l;function p(I,h){I=I||"",h=h||"";const b=o(I),k=o(h),F=M.value.collator,W=P.value.collator;return c(W,b,k)||c(F,I,h)}e.$vq=p;function w(I,h){I=I||"",h=h||"";const b=o(I),k=o(h),F=M.value.collator,W=P.value.collator;return c(W,b,k)||u(I,h)||c(F,I,h)}e.$wq=w;function a(I,h){I=I||"",h=h||"";const b=o(I),k=o(h),F=M.value.collator,W=P.value.collator;return c(W,b,k)||r(I,h)||c(F,I,h)}e.$xq=a;function s(I,h){I=I||"",h=h||"";const b=o(I).toLowerCase(),k=o(h).toLowerCase();return b!==k?b<k?-1:1:I!==h?I<h?-1:1:0}e.$yq=s;const t=/^(.*?)(\.([^.]*))?$/;function n(I,h=!1){const b=I?t.exec(I):[];let k=[b&&b[1]||"",b&&b[3]||""];return h&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function o(I){const h=I?t.exec(I):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function c(I,h,b){const k=I.compare(h,b);return k!==0?k:h.length!==b.length?h.length<b.length?-1:1:0}function d(I){const h=I.charAt(0);return h.toLocaleUpperCase()!==h}function i(I){const h=I.charAt(0);return h.toLocaleLowerCase()!==h}function r(I,h){return d(I)&&i(h)?-1:i(I)&&d(h)?1:0}function u(I,h){return i(I)&&d(h)?-1:d(I)&&i(h)?1:0}function f(I,h,b=!1){return b||(I=I&&I.toLowerCase(),h=h&&h.toLowerCase()),I===h?0:I<h?-1:1}function v(I,h,b=!1){const k=I.split(T.sep),F=h.split(T.sep),W=k.length-1,J=F.length-1;let N,R;for(let L=0;;L++){if(N=W===L,R=J===L,N&&R)return $(k[L],F[L],b);if(N)return-1;if(R)return 1;const O=f(k[L],F[L],b);if(O!==0)return O}}e.$zq=v;function g(I,h,b){const k=I.toLowerCase(),F=h.toLowerCase(),W=D(I,h,b);if(W)return W;const J=k.endsWith(b),N=F.endsWith(b);if(J!==N)return J?-1:1;const R=$(k,F);return R!==0?R:k.localeCompare(F)}e.$Aq=g;function D(I,h,b){const k=I.toLowerCase(),F=h.toLowerCase(),W=k.startsWith(b),J=F.startsWith(b);if(W!==J)return W?-1:1;if(W&&J){if(k.length<F.length)return-1;if(k.length>F.length)return 1}return 0}e.$Bq=D}),define(Ae[46],Re([1,0,20,21,12,16]),function(we,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function P(g){return g===47||g===92}e.$Uf=P;function $(g){return g.replace(/[\\/]/g,E.$fc.sep)}e.$Vf=$;function m(g){return g.indexOf("/")===-1&&(g=$(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}e.$Wf=m;function y(g,D=E.$fc.sep){if(!g)return"";const I=g.length,h=g.charCodeAt(0);if(P(h)){if(P(g.charCodeAt(1))&&!P(g.charCodeAt(2))){let k=3;const F=k;for(;k<I&&!P(g.charCodeAt(k));k++);if(F!==k&&!P(g.charCodeAt(k+1))){for(k+=1;k<I;k++)if(P(g.charCodeAt(k)))return g.slice(0,k+1).replace(/[\\/]/g,D)}}return D}else if(t(h)&&g.charCodeAt(1)===58)return P(g.charCodeAt(2))?g.slice(0,2)+D:g.slice(0,2);let b=g.indexOf("://");if(b!==-1){for(b+=3;b<I;b++)if(P(g.charCodeAt(b)))return g.slice(0,b+1)}return""}e.$Xf=y;function A(g){if(!T.$i||!g||g.length<5)return!1;let D=g.charCodeAt(0);if(D!==92||(D=g.charCodeAt(1),D!==92))return!1;let I=2;const h=I;for(;I<g.length&&(D=g.charCodeAt(I),D!==92);I++);return!(h===I||(D=g.charCodeAt(I+1),isNaN(D)||D===92))}e.$Yf=A;const S=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(g,D=T.$i){const I=D?S:l;return!(!g||g.length===0||/^\s+$/.test(g)||(I.lastIndex=0,I.test(g))||D&&p.test(g)||g==="."||g===".."||D&&g[g.length-1]==="."||D&&g.length!==g.trim().length||g.length>255)}e.$Zf=w;function a(g,D,I){const h=g===D;return!I||h?h:!g||!D?!1:(0,C.$6e)(g,D)}e.$1f=a;function s(g,D,I,h=E.sep){if(g===D)return!0;if(!g||!D||D.length>g.length)return!1;if(I){if(!(0,C.$7e)(g,D))return!1;if(D.length===g.length)return!0;let k=D.length;return D.charAt(D.length-1)===h&&k--,g.charAt(k)===h}return D.charAt(D.length-1)!==h&&(D+=h),g.indexOf(D)===0}e.$2f=s;function t(g){return g>=65&&g<=90||g>=97&&g<=122}e.$3f=t;function n(g,D){return T.$i&&g.endsWith(":")&&(g+=E.sep),(0,E.$hc)(g)||(g=(0,E.$ic)(D,g)),g=(0,E.$gc)(g),T.$i?(g=(0,C.$Oe)(g,E.sep),g.endsWith(":")&&(g+=E.sep)):(g=(0,C.$Oe)(g,E.sep),g||(g=E.sep)),g}e.$4f=n;function o(g){const D=(0,E.$gc)(g);return T.$i?g.length>3?!1:c(D)&&(g.length===2||D.charCodeAt(2)===92):D===E.$fc.sep}e.$5f=o;function c(g,D=T.$i){return D?t(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}e.$6f=c;function d(g,D=T.$i){return c(g,D)?g[0]:void 0}e.$7f=d;function i(g,D,I){return D.length>g.length?-1:g===D?0:(I&&(g=g.toLowerCase(),D=D.toLowerCase()),g.indexOf(D))}e.$8f=i;function r(g){const D=g.split(":");let I,h,b;for(const k of D){const F=Number(k);(0,M.$Gf)(F)?h===void 0?h=F:b===void 0&&(b=F):I=I?[I,k].join(":"):k}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:h!==void 0?h:void 0,column:b!==void 0?b:h!==void 0?1:void 0}}e.$9f=r;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",f="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(g,D,I=8){let h="";for(let k=0;k<I;k++){let F;k===0&&T.$i&&!D&&(I===3||I===4)?F=f:F=u,h+=F.charAt(Math.floor(Math.random()*F.length))}let b;return D?b=`${D}-${h}`:b=h,g?(0,E.$ic)(g,b):b}e.$0f=v}),define(Ae[68],Re([1,0,20]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.$Zr=e.$Yr=e.$Xr=void 0,e.$Xr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(A){const S=(0,E.$nc)(A),l=T[S.toLowerCase()];return l!==void 0?l:P(A)}e.$Yr=M;function P(A){const S=(0,E.$nc)(A);return C[S.toLowerCase()]}e.$Zr=P;function $(A){for(const S in C)if(C[S]===A)return S}e.$1r=$;const m=/^(.+)\/(.+?)(;.+)?$/;function y(A,S){const l=m.exec(A);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:S?void 0:A}e.$2r=y}),define(Ae[51],Re([1,0,24,2]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uh=e.$th=e.$sh=void 0;function C(m){return JSON.stringify(m,P)}e.$sh=C;function M(m){let y=JSON.parse(m);return y=$(y),y}e.$th=M;function P(m,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function $(m,y=0){if(!m||y>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return T.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof E.$fe||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let A=0;A<m.length;++A)m[A]=$(m[A],y+1);else for(const A in m)Object.hasOwnProperty.call(m,A)&&(m[A]=$(m[A],y+1))}return m}e.$uh=$}),define(Ae[13],Re([1,0,11,21,12,2]),function(we,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var P;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(P||(e.Schemas=P={}));function $(l,p){return M.URI.isUri(l)?(0,C.$6e)(l.scheme,p):(0,C.$7e)(l,p+":")}e.$$f=$;function m(l,...p){return p.some(w=>$(l,w))}e.$_f=m,e.$ag="vscode-tkn",e.$bg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${P.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${P.vscodeRemoteResource}`}set(p,w,a){this.a[p]=w,this.b[p]=a}setConnectionToken(p,w){this.c[p]=w}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(o){return E.$Z(o),p}const w=p.authority;let a=this.a[w];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const s=this.b[w],t=this.c[w];let n=`path=${encodeURIComponent(p.path)}`;return typeof t=="string"&&(n+=`&${e.$bg}=${encodeURIComponent(t)}`),M.URI.from({scheme:T.$o?this.d:P.vscodeRemoteResource,authority:`${a}:${s}`,path:this.f,query:n})}}e.$cg=new y,e.$dg="vs/../../extensions",e.$eg="vs/../../node_modules",e.$fg="vs/../../node_modules.asar",e.$gg="vs/../../node_modules.asar.unpacked",e.$hg="vscode-app";class A{static{this.a=e.$hg}asBrowserUri(p){const w=this.b(p,we);return this.uriToBrowserUri(w)}uriToBrowserUri(p){return p.scheme===P.vscodeRemote?e.$cg.rewrite(p):p.scheme===P.file&&(T.$m||T.$q===`${P.vscodeFileResource}://${A.a}`)?p.with({scheme:P.vscodeFileResource,authority:p.authority||A.a,query:null,fragment:null}):p}asFileUri(p){const w=this.b(p,we);return this.uriToFileUri(w)}uriToFileUri(p){return p.scheme===P.vscodeFileResource?p.with({scheme:P.file,authority:p.authority!==A.a?p.authority:null,query:null,fragment:null}):p}b(p,w){return M.URI.isUri(p)?p:M.URI.parse(w.toUrl(p))}}e.$ig=new A;var S;(function(l){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(p.get("3"));const w="vscode-coi";function a(t){let n;typeof t=="string"?n=new URL(t).searchParams:t instanceof URL?n=t.searchParams:M.URI.isUri(t)&&(n=new URL(t.toString(!0)).searchParams);const o=n?.get(w);if(o)return p.get(o)}l.getHeadersFromQuery=a;function s(t,n,o){if(!globalThis.crossOriginIsolated)return;const c=n&&o?"3":o?"2":"1";t instanceof URLSearchParams?t.set(w,c):t[w]=c}l.addSearchParam=s})(S||(e.COI=S={}))}),define(Ae[25],Re([1,0,46,13,20,21,12,2]),function(we,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lg=e.DataUri=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=void 0;function m(p){return(0,$.$vc)(p,!0)}e.$pg=m;class y{constructor(w){this.a=w}compare(w,a,s=!1){return w===a?0:(0,P.$Ye)(this.getComparisonKey(w,s),this.getComparisonKey(a,s))}isEqual(w,a,s=!1){return w===a?!0:!w||!a?!1:this.getComparisonKey(w,s)===this.getComparisonKey(a,s)}getComparisonKey(w,a=!1){return w.with({path:this.a(w)?w.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(w){return this.a(w)}isEqualOrParent(w,a,s=!1){if(w.scheme===a.scheme){if(w.scheme===T.Schemas.file)return E.$2f(m(w),m(a),this.a(w))&&w.query===a.query&&(s||w.fragment===a.fragment);if((0,e.$Gg)(w.authority,a.authority))return E.$2f(w.path,a.path,this.a(w),"/")&&w.query===a.query&&(s||w.fragment===a.fragment)}return!1}joinPath(w,...a){return $.URI.joinPath(w,...a)}basenameOrAuthority(w){return(0,e.$yg)(w)||w.authority}basename(w){return C.$fc.basename(w.path)}extname(w){return C.$fc.extname(w.path)}dirname(w){if(w.path.length===0)return w;let a;return w.scheme===T.Schemas.file?a=$.URI.file(C.$lc(m(w))).path:(a=C.$fc.dirname(w.path),w.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),a="/")),w.with({path:a})}normalizePath(w){if(!w.path.length)return w;let a;return w.scheme===T.Schemas.file?a=$.URI.file(C.$gc(m(w))).path:a=C.$fc.normalize(w.path),w.with({path:a})}relativePath(w,a){if(w.scheme!==a.scheme||!(0,e.$Gg)(w.authority,a.authority))return;if(w.scheme===T.Schemas.file){const n=C.$kc(m(w),m(a));return M.$i?E.$Vf(n):n}let s=w.path||"/";const t=a.path||"/";if(this.a(w)){let n=0;for(const o=Math.min(s.length,t.length);n<o&&!(s.charCodeAt(n)!==t.charCodeAt(n)&&s.charAt(n).toLowerCase()!==t.charAt(n).toLowerCase());n++);s=t.substr(0,n)+s.substr(n)}return C.$fc.relative(s,t)}resolvePath(w,a){if(w.scheme===T.Schemas.file){const s=$.URI.file(C.$jc(m(w),a));return w.with({authority:s.authority,path:s.path})}return a=E.$Wf(a),w.with({path:C.$fc.resolve(w.path,a)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,a){return w===a||w!==void 0&&a!==void 0&&(0,P.$6e)(w,a)}hasTrailingPathSeparator(w,a=C.sep){if(w.scheme===T.Schemas.file){const s=m(w);return s.length>E.$Xf(s).length&&s[s.length-1]===a}else{const s=w.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,a=C.sep){return(0,e.$Hg)(w,a)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,a=C.sep){let s=!1;if(w.scheme===T.Schemas.file){const t=m(w);s=t!==void 0&&t.length===E.$Xf(t).length&&t[t.length-1]===a}else{a="/";const t=w.path;s=t.length===1&&t.charCodeAt(t.length-1)===47}return!s&&!(0,e.$Hg)(w,a)?w.with({path:w.path+"/"}):w}}e.$qg=y,e.$rg=new y(()=>!1),e.$sg=new y(p=>p.scheme===T.Schemas.file?!M.$k:!0),e.$tg=new y(p=>!0),e.$ug=e.$rg.isEqual.bind(e.$rg),e.$vg=e.$rg.isEqualOrParent.bind(e.$rg),e.$wg=e.$rg.getComparisonKey.bind(e.$rg),e.$xg=e.$rg.basenameOrAuthority.bind(e.$rg),e.$yg=e.$rg.basename.bind(e.$rg),e.$zg=e.$rg.extname.bind(e.$rg),e.$Ag=e.$rg.dirname.bind(e.$rg),e.$Bg=e.$rg.joinPath.bind(e.$rg),e.$Cg=e.$rg.normalizePath.bind(e.$rg),e.$Dg=e.$rg.relativePath.bind(e.$rg),e.$Eg=e.$rg.resolvePath.bind(e.$rg),e.$Fg=e.$rg.isAbsolutePath.bind(e.$rg),e.$Gg=e.$rg.isEqualAuthority.bind(e.$rg),e.$Hg=e.$rg.hasTrailingPathSeparator.bind(e.$rg),e.$Ig=e.$rg.removeTrailingPathSeparator.bind(e.$rg),e.$Jg=e.$rg.addTrailingPathSeparator.bind(e.$rg);function A(p,w){const a=[];for(let s=0;s<p.length;s++){const t=w(p[s]);p.some((n,o)=>o===s?!1:(0,e.$vg)(t,w(n)))||a.push(p[s])}return a}e.$Kg=A;var S;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function w(a){const s=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(o=>{const[c,d]=o.split(":");c&&d&&s.set(c,d)});const n=a.path.substring(0,a.path.indexOf(";"));return n&&s.set(p.META_DATA_MIME,n),s}p.parseMetaData=w})(S||(e.DataUri=S={}));function l(p,w,a){if(w){let s=p.path;return s&&s[0]!==C.$fc.sep&&(s=C.$fc.sep+s),p.with({scheme:a,authority:w,path:s})}return p.with({scheme:a})}e.$Lg=l}),define(Ae[14],Re([1,0,19,11,5,6,25,21,123]),function(we,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oh=e.$nh=e.$mh=e.$lh=e.Promises=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=void 0;function y(pe){return!!pe&&typeof pe.then=="function"}e.$Mg=y;function A(pe){const re=new E.$2d,le=pe(re.token),ce=new Promise((be,ee)=>{const fe=re.token.onCancellationRequested(()=>{fe.dispose(),re.dispose(),ee(new T.$4)});Promise.resolve(le).then(ie=>{fe.dispose(),re.dispose(),be(ie)},ie=>{fe.dispose(),re.dispose(),ee(ie)})});return new class{cancel(){re.cancel()}then(be,ee){return ce.then(be,ee)}catch(be){return this.then(void 0,be)}finally(be){return ce.finally(be)}}}e.$Ng=A;function S(pe,re,le){return new Promise((ce,be)=>{const ee=re.onCancellationRequested(()=>{ee.dispose(),ce(le)});pe.then(ce,be).finally(()=>ee.dispose())})}e.$Og=S;function l(pe,re){return new Promise((le,ce)=>{const be=re.onCancellationRequested(()=>{be.dispose(),ce(new T.$4)});pe.then(le,ce).finally(()=>be.dispose())})}e.$Pg=l;async function p(pe){let re=-1;const le=pe.map((ce,be)=>ce.then(ee=>(re=be,ee)));try{return await Promise.race(le)}finally{pe.forEach((ce,be)=>{be!==re&&ce.cancel()})}}e.$Qg=p;function w(pe,re,le){let ce;const be=setTimeout(()=>{ce?.(void 0),le?.()},re);return Promise.race([pe.finally(()=>clearTimeout(be)),new Promise(ee=>ce=ee)])}e.$Rg=w;function a(pe){return new Promise((re,le)=>{const ce=pe();y(ce)?ce.then(re,le):re(ce)})}e.$Sg=a;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(re){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=re,!this.b){const le=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(le,le).then(ce)})}return new Promise((le,ce)=>{this.b.then(le,ce)})}return this.a=re(),new Promise((le,ce)=>{this.a.then(be=>{this.a=null,le(be)},be=>{this.a=null,ce(be)})})}dispose(){this.f=!0}}e.$Tg=s;class t{constructor(){this.a=Promise.resolve(null)}queue(re){return this.a=this.a.then(()=>re(),()=>re())}}e.$Ug=t;class n{constructor(){this.a=new Map}queue(re,le){const be=(this.a.get(re)??Promise.resolve()).catch(()=>{}).then(le).finally(()=>{this.a.get(re)===be&&this.a.delete(re)});return this.a.set(re,be),be}}e.$Vg=n;const o=(pe,re)=>{let le=!0;const ce=setTimeout(()=>{le=!1,re()},pe);return{isTriggered:()=>le,dispose:()=>{clearTimeout(ce),le=!1}}},c=pe=>{let re=!0;return queueMicrotask(()=>{re&&(re=!1,pe())}),{isTriggered:()=>re,dispose:()=>{re=!1}}};class d{constructor(re){this.defaultDelay=re,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(re,le=this.defaultDelay){this.g=re,this.h(),this.b||(this.b=new Promise((be,ee)=>{this.d=be,this.f=ee}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=le===m.$Od?c(ce):o(le,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Wg=d;class i{constructor(re){this.a=new d(re),this.b=new s}trigger(re,le){return this.a.trigger(()=>this.b.queue(re),le)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Xg=i;class r{constructor(){this.a=!1,this.b=new Promise((re,le)=>{this.d=re})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Yg=r;class u extends r{constructor(re){super(),this.f=setTimeout(()=>this.open(),re)}open(){clearTimeout(this.f),super.open()}}e.$Zg=u;function f(pe,re){return re?new Promise((le,ce)=>{const be=setTimeout(()=>{ee.dispose(),le()},pe),ee=re.onCancellationRequested(()=>{clearTimeout(be),ee.dispose(),ce(new T.$4)})}):A(le=>f(pe,le))}e.$1g=f;function v(pe,re=0,le){const ce=setTimeout(()=>{pe(),le&&be.dispose()},re),be=(0,M.$Pc)(()=>{clearTimeout(ce),le?.deleteAndLeak(be)});return le?.add(be),be}e.$2g=v;function g(pe){const re=[];let le=0;const ce=pe.length;function be(){return le<ce?pe[le++]():null}function ee(fe){fe!=null&&re.push(fe);const ie=be();return ie?ie.then(ee):Promise.resolve(re)}return Promise.resolve(null).then(ee)}e.$3g=g;function D(pe,re=ce=>!!ce,le=null){let ce=0;const be=pe.length,ee=()=>{if(ce>=be)return Promise.resolve(le);const fe=pe[ce++];return Promise.resolve(fe()).then(ae=>re(ae)?Promise.resolve(ae):ee())};return ee()}e.$4g=D;function I(pe,re=ce=>!!ce,le=null){if(pe.length===0)return Promise.resolve(le);let ce=pe.length;const be=()=>{ce=-1;for(const ee of pe)ee.cancel?.()};return new Promise((ee,fe)=>{for(const ie of pe)ie.then(ae=>{--ce>=0&&re(ae)?(be(),ee(ae)):ce===0&&ee(le)}).catch(ae=>{--ce>=0&&(be(),fe(ae))})})}e.$5g=I;class h{constructor(re){this.a=0,this.d=re,this.f=[],this.b=0,this.g=new C.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(re){return this.a++,new Promise((le,ce)=>{this.f.push({factory:re,c:le,e:ce}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const re=this.f.shift();this.b++;const le=re.factory();le.then(re.c,re.e),le.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$6g=h;class b extends h{constructor(){super(1)}}e.$7g=b;class k{constructor(){this.a=new De,this.b=0}queue(re){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,re())):this.a.run(this.b++,re())}}e.$8g=k;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const re=new Ee;return this.b.add(re),re.p}g(){for(const[,re]of this.a)if(re.size>0)return!1;return!0}queueFor(re,le=P.$rg){const ce=le.getComparisonKey(re);let be=this.a.get(ce);if(!be){be=new b;const ee=this.f++,fe=C.Event.once(be.onDrained)(()=>{be?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose(ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$1c),this.d.set(ee,fe),this.a.set(ce,be)}return be}h(){this.g()&&this.j()}j(){for(const re of this.b)re.complete();this.b.clear()}dispose(){for(const[,re]of this.a)re.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$9g=F;class W{constructor(re,le){this.a=-1,typeof re=="function"&&typeof le=="number"&&this.setIfNotSet(re,le)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(re,le){this.cancel(),this.a=setTimeout(()=>{this.a=-1,re()},le)}setIfNotSet(re,le){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,re()},le))}}e.$0g=W;class J{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(re,le,ce=globalThis){this.cancel();const be=ce.setInterval(()=>{re()},le);this.d=(0,M.$Pc)(()=>{ce.clearInterval(be),this.d=void 0})}dispose(){this.cancel()}}e.$$g=J;class N{constructor(re,le){this.b=-1,this.a=re,this.d=le,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(re=this.d){this.cancel(),this.b=setTimeout(this.f,re)}get delay(){return this.d}set delay(re){this.d=re}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$_g=N;class R{constructor(re,le){le%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.a=re,this.b=le,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(re=this.b){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(re/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ah=R;class L extends N{constructor(re,le){super(re,le),this.j=[]}work(re){this.j.push(re),this.isScheduled()||this.schedule()}h(){const re=this.j;this.j=[],this.a?.(re)}dispose(){this.j=[],super.dispose()}}e.$bh=L;class O extends M.$Rc{constructor(re,le){super(),this.g=re,this.h=le,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(re){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+re.length>this.g.maxBufferedWork)return!1}else if(this.pending+re.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const le of re)this.a.push(le);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new N(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ch=O,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$eh=(pe,re)=>{(0,$.$B)(()=>{if(le)return;const ce=Date.now()+15;re(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let le=!1;return{dispose(){le||(le=!0)}}}:e.$eh=(pe,re,le)=>{const ce=pe.requestIdleCallback(re,typeof le=="number"?{timeout:le}:void 0);let be=!1;return{dispose(){be||(be=!0,pe.cancelIdleCallback(ce))}}},e.$dh=pe=>(0,e.$eh)(globalThis,pe)}();class X{constructor(re,le){this.g=!1,this.d=()=>{try{this.j=le()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$eh)(re,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$fh=X;class he extends X{constructor(re){super(globalThis,re)}}e.$gh=he;async function $e(pe,re,le){let ce;for(let be=0;be<le;be++)try{return await pe()}catch(ee){ce=ee,await f(re)}throw ce}e.$hh=$e;class De{isRunning(re){return typeof re=="number"?this.a?.taskId===re:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(re,le,ce){return this.a={taskId:re,cancel:()=>ce?.(),promise:le},le.then(()=>this.d(re),()=>this.d(re)),le}d(re){this.a&&re===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const re=this.b;this.b=void 0,re.run().then(re.promiseResolve,re.promiseReject)}}queue(re){if(this.b)this.b.run=re;else{let le,ce;const be=new Promise((ee,fe)=>{le=ee,ce=fe});this.b={run:re,promise:be,promiseResolve:le,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ih=De;class ke{constructor(re,le=()=>Date.now()){this.d=re,this.f=le,this.a=0,this.b=0}increment(){const re=this.f();return re-this.a>this.d&&(this.a=re,this.b=0),this.b++,this.b}}e.$jh=ke;var de;(function(pe){pe[pe.Resolved=0]="Resolved",pe[pe.Rejected=1]="Rejected"})(de||(de={}));class Ee{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((re,le)=>{this.a=re,this.b=le})}complete(re){return new Promise(le=>{this.a(re),this.d={outcome:0,value:re},le()})}error(re){return new Promise(le=>{this.b(re),this.d={outcome:1,value:re},le()})}cancel(){return this.error(new T.$4)}}e.$kh=Ee;var _;(function(pe){async function re(ce){let be;const ee=await Promise.all(ce.map(fe=>fe.then(ie=>ie,ie=>{be||(be=ie)})));if(typeof be<"u")throw be;return ee}pe.settled=re;function le(ce){return new Promise(async(be,ee)=>{try{await ce(be,ee)}catch(fe){ee(fe)}})}pe.withAsyncBody=le})(_||(e.Promises=_={}));var Ce;(function(pe){pe[pe.Initial=0]="Initial",pe[pe.DoneOK=1]="DoneOK",pe[pe.DoneError=2]="DoneError"})(Ce||(Ce={}));class se{static fromArray(re){return new se(le=>{le.emitMany(re)})}static fromPromise(re){return new se(async le=>{le.emitMany(await re)})}static fromPromises(re){return new se(async le=>{await Promise.all(re.map(async ce=>le.emitOne(await ce)))})}static merge(re){return new se(async le=>{await Promise.all(re.map(async ce=>{for await(const be of ce)le.emitOne(be)}))})}static{this.EMPTY=se.fromArray([])}constructor(re){this.a=0,this.b=[],this.d=null,this.f=new C.$Rd,queueMicrotask(async()=>{const le={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(re(le)),this.j()}catch(ce){this.k(ce)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let re=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(re<this.b.length)return{done:!1,value:this.b[re++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(re,le){return new se(async ce=>{for await(const be of re)ce.emitOne(le(be))})}map(re){return se.map(this,re)}static filter(re,le){return new se(async ce=>{for await(const be of re)le(be)&&ce.emitOne(be)})}filter(re){return se.filter(this,re)}static coalesce(re){return se.filter(re,le=>!!le)}coalesce(){return se.coalesce(this)}static async toPromise(re){const le=[];for await(const ce of re)le.push(ce);return le}toPromise(){return se.toPromise(this)}g(re){this.a===0&&(this.b.push(re),this.f.fire())}h(re){this.a===0&&(this.b=this.b.concat(re),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(re){this.a===0&&(this.a=2,this.d=re,this.f.fire())}}e.$lh=se;class Q extends se{constructor(re,le){super(le),this.l=re}cancel(){this.l.cancel()}}e.$mh=Q;function U(pe){const re=new E.$2d,le=pe(re.token);return new Q(re,async ce=>{const be=re.token.onCancellationRequested(()=>{be.dispose(),re.dispose(),ce.reject(new T.$4)});try{for await(const ee of le){if(re.token.isCancellationRequested)return;ce.emitOne(ee)}be.dispose(),re.dispose()}catch(ee){be.dispose(),re.dispose(),ce.reject(ee)}})}e.$nh=U;class ne{constructor(){this.a=new Ee,this.b=new se(ce=>{if(re){ce.reject(re);return}return le&&ce.emitMany(le),this.d=be=>ce.reject(be),this.f=be=>ce.emitOne(be),this.a.p});let re,le;this.f=ce=>{le||(le=[]),le.push(ce)},this.d=ce=>{re||(re=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(re){this.d(re),this.a.complete()}emitOne(re){this.f(re)}}e.$oh=ne}),define(Ae[34],Re([1,0,18,14,46,28,20,21,12]),function(we,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=void 0;function y(){return Object.create(null)}e.$zj=y,e.$Aj="**",e.$Bj="/";const A="[/\\\\]",S="[^/\\\\]",l=/\//g;function p($e,De){switch($e){case 0:return"";case 1:return`${S}*?`;default:return`(?:${A}|${S}+${A}${De?`|${A}${S}+`:""})*?`}}function w($e,De){if(!$e)return[];const ke=[];let de=!1,Ee=!1,_="";for(const Ce of $e){switch(Ce){case De:if(!de&&!Ee){ke.push(_),_="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":Ee=!0;break;case"]":Ee=!1;break}_+=Ce}return _&&ke.push(_),ke}e.$Cj=w;function a($e){if(!$e)return"";let De="";const ke=w($e,e.$Bj);if(ke.every(de=>de===e.$Aj))De=".*";else{let de=!1;ke.forEach((Ee,_)=>{if(Ee===e.$Aj){if(de)return;De+=p(2,_===ke.length-1)}else{let Ce=!1,se="",Q=!1,U="";for(const ne of Ee){if(ne!=="}"&&Ce){se+=ne;continue}if(Q&&(ne!=="]"||!U)){let pe;ne==="-"?pe=ne:(ne==="^"||ne==="!")&&!U?pe="^":ne===e.$Bj?pe="":pe=(0,m.$Je)(ne),U+=pe;continue}switch(ne){case"{":Ce=!0;continue;case"[":Q=!0;continue;case"}":{const re=`(?:${w(se,",").map(le=>a(le)).join("|")})`;De+=re,Ce=!1,se="";break}case"]":{De+="["+U+"]",Q=!1,U="";break}case"?":De+=S;continue;case"*":De+=p(1);continue;default:De+=(0,m.$Je)(ne)}}_<ke.length-1&&(ke[_+1]!==e.$Aj||_+2<ke.length)&&(De+=A)}de=Ee===e.$Aj})}return De}const s=/^\*\*\/\*\.[\w\.-]+$/,t=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.$Cc(1e4),r=function(){return!1},u=function(){return null};function f($e,De){if(!$e)return u;let ke;typeof $e!="string"?ke=$e.pattern:ke=$e,ke=ke.trim();const de=`${ke}_${!!De.trimForExclusions}`;let Ee=i.get(de);if(Ee)return v(Ee,$e);let _;return s.test(ke)?Ee=D(ke.substr(4),ke):(_=t.exec(g(ke,De)))?Ee=I(_[1],ke):(De.trimForExclusions?o:n).test(ke)?Ee=h(ke,De):(_=c.exec(g(ke,De)))?Ee=b(_[1].substr(1),ke,!0):(_=d.exec(g(ke,De)))?Ee=b(_[1],ke,!1):Ee=k(ke),i.set(de,Ee),v(Ee,$e)}function v($e,De){if(typeof De=="string")return $e;const ke=function(de,Ee){return(0,C.$2f)(de,De.base,!$.$k)?$e((0,m.$Ne)(de.substr(De.base.length),P.sep),Ee):null};return ke.allBasenames=$e.allBasenames,ke.allPaths=$e.allPaths,ke.basenames=$e.basenames,ke.patterns=$e.patterns,ke}function g($e,De){return De.trimForExclusions&&$e.endsWith("/**")?$e.substr(0,$e.length-2):$e}function D($e,De){return function(ke,de){return typeof ke=="string"&&ke.endsWith($e)?De:null}}function I($e,De){const ke=`/${$e}`,de=`\\${$e}`,Ee=function(Ce,se){return typeof Ce!="string"?null:se?se===$e?De:null:Ce===$e||Ce.endsWith(ke)||Ce.endsWith(de)?De:null},_=[$e];return Ee.basenames=_,Ee.patterns=[De],Ee.allBasenames=_,Ee}function h($e,De){const ke=X($e.slice(1,-1).split(",").map(se=>f(se,De)).filter(se=>se!==u),$e),de=ke.length;if(!de)return u;if(de===1)return ke[0];const Ee=function(se,Q){for(let U=0,ne=ke.length;U<ne;U++)if(ke[U](se,Q))return $e;return null},_=ke.find(se=>!!se.allBasenames);_&&(Ee.allBasenames=_.allBasenames);const Ce=ke.reduce((se,Q)=>Q.allPaths?se.concat(Q.allPaths):se,[]);return Ce.length&&(Ee.allPaths=Ce),Ee}function b($e,De,ke){const de=P.sep===P.$fc.sep,Ee=de?$e:$e.replace(l,P.sep),_=P.sep+Ee,Ce=P.$fc.sep+$e;let se;return ke?se=function(Q,U){return typeof Q=="string"&&(Q===Ee||Q.endsWith(_)||!de&&(Q===$e||Q.endsWith(Ce)))?De:null}:se=function(Q,U){return typeof Q=="string"&&(Q===Ee||!de&&Q===$e)?De:null},se.allPaths=[(ke?"*/":"./")+$e],se}function k($e){try{const De=new RegExp(`^${a($e)}$`);return function(ke){return De.lastIndex=0,typeof ke=="string"&&De.test(ke)?$e:null}}catch{return u}}function F($e,De,ke){return!$e||typeof De!="string"?!1:W($e)(De,void 0,ke)}e.$Dj=F;function W($e,De={}){if(!$e)return r;if(typeof $e=="string"||J($e)){const ke=f($e,De);if(ke===u)return r;const de=function(Ee,_){return!!ke(Ee,_)};return ke.allBasenames&&(de.allBasenames=ke.allBasenames),ke.allPaths&&(de.allPaths=ke.allPaths),de}return L($e,De)}e.$Ej=W;function J($e){const De=$e;return De?typeof De.base=="string"&&typeof De.pattern=="string":!1}e.$Fj=J;function N($e){return $e.allBasenames||[]}e.$Gj=N;function R($e){return $e.allPaths||[]}e.$Hj=R;function L($e,De){const ke=X(Object.getOwnPropertyNames($e).map(se=>O(se,$e[se],De)).filter(se=>se!==u)),de=ke.length;if(!de)return u;if(!ke.some(se=>!!se.requiresSiblings)){if(de===1)return ke[0];const se=function(ne,pe){let re;for(let le=0,ce=ke.length;le<ce;le++){const be=ke[le](ne,pe);if(typeof be=="string")return be;(0,T.$Mg)(be)&&(re||(re=[]),re.push(be))}return re?(async()=>{for(const le of re){const ce=await le;if(typeof ce=="string")return ce}return null})():null},Q=ke.find(ne=>!!ne.allBasenames);Q&&(se.allBasenames=Q.allBasenames);const U=ke.reduce((ne,pe)=>pe.allPaths?ne.concat(pe.allPaths):ne,[]);return U.length&&(se.allPaths=U),se}const Ee=function(se,Q,U){let ne,pe;for(let re=0,le=ke.length;re<le;re++){const ce=ke[re];ce.requiresSiblings&&U&&(Q||(Q=(0,P.$mc)(se)),ne||(ne=Q.substr(0,Q.length-(0,P.$nc)(se).length)));const be=ce(se,Q,ne,U);if(typeof be=="string")return be;(0,T.$Mg)(be)&&(pe||(pe=[]),pe.push(be))}return pe?(async()=>{for(const re of pe){const le=await re;if(typeof le=="string")return le}return null})():null},_=ke.find(se=>!!se.allBasenames);_&&(Ee.allBasenames=_.allBasenames);const Ce=ke.reduce((se,Q)=>Q.allPaths?se.concat(Q.allPaths):se,[]);return Ce.length&&(Ee.allPaths=Ce),Ee}function O($e,De,ke){if(De===!1)return u;const de=f($e,ke);if(de===u)return u;if(typeof De=="boolean")return de;if(De){const Ee=De.when;if(typeof Ee=="string"){const _=(Ce,se,Q,U)=>{if(!U||!de(Ce,se))return null;const ne=Ee.replace("$(basename)",()=>Q),pe=U(ne);return(0,T.$Mg)(pe)?pe.then(re=>re?$e:null):pe?$e:null};return _.requiresSiblings=!0,_}}return de}function X($e,De){const ke=$e.filter(se=>!!se.basenames);if(ke.length<2)return $e;const de=ke.reduce((se,Q)=>{const U=Q.basenames;return U?se.concat(U):se},[]);let Ee;if(De){Ee=[];for(let se=0,Q=de.length;se<Q;se++)Ee.push(De)}else Ee=ke.reduce((se,Q)=>{const U=Q.patterns;return U?se.concat(U):se},[]);const _=function(se,Q){if(typeof se!="string")return null;if(!Q){let ne;for(ne=se.length;ne>0;ne--){const pe=se.charCodeAt(ne-1);if(pe===47||pe===92)break}Q=se.substr(ne)}const U=de.indexOf(Q);return U!==-1?Ee[U]:null};_.basenames=de,_.patterns=Ee,_.allBasenames=de;const Ce=$e.filter(se=>!se.basenames);return Ce.push(_),Ce}function he($e,De){return(0,E.$tb)($e,De,(ke,de)=>typeof ke=="string"&&typeof de=="string"?ke===de:typeof ke!="string"&&typeof de!="string"?ke.base===de.base&&ke.pattern===de.pattern:!1)}e.$Ij=he}),define(Ae[52],Re([1,0,11,124,25,12,2]),function(we,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class m{constructor(t="",n=!1){if(this.value=t,typeof this.value!="string")throw(0,E.$6)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(t,n=0){return this.value+=l(this.supportThemeIcons?(0,T.$5j)(t):t).replace(/([ \t]+)/g,(o,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(t){return this.value+=t,this}appendCodeblock(t,n){return this.value+="\n```",this.value+=t,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(t,n,o){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(t),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(t,n){const o=new RegExp((0,M.$Je)(n),"g");return t.replace(o,(c,d)=>t.charAt(d-1)!=="\\"?`\\${c}`:c)}}e.$$j=m;function y(s){return A(s)?!s.value:Array.isArray(s)?s.every(y):!0}e.$_j=y;function A(s){return s instanceof m?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.$ak=A;function S(s,t){return s===t?!0:!s||!t?!1:s.value===t.value&&s.isTrusted===t.isTrusted&&s.supportThemeIcons===t.supportThemeIcons&&s.supportHtml===t.supportHtml&&(s.baseUri===t.baseUri||!!s.baseUri&&!!t.baseUri&&(0,C.$ug)(P.URI.from(s.baseUri),P.URI.from(t.baseUri)))}e.$bk=S;function l(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$ck=l;function p(s){return s.replace(/"/g,"&quot;")}e.$dk=p;function w(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ek=w;function a(s){const t=[],n=s.split("|").map(c=>c.trim());s=n[0];const o=n[1];if(o){const c=/height=(\d+)/.exec(o),d=/width=(\d+)/.exec(o),i=c?c[1]:"",r=d?d[1]:"",u=isFinite(parseInt(r)),f=isFinite(parseInt(i));u&&t.push(`width="${r}"`),f&&t.push(`height="${i}"`)}return{href:s,dimensions:t}}e.$fk=a}),define(Ae[94],Re([1,0,18,46,20,21,25,12]),function(we,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=void 0;function m(f,v){const{os:g,tildify:D,relative:I}=v;if(I){const k=y(f,I,g);if(typeof k=="string")return k}let h=f.fsPath;if(g===1&&!M.$i?h=h.replace(/\//g,"\\"):g!==1&&M.$i&&(h=h.replace(/\\/g,"/")),g!==1&&D?.userHome){const k=D.userHome.fsPath;let F;f.scheme!==D.userHome.scheme&&f.path[0]===C.$fc.sep&&f.path[1]!==C.$fc.sep?F=D.userHome.with({path:f.path}).fsPath:F=h,h=l(F,k,g)}return(g===1?C.$ec:C.$fc).normalize(A(h,g===1))}e.$Av=m;function y(f,v,g){const D=g===1?C.$ec:C.$fc,I=g===3?P.$rg:P.$tg,h=v.getWorkspace(),b=(0,E.$Nb)(h.folders);if(!b)return;f.scheme!==b.uri.scheme&&f.path[0]===C.$fc.sep&&f.path[1]!==C.$fc.sep&&(f=b.uri.with({path:f.path}));const k=v.getWorkspaceFolder(f);if(!k)return;let F;if(I.isEqual(k.uri,f)?F="":F=I.relativePath(k.uri,f)??"",F&&(F=D.normalize(F)),h.folders.length>1&&!v.noPrefix){const W=k.name?k.name:I.basenameOrAuthority(k.uri);F=F?`${W} \u2022 ${F}`:W}return F}function A(f,v=M.$i){return(0,T.$6f)(f,v)?f.charAt(0).toUpperCase()+f.slice(1):f}e.$Bv=A;let S=Object.create(null);function l(f,v,g=M.OS){if(g===1||!f||!v)return f;let D=S.original===v?S.normalized:void 0;D||(D=v,M.$i&&(D=(0,T.$Vf)(D)),D=`${(0,$.$Oe)(D,C.$fc.sep)}${C.$fc.sep}`,S={original:v,normalized:D});let I=f;return M.$i&&(I=(0,T.$Vf)(I)),(g===3?I.startsWith(D):(0,$.$7e)(I,D))?`~/${I.substr(D.length)}`:f}e.$Cv=l;function p(f,v){return f.replace(/^~($|\/|\\)/,`${v}$1`)}e.$Dv=p;const w="\u2026",a="\\\\",s="~";function t(f,v=C.sep){const g=new Array(f.length);let D=!1;for(let I=0;I<f.length;I++){const h=f[I];if(h===""){g[I]=`.${v}`;continue}if(!h){g[I]=h;continue}D=!0;let b="",k=h;k.indexOf(a)===0?(b=k.substr(0,k.indexOf(a)+a.length),k=k.substr(k.indexOf(a)+a.length)):k.indexOf(v)===0?(b=k.substr(0,k.indexOf(v)+v.length),k=k.substr(k.indexOf(v)+v.length)):k.indexOf(s)===0&&(b=k.substr(0,k.indexOf(s)+s.length),k=k.substr(k.indexOf(s)+s.length));const F=k.split(v);for(let W=1;D&&W<=F.length;W++)for(let J=F.length-W;D&&J>=0;J--){D=!1;let N=F.slice(J,J+W).join(v);for(let R=0;!D&&R<f.length;R++)if(R!==I&&f[R]&&f[R].indexOf(N)>-1){const L=J+W===F.length,O=J>0&&f[R].indexOf(v)>-1?v+N:N,X=f[R].endsWith(O);D=!L||X}if(!D){let R="";(F[0].endsWith(":")||b!=="")&&(J===1&&(J=0,W++,N=F[0]+v+N),J>0&&(R=F[0]+v),R=b+R),J>0&&(R=R+w+v),R=R+N,J+W<F.length&&(R=R+v+w),g[I]=R}}D&&(g[I]=h)}return g}e.$Ev=t;var n;(function(f){f[f.TEXT=0]="TEXT",f[f.VARIABLE=1]="VARIABLE",f[f.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function o(f,v=Object.create(null)){const g=[];let D=!1,I="";for(const h of f)if(h==="$"||D&&h==="{")I&&g.push({value:I,type:n.TEXT}),I="",D=!0;else if(h==="}"&&D){const b=v[I];if(typeof b=="string")b.length&&g.push({value:b,type:n.VARIABLE});else if(b){const k=g[g.length-1];(!k||k.type!==n.SEPARATOR)&&g.push({value:b.label,type:n.SEPARATOR})}I="",D=!1}else I+=h;return I&&!D&&g.push({value:I,type:n.TEXT}),g.filter((h,b)=>{if(h.type===n.SEPARATOR){const k=g[b-1],F=g[b+1];return[k,F].every(W=>W&&(W.type===n.VARIABLE||W.type===n.TEXT)&&W.value.length>0)}return!0}).map(h=>h.value).join("")}e.$Fv=o;function c(f,v){return M.$j||v?f.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):f.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.$Gv=c;function d(f,v){return M.$j||v?f.replace(/\(&&\w\)|&&/g,""):M.$i?f.replace(/&&|&/g,g=>g==="&"?"&&":"&"):f.replace(/&&/g,"_")}e.$Hv=d;function i(f){return f.replace(/&/g,"&&")}e.$Iv=i;function r(f){if(f.endsWith("]")){const v=f.lastIndexOf(" [",f.length-2);if(v!==-1){const g=u(f.substring(0,v));return{name:g.name,parentPath:g.parentPath+f.substring(v)}}}return u(f)}e.$Jv=r;function u(f){const v=f.indexOf("/")!==-1?C.$fc:C.$ec,g=v.basename(f),D=v.dirname(f);return g.length?{name:g,parentPath:D}:{name:D,parentPath:""}}}),define(Ae[138],Re([1,0,24,2]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=void 0;function C(S){return S.toJSON()}class M{constructor(l){this.a=l}transformIncoming(l){const p=this.a.transformIncoming(l);return p===l?l:C(T.URI.from(p))}transformOutgoing(l){const p=this.a.transformOutgoing(l);return p===l?l:C(T.URI.from(p))}transformOutgoingURI(l){const p=this.a.transformOutgoing(l);return p===l?l:T.URI.from(p)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$Tm=M,e.$Um=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function P(S,l,p){if(!S||p>200)return null;if(typeof S=="object"){if(S instanceof T.URI)return l.transformOutgoing(S);for(const w in S)if(Object.hasOwnProperty.call(S,w)){const a=P(S[w],l,p+1);a!==null&&(S[w]=a)}}return null}function $(S,l){const p=P(S,l,0);return p===null?S:p}e.$Vm=$;function m(S,l,p,w){if(!S||w>200)return null;if(typeof S=="object"){if(S.$mid===1)return p?T.URI.revive(l.transformIncoming(S)):l.transformIncoming(S);if(S instanceof E.$fe)return null;for(const a in S)if(Object.hasOwnProperty.call(S,a)){const s=m(S[a],l,p,w+1);s!==null&&(S[a]=s)}}return null}function y(S,l){const p=m(S,l,!1,0);return p===null?S:p}e.$Wm=y;function A(S,l){const p=m(S,l,!0,0);return p===null?S:p}e.$Xm=A}),define(Ae[139],Re([1,0,12,21,24]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.$Us=e.$Ts=void 0;let M;function P(){return M||(M=new TextDecoder("UTF-16LE")),M}let $;function m(){return $||($=new TextDecoder("UTF-16BE")),$}let y;function A(){return y||(y=T.$D()?P():m()),y}e.$Ts=A;function S(w,a,s){const t=new Uint16Array(w.buffer,a,s);return s>0&&(t[0]===65279||t[0]===65534)?l(w,a,s):P().decode(t)}e.$Us=S;function l(w,a,s){const t=[];let n=0;for(let o=0;o<s;o++){const c=C.$he(w,a);a+=2,t[n++]=String.fromCharCode(c)}return t.join("")}class p{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return A().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const s=this.a-this.d;s<=1&&(s===0||E.$0e(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const s=a.length;if(this.d+s>=this.a){this.f(),this.c[this.c.length]=a;return}for(let t=0;t<s;t++)this.b[this.d++]=a.charCodeAt(t)}}e.$Vs=p}),define(Ae[140],Re([1,0,24,139]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=void 0;function C(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,A,S,l){this.oldPosition=y,this.oldText=A,this.newPosition=S,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,A,S){const l=A.length;E.$ke(y,l,S),S+=4;for(let p=0;p<l;p++)E.$ie(y,A.charCodeAt(p),S),S+=2;return S}static d(y,A){const S=E.$je(y,A);return A+=4,(0,T.$Us)(y,A,S)}writeSize(){return 4+4+M.a(this.oldText)+M.a(this.newText)}write(y,A){return E.$ke(y,this.oldPosition,A),A+=4,E.$ke(y,this.newPosition,A),A+=4,A=M.c(y,this.oldText,A),A=M.c(y,this.newText,A),A}static read(y,A,S){const l=E.$je(y,A);A+=4;const p=E.$je(y,A);A+=4;const w=M.d(y,A);A+=M.a(w);const a=M.d(y,A);return A+=M.a(a),S.push(new M(l,w,p,a)),A}}e.$Ws=M;function P(m,y){return m===null||m.length===0?y:new $(m,y).compress()}e.$Xs=P;class ${constructor(y,A){this.a=y,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,A=0,S=this.n(y),l=this.l(A);for(;y<this.f||A<this.h;){if(S===null){this.k(l),l=this.l(++A);continue}if(l===null){this.m(S),S=this.n(++y);continue}if(l.oldEnd<=S.newPosition){this.k(l),l=this.l(++A);continue}if(S.newEnd<=l.oldPosition){this.m(S),S=this.n(++y);continue}if(l.oldPosition<S.newPosition){const[t,n]=$.r(l,S.newPosition-l.oldPosition);this.k(t),l=n;continue}if(S.newPosition<l.oldPosition){const[t,n]=$.q(S,l.oldPosition-S.newPosition);this.m(t),S=n;continue}let a,s;if(l.oldEnd===S.newEnd)a=S,s=l,S=this.n(++y),l=this.l(++A);else if(l.oldEnd<S.newEnd){const[t,n]=$.q(S,l.oldLength);a=t,s=l,S=n,l=this.l(++A)}else{const[t,n]=$.r(l,S.newLength);a=S,s=t,S=this.n(++y),l=n}this.d[this.e++]=new M(a.oldPosition,a.oldText,s.newPosition,s.newText),this.g+=a.newLength-a.oldLength,this.j+=s.newLength-s.oldLength}const p=$.s(this.d);return $.t(p)}k(y){this.d[this.e++]=$.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=$.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,A){return new M(A.oldPosition-y,A.oldText,A.newPosition,A.newText)}static p(y,A){return new M(A.oldPosition,A.oldText,A.newPosition+y,A.newText)}static q(y,A){const S=y.newText.substr(0,A),l=y.newText.substr(A);return[new M(y.oldPosition,y.oldText,y.newPosition,S),new M(y.oldEnd,"",y.newPosition+A,l)]}static r(y,A){const S=y.oldText.substr(0,A),l=y.oldText.substr(A);return[new M(y.oldPosition,S,y.newPosition,y.newText),new M(y.oldPosition+A,l,y.newEnd,"")]}static s(y){if(y.length===0)return y;const A=[];let S=0,l=y[0];for(let p=1;p<y.length;p++){const w=y[p];l.oldEnd===w.oldPosition?l=new M(l.oldPosition,l.oldText+w.oldText,l.newPosition,l.newText+w.newText):(A[S++]=l,l=w)}return A[S++]=l,A}static t(y){if(y.length===0)return y;const A=[];let S=0;for(let l=0;l<y.length;l++){const p=y[l];p.oldText!==p.newText&&(A[S++]=p)}return A}}}),define(Ae[141],Re([1,0,34,20]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NE=void 0;function C(M,P,$,m,y,A){if(Array.isArray(M)){let S=0;for(const l of M){const p=C(l,P,$,m,y,A);if(p===10)return p;p>S&&(S=p)}return S}else{if(typeof M=="string")return m?M==="*"?5:M===$?10:0:0;if(M){const{language:S,pattern:l,scheme:p,hasAccessToAllModels:w,notebookType:a}=M;if(!m&&!w)return 0;a&&y&&(P=y);let s=0;if(p)if(p===P.scheme)s=10;else if(p==="*")s=5;else return 0;if(S)if(S===$)s=10;else if(S==="*")s=Math.max(s,5);else return 0;if(a)if(a===A)s=10;else if(a==="*"&&A!==void 0)s=Math.max(s,5);else return 0;if(l){let t;if(typeof l=="string"?t=l:t={...l,base:(0,T.$gc)(l.base)},t===P.fsPath||(0,E.$Dj)(t,P.fsPath))s=10;else return 0}return s}else return 0}}e.$NE=C}),define(Ae[142],Re([1,0,5,12,29,92,91,126,140,6]),function(we,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OB=void 0;class A extends y.$Rc{constructor(l,p,w,a,s,t,n){super(),this.m=this.B(new E.$Rd),this.onDidChangeContent=this.m.event,this.f=p,this.j=!t,this.g=a,this.h=s,this.c=new P.$NB(l,w,n)}equals(l){return!(l instanceof A)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,p){return this.c.getOffsetAt(l,p)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,p){const w=l+p,a=this.getPositionAt(l),s=this.getPositionAt(w);return new C.$Bs(a.lineNumber,a.column,s.lineNumber,s.column)}getValueInRange(l,p=0){if(l.isEmpty())return"";const w=this.n(p);return this.c.getValueInRange(l,w)}getValueLengthInRange(l,p=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const w=this.getOffsetAt(l.startLineNumber,l.startColumn),a=this.getOffsetAt(l.endLineNumber,l.endColumn);let s=0;const t=this.n(p),n=this.getEOL();if(t.length!==n.length){const o=t.length-n.length,c=l.endLineNumber-l.startLineNumber;s=o*c}return a-w+s}getCharacterCountInRange(l,p=0){if(this.j){let w=0;const a=l.startLineNumber,s=l.endLineNumber;for(let t=a;t<=s;t++){const n=this.getLineContent(t),o=t===a?l.startColumn-1:0,c=t===s?l.endColumn-1:n.length;for(let d=o;d<c;d++)T.$0e(n.charCodeAt(d))?(w=w+1,d=d+1):w=w+1}return w+=this.n(p).length*(s-a),w}return this.getValueLengthInRange(l,p)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,p){return this.c.getLineCharCode(l,p)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const p=T.$Ue(this.getLineContent(l));return p===-1?0:p+1}getLineLastNonWhitespaceColumn(l){const p=T.$We(this.getLineContent(l));return p===-1?0:p+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,p,w){let a=this.g,s=this.h,t=this.j,n=!0,o=[];for(let v=0;v<l.length;v++){const g=l[v];n&&g._isTracked&&(n=!1);const D=g.range;if(g.text){let F=!0;t||(F=!T.$if(g.text),t=F),!a&&F&&(a=T.$hf(g.text)),!s&&F&&(s=T.$kf(g.text))}let I="",h=0,b=0,k=0;if(g.text){let F;[h,b,k,F]=(0,$.$bt)(g.text);const W=this.getEOL();F===0||F===(W===`\r
`?2:1)?I=g.text:I=g.text.replace(/\r\n|\r|\n/g,W)}o[v]={sortIndex:v,identifier:g.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:I,eolCount:h,firstLineLength:b,lastLineLength:k,forceMoveMarkers:!!g.forceMoveMarkers,isAutoWhitespaceEdit:g.isAutoWhitespaceEdit||!1}}o.sort(A.u);let c=!1;for(let v=0,g=o.length-1;v<g;v++){const D=o[v].range.getEndPosition(),I=o[v+1].range.getStartPosition();if(I.isBeforeOrEqual(D)){if(I.isBefore(D))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(o=this.s(o));const d=w||p?A._getInverseEditRanges(o):[],i=[];if(p)for(let v=0;v<o.length;v++){const g=o[v],D=d[v];if(g.isAutoWhitespaceEdit&&g.range.isEmpty())for(let I=D.startLineNumber;I<=D.endLineNumber;I++){let h="";I===D.startLineNumber&&(h=this.getLineContent(g.range.startLineNumber),T.$Ue(h)!==-1)||i.push({lineNumber:I,oldContent:h})}}let r=null;if(w){let v=0;r=[];for(let g=0;g<o.length;g++){const D=o[g],I=d[g],h=this.getValueInRange(D.range),b=D.rangeOffset+v;v+=D.text.length-h.length,r[g]={sortIndex:D.sortIndex,identifier:D.identifier,range:I,text:h,textChange:new m.$Ws(D.rangeOffset,h,b,D.text)}}c||r.sort((g,D)=>g.sortIndex-D.sortIndex)}this.g=a,this.h=s,this.j=t;const u=this.t(o);let f=null;if(p&&i.length>0){i.sort((v,g)=>g.lineNumber-v.lineNumber),f=[];for(let v=0,g=i.length;v<g;v++){const D=i[v].lineNumber;if(v>0&&i[v-1].lineNumber===D)continue;const I=i[v].oldContent,h=this.getLineContent(D);h.length===0||h===I||T.$Ue(h)!==-1||f.push(D)}}return this.m.fire(),new M.$Wu(r,u,f)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let p=!1;const w=l[0].range,a=l[l.length-1].range,s=new C.$Bs(w.startLineNumber,w.startColumn,a.endLineNumber,a.endColumn);let t=w.startLineNumber,n=w.startColumn;const o=[];for(let u=0,f=l.length;u<f;u++){const v=l[u],g=v.range;p=p||v.forceMoveMarkers,o.push(this.getValueInRange(new C.$Bs(t,n,g.startLineNumber,g.startColumn))),v.text.length>0&&o.push(v.text),t=g.endLineNumber,n=g.endColumn}const c=o.join(""),[d,i,r]=(0,$.$bt)(c);return{sortIndex:0,identifier:l[0].identifier,range:s,rangeOffset:this.getOffsetAt(s.startLineNumber,s.startColumn),rangeLength:this.getValueLengthInRange(s,0),text:c,eolCount:d,firstLineLength:i,lastLineLength:r,forceMoveMarkers:p,isAutoWhitespaceEdit:!1}}t(l){l.sort(A.w);const p=[];for(let w=0;w<l.length;w++){const a=l[w],s=a.range.startLineNumber,t=a.range.startColumn,n=a.range.endLineNumber,o=a.range.endColumn;if(s===n&&t===o&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const c=new C.$Bs(s,t,n,o);p.push({range:c,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return p}findMatchesLineByLine(l,p,w,a){return this.c.findMatchesLineByLine(l,p,w,a)}getPieceTree(){return this.c}static _getInverseEditRange(l,p){const w=l.startLineNumber,a=l.startColumn,[s,t,n]=(0,$.$bt)(p);let o;if(p.length>0){const c=s+1;c===1?o=new C.$Bs(w,a,w,a+t):o=new C.$Bs(w,a,w+c-1,n+1)}else o=new C.$Bs(w,a,w,a);return o}static _getInverseEditRanges(l){const p=[];let w=0,a=0,s=null;for(let t=0,n=l.length;t<n;t++){const o=l[t];let c,d;s?s.range.endLineNumber===o.range.startLineNumber?(c=w,d=a+(o.range.startColumn-s.range.endColumn)):(c=w+(o.range.startLineNumber-s.range.endLineNumber),d=o.range.startColumn):(c=o.range.startLineNumber,d=o.range.startColumn);let i;if(o.text.length>0){const r=o.eolCount+1;r===1?i=new C.$Bs(c,d,c,d+o.firstLineLength):i=new C.$Bs(c,d,c+r-1,o.lastLineLength+1)}else i=new C.$Bs(c,d,c,d);w=i.endLineNumber,a=i.endColumn,p.push(i),s=o}return p}static u(l,p){const w=C.$Bs.compareRangesUsingEnds(l.range,p.range);return w===0?l.sortIndex-p.sortIndex:w}static w(l,p){const w=C.$Bs.compareRangesUsingEnds(l.range,p.range);return w===0?p.sortIndex-l.sortIndex:-w}}e.$OB=A}),define(Ae[143],Re([1,0,12,91,142]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PB=void 0;class M{constructor(m,y,A,S,l,p,w,a,s){this.a=m,this.b=y,this.c=A,this.d=S,this.e=l,this.f=p,this.g=w,this.h=a,this.j=s}k(m){const y=this.c+this.d+this.e,A=this.c+this.e;return y===0?m===1?`
`:`\r
`:A>y/2?`\r
`:`
`}create(m){const y=this.k(m),A=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let l=0,p=A.length;l<p;l++){const w=A[l].buffer.replace(/\r\n|\r|\n/g,y),a=(0,T.$JB)(w);A[l]=new T.$MB(w,a)}const S=new C.$OB(A,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(m){return this.a[0].buffer.substr(0,m).split(/\r\n|\r|\n/)[0]}}class P{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(m){if(m.length===0)return;this.a.length===0&&E.$qf(m)&&(this.b=E.$pf,m=m.substr(1));const y=m.charCodeAt(m.length-1);y===13||y>=55296&&y<=56319?(this.m(m.substr(0,m.length-1),!1),this.c=!0,this.d=y):(this.m(m,!1),this.c=!1,this.d=y)}m(m,y){!y&&m.length===0||(this.c?this.n(String.fromCharCode(this.d)+m):this.n(m))}n(m){const y=(0,T.$KB)(this.e,m);this.a.push(new T.$MB(m,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=E.$hf(m)),this.k||(this.k=E.$kf(m)))}finish(m=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,m)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const m=this.a[this.a.length-1];m.buffer+=String.fromCharCode(this.d);const y=(0,T.$JB)(m.buffer);m.lineStarts=y,this.d===13&&this.f++}}}e.$PB=P}),define(Ae[95],Re([1,0,24,21]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$10=e.$Z0=void 0;var C;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(C||(C={}));function M(S){for(let l=0,p=S.length;l<p;l+=4){const w=S[l+0],a=S[l+1],s=S[l+2],t=S[l+3];S[l+0]=t,S[l+1]=s,S[l+2]=a,S[l+3]=w}}function P(S){const l=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return T.$D()||M(l),E.$fe.wrap(l)}function $(S){const l=S.buffer;if(T.$D()||M(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const p=new Uint8Array(l.byteLength);return p.set(l),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function m(S){const l=new Uint32Array(y(S));let p=0;if(l[p++]=S.id,S.type==="full")l[p++]=1,l[p++]=S.data.length,l.set(S.data,p),p+=S.data.length;else{l[p++]=2,l[p++]=S.deltas.length;for(const w of S.deltas)l[p++]=w.start,l[p++]=w.deleteCount,w.data?(l[p++]=w.data.length,l.set(w.data,p),p+=w.data.length):l[p++]=0}return P(l)}e.$Z0=m;function y(S){let l=0;if(l+=1+1,S.type==="full")l+=1+S.data.length;else{l+=1,l+=(1+1+1)*S.deltas.length;for(const p of S.deltas)p.data&&(l+=p.data.length)}return l}function A(S){const l=$(S);let p=0;const w=l[p++];if(l[p++]===1){const n=l[p++],o=l.subarray(p,p+n);return p+=n,{id:w,type:"full",data:o}}const s=l[p++],t=[];for(let n=0;n<s;n++){const o=l[p++],c=l[p++],d=l[p++];let i;d>0&&(i=l.subarray(p,p+d),p+=d),t[n]={start:o,deleteCount:c,data:i}}return{id:w,type:"delta",deltas:t}}e.$10=A}),define(Ae[144],Re([9,10]),function(we,e){return we.create("vs/editor/common/config/editorOptions",e)}),define(Ae[145],Re([1,0,18,26,21,127,146,144]),function(we,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var m;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(m||(e.EditorAutoIndentStrategy=m={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=y;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class S{constructor(Z,ye,Ue,He){this.id=Z,this.name=ye,this.defaultValue=Ue,this.schema=He}applyUpdate(Z,ye){return p(Z,ye)}compute(Z,ye,Ue){return Ue}}class l{constructor(Z,ye){this.newValue=Z,this.didChange=ye}}e.ApplyUpdateResult=l;function p(Y,Z){if(typeof Y!="object"||typeof Z!="object"||!Y||!Z)return new l(Z,Y!==Z);if(Array.isArray(Y)||Array.isArray(Z)){const Ue=Array.isArray(Y)&&Array.isArray(Z)&&E.$tb(Y,Z);return new l(Z,!Ue)}let ye=!1;for(const Ue in Z)if(Z.hasOwnProperty(Ue)){const He=p(Y[Ue],Z[Ue]);He.didChange&&(Y[Ue]=He.newValue,ye=!0)}return new l(Y,ye)}class w{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,ye){return p(Z,ye)}validate(Z){return this.defaultValue}}class a{constructor(Z,ye,Ue,He){this.id=Z,this.name=ye,this.defaultValue=Ue,this.schema=He}applyUpdate(Z,ye){return p(Z,ye)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,ye,Ue){return Ue}}function s(Y,Z){return typeof Y>"u"?Z:Y==="false"?!1:!!Y}e.boolean=s;class t extends a{constructor(Z,ye,Ue,He=void 0){typeof He<"u"&&(He.type="boolean",He.default=Ue),super(Z,ye,Ue,He)}validate(Z){return s(Z,this.defaultValue)}}function n(Y,Z,ye,Ue){if(typeof Y>"u")return Z;let He=parseInt(Y,10);return isNaN(He)?Z:(He=Math.max(ye,He),He=Math.min(Ue,He),He|0)}e.clampedInt=n;class o extends a{static clampedInt(Z,ye,Ue,He){return n(Z,ye,Ue,He)}constructor(Z,ye,Ue,He,Ye,st=void 0){typeof st<"u"&&(st.type="integer",st.default=Ue,st.minimum=He,st.maximum=Ye),super(Z,ye,Ue,st),this.minimum=He,this.maximum=Ye}validate(Z){return o.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function c(Y,Z,ye,Ue){if(typeof Y>"u")return Z;const He=d.float(Y,Z);return d.clamp(He,ye,Ue)}e.clampedFloat=c;class d extends a{static clamp(Z,ye,Ue){return Z<ye?ye:Z>Ue?Ue:Z}static float(Z,ye){if(typeof Z=="number")return Z;if(typeof Z>"u")return ye;const Ue=parseFloat(Z);return isNaN(Ue)?ye:Ue}constructor(Z,ye,Ue,He,Ye){typeof Ye<"u"&&(Ye.type="number",Ye.default=Ue),super(Z,ye,Ue,Ye),this.validationFn=He}validate(Z){return this.validationFn(d.float(Z,this.defaultValue))}}class i extends a{static string(Z,ye){return typeof Z!="string"?ye:Z}constructor(Z,ye,Ue,He=void 0){typeof He<"u"&&(He.type="string",He.default=Ue),super(Z,ye,Ue,He)}validate(Z){return i.string(Z,this.defaultValue)}}function r(Y,Z,ye,Ue){return typeof Y!="string"?Z:Ue&&Y in Ue?Ue[Y]:ye.indexOf(Y)===-1?Z:Y}e.stringSet=r;class u extends a{constructor(Z,ye,Ue,He,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.enum=He,Ye.default=Ue),super(Z,ye,Ue,Ye),this.c=He}validate(Z){return r(Z,this.defaultValue,this.c)}}class f extends S{constructor(Z,ye,Ue,He,Ye,st,pt=void 0){typeof pt<"u"&&(pt.type="string",pt.enum=Ye,pt.default=He),super(Z,ye,Ue,pt),this.c=Ye,this.d=st}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function v(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,ye,Ue){return Ue===0?Z.accessibilitySupport:Ue}}class D extends S{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:$.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{insertSpace:s(ye.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s(ye.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function h(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var b;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(b||(e.TextEditorCursorStyle=b={}));function k(Y){switch(Y){case b.Line:return"line";case b.Block:return"block";case b.Underline:return"underline";case b.LineThin:return"line-thin";case b.BlockOutline:return"block-outline";case b.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function F(Y){switch(Y){case"line":return b.Line;case"block":return b.Block;case"underline":return b.Underline;case"line-thin":return b.LineThin;case"block-outline":return b.BlockOutline;case"underline-thin":return b.UnderlineThin}}class W extends w{constructor(){super(140)}compute(Z,ye,Ue){const He=["monaco-editor"];return ye.get(39)&&He.push(ye.get(39)),Z.extraEditorClassName&&He.push(Z.extraEditorClassName),ye.get(73)==="default"?He.push("mouse-default"):ye.get(73)==="copy"&&He.push("mouse-copy"),ye.get(110)&&He.push("showUnused"),ye.get(138)&&He.push("showDeprecated"),He.join(" ")}}class J extends t{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(Z,ye,Ue){return Ue&&Z.emptySelectionClipboard}}class N extends S{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:$.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:$.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{cursorMoveOnType:s(ye.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":r(ye.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":r(ye.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s(ye.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s(ye.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s(ye.loop,this.defaultValue.loop)}}}class R extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",R.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?R.OFF:Z==="true"?R.ON:Z:Z?R.ON:R.OFF}}e.EditorFontLigatures=R;class L extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",L.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?L.OFF:Z==="true"?L.TRANSLATE:Z:Z?L.TRANSLATE:L.OFF}compute(Z,ye,Ue){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=L;class O extends w{constructor(){super(50)}compute(Z,ye,Ue){return Z.fontInfo}}class X extends a{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(Z){const ye=d.float(Z,this.defaultValue);return ye===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(ye,6,100)}compute(Z,ye,Ue){return Z.fontInfo.fontSize}}class he extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:he.d,maximum:he.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:he.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(o.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,he.d,he.e))}}class $e extends S{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ye={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...ye},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...ye},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...ye},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...ye},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...ye},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Ue,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Ue,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Ue,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Ue,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Ue,description:$.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{multiple:r(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ye.multipleDefinitions??r(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ye.multipleTypeDefinitions??r(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ye.multipleDeclarations??r(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ye.multipleImplementations??r(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ye.multipleReferences??r(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class De extends S{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:$.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:s(ye.enabled,this.defaultValue.enabled),delay:o.clampedInt(ye.delay,this.defaultValue.delay,0,1e4),sticky:s(ye.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(ye.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:s(ye.above,this.defaultValue.above)}}}var ke;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(ke||(e.RenderMinimap=ke={}));class de extends w{constructor(){super(143)}compute(Z,ye,Ue){return de.computeLayout(ye,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const ye=Z.height/Z.lineHeight,Ue=Math.floor(Z.paddingTop/Z.lineHeight);let He=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(He=Math.max(He,ye-1));const Ye=(Ue+Z.viewLineCount+He)/(Z.pixelRatio*Z.height),st=Math.floor(Z.viewLineCount/Ye);return{typicalViewportLineCount:ye,extraLinesBeforeFirstLine:Ue,extraLinesBeyondLastLine:He,desiredRatio:Ye,minimapLineCount:st}}static c(Z,ye){const Ue=Z.outerWidth,He=Z.outerHeight,Ye=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const st=ye.stableMinimapLayoutInput,pt=st&&Z.outerHeight===st.outerHeight&&Z.lineHeight===st.lineHeight&&Z.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&Z.pixelRatio===st.pixelRatio&&Z.scrollBeyondLastLine===st.scrollBeyondLastLine&&Z.paddingTop===st.paddingTop&&Z.paddingBottom===st.paddingBottom&&Z.minimap.enabled===st.minimap.enabled&&Z.minimap.side===st.minimap.side&&Z.minimap.size===st.minimap.size&&Z.minimap.showSlider===st.minimap.showSlider&&Z.minimap.renderCharacters===st.minimap.renderCharacters&&Z.minimap.maxColumn===st.minimap.maxColumn&&Z.minimap.scale===st.minimap.scale&&Z.verticalScrollbarWidth===st.verticalScrollbarWidth&&Z.isViewportWrapping===st.isViewportWrapping,Te=Z.lineHeight,At=Z.typicalHalfwidthCharacterWidth,Kt=Z.scrollBeyondLastLine,Ht=Z.minimap.renderCharacters;let bt=Ye>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const jt=Z.minimap.maxColumn,Ot=Z.minimap.size,Gt=Z.minimap.side,Ut=Z.verticalScrollbarWidth,kt=Z.viewLineCount,Tt=Z.remainingWidth,Qe=Z.isViewportWrapping,Jt=Ht?2:3;let Wt=Math.floor(Ye*He);const ct=Wt/Ye;let ft=!1,Vt=!1,Rt=Jt*bt,Dt=bt/Ye,gt=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Zt,extraLinesBeforeFirstLine:Se,extraLinesBeyondLastLine:Me,desiredRatio:ve,minimapLineCount:K}=de.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:Kt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:He,lineHeight:Te,pixelRatio:Ye});if(kt/K>1)ft=!0,Vt=!0,bt=1,Rt=1,Dt=bt/Ye;else{let je=!1,Ze=bt+1;if(Ot==="fit"){const qe=Math.ceil((Se+kt+Me)*Rt);Qe&&pt&&Tt<=ye.stableFitRemainingWidth?(je=!0,Ze=ye.stableFitMaxMinimapScale):je=qe>Wt}if(Ot==="fill"||je){ft=!0;const qe=bt;Rt=Math.min(Te*Ye,Math.max(1,Math.floor(1/ve))),Qe&&pt&&Tt<=ye.stableFitRemainingWidth&&(Ze=ye.stableFitMaxMinimapScale),bt=Math.min(Ze,Math.max(1,Math.floor(Rt/Jt))),bt>qe&&(gt=Math.min(2,bt/qe)),Dt=bt/Ye/gt,Wt=Math.ceil(Math.max(Zt,Se+kt+Me)*Rt),Qe?(ye.stableMinimapLayoutInput=Z,ye.stableFitRemainingWidth=Tt,ye.stableFitMaxMinimapScale=bt):(ye.stableMinimapLayoutInput=null,ye.stableFitRemainingWidth=0)}}}const Mt=Math.floor(jt*Dt),Pt=Math.min(Mt,Math.max(0,Math.floor((Tt-Ut-2)*Dt/(At+Dt)))+e.MINIMAP_GUTTER_WIDTH);let St=Math.floor(Ye*Pt);const Ve=St/Ye;St=Math.floor(St*gt);const Nt=Ht?1:2,zt=Gt==="left"?0:Ue-Pt-Ut;return{renderMinimap:Nt,minimapLeft:zt,minimapWidth:Pt,minimapHeightIsEditorHeight:ft,minimapIsSampling:Vt,minimapScale:bt,minimapLineHeight:Rt,minimapCanvasInnerWidth:St,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Ve,minimapCanvasOuterHeight:ct}}static computeLayout(Z,ye){const Ue=ye.outerWidth|0,He=ye.outerHeight|0,Ye=ye.lineHeight|0,st=ye.lineNumbersDigitCount|0,pt=ye.typicalHalfwidthCharacterWidth,Te=ye.maxDigitWidth,At=ye.pixelRatio,Kt=ye.viewLineCount,Ht=Z.get(135),bt=Ht==="inherit"?Z.get(134):Ht,jt=bt==="inherit"?Z.get(130):bt,Ot=Z.get(133),Gt=ye.isDominatedByLongLines,Ut=Z.get(57),kt=Z.get(67).renderType!==0,Tt=Z.get(68),Qe=Z.get(104),Jt=Z.get(83),Wt=Z.get(72),ct=Z.get(102),ft=ct.verticalScrollbarSize,Vt=ct.verticalHasArrows,Rt=ct.arrowSize,Dt=ct.horizontalScrollbarSize,gt=Z.get(43),Mt=Z.get(109)!=="never";let Pt=Z.get(65);gt&&Mt&&(Pt+=16);let St=0;if(kt){const ut=Math.max(st,Tt);St=Math.round(ut*Te)}let Ve=0;Ut&&(Ve=Ye*ye.glyphMarginDecorationLaneCount);let Nt=0,zt=Nt+Ve,Zt=zt+St,Se=Zt+Pt;const Me=Ue-Ve-St-Pt;let ve=!1,K=!1,Le=-1;bt==="inherit"&&Gt?(ve=!0,K=!0):jt==="on"||jt==="bounded"?K=!0:jt==="wordWrapColumn"&&(Le=Ot);const je=de.c({outerWidth:Ue,outerHeight:He,lineHeight:Ye,typicalHalfwidthCharacterWidth:pt,pixelRatio:At,scrollBeyondLastLine:Qe,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Wt,verticalScrollbarWidth:ft,viewLineCount:Kt,remainingWidth:Me,isViewportWrapping:K},ye.memory||new A);je.renderMinimap!==0&&je.minimapLeft===0&&(Nt+=je.minimapWidth,zt+=je.minimapWidth,Zt+=je.minimapWidth,Se+=je.minimapWidth);const Ze=Me-je.minimapWidth,qe=Math.max(1,Math.floor((Ze-ft-2)/pt)),et=Vt?Rt:0;return K&&(Le=Math.max(1,qe),jt==="bounded"&&(Le=Math.min(Le,Ot))),{width:Ue,height:He,glyphMarginLeft:Nt,glyphMarginWidth:Ve,glyphMarginDecorationLaneCount:ye.glyphMarginDecorationLaneCount,lineNumbersLeft:zt,lineNumbersWidth:St,decorationsLeft:Zt,decorationsWidth:Pt,contentLeft:Se,contentWidth:Ze,minimap:je,viewportColumn:qe,isWordWrapMinified:ve,isViewportWrapping:K,wrappingColumn:Le,verticalScrollbarWidth:ft,horizontalScrollbarHeight:Dt,overviewRuler:{top:et,width:ft,height:He-2*et,right:0}}}}e.EditorLayoutInfoComputer=de;class Ee extends S{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(Z){return r(Z,"simple",["simple","advanced"])}compute(Z,ye,Ue){return ye.get(2)===2?"advanced":Ue}}class _ extends S{constructor(){const Z={enabled:!0};super(64,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:$.localize(50,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:s(Z.enabled,this.defaultValue.enabled)}}}class Ce extends S{constructor(){const Z={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:$.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:10,description:$.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:$.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:$.localize(54,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:s(ye.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(ye.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(ye.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:s(ye.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends S{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:$.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(56,null),$.localize(57,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(58,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:$.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:$.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:$.localize(62,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return typeof ye.enabled=="boolean"&&(ye.enabled=ye.enabled?"on":"off"),{enabled:r(ye.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(ye.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(ye.fontFamily,this.defaultValue.fontFamily),padding:s(ye.padding,this.defaultValue.padding)}}}class Q extends S{constructor(){super(65,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):o.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,ye,Ue){return Ue<0?o.clampedInt(-Ue*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ue}}class U extends d{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>d.clamp(Z,0,150),{markdownDescription:$.localize(63,null)})}compute(Z,ye,Ue){return Z.fontInfo.lineHeight}}class ne extends S{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:$.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:$.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(66,null),$.localize(67,null),$.localize(68,null)],default:Z.size,description:$.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:$.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:$.localize(71,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:$.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:$.localize(74,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:s(ye.enabled,this.defaultValue.enabled),autohide:s(ye.autohide,this.defaultValue.autohide),size:r(ye.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(ye.side,this.defaultValue.side,["right","left"]),showSlider:r(ye.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s(ye.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(ye.scale,1,1,3),maxColumn:o.clampedInt(ye.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function pe(Y){return Y==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class re extends S{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(76,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{top:o.clampedInt(ye.top,0,0,1e3),bottom:o.clampedInt(ye.bottom,0,0,1e3)}}}class le extends S{constructor(){const Z={enabled:!0,cycle:!0};super(85,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:$.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:$.localize(78,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:s(ye.enabled,this.defaultValue.enabled),cycle:s(ye.cycle,this.defaultValue.cycle)}}}class ce extends w{constructor(){super(141)}compute(Z,ye,Ue){return Z.pixelRatio}}class be extends S{constructor(){const Z={other:"on",comments:"off",strings:"off"},ye=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(79,null),$.localize(80,null),$.localize(81,null)]}];super(88,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ye,default:Z.strings,description:$.localize(82,null)},comments:{anyOf:ye,default:Z.comments,description:$.localize(83,null)},other:{anyOf:ye,default:Z.other,description:$.localize(84,null)}},default:Z,markdownDescription:$.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const At=Z?"on":"off";return{comments:At,strings:At,other:At}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:ye,comments:Ue,strings:He}=Z,Ye=["on","inline","off"];let st,pt,Te;return typeof ye=="boolean"?st=ye?"on":"off":st=r(ye,this.defaultValue.other,Ye),typeof Ue=="boolean"?pt=Ue?"on":"off":pt=r(Ue,this.defaultValue.comments,Ye),typeof He=="boolean"?Te=He?"on":"off":Te=r(He,this.defaultValue.strings,Ye),{other:st,comments:pt,strings:Te}}}var ee;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class fe extends S{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(86,null),$.localize(87,null),$.localize(88,null),$.localize(89,null)],default:"on",description:$.localize(90,null)})}validate(Z){let ye=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(ye=4,Ue=Z):Z==="interval"?ye=3:Z==="relative"?ye=2:Z==="on"?ye=1:ye=0),{renderType:ye,renderFn:Ue}}}function ie(Y){const Z=Y.get(97);return Z==="editable"?Y.get(90):Z!=="on"}e.filterValidationDecorations=ie;class ae extends S{constructor(){const Z=[],ye={type:"number",description:$.localize(91,null)};super(101,"rulers",Z,{type:"array",items:{anyOf:[ye,{type:["object"],properties:{column:ye,color:{type:"string",description:$.localize(92,null),format:"color-hex"}}}]},default:Z,description:$.localize(93,null)})}validate(Z){if(Array.isArray(Z)){const ye=[];for(const Ue of Z)if(typeof Ue=="number")ye.push({column:o.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const He=Ue;ye.push({column:o.clampedInt(He.column,0,0,1e4),color:He.color})}return ye.sort((Ue,He)=>Ue.column-He.column),ye}return this.defaultValue}}class me extends S{constructor(){super(91,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Pe(Y,Z){if(typeof Y!="string")return Z;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends S{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(94,null),$.localize(95,null),$.localize(96,null)],default:"auto",description:$.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(98,null),$.localize(99,null),$.localize(100,null)],default:"auto",description:$.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:$.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:$.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:$.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:$.localize(105,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z,Ue=o.clampedInt(ye.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=o.clampedInt(ye.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(ye.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(ye.vertical,this.defaultValue.vertical),horizontal:Pe(ye.horizontal,this.defaultValue.horizontal),useShadows:s(ye.useShadows,this.defaultValue.useShadows),verticalHasArrows:s(ye.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s(ye.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s(ye.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s(ye.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:o.clampedInt(ye.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:He,verticalSliderSize:o.clampedInt(ye.verticalSliderSize,He,0,1e3),scrollByPage:s(ye.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:s(ye.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends S{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:$.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:$.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:$.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:$.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:$.localize(112,null)}})}applyUpdate(Z,ye){let Ue=!1;ye.allowedCharacters&&Z&&(T.$gn(Z.allowedCharacters,ye.allowedCharacters)||(Z={...Z,allowedCharacters:ye.allowedCharacters},Ue=!0)),ye.allowedLocales&&Z&&(T.$gn(Z.allowedLocales,ye.allowedLocales)||(Z={...Z,allowedLocales:ye.allowedLocales},Ue=!0));const He=super.applyUpdate(Z,ye);return Ue?new l(He.newValue,!0):He}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{nonBasicASCII:x(ye.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s(ye.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s(ye.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(ye.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(ye.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,ye){if(typeof Z!="object"||!Z)return ye;const Ue={};for(const[He,Ye]of Object.entries(Z))Ye===!0&&(Ue[He]=!0);return Ue}}class H extends S{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:$.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[$.localize(114,null),$.localize(115,null),$.localize(116,null)],description:$.localize(117,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:$.localize(118,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:s(ye.enabled,this.defaultValue.enabled),mode:r(ye.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(ye.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:s(ye.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:s(ye.keepOnBlur,this.defaultValue.keepOnBlur)}}}class G extends S{constructor(){const Z={enabled:M.$$r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$$r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:$.localize(119,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:$.localize(120,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:s(ye.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:s(ye.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends S{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(121,null),$.localize(122,null),$.localize(123,null)],default:Z.bracketPairs,description:$.localize(124,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(125,null),$.localize(126,null),$.localize(127,null)],default:Z.bracketPairsHorizontal,description:$.localize(128,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:$.localize(129,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:$.localize(130,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(131,null),$.localize(132,null),$.localize(133,null)],default:Z.highlightActiveIndentation,description:$.localize(134,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{bracketPairs:x(ye.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(ye.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s(ye.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s(ye.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(ye.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(Y,Z,ye){const Ue=ye.indexOf(Y);return Ue===-1?Z:ye[Ue]}class ue extends S{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(135,null),$.localize(136,null)],default:Z.insertMode,description:$.localize(137,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:$.localize(138,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:$.localize(139,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:$.localize(140,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(141,null),$.localize(142,null),$.localize(143,null),$.localize(144,null)],default:Z.selectionMode,markdownDescription:$.localize(145,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:$.localize(146,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:$.localize(147,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:$.localize(148,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:$.localize(149,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:$.localize(150,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(151,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(152,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(153,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(154,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(155,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(182,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{insertMode:r(ye.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s(ye.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s(ye.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s(ye.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s(ye.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(ye.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:s(ye.showIcons,this.defaultValue.showIcons),showStatusBar:s(ye.showStatusBar,this.defaultValue.showStatusBar),preview:s(ye.preview,this.defaultValue.preview),previewMode:r(ye.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s(ye.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s(ye.showMethods,this.defaultValue.showMethods),showFunctions:s(ye.showFunctions,this.defaultValue.showFunctions),showConstructors:s(ye.showConstructors,this.defaultValue.showConstructors),showDeprecated:s(ye.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:s(ye.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:s(ye.showFields,this.defaultValue.showFields),showVariables:s(ye.showVariables,this.defaultValue.showVariables),showClasses:s(ye.showClasses,this.defaultValue.showClasses),showStructs:s(ye.showStructs,this.defaultValue.showStructs),showInterfaces:s(ye.showInterfaces,this.defaultValue.showInterfaces),showModules:s(ye.showModules,this.defaultValue.showModules),showProperties:s(ye.showProperties,this.defaultValue.showProperties),showEvents:s(ye.showEvents,this.defaultValue.showEvents),showOperators:s(ye.showOperators,this.defaultValue.showOperators),showUnits:s(ye.showUnits,this.defaultValue.showUnits),showValues:s(ye.showValues,this.defaultValue.showValues),showConstants:s(ye.showConstants,this.defaultValue.showConstants),showEnums:s(ye.showEnums,this.defaultValue.showEnums),showEnumMembers:s(ye.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s(ye.showKeywords,this.defaultValue.showKeywords),showWords:s(ye.showWords,this.defaultValue.showWords),showColors:s(ye.showColors,this.defaultValue.showColors),showFiles:s(ye.showFiles,this.defaultValue.showFiles),showReferences:s(ye.showReferences,this.defaultValue.showReferences),showFolders:s(ye.showFolders,this.defaultValue.showFolders),showTypeParameters:s(ye.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s(ye.showSnippets,this.defaultValue.showSnippets),showUsers:s(ye.showUsers,this.defaultValue.showUsers),showIssues:s(ye.showIssues,this.defaultValue.showIssues)}}}class Ne extends S{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(183,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(184,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:s(Z.selectSubwords,this.defaultValue.selectSubwords)}}}var Be;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(Be||(e.WrappingIndent=Be={}));class Xe extends S{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(185,null),$.localize(186,null),$.localize(187,null),$.localize(188,null)],description:$.localize(189,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,ye,Ue){return ye.get(2)===2?0:Ue}}class Je extends w{constructor(){super(144)}compute(Z,ye,Ue){const He=ye.get(143);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}class it extends S{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:$.localize(190,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(191,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(192,null),$.localize(193,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:s(ye.enabled,this.defaultValue.enabled),showDropSelector:r(ye.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class _e extends S{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:$.localize(194,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(195,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(196,null),$.localize(197,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:s(ye.enabled,this.defaultValue.enabled),showPasteSelector:r(ye.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const tt="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?rt:C.$k?nt:tt,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var ht;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.letterSpacing=63]="letterSpacing",Y[Y.lightbulb=64]="lightbulb",Y[Y.lineDecorationsWidth=65]="lineDecorationsWidth",Y[Y.lineHeight=66]="lineHeight",Y[Y.lineNumbers=67]="lineNumbers",Y[Y.lineNumbersMinChars=68]="lineNumbersMinChars",Y[Y.linkedEditing=69]="linkedEditing",Y[Y.links=70]="links",Y[Y.matchBrackets=71]="matchBrackets",Y[Y.minimap=72]="minimap",Y[Y.mouseStyle=73]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=75]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=77]="multiCursorModifier",Y[Y.multiCursorPaste=78]="multiCursorPaste",Y[Y.multiCursorLimit=79]="multiCursorLimit",Y[Y.occurrencesHighlight=80]="occurrencesHighlight",Y[Y.overviewRulerBorder=81]="overviewRulerBorder",Y[Y.overviewRulerLanes=82]="overviewRulerLanes",Y[Y.padding=83]="padding",Y[Y.pasteAs=84]="pasteAs",Y[Y.parameterHints=85]="parameterHints",Y[Y.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=88]="quickSuggestions",Y[Y.quickSuggestionsDelay=89]="quickSuggestionsDelay",Y[Y.readOnly=90]="readOnly",Y[Y.readOnlyMessage=91]="readOnlyMessage",Y[Y.renameOnType=92]="renameOnType",Y[Y.renderControlCharacters=93]="renderControlCharacters",Y[Y.renderFinalNewline=94]="renderFinalNewline",Y[Y.renderLineHighlight=95]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=97]="renderValidationDecorations",Y[Y.renderWhitespace=98]="renderWhitespace",Y[Y.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Y[Y.roundedSelection=100]="roundedSelection",Y[Y.rulers=101]="rulers",Y[Y.scrollbar=102]="scrollbar",Y[Y.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=104]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=105]="scrollPredominantAxis",Y[Y.selectionClipboard=106]="selectionClipboard",Y[Y.selectionHighlight=107]="selectionHighlight",Y[Y.selectOnLineNumbers=108]="selectOnLineNumbers",Y[Y.showFoldingControls=109]="showFoldingControls",Y[Y.showUnused=110]="showUnused",Y[Y.snippetSuggestions=111]="snippetSuggestions",Y[Y.smartSelect=112]="smartSelect",Y[Y.smoothScrolling=113]="smoothScrolling",Y[Y.stickyScroll=114]="stickyScroll",Y[Y.stickyTabStops=115]="stickyTabStops",Y[Y.stopRenderingLineAfter=116]="stopRenderingLineAfter",Y[Y.suggest=117]="suggest",Y[Y.suggestFontSize=118]="suggestFontSize",Y[Y.suggestLineHeight=119]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Y[Y.suggestSelection=121]="suggestSelection",Y[Y.tabCompletion=122]="tabCompletion",Y[Y.tabIndex=123]="tabIndex",Y[Y.unicodeHighlighting=124]="unicodeHighlighting",Y[Y.unusualLineTerminators=125]="unusualLineTerminators",Y[Y.useShadowDOM=126]="useShadowDOM",Y[Y.useTabStops=127]="useTabStops",Y[Y.wordBreak=128]="wordBreak",Y[Y.wordSeparators=129]="wordSeparators",Y[Y.wordWrap=130]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=133]="wordWrapColumn",Y[Y.wordWrapOverride1=134]="wordWrapOverride1",Y[Y.wordWrapOverride2=135]="wordWrapOverride2",Y[Y.wrappingIndent=136]="wrappingIndent",Y[Y.wrappingStrategy=137]="wrappingStrategy",Y[Y.showDeprecated=138]="showDeprecated",Y[Y.inlayHints=139]="inlayHints",Y[Y.editorClassName=140]="editorClassName",Y[Y.pixelRatio=141]="pixelRatio",Y[Y.tabFocusMode=142]="tabFocusMode",Y[Y.layoutInfo=143]="layoutInfo",Y[Y.wrappingInfo=144]="wrappingInfo",Y[Y.defaultColorDecorators=145]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(ht||(e.EditorOption=ht={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new t(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(198,null)})),acceptSuggestionOnEnter:ze(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(199,null),""],markdownDescription:$.localize(200,null)})),accessibilitySupport:ze(new g),accessibilityPageSize:ze(new o(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(201,null),tags:["accessibility"]})),ariaLabel:ze(new i(4,"ariaLabel",$.localize(202,null))),ariaRequired:ze(new t(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new t(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(203,null),tags:["accessibility"]})),autoClosingBrackets:ze(new u(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(204,null),$.localize(205,null),""],description:$.localize(206,null)})),autoClosingComments:ze(new u(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(207,null),$.localize(208,null),""],description:$.localize(209,null)})),autoClosingDelete:ze(new u(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(210,null),""],description:$.localize(211,null)})),autoClosingOvertype:ze(new u(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(212,null),""],description:$.localize(213,null)})),autoClosingQuotes:ze(new u(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(214,null),$.localize(215,null),""],description:$.localize(216,null)})),autoIndent:ze(new f(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[$.localize(217,null),$.localize(218,null),$.localize(219,null),$.localize(220,null),$.localize(221,null)],description:$.localize(222,null)})),automaticLayout:ze(new t(13,"automaticLayout",!1)),autoSurround:ze(new u(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(223,null),$.localize(224,null),$.localize(225,null),""],description:$.localize(226,null)})),bracketPairColorization:ze(new G),bracketPairGuides:ze(new q),stickyTabStops:ze(new t(115,"stickyTabStops",!1,{description:$.localize(227,null)})),codeLens:ze(new t(17,"codeLens",!0,{description:$.localize(228,null)})),codeLensFontFamily:ze(new i(18,"codeLensFontFamily","",{description:$.localize(229,null)})),codeLensFontSize:ze(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(230,null)})),colorDecorators:ze(new t(20,"colorDecorators",!0,{description:$.localize(231,null)})),colorDecoratorActivatedOn:ze(new u(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(232,null),$.localize(233,null),$.localize(234,null)],description:$.localize(235,null)})),colorDecoratorsLimit:ze(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(236,null)})),columnSelection:ze(new t(22,"columnSelection",!1,{description:$.localize(237,null)})),comments:ze(new D),contextmenu:ze(new t(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new t(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(238,null)})),cursorBlinking:ze(new f(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:$.localize(239,null)})),cursorSmoothCaretAnimation:ze(new u(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(240,null),$.localize(241,null),$.localize(242,null)],description:$.localize(243,null)})),cursorStyle:ze(new f(28,"cursorStyle",b.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:$.localize(244,null)})),cursorSurroundingLines:ze(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(245,null)})),cursorSurroundingLinesStyle:ze(new u(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(246,null),$.localize(247,null)],markdownDescription:$.localize(248,null)})),cursorWidth:ze(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(249,null)})),disableLayerHinting:ze(new t(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new t(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new t(34,"domReadOnly",!1)),dragAndDrop:ze(new t(35,"dragAndDrop",!0,{description:$.localize(250,null)})),emptySelectionClipboard:ze(new J),dropIntoEditor:ze(new it),stickyScroll:ze(new Ce),experimentalWhitespaceRendering:ze(new u(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(251,null),$.localize(252,null),$.localize(253,null)],description:$.localize(254,null)})),extraEditorClassName:ze(new i(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new d(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:$.localize(255,null)})),find:ze(new N),fixedOverflowWidgets:ze(new t(42,"fixedOverflowWidgets",!1)),folding:ze(new t(43,"folding",!0,{description:$.localize(256,null)})),foldingStrategy:ze(new u(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(257,null),$.localize(258,null)],description:$.localize(259,null)})),foldingHighlight:ze(new t(45,"foldingHighlight",!0,{description:$.localize(260,null)})),foldingImportsByDefault:ze(new t(46,"foldingImportsByDefault",!1,{description:$.localize(261,null)})),foldingMaximumRegions:ze(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(262,null)})),unfoldOnClickAfterEndOfLine:ze(new t(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(263,null)})),fontFamily:ze(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(264,null)})),fontInfo:ze(new O),fontLigatures2:ze(new R),fontSize:ze(new X),fontWeight:ze(new he),fontVariations:ze(new L),formatOnPaste:ze(new t(55,"formatOnPaste",!1,{description:$.localize(265,null)})),formatOnType:ze(new t(56,"formatOnType",!1,{description:$.localize(266,null)})),glyphMargin:ze(new t(57,"glyphMargin",!0,{description:$.localize(267,null)})),gotoLocation:ze(new $e),hideCursorInOverviewRuler:ze(new t(59,"hideCursorInOverviewRuler",!1,{description:$.localize(268,null)})),hover:ze(new De),inDiffEditor:ze(new t(61,"inDiffEditor",!1)),letterSpacing:ze(new d(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>d.clamp(Y,-5,20),{description:$.localize(269,null)})),lightbulb:ze(new _),lineDecorationsWidth:ze(new Q),lineHeight:ze(new U),lineNumbers:ze(new fe),lineNumbersMinChars:ze(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new t(69,"linkedEditing",!1,{description:$.localize(270,null)})),links:ze(new t(70,"links",!0,{description:$.localize(271,null)})),matchBrackets:ze(new u(71,"matchBrackets","always",["always","near","never"],{description:$.localize(272,null)})),minimap:ze(new ne),mouseStyle:ze(new u(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new d(74,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:$.localize(273,null)})),mouseWheelZoom:ze(new t(75,"mouseWheelZoom",!1,{markdownDescription:$.localize(274,null)})),multiCursorMergeOverlapping:ze(new t(76,"multiCursorMergeOverlapping",!0,{description:$.localize(275,null)})),multiCursorModifier:ze(new f(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],pe,{markdownEnumDescriptions:[$.localize(276,null),$.localize(277,null)],markdownDescription:$.localize(278,null)})),multiCursorPaste:ze(new u(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(279,null),$.localize(280,null)],markdownDescription:$.localize(281,null)})),multiCursorLimit:ze(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(282,null)})),occurrencesHighlight:ze(new u(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[$.localize(283,null),$.localize(284,null),$.localize(285,null)],markdownDescription:$.localize(286,null)})),overviewRulerBorder:ze(new t(81,"overviewRulerBorder",!0,{description:$.localize(287,null)})),overviewRulerLanes:ze(new o(82,"overviewRulerLanes",3,0,3)),padding:ze(new re),pasteAs:ze(new _e),parameterHints:ze(new le),peekWidgetDefaultFocus:ze(new u(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(288,null),$.localize(289,null)],description:$.localize(290,null)})),definitionLinkOpensInPeek:ze(new t(87,"definitionLinkOpensInPeek",!1,{description:$.localize(291,null)})),quickSuggestions:ze(new be),quickSuggestionsDelay:ze(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(292,null)})),readOnly:ze(new t(90,"readOnly",!1)),readOnlyMessage:ze(new me),renameOnType:ze(new t(92,"renameOnType",!1,{description:$.localize(293,null),markdownDeprecationMessage:$.localize(294,null)})),renderControlCharacters:ze(new t(93,"renderControlCharacters",!0,{description:$.localize(295,null),restricted:!0})),renderFinalNewline:ze(new u(94,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(296,null)})),renderLineHighlight:ze(new u(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(297,null)],description:$.localize(298,null)})),renderLineHighlightOnlyWhenFocus:ze(new t(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(299,null)})),renderValidationDecorations:ze(new u(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new u(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(300,null),$.localize(301,null),$.localize(302,null),""],description:$.localize(303,null)})),revealHorizontalRightPadding:ze(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new t(100,"roundedSelection",!0,{description:$.localize(304,null)})),rulers:ze(new ae),scrollbar:ze(new z),scrollBeyondLastColumn:ze(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(305,null)})),scrollBeyondLastLine:ze(new t(104,"scrollBeyondLastLine",!0,{description:$.localize(306,null)})),scrollPredominantAxis:ze(new t(105,"scrollPredominantAxis",!0,{description:$.localize(307,null)})),selectionClipboard:ze(new t(106,"selectionClipboard",!0,{description:$.localize(308,null),included:C.$k})),selectionHighlight:ze(new t(107,"selectionHighlight",!0,{description:$.localize(309,null)})),selectOnLineNumbers:ze(new t(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new u(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(310,null),$.localize(311,null),$.localize(312,null)],description:$.localize(313,null)})),showUnused:ze(new t(110,"showUnused",!0,{description:$.localize(314,null)})),showDeprecated:ze(new t(138,"showDeprecated",!0,{description:$.localize(315,null)})),inlayHints:ze(new se),snippetSuggestions:ze(new u(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(316,null),$.localize(317,null),$.localize(318,null),$.localize(319,null)],description:$.localize(320,null)})),smartSelect:ze(new Ne),smoothScrolling:ze(new t(113,"smoothScrolling",!1,{description:$.localize(321,null)})),stopRenderingLineAfter:ze(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ue),inlineSuggest:ze(new H),inlineCompletionsAccessibilityVerbose:ze(new t(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(322,null)})),suggestFontSize:ze(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(323,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(324,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new t(120,"suggestOnTriggerCharacters",!0,{description:$.localize(325,null)})),suggestSelection:ze(new u(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(326,null),$.localize(327,null),$.localize(328,null)],description:$.localize(329,null)})),tabCompletion:ze(new u(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(330,null),$.localize(331,null),$.localize(332,null)],description:$.localize(333,null)})),tabIndex:ze(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new V),unusualLineTerminators:ze(new u(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(334,null),$.localize(335,null),$.localize(336,null)],description:$.localize(337,null)})),useShadowDOM:ze(new t(126,"useShadowDOM",!0)),useTabStops:ze(new t(127,"useTabStops",!0,{description:$.localize(338,null)})),wordBreak:ze(new u(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(339,null),$.localize(340,null)],description:$.localize(341,null)})),wordSeparators:ze(new i(129,"wordSeparators",P.$_r,{description:$.localize(342,null)})),wordWrap:ze(new u(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(343,null),$.localize(344,null),$.localize(345,null),$.localize(346,null)],description:$.localize(347,null)})),wordWrapBreakAfterCharacters:ze(new i(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new i(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(348,null)})),wordWrapOverride1:ze(new u(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new u(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new W),defaultColorDecorators:ze(new t(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(349,null)})),pixelRatio:ze(new ce),tabFocusMode:ze(new t(142,"tabFocusMode",!1,{markdownDescription:$.localize(350,null)})),layoutInfo:ze(new de),wrappingInfo:ze(new Je),wrappingIndent:ze(new Xe),wrappingStrategy:ze(new Ee)}}),define(Ae[147],Re([9,10]),function(we,e){return we.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[148],Re([9,10]),function(we,e){return we.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[149],Re([9,10]),function(we,e){return we.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[150],Re([9,10]),function(we,e){return we.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[151],Re([9,10]),function(we,e){return we.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[152],Re([9,10]),function(we,e){return we.create("vs/platform/files/common/files",e)}),define(Ae[153],Re([9,10]),function(we,e){return we.create("vs/platform/markers/common/markers",e)}),define(Ae[154],Re([9,10]),function(we,e){return we.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[155],Re([9,10]),function(we,e){return we.create("vs/platform/workspace/common/workspace",e)}),define(Ae[156],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ae[157],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[158],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[159],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[160],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[161],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[162],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[163],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[164],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[165],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[166],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[167],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[168],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[169],Re([9,10]),function(we,e){return we.create("vs/workbench/common/configuration",e)}),define(Ae[170],Re([9,10]),function(we,e){return we.create("vs/workbench/common/editor",e)}),define(Ae[171],Re([9,10]),function(we,e){return we.create("vs/workbench/common/views",e)}),define(Ae[172],Re([9,10]),function(we,e){return we.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[173],Re([9,10]),function(we,e){return we.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[174],Re([9,10]),function(we,e){return we.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[175],Re([9,10]),function(we,e){return we.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[176],Re([9,10]),function(we,e){return we.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[177],Re([9,10]),function(we,e){return we.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ae[178],Re([9,10]),function(we,e){return we.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[179],Re([9,10]),function(we,e){return we.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[180],Re([1,0,11,149]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.TokenType=void 0;var C;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(C||(e.TokenType=C={}));function M(...y){switch(y.length){case 1:return(0,T.localize)(0,null,y[0]);case 2:return(0,T.localize)(1,null,y[0],y[1]);case 3:return(0,T.localize)(2,null,y[0],y[1],y[2]);default:return}}const P=(0,T.localize)(3,null),$=(0,T.localize)(4,null);class m{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,E.$7)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const S=this.d,l=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:l};this.g.push({offset:S,lexeme:l,additionalInfo:A}),this.f.push(p)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const S=this.c.substring(this.d,this.e),l=m.b.get(S);l?this.k(l):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,S=!1,l=!1;for(;;){if(A>=this.c.length){this.e=A,this.l($);return}const w=this.c.charCodeAt(A);if(S)S=!1;else if(w===47&&!l){A++;break}else w===91?l=!0:w===92?S=!0:w===93&&(l=!1);A++}for(;A<this.c.length&&m.a.has(this.c.charCodeAt(A));)A++;this.e=A;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Si=m}),define(Ae[181],Re([1,0,25,31,151,293]),function(we,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function m(t){return t=t.trim(),t==="*"||P.test(t)}e.$To=m;function y(t){if(!m(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=t.match(P);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$Uo=y;function A(t){if(!t)return null;const n=t.majorBase,o=t.majorMustEqual,c=t.minorBase;let d=t.minorMustEqual;const i=t.patchBase;let r=t.patchMustEqual;t.hasCaret&&(n===0||(d=!1),r=!1);let u=0;if(t.preRelease){const f=$.exec(t.preRelease);if(f){const[,v,g,D]=f;u=Date.UTC(Number(v),Number(g)-1,Number(D))}}return{majorBase:n,majorMustEqual:o,minorBase:c,minorMustEqual:d,patchBase:i,patchMustEqual:r,isMinimum:t.hasGreaterEquals,notBefore:u}}e.$Vo=A;function S(t,n,o){let c;typeof t=="string"?c=A(y(t)):c=t;let d;n instanceof Date?d=n.getTime():typeof n=="string"&&(d=new Date(n).getTime());let i;if(typeof o=="string"?i=A(y(o)):i=o,!c||!i)return!1;const r=c.majorBase,u=c.minorBase,f=c.patchBase;let v=i.majorBase,g=i.minorBase,D=i.patchBase;const I=i.notBefore;let h=i.majorMustEqual,b=i.minorMustEqual,k=i.patchMustEqual;return i.isMinimum?r>v?!0:r<v?!1:u>g?!0:u<g||d&&d<I?!1:f>=D:(r===1&&v===0&&(!h||!b||!k)&&(v=1,g=0,D=0,h=!0,b=!1,k=!1),r<v?!1:r>v?!h:u<g?!1:u>g?!b:f<D?!1:f>D?!k:!(d&&d<I))}e.$Wo=S;function l(t,n,o,c,d){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([T.default.Error,C.localize(0,null)]),i;if(typeof c.name!="string")return i.push([T.default.Error,C.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([T.default.Error,C.localize(2,null,"version")]),i;if(!c.engines)return i.push([T.default.Error,C.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([T.default.Error,C.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!s(c.extensionDependencies))return i.push([T.default.Error,C.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!s(c.activationEvents))return i.push([T.default.Error,C.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([T.default.Error,C.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([T.default.Warning,C.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([T.default.Error,C.localize(9,null,"main")]),i;{const f=(0,E.$Bg)(o,c.main);(0,E.$vg)(f,o)||i.push([T.default.Warning,C.localize(10,null,f.path,o.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([T.default.Error,C.localize(11,null,"browser")]),i;{const f=(0,E.$Bg)(o,c.browser);(0,E.$vg)(f,o)||i.push([T.default.Warning,C.localize(12,null,f.path,o.path)])}}if(!M.valid(c.version))return i.push([T.default.Error,C.localize(13,null)]),i;const r=[];if(!p(t,n,c,d,r))for(const f of r)i.push([T.default.Error,f]);return i}e.$Xo=l;function p(t,n,o,c,d){return c||typeof o.main>"u"&&typeof o.browser>"u"?!0:a(t,n,o.engines.vscode,d)}e.$Yo=p;function w(t,n,o){return t==="*"||a(n,o,t)}e.$Zo=w;function a(t,n,o,c=[]){const d=A(y(o));if(!d)return c.push(C.localize(14,null,o)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return c.push(C.localize(15,null,o)),!1}else if(!d.majorMustEqual)return c.push(C.localize(16,null,o)),!1;return S(t,n,d)?!0:(c.push(C.localize(17,null,t,o)),!1)}function s(t){if(!Array.isArray(t))return!1;for(let n=0,o=t.length;n<o;n++)if(typeof t[n]!="string")return!1;return!0}}),define(Ae[69],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=void 0;class E{constructor(C,M=[],P=!1){this.ctor=C,this.staticArguments=M,this.supportsDelayedInstantiation=P}}e.$Uh=E}),define(Ae[70],Re([1,0,69]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=e.InstantiationType=void 0;const T=[];var C;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function M($,m,y){m instanceof E.$Uh||(m=new E.$Uh(m,[],!!y)),T.push([$,m])}e.$Er=M;function P(){return T}e.$Fr=P}),define(Ae[182],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;class E{constructor(M,P){this.key=M,this.data=P,this.incoming=new Map,this.outgoing=new Map}}e.$jq=E;class T{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const P of this.a.values())P.outgoing.size===0&&M.push(P);return M}insertEdge(M,P){const $=this.lookupOrInsertNode(M),m=this.lookupOrInsertNode(P);$.outgoing.set(m.key,m),m.incoming.set($.key,$)}removeNode(M){const P=this.b(M);this.a.delete(P);for(const $ of this.a.values())$.outgoing.delete(P),$.incoming.delete(P)}lookupOrInsertNode(M){const P=this.b(M);let $=this.a.get(P);return $||($=new E(P,M),this.a.set(P,$)),$}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[P,$]of this.a)M.push(`${P}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,P]of this.a){const $=new Set([M]),m=this.c(P,$);if(m)return m}}c(M,P){for(const[$,m]of M.outgoing){if(P.has($))return[...P,$].join(" -> ");P.add($);const y=this.c(m,P);if(y)return y;P.delete($)}}}e.$kq=T}),define(Ae[4],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=e.$Wh=e._util=void 0;var E;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function $(m){return m[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=$})(E||(e._util=E={})),e.$Wh=C("instantiationService");function T(P,$,m){$[E.DI_TARGET]===$?$[E.DI_DEPENDENCIES].push({id:P,index:m}):($[E.DI_DEPENDENCIES]=[{id:P,index:m}],$[E.DI_TARGET]=$)}function C(P){if(E.serviceIds.has(P))return E.serviceIds.get(P);const $=function(m,y,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T($,m,A)};return $.toString=()=>P,E.serviceIds.set(P,$),$}e.$Xh=C;function M(P){return P}e.$Yh=M}),define(Ae[40],Re([1,0,16,2,4]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.ConfigurationTarget=e.$ti=e.$si=e.$ri=void 0,e.$ri=(0,C.$Xh)("configurationService");function M(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof T.URI)}e.$si=M;function P(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof T.URI)}e.$ti=P;var $;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function m(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ui=m;function y(t){return t.applicationValue!==void 0||t.userValue!==void 0||t.userLocalValue!==void 0||t.userRemoteValue!==void 0||t.workspaceValue!==void 0||t.workspaceFolderValue!==void 0}e.$vi=y;function A(t,n){const o=Object.create(null);for(const c in t)S(o,c,t[c],n);return o}e.$wi=A;function S(t,n,o,c){const d=n.split("."),i=d.pop();let r=t;for(let u=0;u<d.length;u++){const f=d[u];let v=r[f];switch(typeof v){case"undefined":v=r[f]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${d.slice(0,u+1).join(".")} is ${JSON.stringify(v)}`);return}r=v}if(typeof r=="object"&&r!==null)try{r[i]=o}catch{c(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(r)}`)}else c(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(r)}`)}e.$xi=S;function l(t,n){const o=n.split(".");p(t,o)}e.$yi=l;function p(t,n){const o=n.shift();if(n.length===0){delete t[o];return}if(Object.keys(t).indexOf(o)!==-1){const c=t[o];typeof c=="object"&&!Array.isArray(c)&&(p(c,n),Object.keys(c).length===0&&delete t[o])}}function w(t,n,o){function c(r,u){let f=r;for(const v of u){if(typeof f!="object"||f===null)return;f=f[v]}return f}const d=n.split("."),i=c(t,d);return typeof i>"u"?o:i}e.$zi=w;function a(t,n,o){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in t?E.$Ef(t[c])&&E.$Ef(n[c])?a(t[c],n[c],o):o&&(t[c]=n[c]):t[c]=n[c])})}e.$Ai=a;function s(t){return t.replace(/[\[\]]/g,"")}e.$Bi=s}),define(Ae[35],Re([1,0,21,12,180,4,148,11]),function(we,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.ContextKeyExprType=e.$Ti=void 0;const m=new Map;m.set("false",!1),m.set("true",!0),m.set("isMac",E.$j),m.set("isLinux",E.$k),m.set("isWindows",E.$i),m.set("isWeb",E.$o),m.set("isMacNative",E.$j&&!E.$o),m.set("isEdge",E.$H),m.set("isFirefox",E.$F),m.set("isChrome",E.$E),m.set("isSafari",E.$G);function y(Q,U){if(m.get(Q)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");m.set(Q,U)}e.$Ti=y;const A=Object.prototype.hasOwnProperty;var S;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const l={regexParsingWithErrorRecovery:!0},p=(0,P.localize)(0,null),w=(0,P.localize)(1,null),a=(0,P.localize)(2,null),s=(0,P.localize)(3,null),t=(0,P.localize)(4,null),n=(0,P.localize)(5,null),o=(0,P.localize)(6,null),c=(0,P.localize)(7,null);class d{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=l){this.k=U,this.d=new C.$Si,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:w});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const pe=this.D(),re=pe.type===17?n:void 0;throw this.h.push({message:t,offset:pe.offset,lexeme:C.$Si.getLexeme(pe),additionalInfo:re}),d.c}return ne}catch(ne){if(ne!==d.c)throw ne;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ne=this.o();U.push(ne)}return U.length===1?U[0]:i.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ne=this.s();U.push(ne)}return U.length===1?U[0]:i.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),v.INSTANCE;case 12:return this.z(),g.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,s),ne?.negate()}case 17:return this.z(),F.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const ne=this.l();return this.A(1,s),ne}case 17:{const ne=U.lexeme;if(this.z(),this.y(9)){const re=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),re.type!==10)throw this.B("REGEX",re);const le=re.lexeme,ce=le.lastIndexOf("/"),be=ce===le.length-1?void 0:this.w(le.substring(ce+1));let ee;try{ee=new RegExp(le.substring(1,ce),be)}catch{throw this.B("REGEX",re)}return O.create(ne,ee)}switch(re.type){case 10:case 19:{const le=[re.lexeme];this.z();let ce=this.D(),be=0;for(let me=0;me<re.lexeme.length;me++)re.lexeme.charCodeAt(me)===40?be++:re.lexeme.charCodeAt(me)===41&&be--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:be++;break;case 1:be--;break;case 10:case 18:for(let me=0;me<ce.lexeme.length;me++)ce.lexeme.charCodeAt(me)===40?be++:re.lexeme.charCodeAt(me)===41&&be--}if(be<0)break;le.push(C.$Si.getLexeme(ce)),this.z(),ce=this.D()}const ee=le.join(""),fe=ee.lastIndexOf("/"),ie=fe===ee.length-1?void 0:this.w(ee.substring(fe+1));let ae;try{ae=new RegExp(ee.substring(1,fe),ie)}catch{throw this.B("REGEX",re)}return i.regex(ne,ae)}case 18:{const le=re.lexeme;this.z();let ce=null;if(!(0,T.$Fe)(le)){const be=le.indexOf("/"),ee=le.lastIndexOf("/");if(be!==ee&&be>=0){const fe=le.slice(be+1,ee),ie=le[ee+1]==="i"?"i":"";try{ce=new RegExp(fe,ie)}catch{throw this.B("REGEX",re)}}}if(ce===null)throw this.B("REGEX",re);return O.create(ne,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,a);const re=this.u();return i.notIn(ne,re)}switch(this.D().type){case 3:{this.z();const re=this.u();if(this.x().type===18)return i.equals(ne,re);switch(re){case"true":return i.has(ne);case"false":return i.not(ne);default:return i.equals(ne,re)}}case 4:{this.z();const re=this.u();if(this.x().type===18)return i.notEquals(ne,re);switch(re){case"true":return i.not(ne);case"false":return i.has(ne);default:return i.notEquals(ne,re)}}case 5:return this.z(),R.create(ne,this.u());case 6:return this.z(),L.create(ne,this.u());case 7:return this.z(),J.create(ne,this.u());case 8:return this.z(),N.create(ne,this.u());case 13:return this.z(),i.in(ne,this.u());default:return i.has(ne)}}case 20:throw this.h.push({message:o,offset:U.offset,lexeme:"",additionalInfo:c}),d.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ne){if(this.C(U))return this.z();throw this.B(ne,this.D())}B(U,ne,pe){const re=(0,P.localize)(8,null,U,C.$Si.getLexeme(ne)),le=ne.offset,ce=C.$Si.getLexeme(ne);return this.h.push({message:re,offset:le,lexeme:ce,additionalInfo:pe}),d.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ui=d;class i{static false(){return v.INSTANCE}static true(){return g.INSTANCE}static has(U){return D.create(U)}static equals(U,ne){return I.create(U,ne)}static notEquals(U,ne){return k.create(U,ne)}static regex(U,ne){return O.create(U,ne)}static in(U,ne){return h.create(U,ne)}static notIn(U,ne){return b.create(U,ne)}static not(U){return F.create(U)}static and(...U){return $e.create(U,null,!0)}static or(...U){return De.create(U,null,!0)}static greater(U,ne){return J.create(U,ne)}static greaterEquals(U,ne){return N.create(U,ne)}static smaller(U,ne){return R.create(U,ne)}static smallerEquals(U,ne){return L.create(U,ne)}static{this.c=new d({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Vi=i;function r(Q){const U=new d({regexParsingWithErrorRecovery:!1});return Q.map(ne=>(U.parse(ne),U.lexingErrors.length>0?U.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,P.localize)(9,null,pe.additionalInfo):(0,P.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}e.$Wi=r;function u(Q,U){const ne=Q?Q.substituteConstants():void 0,pe=U?U.substituteConstants():void 0;return!ne&&!pe?!0:!ne||!pe?!1:ne.equals(pe)}e.$Xi=u;function f(Q,U){return Q.cmp(U)}class v{static{this.INSTANCE=new v}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return g.INSTANCE}}e.$Yi=v;class g{static{this.INSTANCE=new g}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return v.INSTANCE}}e.$Zi=g;class D{static create(U,ne=null){const pe=m.get(U);return typeof pe=="boolean"?pe?g.INSTANCE:v.INSTANCE:new D(U,ne)}constructor(U,ne){this.key=U,this.c=ne,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:de(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=m.get(this.key);return typeof U=="boolean"?U?g.INSTANCE:v.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$1i=D;class I{static create(U,ne,pe=null){if(typeof ne=="boolean")return ne?D.create(U,pe):F.create(U,pe);const re=m.get(U);return typeof re=="boolean"?ne===(re?"true":"false")?g.INSTANCE:v.INSTANCE:new I(U,ne,pe)}constructor(U,ne,pe){this.c=U,this.d=ne,this.f=pe,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:Ee(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=m.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?g.INSTANCE:v.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$2i=I;class h{static create(U,ne){return new h(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:Ee(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.f),pe=U.getValue(this.d);return Array.isArray(ne)?ne.includes(pe):typeof pe=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.$3i=h;class b{static create(U,ne){return new b(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=11,this.c=h.create(U,ne)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$4i=b;class k{static create(U,ne,pe=null){if(typeof ne=="boolean")return ne?F.create(U,pe):D.create(U,pe);const re=m.get(U);return typeof re=="boolean"?ne===(re?"true":"false")?v.INSTANCE:g.INSTANCE:new k(U,ne,pe)}constructor(U,ne,pe){this.c=U,this.d=ne,this.f=pe,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:Ee(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=m.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?v.INSTANCE:g.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$5i=k;class F{static create(U,ne=null){const pe=m.get(U);return typeof pe=="boolean"?pe?v.INSTANCE:g.INSTANCE:new F(U,ne)}constructor(U,ne){this.c=U,this.d=ne,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:de(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=m.get(this.c);return typeof U=="boolean"?U?v.INSTANCE:g.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.$6i=F;function W(Q,U){if(typeof Q=="string"){const ne=parseFloat(Q);isNaN(ne)||(Q=ne)}return typeof Q=="string"||typeof Q=="number"?U(Q):v.INSTANCE}class J{static create(U,ne,pe=null){return W(ne,re=>new J(U,re,pe))}constructor(U,ne,pe){this.c=U,this.d=ne,this.f=pe,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:Ee(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$7i=J;class N{static create(U,ne,pe=null){return W(ne,re=>new N(U,re,pe))}constructor(U,ne,pe){this.c=U,this.d=ne,this.f=pe,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:Ee(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$8i=N;class R{static create(U,ne,pe=null){return W(ne,re=>new R(U,re,pe))}constructor(U,ne,pe){this.c=U,this.d=ne,this.f=pe,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:Ee(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$9i=R;class L{static create(U,ne,pe=null){return W(ne,re=>new L(U,re,pe))}constructor(U,ne,pe){this.c=U,this.d=ne,this.f=pe,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:Ee(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$0i=L;class O{static create(U,ne){return new O(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ne=this.f?this.f.source:"",pe=U.f?U.f.source:"";return ne<pe?-1:ne>pe?1:0}equals(U){if(U.type===this.type){const ne=this.f?this.f.source:"",pe=U.f?U.f.source:"";return this.d===U.d&&ne===pe}return!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=X.create(this)),this.c}}e.$$i=O;class X{static create(U){return new X(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new X(this.c.map(U))}negate(){return this.c}}e.$_i=X;function he(Q){let U=null;for(let ne=0,pe=Q.length;ne<pe;ne++){const re=Q[ne].substituteConstants();if(Q[ne]!==re&&U===null){U=[];for(let le=0;le<ne;le++)U[le]=Q[le]}U!==null&&(U[ne]=re)}return U===null?Q:U}class $e{static create(U,ne,pe){return $e.d(U,ne,pe)}constructor(U,ne){this.expr=U,this.c=ne,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,pe=this.expr.length;ne<pe;ne++){const re=f(this.expr[ne],U.expr[ne]);if(re!==0)return re}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,pe=this.expr.length;ne<pe;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=he(this.expr);return U===this.expr?this:$e.create(U,this.c,!1)}evaluate(U){for(let ne=0,pe=this.expr.length;ne<pe;ne++)if(!this.expr[ne].evaluate(U))return!1;return!0}static d(U,ne,pe){const re=[];let le=!1;for(const ce of U)if(ce){if(ce.type===1){le=!0;continue}if(ce.type===0)return v.INSTANCE;if(ce.type===6){re.push(...ce.expr);continue}re.push(ce)}if(re.length===0&&le)return g.INSTANCE;if(re.length!==0){if(re.length===1)return re[0];re.sort(f);for(let ce=1;ce<re.length;ce++)re[ce-1].equals(re[ce])&&(re.splice(ce,1),ce--);if(re.length===1)return re[0];for(;re.length>1;){const ce=re[re.length-1];if(ce.type!==9)break;re.pop();const be=re.pop(),ee=re.length===0,fe=De.create(ce.expr.map(ie=>$e.create([ie,be],null,pe)),null,ee);fe&&(re.push(fe),re.sort(f))}if(re.length===1)return re[0];if(pe){for(let ce=0;ce<re.length;ce++)for(let be=ce+1;be<re.length;be++)if(re[ce].negate().equals(re[be]))return v.INSTANCE;if(re.length===1)return re[0]}return new $e(re,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new $e(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());this.c=De.create(U,this,!0)}return this.c}}e.$aj=$e;class De{static create(U,ne,pe){return De.d(U,ne,pe)}constructor(U,ne){this.expr=U,this.c=ne,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,pe=this.expr.length;ne<pe;ne++){const re=f(this.expr[ne],U.expr[ne]);if(re!==0)return re}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,pe=this.expr.length;ne<pe;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=he(this.expr);return U===this.expr?this:De.create(U,this.c,!1)}evaluate(U){for(let ne=0,pe=this.expr.length;ne<pe;ne++)if(this.expr[ne].evaluate(U))return!0;return!1}static d(U,ne,pe){let re=[],le=!1;if(U){for(let ce=0,be=U.length;ce<be;ce++){const ee=U[ce];if(ee){if(ee.type===0){le=!0;continue}if(ee.type===1)return g.INSTANCE;if(ee.type===9){re=re.concat(ee.expr);continue}re.push(ee)}}if(re.length===0&&le)return v.INSTANCE;re.sort(f)}if(re.length!==0){if(re.length===1)return re[0];for(let ce=1;ce<re.length;ce++)re[ce-1].equals(re[ce])&&(re.splice(ce,1),ce--);if(re.length===1)return re[0];if(pe){for(let ce=0;ce<re.length;ce++)for(let be=ce+1;be<re.length;be++)if(re[ce].negate().equals(re[be]))return g.INSTANCE;if(re.length===1)return re[0]}return new De(re,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new De(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());for(;U.length>1;){const ne=U.shift(),pe=U.shift(),re=[];for(const le of se(ne))for(const ce of se(pe))re.push($e.create([le,ce],null,!1));U.unshift(De.create(re,null,!1))}this.c=De.create(U,this,!0)}return this.c}}e.$bj=De;class ke extends D{static{this.d=[]}static all(){return ke.d.values()}constructor(U,ne,pe){super(U,null),this.f=ne,typeof pe=="object"?ke.d.push({...pe,key:U}):pe!==!0&&ke.d.push({key:U,description:pe,type:ne!=null?typeof ne:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return I.create(this.key,U)}notEqualsTo(U){return k.create(this.key,U)}}e.$cj=ke,e.$dj=(0,M.$Xh)("contextKeyService");function de(Q,U){return Q<U?-1:Q>U?1:0}function Ee(Q,U,ne,pe){return Q<ne?-1:Q>ne?1:U<pe?-1:U>pe?1:0}function _(Q,U){if(Q.type===0||U.type===1)return!0;if(Q.type===9)return U.type===9?Ce(Q.expr,U.expr):!1;if(U.type===9){for(const ne of U.expr)if(_(Q,ne))return!0;return!1}if(Q.type===6){if(U.type===6)return Ce(U.expr,Q.expr);for(const ne of Q.expr)if(_(ne,U))return!0;return!1}return Q.equals(U)}e.$ej=_;function Ce(Q,U){let ne=0,pe=0;for(;ne<Q.length&&pe<U.length;){const re=Q[ne].cmp(U[pe]);if(re<0)return!1;re===0&&ne++,pe++}return ne===Q.length}function se(Q){return Q.type===9?Q.expr:[Q]}}),define(Ae[183],Re([1,0,4]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=void 0,e.$5h=(0,E.$Xh)("environmentService"),e.$6h=(0,E.$Yh)(e.$5h)}),define(Ae[96],Re([1,0,150,4]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$fo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=void 0,e.$6n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$7n=new RegExp(e.$6n),e.$8n="__web_extension",e.$9n="skipWalkthrough",e.$0n="extensionsSync",e.$$n="dependecyOrPackExtensionInstall";function C(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$_n=C;function M(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$ao=M;function P(t,n){switch(t){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$bo=P;function $(t,n){return n==="web"&&!t.includes("web")}e.$co=$;function m(t,n,o){return $(n,o)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===o}e.$do=m;function y(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.$eo=y;var A;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var S;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var l;(function(t){t.Install="install",t.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var p;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$fo=(0,T.$Xh)("extensionGalleryService");var w;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.Extract="Extract",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var a;(function(t){t.UnknownError="UnknownError",t.PackageIsInvalidZip="PackageIsInvalidZip",t.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a||(e.ExtensionSignaturetErrorCode=a={}));class s extends Error{constructor(n,o){super(n),this.code=o,this.name=o}}e.$go=s,e.$ho=(0,T.$Xh)("extensionManagementService"),e.$io="extensionsIdentifiers/disabled",e.$jo="extensionsIdentifiers/enabled",e.$ko=(0,T.$Xh)("IGlobalExtensionEnablementService"),e.$lo=(0,T.$Xh)("IExtensionTipsService"),e.$mo=(0,E.localize)(0,null),e.$no={value:e.$mo,original:"Extensions"},e.$oo={value:(0,E.localize)(1,null),original:"Preferences"}}),define(Ae[41],Re([1,0,50,20,12,16,2,152,4,21,13,44]),function(we,e,E,T,C,M,P,$,m,y,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileKind=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileOperationResult=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.FileChangeType=e.$yk=e.FileOperation=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileSystemProviderErrorCode=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.FileSystemProviderCapabilities=e.$ik=e.FilePermission=e.FileType=e.$hk=e.$gk=void 0,e.$gk=(0,m.$Xh)("fileService");function l(_){return _.create===!0}e.$hk=l;var p;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var w;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(w||(e.FilePermission=w={}));function a(_){const Ce=_;return!!Ce&&typeof Ce.onDidChange=="function"}e.$ik=a;var s;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(s||(e.FileSystemProviderCapabilities=s={}));function t(_){return!!(_.capabilities&2)}e.$jk=t;function n(_){return!!(_.capabilities&8)}e.$kk=n;function o(_){return!!(_.capabilities&131072)}e.$lk=o;function c(_){return!!(_.capabilities&4)}e.$mk=c;function d(_){return!!(_.capabilities&16)}e.$nk=d;function i(_){return t(_)?!!(_.capabilities&16384):!1}e.$ok=i;function r(_){return t(_)?!!(_.capabilities&32768):!1}e.$pk=r;function u(_){return!!(_.capabilities&65536)}e.$qk=u;function f(_){return!!(_.capabilities&2048)}e.$rk=f;var v;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class g extends Error{static create(Ce,se){const Q=new g(Ce.toString(),se);return h(Q,se),Q}constructor(Ce,se){super(Ce),this.code=se}}e.$sk=g;function D(_,Ce){return g.create(_,Ce)}e.$tk=D;function I(_){return _||D((0,$.localize)(0,null),v.Unknown)}e.$uk=I;function h(_,Ce){return _.name=Ce?`${Ce} (FileSystemError)`:"FileSystemError",_}e.$vk=h;function b(_){if(!_)return v.Unknown;if(_ instanceof g)return _.code;const Ce=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!Ce)return v.Unknown;switch(Ce[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.$wk=b;function k(_){if(_ instanceof L)return _.fileOperationResult;switch(b(_)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}e.$xk=k;var F;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class W{constructor(Ce,se,Q){this.resource=Ce,this.operation=se,this.target=Q}isOperation(Ce){return this.operation===Ce}}e.$yk=W;var J;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(J||(e.FileChangeType=J={}));class N{static{this.a=null}constructor(Ce,se){this.c=se,this.b=void 0,this.d=new S.$U(()=>{const Q=E.$4h.forUris(()=>this.c);return Q.fill(this.rawAdded.map(U=>[U,!0])),Q}),this.f=new S.$U(()=>{const Q=E.$4h.forUris(()=>this.c);return Q.fill(this.rawUpdated.map(U=>[U,!0])),Q}),this.g=new S.$U(()=>{const Q=E.$4h.forUris(()=>this.c);return Q.fill(this.rawDeleted.map(U=>[U,!0])),Q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Q of Ce){switch(Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}this.b!==N.a&&(typeof Q.cId=="number"?this.b===void 0?this.b=Q.cId:this.b!==Q.cId&&(this.b=N.a):this.b!==void 0&&(this.b=N.a))}}contains(Ce,...se){return this.h(Ce,{includeChildren:!1},...se)}affects(Ce,...se){return this.h(Ce,{includeChildren:!0},...se)}h(Ce,se,...Q){if(!Ce)return!1;const U=Q.length>0;return!!((!U||Q.includes(1))&&(this.d.value.get(Ce)||se.includeChildren&&this.d.value.findSuperstr(Ce))||(!U||Q.includes(0))&&(this.f.value.get(Ce)||se.includeChildren&&this.f.value.findSuperstr(Ce))||(!U||Q.includes(2))&&(this.g.value.findSubstr(Ce)||se.includeChildren&&this.g.value.findSuperstr(Ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ce){return this.b===Ce}hasCorrelation(){return typeof this.b=="number"}}e.$zk=N;function R(_,Ce,se){return!_||!Ce||_===Ce||Ce.length>_.length?!1:(Ce.charAt(Ce.length-1)!==T.sep&&(Ce+=T.sep),se?(0,C.$7e)(_,Ce):_.indexOf(Ce)===0)}e.$Ak=R;class L extends Error{constructor(Ce,se,Q){super(Ce),this.fileOperationResult=se,this.options=Q}}e.$Bk=L;class O extends L{constructor(Ce,se,Q,U){super(Ce,se,U),this.fileOperationResult=se,this.size=Q}}e.$Ck=O;class X extends L{constructor(Ce,se,Q){super(Ce,2,Q),this.stat=se}}e.$Dk=X;var he;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(he||(e.FileOperationResult=he={})),e.$Ek={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Fk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Gk="files.associations",e.$Hk="files.exclude",e.$Ik="files.readonlyInclude",e.$Jk="files.readonlyExclude",e.$Kk="files.readonlyFromPermissions";var $e;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})($e||(e.FileKind=$e={})),e.$Lk="";function De(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Mk=De;async function ke(_,Ce){if(!Ce.hasProvider(P.URI.from({scheme:_.scheme})))return new Promise(se=>{const Q=Ce.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===_.scheme&&U.added&&(Q.dispose(),se())})})}e.$Nk=ke;class de{static{this.KB=1024}static{this.MB=de.KB*de.KB}static{this.GB=de.MB*de.KB}static{this.TB=de.GB*de.KB}static formatSize(Ce){return(0,M.$Gf)(Ce)||(Ce=0),Ce<de.KB?(0,$.localize)(1,null,Ce.toFixed(0)):Ce<de.MB?(0,$.localize)(2,null,(Ce/de.KB).toFixed(2)):Ce<de.GB?(0,$.localize)(3,null,(Ce/de.MB).toFixed(2)):Ce<de.TB?(0,$.localize)(4,null,(Ce/de.GB).toFixed(2)):(0,$.localize)(5,null,(Ce/de.TB).toFixed(2))}}e.$Ok=de;function Ee(_){const Ce=typeof _=="string"||_?.scheme===A.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===A.Schemas.file?1024*de.MB:Ce?10*de.MB:y.$o?50*de.MB:1024*de.MB}e.$Pk=Ee}),define(Ae[71],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=void 0;class E{constructor(...C){this.a=new Map;for(const[M,P]of C)this.set(M,P)}set(C,M){const P=this.a.get(C);return this.a.set(C,M),P}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Vh=E}),define(Ae[184],Re([1,0,14,11,6,69,182,4,71,185]),function(we,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=void 0;const A=!1;class S extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class l{constructor(s=new m.$Vh,t=!1,n,o=A){this.f=s,this.g=t,this.h=n,this.i=o,this.o=new Set,this.f.set($.$Wh,this),this._globalGraph=o?n?._globalGraph??new P.$kq(c=>c):void 0}createChild(s){return new l(s,this.g,this,this.i)}invokeFunction(s,...t){const n=w.traceInvocation(this.i,s);let o=!1;try{return s({get:d=>{if(o)throw(0,T.$7)("service accessor is only valid during the invocation of its target method");const i=this.m(d,n);if(!i)throw new Error(`[invokeFunction] unknown service '${d}'`);return i}},...t)}finally{o=!0,n.stop()}}createInstance(s,...t){let n,o;return s instanceof M.$Uh?(n=w.traceCreation(this.i,s.ctor),o=this.j(s.ctor,s.staticArguments.concat(t),n)):(n=w.traceCreation(this.i,s),o=this.j(s,t,n)),n.stop(),o}j(s,t=[],n){const o=$._util.getServiceDependencies(s).sort((i,r)=>i.index-r.index),c=[];for(const i of o){const r=this.m(i.id,n);r||this.u(`[createInstance] ${s.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(r)}const d=o.length>0?o[0].index:t.length;if(t.length!==d){console.trace(`[createInstance] First service dependency of ${s.name} at position ${d+1} conflicts with ${t.length} static arguments`);const i=d-t.length;i>0?t=t.concat(new Array(i)):t=t.slice(0,d)}return Reflect.construct(s,t.concat(c))}k(s,t){if(this.f.get(s)instanceof M.$Uh)this.f.set(s,t);else if(this.h)this.h.k(s,t);else throw new Error("illegalState - setting UNKNOWN service instance")}l(s){const t=this.f.get(s);return!t&&this.h?this.h.l(s):t}m(s,t){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const n=this.l(s);return n instanceof M.$Uh?this.q(s,n,t.branch(s,!0)):(t.branch(s,!1),n)}q(s,t,n){if(this.o.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.o.add(s);try{return this.r(s,t,n)}finally{this.o.delete(s)}}r(s,t,n){const o=new P.$kq(i=>i.id.toString());let c=0;const d=[{id:s,desc:t,_trace:n}];for(;d.length;){const i=d.pop();if(o.lookupOrInsertNode(i),c++>1e3)throw new S(o);for(const r of $._util.getServiceDependencies(i.desc.ctor)){const u=this.l(r.id);if(u||this.u(`[createInstance] ${s} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),u instanceof M.$Uh){const f={id:r.id,desc:u,_trace:i._trace.branch(r.id,!0)};o.insertEdge(i,f),d.push(f)}}}for(;;){const i=o.roots();if(i.length===0){if(!o.isEmpty())throw new S(o);break}for(const{data:r}of i){if(this.l(r.id)instanceof M.$Uh){const f=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,f)}o.removeNode(r)}}return this.l(s)}s(s,t,n=[],o,c){if(this.f.get(s)instanceof M.$Uh)return this.t(s,t,n,o,c);if(this.h)return this.h.s(s,t,n,o,c);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}t(s,t,n=[],o,c){if(o){const d=new l(void 0,this.g,this,this.i);d.c=String(s);const i=new Map,r=new E.$gh(()=>{const u=d.j(t,n,c);for(const[f,v]of i){const g=u[f];if(typeof g=="function")for(const D of v)g.apply(u,D)}return i.clear(),u});return new Proxy(Object.create(null),{get(u,f){if(!r.isInitialized&&typeof f=="string"&&(f.startsWith("onDid")||f.startsWith("onWill"))){let D=i.get(f);return D||(D=new y.$2c,i.set(f,D)),(h,b,k)=>{const F=D.push([h,b,k]);return(0,C.$Pc)(F)}}if(f in u)return u[f];const v=r.value;let g=v[f];return typeof g!="function"||(g=g.bind(v),u[f]=g),g},set(u,f,v){return r.value[f]=v,!0},getPrototypeOf(u){return t.prototype}})}else return this.j(t,n,c)}u(s,t){if(t&&console.warn(s),this.g)throw new Error(s)}}e.$lq=l;var p;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(p||(p={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(s,t){return s?new w(2,t.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(s,t){return s?new w(1,t.name):w.c}static{this.f=0}constructor(s,t){this.type=s,this.name=t,this.g=Date.now(),this.h=[]}branch(s,t){const n=new w(3,s.toString());return this.h.push([s,t,n]),n}stop(){const s=Date.now()-this.g;w.f+=s;let t=!1;function n(c,d){const i=[],r=new Array(c+1).join("	");for(const[u,f,v]of d.h)if(f&&v){t=!0,i.push(`${r}CREATES -> ${u}`);const g=n(c+1,v);g&&i.push(g)}else i.push(`${r}uses -> ${u}`);return i.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(s>2||t)&&w.all.add(o.join(`
`))}}e.$mq=w}),define(Ae[15],Re([1,0,39,5,97,6,28,21,25,16,2,35,4]),function(we,e,E,T,C,M,P,$,m,y,A,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.log=e.$ij=e.LogLevel=e.$hj=e.$gj=e.$fj=void 0,e.$fj=(0,l.$Xh)("logService"),e.$gj=(0,l.$Xh)("loggerService");function p(){return new Date().toISOString()}function w(h){return(0,y.$Gf)(h)}e.$hj=w;var a;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(a||(e.LogLevel=a={})),e.$ij=a.Info;function s(h,b,k){switch(b){case a.Trace:h.trace(k);break;case a.Debug:h.debug(k);break;case a.Info:h.info(k);break;case a.Warning:h.warn(k);break;case a.Error:h.error(k);break;case a.Off:break;default:throw new Error(`Invalid log level ${b}`)}}e.log=s;function t(h,b=!1){let k="";for(let F=0;F<h.length;F++){let W=h[F];if(W instanceof Error&&(W=(0,E.$Ii)(W,b)),typeof W=="object")try{W=JSON.stringify(W)}catch{}k+=(F>0?" ":"")+W}return k}class n extends M.$Rc{constructor(){super(...arguments),this.b=e.$ij,this.c=this.B(new T.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==a.Off&&this.b<=b}}e.$kj=n;class o extends n{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...k){this.f(a.Trace)&&this.g(a.Trace,t([b,...k],!0))}debug(b,...k){this.f(a.Debug)&&this.g(a.Debug,t([b,...k]))}info(b,...k){this.f(a.Info)&&this.g(a.Info,t([b,...k]))}warn(b,...k){this.f(a.Warning)&&this.g(a.Warning,t([b,...k]))}error(b,...k){if(this.f(a.Error))if(b instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=b.stack,this.g(a.Error,t(F))}else this.g(a.Error,t([b,...k]))}flush(){}}e.$lj=o;class c extends n{constructor(b=e.$ij){super(),this.setLevel(b),this.g=!$.$i}trace(b,...k){this.f(a.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,b,...k):console.log(`[main ${p()}]`,b,...k))}debug(b,...k){this.f(a.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,b,...k):console.log(`[main ${p()}]`,b,...k))}info(b,...k){this.f(a.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,b,...k):console.log(`[main ${p()}]`,b,...k))}warn(b,...k){this.f(a.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,b,...k):console.warn(`[main ${p()}]`,b,...k))}error(b,...k){this.f(a.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,b,...k):console.error(`[main ${p()}]`,b,...k))}dispose(){}flush(){}}e.$mj=c;class d extends n{constructor(b=e.$ij,k=!0){super(),this.g=k,this.setLevel(b)}trace(b,...k){this.f(a.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...k):console.log(b,...k))}debug(b,...k){this.f(a.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...k):console.log(b,...k))}info(b,...k){this.f(a.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...k):console.log(b,...k))}warn(b,...k){this.f(a.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...k):console.log(b,...k))}error(b,...k){this.f(a.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...k):console.error(b,...k))}dispose(){}flush(){}}e.$nj=d;class i extends n{constructor(b,k=e.$ij){super(),this.g=b,this.setLevel(k)}trace(b,...k){this.f(a.Trace)&&this.g.log(a.Trace,[this.h(b),...k])}debug(b,...k){this.f(a.Debug)&&this.g.log(a.Debug,[this.h(b),...k])}info(b,...k){this.f(a.Info)&&this.g.log(a.Info,[this.h(b),...k])}warn(b,...k){this.f(a.Warning)&&this.g.log(a.Warning,[this.h(b),...k])}error(b,...k){this.f(a.Error)&&this.g.log(a.Error,[this.h(b),...k])}h(b){return typeof b=="string"?b:(0,E.$Ii)(b,this.f(a.Trace))}dispose(){}flush(){}}e.$oj=i;class r extends n{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const k of this.g)k.setLevel(b);super.setLevel(b)}trace(b,...k){for(const F of this.g)F.trace(b,...k)}debug(b,...k){for(const F of this.g)F.debug(b,...k)}info(b,...k){for(const F of this.g)F.info(b,...k)}warn(b,...k){for(const F of this.g)F.warn(b,...k)}error(b,...k){for(const F of this.g)F.error(b,...k)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose()}}e.$pj=r;class u extends M.$Rc{constructor(b,k,F){if(super(),this.h=b,this.j=k,this.b=new P.$zc,this.c=this.B(new T.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Rd),this.onDidChangeVisibility=this.g.event,F)for(const W of F)this.b.set(W.resource,{logger:void 0,info:W})}m(b){return(0,y.$Cf)(b)?[...this.b.values()].find(k=>k.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,k){const F=this.n(b),W=(0,y.$Cf)(b)?b:k?.id??(0,C.$Li)(F.toString()).toString(16);let J=this.b.get(F)?.logger;const N=k?.logLevel==="always"?a.Trace:k?.logLevel;J||(J=this.s(F,N??this.getLogLevel(F)??this.h,{...k,id:W}));const R={logger:J,info:{resource:F,id:W,logLevel:N,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(R.info),this.b.set(F,R),J}n(b){return(0,y.$Cf)(b)?(0,m.$Bg)(this.j,`${b}.log`):b}setLogLevel(b,k){if(A.URI.isUri(b)){const F=b,W=k,J=this.b.get(F);J&&W!==J.info.logLevel&&(J.info.logLevel=W===this.h?void 0:W,J.logger?.setLevel(W),this.b.set(J.info.resource,J),this.f.fire([F,W]))}else{this.h=b;for(const[F,W]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,k){const F=this.m(b);F&&k!==!F.info.hidden&&(F.info.hidden=!k,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,k]))}getLogLevel(b){let k;return b&&(k=this.b.get(b)?.info.logLevel),k??this.h}registerLogger(b){const k=this.b.get(b.resource);k?k.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const k=this.b.get(b);k&&(k.logger&&k.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$qj=u;class f{constructor(){this.onDidChangeLogLevel=new T.$Rd().event}setLevel(b){}getLevel(){return a.Info}trace(b,...k){}debug(b,...k){}info(b,...k){}warn(b,...k){}error(b,...k){}critical(b,...k){}dispose(){}flush(){}}e.$rj=f;class v extends f{}e.$sj=v;function g(h){if(h.verbose)return a.Trace;if(typeof h.logLevel=="string"){const b=I(h.logLevel.toLowerCase());if(b!==void 0)return b}return e.$ij}e.$tj=g;function D(h){switch(h){case a.Trace:return"trace";case a.Debug:return"debug";case a.Info:return"info";case a.Warning:return"warn";case a.Error:return"error";case a.Off:return"off"}}e.$uj=D;function I(h){switch(h){case"trace":return a.Trace;case"debug":return a.Debug;case"info":return a.Info;case"warn":return a.Warning;case"error":return a.Error;case"critical":return a.Error;case"off":return a.Off}}e.$vj=I,e.$wj=new S.$cj("logLevel",D(a.Info))}),define(Ae[186],Re([1,0,6,15]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YN=void 0;class C extends E.$Rc{constructor(P,$=[]){super(),this.a=new T.$pj([P,...$]),this.B(P.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(P){this.a.setLevel(P)}getLevel(){return this.a.getLevel()}trace(P,...$){this.a.trace(P,...$)}debug(P,...$){this.a.debug(P,...$)}info(P,...$){this.a.info(P,...$)}warn(P,...$){this.a.warn(P,...$)}error(P,...$){this.a.error(P,...$)}flush(){this.a.flush()}}e.$YN=C}),define(Ae[98],Re([1,0,31,153,4]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var P;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(P||(e.MarkerSeverity=P={})),function(m){function y(w,a){return a-w}m.compare=y;const A=Object.create(null);A[m.Error]=(0,T.localize)(0,null),A[m.Warning]=(0,T.localize)(1,null),A[m.Info]=(0,T.localize)(2,null);function S(w){return A[w]||""}m.toString=S;function l(w){switch(w){case E.default.Error:return m.Error;case E.default.Warning:return m.Warning;case E.default.Info:return m.Info;case E.default.Ignore:return m.Hint}}m.fromSeverity=l;function p(w){switch(w){case m.Error:return E.default.Error;case m.Warning:return E.default.Warning;case m.Info:return E.default.Info;case m.Hint:return E.default.Ignore}}m.toSeverity=p}(P||(e.MarkerSeverity=P={}));var $;(function(m){const y="";function A(l){return S(l,!0)}m.makeKey=A;function S(l,p){const w=[y];return l.source?w.push(l.source.replace("\xA6","\\\xA6")):w.push(y),l.code?typeof l.code=="string"?w.push(l.code.replace("\xA6","\\\xA6")):w.push(l.code.value.replace("\xA6","\\\xA6")):w.push(y),l.severity!==void 0&&l.severity!==null?w.push(P.toString(l.severity)):w.push(y),l.message&&p?w.push(l.message.replace("\xA6","\\\xA6")):w.push(y),l.startLineNumber!==void 0&&l.startLineNumber!==null?w.push(l.startLineNumber.toString()):w.push(y),l.startColumn!==void 0&&l.startColumn!==null?w.push(l.startColumn.toString()):w.push(y),l.endLineNumber!==void 0&&l.endLineNumber!==null?w.push(l.endLineNumber.toString()):w.push(y),l.endColumn!==void 0&&l.endColumn!==null?w.push(l.endColumn.toString()):w.push(y),w.push(y),w.join("\xA6")}m.makeKeyOptionalMessage=S})($||(e.IMarkerData=$={})),e.$ht=(0,C.$Xh)("markerService")}),define(Ae[187],Re([1,0,5,31,4]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0u=e.$9u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$8u=e.Severity=void 0,e.Severity=T.default,e.$8u=(0,C.$Xh)("notificationService");var M;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var P;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(P||(e.NeverShowAgainScope=P={}));var $;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class m{constructor(){this.progress=new y,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(S){}updateMessage(S){}updateActions(S){}close(){}}e.$9u=m;class y{infinite(){}done(){}total(S){}worked(S){}}e.$0u=y}),define(Ae[188],Re([1,0,4]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=void 0,e.$xj=(0,E.$Xh)("productService"),e.$yj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(we,e,E,T){var C=arguments.length,M=C<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,E):T,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(we,e,E,T);else for(var $=we.length-1;$>=0;$--)(P=we[$])&&(M=(C<3?P(M):C>3?P(e,E,M):P(e,E))||M);return C>3&&M&&Object.defineProperty(e,E,M),M},We=this&&this.__param||function(we,e){return function(E,T){e(E,T,we)}};define(Ae[72],Re([1,0,14,19,6,4]),function(we,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ev=e.$dv=e.$cv=e.$bv=e.$av=e.$_u=e.ProgressLocation=e.$$u=void 0,e.$$u=(0,M.$Xh)("progressService");var P;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(P||(e.ProgressLocation=P={})),e.$_u=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$av=$;class m{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const p=this.d;this.d=()=>{p?.(),l()}}):Promise.resolve()}}e.$bv=m;let y=class extends C.$Rc{constructor(l,p){super(),this.a=new E.$kh,p.withProgress(l,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,C.$Pc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$cv=y,e.$cv=y=Ke([We(1,e.$$u)],y);class A extends C.$Rc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new C.$Qc)}start(l){this.stop();const p=++this.a,w=new T.$2d;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,C.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Pc)(()=>w.cancel())),this.b.add((0,C.$Pc)(()=>this.c?this.c.done():void 0)),{id:p,token:w.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$dv=A,e.$ev=(0,M.$Xh)("editorProgressService")}),define(Ae[30],Re([1,0,53,16]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=void 0;class C{constructor(){this.a=new Map}add(P,$){E.ok(T.$Cf(P)),E.ok(T.$Ef($)),E.ok(!this.a.has(P),"There is already an extension with this id"),this.a.set(P,$)}knows(P){return this.a.has(P)}as(P){return this.a.get(P)||null}}e.$on=new C}),define(Ae[73],Re([1,0,5,30]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=void 0,e.$pn={JSONContribution:"base.contributions.json"};function C($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class M{constructor(){this.b=new E.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,y){this.a[C(m)]=y,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const P=new M;T.$on.add(e.$pn.JSONContribution,P)}),define(Ae[54],Re([1,0,18,5,16,147,40,73,30]),function(we,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.ConfigurationScope=e.$tn=e.EditPresentationTypes=void 0;var y;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$tn={Configuration:"base.contributions.configuration"};var A;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn={properties:{},patternProperties:{}},e.$zn={properties:{},patternProperties:{}},e.$An="vscode://schemas/settings/resourceLanguage",e.$Bn="vscode://schemas/settings/configurationDefaults";const S=m.$on.as($.$pn.JSONContribution);class l{constructor(){this.h=new Set,this.i=new T.$Rd,this.onDidSchemaChange=this.i.event,this.j=new T.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$An,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const u=new Set;this.n(i,r,u),S.registerSchema(e.$An,this.g),this.i.fire(),this.j.fire({properties:u})}deregisterConfigurations(i){const r=new Set;this.o(i,r),S.registerSchema(e.$An,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const u=new Set;this.o(r,u),this.n(i,!1,u),S.registerSchema(e.$An,this.g),this.i.fire(),this.j.fire({properties:u})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const u=[];for(const{overrides:f,source:v}of i)for(const g in f)if(r.add(g),e.$Dn.test(g)){const D=this.a.get(g),I=D?.valuesSources??new Map;if(v)for(const F of Object.keys(f[g]))I.set(F,v);const h={...D?.value||{},...f[g]};this.a.set(g,{source:v,value:h,valuesSources:I});const b=(0,P.$Bi)(g),k={type:"object",default:h,description:M.localize(1,null,b),$ref:e.$An,defaultDefaultValue:h,source:C.$Cf(v)?void 0:v,defaultValueSource:v};u.push(...a(g)),this.d[g]=k,this.b.properties[g]=k}else{this.a.set(g,{value:f[g],source:v});const D=this.d[g];D&&(this.w(g,D),this.r(g,D))}this.m(u)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:u,source:f}of i)for(const v in u){const g=this.a.get(v),D=C.$Cf(f)?f:f?.id,I=C.$Cf(g?.source)?g?.source:g?.source?.id;if(D===I)if(r.add(v),this.a.delete(v),e.$Dn.test(v))delete this.d[v],delete this.b.properties[v];else{const h=this.d[v];h&&(this.w(v,h),this.r(v,h))}}this.u()}deltaConfiguration(i){let r=!1;const u=new Set;i.removedDefaults&&(this.l(i.removedDefaults,u),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,u),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,u),i.addedConfigurations&&this.n(i.addedConfigurations,!1,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,u){i.forEach(f=>{this.p(f,r,f.extensionInfo,f.restrictedProperties,void 0,u),this.c.push(f),this.q(f)})}o(i,r){const u=f=>{if(f.properties)for(const v in f.properties){r.add(v);const g=this.d[v];g?.policy?.name&&this.e.delete(g.policy.name),delete this.d[v],this.s(v,f.properties[v])}f.allOf?.forEach(v=>u(v))};for(const f of i){u(f);const v=this.c.indexOf(f);v!==-1&&this.c.splice(v,1)}}p(i,r=!0,u,f,v=3,g){v=C.$Lf(i.scope)?v:i.scope;const D=i.properties;if(D)for(const h in D){const b=D[h];if(r&&o(h,b)){delete D[h];continue}if(b.source=u,b.defaultDefaultValue=D[h].default,this.w(h,b),e.$Dn.test(h)?b.scope=void 0:(b.scope=C.$Lf(b.scope)?v:b.scope,b.restricted=C.$Lf(b.restricted)?!!f?.includes(h):b.restricted),D[h].hasOwnProperty("included")&&!D[h].included){this.f[h]=D[h],delete D[h];continue}else this.d[h]=D[h],D[h].policy?.name&&this.e.set(D[h].policy.name,h);!D[h].deprecationMessage&&D[h].markdownDeprecationMessage&&(D[h].deprecationMessage=D[h].markdownDeprecationMessage),g.add(h)}const I=i.allOf;if(I)for(const h of I)this.p(h,r,u,f,v,g)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=u=>{const f=u.properties;if(f)for(const g in f)this.r(g,f[g]);u.allOf?.forEach(r)};r(i)}r(i,r){switch(e.$un.properties[i]=r,r.scope){case 1:e.$vn.properties[i]=r;break;case 2:e.$wn.properties[i]=r;break;case 6:e.$xn.properties[i]=r;break;case 3:e.$yn.properties[i]=r;break;case 4:e.$zn.properties[i]=r;break;case 5:e.$zn.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.$un.properties[i],r.scope){case 1:delete e.$vn.properties[i];break;case 2:delete e.$wn.properties[i];break;case 6:delete e.$xn.properties[i];break;case 3:delete e.$yn.properties[i];break;case 4:case 5:delete e.$zn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,u={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$An};this.w(r,u),e.$un.properties[r]=u,e.$vn.properties[r]=u,e.$wn.properties[r]=u,e.$xn.properties[r]=u,e.$yn.properties[r]=u,e.$zn.properties[r]=u}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$An};e.$un.patternProperties[e.$Cn]=i,e.$vn.patternProperties[e.$Cn]=i,e.$wn.patternProperties[e.$Cn]=i,e.$xn.patternProperties[e.$Cn]=i,e.$yn.patternProperties[e.$Cn]=i,e.$zn.patternProperties[e.$Cn]=i,this.i.fire()}w(i,r){const u=this.a.get(i);let f=u?.value,v=u?.source;C.$Jf(f)&&(f=r.defaultDefaultValue,v=void 0),C.$Jf(f)&&(f=t(r.type)),r.default=f,r.defaultValueSource=v}}const p="\\[([^\\]]+)\\]",w=new RegExp(p,"g");e.$Cn=`^(${p})+$`,e.$Dn=new RegExp(e.$Cn);function a(d){const i=[];if(e.$Dn.test(d)){let r=w.exec(d);for(;r?.length;){const u=r[1].trim();u&&i.push(u),r=w.exec(d)}}return(0,E.$Lb)(i)}e.$En=a;function s(d){return d.reduce((i,r)=>`${i}[${r}]`,"")}e.$Fn=s;function t(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Gn=t;const n=new l;m.$on.add(e.$tn.Configuration,n);function o(d,i){return d.trim()?e.$Dn.test(d)?M.localize(7,null,d):n.getConfigurationProperties()[d]!==void 0?M.localize(8,null,d):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,d,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.$Hn=o;function c(){const d=[],i=n.getConfigurationProperties();for(const r of Object.keys(i))d.push([r,i[r].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.$In=c}),define(Ae[189],Re([1,0,18,5,118,6,28,26,16,2,40,54,30]),function(we,e,E,T,C,M,P,$,m,y,A,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=void 0;function p(r){return Object.isFrozen(r)?r:$.$dn(r)}class w{constructor(u={},f=[],v=[],g){this.b=u,this.c=f,this.d=v,this.raw=g,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const u=this.raw.map(f=>{if(f instanceof w)return f;const v=new a("");return v.parseRaw(f),v.configurationModel});this.f=u.reduce((f,v)=>v===f?v:f.merge(v),u[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,A.$zi)(this.contents,u):this.contents}inspect(u,f){const v=this.rawConfiguration.getValue(u),g=f?this.rawConfiguration.getOverrideValue(u,f):void 0,D=f?this.rawConfiguration.override(f).getValue(u):v;return{value:v,override:g,merged:D}}getOverrideValue(u,f){const v=this.i(f);return v?u?(0,A.$zi)(v,u):v:void 0}getKeysForOverrideIdentifier(u){const f=[];for(const v of this.overrides)v.identifiers.includes(u)&&f.push(...v.keys);return E.$Lb(f)}getAllOverrideIdentifiers(){const u=[];for(const f of this.overrides)u.push(...f.identifiers);return E.$Lb(u)}override(u){let f=this.a.get(u);return f||(f=this.g(u),this.a.set(u,f)),f}merge(...u){const f=$.$cn(this.contents),v=$.$cn(this.overrides),g=[...this.keys],D=this.raw?.length?[...this.raw]:[this];for(const I of u)if(D.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(f,I.contents);for(const h of I.overrides){const[b]=v.filter(k=>E.$tb(k.identifiers,h.identifiers));b?(this.h(b.contents,h.contents),b.keys.push(...h.keys),b.keys=E.$Lb(b.keys)):v.push($.$cn(h))}for(const h of I.keys)g.indexOf(h)===-1&&g.push(h)}return new w(f,g,v,D.every(I=>I instanceof w)?void 0:D)}g(u){const f=this.i(u);if(!f||typeof f!="object"||!Object.keys(f).length)return this;const v={};for(const g of E.$Lb([...Object.keys(this.contents),...Object.keys(f)])){let D=this.contents[g];const I=f[g];I&&(typeof D=="object"&&typeof I=="object"?(D=$.$cn(D),this.h(D,I)):D=I),v[g]=D}return new w(v,this.keys,this.overrides)}h(u,f){for(const v of Object.keys(f)){if(v in u&&m.$Ef(u[v])&&m.$Ef(f[v])){this.h(u[v],f[v]);continue}u[v]=$.$cn(f[v])}}i(u){let f=null,v=null;const g=D=>{D&&(v?this.h(v,D):v=$.$cn(D))};for(const D of this.overrides)D.identifiers.length===1&&D.identifiers[0]===u?f=D.contents:D.identifiers.includes(u)&&g(D.contents);return g(f),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,f){this.j(u,f,!0)}setValue(u,f){this.j(u,f,!1)}removeValue(u){const f=this.keys.indexOf(u);f!==-1&&(this.keys.splice(f,1),(0,A.$yi)(this.contents,u),S.$Dn.test(u)&&this.overrides.splice(this.overrides.findIndex(v=>E.$tb(v.identifiers,(0,S.$En)(u))),1))}j(u,f,v){(0,A.$xi)(this.contents,u,f,g=>console.error(g)),v=v||this.keys.indexOf(u)===-1,v&&this.keys.push(u),S.$Dn.test(u)&&this.overrides.push({identifiers:(0,S.$En)(u),keys:Object.keys(this.contents[u]),contents:(0,A.$wi)(this.contents[u],g=>console.error(g))})}}e.$Jn=w;class a{constructor(u){this.f=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new w}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,f){if(!m.$Lf(u)){const v=this.g(u);this.parseRaw(v,f)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,f){this.a=u;const{contents:v,keys:g,overrides:D,restricted:I,hasExcludedProperties:h}=this.h(u,f);this.b=new w(v,g,D,h?[u]:void 0),this.c=I||[]}g(u){let f={},v=null,g=[];const D=[],I=[];function h(k){Array.isArray(g)?g.push(k):v!==null&&(g[v]=k)}const b={onObjectBegin:()=>{const k={};h(k),D.push(g),g=k,v=null},onObjectProperty:k=>{v=k},onObjectEnd:()=>{g=D.pop()},onArrayBegin:()=>{const k=[];h(k),D.push(g),g=k,v=null},onArrayEnd:()=>{g=D.pop()},onLiteralValue:h,onError:(k,F,W)=>{I.push({error:k,offset:F,length:W})}};if(u)try{C.$_m(u,b),f=g[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return f}h(u,f){const v=l.$on.as(S.$tn.Configuration).getConfigurationProperties(),g=this.i(u,v,!0,f);u=g.raw;const D=(0,A.$wi)(u,b=>console.error(`Conflict in settings file ${this.f}: ${b}`)),I=Object.keys(u),h=this.j(u,b=>console.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:D,keys:I,overrides:h,restricted:g.restricted,hasExcludedProperties:g.hasExcludedProperties}}i(u,f,v,g){let D=!1;if(!g?.scopes&&!g?.skipRestricted&&!g?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:D};const I={},h=[];for(const b in u)if(S.$Dn.test(b)&&v){const k=this.i(u[b],f,!1,g);I[b]=k.raw,D=D||k.hasExcludedProperties,h.push(...k.restricted)}else{const k=f[b],F=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&h.push(b),!g.exclude?.includes(b)&&(g.include?.includes(b)||(F===void 0||g.scopes===void 0||g.scopes.includes(F))&&!(g.skipRestricted&&k?.restricted))?I[b]=u[b]:D=!0}return{raw:I,restricted:h,hasExcludedProperties:D}}j(u,f){const v=[];for(const g of Object.keys(u))if(S.$Dn.test(g)){const D={};for(const I in u[g])D[I]=u[g][I];v.push({identifiers:(0,S.$En)(g),keys:Object.keys(D),contents:(0,A.$wi)(D,f)})}return v}}e.$Kn=a;class s extends M.$Rc{constructor(u,f,v,g){super(),this.c=u,this.f=f,this.g=g,this.b=this.B(new T.$Rd),this.onDidChange=this.b.event,this.a=new a(this.c.toString()),this.B(this.g.watch(v.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(0)||D.isOperation(3)||D.isOperation(1)||D.isOperation(4))&&v.isEqual(D.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new w}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Ln=s;class t{constructor(u,f,v,g,D,I,h,b,k,F,W,J,N){this.a=u,this.b=f,this.c=v,this.overrideIdentifiers=g,this.d=D,this.f=I,this.g=h,this.h=b,this.i=k,this.j=F,this.k=W,this.l=J,this.m=N}get value(){return p(this.c)}n(u,f,v){const g=u.inspect(f,v);return{get value(){return p(g.value)},get override(){return p(g.override)},get merged(){return p(g.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(u,f,v,g,D=new w,I=new w,h=new P.$zc,b=new w,k=new P.$zc){this.c=u,this.d=f,this.f=v,this.g=g,this.h=D,this.i=I,this.j=h,this.l=b,this.m=k,this.a=null,this.b=new P.$zc,this.n=null}getValue(u,f,v){return this.p(u,f,v).getValue(u)}updateValue(u,f,v={}){let g;v.resource?(g=this.m.get(v.resource),g||(g=new w,this.m.set(v.resource,g))):g=this.l,f===void 0?g.removeValue(u):g.setValue(u,f),v.resource||(this.a=null)}inspect(u,f,v){const g=this.p(u,f,v),D=this.t(f.resource,v),I=f.resource?this.m.get(f.resource)||this.l:this.l,h=new Set;for(const b of g.overrides)for(const k of b.identifiers)g.getOverrideValue(u,k)!==void 0&&h.add(k);return new t(u,f,g.getValue(u),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,v?this.i:void 0,D||void 0,I)}keys(u){const f=this.t(void 0,u);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:f?f.keys.slice(0):[]}}updateDefaultConfiguration(u){this.c=u,this.a=null,this.b.clear()}updatePolicyConfiguration(u){this.d=u}updateApplicationConfiguration(u){this.f=u,this.a=null,this.b.clear()}updateLocalUserConfiguration(u){this.g=u,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(u){this.h=u,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(u){this.i=u,this.a=null,this.b.clear()}updateFolderConfiguration(u,f){this.j.set(u,f),this.b.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.b.delete(u)}compareAndUpdateDefaultConfiguration(u,f){const v=[];if(!f){const{added:g,updated:D,removed:I}=d(this.c,u);f=[...g,...D,...I]}for(const g of f)for(const D of(0,S.$En)(g)){const I=this.c.getKeysForOverrideIdentifier(D),h=u.getKeysForOverrideIdentifier(D),b=[...h.filter(k=>I.indexOf(k)===-1),...I.filter(k=>h.indexOf(k)===-1),...I.filter(k=>!$.$gn(this.c.override(D).getValue(k),u.override(D).getValue(k)))];v.push([D,b])}return this.updateDefaultConfiguration(u),{keys:f,overrides:v}}compareAndUpdatePolicyConfiguration(u){const{added:f,updated:v,removed:g}=d(this.d,u),D=[...f,...v,...g];return D.length&&this.updatePolicyConfiguration(u),{keys:D,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:f,updated:v,removed:g,overrides:D}=d(this.applicationConfiguration,u),I=[...f,...v,...g];return I.length&&this.updateApplicationConfiguration(u),{keys:I,overrides:D}}compareAndUpdateLocalUserConfiguration(u){const{added:f,updated:v,removed:g,overrides:D}=d(this.localUserConfiguration,u),I=[...f,...v,...g];return I.length&&this.updateLocalUserConfiguration(u),{keys:I,overrides:D}}compareAndUpdateRemoteUserConfiguration(u){const{added:f,updated:v,removed:g,overrides:D}=d(this.remoteUserConfiguration,u),I=[...f,...v,...g];return I.length&&this.updateRemoteUserConfiguration(u),{keys:I,overrides:D}}compareAndUpdateWorkspaceConfiguration(u){const{added:f,updated:v,removed:g,overrides:D}=d(this.workspaceConfiguration,u),I=[...f,...v,...g];return I.length&&this.updateWorkspaceConfiguration(u),{keys:I,overrides:D}}compareAndUpdateFolderConfiguration(u,f){const v=this.folderConfigurations.get(u),{added:g,updated:D,removed:I,overrides:h}=d(v,f),b=[...g,...D,...I];return(b.length||!v)&&this.updateFolderConfiguration(u,f),{keys:b,overrides:h}}compareAndDeleteFolderConfiguration(u){const f=this.folderConfigurations.get(u);if(!f)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:v,updated:g,removed:D,overrides:I}=d(f,void 0);return{keys:[...v,...g,...D],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(u,f,v){let g=this.q(f,v);return f.overrideIdentifier&&(g=g.override(f.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(u)!==void 0&&(g=g.merge(this.d)),g}q({resource:u},f){let v=this.r();if(f&&u){const g=f.getFolder(u);g&&(v=this.s(g.uri)||v);const D=this.m.get(u);D&&(v=v.merge(D))}return v}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(u){let f=this.b.get(u);if(!f){const v=this.r(),g=this.j.get(u);g?(f=v.merge(g),this.b.set(u,f)):f=v}return f}t(u,f){if(f&&u){const v=f.getFolder(u);if(v)return this.j.get(v.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((u,f)=>{const{contents:v,overrides:g,keys:D}=this.j.get(f);return u.push([f,{contents:v,overrides:g,keys:D}]),u},[])}}allKeys(){const u=new Set;return this.c.keys.forEach(f=>u.add(f)),this.userConfiguration.keys.forEach(f=>u.add(f)),this.i.keys.forEach(f=>u.add(f)),this.j.forEach(f=>f.keys.forEach(v=>u.add(v))),[...u.values()]}u(){const u=new Set;return this.c.getAllOverrideIdentifiers().forEach(f=>u.add(f)),this.userConfiguration.getAllOverrideIdentifiers().forEach(f=>u.add(f)),this.i.getAllOverrideIdentifiers().forEach(f=>u.add(f)),this.j.forEach(f=>f.getAllOverrideIdentifiers().forEach(v=>u.add(v))),[...u.values()]}v(u){const f=new Set;return this.c.getKeysForOverrideIdentifier(u).forEach(v=>f.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(v=>f.add(v)),this.i.getKeysForOverrideIdentifier(u).forEach(v=>f.add(v)),this.j.forEach(v=>v.getKeysForOverrideIdentifier(u).forEach(g=>f.add(g))),[...f.values()]}static parse(u){const f=this.w(u.defaults),v=this.w(u.policy),g=this.w(u.application),D=this.w(u.user),I=this.w(u.workspace),h=u.folders.reduce((b,k)=>(b.set(y.URI.revive(k[0]),this.w(k[1])),b),new P.$zc);return new n(f,v,g,D,new w,I,h,new w,new P.$zc)}static w(u){return new w(u.contents,u.keys,u.overrides)}}e.$Mn=n;function o(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const u=new Set,f=new Map;for(const g of r)g.keys.forEach(D=>u.add(D)),g.overrides.forEach(([D,I])=>{const h=(0,P.$wc)(f,D,new Set);I.forEach(b=>h.add(b))});const v=[];return f.forEach((g,D)=>v.push([D,[...g.values()]])),{keys:[...u.values()],overrides:v}}e.$Nn=o;class c{constructor(u,f,v,g){this.change=u,this.f=f,this.g=v,this.h=g,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const D of u.keys)this.affectedKeys.add(D);for(const[,D]of u.overrides)for(const I of D)this.affectedKeys.add(I);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(u,f){const v=this.a+u,g=this.d.indexOf(v);if(g<0)return!1;const D=g+v.length;if(D>=this.d.length)return!1;const I=this.d.charCodeAt(D);if(I!==this.b&&I!==this.c)return!1;if(f){const h=this.previousConfiguration?this.previousConfiguration.getValue(u,f,this.f?.workspace):void 0,b=this.g.getValue(u,f,this.h);return!$.$gn(h,b)}return!0}}e.$On=c;function d(r,u){const{added:f,removed:v,updated:g}=i(u?.rawConfiguration,r?.rawConfiguration),D=[],I=r?.getAllOverrideIdentifiers()||[],h=u?.getAllOverrideIdentifiers()||[];if(u){const b=h.filter(k=>!I.includes(k));for(const k of b)D.push([k,u.getKeysForOverrideIdentifier(k)])}if(r){const b=I.filter(k=>!h.includes(k));for(const k of b)D.push([k,r.getKeysForOverrideIdentifier(k)])}if(u&&r){for(const b of I)if(h.includes(b)){const k=i({contents:r.getOverrideValue(void 0,b)||{},keys:r.getKeysForOverrideIdentifier(b)},{contents:u.getOverrideValue(void 0,b)||{},keys:u.getKeysForOverrideIdentifier(b)});D.push([b,[...k.added,...k.removed,...k.updated]])}}return{added:f,removed:v,updated:g,overrides:D}}function i(r,u){const f=r?u?r.keys.filter(D=>u.keys.indexOf(D)===-1):[...r.keys]:[],v=u?r?u.keys.filter(D=>r.keys.indexOf(D)===-1):[...u.keys]:[],g=[];if(r&&u){for(const D of u.keys)if(r.keys.indexOf(D)!==-1){const I=(0,A.$zi)(u.contents,D),h=(0,A.$zi)(r.contents,D);$.$gn(I,h)||g.push(D)}}return{added:f,removed:v,updated:g}}}),define(Ae[99],Re([1,0,11,4]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.RemoteAuthorityResolverErrorCode=e.$Zk=e.$Yk=e.RemoteConnectionType=e.$Xk=void 0,e.$Xk=(0,T.$Xh)("remoteAuthorityResolverService");var C;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class M{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Yk=M;class P{constructor(S,l){this.host=S,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Zk=P;var $;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class m extends E.$ab{static isNotAvailable(S){return S instanceof m&&S._code===$.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof m&&S._code===$.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof m&&S._code===$.NoResolverFound}static isInvalidAuthority(S){return S instanceof m&&S._code===$.InvalidAuthority}static isHandled(S){return S instanceof m&&S.isHandled}constructor(S,l=$.Unknown,p){super(S),this._message=S,this._code=l,this._detail=p,this.isHandled=l===$.NotAvailable&&p===!0,Object.setPrototypeOf(this,m.prototype)}}e.$1k=m;function y(A){const S=A.indexOf("+");return S===-1?A:A.substring(0,S)}e.$2k=y}),define(Ae[55],Re([1,0,13]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=void 0;function T(y){return y.scheme===E.Schemas.vscodeRemote?y.authority:void 0}e.$3k=T;function C(y){if(!y)return;const A=y.indexOf("+");return A<0?y:y.substr(0,A)}e.$4k=C;function M(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.$5k=M;function P(y){const{host:A,port:S}=m(y);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:S}}e.$6k=P;function $(y,A){let{host:S,port:l}=m(y);return typeof l>"u"&&(l=A),{host:S,port:l}}e.$7k=$;function m(y){const A=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const S=y.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const l=y.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:y,port:void 0}}}),define(Ae[22],Re([1,0,12,4,55]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.TargetPlatform=e.ExtensionType=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l="extensions.user.cache",e.$9l="extensions.builtin.cache",e.$0l="undefined_publisher",e.$$l=["ui","workspace","web"];function M(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.$_l=M,e.$am=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(P||(e.ExtensionType=P={}));var $;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class m{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,t){if(typeof s>"u"||s===null)return typeof t>"u"||t===null;if(typeof t>"u"||t===null)return!1;if(typeof s=="string"||typeof t=="string"){const n=typeof s=="string"?s:s.value,o=typeof t=="string"?t:t.value;return E.$6e(n,o)}return s._lower===t._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.$bm=m;class y{get size(){return this.c.size}constructor(s){if(this.c=new Set,s)for(const t of s)this.add(t)}add(s){this.c.add(m.toKey(s))}delete(s){return this.c.delete(m.toKey(s))}has(s){return this.c.has(m.toKey(s))}}e.$cm=y;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(s){this.c.delete(m.toKey(s))}get(s){return this.c.get(m.toKey(s))}has(s){return this.c.has(m.toKey(s))}set(s,t){this.c.set(m.toKey(s),t)}values(){return this.c.values()}forEach(s){this.c.forEach(s)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$dm=A;function S(a){return l(a)}e.$em=S;function l(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}e.$fm=l;function p(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}e.$gm=p;function w(a,s){if(s){const t=`onResolveRemoteAuthority:${(0,C.$4k)(s)}`;return!!a.activationEvents?.includes(t)}return!1}e.$hm=w,e.$im=(0,T.$Xh)("IBuiltinExtensionsScannerService")}),define(Ae[100],Re([1,0,11,22]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zF=e.$yF=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(P,$){this.a.set(P,$)}readActivationEvents(P){return this.b.has(P)||this.b.set(P,this.c(P)),this.b.get(P)}createActivationEventsMap(P){const $=Object.create(null);for(const m of P){const y=this.readActivationEvents(m);y.length>0&&($[T.$bm.toKey(m.identifier)]=y)}return $}c(P){if(typeof P.main>"u"&&typeof P.browser>"u")return[];const $=Array.isArray(P.activationEvents)?P.activationEvents.slice(0):[];for(let m=0;m<$.length;m++)$[m]==="onUri"&&($[m]=`onUri:${T.$bm.toKey(P.identifier)}`);if(!P.contributes)return $;for(const m in P.contributes){const y=this.a.get(m);if(!y)continue;const A=P.contributes[m],S=Array.isArray(A)?A:[A];try{y(S,$)}catch(l){(0,E.$Z)(l)}}return $}}e.$yF=C,e.$zF=new C}),define(Ae[190],Re([1,0,21,74,33]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=void 0;function M(m){if(E.$u===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}function P(m,y,A,S,l,p,w,a,s){const t=Object.create(null);t["common.machineId"]=p,t["common.sqmId"]=w,t.sessionID=(0,C.$kg)()+Date.now(),t.commitHash=S,t.version=l,t["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,E.$h)(E.$u),t["common.nodePlatform"]=T.$cc,t["common.nodeArch"]=A,t["common.product"]=s||"desktop",a&&(t["common.msftInternal"]=a);let n=0;const o=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),E.$l&&(t["common.snap"]="true");const c=M(y);return c&&(t["common.platformDetail"]=c),t}e.$po=P;function $(m){const y=T.env.USERDNSDOMAIN;if(!y)return!1;const A=y.toLowerCase();return m.some(S=>A===S)}e.$qo=$}),define(Ae[191],Re([1,0,4]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=void 0,e.$kl=(0,E.$Xh)("telemetryService"),e.$ll=(0,E.$Xh)("customEndpointTelemetryService"),e.$ml="telemetry.currentSessionDate",e.$nl="telemetry.firstSessionDate",e.$ol="telemetry.lastSessionDate",e.$pl="telemetry.machineId",e.$ql="telemetry.sqmId",e.$rl="telemetry",e.$sl="telemetry.telemetryLevel",e.$tl="telemetry.enableCrashReporter",e.$ul="telemetry.enableTelemetry";var T;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var C;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ae[56],Re([1,0,26,16,5,40,55,190,191]),function(we,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=void 0;class y{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.$ro=y;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$so=A,e.$to=new A;class S{async publicLog(v,g,D){}async publicLogError(v,g,D){}}e.$uo=S,e.$vo="telemetry",e.$wo="extensionTelemetryLog",e.$xo={log:()=>null,flush:()=>Promise.resolve(null)};function l(f,v){return C.Event.debounce(v.onDidChangeConfiguration,(D,I)=>{const h=D?new Set([...D.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:h}},1e3,!0)(D=>{D.source!==7&&f.publicLog2("updateConfiguration",{configurationSource:(0,M.$ui)(D.source),configurationKeys:Array.from(D.affectedKeys)})})}e.$yo=l;function p(f,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!f.enableTelemetry)}e.$zo=p;function w(f,v){return v.extensionTestsLocationURI?!0:!(v.isBuilt||v.disableTelemetry||f.enableTelemetry&&f.aiConfig?.ariaKey)}e.$Ao=w;function a(f){const v=f.getValue(m.$sl),g=f.getValue(m.$tl);if(f.getValue(m.$ul)===!1||g===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Bo=a;function s(f){const v={},g={},D={};o(f,D);for(let I in D){I=I.length>150?I.substr(I.length-149):I;const h=D[I];typeof h=="number"?g[I]=h:typeof h=="boolean"?g[I]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${h.length}`),v[I]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(v[I]=h)}return{properties:v,measurements:g}}e.$Co=s;const t=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(f){if(!f)return"none";const v=(0,P.$4k)(f);return t.has(v)?v:"other"}e.$Do=n;function o(f,v,g=0,D){if(f)for(const I of Object.getOwnPropertyNames(f)){const h=f[I],b=D?D+I:I;Array.isArray(h)?v[b]=(0,E.$hn)(h):h instanceof Date?v[b]=h.toISOString():(0,T.$Ef)(h)?g<2?o(h,v,g+1,b+"."):v[b]=(0,E.$hn)(h):v[b]=h}}function c(f,v){const g=f.msftInternalDomains||[],D=v.getValue("telemetry.internalTesting");return(0,$.$qo)(g)||D}e.$Eo=c;function d(f){return[f.appRoot,f.extensionsPath,f.userHome.fsPath,f.tmpDir.fsPath,f.userDataPath]}e.$Fo=d;function i(f,v){if(!f||!f.includes("/")&&!f.includes("\\"))return f;let g=f;const D=[];for(const k of v)for(;;){const F=k.exec(f);if(!F)break;D.push([F.index,k.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(g="";;){const k=h.exec(f);if(!k)break;const F=D.some(([W,J])=>k.index<J&&W<h.lastIndex);!I.test(k[0])&&!F&&(g+=f.substring(b,k.index)+"<REDACTED: user-file-path>",b=h.lastIndex)}return b<f.length&&(g+=f.substr(b)),g}function r(f){if(!f)return f;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of v)if(g.regex.test(f))return`<REDACTED: ${g.label}>`;return f}function u(f,v){return(0,E.$en)(f,g=>{if(g instanceof y||Object.hasOwnProperty.call(g,"isTrustedTelemetryValue"))return g.value;if(typeof g=="string"){let D=g.replaceAll("%20"," ");D=i(D,v);for(const I of v)D=D.replace(I,"");return D=r(D),D}})}e.$Go=u}),define(Ae[192],Re([1,0,12,96,22,21,2,11,74,56]),function(we,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0;function A(u,f){return u.uuid&&f.uuid?u.uuid===f.uuid:u.id===f.id?!0:(0,E.$1e)(u.id,f.id)===0}e.$Ho=A;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(f){const v=f.manifest?f.manifest.version:f.version,g=f.manifest?f.targetPlatform:f.properties.targetPlatform;return new l(f.identifier,v,g)}static parse(f){const v=S.exec(f);return v&&v[1]&&v[2]?new l({id:v[1]},v[2],v[4]||void 0):null}constructor(f,v,g="undefined"){this.version=v,this.targetPlatform=g,this.id=f.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(f){return f instanceof l?A(this,f)&&this.version===f.version&&this.targetPlatform===f.targetPlatform:!1}}e.$Io=l;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(u){const f=p.exec(u);return f&&f[1]?[s(f[1]),f[2]]:[s(u),void 0]}e.$Jo=w;function a(u,f){return`${u}.${f}`}e.$Ko=a;function s(u){return u.toLowerCase()}e.$Lo=s;function t(u,f){return s(a(u??C.$0l,f))}e.$Mo=t;function n(u,f){const v=[],g=D=>{for(const I of v)if(I.some(h=>A(f(h),f(D))))return I;return null};for(const D of u){const I=g(D);I?I.push(D):v.push([D])}return v}e.$No=n;function o(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.$Oo=o;function c(u){return{id:new y.$ro(u.identifier.id),name:new y.$ro(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$Po=c,e.$Qo=new C.$bm("pprice.better-merge");function d(u,f){const v=[],g=f.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const D=g.shift();if(D&&v.every(I=>!A(I.identifier,{id:D}))){const I=u.filter(h=>A(h.identifier,{id:D}));I.length===1&&(v.push(I[0]),g.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.$Ro=d;async function i(u,f){if(!M.$k)return!1;let v;try{v=(await u.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{v=(await u.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){f.debug("Error while getting the os-release file.",(0,$.$9)(D))}}return!!v&&(v.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(u,f){const v=await i(u,f),g=(0,T.$bo)(v?"alpine":M.$u,m.$dc);return f.debug("ComputeTargetPlatform:",g),g}e.$So=r}),define(Ae[193],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=e.$vr=e.$ur=e.$tr=e.$sr=void 0;function E(m){return[...m.entries()]}e.$sr=E;function T(m){return m?[...m.entries()]:[]}e.$tr=T;function C(m){return new Map(m)}e.$ur=C;function M(m){return new Map(m??[])}e.$vr=M;function P(m){return Array.from(m.entries()).map(y=>[y[0],E(y[1].map),T(y[1].descriptionMap)])}e.$wr=P;function $(m){return new Map(m.map(y=>[y[0],{map:C(y[1]),descriptionMap:M(y[2])}]))}e.$xr=$}),define(Ae[194],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqb=void 0;class E{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,M,P=5){const $=M(m=>{const y=typeof m=="string"?m:m.data;let A=this.a.get(C);if(A){A.data.push(y);return}const S=setTimeout(()=>this.flushBuffer(C),P);A={data:[y],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(C),$.dispose()}},this.a.set(C,A)});return $}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const M=this.a.get(C);M&&(this.a.delete(C),this.b(C,M.data.join("")))}}e.$yqb=E}),define(Ae[195],Re([1,0,14,90,45,5,16,2,154,73,30]),function(we,e,E,T,C,M,P,$,m,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jw=e.$iw=e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.IconFontDefinition=e.IconContribution=e.$bw=void 0,e.$bw={IconContribution:"base.contributions.icons"};var S;(function(c){function d(i,r){let u=i.defaults;for(;C.ThemeIcon.isThemeIcon(u);){const f=w.getIcon(u.id);if(!f)return;u=f.defaults}return u}c.getDefinition=d})(S||(e.IconContribution=S={}));var l;(function(c){function d(r){return{weight:r.weight,style:r.style,src:r.src.map(u=>({format:u.format,location:u.location.toString()}))}}c.toJSONObject=d;function i(r){const u=f=>(0,P.$Cf)(f)?f:void 0;if(r&&Array.isArray(r.src)&&r.src.every(f=>(0,P.$Cf)(f.format)&&(0,P.$Cf)(f.location)))return{weight:u(r.weight),style:u(r.style),src:r.src.map(f=>({format:f.format,location:$.URI.parse(f.location)}))}}c.fromJSONObject=i})(l||(e.IconFontDefinition=l={}));class p{constructor(){this.a=new M.$Rd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,m.localize)(0,null)},fontCharacter:{type:"string",description:(0,m.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(d,i,r,u){const f=this.b[d];if(f){if(r&&!f.description){f.description=r,this.d.properties[d].markdownDescription=`${r} $(${d})`;const D=this.e.enum.indexOf(d);D!==-1&&(this.e.enumDescriptions[D]=r),this.a.fire()}return f}const v={id:d,description:r,defaults:i,deprecationMessage:u};this.b[d]=v;const g={$ref:"#/definitions/icons"};return u&&(g.deprecationMessage=u),r&&(g.markdownDescription=`${r}: $(${d})`),this.d.properties[d]=g,this.e.enum.push(d),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:d}}deregisterIcon(d){delete this.b[d],delete this.d.properties[d];const i=this.e.enum.indexOf(d);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(d=>this.b[d])}getIcon(d){return this.b[d]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(d,i){const r=this.f[d];return r||(this.f[d]=i,this.a.fire(),i)}deregisterIconFont(d){delete this.f[d]}getIconFont(d){return this.f[d]}toString(){const d=(f,v)=>f.id.localeCompare(v.id),i=f=>{for(;C.ThemeIcon.isThemeIcon(f.defaults);)f=this.b[f.defaults.id];return`codicon codicon-${f?f.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map(f=>this.b[f]);for(const f of u.filter(v=>!!v.description).sort(d))r.push(`|<i class="${i(f)}"></i>|${f.id}|${C.ThemeIcon.isThemeIcon(f.defaults)?f.defaults.id:f.id}|${f.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const f of u.filter(v=>!C.ThemeIcon.isThemeIcon(v.defaults)).sort(d))r.push(`|<i class="${i(f)}"></i>|${f.id}|`);return r.join(`
`)}}const w=new p;A.$on.add(e.$bw.IconContribution,w);function a(c,d,i,r){return w.registerIcon(c,d,i,r)}e.$cw=a;function s(){return w}e.$dw=s;function t(){const c=(0,T.$1j)();for(const d in c){const i="\\"+c[d].toString(16);w.registerIcon(d,{fontCharacter:i})}}t(),e.$ew="vscode://schemas/icons";const n=A.$on.as(y.$pn.JSONContribution);n.registerSchema(e.$ew,w.getIconSchema());const o=new E.$_g(()=>n.notifySchemaChanged(e.$ew),200);w.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$fw=a("widget-close",T.$3j.close,(0,m.localize)(2,null)),e.$gw=a("goto-previous-location",T.$3j.arrowUp,(0,m.localize)(3,null)),e.$hw=a("goto-next-location",T.$3j.arrowDown,(0,m.localize)(4,null)),e.$iw=C.ThemeIcon.modify(T.$3j.sync,"spin"),e.$jw=C.ThemeIcon.modify(T.$3j.loading,"spin")}),define(Ae[196],Re([1,0,5,40,4,15]),function(we,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.ProvidedOnAutoForward=e.$hv=e.TunnelPrivacyId=e.TunnelProtocol=e.$gv=e.$fv=void 0,e.$fv=(0,C.$Xh)("tunnelService"),e.$gv=(0,C.$Xh)("sharedTunnelsService");var P;(function(s){s.Http="http",s.Https="https"})(P||(e.TunnelProtocol=P={}));var $;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})($||(e.TunnelPrivacyId=$={}));function m(s){return!!s.forwardPort}e.$hv=m;var y;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function A(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(t)return{address:t[1],port:+t[2]}}e.$iv=A,e.$jv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(s){return e.$jv.indexOf(s)>=0}e.$kv=S,e.$lv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(s){return e.$lv.indexOf(s)>=0}e.$mv=l;function p(s,t,n,o){if(n===1)return!1;if(n===2&&l(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(c?.length===4&&parseInt(c[1])>=18)return!1}return s<1024}e.$nv=p;class w{constructor(t,n,o){this.remoteAddress=t,this.localAddress=n,this.b=o,this.a=new E.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$ov=w;let a=class{constructor(t,n){this.j=t,this.k=n,this.a=new E.$Rd,this.onTunnelOpened=this.a.event,this.b=new E.$Rd,this.onTunnelClosed=this.b.event,this.c=new E.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const t=this.k.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.h=t.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const t=[],n=Array.from(this.e.values());for(const o of n){const c=Array.from(o.values());for(const d of c){const i=await d.value;i&&typeof i!="string"&&t.push(i)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:n}of t.values())await n.then(o=>typeof o!="string"?o?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,n,o,c,d){this.p(t,n,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:n,localAddress:o,privacy:c,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,n){(l(t)||S(t))&&(t=e.$jv[0]);const o=this.r(t,n);if(o)return++o.refcount,o.value}openTunnel(t,n,o,c,d,i=!1,r,u){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${o} on local port ${d}.`);const f=this.f??t;if(!f)return;if(n||(n="localhost"),c||(c=this.l),this.f&&this.i.has(o)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.s(f,n,o,c,d,i,r,u);return v?v.then(g=>{if(g){if(typeof g=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(n,o),g}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(n,o);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.n(g);return(g.tunnelRemoteHost!==n||g.tunnelRemotePort!==o)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&g.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}n(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const n=this.e.get(t.tunnelRemoteHost);if(n){const o=n.get(t.tunnelRemotePort);o&&(o.refcount--,await this.o(t.tunnelRemoteHost,t.tunnelRemotePort,o))}}}}async o(t,n,o){if(o.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${n}.`);const c=o.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this.b.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(n),c}}async closeTunnel(t,n){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${n} `);const o=this.e.get(t);if(o&&o.has(n)){const c=o.get(n);c.refcount=0,await this.o(t,n,c)}}p(t,n,o){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(n,{refcount:1,value:o})}async q(t,n){const o=this.e.get(t);if(o){const c=o.get(n),d=c?await c.value:void 0;(!d||typeof d=="string")&&o.delete(n),o.size===0&&this.e.delete(t)}}r(t,n){const o=[t];S(t)?(o.push(...e.$jv),o.push(...e.$lv)):l(t)&&o.push(...e.$lv);const c=o.map(d=>this.e.get(d));for(const d of c){const i=d?.get(n);if(i)return i}}canTunnel(t){return!!A(t)}t(t,n,o,c,d,i,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${o} on local port ${c}.`);const u=o;this.i.add(u);const f=c===void 0?o:c,v={elevationRequired:d?this.isPortPrivileged(f):!1},g={remoteAddress:{host:n,port:o},localAddressPort:c,privacy:i,public:i?i!==$.Private:void 0,protocol:r},D=t.forwardPort(g,v);return D?(this.p(n,o,D),D.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(u)})):this.i.delete(u),D}};e.$pv=a,e.$pv=a=Ke([We(0,M.$fj),We(1,T.$ri)],a)}),define(Ae[197],Re([1,0,4]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$qv=void 0,e.$qv=(0,E.$Xh)("editSessionIdentityService");var T;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Ae[198],Re([1,0,13]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=void 0;function T(m){return m.scheme!==E.Schemas.file&&m.scheme!==E.Schemas.vscodeRemote}e.$9J=T;function C(m){if(m.folders.length)return m.folders.every(y=>T(y.uri))?m.folders[0].uri:void 0;if(m.configuration&&T(m.configuration))return m.configuration}e.$0J=C;function M(m){return C(m)?.scheme}e.$$J=M;function P(m){return C(m)?.authority}e.$_J=P;function $(m){return C(m)!==void 0}e.$aK=$}),define(Ae[47],Re([1,0,155,20,50,25,2,4,13]),function(we,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.WorkbenchState=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=void 0,e.$7h=(0,$.$Xh)("contextService");function y(f){const v=f;return typeof v?.id=="string"&&P.URI.isUri(v.uri)}e.$8h=y;function A(f){return typeof f?.id=="string"&&!y(f)&&!l(f)}e.$9h=A,e.$0h={id:"ext-dev"},e.$$h={id:"empty-window"};function S(f,v){if(typeof f=="string"||typeof f>"u")return typeof f=="string"?{id:(0,T.$mc)(f)}:v?e.$0h:e.$$h;const g=f;return g.configuration?{id:g.id,configPath:g.configuration}:g.folders.length===1?{id:g.id,uri:g.folders[0].uri}:{id:g.id}}e.$_h=S;function l(f){const v=f;return typeof v?.id=="string"&&P.URI.isUri(v.configPath)}e.$ai=l;function p(f){const v=f;if(v?.uri)return{id:v.id,uri:P.URI.revive(v.uri)};const g=f;if(g?.configPath)return{id:g.id,configPath:P.URI.revive(g.configPath)};if(f?.id)return{id:f.id}}e.$bi=p;var w;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function a(f){const v=f;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.$ci=a;function s(f){const v=f;return!!(v&&typeof v=="object"&&P.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.$di=s;class t{constructor(v,g,D,I,h){this.h=v,this.j=D,this.k=I,this.l=h,this.c=C.$4h.forUris(this.l,()=>!0),this.folders=g}update(v){this.h=v.id,this.k=v.configuration,this.j=v.transient,this.l=v.l,this.folders=v.folders}get folders(){return this.g}set folders(v){this.g=v,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(v){this.k=v}getFolder(v){return v&&this.c.findSubstr(v)||null}n(){this.c=C.$4h.forUris(this.l,()=>!0);for(const v of this.folders)this.c.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ei=t;class n{constructor(v,g){this.raw=g,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,M.$Bg)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$fi=n;function o(f){return new n({uri:f,index:0,name:(0,M.$xg)(f)},{uri:f.toString()})}e.$gi=o,e.$hi="code-workspace",e.$ii=`.${e.$hi}`,e.$ji=[{name:(0,E.localize)(0,null),extensions:[e.$hi]}],e.$ki="workspace.json";function c(f,v){return M.$sg.isEqualOrParent(f,v.untitledWorkspacesHome)}e.$li=c;function d(f){let v;return P.URI.isUri(f)?v=f:v=f.configuration,v?.scheme===m.Schemas.tmp}e.$mi=d,e.$ni="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(f){return f.id===e.$ni}e.$oi=i;function r(f,v){return!c(f,v)&&!d(f)}e.$pi=r;function u(f){return(typeof f=="string"?(0,T.$nc)(f):(0,M.$zg)(f))===e.$ii}e.$qi=u}),define(Ae[75],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=void 0;class E{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const M=this.c++;return this.b.set(M,C),this.e(),M}get(C,M){return this.b.has(C)?this.b.get(C)[M]:void 0}delete(C){this.b.delete(C),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$5dc=E}),define(Ae[42],Re([1,0,13,25,4]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=e.$8dc=void 0;class M{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new T.$qg($=>{const m=this.b.get($.scheme);return!(m===void 0||m&1024)})}$acceptProviderInfos($,m){m===null?this.b.delete($.scheme):this.b.set($.scheme,m)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$8dc=M,e.$9dc=(0,C.$Xh)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=void 0,e.$RM=(0,E.$Xh)("IExtHostInitDataService")}),define(Ae[199],Re([1,0,160,15,186,27]),function(we,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;let P=class extends C.$YN{constructor(m,y,A){const S=A.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",l=A.remote.isRemote?(0,E.localize)(0,null):m?(0,E.localize)(1,null):(0,E.localize)(2,null);super(y.createLogger(S,{name:l}))}};e.$cgc=P,e.$cgc=P=Ke([We(1,T.$gj),We(2,M.$RM)],P)}),define(Ae[200],Re([1,0,14]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=e.$Qec=void 0;class T{constructor(P,$,m){this.h=new Map,this.a=P,this.b=$,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new E.$_g(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of y.values())A.complete()}catch(A){for(const S of y.values())S.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this.d}get(P,$){let m=this.f[P];return typeof m>"u"&&(m=$),m}update(P,$){this.f[P]=$;const m=this.h.get(P);if(m!==void 0)return m.p;const y=new E.$kh;return this.h.set(P,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$Qec=T;class C extends T{setKeysForSync(P){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},P)}constructor(P,$){super(P.identifier.value,!0,$),this.j=P}}e.$Rec=C}),define(Ae[201],Re([1,0,5,2]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=void 0;class C{constructor(P){this.c=P,this.a=new E.$Rd,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Rd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(P,$,m,y){const S=this.c.getNotebookDocument(T.URI.revive(P)).acceptModelChanged($.value,m,y);this.b.fire(S)}$acceptDirtyStateChanged(P,$){this.c.getNotebookDocument(T.URI.revive(P)).acceptDirty($)}$acceptModelSaved(P){const $=this.c.getNotebookDocument(T.URI.revive(P));this.a.fire($.apiNotebook)}}e.$Efc=C}),define(Ae[17],Re([1,0,4]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CM=e.$BM=void 0,e.$BM=(0,E.$Xh)("IExtHostRpcService");class T{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$CM=T}),define(Ae[202],Re([1,0,22,5]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=void 0;class C{#e;constructor(P,$){this.b=new T.$Rd,this.onDidChange=this.b.event,this.a=E.$bm.toKey(P.identifier),this.#e=$,this.#e.onDidChangePassword(m=>{m.extensionId===this.a&&this.b.fire({key:m.key})})}get(P){return this.#e.get(this.a,P)}store(P,$){return this.#e.store(this.a,P,$)}delete(P){return this.#e.delete(this.a,P)}}e.$Yec=C}),define(Ae[57],Re([1,0,4]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=e.$oec=void 0,e.$oec=(0,E.$Xh)("IURITransformerService");class T{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.$pec=T}),define(Ae[203],Re([1,0,24]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecb=e.$Dcb=void 0;class T{constructor(){this.buffers=[]}add(m){let y=this.buffers.indexOf(m);return y<0&&(y=this.buffers.length,this.buffers.push(m)),y}}function C($,m){if(m.serializeBuffersForPostMessage){const y=new T,S=JSON.stringify($,(p,w)=>{if(w instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(w)};if(ArrayBuffer.isView(w)){const a=M(w);if(a)return{$$vscode_array_buffer_reference$$:!0,index:y.add(w.buffer),view:{type:a,byteLength:w.byteLength,byteOffset:w.byteOffset}}}return w}),l=y.buffers.map(p=>{const w=new Uint8Array(p);return E.$fe.wrap(w)});return{message:S,buffers:l}}else return{message:JSON.stringify($),buffers:[]}}e.$Dcb=C;function M($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P($,m){const y=m.map(l=>{const p=new ArrayBuffer(l.byteLength);return new Uint8Array(p).set(l.buffer),p}),A=m.length?(l,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const w=p,{index:a}=w,s=y[a];if(w.view)switch(w.view.type){case 1:return new Int8Array(s,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(s,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(s,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(s,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(s,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(s,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(s,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(s,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(s,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(s,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(s,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return p}:void 0;return{message:JSON.parse($,A),arrayBuffers:y}}e.$Ecb=P}),define(Ae[101],Re([1,0,170,16,2,6,4,30,41,13,39,133,31]),function(we,e,E,T,C,M,P,$,m,y,A,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DE=e.$CE=e.$BE=e.EditorsOrder=e.$AE=e.CloseDirection=e.$zE=e.$yE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$xE=e.$wE=e.$vE=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.EditorInputCapabilities=e.$pE=e.SaveReason=e.Verbosity=e.$oE=e.$nE=e.$mE=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$gE=e.$fE=e.$eE=e.$dE=e.$cE=void 0,e.$cE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$dE={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$eE="workbench.editor.sidebysideEditor",e.$fE="workbench.editors.textDiffEditor",e.$gE="workbench.editors.binaryResourceDiffEditor";var p;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var w;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(w||(e.EditorPaneSelectionCompareResult=w={}));function a(se){const Q=se;return!!Q&&typeof Q.getSelection=="function"&&!!Q.onDidChangeSelection}e.$hE=a;function s(se,Q,U){for(const ne of U.visibleEditorPanes)if(ne.group.id===Q&&se.matches(ne.input))return ne.getViewState()}e.$iE=s;function t(se){if(D(se))return!1;const Q=se;return C.URI.isUri(Q?.resource)}e.$jE=t;function n(se){if(D(se))return!1;const Q=se;return Q?.original!==void 0&&Q.modified!==void 0}e.$kE=n;function o(se){if(D(se))return!1;const Q=se;return Array.isArray(Q?.resources)}e.$lE=o;function c(se){if(D(se)||n(se))return!1;const Q=se;return Q?.primary!==void 0&&Q.secondary!==void 0}e.$mE=c;function d(se){if(D(se))return!1;const Q=se;return Q?Q.resource===void 0||Q.resource.scheme===y.Schemas.untitled||Q.forceUntitled===!0:!1}e.$nE=d;function i(se){if(D(se))return!1;const Q=se;return C.URI.isUri(Q?.base?.resource)&&C.URI.isUri(Q?.input1?.resource)&&C.URI.isUri(Q?.input2?.resource)&&C.URI.isUri(Q?.result?.resource)}e.$oE=i;var r;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var u;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class f{constructor(){this.a=new Map}registerSource(Q,U){let ne=this.a.get(Q);return ne||(ne={source:Q,label:U},this.a.set(Q,ne)),ne.source}getSourceLabel(Q){return this.a.get(Q)?.label??Q}}e.$pE=new f;var v;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad",se[se.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(v||(e.EditorInputCapabilities=v={}));class g extends M.$Rc{}e.$qE=g;function D(se){return se instanceof g}e.$rE=D;function I(se){const Q=se;return C.URI.isUri(Q?.preferredResource)}function h(se){const Q=se;return D(Q?.primary)&&D(Q?.secondary)}e.$sE=h;function b(se){const Q=se;return D(Q?.modified)&&D(Q?.original)}e.$tE=b;function k(se,Q,U,ne,pe){return Ce(ne,[(0,S.$Hi)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const re={...U,limits:{size:Number.MAX_VALUE}};se.openEditor(Q,re)}}),(0,S.$Hi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$uE=k;function F(se){return D(se?.editor)}e.$vE=F;function W(se){const Q=se;return F(se)&&Q?.group!==void 0}e.$wE=W;function J(se){const Q=se;return typeof Q?.groupId=="number"&&D(Q.editor)}e.$xE=J;var N;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var R;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LABEL=2]="GROUP_LABEL",se[se.GROUP_LOCKED=3]="GROUP_LOCKED",se[se.EDITOR_OPEN=4]="EDITOR_OPEN",se[se.EDITOR_CLOSE=5]="EDITOR_CLOSE",se[se.EDITOR_MOVE=6]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=8]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=10]="EDITOR_PIN",se[se.EDITOR_STICKY=11]="EDITOR_STICKY",se[se.EDITOR_DIRTY=12]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(R||(e.GroupModelChangeKind=R={}));var L;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(L||(e.SideBySideEditor=L={}));class O{getOriginalUri(Q,U){if(!Q)return;if(i(Q))return e.$zE.getOriginalUri(Q.result,U);if(U?.supportSideBySide){const{primary:pe,secondary:re}=this.a(Q);if(pe&&re){if(U?.supportSideBySide===L.BOTH)return{primary:this.getOriginalUri(pe,{filterByScheme:U.filterByScheme}),secondary:this.getOriginalUri(re,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===L.ANY)return this.getOriginalUri(pe,{filterByScheme:U.filterByScheme})??this.getOriginalUri(re,{filterByScheme:U.filterByScheme});Q=U.supportSideBySide===L.PRIMARY?pe:re}}if(n(Q)||o(Q)||c(Q)||i(Q))return;const ne=I(Q)?Q.preferredResource:Q.resource;return!ne||!U||!U.filterByScheme?ne:this.b(ne,U.filterByScheme)}a(Q){return h(Q)||c(Q)?{primary:Q.primary,secondary:Q.secondary}:b(Q)||n(Q)?{primary:Q.modified,secondary:Q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Q,U){if(!Q)return;if(i(Q))return e.$zE.getCanonicalUri(Q.result,U);if(U?.supportSideBySide){const{primary:pe,secondary:re}=this.a(Q);if(pe&&re){if(U?.supportSideBySide===L.BOTH)return{primary:this.getCanonicalUri(pe,{filterByScheme:U.filterByScheme}),secondary:this.getCanonicalUri(re,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===L.ANY)return this.getCanonicalUri(pe,{filterByScheme:U.filterByScheme})??this.getCanonicalUri(re,{filterByScheme:U.filterByScheme});Q=U.supportSideBySide===L.PRIMARY?pe:re}}if(n(Q)||o(Q)||c(Q)||i(Q))return;const ne=Q.resource;return!ne||!U||!U.filterByScheme?ne:this.b(ne,U.filterByScheme)}b(Q,U){if(Array.isArray(U)){if(U.some(ne=>Q.scheme===ne))return Q}else if(U===Q.scheme)return Q}}var X;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(X||(e.EditorCloseMethod=X={}));function he(se,Q,U,ne){if(!se.isSticky(Q))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return U===X.MOUSE||U===X.KEYBOARD;case"mouse":return U===X.MOUSE;case"keyboard":return U===X.KEYBOARD}return!1}e.$yE=he,e.$zE=new O;var $e;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})($e||(e.CloseDirection=$e={}));class De{constructor(){this.c=new Map,this.d=new Map}start(Q){const U=this.a=Q.get(P.$Wh);for(const[ne,pe]of this.c)this.e(ne,pe,U);this.c.clear()}e(Q,U,ne){const pe=ne.createInstance(U);this.d.set(Q,pe)}registerFileEditorFactory(Q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Q}getFileEditorFactory(){return(0,T.$Nf)(this.b)}registerEditorSerializer(Q,U){if(this.c.has(Q)||this.d.has(Q))throw new Error(`A editor serializer with type ID '${Q}' was already registered.`);return this.a?this.e(Q,U,this.a):this.c.set(Q,U),(0,M.$Pc)(()=>{this.c.delete(Q),this.d.delete(Q)})}getEditorSerializer(Q){return this.d.get(typeof Q=="string"?Q:Q.typeId)}}$.$on.add(e.$cE.EditorFactory,new De);async function ke(se,Q,U){return!se||!se.length?[]:await Promise.all(se.map(async ne=>{const pe=C.URI.revive(ne.fileUri);if(!pe){U.info("Cannot resolve the path because it is not valid.",ne);return}if(!await Q.canHandleResource(pe)){U.info("Cannot resolve the path because it cannot be handled",ne);return}let le=ne.exists,ce=ne.type;if(typeof le!="boolean"||typeof ce!="number")try{ce=(await Q.stat(pe)).isDirectory?m.FileType.Directory:m.FileType.Unknown,le=!0}catch(ee){U.error(ee),le=!1}if(!le&&ne.openOnlyIfExists){U.info("Cannot resolve the path because it does not exist",ne);return}if(ce===m.FileType.Directory){U.info("Cannot resolve the path because it is a directory",ne);return}const be={...ne.options,pinned:!0};return le?{resource:pe,options:be}:{resource:pe,options:be,forceUntitled:!0}}))}e.$AE=ke;var de;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(de||(e.EditorsOrder=de={}));function Ee(se){const Q=se;if(!Q)return!1;const U=Q;if(U.modified)return Ee(U.modified);const ne=Q;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$BE=Ee;function _(se){return(0,A.$Ji)(se)}e.$CE=_;function Ce(se,Q,U){const ne=(0,A.$Ki)(se,Q);return ne.forceMessage=U?.forceMessage,ne.forceSeverity=U?.forceSeverity,ne.allowDialog=U?.allowDialog,ne}e.$DE=Ce}),define(Ae[204],Re([1,0,5,171,4,6,28,30,18,26,90,195]),function(we,e,E,T,C,M,P,$,m,y,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ME=e.$LE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$KE=e.$JE=e.ViewContentGroups=e.$IE=e.$HE=e.ViewContainerLocation=e.Extensions=e.$GE=e.$FE=e.$EE=void 0,e.$EE="views",e.$FE=(0,T.localize)(0,null),e.$GE=(0,S.$cw)("default-view-icon",A.$3j.window,(0,T.localize)(1,null));var l;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var p;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$HE=[0,1,2];function w(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$IE=w;class a extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Rd),this.onDidRegister=this.c.event,this.f=this.B(new E.$Rd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,m.$Qb)([...this.g.values()])}registerViewContainer(u,f,v){const g=this.get(u.id);if(g)return g;const D=u;return D.openCommandActionDescriptor=v?.doNotRegisterOpenCommand?void 0:D.openCommandActionDescriptor??{id:D.id},(0,P.$wc)(this.g,f,[]).push(D),v?.isDefault&&this.h.push(D),this.c.fire({viewContainer:D,viewContainerLocation:f}),D}deregisterViewContainer(u){for(const f of this.g.keys()){const v=this.g.get(f),g=v?.indexOf(u);if(g!==-1){v?.splice(g,1),v.length===0&&this.g.delete(f),this.f.fire({viewContainer:u,viewContainerLocation:f});return}}}get(u){return this.all.filter(f=>f.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(v=>v?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(f=>this.getViewContainerLocation(f)===u)}}$.$on.add(l.ViewContainersRegistry,new a);var s;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(s||(e.ViewContentGroups=s={}));function t(r,u){const f=r.group??s.More,v=u.group??s.More;return f!==v?f.localeCompare(v):(r.order??5)-(u.order??5)}class n extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Rd),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Rd),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Rd),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Rd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new P.$Fc}registerViews(u,f){this.registerViews2([{views:u,viewContainer:f}])}registerViews2(u){u.forEach(({views:f,viewContainer:v})=>this.r(f,v)),this.c.fire(u)}deregisterViews(u,f){const v=this.s(u,f);v.length&&this.f.fire({views:v,viewContainer:f})}moveViews(u,f){for(const v of this.m.keys())if(v!==f){const g=this.s(u,v);g.length&&(this.r(g,f),this.g.fire({views:g,from:v,to:f}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const f of this.j){const v=(this.m.get(f)||[]).filter(g=>g.id===u)[0];if(v)return v}return null}getViewContainer(u){for(const f of this.j)if((this.m.get(f)||[]).filter(g=>g.id===u)[0])return f;return null}registerViewWelcomeContent(u,f){return this.n.add(u,f),this.h.fire(u),(0,M.$Pc)(()=>{this.n.delete(u,f),this.h.fire(u)})}registerViewWelcomeContent2(u,f){const v=new Map;for(const[g,D]of f)this.n.add(u,D),v.set(g,(0,M.$Pc)(()=>{this.n.delete(u,D),this.h.fire(u)}));return this.h.fire(u),v}getViewWelcomeContent(u){const f=[];return this.n.forEach(u,v=>f.push(v)),f.sort(t)}r(u,f){let v=this.m.get(f);v||(v=[],this.m.set(f,v),this.j.push(f));for(const g of u){if(this.getView(g.id)!==null)throw new Error((0,T.localize)(2,null,g.id));v.push(g)}}s(u,f){const v=this.m.get(f);if(!v)return[];const g=[],D=[];for(const I of v)u.includes(I)?g.push(I):D.push(I);return g.length&&(D.length?this.m.set(f,D):(this.m.delete(f),this.j.splice(this.j.indexOf(f),1))),g}}$.$on.add(l.ViewsRegistry,new n),e.$JE=(0,C.$Xh)("viewsService"),e.$KE=(0,C.$Xh)("viewDescriptorService");var o;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var c;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class d{constructor(u,f){this.c=!1,this.d=!1,(0,y.$fn)(this,u),this.d=!!f,this.resolve=async v=>{if(f&&!this.c){const g=await f(v);g&&(this.tooltip=this.tooltip??g.tooltip,this.command=this.command??g.command)}v.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$LE=d;class i extends Error{constructor(u){super((0,T.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$ME=i}),define(Ae[205],Re([1,0,2,29,4]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bF=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$aF=e.$_E=void 0;function M(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof E.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(T.$Bs.isIRange)}e.$_E=M;function P(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(M)}e.$aF=P;var $;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var m;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})(m||(e.InteractiveSessionCopyKind=m={})),e.$bF=(0,C.$Xh)("IChatService")}),define(Ae[206],Re([1,0,5,14,172]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new E.$Rd,this.n=new E.$Rd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,m,y,A){const S={command:$};if(m&&Object.keys(m).length>0&&(S.arguments=m),this.s("request",S),typeof A=="number"){const l=setTimeout(()=>{clearTimeout(l);const p=this.f.get(S.seq);if(p){this.f.delete(S.seq);const w={type:"response",seq:0,request_seq:S.seq,success:!1,command:$,message:(0,C.localize)(0,null,A,$)};p(w)}},A)}return y&&this.f.set(S.seq,y),S.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,m){return $.type!=="event"||m.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,T.$1g)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const m=$,y=this.f.get(m.request_seq);y&&(this.f.delete(m.request_seq),y(m));break}}}}s($,m){m.type=$,m.seq=this.d++,this.sendMessage(m)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((m,y)=>$.set(y,m)),await(0,T.$1g)(500),$.forEach((m,y)=>{m({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$0cb=M}),define(Ae[207],Re([1,0,173,35,4]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$mH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$lH=e.MemoryRangeType=e.$kH=e.State=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=void 0,e.$hG="workbench.view.debug",e.$iG="workbench.debug.variablesView",e.$jG="workbench.debug.watchExpressionsView",e.$kG="workbench.debug.callStackView",e.$lG="workbench.debug.loadedScriptsView",e.$mG="workbench.debug.breakPointsView",e.$nG="workbench.debug.disassemblyView",e.$oG="workbench.panel.repl",e.$pG="workbench.panel.repl.view",e.$qG=new T.$cj("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$rG=new T.$cj("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$sG=new T.$cj("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$tG="debugUx",e.$uG=new T.$cj(e.$tG,"default",{type:"string",description:E.localize(3,null)}),e.$vG=new T.$cj("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$wG=new T.$cj("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$xG=new T.$cj("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$yG=new T.$cj("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$zG=new T.$cj("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$AG=new T.$cj("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$BG=new T.$cj("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$CG=new T.$cj("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$DG=new T.$cj("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$EG=new T.$cj("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$FG=new T.$cj("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$GG=new T.$cj("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$HG=new T.$cj("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$IG=new T.$cj("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$JG=new T.$cj("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$KG=new T.$cj("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$LG=new T.$cj("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$MG=new T.$cj("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$NG=new T.$cj("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$OG=new T.$cj("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$PG=new T.$cj("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$QG=new T.$cj("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$RG=new T.$cj("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$SG=new T.$cj("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$TG=new T.$cj("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$UG=new T.$cj("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$VG=new T.$cj("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$WG=new T.$cj("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$XG=new T.$cj("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$YG=new T.$cj("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$ZG=new T.$cj("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$1G=new T.$cj("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$2G=new T.$cj("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$3G=new T.$cj("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$4G=new T.$cj("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$5G=new T.$cj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$6G=new T.$cj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$7G=new T.$cj("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$8G=new T.$cj("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$9G=new T.$cj("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$0G=new T.$cj("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$$G=new T.$cj("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$_G=new T.$cj("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$aH=new T.$cj("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$bH=new T.$cj("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$cH=new T.$cj("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$dH=new T.$cj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$eH=new T.$cj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const M=l=>E.localize(52,null,l);e.$fH=M,e.$gH="editor.contrib.debug",e.$hH="editor.contrib.breakpoint",e.$iH="debug",e.$jH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var P;(function(l){l[l.Inactive=0]="Inactive",l[l.Initializing=1]="Initializing",l[l.Stopped=2]="Stopped",l[l.Running=3]="Running"})(P||(e.State=P={}));function $(l){switch(l){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$kH=$;var m;(function(l){l[l.Valid=0]="Valid",l[l.Unreadable=1]="Unreadable",l[l.Error=2]="Error"})(m||(e.MemoryRangeType=m={})),e.$lH="vscode-debug-memory";var y;(function(l){l[l.Initial=1]="Initial",l[l.Dynamic=2]="Dynamic"})(y||(e.DebugConfigurationProviderTriggerKind=y={}));var A;(function(l){l.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$mH=(0,C.$Xh)("debugService");var S;(function(l){l[l.CONDITION=0]="CONDITION",l[l.HIT_COUNT=1]="HIT_COUNT",l[l.LOG_MESSAGE=2]="LOG_MESSAGE"})(S||(e.BreakpointWidgetContext=S={}))}),define(Ae[208],Re([1,0,12,2,20,26,13,29,19,18]),function(we,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=void 0;const A=/{([^}]+)}/g;function S(I,h,b){return I.replace(A,function(k,F){return h&&F.length>0&&F[0]!=="_"?k:b&&b.hasOwnProperty(F)?b[F]:k})}e.$gF=S;function l(I){const h={};for(const b of Object.keys(I))b.startsWith("!")||(h[b]=I[b]);return h}e.$hF=l;function p(I){return I.configuration.request==="attach"&&!w(I)&&(!I.parentSession||p(I.parentSession))}e.$iF=p;function w(I){let h=I.configuration.type;if(h)return h==="vslsShare"&&(h=I.configuration.adapterProxy.configuration.type),(0,E.$6e)(h,"extensionhost")||(0,E.$6e)(h,"pwa-extensionhost")?I:I.parentSession?w(I.parentSession):void 0}e.$jF=w;function a(I){return I.type&&(I.label||I.program||I.runtime)}e.$kF=a;function s(I,h,b){let k,F=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let J=null;for(;J=W.exec(I);){const N=J.index+1,R=N+J[0].length;if(N<=h&&R>=b){k=J[0],F=N;break}}if(k){const N=/\w+/g;let R=null;for(;(R=N.exec(k))&&!(R.index+1+F+R[0].length>=b););R&&(k=k.substring(0,N.lastIndex))}return k?{start:F,end:F+k.length-1}:{start:0,end:0}}e.$lF=s;async function t(I,h,b,k){if(I.evaluatableExpressionProvider.has(h)){const F=I.evaluatableExpressionProvider.ordered(h),W=(0,y.$Gb)(await Promise.all(F.map(async J=>{try{return await J.provideEvaluatableExpression(h,b,k??m.CancellationToken.None)}catch{return}})));if(W.length>0){let J=W[0].expression;const N=W[0].range;return J||(J=h.getLineContent(b.lineNumber).substring(N.startColumn-1,N.endColumn-1)),{range:N,matchingExpression:J}}}else{const F=h.getLineContent(b.lineNumber),{start:W,end:J}=s(F,b.column,b.column),N=F.substring(W-1,J);return{matchingExpression:N,range:new $.$Bs(b.lineNumber,W,b.lineNumber,W+N.length)}}return null}e.$mF=t;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(I){return!!(I&&I.match(n))}e.$nF=o;function c(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(o(I.path))return T.URI.parse(I.path);if((0,C.$hc)(I.path))return T.URI.file(I.path)}return I.path}function d(I){if(typeof I.path=="object"){const h=T.URI.revive(I.path);if(h)return h.scheme===P.Schemas.file?h.fsPath:h.toString()}return I.path}function i(I,h){const b=h?c:d,k=(0,M.$cn)(I);return u(k,(F,W)=>{F&&W&&(W.path=b(W))}),k}e.$oF=i;function r(I,h){const b=h?c:d,k=(0,M.$cn)(I);return u(k,(F,W)=>{!F&&W&&(W.path=b(W))}),k}e.$pF=r;function u(I,h){switch(I.type){case"event":{const b=I;switch(b.event){case"output":h(!1,b.body.source);break;case"loadedSource":h(!1,b.body.source);break;case"breakpoint":h(!1,b.body.breakpoint.source);break;default:break}break}case"request":{const b=I;switch(b.command){case"setBreakpoints":h(!0,b.arguments.source);break;case"breakpointLocations":h(!0,b.arguments.source);break;case"source":h(!0,b.arguments.source);break;case"gotoTargets":h(!0,b.arguments.source);break;case"launchVSCode":b.arguments.args.forEach(k=>h(!1,k));break;default:break}break}case"response":{const b=I;if(b.success&&b.body)switch(b.command){case"stackTrace":b.body.stackFrames.forEach(k=>h(!1,k.source));break;case"loadedSources":b.body.sources.forEach(k=>h(!1,k));break;case"scopes":b.body.scopes.forEach(k=>h(!1,k.source));break;case"setFunctionBreakpoints":b.body.breakpoints.forEach(k=>h(!1,k.source));break;case"setBreakpoints":b.body.breakpoints.forEach(k=>h(!1,k.source));break;case"disassemble":b.body?.instructions.forEach(F=>h(!1,F.location));break;default:break}break}}}function f(I){return I.filter(h=>!h.presentation?.hidden).sort((h,b)=>h.presentation?b.presentation?h.presentation.group?b.presentation.group?h.presentation.group!==b.presentation.group?h.presentation.group.localeCompare(b.presentation.group):v(h.presentation.order,b.presentation.order):-1:b.presentation.group?1:v(h.presentation.order,b.presentation.order):-1:b.presentation?1:0)}e.$qF=f;function v(I,h){return typeof I!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:I-h}async function g(I,h){const b=I.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(b!=="none"&&(await h.saveAll(),b==="allEditorsInActiveGroup")){const k=h.activeEditorPane;k&&k.input.resource?.scheme===P.Schemas.untitled&&await h.save({editor:k.input,groupId:k.group.id})}await I.reloadConfiguration()}e.$rF=g;const D=(I,h)=>!I||!h?I===h:I.name===h.name&&I.path===h.path&&I.sourceReference===h.sourceReference;e.$sF=D}),define(Ae[76],Re([1,0,24,34,67,68,13,20,21,35]),function(we,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GI=e.$FI=e.$EI=e.$DI=e.CellStatusbarAlignment=e.$CI=e.$BI=e.$AI=e.NotebookEditorPriority=e.$zI=e.$yI=e.$xI=e.$wI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$vI=e.$uI=e.$tI=e.$sI=e.CellKind=e.$rI=e.$qI=e.$pI=void 0,e.$pI="workbench.editor.notebook",e.$qI="workbench.editor.notebookTextDiffEditor",e.$rI="workbench.editor.interactive";var A;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(A||(e.CellKind=A={})),e.$sI=["application/json","application/javascript","text/html","image/svg+xml",M.$Xr.latex,M.$Xr.markdown,"image/png","image/jpeg",M.$Xr.text],e.$tI=[M.$Xr.latex,M.$Xr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Xr.text],e.$uI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$vI="_notAvailable";var S;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(S||(e.NotebookRunState=S={}));var l;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(l||(e.NotebookCellExecutionState=l={}));var p;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var w;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(w||(e.NotebookRendererMatch=w={}));var a;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(a||(e.RendererMessagingSpec=a={}));var s;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var t;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(t||(e.SelectionStateType=t={}));var n;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var o;(function(O){O.scheme=P.Schemas.vscodeNotebookCell;const X=["W","X","Y","Z","a","b","c","d","e","f"],he=new RegExp(`^[${X.join("")}]+`),$e=7;function De(se,Q){const U=Q.toString($e),pe=`${U.length<X.length?X[U.length-1]:"z"}${U}s${(0,E.$ze)(E.$fe.fromString(se.scheme),!0,!0)}`;return se.with({scheme:O.scheme,fragment:pe})}O.generate=De;function ke(se){if(se.scheme!==O.scheme)return;const Q=se.fragment.indexOf("s");if(Q<0)return;const U=parseInt(se.fragment.substring(0,Q).replace(he,""),$e),ne=(0,E.$ye)(se.fragment.substring(Q+1)).toString();if(!isNaN(U))return{handle:U,notebook:se.with({scheme:ne,fragment:null})}}O.parse=ke;function de(se,Q){return se.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${Q??""},${se.scheme!==P.Schemas.file?se.scheme:""}`})}O.generateCellOutputUri=de;function Ee(se){if(se.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const Q=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(se.fragment);if(!Q)return;const U=Q[1]&&Q[1]!==""?Q[1]:void 0,ne=Q[2];return{outputId:U,notebook:se.with({scheme:ne||P.Schemas.file,fragment:null})}}O.parseCellOutputUri=Ee;function _(se,Q,U){return O.generate(se,Q).with({scheme:U})}O.generateCellPropertyUri=_;function Ce(se,Q){if(se.scheme===Q)return O.parse(se.with({scheme:O.scheme}))}O.parseCellPropertyUri=Ce})(o||(e.CellUri=o={}));const c=O=>m.$i?O.replace(/\//g,"\\"):O;class d{constructor(X=[],he=e.$sI){this.e=he,this.d=[...new Set(X)].map($e=>({pattern:$e,matches:T.$Ej(c($e))}))}sort(X){const he=new Map(C.Iterable.map(X,De=>[De,c(De)]));let $e=[];for(const{matches:De}of this.d)for(const[ke,de]of he)if(De(de)){$e.push(ke),he.delete(ke);break}return he.size&&($e=$e.concat([...he.keys()].sort((De,ke)=>this.e.indexOf(De)-this.e.indexOf(ke)))),$e}prioritize(X,he){const $e=this.f(X);if($e===-1){this.d.unshift({pattern:X,matches:T.$Ej(c(X))});return}const De=new Set(he.map(de=>this.f(de,$e)));De.delete(-1);const ke=Array.from(De).sort();this.d.splice($e+1,0,...ke.map(de=>this.d[de]));for(let de=ke.length-1;de>=0;de--)this.d.splice(ke[de],1)}toArray(){return this.d.map(X=>X.pattern)}f(X,he=this.d.length){const $e=c(X);for(let De=0;De<he;De++)if(this.d[De].matches($e))return De;return-1}}e.$wI=d;function i(O,X,he,$e=(De,ke)=>De===ke){const De=[];function ke(_,Ce,se){if(Ce===0&&se.length===0)return;const Q=De[De.length-1];Q&&Q.start+Q.deleteCount===_?(Q.deleteCount+=Ce,Q.toInsert.push(...se)):De.push({start:_,deleteCount:Ce,toInsert:se})}let de=0,Ee=0;for(;;){if(de===O.length){ke(de,0,X.slice(Ee));break}if(Ee===X.length){ke(de,O.length-de,[]);break}const _=O[de],Ce=X[Ee];if($e(_,Ce)){de+=1,Ee+=1;continue}he(Ce)?(ke(de,1,[]),de+=1):(ke(de,0,[Ce]),Ee+=1)}return De}e.$xI=i,e.$yI=new y.$cj("notebookEditorCursorAtBoundary","none"),e.$zI=new y.$cj("notebookEditorCursorAtLineBoundary","none");var r;(function(O){O.default="default",O.option="option"})(r||(e.NotebookEditorPriority=r={}));function u(O){const X=O;return!!((typeof X.include=="string"||T.$Fj(X.include))&&(typeof X.exclude=="string"||T.$Fj(X.exclude)))}e.$AI=u;function f(O,X,he){if(Array.isArray(O.viewType)&&O.viewType.indexOf(X)>=0||O.viewType===X)return!0;if(O.filenamePattern){const $e=u(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,De=u(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(T.$Dj($e,(0,$.$mc)(he.fsPath).toLowerCase()))return!(De&&T.$Dj(De,(0,$.$mc)(he.fsPath).toLowerCase()))}return!1}e.$BI=f,e.$CI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var v;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(v||(e.CellStatusbarAlignment=v={}));class g{static{this.d="notebook/"}static create(X){return`${g.d}${X}`}static parse(X){if(X.startsWith(g.d))return X.substring(g.d.length)}}e.$DI=g;function D(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$EI=D;const I=new TextDecoder;function h(O){const X=[];let he=!1;for(const de of O)(X.length===0||he)&&(X.push(de),he=!0);let $e=F(X);const De=E.$fe.concat(X.map(de=>E.$fe.wrap(de))),ke=L(De);return $e=$e||ke.byteLength!==De.byteLength,{data:ke,didCompression:$e}}e.$FI=h,e.$GI=`${String.fromCharCode(27)}[A`;const b=e.$GI.split("").map(O=>O.charCodeAt(0)),k=10;function F(O){let X=!1;return O.forEach((he,$e)=>{if($e===0||he.length<e.$GI.length)return;const De=O[$e-1],ke=he.subarray(0,e.$GI.length);if(ke[0]===b[0]&&ke[1]===b[1]&&ke[2]===b[2]){const de=De.lastIndexOf(k);if(de===-1)return;X=!0,O[$e-1]=De.subarray(0,de),O[$e]=he.subarray(e.$GI.length)}}),X}function W(O){let X=O;do O=X,X=O.replace(/[^\n]\x08/gm,"");while(X.length<O.length);return O}function J(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const X=O.match(/^(.*)\r+/m)[1];let he=O.match(/\r+(.*)$/m)[1];he=he+X.slice(he.length,X.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,he)}return O}const N="\b".charCodeAt(0),R="\r".charCodeAt(0);function L(O){return!O.buffer.includes(N)&&!O.buffer.includes(R)?O:E.$fe.fromString(J(W(I.decode(O.buffer))))}}),define(Ae[7],Re([1,0,18,11,52,28,68,12,16,2,33,22,41,99,76]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w){"use strict";var a,s,t,n,o,c,d,i,r,u,f,v,g,D,I,h,b,k;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$qM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.TestRunProfileKind=e.TestResultState=e.$9L=e.$8L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$7L=e.NotebookVariablesRequestKind=e.$6L=e.$5L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$4L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.ColorThemeKind=e.$XL=e.$WL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$VL=e.DebugConsoleMode=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$PL=e.$OL=e.FileChangeType=e.$NL=e.$ML=e.$LL=e.$KL=e.InlineCompletionTriggerKind=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.ConfigurationTarget=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$nL=e.ViewBadge=e.ProgressLocation=e.$mL=e.$lL=e.TaskScope=e.ShellQuoting=e.$kL=e.$jL=e.$iL=e.TaskPanelKind=e.TaskRevealKind=e.$hL=e.TerminalLocation=e.$gL=e.$fL=e.$eL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$dL=e.$cL=e.$bL=e.$aL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$_K=e.StatusBarAlignment=e.ViewColumn=e.$$K=e.$0K=e.$9K=e.$8K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$7K=e.$6K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.LanguageStatusSeverity=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.CodeActionTriggerKind=e.$TK=e.$SK=e.SymbolTag=e.SymbolKind=e.$RK=e.DocumentHighlightKind=e.$QK=e.$PK=e.$OK=e.$NK=e.DiagnosticSeverity=e.DiagnosticTag=e.$MK=e.$LK=e.FileEditType=e.$KK=e.$JK=e.$IK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(j){return Object.assign(j,{apply:function(...oe){if(oe.length===0)return Reflect.construct(j,[]);{const Ie=oe.length===1?[]:oe[1];return Reflect.construct(j,Ie,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(j,[]);{const[Ie,...Ge]=oe;return Reflect.construct(j,Ge,Ie.constructor)}}})}var W;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var J;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(J||(e.TerminalQuickFixType=J={}));let N=a=class{static from(...B){let oe=B;return new a(function(){if(oe){for(const Ie of oe)Ie&&typeof Ie.dispose=="function"&&Ie.dispose();oe=void 0}})}#e;constructor(B){this.#e=B}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$BK=N,e.$BK=N=a=Ke([F],N);let R=s=class{static Min(...B){if(B.length===0)throw new TypeError;let oe=B[0];for(let Ie=1;Ie<B.length;Ie++){const Ge=B[Ie];Ge.isBefore(oe)&&(oe=Ge)}return oe}static Max(...B){if(B.length===0)throw new TypeError;let oe=B[0];for(let Ie=1;Ie<B.length;Ie++){const Ge=B[Ie];Ge.isAfter(oe)&&(oe=Ge)}return oe}static isPosition(B){if(!B)return!1;if(B instanceof s)return!0;const{line:oe,character:Ie}=B;return typeof oe=="number"&&typeof Ie=="number"}static of(B){if(B instanceof s)return B;if(this.isPosition(B))return new s(B.line,B.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(B,oe){if(B<0)throw(0,T.$6)("line must be non-negative");if(oe<0)throw(0,T.$6)("character must be non-negative");this.c=B,this.e=oe}isBefore(B){return this.c<B.c?!0:B.c<this.c?!1:this.e<B.e}isBeforeOrEqual(B){return this.c<B.c?!0:B.c<this.c?!1:this.e<=B.e}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this.c===B.c&&this.e===B.e}compareTo(B){return this.c<B.c?-1:this.c>B.line?1:this.e<B.e?-1:this.e>B.e?1:0}translate(B,oe=0){if(B===null||oe===null)throw(0,T.$6)();let Ie;return typeof B>"u"?Ie=0:typeof B=="number"?Ie=B:(Ie=typeof B.lineDelta=="number"?B.lineDelta:0,oe=typeof B.characterDelta=="number"?B.characterDelta:0),Ie===0&&oe===0?this:new s(this.line+Ie,this.character+oe)}with(B,oe=this.character){if(B===null||oe===null)throw(0,T.$6)();let Ie;return typeof B>"u"?Ie=this.line:typeof B=="number"?Ie=B:(Ie=typeof B.line=="number"?B.line:this.line,oe=typeof B.character=="number"?B.character:this.character),Ie===this.line&&oe===this.character?this:new s(Ie,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$CK=R,e.$CK=R=s=Ke([F],R);let L=t=class{static isRange(B){return B instanceof t?!0:B?R.isPosition(B.start)&&R.isPosition(B.end):!1}static of(B){if(B instanceof t)return B;if(this.isRange(B))return new t(B.start,B.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(B,oe,Ie,Ge){let xe,at;if(typeof B=="number"&&typeof oe=="number"&&typeof Ie=="number"&&typeof Ge=="number"?(xe=new R(B,oe),at=new R(Ie,Ge)):R.isPosition(B)&&R.isPosition(oe)&&(xe=R.of(B),at=R.of(oe)),!xe||!at)throw new Error("Invalid arguments");xe.isBefore(at)?(this.c=xe,this.e=at):(this.c=at,this.e=xe)}contains(B){return t.isRange(B)?this.contains(B.start)&&this.contains(B.end):R.isPosition(B)?!(R.of(B).isBefore(this.c)||this.e.isBefore(B)):!1}isEqual(B){return this.c.isEqual(B.c)&&this.e.isEqual(B.e)}intersection(B){const oe=R.Max(B.start,this.c),Ie=R.Min(B.end,this.e);if(!oe.isAfter(Ie))return new t(oe,Ie)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const oe=R.Min(B.start,this.c),Ie=R.Max(B.end,this.end);return new t(oe,Ie)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(B,oe=this.end){if(B===null||oe===null)throw(0,T.$6)();let Ie;return B?R.isPosition(B)?Ie=B:(Ie=B.start||this.start,oe=B.end||this.end):Ie=this.start,Ie.isEqual(this.c)&&oe.isEqual(this.end)?this:new t(Ie,oe)}toJSON(){return[this.start,this.end]}};e.$DK=L,e.$DK=L=t=Ke([F],L);let O=n=class extends L{static isSelection(B){return B instanceof n?!0:B?L.isRange(B)&&R.isPosition(B.anchor)&&R.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(B,oe,Ie,Ge){let xe,at;if(typeof B=="number"&&typeof oe=="number"&&typeof Ie=="number"&&typeof Ge=="number"?(xe=new R(B,oe),at=new R(Ie,Ge)):R.isPosition(B)&&R.isPosition(oe)&&(xe=R.of(B),at=R.of(oe)),!xe||!at)throw new Error("Invalid arguments");super(xe,at),this.f=xe,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$EK=O,e.$EK=O=n=Ke([F],O);const X=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,T.$6)("connectionToken")};class he{static isResolvedAuthority(B){return B&&typeof B=="object"&&typeof B.host=="string"&&typeof B.port=="number"&&(B.connectionToken===void 0||typeof B.connectionToken=="string")}constructor(B,oe,Ie){if(typeof B!="string"||B.length===0)throw(0,T.$6)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,T.$6)("port");typeof Ie<"u"&&X(Ie),this.host=B,this.port=Math.round(oe),this.connectionToken=Ie}}e.$FK=he;class $e{static isManagedResolvedAuthority(B){return B&&typeof B=="object"&&typeof B.makeConnection=="function"&&(B.connectionToken===void 0||typeof B.connectionToken=="string")}constructor(B,oe){this.makeConnection=B,this.connectionToken=oe,typeof oe<"u"&&X(oe)}}e.$GK=$e;class De extends Error{static NotAvailable(B,oe){return new De(B,p.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(B){return new De(B,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(B,oe=p.RemoteAuthorityResolverErrorCode.Unknown,Ie){super(B),this._message=B,this._code=oe,this._detail=Ie,Object.setPrototypeOf(this,De.prototype)}}e.$HK=De;var ke;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(ke||(e.EndOfLine=ke={}));var de;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(de||(e.EnvironmentVariableMutatorType=de={}));let Ee=o=class{static isTextEdit(B){return B instanceof o?!0:B?L.isRange(B)&&typeof B.newText=="string":!1}static replace(B,oe){return new o(B,oe)}static insert(B,oe){return o.replace(new L(B,B),oe)}static delete(B){return o.replace(B,"")}static setEndOfLine(B){const oe=new o(new L(new R(0,0),new R(0,0)),"");return oe.newEol=B,oe}get range(){return this.c}set range(B){if(B&&!L.isRange(B))throw(0,T.$6)("range");this.c=B}get newText(){return this.e||""}set newText(B){if(B&&typeof B!="string")throw(0,T.$6)("newText");this.e=B}get newEol(){return this.f}set newEol(B){if(B&&typeof B!="number")throw(0,T.$6)("newEol");this.f=B}constructor(B,oe){this.c=B,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$IK=Ee,e.$IK=Ee=o=Ke([F],Ee);let _=c=class{static isNotebookCellEdit(B){return B instanceof c?!0:B?xt.isNotebookRange(B)&&Array.isArray(B.newCells):!1}static replaceCells(B,oe){return new c(B,oe)}static insertCells(B,oe){return new c(new xt(B,B),oe)}static deleteCells(B){return new c(B,[])}static updateCellMetadata(B,oe){const Ie=new c(new xt(B,B),[]);return Ie.newCellMetadata=oe,Ie}static updateNotebookMetadata(B){const oe=new c(new xt(0,0),[]);return oe.newNotebookMetadata=B,oe}constructor(B,oe){this.range=B,this.newCells=oe}};e.$JK=_,e.$JK=_=c=Ke([F],_);class Ce{static isSnippetTextEdit(B){return B instanceof Ce?!0:B?L.isRange(B.range)&&U.isSnippetString(B.snippet):!1}static replace(B,oe){return new Ce(B,oe)}static insert(B,oe){return Ce.replace(new L(B,B),oe)}constructor(B,oe){this.range=B,this.snippet=oe}}e.$KK=Ce;var se;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(se||(e.FileEditType=se={}));let Q=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(B,oe,Ie,Ge){this.c.push({_type:1,from:B,to:oe,options:Ie,metadata:Ge})}createFile(B,oe,Ie){this.c.push({_type:1,from:void 0,to:B,options:oe,metadata:Ie})}deleteFile(B,oe,Ie){this.c.push({_type:1,from:B,to:void 0,options:oe,metadata:Ie})}e(B,oe,Ie){this.c.push({_type:3,metadata:Ie,uri:B,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(B,oe,Ie,Ge){const xe=oe.start,at=oe.end;(xe!==at||Ie.length>0)&&this.c.push({_type:5,uri:B,index:xe,count:at-xe,cells:Ie,metadata:Ge})}g(B,oe,Ie,Ge){this.c.push({_type:3,metadata:Ge,uri:B,edit:{editType:3,index:oe,metadata:Ie}})}replace(B,oe,Ie,Ge){this.c.push({_type:2,uri:B,edit:new Ee(oe,Ie),metadata:Ge})}insert(B,oe,Ie,Ge){this.replace(B,new L(oe,oe),Ie,Ge)}delete(B,oe,Ie){this.replace(B,oe,"",Ie)}has(B){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===B.toString())}set(B,oe){if(oe)for(const Ie of oe){if(!Ie)continue;let Ge,xe;Array.isArray(Ie)?(Ge=Ie[0],xe=Ie[1]):Ge=Ie,_.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(B,Ge.range.start,Ge.newCellMetadata,xe):Ge.newNotebookMetadata?this.e(B,Ge.newNotebookMetadata,xe):this.f(B,Ge.range,Ge.newCells,xe):Ce.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:B,range:Ge.range,edit:Ge.snippet,metadata:xe}):this.c.push({_type:2,uri:B,edit:Ge,metadata:xe})}else{for(let Ie=0;Ie<this.c.length;Ie++){const Ge=this.c[Ie];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===B.toString()&&(this.c[Ie]=void 0);break}}(0,E.$Hb)(this.c)}}get(B){const oe=[];for(const Ie of this.c)Ie._type===2&&Ie.uri.toString()===B.toString()&&oe.push(Ie.edit);return oe}entries(){const B=new M.$zc;for(const oe of this.c)if(oe._type===2){let Ie=B.get(oe.uri);Ie||(Ie=[oe.uri,[]],B.set(oe.uri,Ie)),Ie[1].push(oe.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$LK=Q,e.$LK=Q=Ke([F],Q);let U=d=class{static isSnippetString(B){return B instanceof d?!0:B?typeof B.value=="string":!1}static c(B){return B.replace(/\$|}|\\/g,"\\$&")}constructor(B){this.e=1,this.value=B||""}appendText(B){return this.value+=d.c(B),this}appendTabstop(B=this.e++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,oe=this.e++){if(typeof B=="function"){const Ie=new d;Ie.e=this.e,B(Ie),this.e=Ie.e,B=Ie.value}else B=d.c(B);return this.value+="${",this.value+=oe,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,oe=this.e++){const Ie=B.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=Ie,this.value+="|}",this}appendVariable(B,oe){if(typeof oe=="function"){const Ie=new d;Ie.e=this.e,oe(Ie),this.e=Ie.e,oe=Ie.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$MK=U,e.$MK=U=d=Ke([F],U);var ne;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ne||(e.DiagnosticTag=ne={}));var pe;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(pe||(e.DiagnosticSeverity=pe={}));let re=i=class{static isLocation(B){return B instanceof i?!0:B?L.isRange(B.range)&&y.URI.isUri(B.uri):!1}constructor(B,oe){if(this.uri=B,oe)if(L.isRange(oe))this.range=L.of(oe);else if(R.isPosition(oe))this.range=new L(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$NK=re,e.$NK=re=i=Ke([F],re);let le=class{static is(B){return B?typeof B.message=="string"&&B.location&&L.isRange(B.location.range)&&y.URI.isUri(B.location.uri):!1}constructor(B,oe){this.location=B,this.message=oe}static isEqual(B,oe){return B===oe?!0:!B||!oe?!1:B.message===oe.message&&B.location.range.isEqual(oe.location.range)&&B.location.uri.toString()===oe.location.uri.toString()}};e.$OK=le,e.$OK=le=Ke([F],le);let ce=class{constructor(B,oe,Ie=pe.Error){if(!L.isRange(B))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=B,this.message=oe,this.severity=Ie}toJSON(){return{severity:pe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,oe){return B===oe?!0:!B||!oe?!1:B.message===oe.message&&B.severity===oe.severity&&B.code===oe.code&&B.severity===oe.severity&&B.source===oe.source&&B.range.isEqual(oe.range)&&(0,E.$tb)(B.tags,oe.tags)&&(0,E.$tb)(B.relatedInformation,oe.relatedInformation,le.isEqual)}};e.$PK=ce,e.$PK=ce=Ke([F],ce);let be=class{constructor(B,oe){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:this.contents=[B],this.range=oe}};e.$QK=be,e.$QK=be=Ke([F],be);var ee;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(ee||(e.DocumentHighlightKind=ee={}));let fe=class{constructor(B,oe=ee.Text){this.range=B,this.kind=oe}toJSON(){return{range:this.range,kind:ee[this.kind]}}};e.$RK=fe,e.$RK=fe=Ke([F],fe);var ie;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ie||(e.SymbolKind=ie={}));var ae;(function(j){j[j.Deprecated=1]="Deprecated"})(ae||(e.SymbolTag=ae={}));let me=r=class{static validate(B){if(!B.name)throw new Error("name must not be falsy")}constructor(B,oe,Ie,Ge,xe){this.name=B,this.kind=oe,this.containerName=xe,typeof Ie=="string"&&(this.containerName=Ie),Ge instanceof re?this.location=Ge:Ie instanceof L&&(this.location=new re(Ge,Ie)),r.validate(this)}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};e.$SK=me,e.$SK=me=r=Ke([F],me);let Pe=u=class{static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children?.forEach(u.validate)}constructor(B,oe,Ie,Ge,xe){this.name=B,this.detail=oe,this.kind=Ie,this.range=Ge,this.selectionRange=xe,this.children=[],u.validate(this)}};e.$TK=Pe,e.$TK=Pe=u=Ke([F],Pe);var z;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(z||(e.CodeActionTriggerKind=z={}));let V=class{constructor(B,oe){this.title=B,this.kind=oe}};e.$UK=V,e.$UK=V=Ke([F],V);let H=class{static{f=this}static{this.c="."}constructor(B){this.value=B}append(B){return new f(this.value?this.value+f.c+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+f.c)}};e.$VK=H,e.$VK=H=f=Ke([F],H),H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorMove=H.Refactor.append("move"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll"),H.Notebook=H.Empty.append("notebook");let G=class{constructor(B,oe){if(this.range=B,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$WK=G,e.$WK=G=Ke([F],G);class q{constructor(B,oe,Ie,Ge,xe,at){this.kind=B,this.name=oe,this.detail=Ie,this.uri=Ge,this.range=xe,this.selectionRange=at}}e.$XK=q;class x{constructor(B,oe){this.fromRanges=oe,this.from=B}}e.$YK=x;class ue{constructor(B,oe){this.fromRanges=oe,this.to=B}}e.$ZK=ue;var Ne;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let Be=class{constructor(B,oe){this.range=B,this.command=oe}get isResolved(){return!!this.command}};e.$1K=Be,e.$1K=Be=Ke([F],Be);let Xe=v=class{#e;static isMarkdownString(B){return B instanceof v?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}constructor(B,oe=!1){this.#e=new C.$$j(B,{supportThemeIcons:oe})}get value(){return this.#e.value}set value(B){this.#e.value=B}get isTrusted(){return this.#e.isTrusted}set isTrusted(B){this.#e.isTrusted=B}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(B){this.#e.supportThemeIcons=B}get supportHtml(){return this.#e.supportHtml}set supportHtml(B){this.#e.supportHtml=B}get baseUri(){return this.#e.baseUri}set baseUri(B){this.#e.baseUri=B}appendText(B){return this.#e.appendText(B),this}appendMarkdown(B){return this.#e.appendMarkdown(B),this}appendCodeblock(B,oe){return this.#e.appendCodeblock(oe??"",B),this}};e.$2K=Xe,e.$2K=Xe=v=Ke([F],Xe);let Je=class{constructor(B,oe){this.label=B,this.documentation=oe}};e.$3K=Je,e.$3K=Je=Ke([F],Je);let it=class{constructor(B,oe){this.label=B,this.documentation=oe,this.parameters=[]}};e.$4K=it,e.$4K=it=Ke([F],it);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$5K=_e,e.$5K=_e=Ke([F],_e);var tt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var rt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let nt=class{constructor(B){this.value=B}};e.$6K=nt,e.$6K=nt=Ke([F],nt);let ze=class{constructor(B,oe,Ie){this.position=B,this.label=oe,this.kind=Ie}};e.$7K=ze,e.$7K=ze=Ke([F],ze);var ht;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ht||(e.CompletionTriggerKind=ht={}));var Y;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Y||(e.CompletionItemKind=Y={}));var Z;(function(j){j[j.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let ye=class{constructor(B,oe){this.label=B,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&Y[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$8K=ye,e.$8K=ye=Ke([F],ye);let Ue=class{constructor(B=[],oe=!1){this.items=B,this.isIncomplete=oe}};e.$9K=Ue,e.$9K=Ue=Ke([F],Ue);let He=class{constructor(B,oe,Ie){this.insertText=B,this.range=oe,this.command=Ie}};e.$0K=He,e.$0K=He=Ke([F],He);let Ye=class{constructor(B){this.commands=void 0,this.suppressSuggestions=void 0,this.items=B}};e.$$K=Ye,e.$$K=Ye=Ke([F],Ye);var st;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(st||(e.ViewColumn=st={}));var pt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(pt||(e.StatusBarAlignment=pt={}));function Te(j,B){return`${S.$bm.toKey(j)}.${B}`}e.$_K=Te;var At;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(At||(e.TextEditorLineNumbersStyle=At={}));var Kt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var bt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(bt||(e.TextEditorSelectionChangeKind=bt={}));var jt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Ot;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ot||(e.DecorationRangeBehavior=Ot={})),function(j){function B(oe){switch(oe){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=B}(bt||(e.TextEditorSelectionChangeKind=bt={}));var Gt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(j){function B(oe){switch(oe){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=B}(Gt||(e.SyntaxTokenType=Gt={}));let Ut=class{constructor(B,oe){if(oe&&!y.URI.isUri(oe))throw(0,T.$6)("target");if(!L.isRange(B)||B.isEmpty)throw(0,T.$6)("range");this.range=B,this.target=oe}};e.$aL=Ut,e.$aL=Ut=Ke([F],Ut);let kt=class{constructor(B,oe,Ie,Ge){this.red=B,this.green=oe,this.blue=Ie,this.alpha=Ge}};e.$bL=kt,e.$bL=kt=Ke([F],kt);let Tt=class{constructor(B,oe){if(oe&&!(oe instanceof kt))throw(0,T.$6)("color");if(!L.isRange(B)||B.isEmpty)throw(0,T.$6)("range");this.range=B,this.color=oe}};e.$cL=Tt,e.$cL=Tt=Ke([F],Tt);let Qe=class{constructor(B){if(!B||typeof B!="string")throw(0,T.$6)("label");this.label=B}};e.$dL=Qe,e.$dL=Qe=Ke([F],Qe);var Jt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Wt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var ct;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(ct||(e.TerminalExitReason=ct={}));class ft{constructor(B,oe,Ie){if(this.startIndex=B,this.length=oe,this.tooltip=Ie,typeof B!="number"||B<0)throw(0,T.$6)("startIndex");if(typeof oe!="number"||oe<1)throw(0,T.$6)("length");if(Ie!==void 0&&typeof Ie!="string")throw(0,T.$6)("tooltip")}}e.$eL=ft;class Vt{constructor(B){this.uri=B}}e.$fL=Vt;class Rt{constructor(B){this.terminalCommand=B}}e.$gL=Rt;var Dt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Dt||(e.TerminalLocation=Dt={}));class gt{constructor(B){if(this.options=B,typeof B!="object")throw(0,T.$6)("options")}}e.$hL=gt;var Mt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(Mt||(e.TaskRevealKind=Mt={}));var Pt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Pt||(e.TaskPanelKind=Pt={}));let St=class{static{g=this}static{this.Clean=new g("clean","Clean")}static{this.Build=new g("build","Build")}static{this.Rebuild=new g("rebuild","Rebuild")}static{this.Test=new g("test","Test")}static from(B){switch(B){case"clean":return g.Clean;case"build":return g.Build;case"rebuild":return g.Rebuild;case"test":return g.Test;default:return}}constructor(B,oe){if(this.label=oe,typeof B!="string"||typeof oe!="string")throw(0,T.$6)("name");this.c=B}get id(){return this.c}};e.$iL=St,e.$iL=St=g=Ke([F],St);function Ve(j){let B="";for(let oe=0;oe<j.length;oe++)B+=j[oe].replace(/,/g,",,")+",";return B}let Nt=class{constructor(B,oe,Ie){if(typeof B!="string")throw(0,T.$6)("process");this.e=[],this.c=B,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=Ie):this.f=oe)}get process(){return this.c}set process(B){if(typeof B!="string")throw(0,T.$6)("process");this.c=B}get args(){return this.e}set args(B){Array.isArray(B)||(B=[]),this.e=B}get options(){return this.f}set options(B){this.f=B}computeId(){const B=[];if(B.push("process"),this.c!==void 0&&B.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)B.push(oe);return Ve(B)}};e.$jL=Nt,e.$jL=Nt=Ke([F],Nt);let zt=class{constructor(B,oe,Ie){if(this.f=[],Array.isArray(oe)){if(!B)throw(0,T.$6)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,T.$6)("command");this.e=B,this.f=oe,this.g=Ie}else{if(typeof B!="string")throw(0,T.$6)("commandLine");this.c=B,this.g=oe}}get commandLine(){return this.c}set commandLine(B){if(typeof B!="string")throw(0,T.$6)("commandLine");this.c=B}get command(){return this.e?this.e:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,T.$6)("command");this.e=B}get args(){return this.f}set args(B){this.f=B||[]}get options(){return this.g}set options(B){this.g=B}computeId(){const B=[];if(B.push("shell"),this.c!==void 0&&B.push(this.c),this.e!==void 0&&B.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)B.push(typeof oe=="string"?oe:oe.value);return Ve(B)}};e.$kL=zt,e.$kL=zt=Ke([F],zt);var Zt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Zt||(e.ShellQuoting=Zt={}));var Se;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Se||(e.TaskScope=Se={}));class Me{constructor(B){this.c=B}computeId(){return"customExecution"+(0,A.$kg)()}set callback(B){this.c=B}get callback(){return this.c}}e.$lL=Me;let ve=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(B,oe,Ie,Ge,xe,at){this.j=!1,this.k=this.definition=B;let dt;typeof oe=="string"?(this.m=this.name=oe,this.t=this.source=Ie,this.execution=Ge,dt=xe,this.j=!0):oe===Se.Global||oe===Se.Workspace?(this.target=oe,this.m=this.name=Ie,this.t=this.source=Ge,this.execution=xe,dt=at):(this.target=oe,this.m=this.name=Ie,this.t=this.source=Ge,this.execution=xe,dt=at),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(B){this.h=B}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Nt?this.k={type:D.e,id:this.n.computeId()}:this.n instanceof zt?this.k={type:D.f,id:this.n.computeId()}:this.n instanceof Me?this.k={type:D.c,id:this.n.computeId()}:this.k={type:D.g,id:(0,A.$kg)()}}get definition(){return this.k}set definition(B){if(B==null)throw(0,T.$6)("Kind can't be undefined or null");this.z(),this.k=B}get scope(){return this.l}set target(B){this.z(),this.l=B}get name(){return this.m}set name(B){if(typeof B!="string")throw(0,T.$6)("name");this.z(),this.m=B}get execution(){return this.n}set execution(B){B===null&&(B=void 0),this.z(),this.n=B;const oe=this.k.type;(D.g===oe||D.e===oe||D.f===oe||D.c===oe)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(B){if(Array.isArray(B))this.z(),this.o=B,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.z(),this.r=B}get source(){return this.t}set source(B){if(typeof B!="string"||B.length===0)throw(0,T.$6)("source must be a string of length > 0");this.z(),this.t=B}get group(){return this.u}set group(B){B===null&&(B=void 0),this.z(),this.u=B}get detail(){return this.y}set detail(B){B===null&&(B=void 0),this.y=B}get presentationOptions(){return this.w}set presentationOptions(B){B==null&&(B=Object.create(null)),this.z(),this.w=B}get runOptions(){return this.x}set runOptions(B){B==null&&(B=Object.create(null)),this.z(),this.x=B}};e.$mL=ve,e.$mL=ve=D=Ke([F],ve);var K;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(K||(e.ProgressLocation=K={}));var Le;(function(j){function B(oe){const Ie=oe;return(0,m.$Gf)(Ie.value)?Ie.tooltip&&!(0,m.$Cf)(Ie.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ie.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ie.value),!1)}j.isViewBadge=B})(Le||(e.ViewBadge=Le={}));let je=I=class{static isTreeItem(B,oe){const Ie=B;if(Ie.checkboxState!==void 0){const Ge=(0,m.$Gf)(Ie.checkboxState)?Ie.checkboxState:(0,m.$Ef)(Ie.checkboxState)&&(0,m.$Gf)(Ie.checkboxState.state)?Ie.checkboxState.state:void 0,xe=!(0,m.$Gf)(Ie.checkboxState)&&(0,m.$Ef)(Ie.checkboxState)?Ie.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==qe.Checked&&Ge!==qe.Unchecked||xe!==void 0&&!(0,m.$Cf)(xe))return console.log("INVALID tree item, invalid checkboxState",Ie.checkboxState),!1}if(B instanceof I)return!0;if(Ie.label!==void 0&&!(0,m.$Cf)(Ie.label)&&!Ie.label?.label)return console.log("INVALID tree item, invalid label",Ie.label),!1;if(Ie.id!==void 0&&!(0,m.$Cf)(Ie.id))return console.log("INVALID tree item, invalid id",Ie.id),!1;if(Ie.iconPath!==void 0&&!(0,m.$Cf)(Ie.iconPath)&&!y.URI.isUri(Ie.iconPath)&&(!Ie.iconPath||!(0,m.$Cf)(Ie.iconPath.id))){const Ge=Ie.iconPath;if(!Ge||!(0,m.$Cf)(Ge.light)&&!y.URI.isUri(Ge.light)&&!(0,m.$Cf)(Ge.dark)&&!y.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Ie.iconPath),!1}return Ie.description!==void 0&&!(0,m.$Cf)(Ie.description)&&typeof Ie.description!="boolean"?(console.log("INVALID tree item, invalid description",Ie.description),!1):Ie.resourceUri!==void 0&&!y.URI.isUri(Ie.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ie.resourceUri),!1):Ie.tooltip!==void 0&&!(0,m.$Cf)(Ie.tooltip)&&!(Ie.tooltip instanceof Xe)?(console.log("INVALID tree item, invalid tooltip",Ie.tooltip),!1):Ie.command!==void 0&&!Ie.command.command?(console.log("INVALID tree item, invalid command",Ie.command),!1):Ie.collapsibleState!==void 0&&Ie.collapsibleState<Ze.None&&Ie.collapsibleState>Ze.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ie.collapsibleState),!1):Ie.contextValue!==void 0&&!(0,m.$Cf)(Ie.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ie.contextValue),!1):Ie.accessibilityInformation!==void 0&&!Ie.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ie.accessibilityInformation),!1):!0}constructor(B,oe=Ze.None){this.collapsibleState=oe,y.URI.isUri(B)?this.resourceUri=B:this.label=B}};e.$nL=je,e.$nL=je=I=Ke([F],je);var Ze;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Ze||(e.TreeItemCollapsibleState=Ze={}));var qe;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(qe||(e.TreeItemCheckboxState=qe={}));let et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(B){this.value=B}};e.$oL=et,e.$oL=et=Ke([F],et);class ut extends et{}e.$pL=ut;class vt extends ut{#e;constructor(B){super(""),this.#e=B}asFile(){return this.#e}}e.$qL=vt;class $t{constructor(B,oe,Ie,Ge){this.name=B,this.uri=oe,this._itemId=Ie,this.c=Ge}data(){return this.c()}}e.$rL=$t;let Et=class{#e=new Map;constructor(B){for(const[oe,Ie]of B??[]){const Ge=this.#e.get(this.#t(oe));Ge?Ge.push(Ie):this.#e.set(this.#t(oe),[Ie])}}get(B){return this.#e.get(this.#t(B))?.[0]}set(B,oe){this.#e.set(this.#t(B),[oe])}forEach(B,oe){for(const[Ie,Ge]of this.#e)for(const xe of Ge)B.call(oe,xe,Ie,this)}*[Symbol.iterator](){for(const[B,oe]of this.#e)for(const Ie of oe)yield[B,Ie]}#t(B){return B.toLowerCase()}};e.$sL=Et,e.$sL=Et=Ke([F],Et);let yt=class{constructor(B){this.insertText=B}};e.$tL=yt,e.$tL=yt=Ke([F],yt);let Di=class{constructor(B,oe){this.label=oe,this.insertText=B}};e.$uL=Di,e.$uL=Di=Ke([F],Di);let qt=class{constructor(B,oe){this.id=B,this.color=oe}static isThemeIcon(B){return typeof B.id!="string"?(console.log("INVALID ThemeIcon, invalid id",B.id),!1):!0}};e.$vL=qt,e.$vL=qt=Ke([F],qt),qt.File=new qt("file"),qt.Folder=new qt("folder");let mi=class{constructor(B){this.id=B}};e.$wL=mi,e.$wL=mi=Ke([F],mi);var Ct;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Ct||(e.ConfigurationTarget=Ct={}));let ki=class{get base(){return this.c}set base(B){this.c=B,this.e=y.URI.file(B)}get baseUri(){return this.e}set baseUri(B){this.e=B,this.c=B.fsPath}constructor(B,oe){if(typeof B!="string"&&(!B||!y.URI.isUri(B)&&!y.URI.isUri(B.uri)))throw(0,T.$6)("base");if(typeof oe!="string")throw(0,T.$6)("pattern");typeof B=="string"?this.baseUri=y.URI.file(B):y.URI.isUri(B)?this.baseUri=B:this.baseUri=B.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$xL=ki,e.$xL=ki=Ke([F],ki);const Ki=new WeakMap;function It(j,B){Ki.set(j,B)}e.$yL=It;let ii=class{constructor(B,oe,Ie,Ge){this.enabled=typeof B=="boolean"?B:!0,typeof oe=="string"&&(this.condition=oe),typeof Ie=="string"&&(this.hitCondition=Ie),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Ki.get(this)??(0,A.$kg)()),this.c}};e.$zL=ii,e.$zL=ii=Ke([F],ii);let $i=class extends ii{constructor(B,oe,Ie,Ge,xe){if(super(oe,Ie,Ge,xe),B===null)throw(0,T.$6)("location");this.location=B}};e.$AL=$i,e.$AL=$i=Ke([F],$i);let oi=class extends ii{constructor(B,oe,Ie,Ge,xe){super(oe,Ie,Ge,xe),this.functionName=B}};e.$BL=oi,e.$BL=oi=Ke([F],oi);let Si=class extends ii{constructor(B,oe,Ie,Ge,xe,at,dt){if(super(Ge,xe,at,dt),!oe)throw(0,T.$6)("dataId");this.label=B,this.dataId=oe,this.canPersist=Ie}};e.$CL=Si,e.$CL=Si=Ke([F],Si);let Ii=class{constructor(B,oe,Ie){this.command=B,this.args=oe||[],this.options=Ie}};e.$DL=Ii,e.$DL=Ii=Ke([F],Ii);let Lt=class{constructor(B,oe){this.port=B,this.host=oe}};e.$EL=Lt,e.$EL=Lt=Ke([F],Lt);let pi=class{constructor(B){this.path=B}};e.$FL=pi,e.$FL=pi=Ke([F],pi);let Ci=class{constructor(B){this.implementation=B}};e.$GL=Ci,e.$GL=Ci=Ke([F],Ci);let ai=class{constructor(B,oe,Ie){this.session=B,this.threadId=oe,this.frameId=Ie}};e.$HL=ai,e.$HL=ai=Ke([F],ai);let ci=class{constructor(B,oe){this.session=B,this.threadId=oe}};e.$IL=ci,e.$IL=ci=Ke([F],ci);let lt=class{constructor(B,oe){this.range=B,this.expression=oe}};e.$JL=lt,e.$JL=lt=Ke([F],lt);var Hi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Hi||(e.InlineCompletionTriggerKind=Hi={}));let Yt=class{constructor(B,oe){this.range=B,this.text=oe}};e.$KL=Yt,e.$KL=Yt=Ke([F],Yt);let ni=class{constructor(B,oe,Ie=!0){this.range=B,this.variableName=oe,this.caseSensitiveLookup=Ie}};e.$LL=ni,e.$LL=ni=Ke([F],ni);let di=class{constructor(B,oe){this.range=B,this.expression=oe}};e.$ML=di,e.$ML=di=Ke([F],di);let Pi=class{constructor(B,oe){this.frameId=B,this.stoppedLocation=oe}};e.$NL=Pi,e.$NL=Pi=Ke([F],Pi);var Gi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Gi||(e.FileChangeType=Gi={}));let Ai=h=class extends Error{static FileExists(B){return new h(B,l.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(B){return new h(B,l.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(B){return new h(B,l.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(B){return new h(B,l.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(B){return new h(B,l.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(B){return new h(B,l.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}constructor(B,oe=l.FileSystemProviderErrorCode.Unknown,Ie){super(y.URI.isUri(B)?B.toString(!0):B),this.code=Ie?.name??"Unknown",(0,l.$vk)(this,oe),Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof Ie=="function"&&Error.captureStackTrace(this,Ie)}};e.$OL=Ai,e.$OL=Ai=h=Ke([F],Ai);let vi=class{constructor(B,oe,Ie){this.start=B,this.end=oe,this.kind=Ie}};e.$PL=vi,e.$PL=vi=Ke([F],vi);var Ji;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Ji||(e.FoldingRangeKind=Ji={}));var Ri;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Ri||(e.CommentThreadCollapsibleState=Ri={}));var ui;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(ui||(e.CommentMode=ui={}));var Zi;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Zi||(e.CommentState=Zi={}));var wi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Mi{constructor(B,oe=[]){this.tokenTypes=B,this.tokenModifiers=oe}}e.$QL=Mi;function ln(j){return typeof j>"u"||(0,m.$Df)(j)}class Li{constructor(B){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,B){this.l=!0;for(let oe=0,Ie=B.tokenTypes.length;oe<Ie;oe++)this.j.set(B.tokenTypes[oe],oe);for(let oe=0,Ie=B.tokenModifiers.length;oe<Ie;oe++)this.k.set(B.tokenModifiers[oe],oe)}}push(B,oe,Ie,Ge,xe){if(typeof B=="number"&&typeof oe=="number"&&typeof Ie=="number"&&typeof Ge=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.n(B,oe,Ie,Ge,xe);if(L.isRange(B)&&typeof oe=="string"&&ln(Ie))return this.m(B,oe,Ie);throw(0,T.$6)()}m(B,oe,Ie){if(!this.l)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ge=B.start.line,xe=B.start.character,at=B.end.character-B.start.character,dt=this.j.get(oe);let Bt=0;if(Ie)for(const Xt of Ie){if(!this.k.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Xt);Bt|=1<<ei>>>0}this.n(Ge,xe,at,dt,Bt)}n(B,oe,Ie,Ge,xe){if(this.f&&(B<this.c||B===this.c&&oe<this.e)){this.f=!1;const Bt=this.g.length/5|0;let Xt=0,ei=0;for(let ti=0;ti<Bt;ti++){let si=this.g[5*ti],Vi=this.g[5*ti+1];si===0?(si=Xt,Vi+=ei):si+=Xt,this.g[5*ti]=si,this.g[5*ti+1]=Vi,Xt=si,ei=Vi}}let at=B,dt=oe;this.f&&this.h>0&&(at-=this.c,at===0&&(dt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=dt,this.g[this.h++]=Ie,this.g[this.h++]=Ge,this.g[this.h++]=xe,this.c=B,this.e=oe}static o(B){const oe=[],Ie=B.length/5|0;for(let dt=0;dt<Ie;dt++)oe[dt]=dt;oe.sort((dt,Bt)=>{const Xt=B[5*dt],ei=B[5*Bt];if(Xt===ei){const ti=B[5*dt+1],si=B[5*Bt+1];return ti-si}return Xt-ei});const Ge=new Uint32Array(B.length);let xe=0,at=0;for(let dt=0;dt<Ie;dt++){const Bt=5*oe[dt],Xt=B[Bt+0],ei=B[Bt+1],ti=B[Bt+2],si=B[Bt+3],Vi=B[Bt+4],kn=Xt-xe,On=kn===0?ei-at:ei,qi=5*dt;Ge[qi+0]=kn,Ge[qi+1]=On,Ge[qi+2]=ti,Ge[qi+3]=si,Ge[qi+4]=Vi,xe=Xt,at=ei}return Ge}build(B){return this.f?new ri(new Uint32Array(this.g),B):new ri(Li.o(this.g),B)}}e.$RL=Li;class ri{constructor(B,oe){this.resultId=oe,this.data=B}}e.$SL=ri;class hn{constructor(B,oe,Ie){this.start=B,this.deleteCount=oe,this.data=Ie}}e.$TL=hn;class dn{constructor(B,oe){this.resultId=oe,this.edits=B}}e.$UL=dn;var Qi;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Qi||(e.DebugConsoleMode=Qi={}));let fi=class{static{this.Back={iconPath:new qt("arrow-left")}}constructor(){}};e.$VL=fi,e.$VL=fi=Ke([F],fi);var Xi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Xi||(e.QuickPickItemKind=Xi={}));var Yi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Yi||(e.InputBoxValidationSeverity=Yi={}));var gi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(gi||(e.ExtensionKind=gi={}));class xi{static validate(B){if(typeof B.badge=="string"){let oe=(0,$.$df)(B.badge,0);if(oe<B.badge.length&&(oe+=(0,$.$df)(B.badge,oe)),B.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(B.badge&&!qt.isThemeIcon(B.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty");return!0}constructor(B,oe,Ie){this.badge=B,this.tooltip=oe,this.color=Ie}}e.$WL=xi;let Fi=class{constructor(B){this.kind=B}};e.$XL=Fi,e.$XL=Fi=Ke([F],Fi);var Ti;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Ti||(e.ColorThemeKind=Ti={}));class xt{static isNotebookRange(B){return B instanceof xt?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(B,oe){if(B<0)throw(0,T.$6)("start must be positive");if(oe<0)throw(0,T.$6)("end must be positive");B<=oe?(this.c=B,this.e=oe):(this.c=oe,this.e=B)}with(B){let oe=this.c,Ie=this.e;return B.start!==void 0&&(oe=B.start),B.end!==void 0&&(Ie=B.end),oe===this.c&&Ie===this.e?this:new xt(oe,Ie)}}e.$YL=xt;class bi{static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(oe=>bi.isNotebookCellData(oe))}static isNotebookCellData(B){return!0}constructor(B,oe,Ie,Ge,xe,at,dt){this.kind=B,this.value=oe,this.languageId=Ie,this.mime=Ge,this.outputs=xe??[],this.metadata=at,this.executionSummary=dt,bi.validate(this)}}e.$ZL=bi;class fn{constructor(B){this.cells=B}}e.$1L=fn;class Qt{static isNotebookCellOutputItem(B){return B instanceof Qt?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B){const oe={name:B.name,message:B.message,stack:B.stack};return Qt.json(oe,"application/vnd.code.notebook.error")}static stdout(B){return Qt.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return Qt.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,oe="application/octet-stream"){return new Qt(B,oe)}static#e=new TextEncoder;static text(B,oe=P.$Xr.text){const Ie=Qt.#e.encode(String(B));return new Qt(Ie,oe)}static json(B,oe="text/x-json"){const Ie=JSON.stringify(B,void 0,"	");return Qt.text(Ie,oe)}constructor(B,oe){this.data=B,this.mime=oe;const Ie=(0,P.$2r)(oe,!0);if(!Ie)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ie}}e.$2L=Qt;class yi{static isNotebookCellOutput(B){return B instanceof yi?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&Array.isArray(B.items)}static ensureUniqueMimeTypes(B,oe=!1){const Ie=new Set,Ge=new Set;for(let xe=0;xe<B.length;xe++){const at=B[xe],dt=(0,P.$2r)(at.mime);if(!Ie.has(dt)||(0,w.$EI)(dt)){Ie.add(dt);continue}Ge.add(xe),oe&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?B:B.filter((xe,at)=>!Ge.has(at))}constructor(B,oe,Ie){this.items=yi.ensureUniqueMimeTypes(B,!0),typeof oe=="string"?(this.id=oe,this.metadata=Ie):(this.id=(0,A.$kg)(),this.metadata=oe??Ie)}}e.$3L=yi;var Ei;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Ei||(e.NotebookCellKind=Ei={}));var Oi;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var Oe;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Oe||(e.NotebookCellStatusBarAlignment=Oe={}));var _t;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(_t||(e.NotebookEditorRevealType=_t={}));class _i{constructor(B,oe){this.text=B,this.alignment=oe}}e.$4L=_i;var mt;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(mt||(e.NotebookControllerAffinity=mt={}));var en;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(en||(e.NotebookControllerAffinity2=en={}));class gn{constructor(B,oe=[]){this.uri=B,this.provides=(0,E.$2b)(oe)}}e.$5L=gn;class tn{constructor(B){this.label=B}}e.$6L=tn;var nn;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let li=class{constructor(B,oe){this.label=B,this.timestamp=oe}};e.$7L=li,e.$7L=li=Ke([F],li);var rn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class an{constructor(B,oe){this.ranges=B,this.wordPattern=oe}}e.$8L=an;class mn{constructor(B){this.c=B}get autoForwardAction(){return this.c}}e.$9L=mn;var cn;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Ni=class{constructor(B=void 0,oe=void 0,Ie=void 0,Ge=!1){this.include=B,this.exclude=oe,this.profile=Ie,this.continuous=Ge}};e.$0L=Ni,e.$0L=Ni=Ke([F],Ni);let zi=b=class{static diff(B,oe,Ie){const Ge=new b(B);return Ge.expectedOutput=oe,Ge.actualOutput=Ie,Ge}constructor(B){this.message=B}};e.$$L=zi,e.$$L=zi=b=Ke([F],zi);let Bi=class{constructor(B){this.id=B}};e.$_L=Bi,e.$_L=Bi=Ke([F],Bi);let hi=class{constructor(B,oe){this.covered=B,this.total=oe}};e.$aM=hi,e.$aM=hi=Ke([F],hi);let ji=k=class{static fromDetails(B,oe){const Ie=new hi(0,0),Ge=new hi(0,0),xe=new hi(0,0);for(const dt of oe)if("branches"in dt){Ie.total+=1,Ie.covered+=dt.executionCount>0?1:0;for(const Bt of dt.branches)Ge.total+=1,Ge.covered+=Bt.executionCount>0?1:0}else xe.total+=1,xe.covered+=dt.executionCount>0?1:0;const at=new k(B,Ie,Ge.total>0?Ge:void 0,xe.total>0?xe:void 0);return at.detailedCoverage=oe,at}constructor(B,oe,Ie,Ge){this.uri=B,this.statementCoverage=oe,this.branchCoverage=Ie,this.functionCoverage=Ge}};e.$bM=ji,e.$bM=ji=k=Ke([F],ji);let Ui=class{constructor(B,oe,Ie=[]){this.executionCount=B,this.location=oe,this.branches=Ie}};e.$cM=Ui,e.$cM=Ui=Ke([F],Ui);let Wi=class{constructor(B,oe){this.executionCount=B,this.location=oe}};e.$dM=Wi,e.$dM=Wi=Ke([F],Wi);let te=class{constructor(B,oe){this.executionCount=B,this.location=oe}};e.$eM=te,e.$eM=te=Ke([F],te);var ge;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(ge||(e.ExternalUriOpenerPriority=ge={}));var Fe;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Fe||(e.WorkspaceTrustState=Fe={}));var ot;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(ot||(e.PortAutoForwardAction=ot={}));class wt{constructor(B,oe,Ie,Ge,xe,at){this.kind=B,this.name=oe,this.detail=Ie,this.uri=Ge,this.range=xe,this.selectionRange=at}}e.$fM=wt;class Ft{constructor(B){this.uri=B}}e.$gM=Ft;class Sn{constructor(B,oe){this.original=B,this.modified=oe}}e.$hM=Sn;class In{constructor(B,oe,Ie,Ge){this.base=B,this.input1=oe,this.input2=Ie,this.result=Ge}}e.$iM=In;class Cn{constructor(B,oe){this.uri=B,this.viewType=oe}}e.$jM=Cn;class Pn{constructor(B){this.viewType=B}}e.$kM=Pn;class An{constructor(B,oe){this.uri=B,this.notebookType=oe}}e.$lM=An;class Rn{constructor(B,oe,Ie){this.original=B,this.modified=oe,this.notebookType=Ie}}e.$mM=Rn;class Mn{constructor(){}}e.$nM=Mn;class Ln{constructor(B,oe){this.uri=B,this.inputBoxUri=oe}}e.$oM=Ln;class Fn{constructor(B){this.providerId=B}}e.$pM=Fn;var $n;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})($n||(e.InteractiveSessionVoteDirection=$n={}));var pn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var vn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(vn||(e.InteractiveEditorResponseFeedbackKind=vn={}));var wn;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(wn||(e.ChatMessageRole=wn={}));var bn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(bn||(e.ChatVariableLevel=bn={}));class Tn{constructor(B,oe){this.role=B,this.content=oe}}e.$qM=Tn;var yn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(yn||(e.ChatAgentResultFeedbackKind=yn={}));var En;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(En||(e.RelatedInformationType=En={}));var Dn;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}))}),define(Ae[102],Re([1,0,53,13,12,294,146,7,18]),function(we,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=e.$DM=void 0;const y=new Map;function A(w,a){a?y.set(w,a):y.delete(w)}e.$DM=A;function S(w){return y.get(w)}class l extends M.$4u{constructor(a,s,t,n,o,c,d,i){super(s,t,n,o),this.c=a,this.m=c,this.q=d,this.notebook=i,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,m.$tb)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===T.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(s){return s?a.s(s):a.getText()},get eol(){return a.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(s){return a.t(s)},offsetAt(s){return a.u(s)},positionAt(s){return a.v(s)},validateRange(s){return a.w(s)},validatePosition(s){return a.x(s)},getWordRangeAtPosition(s,t){return a.y(s,t)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,E.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,E.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const s=this.w(a);if(s.isEmpty)return"";if(s.isSingleLine)return this.f[s.start.line].substring(s.start.character,s.end.character);const t=this.g,n=s.start.line,o=s.end.line,c=[];c.push(this.f[n].substring(s.start.character));for(let d=n+1;d<o;d++)c.push(this.f[d]);return c.push(this.f[o].substring(0,s.end.character)),c.join(t)}t(a){let s;if(a instanceof $.$CK?s=a.line:typeof a=="number"&&(s=a),typeof s!="number"||s<0||s>=this.f.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new p(s,this.f[s],s===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const s=this.j.getIndexOf(a),t=this.f[s.index].length;return new $.$CK(s.index,Math.min(s.remainder,t))}w(a){if(!(a instanceof $.$DK))throw new Error("Invalid argument");const s=this.x(a.start),t=this.x(a.end);return s===a.start&&t===a.end?a:new $.$DK(s.line,s.character,t.line,t.character)}x(a){if(!(a instanceof $.$CK))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:s,character:t}=a,n=!1;if(s<0)s=0,t=0,n=!0;else if(s>=this.f.length)s=this.f.length-1,t=this.f[s].length,n=!0;else{const o=this.f[s].length;t<0?(t=0,n=!0):t>o&&(t=o,n=!0)}return n?new $.$CK(s,t):a}y(a,s){const t=this.x(a);if(!s)s=S(this.m);else if((0,C.$Se)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const n=(0,P.$ds)(t.character+1,(0,P.$bs)(s),this.f[t.line],0);if(n)return new $.$DK(t.line,n.startColumn-1,t.line,n.endColumn-1)}}e.$EM=l;class p{constructor(a,s,t){this.a=a,this.b=s,this.c=t}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$DK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$DK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$FM=p}),define(Ae[209],Re([1,0,7,17,5]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;let M=class{constructor($){this.a=new E.$XL(E.ColorThemeKind.Dark),this.b=new C.$Rd}get activeColorTheme(){return this.a}$onColorThemeChange($){let m;switch($){case"light":m=E.ColorThemeKind.Light;break;case"hcDark":m=E.ColorThemeKind.HighContrast;break;case"hcLight":m=E.ColorThemeKind.HighContrastLight;break;default:m=E.ColorThemeKind.Dark}this.a=new E.$XL(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$3fc=M,e.$3fc=M=Ke([We(0,T.$BM)],M)}),define(Ae[210],Re([1,0,4]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$II=e.CellExecutionUpdateType=void 0;var T;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$II=(0,E.$Xh)("INotebookExecutionService")}),define(Ae[211],Re([1,0,6,29,143,93]),function(we,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Ob=void 0;class P extends E.$Rc{constructor(m,y,A){super(),this._source=m,this.b=y,this.c=A,this.a=void 0}f(m){const y=m.getLineCount();return new T.$Bs(1,1,y,this.g(m,y))}g(m,y){if(y<1||y>m.getLineCount())throw new Error("Illegal value for lineNumber");return m.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const m=new C.$PB;m.acceptChunk(this._source);const y=m.finish(!0),{textBuffer:A,disposable:S}=y.create(1);this.b=A,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(m=>{const y=new C.$PB;y.acceptChunk(m);const A=y.finish(!0),{textBuffer:S,disposable:l}=A.create(1);return this.B(l),S})),this.a}findInInputs(m){const A=new M.$DB(m,!1,!1,null).parseSearchRequest();if(!A)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,A,!0,5e3)}findInOutputs(m){const A=new M.$DB(m,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(S=>{const l=S.findMatchesLineByLine(this.f(S),A,!0,5e3);if(l.length!==0)return{textBuffer:S,matches:l}}).filter(S=>!!S):[]}}e.$_Ob=P}),define(Ae[48],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(M){M.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var T;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class C{static fromExtHostTestItem(P,$,m=P.parent){if(P._isRoot)return new C([$]);const y=[P.id];for(let A=m;A&&A.id!==$;A=A.parent)y.push(A.id);return y.push($),new C(y.reverse())}static isRoot(P){return!P.includes("\0")}static root(P){const $=P.indexOf("\0");return $===-1?P:P.slice(0,$)}static fromString(P){return new C(P.split("\0"))}static join(P,$){return new C([...P.path,$])}static joinToString(P,$){return P.toString()+"\0"+$}static parentId(P){const $=P.lastIndexOf("\0");return $===-1?void 0:P.slice(0,$)}static localId(P){const $=P.lastIndexOf("\0");return $===-1?P:P.slice($+1)}static isChild(P,$){return $.startsWith(P)&&$[P.length]==="\0"}static compare(P,$){return P===$?0:C.isChild(P,$)?2:C.isChild($,P)?3:1}constructor(P,$=P.length){if(this.path=P,this.d=$,P.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let P=1;P<=this.d;P++)yield new C(this.path,P)}*idsToRoot(){for(let P=this.d;P>0;P--)yield new C(this.path,P)}compare(P){if(typeof P=="string")return C.compare(this.toString(),P);for(let $=0;$<P.d&&$<this.d;$++)if(P.path[$]!==this.path[$])return 1;return P.d>this.d?2:P.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let P=1;P<this.d;P++)this.c+="\0",this.c+=this.path[P]}return this.c}}e.$sJ=C}),define(Ae[58],Re([1,0,2,29,48]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$yJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$xJ=e.$wJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$vJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$uJ=e.$tJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var P;(function(I){I[I.Run=1]="Run",I[I.Debug=2]="Debug",I[I.Coverage=3]="Coverage"})(P||(e.ExtTestRunProfileKind=P={}));var $;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable",I[I.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$tJ=[2,4,8,16,32,64];const m=I=>"runId"in I;e.$uJ=m;var y;(function(I){I.serialize=h=>({range:h.range.toJSON(),uri:h.uri.toJSON()}),I.deserialize=h=>({range:T.$Bs.lift(h.range),uri:E.URI.revive(h.uri)})})(y||(e.IRichLocation=y={}));var A;(function(I){I[I.Error=0]="Error",I[I.Output=1]="Output"})(A||(e.TestMessageType=A={}));var S;(function(I){I.serialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,contextValue:h.contextValue,location:h.location&&y.serialize(h.location)}),I.deserialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,contextValue:h.contextValue,location:h.location&&y.deserialize(h.location)})})(S||(e.ITestErrorMessage=S={}));const l=(I,h)=>`${h?"s":"e"}${I}`;e.$vJ=l;var p;(function(I){I.serialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&y.serialize(h.location)}),I.deserialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&y.deserialize(h.location)})})(p||(e.ITestOutputMessage=p={}));var w;(function(I){I.serialize=h=>h.type===0?S.serialize(h):p.serialize(h),I.deserialize=h=>h.type===0?S.deserialize(h):p.deserialize(h)})(w||(e.ITestMessage=w={}));var a;(function(I){I.serializeWithoutMessages=h=>({state:h.state,duration:h.duration,messages:[]}),I.serialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(w.serialize)}),I.deserialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(w.deserialize)})})(a||(e.ITestTaskState=a={}));const s="\0",t=(I,h)=>I+s+h;e.$wJ=t;const n=I=>{const h=I.indexOf(s);return{ctrlId:I.slice(0,h),tagId:I.slice(h+1)}};e.$xJ=n;var o;(function(I){I.serialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?.toJSON(),range:h.range?.toJSON()||null,description:h.description,error:h.error,sortText:h.sortText}),I.deserialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?E.URI.revive(h.uri):void 0,range:h.range?T.$Bs.lift(h.range):null,description:h.description,error:h.error,sortText:h.sortText})})(o||(e.ITestItem=o={}));var c;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(c||(e.TestItemExpandState=c={}));var d;(function(I){I.serialize=h=>({expand:h.expand,item:o.serialize(h.item)}),I.deserialize=h=>({controllerId:C.$sJ.root(h.item.extId),expand:h.expand,item:o.deserialize(h.item)})})(d||(e.InternalTestItem=d={}));var i;(function(I){I.serialize=h=>{let b;return h.item&&(b={},h.item.label!==void 0&&(b.label=h.item.label),h.item.tags!==void 0&&(b.tags=h.item.tags),h.item.busy!==void 0&&(b.busy=h.item.busy),h.item.uri!==void 0&&(b.uri=h.item.uri?.toJSON()),h.item.range!==void 0&&(b.range=h.item.range?.toJSON()),h.item.description!==void 0&&(b.description=h.item.description),h.item.error!==void 0&&(b.error=h.item.error),h.item.sortText!==void 0&&(b.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:b}},I.deserialize=h=>{let b;return h.item&&(b={},h.item.label!==void 0&&(b.label=h.item.label),h.item.tags!==void 0&&(b.tags=h.item.tags),h.item.busy!==void 0&&(b.busy=h.item.busy),h.item.range!==void 0&&(b.range=h.item.range?T.$Bs.lift(h.item.range):null),h.item.description!==void 0&&(b.description=h.item.description),h.item.error!==void 0&&(b.error=h.item.error),h.item.sortText!==void 0&&(b.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:b}}})(i||(e.ITestItemUpdate=i={}));const r=(I,h)=>{h.expand!==void 0&&(I.expand=h.expand),h.item!==void 0&&(I.item=I.item?Object.assign(I.item,h.item):h.item)};e.$yJ=r;var u;(function(I){I.serializeWithoutMessages=h=>({...d.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(a.serializeWithoutMessages)}),I.serialize=h=>({...d.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(a.serialize)}),I.deserialize=h=>({...d.deserialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(a.deserialize),retired:!0})})(u||(e.TestResultItem=u={}));var f;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(f||(e.DetailType=f={}));var v;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.DocumentSynced=2]="DocumentSynced",I[I.Remove=3]="Remove",I[I.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",I[I.Retire=5]="Retire",I[I.AddTag=6]="AddTag",I[I.RemoveTag=7]="RemoveTag"})(v||(e.TestDiffOpType=v={}));var g;(function(I){I.deserialize=h=>h.op===0?{op:h.op,item:d.deserialize(h.item)}:h.op===1?{op:h.op,item:i.deserialize(h.item)}:h.op===2?{op:h.op,uri:E.URI.revive(h.uri),docv:h.docv}:h,I.serialize=h=>h.op===0?{op:h.op,item:d.serialize(h.item)}:h.op===1?{op:h.op,item:i.serialize(h.item)}:h})(g||(e.TestsDiffOp=g={}));class D{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(h){const b=this.o();for(const k of h)switch(k.op){case 0:this.j(d.deserialize(k.item),b);break;case 1:this.k(i.deserialize(k.item),b);break;case 3:this.l(k.itemId,b);break;case 5:this.m(k.itemId);break;case 4:this.updatePendingRoots(k.amount);break;case 6:this.c.set(k.tag.id,k.tag);break;case 7:this.c.delete(k.id);break}b.complete?.()}j(h,b){const k=C.$sJ.parentId(h.item.extId)?.toString();let F;if(!k)F=this.p(h),this.f.add(F),this.d.set(h.item.extId,F);else if(this.d.has(k)){const W=this.d.get(k);W.children.add(h.item.extId),F=this.p(h,W),this.d.set(h.item.extId,F)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(h)}`);return}return b.add?.(F),h.expand===2&&this.g++,F}k(h,b){const k=this.d.get(h.extId);if(k)return h.expand!==void 0&&(k.expand===2&&this.g--,h.expand===2&&this.g++),(0,e.$yJ)(k,h),b.update?.(k),k}l(h,b){const k=this.d.get(h);if(!k)return;const F=C.$sJ.parentId(k.item.extId)?.toString();F?this.d.get(F).children.delete(k.item.extId):this.f.delete(k);const W=[[h]];for(;W.length;)for(const J of W.pop()){const N=this.d.get(J);N&&(W.push(N.children),this.d.delete(J),b.remove?.(N,N!==k),N.expand===2&&this.g--)}}m(h){}updatePendingRoots(h){this.h+=h}o(){return{}}}e.$zJ=D}),define(Ae[77],Re([1,0,14,5,6,53,58,48]),function(we,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.TestItemEventOp=void 0;var m;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const y=(n,o)=>n===o,S=Object.entries({range:(n,o)=>n===o?!0:!n||!o?!1:n.equalsRange(o),busy:y,label:y,description:y,error:y,sortText:y,tags:(n,o)=>!(n.length!==o.length||n.some(c=>!o.includes(c)))}),l=(n,o)=>{let c;for(const[d,i]of S)i(n[d],o[d])||(c?c[d]=o[d]:c={[d]:o[d]});return c};class p extends C.$Rc{get root(){return this.s.root}constructor(o){super(),this.s=o,this.f=this.B(new E.$_g(()=>this.flushDiff(),200)),this.g=this.B(new T.$Rd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(o){this.h=o;for(const c of this.tree.values())this.I(c)}get resolveHandler(){return this.h}collectDiff(){const o=this.m;return this.m=[],o}pushDiff(o){switch(o.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===o.uri){c.docv=o.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===o.item.extId){(0,P.$yJ)(c.item,o.item);return}if(c.op===0&&c.item.item.extId===o.item.extId){(0,P.$yJ)(c.item,o.item);return}}break}}this.m.push(o),this.f.isScheduled()||this.f.schedule()}expand(o,c){const d=this.tree.get(o);if(d){if((d.expandLevels===void 0||c>d.expandLevels)&&(d.expandLevels=c),d.expand===1){const i=this.L(d);return i.isOpen()?this.J(d,c-1):i.wait().then(()=>this.J(d,c-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.J(d,c-1)):this.J(d,c-1)}}dispose(){for(const o of this.tree.values())this.s.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(o,c){switch(c.op){case 3:this.N($.$sJ.joinToString(o.fullId,c.id));break;case 0:this.y(c.item,o);break;case 5:for(const d of c.ops)this.u(o,d);break;case 1:this.z(c.new,c.old,o.fullId.toString());break;case 2:this.I(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:c.update}});break;case 6:this.w(o.actual.uri);break;default:(0,M.$4c)(c)}}w(o){o&&this.pushDiff({op:2,uri:o,docv:this.s.getDocumentVersion(o)})}y(o,c){const d=$.$sJ.fromExtHostTestItem(o,this.root.id,c?.actual),i=this.s.getApiFor(o);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(o.id);let r=this.tree.get(d.toString());if(!r){r={fullId:d,actual:o,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},o.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(o,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(o)}}),this.H(o,r,c);return}if(r.actual===o){this.G(o,r,c);return}if(r.actual.uri?.toString()!==o.uri?.toString())return this.N(d.toString()),this.y(o,c);const u=this.s.getChildren(r.actual),f=r.actual,v=l(this.s.toITestItem(f),this.s.toITestItem(o));this.s.getApiFor(f).listener=void 0,r.actual=o,r.expand=0,v&&(v.hasOwnProperty("tags")&&(this.z(o.tags,f.tags,d.toString()),delete v.tags),this.u(r,{op:4,update:v})),this.H(o,r,c);for(const[g,D]of u)this.s.getChildren(o).get(D.id)||this.N($.$sJ.joinToString(d,D.id));this.w(r.actual.uri)}z(o,c,d){const i=new Set(c.map(r=>r.id));for(const r of o)i.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:d,item:{tags:o.map(r=>(0,P.$wJ)(this.s.controllerId,r.id))}}}),i.forEach(this.D,this)}C(o){const c=this.j.get(o.id);c?c.refCount++:(this.j.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,P.$wJ)(this.s.controllerId,o.id)}}))}D(o){const c=this.j.get(o);c&&!--c.refCount&&(this.j.delete(o),this.pushDiff({op:7,id:(0,P.$wJ)(this.s.controllerId,o)}))}F(o,c){this.s.getApiFor(o).parent=c&&c.actual!==this.root?c.actual:void 0}G(o,c,d){this.F(o,d);const i=this.s.getApiFor(o);i.parent=d?.actual,i.listener=r=>this.u(c,r),this.I(c)}H(o,c,d){this.G(o,c,d);for(const[i,r]of this.s.getChildren(o))this.y(r,c)}I(o){let c;this.h?o.resolveBarrier?c=o.resolveBarrier.isOpen()?3:2:c=o.actual.canResolveChildren?1:0:c=0,c!==o.expand&&(o.expand=c,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:c}}),c===1&&o.expandLevels!==void 0&&this.L(o))}J(o,c){if(c<0)return;const d=[];for(const[i,r]of this.s.getChildren(o.actual)){const u=this.expand($.$sJ.joinToString(o.fullId,r.id),c);(0,E.$Mg)(u)&&d.push(u)}if(d.length)return Promise.all(d).then(()=>{})}L(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this.h){const r=new E.$Yg;return r.open(),r}o.expand=2,this.M(o);const c=o.resolveBarrier=new E.$Yg,d=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let i;try{i=this.h(o.actual===this.root?void 0:o.actual)}catch(r){d(r)}return(0,E.$Mg)(i)?i.catch(d).then(()=>{c.open(),this.I(o)}):(c.open(),this.I(o)),o.resolveBarrier}M(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}N(o){const c=this.tree.get(o);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const d=[c];for(;d.length;){const i=d.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const r of i.actual.tags)this.D(r.id);this.tree.delete(i.fullId.toString());for(const[r,u]of this.s.getChildren(i.actual))d.push(this.tree.get($.$sJ.joinToString(i.fullId,u.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.g.fire(o)}}e.$rM=p;class w extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.$sM=w;class a extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$tM=a;class s extends Error{constructor(o,c,d){super(`TestItem with ID "${o}" is from controller "${c}" and cannot be added as a child of an item from controller "${d}".`)}}e.$uM=s;const t=(n,o,c)=>{let d=new Map;return{get size(){return d.size},forEach(i,r){for(const u of d.values())i.call(r,u,this)},[Symbol.iterator](){return d.entries()},replace(i){const r=new Map,u=new Set(d.keys()),f={op:5,ops:[]};for(const v of i){if(!(v instanceof c))throw new a(v.id);const g=o(v).controllerId;if(g!==n.controllerId)throw new s(v.id,g,n.controllerId);if(r.has(v.id))throw new w(v.id);r.set(v.id,v),u.delete(v.id),f.ops.push({op:0,item:v})}for(const v of u.keys())f.ops.push({op:3,id:v});n.listener?.(f),d=r},add(i){if(!(i instanceof c))throw new a(i.id);d.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){d.delete(i)&&n.listener?.({op:3,id:i})},get(i){return d.get(i)},toJSON(){return Array.from(d.values())}}};e.$vM=t}),define(Ae[103],Re([1,0,77]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=void 0;const T=new WeakMap,C=(P,$)=>{const m={controllerId:$};return T.set(P,m),m};e.$wM=C;const M=P=>{const $=T.get(P);if(!$)throw new E.$tM(P?.id||"<unknown>");return $};e.$xM=M}),define(Ae[78],Re([1,0,13,2]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lub=e.$kub=e.$jub=e.$iub=e.$hub=void 0,e.$hub="vscode-cdn.net",e.$iub=`vscode-resource.${e.$hub}`,e.$jub=`'self' https://*.${e.$hub}`;function C($,m){return $.scheme===E.Schemas.http||$.scheme===E.Schemas.https?$:(m&&m.authority&&m.isRemote&&$.scheme===E.Schemas.file&&($=T.URI.from({scheme:E.Schemas.vscodeRemote,authority:m.authority,path:$.path})),T.URI.from({scheme:E.Schemas.https,authority:`${$.scheme}+${M($.authority)}.${e.$iub}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$kub=C;function M($){return $.replace(/./g,m=>{const y=m.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?m:"-"+y.toString(16).padStart(4,"0")})}function P($){return $.replace(/-([0-9a-f]{4})/g,(m,y)=>String.fromCharCode(parseInt(y,16)))}e.$lub=P}),define(Ae[212],Re([1,0,5,6,78]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=void 0;class M{constructor($,m,y){this.d=$,this.e=m,this.f=y,this.a=0,this.b=new T.$Qc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const A=m.getVisibleTextEditors();for(const S of this.c.values())A.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,m,y,A,S){let l;for(const o of this.e.getVisibleTextEditors(!0))if(o.value===$){l=o;break}if(!l)throw new Error("not a visible editor");const p=this,w=this.a++,a=new E.$Rd,s=new E.$Rd,t=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(o){return(0,C.$kub)(o,p.f)}get cspSource(){return C.$jub}set options(o){this.b=o,p.d.$setOptions(w,o)}get options(){return this.b}set html(o){this.a=o,p.d.$setHtml(w,o)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(o){return p.d.$postMessage(w,o)}},n=new class{constructor(){this.editor=$,this.line=m,this.height=y,this.webview=t,this.onDidDispose=s.event}dispose(){p.c.has(w)&&(p.c.delete(w),p.d.$disposeEditorInset(w),s.fire(),s.dispose(),a.dispose())}};return this.d.$createEditorInset(w,l.id,l.value.document.uri,m+1,y,A||{},S.identifier,S.extensionLocation),this.c.set(w,{editor:$,inset:n,onDidReceiveMessage:a}),n}$onDidDispose($){const m=this.c.get($);m&&m.inset.dispose()}$onDidReceiveMessage($,m){this.c.get($)?.onDidReceiveMessage.fire(m)}}e.$mec=M}),define(Ae[213],Re([1,0,4]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oN=e.VariableKind=e.$nN=void 0,e.$nN=(0,E.$Xh)("configurationResolverService");var T;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class C extends Error{constructor(P,$){super($),this.variable=P}}e.$oN=C}),define(Ae[214],Re([1,0,20,74,16,26,21,94,176,213,12]),function(we,e,E,T,C,M,P,$,m,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,w,a,s){this.h=new Map,this.a=p,this.b=w,this.g=a,s&&(this.c=s.then(t=>this.i(t)))}i(p){if(P.$i){const w=Object.create(null);return Object.keys(p).forEach(a=>{w[a.toLowerCase()]=p[a]}),w}return p}resolveWithEnvironment(p,w,a){return this.l({env:this.i(p),userHome:void 0},w?w.uri:void 0,a)}async resolveAsync(p,w){const a={env:await this.c,userHome:await this.g};return this.l(a,p?p.uri:void 0,w)}async j(p,w,a,s){const t=M.$cn(w);P.$i&&t.windows?Object.keys(t.windows).forEach(o=>t[o]=t.windows[o]):P.$j&&t.osx?Object.keys(t.osx).forEach(o=>t[o]=t.osx[o]):P.$k&&t.linux&&Object.keys(t.linux).forEach(o=>t[o]=t.linux[o]),delete t.windows,delete t.osx,delete t.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,p?p.uri:void 0,t,a,s)}async resolveAnyAsync(p,w,a){return this.j(p,w,a)}async resolveAnyMap(p,w,a){const s=new Map;return{newConfig:await this.j(p,w,a,s),resolvedVariables:s}}resolveWithInteractionReplace(p,w,a,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,w,a,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,w){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,w)}async l(p,w,a,s,t){if(C.$Cf(a))return this.m(p,w,a,s,t);if(Array.isArray(a))return Promise.all(a.map(n=>this.l(p,w,n,s,t)));if(C.$Ef(a)){const n=Object.create(null),o=await Promise.all(Object.keys(a).map(async c=>[await this.m(p,w,c,s,t),await this.l(p,w,a[c],s,t)]));for(const[c,d]of o)n[c]=d;return n}return a}m(p,w,a,s,t){return(0,A.$Xe)(a,S.VARIABLE_REGEXP,async(n,o)=>{if(o.includes(S.VARIABLE_LHS))return n;let c=await this.o(p,n,o,w,s);return t?.set(o,c),c!==n&&C.$Cf(c)&&c.match(S.VARIABLE_REGEXP)&&(c=await this.m(p,w,c,s,t)),c})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,w,a,s,t){let n;const o=a.split(":");o.length>1&&(a=o[0],n=o[1]);const c=r=>{const u=this.a.getFilePath();if(u)return(0,$.$Bv)(u);throw new y.$oN(r,(0,m.localize)(0,null,w))},d=r=>{const u=c(r);if(this.a.getWorkspaceFolderPathForFile){const f=this.a.getWorkspaceFolderPathForFile();if(f)return(0,$.$Bv)(f)}throw new y.$oN(r,(0,m.localize)(1,null,w,E.$mc(u)))},i=r=>{if(n){const u=this.a.getFolderUri(n);if(u)return u;throw new y.$oN(r,(0,m.localize)(2,null,w,n))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new y.$oN(r,(0,m.localize)(3,null,w)):new y.$oN(r,(0,m.localize)(4,null,w))};switch(a){case"env":if(n){if(p.env){const r=p.env[P.$i?n.toLowerCase():n];if(C.$Cf(r))return r}return""}throw new y.$oN(y.VariableKind.Env,(0,m.localize)(5,null,w));case"config":if(n){const r=this.a.getConfigurationValue(s,n);if(C.$Lf(r))throw new y.$oN(y.VariableKind.Config,(0,m.localize)(6,null,w,n));if(C.$Ef(r))throw new y.$oN(y.VariableKind.Config,(0,m.localize)(7,null,w,n));return r}throw new y.$oN(y.VariableKind.Config,(0,m.localize)(8,null,w));case"command":return this.p(y.VariableKind.Command,w,n,t,"command");case"input":return this.p(y.VariableKind.Input,w,n,t,"input");case"extensionInstallFolder":if(n){const r=await this.a.getExtension(n);if(!r)throw new y.$oN(y.VariableKind.ExtensionInstallFolder,(0,m.localize)(9,null,w,n));return this.n(r.extensionLocation)}throw new y.$oN(y.VariableKind.ExtensionInstallFolder,(0,m.localize)(10,null,w));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,$.$Bv)(this.n(i(y.VariableKind.WorkspaceFolder)));case"cwd":return s||n?(0,$.$Bv)(this.n(i(y.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$Bv)(E.$mc(this.n(i(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new y.$oN(y.VariableKind.UserHome,(0,m.localize)(11,null,w))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new y.$oN(y.VariableKind.LineNumber,(0,m.localize)(12,null,w))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new y.$oN(y.VariableKind.SelectedText,(0,m.localize)(13,null,w))}case"file":return c(y.VariableKind.File);case"fileWorkspaceFolder":return d(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return E.$mc(d(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return s||n?E.$kc(this.n(i(y.VariableKind.RelativeFile)),c(y.VariableKind.RelativeFile)):c(y.VariableKind.RelativeFile);case"relativeFileDirname":{const r=E.$lc(c(y.VariableKind.RelativeFileDirname));if(s||n){const u=E.$kc(this.n(i(y.VariableKind.RelativeFileDirname)),r);return u.length===0?".":u}return r}case"fileDirname":return E.$lc(c(y.VariableKind.FileDirname));case"fileExtname":return E.$nc(c(y.VariableKind.FileExtname));case"fileBasename":return E.$mc(c(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=E.$mc(c(y.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-E.$nc(r).length)}case"fileDirnameBasename":return E.$mc(E.$lc(c(y.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||w}case"execInstallFolder":{const r=this.a.getAppRoot();return r||w}case"pathSeparator":return E.sep;default:try{const r=n?`${a}:${n}`:a;return this.p(y.VariableKind.Unknown,w,r,t,void 0)}catch{return w}}}}p(p,w,a,s,t){if(a&&s){const n=t===void 0?s[a]:s[t+":"+a];if(typeof n=="string")return n;throw new y.$oN(p,(0,m.localize)(14,null,w))}return w}}e.$CN=S}),define(Ae[104],Re([1,0,4,101]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LC=e.$KC=e.OpenEditorContext=e.GroupsOrder=e.$JC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$IC=void 0,e.$IC=(0,E.$Xh)("editorGroupsService");var C;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var M;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var P;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(P||(e.GroupLocation=P={}));var $;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EXPAND=1]="EXPAND",w[w.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var m;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function y(w){const a=w;return(0,T.$rE)(a?.editor)&&(0,T.$rE)(a?.replacement)}e.$JC=y;var A;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var S;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function l(w){const a=w;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}e.$KC=l;function p(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$LC=p}),define(Ae[215],Re([1,0,4,104]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PC=e.$OC=e.$NC=e.$MC=void 0,e.$MC=(0,E.$Xh)("editorService"),e.$NC=-1,e.$OC=-2;function C(M){const P=M;return typeof M=="number"||(0,T.$KC)(P)}e.$PC=C}),define(Ae[216],Re([1,0,4,183]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WJ=void 0,e.$WJ=(0,E.$Yh)(T.$5h)}),define(Ae[105],Re([1,0,22,5,20,6]),function(we,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j6b=e.$i6b=e.$h6b=e.$g6b=e.$f6b=void 0;class P{constructor(t,n){this.versionId=t,this.removedDueToLooping=n}}e.$f6b=P;class ${static isHostExtension(t,n,o){if(n.getExtensionDescription(t))return!1;const c=o.getExtensionDescription(t);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(t,n){this.j=t,this.c=new T.$Rd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(w),this.f=new E.$dm,this.g=[],this.h=new Map;for(const t of this.e){if(this.f.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.f.set(t.identifier,t),this.g.push(t);const n=this.j.readActivationEvents(t);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(t)}}set(t){return this.e=t,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(t,n){this.e=a(this.e,n),this.e=this.e.concat(t);const o=$.l(this.e);return this.e=a(this.e,o.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new P(this.d,o)}static l(t){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,u){this.addNode(r),this.addNode(u),this.c.has(r)?this.c.get(r).push(u):this.c.set(r,[u])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,u){const f=n.getArcs(r);for(let v=0;v<f.length;v++)if(!u.has(f[v]))return!1;return!0}getNodes(){return this.e}},o=new E.$dm;for(const r of t)if(o.set(r.identifier,r),r.extensionDependencies)for(const u of r.extensionDependencies)n.addArc(E.$bm.toKey(r.identifier),E.$bm.toKey(u));const c=new Set;n.getNodes().filter(r=>n.getArcs(r).length===0).forEach(r=>c.add(r));const d=n.getNodes().filter(r=>!c.has(r));let i;do{i=!1;for(let r=0;r<d.length;r++){const u=d[r];n.hasOnlyGoodArcs(u,c)&&(d.splice(r,1),r--,c.add(u),i=!0)}}while(i);return d.map(r=>o.get(r))}containsActivationEvent(t){return this.h.has(t)}containsExtension(t){return this.f.has(t)}getExtensionDescriptionsForActivationEvent(t){const n=this.h.get(t);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new m(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(t){const n=this.f.get(t);return n||void 0}getExtensionDescriptionByUUID(t){for(const n of this.g)if(n.uuid===t)return n}getExtensionDescriptionByIdOrUUID(t,n){return this.getExtensionDescription(t)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$g6b=$;class m{constructor(t,n){this.versionId=t,this.extensions=n}}e.$h6b=m;class y{constructor(t){this.d=new l,this.c=new $(t,[])}async acquireLock(t){const n=await this.d.acquire(t);return new A(this,n)}deltaExtensions(t,n,o){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,n){return this.c.getExtensionDescriptionByIdOrUUID(t,n)}}e.$i6b=y;class A extends M.$Rc{constructor(t,n){super(),this.f=t,this.c=!1,this.B(n)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$j6b=A;class S{constructor(t){this.name=t,this.promise=new Promise((n,o)=>{this.c=n})}resolve(t){this.c(t)}}class l{constructor(){this.c=[],this.d=!1}async acquire(t){const n=new S(t);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};t.resolve((0,M.$Pc)(c))}}var p;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(p||(p={}));function w(s,t){const n=s.isBuiltin?0:s.isUnderDevelopment?2:1,o=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(n!==o)return n-o;const c=C.$fc.basename(s.extensionLocation.path),d=C.$fc.basename(t.extensionLocation.path);return c<d?-1:c>d?1:0}function a(s,t){const n=new E.$cm(t);return s.filter(o=>!n.has(o.identifier))}}),define(Ae[79],Re([1,0,24]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$km=e.$jm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(T||(e.UIKind=T={}));var C;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var M;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function P(y){const A=E.$fe.alloc(1);switch(y){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$jm=P;function $(y,A){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$km=$;var m;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(Ae[59],Re([1,0,4,5,15,27,79,55,56,26,2,6,164]),function(we,e,E,T,C,M,P,$,m,y,A,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=e.$UM=e.$TM=e.$SM=void 0;let p=class extends S.$Rc{constructor(t,n){super(),this.s=t,this.t=n,this.a=this.B(new T.$Rd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Rd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:m.$wo,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(n.onDidChangeLogLevel(o=>{(0,C.$hj)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(t,n,o){const c=this.getTelemetryDetails(),d=new w(n,o,t,this.n,this.j,this.getBuiltInCommonProperties(t),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(t.identifier.value)??[];return this.r.set(t.identifier.value,[...i,d]),d.apiTelemetryLogger}$initializeTelemetryLevel(t,n,o){this.f=t,this.g=n,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(t){const n=Object.create(null);switch(n["common.extname"]=`${t.publisher}.${t.name}`,n["common.extversion"]=t.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=a(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case P.UIKind.Web:n["common.uikind"]="web";break;case P.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$4k)((0,m.$Do)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(t){this.h=this.getTelemetryConfiguration(),this.f=t;const n=this.getTelemetryDetails();this.r.forEach((o,c)=>{const d=o.filter(i=>!i.isDisposed);d.length===0?this.r.delete(c):this.r.set(c,d)}),this.r.forEach(o=>{for(const c of o)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(t,n){const c=this.r.get(t.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(t.value),!1;let d=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(n),d=!0);return d}};e.$SM=p,e.$SM=p=Ke([We(0,M.$RM),We(1,C.$gj)],p);class w{static validateSender(t){if(typeof t!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof t.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof t.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof t.flush<"u"&&typeof t.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(t,n,o,c,d,i,r){this.g=o,this.h=c,this.i=d,this.j=i,this.a=new T.$Rd,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=t,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(t,n){this.e&&(this.d={isUsageEnabled:t,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(t){let n="properties"in t?t.properties??{}:t;return n=(0,m.$Go)(n,[]),this.c&&(n=(0,y.$fn)(n,this.c)),this.b||(n=(0,y.$fn)(n,this.j)),"properties"in t?t.properties=n:t=n,t}k(t,n){this.f&&(this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(t,n),this.h.trace(t,n))}logUsage(t,n){this.d.isUsageEnabled&&this.k(t,n)}logError(t,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof t=="string")this.k(t,n);else{const o={name:t.name,message:t.message,stack:t.stack,cause:t.cause},c=(0,m.$Go)(o,[]),d=new Error(c.message,{cause:c.cause});d.stack=c.stack,d.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(d,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const t=this,n={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.d.isUsageEnabled},get isErrorsEnabled(){return t.d.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.a.event.bind(t)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let t=this.f;this.f=void 0,Promise.resolve(t.flush()).then(t=void 0),this.e=void 0}else this.f=void 0}}e.$TM=w;function a(s){const t=Date.now()-new Date(s).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.$UM=a,e.$VM=(0,E.$Xh)("IExtHostTelemetry")}),define(Ae[23],Re([1,0,5,2,192,100,22,4]),function(we,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TF=e.$SF=e.$RF=e.ActivationKind=e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.ExtensionHostStartup=e.$LF=e.$KF=e.$JF=e.$IF=void 0,e.$IF=Object.freeze({identifier:new P.$bm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$JF="extensions.webWorker",e.$KF=(0,$.$Xh)("extensionService");class m{constructor(d){this.dependency=d}}e.$LF=m;var y;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(d,i,r){this.c=d,this.d=i.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$zF.createActivationEventsMap(this.d)}}set(d,i,r){if(this.c>d)throw new Error(`ExtensionHostExtensions: invalid versionId ${d} (current: ${this.c})`);const u=[],f=[],v=[],g=[],D=S(this.d),I=S(i),h=(J,N)=>J.extensionLocation.toString()===N.extensionLocation.toString()||J.isBuiltin===N.isBuiltin||J.isUserBuiltin===N.isUserBuiltin||J.isUnderDevelopment===N.isUnderDevelopment;for(const J of this.d){const N=I.get(J.identifier);if(!N){u.push(J.identifier),D.delete(J.identifier);continue}if(!h(J,N)){u.push(J.identifier),D.delete(J.identifier);continue}}for(const J of i){const N=D.get(J.identifier);if(!N){f.push(J);continue}if(!h(N,J)){u.push(N.identifier),D.delete(N.identifier);continue}}const b=new P.$cm(this.e),k=new P.$cm(r);for(const J of this.e)k.has(J)||v.push(J);for(const J of r)b.has(J)||g.push(J);const F=M.$zF.createActivationEventsMap(f),W={versionId:d,toRemove:u,toAdd:f,addActivationEvents:F,myToRemove:v,myToAdd:g};return this.delta(W),W}delta(d){if(this.c>=d.versionId)return null;const{toRemove:i,toAdd:r,myToRemove:u,myToAdd:f}=d,v=new P.$cm(i),g=new P.$cm(u);for(let D=0;D<this.d.length;D++)v.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)g.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of r)this.d.push(D);for(const D of f)this.e.push(D);return this.f=null,d}containsExtension(d){for(const i of this.e)if(P.$bm.equals(i,d))return!0;return!1}containsActivationEvent(d){return this.f||(this.f=this.g()),this.f.has(d)}g(){const d=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const r=M.$zF.readActivationEvents(i);for(const u of r)d.add(u)}return d}}e.$MF=A;function S(c){const d=new P.$dm;for(const i of c)d.set(i.identifier,i);return d}function l(c,d){return c.enabledApiProposals?c.enabledApiProposals.includes(d):!1}e.$NF=l;function p(c,d){if(!l(c,d))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$OF=p;class w{constructor(d,i,r,u){this.codeLoadingTime=d,this.activateCallTime=i,this.activateResolvedTime=r,this.activationReason=u}}e.$PF=w;class a{constructor(d,i){this.description=d,this.value=i}}e.$QF=a;var s;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function t(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.$Mo)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$RF=t;function n(c,d){return{identifier:new P.$bm((0,C.$Ko)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!d,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$SF=n;class o{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activateById(d,i){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(d,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$TF=o}),define(Ae[217],Re([1,0,11,105,22,23,15,14]),function(we,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=e.$Mec=e.$Lec=e.$Kec=e.$Jec=e.$Iec=void 0;class m{static{this.NONE=new m(!1,-1,-1,-1)}constructor(t,n,o,c){this.startup=t,this.codeLoadingTime=n,this.activateCallTime=o,this.activateResolvedTime=c}}e.$Iec=m;class y{constructor(t){this.a=t,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(t,n){return t===-1||n===-1?-1:n-t}build(){return new m(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Jec=y;class A{constructor(t,n,o,c,d,i){this.activationFailed=t,this.activationFailedError=n,this.activationTimes=o,this.module=c,this.exports=d,this.subscriptions=i}}e.$Kec=A;class S extends A{constructor(t){super(!1,null,t,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Lec=S;class l extends A{constructor(){super(!1,null,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Mec=l;class p extends A{constructor(t){super(!0,t,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let w=class{constructor(t,n,o,c){this.g=c,this.a=t,this.b=n,this.c=o,this.d=new C.$dm,this.f=Object.create(null)}dispose(){for(const[t,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const t=[];for(const[n,o]of this.d)t.push(o.wait());await Promise.all(t)}isActivated(t){const n=this.d.get(t);return!!(n&&n.value)}getActivatedExtension(t){const n=this.d.get(t);if(!n||!n.value)throw new Error(`Extension '${t.value}' is not known or not activated`);return n.value}async activateByEvent(t,n){if(this.f[t])return;const o=this.a.getExtensionDescriptionsForActivationEvent(t);await this.h(o.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:t}}))),this.f[t]=!0}activateById(t,n){const o=this.a.getExtensionDescription(t);if(!o)throw new Error(`Extension '${t}' is not known`);return this.h([{id:o.identifier,reason:n}])}async h(t){const n=t.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(n.map(o=>o.wait()))}j(t){if(this.d.has(t.id))return this.d.get(t.id);if(this.l(t.id))return this.k(t,null,[],null);const n=this.a.getExtensionDescription(t.id);if(!n){const d=new Error(`Cannot activate unknown extension '${t.id.value}'`),i=this.k(t,null,[],new p(d));return this.c.onExtensionActivationError(t.id,d,new M.$LF(t.id.value)),i}const o=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const d of c){if(this.m(d))continue;const i=this.d.get(d);if(i){o.push(i);continue}if(this.l(d)){o.push(this.j({id:this.b.getExtensionDescription(d).identifier,reason:t.reason}));continue}const r=this.a.getExtensionDescription(d);if(r){if(!r.main&&!r.browser)continue;o.push(this.j({id:r.identifier,reason:t.reason}));continue}const u=n.displayName||n.identifier.value,f=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${d}'`),v=this.k(t,n.displayName,[],new p(f));return this.c.onExtensionActivationError(n.identifier,f,new M.$LF(d)),v}return this.k(t,n.displayName,o,null)}k(t,n,o,c){const d=new a(t.id,n,t.reason,o,c,this.c,this.g);return this.d.set(t.id,d),d}l(t){return T.$g6b.isHostExtension(t,this.a,this.b)}m(t){const n=this.b.getExtensionDescription(t);return n?!n.main&&!n.browser:!1}};e.$Nec=w,e.$Nec=w=Ke([We(3,P.$fj)],w);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(t,n,o,c,d,i,r){this.c=t,this.d=n,this.f=o,this.g=c,this.h=d,this.j=i,this.k=r,this.a=new $.$Yg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let t=0;t<this.g.length;t++){const n=this.g[t];if(n.value&&!n.value.activationFailed){this.g.splice(t,1),t--;continue}if(n.value&&n.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);o.detail=n.value.activationFailedError,this.h=new p(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(t=>t.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(t){const n=new Error;if(t&&t.name&&(n.name=t.name),t&&t.message?n.message=`Activating extension '${this.c.value}' failed: ${t.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${t}.`,t&&t.stack&&(n.stack=t.stack),this.h=new p(n),this.b&&E.$3(t))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(t)}}};a=Ke([We(6,P.$fj)],a)}),define(Ae[8],Re([1,0,18,24,125,218,52,28,119,51,68,26,16,2,29,80,98,103,101,76,48,58,215,7,23]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a,s,t,n,o,c,d,i,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$AM=e.$zM=e.MarkdownString=e.$yM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var f;(function(Se){function Me(K){const{selectionStartLineNumber:Le,selectionStartColumn:je,positionLineNumber:Ze,positionColumn:qe}=K,et=new r.$CK(Le-1,je-1),ut=new r.$CK(Ze-1,qe-1);return new r.$EK(et,ut)}Se.to=Me;function ve(K){const{anchor:Le,active:je}=K;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}Se.from=ve})(f||(e.Selection=f={}));var v;(function(Se){function Me(K){if(!K)return;const{start:Le,end:je}=K;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}Se.from=Me;function ve(K){if(!K)return;const{startLineNumber:Le,startColumn:je,endLineNumber:Ze,endColumn:qe}=K;return new r.$DK(Le-1,je-1,Ze-1,qe-1)}Se.to=ve})(v||(e.Range=v={}));var g;(function(Se){function Me(ve){switch(ve){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Se.to=Me})(g||(e.TokenType=g={}));var D;(function(Se){function Me(K){return new r.$CK(K.lineNumber-1,K.column-1)}Se.to=Me;function ve(K){return{lineNumber:K.line+1,column:K.character+1}}Se.from=ve})(D||(e.Position=D={}));var I;(function(Se){function Me(Le,je,Ze){return(0,E.$Gb)((0,E.$2b)(Le).map(qe=>ve(qe,je,Ze)))}Se.from=Me;function ve(Le,je,Ze){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:Ze?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:K(Le.scheme,je),pattern:Y.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:Ze?.isBuiltin}}function K(Le,je){return je&&typeof Le=="string"?je.transformOutgoingScheme(Le):Le}})(I||(e.DocumentSelector=I={}));var h;(function(Se){function Me(K){switch(K){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Se.from=Me;function ve(K){switch(K){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Se.to=ve})(h||(e.DiagnosticTag=h={}));var b;(function(Se){function Me(K){let Le;return K.code&&((0,l.$Cf)(K.code)||(0,l.$Gf)(K.code)?Le=String(K.code):Le={value:String(K.code.value),target:K.code.target}),{...v.from(K.range),message:K.message,source:K.source,code:Le,severity:F.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(k.from),tags:Array.isArray(K.tags)?(0,E.$Gb)(K.tags.map(h.from)):void 0}}Se.from=Me;function ve(K){const Le=new r.$PK(v.to(K),K.message,F.to(K.severity));return Le.source=K.source,Le.code=(0,l.$Cf)(K.code)?K.code:K.code?.value,Le.relatedInformation=K.relatedInformation&&K.relatedInformation.map(k.to),Le.tags=K.tags&&(0,E.$Gb)(K.tags.map(h.to)),Le}Se.to=ve})(b||(e.Diagnostic=b={}));var k;(function(Se){function Me(K){return{...v.from(K.location.range),message:K.message,resource:K.location.uri}}Se.from=Me;function ve(K){return new r.$OK(new r.$NK(K.resource,v.to(K)),K.message)}Se.to=ve})(k||(e.DiagnosticRelatedInformation=k={}));var F;(function(Se){function Me(K){switch(K){case r.DiagnosticSeverity.Error:return s.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return s.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return s.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return s.MarkerSeverity.Hint}return s.MarkerSeverity.Error}Se.from=Me;function ve(K){switch(K){case s.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case s.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case s.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case s.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Se.to=ve})(F||(e.DiagnosticSeverity=F={}));var W;(function(Se){function Me(K){return typeof K=="number"&&K>=r.ViewColumn.One?K-1:K===r.ViewColumn.Beside?i.$OC:i.$NC}Se.from=Me;function ve(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=ve})(W||(e.ViewColumn=W={}));function J(Se){return typeof Se.range<"u"}function N(Se){return Se.length===0?!0:!!J(Se[0])}e.$yM=N;var R;(function(Se){function Me(qe){return qe.map(Se.from)}Se.fromMany=Me;function ve(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function K(qe){let et;if(ve(qe)){const{language:Et,value:yt}=qe;et={value:"```"+Et+`
`+yt+"\n```\n"}}else r.$2K.isMarkdownString(qe)?et={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?et={value:qe}:et={value:""};const ut=Object.create(null);et.uris=ut;const vt=Et=>{try{let yt=p.URI.parse(Et,!0);yt=yt.with({query:Le(yt.query,ut)}),ut[Et]=yt}catch{}return""},$t=new m.marked.Renderer;return $t.link=vt,$t.image=Et=>typeof Et=="string"?vt(P.$fk(Et).href):"",(0,m.marked)(et.value,{renderer:$t}),et}Se.from=K;function Le(qe,et){if(!qe)return qe;let ut;try{ut=(0,y.$th)(qe)}catch{}if(!ut)return qe;let vt=!1;return ut=(0,S.$en)(ut,$t=>{if(p.URI.isUri($t)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[Et]=$t,vt=!0,Et}else return}),vt?JSON.stringify(ut):qe}function je(qe){const et=new r.$2K(qe.value,qe.supportThemeIcons);return et.isTrusted=qe.isTrusted,et.supportHtml=qe.supportHtml,et.baseUri=qe.baseUri?p.URI.from(qe.baseUri):void 0,et}Se.to=je;function Ze(qe){if(qe)return typeof qe=="string"?qe:Se.from(qe)}Se.fromStrict=Ze})(R||(e.MarkdownString=R={}));function L(Se){return N(Se)?Se.map(Me=>({range:v.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?R.fromMany(Me.hoverMessage):Me.hoverMessage?R.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Se.map(Me=>({range:v.from(Me)}))}e.$zM=L;function O(Se){return typeof Se>"u"?Se:typeof Se=="string"?p.URI.file(Se):Se}e.$AM=O;var X;(function(Se){function Me(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?O(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Se.from=Me})(X||(e.ThemableDecorationAttachmentRenderOptions=X={}));var he;(function(Se){function Me(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?O(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?X.from(ve.before):void 0,after:ve.after?X.from(ve.after):void 0}}Se.from=Me})(he||(e.ThemableDecorationRenderOptions=he={}));var $e;(function(Se){function Me(ve){if(typeof ve>"u")return ve;switch(ve){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Me})($e||(e.DecorationRangeBehavior=$e={}));var De;(function(Se){function Me(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?$e.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?he.from(ve.light):void 0,dark:ve.dark?he.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?O(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?X.from(ve.before):void 0,after:ve.after?X.from(ve.after):void 0}}Se.from=Me})(De||(e.DecorationRenderOptions=De={}));var ke;(function(Se){function Me(K){return{text:K.newText,eol:K.newEol&&tt.from(K.newEol),range:v.from(K.range)}}Se.from=Me;function ve(K){const Le=new r.$IK(v.to(K.range),K.text);return Le.newEol=typeof K.eol>"u"?void 0:tt.to(K.eol),Le}Se.to=ve})(ke||(e.TextEdit=ke={}));var de;(function(Se){function Me(K,Le){const je={edits:[]};if(K instanceof r.$LK){const Ze=new $.$Ac;for(const qe of K._allEntries())qe._type===1&&p.URI.isUri(qe.to)&&qe.from===void 0&&Ze.add(qe.to);for(const qe of K._allEntries())if(qe._type===1){let et;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?et={type:"base64",value:(0,T.$ze)(T.$fe.wrap(qe.options.contents))}:et={type:"dataTransferItem",id:qe.options.contents._itemId}),je.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:et},metadata:qe.metadata})}else qe._type===2?je.edits.push({resource:qe.uri,textEdit:ke.from(qe.edit),versionId:Ze.has(qe.uri)?void 0:Le?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?je.edits.push({resource:qe.uri,textEdit:{range:v.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Ze.has(qe.uri)?void 0:Le?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?je.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&je.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Le?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Te.from)}})}return je}Se.from=Me;function ve(K){const Le=new r.$LK,je=new $.$zc;for(const Ze of K.edits)if(Ze.textEdit){const qe=Ze,et=p.URI.revive(qe.resource),ut=v.to(qe.textEdit.range),vt=qe.textEdit.text,$t=qe.textEdit.insertAsSnippet;let Et;$t?Et=r.$KK.replace(ut,new r.$MK(vt)):Et=r.$IK.replace(ut,vt);const yt=je.get(et);yt?yt.push(Et):je.set(et,[Et])}else Le.renameFile(p.URI.revive(Ze.oldResource),p.URI.revive(Ze.newResource),Ze.options);for(const[Ze,qe]of je)Le.set(Ze,qe);return Le}Se.to=ve})(de||(e.WorkspaceEdit=de={}));var Ee;(function(Se){const Me=Object.create(null);Me[r.SymbolKind.File]=0,Me[r.SymbolKind.Module]=1,Me[r.SymbolKind.Namespace]=2,Me[r.SymbolKind.Package]=3,Me[r.SymbolKind.Class]=4,Me[r.SymbolKind.Method]=5,Me[r.SymbolKind.Property]=6,Me[r.SymbolKind.Field]=7,Me[r.SymbolKind.Constructor]=8,Me[r.SymbolKind.Enum]=9,Me[r.SymbolKind.Interface]=10,Me[r.SymbolKind.Function]=11,Me[r.SymbolKind.Variable]=12,Me[r.SymbolKind.Constant]=13,Me[r.SymbolKind.String]=14,Me[r.SymbolKind.Number]=15,Me[r.SymbolKind.Boolean]=16,Me[r.SymbolKind.Array]=17,Me[r.SymbolKind.Object]=18,Me[r.SymbolKind.Key]=19,Me[r.SymbolKind.Null]=20,Me[r.SymbolKind.EnumMember]=21,Me[r.SymbolKind.Struct]=22,Me[r.SymbolKind.Event]=23,Me[r.SymbolKind.Operator]=24,Me[r.SymbolKind.TypeParameter]=25;function ve(Le){return typeof Me[Le]=="number"?Me[Le]:6}Se.from=ve;function K(Le){for(const je in Me)if(Me[je]===Le)return Number(je);return r.SymbolKind.Property}Se.to=K})(Ee||(e.SymbolKind=Ee={}));var _;(function(Se){function Me(K){switch(K){case r.SymbolTag.Deprecated:return 1}}Se.from=Me;function ve(K){switch(K){case 1:return r.SymbolTag.Deprecated}}Se.to=ve})(_||(e.SymbolTag=_={}));var Ce;(function(Se){function Me(K){return{name:K.name,kind:Ee.from(K.kind),tags:K.tags&&K.tags.map(_.from),containerName:K.containerName,location:pe.from(K.location)}}Se.from=Me;function ve(K){const Le=new r.$SK(K.name,Ee.to(K.kind),K.containerName,pe.to(K.location));return Le.tags=K.tags&&K.tags.map(_.to),Le}Se.to=ve})(Ce||(e.WorkspaceSymbol=Ce={}));var se;(function(Se){function Me(K){const Le={name:K.name||"!!MISSING: name!!",detail:K.detail,range:v.from(K.range),selectionRange:v.from(K.selectionRange),kind:Ee.from(K.kind),tags:K.tags?.map(_.from)??[]};return K.children&&(Le.children=K.children.map(Me)),Le}Se.from=Me;function ve(K){const Le=new r.$TK(K.name,K.detail,Ee.to(K.kind),v.to(K.range),v.to(K.selectionRange));return(0,E.$Kb)(K.tags)&&(Le.tags=K.tags.map(_.to)),K.children&&(Le.children=K.children.map(ve)),Le}Se.to=ve})(se||(e.DocumentSymbol=se={}));var Q;(function(Se){function Me(K){const Le=new r.$XK(Ee.to(K.kind),K.name,K.detail||"",p.URI.revive(K.uri),v.to(K.range),v.to(K.selectionRange));return Le._sessionId=K._sessionId,Le._itemId=K._itemId,Le}Se.to=Me;function ve(K,Le,je){if(Le=Le??K._sessionId,je=je??K._itemId,Le===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:je,name:K.name,detail:K.detail,kind:Ee.from(K.kind),uri:K.uri,range:v.from(K.range),selectionRange:v.from(K.selectionRange),tags:K.tags?.map(_.from)}}Se.from=ve})(Q||(e.CallHierarchyItem=Q={}));var U;(function(Se){function Me(ve){return new r.$YK(Q.to(ve.from),ve.fromRanges.map(K=>v.to(K)))}Se.to=Me})(U||(e.CallHierarchyIncomingCall=U={}));var ne;(function(Se){function Me(ve){return new r.$ZK(Q.to(ve.to),ve.fromRanges.map(K=>v.to(K)))}Se.to=Me})(ne||(e.CallHierarchyOutgoingCall=ne={}));var pe;(function(Se){function Me(K){return{range:K.range&&v.from(K.range),uri:K.uri}}Se.from=Me;function ve(K){return new r.$NK(p.URI.revive(K.uri),v.to(K.range))}Se.to=ve})(pe||(e.location=pe={}));var re;(function(Se){function Me(K){const Le=K,je=K;return{originSelectionRange:Le.originSelectionRange?v.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:je.uri,range:v.from(Le.targetRange?Le.targetRange:je.range),targetSelectionRange:Le.targetSelectionRange?v.from(Le.targetSelectionRange):void 0}}Se.from=Me;function ve(K){return{targetUri:p.URI.revive(K.uri),targetRange:v.to(K.range),targetSelectionRange:K.targetSelectionRange?v.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?v.to(K.originSelectionRange):void 0}}Se.to=ve})(re||(e.DefinitionLink=re={}));var le;(function(Se){function Me(K){return{range:v.from(K.range),contents:R.fromMany(K.contents)}}Se.from=Me;function ve(K){return new r.$QK(K.contents.map(R.to),v.to(K.range))}Se.to=ve})(le||(e.Hover=le={}));var ce;(function(Se){function Me(K){return{range:v.from(K.range),expression:K.expression}}Se.from=Me;function ve(K){return new r.$JL(v.to(K.range),K.expression)}Se.to=ve})(ce||(e.EvaluatableExpression=ce={}));var be;(function(Se){function Me(K){if(K instanceof r.$KL)return{type:"text",range:v.from(K.range),text:K.text};if(K instanceof r.$LL)return{type:"variable",range:v.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof r.$ML)return{type:"expression",range:v.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Me;function ve(K){switch(K.type){case"text":return{range:v.to(K.range),text:K.text};case"variable":return{range:v.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:v.to(K.range),expression:K.expression}}}Se.to=ve})(be||(e.InlineValue=be={}));var ee;(function(Se){function Me(K){return{frameId:K.frameId,stoppedLocation:v.from(K.stoppedLocation)}}Se.from=Me;function ve(K){return new r.$NL(K.frameId,v.to(K.stoppedLocation))}Se.to=ve})(ee||(e.InlineValueContext=ee={}));var fe;(function(Se){function Me(K){return{range:v.from(K.range),kind:K.kind}}Se.from=Me;function ve(K){return new r.$RK(v.to(K.range),K.kind)}Se.to=ve})(fe||(e.DocumentHighlight=fe={}));var ie;(function(Se){function Me(ve){switch(ve){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Se.to=Me})(ie||(e.CompletionTriggerKind=ie={}));var ae;(function(Se){function Me(ve){return{triggerKind:ie.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Se.to=Me})(ae||(e.CompletionContext=ae={}));var me;(function(Se){function Me(K){switch(K){case r.CompletionItemTag.Deprecated:return 1}}Se.from=Me;function ve(K){switch(K){case 1:return r.CompletionItemTag.Deprecated}}Se.to=ve})(me||(e.CompletionItemTag=me={}));var Pe;(function(Se){const Me=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function ve(je){return Me.get(je)??9}Se.from=ve;const K=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Le(je){return K.get(je)??r.CompletionItemKind.Property}Se.to=Le})(Pe||(e.CompletionItemKind=Pe={}));var z;(function(Se){function Me(ve,K){const Le=new r.$8K(ve.label);return Le.insertText=ve.insertText,Le.kind=Pe.to(ve.kind),Le.tags=ve.tags?.map(me.to),Le.detail=ve.detail,Le.documentation=P.$ak(ve.documentation)?R.to(ve.documentation):ve.documentation,Le.sortText=ve.sortText,Le.filterText=ve.filterText,Le.preselect=ve.preselect,Le.commitCharacters=ve.commitCharacters,w.$Bs.isIRange(ve.range)?Le.range=v.to(ve.range):typeof ve.range=="object"&&(Le.range={inserting:v.to(ve.range.insert),replacing:v.to(ve.range.replace)}),Le.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&1),typeof ve.insertTextRules<"u"&&ve.insertTextRules&4?Le.insertText=new r.$MK(ve.insertText):(Le.insertText=ve.insertText,Le.textEdit=Le.range instanceof r.$DK?new r.$IK(Le.range,Le.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Le.additionalTextEdits=ve.additionalTextEdits.map(je=>ke.to(je))),Le.command=K&&ve.command?K.fromInternal(ve.command):void 0,Le}Se.to=Me})(z||(e.CompletionItem=z={}));var V;(function(Se){function Me(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:R.fromStrict(K.documentation)}}Se.from=Me;function ve(K){return{label:K.label,documentation:P.$ak(K.documentation)?R.to(K.documentation):K.documentation}}Se.to=ve})(V||(e.ParameterInformation=V={}));var H;(function(Se){function Me(K){return{label:K.label,documentation:R.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(V.from):[],activeParameter:K.activeParameter}}Se.from=Me;function ve(K){return{label:K.label,documentation:P.$ak(K.documentation)?R.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(V.to):[],activeParameter:K.activeParameter}}Se.to=ve})(H||(e.SignatureInformation=H={}));var G;(function(Se){function Me(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(H.from):[]}}Se.from=Me;function ve(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(H.to):[]}}Se.to=ve})(G||(e.SignatureHelp=G={}));var q;(function(Se){function Me(ve,K){const Le=new r.$7K(D.to(K.position),typeof K.label=="string"?K.label:K.label.map(x.to.bind(void 0,ve)),K.kind&&ue.to(K.kind));return Le.textEdits=K.textEdits&&K.textEdits.map(ke.to),Le.tooltip=P.$ak(K.tooltip)?R.to(K.tooltip):K.tooltip,Le.paddingLeft=K.paddingLeft,Le.paddingRight=K.paddingRight,Le}Se.to=Me})(q||(e.InlayHint=q={}));var x;(function(Se){function Me(ve,K){const Le=new r.$6K(K.label);return Le.tooltip=P.$ak(K.tooltip)?R.to(K.tooltip):K.tooltip,a.Command.is(K.command)&&(Le.command=ve.fromInternal(K.command)),K.location&&(Le.location=pe.to(K.location)),Le}Se.to=Me})(x||(e.InlayHintLabelPart=x={}));var ue;(function(Se){function Me(K){return K}Se.from=Me;function ve(K){return K}Se.to=ve})(ue||(e.InlayHintKind=ue={}));var Ne;(function(Se){function Me(K){return{range:v.from(K.range),url:K.target,tooltip:K.tooltip}}Se.from=Me;function ve(K){let Le;if(K.url)try{Le=typeof K.url=="string"?p.URI.parse(K.url,!0):p.URI.revive(K.url)}catch{}return new r.$aL(v.to(K.range),Le)}Se.to=ve})(Ne||(e.DocumentLink=Ne={}));var Be;(function(Se){function Me(K){const Le=new r.$dL(K.label);return K.textEdit&&(Le.textEdit=ke.to(K.textEdit)),K.additionalTextEdits&&(Le.additionalTextEdits=K.additionalTextEdits.map(je=>ke.to(je))),Le}Se.to=Me;function ve(K){return{label:K.label,textEdit:K.textEdit?ke.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Le=>ke.from(Le)):void 0}}Se.from=ve})(Be||(e.ColorPresentation=Be={}));var Xe;(function(Se){function Me(K){return new r.$bL(K[0],K[1],K[2],K[3])}Se.to=Me;function ve(K){return[K.red,K.green,K.blue,K.alpha]}Se.from=ve})(Xe||(e.Color=Xe={}));var Je;(function(Se){function Me(K){return{range:v.from(K.range)}}Se.from=Me;function ve(K){return new r.$WK(v.to(K.range))}Se.to=ve})(Je||(e.SelectionRange=Je={}));var it;(function(Se){function Me(ve){switch(ve){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Se.to=Me})(it||(e.TextDocumentSaveReason=it={}));var _e;(function(Se){function Me(K){switch(K){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Me;function ve(K){switch(K){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Se.to=ve})(_e||(e.TextEditorLineNumbersStyle=_e={}));var tt;(function(Se){function Me(K){if(K===r.EndOfLine.CRLF)return 1;if(K===r.EndOfLine.LF)return 0}Se.from=Me;function ve(K){if(K===1)return r.EndOfLine.CRLF;if(K===0)return r.EndOfLine.LF}Se.to=ve})(tt||(e.EndOfLine=tt={}));var rt;(function(Se){function Me(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Me})(rt||(e.ProgressLocation=rt={}));var nt;(function(Se){function Me(K){const Le={start:K.start+1,end:K.end+1};return K.kind&&(Le.kind=ze.from(K.kind)),Le}Se.from=Me;function ve(K){const Le={start:K.start-1,end:K.end-1};return K.kind&&(Le.kind=ze.to(K.kind)),Le}Se.to=ve})(nt||(e.FoldingRange=nt={}));var ze;(function(Se){function Me(K){if(K)switch(K){case r.FoldingRangeKind.Comment:return a.$qt.Comment;case r.FoldingRangeKind.Imports:return a.$qt.Imports;case r.FoldingRangeKind.Region:return a.$qt.Region}}Se.from=Me;function ve(K){if(K)switch(K.value){case a.$qt.Comment.value:return r.FoldingRangeKind.Comment;case a.$qt.Imports.value:return r.FoldingRangeKind.Imports;case a.$qt.Region.value:return r.FoldingRangeKind.Region}}Se.to=ve})(ze||(e.FoldingRangeKind=ze={}));var ht;(function(Se){function Me(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?v.from(ve.selection):void 0,override:typeof ve.override=="boolean"?n.$dE.id:void 0}}Se.from=Me})(ht||(e.TextEditorOpenOptions=ht={}));var Y;(function(Se){function Me(je){return je instanceof r.$xL?je.toJSON():typeof je=="string"?je:ve(je)||K(je)?new r.$xL(je.baseUri??je.base,je.pattern).toJSON():je}Se.from=Me;function ve(je){const Ze=je;return Ze?p.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function K(je){const Ze=je;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Le(je){return typeof je=="string"?je:new r.$xL(p.URI.revive(je.baseUri),je.pattern)}Se.to=Le})(Y||(e.GlobPattern=Y={}));var Z;(function(Se){function Me(ve){if(ve){if(Array.isArray(ve))return ve.map(Me);if(typeof ve=="string")return ve;{const K=ve;return{language:K.language,scheme:K.scheme,pattern:Y.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Se.from=Me})(Z||(e.LanguageSelector=Z={}));var ye;(function(Se){function Me(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(Le=>Array.isArray(Le)&&Le.every(je=>je&&typeof je=="object"&&"uri"in je&&p.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Ze=>Ze instanceof r.$DK)))}Se.is=Me;function ve(K){return{documents:K.documents.map(Le=>Le.map(je=>({uri:p.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Ze=>v.from(Ze))})))}}Se.from=ve})(ye||(e.MappedEditsContext=ye={}));var Ue;(function(Se){function Me(K){return{start:K.start,end:K.end}}Se.from=Me;function ve(K){return new r.$YL(K.start,K.end)}Se.to=ve})(Ue||(e.NotebookRange=Ue={}));var He;(function(Se){function Me(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Se.to=Me;function ve(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Se.from=ve})(He||(e.NotebookCellExecutionSummary=He={}));var Ye;(function(Se){function Me(ve){if(ve===o.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(ve===o.NotebookCellExecutionState.Pending)return;if(ve===o.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Se.to=Me})(Ye||(e.NotebookCellExecutionState=Ye={}));var st;(function(Se){function Me(K){switch(K){case r.NotebookCellKind.Markup:return o.CellKind.Markup;case r.NotebookCellKind.Code:default:return o.CellKind.Code}}Se.from=Me;function ve(K){switch(K){case o.CellKind.Markup:return r.NotebookCellKind.Markup;case o.CellKind.Code:default:return r.NotebookCellKind.Code}}Se.to=ve})(st||(e.NotebookCellKind=st={}));var pt;(function(Se){function Me(K){const Le={metadata:K.metadata??Object.create(null),cells:[]};for(const je of K.cells)r.$ZL.validate(je),Le.cells.push(Te.from(je));return Le}Se.from=Me;function ve(K){const Le=new r.$1L(K.cells.map(Te.to));return(0,l.$Pf)(K.metadata)||(Le.metadata=K.metadata),Le}Se.to=ve})(pt||(e.NotebookData=pt={}));var Te;(function(Se){function Me(K){return{cellKind:st.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:He.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Kt.from):[]}}Se.from=Me;function ve(K){return new r.$ZL(st.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Kt.to):void 0,K.metadata,K.internalMetadata?He.to(K.internalMetadata):void 0)}Se.to=ve})(Te||(e.NotebookCellData=Te={}));var At;(function(Se){function Me(K){return{mime:K.mime,valueBytes:T.$fe.wrap(K.data)}}Se.from=Me;function ve(K){return new r.$2L(K.valueBytes.buffer,K.mime)}Se.to=ve})(At||(e.NotebookCellOutputItem=At={}));var Kt;(function(Se){function Me(K){return{outputId:K.id,items:K.items.map(At.from),metadata:K.metadata}}Se.from=Me;function ve(K){const Le=K.items.map(At.to);return new r.$3L(Le,K.outputId,K.metadata)}Se.to=ve})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Se){function Me(Le){return K(Le)?{include:Y.from(Le.include)??void 0,exclude:Y.from(Le.exclude)??void 0}:Y.from(Le)??void 0}Se.from=Me;function ve(Le){return K(Le)?{include:Y.to(Le.include),exclude:Y.to(Le.exclude)}:Y.to(Le)}Se.to=ve;function K(Le){const je=Le;return je?!(0,l.$Lf)(je.include)&&!(0,l.$Lf)(je.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var bt;(function(Se){function Me(ve,K,Le){const je=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(je,Le),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Se.from=Me})(bt||(e.NotebookStatusBarItem=bt={}));var jt;(function(Se){function Me(ve,K,Le){const je=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:K.toInternal(je,Le),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Se.from=Me})(jt||(e.NotebookKernelSourceAction=jt={}));var Ot;(function(Se){function Me(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Se.from=Me})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Gt;(function(Se){function Me(K){return{uri:K.uri,provides:K.provides}}Se.from=Me;function ve(K){return new r.$5L(p.URI.revive(K.uri),K.provides)}Se.to=ve})(Gt||(e.NotebookRendererScript=Gt={}));var Ut;(function(Se){function Me(K){return{message:R.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:v.from(K.location.range),uri:K.location.uri}}}Se.from=Me;function ve(K){const Le=new r.$$L(typeof K.message=="string"?K.message:R.to(K.message));return Le.actualOutput=K.actual,Le.expectedOutput=K.expected,Le.contextValue=K.contextValue,Le.location=K.location?pe.to(K.location):void 0,Le}Se.to=ve})(Ut||(e.TestMessage=Ut={}));var kt;(function(Se){Se.namespace=d.$wJ,Se.denamespace=d.$xJ})(kt||(e.TestTag=kt={}));var Tt;(function(Se){function Me(K){const Le=(0,t.$xM)(K).controllerId;return{extId:c.$sJ.fromExtHostTestItem(K,Le).toString(),label:K.label,uri:p.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(je=>kt.namespace(Le,je.id)),range:w.$Bs.lift(v.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&R.fromStrict(K.error)||null}}Se.from=Me;function ve(K){return{parent:void 0,error:void 0,id:c.$sJ.fromString(K.extId).localId,label:K.label,uri:p.URI.revive(K.uri),tags:(K.tags||[]).map(Le=>{const{tagId:je}=kt.denamespace(Le);return new r.$_L(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:v.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Se.toPlain=ve})(Tt||(e.TestItem=Tt={})),function(Se){function Me(K){return{id:K.id}}Se.from=Me;function ve(K){return new r.$_L(K.id)}Se.to=ve}(kt||(e.TestTag=kt={}));var Qe;(function(Se){const Me=(K,Le)=>{const je=[];for(const[qe,et]of Le)c.$sJ.compare(et.item.extId,qe)===2&&(Le.delete(qe),je.push(et));const Ze={...Tt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(et=>et.type===0).map(Ut.to)})),children:je.map(qe=>Me(qe,Le))};for(const qe of Ze.children)qe.parent=Ze;return Ze};function ve(K){const Le=[],je=new Map;for(const Ze of K.items){je.set(Ze.item.extId,Ze);const qe=c.$sJ.root(Ze.item.extId);K.request.targets.some(et=>et.controllerId===qe&&et.testIds.includes(Ze.item.extId))&&Le.push(Ze)}return{completedAt:K.completedAt,results:Le.map(Ze=>Me(Ze,je))}}Se.to=ve})(Qe||(e.TestResults=Qe={}));var Jt;(function(Se){function Me(je){return{covered:je.covered,total:je.covered}}function ve(je){return"line"in je?D.from(je):v.from(je)}function K(je){return"branches"in je?{count:je.executionCount,location:ve(je.location),type:1,branches:je.branches.length?je.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ve(Ze.location)})):void 0}:{type:0,count:je.executionCount,location:ve(je.location)}}Se.fromDetailed=K;function Le(je){return{uri:je.uri,statement:Me(je.statementCoverage),branch:je.branchCoverage&&Me(je.branchCoverage),function:je.functionCoverage&&Me(je.functionCoverage),details:je.detailedCoverage?.map(K)}}Se.fromFile=Le})(Jt||(e.TestCoverage=Jt={}));var Wt;(function(Se){function Me(ve){switch(ve){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Se.to=Me})(Wt||(e.CodeActionTriggerKind=Wt={}));var ct;(function(Se){function Me(K){const Le=new r.$fM(Ee.to(K.kind),K.name,K.detail||"",p.URI.revive(K.uri),v.to(K.range),v.to(K.selectionRange));return Le._sessionId=K._sessionId,Le._itemId=K._itemId,Le}Se.to=Me;function ve(K,Le,je){if(Le=Le??K._sessionId,je=je??K._itemId,Le===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:je,kind:Ee.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:v.from(K.range),selectionRange:v.from(K.selectionRange),tags:K.tags?.map(_.from)}}Se.from=ve})(ct||(e.TypeHierarchyItem=ct={}));var ft;(function(Se){function Me(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Se.from=Me})(ft||(e.ViewBadge=ft={}));var Vt;(function(Se){function Me(je,Ze,qe){const et=Ze.fileData;return et?new r.$qL(new r.$rL(et.name,p.URI.revive(et.uri),et.id,(0,M.$cb)(()=>qe(et.id)))):je===A.$Xr.uriList&&Ze.uriListData?new r.$pL(Le(Ze.uriListData)):new r.$pL(Ze.asString)}Se.to=Me;async function ve(je,Ze){const qe=await Ze.asString();if(je===A.$Xr.uriList)return{asString:qe,fileData:void 0,uriListData:K(qe)};const et=Ze.asFile();return{asString:qe,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Se.from=ve;function K(je){return C.$$s.split(je).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return p.URI.parse(Ze)}catch{}return Ze})}function Le(je){return C.$$s.create(je.map(Ze=>typeof Ze=="string"?Ze:p.URI.revive(Ze)))}})(Vt||(e.DataTransferItem=Vt={}));var Rt;(function(Se){function Me(K,Le){const je=K.items.map(([Ze,qe])=>[Ze,Vt.to(Ze,qe,Le)]);return new r.$sL(je)}Se.toDataTransfer=Me;async function ve(K){const Le={items:[]},je=[];for(const[Ze,qe]of K)je.push((async()=>{Le.items.push([Ze,await Vt.from(Ze,qe)])})());return await Promise.all(je),Le}Se.from=ve})(Rt||(e.DataTransfer=Rt={}));var Dt;(function(Se){function Me(ve){return{kind:"reply",message:ve.message,title:ve.title,tooltip:ve.tooltip}}Se.from=Me})(Dt||(e.ChatReplyFollowup=Dt={}));var gt;(function(Se){function Me(ve){return typeof ve=="string"?{title:ve,message:ve,kind:"reply"}:"commandId"in ve?{kind:"command",title:ve.title??"",commandId:ve.commandId??"",when:ve.when??"",args:ve.args}:Dt.from(ve)}Se.from=Me})(gt||(e.ChatFollowup=gt={}));var Mt;(function(Se){function Me(K){const Le=new r.$qM(Pt.to(K.role),K.content);return Le.name=K.name,Le}Se.to=Me;function ve(K){return{role:Pt.from(K.role),content:K.content,name:K.name}}Se.from=ve})(Mt||(e.ChatMessage=Mt={}));var Pt;(function(Se){function Me(K){switch(K){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Se.to=Me;function ve(K){switch(K){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Se.from=ve})(Pt||(e.ChatMessageRole=Pt={}));var St;(function(Se){function Me(Le){const je={};for(const Ze of Object.keys(Le))je[Ze]=Le[Ze].map(Se.to);return je}Se.objectTo=Me;function ve(Le){return{level:Ve.to(Le.level),value:Le.value,description:Le.description}}Se.to=ve;function K(Le){return{level:Ve.from(Le.level),value:Le.value,description:Le.description}}Se.from=K})(St||(e.ChatVariable=St={}));var Ve;(function(Se){function Me(K){switch(K){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Se.to=Me;function ve(K){switch(K){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Se.from=ve})(Ve||(e.ChatVariableLevel=Ve={}));var Nt;(function(Se){function Me(ve){switch(ve){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Se.to=Me})(Nt||(e.InteractiveEditorResponseFeedbackKind=Nt={}));var zt;(function(Se){function Me(ve,K){return"placeholder"in K&&"resolvedContent"in K?{content:K.placeholder,kind:"asyncContent"}:"markdownContent"in K?((0,u.$OF)(ve,"chatAgents2Additions"),{content:R.from(K.markdownContent),kind:"markdownContent"}):"content"in K?"vulnerability"in K&&K.vulnerability?((0,u.$OF)(ve,"chatAgents2Additions"),{content:K.content,title:K.vulnerability.title,description:K.vulnerability.description,kind:"vulnerability"}):typeof K.content=="string"?{content:K.content,kind:"content"}:((0,u.$OF)(ve,"chatAgents2Additions"),{content:R.from(K.content),kind:"markdownContent"}):"documents"in K?{documents:K.documents.map(Le=>({uri:Le.uri,version:Le.version,ranges:Le.ranges.map(je=>v.from(je))})),kind:"usedContext"}:"reference"in K?{reference:"uri"in K.reference?{uri:K.reference.uri,range:v.from(K.reference.range)}:K.reference,kind:"reference"}:"inlineReference"in K?{inlineReference:"uri"in K.inlineReference?{uri:K.inlineReference.uri,range:v.from(K.inlineReference.range)}:K.inlineReference,name:K.title,kind:"inlineReference"}:"agentName"in K?((0,u.$OF)(ve,"chatAgents2Additions"),{agentName:K.agentName,command:K.command,kind:"agentDetection"}):"treeData"in K?{treeData:K.treeData,kind:"treeData"}:"message"in K?{content:K.message,kind:"progressMessage"}:void 0}Se.from=Me})(zt||(e.ChatResponseProgress=zt={}));var Zt;(function(Se){function Me(ve,K,Le){return"terminalCommand"in ve?{terminalCommand:ve.terminalCommand}:"uri"in ve?{uri:ve.uri}:K.toInternal(ve,Le)}Se.from=Me})(Zt||(e.TerminalQuickFix=Zt={}))}),define(Ae[219],Re([1,0,2,11,7,8,185]),function(we,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=void 0;class ${constructor(y,A,S,l={timeout:1500,errors:3}){this.c=y,this.d=A,this.f=S,this.g=l,this.a=new P.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(A,S,l)=>{const w={dispose:this.a.push([A,S,y])};return Array.isArray(l)&&l.push(w),w}}async $participateInSave(y,A){const S=E.URI.revive(y);let l=!1;const p=setTimeout(()=>l=!0,this.g.timeout),w=[];try{for(const a of[...this.a]){if(l)break;const s=this.d.getDocument(S),t=await this.h(a,{document:s,reason:M.TextDocumentSaveReason.to(A)});w.push(t)}}finally{clearTimeout(p)}return w}h([y,A,S],l){const p=this.b.get(y);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(S,y,A,l).then(()=>!0,w=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this.c.error(w),!(w instanceof Error)||w.message!=="concurrent_edits"){const a=this.b.get(y);this.b.set(y,a?a+1:1),typeof a=="number"&&a>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,A,S,l){const p=[],w=Date.now(),{document:a,reason:s}=l,{version:t}=a,n=Object.freeze({document:a,reason:s,waitUntil(o){if(Object.isFrozen(p))throw(0,T.$7)("waitUntil can not be called async");p.push(Promise.resolve(o))}});try{A.apply(S,[n])}catch(o){return Promise.reject(o)}return Object.freeze(p),new Promise((o,c)=>{const d=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all(p).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-w}ms`),clearTimeout(d),o(i)}).catch(i=>{clearTimeout(d),c(i)})}).then(o=>{const c={edits:[]};for(const d of o)if(Array.isArray(d)&&d.every(i=>i instanceof C.$IK))for(const{newText:i,newEol:r,range:u}of d)c.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:u&&M.Range.from(u),text:i,eol:r&&M.EndOfLine.from(r)}});if(c.edits.length!==0)return t===a.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$hfc=$}),define(Ae[220],Re([1,0,13,2,8,7,76]),function(we,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=e.$mfc=void 0;class ${constructor(S,l,p,w){this.start=S,this.deletedCount=l,this.deletedItems=p,this.items=w}asApiEvent(){return{range:new M.$YL(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(S,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,l,p){this.notebook=S,this.h=l,this.j=p,this.handle=p.handle,this.uri=T.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(C.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return S.g},set mime(w){S.g=w},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(p)}return this.f}setOutputs(S){this.a=S.map(C.NotebookCellOutput.to)}setOutputItems(S,l,p){const w=p.map(C.NotebookCellOutputItem.to),a=this.a.find(s=>s.id===S);if(a&&(l||(a.items.length=0),a.items.push(...w),a.items.length>1&&a.items.every(s=>P.$EI(s.mime)))){const s=new Map,t=[];a.items.forEach(n=>{let o;s.has(n.mime)?o=s.get(n.mime):(o=[],s.set(n.mime,o),t.push(n.mime)),o.push(n.data)}),a.items.length=0,t.forEach(n=>{const o=P.$FI(s.get(n));a.items.push({mime:n,data:o.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$mfc=m;class y{static{this.a=0}constructor(S,l,p,w,a){this.k=S,this.l=l,this.m=p,this.uri=w,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,l={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===E.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(p){return p=S.n(p),S.b[p].apiCell},getCells(p){return(p?S.p(p):S.b).map(a=>a.apiCell)},save(){return S.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,l,p){this.g=S.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:p});const w={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},a=[];for(const t of S.rawEvents)t.kind===P.NotebookCellsChangeType.ModelChange?this.r(t.changes,!1,w.contentChanges):t.kind===P.NotebookCellsChangeType.Move?this.s(t.index,t.length,t.newIdx,w.contentChanges):t.kind===P.NotebookCellsChangeType.Output?(this.t(t.index,t.outputs),a.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===P.NotebookCellsChangeType.OutputItem?(this.u(t.index,t.outputId,t.append,t.outputItems),a.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===P.NotebookCellsChangeType.ChangeCellLanguage?(this.v(t.index,t.language),a.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document})):t.kind===P.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document}):t.kind===P.NotebookCellsChangeType.ChangeCellMime?this.w(t.index,t.mime):t.kind===P.NotebookCellsChangeType.ChangeCellMetadata?(this.x(t.index,t.metadata),a.push({cell:this.b[t.index].apiCell,metadata:this.b[t.index].apiCell.metadata})):t.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(t.index,t.internalMetadata),a.push({cell:this.b[t.index].apiCell,executionSummary:this.b[t.index].apiCell.executionSummary}));const s=new Map;for(let t=0;t<a.length;t++){const n=a[t],o=s.get(n.cell);if(o===void 0){const c=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});s.set(n.cell,c-1)}else w.cellChanges[o]={...w.cellChanges[o],...n}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let l=S.start|0,p=S.end|0;return l<0&&(l=0),p>this.b.length&&(p=this.b.length),S.with({start:l,end:p})}p(S){S=this.o(S);const l=[];for(let p=S.start;p<S.end;p++)l.push(this.b[p]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,l,p){if(this.j)return;const w=[],a=[],s=[];if(S.reverse().forEach(t=>{const o=t[2].map(i=>{const r=new m(this,this.l,i);return l||a.push(m.asModelAddData(this.apiNotebook,i)),r}),c=new $(t[0],t[1],[],o),d=this.b.splice(t[0],t[1],...o);for(const i of d)s.push(i.uri),c.deletedItems.push(i.apiCell);w.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:s}),p)for(const t of w)p.push(t.asApiEvent())}s(S,l,p,w){const a=this.b.splice(S,l);this.b.splice(p,0,...a);const s=[new $(S,l,a.map(t=>t.apiCell),[]),new $(p,0,[],a)];for(const t of s)w.push(t.asApiEvent())}t(S,l){this.b[S].setOutputs(l)}u(S,l,p,w){this.b[S].setOutputItems(l,p,w)}v(S,l){const p=this.b[S];p.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(p.uri,l)}w(S,l){const p=this.b[S];p.apiCell.mime=l}x(S,l){this.b[S].setMetadata(l)}y(S,l){this.b[S].setInternalMetadata(l)}getCellFromApiCell(S){return this.b.find(l=>l.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(l=>l.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$nfc=y}),define(Ae[221],Re([1,0,5,2,8,7]),function(we,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=void 0;class P{constructor(m,y,A,S={timeout:1500,errors:3}){this.b=m,this.c=y,this.d=A,this.f=S,this.a=new E.$Td}dispose(){}getOnWillSaveNotebookDocumentEvent(m){return(y,A,S)=>{const l=function(w){y.call(A,w)};return l.extension=m,this.a.event(l,void 0,S)}}async $participateInSave(m,y,A){const S=T.URI.revive(m),l=this.c.getNotebookDocument(S);if(!l)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:C.TextDocumentSaveReason.to(y)},A,async(a,s)=>{const t=Date.now(),n=await await Promise.resolve(a);Date.now()-t>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!A.isCancellationRequested&&n&&(n instanceof M.$LK?p.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(p.length===0)return!0;const w={edits:[]};for(const a of p){const{edits:s}=C.WorkspaceEdit.from(a);w.edits=w.edits.concat(s)}return this.d.$tryApplyWorkspaceEdit(w)}}e.$Dfc=P}),define(Ae[106],Re([1,0,11,8,7]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor($,m,y,A,S,l){this.id=$,this.f=m,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=A,this.c=l}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(m){this.selections=[m]},get selections(){return $.a},set selections(m){if(!Array.isArray(m)||!m.every(C.$YL.isNotebookRange))throw(0,E.$6)("selections");$.a=m,$.g(m)},get visibleRanges(){return $.b},revealRange(m,y){$.f.$tryRevealRange($.id,T.NotebookRange.from(m),y??C.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(T.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$ofc=M}),define(Ae[222],Re([1,0,11,5,15,8]),function(we,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;let P=class{constructor(m,y){this.c=m,this.d=y,this.a=new T.$Rd({onListenerError:E.$1}),this.b=new T.$Rd({onListenerError:E.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,y);const A=this.d.getEditorById(m);y.visibleRanges&&A._acceptVisibleRanges(y.visibleRanges.ranges.map(M.NotebookRange.to)),y.selections&&A._acceptSelections(y.selections.selections.map(M.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const y in m)this.d.getEditorById(y)._acceptViewColumn(M.ViewColumn.to(m[y]))}};e.$Ffc=P,e.$Ffc=P=Ke([We(0,C.$fj)],P)}),define(Ae[223],Re([1,0,8,72,162,19,66,11]),function(we,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0;class m{constructor(l){this.b=0,this.c=new Map,this.a=l}async withProgress(l,p,w){const a=this.b++,{title:s,location:t,cancellable:n}=p,o={label:(0,C.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this.a.$startProgress(a,{location:E.ProgressLocation.from(t),title:s,source:o,cancellable:n},l.isUnderDevelopment?void 0:l.identifier.value).catch($.$1),this.d(a,w,!!n)}d(l,p,w){let a;w&&(a=new M.$2d,this.c.set(l,a));const s=n=>{this.a.$progressEnd(n),this.c.delete(n),a?.dispose()};let t;try{t=p(new A(this.a,l),w&&a?a.token:M.CancellationToken.None)}catch(n){throw s(l),n}return t.then(n=>s(l),n=>s(l)),t}$acceptProgressCanceled(l){const p=this.c.get(l);p&&(p.cancel(),this.c.delete(l))}}e.$Mfc=m;function y(S,l){return S.message=l.message,typeof l.increment=="number"&&(typeof S.increment=="number"?S.increment+=l.increment:S.increment=l.increment),S}class A extends T.$av{constructor(l,p){super(w=>this.throttledReport(w)),this.c=l,this.d=p}throttledReport(l){this.c.$progressReport(this.d,l)}}Ke([(0,P.$rh)(100,(S,l)=>y(S,l),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Ae[107],Re([1,0,29,103,48,77,58,8,2]),function(we,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.$OM=e.$NM=void 0;const y=(o,c,d,i)=>{let r=c;return{enumerable:!0,configurable:!1,get(){return r},set(u){if(!d(r,u)){const f=r;r=u,o.listener?.(i(u,f))}}}},A=(o,c)=>o===c,S={range:(o,c)=>o===c?!0:!o||!c?!1:o.isEqual(c),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(o,c)=>!(o.length!==c.length||o.some(d=>!c.find(i=>d.id===i.id)))},l=o=>c=>({op:4,update:o(c)}),p=(o,c)=>({range:(()=>{let d;const i=l(r=>({range:E.$Bs.lift($.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return d},set(r){o.listener?.({op:6}),S.range(d,r)||(d=r,o.listener?.(i(r)))}}})(),label:y(o,c,S.label,l(d=>({label:d}))),description:y(o,void 0,S.description,l(d=>({description:d}))),sortText:y(o,void 0,S.sortText,l(d=>({sortText:d}))),canResolveChildren:y(o,!1,S.canResolveChildren,d=>({op:2,state:d})),busy:y(o,!1,S.busy,l(d=>({busy:d}))),error:y(o,void 0,S.error,l(d=>({error:$.MarkdownString.fromStrict(d)||null}))),tags:y(o,[],S.tags,(d,i)=>({op:1,new:d.map($.TestTag.from),old:i.map($.TestTag.from)}))}),w=o=>{const c=C.$sJ.fromString(o.extId),d=new s(c.controllerId,c.localId,o.label,m.URI.revive(o.uri)||void 0);return d.range=$.Range.to(o.range||void 0),d.description=o.description||void 0,d.sortText=o.sortText||void 0,d.tags=o.tags.map(i=>$.TestTag.to({id:(0,P.$xJ)(i).tagId})),d},a=o=>{let c;for(const d of o.tests){const i=w(d.item);(0,T.$xM)(i).parent=c,c=i}return c};e.$NM=a;class s{constructor(c,d,i,r){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const u=(0,T.$wM)(this,c);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof t?void 0:u.parent}},children:{value:(0,M.$vM)(u,T.$xM,s),enumerable:!0,writable:!1},...p(u,i)})}}e.$OM=s;class t extends s{constructor(c,d){super(c,c,d,void 0),this._isRoot=!0}}e.$PM=t;class n extends M.$rM{constructor(c,d,i){super({controllerId:c,getDocumentVersion:r=>r&&i.getDocument(r)?.version,getApiFor:T.$xM,getChildren:r=>r.children,root:new t(c,d),toITestItem:$.TestItem.from})}}e.$QM=n}),define(Ae[108],Re([1,0,53,11,89,8,7]),function(we,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=e.$IM=void 0;class ${static{this.c=new C.$GM("TextEditorDecorationType")}constructor(l,p,w){const a=$.c.nextId();l.$registerTextEditorDecorationType(p.identifier,a,M.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:a,dispose(){l.$removeTextEditorDecorationType(a)}})}}e.$IM=$;class m{constructor(l,p){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,p){this.k();let w=null;if(l instanceof P.$CK)w=new P.$DK(l,l);else if(l instanceof P.$DK)w=l;else throw new Error("Unrecognized location");this.l(w,p,!1)}insert(l,p){this.k(),this.l(new P.$DK(l,l),p,!0)}delete(l){this.k();let p=null;if(l instanceof P.$DK)p=l;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(l,p,w){const a=this.c.validateRange(l);this.g.push({range:a,text:p,forceMoveMarkers:w})}setEndOfLine(l){if(this.k(),l!==P.EndOfLine.LF&&l!==P.EndOfLine.CRLF)throw(0,T.$6)("endOfLine");this.h=l}}class y{constructor(l,p,w,a){this.c=l,this.d=p,this._accept(w),this.e=a;const s=this;this.value={get tabSize(){return s.f},set tabSize(t){s.m(t)},get indentSize(){return s.g},set indentSize(t){s.o(t)},get insertSpaces(){return s.h},set insertSpaces(t){s.q(t)},get cursorStyle(){return s.j},set cursorStyle(t){s.s(t)},get lineNumbers(){return s.k},set lineNumbers(t){s.t(t)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.insertSpaces,this.j=l.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(l.lineNumbers)}l(l){if(l==="auto")return"auto";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}m(l){const p=this.l(l);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}o(l){const p=this.n(l);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(l){return l==="auto"?"auto":l==="false"?!1:!!l}q(l){const p=this.p(l);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(l){this.j!==l&&(this.j=l,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}t(l){this.k!==l&&(this.k=l,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(l)})))}assign(l){const p={};let w=!1;if(typeof l.tabSize<"u"){const a=this.l(l.tabSize);a==="auto"?(w=!0,p.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,w=!0,p.tabSize=a)}if(typeof l.indentSize<"u"){const a=this.n(l.indentSize);a==="tabSize"?(w=!0,p.indentSize=a):typeof a=="number"&&this.g!==a&&(this.g=a,w=!0,p.indentSize=a)}if(typeof l.insertSpaces<"u"){const a=this.p(l.insertSpaces);a==="auto"?(w=!0,p.insertSpaces=a):this.h!==a&&(this.h=a,w=!0,p.insertSpaces=a)}typeof l.cursorStyle<"u"&&this.j!==l.cursorStyle&&(this.j=l.cursorStyle,w=!0,p.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.k!==l.lineNumbers&&(this.k=l.lineNumbers,w=!0,p.lineNumbers=M.TextEditorLineNumbersStyle.from(l.lineNumbers)),w&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(l,p){p.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(w)})}}e.$JM=y;class A{constructor(l,p,w,a,s,t,n,o){this.id=l,this.j=p,this.k=w,this.g=!1,this.h=new Set,this.c=s,this.d=new y(this.j,this.id,t,w),this.e=n,this.f=o;const c=this;this.value=Object.freeze({get document(){return a.value},set document(d){throw new T.$8("document")},get selection(){return c.c&&c.c[0]},set selection(d){if(!(d instanceof P.$EK))throw(0,T.$6)("selection");c.c=[d],c.l()},get selections(){return c.c},set selections(d){if(!Array.isArray(d)||d.some(i=>!(i instanceof P.$EK)))throw(0,T.$6)("selections");c.c=d,c.l()},get visibleRanges(){return c.e},set visibleRanges(d){throw new T.$8("visibleRanges")},get options(){return c.d.value},set options(d){c.g||c.d.assign(d)},get viewColumn(){return c.f},set viewColumn(d){throw new T.$8("viewColumn")},edit(d,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new m(a.value,i);return d(r),c.m(r)},insertSnippet(d,i,r={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!i||Array.isArray(i)&&i.length===0)u=c.c.map(f=>M.Range.from(f));else if(i instanceof P.$CK){const{lineNumber:f,column:v}=M.Position.from(i);u=[{startLineNumber:f,startColumn:v,endLineNumber:f,endColumn:v}]}else if(i instanceof P.$DK)u=[M.Range.from(i)];else{u=[];for(const f of i)if(f instanceof P.$DK)u.push(M.Range.from(f));else{const{lineNumber:v,column:g}=M.Position.from(f);u.push({startLineNumber:v,startColumn:g,endLineNumber:v,endColumn:g})}}return p.$tryInsertSnippet(l,a.value.version,d.value,u,r)},setDecorations(d,i){const r=i.length===0;r&&!c.h.has(d.key)||(r?c.h.delete(d.key):c.h.add(d.key),c.n(()=>{if(M.$yM(i))return p.$trySetDecorations(l,d.key,M.$zM(i));{const u=new Array(4*i.length);for(let f=0,v=i.length;f<v;f++){const g=i[f];u[4*f]=g.start.line+1,u[4*f+1]=g.start.character+1,u[4*f+2]=g.end.line+1,u[4*f+3]=g.end.character+1}return p.$trySetDecorationsFast(l,d.key,u)}}))},revealRange(d,i){c.n(()=>p.$tryRevealRange(l,M.Range.from(d),i||P.TextEditorRevealType.Default))},show(d){p.$tryShowEditor(l,M.ViewColumn.from(d))},hide(){p.$tryHideEditor(l)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,E.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,E.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,E.ok)(!this.g),this.f=l}_acceptSelections(l){(0,E.ok)(!this.g),this.c=l}async l(){const l=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const p=l.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const w=p.edits.map(s=>s.range);w.sort((s,t)=>s.end.line===t.end.line?s.end.character===t.end.character?s.start.line===t.start.line?s.start.character-t.start.character:s.start.line-t.start.line:s.end.character-t.end.character:s.end.line-t.end.line);for(let s=0,t=w.length-1;s<t;s++){const n=w[s].end;if(w[s+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=p.edits.map(s=>({range:M.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,a,{setEndOfLine:typeof p.setEndOfLine=="number"?M.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$KM=A}),define(Ae[224],Re([1,0,166,25,2,5,6,204,14,7,16,18,8,52,19,131,23]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;function t(c,d){if((0,A.$Cf)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class n extends P.$Rc{constructor(d,i,r){super(),this.f=d,this.g=i,this.h=r,this.a=new Map,this.b=new a.$Q7;function u(f){return f&&f.$treeViewId&&(f.$treeItemHandle||f.$selectedTreeItems||f.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:f=>u(f)?this.r(f):Array.isArray(f)&&f.length>0?f.map(v=>u(v)?this.r(v):v):f})}registerTreeDataProvider(d,i,r){const u=this.createTreeView(d,{treeDataProvider:i},r);return{dispose:()=>u.dispose()}}createTreeView(d,i,r){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=i.dragAndDropController?.dropMimeTypes??[],f=i.dragAndDropController?.dragMimeTypes??[],v=!!i.dragAndDropController?.handleDrag,g=!!i.dragAndDropController?.handleDrop,D=this.m(d,i,r),I={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:u,dragMimeTypes:f,hasHandleDrag:v,hasHandleDrop:g,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},h=this.f.$registerTreeViewDataProvider(d,I),b={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,s.$OF)(r,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,s.$OF)(r,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(k){(0,p.$ak)(k)&&(0,s.$OF)(r,"treeViewMarkdownMessage"),D.message=k},get title(){return D.title},set title(k){D.title=k},get description(){return D.description},set description(k){D.description=k},get badge(){return D.badge},set badge(k){k!==void 0&&y.ViewBadge.isViewBadge(k)?D.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(D.badge=void 0)},reveal:(k,F)=>D.reveal(k,F),dispose:async()=>{await h,this.a.delete(d),D.dispose()}};return this.B(b),b}$getChildren(d,i){const r=this.a.get(d);return r?r.getChildren(i):Promise.reject(new $.$ME(d))}async $handleDrop(d,i,r,u,f,v,g,D){const I=this.a.get(d);if(!I)return Promise.reject(new $.$ME(d));const h=l.DataTransfer.toDataTransfer(r,async b=>(await this.f.$resolveDropFileData(d,i,b)).buffer);return g===d&&D&&await this.j(h,I,D,f,v),I.onDrop(h,u,f)}async j(d,i,r,u,f){const v=this.b.removeDragOperationTransfer(f);if(v)(await v)?.forEach((g,D)=>{g&&d.set(D,g)});else if(f&&i.handleDrag){const g=i.handleDrag(r,d,u);this.b.addDragOperationTransfer(f,g),await g}return d}async $handleDrag(d,i,r,u){const f=this.a.get(d);if(!f)return Promise.reject(new $.$ME(d));const v=await this.j(new y.$sL,f,i,u,r);if(!(!v||u.isCancellationRequested))return l.DataTransfer.from(v)}async $hasResolve(d){const i=this.a.get(d);if(!i)throw new $.$ME(d);return i.hasResolve}$resolve(d,i,r){const u=this.a.get(d);if(!u)throw new $.$ME(d);return u.resolveTreeItem(i,r)}$setExpanded(d,i,r){const u=this.a.get(d);if(!u)throw new $.$ME(d);u.setExpanded(i,r)}$setSelectionAndFocus(d,i,r){const u=this.a.get(d);if(!u)throw new $.$ME(d);u.setSelectionAndFocus(i,r)}$setVisible(d,i){const r=this.a.get(d);if(!r){if(!i)return;throw new $.$ME(d)}r.setVisible(i)}$changeCheckboxState(d,i){const r=this.a.get(d);if(!r)throw new $.$ME(d);r.setCheckboxState(i)}m(d,i,r){const u=this.B(new o(d,i,this.f,this.g.converter,this.h,r));return this.a.set(d,u),u}r(d){const i=this.a.get(d.$treeViewId);return i&&"$treeItemHandle"in d?i.getExtensionElement(d.$treeItemHandle):i&&"$focusedTreeItem"in d&&d.$focusedTreeItem?i.focusedElement:null}}e.$6fc=n;class o extends P.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(d=>this.getExtensionElement(d)).filter(d=>!(0,A.$Lf)(d))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(d,i,r,u,f,v){if(super(),this.I=d,this.J=r,this.L=u,this.M=f,this.N=v,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Rd),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Rd),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Rd),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Rd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Rd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Rd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Rd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new w.$2d,v.contributes&&v.contributes.views)for(const h in v.contributes.views)for(const b of v.contributes.views[h])b.id===d&&(this.P=b.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>this.F.fire({message:!1,element:h})));let g,D;const I=M.Event.debounce(this.F.event,(h,b)=>(h||(h={message:!1,elements:[]}),b.element!==!1&&(g||(g=new Promise(k=>D=k),this.G=this.G.then(()=>g)),Array.isArray(b.element)?h.elements.push(...b.element):h.elements.push(b.element)),b.message&&(h.message=!0),h),200,!0);this.B(I(({message:h,elements:b})=>{b.length&&(this.H=this.H.then(()=>{const k=D;return g=null,this.$(b).then(()=>k())})),h&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(d){const i=d?this.getExtensionElement(d):void 0;if(d&&!i)return this.M.error(`No tree item with id '${d}' found.`),Promise.resolve([]);let r=this.X(d);return r||(r=await this.Y(i)),r?r.map(u=>u.item):void 0}getExtensionElement(d){return this.j.get(d)}reveal(d,i){i=i||{select:!0,focus:!1};const r=(0,A.$Lf)(i.select)?!0:i.select,u=(0,A.$Lf)(i.focus)?!1:i.focus,f=(0,A.$Lf)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.G.then(()=>this.S(d)).then(v=>this.W(d,v[v.length-1]).then(g=>this.J.$reveal(this.I,{item:g.item,parentChain:v.map(D=>D.item)},{select:r,focus:u,expand:f})),v=>this.M.error(v)):this.J.$reveal(this.I,void 0,{select:r,focus:u,expand:f})}get message(){return this.O}set message(d){this.O=d,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(d){this.P=d,this.J.$setTitle(this.I,d,this.Q)}get description(){return this.Q}set description(d){this.Q=d,this.J.$setTitle(this.I,this.P,d)}get badge(){return this.R}set badge(d){this.R?.value===d?.value&&this.R?.tooltip===d?.tooltip||(this.R=l.ViewBadge.from(d),this.J.$setBadge(this.I,d))}setExpanded(d,i){const r=this.getExtensionElement(d);r&&(i?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(d,i){const r=!(0,S.$tb)(this.s,d);this.s=d;const u=this.t!==i;this.t=i,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),u&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(d){d!==this.r&&(this.r=d,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(d){const i=(await Promise.all(d.map(async r=>{const u=this.getExtensionElement(r.treeItemHandle);return u?{extensionItem:u,treeItem:await this.f.getTreeItem(u),newState:r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);i.forEach(r=>{r.treeItem.checkboxState=r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(r=>[r.extensionItem,r.newState])})}async handleDrag(d,i,r){const u=[];for(const f of d){const v=this.getExtensionElement(f);v&&u.push(v)}if(!(!this.g?.handleDrag||u.length===0))return await this.g.handleDrag(u,i,r),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(d,i,r){const u=i?this.getExtensionElement(i):void 0;if(!(!u&&i||!this.g?.handleDrop))return(0,m.$Sg)(()=>this.g?.handleDrop?this.g.handleDrop(u,d,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(d,i){if(!this.f.resolveTreeItem)return;const r=this.j.get(d);if(r){const u=this.m.get(r);if(u){const f=await this.f.resolveTreeItem(u.extensionItem,r,i)??u.extensionItem;return this.hb(f),u.item.tooltip=this.eb(f.tooltip),u.item.command=this.fb(u.disposableStore,f.command),u.item}}}S(d){return this.U(d).then(i=>i?this.S(i).then(r=>this.W(i,r[r.length-1]).then(u=>(r.push(u),r))):Promise.resolve([]))}U(d){const i=this.m.get(d);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,m.$Sg)(()=>this.f.getParent(d))}W(d,i){const r=this.m.get(d);return r?Promise.resolve(r):(0,m.$Sg)(()=>this.f.getTreeItem(d)).then(u=>this.kb(d,u,i,!0)).then(u=>this.getChildren(i?i.item.handle:void 0).then(()=>{const f=this.getExtensionElement(u);if(f){const v=this.m.get(f);if(v)return Promise.resolve(v)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.N.identifier.value}`)}))}X(d){if(d){let i;if(typeof d=="string"){const r=this.getExtensionElement(d);i=r?this.m.get(r):void 0}else i=d;return i&&i.children||void 0}return this.h}async Y(d){this.rb(d);const i=new w.$2d(this.Z.token);try{const r=d?this.m.get(d):void 0,u=await this.f.getChildren(d);if(i.token.isCancellationRequested)return;const f=await Promise.all((0,S.$Gb)(u||[]).map(async v=>{const g=await this.f.getTreeItem(v);return g&&!i.token.isCancellationRequested?this.db(v,g,r):null}));return i.token.isCancellationRequested?void 0:(0,S.$Gb)(f)}finally{i.dispose()}}$(d){if(d.some(r=>!r))return this.Z.dispose(!0),this.Z=new w.$2d,this.tb(),this.J.$refresh(this.I);{const r=this.ab(d);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(d){const i=new Set,r=d.map(f=>this.m.get(f));for(const f of r)if(f&&!i.has(f.item.handle)){let v=f;for(;v&&v.parent&&r.findIndex(g=>v&&v.parent&&g&&g.item.handle===v.parent.item.handle)===-1;){const g=this.j.get(v.parent.item.handle);v=g?this.m.get(g):void 0}v&&!v.parent&&i.add(f.item.handle)}const u=[];return i.forEach(f=>{const v=this.j.get(f);if(v){const g=this.m.get(v);g&&(!g.parent||!i.has(g.parent.item.handle))&&u.push(f)}}),u}bb(d){const i={};return Promise.all(d.map(r=>this.cb(r).then(u=>{u&&(i[r]=u.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(d){const i=this.getExtensionElement(d);if(i){const r=this.m.get(i);if(r)return this.rb(i),(0,m.$Sg)(()=>this.f.getTreeItem(i)).then(u=>{if(u){const f=this.ib(i,u,r.parent);return this.pb(i,f,r,r.parent),r.dispose(),f}return null})}return Promise.resolve(null)}db(d,i,r){const u=this.ib(d,i,r);if(i.id&&this.j.has(u.item.handle))throw new Error((0,E.localize)(0,null,i.id));return this.ob(d,u),this.qb(u,r),u}eb(d){return y.$2K.isMarkdownString(d)?l.MarkdownString.from(d):d}fb(d,i){return i?{...this.L.toInternal(i,d),originalId:i.command}:void 0}gb(d){if(d.checkboxState===void 0)return;let i,r,u;return typeof d.checkboxState=="number"?i=d.checkboxState:(i=d.checkboxState.state,r=d.checkboxState.tooltip,u=d.checkboxState.accessibilityInformation),{isChecked:i===y.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:u}}hb(d){if(!y.$nL.isTreeItem(d,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(d,i,r){this.hb(i);const u=this.B(new P.$Qc),f=this.kb(d,i,r),v=this.lb(i);return{item:{handle:f,parentHandle:r?r.item.handle:void 0,label:t(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(u,i.command),contextValue:i.contextValue,icon:v,iconDark:this.mb(i)||v,themeIcon:this.jb(i),collapsibleState:(0,A.$Lf)(i.collapsibleState)?y.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:r,children:void 0,disposableStore:u,dispose(){u.dispose()}}}jb(d){return d.iconPath instanceof y.$vL?d.iconPath:void 0}kb(d,{id:i,label:r,resourceUri:u},f,v){if(i)return`${o.b}/${i}`;const g=t(r,this.N),D=f?f.item.handle:o.a;let I=g?g.label:u?(0,T.$yg)(u):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const h=this.m.has(d)?this.m.get(d).item.handle:void 0,b=this.X(f)||[];let k,F=0;do{if(k=`${D}/${F}:${I}`,v||!this.j.has(k)||h===k)break;F++}while(F<=b.length);return k}lb(d){if(d.iconPath&&!(d.iconPath instanceof y.$vL))return typeof d.iconPath=="string"||C.URI.isUri(d.iconPath)?this.nb(d.iconPath):this.nb(d.iconPath.light)}mb(d){if(d.iconPath&&!(d.iconPath instanceof y.$vL)&&d.iconPath.dark)return this.nb(d.iconPath.dark)}nb(d){return C.URI.isUri(d)?d:C.URI.file(d)}ob(d,i){this.j.set(i.item.handle,d),this.m.set(d,i)}pb(d,i,r,u){this.j.delete(i.item.handle),this.m.delete(d),i.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(d,i);const f=this.X(u)||[],v=f.filter(g=>g.item.handle===r.item.handle)[0];v&&f.splice(f.indexOf(v),1,i)}qb(d,i){i?(i.children||(i.children=[]),i.children.push(d)):(this.h||(this.h=[]),this.h.push(d))}rb(d){if(d){const i=this.m.get(d);if(i){if(i.children)for(const r of i.children){const u=this.j.get(r.item.handle);u&&this.sb(u)}i.children=void 0}}else this.tb()}sb(d){const i=this.m.get(d);if(i){if(i.children)for(const r of i.children){const u=this.j.get(r.item.handle);u&&this.sb(u)}this.m.delete(d),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(d=>d.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[225],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[226],Re([1,0,178,11,31,96,73,30,22,225,188,100]),function(we,e,E,T,C,M,P,$,m,y,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=void 0;const l=$.$on.as(P.$pn.JSONContribution);class p{constructor(d,i,r){this.a=d,this.b=i,this.c=r}d(d,i){this.a({type:d,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(d){this.d(C.default.Error,d)}warn(d){this.d(C.default.Warning,d)}info(d){this.d(C.default.Info,d)}}e.$UF=p;class w{static a(d){const i=new m.$cm;for(let r=0,u=d.length;r<u;r++)i.add(d[r].description.identifier);return i}static compute(d,i){if(!d||!d.length)return new w(i,[]);if(!i||!i.length)return new w([],d);const r=this.a(d),u=this.a(i),f=i.filter(g=>!r.has(g.description.identifier)),v=d.filter(g=>!u.has(g.description.identifier));return new w(f,v)}constructor(d,i){this.added=d,this.removed=i}}e.$VF=w;class a{constructor(d,i){this.name=d,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(d){if(this.a!==null)throw new Error("Handler already set!");this.a=d,this.d()}acceptUsers(d){this.c=w.compute(this.b,d),this.b=d,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(d){(0,T.$Z)(d)}}}e.$WF=a;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},t="vscode://schemas/vscode-extensions";e.$XF={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$am},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:E.localize(42,null)},{label:"*",description:E.localize(43,null),body:"*"}]}},badges:{type:"array",description:E.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(45,null)},href:{type:"string",description:E.localize(46,null)},description:{type:"string",description:E.localize(47,null)}}}},markdown:{type:"string",description:E.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$6n}},extensionPack:{description:E.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$6n}},extensionKind:{description:E.localize(52,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(53,null)},{body:["workspace"],description:E.localize(54,null)},{body:["ui","workspace"],description:E.localize(55,null)},{body:["workspace","ui"],description:E.localize(56,null)},{body:[],description:E.localize(57,null)}]},capabilities:{description:E.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(61,null),E.localize(62,null),E.localize(63,null)]},description:{type:"string",markdownDescription:E.localize(64,null)}}},untrustedWorkspaces:{description:E.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(67,null),E.localize(68,null),E.localize(69,null)]},restrictedConfigurations:{description:E.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(71,null)}}}}},sponsor:{description:E.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(74,null),type:"string"},"vscode:uninstall":{description:E.localize(75,null),type:"string"}}},icon:{type:"string",description:E.localize(76,null)},l10n:{type:"string",description:E.localize(77,null)},pricing:{type:"string",markdownDescription:E.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(d){if(this.a.has(d.extensionPoint))throw new Error("Duplicate extension point: "+d.extensionPoint);const i=new a(d.extensionPoint,d.defaultExtensionKind);return this.a.set(d.extensionPoint,i),d.activationEventsGenerator&&S.$zF.register(d.extensionPoint,d.activationEventsGenerator),e.$XF.properties.contributes.properties[d.extensionPoint]=d.jsonSchema,l.registerSchema(t,e.$XF),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$YF=n;const o={ExtensionsRegistry:"ExtensionsRegistry"};$.$on.add(o.ExtensionsRegistry,new n),e.$ZF=$.$on.as(o.ExtensionsRegistry),l.registerSchema(t,e.$XF),l.registerSchema(A.$yj,{properties:{extensionEnabledApiProposals:{description:E.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(Ae[227],Re([1,0,174,16,26,226,35,5]),function(we,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9F=void 0;const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var y;(function(l){function p(w,a,s){if(!w)return;const t=T.$Cf(w.type)?w.type:void 0;if(!t||t.length===0){s.error(E.localize(3,null));return}const n=[];if(Array.isArray(w.required))for(const o of w.required)T.$Cf(o)&&n.push(o);return{extensionId:a.value,taskType:t,required:n,properties:w.properties?C.$cn(w.properties):{},when:w.when?P.$Vi.deserialize(w.when):void 0}}l.from=p})(y||(y={}));const A=M.$ZF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,p)=>{for(const w of l)w.type&&p.push(`onTaskType:${w.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:m}});class S{constructor(){this.d=new $.$Rd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,w)=>{A.setHandler((a,s)=>{this.c=void 0;try{for(const t of s.removed){const n=t.value;for(const o of n)this.a&&o.type&&this.a[o.type]&&delete this.a[o.type]}for(const t of s.added){const n=t.value;for(const o of n){const c=y.from(o,t.description.identifier,t.collector);c&&(this.a[c.taskType]=c)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const w of this.all()){const a={type:"object",additionalProperties:!1};w.required.length>0&&(a.required=w.required.slice(0)),w.properties!==void 0?a.properties=C.$cn(w.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[w.taskType]},p.push(a)}this.c={oneOf:p}}return this.c}}e.$9F=new S}),define(Ae[228],Re([1,0,175,16,25,26,35,227]),function(we,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$gG=e.JsonSchemaVersion=e.ExecutionEngine=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$aG=e.ShellQuoting=e.$_F=e.$$F=e.$0F=void 0,e.$0F="settings",e.$$F=new P.$cj("taskRunning",!1,E.localize(0,null)),e.$_F={value:E.localize(1,null),original:"Tasks"};var m;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(m||(e.ShellQuoting=m={})),e.$aG="$customized",function(L){function O(X){if(!X)return L.Strong;switch(X.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=O}(m||(e.ShellQuoting=m={}));var y;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var A;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(A||(e.RevealKind=A={})),function(L){function O(X){switch(X.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=O}(A||(e.RevealKind=A={}));var S;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(L){function O(X){switch(X.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=O}(S||(e.RevealProblemKind=S={}));var l;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(l||(e.PanelKind=l={})),function(L){function O(X){switch(X.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=O}(l||(e.PanelKind=l={}));var p;(function(L){L.defaults={echo:!0,reveal:A.Always,revealProblems:S.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var w;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(w||(e.RuntimeType=w={})),function(L){function O(he){switch(he.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=O;function X(he){switch(he){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=X}(w||(e.RuntimeType=w={}));var a;(function(L){function O(X){return T.$Cf(X)?X:X.value}L.value=O})(a||(e.CommandString=a={}));var s;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function O(he){return he===L.Clean._id||he===L.Build._id||he===L.Rebuild._id||he===L.Test._id}L.is=O;function X(he){if(he!==void 0)return T.$Cf(he)?O(he)?{_id:he,isDefault:!1}:void 0:he}L.from=X})(s||(e.TaskGroup=s={}));var t;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(t||(e.TaskScope=t={}));var n;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function O(X){switch(X){case L.User:return 2;case L.WorkspaceFile:return 5;default:return 6}}L.toConfigurationTarget=O})(n||(e.TaskSourceKind=n={}));var o;(function(L){L.parallel="parallel",L.sequence="sequence"})(o||(e.DependsOrder=o={}));var c;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var d;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(d||(e.RunOptions=d={}));class i{constructor(O,X,he,$e,De,ke){this._label="",this._id=O,X&&(this._label=X),he&&(this.type=he),this.runOptions=$e,this.configurationProperties=De,this._source=ke}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,X=!1){if(O===void 0)return!1;if(T.$Cf(O))return O===this._label||O===this.configurationProperties.identifier||X&&O===this._id;const he=this.getDefinition(!0);return he!==void 0&&he._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$bG=i;class r extends i{constructor(O,X,he,$e,De,ke,de,Ee){super(O,he,void 0,de,Ee,X),this.command={},this._source=X,this.hasDefinedMatchers=ke,De&&(this.command=De)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let X;switch(this.command?this.command.runtime:void 0){case w.Shell:X="shell";break;case w.Process:X="process";break;case w.CustomExecution:X="customExecution";break;case void 0:X="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:X,_key:this._id,id:this._id}}}static is(O){return O instanceof r}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$0F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let X=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(X+=this._source.kind);const he={type:e.$aG,folder:O,id:X};return JSON.stringify(he)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$yg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new r(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$cG=r;class u extends i{constructor(O,X,he,$e,De,ke,de){super(O,he,$e,ke,de,X),this._source=X,this.configures=De}static is(O){return O instanceof u}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$yg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$0F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let X=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(X+=this._source.kind);const he={type:e.$aG,folder:O,id:X};return JSON.stringify(he)}}e.$dG=u;class f extends i{constructor(O,X,he,$e,De,ke,de,Ee,_){super(O,he,$e,Ee,_,X),this.defines=De,this.hasDefinedMatchers=de,this.command=ke,this.icon=_.icon,this.hide=_.hide}clone(){return new f(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof f}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new f(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$eG=f;class v extends i{constructor(O,X,he,$e,De,ke){super(O,he,$e,De,ke,X),this._source=X}clone(){return new v(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof v}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new v(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$fG=v;var g;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(g||(e.ExecutionEngine=g={})),function(L){L._default=L.Terminal}(g||(e.ExecutionEngine=g={}));var D;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(D||(e.JsonSchemaVersion=D={}));class I{constructor(O){this.c=new Map;for(let X=0;X<O.length;X++)this.c.set(O[X].uri.toString(),X)}compare(O,X){const he=O.getWorkspaceFolder(),$e=X.getWorkspaceFolder();if(he&&$e){let De=this.c.get(he.uri.toString());De=De===void 0?0:De+1;let ke=this.c.get($e.uri.toString());return ke=ke===void 0?0:ke+1,De===ke?O._label.localeCompare(X._label):De-ke}else return!he&&$e?-1:he&&!$e?1:0}}e.$gG=I;var h;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(h||(e.TaskEventKind=h={}));var b;(function(L){L.SingleRun="singleRun",L.Background="background"})(b||(e.TaskRunType=b={}));var k;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var F;(function(L){function O(Ee){return{taskId:Ee._id,taskName:Ee.configurationProperties.name,runType:Ee.configurationProperties.isBackground?"background":"singleRun",group:Ee.configurationProperties.group,__task:Ee}}function X(Ee,_,Ce){return{...O(Ee),kind:"start",terminalId:_,resolvedVariables:Ce}}L.start=X;function he(Ee,_,Ce){return{...O(Ee),kind:"processStarted",terminalId:_,processId:Ce}}L.processStarted=he;function $e(Ee,_,Ce){return{...O(Ee),kind:"processEnded",terminalId:_,exitCode:Ce}}L.processEnded=$e;function De(Ee,_,Ce){return{...O(Ee),kind:"terminated",exitReason:Ce,terminalId:_}}L.terminated=De;function ke(Ee,_,Ce){return{...O(_),kind:Ee,terminalId:Ce}}L.general=ke;function de(){return{kind:"changed"}}L.changed=de})(F||(e.TaskEvent=F={}));var W;(function(L){function O(he){const $e=Object.keys(he).sort();let De="";for(const ke of $e){let de=he[ke];de instanceof Object?de=O(de):typeof de=="string"&&(de=de.replace(/,/g,",,")),De+=ke+","+de+","}return De}function X(he){const De={_key:O(he),type:he.taskType};return Object.assign(De,he),De}L.create=X})(W||(e.KeyedTaskIdentifier=W={}));var J;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection",L.VerboseLogging="task.verboseLogging"})(J||(e.TaskSettingId=J={}));var N;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(N||(e.TasksSchemaProperties=N={}));var R;(function(L){function O(X,he){const $e=$.$9F.get(X.type);if($e===void 0){const Ee=M.$cn(X);return delete Ee._key,W.create(Ee)}const De=Object.create(null);De.type=$e.taskType;const ke=new Set;$e.required.forEach(Ee=>ke.add(Ee));const de=$e.properties;for(const Ee of Object.keys(de)){const _=X[Ee];if(_!=null)De[Ee]=_;else if(ke.has(Ee)){const Ce=de[Ee];if(Ce.default!==void 0)De[Ee]=M.$cn(Ce.default);else switch(Ce.type){case"boolean":De[Ee]=!1;break;case"number":case"integer":De[Ee]=0;break;case"string":De[Ee]="";break;default:he.error(E.localize(2,null,JSON.stringify(X,void 0,0),Ee));return}}}return W.create(De)}L.createTaskIdentifier=O})(R||(e.TaskDefinition=R={}))}),define(Ae[229],Re([1,0,11]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l6b=e.$k6b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((P,$)=>{this.b=P,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(P){this.f||this.h||(this.f=!0,this.g=P,this.a&&this.b(P))}resolveErr(P){this.f||this.h||(this.h=!0,this.i=P,this.a?this.d(P):(0,E.$Z)(P))}then(P,$){return this.j().then(P,$)}catch(P){return this.j().then(void 0,P)}finally(P){return this.j().finally(P)}}e.$k6b=T;class C extends T{constructor(){super(),this.h=!0,this.i=new E.$4}}e.$l6b=C}),define(Ae[49],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yv=e.$xv=e.$wv=e.$vv=void 0;class E{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++E.count}}e.$vv=E;const T=[];function C($){const m=new E($);return T[m.nid]=m,m}e.$wv=C;function M($){return T[$].sid}e.$xv=M;class P{constructor(m){this.value=m}}e.$yv=P}),define(Ae[3],Re([1,0,49]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AK=e.$zK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$yK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var C;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput"})(C||(e.TabInputKind=C={}));var M;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var P;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(P||(e.WebviewEditorCapabilities=P={}));var $;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var m;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var y;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var A;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class S{static{this.a=0}static mixin(s){return s._id=S.a++,s}}e.$yK=S;var l;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var p;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var w;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(w||(e.ExtHostTestingResource=w={})),e.$zK={MainThreadAuthentication:(0,E.$wv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$wv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$wv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,E.$wv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$wv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$wv)("MainThreadClipboard"),MainThreadCommands:(0,E.$wv)("MainThreadCommands"),MainThreadComments:(0,E.$wv)("MainThreadComments"),MainThreadConfiguration:(0,E.$wv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$wv)("MainThreadConsole"),MainThreadDebugService:(0,E.$wv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$wv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$wv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$wv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$wv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$wv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$wv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$wv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$wv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$wv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$wv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$wv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$wv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$wv)("MainThreadLanguages"),MainThreadLogger:(0,E.$wv)("MainThreadLogger"),MainThreadMessageService:(0,E.$wv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$wv)("MainThreadOutputService"),MainThreadProgress:(0,E.$wv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$wv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$wv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$wv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$wv)("MainThreadSecretState"),MainThreadStorage:(0,E.$wv)("MainThreadStorage"),MainThreadSpeech:(0,E.$wv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$wv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$wv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$wv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$wv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$wv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$wv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$wv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$wv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$wv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$wv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$wv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$wv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$wv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$wv)("MainThreadSCM"),MainThreadSearch:(0,E.$wv)("MainThreadSearch"),MainThreadShare:(0,E.$wv)("MainThreadShare"),MainThreadTask:(0,E.$wv)("MainThreadTask"),MainThreadWindow:(0,E.$wv)("MainThreadWindow"),MainThreadLabelService:(0,E.$wv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$wv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$wv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$wv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$wv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$wv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$wv)("MainThreadInteractive"),MainThreadChat:(0,E.$wv)("MainThreadChat"),MainThreadInlineChat:(0,E.$wv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$wv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$wv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$wv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$wv)("MainThreadTimeline"),MainThreadTesting:(0,E.$wv)("MainThreadTesting"),MainThreadLocalization:(0,E.$wv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$wv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$wv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$wv)("MainThreadIssueReporter")},e.$AK={ExtHostCommands:(0,E.$wv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$wv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$wv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$wv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$wv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$wv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$wv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$wv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$wv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$wv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$wv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$wv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$wv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$wv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$wv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$wv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$wv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$wv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$wv)("ExtHostStatusBar"),ExtHostShare:(0,E.$wv)("ExtHostShare"),ExtHostExtensionService:(0,E.$wv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$wv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$wv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$wv)("ExtHostSCM"),ExtHostSearch:(0,E.$wv)("ExtHostSearch"),ExtHostTask:(0,E.$wv)("ExtHostTask"),ExtHostWorkspace:(0,E.$wv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$wv)("ExtHostWindow"),ExtHostWebviews:(0,E.$wv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$wv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$wv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$wv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$wv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$wv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$wv)("ExtHostProgress"),ExtHostComments:(0,E.$wv)("ExtHostComments"),ExtHostSecretState:(0,E.$wv)("ExtHostSecretState"),ExtHostStorage:(0,E.$wv)("ExtHostStorage"),ExtHostUrls:(0,E.$wv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$wv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$wv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$wv)("ExtHostOutputService"),ExtHosLabelService:(0,E.$wv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$wv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$wv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$wv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$wv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$wv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$wv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$wv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$wv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$wv)("ExtHostChat"),ExtHostChatAgents2:(0,E.$wv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$wv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$wv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$wv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$wv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$wv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$wv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$wv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$wv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$wv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$wv)("ExtHostTimeline"),ExtHostTesting:(0,E.$wv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$wv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$wv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$wv)("ExtHostIssueReporter")}}),define(Ae[230],Re([1,0,3,7]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;class C{constructor(P){this.a=new Map,this.b=0,this.c=P.getProxy(E.$zK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(P,$,m){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(P);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation($,m)??[]}getRelatedInformation(P,$,m){return this.c.$getAiRelatedInformation($,m)}registerRelatedInformationProvider(P,$,m){const y=this.b;return this.b++,this.a.set(y,m),this.c.$registerAiRelatedInformationProvider(y,$),new T.$BK(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$6dc=C}),define(Ae[81],Re([1,0,4,15,3,17]),function(we,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=e.$aec=e.$_dc=void 0,e.$_dc=(0,E.$Xh)("IExtHostApiDeprecationService");let P=class{constructor(m,y){this.c=y,this.a=new Set,this.b=m.getProxy(C.$zK.MainThreadTelemetry)}report(m,y,A){const S=this.d(m,y);this.a.has(S)||(this.a.add(S),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:m}))}d(m,y){return`${m}-${y.identifier.value}`}};e.$aec=P,e.$aec=P=Ke([We(0,M.$BM),We(1,T.$fj)],P),e.$bec=Object.freeze(new class{report($,m,y){}})}),define(Ae[231],Re([1,0,5,3,7,22]),function(we,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;class P{constructor(y){this.b=new Map,this.c=[],this.d=new E.$Rd,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=y.getProxy(T.$zK.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,A,S,l={}){const p=M.$bm.toKey(y.identifier),w=[...S].sort().join(" ");return await this.f.getOrCreate(`${p} ${A} ${w}`,async()=>{await this.a.$ensureProvider(A);const a=y.displayName||y.name;return this.a.$getSession(A,S,p,a,l)})}async getSessions(y,A,S){const l=M.$bm.toKey(y.identifier),p=[...S].sort().join(" ");return await this.g.getOrCreate(`${l} ${p}`,async()=>{await this.a.$ensureProvider(A);const w=y.displayName||y.name;return this.a.$getSessions(A,S,l,w)})}async removeSession(y,A){const S=this.b.get(y);return S?S.provider.removeSession(A):this.a.$removeSession(y,A)}registerAuthenticationProvider(y,A,S,l){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:A,provider:S,options:l??{supportsMultipleAccounts:!1}}),this.c.find(w=>w.id===y)||this.c.push({id:y,label:A});const p=S.onDidChangeSessions(w=>{this.a.$sendDidChangeSessions(y,{added:w.added??[],changed:w.changed??[],removed:w.removed??[]})});return this.a.$registerAuthenticationProvider(y,A,l?.supportsMultipleAccounts??!1),new C.$BK(()=>{p.dispose(),this.b.delete(y);const w=this.c.findIndex(a=>a.id===y);w>-1&&this.c.splice(w),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,A,S){const l=this.b.get(y);if(l)return Promise.resolve(l.provider.createSession(A,S));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,A){const S=this.b.get(y);if(S)return Promise.resolve(S.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,A){const S=this.b.get(y);if(S)return Promise.resolve(S.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,A){return this.d.fire({provider:{id:y,label:A}}),Promise.resolve()}}e.$eec=P;class ${constructor(){this.a=new Map}getOrCreate(y,A){const S=this.a.get(y);if(S)return S;const l=A().finally(()=>this.a.delete(y));return this.a.set(y,l),l}}}),define(Ae[232],Re([1,0,3,17,8]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=void 0;let M=class{constructor($,m){this.a=$.getProxy(E.$zK.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>m.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,m,y){const A=C.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,y?.isRefactoring??!1)}};e.$fec=M,e.$fec=M=Ke([We(0,T.$BM)],M)}),define(Ae[233],Re([1,0,5,67,6,3,8]),function(we,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0;class ${static{this.a=0}constructor(A,S){this.extension=A,this.provider=S,this.handle=$.a++}}class m{static{this.a=0}constructor(A){this.b=new Map,this.c=new Map,this.d=new E.$Rd,this.onDidPerformUserAction=this.d.event,this.e=A.getProxy(M.$zK.MainThreadChat)}registerChatProvider(A,S,l){const p=new $(A,l);return this.b.set(p.handle,p),this.e.$registerChatProvider(p.handle,S),(0,C.$Pc)(()=>{this.e.$unregisterChatProvider(p.handle),this.b.delete(p.handle)})}transferChatSession(A,S){const l=T.Iterable.find(this.c.keys(),p=>this.c.get(p)===A)??0;typeof l=="number"&&this.e.$transferChatSession(l,S)}sendInteractiveRequestToProvider(A,S){this.e.$sendRequestToProvider(A,S)}async $prepareChat(A,S){const l=this.b.get(A);if(!l)return;const p=await l.provider.prepareSession(S);if(!p)return;const w=m.a++;return this.c.set(w,p),{id:w,requesterUsername:p.requester?.name,requesterAvatarIconUri:p.requester?.icon,responderUsername:p.responder?.name,responderAvatarIconUri:p.responder?.icon,inputPlaceholder:p.inputPlaceholder}}async $provideWelcomeMessage(A,S){const l=this.b.get(A);if(!l||!l.provider.provideWelcomeMessage)return;const p=await l.provider.provideWelcomeMessage(S);if(p)return p.map(w=>typeof w=="string"?w:Array.isArray(w)?w.map(a=>P.ChatReplyFollowup.from(a)):P.MarkdownString.from(w))}async $provideSampleQuestions(A,S){const l=this.b.get(A);if(!l||!l.provider.provideSampleQuestions)return;const p=await l.provider.provideSampleQuestions(S);if(p)return p?.map(w=>P.ChatReplyFollowup.from(w))}$releaseSession(A){this.c.delete(A)}async $onDidPerformUserAction(A){this.d.fire(A)}}e.$gec=m}),define(Ae[234],Re([1,0,14,19,39,5,60,16,2,156,72,3,8,7,205,23]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;class s{static{this.a=0}constructor(o,c,d){this.i=c,this.j=d,this.b=new Map,this.g=new Map,this.h=new Map,this.d=o.getProxy(S.$zK.MainThreadChatAgents2)}createChatAgent(o,c,d){const i=s.a++,r=new t(o,c,this.d,i,d);return this.b.set(i,r),this.d.$registerAgent(i,c,{}),r.apiAgent}async $invokeAgent(o,c,d,i,r,u){this.g.delete(c);const f=this.b.get(o);if(!f)throw new Error(`[CHAT](${o}) CANNOT invoke agent because the agent is not registered`);let v=!1;function g(){if(v)throw new Error("Only valid while executing the command")}const D=new E.$kh;u.onCancellationRequested(()=>D.complete()),setTimeout(()=>D.complete(),10*1e3),this.i.allowListExtensionWhile(f.extension.identifier,D.p);const I=i.command?await f.validateSlashCommand(i.command):void 0,h=P.$Nd.create(!1);let b;try{const k=f.invoke({prompt:i.message,variables:l.ChatVariable.objectTo(i.variables),slashCommand:I},{history:r.history.map(l.ChatMessage.to)},new A.$av(F=>{g(),typeof b>"u"&&"content"in F&&(b=h.elapsed());const W=l.ChatResponseProgress.from(f.extension,F);if(!W){this.j.error("Unknown progress type: "+JSON.stringify(F));return}if("placeholder"in F&&"resolvedContent"in F){const J=Promise.all([this.d.$handleProgressChunk(d,W),F.resolvedContent]);(0,E.$Og)(J,u).then(N=>{if(!N)return;const[R,L]=N,O=l.ChatResponseProgress.from(f.extension,L);if(!O){this.j.error("Unknown progress type: "+JSON.stringify(L));return}this.d.$handleProgressChunk(d,O,R??void 0)})}else this.d.$handleProgressChunk(d,W)}),u);return await(0,E.$Og)(Promise.resolve(k).then(F=>{if(F){this.g.set(c,F);let W=this.h.get(c);W||(W=new Map,this.h.set(c,W)),W.set(d,F);const J={firstProgress:b,totalElapsed:h.elapsed()};return{errorDetails:F.errorDetails,timings:J}}else this.g.delete(c)}),u)}catch(k){return this.j.error(k,f.extension),{errorDetails:{message:(0,y.localize)(0,null,(0,C.$Ii)(k)),responseIsIncomplete:!0}}}finally{v=!0,D.complete()}}$releaseSession(o){this.g.delete(o),this.h.delete(o)}async $provideSlashCommands(o,c){const d=this.b.get(o);return d?d.provideSlashCommand(c):[]}$provideFollowups(o,c,d){const i=this.b.get(o);if(!i)return Promise.resolve([]);const r=this.g.get(c);return r?i.provideFollowups(r,d):Promise.resolve([])}$acceptFeedback(o,c,d,i,r){const u=this.b.get(o);if(!u)return;const f=this.h.get(c)?.get(d);if(!f)return;let v;switch(i){case w.InteractiveSessionVoteDirection.Down:v=p.ChatAgentResultFeedbackKind.Unhelpful;break;case w.InteractiveSessionVoteDirection.Up:v=p.ChatAgentResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(r?{result:f,kind:v,reportIssue:r}:{result:f,kind:v}))}$acceptAction(o,c,d,i){const r=this.b.get(o);if(!r)return;const u=this.h.get(c)?.get(d);u&&i.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:i.action,result:u}))}}e.$iec=s;class t{constructor(o,c,d,i,r){this.extension=o,this.s=c,this.t=d,this.u=i,this.w=r,this.o=new M.$Rd,this.q=new M.$Rd}acceptFeedback(o){this.o.fire(o)}acceptAction(o){this.q.fire(o)}async validateSlashCommand(o){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,$.$Mf)(this.b));const c=this.b.find(d=>d.name===o);if(!c)throw new Error(`Unknown slashCommand: ${o}`);return c}async provideSlashCommand(o){if(!this.a)return[];const c=await this.a.provideSlashCommands(o);return c?(this.b=c,c.map(d=>({name:d.name,description:d.description,followupPlaceholder:d.followupPlaceholder,shouldRepopulate:d.shouldRepopulate,sampleRequest:d.sampleRequest}))):[]}async provideFollowups(o,c){if(!this.d)return[];const d=await this.d.provideFollowups(o,c);return d?d.map(i=>l.ChatFollowup.from(i)):[]}get apiAgent(){let o=!1,c=!1;const d=()=>{o||c||(c=!0,queueMicrotask(()=>{this.t.$updateAgent(this.u,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof m.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof p.$vL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),c=!1}))},i=this;return{get name(){return i.s},get description(){return i.g??""},set description(r){i.g=r,d()},get fullName(){return i.h??i.extension.displayName??i.extension.name},set fullName(r){i.h=r,d()},get iconPath(){return i.i},set iconPath(r){i.i=r,d()},get slashCommandProvider(){return i.a},set slashCommandProvider(r){i.a=r,d()},get followupProvider(){return i.d},set followupProvider(r){i.d=r,d()},get isDefault(){return(0,a.$OF)(i.extension,"defaultChatAgent"),i.j},set isDefault(r){(0,a.$OF)(i.extension,"defaultChatAgent"),i.j=r,d()},get helpTextPrefix(){return(0,a.$OF)(i.extension,"defaultChatAgent"),i.k},set helpTextPrefix(r){if((0,a.$OF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPrefix is only available on the default chat agent");i.k=r,d()},get helpTextPostfix(){return(0,a.$OF)(i.extension,"defaultChatAgent"),i.l},set helpTextPostfix(r){if((0,a.$OF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPostfix is only available on the default chat agent");i.l=r,d()},get isSecondary(){return(0,a.$OF)(i.extension,"defaultChatAgent"),i.n},set isSecondary(r){(0,a.$OF)(i.extension,"defaultChatAgent"),i.n=r,d()},get sampleRequest(){return i.m},set sampleRequest(r){i.m=r,d()},get supportIssueReporting(){return(0,a.$OF)(i.extension,"chatAgents2Additions"),i.r},set supportIssueReporting(r){(0,a.$OF)(i.extension,"chatAgents2Additions"),i.r=r,d()},get onDidReceiveFeedback(){return i.o.event},onDidPerformAction:(0,a.$NF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){o=!0,i.a=void 0,i.d=void 0,i.o.dispose(),i.t.$unregisterAgent(i.u)}}}invoke(o,c,d,i){return this.w(o,c,d,i)}}}),define(Ae[235],Re([1,0,19,6,3,8,72,22,14,5]),function(we,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;class A{constructor(w,a){this.stream=new m.$oh,this.stream=a??new m.$oh;const s=this;this.apiObj={option:w,response:s.stream.asyncIterable}}}class S{constructor(w,a){this.a=new y.$Rd,this.b=new Map,this.c=new m.$oh,this.d=!1;const s=this;this.apiObject={result:w,response:s.c.asyncIterable,onDidStartResponseStream:s.a.event,cancel(){a.cancel()}},w.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,t]of this.b)t.stream.resolve();else this.c.resolve()})}handleFragment(w){if(this.d)return;let a=this.b.get(w.index);a||(this.b.size===0?a=new A(w.index,this.c):a=new A(w.index),this.b.set(w.index,a),this.a.fire(a.apiObj)),a.stream.emitOne(w.part)}}class l{static{this.a=1}constructor(w,a){this.d=a,this.c=new Map,this.e=new Map,this.f=new $.$dm,this.b=w.getProxy(C.$zK.MainThreadChatProvider)}registerProvider(w,a,s,t){const n=l.a++;return this.c.set(n,{extension:w,provider:s}),this.b.$registerProvider(n,a,{extension:w,displayName:t.name??w.value}),(0,T.$Pc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(w,a,s,t,n){const o=this.c.get(w);if(!o)return;const c=new P.$av(async d=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${o.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(a,{index:d.index,part:d.part})});return o.provider.provideChatResponse(s.map(M.ChatMessage.to),t,c,n)}allowListExtensionWhile(w,a){this.f.set(w,a),a.finally(()=>this.f.delete(w))}async requestChatResponseProvider(w,a){if(!this.f.has(w))throw new Error("Extension is NOT allowed to make chat requests");const s=this;return{get isRevoked(){return!s.f.has(w)},makeRequest(t,n,o){if(!s.f.has(w))throw new Error("Access to chat has been revoked");const c=new E.$2d(o),d=Math.random()*1e6|0,i=s.b.$fetchResponse(w,a,d,t.map(M.ChatMessage.from),n??{},c.token),r=new S(i,c);return s.e.set(d,{res:r}),i.finally(()=>{s.e.delete(d)}),r.apiObject}}}async $handleResponseFragment(w,a){const s=this.e.get(w);s&&s.res.handleFragment(a)}}e.$hec=l}),define(Ae[236],Re([1,0,6,3,11,8]),function(we,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class P{static{this.a=0}constructor(m){this.b=new Map,this.c=m.getProxy(T.$zK.MainThreadChatVariables)}async $resolveVariable(m,y,A){const S=this.b.get(m);if(S)try{const l=await S.resolver.resolve(S.data.name,{message:y},A);if(l)return l.map(M.ChatVariable.from)}catch(l){(0,C.$1)(l)}}registerVariableResolver(m,y,A,S){const l=P.a++;return this.b.set(l,{extension:m.identifier,data:{name:y,description:A},resolver:S}),this.c.$registerVariable(l,{name:y,description:A}),(0,E.$Pc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$jec=P}),define(Ae[237],Re([1,0,3]),function(we,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0;class T{constructor(M){const P=M.getProxy(E.$zK.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText($){return P.$writeText($)}})}}e.$kec=T}),define(Ae[32],Re([1,0,16,7,8,26,3,18,15,51,29,130,2,6,4,17,107,24,49,39,60,56,59,33]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a,s,t,n,o,c,d,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=void 0;let u=class{#e;#t;#i;constructor(h,b,k){this.b=new Map,this.c=new Map,this.#e=h.getProxy(P.$zK.MainThreadCommands),this.d=b,this.#i=k,this.#t=h.getProxy(P.$zK.MainThreadTelemetry),this.converter=new f(this,F=>{const W=this.c.get(F);return W?.result===g.Void?W:void 0},b),this.f=[{processArgument(F){return(0,y.$uh)(F)}},{processArgument(F){return(0,M.$en)(F,function(W){if(A.$Bs.isIRange(W))return C.Range.to(W);if(S.$As.isIPosition(W))return C.Position.to(W);if(A.$Bs.isIRange(W.range)&&l.URI.isUri(W.uri))return C.location.to(W);if(W instanceof t.$fe)return W.buffer.buffer;if(!Array.isArray(W))return W})}}]}registerArgumentProcessor(h){this.f.push(h)}registerApiCommand(h){const b=this.registerCommand(!1,h.id,async(...k)=>{const F=h.args.map((J,N)=>{if(!J.validate(k[N]))throw new Error(`Invalid argument '${J.name}' when running '${h.id}', received: ${typeof k[N]=="object"?JSON.stringify(k[N],null,"	"):k[N]} `);return J.convert(k[N])}),W=await this.executeCommand(h.internalId,...F);return h.result.convert(W,k,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this.c.set(h.id,h),new T.$BK(()=>{b.dispose(),this.c.delete(h.id)})}registerCommand(h,b,k,F,W,J){if(this.d.trace("ExtHostCommands#registerCommand",b),!b.trim().length)throw new Error("invalid id");if(this.b.has(b))throw new Error(`command '${b}' already exists`);return this.b.set(b,{callback:k,thisArg:F,metadata:W,extension:J}),h&&this.#e.$registerCommand(b),new T.$BK(()=>{this.b.delete(b)&&h&&this.#e.$unregisterCommand(b)})}executeCommand(h,...b){return this.d.trace("ExtHostCommands#executeCommand",h),this.g(h,b,!0)}async g(h,b,k){if(this.b.has(h))return this.#e.$fireCommandActivationEvent(h),this.h(h,b,!1);{let F=!1;const W=(0,M.$en)(b,function(J){if(J instanceof T.$CK)return C.Position.from(J);if(J instanceof T.$DK)return C.Range.from(J);if(J instanceof T.$NK)return C.location.from(J);if(T.$YL.isNotebookRange(J))return C.NotebookRange.from(J);if(J instanceof ArrayBuffer)return F=!0,t.$fe.wrap(new Uint8Array(J));if(J instanceof Uint8Array)return F=!0,t.$fe.wrap(J);if(J instanceof t.$fe)return F=!0,J;if(!Array.isArray(J))return J});try{const J=await this.#e.$executeCommand(h,F?new n.$yv(W):W,k);return(0,y.$uh)(J)}catch(J){if(J instanceof Error&&J.message==="$executeCommand:retry")return this.g(h,b,!1);throw J}}}async h(h,b,k){const F=this.b.get(h);if(!F)throw new Error("Unknown command");const{callback:W,thisArg:J,metadata:N}=F;if(N?.args)for(let L=0;L<N.args.length;L++)try{(0,E.$Tf)(b[L],N.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${N.args[L].name}' - ${N.args[L].description}`)}const R=c.$Nd.create();try{return await W.apply(J,b)}catch(L){if(h===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...b);O&&(h=O.command)}if(this.d.error(L,h,F.extension?.identifier),!k)throw L;if(F.extension?.identifier){const O=this.#i.onExtensionError(F.extension.identifier,L);this.d.trace("forwarded error to extension?",O,F.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.$Ii)(L)),this.id=h,this.source=F.extension?.displayName??F.extension?.name}}}finally{this.j(F,h,R.elapsed())}}j(h,b,k){h.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:h.extension.identifier.value,id:new d.$ro(b),duration:k})}$executeContributedCommand(h,...b){this.d.trace("ExtHostCommands#$executeContributedCommand",h);const k=this.b.get(h);return k?(b=b.map(F=>this.f.reduce((W,J)=>J.processArgument(W,k.extension?.identifier),F)),this.h(h,b,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this.d.trace("ExtHostCommands#getCommands",h),this.#e.$getCommands().then(b=>(h&&(b=b.filter(k=>k[0]!=="_")),b))}$getContributedCommandMetadata(){const h=Object.create(null);for(const[b,k]of this.b){const{metadata:F}=k;F&&(h[b]=F)}return Promise.resolve(h)}};e.$WM=u,e.$WM=u=Ke([We(0,a.$BM),We(1,m.$fj),We(2,i.$VM)],u),e.$XM=(0,w.$Xh)("IExtHostCommands");class f{constructor(h,b,k){this.d=h,this.f=b,this.g=k,this.delegatingCommandId=`__vsc${(0,r.$kg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(h,b){if(!h)return;const k={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return k;const F=this.f(h.command);if(F)k.id=F.internalId,k.arguments=F.args.map((W,J)=>W.convert(h.arguments&&h.arguments[J]));else if((0,$.$Kb)(h.arguments)){const W=`${h.command} /${++this.c}`;this.b.set(W,h),b.add((0,p.$Pc)(()=>{this.b.delete(W),this.g.trace("CommandsConverter#DISPOSE",W)})),k.$ident=W,k.id=this.delegatingCommandId,k.arguments=[W],this.g.trace("CommandsConverter#CREATE",h.command,W)}return k}fromInternal(h){return typeof h.$ident=="string"?this.b.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this.b.get(h[0])}h(...h){const b=this.getActualCommand(...h);return this.g.trace("CommandsConverter#EXECUTE",h[0],b?b.command:"MISSING"),b?this.d.executeCommand(b.command,...b.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${h[0]}`)}}e.$YM=f;class v{static{this.Uri=new v("uri","Uri of a text document",h=>l.URI.isUri(h),h=>h)}static{this.Position=new v("position","A position in a text document",h=>T.$CK.isPosition(h),C.Position.from)}static{this.Range=new v("range","A range in a text document",h=>T.$DK.isRange(h),C.Range.from)}static{this.Selection=new v("selection","A selection in a text document",h=>T.$EK.isSelection(h),C.Selection.from)}static{this.Number=new v("number","",h=>typeof h=="number",h=>h)}static{this.String=new v("string","",h=>typeof h=="string",h=>h)}static{this.StringArray=v.Arr(v.String)}static Arr(h){return new v(`${h.name}_array`,`Array of ${h.name}, ${h.description}`,b=>Array.isArray(b)&&b.every(k=>h.validate(k)),b=>b.map(k=>h.convert(k)))}static{this.CallHierarchyItem=new v("item","A call hierarchy item",h=>h instanceof T.$XK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new v("item","A type hierarchy item",h=>h instanceof T.$fM,C.TypeHierarchyItem.from)}static{this.TestItem=new v("testItem","A VS Code TestItem",h=>h instanceof s.$OM,C.TestItem.from)}constructor(h,b,k,F){this.name=h,this.description=b,this.validate=k,this.convert=F}optional(){return new v(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,b){return new v(h??this.name,b??this.description,this.validate,this.convert)}}e.$ZM=v;class g{static{this.Void=new g("no result",h=>h)}constructor(h,b){this.description=h,this.convert=b}}e.$1M=g;class D{constructor(h,b,k,F,W){this.id=h,this.internalId=b,this.description=k,this.args=F,this.result=W}}e.$2M=D}),define(Ae[238],Re([1,0,18,13,2,80,95,35,32,8,7]),function(we,e,E,T,C,M,P,$,m,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;const S=[new m.$2M("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$ZM.Uri,m.$ZM.Position],new m.$1M("A promise that resolves to an array of DocumentHighlight-instances.",p(y.DocumentHighlight.to))),new m.$2M("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$ZM.Uri],new m.$1M("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,s)=>{if((0,E.$Jb)(a))return;class t extends A.$SK{static to(o){const c=new t(o.name,y.SymbolKind.to(o.kind),o.containerName||"",new A.$NK(s[0],y.Range.to(o.range)));return c.detail=o.detail,c.range=c.location.range,c.selectionRange=y.Range.to(o.selectionRange),c.children=o.children?o.children.map(t.to):[],c}}return a.map(t.to)})),new m.$2M("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$ZM.Uri,new m.$ZM("options","Formatting options",a=>!0,a=>a)],new m.$1M("A promise that resolves to an array of TextEdits.",p(y.TextEdit.to))),new m.$2M("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$ZM.Uri,m.$ZM.Range,new m.$ZM("options","Formatting options",a=>!0,a=>a)],new m.$1M("A promise that resolves to an array of TextEdits.",p(y.TextEdit.to))),new m.$2M("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$ZM.Uri,m.$ZM.Position,new m.$ZM("ch","Trigger character",a=>typeof a=="string",a=>a),new m.$ZM("options","Formatting options",a=>!0,a=>a)],new m.$1M("A promise that resolves to an array of TextEdits.",p(y.TextEdit.to))),new m.$2M("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$ZM.Uri,m.$ZM.Position],new m.$1M("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$2M("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$ZM.Uri,m.$ZM.Position],new m.$1M("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$2M("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$ZM.Uri,m.$ZM.Position],new m.$1M("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$2M("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$ZM.Uri,m.$ZM.Position],new m.$1M("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$2M("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$ZM.Uri,m.$ZM.Position],new m.$1M("A promise that resolves to an array of Location-instances.",p(y.location.to))),new m.$2M("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$ZM.Uri,m.$ZM.Position],new m.$1M("A promise that resolves to an array of Hover-instances.",p(y.Hover.to))),new m.$2M("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$ZM.Uri,new m.$ZM("position","A position in a text document",a=>Array.isArray(a)&&a.every(s=>A.$CK.isPosition(s)),a=>a.map(y.Position.from))],new m.$1M("A promise that resolves to an array of ranges.",a=>a.map(s=>{let t;for(const n of s.reverse())t=new A.$WK(y.Range.to(n),t);return t}))),new m.$2M("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$ZM.String.with("query","Search string")],new m.$1M("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(y.WorkspaceSymbol.to))),new m.$2M("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$ZM.Uri,m.$ZM.Position],new m.$1M("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(y.CallHierarchyItem.to))),new m.$2M("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$ZM.CallHierarchyItem],new m.$1M("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(y.CallHierarchyIncomingCall.to))),new m.$2M("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$ZM.CallHierarchyItem],new m.$1M("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(y.CallHierarchyOutgoingCall.to))),new m.$2M("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$ZM.Uri,m.$ZM.Position],new m.$1M("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:y.Range.to(a.range),placeholder:a.text}})),new m.$2M("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$ZM.Uri,m.$ZM.Position,m.$ZM.String.with("newName","The new symbol name")],new m.$1M("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return y.WorkspaceEdit.to(a)}})),new m.$2M("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$ZM.Uri,m.$ZM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$1M("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(y.DocumentLink.to))),new m.$2M("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$ZM.Uri],new m.$1M("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.$QL(a.tokenTypes,a.tokenModifiers)})),new m.$2M("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$ZM.Uri],new m.$1M("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const s=(0,P.$10)(a);if(s.type==="full")return new A.$SL(s.data,void 0)})),new m.$2M("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$ZM.Uri,m.$ZM.Range.optional()],new m.$1M("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.$QL(a.tokenTypes,a.tokenModifiers)})),new m.$2M("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$ZM.Uri,m.$ZM.Range],new m.$1M("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const s=(0,P.$10)(a);if(s.type==="full")return new A.$SL(s.data,void 0)})),new m.$2M("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$ZM.Uri,m.$ZM.Position,m.$ZM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$ZM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$1M("A promise that resolves to a CompletionList-instance.",(a,s,t)=>{if(!a)return new A.$9K([]);const n=a.suggestions.map(o=>y.CompletionItem.to(o,t));return new A.$9K(n,a.incomplete)})),new m.$2M("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$ZM.Uri,m.$ZM.Position,m.$ZM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$1M("A promise that resolves to SignatureHelp.",a=>{if(a)return y.SignatureHelp.to(a)})),new m.$2M("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$ZM.Uri,m.$ZM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$1M("A promise that resolves to an array of CodeLens-instances.",(a,s,t)=>p(n=>new A.$1K(y.Range.to(n.range),n.command&&t.fromInternal(n.command)))(a))),new m.$2M("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$ZM.Uri,new m.$ZM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>A.$DK.isRange(a),a=>A.$EK.isSelection(a)?y.Selection.from(a):y.Range.from(a)),m.$ZM.String.with("kind","Code action kind to return code actions for").optional(),m.$ZM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$1M("A promise that resolves to an array of Command-instances.",(a,s,t)=>p(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return t.fromInternal(n.command)}else{const o=new A.$UK(n.title,n.kind?new A.$VK(n.kind):void 0);return n.edit&&(o.edit=y.WorkspaceEdit.to(n.edit)),n.command&&(o.command=t.fromInternal(n.command)),o.isPreferred=n.isPreferred,o}})(a))),new m.$2M("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$ZM.Uri],new m.$1M("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(s=>new A.$cL(y.Range.to(s.range),y.Color.to(s.color))):[])),new m.$2M("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$ZM("color","The color to show and insert",a=>a instanceof A.$bL,y.Color.from),new m.$ZM("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:y.Range.from(a.range)}))],new m.$1M("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(y.ColorPresentation.to):[])),new m.$2M("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$ZM.Uri,m.$ZM.Range],new m.$1M("A promise that resolves to an array of Inlay objects",(a,s,t)=>a.map(y.InlayHint.to.bind(void 0,t)))),new m.$2M("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$ZM.Uri],new m.$1M("A promise that resolves to an array of FoldingRange objects",(a,s)=>{if(a)return a.map(y.FoldingRange.to)})),new m.$2M("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$1M("A promise that resolves to an array of NotebookContentProvider static info objects.",p(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(s=>y.NotebookExclusiveDocumentPattern.to(s))})))),new m.$2M("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$ZM.Uri,m.$ZM.Range,new m.$ZM("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof A.$DK,a=>y.InlineValueContext.from(a))],new m.$1M("A promise that resolves to an array of InlineValue objects",a=>a.map(y.InlineValue.to))),new m.$2M("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$ZM("uriOrString","Uri-instance or string (only http/https)",a=>C.URI.isUri(a)||typeof a=="string"&&(0,T.$_f)(a,T.Schemas.http,T.Schemas.https),a=>a),new m.$ZM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[y.ViewColumn.from(a),void 0]:[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)])).optional(),m.$ZM.String.with("label","").optional()],m.$1M.Void),new m.$2M("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$ZM.Uri.with("resource","Resource to open"),m.$ZM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$ZM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[y.ViewColumn.from(a),void 0]:[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)])).optional()],m.$1M.Void),new m.$2M("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$ZM.Uri.with("left","Left-hand side resource of the diff editor"),m.$ZM.Uri.with("right","Right-hand side resource of the diff editor"),m.$ZM.String.with("title","Human readable title for the diff editor").optional(),new m.$ZM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)]).optional()],m.$1M.Void),new m.$2M("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$ZM.String.with("title","Human readable title for the changes editor"),new m.$ZM("resourceList","List of resources to compare",a=>{for(const s of a){if(s.length!==3)return!1;const[t,n,o]=s;if(!C.URI.isUri(t)||!C.URI.isUri(n)&&n!==void 0&&n!==null||!C.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},a=>a)],m.$1M.Void),new m.$2M("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$ZM.Uri,m.$ZM.Position],new m.$1M("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(y.TypeHierarchyItem.to))),new m.$2M("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$ZM.TypeHierarchyItem],new m.$1M("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(y.TypeHierarchyItem.to))),new m.$2M("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$ZM.TypeHierarchyItem],new m.$1M("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(y.TypeHierarchyItem.to))),new m.$2M("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$ZM.TestItem],m.$1M.Void),new m.$2M("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$ZM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$1M.Void),new m.$2M("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$ZM.String.with("name","The context key name"),new m.$ZM("value","The context key value",()=>!0,a=>a)],m.$1M.Void),new m.$2M("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$ZM.Uri,m.$ZM.StringArray,new m.$ZM("MappedEditsContext","Mapped Edits Context",a=>y.MappedEditsContext.is(a),a=>y.MappedEditsContext.from(a))],new m.$1M("A promise that resolves to a workspace edit or null",a=>a?y.WorkspaceEdit.to(a):null))];class l{static register(s){S.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",$.$Wi)}}e.$dec=l;function p(a){return s=>{if(Array.isArray(s))return s.map(a)}}function w(a){if(!Array.isArray(a))return;const s=[];for(const t of a)M.$mt(t)?s.push(y.DefinitionLink.to(t)):s.push(y.location.to(t));return s}}),define(Ae[239],Re([1,0,14,66,5,6,2,80,22,8,7,3,23]),function(we,e,E,T,C,M,P,$,m,y,A,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=void 0;function p(w,a,s){const t=w.getProxy(S.$zK.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new m.$dm,a.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===6){const D=this.b.get(g.handle);return D?D.value:g}else if(g&&g.$mid===7){const D=this.b.get(g.commentControlHandle);if(!D)return g;const I=D.getCommentThread(g.commentThreadHandle);return I?I.value:g}else if(g&&(g.$mid===9||g.$mid===8)){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const I=D.getCommentThread(g.thread.commentThreadHandle);return I?g.$mid===8?I.value:{thread:I.value,text:g.text}:g}else if(g&&g.$mid===10){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const I=D.getCommentThread(g.thread.commentThreadHandle);if(!I)return g;const h=g.commentUniqueId,b=I.getCommentByUniqueId(h);return b||g}else if(g&&g.$mid===11){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const I=D.getCommentThread(g.thread.commentThreadHandle);if(!I)return g;const h=g.text,b=g.commentUniqueId,k=I.getCommentByUniqueId(b);return k?(typeof k.body=="string"?k.body=h:k.body=new A.$2K(h),k):g}return g}})}createCommentController(g,D,I){const h=n.a++,b=new c(g,h,D,I);this.b.set(b.handle,b);const k=this.c.get(g.identifier)||[];return k.push(b),this.c.set(g.identifier,k),b.value}async $createCommentThreadTemplate(g,D,I){const h=this.b.get(g);h&&h.$createCommentThreadTemplate(D,I)}async $updateCommentThreadTemplate(g,D,I){const h=this.b.get(g);h&&h.$updateCommentThreadTemplate(D,I)}$deleteCommentThread(g,D){this.b.get(g)?.$deleteCommentThread(D)}$provideCommentingRanges(g,D,I){const h=this.b.get(g);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const b=s.getDocument(P.URI.revive(D));return(0,E.$Sg)(async()=>{const k=await h.commentingRangeProvider.provideCommentingRanges(b,I);let F;return Array.isArray(k)?F={ranges:k,fileComments:!1}:k?F={ranges:k.ranges||[],fileComments:k.fileComments||!1}:F=k??void 0,F}).then(k=>{let F;return k&&(F={ranges:k.ranges.map(W=>y.Range.from(W)),fileComments:k.fileComments}),F})}$toggleReaction(g,D,I,h,b){const k=this.b.get(g);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,E.$Sg)(()=>{const F=k.getCommentThread(D);if(F){const W=F.getCommentByUniqueId(h.uniqueIdInThread);if(k!==void 0&&W&&k.reactionHandler)return k.reactionHandler(W,r(b))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(g){this.n=g}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(g){(g===void 0!=(this.p===void 0)||!g||!this.p||!g.isEqual(this.p))&&(this.p=g,this.b.range=g,this.c.fire())}get range(){return this.p}set canReply(g){this.d!==g&&(this.d=g,this.b.canReply=g,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(g){this.e=g,this.b.label=g,this.c.fire()}get contextValue(){return this.f}set contextValue(g){this.f=g,this.b.contextValue=g,this.c.fire()}get comments(){return this.q}set comments(g){this.q=g,this.b.comments=g,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(g){this.g=g,this.b.collapsibleState=g,this.c.fire()}get state(){return this.h}set state(g){this.h=g,this.b.state=g,this.c.fire()}get isDisposed(){return this.j}constructor(g,D,I,h,b,k,F,W){this.m=D,this.n=I,this.o=h,this.p=b,this.q=k,this.extensionDescription=F,this.r=W,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$Rd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Sc,this.l.value=new M.$Qc,this.n===void 0&&(this.n=`${g}.${this.handle}`),t.$createCommentThread(D,this.handle,this.n,this.o,y.Range.from(this.p),F.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{t.$deleteCommentThread(D,this.handle)}});const J=this;this.value={get uri(){return J.uri},get range(){return J.range},set range(N){J.range=N},get comments(){return J.comments},set comments(N){J.comments=N},get collapsibleState(){return J.collapsibleState},set collapsibleState(N){J.collapsibleState=N},get canReply(){return J.canReply},set canReply(N){J.canReply=N},get contextValue(){return J.contextValue},set contextValue(N){J.contextValue=N},get label(){return J.label},set label(N){J.label=N},get state(){return J.state},set state(N){J.state=N},dispose:()=>{J.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Qc);const g=I=>Object.prototype.hasOwnProperty.call(this.b,I),D={};g("range")&&(D.range=y.Range.from(this.p)),g("label")&&(D.label=this.label),g("contextValue")&&(D.contextValue=this.contextValue??null),g("comments")&&(D.comments=this.q.map(I=>d(this,I,this.k,this.extensionDescription))),g("collapsibleState")&&(D.collapseState=u(this.g)),g("canReply")&&(D.canReply=this.canReply),g("state")&&(D.state=f(this.h)),g("isTemplate")&&(D.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(g){for(const D of this.k){const I=D[0],h=D[1];if(g===h)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(g=>g.dispose())}}Ke([(0,T.$qh)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(g){this.b=g,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(g){this.c=g,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!g})}get options(){return this.d}set options(g){this.d=g,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(g,D,I,h){this.f=g,this.g=D,this.h=I,this.i=h,this.a=new Map,t.$registerCommentController(this.handle,I,h,this.f.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(k){b.options=k},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(k){b.commentingRangeProvider=k},get reactionHandler(){return b.reactionHandler},set reactionHandler(k){b.reactionHandler=k},createCommentThread(k,F,W){return b.createCommentThread(k,F,W).value},dispose:()=>{b.dispose()}}),this.e=[],this.e.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(g,D,I){D===void 0&&(0,l.$OF)(this.f,"fileComments");const h=new o(this.id,this.handle,void 0,g,D,I,this.f,!1);return this.a.set(h.handle,h),h}$createCommentThreadTemplate(g,D){const I=new o(this.id,this.handle,void 0,P.URI.revive(g),y.Range.to(D),[],this.f,!0);return I.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(g,D){const I=this.a.get(g);I&&(I.range=y.Range.to(D))}$deleteCommentThread(g){this.a.get(g)?.dispose(),this.a.delete(g)}getCommentThread(g){return this.a.get(g)}dispose(){this.a.forEach(g=>{g.dispose()}),this.e.forEach(g=>g.dispose())}}function d(v,g,D,I){let h=D.get(g);return h||(h=++v.commentHandle,D.set(g,h)),g.state!==void 0&&(0,l.$OF)(I,"commentsDraftState"),{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:h,body:typeof g.body=="string"?g.body:y.MarkdownString.from(g.body),userName:g.author.name,userIconPath:g.author.iconPath,label:g.label,commentReactions:g.reactions?g.reactions.map(b=>i(b)):void 0,state:g.state,timestamp:g.timestamp?.toJSON()}}function i(v){return{label:v.label,iconPath:v.iconPath?y.$AM(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted}}function r(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?P.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1}}function u(v){if(v!==void 0)switch(v){case A.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function f(v){if(v!==void 0)switch(v){case A.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new n}e.$nec=p}),define(Ae[240],Re([1,0,26,3,27,17]),function(we,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;let P=class{constructor(A,S){this.a=A.getProxy(T.$zK.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,S){const l=this,p=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){l.e(A,S,p,arguments)}})}e(A,S,l,p){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:m(p,this.b)}),this.c&&this.f(A,l,p)}};e.$bgc=P,e.$bgc=P=Ke([We(0,M.$BM),We(1,C.$RM)],P);const $=1e5;function m(y,A){const S=[];if(y.length)for(let l=0;l<y.length;l++){let p=y[l];if(typeof p>"u")p="undefined";else if(p instanceof Error){const w=p;w.stack?p=w.stack:p=w.toString()}S.push(p)}if(A){const l=new Error().stack;l&&S.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,E.$hn)(S);return l.length>$?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Ae[109],Re([1,0,2,3,7,4,17,15,18,12,20,23]),function(we,e,E,T,C,M,P,$,m,y,A,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=e.$dfc=void 0;let p=class{static{l=this}static{this.c=0}static{this.d=250}constructor(a,s){this.h=s,this.f=new Map,this.g=a.getProxy(T.$zK.MainThreadDecorations)}registerFileDecorationProvider(a,s){const t=l.c++;this.f.set(t,{provider:a,extensionDescription:s}),this.g.$registerDecorationProvider(t,s.identifier.value);const n=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(o=>{if(!o){this.g.$onDidChange(t,null);return}const c=(0,m.$2b)(o);if(c.length<=l.d){this.g.$onDidChange(t,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,c.length);const d=c.map(u=>({uri:u,rank:(0,y.$Ke)(u.path,"/")})),i=(0,m.$yb)(d,(u,f)=>u.rank-f.rank||(0,y.$Ye)(u.uri.path,f.uri.path)),r=[];e:for(const u of i){let f;for(const v of u){const g=(0,A.$lc)(v.uri.path);if(f!==g&&(f=g,r.push(v.uri)>=l.d))break e}}this.g.$onDidChange(t,r)});return new C.$BK(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(a,s,t){if(!this.f.has(a))return Object.create(null);const n=Object.create(null),{provider:o,extensionDescription:c}=this.f.get(a);return await Promise.all(s.map(async d=>{try{const{uri:i,id:r}=d,u=await Promise.resolve(o.provideFileDecoration(E.URI.revive(i),t));if(!u)return;try{C.$WL.validate(u),u.badge&&typeof u.badge!="string"&&(0,S.$OF)(c,"codiconDecoration"),n[r]=[u.propagate,u.tooltip,u.badge,u.color]}catch(f){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${f}`)}}catch(i){this.h.error(i)}})),n}};e.$dfc=p,e.$dfc=p=l=Ke([We(0,P.$BM),We(1,$.$fj)],p),e.$efc=(0,M.$Xh)("IExtHostDecorations")}),define(Ae[241],Re([1,0,157,98,2,3,7,8,5,15,28,42]),function(we,e,E,T,C,M,P,$,m,y,A,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=e.$0dc=void 0;class p{#e;#t;#i;constructor(s,t,n,o,c,d,i,r){this.d=s,this.e=t,this.f=n,this.g=o,this.h=c,this.c=!1,this.f=Math.max(o,n),this.#i=new A.$zc(u=>d.getComparisonKey(u)),this.#e=i,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(s,t){if(!s){this.clear();return}this.j();let n=[];if(C.URI.isUri(s)){if(!t){this.delete(s);return}this.#i.set(s,t.slice()),n=[s]}else if(Array.isArray(s)){n=[];let d;s=[...s].sort(p.k);for(const i of s){const[r,u]=i;if((!d||r.toString()!==d.toString())&&(d&&this.#i.get(d).length===0&&this.#i.delete(d),d=r,n.push(r),this.#i.set(r,[])),u)this.#i.get(r)?.push(...u);else{const f=this.#i.get(r);f&&(f.length=0)}}}if(this.#t.fire(n),!this.#e)return;const o=[];let c=0;for(const d of n){let i=[];const r=this.#i.get(d);if(r)if(r.length>this.g){i=[];const u=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(const v of r)if(v.severity===u[f]&&i.push({...$.Diagnostic.from(v),modelVersionId:this.h(d)})===this.g)break e;i.push({severity:T.MarkerSeverity.Info,message:(0,E.localize)(0,null,r.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=r.map(u=>({...$.Diagnostic.from(u),modelVersionId:this.h(d)}));if(o.push([d,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,o)}delete(s){this.j(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this.e,[[s,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(s,t){this.j();for(const[n,o]of this)s.call(t,n,o,this)}*[Symbol.iterator](){this.j();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this.j();const t=this.#i.get(s);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(s){return this.j(),Array.isArray(this.#i.get(s))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(s,t){return s[0].toString()<t[0].toString()?-1:s[0].toString()>t[0].toString()?1:0}}e.$0dc=p;let w=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(s){const t=new A.$zc;for(const n of s)t.set(n,n);return{uris:Object.freeze(Array.from(t.values()))}}constructor(s,t,n,o){this.j=t,this.k=n,this.l=o,this.g=new Map,this.h=new m.$Vd({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,l._mapper),this.f=s.getProxy(M.$zK.MainThreadDiagnostics)}createDiagnosticCollection(s,t){const{g:n,f:o,h:c,j:d,k:i,l:r}=this,u=new class{$changeMany(g,D){o.$changeMany(g,D),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,g,D.length===0?"CLEARING":D)}$clear(g){o.$clear(g),d.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,g)}dispose(){o.dispose()}};let f;if(!t)t="_generated_diagnostic_collection_name_#"+l.c++,f=t;else if(!n.has(t))f=t;else{this.j.warn(`DiagnosticCollection with name '${t}' does already exist.`);do f=t+l.c++;while(n.has(f))}return new class extends p{constructor(){super(t,f,l.e,l.d,g=>r.getDocument(g)?.version,i.extUri,u,c),n.set(f,this)}dispose(){super.dispose(),n.delete(f)}}}getDiagnostics(s){if(s)return this.m(s);{const t=new Map,n=[];for(const o of this.g.values())o.forEach((c,d)=>{let i=t.get(c.toString());typeof i>"u"&&(i=n.length,t.set(c.toString(),i),n.push([c,[]])),n[i][1]=n[i][1].concat(...d)});return n}}m(s){let t=[];for(const n of this.g.values())n.has(s)&&(t=t.concat(n.get(s)));return t}$acceptMarkersChange(s){if(!this.n){const t="_generated_mirror",n=new p(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,o=>{},this.k.extUri,void 0,this.h);this.g.set(t,n),this.n=n}for(const[t,n]of s)this.n.set(C.URI.revive(t),n.map($.Diagnostic.to))}};e.$$dc=w,e.$$dc=w=l=Ke([We(1,y.$fj),We(2,S.$9dc)],w)}),define(Ae[242],Re([1,0,2,3,23]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;class M{constructor($){this.a=$.getProxy(T.$zK.MainThreadDialogs)}showOpenDialog($,m){return m?.allowUIResources&&(0,C.$OF)($,"showLocal"),this.a.$showOpenDialog(m).then(y=>y?y.map(A=>E.URI.revive(A)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(m=>m?E.URI.revive(m):void 0)}}e.$ffc=M}),define(Ae[243],Re([1,0,11,2,7,3,13,19,12]),function(we,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=void 0;class y{static{this.a=0}constructor(S,l,p){this.d=l,this.e=p,this.b=new Map,this.c=S.getProxy(M.$zK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,l){if(Object.keys(P.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const p=y.a++;this.b.set(p,l),this.c.$registerTextContentProvider(p,S);let w;return typeof l.onDidChange=="function"&&(w=l.onDidChange(a=>{if(a.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this.d.getDocument(a)&&this.$provideTextDocumentContent(p,a).then(s=>{if(!s&&typeof s!="string")return;const t=this.d.getDocument(a);if(!t)return;const n=(0,m.$Te)(s);if(!t.equalLines(n))return this.c.$onVirtualDocumentChange(a,s)},E.$Z)})),new C.$BK(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(S,l){const p=this.b.get(S);return p?Promise.resolve(p.provideTextDocumentContent(T.URI.revive(l),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$gfc=y}),define(Ae[244],Re([1,0,5,6,2,3,102,8,16,26,7,11]),function(we,e,E,T,C,M,P,$,m,y,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=void 0;class l{constructor(w,a){this.a=new E.$Rd({onListenerError:S.$1}),this.b=new E.$Rd({onListenerError:S.$1}),this.c=new E.$Rd({onListenerError:S.$1}),this.d=new E.$Rd({onListenerError:S.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Qc,this.h=new Map,this.f=w.getProxy(M.$zK.MainThreadDocuments),this.g=a,this.g.onDidRemoveDocuments(s=>{for(const t of s)this.b.fire(t.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const t of s)this.a.fire(t.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(w){if(!w)return;const a=this.g.getDocument(w);if(a)return a}getDocument(w){const a=this.getDocumentData(w);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return a.document}ensureDocumentData(w){const a=this.g.getDocument(w);if(a)return Promise.resolve(a);let s=this.h.get(w.toString());return s||(s=this.f.$tryOpenDocument(w).then(t=>{this.h.delete(w.toString());const n=C.URI.revive(t);return(0,m.$Nf)(this.g.getDocument(n))},t=>(this.h.delete(w.toString()),Promise.reject(t))),this.h.set(w.toString(),s)),s}createDocumentData(w){return this.f.$tryCreateDocument(w).then(a=>C.URI.revive(a))}$acceptModelLanguageChanged(w,a){const s=C.URI.revive(w),t=this.g.getDocument(s);if(!t)throw new Error("unknown document");this.b.fire(t.document),t._acceptLanguageId(a),this.a.fire(t.document)}$acceptModelSaved(w){const a=C.URI.revive(w),s=this.g.getDocument(a);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(w,a){const s=C.URI.revive(w),t=this.g.getDocument(s);if(!t)throw new Error("unknown document");t._acceptIsDirty(a),this.c.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,a,s){const t=C.URI.revive(w),n=this.g.getDocument(t);if(!n)throw new Error("unknown document");n._acceptIsDirty(s),n.onEvents(a);let o;a.isUndoing?o=A.TextDocumentChangeReason.Undo:a.isRedoing&&(o=A.TextDocumentChangeReason.Redo),this.c.fire((0,y.$dn)({document:n.document,contentChanges:a.changes.map(c=>({range:$.Range.to(c.range),rangeOffset:c.rangeOffset,rangeLength:c.rangeLength,text:c.text})),reason:o}))}setWordDefinitionFor(w,a){(0,P.$DM)(w,a)}}e.$7dc=l}),define(Ae[61],Re([1,0,53,5,6,2,4,3,102,17,108,8,15,28,13,67,44]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=void 0;class t{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,d){this.h=c,this.i=d,this.a=null,this.b=new Map,this.c=new p.$zc,this.d=new T.$Rd,this.e=new T.$Rd,this.f=new T.$Rd,this.g=new T.$Rd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const d=[],i=[],r=[];if(c.removedDocuments)for(const u of c.removedDocuments){const f=M.URI.revive(u),v=this.c.get(f);v?.unref()&&(this.c.delete(f),d.push(v.value))}if(c.addedDocuments)for(const u of c.addedDocuments){const f=M.URI.revive(u.uri);let v=this.c.get(f);if(v&&f.scheme!==w.Schemas.vscodeNotebookCell&&f.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${f} already exists!'`);v||(v=new t(new m.$EM(this.h.getProxy($.$zK.MainThreadDocuments),f,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty,u.notebook)),this.c.set(f,v),i.push(v.value)),v.ref()}if(c.removedEditors)for(const u of c.removedEditors){const f=this.b.get(u);this.b.delete(u),f&&r.push(f)}if(c.addedEditors)for(const u of c.addedEditors){const f=M.URI.revive(u.documentUri);E.ok(this.c.has(f),`document '${f}' does not exist`),E.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const v=this.c.get(f).value,g=new A.$KM(u.id,this.h.getProxy($.$zK.MainThreadTextEditors),this.i,new s.$U(()=>v.document),u.selections.map(S.Selection.to),u.options,u.visibleRanges.map(D=>S.Range.to(D)),typeof u.editorPosition=="number"?S.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,g)}c.newActiveEditor!==void 0&&(E.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,C.$Mc)(d),(0,C.$Mc)(r),c.removedDocuments&&this.e.fire(d),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return a.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const d=this.b.get(this.a);return c?d:d?.value}allEditors(){return[...this.b.values()]}};e.$LM=n,e.$LM=n=Ke([We(0,y.$BM),We(1,l.$fj)],n),e.$MM=(0,P.$Xh)("IExtHostDocumentsAndEditors")}),define(Ae[62],Re([1,0,245,5,16,2,4,3,17,8,7]),function(we,e,E,T,C,M,P,$,m,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=e.$Gec=void 0,e.$Gec=(0,P.$Xh)("IExtHostEditorTabs");class S{constructor(s,t,n){this.e=n,this.d=t,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,t={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(t)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$gM(M.URI.revive(this.b.input.uri));case 2:return new A.$hM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new A.$iM(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new A.$jM(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$kM(this.b.input.viewType);case 4:return new A.$lM(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$mM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$nM;case 9:return new A.$oM(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$pM(this.b.input.providerId);default:return}}}class l{constructor(s,t){this.c=[],this.d="",this.b=s,this.e=t;for(const n of s.tabs)n.isActive&&(this.d=n.id),this.c.push(new S(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,t={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return y.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(n=>n.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(n=>n.apiObject))}};this.a=Object.freeze(t)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===0){const n=new S(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,n),s.tabDto.isActive&&(this.d=n.tabId),n}else if(s.kind===1){const n=this.c.splice(s.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(s.kind===3){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(s.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,n),n}const t=this.c.find(n=>n.tabId===s.tabDto.id);if(!t)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),t.acceptDtoUpdate(s.tabDto),t}activeTabId(){return this.d}}let p=class{constructor(s){this.b=new T.$Rd,this.c=new T.$Rd,this.e=[],this.a=s.getProxy($.$zK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,t={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(n=>n.apiObject))},get activeTabGroup(){const n=s.d;return(0,C.$Nf)(s.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,o)=>{const c=Array.isArray(n)?n:[n];return c.length?w(c[0])?this.j(c,o):this.i(c,o):!0}};this.f=Object.freeze(t)}return this.f}$acceptEditorTabModel(s){const t=new Set(this.e.map(u=>u.groupId)),n=new Set(s.map(u=>u.groupId)),o=(0,E.$K)(t,n),c=this.e.filter(u=>o.removed.includes(u.groupId)).map(u=>u.apiObject),d=[],i=[];this.e=s.map(u=>{const f=new l(u,()=>this.d);return o.added.includes(f.groupId)?d.push(f.apiObject):i.push(f.apiObject),f});const r=(0,C.$Nf)(s.find(u=>u.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:d,closed:c,changed:i}))}$acceptTabGroupUpdate(s){const t=this.e.find(n=>n.groupId===s.groupId);if(!t)throw new Error("Update Group IPC call received before group creation.");t.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[t.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const t=this.e.find(o=>o.groupId===s.groupId);if(!t)throw new Error("Update Tabs IPC call received before group creation.");const n=t.acceptTabOperation(s);switch(s.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(s){for(const t of this.e)for(const n of t.tabs)if(n.apiObject===s)return n}h(s){return this.e.find(t=>t.apiObject===s)}async i(s,t){const n=[];for(const o of s){const c=this.g(o);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,t)}async j(s,t){const n=[];for(const o of s){const c=this.h(o);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,t)}};e.$Hec=p,e.$Hec=p=Ke([We(0,m.$BM)],p);function w(a){return a.tabs!==void 0}}),define(Ae[246],Re([1,0,3,7]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=void 0;class C{constructor(P){this.a=new Map,this.b=0,this.c=P.getProxy(E.$zK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(P,$,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(P);if(!y)throw new Error("Embedding vector provider not found");const A=await y.provideEmbeddingVector($,m);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(P,$,m){const y=this.b;return this.b++,this.a.set(y,m),this.c.$registerAiEmbeddingVectorProvider($,y),new T.$BK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$ifc=C}),define(Ae[247],Re([1,0,2,3,6,7,8,295,12,24,23,52]),function(we,e,E,T,C,M,P,$,m,y,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;class l{constructor(){this.a=[]}add(a){this.b=void 0,this.a.push(a)}delete(a){const s=this.a.indexOf(a);s>=0&&(this.a.splice(s,1),this.b=void 0)}c(){if(!this.b){const a=this.a.sort(),s=[];let t,n,o=14,c=14;for(const d of a){let i=t?(0,m.$8e)(t,d):0;for(i===0?n=1:n=c;i<d.length;i++)i+1===d.length?(o=c,c=9):c+=1,s.push([n,d.toUpperCase().charCodeAt(i),c]),s.push([n,d.toLowerCase().charCodeAt(i),c]),n=c;t=d,c=o}s.push([9,58,10]),s.push([10,47,12]),this.b=new $.$3Y(s)}}provideDocumentLinks(a){this.c();const s=[],t=$.$4Y.computeLinks({getLineContent(n){return a.lineAt(n-1).text},getLineCount(){return a.lineCount}},this.b);for(const n of t){const o=P.DocumentLink.to(n);o.target&&s.push(o)}return s}}class p{constructor(a,s){this.i=s,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=a.getProxy(T.$zK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(a,s,t,n={}){if(p.j(t),this.d.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(a,"*",this.b));const o=this.h++;this.b.add(s),this.d.add(s),this.c.set(o,t);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof t.copy=="function"&&(c+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,A.$OF)(a,"fsChunks"),c+=4);let d;n.isReadonly&&(0,S.$ak)(n.isReadonly)&&((0,A.$OF)(a,"readonlyMessage"),d={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(o,s,c,d).catch(r=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${s}`),console.error(r)});const i=t.onDidChangeFile(r=>{const u=[];for(const f of r){const{uri:v,type:g}=f;if(v.scheme!==s)continue;let D;switch(g){case M.FileChangeType.Changed:D=0;break;case M.FileChangeType.Created:D=1;break;case M.FileChangeType.Deleted:D=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:v,type:D})}this.a.$onFileSystemChange(o,u)});return(0,C.$Pc)(()=>{i.dispose(),this.b.delete(s),this.d.delete(s),this.c.delete(o),this.a.$unregisterProvider(o)})}static j(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static k(a){const{type:s,ctime:t,mtime:n,size:o,permissions:c}=a;return{type:s,ctime:t,mtime:n,size:o,permissions:c}}$stat(a,s){return Promise.resolve(this.l(a).stat(E.URI.revive(s))).then(t=>p.k(t))}$readdir(a,s){return Promise.resolve(this.l(a).readDirectory(E.URI.revive(s)))}$readFile(a,s){return Promise.resolve(this.l(a).readFile(E.URI.revive(s))).then(t=>y.$fe.wrap(t))}$writeFile(a,s,t,n){return Promise.resolve(this.l(a).writeFile(E.URI.revive(s),t.buffer,n))}$delete(a,s,t){return Promise.resolve(this.l(a).delete(E.URI.revive(s),t))}$rename(a,s,t,n){return Promise.resolve(this.l(a).rename(E.URI.revive(s),E.URI.revive(t),n))}$copy(a,s,t,n){const o=this.l(a);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(E.URI.revive(s),E.URI.revive(t),n))}$mkdir(a,s){return Promise.resolve(this.l(a).createDirectory(E.URI.revive(s)))}$watch(a,s,t,n){const o=this.l(a).watch(E.URI.revive(t),n);this.f.set(s,o)}$unwatch(a,s){const t=this.f.get(s);t&&(t.dispose(),this.f.delete(s))}$open(a,s,t){const n=this.l(a);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(E.URI.revive(s),t))}$close(a,s){const t=this.l(a);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(s))}$read(a,s,t,n){const o=this.l(a);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const c=y.$fe.alloc(n);return Promise.resolve(o.read(s,t,c.buffer,0,n)).then(d=>c.slice(0,d))}$write(a,s,t,n){const o=this.l(a);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(s,t,n.buffer,0,n.byteLength))}l(a){const s=this.c.get(a);if(!s){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return s}}e.$jfc=p}),define(Ae[63],Re([1,0,3,41,7,24,4,17,42,6,14,25,13]),function(we,e,E,T,C,M,P,$,m,y,A,S,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=e.$vec=void 0;let w=p=class{constructor(s,t){this.b=new Map,this.c=new A.$9g,this.a=s.getProxy(E.$zK.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(o){try{let c;const d=n.b.get(o.scheme);return d?(await n.a.$ensureActivation(o.scheme),c=await d.impl.stat(o)):c=await n.a.$stat(o),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===T.FilePermission.Readonly?1:void 0}}catch(c){p.e(c)}},async readDirectory(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readDirectory(o)).slice()):await n.a.$readdir(o)}catch(c){return p.e(c)}},async createDirectory(o){try{const c=n.b.get(o.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(c.impl,c.extUri,o)):await n.a.$mkdir(o)}catch(c){return p.e(c)}},async readFile(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readFile(o)).slice()):(await n.a.$readFile(o)).buffer}catch(c){return p.e(c)}},async writeFile(o,c){try{const d=n.b.get(o.scheme);return d&&!d.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(d.impl,d.extUri,d.extUri.dirname(o)),await n.c.queueFor(o).queue(()=>Promise.resolve(d.impl.writeFile(o,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(o,M.$fe.wrap(c))}catch(d){return p.e(d)}},async delete(o,c){try{const d=n.b.get(o.scheme);return d&&!d.isReadonly?(await n.a.$ensureActivation(o.scheme),await d.impl.delete(o,{recursive:!1,...c})):await n.a.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(d){return p.e(d)}},async rename(o,c,d){try{return await n.a.$rename(o,c,{overwrite:!1,...d})}catch(i){return p.e(i)}},async copy(o,c,d){try{return await n.a.$copy(o,c,{overwrite:!1,...d})}catch(i){return p.e(i)}},isWritableFileSystem(o){const c=t.getCapabilities(o);if(typeof c=="number")return!(c&2048)}})}async d(s,t,n){const o=[];for(;!t.isEqual(n,t.dirname(n));)try{if(!((await s.stat(n)).type&T.FileType.Directory))throw C.$OL.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(T.$wk(c)!==T.FileSystemProviderErrorCode.FileNotFound)throw c;o.push(t.basename(n)),n=t.dirname(n)}for(let c=o.length-1;c>=0;c--){n=t.joinPath(n,o[c]);try{await s.createDirectory(n)}catch(d){if(T.$wk(d)!==T.FileSystemProviderErrorCode.FileExists)throw d}}}static e(s){if(s instanceof C.$OL)throw s;if(s instanceof T.$sk)switch(s.code){case T.FileSystemProviderErrorCode.FileExists:throw C.$OL.FileExists(s.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.$OL.FileNotFound(s.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.$OL.FileNotADirectory(s.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.$OL.FileIsADirectory(s.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.$OL.NoPermissions(s.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.$OL.Unavailable(s.message);default:throw new C.$OL(s.message,s.name)}if(!(s instanceof Error))throw new C.$OL(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw C.$OL.Unavailable(s.message);switch(s.name){case T.FileSystemProviderErrorCode.FileExists:throw C.$OL.FileExists(s.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.$OL.FileNotFound(s.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.$OL.FileNotADirectory(s.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.$OL.FileIsADirectory(s.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.$OL.NoPermissions(s.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.$OL.Unavailable(s.message);default:throw new C.$OL(s.message,s.name)}}addFileSystemProvider(s,t,n){return this.b.set(s,{impl:t,extUri:n?.isCaseSensitive?S.$rg:S.$tg,isReadonly:!!n?.isReadonly}),(0,y.$Pc)(()=>this.b.delete(s))}getFileSystemProviderExtUri(s){return this.b.get(s)?.extUri??S.$rg}};e.$vec=w,e.$vec=w=p=Ke([We(0,$.$BM),We(1,m.$9dc)],w),e.$wec=(0,P.$Xh)("IExtHostConsumerFileSystem")}),define(Ae[248],Re([1,0,5,34,2,3,8,7,44]),function(we,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,w,a,s,t,n){this.a=Math.random(),this.b=new E.$Rd,this.c=new E.$Rd,this.d=new E.$Rd,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const o=(0,T.$Ej)(t),c=typeof t=="string",d=n?.correlate,i=s(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)&&!(d&&typeof r.session>"u")){if(!n?.ignoreCreateEvents)for(const u of r.created){const f=C.URI.revive(u);o(f.fsPath)&&(!c||w.getWorkspaceFolder(f))&&this.b.fire(f)}if(!n?.ignoreChangeEvents)for(const u of r.changed){const f=C.URI.revive(u);o(f.fsPath)&&(!c||w.getWorkspaceFolder(f))&&this.c.fire(f)}if(!n?.ignoreDeleteEvents)for(const u of r.deleted){const f=C.URI.revive(u);o(f.fsPath)&&(!c||w.getWorkspaceFolder(f))&&this.d.fire(f)}}});this.g=$.$BK.from(this.i(p,a,t,n,n?.correlate),this.b,this.c,this.d,i)}i(p,w,a,s,t){const n=$.$BK.from();if(typeof a=="string")return n;const o=p.getProxy(M.$zK.MainThreadFileSystemEventService);let c=!1;return(a.pattern.includes(T.$Aj)||a.pattern.includes(T.$Bj))&&(c=!0),o.$watch(w.identifier.value,this.a,a.baseUri,{recursive:c,excludes:s?.excludes??[]},!!t),$.$BK.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(p){this.a=p,this.session=this.a.session,this.b=new m.$U(()=>this.a.created.map(C.URI.revive)),this.c=new m.$U(()=>this.a.changed.map(C.URI.revive)),this.d=new m.$U(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(p,w,a){this.j=p,this.k=w,this.l=a,this.a=new E.$Rd,this.b=new E.$Rd,this.c=new E.$Rd,this.d=new E.$Rd,this.g=new E.$Td,this.h=new E.$Td,this.i=new E.$Td,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,w,a,s){return new y(this.j,p,w,this.a.event,P.GlobPattern.from(a),s)}$onFileEvent(p){this.a.fire(new A(p))}$onDidRunFileOperation(p,w){switch(p){case 2:this.b.fire(Object.freeze({files:w.map(a=>({oldUri:C.URI.revive(a.source),newUri:C.URI.revive(a.target)}))}));break;case 1:this.d.fire(Object.freeze({files:w.map(a=>C.URI.revive(a.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:w.map(a=>C.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,w){return(a,s,t)=>{const n=function(c){a.call(s,c)};return n.extension=p,w.event(n,void 0,t)}}async $onWillRunFileOperation(p,w,a,s){switch(p){case 2:return await this.n(this.g,{files:w.map(t=>({oldUri:C.URI.revive(t.source),newUri:C.URI.revive(t.target)}))},a,s);case 1:return await this.n(this.i,{files:w.map(t=>C.URI.revive(t.target))},a,s);case 0:case 3:return await this.n(this.h,{files:w.map(t=>C.URI.revive(t.target))},a,s)}}async n(p,w,a,s){const t=new Set,n=[];if(await p.fireAsync(w,s,async(c,d)=>{const i=Date.now(),r=await Promise.resolve(c);r instanceof $.$LK&&(n.push([d.extension,r]),t.add(d.extension.displayName??d.extension.identifier.value)),Date.now()-i>a&&this.k.warn("SLOW file-participant",d.extension.identifier)}),s.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,c]of n){const{edits:d}=P.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(d)}return{edit:o,extensionNames:Array.from(t)}}}e.$kfc=S}),define(Ae[249],Re([1,0,6,2,3,8,7,32,14]),function(we,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;class y{static{this.a=0}constructor(p,w){this.extension=p,this.provider=w,this.handle=y.a++}}class A{constructor(p){this.session=p,this.responses=[]}}class S{static{this.a=0}constructor(p,w,a,s){this.f=a,this.g=s,this.b=new Map,this.d=new Map,this.e=p.getProxy(C.$zK.MainThreadInlineChat),w.registerApiCommand(new $.$2M("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$ZM("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?M.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?M.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?M.Position.from(t.position):void 0}})],$.$1M.Void))}registerProvider(p,w,a){const s=new y(p,w);return this.b.set(s.handle,s),this.e.$registerInteractiveEditorProvider(s.handle,a?.label??p.displayName??p.name,p.identifier.value,typeof w.handleInteractiveEditorResponseFeedback=="function",typeof w.provideFollowups=="function",a?.supportReportIssue??!1),(0,E.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(s.handle),this.b.delete(s.handle)})}async $prepareSession(p,w,a,s){const t=this.b.get(p);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(T.URI.revive(w)),o=M.Selection.to(a),c=await t.provider.prepareInteractiveEditorSession({document:n,selection:o},s);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const d=S.a++;return this.d.set(d,new A(c)),{id:d,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:M.Range.from(c.wholeRange),message:c.message}}async $provideResponse(p,w,a,s){const t=this.b.get(p);if(!t)return;const n=this.d.get(w.id);if(!n)return;const o={prompt:a.prompt,selection:M.Selection.to(a.selection),wholeRange:M.Range.to(a.wholeRange),attempt:a.attempt,live:a.live};let c=!1;const d={report:async v=>{if(!a.live&&v.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||s.isCancellationRequested||await this.e.$handleProgressChunk(a.requestId,{message:v.message,edits:v.edits?.map(M.TextEdit.from),editsShouldBeInstant:v.editsShouldBeInstant,slashCommand:v.slashCommand?.command,markdownFragment:P.$2K.isMarkdownString(v.content)?v.content.value:v.content})}},i=Promise.resolve(t.provider.provideInteractiveEditorResponse(n.session,o,d,s));let r;try{r=await(0,m.$Og)(i,s)}finally{c=!0}if(!r)return;const u=n.responses.push(r)-1,f={wholeRange:M.Range.from(r.wholeRange),placeholder:r.placeholder};if(S.h(r)){const{edits:v,contents:g}=r,D=g!==void 0?M.MarkdownString.from(g):void 0;return v instanceof P.$LK?{...f,id:u,type:"bulkEdit",edits:M.WorkspaceEdit.from(v),message:D}:{...f,id:u,type:"editorEdit",edits:v.map(M.TextEdit.from),message:D}}return{...f,id:u,type:"message",message:M.MarkdownString.from(r.contents)}}async $provideFollowups(p,w,a,s){const t=this.b.get(p),n=this.d.get(w),o=n?.responses[a];if(t&&o&&t.provider.provideFollowups){const c=Promise.resolve(t.provider.provideFollowups(n.session,o,s));return(await(0,m.$Og)(c,s))?.map(M.ChatReplyFollowup.from)}}$handleFeedback(p,w,a,s){const t=this.b.get(p),n=this.d.get(w),o=n?.responses[a];if(t&&o){const c=M.InteractiveEditorResponseFeedbackKind.to(s);t.provider.handleInteractiveEditorResponseFeedback?.(n.session,o,c)}}$releaseSession(p,w){}static h(p){return typeof p=="object"&&typeof p.edits=="object"}}e.$lfc=S}),define(Ae[250],Re([1,0,2,32]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=void 0;class C{constructor(P,$,m,y,A){this.a=$,this.b=m,this.c=y;const S=new T.$2M("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$ZM("showOptions","Show Options",l=>!0,l=>l),new T.$ZM("resource","Interactive resource Uri",l=>!0,l=>l),new T.$ZM("controllerId","Notebook controller Id",l=>!0,l=>l),new T.$ZM("title","Interactive editor title",l=>!0,l=>l)],new T.$1M("Notebook and input URI",l=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const p=this.a.getEditorById(l.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri),notebookEditor:p.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(P,$,m,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:m,uri:P,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.$yfc=C}),define(Ae[251],Re([1,0,3,7]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zfc=void 0;class C{constructor(P){this.a=new Map,this.b=new Map,this.c=P.getProxy(E.$zK.MainThreadIssueReporter)}async $getIssueReporterUri(P,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const m=this.a.get(P);if(!m)throw new Error("Issue request handler not found");const y=await m.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(P,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const m=this.b.get(P);if(!m)throw new Error("Issue data provider not found");const y=await m.provideIssueData($);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(P,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const m=this.b.get(P);if(!m)throw new Error("Issue data provider not found");const y=await m.provideIssueTemplate($);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(P,$){const m=P.identifier.value;return this.a.set(m,$),this.c.$registerIssueUriRequestHandler(m),new T.$BK(()=>{this.c.$unregisterIssueUriRequestHandler(m),this.a.delete(m)})}registerIssueDataProvider(P,$){const m=P.identifier.value;return this.b.set(m,$),this.c.$registerIssueDataProvider(m),new T.$BK(()=>{this.c.$unregisterIssueDataProvider(m),this.b.delete(m)})}}e.$zfc=C}),define(Ae[252],Re([1,0,6,3]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=void 0;class C{constructor(P){this.b=0,this.a=P.getProxy(T.$zK.MainThreadLabelService)}$registerResourceLabelFormatter(P){const $=this.b++;return this.a.$registerResourceLabelFormatter($,P),(0,E.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$Afc=C}),define(Ae[253],Re([1,0,2,26,8,7,80,3,12,29,18,16,296,19,22,6,95,89,75,60,11,14,23,159]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a,s,t,n,o,c,d,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=void 0;class u{constructor(z,V){this.d=z,this.e=V}async provideDocumentSymbols(z,V){const H=this.d.getDocument(z),G=await this.e.provideDocumentSymbols(H,V);if(!(0,A.$Jb)(G))return G[0]instanceof M.$TK?G.map(C.DocumentSymbol.from):u.f(G)}static f(z){z=z.slice(0).sort((G,q)=>{let x=G.location.range.start.compareTo(q.location.range.start);return x===0&&(x=q.location.range.end.compareTo(G.location.range.end)),x});const V=[],H=[];for(const G of z){const q={name:G.name||"!!MISSING: name!!",kind:C.SymbolKind.from(G.kind),tags:G.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:G.containerName,range:C.Range.from(G.location.range),selectionRange:C.Range.from(G.location.range),children:[]};for(;;){if(H.length===0){H.push(q),V.push(q);break}const x=H[H.length-1];if(y.$Bs.containsRange(x.range,q.range)&&!y.$Bs.equalsRange(x.range,q.range)){x.children?.push(q),H.push(q);break}H.pop()}}return V}}class f{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(z,V,H){this.g=z,this.h=V,this.j=H,this.e=new n.$5dc("CodeLens"),this.f=new Map}async provideCodeLenses(z,V){const H=this.g.getDocument(z),G=await this.j.provideCodeLenses(H,V);if(!G||V.isCancellationRequested)return;const q=this.e.add(G),x=new a.$Qc;this.f.set(q,x);const ue={cacheId:q,lenses:[]};for(let Ne=0;Ne<G.length;Ne++)ue.lenses.push({cacheId:[q,Ne],range:C.Range.from(G[Ne].range),command:this.h.toInternal(G[Ne].command,x)});return ue}async resolveCodeLens(z,V){const H=z.cacheId&&this.e.get(...z.cacheId);if(!H)return;let G;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?G=H:G=await this.j.resolveCodeLens(H,V),G||(G=H),V.isCancellationRequested)return;const q=z.cacheId&&this.f.get(z.cacheId[0]);if(q)return z.command=this.h.toInternal(G.command??f.d,q),z}releaseCodeLenses(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}}function v(Pe){return Array.isArray(Pe)?Pe.map(C.DefinitionLink.from):Pe?[C.DefinitionLink.from(Pe)]:[]}class g{constructor(z,V){this.d=z,this.e=V}async provideDefinition(z,V,H){const G=this.d.getDocument(z),q=C.Position.to(V),x=await this.e.provideDefinition(G,q,H);return v(x)}}class D{constructor(z,V){this.d=z,this.e=V}async provideDeclaration(z,V,H){const G=this.d.getDocument(z),q=C.Position.to(V),x=await this.e.provideDeclaration(G,q,H);return v(x)}}class I{constructor(z,V){this.d=z,this.e=V}async provideImplementation(z,V,H){const G=this.d.getDocument(z),q=C.Position.to(V),x=await this.e.provideImplementation(G,q,H);return v(x)}}class h{constructor(z,V){this.d=z,this.e=V}async provideTypeDefinition(z,V,H){const G=this.d.getDocument(z),q=C.Position.to(V),x=await this.e.provideTypeDefinition(G,q,H);return v(x)}}class b{constructor(z,V){this.d=z,this.e=V}async provideHover(z,V,H){const G=this.d.getDocument(z),q=C.Position.to(V),x=await this.e.provideHover(G,q,H);if(!(!x||(0,A.$Jb)(x.contents)))return x.range||(x.range=G.getWordRangeAtPosition(q)),x.range||(x.range=new M.$DK(q,q)),C.Hover.from(x)}}class k{constructor(z,V){this.d=z,this.e=V}async provideEvaluatableExpression(z,V,H){const G=this.d.getDocument(z),q=C.Position.to(V),x=await this.e.provideEvaluatableExpression(G,q,H);if(x)return C.EvaluatableExpression.from(x)}}class F{constructor(z,V){this.d=z,this.e=V}async provideInlineValues(z,V,H,G){const q=this.d.getDocument(z),x=await this.e.provideInlineValues(q,C.Range.to(V),C.InlineValueContext.to(H),G);if(Array.isArray(x))return x.map(ue=>C.InlineValue.from(ue))}}class W{constructor(z,V){this.d=z,this.e=V}async provideDocumentHighlights(z,V,H){const G=this.d.getDocument(z),q=C.Position.to(V),x=await this.e.provideDocumentHighlights(G,q,H);if(Array.isArray(x))return x.map(C.DocumentHighlight.from)}}class J{constructor(z,V){this.d=z,this.e=V}async provideLinkedEditingRanges(z,V,H){const G=this.d.getDocument(z),q=C.Position.to(V),x=await this.e.provideLinkedEditingRanges(G,q,H);if(x&&Array.isArray(x.ranges))return{ranges:(0,A.$Gb)(x.ranges.map(C.Range.from)),wordPattern:x.wordPattern}}}class N{constructor(z,V){this.d=z,this.e=V}async provideReferences(z,V,H,G){const q=this.d.getDocument(z),x=C.Position.to(V),ue=await this.e.provideReferences(q,x,H,G);if(Array.isArray(ue))return ue.map(C.location.from)}}class R{static{this.d=1e3}constructor(z,V,H,G,q,x,ue){this.g=z,this.h=V,this.j=H,this.k=G,this.l=q,this.m=x,this.n=ue,this.e=new n.$5dc("CodeAction"),this.f=new Map}async provideCodeActions(z,V,H,G){const q=this.g.getDocument(z),x=l.$Ds.isISelection(V)?C.Selection.to(V):C.Range.to(V),ue=[];for(const _e of this.j.getDiagnostics(z))if(x.intersection(_e.range)&&ue.push(_e)>R.d)break;const Ne={diagnostics:ue,only:H.only?new M.$VK(H.only):void 0,triggerKind:C.CodeActionTriggerKind.to(H.trigger)},Be=await this.k.provideCodeActions(q,x,Ne,G);if(!(0,A.$Kb)(Be)||G.isCancellationRequested)return;const Xe=this.e.add(Be),Je=new a.$Qc;this.f.set(Xe,Je);const it=[];for(let _e=0;_e<Be.length;_e++){const tt=Be[_e];tt&&(R.o(tt)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:tt.title,command:this.h.toInternal(tt,Je)})):(Ne.only&&(tt.kind?Ne.only.contains(tt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${tt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[Xe,_e],title:tt.title,command:tt.command&&this.h.toInternal(tt.command,Je),diagnostics:tt.diagnostics&&tt.diagnostics.map(C.Diagnostic.from),edit:tt.edit&&C.WorkspaceEdit.from(tt.edit,void 0),kind:tt.kind&&tt.kind.value,isPreferred:tt.isPreferred,isAI:(0,i.$NF)(this.m,"codeActionAI")?tt.isAI:!1,disabled:tt.disabled?.reason})))}return{cacheId:Xe,actions:it}}async resolveCodeAction(z,V){const[H,G]=z,q=this.e.get(H,G);if(!q||R.o(q))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(q,V)??q;let ue;x.edit&&(ue=C.WorkspaceEdit.from(x.edit,void 0));let Ne;if(x.command){const Be=this.f.get(H);Be&&(Ne=this.h.toInternal(x.command,Be))}return{edit:ue,command:Ne}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class L{static toInternalProviderId(z,V){return z+"."+V}constructor(z,V,H,G,q){this.d=z,this.e=V,this.f=H,this.g=G,this.h=q}async prepareDocumentPaste(z,V,H,G){if(!this.f.prepareDocumentPaste)return;const q=this.e.getDocument(z),x=V.map(Be=>C.Range.to(Be)),ue=C.DataTransfer.toDataTransfer(H,()=>{throw new c.$0});if(await this.f.prepareDocumentPaste(q,x,ue,G),G.isCancellationRequested)return;const Ne=Array.from(ue).filter(([,Be])=>!(Be instanceof M.$pL));return C.DataTransfer.from(Ne)}async providePasteEdits(z,V,H,G,q){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(V),ue=H.map(Xe=>C.Range.to(Xe)),Ne=C.DataTransfer.toDataTransfer(G,async Xe=>(await this.d.$resolvePasteFileData(this.g,z,Xe)).buffer),Be=await this.f.provideDocumentPasteEdits(x,ue,Ne,q);if(Be)return{label:Be.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Be.yieldTo?.map(Xe=>"mimeType"in Xe?Xe:{providerId:L.toInternalProviderId(Xe.extensionId,Xe.providerId)}),insertText:typeof Be.insertText=="string"?Be.insertText:{snippet:Be.insertText.value},additionalEdit:Be.additionalEdit?C.WorkspaceEdit.from(Be.additionalEdit,void 0):void 0}}}class O{constructor(z,V){this.d=z,this.e=V}async provideDocumentFormattingEdits(z,V,H){const G=this.d.getDocument(z),q=await this.e.provideDocumentFormattingEdits(G,V,H);if(Array.isArray(q))return q.map(C.TextEdit.from)}}class X{constructor(z,V){this.d=z,this.e=V}async provideDocumentRangeFormattingEdits(z,V,H,G){const q=this.d.getDocument(z),x=C.Range.to(V),ue=await this.e.provideDocumentRangeFormattingEdits(q,x,H,G);if(Array.isArray(ue))return ue.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,V,H,G){(0,S.$Mf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const q=this.d.getDocument(z),x=V.map(C.Range.to),ue=await this.e.provideDocumentRangesFormattingEdits(q,x,H,G);if(Array.isArray(ue))return ue.map(C.TextEdit.from)}}class he{constructor(z,V){this.d=z,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,V,H,G,q){const x=this.d.getDocument(z),ue=C.Position.to(V),Ne=await this.e.provideOnTypeFormattingEdits(x,ue,H,G,q);if(Array.isArray(Ne))return Ne.map(C.TextEdit.from)}}class $e{constructor(z,V){this.e=z,this.f=V,this.d=new n.$5dc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,V){const H=await this.e.provideWorkspaceSymbols(z,V);if(!(0,A.$Kb)(H))return{symbols:[]};const G=this.d.add(H),q={cacheId:G,symbols:[]};for(let x=0;x<H.length;x++){const ue=H[x];if(!ue||!ue.name){this.f.warn("INVALID SymbolInformation",ue);continue}q.symbols.push({...C.WorkspaceSymbol.from(ue),cacheId:[G,x]})}return q}async resolveWorkspaceSymbol(z,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const H=this.d.get(...z.cacheId);if(H){const G=await this.e.resolveWorkspaceSymbol(H,V);return G&&(0,T.$fn)(z,C.WorkspaceSymbol.from(G),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class De{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,V,H){this.d=z,this.e=V,this.f=H}async provideRenameEdits(z,V,H,G){const q=this.d.getDocument(z),x=C.Position.to(V);try{const ue=await this.e.provideRenameEdits(q,x,H,G);return ue?C.WorkspaceEdit.from(ue):void 0}catch(ue){const Ne=De.g(ue);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(ue)}}async resolveRenameLocation(z,V,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const G=this.d.getDocument(z),q=C.Position.to(V);try{const x=await this.e.prepareRename(G,q,H);let ue,Ne;if(M.$DK.isRange(x)?(ue=x,Ne=G.getText(x)):(0,S.$Ef)(x)&&(ue=x.range,Ne=x.placeholder),!ue||!Ne)return;if(ue.start.line>q.line||ue.end.line<q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ue),text:Ne}}catch(x){const ue=De.g(x);return ue?{rejectReason:ue,range:void 0,text:void 0}:Promise.reject(x)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ke{constructor(z,V){this.resultId=z,this.tokens=V}}class de{constructor(z,V){this.f=z,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,V,H){const G=this.f.getDocument(z),q=V!==0?this.d.get(V):null;let x=typeof q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(G,q.resultId,H):await this.g.provideDocumentSemanticTokens(G,H);return q&&this.d.delete(V),x?(x=de.h(x),this.o(de.n(q,x),x)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return de.j(z)?de.k(z)?z:new M.$SL(new Uint32Array(z.data),z.resultId):de.l(z)?de.m(z)?z:new M.$UL(z.edits.map(V=>new M.$TL(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const V of z.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(z,V){if(!de.j(V)||!z||!z.tokens)return V;const H=z.tokens,G=H.length,q=V.data,x=q.length;let ue=0;const Ne=Math.min(G,x);for(;ue<Ne&&H[ue]===q[ue];)ue++;if(ue===G&&ue===x)return new M.$UL([],V.resultId);let Be=0;const Xe=Ne-ue;for(;Be<Xe&&H[G-Be-1]===q[x-Be-1];)Be++;return new M.$UL([{start:ue,deleteCount:G-ue-Be,data:q.subarray(ue,x-Be)}],V.resultId)}o(z,V){if(de.j(z)){const H=this.e++;return this.d.set(H,new ke(z.resultId,z.data)),(0,s.$Z0)({id:H,type:"full",data:z.data})}if(de.l(z)){const H=this.e++;return de.j(V)?this.d.set(H,new ke(V.resultId,V.data)):this.d.set(H,new ke(z.resultId)),(0,s.$Z0)({id:H,type:"delta",deltas:(z.edits||[]).map(G=>({start:G.start,deleteCount:G.deleteCount,data:G.data}))})}return null}}class Ee{constructor(z,V){this.d=z,this.e=V}async provideDocumentRangeSemanticTokens(z,V,H){const G=this.d.getDocument(z),q=await this.e.provideDocumentRangeSemanticTokens(G,C.Range.to(V),H);return q?this.f(q):null}f(z){return(0,s.$Z0)({id:0,type:"full",data:z.data})}}class _{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,V,H,G,q){this.f=z,this.g=V,this.h=H,this.j=G,this.k=q,this.d=new n.$5dc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,V,H,G){const q=this.f.getDocument(z),x=C.Position.to(V),ue=q.getWordRangeAtPosition(x)||new M.$DK(x,x),Ne=ue.with({end:x}),Be=new o.$Nd,Xe=await this.h.provideCompletionItems(q,x,G,C.CompletionContext.to(H));if(!Xe||G.isCancellationRequested)return;const Je=Array.isArray(Xe)?new M.$9K(Xe):Xe,it=_.supportsResolving(this.h)?this.d.add(Je.items):this.d.add([]),_e=new a.$Qc;this.e.set(it,_e);const tt=[],rt={x:it,b:tt,a:{replace:C.Range.from(ue),insert:C.Range.from(Ne)},c:Je.isIncomplete||void 0,d:Be.elapsed()};for(let nt=0;nt<Je.items.length;nt++){const ze=Je.items[nt],ht=this.l(ze,[it,nt],Ne,ue);tt.push(ht)}return rt}async resolveCompletionItem(z,V){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...z);if(!H)return;const G=this.l(H,z),q=await this.h.resolveCompletionItem(H,V);if(!q)return;const x=this.l(q,z);return(G.h!==x.h||G.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(G.n!==x.n||G.o!==x.o||!(0,T.$gn)(G.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...G,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,V,H,G){const q=this.e.get(V[0]);if(!q)throw Error("DisposableStore is missing...");const x=this.g.toInternal(z.command,q),ue={x:V,a:z.label,b:z.kind!==void 0?C.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(C.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:C.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(C.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ue.h=z.textEdit.newText):typeof z.insertText=="string"?ue.h=z.insertText:z.insertText instanceof M.$MK&&(ue.h=z.insertText.value,ue.i|=4);let Ne;return z.textEdit?Ne=z.textEdit.range:z.range&&(Ne=z.range),M.$DK.isRange(Ne)?ue.j=C.Range.from(Ne):Ne&&(!H?.isEqual(Ne.inserting)||!G?.isEqual(Ne.replacing))&&(ue.j={insert:C.Range.from(Ne.inserting),replace:C.Range.from(Ne.replacing)}),ue}}class Ce{async provideInlineCompletions(z,V,H,G){}disposeCompletions(z){}handleDidShowCompletionItem(z,V,H){}handlePartialAccept(z,V,H){}}class se extends Ce{constructor(z,V,H,G){super(),this.f=z,this.g=V,this.h=H,this.j=G,this.d=new Q,this.e=(0,i.$NF)(this.f,"inlineCompletionsAdditions"),this.k={[P.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[P.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$NF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,V,H,G){const q=this.g.getDocument(z),x=C.Position.to(V),ue=await this.h.provideInlineCompletionItems(q,x,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:C.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},G);if(!ue||G.isCancellationRequested)return;const Ne=Array.isArray(ue)?ue:ue.items,Be=this.e?Array.isArray(ue)?[]:ue.commands||[]:[],Xe=this.e&&!Array.isArray(ue)?ue.enableForwardStability:void 0;let Je;return{pid:this.d.createReferenceId({dispose(){Je?.dispose()},items:Ne}),items:Ne.map((_e,tt)=>{let rt;_e.command&&(Je||(Je=new a.$Qc),rt=this.j.toInternal(_e.command,Je));const nt=_e.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:_e.filterText,range:_e.range?C.Range.from(_e.range):void 0,command:rt,idx:tt,completeBracketPairs:this.e?_e.completeBracketPairs:!1}}),commands:Be.map(_e=>(Je||(Je=new a.$Qc),this.j.toInternal(_e,Je))),suppressSuggestions:!1,enableForwardStability:Xe}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,V,H){const G=this.d.get(z)?.items[V];G&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(G,H)}handlePartialAccept(z,V,H){const G=this.d.get(z)?.items[V];G&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(G,H)}}class Q{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const V=this.e++;return this.d.set(V,z),V}disposeReferenceId(z){const V=this.d.get(z);return this.d.delete(z),V}get(z){return this.d.get(z)}}class U{constructor(z,V){this.e=z,this.f=V,this.d=new n.$5dc("SignatureHelp")}async provideSignatureHelp(z,V,H,G){const q=this.e.getDocument(z),x=C.Position.to(V),ue=this.g(H),Ne=await this.f.provideSignatureHelp(q,x,G,ue);if(Ne){const Be=this.d.add([Ne]);return{...C.SignatureHelp.from(Ne),id:Be}}}g(z){let V;if(z.activeSignatureHelp){const H=C.SignatureHelp.to(z.activeSignatureHelp),G=this.d.get(z.activeSignatureHelp.id,0);G?(V=G,V.activeSignature=H.activeSignature,V.activeParameter=H.activeParameter):V=H}return{...z,activeSignatureHelp:V}}releaseSignatureHelp(z){this.d.delete(z)}}class ne{constructor(z,V,H,G,q){this.f=z,this.g=V,this.h=H,this.j=G,this.k=q,this.d=new n.$5dc("InlayHints"),this.e=new Map}async provideInlayHints(z,V,H){const G=this.f.getDocument(z),q=C.Range.to(V),x=await this.h.provideInlayHints(G,q,H);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`);return}if(H.isCancellationRequested)return;const ue=this.d.add(x);this.e.set(ue,new a.$Qc);const Ne={hints:[],cacheId:ue};for(let Be=0;Be<x.length;Be++)this.l(x[Be],q)&&Ne.hints.push(this.m(x[Be],[ue,Be]));return this.j.trace(`[InlayHints] ${Ne.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`),Ne}async resolveInlayHint(z,V){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...z);if(!H)return;const G=await this.h.resolveInlayHint(H,V);if(G&&this.l(G))return this.m(G,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,V){return z.label.length===0||Array.isArray(z.label)&&z.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(V&&!V.contains(z.position))}m(z,V){const H=this.e.get(V[0]);if(!H)throw Error("DisposableStore is missing...");const G={label:"",cacheId:V,tooltip:C.MarkdownString.fromStrict(z.tooltip),position:C.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(C.TextEdit.from),kind:z.kind&&C.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};return typeof z.label=="string"?G.label=z.label:G.label=z.label.map(q=>{const x={label:q.value};return x.tooltip=C.MarkdownString.fromStrict(q.tooltip),M.$NK.isLocation(q.location)&&(x.location=C.location.from(q.location)),q.command&&(x.command=this.g.toInternal(q.command,H)),x}),G}}class pe{constructor(z,V){this.e=z,this.f=V,this.d=new n.$5dc("DocumentLink")}async provideLinks(z,V){const H=this.e.getDocument(z),G=await this.f.provideDocumentLinks(H,V);if(!(!Array.isArray(G)||G.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:G.filter(pe.g).map(C.DocumentLink.from)};{const q=this.d.add(G),x={links:[],cacheId:q};for(let ue=0;ue<G.length;ue++){if(!pe.g(G[ue]))continue;const Ne=C.DocumentLink.from(G[ue]);Ne.cacheId=[q,ue],x.links.push(Ne)}return x}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,V){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...z);if(!H)return;const G=await this.f.resolveDocumentLink(H,V);if(!(!G||!pe.g(G)))return C.DocumentLink.from(G)}releaseLinks(z){this.d.delete(z)}}class re{constructor(z,V){this.d=z,this.e=V}async provideColors(z,V){const H=this.d.getDocument(z),G=await this.e.provideDocumentColors(H,V);return Array.isArray(G)?G.map(x=>({color:C.Color.from(x.color),range:C.Range.from(x.range)})):[]}async provideColorPresentations(z,V,H){const G=this.d.getDocument(z),q=C.Range.to(V.range),x=C.Color.to(V.color),ue=await this.e.provideColorPresentations(x,{document:G,range:q},H);if(Array.isArray(ue))return ue.map(C.ColorPresentation.from)}}class le{constructor(z,V){this.d=z,this.e=V}async provideFoldingRanges(z,V,H){const G=this.d.getDocument(z),q=await this.e.provideFoldingRanges(G,V,H);if(Array.isArray(q))return q.map(C.FoldingRange.from)}}class ce{constructor(z,V,H){this.d=z,this.e=V,this.f=H}async provideSelectionRanges(z,V,H){const G=this.d.getDocument(z),q=V.map(C.Position.to),x=await this.e.provideSelectionRanges(G,q,H);if(!(0,A.$Kb)(x))return[];if(x.length!==q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ue=[];for(let Ne=0;Ne<q.length;Ne++){const Be=[];ue.push(Be);let Xe=q[Ne],Je=x[Ne];for(;;){if(!Je.range.contains(Xe))throw new Error("INVALID selection range, must contain the previous range");if(Be.push(C.SelectionRange.from(Je)),!Je.parent)break;Xe=Je.range,Je=Je.parent}}return ue}}class be{constructor(z,V){this.f=z,this.g=V,this.d=new t.$GM(""),this.e=new Map}async prepareSession(z,V,H){const G=this.f.getDocument(z),q=C.Position.to(V),x=await this.g.prepareCallHierarchy(G,q,H);if(!x)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(x)?x.map(Ne=>this.h(ue,Ne)):[this.h(ue,x)]}async provideCallsTo(z,V,H){const G=this.j(z,V);if(!G)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyIncomingCalls(G,H);if(q)return q.map(x=>({from:this.h(z,x.from),fromRanges:x.fromRanges.map(ue=>C.Range.from(ue))}))}async provideCallsFrom(z,V,H){const G=this.j(z,V);if(!G)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyOutgoingCalls(G,H);if(q)return q.map(x=>({to:this.h(z,x.to),fromRanges:x.fromRanges.map(ue=>C.Range.from(ue))}))}releaseSession(z){this.e.delete(z)}h(z,V){const H=this.e.get(z),G=C.CallHierarchyItem.from(V,z,H.size.toString(36));return H.set(G._itemId,V),G}j(z,V){return this.e.get(z)?.get(V)}}class ee{constructor(z,V){this.f=z,this.g=V,this.d=new t.$GM(""),this.e=new Map}async prepareSession(z,V,H){const G=this.f.getDocument(z),q=C.Position.to(V),x=await this.g.prepareTypeHierarchy(G,q,H);if(!x)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(x)?x.map(Ne=>this.h(ue,Ne)):[this.h(ue,x)]}async provideSupertypes(z,V,H){const G=this.j(z,V);if(!G)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySupertypes(G,H);if(q)return q.map(x=>this.h(z,x))}async provideSubtypes(z,V,H){const G=this.j(z,V);if(!G)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySubtypes(G,H);if(q)return q.map(x=>this.h(z,x))}releaseSession(z){this.e.delete(z)}h(z,V){const H=this.e.get(z),G=C.TypeHierarchyItem.from(V,z,H.size.toString(36));return H.set(G._itemId,V),G}j(z,V){return this.e.get(z)?.get(V)}}class fe{static toInternalProviderId(z,V){return z+"."+V}constructor(z,V,H,G,q){this.d=z,this.e=V,this.f=H,this.g=G,this.h=q}async provideDocumentOnDropEdits(z,V,H,G,q){const x=this.e.getDocument(V),ue=C.Position.to(H),Ne=C.DataTransfer.toDataTransfer(G,async Xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,z,Xe)).buffer),Be=await this.f.provideDocumentDropEdits(x,ue,Ne,q);if(Be)return{label:Be.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Be.yieldTo?.map(Xe=>"mimeType"in Xe?Xe:{providerId:fe.toInternalProviderId(Xe.extensionId,Xe.providerId)}),insertText:typeof Be.insertText=="string"?Be.insertText:{snippet:Be.insertText.value},additionalEdit:Be.additionalEdit?C.WorkspaceEdit.from(Be.additionalEdit,void 0):void 0}}}class ie{constructor(z,V){this.d=z,this.e=V}async provideMappedEdits(z,V,H,G){const q=E.URI.revive(z),x=this.d.getDocument(q),ue=H.documents.map(Xe=>Xe.map(Je=>({uri:E.URI.revive(Je.uri),version:Je.version,ranges:Je.ranges.map(it=>C.Range.to(it))}))),Ne={documents:ue,selections:ue[0]?.[0]?.ranges??[]},Be=await this.e.provideMappedEdits(x,V,Ne,G);return Be?C.WorkspaceEdit.from(Be):null}}class ae{constructor(z,V){this.adapter=z,this.extension=V}}class me{static{this.d=0}constructor(z,V,H,G,q,x,ue,Ne){this.g=V,this.h=H,this.j=G,this.k=q,this.l=x,this.m=ue,this.n=Ne,this.f=new Map,this.e=z.getProxy($.$zK.MainThreadLanguageFeatures)}o(z,V){return C.DocumentSelector.from(z,this.g,V)}p(z){return new M.$BK(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return me.d++}async s(z,V,H,G,q,x=!1){const ue=this.f.get(z);if(!ue||!(ue.adapter instanceof V))return G;const Ne=Date.now();x||this.l.trace(`[${ue.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Be=H(ue.adapter,ue.extension);return Promise.resolve(Be).catch(Xe=>{(0,c.$3)(Xe)||(this.l.error(`[${ue.extension.identifier.value}] provider FAILED`),this.l.error(Xe),this.n.onExtensionError(ue.extension.identifier,Xe))}).finally(()=>{x||this.l.trace(`[${ue.extension.identifier.value}] provider DONE after ${Date.now()-Ne}ms`)}),p.CancellationToken.isCancellationToken(q)?(0,d.$Pg)(Be,q):Be}t(z,V){const H=this.q();return this.f.set(H,new ae(z,V)),H}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,V,H,G){const q=this.t(new u(this.h,H),z),x=G&&G.label||me.u(z);return this.e.$registerDocumentSymbolProvider(q,this.o(V,z),x),this.p(q)}$provideDocumentSymbols(z,V,H){return this.s(z,u,G=>G.provideDocumentSymbols(E.URI.revive(V),H),void 0,H)}registerCodeLensProvider(z,V,H){const G=this.q(),q=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(G,new ae(new f(this.h,this.j.converter,H),z)),this.e.$registerCodeLensSupport(G,this.o(V,z),q);let x=this.p(G);if(q!==void 0){const ue=H.onDidChangeCodeLenses(Ne=>this.e.$emitCodeLensEvent(q));x=M.$BK.from(x,ue)}return x}$provideCodeLenses(z,V,H){return this.s(z,f,G=>G.provideCodeLenses(E.URI.revive(V),H),void 0,H)}$resolveCodeLens(z,V,H){return this.s(z,f,G=>G.resolveCodeLens(V,H),void 0,void 0)}$releaseCodeLenses(z,V){this.s(z,f,H=>Promise.resolve(H.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(z,V,H){const G=this.t(new g(this.h,H),z);return this.e.$registerDefinitionSupport(G,this.o(V,z)),this.p(G)}$provideDefinition(z,V,H,G){return this.s(z,g,q=>q.provideDefinition(E.URI.revive(V),H,G),[],G)}registerDeclarationProvider(z,V,H){const G=this.t(new D(this.h,H),z);return this.e.$registerDeclarationSupport(G,this.o(V,z)),this.p(G)}$provideDeclaration(z,V,H,G){return this.s(z,D,q=>q.provideDeclaration(E.URI.revive(V),H,G),[],G)}registerImplementationProvider(z,V,H){const G=this.t(new I(this.h,H),z);return this.e.$registerImplementationSupport(G,this.o(V,z)),this.p(G)}$provideImplementation(z,V,H,G){return this.s(z,I,q=>q.provideImplementation(E.URI.revive(V),H,G),[],G)}registerTypeDefinitionProvider(z,V,H){const G=this.t(new h(this.h,H),z);return this.e.$registerTypeDefinitionSupport(G,this.o(V,z)),this.p(G)}$provideTypeDefinition(z,V,H,G){return this.s(z,h,q=>q.provideTypeDefinition(E.URI.revive(V),H,G),[],G)}registerHoverProvider(z,V,H,G){const q=this.t(new b(this.h,H),z);return this.e.$registerHoverProvider(q,this.o(V,z)),this.p(q)}$provideHover(z,V,H,G){return this.s(z,b,q=>q.provideHover(E.URI.revive(V),H,G),void 0,G)}registerEvaluatableExpressionProvider(z,V,H,G){const q=this.t(new k(this.h,H),z);return this.e.$registerEvaluatableExpressionProvider(q,this.o(V,z)),this.p(q)}$provideEvaluatableExpression(z,V,H,G){return this.s(z,k,q=>q.provideEvaluatableExpression(E.URI.revive(V),H,G),void 0,G)}registerInlineValuesProvider(z,V,H,G){const q=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new F(this.h,H),z);this.e.$registerInlineValuesProvider(x,this.o(V,z),q);let ue=this.p(x);if(q!==void 0){const Ne=H.onDidChangeInlineValues(Be=>this.e.$emitInlineValuesEvent(q));ue=M.$BK.from(ue,Ne)}return ue}$provideInlineValues(z,V,H,G,q){return this.s(z,F,x=>x.provideInlineValues(E.URI.revive(V),H,G,q),void 0,q)}registerDocumentHighlightProvider(z,V,H){const G=this.t(new W(this.h,H),z);return this.e.$registerDocumentHighlightProvider(G,this.o(V,z)),this.p(G)}$provideDocumentHighlights(z,V,H,G){return this.s(z,W,q=>q.provideDocumentHighlights(E.URI.revive(V),H,G),void 0,G)}registerLinkedEditingRangeProvider(z,V,H){const G=this.t(new J(this.h,H),z);return this.e.$registerLinkedEditingRangeProvider(G,this.o(V,z)),this.p(G)}$provideLinkedEditingRanges(z,V,H,G){return this.s(z,J,async q=>{const x=await q.provideLinkedEditingRanges(E.URI.revive(V),H,G);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?me.w(x.wordPattern):void 0}},void 0,G)}registerReferenceProvider(z,V,H){const G=this.t(new N(this.h,H),z);return this.e.$registerReferenceSupport(G,this.o(V,z)),this.p(G)}$provideReferences(z,V,H,G,q){return this.s(z,N,x=>x.provideReferences(E.URI.revive(V),H,G,q),void 0,q)}registerCodeActionProvider(z,V,H,G){const q=new a.$Qc,x=this.t(new R(this.h,this.j.converter,this.k,H,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(x,this.o(V,z),{providedKinds:G?.providedCodeActionKinds?.map(ue=>ue.value),documentation:G?.documentation?.map(ue=>({kind:ue.kind.value,command:this.j.converter.toInternal(ue.command,q)}))},me.u(z),!!H.resolveCodeAction),q.add(this.p(x)),q}$provideCodeActions(z,V,H,G,q){return this.s(z,R,x=>x.provideCodeActions(E.URI.revive(V),H,G,q),void 0,q)}$resolveCodeAction(z,V,H){return this.s(z,R,G=>G.resolveCodeAction(V,H),{},void 0)}$releaseCodeActions(z,V){this.s(z,R,H=>Promise.resolve(H.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(z,V,H){const G=this.t(new O(this.h,H),z);return this.e.$registerDocumentFormattingSupport(G,this.o(V,z),z.identifier,z.displayName||z.name),this.p(G)}$provideDocumentFormattingEdits(z,V,H,G){return this.s(z,O,q=>q.provideDocumentFormattingEdits(E.URI.revive(V),H,G),void 0,G)}registerDocumentRangeFormattingEditProvider(z,V,H){const G=typeof H.provideDocumentRangesFormattingEdits=="function",q=this.t(new X(this.h,H),z);return this.e.$registerRangeFormattingSupport(q,this.o(V,z),z.identifier,z.displayName||z.name,G),this.p(q)}$provideDocumentRangeFormattingEdits(z,V,H,G,q){return this.s(z,X,x=>x.provideDocumentRangeFormattingEdits(E.URI.revive(V),H,G,q),void 0,q)}$provideDocumentRangesFormattingEdits(z,V,H,G,q){return this.s(z,X,x=>x.provideDocumentRangesFormattingEdits(E.URI.revive(V),H,G,q),void 0,q)}registerOnTypeFormattingEditProvider(z,V,H,G){const q=this.t(new he(this.h,H),z);return this.e.$registerOnTypeFormattingSupport(q,this.o(V,z),G,z.identifier),this.p(q)}$provideOnTypeFormattingEdits(z,V,H,G,q,x){return this.s(z,he,ue=>ue.provideOnTypeFormattingEdits(E.URI.revive(V),H,G,q,x),void 0,x)}registerWorkspaceSymbolProvider(z,V){const H=this.t(new $e(V,this.l),z);return this.e.$registerNavigateTypeSupport(H,typeof V.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(z,V,H){return this.s(z,$e,G=>G.provideWorkspaceSymbols(V,H),{symbols:[]},H)}$resolveWorkspaceSymbol(z,V,H){return this.s(z,$e,G=>G.resolveWorkspaceSymbol(V,H),void 0,void 0)}$releaseWorkspaceSymbols(z,V){this.s(z,$e,H=>H.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(z,V,H){const G=this.t(new De(this.h,H,this.l),z);return this.e.$registerRenameSupport(G,this.o(V,z),De.supportsResolving(H)),this.p(G)}$provideRenameEdits(z,V,H,G,q){return this.s(z,De,x=>x.provideRenameEdits(E.URI.revive(V),H,G,q),void 0,q)}$resolveRenameLocation(z,V,H,G){return this.s(z,De,q=>q.resolveRenameLocation(E.URI.revive(V),H,G),void 0,G)}registerDocumentSemanticTokensProvider(z,V,H,G){const q=this.t(new de(this.h,H),z),x=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(q,this.o(V,z),G,x);let ue=this.p(q);if(x){const Ne=H.onDidChangeSemanticTokens(Be=>this.e.$emitDocumentSemanticTokensEvent(x));ue=M.$BK.from(ue,Ne)}return ue}$provideDocumentSemanticTokens(z,V,H,G){return this.s(z,de,q=>q.provideDocumentSemanticTokens(E.URI.revive(V),H,G),null,G)}$releaseDocumentSemanticTokens(z,V){this.s(z,de,H=>H.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,V,H,G){const q=this.t(new Ee(this.h,H),z);return this.e.$registerDocumentRangeSemanticTokensProvider(q,this.o(V,z),G),this.p(q)}$provideDocumentRangeSemanticTokens(z,V,H,G){return this.s(z,Ee,q=>q.provideDocumentRangeSemanticTokens(E.URI.revive(V),H,G),null,G)}registerCompletionItemProvider(z,V,H,G){const q=this.t(new _(this.h,this.j.converter,H,this.m,z),z);return this.e.$registerCompletionsProvider(q,this.o(V,z),G,_.supportsResolving(H),z.identifier),this.p(q)}$provideCompletionItems(z,V,H,G,q){return this.s(z,_,x=>x.provideCompletionItems(E.URI.revive(V),H,G,q),void 0,q)}$resolveCompletionItem(z,V,H){return this.s(z,_,G=>G.resolveCompletionItem(V,H),void 0,H)}$releaseCompletionItems(z,V){this.s(z,_,H=>H.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(z,V,H,G){const q=new se(z,this.h,H,this.j.converter),x=this.t(q,z);return this.e.$registerInlineCompletionsSupport(x,this.o(V,z),q.supportsHandleEvents,w.$bm.toKey(z.identifier.value),G?.yieldTo?.map(ue=>w.$bm.toKey(ue))||[]),this.p(x)}$provideInlineCompletions(z,V,H,G,q){return this.s(z,Ce,x=>x.provideInlineCompletions(E.URI.revive(V),H,G,q),void 0,q)}$handleInlineCompletionDidShow(z,V,H,G){this.s(z,Ce,async q=>{q.handleDidShowCompletionItem(V,H,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,V,H,G){this.s(z,Ce,async q=>{q.handlePartialAccept(V,H,G)},void 0,void 0)}$freeInlineCompletionsList(z,V){this.s(z,Ce,async H=>{H.disposeCompletions(V)},void 0,void 0)}registerSignatureHelpProvider(z,V,H,G){const q=Array.isArray(G)?{triggerCharacters:G,retriggerCharacters:[]}:G,x=this.t(new U(this.h,H),z);return this.e.$registerSignatureHelpProvider(x,this.o(V,z),q),this.p(x)}$provideSignatureHelp(z,V,H,G,q){return this.s(z,U,x=>x.provideSignatureHelp(E.URI.revive(V),H,G,q),void 0,q)}$releaseSignatureHelp(z,V){this.s(z,U,H=>H.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(z,V,H){const G=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,q=this.t(new ne(this.h,this.j.converter,H,this.l,z),z);this.e.$registerInlayHintsProvider(q,this.o(V,z),typeof H.resolveInlayHint=="function",G,me.u(z));let x=this.p(q);if(G!==void 0){const ue=H.onDidChangeInlayHints(Ne=>this.e.$emitInlayHintsEvent(G));x=M.$BK.from(x,ue)}return x}$provideInlayHints(z,V,H,G){return this.s(z,ne,q=>q.provideInlayHints(E.URI.revive(V),H,G),void 0,G)}$resolveInlayHint(z,V,H){return this.s(z,ne,G=>G.resolveInlayHint(V,H),void 0,H)}$releaseInlayHints(z,V){this.s(z,ne,H=>H.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(z,V,H){const G=this.t(new pe(this.h,H),z);return this.e.$registerDocumentLinkProvider(G,this.o(V,z),typeof H.resolveDocumentLink=="function"),this.p(G)}$provideDocumentLinks(z,V,H){return this.s(z,pe,G=>G.provideLinks(E.URI.revive(V),H),void 0,H,V.scheme==="output")}$resolveDocumentLink(z,V,H){return this.s(z,pe,G=>G.resolveLink(V,H),void 0,void 0,!0)}$releaseDocumentLinks(z,V){this.s(z,pe,H=>H.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(z,V,H){const G=this.t(new re(this.h,H),z);return this.e.$registerDocumentColorProvider(G,this.o(V,z)),this.p(G)}$provideDocumentColors(z,V,H){return this.s(z,re,G=>G.provideColors(E.URI.revive(V),H),[],H)}$provideColorPresentations(z,V,H,G){return this.s(z,re,q=>q.provideColorPresentations(E.URI.revive(V),H,G),void 0,G)}registerFoldingRangeProvider(z,V,H){const G=this.q(),q=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(G,new ae(new le(this.h,H),z)),this.e.$registerFoldingRangeProvider(G,this.o(V,z),z.identifier,q);let x=this.p(G);if(q!==void 0){const ue=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(q));x=M.$BK.from(x,ue)}return x}$provideFoldingRanges(z,V,H,G){return this.s(z,le,q=>q.provideFoldingRanges(E.URI.revive(V),H,G),void 0,G)}registerSelectionRangeProvider(z,V,H){const G=this.t(new ce(this.h,H,this.l),z);return this.e.$registerSelectionRangeProvider(G,this.o(V,z)),this.p(G)}$provideSelectionRanges(z,V,H,G){return this.s(z,ce,q=>q.provideSelectionRanges(E.URI.revive(V),H,G),[],G)}registerCallHierarchyProvider(z,V,H){const G=this.t(new be(this.h,H),z);return this.e.$registerCallHierarchyProvider(G,this.o(V,z)),this.p(G)}$prepareCallHierarchy(z,V,H,G){return this.s(z,be,q=>Promise.resolve(q.prepareSession(E.URI.revive(V),H,G)),void 0,G)}$provideCallHierarchyIncomingCalls(z,V,H,G){return this.s(z,be,q=>q.provideCallsTo(V,H,G),void 0,G)}$provideCallHierarchyOutgoingCalls(z,V,H,G){return this.s(z,be,q=>q.provideCallsFrom(V,H,G),void 0,G)}$releaseCallHierarchy(z,V){this.s(z,be,H=>Promise.resolve(H.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(z,V,H){const G=this.t(new ee(this.h,H),z);return this.e.$registerTypeHierarchyProvider(G,this.o(V,z)),this.p(G)}$prepareTypeHierarchy(z,V,H,G){return this.s(z,ee,q=>Promise.resolve(q.prepareSession(E.URI.revive(V),H,G)),void 0,G)}$provideTypeHierarchySupertypes(z,V,H,G){return this.s(z,ee,q=>q.provideSupertypes(V,H,G),void 0,G)}$provideTypeHierarchySubtypes(z,V,H,G){return this.s(z,ee,q=>q.provideSubtypes(V,H,G),void 0,G)}$releaseTypeHierarchy(z,V){this.s(z,ee,H=>Promise.resolve(H.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(z,V,H,G){const q=this.q();this.f.set(q,new ae(new fe(this.e,this.h,H,q,z),z));const x=(0,i.$NF)(z,"dropMetadata")&&G?fe.toInternalProviderId(z.identifier.value,G.id):void 0;return this.e.$registerDocumentOnDropEditProvider(q,this.o(V,z),x,(0,i.$NF)(z,"dropMetadata")?G:void 0),this.p(q)}$provideDocumentOnDropEdits(z,V,H,G,q,x){return this.s(z,fe,ue=>Promise.resolve(ue.provideDocumentOnDropEdits(V,E.URI.revive(H),G,q,x)),void 0,void 0)}registerMappedEditsProvider(z,V,H){const G=this.t(new ie(this.h,H),z);return this.e.$registerMappedEditsProvider(G,this.o(V,z)),this.p(G)}$provideMappedEdits(z,V,H,G,q){return this.s(z,ie,x=>Promise.resolve(x.provideMappedEdits(V,H,G,q)),null,q)}registerDocumentPasteEditProvider(z,V,H,G){const q=this.q();this.f.set(q,new ae(new L(this.e,this.h,H,q,z),z));const x=L.toInternalProviderId(z.identifier.value,G.id);return this.e.$registerPasteEditProvider(q,this.o(V,z),x,{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,copyMimeTypes:G.copyMimeTypes,pasteMimeTypes:G.pasteMimeTypes}),this.p(q)}$prepareDocumentPaste(z,V,H,G,q){return this.s(z,L,x=>x.prepareDocumentPaste(E.URI.revive(V),H,G,q),void 0,q)}$providePasteEdits(z,V,H,G,q,x){return this.s(z,L,ue=>ue.providePasteEdits(V,E.URI.revive(H),G,q,x),void 0,x)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:me.w(z.decreaseIndentPattern),increaseIndentPattern:me.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?me.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?me.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:me.w(z.beforeText),afterText:z.afterText?me.w(z.afterText):void 0,previousLineText:z.previousLineText?me.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(me.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(V=>M.SyntaxTokenType.toString(V)):void 0}}static D(z){return z.map(me.C)}setLanguageConfiguration(z,V,H){const{wordPattern:G}=H;if(G&&(0,m.$Se)(G))throw new Error(`Invalid language configuration: wordPattern '${G}' is not allowed to match the empty string.`);G?this.h.setWordDefinitionFor(V,G):this.h.setWordDefinitionFor(V,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const q=this.q(),x={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?me.w(H.wordPattern):void 0,indentationRules:H.indentationRules?me.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?me.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?me.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(q,V,x),this.p(q)}$setWordDefinitions(z){for(const V of z)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$cec=me}),define(Ae[254],Re([1,0,3,8,7,31,14,6,23]),function(we,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;class y{constructor(S,l,p,w){this.c=l,this.d=p,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(E.$zK.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,l){await this.a.$changeLanguage(S,l);const p=this.c.getDocumentData(S);if(!p)throw new Error(`document '${S.toString()}' NOT found`);return p.document}async tokenAtPosition(S,l){const p=S.version,w=T.Position.from(l),a=await this.a.$tokensAtPosition(S.uri,w),s={type:C.StandardTokenType.Other,range:S.getWordRangeAtPosition(l)??new C.$DK(l.line,l.character,l.line,l.character)};if(!a)return s;const t={range:T.Range.to(a.range),type:T.TokenType.to(a.type)};return!t.range.contains(l)||p!==S.version?s:t}createLanguageStatusItem(S,l,p){const w=this.f++,a=this.a,s=this.g,t=`${S.identifier.value}/${l}`;if(s.has(t))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);s.add(t);const n={selector:p,id:l,name:S.displayName??S.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const c=new $.$Qc,d=()=>{if(o?.dispose(),!s.has(t)){console.warn(`LanguageStatusItem (${l}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,P.$2g)(()=>{c.clear(),this.a.$setLanguageStatus(w,{id:t,name:n.name??S.displayName??S.name,source:S.displayName??S.name,selector:T.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===C.LanguageStatusSeverity.Error?M.default.Error:n.severity===C.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){c.dispose(),o?.dispose(),a.$removeLanguageStatus(w),s.delete(t)},get id(){return n.id},get name(){return n.name},set name(r){n.name=r,d()},get selector(){return n.selector},set selector(r){n.selector=r,d()},get text(){return n.text},set text(r){n.text=r,d()},set text2(r){(0,m.$OF)(S,"languageStatusText"),n.text=r,d()},get text2(){return(0,m.$OF)(S,"languageStatusText"),n.text},get detail(){return n.detail},set detail(r){n.detail=r,d()},get severity(){return n.severity},set severity(r){n.severity=r,d()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(r){n.accessibilityInformation=r,d()},get command(){return n.command},set command(r){n.command=r,d()},get busy(){return n.busy},set busy(r){n.busy=r,d()}};return d(),i}}e.$Bfc=y}),define(Ae[82],Re([1,0,21,12,2,4,15,3,27,17]),function(we,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=e.$Zec=void 0;let A=class{constructor(l,p,w){this.f=w,this.d=new Map,this.a=p.getProxy($.$zK.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===E.$g}getMessage(l,p){const{message:w,args:a,comment:s}=p;if(this.c)return(0,T.$He)(w,a??{});let t=w;s&&s.length>0&&(t+=`/${Array.isArray(s)?s.join(""):s}`);const n=this.d.get(l)?.contents[t];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${t}`),(0,T.$He)(n??w,a??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let p;const w=await this.g(l);if(!w){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(w),s=JSON.parse(a);p=l.isBuiltin?s.contents?.bundle:s}catch(a){this.f.error(`Failed to load translations for ${l.identifier.value} from ${w}: ${a.message}`);return}p&&this.d.set(l.identifier.value,{contents:p,uri:w})}async g(l){if(l.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return C.URI.revive(p)}return l.l10n?C.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Zec=A,e.$Zec=A=Ke([We(0,m.$RM),We(1,y.$BM),We(2,P.$fj)],A),e.$1ec=(0,M.$Xh)("IExtHostLocalizationService")}),define(Ae[255],Re([1,0,15,3,27,17,2,51]),function(we,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;let m=class extends E.$qj{constructor(S,l){super(l.logLevel,l.logsLocation,l.loggers.map(p=>(0,$.$uh)(p))),this.r=S.getProxy(T.$zK.MainThreadLogger)}$setLogLevel(S,l){l?this.setLogLevel(P.URI.revive(l),S):this.setLogLevel(S)}setVisibility(S,l){super.setVisibility(S,l),this.r.$setVisibility(S,l)}s(S,l,p){return new y(this.r,S,l,p)}};e.$agc=m,e.$agc=m=Ke([We(0,M.$BM),We(1,C.$RM)],m);class y extends E.$lj{constructor(S,l,p,w){super(w?.logLevel==="always"),this.r=S,this.s=l,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(l,w).then(()=>{this.u(this.n),this.m=!0})}g(S,l){const p=[[S,l]];this.m?this.u(p):this.n.push(...p)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Ae[83],Re([1,0,3,4,6,17,24]),function(we,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=e.$2ec=void 0,e.$2ec=(0,T.$Xh)("IExtHostManagedSockets");let $=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(E.$zK.MainThreadManagedSockets)}setFactory(S,l){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(S,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const l=++this.b,p=await this.c.makeConnection(),w=new C.$Qc;return this.d.set(l,new y(l,p,w)),w.add((0,C.$Pc)(()=>this.d.delete(l))),w.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),w.dispose()})),w.add(p.onDidClose(a=>{this.a.$onDidManagedSocketClose(l,a?.stack??a?.message),w.dispose()})),w.add(p.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(l,P.$fe.wrap(a)))),l}$remoteSocketWrite(S,l){this.d.get(S)?.actual.send(l.buffer)}$remoteSocketEnd(S){const l=this.d.get(S);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$3ec=$,e.$3ec=$=Ke([We(0,M.$BM)],$);class m{constructor(S,l){this.socketFactoryId=S,this.makeConnection=l}}class y extends C.$Rc{constructor(S,l,p){super(),this.socketId=S,this.actual=l,this.B(p)}}}),define(Ae[256],Re([1,0,3,15,23]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=void 0;function M($){return $&&$.title}let P=class{constructor(m,y){this.b=y,this.a=m.getProxy(E.$zK.MainThreadMessageService)}showMessage(m,y,A,S,l){const p={source:{identifier:m.identifier,label:m.displayName||m.name}};let w;typeof S=="string"||M(S)?w=[S,...l]:(p.modal=S?.modal,p.useCustom=S?.useCustom,p.detail=S?.detail,w=l),p.useCustom&&(0,C.$OF)(m,"resolvers");const a=[];for(let s=0;s<w.length;s++){const t=w[s];if(typeof t=="string")a.push({title:t,handle:s,isCloseAffordance:!1});else if(typeof t=="object"){const{title:n,isCloseAffordance:o}=t;a.push({title:n,isCloseAffordance:!!o,handle:s})}else this.b.warn("Invalid message item:",t)}return this.a.$showMessage(y,A,p,a).then(s=>{if(typeof s=="number")return w[s]})}};e.$Cfc=P,e.$Cfc=P=Ke([We(1,T.$fj)],P)}),define(Ae[257],Re([1,0,18,14,19,5,6,28,2,22,15,3,32,8,7,78,210,23,49]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a,s,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=void 0;let o=class{constructor(g,D,I,h,b){this.m=D,this.n=I,this.o=h,this.q=b,this.b=new $.$zc,this.c=new $.$zc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new M.$Rd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=g.getProxy(S.$zK.MainThreadNotebookKernels);const k=new l.$2M("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$ZM("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const W=this.n.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:W}}else if(F&&"notebookEditor"in F){const W=this.n.getIdByEditor(F.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return F})],l.$1M.Void);this.o.registerApiCommand(k)}createNotebookController(g,D,I,h,b,k){for(const _ of this.j.values())if(_.controller.id===D&&y.$bm.equals(g.identifier,_.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const F=this.k++,W=this;this.q.trace(`NotebookController[${F}], CREATED by ${g.identifier.value}, ${D}`);const J=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${g.identifier}'`);let N=!1;const R=new M.$Rd,L=new M.$Rd,O={id:f(g.identifier,D),notebookType:I,extensionId:g.identifier,extensionLocation:g.extensionLocation,label:h||g.identifier.value,preloads:k?k.map(p.NotebookRendererScript.from):[]};let X=b??J,he,$e;this.a.$addKernel(F,O).catch(_=>{console.log(_),N=!0});let De=0;const ke=()=>{if(N)return;const _=++De;Promise.resolve().then(()=>{_===De&&this.a.$updateKernel(F,O)})},de=new $.$zc,Ee={get id(){return D},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return O.label},set label(_){O.label=_??g.displayName??g.name,ke()},get detail(){return O.detail??""},set detail(_){O.detail=_,ke()},get description(){return O.description??""},set description(_){O.description=_,ke()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(_){O.supportedLanguages=_,ke()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(_){O.supportsExecutionOrder=_,ke()},get rendererScripts(){return O.preloads?O.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(_){X=_??J},get interruptHandler(){return he},set interruptHandler(_){he=_,O.supportsInterrupt=!!_,ke()},set variableProvider(_){(0,t.$OF)(g,"notebookVariableProvider"),$e=_,O.hasVariableProvider=!!_,_?.onDidChangeVariables(Ce=>W.a.$variablesUpdated(Ce.uri)),ke()},get variableProvider(){return $e},createNotebookCellExecution(_){if(N)throw new Error("notebook controller is DISPOSED");if(!de.has(_.notebook.uri))throw W.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${_.notebook.uri.toString()}`);return W._createNotebookCellExecution(_,f(g.identifier,this.id))},createNotebookExecution(_){if((0,t.$OF)(g,"notebookExecution"),N)throw new Error("notebook controller is DISPOSED");if(!de.has(_.uri))throw W.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${_.uri.toString()}`);return W._createNotebookExecution(_,f(g.identifier,this.id))},dispose:()=>{N||(this.q.trace(`NotebookController[${F}], DISPOSED`),N=!0,this.j.delete(F),R.dispose(),L.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(_,Ce){Ce===w.NotebookControllerAffinity2.Hidden&&(0,t.$OF)(g,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(F,_.uri,Ce)},onDidReceiveMessage:L.event,postMessage(_,Ce){return(0,t.$OF)(g,"notebookMessaging"),W.a.$postMessage(F,Ce&&W.n.getIdByEditor(Ce),_)},asWebviewUri(_){return(0,t.$OF)(g,"notebookMessaging"),(0,a.$kub)(_,W.m.remote)}};return this.j.set(F,{extensionId:g.identifier,controller:Ee,onDidReceiveMessage:L,onDidChangeSelection:R,associatedNotebooks:de}),Ee}getIdByController(g){for(const[D,I]of this.j)if(I.controller===g)return f(I.extensionId,g.id);return null}createNotebookControllerDetectionTask(g,D){const I=this.g++,h=this;this.q.trace(`NotebookControllerDetectionTask[${I}], CREATED by ${g.identifier.value}`),this.a.$addKernelDetectionTask(I,D);const b={dispose:()=>{this.f.delete(I),h.a.$removeKernelDetectionTask(I)}};return this.f.set(I,b),b}registerKernelSourceActionProvider(g,D,I){const h=this.i++,b=typeof I.onDidChangeNotebookKernelSourceActions=="function"?h:void 0,k=this;this.h.set(h,I),this.q.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${g.identifier.value}`),this.a.$addKernelSourceActionProvider(h,h,D);let F;return b!==void 0&&(F=I.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.h.delete(h),k.a.$removeKernelSourceActionProvider(h,h),F?.dispose()}}}async $provideKernelSourceActions(g,D){const I=this.h.get(g);if(I){const h=new P.$Qc;return(await I.provideNotebookKernelSourceActions(D)??[]).map(k=>p.NotebookKernelSourceAction.from(k,this.o.converter,h))}return[]}$acceptNotebookAssociation(g,D,I){const h=this.j.get(g);if(h){const b=this.n.getNotebookDocument(m.URI.revive(D));I?h.associatedNotebooks.set(b.uri,!0):h.associatedNotebooks.delete(b.uri),this.q.trace(`NotebookController[${g}] ASSOCIATE notebook`,b.uri.toString(),I),h.onDidChangeSelection.fire({selected:I,notebook:b.apiNotebook})}}async $executeCells(g,D,I){const h=this.j.get(g);if(!h)return;const b=this.n.getNotebookDocument(m.URI.revive(D)),k=[];for(const F of I){const W=b.getCell(F);W&&k.push(W.apiCell)}try{this.q.trace(`NotebookController[${g}] EXECUTE cells`,b.uri.toString(),k.length),await h.controller.executeHandler.call(h.controller,k,b.apiNotebook,h.controller)}catch(F){this.q.error(`NotebookController[${g}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(g,D,I){const h=this.j.get(g);if(!h)return;const b=this.n.getNotebookDocument(m.URI.revive(D));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,b.apiNotebook);else for(const k of I){const F=b.getCell(k);F&&this.b.get(F.uri)?.cancel()}if(h.controller.interruptHandler){const k=this.c.get(b.uri);I.length&&Array.isArray(k)&&k.length&&k.forEach(F=>F.dispose())}}async $provideVariables(g,D,I,h,b,k,F){const W=this.j.get(g);if(!W)return;const J=this.n.getNotebookDocument(m.URI.revive(I)),N=W.controller.variableProvider;if(!N)return;const R=h?{name:h,value:""}:void 0,L=b==="named"?w.NotebookVariablesRequestKind.Named:w.NotebookVariablesRequestKind.Indexed,O=N.provideVariables(J.apiNotebook,R,L,k,F);for await(const X of O){if(F.isCancellationRequested)return;this.a.$receiveVariable(D,X)}}$acceptKernelMessageFromRenderer(g,D,I){const h=this.j.get(g);if(!h)return;const b=this.n.getEditorById(D);h.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:I}))}$cellExecutionChanged(g,D,I){const b=this.n.getNotebookDocument(m.URI.revive(g)).getCell(D);if(b){const k=I?p.NotebookCellExecutionState.to(I):w.NotebookCellExecutionState.Idle;k!==void 0&&this.l.fire({cell:b.apiCell,state:k})}}_createNotebookCellExecution(g,D){if(g.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this.n.getNotebookDocument(g.notebook.uri).getCellFromApiCell(g);if(!h)throw new Error("invalid cell");if(this.b.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const b=new d(D,h,this.a);this.b.set(h.uri,b);const k=b.onDidChangeState(()=>{b.state===c.Resolved&&(b.dispose(),k.dispose(),this.b.delete(h.uri))});return b.asApiObject()}_createNotebookExecution(g,D){const I=this.n.getNotebookDocument(g.uri),h=g.getCells().find(F=>{const W=I.getCellFromApiCell(F);return W&&this.b.has(W.uri)});if(h)throw new Error(`duplicate cell execution for ${h.document.uri}`);if(this.c.has(I.uri))throw new Error(`duplicate notebook execution for ${I.uri}`);const b=new r(D,I,this.a),k=b.onDidChangeState(()=>{b.state===i.Resolved&&(b.dispose(),k.dispose(),this.c.delete(I.uri))});return this.c.set(I.uri,[b,k]),b.asApiObject()}};e.$Gfc=o,e.$Gfc=o=Ke([We(4,A.$fj)],o);var c;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(c||(c={}));class d extends P.$Rc{static{this.a=0}get state(){return this.f}constructor(g,D,I){super(),this.m=D,this.n=I,this.b=d.a++,this.c=new M.$Rd,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new C.$2d),this.h=new u(10,h=>this.s(h)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,g,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(g){await this.h.addItem(g)}async s(g){const D=Array.isArray(g)?g:[g];return this.n.$updateExecution(this.b,new n.$yv(D))}t(){if(this.f===c.Init)throw new Error("Must call start before modifying cell output");if(this.f===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(g){let D=this.m;if(g&&(D=this.m.notebook.getCellFromApiCell(g)),!D)throw new Error("INVALID cell");return D.handle}y(g){return g.map(D=>{const I=w.$3L.ensureUniqueMimeTypes(D.items,!0);return I===D.items?p.NotebookCellOutput.from(D):p.NotebookCellOutput.from({items:I,id:D.id,metadata:D.metadata})})}async z(g,D,I){const h=this.w(D),b=this.y((0,E.$2b)(g));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:h,append:I,outputs:b})}async C(g,D,I){return g=w.$3L.ensureUniqueMimeTypes((0,E.$2b)(g),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:g.map(p.NotebookCellOutputItem.from),outputId:D.id,append:I})}asApiObject(){const g=this;return Object.freeze({get token(){return g.g.token},get cell(){return g.m.apiCell},get executionOrder(){return g.j},set executionOrder(I){g.j=I,g.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:g.j}])},start(I){if(g.f===c.Resolved||g.f===c.Started)throw new Error("Cannot call start again");g.f=c.Started,g.c.fire(),g.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:I})},end(I,h){if(g.f===c.Resolved)throw new Error("Cannot call resolve twice");g.f=c.Resolved,g.c.fire(),g.h.flush(),g.n.$completeExecution(g.b,new n.$yv({runEndTime:h,lastRunSuccess:I}))},clearOutput(I){return g.t(),g.z([],I,!1)},appendOutput(I,h){return g.t(),g.z(I,h,!0)},replaceOutput(I,h){return g.t(),g.z(I,h,!1)},appendOutputItems(I,h){return g.t(),g.C(I,h,!0)},replaceOutputItems(I,h){return g.t(),g.C(I,h,!1)}})}}var i;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(i||(i={}));class r extends P.$Rc{static{this.a=0}get state(){return this.f}constructor(g,D,I){super(),this.h=D,this.j=I,this.b=r.a++,this.c=new M.$Rd,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new C.$2d),this.j.$createNotebookExecution(this.b,g,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===i.Resolved||this.f===i.Started)throw new Error("Cannot call start again");this.f=i.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===i.Resolved)throw new Error("Cannot call resolve twice");this.f=i.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class u{constructor(g,D){this.f=g,this.g=D,this.a=[],this.b=Date.now()}addItem(g){return this.a.push(g),this.c||(this.c=new T.$kh,this.b=Date.now(),(0,T.$1g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const g=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>g.complete())}}function f(v,g){return`${v.value}/${g}`}e.$Hfc=f}),define(Ae[258],Re([1,0,5,3,106]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0;class M{constructor($,m){this.c=m,this.a=new Map,this.b=$.getProxy(T.$zK.MainThreadNotebookRenderers)}$postRendererMessage($,m,y){const A=this.c.getEditorById($);this.a.get(m)?.fire({editor:A.apiEditor,message:y})}createRendererMessaging($,m){if(!$.contributes?.notebookRenderer?.some(A=>A.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(A,S,l)=>this.d(m).event(A,S,l),postMessage:(A,S)=>{C.$ofc.apiEditorsToExtHost.has(A)&&([A,S]=[S,A]);const l=S&&C.$ofc.apiEditorsToExtHost.get(S);return this.b.$postMessage(l?.id,m,A)}}}d($){let m=this.a.get($);return m||(m=new E.$Rd({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete($)}}),this.a.set($,m),m)}}e.$Ifc=M}),define(Ae[259],Re([1,0,6,16,2,23,3]),function(we,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;class ${constructor(y){this.b=new Map,this.a=y.getProxy(P.$zK.MainThreadProfileContentHandlers)}registrProfileContentHandler(y,A,S){if((0,M.$OF)(y,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,S),this.a.$registerProfileContentHandler(A,S.name,S.description,y.identifier.value),(0,E.$Pc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(y,A,S,l){const p=this.b.get(y);if(!p)throw new Error(`Unknown handler with id: ${y}`);return p.saveProfile(A,S,l)}async $readProfile(y,A,S){const l=this.b.get(y);if(!l)throw new Error(`Unknown handler with id: ${y}`);return l.readProfile((0,T.$Cf)(A)?A:C.URI.revive(A),S)}}e.$Lfc=$}),define(Ae[260],Re([1,0,2,3,14,8]),function(we,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=void 0;class P{static{this.a=0}constructor(m,y){this.d=y,this.c=new Map,this.b=m.getProxy(T.$zK.MainThreadQuickDiff)}$provideOriginalResource(m,y,A){const S=E.URI.revive(y),l=this.c.get(m);return l?(0,C.$Sg)(()=>l.provideOriginalResource(S,A)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(m,y,A,S){const l=P.a++;return this.c.set(l,y),this.b.$registerQuickDiffProvider(l,M.DocumentSelector.from(m,this.d),A,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Nfc=P}),define(Ae[261],Re([1,0,19,5,6,3,2,7,11,18,31,45,23,8]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=void 0;function w(a,s,t){const n=a.getProxy(M.$zK.MainThreadQuickOpen);class o{constructor(D,I){this.e=new Map,this.f=0,this.a=D,this.b=I}showQuickPick(D,I,h,b=E.CancellationToken.None){this.c=void 0;const k=Promise.resolve(I),F=++this.f,W=n.$show(F,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},b),J={},N=W.then(()=>J);return Promise.race([N,k]).then(R=>{if(R===J)return;const L=(0,l.$NF)(D,"quickPickItemTooltip");return k.then(O=>{const X=[];for(let he=0;he<O.length;he++){const $e=O[he];if(typeof $e=="string")X.push({label:$e,handle:he});else if($e.kind===$.QuickPickItemKind.Separator)X.push({type:"separator",label:$e.label});else{$e.tooltip&&!L&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const De=$e.iconPath?u($e.iconPath):void 0;X.push({label:$e.label,iconPath:De?.iconPath,iconClass:De?.iconClass,description:$e.description,detail:$e.detail,picked:$e.picked,alwaysShow:$e.alwaysShow,tooltip:L?p.MarkdownString.fromStrict($e.tooltip):void 0,handle:he})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=he=>{h.onDidSelectItem(O[he])}),n.$setItems(F,X),W.then(he=>{if(typeof he=="number")return O[he];if(Array.isArray(he))return he.map($e=>O[$e])})})}).then(void 0,R=>{if(!(0,m.$3)(R))return n.$setError(F,R),Promise.reject(R)})}$onItemSelected(D){this.c?.(D)}showInput(D,I=E.CancellationToken.None){return this.d=D?.validateInput,n.$input(D,typeof this.d=="function",I).then(void 0,h=>{if(!(0,m.$3)(h))return Promise.reject(h)})}async $validateInput(D){if(!this.d)return;const I=await this.d(D);if(!I||typeof I=="string")return I;let h;switch(I.severity){case $.InputBoxValidationSeverity.Info:h=A.default.Info;break;case $.InputBoxValidationSeverity.Warning:h=A.default.Warning;break;case $.InputBoxValidationSeverity.Error:h=A.default.Error;break;default:h=I.message?A.default.Error:A.default.Ignore;break}return{content:I.message,severity:h}}async showWorkspaceFolderPick(D,I=E.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!h)return;const b=await this.a.getWorkspaceFolders2();if(b)return b.find(k=>k.uri.toString()===h.uri.toString())}createQuickPick(D){const I=new f(D,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(D){const I=new v(D,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(D,I){this.e.get(D)?._fireDidChangeValue(I)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,I){const h=this.e.get(D);h instanceof f&&h._fireDidChangeActive(I)}$onDidChangeSelection(D,I){const h=this.e.get(D);h instanceof f&&h._fireDidChangeSelection(I)}$onDidTriggerButton(D,I){this.e.get(D)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(D,I,h){const b=this.e.get(D);b instanceof f&&b._fireDidTriggerItemButton(I,h)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class c{static{this.a=1}constructor(D,I){this.x=D,this.y=I,this._id=f.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Rd,this.q=new T.$Rd,this.r=new T.$Rd,this.s=new T.$Rd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((I,h)=>{const b=I===$.$VL.Back?-1:h;this.o.set(b,I)}),this.z({buttons:D.map((I,h)=>({...u(I.iconPath),tooltip:I.tooltip,handle:I===$.$VL.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const I=this.o.get(D);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(D){if(!this.v){for(const I of Object.keys(D)){const h=D[I];this.u[I]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function d(g){if(g instanceof $.$vL)return{id:g.id};const D=r(g),I=i(g);return{dark:typeof D=="string"?P.URI.file(D):D,light:typeof I=="string"?P.URI.file(I):I}}function i(g){return typeof g=="object"&&"light"in g?g.light:g}function r(g){return typeof g=="object"&&"dark"in g?g.dark:g}function u(g){const D=d(g);let I,h;return"id"in D?h=S.ThemeIcon.asClassName(D):I=D,{iconPath:I,iconClass:h}}class f extends c{constructor(D,I){super(D.identifier,I),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Rd,this.L=[],this.M=new T.$Rd,this.N=new T.$Rd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((b,k)=>{this.C.set(k,b),this.D.set(b,k)});const I=(0,l.$NF)(this.O,"quickPickItemTooltip"),h=[];for(let b=0;b<D.length;b++){const k=D[b];if(k.kind===$.QuickPickItemKind.Separator)h.push({type:"separator",label:k.label});else{k.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const F=k.iconPath?u(k.iconPath):void 0;h.push({handle:b,label:k.label,iconPath:F?.iconPath,iconClass:F?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:I?p.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((W,J)=>({...u(W.iconPath),tooltip:W.tooltip,handle:J}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(D){const I=(0,y.$Gb)(D.map(h=>this.C.get(h)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(D){const I=(0,y.$Gb)(D.map(h=>this.C.get(h)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(D,I){const h=this.C.get(D);if(!h||!h.buttons||!h.buttons.length)return;const b=h.buttons[I];b&&this.N.fire({button:b,item:h})}}class v extends c{constructor(D,I){super(D.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:A.default.Error}):this.z({validationMessage:D.message,severity:D.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new o(s,t)}e.$Ofc=w}),define(Ae[262],Re([1,0,2,5,66,6,14,3,18,137,15,19,22,45,8,23,13,21]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a,s,t){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=e.$Pfc=void 0;function o(N){return N instanceof E.URI}function c(N,R){return N.scheme===s.Schemas.file&&R.scheme===s.Schemas.file&&t.$k?N.toString()===R.toString():N.toString().toLowerCase()===R.toString().toLowerCase()}function d(N){if(N)return typeof N.iconPath=="string"?E.URI.file(N.iconPath):E.URI.isUri(N.iconPath)||p.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function i(N){if(N?.icon){if(E.URI.isUri(N.icon))return N.icon;if(p.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const R=N.icon;return{light:R.light,dark:R.dark}}}else return}function r(N){if(N.icon){if(E.URI.isUri(N.icon))return N.icon;if(p.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const R=N.icon;return{light:R.light,dark:R.dark}}}else return}function u(N){if(N.icon){if(E.URI.isUri(N.icon))return N.icon;if(p.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const R=N.icon;return{light:R.light,dark:R.dark}}}else return}function f(N,R){if(!N.iconPath&&!R.iconPath)return 0;if(N.iconPath){if(!R.iconPath)return 1}else return-1;const L=typeof N.iconPath=="string"?N.iconPath:E.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,O=typeof R.iconPath=="string"?R.iconPath:E.URI.isUri(R.iconPath)?R.iconPath.fsPath:R.iconPath.id;return(0,y.$zq)(L,O)}function v(N,R){let L=0;if(N.strikeThrough!==R.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==R.faded)return N.faded?1:-1;if(N.tooltip!==R.tooltip)return(N.tooltip||"").localeCompare(R.tooltip||"");if(L=f(N,R),L!==0)return L;if(N.light&&R.light)L=f(N.light,R.light);else{if(N.light)return 1;if(R.light)return-1}if(L!==0)return L;if(N.dark&&R.dark)L=f(N.dark,R.dark);else{if(N.dark)return 1;if(R.dark)return-1}return L}function g(N,R){if(N.command!==R.command)return N.command<R.command?-1:1;if(N.title!==R.title)return N.title<R.title?-1:1;if(N.tooltip!==R.tooltip){if(N.tooltip!==void 0&&R.tooltip!==void 0)return N.tooltip<R.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(R.tooltip!==void 0)return-1}if(N.arguments===R.arguments)return 0;if(N.arguments)if(R.arguments){if(N.arguments.length!==R.arguments.length)return N.arguments.length-R.arguments.length}else return 1;else return-1;for(let L=0;L<N.arguments.length;L++){const O=N.arguments[L],X=R.arguments[L];if(O!==X&&!(o(O)&&o(X)&&c(O,X)))return O<X?-1:1}return 0}function D(N,R){let L=(0,y.$zq)(N.resourceUri.fsPath,R.resourceUri.fsPath,!0);if(L!==0)return L;if(N.command&&R.command)L=g(N.command,R.command);else{if(N.command)return 1;if(R.command)return-1}if(L!==0)return L;if(N.decorations&&R.decorations)L=v(N.decorations,R.decorations);else{if(N.decorations)return 1;if(R.decorations)return-1}return L}function I(N,R){for(let L=0;L<N.length;L++)if(N[L]!==R[L])return!1;return!0}function h(N,R){return N.command===R.command&&N.title===R.title&&N.tooltip===R.tooltip&&(N.arguments&&R.arguments?I(N.arguments,R.arguments):N.arguments===R.arguments)}function b(N,R){return(0,m.$tb)(N,R,h)}class k{#e;#t;get value(){return this.d}set value(R){R=R??"",this.#e.$setInputBoxValue(this.o,R),this.q(R)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(R){this.#e.$setInputBoxPlaceholder(this.o,R),this.f=R}get validateInput(){return(0,a.$OF)(this.m,"scmValidation"),this.g}set validateInput(R){if((0,a.$OF)(this.m,"scmValidation"),R&&typeof R!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=R,this.#e.$setValidationProviderIsEnabled(this.o,!!R)}get enabled(){return this.h}set enabled(R){R=!!R,this.h!==R&&(this.h=R,this.#e.$setInputBoxEnablement(this.o,R))}get visible(){return this.j}set visible(R){R=!!R,this.j!==R&&(this.j=R,this.#e.$setInputBoxVisibility(this.o,R))}get actionButton(){return(0,a.$OF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(R){(0,a.$OF)(this.m,"scmInputBoxActionButton"),this.l.value=new M.$Qc,this.k=R;const L=R!==void 0?{command:this.n.converter.toInternal(R.command,this.l.value),icon:i(R),enabled:R.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,L??null)}get document(){return(0,a.$OF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(R,L,O,X,he,$e){this.m=R,this.n=L,this.o=he,this.p=$e,this.d="",this.e=new T.$Rd,this.f="",this.h=!0,this.j=!0,this.l=new M.$Sc,this.#t=O,this.#e=X}showValidationMessage(R,L){(0,a.$OF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,R,L)}$onInputBoxValueChange(R){this.q(R)}q(R){this.d=R,this.e.fire(R)}}e.$Pfc=k;class F{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(R){this.v=R,this.q.$updateGroupLabel(this.t,this.handle,R)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(R){this.p=R,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(R){this.f=[...R],this.k.fire()}constructor(R,L,O,X,he){this.q=R,this.s=L,this.t=O,this.u=X,this.v=he,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Rd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Rd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=F.d++}getResourceState(R){return this.g.get(R)}$executeResourceCommand(R,L){const O=this.h.get(R);return O?(0,P.$Sg)(()=>this.s.executeCommand(O.command,...O.arguments||[],L)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const R=[...this.f].sort(D),O=(0,m.$Cb)(this.o,R,D).map($e=>{const De=$e.toInsert.map(ke=>{const de=this.e++;this.g.set(de,ke);const Ee=ke.resourceUri;let _;if(ke.command)if(ke.command.command==="vscode.open"||ke.command.command==="vscode.diff"||ke.command.command==="vscode.changes"){const be=new M.$Qc;_=this.s.converter.toInternal(ke.command,be),this.j.set(de,be)}else this.h.set(de,ke.command);const Ce=d(ke.decorations),se=ke.decorations&&d(ke.decorations.light)||Ce,Q=ke.decorations&&d(ke.decorations.dark)||Ce,U=[se,Q],ne=ke.decorations&&ke.decorations.tooltip||"",pe=ke.decorations&&!!ke.decorations.strikeThrough,re=ke.decorations&&!!ke.decorations.faded,le=ke.contextValue||"";return{rawResource:[de,Ee,U,ne,pe,re,le,_],handle:de}});return{start:$e.start,deleteCount:$e.deleteCount,toInsert:De}}),X=O.map(({start:$e,deleteCount:De,toInsert:ke})=>[$e,De,ke.map(de=>de.rawResource)]),he=O.reverse();for(const{start:$e,deleteCount:De,toInsert:ke}of he){const de=ke.map(_=>_.handle),Ee=this.n.splice($e,De,...de);for(const _ of Ee)this.g.delete(_),this.h.delete(_),this.j.get(_)?.dispose(),this.j.delete(_)}return this.o=R,X}dispose(){this.l=!0,this.m.fire()}}class W{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(R){this.g!==R&&(this.g=R,this.#e.$updateSourceControl(this.x,{count:R}))}get quickDiffProvider(){return this.h}set quickDiffProvider(R){this.h=R;let L;(0,a.$NF)(this.y,"quickDiffProvider")&&(L=R?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!R,quickDiffLabel:L})}get historyProvider(){return(0,a.$OF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(R){(0,a.$OF)(this.y,"scmHistoryProvider"),this.j=R,this.k.value=new M.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!R}),R&&(this.k.value.add(R.onDidChangeCurrentHistoryItemGroup(()=>{this.l=R?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l)})),this.k.value.add(R.onDidChangeActionButton(()=>{(0,a.$OF)(this.y,"scmActionButton"),this.m.value=new M.$Qc;const L=R.actionButton!==void 0?{command:this.z.converter.toInternal(R.actionButton.command,this.m.value),description:R.actionButton.description,enabled:R.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,L??null)})))}get commitTemplate(){return this.n}set commitTemplate(R){R!==this.n&&(this.n=R,this.#e.$updateSourceControl(this.x,{commitTemplate:R}))}get acceptInputCommand(){return this.p}set acceptInputCommand(R){this.o.value=new M.$Qc,this.p=R;const L=this.z.converter.toInternal(R,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:L})}get actionButton(){return(0,a.$OF)(this.y,"scmActionButton"),this.s}set actionButton(R){(0,a.$OF)(this.y,"scmActionButton"),this.q.value=new M.$Qc,this.s=R;const L=R!==void 0?{command:this.z.converter.toInternal(R.command,this.q.value),secondaryCommands:R.secondaryCommands?.map(O=>O.map(X=>this.z.converter.toInternal(X,this.q.value))),description:R.description,enabled:R.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:L??null})}get statusBarCommands(){return this.u}set statusBarCommands(R){if(this.u&&R&&b(this.u,R))return;this.t.value=new M.$Qc,this.u=R;const L=(R||[]).map(O=>this.z.converter.toInternal(O,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:L})}get selected(){return this.v}constructor(R,L,O,X,he,$e,De){this.y=R,this.z=X,this.A=he,this.B=$e,this.C=De,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Sc,this.m=new M.$Sc,this.n=void 0,this.o=new M.$Sc,this.p=void 0,this.q=new M.$Sc,this.t=new M.$Sc,this.u=void 0,this.v=!1,this.w=new T.$Rd,this.onDidChangeSelection=this.w.event,this.x=W.d++,this.D=new Map,this.E=new Set,this.#e=O;const ke=E.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${he}/scm${this.x}/input`,query:De?`rootUri=${encodeURIComponent(De.toString())}`:void 0});this.f=new k(R,X,L,this.#e,this.x,ke),this.#e.$registerSourceControl(this.x,he,$e,De,ke)}createResourceGroup(R,L){const O=new F(this.#e,this.z,this.x,R,L),X=T.Event.once(O.onDidDispose)(()=>this.D.delete(O));return this.D.set(O,X),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const R=[],L=[];for(const[O,X]of this.D){X.dispose();const he=O.onDidUpdateResourceStates(()=>{this.E.add(O),this.eventuallyUpdateResourceStates()});T.Event.once(O.onDidDispose)(()=>{this.E.delete(O),he.dispose(),this.e.delete(O.handle),this.#e.$unregisterGroup(this.x,O.handle)}),R.push([O.handle,O.id,O.label,O.features]);const $e=O._takeResourceStateSnapshot();$e.length>0&&L.push([O.handle,$e]),this.e.set(O.handle,O)}this.#e.$registerGroups(this.x,R,L),this.D.clear()}eventuallyUpdateResourceStates(){const R=[];this.E.forEach(L=>{const O=L._takeResourceStateSnapshot();O.length!==0&&R.push([L.handle,O])}),R.length>0&&this.#e.$spliceResourceStates(this.x,R),this.E.clear()}getResourceGroup(R){return this.e.get(R)}setSelectionState(R){this.v=R,this.w.fire(R)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(R=>R.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,C.$qh)(100)],W.prototype,"eventuallyAddResourceGroups",null),Ke([(0,C.$qh)(100)],W.prototype,"eventuallyUpdateResourceStates",null);let J=class{static{n=this}static{this.d=0}static{this.e=0}get onDidChangeActiveProvider(){return this.k.event}constructor(R,L,O,X){this.n=L,this.o=O,this.p=X,this.h=new Map,this.j=new l.$dm,this.k=new T.$Rd,this.l=new Map,this.f=R.getProxy($.$zK.MainThreadSCM),this.g=R.getProxy($.$zK.MainThreadTelemetry),L.registerArgumentProcessor({processArgument:he=>{if(he&&he.$mid===3){const $e=this.h.get(he.sourceControlHandle);if(!$e)return he;const De=$e.getResourceGroup(he.groupHandle);return De?De.getResourceState(he.handle):he}else if(he&&he.$mid===4){const $e=this.h.get(he.sourceControlHandle);return $e?$e.getResourceGroup(he.groupHandle):he}else if(he&&he.$mid===5){const $e=this.h.get(he.handle);return $e||he}return he}})}createSourceControl(R,L,O,X){this.p.trace("ExtHostSCM#createSourceControl",R.identifier.value,L,O,X),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:R.identifier.value});const he=n.d++,$e=new W(R,this.o,this.f,this.n,L,O,X);this.h.set(he,$e);const De=this.j.get(R.identifier)||[];return De.push($e),this.j.set(R.identifier,De),$e}registerSourceControlInputBoxValueProvider(R,L){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",R.identifier.value,L.label);const O=n.e++;return this.l.set(O,L),this.f.$registerSourceControlInputBoxValueProvider(O,L.label,u(L)),(0,M.$Pc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(O),this.l.delete(O)})}async $provideInputBoxValue(R,L,O){const X=this.l.get(R);if(X)return await X.provideValue(L,O,S.CancellationToken.None)??void 0}getLastInputBox(R){this.p.trace("ExtHostSCM#getLastInputBox",R.identifier.value);const L=this.j.get(R.identifier),O=L&&L[L.length-1];return O&&O.inputBox}$provideOriginalResource(R,L,O){const X=E.URI.revive(L);this.p.trace("ExtHostSCM#$provideOriginalResource",R,X.toString());const he=this.h.get(R);return!he||!he.quickDiffProvider||!he.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.$Sg)(()=>he.quickDiffProvider.provideOriginalResource(X,O)).then($e=>$e||null)}$onInputBoxValueChange(R,L){this.p.trace("ExtHostSCM#$onInputBoxValueChange",R);const O=this.h.get(R);return O&&O.inputBox.$onInputBoxValueChange(L),Promise.resolve(void 0)}$executeResourceCommand(R,L,O,X){this.p.trace("ExtHostSCM#$executeResourceCommand",R,L,O);const he=this.h.get(R);if(!he)return Promise.resolve(void 0);const $e=he.getResourceGroup(L);return $e?$e.$executeResourceCommand(O,X):Promise.resolve(void 0)}$validateInput(R,L,O){this.p.trace("ExtHostSCM#$validateInput",R);const X=this.h.get(R);return!X||!X.inputBox.validateInput?Promise.resolve(void 0):(0,P.$Sg)(()=>X.inputBox.validateInput(L,O)).then(he=>{if(!he)return Promise.resolve(void 0);const $e=w.MarkdownString.fromStrict(he.message);return $e?Promise.resolve([$e,he.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(R){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",R),R!==void 0&&this.h.get(R)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=R,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(R,L,O){return await this.h.get(R)?.historyProvider?.resolveHistoryItemGroupBase(L,O)??void 0}async $resolveHistoryItemGroupCommonAncestor(R,L,O,X){return await this.h.get(R)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(L,O,X)??void 0}async $provideHistoryItems(R,L,O,X){return(await this.h.get(R)?.historyProvider?.provideHistoryItems(L,O,X))?.map(De=>({...De,icon:r(De)}))??void 0}async $provideHistoryItemChanges(R,L,O){return await this.h.get(R)?.historyProvider?.provideHistoryItemChanges(L,O)??void 0}};e.$Qfc=J,e.$Qfc=J=n=Ke([We(3,A.$fj)],J)}),define(Ae[84],Re([1,0,3,5,4]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=e.$Wec=void 0;class M{constructor($){this.b=new T.$Rd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(E.$zK.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,m){return this.a.$getPassword($,m)}store($,m,y){return this.a.$setPassword($,m,y)}delete($,m){return this.a.$deletePassword($,m)}}e.$Wec=M,e.$Xec=(0,C.$Xh)("IExtHostSecretState")}),define(Ae[263],Re([1,0,3,8,2]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=void 0;class M{static{this.a=0}constructor($,m){this.d=m,this.c=new Map,this.b=$.getProxy(E.$zK.MainThreadShare)}async $provideShare($,m,y){return await this.c.get($)?.provideShare({selection:T.Range.to(m.selection),resourceUri:C.URI.revive(m.resourceUri)},y)??void 0}registerShareProvider($,m){const y=M.a++;return this.c.set(y,m),this.b.$registerShareProvider(y,T.DocumentSelector.from($,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$Rfc=M}),define(Ae[264],Re([1,0,19,6,3]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=void 0;class M{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(C.$zK.MainThreadSpeech)}async $createSpeechToTextSession($,m){const y=this.c.get($);if(!y)return;const A=new T.$Qc,S=new E.$2d;this.d.set(m,S);const l=A.add(y.provideSpeechToTextSession(S.token));A.add(l.onDidChange(p=>{S.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,p)})),A.add(S.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,m,y){const A=M.a++;return this.c.set(A,y),this.b.$registerProvider(A,m,{extension:$,displayName:$.value}),(0,T.$Pc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Sfc=M}),define(Ae[265],Re([1,0,7,3,163,6,8,16]),function(we,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=e.$Tfc=void 0;class m{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$wL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$wL("statusBarItem.warningForeground")]])}#e;#t;constructor(l,p,w,a,s,t=E.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new M.$Qc,this.#e=l,this.#t=p,s&&a){this.c=(0,E.$_K)(a.identifier,s);const o=w.get(this.c);o&&(t=o.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,n=o.priority,this.j=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this.c=String(m.a++);this.e=a,this.f=s,this.g=t,this.h=this.u(n)}u(l){if((0,$.$Gf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!m.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new M.$Qc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let p;this.m?p=this.m:p=(0,C.localize)(0,null,this.e.displayName||this.e.name);let w=this.n;this.o&&(w=m.b.get(this.o.id));const a=P.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,p,this.k,a,this.r?.internal,w,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Tfc=m;class y{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const p={message:l};return this.b.unshift(p),this.c(),new E.$BK(()=>{const w=this.b.indexOf(p);w>=0&&(this.b.splice(w,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(l,p){this.e=new Map,this.a=l.getProxy(T.$zK.MainThreadStatusBar),this.b=p,this.c=new y(this)}$acceptStaticEntries(l){for(const p of l)this.e.set(p.entryId,p)}createStatusBarEntry(l,p,w,a){return new m(this.a,this.b,this.e,l,p,w,a)}setStatusBarMessage(l,p){const w=this.c.setMessage(l);let a;return typeof p=="number"?a=setTimeout(()=>w.dispose(),p):typeof p<"u"&&p.then(()=>w.dispose(),()=>w.dispose()),new E.$BK(()=>{w.dispose(),clearTimeout(a)})}}e.$Ufc=A}),define(Ae[85],Re([1,0,3,5,4]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=e.$Oec=void 0;class M{constructor($,m){this.c=m,this.b=new T.$Rd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(E.$zK.MainThreadStorage)}registerExtensionStorageKeysToSync($,m){this.a.$registerExtensionStorageKeysToSync($,m)}async initializeExtensionStorage($,m,y){const A=await this.a.$initializeExtensionStorage($,m);let S;return A&&(S=this.d($,m,A)),S||y}setValue($,m,y){return this.a.$setValue($,m,y)}$acceptValue($,m,y){const A=this.d($,m,y);A&&this.b.fire({shared:$,key:m,value:A})}d($,m,y){try{return JSON.parse(y)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${$}): ${A}`)}}}e.$Oec=M,e.$Pec=(0,C.$Xh)("IExtHostStorage")}),define(Ae[86],Re([1,0,4,27,15,63,2]),function(we,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=e.$xec=void 0,e.$xec=(0,E.$Xh)("IExtensionStoragePaths");let $=class{constructor(y,A,S){this.d=A,this.f=S,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(y){return P.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,A=await this.g(y);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(P.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:P.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(y){if(this.c)return P.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return P.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$yec=$,e.$yec=$=Ke([We(0,T.$RM),We(1,C.$fj),We(2,M.$wec)],$)}),define(Ae[64],Re([1,0,5,3,4,2,17,6,7,165,11,193,19,33,194,45,14,8,32]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a,s,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=e.$Uec=e.$Tec=e.$Sec=void 0,e.$Sec=(0,C.$Xh)("IExtHostTerminalService");class o{constructor(h,b,k,F){this.l=h,this._id=b,this.m=k,this.n=F,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(J=>this.f=J);const W=this;this.value={get name(){return W.n||""},get processId(){return W.b},get creationOptions(){return W.m},get exitStatus(){return W.h},get state(){return W.j},get selection(){return W.k},sendText(J,N=!0){W.q(),W.l.$sendText(W._id,J,N)},show(J){W.q(),W.l.$show(W._id,J)},hide(){W.q(),W.l.$hide(W._id)},dispose(){W.a||(W.a=!0,W.l.$dispose(W._id))},get dimensions(){if(!(W.d===void 0||W.g===void 0))return{columns:W.d,rows:W.g}}}}async create(h,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??b?.cwd??void 0,env:h.env??void 0,icon:v(h.iconPath)??void 0,color:a.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.o(h.location,b?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,b,k,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:k,color:a.ThemeColor.isThemeColor(F)?F.id:void 0,location:this.o(h,b),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(h,b){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in h?{viewColumn:t.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.n=h}setExitStatus(h,b){this.h=Object.freeze({code:h,reason:b})}setDimensions(h,b){return h===this.d&&b===this.g||h===0||b===0?!1:(this.d=h,this.g=b,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(h){this.k=h}_setProcessId(h){this.f?(this.f(h),this.f=void 0):this.b.then(b=>{b!==h&&(this.b=Promise.resolve(h))})}}e.$Tec=o;class c{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new E.$Rd,this.onProcessData=this.a.event,this.b=new E.$Rd,this.d=new E.$Rd,this.onDidChangeProperty=this.d.event,this.f=new E.$Rd,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,b){this.g.setDimensions?.({columns:h,rows:b})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:"overrideDimensions",value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:"title",value:b})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let d=1,i=class extends $.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,b,k){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Rd,this.onDidCloseTerminal=this.H.event,this.I=new E.$Rd,this.onDidOpenTerminal=this.I.event,this.J=new E.$Rd,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Rd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Rd,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Rd,this.onDidChangeShell=this.N.event,this.O=new E.$Rd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Rd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(T.$zK.MainThreadTerminalService),this.y=new w.$yqb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:F=>{const W=J=>{const N=J;return this.W(N.instanceId)?.value};switch(F?.$mid){case 15:return W(F);default:{if(Array.isArray(F))for(let J=0;J<F.length&&F[J].$mid===15;J++)F[J]=W(F[J]);return F}}}}),this.B({dispose:()=>{for(const[F,W]of this.g)W.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,b){const k=new o(this.a,(0,p.$kg)(),h,h.name),F=new c(h.pty);return k.createExtensionTerminal(h.location,this.R(h,b).resolvedExtHostIdentifier,v(h.iconPath),g(h.color)).then(W=>{const J=this.S(W,F);this.h[W]=J}),this.f.push(k),k.value}R(h,b){if(b=b||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const k=h.location.parentTerminal;if(k){const F=this.f.find(W=>W.value===k);F&&(b.resolvedExtHostIdentifier=F._id)}}else h.location&&typeof h.location!="object"?b.location=h.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(h,b){if(!this.W(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const F=new c(b),W=this.S(h,F);this.h[h]=W}async $acceptActiveTerminalChanged(h){const b=this.b;if(h===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const k=this.W(h);k&&(this.b=k,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,b){const k=this.W(h);k&&this.O.fire({terminal:k.value,data:b})}async $acceptTerminalDimensions(h,b,k){const F=this.W(h);F&&F.setDimensions(b,k)&&this.L.fire({terminal:F.value,dimensions:F.value.dimensions})}async $acceptDidExecuteCommand(h,b){const k=this.W(h);k&&this.P.fire({terminal:k.value,...b})}async $acceptTerminalMaximumDimensions(h,b,k){this.g.get(h)?.resize(b,k)}async $acceptTerminalTitleChange(h,b){const k=this.W(h);k&&(k.name=b)}async $acceptTerminalClosed(h,b,k){const F=this.Y(this.f,h);if(F!==null){const W=this.f.splice(F,1)[0];W.setExitStatus(b,k),this.H.fire(W.value)}}$acceptTerminalOpened(h,b,k,F){if(b){const N=this.Y(this.f,b);if(N!==null){this.f[N]._id=h,this.I.fire(this.terminals[N]),this.f[N].isOpen=!0;return}}const W={name:F.name,shellPath:F.executable,shellArgs:F.args,cwd:typeof F.cwd=="string"?F.cwd:M.URI.revive(F.cwd),env:F.env,hideFromUser:F.hideFromUser},J=new o(this.a,h,W,k);this.f.push(J),this.I.fire(J.value),J.isOpen=!0}async $acceptTerminalProcessId(h,b){this.W(h)?._setProcessId(b)}async $startExtensionTerminal(h,b){const k=this.W(h);if(!k)return{message:(0,y.localize)(0,null,h)};k.isOpen||await new Promise(W=>{const J=this.onDidOpenTerminal(async N=>{N===k.value&&(J.dispose(),W())})});const F=this.g.get(h);F?F.startSendingEvents(b):this.j[h]={initialDimensions:b}}S(h,b){const k=new $.$Qc;k.add(b.onProcessReady(W=>this.a.$sendProcessReady(h,W.pid,W.cwd,W.windowsPty))),k.add(b.onDidChangeProperty(W=>this.a.$sendProcessProperty(h,W))),this.y.startBuffering(h,b.onProcessData),k.add(b.onProcessExit(W=>this.U(h,W))),this.g.set(h,b);const F=this.j[h];return F&&b instanceof c&&(b.startSendingEvents(F.initialDimensions),delete this.j[h]),k}$acceptProcessAckDataEvent(h,b){this.g.get(h)?.acknowledgeDataEvent(b)}$acceptProcessInput(h,b){this.g.get(h)?.input(b)}$acceptTerminalInteraction(h){const b=this.W(h);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection(h,b){this.W(h)?.setSelection(b)}$acceptProcessResize(h,b,k){try{this.g.get(h)?.resize(b,k)}catch(F){if(F.code!=="EPIPE"&&F.code!=="ERR_IPC_CHANNEL_CLOSED")throw F}}$acceptProcessShutdown(h,b){this.g.get(h)?.shutdown(b)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(b=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:b}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(b=>this.a.$sendProcessProperty(h,{type:"cwd",value:b}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new m.$BK(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,b,k){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,k),this.a.$registerProfileProvider(b,h.identifier.value),new m.$BK(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(h,b,k){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,k),this.a.$registerQuickFixProvider(h,b),new m.$BK(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,b){const k=new l.$2d().token;if(k.isCancellationRequested)return;const F=this.D.get(h);if(!F)return;const W=await F.provideTerminalQuickFixes(b,k);if(W===null||Array.isArray(W)&&W.length===0)return;const J=new $.$Qc;if(this.w.value=J,!Array.isArray(W))return W?t.TerminalQuickFix.from(W,this.Q.converter,J):void 0;const N=[];for(const R of W){const L=t.TerminalQuickFix.from(R,this.Q.converter,J);L&&N.push(L)}return N}async $createContributedProfileTerminal(h,b){const k=new l.$2d().token;let F=await this.C.get(h)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(F&&!("options"in F)&&(F={options:F}),!F||!("options"in F))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in F.options){this.createExtensionTerminal(F.options,b);return}this.createTerminalFromOptions(F.options,b)}}async $provideLinks(h,b){const k=this.W(h);if(!k)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const W=new l.$2d;this.G.set(h,W);const J=[],N={terminal:k.value,line:b},R=[];for(const X of this.z)R.push(s.Promises.withAsyncBody(async he=>{W.token.onCancellationRequested(()=>he({provider:X,links:[]}));const $e=await X.provideTerminalLinks(N,W.token)||[];W.token.isCancellationRequested||he({provider:X,links:$e})}));const L=await Promise.all(R);if(W.token.isCancellationRequested)return[];const O=new Map;for(const X of L)X&&X.links.length>0&&J.push(...X.links.map(he=>{const $e={id:d++,startIndex:he.startIndex,length:he.length,label:he.tooltip};return O.set($e.id,{provider:X.provider,link:he}),$e}));return this.F.set(h,O),J}$activateLink(h,b){const k=this.F.get(h)?.get(b);k&&k.provider.handleTerminalLink(k.link)}U(h,b){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const k=this.h[h];k&&(k.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,b)}W(h){return this.X(this.f,h)}X(h,b){const k=this.Y(h,b);return k!==null?h[k]:null}Y(h,b){const k=h.findIndex(F=>F._id===b);return k===-1?null:k}getEnvironmentVariableCollection(h){let b=this.n.get(h.identifier.value);return b||(b=new r,this.$(h.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Z(h,b){const k=(0,S.$sr)(b.map),F=(0,S.$tr)(b.descriptionMap);this.a.$setEnvironmentVariableCollection(h,b.persistent,k.length===0?void 0:k,F)}$initEnvironmentVariableCollections(h){h.forEach(b=>{const k=b[0],F=new r(b[1]);this.$(k,F)})}$acceptDefaultProfile(h,b){const k=this.s;this.s=h,this.u=b,k?.path!==h.path&&this.N.fire(h.path)}$(h,b){this.n.set(h,b),b.onDidChangeCollection(()=>{this.Z(h,b)})}};e.$Uec=i,e.$Uec=i=Ke([We(1,n.$XM),We(2,P.$BM)],i);class r{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Rd,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const b=this.h(h);let k=this.a.get(b);return k||(k=new u(this,h),this.a.set(b,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(h,b,k,F){this.f(h,{value:b,type:m.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:F})}append(h,b,k,F){this.f(h,{value:b,type:m.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:F})}prepend(h,b,k,F){this.f(h,{value:b,type:m.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:F})}f(h,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(h,b.scope),F=this.map.get(k),W=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!F||F.value!==b.value||F.type!==b.type||F.options?.applyAtProcessCreation!==W.applyAtProcessCreation||F.options?.applyAtShellIntegration!==W.applyAtShellIntegration||F.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const J=this.g(h,b.scope),N={variable:h,...b,options:W};this.map.set(J,N),this.d.fire()}}get(h,b){const k=this.g(h,b),F=this.map.get(k);return F?D(F):void 0}g(h,b){const k=this.h(b);return k.length?`${h}:::${k}`:h}h(h){return this.j(h?.workspaceFolder)??""}j(h){return h?h.uri.toString():void 0}getVariableMap(h){const b=new Map;for(const[k,F]of this.map)this.h(F.scope)===this.h(h)&&b.set(F.variable,D(F));return b}delete(h,b){const k=this.g(h,b);this.map.delete(k),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[b,k]of this.map)k.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(b);this.k(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,b){const k=this.h(b),F=this.descriptionMap.get(k);if(!F||F.description!==h){let W;typeof h=="string"?W=h:W=h?.value.split(`

`)[0];const J={description:W,scope:b};this.descriptionMap.set(k,J),this.d.fire()}}getDescription(h){const b=this.h(h);return this.descriptionMap.get(b)?.description}k(h){const b=this.h(h);this.descriptionMap.delete(b)}}class u{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,b){this.b=h,this.d=b,this.a=new E.$Rd}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,b,k){this.b.replace(h,b,k,this.d)}append(h,b,k){this.b.append(h,b,k,this.d)}prepend(h,b,k){this.b.prepend(h,b,k,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,b){this.b.getVariableMap(this.d).forEach((k,F)=>h.call(b,F,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let f=class extends i{constructor(h,b){super(!1,h,b)}createTerminal(h,b,k){throw new A.$$}createTerminalFromOptions(h,b){throw new A.$$}};e.$Vec=f,e.$Vec=f=Ke([We(0,n.$XM),We(1,P.$BM)],f);function v(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function g(I){return a.ThemeColor.isThemeColor(I)?I:void 0}function D(I){const h={...I};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(Ae[266],Re([1,0,297,14,24,19,5,218,97,6,26,16,33,3,17,107,8,7,48,77,58,23]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a,s,t,n,o,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=e.$1fc=e.$Zfc=e.$Yfc=void 0;let i=class extends y.$Rc{constructor(N,R,L){super(),this.u=L,this.f=this.B(new P.$Rd),this.g=new Map,this.s=this.B(new P.$Rd),this.onResultsChanged=this.f.event,this.results=[],this.h=N.getProxy(p.$zK.MainThreadTesting),this.m=new k(this.h),this.j=new v(this.h),R.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const X=O,he=X.tests[X.tests.length-1].item.extId;return this.g.get(n.$sJ.root(he))?.collection.tree.get(he)?.actual??(0,a.$NM)(O)}case 18:{const{extId:X,message:he}=O;return{test:this.g.get(n.$sJ.root(X))?.collection.tree.get(X)?.actual,message:s.TestMessage.to(he)}}default:return O}}}),R.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await R.executeCommand("_testing.getExplorerSelection"),X=he=>{const $e=this.g.get(n.$sJ.root(he));if($e)return n.$sJ.isRoot(he)?$e.controller:$e.collection.tree.get(he)?.actual};return{include:O?.include.map(X).filter(S.$Kf)||[],exclude:O?.exclude.map(X).filter(S.$Kf)||[]}})}createTestController(N,R,L,O){if(this.g.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const X=new y.$Qc,he=X.add(new a.$QM(R,L,this.u));he.root.label=L;const $e=new Map,De=new Set,ke=this.h,de={items:he.root.children,get label(){return L},set label(_){L=_,he.root.label=_,ke.$updateController(R,{label:L})},get refreshHandler(){return O},set refreshHandler(_){O=_,ke.$updateController(R,{canRefresh:!!_})},get id(){return R},createRunProfile:(_,Ce,se,Q,U,ne)=>{let pe=(0,m.$Li)(_);for(;$e.has(pe);)pe++;return new F(this.h,$e,N,De,this.s.event,R,pe,_,Ce,se,Q,U,ne)},createTestItem(_,Ce,se){return new a.$OM(R,_,Ce,se)},createTestRun:(_,Ce,se=!0)=>this.j.createTestRun(N,R,he,_,Ce,se),invalidateTestResults:_=>{if(_===void 0)this.h.$markTestRetired(void 0);else{const Ce=_ instanceof Array?_:[_];this.h.$markTestRetired(Ce.map(se=>n.$sJ.fromExtHostTestItem(se,R).toString()))}},set resolveHandler(_){he.resolveHandler=_},get resolveHandler(){return he.resolveHandler},dispose:()=>{X.dispose()}};ke.$registerTestController(R,L,!!O),X.add((0,y.$Pc)(()=>ke.$unregisterTestController(R)));const Ee={controller:de,collection:he,profiles:$e,extension:N,activeProfiles:De};return this.g.set(R,Ee),X.add((0,y.$Pc)(()=>this.g.delete(R))),X.add(he.onDidGenerateDiff(_=>ke.$publishDiff(R,_.map(c.TestsDiffOp.serialize)))),de}createTestObserver(){return this.m.checkout()}async runTests(N,R=M.CancellationToken.None){const L=g(N);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.g.get(L.controllerId);if(!O)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(X=>n.$sJ.fromExtHostTestItem(X,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:W[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:N.exclude?.map(X=>X.id)},R)}$syncTests(){for(const{collection:N}of this.g.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,R,L){return(0,E.$qb)(this.j.trackers,X=>X.id===N?X.getCoverage(R):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(N,R,L,O){return(0,E.$qb)(this.j.trackers,he=>he.id===N?he.getCoverage(R):void 0)?.resolveFileCoverage(L,O)??Promise.resolve([])}$configureRunProfile(N,R){this.g.get(N)?.profiles.get(R)?.configureHandler?.()}$setActiveRunProfiles(N){const R=new Map;for(const[L,O]of Object.entries(N)){const X=this.g.get(L);if(!X)continue;const he=new Map,$e=O.filter(ke=>!X.activeProfiles.has(ke)),De=[...X.activeProfiles].filter(ke=>!O.includes(ke));for(const ke of $e)he.set(ke,!0),X.activeProfiles.add(ke);for(const ke of De)he.set(ke,!1),X.activeProfiles.delete(ke);he.size&&R.set(L,he)}this.s.fire(R)}async $refreshTests(N,R){await this.g.get(N)?.controller.refreshHandler?.(R)}$publishTestResults(N){this.results=Object.freeze(N.map(R=>(0,A.$dn)(s.TestResults.to(R))).concat(this.results).sort((R,L)=>L.completedAt-R.completedAt).slice(0,32)),this.f.fire()}async $expandTest(N,R){const L=this.g.get(n.$sJ.fromString(N).controllerId)?.collection;L&&(await L.expand(N,R<0?1/0:R),L.flushDiff())}$acceptDiff(N){this.m.applyDiff(N.map(c.TestsDiffOp.deserialize))}async $runControllerTests(N,R){return Promise.all(N.map(L=>this.w(L,!1,R)))}async $startContinuousRun(N,R){const L=new M.$2d(R),O=await Promise.all(N.map(X=>this.w(X,!0,L.token)));return!R.isCancellationRequested&&!O.some(X=>X.error)&&await new Promise(X=>R.onCancellationRequested(X)),L.dispose(!0),O}async w(N,R,L){const O=this.g.get(N.controllerId);if(!O)return{};const{collection:X,profiles:he,extension:$e}=O,De=he.get(N.profileId);if(!De)return{};const ke=N.testIds.map(Ce=>X.tree.get(Ce)).filter(S.$Kf),de=N.excludeExtIds.map(Ce=>O.collection.tree.get(Ce)).filter(S.$Kf).filter(Ce=>ke.some(se=>se.fullId.compare(Ce.fullId)===2));if(!ke.length)return{};const Ee=new t.$0L(ke.some(Ce=>Ce.actual instanceof a.$PM)?void 0:ke.map(Ce=>Ce.actual),de.map(Ce=>Ce.actual),De,R),_=(0,c.$uJ)(N)&&this.j.prepareForMainThreadTestRun(Ee,D.fromInternal(N,O.collection),$e,L);try{return await De.runHandler(Ee,L),{}}catch(Ce){return{error:String(Ce)}}finally{_&&(_.hasRunningTasks&&!L.isCancellationRequested&&await P.Event.toPromise(_.onEnd),_.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.j.cancelAllRuns():this.j.cancelRunById(N)}};e.$Yfc=i,e.$Yfc=i=Ke([We(0,w.$BM)],i);const r=1e4;var u;(function(J){J[J.Running=0]="Running",J[J.Cancelling=1]="Cancelling",J[J.Ended=2]="Ended"})(u||(u={}));class f extends y.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(N,R,L){super(),this.m=N,this.s=R,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new P.$Rd),this.onEnd=this.j.event,this.h=this.B(new M.$2d(L));const O=this.B(new T.$_g(()=>this.u(),r));this.B(this.h.token.onCancellationRequested(()=>O.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(N){return this.f.get(N)?.coverage}createRun(N){const R=this.m.id,L=this.m.controllerId,O=(0,l.$kg)(),X=new I(this.s,R,O),he=de=>(Ee,..._)=>{if(De){console.warn(`Setting the state of test "${Ee.id}" is a no-op after the run ends.`);return}this.m.isIncluded(Ee)&&(this.y(Ee),de(Ee,..._))},$e=(de,Ee)=>{const _=Ee instanceof Array?Ee.map(s.TestMessage.from):[s.TestMessage.from(Ee)];if(de.uri&&de.range){const Ce={range:s.Range.from(de.range),uri:de.uri};for(const se of _)se.location=se.location||Ce}this.s.$appendTestMessagesInRun(R,O,n.$sJ.fromExtHostTestItem(de,L).toString(),_)};let De=!1;const ke={isPersisted:this.m.isPersisted,token:this.h.token,name:N,get coverageProvider(){return X.coverageProvider},set coverageProvider(de){X.coverageProvider=de},enqueued:he(de=>{this.s.$updateTestStateInRun(R,O,n.$sJ.fromExtHostTestItem(de,L).toString(),1)}),skipped:he(de=>{this.s.$updateTestStateInRun(R,O,n.$sJ.fromExtHostTestItem(de,L).toString(),5)}),started:he(de=>{this.s.$updateTestStateInRun(R,O,n.$sJ.fromExtHostTestItem(de,L).toString(),2)}),errored:he((de,Ee,_)=>{$e(de,Ee),this.s.$updateTestStateInRun(R,O,n.$sJ.fromExtHostTestItem(de,L).toString(),6,_)}),failed:he((de,Ee,_)=>{$e(de,Ee),this.s.$updateTestStateInRun(R,O,n.$sJ.fromExtHostTestItem(de,L).toString(),4,_)}),passed:he((de,Ee)=>{this.s.$updateTestStateInRun(R,O,n.$sJ.fromExtHostTestItem(de,this.m.controllerId).toString(),3,Ee)}),appendOutput:(de,Ee,_)=>{De||(_&&(this.m.isIncluded(_)?this.y(_):_=void 0),this.s.$appendOutputToRun(R,O,C.$fe.fromString(de),Ee&&s.location.from(Ee),_&&n.$sJ.fromExtHostTestItem(_,L).toString()))},end:()=>{De||(De=!0,this.s.$finishedTestRunTask(R,O),this.f.delete(O),this.f.size||this.w())}};return this.f.set(O,{run:ke,coverage:X}),this.s.$startedTestRunTask(R,{id:O,name:N,running:!0}),ke}u(){for(const{run:N}of this.f.values())N.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(N){if(!(N instanceof a.$OM))throw new o.$tM(N.id);if(this.g.has(n.$sJ.fromExtHostTestItem(N,this.m.controllerId).toString()))return;const R=[],L=this.m.colllection.root;for(;;){const O=s.TestItem.from(N);if(R.unshift(O),this.g.has(O.extId)||(this.g.add(O.extId),N===L))break;N=N.parent||L}this.s.$addTestsToRun(this.m.controllerId,this.m.id,R)}dispose(){this.w(),super.dispose()}}class v{get trackers(){return this.c.values()}constructor(N){this.d=N,this.c=new Map}prepareForMainThreadTestRun(N,R,L,O){return this.f(N,R,L,O)}cancelRunById(N){for(const R of this.c.values())if(R.id===N){R.cancel();return}}cancelAllRuns(){for(const N of this.c.values())N.cancel()}createTestRun(N,R,L,O,X,he){const $e=this.c.get(O);if($e)return $e.createRun(X);const De=D.fromPublic(R,L,O,he),ke=g(O);this.d.$startedExtensionTestRun({controllerId:R,continuous:!!O.continuous,profile:ke&&{group:W[ke.kind],id:ke.profileId},exclude:O.exclude?.map(Ee=>n.$sJ.fromExtHostTestItem(Ee,L.root.id).toString())??[],id:De.id,include:O.include?.map(Ee=>n.$sJ.fromExtHostTestItem(Ee,L.root.id).toString())??[L.root.id],persist:he});const de=this.f(O,De,N);return P.Event.once(de.onEnd)(()=>{this.d.$finishedExtensionTestRun(De.id),de.dispose()}),de.createRun(X)}f(N,R,L,O){const X=new f(R,this.d,O);return this.c.set(N,X),P.Event.once(X.onEnd)(()=>this.c.delete(N)),X}}e.$Zfc=v;const g=J=>{if(J.profile){if(!(J.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return J.profile}};class D{static fromPublic(N,R,L,O){return new D(N,(0,l.$kg)(),L.include?.map(X=>n.$sJ.fromExtHostTestItem(X,N).toString())??[N],L.exclude?.map(X=>n.$sJ.fromExtHostTestItem(X,N).toString())??[],O,R)}static fromInternal(N,R){return new D(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,R)}constructor(N,R,L,O,X,he){this.controllerId=N,this.id=R,this.isPersisted=X,this.colllection=he,this.c=L.map($e=>$e+"\0"),this.d=O.map($e=>$e+"\0")}isIncluded(N){const R=n.$sJ.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const L of this.d)if(R===L||R.startsWith(L))return!1;for(const L of this.c)if(R===L||R.startsWith(L))return!0;return!1}}e.$1fc=D;class I{set coverageProvider(N){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");N&&(this.c=N,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(N,R,L){this.f=N,this.g=R,this.h=L}async provideFileCoverage(N){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(N))());try{return(await this.d)?.map(s.TestCoverage.fromFile)??[]}catch(R){throw this.d=void 0,R}}async resolveFileCoverage(N,R){const L=await this.d;let O=L?.[N];return!this.c||!L||!O?[]:(O.detailedCoverage||(O=L[N]=await this.c.resolveFileCoverage?.(O,R)??O),O.detailedCoverage?.map(s.TestCoverage.fromDetailed)??[])}}class h{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(N){this.h=N,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(N){this.c.add(N)}update(N){Object.assign(N.revived,s.TestItem.toPlain(N.item)),this.c.has(N)||this.d.add(N)}remove(N){if(this.c.has(N)){this.c.delete(N);return}this.d.delete(N);const R=n.$sJ.parentId(N.item.extId);if(R&&this.g.has(R.toString())){this.g.add(N.item.extId);return}this.f.add(N)}getChangeEvent(){const{c:N,d:R,f:L}=this;return{get added(){return[...N].map(O=>O.revived)},get updated(){return[...R].map(O=>O.revived)},get removed(){return[...L].map(O=>O.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class b extends c.$zJ{constructor(){super(...arguments),this.q=new P.$Rd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(N){return this.d.get(N)}getMirroredTestDataByReference(N){return this.d.get(N.id)}p(N,R){return{...N,revived:s.TestItem.toPlain(N.item),depth:R?R.depth+1:0,children:new Set}}o(){return new h(this.q)}}class k{constructor(N){this.d=N}checkout(){this.c||(this.c=this.f());const N=this.c;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(R=>R.revived)},dispose:(0,$.$cb)(()=>{--N.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(N){return this.c?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.c?.tests.apply(N)}f(){const N=new b;return this.d.$subscribeToDiffs(),{observers:0,tests:N}}}class F{#e;#t;#i;#o;#r;get label(){return this.d}set label(N){N!==this.d&&(this.d=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(N){N!==this.g&&(this.g=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this.f}set isDefault(N){N!==this.f&&(this.f=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?s.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this.c}set configureHandler(N){N!==this.c&&(this.c=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}get isSelected(){return(0,d.$OF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,d.$OF)(this.#t,"testingActiveProfile"),P.Event.chain(this.#o,N=>N.map(R=>R.get(this.controllerId)?.get(this.profileId)).filter(S.$Kf))}constructor(N,R,L,O,X,he,$e,De,ke,de,Ee=!1,_=void 0,Ce=!1){this.controllerId=he,this.profileId=$e,this.d=De,this.kind=ke,this.runHandler=de,this.f=Ee,this._tag=_,this.g=Ce,this.#e=N,this.#r=R,this.#t=L,this.#i=O,this.#o=X,R.set($e,this);const se=W[ke];if(typeof se!="number")throw new Error(`Unknown TestRunProfile.group ${ke}`);this.#e.$publishTestRunProfile({profileId:$e,controllerId:he,tag:_?s.TestTag.namespace(this.controllerId,_.id):null,label:De,group:se,isDefault:Ee,hasConfigurationHandler:!1,supportsContinuousRun:Ce})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$2fc=F;const W={[t.TestRunProfileKind.Coverage]:8,[t.TestRunProfileKind.Debug]:4,[t.TestRunProfileKind.Run]:2}}),define(Ae[267],Re([1,0,18,11,5,3,108,8,7]),function(we,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=void 0;class y{constructor(S,l){this.i=l,this.a=new C.$Rd({onListenerError:T.$1}),this.b=new C.$Rd({onListenerError:T.$1}),this.c=new C.$Rd({onListenerError:T.$1}),this.d=new C.$Rd({onListenerError:T.$1}),this.f=new C.$Rd({onListenerError:T.$1}),this.g=new C.$Rd({onListenerError:T.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=S.getProxy(M.$zK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(S){const l=this.i.allEditors();return S?l:l.map(p=>p.value)}async showTextDocument(S,l,p){let w;typeof l=="number"?w={position:$.ViewColumn.from(l),preserveFocus:p}:typeof l=="object"?w={position:$.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selection:typeof l.selection=="object"?$.Range.from(l.selection):void 0,pinned:typeof l.preview=="boolean"?!l.preview:void 0}:w={preserveFocus:!1};const a=await this.h.$tryShowTextDocument(S.uri,w),s=a&&this.i.getEditor(a);if(s)return s.value;throw a?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}createTextEditorDecorationType(S,l){return new P.$IM(this.h,S,l).value}$acceptEditorPropertiesChanged(S,l){const p=this.i.getEditor(S);if(!p)throw new Error("unknown text editor");if(l.options&&p._acceptOptions(l.options),l.selections){const w=l.selections.selections.map($.Selection.to);p._acceptSelections(w)}if(l.visibleRanges){const w=E.$Gb(l.visibleRanges.map($.Range.to));p._acceptVisibleRanges(w)}if(l.options&&this.b.fire({textEditor:p.value,options:{...l.options,lineNumbers:$.TextEditorLineNumbersStyle.to(l.options.lineNumbers)}}),l.selections){const w=m.TextEditorSelectionChangeKind.fromValue(l.selections.source),a=l.selections.selections.map($.Selection.to);this.a.fire({textEditor:p.value,selections:a,kind:w})}if(l.visibleRanges){const w=E.$Gb(l.visibleRanges.map($.Range.to));this.c.fire({textEditor:p.value,visibleRanges:w})}}$acceptEditorPositionData(S){for(const l in S){const p=this.i.getEditor(l);if(!p)throw new Error("Unknown text editor");const w=$.ViewColumn.to(S[l]);p.value.viewColumn!==w&&(p._acceptViewColumn(w),this.d.fire({textEditor:p.value,viewColumn:w}))}}getDiffInformation(S){return Promise.resolve(this.h.$getDiffInformation(S))}}e.$lec=y}),define(Ae[268],Re([1,0,2,4,3,6,7,8,22,16]),function(we,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=e.$4fc=void 0,e.$4fc=(0,T.$Xh)("IExtHostTimeline");class A{constructor(p,w){this.b=new Map,this.c=new Map,this.a=p.getProxy(C.$zK.MainThreadTimeline),w.registerArgumentProcessor({processArgument:(a,s)=>{if(a&&a.$mid===12)if(this.b.get(a.source)&&m.$bm.equals(s,this.b.get(a.source)?.extension)){const t=a.uri===void 0?void 0:E.URI.revive(a.uri);return this.c.get(a.source)?.get(S(t))?.get(a.handle)}else return;return a}})}async $getTimeline(p,w,a,s){return this.b.get(p)?.provider.provideTimeline(E.URI.revive(w),a,s)}registerTimelineProvider(p,w,a,s){const t=new M.$Qc,n=this.d(w.id,s,t).bind(this);let o;w.onDidChange&&(o=w.onDidChange(d=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...d,id:w.id}),this));const c=this.c;return this.f({...w,scheme:p,onDidChange:void 0,async provideTimeline(d,i,r){i?.resetCache&&(t.clear(),c.get(w.id)?.clear());const u=await w.provideTimeline(d,i,r);if(u==null)return;const f=n(d,i);return{...u,source:w.id,items:u.items.map(f)}},dispose(){for(const d of c.values())d.get(w.id)?.clear();o?.dispose(),t.dispose()}},a)}d(p,w,a){return(s,t)=>{let n;if(t?.cacheResults){let o=this.c.get(p);o===void 0&&(o=new Map,this.c.set(p,o));const c=S(s);n=o.get(c),n===void 0&&(n=new Map,o.set(c,n))}return o=>{const{iconPath:c,...d}=o,i=`${p}|${o.id??o.timestamp}`;n?.set(i,o);let r,u,f;o.iconPath&&(c instanceof P.$vL?f={id:c.id,color:c.color}:E.URI.isUri(c)?(r=c,u=c):{light:r,dark:u}=c);let v;return P.$2K.isMarkdownString(d.tooltip)?v=$.MarkdownString.from(d.tooltip):(0,y.$Cf)(d.tooltip)?v=d.tooltip:P.$2K.isMarkdownString(d.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=$.MarkdownString.from(d.detail)):(0,y.$Cf)(d.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=d.detail),{...d,id:d.id??void 0,handle:i,source:p,command:o.command?w.toInternal(o.command,a):void 0,icon:r,iconDark:u,themeIcon:f,tooltip:v,accessibilityInformation:o.accessibilityInformation}}}}f(p,w){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:w}),(0,M.$Pc)(()=>{for(const s of this.c.values())s.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$5fc=A;function S(l){return l?.toString()}}),define(Ae[87],Re([1,0,19,5,6,167,4,15,196,3,27,17,7]),function(we,e,E,T,C,M,P,$,m,y,A,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cxb=e.$bxb=e.TunnelDtoConverter=void 0;class p extends m.$ov{}var w;(function(s){function t(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:o.protocol}}s.fromApiTunnel=t;function n(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==m.TunnelPrivacyId.ConstantPrivate&&o.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}s.fromServiceTunnel=n})(w||(e.TunnelDtoConverter=w={})),e.$bxb=(0,P.$Xh)("IExtHostTunnelService");let a=class extends C.$Rc{constructor(t,n,o){super(),this.s=o,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Rd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=t.getProxy(y.$zK.MainThreadTunnelService)}async openTunnel(t,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const o=await this.a.$openTunnel(n,t.displayName);if(o){const c=new p(o.remoteAddress,o.localAddress,()=>this.a.$closeTunnel(o.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(t,n){const o=this.u();return this.r.set(o,{selector:t,provider:n}),this.a.$registerPortsAttributesProvider(t,o),new l.$BK(()=>{this.r.delete(o),this.a.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(t,n,o,c,d){const i=[];for(const u of t){const f=this.r.get(u);if(!f)return[];i.push(...await Promise.all(n.map(async v=>{let g;try{g=await f.provider.providePortAttributes({port:v,pid:o,commandLine:c},d)}catch{g=await f.provider.providePortAttributes(v,o,c,d)}return{providedAttributes:g,port:v}})))}const r=i.filter(u=>!!u.providedAttributes);return r.length>0?r.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder(t){}registerTunnelProvider(t,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,d)=>await t.provideTunnel(c,d,new E.$2d().token)??void 0;const o=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(o),Promise.resolve((0,C.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(t,n){if(t){t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.f=t.showCandidatePort,this.a.$setCandidateFilter());const o=t.tunnelFactory??(n?this.w(n):void 0);if(o){this.b=o;let c=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const d=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:c}:void 0;this.a.$setTunnelProvider(d)}}else this.b=void 0;return(0,C.$Pc)(()=>{this.b=void 0})}w(t){}async $closeTunnel(t,n){if(this.g.has(t.host)){const o=this.g.get(t.host);o.has(t.port)&&(n&&o.get(t.port).disposeListener.dispose(),await o.get(t.port).tunnel.dispose(),o.delete(t.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(t,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this.b(t,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const c=await o;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(t.remoteAddress.host)||this.g.set(t.remoteAddress.host,new Map);const d=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:c,disposeListener:d}),w.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(t){const n=await Promise.all(t.map(c=>this.f(c.host,c.port,c.detail??""))),o=t.filter((c,d)=>n[d]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(c=>c.port).join(", ")} to ${o.map(c=>c.port).join(", ")}`),o}};e.$cxb=a,e.$cxb=a=Ke([We(0,S.$BM),We(1,A.$RM),We(2,$.$fj)],a)}),define(Ae[269],Re([1,0,6,13,2,3]),function(we,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;class P{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(m){this.c=new Map,this.b=m.getProxy(M.$zK.MainThreadUriOpeners)}registerExternalUriOpener(m,y,A,S){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const l=S.schemes.find(p=>!P.a.has(p));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(y,A),this.b.$registerUriOpener(y,S.schemes,m,S.label),(0,E.$Pc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri(m,y,A){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener with id: ${m}`);const l=C.URI.revive(y);return S.canOpenExternalUri(l,A)}async $openUri(m,y,A){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener id: '${m}'`);return S.openExternalUri(C.URI.revive(y.resolvedUri),{sourceUri:C.URI.revive(y.sourceUri)},A)}}e.$7fc=P}),define(Ae[270],Re([1,0,3,2,6,11,22]),function(we,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=void 0;class ${static{this.a=0}constructor(y){this.c=new P.$cm,this.d=new Map,this.b=y.getProxy(E.$zK.MainThreadUrls)}registerUriHandler(y,A){const S=y.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const l=$.a++;return this.c.add(S),this.d.set(l,A),this.b.$registerUriHandler(l,S,y.displayName||y.name),(0,C.$Pc)(()=>{this.c.delete(S),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(y,A){const S=this.d.get(y);if(!S)return Promise.resolve(void 0);try{S.handleUri(T.URI.revive(A))}catch(l){(0,M.$Z)(l)}return Promise.resolve(void 0)}async createAppUri(y){return T.URI.revive(await this.b.$createAppUri(y))}}e.$8fc=$}),define(Ae[65],Re([1,0,5,6,13,26,2,181,203,78,3]),function(we,e,E,T,C,M,P,$,m,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=e.$Cec=e.$Bec=e.$Aec=e.$zec=void 0;class S{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(c,d,i,r,u,f,v){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new E.$Rd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Rd,this._onDidDispose=this.#h.event,this.#e=c,this.#t=d,this.#s=i,this.#o=r,this.#r=u,this.#n=f,this.#l=l(f),this.#d=p(f),this.#i=v}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,y.$kub)(c,this.#o)}get cspSource(){const c=this.#n.extensionLocation;if(c.scheme===C.Schemas.https||c.scheme===C.Schemas.http){let d=c.toString();return d.endsWith("/")||(d+="/"),d+" "+y.$jub}return y.$jub}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#s}set options(c){this.a(),M.$gn(this.#s,c)||this.#t.$setOptions(this.#e,s(this.#n,this.#r,c)),this.#s=c}async postMessage(c){if(this.#c)return!1;const d=(0,m.$Dcb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,d.message,...d.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const d=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,i=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,u,f,v,g,D)=>{const I=P.URI.from({scheme:v||"file",path:decodeURIComponent(g)}),h=(0,y.$kub)(I,{isRemote:d,authority:i}).toString();return`${u}${h}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,u,f,v,g,D)=>{const I=P.URI.from({scheme:v||"file",path:decodeURIComponent(g)}),h=(0,y.$kub)(I,{isRemote:d,authority:i}).toString();return`${u}${h}${D}`})}}e.$zec=S;function l(o){try{const c=(0,$.$Vo)((0,$.$Uo)(o.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.$Aec=l;function p(o){try{const c=(0,$.$Vo)((0,$.$Uo)(o.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class w extends T.$Rc{constructor(c,d,i,r,u){super(),this.c=d,this.f=i,this.g=r,this.h=u,this.b=new Map,this.a=c.getProxy(A.$zK.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,d,i){const r=this.j(c);if(r){const{message:u}=(0,m.$Ecb)(d,i.value);r._onMessageEmitter.fire(u)}}$onMissingCsp(c,d){this.g.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,d,i){const r=new S(c,this.a,t(d),this.c,this.f,i,this.h);this.b.set(c,r);const u=r._onDidDispose(()=>{u.dispose(),this.deleteWebview(c)});return r}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Bec=w;function a(o){return{id:o.identifier,location:o.extensionLocation}}e.$Cec=a;function s(o,c,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||n(o,c)}}e.$Dec=s;function t(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(c=>P.URI.from(c))}}function n(o,c){return[...(c?.getWorkspaceFolders()||[]).map(d=>d.uri),o.extensionLocation]}}),define(Ae[271],Re([1,0,19,97,6,13,25,2,8,65,75,3,7]),function(we,e,E,T,C,M,P,$,m,y,A,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;class p{constructor(r,u){this.document=r,this.b=u,this.a=1,this.c=new A.$5dc("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,u){await this.f(r).undo(),u||this.disposeBackup()}async redo(r,u){await this.f(r).redo(),u||this.disposeBackup()}disposeEdits(r){for(const u of r)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=d(this.document.uri)+this.a++;return(0,P.$Bg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const u=this.c.get(r,0);if(!u)throw new Error("No edit found");return u}}class w{constructor(){this.a=new Map}get(r,u){return this.a.get(this.b(r,u))}add(r,u,f){const v=this.b(r,u.uri);if(this.a.has(v))throw new Error(`Document already exists for viewType:${r} resource:${u.uri}`);const g=new p(u,f);return this.a.set(v,g),g}delete(r,u){const f=this.b(r,u.uri);this.a.delete(f)}b(r,u){return`${r}@@@${u}`}}var a;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(a||(a={}));class s{constructor(){this.a=new Map}addTextProvider(r,u,f){return this.b(0,r,u,f)}addCustomProvider(r,u,f){return this.b(1,r,u,f)}get(r){return this.a.get(r)}b(r,u,f,v){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,{type:r,extension:f,provider:v}),new l.$BK(()=>this.a.delete(u))}}class t{constructor(r,u,f,v,g){this.d=u,this.f=f,this.g=v,this.h=g,this.b=new s,this.c=new w,this.a=r.getProxy(S.$zK.MainThreadCustomEditors)}registerCustomEditorProvider(r,u,f,v){const g=new C.$Qc;return o(f)?(g.add(this.b.addTextProvider(u,r,f)),this.a.$registerTextEditorProvider((0,y.$Cec)(r),u,v.webviewOptions||{},{supportsMove:!!f.moveCustomTextEditor},(0,y.$Aec)(r))):(g.add(this.b.addCustomProvider(u,r,f)),n(f)&&g.add(f.onDidChangeCustomDocument(D=>{const I=this.i(u,D.document.uri);if(c(D)){const h=I.addEdit(D);this.a.$onDidEdit(D.document.uri,u,h,D.label)}else this.a.$onContentChange(D.document.uri,u)})),this.a.$registerCustomEditorProvider((0,y.$Cec)(r),u,v.webviewOptions||{},!!v.supportsMultipleEditorsPerDocument,(0,y.$Aec)(r))),l.$BK.from(g,new l.$BK(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(r,u,f,v,g){const D=this.b.get(u);if(!D)throw new Error(`No provider found for '${u}'`);if(D.type!==1)throw new Error(`Invalid provide type for '${u}'`);const I=$.URI.revive(r),h=await D.provider.openCustomDocument(I,{backupId:f,untitledDocumentData:v?.buffer},g);let b;return n(D.provider)&&this.f&&(b=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(u,h,b),{editable:n(D.provider)}}async $disposeCustomDocument(r,u){const f=this.b.get(u);if(!f)throw new Error(`No provider found for '${u}'`);if(f.type!==1)throw new Error(`Invalid provider type for '${u}'`);const v=$.URI.revive(r),{document:g}=this.i(u,v);this.c.delete(u,g),g.dispose()}async $resolveCustomEditor(r,u,f,v,g,D){const I=this.b.get(f);if(!I)throw new Error(`No provider found for '${f}'`);const h=m.ViewColumn.to(g),b=this.g.createNewWebview(u,v.contentOptions,I.extension),k=this.h.createNewWebviewPanel(u,f,v.title,h,v.options,b,v.active),F=$.URI.revive(r);switch(I.type){case 1:{const{document:W}=this.i(f,F);return I.provider.resolveCustomEditor(W,k,D)}case 0:{const W=this.d.getDocument(F);return I.provider.resolveCustomTextEditor(W,k,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,u,f){this.i(u,r).disposeEdits(f)}async $onMoveCustomEditor(r,u,f){const v=this.b.get(f);if(!v)throw new Error(`No provider found for '${f}'`);if(!v.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${f}'`);const g=this.h.getWebviewPanel(r);if(!g)throw new Error("No webview found");const D=$.URI.revive(u),I=this.d.getDocument(D);await v.provider.moveCustomTextEditor(I,g,E.CancellationToken.None)}async $undo(r,u,f,v){return this.i(u,r).undo(f,v)}async $redo(r,u,f,v){return this.i(u,r).redo(f,v)}async $revert(r,u,f){const v=this.i(u,r);await this.j(u).revertCustomDocument(v.document,f),v.disposeBackup()}async $onSave(r,u,f){const v=this.i(u,r);await this.j(u).saveCustomDocument(v.document,f),v.disposeBackup()}async $onSaveAs(r,u,f,v){const g=this.i(u,r);return this.j(u).saveCustomDocumentAs(g.document,$.URI.revive(f),v)}async $backup(r,u,f){const v=this.i(u,r),D=await this.j(u).backupCustomDocument(v.document,{destination:v.getNewBackupUri()},f);return v.updateBackup(D),D.id}i(r,u){const f=this.c.get(r,$.URI.revive(u));if(!f)throw new Error("No custom document found");return f}j(r){const f=this.b.get(r)?.provider;if(!f||!n(f))throw new Error("Custom document is not editable");return f}}e.$Fec=t;function n(i){return!!i.onDidChangeCustomDocument}function o(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function d(i){const r=i.scheme===M.Schemas.file||i.scheme===M.Schemas.untitled?i.fsPath:i.toString();return(0,T.$Li)(r)+""}}),define(Ae[272],Re([1,0,5,6,2,33,8,65,3,7]),function(we,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=void 0;class A extends T.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(w,a,s,t){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new E.$Rd),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Rd),this.onDidChangeViewState=this.#h.event,this.#e=w,this.#t=a,this.#o=s,this.#i=t.viewType,this.#r=t.panelOptions,this.#s=t.viewColumn,this.#n=t.title,this.#u=t.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(w){this.c(),this.#n!==w&&(this.#n=w,this.#t.$setTitle(this.#e,w))}get iconPath(){return this.c(),this.#a}set iconPath(w){this.c(),this.#a!==w&&(this.#a=w,this.#t.$setIconPath(this.#e,C.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(w){this.#l||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(this.#u=w.active,this.#c=w.visible,this.#s=w.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(w,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof w>"u"?void 0:P.ViewColumn.from(w),preserveFocus:!!a})}c(){if(this.#l)throw new Error("Webview is disposed")}}class S extends T.$Rc{static c(){return(0,M.$kg)()}constructor(w,a,s){super(),this.j=a,this.m=s,this.g=new Map,this.h=new Map,this.f=w.getProxy(m.$zK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(w=>w.dispose()),this.g.clear()}createWebviewPanel(w,a,s,t,n={}){const o=typeof t=="object"?t.viewColumn:t,c={viewColumn:P.ViewColumn.from(o),preserveFocus:typeof t=="object"&&!!t.preserveFocus},d=(0,$.$Aec)(w),i=S.c();this.f.$createWebviewPanel((0,$.$Cec)(w),i,a,{title:s,panelOptions:l(n),webviewOptions:(0,$.$Dec)(w,this.m,n),serializeBuffersForPostMessage:d},c);const r=this.j.createNewWebview(i,n,w);return this.createNewWebviewPanel(i,a,s,o,n,r,!0)}$onDidChangeWebviewPanelViewStates(w){const a=Object.keys(w);a.sort((s,t)=>{const n=w[s],o=w[t];return n.active?1:o.active?-1:+n.visible-+o.visible});for(const s of a){const t=this.getWebviewPanel(s);if(!t)continue;const n=w[s];t._updateViewState({active:n.active,visible:n.visible,viewColumn:P.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(w){this.getWebviewPanel(w)?.dispose(),this.g.delete(w),this.j.deleteWebview(w)}registerWebviewPanelSerializer(w,a,s){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:s,extension:w}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,$.$Aec)(w)}),new y.$BK(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(w,a,s,t){const n=this.h.get(a);if(!n)throw new Error(`No serializer found for '${a}'`);const{serializer:o,extension:c}=n,d=this.j.createNewWebview(w,s.webviewOptions,c),i=this.createNewWebviewPanel(w,a,s.title,t,s.panelOptions,d,s.active);await o.deserializeWebviewPanel(i,s.state)}createNewWebviewPanel(w,a,s,t,n,o,c){const d=new A(w,this.f,o,{viewType:a,title:s,viewColumn:t,panelOptions:n,active:c});return this.g.set(w,d),d}getWebviewPanel(w){return this.g.get(w)}}e.$Eec=S;function l(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Ae[273],Re([1,0,5,6,65,8,3,7]),function(we,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=void 0;class m extends T.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(S,l,p,w,a,s){super(),this.#r=!1,this.#u=this.B(new E.$Rd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new E.$Rd),this.onDidDispose=this.#l.event,this.#i=p,this.#a=w,this.#e=S,this.#t=l,this.#o=a,this.#n=s}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#s}set description(S){this.a(),this.#s!==S&&(this.#s=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(S){S===this.#n||this.#r||(this.#n=S,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#r)throw new Error("Webview is disposed")}}class y{constructor(S,l){this.d=l,this.b=new Map,this.c=new Map,this.a=S.getProxy(P.$zK.MainThreadWebviewViews)}registerWebviewViewProvider(S,l,p,w){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:p,extension:S}),this.a.$registerWebviewViewProvider((0,C.$Cec)(S),l,{retainContextWhenHidden:w?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Aec)(S)}),new $.$BK(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(S,l,p,w,a){const s=this.b.get(l);if(!s)throw new Error(`No view provider found for '${l}'`);const{provider:t,extension:n}=s,o=this.d.createNewWebview(S,{},n),c=new m(S,this.a,l,p,o,!0);this.c.set(S,c),await t.resolveWebviewView(c,{state:w},a)}async $onDidChangeWebviewViewVisibility(S,l){this.e(S)._setVisible(l)}async $disposeWebviewView(S){const l=this.e(S);this.c.delete(S),l.dispose(),this.d.deleteWebview(S)}e(S){const l=this.c.get(S);if(!l)throw new Error("No webview found");return l}}e.$9fc=y}),define(Ae[110],Re([1,0,5,3,2,13,12,4,17,23]),function(we,e,E,T,C,M,P,$,m,y){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=e.$0fc=void 0;let S=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(p){const w=this.d;return{get focused(){return w.focused},get active(){return(0,y.$OF)(p,"windowActivity"),w.active}}}constructor(p){this.c=new E.$Rd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=p.getProxy(T.$zK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:w,isActive:a})=>{this.onDidChangeWindowProperty("focused",w),this.onDidChangeWindowProperty("active",a)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,w){w!==this.d[p]&&(this.d={...this.d,[p]:w},this.c.fire(this.d))}openUri(p,w){let a;if(typeof p=="string"){a=p;try{p=C.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,P.$Fe)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,a,w)}async asExternalUri(p,w){if((0,P.$Fe)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const a=await this.b.$asExternalUri(p,w);return C.URI.from(a)}};e.$0fc=S,e.$0fc=S=A=Ke([We(0,m.$BM)],S),e.$$fc=(0,$.$Xh)("IExtHostWindow")}),define(Ae[274],Re([1,0,240,27,17]),function(we,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=void 0;let M=class extends E.$bgc{constructor($,m){super($,m)}f($,m,y){m.apply(console,y)}};e.$jic=M,e.$jic=M=Ke([We(0,C.$BM),We(1,T.$RM)],M)}),define(Ae[275],Re([1,0,14,24,19,11,5,6,138,229,49]),function(we,e,E,T,C,M,P,$,m,y,A){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$o6b=e.ResponsiveState=e.RequestInitiator=e.$n6b=e.$m6b=void 0;function l(k,F){try{return JSON.stringify(k,F)}catch{return"null"}}const p="$$ref$$",w={[p]:-1};class a{constructor(F,W){this.jsonString=F,this.referencedBuffers=W}}function s(k,F=null,W=!1){const J=[];return{jsonString:(W?l:JSON.stringify)(k,(R,L)=>{if(typeof L>"u")return w;if(typeof L=="object"){if(L instanceof T.$fe){const O=J.push(L)-1;return{[p]:O}}if(F)return F(R,L)}return L}),referencedBuffers:J}}e.$m6b=s;function t(k,F,W){return JSON.parse(k,(J,N)=>{if(N){const R=N[p];if(typeof R=="number")return F[R];if(W&&N.$mid===1)return W.transformIncoming(N)}return N})}e.$n6b=t;function n(k,F){return JSON.stringify(k,F)}function o(k){return k?(F,W)=>W&&W.$mid===1?k.transformOutgoing(W):W:null}var c;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var d;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(d||(e.ResponsiveState=d={}));const i=()=>{},r=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class f extends $.$Rc{static{S=r}static{this.a=3*1e3}constructor(F,W=null,J=null){super(),this[S]=!0,this.b=this.B(new P.$Rd),this.onDidChangeResponsiveState=this.b.event,this.c=F,this.f=W,this.g=J,this.h=o(this.g),this.j=!1,this.m=[],this.s=[];for(let N=0,R=A.$vv.count;N<R;N++)this.m[N]=null,this.s[N]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$_g(()=>this.H(),1e3)),this.c.onMessage(N=>this.L(N))}dispose(){this.j=!0,Object.keys(this.w).forEach(F=>{const W=this.w[F];delete this.w[F],W.resolveErr(M.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(F){this.z===0&&(this.C=Date.now()+f.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(F){this.C=Date.now()+f.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(F){this.y!==F&&(this.y=F,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(F){return this.g?(0,m.$Wm)(F,this.g):F}getProxy(F){const{nid:W,sid:J}=F;return this.s[W]||(this.s[W]=this.J(W,J)),this.s[W]}J(F,W){const J={get:(N,R)=>(typeof R=="string"&&!N[R]&&R.charCodeAt(0)===36&&(N[R]=(...L)=>this.U(F,R,L)),R===u?W:N[R])};return new Proxy(Object.create(null),J)}set(F,W){return this.m[F.nid]=W,W}assertRegistered(F){for(let W=0,J=F.length;W<J;W++){const N=F[W];if(!this.m[N.nid])throw new Error(`Missing proxy instance ${N.sid}`)}}L(F){if(this.j)return;const W=F.byteLength,J=g.read(F,0),N=J.readUInt8(),R=J.readUInt32();switch(N){case 1:case 2:{let{rpcId:L,method:O,args:X}=I.deserializeRequestJSONArgs(J);this.g&&(X=(0,m.$Wm)(X,this.g)),this.M(W,R,L,O,X,N===2);break}case 3:case 4:{let{rpcId:L,method:O,args:X}=I.deserializeRequestMixedArgs(J);this.g&&(X=(0,m.$Wm)(X,this.g)),this.M(W,R,L,O,X,N===4);break}case 5:{this.f?.logIncoming(W,R,0,"ack"),this.G(R);break}case 6:{this.N(W,R);break}case 7:{this.O(W,R,void 0);break}case 9:{let L=I.deserializeReplyOKJSON(J);this.g&&(L=(0,m.$Wm)(L,this.g)),this.O(W,R,L);break}case 10:{const L=I.deserializeReplyOKJSONWithBuffers(J,this.g);this.O(W,R,L);break}case 8:{const L=I.deserializeReplyOKVSBuffer(J);this.O(W,R,L);break}case 11:{let L=I.deserializeReplyErrError(J);this.g&&(L=(0,m.$Wm)(L,this.g)),this.P(W,R,L);break}case 12:{this.P(W,R,void 0);break}default:console.error("received unexpected message"),console.error(F)}}M(F,W,J,N,R,L){this.f?.logIncoming(F,W,1,`receiveRequest ${(0,A.$xv)(J)}.${N}(`,R);const O=String(W);let X,he;if(L){const De=new C.$2d;R.push(De.token),X=this.Q(J,N,R),he=()=>De.cancel()}else X=this.Q(J,N,R),he=i;this.u[O]=he;const $e=I.serializeAcknowledged(W);this.f?.logOutgoing($e.byteLength,W,1,"ack"),this.c.send($e),X.then(De=>{delete this.u[O];const ke=I.serializeReplyOK(W,De,this.h);this.f?.logOutgoing(ke.byteLength,W,1,"reply:",De),this.c.send(ke)},De=>{delete this.u[O];const ke=I.serializeReplyErr(W,De);this.f?.logOutgoing(ke.byteLength,W,1,"replyErr:",De),this.c.send(ke)})}N(F,W){this.f?.logIncoming(F,W,1,"receiveCancel");const J=String(W);this.u[J]?.()}O(F,W,J){this.f?.logIncoming(F,W,0,"receiveReply:",J);const N=String(W);if(!this.w.hasOwnProperty(N))return;const R=this.w[N];delete this.w[N],R.resolveOk(J)}P(F,W,J){this.f?.logIncoming(F,W,0,"receiveReplyErr:",J);const N=String(W);if(!this.w.hasOwnProperty(N))return;const R=this.w[N];delete this.w[N];let L;J&&(J.$isError?(L=new Error,L.name=J.name,L.message=J.message,L.stack=J.stack):L=J),R.resolveErr(L)}Q(F,W,J){try{return Promise.resolve(this.S(F,W,J))}catch(N){return Promise.reject(N)}}S(F,W,J){const N=this.m[F];if(!N)throw new Error("Unknown actor "+(0,A.$xv)(F));const R=N[W];if(typeof R!="function")throw new Error("Unknown method "+W+" on actor "+(0,A.$xv)(F));return R.apply(N,J)}U(F,W,J){if(this.j)return new y.$l6b;let N=null;if(J.length>0&&C.CancellationToken.isCancellationToken(J[J.length-1])&&(N=J.pop()),N&&N.isCancellationRequested)return Promise.reject(M.$5());const R=I.serializeRequestArguments(J,this.h),L=++this.t,O=String(L),X=new y.$k6b,he=new $.$Qc;N&&he.add(N.onCancellationRequested(()=>{const De=I.serializeCancel(L);this.f?.logOutgoing(De.byteLength,L,0,"cancel"),this.c.send(I.serializeCancel(L))})),this.w[O]=new v(X,he),this.F(L);const $e=I.serializeRequest(L,F,W,R,!!N);return this.f?.logOutgoing($e.byteLength,L,0,`request: ${(0,A.$xv)(F)}.${W}(`,J),this.c.send($e),X}}e.$o6b=f;class v{constructor(F,W){this.a=F,this.b=W}resolveOk(F){this.a.resolveOk(F),this.b.dispose()}resolveErr(F){this.a.resolveErr(F),this.b.dispose()}}class g{static alloc(F,W,J){const N=new g(T.$fe.alloc(J+1+4),0);return N.writeUInt8(F),N.writeUInt32(W),N}static read(F,W){return new g(F,W)}get buffer(){return this.a}constructor(F,W){this.a=F,this.b=W}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(F){this.a.writeUInt8(F,this.b),this.b+=1}readUInt8(){const F=this.a.readUInt8(this.b);return this.b+=1,F}writeUInt32(F){this.a.writeUInt32BE(F,this.b),this.b+=4}readUInt32(){const F=this.a.readUInt32BE(this.b);return this.b+=4,F}static sizeShortString(F){return 1+F.byteLength}writeShortString(F){this.a.writeUInt8(F.byteLength,this.b),this.b+=1,this.a.set(F,this.b),this.b+=F.byteLength}readShortString(){const F=this.a.readUInt8(this.b);this.b+=1;const J=this.a.slice(this.b,this.b+F).toString();return this.b+=F,J}static sizeLongString(F){return 4+F.byteLength}writeLongString(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readLongString(){const F=this.a.readUInt32BE(this.b);this.b+=4;const J=this.a.slice(this.b,this.b+F).toString();return this.b+=F,J}writeBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}static sizeVSBuffer(F){return 4+F.byteLength}writeVSBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readVSBuffer(){const F=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+F);return this.b+=F,W}static sizeMixedArray(F){let W=0;W+=1;for(let J=0,N=F.length;J<N;J++){const R=F[J];switch(W+=1,R.type){case 1:W+=this.sizeLongString(R.value);break;case 2:W+=this.sizeVSBuffer(R.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(R.value);for(let L=0;L<R.buffers.length;++L)W+=this.sizeVSBuffer(R.buffers[L]);break;case 4:break}}return W}writeMixedArray(F){this.a.writeUInt8(F.length,this.b),this.b+=1;for(let W=0,J=F.length;W<J;W++){const N=F[W];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let R=0;R<N.buffers.length;++R)this.writeBuffer(N.buffers[R]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const F=this.a.readUInt8(this.b);this.b+=1;const W=new Array(F);for(let J=0;J<F;J++)switch(this.readUInt8()){case 1:W[J]=this.readLongString();break;case 2:W[J]=this.readVSBuffer();break;case 3:{const R=this.readUInt32(),L=this.readLongString(),O=[];for(let X=0;X<R;++X)O.push(this.readVSBuffer());W[J]=new A.$yv(t(L,O,null));break}case 4:W[J]=void 0;break}return W}}var D;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(D||(D={}));class I{static a(F){for(let W=0,J=F.length;W<J;W++)if(F[W]instanceof T.$fe||F[W]instanceof A.$yv||typeof F[W]>"u")return!0;return!1}static serializeRequestArguments(F,W){if(this.a(F)){const J=[];for(let N=0,R=F.length;N<R;N++){const L=F[N];if(L instanceof T.$fe)J[N]={type:2,value:L};else if(typeof L>"u")J[N]={type:4};else if(L instanceof A.$yv){const{jsonString:O,referencedBuffers:X}=s(L.value,W);J[N]={type:3,value:T.$fe.fromString(O),buffers:X}}else J[N]={type:1,value:T.$fe.fromString(n(L,W))}}return{type:1,args:J}}return{type:0,args:n(F,W)}}static serializeRequest(F,W,J,N,R){switch(N.type){case 0:return this.b(F,W,J,N.args,R);case 1:return this.c(F,W,J,N.args,R)}}static b(F,W,J,N,R){const L=T.$fe.fromString(J),O=T.$fe.fromString(N);let X=0;X+=g.sizeUInt8(),X+=g.sizeShortString(L),X+=g.sizeLongString(O);const he=g.alloc(R?2:1,F,X);return he.writeUInt8(W),he.writeShortString(L),he.writeLongString(O),he.buffer}static deserializeRequestJSONArgs(F){const W=F.readUInt8(),J=F.readShortString(),N=F.readLongString();return{rpcId:W,method:J,args:JSON.parse(N)}}static c(F,W,J,N,R){const L=T.$fe.fromString(J);let O=0;O+=g.sizeUInt8(),O+=g.sizeShortString(L),O+=g.sizeMixedArray(N);const X=g.alloc(R?4:3,F,O);return X.writeUInt8(W),X.writeShortString(L),X.writeMixedArray(N),X.buffer}static deserializeRequestMixedArgs(F){const W=F.readUInt8(),J=F.readShortString(),N=F.readMixedArray(),R=new Array(N.length);for(let L=0,O=N.length;L<O;L++){const X=N[L];typeof X=="string"?R[L]=JSON.parse(X):R[L]=X}return{rpcId:W,method:J,args:R}}static serializeAcknowledged(F){return g.alloc(5,F,0).buffer}static serializeCancel(F){return g.alloc(6,F,0).buffer}static serializeReplyOK(F,W,J){if(typeof W>"u")return this.d(F);if(W instanceof T.$fe)return this.e(F,W);if(W instanceof A.$yv){const{jsonString:N,referencedBuffers:R}=s(W.value,J,!0);return this.g(F,N,R)}else return this.f(F,l(W,J))}static d(F){return g.alloc(7,F,0).buffer}static e(F,W){let J=0;J+=g.sizeVSBuffer(W);const N=g.alloc(8,F,J);return N.writeVSBuffer(W),N.buffer}static deserializeReplyOKVSBuffer(F){return F.readVSBuffer()}static f(F,W){const J=T.$fe.fromString(W);let N=0;N+=g.sizeLongString(J);const R=g.alloc(9,F,N);return R.writeLongString(J),R.buffer}static g(F,W,J){const N=T.$fe.fromString(W);let R=0;R+=g.sizeUInt32,R+=g.sizeLongString(N);for(const O of J)R+=g.sizeVSBuffer(O);const L=g.alloc(10,F,R);L.writeUInt32(J.length),L.writeLongString(N);for(const O of J)L.writeBuffer(O);return L.buffer}static deserializeReplyOKJSON(F){const W=F.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(F,W){const J=F.readUInt32(),N=F.readLongString(),R=[];for(let L=0;L<J;++L)R.push(F.readVSBuffer());return new A.$yv(t(N,R,W))}static serializeReplyErr(F,W){const J=W?l(M.$2(W),null):void 0;if(typeof J!="string")return this.h(F);const N=T.$fe.fromString(J);let R=0;R+=g.sizeLongString(N);const L=g.alloc(11,F,R);return L.writeLongString(N),L.buffer}static deserializeReplyErrError(F){const W=F.readLongString();return JSON.parse(W)}static h(F){return g.alloc(12,F,0).buffer}}var h;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var b;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(b||(b={}))}),define(Ae[276],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0;const E=function(M){const P=$=>{globalThis.removeEventListener("message",P);const m=$.data;Object.defineProperties(globalThis,{postMessage:{value(y,A){m.postMessage(y,A)}},onmessage:{get(){return m.onmessage},set(y){m.onmessage=y}}}),m.addEventListener("message",y=>{globalThis.dispatchEvent(new MessageEvent("message",{data:y.data,ports:y.ports?[...y.ports]:void 0}))}),m.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",P)}.toString();class T extends EventTarget{constructor(M,P,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const m=`((${E})('${P}'))`,y=new Blob([m],{type:"application/javascript"}),A=URL.createObjectURL(y),S=new MessageChannel,l=A,p={type:"_newWorker",id:l,port:S.port2,url:A,options:$};M(p,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{M({type:"_terminateWorker",id:l}),URL.revokeObjectURL(A),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(w){S.port1.onmessage=w}},onmessageerror:{get(){return S.port1.onmessageerror},set(w){S.port1.onmessageerror=w}}}),S.port1.addEventListener("messageerror",w=>{const a=new MessageEvent("messageerror",{data:w.data});this.dispatchEvent(a)}),S.port1.addEventListener("message",w=>{const a=new MessageEvent("message",{data:w.data});this.dispatchEvent(a)}),S.port1.start()}}e.$lic=T}),define(Ae[277],Re([1,0,5,30,35,4]),function(we,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VJ=e.$UJ=e.OutputChannelUpdateMode=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=void 0,e.$KJ="text/x-code-output",e.$LJ="output",e.$MJ="Log",e.$NJ="text/x-code-log-output",e.$OJ="log",e.$PJ="workbench.panel.output",e.$QJ=new C.$cj("inOutput",!1),e.$RJ=new C.$cj("activeLogOutput",!1),e.$SJ=new C.$cj("outputView.scrollLock",!1),e.$TJ=(0,M.$Xh)("outputService");var P;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(P||(e.OutputChannelUpdateMode=P={})),e.$UJ={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new E.$Rd,this.onDidRegisterChannel=this.b.event,this.c=new E.$Rd,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(A=>y.push(A)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}T.$on.add(e.$UJ.OutputChannels,new $),e.$VJ=new C.$cj("activeOutputChannel","")}),define(Ae[111],Re([1,0,3,4,17,22,15,277,63,27,42,135,24,16,41,5,6]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=e.$Jfc=void 0;class t extends P.$lj{get disposed(){return this.n}constructor(d,i,r,u,f){super(),this.id=d,this.name=i,this.r=r,this.s=u,this.extension=f,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(v=>this.setLevel(v)))}get logLevel(){return this.getLevel()}appendLine(d){this.append(d+`
`)}append(d){this.info(d)}clear(){const d=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,d)}replace(d){const i=this.m;this.info(d),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(d,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof d=="boolean"?d:i))}hide(){this.s.$close(this.id)}g(d,i){this.m+=l.$fe.fromString(i).byteLength,(0,P.log)(this.r,d,i),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends t{appendLine(d){this.append(d)}}let o=class{constructor(d,i,r,u,f,v){this.i=i,this.j=r,this.k=u,this.l=f,this.m=v,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=d.getProxy(E.$zK.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,S.$mm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.h=d;for(const[i,r]of this.g)r.visible=i===this.h}createOutputChannel(d,i,r){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");const u=typeof i=="object"&&i.log,f=(0,p.$Cf)(i)?i:void 0;if((0,p.$Cf)(f)&&!f.trim())throw new Error("illegal argument `languageId`. must not be empty");let v;const g=this.i.environment.extensionLogLevel?.find(([I])=>M.$bm.equals(r.identifier,I))?.[1];g&&(v=(0,P.$vj)(g));const D=u?this.o(d,v,r):this.n(d,f,r);return D.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),u?this.r(d,v??this.m.getLevel(),D):this.q(d,D)}async n(d,i,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,f=this.k.extUri.joinPath(u,`${this.f++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.l.createLogger(f,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),g=await this.a.$register(d,f,i,r.identifier.value);return new t(g,d,v,this.a,r)}async o(d,i,r){const u=await this.p(r),f=d.replace(/[\\/:\*\?"<>\|]/g,""),v=this.k.extUri.joinPath(u,`${f}.log`),g=`${r.identifier.value}.${f}`,D=this.l.createLogger(v,{id:g,name:d,logLevel:i,extensionId:r.identifier.value});return new n(g,d,D,this.a,r)}p(d){let i=this.d.get(d.identifier.value);if(!i){const r=this.k.extUri.joinPath(this.i.logsLocation,d.identifier.value);this.d.set(d.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(r)}catch(u){if((0,w.$wk)(u)!==w.FileSystemProviderErrorCode.FileExists)throw u}return r})())}return i}q(d,i){let r=!1;const u=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return d},append(f){u(),i.then(v=>v.append(f))},appendLine(f){u(),i.then(v=>v.appendLine(f))},clear(){u(),i.then(f=>f.clear())},replace(f){u(),i.then(v=>v.replace(f))},show(f,v){u(),i.then(g=>g.show(f,v))},hide(){u(),i.then(f=>f.hide())},dispose(){r=!0,i.then(f=>f.dispose())}}}r(d,i,r){const u=new s.$Qc,f=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},v=u.add(new a.$Rd);function g(D){i=D,v.fire(D)}return r.then(D=>{u.add(D),D.logLevel!==i&&g(D.logLevel),u.add(D.onDidChangeLogLevel(I=>g(I)))}),{...this.q(d,r),get logLevel(){return i},onDidChangeLogLevel:v.event,trace(D,...I){f(),r.then(h=>h.trace(D,...I))},debug(D,...I){f(),r.then(h=>h.debug(D,...I))},info(D,...I){f(),r.then(h=>h.info(D,...I))},warn(D,...I){f(),r.then(h=>h.warn(D,...I))},error(D,...I){f(),r.then(h=>h.error(D,...I))},dispose(){u.dispose()}}}};e.$Jfc=o,e.$Jfc=o=Ke([We(0,C.$BM),We(1,y.$RM),We(2,m.$wec),We(3,A.$9dc),We(4,P.$gj),We(5,P.$fj)],o),e.$Kfc=(0,T.$Xh)("IExtHostOutputService")}),define(Ae[112],Re([1,0,4,14]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=void 0,e.$Bm=(0,E.$Xh)("remoteAgentService"),e.$Cm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let M=1/0;for(let $=0;$<this.maxSampleCount;$++){const m=await C.getRoundTripTime();if(m===void 0)return;M=Math.min(M,m/2),await(0,T.$1g)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let P;return this.initial.length<this.maxInitialCount?this.initial.push(M):P=this.initial.reduce(($,m)=>$+m,0)/this.initial.length,this.lastMeasurement={initial:P,current:M,average:this.average.reduce(($,m)=>$+m,0)/this.average.length,high:(()=>typeof P>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>P*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[278],Re([1,0,169,54,30,47,40,6,5,112,21,26]),function(we,e,E,T,C,M,P,$,m,y,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=void 0,e.$qH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$rH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$sH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$tH={ConfigurationMigration:"base.contributions.configuration.migration"};class l{constructor(){this.migrations=[],this.a=new m.$Rd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const p=new l;C.$on.add(e.$tH.ConfigurationMigration,p);let w=class extends $.$Rc{constructor(t,n){super(),this.a=t,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const c of o.added)await this.f(c,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(t){await this.f(void 0,t);for(const n of this.b.getWorkspace().folders)await this.f(n,t)}async f(t,n){await Promise.all([n.map(o=>this.g(o,t?.uri))])}async g(t,n){const o=this.a.inspect(t.key,{resource:n}),c=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[d,i]of c){const r=[];for(const f of o.overrideIdentifiers??[]){const v=await this.h(t,{resource:n,overrideIdentifier:f},d);for(const g of v??[]){let D=r.find(([[I,h]])=>I===g[0]&&(0,S.$gn)(h.value,g[1].value));D||r.push(D=[g,[]]),D[1].push(f)}}const u=await this.h(t,{resource:n},d,o);for(const f of u??[])r.push([f,[]]);r.length&&await Promise.allSettled(r.map(async([[f,v],g])=>this.a.updateValue(f,v.value,{resource:n,overrideIdentifiers:g},i)))}}async h(t,n,o,c){const d=(c??this.a.inspect(t.key,n))[o];if(d===void 0)return;const i=u=>this.a.inspect(u,n)[o],r=await t.migrateFn(d,i);return Array.isArray(r)?r:[[t.key,r]]}};e.$uH=w,e.$uH=w=Ke([We(0,P.$ri),We(1,M.$7h)],w);let a=class extends $.$Rc{constructor(t){super(),(async()=>{if(!A.$i&&(await t.getEnvironment())?.os!==1)return;C.$on.as(T.$tn.Configuration).registerConfiguration({...e.$sH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(3,null)},default:[],markdownDescription:(0,E.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(5,null),scope:2}}})})()}};e.$vH=a,e.$vH=a=Ke([We(0,y.$Bm)],a)}),define(Ae[279],Re([1,0,34,13,20,25,177,278,54,4,30]),function(we,e,E,T,C,M,P,$,m,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbb=e.$Wbb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Vbb=e.$Ubb=void 0,e.$Ubb=(0,y.$Xh)("editorResolverService"),e.$Vbb="workbench.editorAssociations";const S=A.$on.as(m.$tn.Configuration),l={...$.$rH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,P.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(l);var p;(function(t){t.builtin="builtin",t.option="option",t.exclusive="exclusive",t.default="default"})(p||(e.RegisteredEditorPriority=p={}));var w;(function(t){t[t.ABORT=1]="ABORT",t[t.NONE=2]="NONE"})(w||(e.ResolvedStatus=w={}));function a(t){switch(t){case p.exclusive:return 5;case p.default:return 4;case p.builtin:return 3;case p.option:default:return 1}}e.$Wbb=a;function s(t,n){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(n.scheme))return!1;const d=typeof t=="string"&&t.indexOf(C.$fc.sep)>=0?`${n.scheme}:${n.path}`:(0,M.$yg)(n);return E.$Dj(typeof t=="string"?t.toLowerCase():t,d.toLowerCase())}e.$Xbb=s}),define(Ae[280],Re([1,0,46,13,20,21,25,2,4,198,47,216,112]),function(we,e,E,T,C,M,P,$,m,y,A,S,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$cK=e.$bK=void 0,e.$bK=(0,m.$Xh)("pathService");let w=p=class{constructor(s,t,n,o){this.d=s,this.e=t,this.f=n,this.g=o,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??s})()}hasValidBasename(s,t,n){return typeof t=="string"||typeof t>"u"?this.a.then(o=>this.h(s,o,t)):this.h(s,t,n)}h(s,t,n){return s.scheme===T.Schemas.file||s.scheme===T.Schemas.vscodeRemote?(0,E.$Zf)(n??(0,P.$yg)(s),t===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,t){if(s.remoteAuthority)return T.Schemas.vscodeRemote;const n=(0,y.$$J)(t.getWorkspace());if(n)return n;const o=t.getWorkspace().folders[0];if(o)return o.uri.scheme;const c=t.getWorkspace().configuration;return c?c.scheme:T.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===1?C.$ec:C.$fc)}async fileURI(s){let t="";if(await this.a===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const o=s.indexOf("/",2);o===-1?(t=s.substring(2),s="/"):(t=s.substring(2,o),s=s.substring(o)||"/")}return $.URI.from({scheme:T.Schemas.file,authority:t,path:s,query:"",fragment:""})}};e.$cK=w,e.$cK=w=p=Ke([We(1,l.$Bm),We(2,S.$WJ),We(3,A.$7h)],w)}),define(Ae[113],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$RI=e.$QI=void 0;class E{constructor(P,$){this.line=P,this.character=$}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,$){return new E(0,0)}with(P){return new E(0,0)}}e.$QI=E;class T{constructor(P,$,m,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(P,$),this.end=new E(m,y)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new T(0,0,0,0)}with(P){return new T(0,0,0,0)}}e.$RI=T;var C;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ae[43],Re([1,0,18,34,26,46,12,4,20,11,113,14]),function(we,e,E,T,C,M,P,$,m,y,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.SearchErrorCode=e.$7I=e.$6I=e.SearchSortOrder=e.ViewMode=e.$5I=e.$4I=e.$3I=e.$2I=e.SearchCompletionExitCode=e.$1I=e.$ZI=e.$YI=e.QueryType=e.SearchProviderType=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$SI="workbench.view.search",e.$TI="workbench.panel.search",e.$UI="workbench.view.search",e.$VI="search-result",e.$WI="search.exclude";const l="\u27EA ",p=" characters skipped \u27EB",w=(l.length+p.length+5)*2;e.$XI=(0,$.$Xh)("searchService");var a;(function(de){de[de.file=0]="file",de[de.text=1]="text"})(a||(e.SearchProviderType=a={}));var s;(function(de){de[de.File=1]="File",de[de.Text=2]="Text"})(s||(e.QueryType=s={}));function t(de){return!!de.preview}e.$YI=t;function n(de){return!!de.resource}e.$ZI=n;function o(de){return!!de.message}e.$1I=o;var c;(function(de){de[de.Normal=0]="Normal",de[de.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class d{constructor(Ee){this.resource=Ee,this.results=[]}}e.$2I=d;class i{constructor(Ee,_,Ce,se){this.ranges=_,this.webviewIndex=se;const Q=Array.isArray(_)?_:[_];if(Ce&&Ce.matchLines===1&&r(Q)){Ee=(0,P.$vf)(Ee,Ce.matchLines);let U="",ne=0,pe=0;const re=Math.floor(Ce.charsPerLine/5),le=[];for(const ce of Q){const be=Math.max(ce.startColumn-re,0),ee=ce.startColumn+Ce.charsPerLine;if(be>pe+re+w){const fe=l+(be-pe)+p;U+=fe+Ee.slice(be,ee),ne+=be-(pe+fe.length)}else U+=Ee.slice(pe,ee);le.push(new f(0,ce.startColumn-ne,ce.endColumn-ne)),pe=ee}this.preview={text:U,matches:Array.isArray(this.ranges)?le:le[0]}}else{const U=Array.isArray(_)?_[0].startLineNumber:_.startLineNumber;this.preview={text:Ee,matches:(0,E.$1b)(_,ne=>new u(ne.startLineNumber-U,ne.startColumn,ne.endLineNumber-U,ne.endColumn))}}}}e.$3I=i;function r(de){const Ee=de[0].startLineNumber;for(const _ of de)if(_.startLineNumber!==Ee||_.endLineNumber!==Ee)return!1;return!0}class u{constructor(Ee,_,Ce,se){this.startLineNumber=Ee,this.startColumn=_,this.endLineNumber=Ce,this.endColumn=se}}e.$4I=u;class f extends u{constructor(Ee,_,Ce){super(Ee,_,Ee,Ce)}}e.$5I=f;var v;(function(de){de.List="list",de.Tree="tree"})(v||(e.ViewMode=v={}));var g;(function(de){de.Default="default",de.FileNames="fileNames",de.Type="type",de.Modified="modified",de.CountDescending="countDescending",de.CountAscending="countAscending"})(g||(e.SearchSortOrder=g={}));function D(de,Ee=!0){const _=de&&de.files&&de.files.exclude,Ce=Ee&&de&&de.search&&de.search.exclude;if(!_&&!Ce)return;if(!_||!Ce)return _||Ce;let se=Object.create(null);return se=C.$fn(se,C.$cn(_)),se=C.$fn(se,C.$cn(Ce),!0),se}e.$6I=D;function I(de,Ee){return de.excludePattern&&T.$Dj(de.excludePattern,Ee)?!1:de.includePattern||de.usingSearchPaths?de.includePattern&&T.$Dj(de.includePattern,Ee)?!0:de.usingSearchPaths?!!de.folderQueries&&de.folderQueries.some(_=>{const Ce=_.folder.fsPath;if(M.$2f(Ee,Ce)){const se=m.$kc(Ce,Ee);return!_.includePattern||!!T.$Dj(_.includePattern,se)}else return!1}):!1:!0}e.$7I=I;var h;(function(de){de[de.unknownEncoding=1]="unknownEncoding",de[de.regexParseError=2]="regexParseError",de[de.globParseError=3]="globParseError",de[de.invalidLiteral=4]="invalidLiteral",de[de.rgProcessError=5]="rgProcessError",de[de.other=6]="other",de[de.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class b extends Error{constructor(Ee,_){super(Ee),this.code=_}}e.$8I=b;function k(de){const Ee=de.message;if((0,y.$3)(de))return new b(Ee,h.canceled);try{const _=JSON.parse(Ee);return new b(_.message,_.code)}catch{return new b(Ee,h.other)}}e.$9I=k;function F(de){const Ee={message:de.message,code:de.code};return new Error(JSON.stringify(Ee))}e.$0I=F;function W(de){return de.type==="error"?!0:de.type==="success"}e.$$I=W;function J(de){return de.type==="success"}e.$_I=J;function N(de){return!!de.path}e.$aJ=N;function R(de,Ee){const _=de.searchPath?de.searchPath:de.relativePath;return(0,P.$sf)(_,Ee)}e.$bJ=R;class L{constructor(Ee){this.path=Ee,this.results=[]}addMatch(Ee){this.results.push(Ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$cJ=L;function O(de,Ee){const _={...de||{},...Ee||{}};return Object.keys(_).filter(Ce=>{const se=_[Ce];return typeof se=="boolean"&&se})}e.$dJ=O;class X{constructor(Ee,_){this.c=null,this.a={...Ee.excludePattern||{},..._.excludePattern||{}},this.b=T.$Ej(this.a);let Ce=Ee.includePattern;_.includePattern&&(Ce?Ce={...Ce,..._.includePattern}:Ce=_.includePattern),Ce&&(this.c=T.$Ej(Ce))}matchesExcludesSync(Ee,_,Ce){return!!(this.b&&this.b(Ee,_,Ce))}includedInQuerySync(Ee,_,Ce){return!(this.b&&this.b(Ee,_,Ce)||this.c&&!this.c(Ee,_,Ce))}includedInQuery(Ee,_,Ce){const se=this.b(Ee,_,Ce),Q=()=>this.c?!!this.c(Ee,_,Ce):!0;return(0,S.$Mg)(se)?se.then(U=>U?!1:Q()):Q()}hasSiblingExcludeClauses(){return he(this.a)}}e.$eJ=X;function he(de){for(const Ee in de)if(typeof de[Ee]!="boolean")return!0;return!1}function $e(de){if(!de)return;let Ee;return _=>(Ee||(Ee=(de()||Promise.resolve([])).then(Ce=>Ce?ke(Ce):{})),Ee.then(Ce=>!!Ce[_]))}e.$fJ=$e;function De(de){if(!de)return;let Ee;return _=>{if(!Ee){const Ce=de();Ee=Ce?ke(Ce):{}}return!!Ee[_]}}e.$gJ=De;function ke(de){const Ee={};for(const _ of de)Ee[_]=!0;return Ee}}),define(Ae[36],Re([1,0,18,14,19,5,6,50,13,120,25,12,2,168,4,15,187,47,42,27,17,8,7,57,43,3,51]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a,s,t,n,o,c,d,i,r,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=e.$qec=void 0;function g(J,N,R){return new A.$qg(L=>b(L,R)).isEqual(J,N)}function D(J,N,R){return g(J.uri,N.uri,R)?0:(0,S.$Ye)(J.uri.toString(),N.uri.toString())}function I(J,N,R){return J.index!==N.index?J.index<N.index?-1:1:g(J.uri,N.uri,R)?(0,S.$Ye)(J.name,N.name):(0,S.$Ye)(J.uri.toString(),N.uri.toString())}function h(J,N,R,L){const O=J.slice(0).sort((he,$e)=>R(he,$e,L)),X=N.slice(0).sort((he,$e)=>R(he,$e,L));return(0,E.$Db)(O,X,(he,$e)=>R(he,$e,L))}function b(J,N){const R=N.getCapabilities(J.scheme);return!(R&&R&1024)}class k extends t.$ei{static toExtHostWorkspace(N,R,L,O){if(!N)return{workspace:null,added:[],removed:[]};const{id:X,name:he,folders:$e,configuration:De,transient:ke,isUntitled:de}=N,Ee=[],_=R;R?$e.forEach((U,ne)=>{const pe=l.URI.revive(U.uri),re=k.o(L||R,pe,O);re?(re.name=U.name,re.index=U.index,Ee.push(re)):Ee.push({uri:pe,name:U.name,index:ne})}):Ee.push(...$e.map(({uri:U,name:ne,index:pe})=>({uri:l.URI.revive(U),name:ne,index:pe}))),Ee.sort((U,ne)=>U.index<ne.index?-1:1);const Ce=new k(X,he,Ee,!!ke,De?l.URI.revive(De):null,!!de,U=>b(U,O)),{added:se,removed:Q}=h(_?_.workspaceFolders:[],Ce.workspaceFolders,D,O);return{workspace:Ce,added:se,removed:Q}}static o(N,R,L){for(let O=0;O<N.folders.length;O++){const X=N.workspaceFolders[O];if(g(X.uri,R,L))return X}}constructor(N,R,L,O,X,he,$e){super(N,L.map(De=>new t.$fi(De)),O,X,$e),this.t=R,this.u=he,this.q=[],this.s=$.$4h.forUris($e),L.forEach(De=>{this.q.push(De),this.s.set(De.uri,De)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(N,R){return R&&this.s.get(N)&&(N=(0,A.$Ag)(N)),this.s.findSubstr(N)}resolveWorkspaceFolder(N){return this.s.get(N)}}let F=class{constructor(N,R,L,O,X){this.c=new M.$Rd,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Rd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Td,this.B=new Map,this.h=O,this.s=L,this.t=X,this.j=new y.$Yl,this.k=new T.$Yg,this.o=N.getProxy(f.$zK.MainThreadWorkspace),this.q=N.getProxy(f.$zK.MainThreadMessageService);const he=R.workspace;this.l=he?new k(he.id,he.name,[],!!he.transient,he.configuration?l.URI.revive(he.configuration):null,!!he.isUntitled,$e=>b($e,L)):void 0}$initializeWorkspace(N,R){this.v=R,this.$acceptWorkspaceData(N),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:m.Schemas.untitled,path:(0,A.$yg)((0,A.$Ag)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(N,R,L,...O){const X=[];if(Array.isArray(O)&&O.forEach(de=>{l.URI.isUri(de.uri)&&!X.some(Ee=>g(Ee.uri,de.uri,this.s))&&X.push({uri:de.uri,name:de.name||(0,A.$xg)(de.uri)})}),this.n||[R,L].some(de=>typeof de!="number"||de<0)||L===0&&X.length===0)return!1;const he=this.x?this.x.workspaceFolders:[];if(R+L>he.length)return!1;const $e=he.slice(0);$e.splice(R,L,...X.map(de=>({uri:de.uri,name:de.name||(0,A.$xg)(de.uri),index:void 0})));for(let de=0;de<$e.length;de++){const Ee=$e[de];if($e.some((_,Ce)=>Ce!==de&&g(Ee.uri,_.uri,this.s)))return!1}$e.forEach((de,Ee)=>de.index=Ee);const{added:De,removed:ke}=h(he,$e,I,this.s);if(De.length===0&&ke.length===0)return!1;if(this.o){const de=N.displayName||N.name;this.o.$updateWorkspaceFolders(de,R,L,X).then(void 0,Ee=>{this.n=void 0;const _={source:{identifier:N.identifier,label:N.displayName||N.name}};this.q.$showMessage(s.Severity.Error,(0,p.localize)(0,null,de,Ee.toString()),_,[])})}return this.y($e),!0}getWorkspaceFolder(N,R){if(this.x)return this.x.getWorkspaceFolder(N,R)}async getWorkspaceFolder2(N,R){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(N,R)}async resolveWorkspaceFolder(N){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(N)}getPath(){if(!this.x)return;const{folders:N}=this.x;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,R){let L,O="";if(typeof N=="string"?(L=l.URI.file(N),O=N):typeof N<"u"&&(L=N,O=N.fsPath),!L)return O;const X=this.getWorkspaceFolder(L,!0);if(!X)return O;typeof R>"u"&&this.x&&(R=this.x.folders.length>1);let he=(0,A.$Dg)(X.uri,L);return R&&X.name&&(he=`${X.name}/${he}`),he}y(N){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:N,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:R,added:L,removed:O}=k.toExtHostWorkspace(N,this.l,this.n,this.s);this.l=R||void 0,this.n=void 0,this.c.fire(Object.freeze({added:L,removed:O}))}findFiles(N,R,L,O,X=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let he;if(R===null?he=!1:R&&(typeof R=="string"?he=R:he=R.pattern),X&&X.isCancellationRequested)return Promise.resolve([]);const{includePattern:$e,folder:De}=W(d.GlobPattern.from(N));return this.o.$startFileSearch($e??null,De??null,he??null,L??null,X).then(ke=>Array.isArray(ke)?ke.map(de=>l.URI.revive(de)):[])}async findTextInFiles(N,R,L,O,X=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const he=this.j.getNext(),$e=typeof R.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:R.previewOptions,{includePattern:De,folder:ke}=W(d.GlobPattern.from(R.include)),de=typeof R.exclude=="string"?R.exclude:R.exclude?R.exclude.pattern:void 0,Ee={ignoreSymlinks:typeof R.followSymlinks=="boolean"?!R.followSymlinks:void 0,disregardIgnoreFiles:typeof R.useIgnoreFiles=="boolean"?!R.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof R.useGlobalIgnoreFiles=="boolean"?!R.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof R.useParentIgnoreFiles=="boolean"?!R.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof R.useDefaultExcludes=="boolean"?!R.useDefaultExcludes:!0,fileEncoding:R.encoding,maxResults:R.maxResults,previewOptions:$e,afterContext:R.afterContext,beforeContext:R.beforeContext,includePattern:De,excludePattern:de},_=!1;if(this.u[he]=Ce=>{if(_)return;const se=l.URI.revive(Ce.resource);Ce.results.forEach(Q=>{const U=(0,v.$uh)(Q);(0,u.$YI)(U)?L({uri:se,preview:{text:U.preview.text,matches:(0,E.$1b)(U.preview.matches,ne=>new i.$DK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,E.$1b)(U.ranges,ne=>new i.$DK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):L({uri:se,text:U.text,lineNumber:U.lineNumber})})},X.isCancellationRequested)return{};try{const Ce=await this.o.$startTextSearch(N,ke??null,Ee,he,X);return delete this.u[he],Ce||{}}catch(Ce){throw delete this.u[he],Ce}}$handleTextSearchResult(N,R){this.u[R]?.(N)}async save(N){const R=await this.o.$save(N,{saveAs:!1});return l.URI.revive(R)}async saveAs(N){const R=await this.o.$save(N,{saveAs:!0});return l.URI.revive(R)}saveAll(N){return this.o.$saveAll(N)}resolveProxy(N){return this.o.$resolveProxy(N)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(N){return this.o.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(N,R){if(this.w.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.w.set(N,R);const L=this.t.transformOutgoingScheme(N),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,L),(0,P.$Pc)(()=>{this.w.delete(N),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(N,R){this.h.info("Getting edit session identifier for workspaceFolder",N);const L=await this.resolveWorkspaceFolder(l.URI.revive(N));if(!L){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const O=this.w.get(L.uri.scheme);if(this.h.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!O),!O)return;const X=await O.provideEditSessionIdentity(L,R);if(this.h.info("Provider returned edit session identifier: ",X),!!X)return X}async $provideEditSessionIdentityMatch(N,R,L,O){this.h.info("Getting edit session identifier for workspaceFolder",N);const X=await this.resolveWorkspaceFolder(l.URI.revive(N));if(!X){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",X);const he=this.w.get(X.uri.scheme);if(this.h.info(`Provider for scheme ${X.uri.scheme} is defined: `,!!he),!he)return;const $e=await he.provideEditSessionIdentityMatch?.(R,L,O);if(this.h.info("Provider returned edit session identifier match result: ",$e),!!$e)return $e}getOnWillCreateEditSessionIdentityEvent(N){return(R,L,O)=>{const X=function($e){R.call(L,$e)};return X.extension=N,this.A.event(X,void 0,O)}}async $onWillCreateEditSessionIdentity(N,R,L){const O=await this.resolveWorkspaceFolder(l.URI.revive(N));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},R,async(X,he)=>{const $e=Date.now();await Promise.resolve(X),Date.now()-$e>L&&this.h.warn("SLOW edit session create-participant",he.extension.identifier)}),R.isCancellationRequested}registerCanonicalUriProvider(N,R){if(this.B.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.B.set(N,R);const L=this.t.transformOutgoingScheme(N),O=this.z++;return this.o.$registerCanonicalUriProvider(O,L),(0,P.$Pc)(()=>{this.B.delete(N),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(N,R,L){const O=this.B.get(N.scheme);if(!O)return;const X=await O.provideCanonicalUri?.(l.URI.revive(N),R,L);if(X)return X}async $provideCanonicalUri(N,R,L){return this.provideCanonicalUri(l.URI.revive(N),{targetScheme:R},L)}};e.$qec=F,e.$qec=F=Ke([We(0,c.$BM),We(1,o.$RM),We(2,n.$9dc),We(3,a.$fj),We(4,r.$oec)],F),e.$rec=(0,w.$Xh)("IExtHostWorkspace");function W(J){let N,R;return J&&(typeof J=="string"?N=J:(N=J.pattern,R=l.URI.revive(J.baseUri))),{includePattern:N,folder:R}}}),define(Ae[37],Re([1,0,26,5,36,3,7,189,54,16,14,4,17,15,2]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=e.$tec=e.$sec=void 0;function a(r,u){if(u){const f=u.split(".");let v=r;for(let g=0;v&&g<f.length;g++)v=v[f[g]];return v}}function s(r){return r instanceof w.URI}function t(r){return r&&r.uri instanceof w.URI&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function o(r){return r&&r.uri instanceof w.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function c(r){if(s(r))return{resource:r};if(t(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(n(r))return{overrideIdentifier:r.languageId};if(o(r))return{resource:r.uri};if(r===null)return{resource:null}}let d=class{constructor(u,f,v){this.a=u.getProxy(M.$zK.MainThreadConfiguration),this.c=f,this.b=v,this.d=new A.$Yg,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new i(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,f){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(u,f))}};e.$sec=d,e.$sec=d=Ke([We(0,l.$BM),We(1,C.$rec),We(2,p.$fj)],d);class i{constructor(u,f,v,g){this.a=new T.$Rd,this.b=u,this.f=g,this.c=f,this.e=$.$Mn.parse(v),this.d=this.k(v.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,f){const v={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Mn.parse(u),this.d=this.k(u.configurationScopes),this.a.fire(this.j(f,v))}getConfiguration(u,f,v){const g=c(f)||{},D=this.g(u?a(this.e.getValue(void 0,g,this.c.workspace),u):this.e.getValue(void 0,g,this.c.workspace));u&&this.h(u,g,v?.identifier);function I(b){if(b==null)return null;if(typeof b=="boolean")return b?2:5;switch(b){case P.ConfigurationTarget.Global:return 2;case P.ConfigurationTarget.Workspace:return 5;case P.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(b){return typeof a(D,b)<"u"},get:(b,k)=>{this.h(u?`${u}.${b}`:b,g,v?.identifier);let F=a(D,b);if(typeof F>"u")F=k;else{let W;const J=(N,R)=>{if((0,y.$Ef)(N)){let L;const O=()=>{W=W||(0,E.$cn)(D),L=L||a(W,R)};return new Proxy(N,{get:(X,he)=>{if(typeof he=="string"&&he.toLowerCase()==="tojson")return O(),()=>L;if(W)return L=L||a(W,R),L[he];const $e=X[he];return typeof he=="string"?J($e,`${R}.${he}`):$e},set:(X,he,$e)=>(O(),L&&(L[he]=$e),!0),deleteProperty:(X,he)=>(O(),L&&delete L[he],!0),defineProperty:(X,he,$e)=>(O(),L&&Object.defineProperty(L,he,$e),!0)})}return Array.isArray(N)?(0,E.$cn)(N):N};F=J(F,b)}return F},update:(b,k,F,W)=>{b=u?`${u}.${b}`:b;const J=I(F);return k!==void 0?this.b.$updateConfigurationOption(J,b,k,g,W):this.b.$removeConfigurationOption(J,b,g,W)},inspect:b=>{b=u?`${u}.${b}`:b;const k=this.e.inspect(b,g,this.c.workspace);if(k)return{key:b,defaultValue:(0,E.$cn)(k.policy?.value??k.default?.value),globalValue:(0,E.$cn)(k.user?.value??k.application?.value),workspaceValue:(0,E.$cn)(k.workspace?.value),workspaceFolderValue:(0,E.$cn)(k.workspaceFolder?.value),defaultLanguageValue:(0,E.$cn)(k.default?.override),globalLanguageValue:(0,E.$cn)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,E.$cn)(k.workspace?.override),workspaceFolderLanguageValue:(0,E.$cn)(k.workspaceFolder?.override),languageIds:(0,E.$cn)(k.overrideIdentifiers)}}};return typeof D=="object"&&(0,E.$fn)(h,D,!1),Object.freeze(h)}g(u){const f=v=>(0,y.$Ef)(v)?new Proxy(v,{get:(g,D)=>f(g[D]),set:(g,D,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(D)}' of object`)},deleteProperty:(g,D)=>{throw new Error(`TypeError: Cannot delete read only property '${String(D)}' of object`)},defineProperty:(g,D)=>{throw new Error(`TypeError: Cannot define property '${String(D)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return f(u)}h(u,f,v){const g=m.$Dn.test(u)?4:this.d.get(u),D=v?`[${v.value}] `:"";if(g===4){typeof f?.resource>"u"&&this.f.warn(`${D}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){f?.resource&&this.f.warn(`${D}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,f){const v=new $.$On(u,f,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(g,D)=>v.affectsConfiguration(g,c(D))})}k(u){return u.reduce((f,v)=>(f.set(v[0],v[1]),f),new Map)}}e.$tec=i,e.$uec=(0,S.$Xh)("IExtHostConfiguration")}),define(Ae[114],Re([1,0,2,14,5,3,7,36,61,37,19,64,17,27,4,13,21,15,81,228,11]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a,s,t,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.$Wfc=e.$Vfc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var d;(function(J){function N(L){if(L!=null)return L}J.from=N;function R(L){if(L!=null)return L}J.to=R})(d||(d={}));var i;(function(J){function N(L){if(L!=null)return L}J.from=N;function R(L){if(L!=null)return L}J.to=R})(i||(i={}));var r;(function(J){function N(L){if(L!=null)return L}J.from=N;function R(L){if(L!=null)return L}J.to=R})(r||(r={}));var u;(function(J){function N(O){if(O){const X=O;return X&&!!X.process}else return!1}J.is=N;function R(O){if(O==null)return;const X={process:O.process,args:O.args};return O.options&&(X.options=r.from(O.options)),X}J.from=R;function L(O){if(O!=null)return new P.$jL(O.process,O.args,O.options)}J.to=L})(u||(u={}));var f;(function(J){function N(L){if(L!=null)return L}J.from=N;function R(L){if(L!=null)return L}J.to=R})(f||(f={}));var v;(function(J){function N(O){if(O){const X=O;return X&&(!!X.commandLine||!!X.command)}else return!1}J.is=N;function R(O){if(O==null)return;const X={};return O.commandLine!==void 0?X.commandLine=O.commandLine:(X.command=O.command,X.args=O.args),O.options&&(X.options=f.from(O.options)),X}J.from=R;function L(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new P.$kL(O.commandLine,O.options):new P.$kL(O.command,O.args?O.args:[],O.options)}J.to=L})(v||(v={}));var g;(function(J){function N(O){if(O){const X=O;return X&&X.customExecution==="customExecution"}else return!1}J.is=N;function R(O){return{customExecution:"customExecution"}}J.from=R;function L(O,X){return X.get(O)}J.to=L})(g||(e.CustomExecutionDTO=g={}));var D;(function(J){function N(R,L){let O;return R.scope!==void 0&&typeof R.scope!="number"?O=R.scope.uri:R.scope!==void 0&&typeof R.scope=="number"&&(R.scope===P.TaskScope.Workspace&&L&&L.workspaceFile?O=L.workspaceFile:O=o.$0F),{id:R._id,workspaceFolder:O}}J.from=N})(D||(e.TaskHandleDTO=D={}));var I;(function(J){function N(R){if(R!=null)return{_id:R.id,isDefault:R.isDefault}}J.from=N})(I||(I={}));var h;(function(J){function N(O,X){if(O==null)return[];const he=[];for(const $e of O){const De=R($e,X);De&&he.push(De)}return he}J.fromMany=N;function R(O,X){if(O==null)return;let he;O.execution instanceof P.$jL?he=u.from(O.execution):O.execution instanceof P.$kL?he=v.from(O.execution):O.execution&&O.execution instanceof P.$lL&&(he=g.from(O.execution));const $e=d.from(O.definition);let De;return O.scope?typeof O.scope=="number"?De=O.scope:De=O.scope.uri:De=P.TaskScope.Workspace,!$e||!De?void 0:{_id:O._id,definition:$e,name:O.name,source:{extensionId:X.identifier.value,label:O.source,scope:De},execution:he,isBackground:O.isBackground,group:I.from(O.group),presentationOptions:i.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}J.from=R;async function L(O,X,he){if(O==null)return;let $e;u.is(O.execution)?$e=u.to(O.execution):v.is(O.execution)?$e=v.to(O.execution):g.is(O.execution)&&($e=g.to(O._id,he));const De=d.to(O.definition);let ke;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?ke=O.source.scope:ke=await X.resolveWorkspaceFolder(E.URI.revive(O.source.scope)):ke=P.TaskScope.Workspace),!De||!ke)return;const de=new P.$mL(De,ke,O.name,O.source.label,$e,O.problemMatchers);return O.isBackground!==void 0&&(de.isBackground=O.isBackground),O.group!==void 0&&(de.group=P.$iL.from(O.group._id),de.group&&O.group.isDefault&&(de.group=new P.$iL(de.group.id,de.group.label),O.group.isDefault===!0&&(de.group.isDefault=O.group.isDefault))),O.presentationOptions&&(de.presentationOptions=i.to(O.presentationOptions)),O._id&&(de._id=O._id),O.detail&&(de.detail=O.detail),de}J.to=L})(h||(e.TaskDTO=h={}));var b;(function(J){function N(L){return L}J.from=N;function R(L){if(L)return Object.assign(Object.create(null),L)}J.to=R})(b||(b={}));class k{#e;constructor(N,R,L){this._id=R,this.a=L,this.#e=N}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}let F=class{constructor(N,R,L,O,X,he,$e,De){this.q=new C.$Rd,this.r=new C.$Rd,this.s=new C.$Rd,this.t=new C.$Rd,this.a=N.getProxy(M.$zK.MainThreadTask),this.b=L,this.c=O,this.d=X,this.e=he,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=$e,this.g=De,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(N,R,L){if(!L)return new P.$BK(()=>{});const O=this.w();return this.j.set(O,{type:R,provider:L,extension:N}),this.a.$registerTaskProvider(O,R),new P.$BK(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(N,R){this.a.$registerTaskSystem(N,R)}fetchTasks(N){return this.a.$fetchTasks(b.from(N)).then(async R=>{const L=[];for(const O of R){const X=await h.to(O,this.b,this.m);X&&L.push(X)}return L})}get taskExecutions(){const N=[];return this.k.forEach(R=>N.push(R)),N}terminateTask(N){if(!(N instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(N._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(N,R,L){const O=this.m.get(N.id);O&&(this.o.set(N.id,O),this.e.attachPtyToTerminal(R,await O.callback(L))),this.p=N.id,this.q.fire({execution:await this.y(N)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(N){const R=await this.y(N);this.l.delete(N.id),this.k.delete(N.id),this.A(N),this.r.fire({execution:R})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(N){const R=await this.y(N.id);this.s.fire({execution:R,processId:N.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(N){const R=await this.y(N.id);this.t.fire({execution:R,exitCode:N.exitCode})}$provideTasks(N,R){const L=this.j.get(N);if(!L)return Promise.reject(new Error("no handler found"));const O=[],X=(0,T.$Sg)(()=>L.provider.provideTasks(A.CancellationToken.None)).then(he=>this.u(R,O,L,he));return new Promise(he=>{X.then($e=>{Promise.all(O).then(()=>{he($e)})})})}async $resolveTask(N,R){const L=this.j.get(N);if(!L)return Promise.reject(new Error("no handler found"));if(R.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${R.definition.type}] cannot be resolved by provider of type [${L.type}].`);const O=await h.to(R,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const X=await L.provider.resolveTask(O,A.CancellationToken.None);if(!X)return;this.z(X,L);const he=h.from(X,L.extension);if(!he)throw new Error("Unexpected: Task cannot be resolved.");if(X.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(he.execution)&&await this.x(he,X,!0),await this.v(he)}w(){return this.h++}async x(N,R,L){const O=await this.a.$createTaskId(N);!L&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,R.execution)),this.m.set(O,R.execution)}async y(N,R){if(typeof N=="string"){const X=this.l.get(N);if(!X)throw new c.$ab("Unexpected: The specified task is missing an execution");return X}const L=this.l.get(N.id);if(L)return L;const O=new Promise((X,he)=>{function $e(De,ke,de){de?X(new k(De,ke.id,de)):he("Unexpected: Task does not exist.")}R?$e(this,N,R):h.to(N.task,this.b,this.m).then(De=>$e(this,N,De))});return this.l.set(N.id,O),O.then(X=>(this.k.set(N.id,X),X),X=>Promise.reject(X))}z(N,R){N._deprecated&&this.g.report("Task.constructor",R.extension,"Use the Task constructor that takes a `scope` instead.")}A(N){this.o.get(N.id)&&this.o.delete(N.id),this.n.has(N.id)&&this.p!==N.id&&(this.m.delete(N.id),this.n.delete(N.id));const L=this.n.values();let O=L.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=L.next()}};e.$Vfc=F,e.$Vfc=F=Ke([We(0,l.$BM),We(1,p.$RM),We(2,$.$rec),We(3,m.$MM),We(4,y.$uec),We(5,S.$Sec),We(6,t.$fj),We(7,n.$_dc)],F);let W=class extends F{constructor(N,R,L,O,X,he,$e,De){super(N,R,L,O,X,he,$e,De),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:s.$h(0)})}async executeTask(N,R){if(!R.execution)throw new Error("Tasks to execute must include an execution");const L=h.from(R,N);if(L===void 0)throw new Error("Task is not valid");if(g.is(L.execution))await this.x(L,R,!1);else throw new c.$$;const O=await this.y(await this.a.$getTaskExecution(L),R);return this.a.$executeTask(L).catch(X=>{throw new Error(X)}),O}u(N,R,L,O){const X=[];if(O)for(const he of O){if(this.z(he,L),!he.definition||!N[he.definition.type]){const De=he.source?he.source:"No task source";this.f.warn(`The task [${De}, ${he.name}] uses an undefined task type. The task will be ignored in the future.`)}const $e=h.from(he,L.extension);$e&&g.is($e.execution)?(X.push($e),R.push(this.x($e,he,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:X,extension:L.extension}}async v(N){if(g.is(N.execution))return N;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(N,R){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,R,L){}};e.$Wfc=W,e.$Wfc=W=Ke([We(0,l.$BM),We(1,p.$RM),We(2,$.$rec),We(3,m.$MM),We(4,y.$uec),We(5,S.$Sec),We(6,t.$fj),We(7,n.$_dc)],W),e.$Xfc=(0,w.$Xh)("IExtHostTask")}),define(Ae[281],Re([1,0,43,29]),function(we,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oJ=e.$nJ=e.$mJ=void 0;function C(P){return"cellResults"in P}e.$mJ=C,e.$nJ="rawCell#";function M(P,$){let m=-1;const y=[];let A=[];return P.forEach(l=>{l.range.startLineNumber!==m&&A.length>0&&(y.push([...A]),A=[]),A.push(l),m=l.range.endLineNumber}),A.length>0&&y.push([...A]),y.map(l=>{const p=[],w=l[0].range.startLineNumber,a=l[l.length-1].range.endLineNumber;for(let s=w;s<=a;s++)p.push($.getLineContent(s));return new E.$3I(p.join(`
`)+`
`,l.map(s=>new T.$Bs(s.range.startLineNumber-1,s.range.startColumn-1,s.range.endLineNumber-1,s.range.endColumn-1)))})}e.$oJ=M}),define(Ae[282],Re([1,0,161,24,5,6,28,12,16,2,41,75,3,32,8,7,49,220,106,11,26,13,211,281,279]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a,s,t,n,o,c,d,i,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=void 0;class f{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(g=>g.apiEditor)}constructor(g,D,I,h,b,k){this.q=I,this.r=h,this.s=b,this.t=k,this.f=new Map,this.g=new P.$zc,this.h=new Map,this.j=new C.$Rd({onListenerError:o.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$Rd({onListenerError:o.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$Rd({onListenerError:o.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$Rd({onListenerError:o.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$5dc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=g.getProxy(l.$zK.MainThreadNotebook),this.c=g.getProxy(l.$zK.MainThreadNotebookDocuments),this.d=g.getProxy(l.$zK.MainThreadNotebookEditors),this.i=D.converter,D.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===13){const W=F.notebookEditor?.notebookUri,J=F.cell.handle,R=this.g.get(W)?.getCell(J);if(R)return R.apiCell}if(F&&F.$mid===14){const W=F.uri,J=this.g.get(W);if(J)return J.apiNotebook}return F}}),f.B(D)}getEditorById(g){const D=this.h.get(g);if(!D)throw new Error(`unknown text editor: ${g}. known editors: ${[...this.h.keys()]} `);return D}getIdByEditor(g){for(const[D,I]of this.h)if(I.apiEditor===g)return D}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(g,D){const I=this.g.get(g);if(!I&&!D)throw new Error(`NO notebook document for '${g}'`);return I}static u(g,D){if(!D)return;const I=D.filenamePattern.map(h=>w.NotebookExclusiveDocumentPattern.from(h)).filter(h=>h!==void 0);if(D.filenamePattern&&!I){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:g.identifier,providerDisplayName:g.displayName||g.name,displayName:D.displayName,filenamePattern:I,exclusive:D.exclusive||!1}}registerNotebookCellStatusBarItemProvider(g,D,I){const h=f.a++,b=typeof I.onDidChangeCellStatusBarItems=="function"?f.a++:void 0;this.f.set(h,I),this.b.$registerNotebookCellStatusBarItemProvider(h,b,D);let k;return b!==void 0&&(k=I.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(b))),new a.$BK(()=>{this.f.delete(h),this.b.$unregisterNotebookCellStatusBarItemProvider(h,b),k?.dispose()})}async createNotebookDocument(g){const D=await this.c.$tryCreateNotebook({viewType:g.viewType,content:g.content&&w.NotebookData.from(g.content)});return y.URI.revive(D)}async openNotebookDocument(g){const D=this.g.get(g);if(D)return D.apiNotebook;const I=await this.c.$tryOpenNotebook(g),h=this.g.get(y.URI.revive(I));return(0,m.$Nf)(h?.apiNotebook)}async showNotebookDocument(g,D){y.URI.isUri(g)&&(g=await this.openNotebookDocument(g));let I;typeof D=="object"?I={position:w.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(w.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:I={preserveFocus:!1};const h=await this.d.$tryShowNotebookDocument(g.uri,g.notebookType,I),b=h&&this.h.get(h)?.apiEditor;if(b)return b;throw h?new Error(`Could NOT open editor for "${g.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${g.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(g,D,I,h){const b=this.f.get(g),k=y.URI.revive(D),F=this.g.get(k);if(!F||!b)return;const W=F.getCellFromIndex(I);if(!W)return;const J=await b.provideCellStatusBarItems(W.apiCell,h);if(!J)return;const N=new M.$Qc,R=this.p.add([N]),O=(Array.isArray(J)?J:[J]).map(X=>w.NotebookStatusBarItem.from(X,this.i,N));return{cacheId:R,items:O}}$releaseNotebookCellStatusBarItems(g){this.p.delete(g)}registerNotebookSerializer(g,D,I,h,b){if((0,$.$Fe)(D))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:D,serializer:I,options:h}),this.b.$registerNotebookSerializer(k,{id:g.identifier,location:g.extensionLocation},D,w.NotebookDocumentContentOptions.from(h),f.u(g,b)),(0,M.$Pc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(g,D,I){const h=this.x.get(g);if(!h)throw new Error("NO serializer found");const b=await h.serializer.deserializeNotebook(D.buffer,I);return new s.$yv(w.NotebookData.from(b))}async $notebookToData(g,D,I){const h=this.x.get(g);if(!h)throw new Error("NO serializer found");const b=await h.serializer.serializeNotebook(w.NotebookData.to(D.value),I);return T.$fe.wrap(b)}async $saveNotebook(g,D,I,h,b){const k=y.URI.revive(D),F=this.x.get(g);if(!F)throw new Error("NO serializer found");const W=this.g.get(k);if(!W)throw new Error("Document NOT found");if(W.versionId!==I)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new A.$Bk((0,E.localize)(0,null,this.z(k)),6);await this.y(k,h);const J={metadata:(0,c.$kn)(W.apiNotebook.metadata,X=>!(F.options?.transientDocumentMetadata??{})[X]),cells:[]};for(const X of W.apiNotebook.getCells()){const he=new a.$ZL(X.kind,X.document.getText(),X.document.languageId,X.mime,F.options?.transientOutputs?[]:[...X.outputs],X.metadata,X.executionSummary);he.metadata=(0,c.$kn)(X.metadata,$e=>!(F.options?.transientCellMetadata??{})[$e]),J.cells.push(he)}const N=await F.serializer.serializeNotebook(J,b);await this.s.value.writeFile(k,N);const R=this.s.getFileSystemProviderExtUri(k.scheme),L=await this.s.value.stat(k);return{name:R.basename(k),isFile:(L.type&A.FileType.File)!==0,isDirectory:(L.type&A.FileType.Directory)!==0,isSymbolicLink:(L.type&A.FileType.SymbolicLink)!==0,mtime:L.mtime,ctime:L.ctime,size:L.size,readonly:!!((L.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((L.permissions??0)&A.FilePermission.Locked),etag:A.$Mk({mtime:L.mtime,size:L.size}),children:void 0}}async $searchInNotebooks(g,D,I,h,b){const k=this.x.get(g)?.serializer;if(!k)return{limitHit:!1,results:[]};const F=new P.$Ac;await(async(L,O,X)=>{await Promise.all(L.map(async he=>await Promise.all(he.filenamePatterns.map($e=>{const De={...X,type:1,filePattern:$e};return this.t.doInternalFileSearchWithCustomCallback(De,O,ke=>{ke.forEach(de=>{F.has(de)||h.some(_=>he.isFromSettings&&!_.isFromSettings?!1:_.filenamePatterns.some(Ce=>(0,u.$Xbb)(Ce,de)))||F.add(de)})})}))))})(I,b,D);const J=new P.$zc;let N=!1;const R=Array.from(F).map(async L=>{const O=[];try{if(b.isCancellationRequested)return;if(D.maxResults&&[...J.values()].reduce((De,ke)=>De+ke.cellResults.length,0)>D.maxResults){N=!0;return}const X=[],he=this.g.get(L);if(he)he.apiNotebook.getCells().forEach(ke=>X.push({input:ke.document.getText(),outputs:ke.outputs.flatMap(de=>de.items.map(Ee=>Ee.data.toString()))}));else{const De=await this.s.value.readFile(L),ke=T.$fe.fromString(De.toString()),de=await k.deserializeNotebook(ke.buffer,b);if(b.isCancellationRequested)return;w.NotebookData.from(de).cells.forEach(_=>X.push({input:_.source,outputs:_.outputs.flatMap(Ce=>Ce.items.map(se=>se.valueBytes.toString()))}))}if(b.isCancellationRequested)return;X.forEach((De,ke)=>{const de=D.contentPattern.pattern,Ee=new i.$_Ob(De.input,void 0,De.outputs),_=Ee.findInInputs(de),Ce=Ee.findInOutputs(de),se=Ce.flatMap(Q=>(0,r.$oJ)(Q.matches,Q.textBuffer)).map((Q,U)=>(Q.webviewIndex=U,Q));if(_.length>0||Ce.length>0){const Q={index:ke,contentResults:(0,r.$oJ)(_,Ee.inputTextBuffer),webviewResults:se};O.push(Q)}});const $e={resource:L,cellResults:O};J.set(L,$e);return}catch{return}});return await Promise.all(R),{limitHit:N,results:[...J.values()]}}async y(g,D){const I=await this.s.value.stat(g);if(typeof D?.mtime=="number"&&typeof D.etag=="string"&&D.etag!==A.$Lk&&typeof I.mtime=="number"&&typeof I.size=="number"&&D.mtime<I.mtime&&D.etag!==A.$Mk({mtime:D.mtime,size:I.size}))throw new A.$Bk((0,E.localize)(1,null),3,D)}z(g){return g.scheme===d.Schemas.file?g.fsPath:g.toString()}A(g,D,I){if(this.h.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const h=new n.$ofc(D,this.d,g,I.visibleRanges.map(w.NotebookRange.to),I.selections.map(w.NotebookRange.to),typeof I.viewColumn=="number"?w.ViewColumn.to(I.viewColumn):void 0);this.h.set(D,h)}$acceptDocumentAndEditorsDelta(g){if(g.value.removedDocuments)for(const I of g.value.removedDocuments){const h=y.URI.revive(I),b=this.g.get(h);b&&(b.dispose(),this.g.delete(h),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(b.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===h.toString()&&this.h.delete(k.id)}if(g.value.addedDocuments){const I=[];for(const h of g.value.addedDocuments){const b=y.URI.revive(h.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const k=new t.$nfc(this.c,this.q,this.r,b,h);I.push(...h.cells.map(F=>t.$mfc.asModelAddData(k.apiNotebook,F))),this.g.get(b)?.dispose(),this.g.set(b,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:I}),this.m.fire(k.apiNotebook)}}if(g.value.addedEditors)for(const I of g.value.addedEditors){if(this.h.has(I.id))return;const h=y.URI.revive(I.documentUri),b=this.g.get(h);b&&this.A(b,I.id,I)}const D=[];if(g.value.removedEditors)for(const I of g.value.removedEditors){const h=this.h.get(I);h&&(this.h.delete(I),this.k?.id===h.id&&(this.k=void 0),D.push(h))}if(g.value.visibleEditors){this.l=g.value.visibleEditors.map(h=>this.h.get(h)).filter(h=>!!h);const I=new Set;this.l.forEach(h=>I.add(h.id));for(const h of this.h.values()){const b=I.has(h.id);h._acceptVisibility(b)}this.l=[...this.h.values()].map(h=>h).filter(h=>h.visible),this.o.fire(this.visibleNotebookEditors)}g.value.newActiveEditor===null?this.k=void 0:g.value.newActiveEditor&&(this.h.get(g.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${g.value.newActiveEditor}`),this.k=this.h.get(g.value.newActiveEditor)),g.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(g){const D=p.$ZM.String.with("notebookType","A notebook type"),I=new p.$2M("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new p.$ZM("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>T.$fe.wrap(b))],new p.$1M("Notebook Data",b=>w.NotebookData.to(b.value))),h=new p.$2M("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new p.$ZM("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new s.$yv(w.NotebookData.from(b)))],new p.$1M("Bytes",b=>b.buffer));g.registerApiCommand(I),g.registerApiCommand(h)}}e.$xfc=f}),define(Ae[283],Re([1,0,20,19,39,34,25,60,43]),function(we,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;class y{constructor(l,p,w){this.k=l,this.l=p,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&M.$Ej(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&M.$Ej(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const p=this.k.folderQueries||[];return new Promise((w,a)=>{const s=t=>{this.f++,l(t)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(t=>{const n=t.toString(),o=E.$mc(n);this.j&&this.j(n,o)||this.v(s,{base:t,basename:o})}),Promise.all(p.map(t=>this.p(t,s))).then(t=>{w({limitHit:this.e,stats:t[0]||void 0})},t=>{a(new Error((0,C.$Ii)(t)))})})}async p(l,p){const w=new T.$2d,a=this.q(l),s=this.r(),t=new m.$eJ(this.k,l),n=!t.hasSiblingExcludeClauses();let o;try{this.h.add(w),o=$.$Nd.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,w.token),d=o.elapsed(),i=$.$Nd.create();return this.g&&!this.e||(c&&c.forEach(r=>{const u=E.$fc.relative(l.folder.path,r.path);if(n){const f=E.$mc(r.path);this.v(p,{base:l.folder,relativePath:u,basename:f});return}this.s(s,l.folder,u,p)}),this.g&&!this.e)?null:(this.u(s,t,p),{providerTime:d,postProcessTime:i.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q(l){const p=(0,m.$dJ)(this.k.includePattern,l.includePattern),w=(0,m.$dJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:w,includes:p,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},p,w,a){if(w===this.a){const t=E.$mc(this.a);this.v(a,{base:p,relativePath:this.a,basename:t})}function s(t){const n=E.$mc(t),o=E.$lc(t);let c=l[o];c||(c=l[o]=[],s(o)),c.push({base:p,relativePath:t,basename:n})}s(w)}u({rootEntries:l,pathToEntries:p},w,a){const s=this,t=this.a;function n(o){const c=(0,m.$gJ)(()=>o.map(d=>d.basename));for(let d=0,i=o.length;d<i;d++){const r=o[d],{relativePath:u,basename:f}=r;if(w.matchesExcludesSync(u,f,t!==f?c:void 0))continue;const v=p[u];if(v)n(v);else{if(u===t)continue;s.v(a,r)}if(s.e)break}}n(l)}v(l,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(p))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,p,w,a){const s=this.c(l.cacheKey),t=new y(l,p,s&&s.token);let n=0;const o=c=>{n+=c.length,w(c.map(d=>this.d(d)))};return this.e(t,A.a,o,a).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new T.$2d),this.b.get(l)}d(l){return l.relativePath?{resource:P.$Bg(l.base,l.relativePath)}:{resource:l.base}}e(l,p,w,a){const s=a.onCancellationRequested(()=>{l.cancel()}),t=o=>{o&&(n.push(o),p>0&&n.length>=p&&(w(n),n=[]))};let n=[];return l.search(t).then(o=>(n.length&&w(n),s.dispose(),o),o=>(n.length&&w(n),s.dispose(),Promise.reject(o)))}}e.$pfc=A}),define(Ae[284],Re([1,0,18,245,34,94,28,13,20,25,12,16,2,93,179,40,15,47,104,280,43]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a,s,t,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eK=e.$dK=void 0;let d=class{constructor(b,k,F,W,J){this.a=b,this.b=k,this.c=F,this.d=W,this.e=J}text(b,k,F={}){b=this.f(b,F);const W=this.a.getValue(),J=k&&k.some(R=>!this.a.getValue({resource:R}).search.useRipgrep);return{...this.h(k?.map(t.$gi),F),type:2,contentPattern:b,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:W.search.usePCRE2||J||!1,beforeContext:F.beforeContext,afterContext:F.afterContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}f(b,k){const F=this.a.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const W={...b,wordSeparators:F.editor.wordSeparators};return this.j(b,k)&&(W.isCaseSensitive=!0),this.k(b)&&(W.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),W}file(b,k={}){return{...this.h(b,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}g(b,k){return b?(b=Array.isArray(b)?b.map(v):v(b),k?this.parseSearchPaths(b):{pattern:r(...Array.isArray(b)?b:[b])}):{}}h(b=[],k={}){const F=this.g(k.includePattern,k.expandPatterns),W=this.g(k.excludePattern,k.expandPatterns),J=b.length>1,N=(F.searchPaths&&F.searchPaths.length?F.searchPaths.map(O=>this.q(O,k,W)):b.map(O=>this.r(O,k,W,J))).filter(O=>!!O),R={_reason:k._reason,folderQueries:N,usingSearchPaths:!!(F.searchPaths&&F.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:W.pattern,includePattern:F.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const O=E.$Gb(E.$Qb(this.c.groups.map($e=>$e.editors.map(De=>De.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const X=O.filter($e=>(0,c.$7I)(R,$e.fsPath)),he=this.i(X);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(he)),{...R,...he}}const L=k.extraFileResources&&k.extraFileResources.filter(O=>(0,c.$7I)(R,O.fsPath));return R.extraFileResources=L&&L.length?L:void 0,R}i(b){const k=[],F=new P.$zc,W={};let J=!1;return b.forEach(N=>{if(N.scheme===$.Schemas.walkThrough)return;if((0,y.$Fg)(N)){const L=this.b.getWorkspaceFolder(N)?.uri??N.with({path:m.$lc(N.fsPath)});let O=F.get(L);O||(J=!0,O={folder:L,includePattern:{}},k.push(O),F.set(L,O));const X=m.$kc(L.fsPath,N.fsPath);(0,S.$Nf)(O.includePattern)[X.replace(/\\/g,"/")]=!0}else N.fsPath&&(J=!0,W[N.fsPath]=!0)}),{folderQueries:k,includePattern:W,usingSearchPaths:!0,excludePattern:J?void 0:{"**/*":!0}}}j(b,k){if(k.isSmartCase){if(b.isRegExp){if(A.$tf(b.pattern,!0))return!0}else if(A.$tf(b.pattern))return!0}return!!b.isCaseSensitive}k(b){return b.isMultiline||b.isRegExp&&(0,p.$EB)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const k=he=>m.$hc(he)||/^\.\.?([\/\\]|$)/.test(he),W=(Array.isArray(b)?b:u(b)).map(he=>{const $e=this.e.resolvedUserHome;return $e?(0,M.$Dv)(he,$e.scheme===$.Schemas.file?$e.fsPath:$e.path):he}),J=T.$J(W,he=>k(he)?"searchPaths":"exprSegments"),N=(J.exprSegments||[]).map(he=>A.$Oe(he,"/")).map(he=>A.$Oe(he,"\\")).map(he=>(he[0]==="."&&(he="*"+he),f(he))),R={},L=this.m(J.searchPaths||[]);L&&L.length&&(R.searchPaths=L);const O=E.$Qb(N),X=r(...O);return X&&(R.pattern=X),R}l(b,k){return k.disregardExcludeSettings?void 0:(0,c.$6I)(b,!k.disregardSearchExcludeSettings)}m(b){if(!b||!b.length)return[];const k=b.flatMap(W=>{let{pathPortion:J,globPortion:N}=i(W);return N&&(N=g(N)),this.n(J).flatMap(L=>this.o(L,N))}),F=new Map;return k.forEach(W=>{const J=W.searchPath.toString(),N=F.get(J);N?W.pattern&&(N.pattern=N.pattern||{},N.pattern[W.pattern]=!0):F.set(J,{searchPath:W.searchPath,pattern:W.pattern?r(W.pattern):void 0})}),Array.from(F.values())}n(b){if(m.$hc(b)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==$.Schemas.file?[{searchPath:k[0].uri.with({path:b})}]:[{searchPath:l.URI.file(m.$gc(b))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(b=v(b),b.startsWith("../")||b===".."){const W=m.$fc.resolve(k.path,b);return[{searchPath:k.with({path:W})}]}const F=g(b);return[{searchPath:k,pattern:F}]}else{if(b==="./"||b===".\\")return[];{const k=b.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(J=>{const N=k.match(new RegExp(`^${A.$Je(J.name)}(?:/(.*)|$)`));return N?{match:N,folder:J}:null}).filter(S.$Kf);if(W.length)return W.map(J=>{const N=J.match[1];return{searchPath:J.folder.uri,pattern:N&&g(N)}});{const J=b.match(/\.[\/\\](.+)[\/\\]?/),N=J?J[1]:b,R=w.localize(0,null,N);throw new Error(R)}}}}o(b,k){const F=b.pattern&&k?`${b.pattern}/${k}`:b.pattern||k,W=[{searchPath:b.searchPath,pattern:F}];return F&&!F.endsWith("**")&&W.push({searchPath:b.searchPath,pattern:F+"/**"}),W}q(b,k,F){const W=this.r((0,t.$gi)(b.searchPath),k,F,!1);return W?{...W,includePattern:b.pattern}:null}r(b,k,F,W){let J;const N=l.URI.isUri(b)?b:b.uri;if(F.searchPaths){const he=F.searchPaths.filter($e=>(0,y.$ug)($e.searchPath,N))[0];if(he&&!he.pattern)return null;he&&(J=he.pattern)}const R=this.a.getValue({resource:N}),O={...this.l(R,k)||{},...J||{}},X=l.URI.isUri(b)?(0,y.$yg)(b):b.name;return{folder:N,folderName:W?X:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:R.files&&R.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!R.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!R.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!R.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!R.search.followSymlinks}}};e.$dK=d,e.$dK=d=Ke([We(0,a.$ri),We(1,t.$7h),We(2,n.$IC),We(3,s.$fj),We(4,o.$bK)],d);function i(h){const b=h.match(/[\*\{\}\(\)\[\]\?]/);if(b){const k=b.index,F=h.substr(0,k).match(/[/|\\][^/\\]*$/);if(F){let W=h.substr(0,F.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:h.substr((F.index||0)+1)}}}return{pathPortion:h}}function r(...h){return h.length?h.reduce((b,k)=>(b[k]=!0,b),Object.create(null)):void 0}function u(h){return C.$Cj(h,",").map(b=>b.trim()).filter(b=>!!b.length)}function f(h){return[`**/${h}/**`,`**/${h}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function v(h){return h.replace(/\\/g,"/")}function g(h){return v(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(h){return h.replace(/([?*[\]])/g,"[$1]")}function I(h,b){h=E.$Lb(h,W=>W.toString());const k=[],F=b.getWorkspace();return h&&h.forEach(W=>{let J;if(b.getWorkbenchState()===2)J=(0,y.$Dg)(F.folders[0].uri,W),J&&J!=="."&&(J="./"+J);else{const N=b.getWorkspaceFolder(W);if(N){const R=N.name;if(F.folders.filter(O=>O.name===R).length===1){const O=(0,y.$Dg)(N.uri,W);O===""?J=`./${N.name}`:J=`./${N.name}/${O}`}else J=W.fsPath}}J&&k.push(D(J))}),k}e.$eK=I}),define(Ae[285],Re([1,0,25,2,19,11,4,284,43,47]),function(we,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frb=e.$erb=void 0;const A=7e3;function S(a,s){const t=s.activationEvents;if(!t)return Promise.resolve(void 0);const n=[],o=[];for(const f of t)if(/^workspaceContains:/.test(f)){const v=f.substr(18);v.indexOf("*")>=0||v.indexOf("?")>=0||a.forceUsingSearch?o.push(v):n.push(v)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);let c;const d=new Promise((f,v)=>{c=f}),i=f=>c({activationEvent:f}),r=Promise.all(n.map(f=>l(a,f,i))).then(()=>{}),u=p(a,s.identifier,o,i);return Promise.all([r,u]).then(()=>{c(void 0)}),d}e.$erb=S;async function l(a,s,t){for(const n of a.folders)if(await a.exists(E.$Bg(T.URI.revive(n),s))){t(`workspaceContains:${s}`);return}}async function p(a,s,t,n){if(t.length===0)return Promise.resolve(void 0);const o=new C.$2d,c=a.checkExists(a.folders,t,o.token),d=setTimeout(async()=>{o.cancel(),a.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${t.join(",")}`)},A);let i=!1;try{i=await c}catch(r){M.$3(r)||M.$Z(r)}o.dispose(),clearTimeout(d),i&&n(`workspaceContains:${t.join(",")}`)}function w(a,s,t,n){const o=a.get(P.$Wh),c=a.get(m.$XI),i=o.createInstance($.$dK).file(s.map(r=>(0,y.$gi)(T.URI.revive(r))),{_reason:"checkExists",includePattern:t,exists:!0});return c.fileSearch(i,n).then(r=>!!r.limitHit,r=>M.$3(r)?!1:Promise.reject(r))}e.$frb=w}),define(Ae[38],Re([1,0,158,20,88,25,14,6,50,2,15,3,37,217,85,36,23,105,11,22,24,200,7,99,4,27,86,17,71,87,64,5,285,84,202,13,82,60,21,83]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a,s,t,n,o,c,d,i,r,u,f,v,g,D,I,h,b,k,F,W,J,N,R,L,O){"use strict";var X;Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=e.$7ec=e.$6ec=e.$5ec=e.$4ec=void 0,e.$4ec=(0,u.$Xh)("IHostUtils");let he=X=class extends $.$Rc{constructor(Q,U,ne,pe,re,le,ce,be,ee,fe,ie,ae){super(),this.X=ae,this.a=this.B(new b.$Rd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=ne,this.f=ce,this.j=pe,this.m=re,this.s=le,this.t=ee,this.u=fe,this.w=ie,this.y=this.g.getProxy(S.$zK.MainThreadWorkspace),this.z=this.g.getProxy(S.$zK.MainThreadTelemetry),this.C=this.g.getProxy(S.$zK.MainThreadExtensionService),this.D=new P.$Yg,this.F=new P.$Yg,this.G=new P.$Yg,this.H=new P.$Yg,this.I=new Ce(this.f.extensions.activationEvents),this.L=new t.$g6b(this.I,this.f.extensions.allExtensions);const me=new o.$cm(this.f.extensions.myExtensions);this.J=new t.$g6b(this.I,Ee(this.L,me)),L.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ke(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ke(this.J)}`)),this.M=new w.$Oec(this.g,this.s),this.N=new F.$Wec(this.g),this.O=be,this.h=Q.createChild(new D.$Vh([w.$Pec,this.M],[F.$Xec,this.N])),this.P=this.B(new p.$Nec(this.J,this.L,{onExtensionActivationError:(Pe,z,V)=>{this.C.$onExtensionActivationError(Pe,n.$2(z),V)},actualActivateExtension:async(Pe,z)=>{if(t.$g6b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,z),new p.$Mec;const V=this.J.getExtensionDescription(Pe);return this.db(V,z)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(Q){n.$Z(Q)}}async Y(){this.O.onWillDeactivateAll();let Q=[];try{Q=this.J.getAllExtensionDescriptions().map(re=>re.identifier).filter(re=>this.isActivated(re)).map(re=>this.cb(re))}catch{}await Promise.all(Q)}terminate(Q,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${Q}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(pe=>{this.s.error(pe)}),this.g.dispose();const ne=this.Y();Promise.race([(0,P.$1g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(Q){return this.G.isOpen()?this.P.isActivated(Q):!1}async getExtension(Q){const U=await this.C.$getExtension(Q);return U&&{...U,identifier:new o.$bm(U.identifier.value),extensionLocation:y.URI.revive(U.extensionLocation)}}Z(Q,U){return this.P.activateByEvent(Q,U)}$(Q,U){return this.P.activateById(Q,U)}activateByIdWithErrors(Q,U){return this.$(Q,U).then(()=>{const ne=this.P.getActivatedExtension(Q);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Q=>this.J)}getExtensionExports(Q){if(this.G.isOpen())return this.P.getActivatedExtension(Q).exports;try{return this.P.getActivatedExtension(Q).exports}catch{return null}}async ab(Q){if(Q.scheme===J.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(Q.fsPath);return y.URI.file(U)}return Q}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(Q=>new _(Q))),this.Q}async bb(Q){const U=m.$4h.forUris(ne=>M.$sg.ignorePathCasing(ne));return await Promise.all(Q.map(async ne=>{if(this.ub(ne)){const pe=await this.ab(ne.extensionLocation);U.set(pe,ne)}})),U}cb(Q){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Q))return U;const ne=this.P.getActivatedExtension(Q);if(!ne)return U;try{typeof ne.module.deactivate=="function"&&(U=Promise.resolve(ne.module.deactivate()).then(void 0,pe=>(this.s.error(pe),Promise.resolve(void 0))))}catch(pe){this.s.error(`An error occurred when deactivating the extension '${Q.value}':`),this.s.error(pe)}try{(0,$.$Mc)(ne.subscriptions)}catch(pe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Q.value}':`),this.s.error(pe)}return U}async db(Q,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Q.identifier):await this.C.$onWillActivateExtension(Q.identifier),this.fb(Q,U).then(ne=>{const pe=ne.activationTimes;return this.C.$onDidActivateExtension(Q.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,U),this.eb(Q,U,"success",pe),ne},ne=>{throw this.eb(Q,U,"failure"),ne})}eb(Q,U,ne,pe){const re=De(Q,U);this.z.$publicLog2("extensionActivationTimes",{...re,...pe||{},outcome:ne})}fb(Q,U){const ne=De(Q,U);this.z.$publicLog2("activatePlugin",ne);const pe=this.ub(Q);if(!pe)return Promise.resolve(new p.$Lec(p.$Iec.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${Q.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const re=new p.$Jec(U.startup);return Promise.all([this.vb(Q,(0,M.$Bg)(Q.extensionLocation,pe),re),this.gb(Q)]).then(le=>(C.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),X.hb(this.s,Q.identifier,le[0],le[1],re))).then(le=>(C.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),le))}gb(Q){const U=new d.$Rec(Q,this.M),ne=new d.$Qec(Q.identifier.value,!1,this.M),pe=new W.$Yec(Q,this.N),re=Q.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,le=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([U.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const ce=this;let be,ee;const fe=(0,s.$NF)(Q,"ipc")?this.f.messagePorts?.get(o.$bm.toKey(Q.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:ne,secrets:pe,subscriptions:[],get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(ie){return T.$ic(Q.extensionLocation.fsPath,ie)},get storagePath(){return ce.O.workspaceValue(Q)?.fsPath},get globalStoragePath(){return ce.O.globalValue(Q).fsPath},get logPath(){return T.$ic(ce.f.logsLocation.fsPath,Q.identifier.value)},get logUri(){return y.URI.joinPath(ce.f.logsLocation,Q.identifier.value)},get storageUri(){return ce.O.workspaceValue(Q)},get globalStorageUri(){return ce.O.globalValue(Q)},get extensionMode(){return re},get extension(){return be===void 0&&(be=new de(ce,Q.identifier,Q,le,!1)),be},get extensionRuntime(){return(0,s.$OF)(Q,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce.u.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!ee){if(!fe)return;const ie=b.Event.buffer(b.Event.fromDOMEventEmitter(fe,"message",ae=>ae.data));fe.start(),ee={onDidReceiveMessage:ie,postMessage:fe.postMessage.bind(fe)}}return ee}})})}static hb(Q,U,ne,pe,re){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(Q,U,ne,pe,re).then(le=>new p.$Kec(!1,null,re.build(),ne,le,pe.subscriptions))}static ib(Q,U,ne,pe,re){if(typeof ne.activate=="function")try{re.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${U.value}`);const le=typeof global=="object"?global:self,ce=ne.activate.apply(le,[pe]);return re.activateCallStop(),re.activateResolveStart(),Promise.resolve(ce).then(be=>(re.activateResolveStop(),be))}catch(le){return Promise.reject(le)}else return Promise.resolve(ne)}jb(Q,U){this.$(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:U}).then(void 0,ne=>{this.s.error(ne)})}kb(Q,U=0){const pe=Date.now();(0,L.$B)(()=>{for(let re=U;re<Q.length;re+=1){const le=Q[re];for(const ce of le.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-pe>50){this.kb(Q,re);break}else this.jb(le,ce)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(Q=>{const U=Q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(U)this.kb(ne);else for(const pe of ne)if(pe.activationEvents)for(const re of pe.activationEvents)re==="onStartupFinished"&&this.jb(pe,re)})}mb(){const Q=this.Z("*",!0).then(void 0,le=>{this.s.error(le)});this.B(this.j.onDidChangeWorkspace(le=>this.nb(le.added)));const U=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(U),pe=this.pb(),re=Promise.all([pe,Q,ne]).then(()=>{});return Promise.race([re,(0,P.$1g)(1e4)]).then(()=>{this.lb()}),re}nb(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(Q,U))).then(()=>{})}async ob(Q,U){if(this.isActivated(U.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,pe={logService:this.s,folders:Q.map(le=>le.uri),forceUsingSearch:ne||!this.c.fsExists,exists:le=>this.c.fsExists(le.fsPath),checkExists:(le,ce,be)=>this.y.$checkExists(le,ce,be)},re=await(0,k.$erb)(pe,U);if(re)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:re.activationEvent}).then(void 0,le=>this.s.error(le))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(Q){throw console.error(Q),Q}}async qb(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:U}=this.f.environment;if(!Q||!U)throw new Error(E.localize(0,null));const ne=await this.vb(null,U,new p.$Jec(!1));if(!ne||typeof ne.run!="function")throw new Error(E.localize(1,null,U.toString()));return new Promise((pe,re)=>{const le=(ee,fe)=>{ee?(L.$t&&this.s.error("Test runner called back with error",ee),re(ee)):(L.$t&&(fe?this.s.info(`Test runner called back with ${fe} failures.`):this.s.info("Test runner called back with successful outcome.")),pe(typeof fe=="number"&&fe>0?1:0))},ce=(0,M.$pg)(U),be=ne.run(ce,le);be&&be.then&&be.then(()=>{L.$t&&this.s.info("Test runner finished successfully."),pe(0)}).catch(ee=>{L.$t&&this.s.error("Test runner finished with error",ee),re(ee instanceof Error&&ee.stack?ee.stack:String(ee))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,P.$1g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,U){return this.R[Q]=U,(0,$.$Pc)(()=>{delete this.R[Q]})}async getRemoteExecServer(Q){const{resolver:U}=await this.sb(Q);return U?.resolveExecServer?.(Q,{resolveAttempt:0})}async sb(Q){const U=Q.indexOf("+");if(U===-1)throw new i.$HK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=Q.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(Q,U){const ne=R.$Nd.create(!1),pe=()=>`[resolveAuthority(${(0,r.$2k)(Q)},${U})][${ne.elapsed()}ms] `,re=G=>this.s.info(`${pe()}${G}`),le=G=>this.s.warn(`${pe()}${G}`),ce=(G,q=void 0)=>this.s.error(`${pe()}${G}`,q),be=G=>{if(G instanceof i.$HK)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G},ee=async G=>{re(`activating resolver for ${G}...`);const{resolver:q,authorityPrefix:x}=await this.sb(G);if(!q)throw ce(`no resolver for ${x}`),new i.$HK(`No remote extension installed to resolve ${x}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:x,remoteAuthority:G}},fe=Q.split(/@|%40/g).reverse();re(`activating remote resolvers ${fe.join(" -> ")}`);let ie;try{ie=await Promise.all(fe.map(ee)).catch(async G=>{if(!(G instanceof i.$HK)||G._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw G;return le(`resolving nested authorities failed: ${G.message}`),[await ee(Q)]})}catch(G){return be(G)}const ae=new P.$$g;ae.cancelAndSet(()=>re("waiting..."),1e3);let me,Pe;for(const[G,{authorityPrefix:q,resolver:x,remoteAuthority:ue}]of ie.entries())try{if(G===ie.length-1)re("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${q}`),me=await x.resolve(ue,{resolveAttempt:U,execServer:Pe}),C.mark(`code/extHost/didResolveAuthorityOK/${q}`),re("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,i.$GK.isManagedResolvedAuthority(me)?me:void 0));else{if(re(`invoking resolveExecServer() for ${ue}`),C.mark(`code/extHost/willResolveExecServer/${q}`),Pe=await x.resolveExecServer?.(ue,{resolveAttempt:U,execServer:Pe}),!Pe)throw new i.$HK(`Exec server was not available for ${ue}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Ne){return C.mark(`code/extHost/didResolveAuthorityError/${q}`),ce("returned an error",Ne),ae.dispose(),be(Ne)}ae.dispose();const z={environmentTunnels:me.environmentTunnels,features:me.tunnelFeatures},V={extensionHostEnv:me.extensionHostEnv,isTrusted:me.isTrusted,authenticationSession:me.authenticationSessionForInitializingExtensions?{id:me.authenticationSessionForInitializingExtensions.id,providerId:me.authenticationSessionForInitializingExtensions.providerId}:void 0};re(`returned ${i.$GK.isManagedResolvedAuthority(me)?"managed authority":`${me.host}:${me.port}`}`);let H;if(i.$GK.isManagedResolvedAuthority(me)){const G=U;this.X.setFactory(G,me.makeConnection),H={authority:Q,connectTo:new r.$Yk(G),connectionToken:me.connectionToken}}else H={authority:Q,connectTo:new r.$Zk(me.host,me.port),connectionToken:me.connectionToken};return{type:"ok",value:{authority:H,options:V,tunnelInformation:z}}}async $getCanonicalURI(Q,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$2k)(Q)})`);const{resolver:ne}=await this.sb(Q);if(!ne)return null;const pe=y.URI.revive(U);if(typeof ne.getCanonicalURI>"u")return pe;const re=await(0,P.$Sg)(()=>ne.getCanonicalURI(pe));return re||pe}$startExtensionHost(Q){Q.toAdd.forEach(pe=>pe.extensionLocation=y.URI.revive(pe.extensionLocation));const{globalRegistry:U,myExtensions:ne}=$e(this.I,this.L,this.J,Q);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(ne),L.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ke(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ke(this.J)}`)),this.rb()}$activateByEvent(Q,U){return U===1?this.D.wait().then(ne=>this.Z(Q,!1)):this.G.wait().then(ne=>this.Z(Q,!1))}async $activate(Q,U){return await this.G.wait(),this.J.getExtensionDescription(Q)?(await this.$(Q,U),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(le=>le.extensionLocation=y.URI.revive(le.extensionLocation));const{globalRegistry:U,myExtensions:ne}=$e(this.I,this.L,this.J,Q),pe=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(pe),this.L.set(U.getAllExtensionDescriptions()),this.J.set(ne),L.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ke(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ke(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){const U=c.$fe.alloc(Q),ne=Math.random()%256;for(let pe=0;pe<Q;pe++)U.writeUInt8(ne,pe);return U}async $updateRemoteConnectionData(Q){this.W=Q,this.a.fire()}};e.$5ec=he,e.$5ec=he=X=Ke([We(0,u.$Wh),We(1,e.$4ec),We(2,g.$BM),We(3,a.$rec),We(4,l.$uec),We(5,A.$fj),We(6,f.$RM),We(7,v.$xec),We(8,I.$bxb),We(9,h.$Sec),We(10,N.$1ec),We(11,O.$2ec)],he);function $e(se,Q,U,ne){se.addActivationEvents(ne.addActivationEvents);const pe=new t.$g6b(se,Q.getAllExtensionDescriptions());pe.deltaExtensions(ne.toAdd,ne.toRemove);const re=new o.$cm(U.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ne.myToRemove)re.delete(ce);for(const ce of ne.myToAdd)re.add(ce);const le=Ee(pe,re);return{globalRegistry:pe,myExtensions:le}}function De(se,Q){return{id:se.identifier.value,name:se.name,extensionVersion:se.version,publisherDisplayName:se.publisher,activationEvents:se.activationEvents?se.activationEvents.join(","):null,isBuiltin:se.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}function ke(se){return se.getAllExtensionDescriptions().map(Q=>Q.identifier.value).join(",")}e.$6ec=(0,u.$Xh)("IExtHostExtensionService");class de{#e;#t;#i;constructor(Q,U,ne,pe,re){this.#e=Q,this.#t=U,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=T.$gc((0,M.$pg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=pe,this.isFromDifferentExtensionHost=re}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$7ec=de;function Ee(se,Q){return se.getAllExtensionDescriptions().filter(U=>Q.has(U.identifier))}class _{constructor(Q){this.a=Q}setSearchTree(Q){this.a=Q}findSubstr(Q){return this.a.findSubstr(Q)}forEach(Q){return this.a.forEach(Q)}}e.$8ec=_;class Ce{constructor(Q){this.a=new o.$dm,this.addActivationEvents(Q)}readActivationEvents(Q){return this.a.get(Q.identifier)??[]}addActivationEvents(Q){for(const U of Object.keys(Q))this.a.set(U,Q[U])}}}),define(Ae[286],Re([1,0,88,2,3,37,23,22,17,27,4,38,15,12]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;let a=class{constructor(c,d,i,r,u,f,v){this.c=c,this.d=d,this.e=i,this.f=r,this.g=u,this.h=f,this.i=v,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const d=await this.g.getExtensionPathIndex();this.register(new t(this.c,d,this.d,c,this.i)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,d,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const d of c.nodeModuleName)this.a.set(d,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(d=>c.alternativeModuleName(d))}};e.$dgc=a,e.$dgc=a=Ke([We(2,A.$Wh),We(3,M.$uec),We(4,S.$6ec),We(5,y.$RM),We(6,l.$fj)],a);let s=class{static{w=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&w.a.size){const d=(0,p.$Je)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",r=`@${i}+\\/${i}+|${i}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${d}/${u}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const d=this.b.exec(this.c(c));if(!d)return;const[,i,r,u]=d,f=w.a.get(r);if(f!==void 0)return console.warn(`${r} as been renamed to ${f}, please update your imports`),i+f+u}c(c){return c.replace(/\\/g,"/")}};s=w=Ke([We(0,y.$RM)],s);class t{constructor(c,d,i,r,u){this.c=c,this.d=d,this.e=i,this.f=r,this.g=u,this.nodeModuleName="vscode",this.a=new $.$dm}load(c,d){const i=this.d.findSubstr(d);if(i){let r=this.a.get(i.identifier);return r||(r=this.c(i,this.e,this.f),this.a.set(i.identifier,r)),r}if(!this.b){let r="";this.d.forEach((u,f)=>r+=`	${f} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${d}. These are the extension path mappings: 
${r}`),this.b=this.c(P.$IF,this.e,this.f)}return this.b}}let n=class{constructor(c,d,i){this.e=c,this.f=d,this.nodeModuleName=["open","opn"],this.d=i.getProxy(C.$zK.MainThreadTelemetry);const r=i.getProxy(C.$zK.MainThreadWindow);this.c=(u,f)=>{const v=T.URI.parse(u);return f?this.g(u,f):v.scheme==="http"||v.scheme==="https"?r.$openUri(v,u,{allowTunneling:!0}):v.scheme==="mailto"||v.scheme===this.f?r.$openUri(v,u,{}):this.g(u,f)}}load(c,d,i){const r=this.e.findSubstr(d);return r&&(this.a=r.identifier.value,this.h()),this.b=i(c),this.c}g(c,d){return this.i(),this.b(c,d)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Ke([We(2,m.$BM)],n)}),define(Ae[115],Re([1,0,44,6,20,74,4,61,62,38,7,36,214,37]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=e.$9ec=void 0,e.$9ec=(0,P.$Xh)("IExtHostVariableResolverProvider");class w extends l.$CN{constructor(t,n,o,c,d,i,r){function u(){if(o){const f=o.activeEditor();if(f)return f.document.uri;const v=c.tabGroups.all.find(g=>g.isActive)?.activeTab;if(v!==void 0){if(v.input instanceof A.$hM||v.input instanceof A.$mM)return v.input.modified;if(v.input instanceof A.$gM||v.input instanceof A.$lM||v.input instanceof A.$jM)return v.input.uri}}}super({getFolderUri:f=>{const v=i.folders.filter(g=>g.name===f);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(f,v)=>d.getConfiguration(void 0,f).get(v),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const f=u();if(f)return C.$gc(f.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const f=u();if(f){const v=n.getWorkspaceFolder(f);if(v)return C.$gc(v.uri.fsPath)}}},getSelectedText:()=>{if(o){const f=o.activeEditor();if(f&&!f.selection.isEmpty)return f.document.getText(f.selection)}},getLineNumber:()=>{if(o){const f=o.activeEditor();if(f)return String(f.selection.end.line+1)}},getExtension:f=>t.getExtension(f)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(M.env))}}let a=class extends T.$Rc{constructor(t,n,o,c,d){super(),this.b=t,this.c=n,this.g=o,this.h=c,this.j=d,this.a=new E.$U(async()=>{const i=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async f=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.j,i,u,this.m())})}getResolver(){return this.a.value}m(){}};e.$0ec=a,e.$0ec=a=Ke([We(0,y.$6ec),We(1,S.$rec),We(2,$.$MM),We(3,p.$uec),We(4,m.$Gec)],a)}),define(Ae[116],Re([1,0,14,5,2,4,3,62,38,17,7,36,206,208,37,115]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=e.$bfc=e.$afc=e.$_ec=e.$$ec=void 0,e.$$ec=(0,M.$Xh)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,u,f,v,g,D){this.E=u,this.F=f,this.G=v,this.H=g,this.I=D,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Rd,this.n=new T.$Rd,this.o=new T.$Rd,this.u=new T.$Rd,this.k=r.getProxy(P.$zK.MainThreadDebugService),this.y=new T.$Rd,this.A=new T.$Rd,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(I=>{I.onDidChange(h=>{this.J(I)}),this.J(I)})}asDebugSourceUri(r,u){const f=r;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let v=`debug:${encodeURIComponent(f.path||"")}`,g="?";return u&&(v+=`${g}session=${encodeURIComponent(u.id)}`,g="&"),v+=`${g}ref=${f.sourceReference}`,C.URI.parse(v)}else{if(f.path)return C.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const u=[];for(const f of r.getAllExtensionDescriptions())if(f.contributes){const v=f.contributes.debuggers;if(v&&v.length>0)for(const g of v)(0,p.$kF)(g)&&u.push(g.type)}this.k.$registerDebugTypes(u)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(u=>r.push(u)),r}addBreakpoints(r){const u=r.filter(g=>{const D=g.id;return this.w.has(D)?!1:(this.w.set(D,g),!0)});this.U(u,[],[]);const f=[],v=new Map;for(const g of u)if(g instanceof A.$AL){let D=v.get(g.location.uri.toString());D||(D={type:"sourceMulti",uri:g.location.uri,lines:[]},v.set(g.location.uri.toString(),D),f.push(D)),D.lines.push({id:g.id,enabled:g.enabled,condition:g.condition,hitCondition:g.hitCondition,logMessage:g.logMessage,line:g.location.range.start.line,character:g.location.range.start.character})}else g instanceof A.$BL&&f.push({type:"function",id:g.id,enabled:g.enabled,hitCondition:g.hitCondition,logMessage:g.logMessage,condition:g.condition,functionName:g.functionName});return this.k.$registerBreakpoints(f)}removeBreakpoints(r){const u=r.filter(D=>this.w.delete(D.id));this.U([],u,[]);const f=u.filter(D=>D instanceof A.$AL).map(D=>D.id),v=u.filter(D=>D instanceof A.$BL).map(D=>D.id),g=u.filter(D=>D instanceof A.$CL).map(D=>D.id);return this.k.$unregisterBreakpoints(f,v,g)}startDebugging(r,u,f){return this.k.$startDebugging(r?r.uri:void 0,u,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,u,f){if(!u)return new A.$BK(()=>{});const v=this.d++;return this.f.push({type:r,handle:v,provider:u}),this.k.$registerDebugConfigurationProvider(r,f,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,v),new A.$BK(()=>{this.f=this.f.filter(g=>g.provider!==u),this.k.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(r,u,f){if(!f)return new A.$BK(()=>{});if(!this.Q(r,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.N(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this.g++;return this.h.push({type:u,handle:v,factory:f}),this.k.$registerDebugAdapterDescriptorFactory(u,v),new A.$BK(()=>{this.h=this.h.filter(g=>g.factory!==f),this.k.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(r,u){if(!u)return new A.$BK(()=>{});const f=this.i++;return this.j.push({type:r,handle:f,factory:u}),new A.$BK(()=>{this.j=this.j.filter(v=>v.factory!==u)})}async $runInTerminal(r,u){return Promise.resolve(void 0)}async $substituteVariables(r,u){let f;const v=await this.W(r);return v&&(f={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(f,u)}K(r,u){if(r.type==="implementation")return new c(r.implementation)}L(){}async $startDASession(r,u){const f=this,v=await this.V(u);return this.S(this.N(v.type),v).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const D=this.M(g),I=this.K(D,v);if(!I)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const h=I;return this.B.set(r,h),this.R(v).then(b=>(b&&this.C.set(r,b),h.onMessage(async k=>{if(k.type==="request"&&k.command==="handshake"){const F=k,W={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const J=await this.D.sign(F.arguments.value);W.body={signature:J},h.sendResponse(W)}else throw new Error("no signer")}catch(J){W.success=!1,W.message=J.message,h.sendResponse(W)}}else b&&b.onDidSendMessage&&b.onDidSendMessage(k),k=(0,p.$pF)(k,!0),f.k.$acceptDAMessage(r,k)}),h.onError(k=>{b&&b.onError&&b.onError(k),this.k.$acceptDAError(r,k.name,k.message,k.stack)}),h.onExit(k=>{b&&b.onExit&&b.onExit(k??void 0,void 0),this.k.$acceptDAExit(r,k??void 0,void 0)}),b&&b.onWillStartSession&&b.onWillStartSession(),h.startSession()))})}$sendDAMessage(r,u){u=(0,p.$oF)(u,!1);const f=this.C.get(r);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(u),this.B.get(r)?.sendMessage(u)}$stopDASession(r){const u=this.C.get(r);this.C.delete(r),u&&u.onWillStopSession&&u.onWillStopSession();const f=this.B.get(r);return this.B.delete(r),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const u=[],f=[],v=[];if(r.added)for(const g of r.added){const D=g.id;if(D&&!this.w.has(D)){let I;if(g.type==="function")I=new A.$BL(g.functionName,g.enabled,g.condition,g.hitCondition,g.logMessage);else if(g.type==="data")I=new A.$CL(g.label,g.dataId,g.canPersist,g.enabled,g.hitCondition,g.condition,g.logMessage);else{const h=C.URI.revive(g.uri);I=new A.$AL(new A.$NK(h,new A.$CK(g.line,g.character)),g.enabled,g.condition,g.hitCondition,g.logMessage)}(0,A.$yL)(I,D),this.w.set(D,I),u.push(I)}}if(r.removed)for(const g of r.removed){const D=this.w.get(g);D&&(this.w.delete(g),f.push(D))}if(r.changed){for(const g of r.changed)if(g.id){const D=this.w.get(g.id);if(D){if(D instanceof A.$BL&&g.type==="function"){const I=D;I.enabled=g.enabled,I.condition=g.condition,I.hitCondition=g.hitCondition,I.logMessage=g.logMessage,I.functionName=g.functionName}else if(D instanceof A.$AL&&g.type==="source"){const I=D;I.enabled=g.enabled,I.condition=g.condition,I.hitCondition=g.hitCondition,I.logMessage=g.logMessage,I.location=new A.$NK(C.URI.revive(g.uri),new A.$CK(g.line,g.character))}v.push(D)}}}this.U(u,f,v)}async $acceptStackFrameFocus(r){let u;const f=r.sessionId?await this.V(r.sessionId):void 0;if(!f)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?u=new A.$IL(f,r.threadId):u=new A.$HL(f,r.threadId,r.frameId),this.z=u,this.A.fire(this.z)}$provideDebugConfigurations(r,u,f){return(0,E.$Sg)(async()=>{const v=this.P(r);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const g=await this.W(u);return v.provideDebugConfigurations(g,f)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(r,u,f,v){return(0,E.$Sg)(async()=>{const g=this.P(r);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const D=await this.W(u);return g.resolveDebugConfiguration(D,f,v)})}$resolveDebugConfigurationWithSubstitutedVariables(r,u,f,v){return(0,E.$Sg)(async()=>{const g=this.P(r);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const D=await this.W(u);return g.resolveDebugConfigurationWithSubstitutedVariables(D,f,v)})}async $provideDebugAdapter(r,u){const f=this.O(r);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.V(u);return this.S(f,v).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.M(g)})}async $acceptDebugSessionStarted(r){const u=await this.V(r);this.m.fire(u)}async $acceptDebugSessionTerminated(r){const u=await this.V(r);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,u){(await this.V(r))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(r,u){const v={session:await this.V(r),event:u.event,body:u.body};this.u.fire(v)}M(r){if(r instanceof A.$DL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof A.$EL)return{type:"server",port:r.port,host:r.host};if(r instanceof A.$FL)return{type:"pipeServer",path:r.path};if(r instanceof A.$GL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const u=this.h.filter(f=>f.type===r);if(u.length>0)return u[0].factory}O(r){const u=this.h.filter(f=>f.handle===r);if(u.length>0)return u[0].factory}P(r){const u=this.f.filter(f=>f.handle===r);if(u.length>0)return u[0].provider}Q(r,u){if(r.contributes){const f=r.contributes.debuggers;if(f&&f.length>0){for(const v of f)if(v.label&&v.type&&v.type===u)return!0}}return!1}R(r){const f=r.configuration.type,v=this.j.filter(g=>g.type===f||g.type==="*").map(g=>(0,E.$Sg)(()=>g.factory.createDebugAdapterTracker(r)).then(D=>D,D=>null));return Promise.race([Promise.all(v).then(g=>{const D=g.filter(I=>!!I);if(D.length>0)return new o(D)}),new Promise(g=>setTimeout(()=>g(void 0),1e3))]).catch(g=>{})}async S(r,u){const f=u.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new A.$EL(f));if(r){const g=await this.F.getExtensionRegistry();return(0,E.$Sg)(()=>r.createDebugAdapterDescriptor(u,this.T(u,g))).then(D=>{if(D)return D})}const v=await this.F.getExtensionRegistry();return Promise.resolve(this.T(u,v))}T(r,u){}U(r,u,f){(r.length>0||u.length>0||f.length>0)&&this.y.fire(Object.freeze({added:r,removed:u,changed:f}))}async V(r){if(r)if(typeof r=="string"){const u=this.l.get(r);if(u)return u}else{let u=this.l.get(r.id);if(!u){const f=await this.W(r.folderUri),v=r.parent?this.l.get(r.parent):void 0;u=new t(this.k,r.id,r.type,r.name,f,r.configuration,v),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(r){if(r){const u=C.URI.revive(r);return this.E.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};e.$_ec=s,e.$_ec=s=Ke([We(0,y.$BM),We(1,S.$rec),We(2,m.$6ec),We(3,w.$uec),We(4,$.$Gec),We(5,a.$9ec)],s);class t{constructor(r,u,f,v,g,D,I){this.d=r,this.f=u,this.g=f,this.h=v,this.i=g,this.j=D,this.k=I}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,u){return this.d.$customDebugAdapterRequest(this.f,r,u)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$afc=t;class n{constructor(r){this.value=Object.freeze({append(u){r.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.$bfc=n;class o{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(u=>u.onError?u.onError(r):void 0)}onExit(r,u){this.d.forEach(f=>f.onExit?f.onExit(r,u):void 0)}}class c extends l.$0cb{constructor(r){super(),this.h=r,r.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let d=class extends s{constructor(r,u,f,v,g,D){super(r,u,f,v,g,D)}};e.$cfc=d,e.$cfc=d=Ke([We(0,y.$BM),We(1,S.$rec),We(2,m.$6ec),We(3,w.$uec),We(4,$.$Gec),We(5,a.$9ec)],d)}),define(Ae[287],Re([1,0,11,88,2,3,275,15,70,71,27,184,17,57,38,59]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=e.$egc=void 0;class s{static async installEarlyHandler(o){Error.stackTraceLimit=100;const c=o.get($.$fj),i=o.get(l.$BM).getProxy(M.$zK.MainThreadErrors);E.setUnexpectedErrorHandler(r=>{c.error(r);const u=E.$2(r);i.$onUnexpectedError(u)})}static async installFullHandler(o){const c=o.get($.$fj),d=o.get(l.$BM),i=o.get(w.$6ec),r=o.get(a.$VM),u=d.getProxy(M.$zK.MainThreadExtensionService),f=d.getProxy(M.$zK.MainThreadErrors),v=await i.getExtensionPathIndex(),g=new WeakMap;function D(b,k){if(g.has(b))return g.get(b).stack;let F="",W,J;for(const R of k)F+=`
	at ${R.toString()}`,J=R.getFileName(),!W&&J&&(W=v.findSubstr(C.URI.file(J)));const N=`${b.name||"Error"}: ${b.message||""}${F}`;return g.set(b,{extensionIdentifier:W?.identifier,stack:N}),N}const I=Symbol("prepareStackTrace wrapped");let h=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(b){if(b===D||!b||b[I]){h=b||D;return}h=function(k,F){return D(k,F),b.call(Error,k,F)},Object.assign(h,{[I]:!0})}}),E.setUnexpectedErrorHandler(b=>{c.error(b);const k=E.$2(b),F=g.get(b);if(!F?.extensionIdentifier){f.$onUnexpectedError(k);return}u.$onExtensionRuntimeError(F.extensionIdentifier,k);const W=r.onExtensionError(F.extensionIdentifier,b);c.trace("forwarded error to extension?",W,F)})}}e.$egc=s;class t{constructor(o,c,d,i,r){this.a=d,this.b=new P.$o6b(o,null,i),c=t.e(c,this.b);const u=new y.$Vh(...(0,m.$Fr)());u.set(A.$RM,{_serviceBrand:void 0,...c,messagePorts:r}),u.set(l.$BM,new l.$CM(this.b)),u.set(p.$oec,new p.$pec(i)),u.set(w.$4ec,d);const f=new S.$lq(u,!0);f.invokeFunction(s.installEarlyHandler),this.d=f.invokeFunction(v=>v.get($.$fj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=f.invokeFunction(v=>v.get(w.$6ec)),this.c.initialize(),f.invokeFunction(s.installFullHandler)}async asBrowserUri(o){const c=this.b.getProxy(M.$zK.MainThreadExtensionService);return C.URI.revive(await c.$asBrowserUri(o))}terminate(o){this.c.terminate(o)}static e(o,c){o.extensions.allExtensions.forEach(i=>{i.extensionLocation=C.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),o.environment.appRoot=C.URI.revive(c.transformIncomingURIs(o.environment.appRoot));const d=o.environment.extensionDevelopmentLocationURI;return d&&(o.environment.extensionDevelopmentLocationURI=d.map(i=>C.URI.revive(c.transformIncomingURIs(i)))),o.environment.extensionTestsLocationURI=C.URI.revive(c.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=C.URI.revive(c.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=C.URI.revive(c.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=C.URI.revive(c.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=C.URI.revive(c.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=C.URI.revive(c.transformIncomingURIs(o.logsLocation)),o.workspace=c.transformIncomingURIs(o.workspace),o}}e.$fgc=t}),define(Ae[288],Re([1,0,18,14,19,39,13,20,25,2,43]),function(we,e,E,T,C,M,P,$,m,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=e.$sfc=e.$rfc=e.$qfc=void 0;class S{constructor(n,o,c,d){this.d=n,this.e=o,this.f=c,this.g=d,this.a=null,this.b=!1,this.c=0}search(n,o){const c=this.d.folderQueries||[],d=new C.$2d(o);return new Promise((i,r)=>{this.a=new p(n);let u=!1;const f=(v,g)=>{if(!u&&!this.b){const D=this.h(v);a(v)&&typeof this.d.maxResults=="number"&&this.c+D>this.d.maxResults&&(this.b=!0,u=!0,d.cancel(),v=this.j(v,this.d.maxResults-this.c));const I=this.h(v);this.c+=I,(I>0||!a(v))&&this.a.add(v,g)}};Promise.all(c.map((v,g)=>this.k(v,D=>f(D,g),d.token))).then(v=>{d.dispose(),this.a.flush();const g=v.some(D=>!!D&&!!D.limitHit);i({limitHit:this.b||g,messages:(0,E.$Qb)(v.map(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[])),stats:{type:this.g}})},v=>{d.dispose();const g=(0,M.$Ii)(v);r(new Error(g))})})}h(n){return a(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,o){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],d=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,o),preview:{matches:d.slice(0,o),text:n.preview.text},uri:n.uri}}async k(n,o,c){const d=new A.$eJ(this.d,n),i=[],r={report:v=>{if(!this.l(v))return;const g=n.folder.scheme===P.Schemas.file?(0,A.$fJ)(()=>this.f.readdir(m.$Ag(v.uri))):void 0,D=m.$Dg(n.folder,v.uri);if(D){const I=d.includedInQuery(D,$.$mc(D),g);(0,T.$Mg)(I)?i.push(I.then(h=>{h&&o(v)})):I&&o(v)}}},u=this.n(n),f=await this.e.provideTextSearchResults(l(this.d.contentPattern),u,r,c);return i.length&&await Promise.all(i),f}l(n){if(a(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const o=(0,A.$dJ)(this.d.includePattern,n.includePattern),c=(0,A.$dJ)(this.d.excludePattern,n.excludePattern),d={folder:y.URI.from(n.folder),excludes:c,includes:o,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return d.usePCRE2=this.d.usePCRE2,d}}e.$qfc=S;function l(t){return{isCaseSensitive:t.isCaseSensitive||!1,isRegExp:t.isRegExp||!1,isWordMatch:t.isWordMatch||!1,isMultiline:t.isMultiline||!1,pattern:t.pattern}}class p{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new s(512,o=>this.g(o))}add(n,o){this.d&&(this.b!==o||!m.$ug(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=o,this.d={resource:n.uri,results:[]}),this.d.results.push(w(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$rfc=p;function w(t){return a(t)?{preview:{matches:(0,E.$1b)(t.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:t.preview.text},ranges:(0,E.$1b)(t.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:t.text,lineNumber:t.lineNumber}}function a(t){return!!t.preview}e.$sfc=a;class s{static{this.a=4e3}static{this.b=50}constructor(n,o){this.g=n,this.h=o,this.c=0,this.d=[],this.e=0}addItem(n,o){n&&this.j(n,o)}addItems(n,o){n&&this.k(n,o)}j(n,o){this.d.push(n),this.e+=o,this.l()}k(n,o){this.d=this.d.concat(n),this.e+=o,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$tfc=s}),define(Ae[117],Re([1,0,6,3,4,283,17,57,15,2,288]),function(we,e,E,T,C,M,P,$,m,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=e.$vfc=e.$ufc=void 0,e.$ufc=(0,C.$Xh)("IExtHostSearch");let S=class{constructor(a,s,t){this.k=a,this.l=s,this.n=t,this.c=this.k.getProxy(T.$zK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$pfc}o(a){return this.l.transformOutgoingScheme(a)}registerTextSearchProvider(a,s){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const t=this.d++;return this.e.set(t,s),this.c.$registerTextSearchProvider(t,this.o(a)),(0,E.$Pc)(()=>{this.g.delete(a),this.e.delete(t),this.c.$unregisterProvider(t)})}registerFileSearchProvider(a,s){if(this.i.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.i.add(a);const t=this.d++;return this.h.set(t,s),this.c.$registerFileSearchProvider(t,this.o(a)),(0,E.$Pc)(()=>{this.i.delete(a),this.h.delete(t),this.c.$unregisterProvider(t)})}$provideFileSearchResults(a,s,t,n){const o=l(t),c=this.h.get(a);if(c)return this.j.fileSearch(o,c,d=>{this.c.$handleFileMatch(a,s,d.map(i=>i.resource))},n);throw new Error("unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,s,t){return{messages:[]}}$clearCache(a){return this.j.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,s,t,n){const o=this.e.get(a);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const c=l(t);return this.q(c,o).search(i=>this.c.$handleTextMatch(a,s,i),n)}$enableExtensionHostSearch(){}q(a,s){return new A.$qfc(a,s,{readdir:t=>Promise.resolve([]),toCanonicalName:t=>t},"textSearchProvider")}};e.$vfc=S,e.$vfc=S=Ke([We(0,P.$BM),We(1,$.$oec),We(2,m.$fj)],S);function l(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(p),extraFileResources:w.extraFileResources&&w.extraFileResources.map(a=>y.URI.revive(a))}}e.$wfc=l;function p(w){return{...w,folder:y.URI.revive(w.folder)}}}),define(Ae[289],Re([1,0,19,11,5,6,13,31,2,145,141,128,92,22,41,15,55,56,197,3,230,238,81,231,232,233,234,235,236,237,212,32,239,37,271,116,109,241,242,243,219,244,61,62,246,38,247,63,248,42,27,249,250,251,252,253,254,82,83,256,282,221,201,222,257,258,111,259,223,260,261,17,262,117,84,263,264,265,85,86,114,59,64,266,267,209,268,224,87,8,7,269,57,270,65,272,273,110,36,207,79,23,113]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a,s,t,n,o,c,d,i,r,u,f,v,g,D,I,h,b,k,F,W,J,N,R,L,O,X,he,$e,De,ke,de,Ee,_,Ce,se,Q,U,ne,pe,re,le,ce,be,ee,fe,ie,ae,me,Pe,z,V,H,G,q,x,ue,Ne,Be,Xe,Je,it,_e,tt,rt,nt,ze,ht,Y,Z,ye,Ue,He,Ye,st,pt,Te,At,Kt,Ht,bt,jt,Ot,Gt,Ut,kt,Tt,Qe,Jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;function Wt(ct){const ft=ct.get(Q.$RM),Vt=ct.get(se.$9dc),Rt=ct.get(_.$wec),Dt=ct.get(de.$6ec),gt=ct.get(Ut.$rec),Mt=ct.get(ht.$VM),Pt=ct.get(F.$uec),St=ct.get(Kt.$oec),Ve=ct.get(Ne.$BM),Nt=ct.get(rt.$Pec),zt=ct.get(nt.$xec),Zt=ct.get(a.$gj),Se=ct.get(a.$fj),Me=ct.get(st.$bxb),ve=ct.get(i.$_dc),K=ct.get(Gt.$$fc),Le=ct.get(Je.$Xec),je=ct.get(De.$Gec),Ze=ct.get(ee.$2ec);Ve.set(o.$AK.ExtHostFileSystemInfo,Vt),Ve.set(o.$AK.ExtHostLogLevelServiceShape,Zt),Ve.set(o.$AK.ExtHostWorkspace,gt),Ve.set(o.$AK.ExtHostConfiguration,Pt),Ve.set(o.$AK.ExtHostExtensionService,Dt),Ve.set(o.$AK.ExtHostStorage,Nt),Ve.set(o.$AK.ExtHostTunnelService,Me),Ve.set(o.$AK.ExtHostWindow,K),Ve.set(o.$AK.ExtHostSecretState,Le),Ve.set(o.$AK.ExtHostTelemetry,Mt),Ve.set(o.$AK.ExtHostEditorTabs,je),Ve.set(o.$AK.ExtHostManagedSockets,Ze);const qe=Ve.set(o.$AK.ExtHostDecorations,ct.get(N.$efc)),et=Ve.set(o.$AK.ExtHostDocumentsAndEditors,ct.get($e.$MM)),ut=Ve.set(o.$AK.ExtHostCommands,ct.get(b.$XM)),vt=Ve.set(o.$AK.ExtHostTerminalService,ct.get(Y.$Sec)),$t=Ve.set(o.$AK.ExtHostDebugService,ct.get(J.$$ec)),Et=Ve.set(o.$AK.ExtHostSearch,ct.get(Xe.$ufc)),yt=Ve.set(o.$AK.ExtHostTask,ct.get(ze.$Xfc)),Di=Ve.set(o.$AK.ExtHostOutputService,ct.get(H.$Kfc)),qt=Ve.set(o.$AK.ExtHostLocalization,ct.get(be.$1ec)),mi=Ve.set(o.$AK.ExtHostUrls,new Ht.$8fc(Ve)),Ct=Ve.set(o.$AK.ExtHostDocuments,new he.$7dc(Ve,et)),ki=Ve.set(o.$AK.ExtHostDocumentContentProviders,new O.$gfc(Ve,et,Se)),Ki=Ve.set(o.$AK.ExtHostDocumentSaveParticipant,new X.$hfc(Se,Ct,Ve.getProxy(o.$zK.MainThreadBulkEdits))),It=Ve.set(o.$AK.ExtHostNotebook,new ie.$xfc(Ve,ut,et,Ct,Rt,Et)),ii=Ve.set(o.$AK.ExtHostNotebookDocuments,new me.$Efc(It)),$i=Ve.set(o.$AK.ExtHostNotebookEditors,new Pe.$Ffc(Se,It)),oi=Ve.set(o.$AK.ExtHostNotebookKernels,new z.$Gfc(Ve,ft,It,ut,Se)),Si=Ve.set(o.$AK.ExtHostNotebookRenderers,new V.$Ifc(Ve,It)),Ii=Ve.set(o.$AK.ExtHostNotebookDocumentSaveParticipant,new ae.$Dfc(Se,It,Ve.getProxy(o.$zK.MainThreadBulkEdits))),Lt=Ve.set(o.$AK.ExtHostEditors,new ye.$lec(Ve,et)),pi=Ve.set(o.$AK.ExtHostTreeViews,new Ye.$6fc(Ve.getProxy(o.$zK.MainThreadTreeViews),ut,Se)),Ci=Ve.set(o.$AK.ExtHostEditorInsets,new h.$mec(Ve.getProxy(o.$zK.MainThreadEditorInsets),Lt,ft.remote)),ai=Ve.set(o.$AK.ExtHostDiagnostics,new R.$$dc(Ve,Se,Vt,et)),ci=Ve.set(o.$AK.ExtHostLanguages,new ce.$Bfc(Ve,Ct,ut.converter,St)),lt=Ve.set(o.$AK.ExtHostLanguageFeatures,new le.$cec(Ve,St,Ct,ut,ai,Se,ve,Mt)),Hi=Ve.set(o.$AK.ExtHostFileSystem,new Ee.$jfc(Ve,lt)),Yt=Ve.set(o.$AK.ExtHostFileSystemEventService,new Ce.$kfc(Ve,Se,et)),ni=Ve.set(o.$AK.ExtHostQuickOpen,(0,ue.$Ofc)(Ve,gt,ut)),di=Ve.set(o.$AK.ExtHostSCM,new Be.$Qfc(Ve,ut,Ct,Se)),Pi=Ve.set(o.$AK.ExtHostQuickDiff,new x.$Nfc(Ve,St)),Gi=Ve.set(o.$AK.ExtHostShare,new it.$Rfc(Ve,St)),Ai=Ve.set(o.$AK.ExtHostComments,(0,k.$nec)(Ve,ut,Ct)),vi=Ve.set(o.$AK.ExtHostProgress,new q.$Mfc(Ve.getProxy(o.$zK.MainThreadProgress))),Ji=Ve.set(o.$AK.ExtHosLabelService,new re.$Afc(Ve)),Ri=Ve.set(o.$AK.ExtHostTheming,new Ue.$3fc(Ve)),ui=Ve.set(o.$AK.ExtHostAuthentication,new r.$eec(Ve)),Zi=Ve.set(o.$AK.ExtHostTimeline,new He.$5fc(Ve,ut)),wi=Ve.set(o.$AK.ExtHostWebviews,new bt.$Bec(Ve,ft.remote,gt,Se,ve)),Mi=Ve.set(o.$AK.ExtHostWebviewPanels,new jt.$Eec(Ve,wi,gt)),ln=Ve.set(o.$AK.ExtHostCustomEditors,new W.$Fec(Ve,Ct,zt,wi,Mi)),Li=Ve.set(o.$AK.ExtHostWebviewViews,new Ot.$9fc(Ve,wi)),ri=Ve.set(o.$AK.ExtHostTesting,new Z.$Yfc(Ve,ut,et)),hn=Ve.set(o.$AK.ExtHostUriOpeners,new At.$7fc(Ve)),dn=Ve.set(o.$AK.ExtHostProfileContentHandlers,new G.$Lfc(Ve));Ve.set(o.$AK.ExtHostInteractive,new ne.$yfc(Ve,It,et,ut,Se));const Qi=Ve.set(o.$AK.ExtHostInlineChat,new U.$lfc(Ve,ut,Ct,Se)),fi=Ve.set(o.$AK.ExtHostChatProvider,new g.$hec(Ve,Se)),Xi=Ve.set(o.$AK.ExtHostChatAgents2,new v.$iec(Ve,fi,Se)),Yi=Ve.set(o.$AK.ExtHostChatVariables,new D.$jec(Ve)),gi=Ve.set(o.$AK.ExtHostChat,new f.$gec(Ve)),xi=Ve.set(o.$AK.ExtHostAiRelatedInformation,new c.$6dc(Ve)),Fi=Ve.set(o.$AK.ExtHostAiEmbeddingVector,new ke.$ifc(Ve)),Ti=Ve.set(o.$AK.ExtHostIssueReporter,new pe.$zfc(Ve)),xt=Ve.set(o.$AK.ExtHostStatusBar,new tt.$Ufc(Ve,ut.converter)),bi=Ve.set(o.$AK.ExtHostSpeech,new _e.$Sfc(Ve)),fn=Object.values(o.$AK);Ve.assertRegistered(fn);const Qt=new u.$fec(Ve,et),yi=new I.$kec(Ve),Ei=new fe.$Cfc(Ve,Se),Oi=new L.$ffc(Ve);return d.$dec.register(ut),function(Oe,_t,_i){const mt=function(){let te=!Oe.isUnderDevelopment;function ge(){te||(Se.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Fe(ot){if(Array.isArray(ot))ot.forEach(Fe);else if(typeof ot=="string")ge();else{const wt=ot;typeof wt.scheme>"u"&&ge(),typeof wt.exclusive=="boolean"&&(0,Qe.$OF)(Oe,"documentFiltersExclusive")}return ot}}(),en={getSession(te,ge,Fe){return ui.getSession(Oe,te,ge,Fe)},getSessions(te,ge){return(0,Qe.$OF)(Oe,"authGetSessions"),ui.getSessions(Oe,te,ge)},async hasSession(te,ge){return(0,Qe.$OF)(Oe,"authSession"),!!await ui.getSession(Oe,te,ge,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(te,ge,Fe,ot){return ui.registerAuthenticationProvider(te,ge,Fe,ot)}},gn={registerCommand(te,ge,Fe){return ut.registerCommand(!0,te,ge,Fe,void 0,Oe)},registerTextEditorCommand(te,ge,Fe){return ut.registerCommand(!0,te,(...ot)=>{const wt=Lt.getActiveTextEditor();if(!wt){Se.warn("Cannot execute "+te+" because there is no active text editor.");return}return wt.edit(Ft=>{ge.apply(Fe,[wt,Ft,...ot])}).then(Ft=>{Ft||Se.warn("Edits from command "+te+" were not applied.")},Ft=>{Se.warn("An error occurred while running command "+te,Ft)})},void 0,void 0,Oe)},registerDiffInformationCommand:(te,ge,Fe)=>((0,Qe.$OF)(Oe,"diffCommand"),ut.registerCommand(!0,te,async(...ot)=>{const wt=et.activeEditor(!0);if(!wt){Se.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ft=await Lt.getDiffInformation(wt.id);ge.apply(Fe,[Ft,...ot])},void 0,void 0,Oe)),executeCommand(te,...ge){return ut.executeCommand(te,...ge)},getCommands(te=!1){return ut.getCommands(te)}},tn={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return yi.value},get shell(){return vt.getDefaultShell(!1)},get onDidChangeShell(){return vt.onDidChangeShell},get isTelemetryEnabled(){return Mt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Mt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Qe.$OF)(Oe,"telemetry"),Mt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Qe.$OF)(Oe,"telemetry"),Mt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,ht.$UM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,ge){return ht.$TM.validateSender(te),Mt.instantiateLogger(Oe,te,ge)},openExternal(te,ge){return K.openUri(te,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ft.environment.appUriScheme)return mi.createAppUri(te);try{return await K.asExternalUri(te,{allowTunneling:!!ft.remote.authority})}catch(ge){if((0,P.$$f)(te,P.Schemas.http)||(0,P.$$f)(te,P.Schemas.https))return te;throw ge}},get remoteName(){return(0,s.$4k)(ft.remote.authority)},get remoteAuthority(){return(0,Qe.$OF)(Oe,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return Se.getLevel()},get onDidChangeLogLevel(){return Se.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Qe.$OF)(Oe,"handleIssueUri"),Ti.registerIssueUriRequestHandler(Oe,te)},registerIssueDataProvider(te){return(0,Qe.$OF)(Oe,"handleIssueUri"),Ti.registerIssueDataProvider(Oe,te)},get appQuality(){return(0,Qe.$OF)(Oe,"resolvers"),ft.quality},get appCommit(){return(0,Qe.$OF)(Oe,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(tn);const nn={createTestController(te,ge,Fe){return ri.createTestController(Oe,te,ge,Fe)},createTestObserver(){return(0,Qe.$OF)(Oe,"testObserver"),ri.createTestObserver()},runTests(te){return(0,Qe.$OF)(Oe,"testObserver"),ri.runTests(te)},get onDidChangeTestResults(){return(0,Qe.$OF)(Oe,"testObserver"),ri.onResultsChanged},get testResults(){return(0,Qe.$OF)(Oe,"testObserver"),ri.results}},li=ft.remote.isRemote?Te.ExtensionKind.Workspace:Te.ExtensionKind.UI,rn={getExtension(te,ge){(0,Qe.$NF)(Oe,"extensionsAny")||(ge=!1);const Fe=_t.mine.getExtensionDescription(te);if(Fe)return new de.$7ec(Dt,Oe.identifier,Fe,li,!1);if(ge){const ot=_t.all.getExtensionDescription(te);if(ot)return new de.$7ec(Dt,Oe.identifier,ot,li,!0)}},get all(){const te=[];for(const ge of _t.mine.getAllExtensionDescriptions())te.push(new de.$7ec(Dt,Oe.identifier,ge,li,!1));return te},get allAcrossExtensionHosts(){(0,Qe.$OF)(Oe,"extensionsAny");const te=new p.$cm(_t.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),ge=[];for(const Fe of _t.all.getAllExtensionDescriptions()){const ot=!te.has(Fe.identifier);ge.push(new de.$7ec(Dt,Oe.identifier,Fe,li,ot))}return ge},get onDidChange(){return(0,Qe.$NF)(Oe,"extensionsAny")?C.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},sn={createDiagnosticCollection(te){return ai.createDiagnosticCollection(Oe.identifier,te)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:te=>ai.getDiagnostics(te),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(te,ge){return ci.changeLanguage(te.uri,ge)},match(te,ge){const Fe=Ct.getDocumentData(ge.uri)?.notebook;return(0,A.$NE)(pt.LanguageSelector.from(te),ge.uri,ge.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(te,ge,Fe){return lt.registerCodeActionProvider(Oe,mt(te),ge,Fe)},registerDocumentPasteEditProvider(te,ge,Fe){return(0,Qe.$OF)(Oe,"documentPaste"),lt.registerDocumentPasteEditProvider(Oe,mt(te),ge,Fe)},registerCodeLensProvider(te,ge){return lt.registerCodeLensProvider(Oe,mt(te),ge)},registerDefinitionProvider(te,ge){return lt.registerDefinitionProvider(Oe,mt(te),ge)},registerDeclarationProvider(te,ge){return lt.registerDeclarationProvider(Oe,mt(te),ge)},registerImplementationProvider(te,ge){return lt.registerImplementationProvider(Oe,mt(te),ge)},registerTypeDefinitionProvider(te,ge){return lt.registerTypeDefinitionProvider(Oe,mt(te),ge)},registerHoverProvider(te,ge){return lt.registerHoverProvider(Oe,mt(te),ge,Oe.identifier)},registerEvaluatableExpressionProvider(te,ge){return lt.registerEvaluatableExpressionProvider(Oe,mt(te),ge,Oe.identifier)},registerInlineValuesProvider(te,ge){return lt.registerInlineValuesProvider(Oe,mt(te),ge,Oe.identifier)},registerDocumentHighlightProvider(te,ge){return lt.registerDocumentHighlightProvider(Oe,mt(te),ge)},registerLinkedEditingRangeProvider(te,ge){return lt.registerLinkedEditingRangeProvider(Oe,mt(te),ge)},registerReferenceProvider(te,ge){return lt.registerReferenceProvider(Oe,mt(te),ge)},registerRenameProvider(te,ge){return lt.registerRenameProvider(Oe,mt(te),ge)},registerDocumentSymbolProvider(te,ge,Fe){return lt.registerDocumentSymbolProvider(Oe,mt(te),ge,Fe)},registerWorkspaceSymbolProvider(te){return lt.registerWorkspaceSymbolProvider(Oe,te)},registerDocumentFormattingEditProvider(te,ge){return lt.registerDocumentFormattingEditProvider(Oe,mt(te),ge)},registerDocumentRangeFormattingEditProvider(te,ge){return lt.registerDocumentRangeFormattingEditProvider(Oe,mt(te),ge)},registerOnTypeFormattingEditProvider(te,ge,Fe,...ot){return lt.registerOnTypeFormattingEditProvider(Oe,mt(te),ge,[Fe].concat(ot))},registerDocumentSemanticTokensProvider(te,ge,Fe){return lt.registerDocumentSemanticTokensProvider(Oe,mt(te),ge,Fe)},registerDocumentRangeSemanticTokensProvider(te,ge,Fe){return lt.registerDocumentRangeSemanticTokensProvider(Oe,mt(te),ge,Fe)},registerSignatureHelpProvider(te,ge,Fe,...ot){return typeof Fe=="object"?lt.registerSignatureHelpProvider(Oe,mt(te),ge,Fe):lt.registerSignatureHelpProvider(Oe,mt(te),ge,typeof Fe>"u"?[]:[Fe,...ot])},registerCompletionItemProvider(te,ge,...Fe){return lt.registerCompletionItemProvider(Oe,mt(te),ge,Fe)},registerInlineCompletionItemProvider(te,ge,Fe){return ge.handleDidShowCompletionItem&&(0,Qe.$OF)(Oe,"inlineCompletionsAdditions"),ge.handleDidPartiallyAcceptCompletionItem&&(0,Qe.$OF)(Oe,"inlineCompletionsAdditions"),Fe&&(0,Qe.$OF)(Oe,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Oe,mt(te),ge,Fe)},registerDocumentLinkProvider(te,ge){return lt.registerDocumentLinkProvider(Oe,mt(te),ge)},registerColorProvider(te,ge){return lt.registerColorProvider(Oe,mt(te),ge)},registerFoldingRangeProvider(te,ge){return lt.registerFoldingRangeProvider(Oe,mt(te),ge)},registerSelectionRangeProvider(te,ge){return lt.registerSelectionRangeProvider(Oe,te,ge)},registerCallHierarchyProvider(te,ge){return lt.registerCallHierarchyProvider(Oe,te,ge)},registerTypeHierarchyProvider(te,ge){return lt.registerTypeHierarchyProvider(Oe,te,ge)},setLanguageConfiguration:(te,ge)=>lt.setLanguageConfiguration(Oe,te,ge),getTokenInformationAtPosition(te,ge){return(0,Qe.$OF)(Oe,"tokenInformation"),ci.tokenAtPosition(te,ge)},registerInlayHintsProvider(te,ge){return lt.registerInlayHintsProvider(Oe,te,ge)},createLanguageStatusItem(te,ge){return ci.createLanguageStatusItem(Oe,te,ge)},registerDocumentDropEditProvider(te,ge,Fe){return lt.registerDocumentOnDropEditProvider(Oe,te,ge,(0,Qe.$NF)(Oe,"dropMetadata")?Fe:void 0)}},on={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(te,ge,Fe){const ot=await(m.URI.isUri(te)?Promise.resolve(an.openTextDocument(te)):Promise.resolve(te));return Lt.showTextDocument(ot,ge,Fe)},createTextEditorDecorationType(te){return Lt.createTextEditorDecorationType(Oe,te)},onDidChangeActiveTextEditor(te,ge,Fe){return Lt.onDidChangeActiveTextEditor(te,ge,Fe)},onDidChangeVisibleTextEditors(te,ge,Fe){return Lt.onDidChangeVisibleTextEditors(te,ge,Fe)},onDidChangeTextEditorSelection(te,ge,Fe){return Lt.onDidChangeTextEditorSelection(te,ge,Fe)},onDidChangeTextEditorOptions(te,ge,Fe){return Lt.onDidChangeTextEditorOptions(te,ge,Fe)},onDidChangeTextEditorVisibleRanges(te,ge,Fe){return Lt.onDidChangeTextEditorVisibleRanges(te,ge,Fe)},onDidChangeTextEditorViewColumn(te,ge,Fe){return Lt.onDidChangeTextEditorViewColumn(te,ge,Fe)},onDidCloseTerminal(te,ge,Fe){return vt.onDidCloseTerminal(te,ge,Fe)},onDidOpenTerminal(te,ge,Fe){return vt.onDidOpenTerminal(te,ge,Fe)},onDidChangeActiveTerminal(te,ge,Fe){return vt.onDidChangeActiveTerminal(te,ge,Fe)},onDidChangeTerminalDimensions(te,ge,Fe){return(0,Qe.$OF)(Oe,"terminalDimensions"),vt.onDidChangeTerminalDimensions(te,ge,Fe)},onDidChangeTerminalState(te,ge,Fe){return vt.onDidChangeTerminalState(te,ge,Fe)},onDidWriteTerminalData(te,ge,Fe){return(0,Qe.$OF)(Oe,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(te,ge,Fe)},onDidExecuteTerminalCommand(te,ge,Fe){return(0,Qe.$OF)(Oe,"terminalExecuteCommandEvent"),vt.onDidExecuteTerminalCommand(te,ge,Fe)},get state(){return K.getState(Oe)},onDidChangeWindowState(te,ge,Fe){return K.onDidChangeWindowState(te,ge,Fe)},showInformationMessage(te,...ge){return Ei.showMessage(Oe,$.default.Info,te,ge[0],ge.slice(1))},showWarningMessage(te,...ge){return Ei.showMessage(Oe,$.default.Warning,te,ge[0],ge.slice(1))},showErrorMessage(te,...ge){return Ei.showMessage(Oe,$.default.Error,te,ge[0],ge.slice(1))},showQuickPick(te,ge,Fe){return ni.showQuickPick(Oe,te,ge,Fe)},showWorkspaceFolderPick(te){return ni.showWorkspaceFolderPick(te)},showInputBox(te,ge){return ni.showInput(te,ge)},showOpenDialog(te){return Oi.showOpenDialog(Oe,te)},showSaveDialog(te){return Oi.showSaveDialog(te)},createStatusBarItem(te,ge,Fe){let ot,wt,Ft;return typeof te=="string"?(ot=te,wt=ge,Ft=Fe):(wt=te,Ft=ge),xt.createStatusBarEntry(Oe,ot,wt,Ft)},setStatusBarMessage(te,ge){return xt.setStatusBarMessage(te,ge)},withScmProgress(te){return ve.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),vi.withProgress(Oe,{location:Te.ProgressLocation.SourceControl},(ge,Fe)=>te({report(ot){}}))},withProgress(te,ge){return vi.withProgress(Oe,te,ge)},createOutputChannel(te,ge){return Di.createOutputChannel(te,ge,Oe)},createWebviewPanel(te,ge,Fe,ot){return Mi.createWebviewPanel(Oe,te,ge,Fe,ot)},createWebviewTextEditorInset(te,ge,Fe,ot){return(0,Qe.$OF)(Oe,"editorInsets"),Ci.createWebviewEditorInset(te,ge,Fe,ot,Oe)},createTerminal(te,ge,Fe){return typeof te=="object"?"pty"in te?vt.createExtensionTerminal(te):vt.createTerminalFromOptions(te):vt.createTerminal(te,ge,Fe)},registerTerminalLinkProvider(te){return vt.registerLinkProvider(te)},registerTerminalProfileProvider(te,ge){return vt.registerProfileProvider(Oe,te,ge)},registerTerminalQuickFixProvider(te,ge){return(0,Qe.$OF)(Oe,"terminalQuickFixProvider"),vt.registerTerminalQuickFixProvider(te,Oe.identifier.value,ge)},registerTreeDataProvider(te,ge){return pi.registerTreeDataProvider(te,ge,Oe)},createTreeView(te,ge){return pi.createTreeView(te,ge,Oe)},registerWebviewPanelSerializer:(te,ge)=>Mi.registerWebviewPanelSerializer(Oe,te,ge),registerCustomEditorProvider:(te,ge,Fe={})=>ln.registerCustomEditorProvider(Oe,te,ge,Fe),registerFileDecorationProvider(te){return qe.registerFileDecorationProvider(te,Oe)},registerUriHandler(te){return mi.registerUriHandler(Oe,te)},createQuickPick(){return ni.createQuickPick(Oe)},createInputBox(){return ni.createInputBox(Oe)},get activeColorTheme(){return Ri.activeColorTheme},onDidChangeActiveColorTheme(te,ge,Fe){return Ri.onDidChangeActiveColorTheme(te,ge,Fe)},registerWebviewViewProvider(te,ge,Fe){return Li.registerWebviewViewProvider(Oe,te,ge,Fe?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ge,Fe){return It.onDidChangeActiveNotebookEditor(te,ge,Fe)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return It.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,ge,Fe){return $i.onDidChangeNotebookEditorSelection(te,ge,Fe)},onDidChangeNotebookEditorVisibleRanges(te,ge,Fe){return $i.onDidChangeNotebookEditorVisibleRanges(te,ge,Fe)},showNotebookDocument(te,ge){return It.showNotebookDocument(te,ge)},registerExternalUriOpener(te,ge,Fe){return(0,Qe.$OF)(Oe,"externalUriOpener"),hn.registerExternalUriOpener(Oe.identifier,te,ge,Fe)},registerProfileContentHandler(te,ge){return(0,Qe.$OF)(Oe,"profileContentHandlers"),dn.registrProfileContentHandler(Oe,te,ge)},registerQuickDiffProvider(te,ge,Fe,ot){return(0,Qe.$OF)(Oe,"quickDiffProvider"),Pi.registerQuickDiffProvider(mt(te),ge,Fe,ot)},get tabGroups(){return je.tabGroups},registerShareProvider(te,ge){return(0,Qe.$OF)(Oe,"shareProvider"),Gi.registerShareProvider(mt(te),ge)}},an={get rootPath(){return ve.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(te){throw new T.$8("rootPath")},getWorkspaceFolder(te){return gt.getWorkspaceFolder(te)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(te){throw new T.$8("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(te){throw new T.$8("workspaceFile")},updateWorkspaceFolders:(te,ge,...Fe)=>gt.updateWorkspaceFolders(Oe,te,ge||0,...Fe),onDidChangeWorkspaceFolders:function(te,ge,Fe){return gt.onDidChangeWorkspace(te,ge,Fe)},asRelativePath:(te,ge)=>gt.getRelativePath(te,ge),findFiles:(te,ge,Fe,ot)=>gt.findFiles(te,ge,Fe,Oe.identifier,ot),findTextInFiles:(te,ge,Fe,ot)=>{(0,Qe.$OF)(Oe,"findTextInFiles");let wt,Ft;return typeof ge=="object"?(wt=ge,Ft=Fe):(wt={},Ft=ge,ot=Fe),gt.findTextInFiles(te,wt||{},Ft,Oe.identifier,ot)},save:te=>((0,Qe.$OF)(Oe,"saveEditor"),gt.save(te)),saveAs:te=>((0,Qe.$OF)(Oe,"saveEditor"),gt.saveAs(te)),saveAll:te=>gt.saveAll(te),applyEdit(te,ge){return Qt.applyWorkspaceEdit(te,Oe,ge)},createFileSystemWatcher:(te,ge,Fe,ot)=>{let wt;return typeof ge=="boolean"?wt={ignoreCreateEvents:!!ge,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!ot,correlate:!1}:ge&&((0,Qe.$OF)(Oe,"createFileSystemWatcher"),wt={...ge,correlate:!0}),Yt.createFileSystemWatcher(gt,Oe,te,wt)},get textDocuments(){return Ct.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new T.$8("textDocuments")},openTextDocument(te){let ge;const Fe=te;if(typeof te=="string")ge=Promise.resolve(m.URI.file(te));else if(m.URI.isUri(te))ge=Promise.resolve(te);else if(!Fe||typeof Fe=="object")ge=Ct.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(ot=>Ct.ensureDocumentData(ot).then(wt=>wt.document))},onDidOpenTextDocument:(te,ge,Fe)=>Ct.onDidAddDocument(te,ge,Fe),onDidCloseTextDocument:(te,ge,Fe)=>Ct.onDidRemoveDocument(te,ge,Fe),onDidChangeTextDocument:(te,ge,Fe)=>Ct.onDidChangeDocument(te,ge,Fe),onDidSaveTextDocument:(te,ge,Fe)=>Ct.onDidSaveDocument(te,ge,Fe),onWillSaveTextDocument:(te,ge,Fe)=>Ki.getOnWillSaveTextDocumentEvent(Oe)(te,ge,Fe),get notebookDocuments(){return It.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,ge){let Fe;if(m.URI.isUri(te))Fe=te,await It.openNotebookDocument(te);else if(typeof te=="string")Fe=m.URI.revive(await It.createNotebookDocument({viewType:te,content:ge}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(te,ge,Fe){return ii.onDidSaveNotebookDocument(te,ge,Fe)},onDidChangeNotebookDocument(te,ge,Fe){return ii.onDidChangeNotebookDocument(te,ge,Fe)},onWillSaveNotebookDocument(te,ge,Fe){return Ii.getOnWillSaveNotebookDocumentEvent(Oe)(te,ge,Fe)},get onDidOpenNotebookDocument(){return It.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return It.onDidCloseNotebookDocument},registerNotebookSerializer(te,ge,Fe,ot){return It.registerNotebookSerializer(Oe,te,ge,Fe,(0,Qe.$NF)(Oe,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(te,ge,Fe)=>_i.onDidChangeConfiguration(te,ge,Fe),getConfiguration(te,ge){return ge=arguments.length===1?void 0:ge,_i.getConfiguration(te,ge,Oe)},registerTextDocumentContentProvider(te,ge){return ki.registerTextDocumentContentProvider(te,ge)},registerTaskProvider:(te,ge)=>(ve.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Oe,te,ge)),registerFileSystemProvider(te,ge,Fe){return(0,M.$Oc)(Hi.registerFileSystemProvider(Oe,te,ge,Fe),Rt.addFileSystemProvider(te,ge,Fe))},get fs(){return Rt.value},registerFileSearchProvider:(te,ge)=>((0,Qe.$OF)(Oe,"fileSearchProvider"),Et.registerFileSearchProvider(te,ge)),registerTextSearchProvider:(te,ge)=>((0,Qe.$OF)(Oe,"textSearchProvider"),Et.registerTextSearchProvider(te,ge)),registerRemoteAuthorityResolver:(te,ge)=>((0,Qe.$OF)(Oe,"resolvers"),Dt.registerRemoteAuthorityResolver(te,ge)),registerResourceLabelFormatter:te=>((0,Qe.$OF)(Oe,"resolvers"),Ji.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Qe.$OF)(Oe,"resolvers"),Dt.getRemoteExecServer(te)),onDidCreateFiles:(te,ge,Fe)=>Yt.onDidCreateFile(te,ge,Fe),onDidDeleteFiles:(te,ge,Fe)=>Yt.onDidDeleteFile(te,ge,Fe),onDidRenameFiles:(te,ge,Fe)=>Yt.onDidRenameFile(te,ge,Fe),onWillCreateFiles:(te,ge,Fe)=>Yt.getOnWillCreateFileEvent(Oe)(te,ge,Fe),onWillDeleteFiles:(te,ge,Fe)=>Yt.getOnWillDeleteFileEvent(Oe)(te,ge,Fe),onWillRenameFiles:(te,ge,Fe)=>Yt.getOnWillRenameFileEvent(Oe)(te,ge,Fe),openTunnel:te=>((0,Qe.$OF)(Oe,"tunnels"),Me.openTunnel(Oe,te).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,Qe.$OF)(Oe,"tunnels"),Me.getTunnels()},onDidChangeTunnels:(te,ge,Fe)=>((0,Qe.$OF)(Oe,"tunnels"),Me.onDidChangeTunnels(te,ge,Fe)),registerPortAttributesProvider:(te,ge)=>((0,Qe.$OF)(Oe,"portsAttributes"),Me.registerPortsAttributesProvider(te,ge)),registerTunnelProvider:(te,ge)=>((0,Qe.$OF)(Oe,"tunnelFactory"),Me.registerTunnelProvider(te,ge)),registerTimelineProvider:(te,ge)=>((0,Qe.$OF)(Oe,"timeline"),Zi.registerTimelineProvider(te,ge,Oe.identifier,ut.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:te=>((0,Qe.$OF)(Oe,"workspaceTrust"),gt.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ge,Fe)=>gt.onDidGrantWorkspaceTrust(te,ge,Fe),registerEditSessionIdentityProvider:(te,ge)=>((0,Qe.$OF)(Oe,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(te,ge)),onWillCreateEditSessionIdentity:(te,ge,Fe)=>((0,Qe.$OF)(Oe,"editSessionIdentityProvider"),gt.getOnWillCreateEditSessionIdentityEvent(Oe)(te,ge,Fe)),registerCanonicalUriProvider:(te,ge)=>((0,Qe.$OF)(Oe,"canonicalUriProvider"),gt.registerCanonicalUriProvider(te,ge)),getCanonicalUri:(te,ge,Fe)=>((0,Qe.$OF)(Oe,"canonicalUriProvider"),gt.provideCanonicalUri(te,ge,Fe))},mn={get inputBox(){return ve.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),di.getLastInputBox(Oe)},createSourceControl(te,ge,Fe){return di.createSourceControl(Oe,te,ge,Fe)},registerSourceControlInputBoxValueProvider(te){return(0,Qe.$OF)(Oe,"scmInputBoxValueProvider"),di.registerSourceControlInputBoxValueProvider(Oe,te)}},cn={createCommentController(te,ge){return Ai.createCommentController(Oe,te,ge)}},un={get activeDebugSession(){return $t.activeDebugSession},get activeDebugConsole(){return $t.activeDebugConsole},get breakpoints(){return $t.breakpoints},get stackFrameFocus(){return $t.stackFrameFocus},onDidStartDebugSession(te,ge,Fe){return $t.onDidStartDebugSession(te,ge,Fe)},onDidTerminateDebugSession(te,ge,Fe){return $t.onDidTerminateDebugSession(te,ge,Fe)},onDidChangeActiveDebugSession(te,ge,Fe){return $t.onDidChangeActiveDebugSession(te,ge,Fe)},onDidReceiveDebugSessionCustomEvent(te,ge,Fe){return $t.onDidReceiveDebugSessionCustomEvent(te,ge,Fe)},onDidChangeBreakpoints(te,ge,Fe){return $t.onDidChangeBreakpoints(te,ge,Fe)},onDidChangeStackFrameFocus(te,ge,Fe){return(0,Qe.$OF)(Oe,"debugFocus"),$t.onDidChangeStackFrameFocus(te,ge,Fe)},registerDebugConfigurationProvider(te,ge,Fe){return $t.registerDebugConfigurationProvider(te,ge,Fe||kt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ge){return $t.registerDebugAdapterDescriptorFactory(Oe,te,ge)},registerDebugAdapterTrackerFactory(te,ge){return $t.registerDebugAdapterTrackerFactory(te,ge)},startDebugging(te,ge,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?$t.startDebugging(te,ge,{parentSession:Fe}):$t.startDebugging(te,ge,Fe||{})},stopDebugging(te){return $t.stopDebugging(te)},addBreakpoints(te){return $t.addBreakpoints(te)},removeBreakpoints(te){return $t.removeBreakpoints(te)},asDebugSourceUri(te,ge){return $t.asDebugSourceUri(te,ge)}},Ni={registerTaskProvider:(te,ge)=>yt.registerTaskProvider(Oe,te,ge),fetchTasks:te=>yt.fetchTasks(te),executeTask:te=>yt.executeTask(Oe,te),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(te,ge,Fe)=>yt.onDidStartTask(te,ge,Fe),onDidEndTask:(te,ge,Fe)=>yt.onDidEndTask(te,ge,Fe),onDidStartTaskProcess:(te,ge,Fe)=>yt.onDidStartTaskProcess(te,ge,Fe),onDidEndTaskProcess:(te,ge,Fe)=>yt.onDidEndTaskProcess(te,ge,Fe)},zi={createNotebookController(te,ge,Fe,ot,wt){return oi.createNotebookController(Oe,te,ge,Fe,ot,(0,Qe.$NF)(Oe,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(te,ge)=>It.registerNotebookCellStatusBarItemProvider(Oe,te,ge),createRendererMessaging(te){return Si.createRendererMessaging(Oe,te)},createNotebookControllerDetectionTask(te){return(0,Qe.$OF)(Oe,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Oe,te)},registerKernelSourceActionProvider(te,ge){return(0,Qe.$OF)(Oe,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Oe,te,ge)},onDidChangeNotebookCellExecutionState(te,ge,Fe){return(0,Qe.$OF)(Oe,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(te,ge,Fe)}},Bi={t(...te){if(typeof te[0]=="string"){const ge=te.shift(),Fe=!te||typeof te[0]!="object"?te:te[0];return qt.getMessage(Oe.identifier.value,{message:ge,args:Fe})}return qt.getMessage(Oe.identifier.value,te[0])},get bundle(){return qt.getBundle(Oe.identifier.value)},get uri(){return qt.getBundleUri(Oe.identifier.value)}},hi={_version:1,registerInteractiveEditorSessionProvider(te,ge){return(0,Qe.$OF)(Oe,"interactive"),Qi.registerProvider(Oe,te,ge)},registerInteractiveSessionProvider(te,ge){return(0,Qe.$OF)(Oe,"interactive"),gi.registerChatProvider(Oe,te,ge)},sendInteractiveRequestToProvider(te,ge){return(0,Qe.$OF)(Oe,"interactive"),gi.sendInteractiveRequestToProvider(te,ge)},get onDidPerformUserAction(){return(0,Qe.$OF)(Oe,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(te,ge){return(0,Qe.$OF)(Oe,"interactive"),gi.transferChatSession(te,ge)}},ji={getRelatedInformation(te,ge){return(0,Qe.$OF)(Oe,"aiRelatedInformation"),xi.getRelatedInformation(Oe,te,ge)},registerRelatedInformationProvider(te,ge){return(0,Qe.$OF)(Oe,"aiRelatedInformation"),xi.registerRelatedInformationProvider(Oe,te,ge)},registerEmbeddingVectorProvider(te,ge){return(0,Qe.$OF)(Oe,"aiRelatedInformation"),Fi.registerEmbeddingVectorProvider(Oe,te,ge)}},Ui={registerChatResponseProvider(te,ge,Fe){return(0,Qe.$OF)(Oe,"chatProvider"),fi.registerProvider(Oe.identifier,te,ge,Fe)},requestChatAccess(te){return(0,Qe.$OF)(Oe,"chatRequestAccess"),fi.requestChatResponseProvider(Oe.identifier,te)},registerVariable(te,ge,Fe){return(0,Qe.$OF)(Oe,"chatVariables"),Yi.registerVariableResolver(Oe,te,ge,Fe)},registerMappedEditsProvider(te,ge){return(0,Qe.$OF)(Oe,"mappedEditsProvider"),lt.registerMappedEditsProvider(Oe,te,ge)},createChatAgent(te,ge){return(0,Qe.$OF)(Oe,"chatAgents2"),Xi.createChatAgent(Oe,te,ge)}},Wi={registerSpeechProvider(te,ge){return(0,Qe.$OF)(Oe,"speech"),bi.registerProvider(Oe.identifier,te,ge)}};return{version:ft.version,ai:ji,authentication:en,commands:gn,comments:cn,chat:Ui,debug:un,env:tn,extensions:rn,interactive:hi,l10n:Bi,languages:sn,notebooks:zi,scm:mn,speech:Wi,tasks:Ni,tests:nn,window:on,workspace:an,Breakpoint:Te.$zL,TerminalOutputAnchor:Te.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Te.ChatAgentResultFeedbackKind,ChatMessage:Te.$qM,ChatMessageRole:Te.ChatMessageRole,ChatVariableLevel:Te.ChatVariableLevel,CallHierarchyIncomingCall:Te.$YK,CallHierarchyItem:Te.$XK,CallHierarchyOutgoingCall:Te.$ZK,CancellationError:T.$4,CancellationTokenSource:E.$2d,CandidatePortSource:o.CandidatePortSource,CodeAction:Te.$UK,CodeActionKind:Te.$VK,CodeActionTriggerKind:Te.CodeActionTriggerKind,CodeLens:Te.$1K,Color:Te.$bL,ColorInformation:Te.$cL,ColorPresentation:Te.$dL,ColorThemeKind:Te.ColorThemeKind,CommentMode:Te.CommentMode,CommentState:Te.CommentState,CommentThreadCollapsibleState:Te.CommentThreadCollapsibleState,CommentThreadState:Te.CommentThreadState,CompletionItem:Te.$8K,CompletionItemKind:Te.CompletionItemKind,CompletionItemTag:Te.CompletionItemTag,CompletionList:Te.$9K,CompletionTriggerKind:Te.CompletionTriggerKind,ConfigurationTarget:Te.ConfigurationTarget,CustomExecution:Te.$lL,DebugAdapterExecutable:Te.$DL,DebugAdapterInlineImplementation:Te.$GL,DebugAdapterNamedPipeServer:Te.$FL,DebugAdapterServer:Te.$EL,DebugConfigurationProviderTriggerKind:kt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Te.DebugConsoleMode,DecorationRangeBehavior:Te.DecorationRangeBehavior,Diagnostic:Te.$PK,DiagnosticRelatedInformation:Te.$OK,DiagnosticSeverity:Te.DiagnosticSeverity,DiagnosticTag:Te.DiagnosticTag,Disposable:Te.$BK,DocumentHighlight:Te.$RK,DocumentHighlightKind:Te.DocumentHighlightKind,DocumentLink:Te.$aL,DocumentSymbol:Te.$TK,EndOfLine:Te.EndOfLine,EnvironmentVariableMutatorType:Te.EnvironmentVariableMutatorType,EvaluatableExpression:Te.$JL,InlineValueText:Te.$KL,InlineValueVariableLookup:Te.$LL,InlineValueEvaluatableExpression:Te.$ML,InlineCompletionTriggerKind:Te.InlineCompletionTriggerKind,EventEmitter:C.$Rd,ExtensionKind:Te.ExtensionKind,ExtensionMode:Te.ExtensionMode,ExternalUriOpenerPriority:Te.ExternalUriOpenerPriority,FileChangeType:Te.FileChangeType,FileDecoration:Te.$WL,FileDecoration2:Te.$WL,FileSystemError:Te.$OL,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:Te.$PL,FoldingRangeKind:Te.FoldingRangeKind,FunctionBreakpoint:Te.$BL,InlineCompletionItem:Te.$0K,InlineCompletionList:Te.$$K,Hover:Te.$QK,IndentAction:S.IndentAction,Location:Te.$NK,MarkdownString:Te.$2K,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Te.$3K,PortAutoForwardAction:Te.PortAutoForwardAction,Position:Te.$CK,ProcessExecution:Te.$jL,ProgressLocation:Te.ProgressLocation,QuickInputButtons:Te.$VL,Range:Te.$DK,RelativePattern:Te.$xL,Selection:Te.$EK,SelectionRange:Te.$WK,SemanticTokens:Te.$SL,SemanticTokensBuilder:Te.$RL,SemanticTokensEdit:Te.$TL,SemanticTokensEdits:Te.$UL,SemanticTokensLegend:Te.$QL,ShellExecution:Te.$kL,ShellQuoting:Te.ShellQuoting,SignatureHelp:Te.$5K,SignatureHelpTriggerKind:Te.SignatureHelpTriggerKind,SignatureInformation:Te.$4K,SnippetString:Te.$MK,SourceBreakpoint:Te.$AL,StandardTokenType:Te.StandardTokenType,StatusBarAlignment:Te.StatusBarAlignment,SymbolInformation:Te.$SK,SymbolKind:Te.SymbolKind,SymbolTag:Te.SymbolTag,Task:Te.$mL,TaskGroup:Te.$iL,TaskPanelKind:Te.TaskPanelKind,TaskRevealKind:Te.TaskRevealKind,TaskScope:Te.TaskScope,TerminalLink:Te.$eL,TerminalQuickFixExecuteTerminalCommand:Te.$gL,TerminalQuickFixOpener:Te.$fL,TerminalLocation:Te.TerminalLocation,TerminalProfile:Te.$hL,TerminalExitReason:Te.TerminalExitReason,TextDocumentSaveReason:Te.TextDocumentSaveReason,TextEdit:Te.$IK,SnippetTextEdit:Te.$KK,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Te.TextEditorLineNumbersStyle,TextEditorRevealType:Te.TextEditorRevealType,TextEditorSelectionChangeKind:Te.TextEditorSelectionChangeKind,SyntaxTokenType:Te.SyntaxTokenType,TextDocumentChangeReason:Te.TextDocumentChangeReason,ThemeColor:Te.$wL,ThemeIcon:Te.$vL,TreeItem:Te.$nL,TreeItemCheckboxState:Te.TreeItemCheckboxState,TreeItemCollapsibleState:Te.TreeItemCollapsibleState,TypeHierarchyItem:Te.$fM,UIKind:Tt.UIKind,Uri:m.URI,ViewColumn:Te.ViewColumn,WorkspaceEdit:Te.$LK,DocumentDropEdit:Te.$tL,DocumentPasteEdit:Te.$uL,InlayHint:Te.$7K,InlayHintLabelPart:Te.$6K,InlayHintKind:Te.InlayHintKind,RemoteAuthorityResolverError:Te.$HK,ResolvedAuthority:Te.$FK,ManagedResolvedAuthority:Te.$GK,SourceControlInputBoxValidationType:Te.SourceControlInputBoxValidationType,ExtensionRuntime:Te.ExtensionRuntime,TimelineItem:Te.$7L,NotebookRange:Te.$YL,NotebookCellKind:Te.NotebookCellKind,NotebookCellExecutionState:Te.NotebookCellExecutionState,NotebookCellData:Te.$ZL,NotebookData:Te.$1L,NotebookRendererScript:Te.$5L,NotebookCellStatusBarAlignment:Te.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Te.NotebookEditorRevealType,NotebookCellOutput:Te.$3L,NotebookCellOutputItem:Te.$2L,NotebookCellStatusBarItem:Te.$4L,NotebookControllerAffinity:Te.NotebookControllerAffinity,NotebookControllerAffinity2:Te.NotebookControllerAffinity2,NotebookEdit:Te.$JK,NotebookKernelSourceAction:Te.$6L,NotebookVariablesRequestKind:Te.NotebookVariablesRequestKind,PortAttributes:Te.$9L,LinkedEditingRanges:Te.$8L,TestResultState:Te.TestResultState,TestRunRequest:Te.$0L,TestMessage:Te.$$L,TestMessage2:Te.$$L,TestTag:Te.$_L,TestRunProfileKind:Te.TestRunProfileKind,TextSearchCompleteMessageType:Jt.TextSearchCompleteMessageType,DataTransfer:Te.$sL,DataTransferItem:Te.$oL,CoveredCount:Te.$aM,FileCoverage:Te.$bM,StatementCoverage:Te.$cM,BranchCoverage:Te.$dM,FunctionCoverage:Te.$eM,WorkspaceTrustState:Te.WorkspaceTrustState,LanguageStatusSeverity:Te.LanguageStatusSeverity,QuickPickItemKind:Te.QuickPickItemKind,InputBoxValidationSeverity:Te.InputBoxValidationSeverity,TabInputText:Te.$gM,TabInputTextDiff:Te.$hM,TabInputTextMerge:Te.$iM,TabInputCustom:Te.$jM,TabInputNotebook:Te.$lM,TabInputNotebookDiff:Te.$mM,TabInputWebview:Te.$kM,TabInputTerminal:Te.$nM,TabInputInteractiveWindow:Te.$oM,TabInputChat:Te.$pM,TelemetryTrustedValue:t.$ro,LogLevel:a.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Te.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Te.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Te.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Te.$HL,ThreadFocus:Te.$IL,RelatedInformationType:Te.RelatedInformationType,SpeechToTextStatus:Te.SpeechToTextStatus}}}e.$_fc=Wt}),define(Ae[290],Re([1,0,70,111,36,109,37,32,61,64,114,116,117,85,87,81,110,63,42,84,59,62,255,15,115,82,83]),function(we,e,E,T,C,M,P,$,m,y,A,S,l,p,w,a,s,t,n,o,c,d,i,r,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Er)(f.$1ec,f.$Zec,1),(0,E.$Er)(r.$gj,i.$agc,1),(0,E.$Er)(a.$_dc,a.$aec,1),(0,E.$Er)($.$XM,$.$WM,0),(0,E.$Er)(P.$uec,P.$sec,0),(0,E.$Er)(t.$wec,t.$vec,0),(0,E.$Er)(S.$$ec,S.$cfc,0),(0,E.$Er)(M.$efc,M.$dfc,0),(0,E.$Er)(m.$MM,m.$LM,0),(0,E.$Er)(v.$2ec,v.$3ec,0),(0,E.$Er)(n.$9dc,n.$8dc,0),(0,E.$Er)(T.$Kfc,T.$Jfc,1),(0,E.$Er)(l.$ufc,l.$vfc,0),(0,E.$Er)(p.$Pec,p.$Oec,0),(0,E.$Er)(A.$Xfc,A.$Wfc,0),(0,E.$Er)(y.$Sec,y.$Vec,0),(0,E.$Er)(w.$bxb,w.$cxb,0),(0,E.$Er)(s.$$fc,s.$0fc,0),(0,E.$Er)(C.$rec,C.$qec,0),(0,E.$Er)(o.$Xec,o.$Wec,0),(0,E.$Er)(c.$VM,c.$SM,0),(0,E.$Er)(d.$Gec,d.$Hec,0),(0,E.$Er)(u.$9ec,u.$0ec,0)}),define(Ae[291],Re([1,0,289,38,2,286,7,14,274]),function(we,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=void 0;class y extends M.$dgc{j(){}getModule(p,w){for(const a of this.b){const s=a(p);if(s){p=s;break}}if(this.a.has(p))return this.a.get(p).load(p,w,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends T.$5ec{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(m.$jic);const p=this.h.invokeFunction(E.$_fc);this.r=this.h.createInstance(y,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,w,a){w=w.with({path:S(w.path,".js")});const s=p?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const t=C.URI.revive(await this.C.$asBrowserUri(w)),n=await fetch(t.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),n.status!==200)throw new Error(n.statusText);const o=await n.text(),c=`${w.toString(!0)}#vscode-extension`,d=`${o}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",d)}catch(v){throw console.error(s?`Loading code for extension ${s} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${w.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}p&&await this.w.initializeLocalizedMessages(p);const r={},u={exports:r},f=v=>{const g=this.r.getModule(v,w);if(g===void 0)throw new Error(`Cannot load module '${v}'`);return g};try{return a.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),i(u,r,f),u.exports!==r?u.exports:r}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),a.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const w=Date.now()+p;for(;Date.now()<w&&!("__jsDebugIsReady"in globalThis);)await(0,$.$1g)(10)}}e.$kic=A;function S(l,p){return l.endsWith(p)?l:l+p}}),define(Ae[292],Re([1,0,69,70,15,38,199,86,291]),function(we,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$Er)(C.$fj,new E.$Uh(P.$cgc,[!0],!0)),(0,T.$Er)(M.$6ec,m.$kic,0),(0,T.$Er)($.$xec,$.$yec,0)}),define(Ae[298],Re([1,0,24,5,79,287,276,20,88,13,2,290,292]),function(we,e,E,T,C,M,P,$,m,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(i){return/^(file|vscode-remote):/i.test(i)}const w=fetch.bind(self);function a(i){self.fetch=async function(r,u){return r instanceof Request||p(String(r))&&(r=(await i(A.URI.parse(String(r)))).toString(!0)),w(r,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,u,f,v,g){(async()=>(p(u.toString())&&(u=(await i(A.URI.parse(u.toString()))).toString(!0)),super.open(r,u,f??!0,v,g)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(r,u){if(/^file:/i.test(r.toString()))r=y.$ig.uriToBrowserUri(A.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const v=`(${function(h){function b(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const k=fetch.bind(self);self.fetch=function(W,J){return W instanceof Request?k(W,J):k(b(W),J)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,J,N,R,L){return super.open(W,b(J),N??!0,R,L)}};const F=importScripts.bind(self);self.importScripts=(...W)=>{F(...W.map(b))},F(h)}.toString()}('${r}'))`;u=u||{},u.name=u.name||$.$mc(r.toString());const g=new Blob([v],{type:"application/javascript"}),D=URL.createObjectURL(g);return new i(D,u)}}else self.Worker=class extends P.$lic{constructor(i,r){super(l,i,{name:$.$mc(i.toString()),...r})}};const s=new class{constructor(){this.pid=void 0}exit(i){S()}};class t{constructor(){const r=new MessageChannel,u=new T.$Rd;let f=!1;l(r.port2,[r.port2]),r.port1.onmessage=v=>{const{data:g}=v;if(!(g instanceof ArrayBuffer)){console.warn("UNKNOWN data received",g);return}const D=E.$fe.wrap(new Uint8Array(g,0,g.byteLength));if((0,C.$km)(D,2)){f=!0,o("received terminate message from renderer");return}u.fire(D)},this.protocol={onMessage:u.event,send:v=>{if(!f){const g=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);r.port1.postMessage(g,[g])}}}}}function n(i){return new Promise(r=>{const u=i.onMessage(f=>{u.dispose();const v=JSON.parse(f.toString());i.send((0,C.$jm)(0)),r({protocol:i,initData:v})});i.send((0,C.$jm)(1))})}let o=i=>S();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function d(){m.mark("code/extHost/willConnectToRenderer");const i=new t;return{onmessage(r){c(r)&&n(i.protocol).then(u=>{m.mark("code/extHost/didWaitForInitData");const f=new M.$fgc(u.protocol,u.initData,s,null,r.data);a(v=>f.asBrowserUri(v)),o=v=>f.terminate(v)})}}}e.create=d})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/da5ab29656a9f0bef63602fbce10968a7f4db2b5/core/vs/workbench/api/worker/extensionHostWorker.js.map
