/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var V=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],_=function(K){for(var e=[],L=0,T=K.length;L<T;L++)e[L]=V[K[L]];return e};define(V[22],_([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class L{static get(){const y=new Map,P=new Map,s=new Map,d=new Map;function t(a,i){a.has(i.detail)||a.set(i.detail,-i.timestamp)}function o(a,i){const n=a.get(i.detail);n&&(n>=0||a.set(i.detail,n+i.timestamp))}let g=[];typeof K=="function"&&typeof K.getStats=="function"&&(g=K.getStats().slice(0).sort((a,i)=>a.timestamp-i.timestamp));for(const a of g)switch(a.type){case 10:t(y,a);break;case 11:case 12:o(y,a);break;case 21:t(P,a);break;case 22:o(P,a);break;case 33:t(s,a);break;case 34:o(s,a);break;case 31:t(d,a);break;case 32:o(d,a);break}let c=0;s.forEach(a=>c+=a);function h(a){const i=[];return a.forEach((n,r)=>i.push([r,n])),i}return{amdLoad:h(y),amdInvoke:h(P),nodeRequire:h(s),nodeEval:h(d),nodeRequireTotal:c}}static toMarkdownTable(y,P){let s="";const d=[];return y.forEach((t,o)=>{d[o]=t.length}),P.forEach(t=>{t.forEach((o,g)=>{typeof o>"u"&&(o=t[g]="-");const c=o.toString().length;d[g]=Math.max(c,d[g])})}),y.forEach((t,o)=>{s+=`| ${t+" ".repeat(d[o]-t.toString().length)} `}),s+=`|
`,y.forEach((t,o)=>{s+=`| ${"-".repeat(d[o])} `}),s+=`|
`,P.forEach(t=>{t.forEach((o,g)=>{typeof o<"u"&&(s+=`| ${o+" ".repeat(d[g]-o.toString().length)} `)}),s+=`|
`}),s}}e.$T=L}),define(V[4],_([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rd=e.$qd=e.$pd=void 0;let L;function T(n){L=n}e.$pd=T;function y(){return L}e.$qd=y;class P{constructor(){this.a=0,this.d=new WeakMap}b(r){return s([d(a("|  ",this.a)),r])}c(r){return r.hadValue?r.didChange?[d(" "),o(g(r.oldValue,70),{color:"red",strikeThrough:!0}),d(" "),o(g(r.newValue,60),{color:"green"})]:[d(" (unchanged)")]:[d(" "),o(g(r.newValue,60),{color:"green"}),d(" (initial)")]}handleObservableChanged(r,b){console.log(...this.b([t("observable value changed"),o(r.debugName,{color:"BlueViolet"}),...this.c(b)]))}formatChanges(r){if(r.size!==0)return o(" (changed deps: "+[...r].map(b=>b.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const b=r.handleChange;this.d.set(r,new Set),r.handleChange=(O,j)=>(this.d.get(r).add(O),b.apply(r,[O,j]))}handleDerivedRecomputed(r,b){const O=this.d.get(r);console.log(...this.b([t("derived recomputed"),o(r.debugName,{color:"BlueViolet"}),...this.c(b),this.formatChanges(O),{data:[{fn:r._computeFn}]}])),O.clear()}handleFromEventObservableTriggered(r,b){console.log(...this.b([t("observable from event triggered"),o(r.debugName,{color:"BlueViolet"}),...this.c(b),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const b=r.handleChange;this.d.set(r,new Set),r.handleChange=(O,j)=>(this.d.get(r).add(O),b.apply(r,[O,j]))}handleAutorunTriggered(r){const b=this.d.get(r);console.log(...this.b([t("autorun"),o(r.debugName,{color:"BlueViolet"}),this.formatChanges(b),{data:[{fn:r._runFn}]}])),b.clear(),this.a++}handleAutorunFinished(r){this.a--}handleBeginTransaction(r){let b=r.getDebugName();b===void 0&&(b=""),console.log(...this.b([t("transaction"),o(b,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$rd=P;function s(n){const r=new Array,b=[];let O="";function j(A){if("length"in A)for(const f of A)f&&j(f);else"text"in A?(O+=`%c${A.text}`,r.push(A.style),A.data&&b.push(...A.data)):"data"in A&&b.push(...A.data)}j(n);const N=[O,...r];return N.push(...b),N}function d(n){return o(n,{color:"black"})}function t(n){return o(i(`${n}: `,10),{color:"black",bold:!0})}function o(n,r={color:"black"}){function b(j){return Object.entries(j).reduce((N,[A,f])=>`${N}${A}:${f};`,"")}const O={color:r.color};return r.strikeThrough&&(O["text-decoration"]="line-through"),r.bold&&(O["font-weight"]="bold"),{text:n,style:b(O)}}function g(n,r){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=r?`"${n}"`:`"${n.substr(0,r-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?c(n,r):h(n,r);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function c(n,r){let b="[ ",O=!0;for(const j of n){if(O||(b+=", "),b.length-5>r){b+="...";break}O=!1,b+=`${g(j,r-b.length)}`}return b+=" ]",b}function h(n,r){let b="{ ",O=!0;for(const[j,N]of Object.entries(n)){if(O||(b+=", "),b.length-5>r){b+="...";break}O=!1,b+=`${j}: ${g(N,r-b.length)}`}return b+=" }",b}function a(n,r){let b="";for(let O=1;O<=r;O++)b+=n;return b}function i(n,r){for(;n.length<r;)n+=" ";return n}}),define(V[5],_([0,1,4]),function(K,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=void 0;let T;function y(m){T=m}e.$yd=y;let P;function s(m){P=m}e.$zd=s;class d{get TChange(){return null}reportChanges(){this.get()}read(E){return E?E.readObservable(this):this.get()}map(E,B){const S=B===void 0?void 0:E,l=B===void 0?E:B;return P({owner:S,debugName:()=>{const M=k(l);if(M!==void 0)return M;const z=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(l.toString());if(z)return`${this.debugName}.${z[2]}`;if(!S)return`${this.debugName} (mapped)`}},M=>l(this.read(M),M))}recomputeInitiallyAndOnChange(E,B){return E.add(T(this,B)),this}}e.$Ad=d;class t extends d{constructor(){super(...arguments),this.c=new Set}addObserver(E){const B=this.c.size;this.c.add(E),B===0&&this.f()}removeObserver(E){this.c.delete(E)&&this.c.size===0&&this.g()}f(){}g(){}}e.$Bd=t;function o(m,E){const B=new i(m,E);try{m(B)}finally{B.finish()}}e.$Cd=o;let g;function c(m){if(g)m(g);else{const E=new i(m,void 0);g=E;try{m(E)}finally{E.finish(),g=void 0}}}e.$Dd=c;async function h(m,E){const B=new i(m,E);try{await m(B)}finally{B.finish()}}e.$Ed=h;function a(m,E,B){m?E(m):o(E,B)}e.$Fd=a;class i{constructor(E,B){this._fn=E,this.b=B,this.a=[],(0,L.$qd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():k(this._fn)}updateObserver(E,B){this.a.push({observer:E,observable:B}),E.beginUpdate(B)}finish(){const E=this.a;for(let B=0;B<E.length;B++){const{observer:S,observable:l}=E[B];S.endUpdate(l)}this.a=null,(0,L.$qd)()?.handleEndTransaction()}}e.$Gd=i;const n=new Map,r=new WeakMap;function b(m,E,B,S,l){const M=r.get(m);if(M)return M;const D=O(m,E,B,S,l);if(D){let z=n.get(D)??0;z++,n.set(D,z);const W=z===1?D:`${D}#${z}`;return r.set(m,W),W}}e.$Hd=b;function O(m,E,B,S,l){const M=r.get(m);if(M)return M;const D=S?A(S)+".":"";let z;if(E!==void 0)if(typeof E=="function"){if(z=E(),z!==void 0)return D+z}else return D+E;if(B!==void 0&&(z=k(B),z!==void 0))return D+z;if(S!==void 0){for(const W in S)if(S[W]===l)return D+W}}const j=new Map,N=new WeakMap;function A(m){const E=N.get(m);if(E)return E;const B=f(m);let S=j.get(B)??0;S++,j.set(B,S);const l=S===1?B:`${B}#${S}`;return N.set(m,l),l}function f(m){const E=m.constructor;return E?E.name:"Object"}function k(m){const E=m.toString(),S=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(E);return(S?S[1]:void 0)?.trim()}e.$Id=k;function w(m,E){return typeof m=="string"?new I(void 0,m,E):new I(m,void 0,E)}e.$Jd=w;class I extends t{get debugName(){return b(this,this.d,void 0,this.b,this)??"ObservableValue"}constructor(E,B,S){super(),this.b=E,this.d=B,this.a=S}get(){return this.a}set(E,B,S){if(this.a===E)return;let l;B||(B=l=new i(()=>{},()=>`Setting ${this.debugName}`));try{const M=this.a;this.e(E),(0,L.$qd)()?.handleObservableChanged(this,{oldValue:M,newValue:E,change:S,didChange:!0,hadValue:!0});for(const D of this.c)B.updateObserver(D,this),D.handleChange(this,S)}finally{l&&l.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(E){this.a=E}}e.$Kd=I;function U(m,E){return typeof m=="string"?new $(void 0,m,E):new $(m,void 0,E)}e.$Ld=U;class $ extends I{e(E){this.a!==E&&(this.a&&this.a.dispose(),this.a=E)}dispose(){this.a?.dispose()}}e.$Md=$}),define(V[9],_([0,1,42,2,5,4]),function(K,e,L,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=void 0;function s(i){return new h(void 0,i,void 0,void 0)}e.$8c=s;function d(i,n){return new h(i.debugName,n,void 0,void 0)}e.$9c=d;function t(i,n){return new h(i.debugName,n,i.createEmptyChangeSummary,i.handleChange)}e.$0c=t;function o(i,n){const r=new T.$Qc,b=t({debugName:i.debugName??(()=>(0,y.$Id)(n)),createEmptyChangeSummary:i.createEmptyChangeSummary,handleChange:i.handleChange},(O,j)=>{r.clear(),n(O,j,r)});return(0,T.$Pc)(()=>{b.dispose(),r.dispose()})}e.$$c=o;function g(i){const n=new T.$Qc,r=d({debugName:()=>(0,y.$Id)(i)||"(anonymous)"},b=>{n.clear(),i(b,n)});return(0,T.$Pc)(()=>{r.dispose(),n.dispose()})}e.$_c=g;var c;(function(i){i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(c||(c={}));class h{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const r=this.h();if(r!==void 0)return r}const n=(0,y.$Id)(this._runFn);return n!==void 0?n:"(anonymous)"}constructor(n,r,b,O){this.h=n,this._runFn=r,this.i=b,this.j=O,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,P.$qd)()?.handleAutorunCreated(this),this.k(),(0,T.$Ic)(this)}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear(),(0,T.$Jc)(this)}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3;const r=this.c;try{if(!r){(0,P.$qd)()?.handleAutorunTriggered(this);const b=this.g;this.g=this.i?.(),this._runFn(this,b)}}finally{r||(0,P.$qd)()?.handleAutorunFinished(this);for(const b of this.f)b.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,L.$6c)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,r){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:r,didChange:O=>O===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const r=n.get();return this.e.add(n),this.f.delete(n),r}}e.$ad=h,function(i){i.Observer=h}(s||(e.$8c=s={}));function a(i,n){let r;return d({debugName:()=>(0,y.$Id)(n)},b=>{const O=i.read(b),j=r;r=O,n({lastValue:j,newValue:O})})}e.$bd=a}),define(V[10],_([0,1,6,2,5,4]),function(K,e,L,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=void 0;const s=(i,n)=>i===n;function d(i,n){return n!==void 0?new a(i,void 0,n,void 0,void 0,void 0,s):new a(void 0,void 0,i,void 0,void 0,void 0,s)}e.$sd=d;function t(i,n){return new a(i.owner,i.debugName,n,void 0,void 0,void 0,i.equalityComparer??s)}e.$td=t;function o(i,n){return new a(i.owner,i.debugName,n,i.createEmptyChangeSummary,i.handleChange,void 0,i.equalityComparer??s)}e.$ud=o;function g(i,n){let r,b;n===void 0?(r=i,b=void 0):(b=i,r=n);const O=new T.$Qc;return new a(b,()=>(0,y.$Id)(r)??"(anonymous)",j=>(O.clear(),r(j,O)),void 0,void 0,()=>O.dispose(),s)}e.$vd=g;function c(i,n){let r,b;n===void 0?(r=i,b=void 0):(b=i,r=n);const O=new T.$Qc;return new a(b,()=>(0,y.$Id)(r)??"(anonymous)",j=>{O.clear();const N=r(j);return N&&O.add(N),N},void 0,void 0,()=>O.dispose(),s)}e.$wd=c,(0,y.$zd)(t);var h;(function(i){i[i.initial=0]="initial",i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(h||(h={}));class a extends y.$Bd{get debugName(){return(0,y.$Hd)(this,this.p,this._computeFn,this.n,this)??"(anonymous)"}constructor(n,r,b,O,j,N=void 0,A){super(),this.n=n,this.p=r,this._computeFn=b,this.q=O,this.s=j,this.t=N,this.u=A,this.e=0,this.h=void 0,this.j=0,this.k=new Set,this.l=new Set,this.m=void 0,this.m=this.q?.(),(0,P.$qd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.k)n.removeObserver(this);this.k.clear(),this.t?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.q?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.k)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.w()}while(this.e!==3);return this.h}}w(){if(this.e===3)return;const n=this.l;this.l=this.k,this.k=n;const r=this.e!==0,b=this.h;this.e=3;const O=this.m;this.m=this.q?.();try{this.h=this._computeFn(this,O)}finally{for(const N of this.l)N.removeObserver(this);this.l.clear()}const j=r&&!this.u(b,this.h);if((0,P.$qd)()?.handleDerivedRecomputed(this,{oldValue:b,newValue:this.h,change:void 0,didChange:j,hadValue:r}),j)for(const N of this.c)N.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.j++;const r=this.j===1;if(this.e===3&&(this.e=1,!r))for(const b of this.c)b.handlePossibleChange(this);if(r)for(const b of this.c)b.beginUpdate(this)}endUpdate(n){if(this.j--,this.j===0){const r=[...this.c];for(const b of r)b.endUpdate(this)}if(this.j<0)throw new L.$bb}handlePossibleChange(n){if(this.e===3&&this.k.has(n)&&!this.l.has(n)){this.e=1;for(const r of this.c)r.handlePossibleChange(this)}}handleChange(n,r){if(this.k.has(n)&&!this.l.has(n)){const b=this.s?this.s({changedObservable:n,change:r,didChange:j=>j===n},this.m):!0,O=this.e===3;if(b&&(this.e===1||O)&&(this.e=2,O))for(const j of this.c)j.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const r=n.get();return this.k.add(n),this.l.delete(n),r}addObserver(n){const r=!this.c.has(n)&&this.j>0;super.addObserver(n),r&&n.beginUpdate(this)}removeObserver(n){const r=this.c.has(n)&&this.j>0;super.removeObserver(n),r&&n.endUpdate(this)}}e.$xd=a}),define(V[23],_([0,1,2,9,5,10,4]),function(K,e,L,T,y,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=void 0;function d(w){return new t(w)}e.$cd=d;class t extends y.$Ad{constructor(I){super(),this.a=I}get debugName(){return this.toString()}get(){return this.a}addObserver(I){}removeObserver(I){}toString(){return`Const: ${this.a}`}}function o(w){const I=(0,y.$Jd)("promiseValue",{});return w.then(U=>{I.set({value:U},void 0)}),I}e.$dd=o;function g(w,I){return new Promise(U=>{let $=!1,m=!1;const E=w.map(S=>({isFinished:I(S),state:S})),B=(0,T.$8c)(S=>{const{isFinished:l,state:M}=E.read(S);l&&($?B.dispose():m=!0,U(M))});$=!0,m&&B.dispose()})}e.$ed=g;function c(w,I){return new h(w,I)}e.$fd=c;class h extends y.$Bd{constructor(I,U){super(),this.h=I,this._getValue=U,this.b=!1,this.l=$=>{const m=this._getValue($),E=this.a,B=!this.b||E!==m;let S=!1;B&&(this.a=m,this.b&&(S=!0,(0,y.$Fd)(h.globalTransaction,l=>{(0,s.$qd)()?.handleFromEventObservableTriggered(this,{oldValue:E,newValue:m,change:void 0,didChange:B,hadValue:this.b});for(const M of this.c)l.updateObserver(M,this),M.handleChange(this,void 0)},()=>{const l=this.j();return"Event fired"+(l?`: ${l}`:"")})),this.b=!0),S||(0,s.$qd)()?.handleFromEventObservableTriggered(this,{oldValue:E,newValue:m,change:void 0,didChange:B,hadValue:this.b})}}j(){return(0,y.$Id)(this._getValue)}get debugName(){const I=this.j();return"From Event"+(I?`: ${I}`:"")}f(){this.e=this.h(this.l)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.l(void 0),this.a):this._getValue(void 0)}}e.$gd=h,function(w){w.Observer=h;function I(U,$){let m=!1;h.globalTransaction===void 0&&(h.globalTransaction=U,m=!0);try{$()}finally{m&&(h.globalTransaction=void 0)}}w.batchEventsGlobally=I}(c||(e.$fd=c={}));function a(w,I){return new i(w,I)}e.$hd=a;class i extends y.$Bd{constructor(I,U){super(),this.debugName=I,this.b=U,this.h=()=>{(0,y.$Cd)($=>{for(const m of this.c)$.updateObserver(m,this),m.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function n(w){return typeof w=="string"?new r(w):new r(void 0,w)}e.$id=n;class r extends y.$Bd{get debugName(){return(0,y.$Hd)(this,this.a,void 0,this.b,this)??"Observable Signal"}constructor(I,U){super(),this.a=I,this.b=U}trigger(I,U){if(!I){(0,y.$Cd)($=>{this.trigger($,U)},()=>`Trigger signal ${this.debugName}`);return}for(const $ of this.c)I.updateObserver($,this),$.handleChange(this,U)}get(){}}function b(w,I,U){const $=(0,y.$Jd)("debounced",void 0);let m;return U.add((0,T.$8c)(E=>{const B=w.read(E);m&&clearTimeout(m),m=setTimeout(()=>{(0,y.$Cd)(S=>{$.set(B,S)})},I)})),$}e.$jd=b;function O(w,I,U){const $=(0,y.$Jd)("triggeredRecently",!1);let m;return U.add(w(()=>{$.set(!0,void 0),m&&clearTimeout(m),m=setTimeout(()=>{$.set(!1,void 0)},I)})),$}e.$kd=O;function j(w){const I=new A(!1,void 0);return w.addObserver(I),(0,L.$Pc)(()=>{w.removeObserver(I)})}e.$ld=j;function N(w,I){const U=new A(!0,I);return w.addObserver(U),I?I(w.get()):w.reportChanges(),(0,L.$Pc)(()=>{w.removeObserver(U)})}e.$md=N,(0,y.$yd)(N);class A{constructor(I,U){this.b=I,this.c=U,this.a=0}beginUpdate(I){this.a++}endUpdate(I){this.a--,this.a===0&&this.b&&(this.c?this.c(I.get()):I.reportChanges())}handlePossibleChange(I){}handleChange(I,U){}}function f(w){let I;return(0,P.$sd)($=>(I=w($,I),I))}e.$nd=f;function k(w,I){let U;const $=(0,y.$Jd)("derivedObservableWithWritableCache.counter",0),m=(0,P.$sd)(w,E=>($.read(E),U=I(E,U),U));return Object.assign(m,{clearCache:E=>{U=void 0,$.set($.get()+1,E)}})}e.$od=k}),define(V[11],_([0,1,5,10,9,23,4]),function(K,e,L,T,y,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return L.$Jd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return L.$Ld}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return L.$Cd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return L.$Fd}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return T.$sd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return T.$td}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return T.$ud}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return T.$vd}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return y.$8c}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return y.$bd}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return y.$0c}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return y.$_c}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return y.$9c}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return y.$$c}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return P.$cd}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return P.$jd}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return P.$nd}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return P.$od}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return P.$ld}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return P.$md}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return P.$fd}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return P.$dd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return P.$id}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return P.$hd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return P.$ed}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return P.$kd}}),!1&&(0,s.$pd)(new s.$rd)}),define(V[24],_([0,1,6,2]),function(K,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function y(N){const A=N;return A?typeof A.read=="function":!1}e.$3d=y;function P(N){const A=N;return A?[A.on,A.pause,A.resume,A.destroy].every(f=>typeof f=="function"):!1}e.$4d=P;function s(N){const A=N;return A?P(A.stream)&&Array.isArray(A.buffer)&&typeof A.ended=="boolean":!1}e.$5d=s;function d(N,A){return new t(N,A)}e.$6d=d;class t{constructor(A,f){this.e=A,this.f=f,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(A){if(!this.a.destroyed){if(this.a.flowing)this.g(A);else if(this.b.data.push(A),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(f=>this.d.push(f))}}error(A){this.a.destroyed||(this.a.flowing?this.h(A):this.b.error.push(A))}end(A){this.a.destroyed||(typeof A<"u"&&this.write(A),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(A){this.c.data.slice(0).forEach(f=>f(A))}h(A){this.c.error.length===0?(0,L.$Z)(A):this.c.error.slice(0).forEach(f=>f(A))}i(){this.c.end.slice(0).forEach(A=>A())}on(A,f){if(!this.a.destroyed)switch(A){case"data":this.c.data.push(f),this.resume();break;case"end":this.c.end.push(f),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(f),this.a.flowing&&this.k();break}}removeListener(A,f){if(this.a.destroyed)return;let k;switch(A){case"data":k=this.c.data;break;case"end":k=this.c.end;break;case"error":k=this.c.error;break}if(k){const w=k.indexOf(f);w>=0&&k.splice(w,1)}}j(){if(this.b.data.length>0){const A=this.e(this.b.data);this.g(A),this.b.data.length=0;const f=[...this.d];this.d.length=0,f.forEach(k=>k())}}k(){if(this.c.error.length>0){for(const A of this.b.error)this.h(A);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function o(N,A){const f=[];let k;for(;(k=N.read())!==null;)f.push(k);return A(f)}e.$7d=o;function g(N,A,f){const k=[];let w;for(;(w=N.read())!==null&&k.length<f;)k.push(w);return w===null&&k.length>0?A(k):{read:()=>{if(k.length>0)return k.shift();if(typeof w<"u"){const I=w;return w=void 0,I}return N.read()}}}e.$8d=g;function c(N,A){return new Promise((f,k)=>{const w=[];h(N,{onData:I=>{A&&w.push(I)},onError:I=>{A?k(I):f(void 0)},onEnd:()=>{f(A?A(w):void 0)}})})}e.$9d=c;function h(N,A,f){N.on("error",k=>{f?.isCancellationRequested||A.onError(k)}),N.on("end",()=>{f?.isCancellationRequested||A.onEnd()}),N.on("data",k=>{f?.isCancellationRequested||A.onData(k)})}e.$0d=h;function a(N,A){return new Promise((f,k)=>{const w=new T.$Qc,I=[],U=E=>{if(I.push(E),I.length>A)return w.dispose(),N.pause(),f({stream:N,buffer:I,ended:!1})},$=E=>(w.dispose(),k(E)),m=()=>(w.dispose(),f({stream:N,buffer:I,ended:!0}));w.add((0,T.$Pc)(()=>N.removeListener("error",$))),N.on("error",$),w.add((0,T.$Pc)(()=>N.removeListener("end",m))),N.on("end",m),w.add((0,T.$Pc)(()=>N.removeListener("data",U))),N.on("data",U)})}e.$$d=a;function i(N,A){const f=d(A);return f.end(N),f}e.$_d=i;function n(){const N=d(()=>{throw new Error("not supported")});return N.end(),N}e.$ae=n;function r(N){let A=!1;return{read:()=>A?null:(A=!0,N)}}e.$be=r;function b(N,A,f){const k=d(f);return h(N,{onData:w=>k.write(A.data(w)),onError:w=>k.error(A.error?A.error(w):w),onEnd:()=>k.end()}),k}e.$ce=b;function O(N,A,f){let k=!1;return{read:()=>{const w=A.read();return k?w:(k=!0,w!==null?f([N,w]):N)}}}e.$de=O;function j(N,A,f){let k=!1;const w=d(f);return h(A,{onData:I=>k?w.write(I):(k=!0,w.write(f([N,I]))),onError:I=>w.error(I),onEnd:()=>{k||(k=!0,w.write(N)),w.end()}}),w}e.$ee=j}),define(V[12],_([0,1,43,24]),function(K,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const y=typeof Buffer<"u",P=new L.$U(()=>new Uint8Array(256));let s,d;class t{static alloc(l){return y?new t(Buffer.allocUnsafe(l)):new t(new Uint8Array(l))}static wrap(l){return y&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new t(l)}static fromString(l,M){return!(M?.dontUseNodeBuffer||!1)&&y?new t(Buffer.from(l)):(s||(s=new TextEncoder),new t(s.encode(l)))}static fromByteArray(l){const M=t.alloc(l.length);for(let D=0,z=l.length;D<z;D++)M.buffer[D]=l[D];return M}static concat(l,M){if(typeof M>"u"){M=0;for(let W=0,H=l.length;W<H;W++)M+=l[W].byteLength}const D=t.alloc(M);let z=0;for(let W=0,H=l.length;W<H;W++){const G=l[W];D.set(G,z),z+=G.byteLength}return D}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=t.alloc(this.byteLength);return l.set(this),l}toString(){return y?this.buffer.toString():(d||(d=new TextDecoder),d.decode(this.buffer))}slice(l,M){return new t(this.buffer.subarray(l,M))}set(l,M){if(l instanceof t)this.buffer.set(l.buffer,M);else if(l instanceof Uint8Array)this.buffer.set(l,M);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),M);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return h(this.buffer,l)}writeUInt32BE(l,M){a(this.buffer,l,M)}readUInt32LE(l){return i(this.buffer,l)}writeUInt32LE(l,M){n(this.buffer,l,M)}readUInt8(l){return r(this.buffer,l)}writeUInt8(l,M){b(this.buffer,l,M)}indexOf(l,M=0){return o(this.buffer,l instanceof t?l.buffer:l,M)}}e.$fe=t;function o(S,l,M=0){const D=l.byteLength,z=S.byteLength;if(D===0)return 0;if(D===1)return S.indexOf(l[0]);if(D>z-M)return-1;const W=P.value;W.fill(l.length);for(let J=0;J<l.length;J++)W[l[J]]=l.length-J-1;let H=M+l.length-1,G=H,p=-1;for(;H<z;)if(S[H]===l[G]){if(G===0){p=H;break}H--,G--}else H+=Math.max(l.length-G,W[S[H]]),G=l.length-1;return p}e.$ge=o;function g(S,l){return S[l+0]<<0>>>0|S[l+1]<<8>>>0}e.$he=g;function c(S,l,M){S[M+0]=l&255,l=l>>>8,S[M+1]=l&255}e.$ie=c;function h(S,l){return S[l]*2**24+S[l+1]*2**16+S[l+2]*2**8+S[l+3]}e.$je=h;function a(S,l,M){S[M+3]=l,l=l>>>8,S[M+2]=l,l=l>>>8,S[M+1]=l,l=l>>>8,S[M]=l}e.$ke=a;function i(S,l){return S[l+0]<<0>>>0|S[l+1]<<8>>>0|S[l+2]<<16>>>0|S[l+3]<<24>>>0}e.$le=i;function n(S,l,M){S[M+0]=l&255,l=l>>>8,S[M+1]=l&255,l=l>>>8,S[M+2]=l&255,l=l>>>8,S[M+3]=l&255}e.$me=n;function r(S,l){return S[l]}e.$ne=r;function b(S,l,M){S[M]=l}e.$oe=b;function O(S){return T.$7d(S,l=>t.concat(l))}e.$pe=O;function j(S){return T.$be(S)}e.$qe=j;function N(S){return T.$9d(S,l=>t.concat(l))}e.$re=N;async function A(S){return S.ended?t.concat(S.buffer):t.concat([...S.buffer,await N(S.stream)])}e.$se=A;function f(S){return T.$_d(S,l=>t.concat(l))}e.$te=f;function k(S){return T.$ce(S,{data:l=>typeof l=="string"?t.fromString(l):t.wrap(l)},l=>t.concat(l))}e.$ue=k;function w(S){return T.$6d(l=>t.concat(l),S)}e.$ve=w;function I(S,l){return T.$de(S,l,M=>t.concat(M))}e.$we=I;function U(S,l){return T.$ee(S,l,M=>t.concat(M))}e.$xe=U;function $(S){let l=0,M=0,D=0;const z=new Uint8Array(Math.floor(S.length/4*3)),W=G=>{switch(M){case 3:z[D++]=l|G,M=0;break;case 2:z[D++]=l|G>>>2,l=G<<6,M=3;break;case 1:z[D++]=l|G>>>4,l=G<<4,M=2;break;default:l=G<<2,M=1}};for(let G=0;G<S.length;G++){const p=S.charCodeAt(G);if(p>=65&&p<=90)W(p-65);else if(p>=97&&p<=122)W(p-97+26);else if(p>=48&&p<=57)W(p-48+52);else if(p===43||p===45)W(62);else if(p===47||p===95)W(63);else{if(p===61)break;throw new SyntaxError(`Unexpected base64 character ${S[G]}`)}}const H=D;for(;M>0;)W(0);return t.wrap(z).slice(0,H)}e.$ye=$;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function B({buffer:S},l=!0,M=!1){const D=M?E:m;let z="";const W=S.byteLength%3;let H=0;for(;H<S.byteLength-W;H+=3){const G=S[H+0],p=S[H+1],J=S[H+2];z+=D[G>>>2],z+=D[(G<<4|p>>>4)&63],z+=D[(p<<2|J>>>6)&63],z+=D[J&63]}if(W===1){const G=S[H+0];z+=D[G>>>2],z+=D[G<<4&63],l&&(z+="==")}else if(W===2){const G=S[H+0],p=S[H+1];z+=D[G>>>2],z+=D[(G<<4|p>>>4)&63],z+=D[p<<2&63],l&&(z+="=")}return z}e.$ze=B}),define(V[25],_([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(V[13],_([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=e.StringEOL=void 0;var L;(function(y){y[y.Unknown=0]="Unknown",y[y.Invalid=3]="Invalid",y[y.LF=1]="LF",y[y.CRLF=2]="CRLF"})(L||(e.StringEOL=L={}));function T(y){let P=0,s=0,d=0,t=0;for(let o=0,g=y.length;o<g;o++){const c=y.charCodeAt(o);c===13?(P===0&&(s=o),P++,o+1<g&&y.charCodeAt(o+1)===10?(t|=2,o++):t|=3,d=o+1):c===10&&(t|=1,P===0&&(s=o),P++,d=o+1)}return P===0&&(s=y.length),[P,s,y.length-d,t]}e.$bt=T}),define(V[14],_([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var L;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(L||(e.LanguageId=L={}));var T;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(T||(e.FontStyle=T={}));var y;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(y||(e.ColorId=y={}));var P;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(P||(e.StandardTokenType=P={}));var s;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(s||(e.MetadataConsts=s={}));class d{static getLanguageId(o){return(o&255)>>>0}static getTokenType(o){return(o&768)>>>8}static containsBalancedBrackets(o){return(o&1024)!==0}static getFontStyle(o){return(o&30720)>>>11}static getForeground(o){return(o&16744448)>>>15}static getBackground(o){return(o&4278190080)>>>24}static getClassNameFromMetadata(o){let c="mtk"+this.getForeground(o);const h=this.getFontStyle(o);return h&1&&(c+=" mtki"),h&2&&(c+=" mtkb"),h&4&&(c+=" mtku"),h&8&&(c+=" mtks"),c}static getInlineStyleFromMetadata(o,g){const c=this.getForeground(o),h=this.getFontStyle(o);let a=`color: ${g[c]};`;h&1&&(a+="font-style: italic;"),h&2&&(a+="font-weight: bold;");let i="";return h&4&&(i+=" underline"),h&8&&(i+=" line-through"),i&&(a+=`text-decoration:${i};`),a}static getPresentationFromMetadata(o){const g=this.getForeground(o),c=this.getFontStyle(o);return{foreground:g,italic:!!(c&1),bold:!!(c&2),underline:!!(c&4),strikethrough:!!(c&8)}}}e.$_s=d}),define(V[26],_([0,1,27]),function(K,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TB=void 0;class T{constructor(s){this.b=s,this.a=[]}get(s){return s<this.a.length?this.a[s]:this.b}set(s,d){for(;s>=this.a.length;)this.a[this.a.length]=this.b;this.a[s]=d}replace(s,d,t){if(s>=this.a.length)return;if(d===0){this.insert(s,t);return}else if(t===0){this.delete(s,d);return}const o=this.a.slice(0,s),g=this.a.slice(s+d),c=y(t,this.b);this.a=o.concat(c,g)}delete(s,d){d===0||s>=this.a.length||this.a.splice(s,d)}insert(s,d){if(d===0||s>=this.a.length)return;const t=[];for(let o=0;o<d;o++)t[o]=this.b;this.a=(0,L.$Vb)(this.a,s,t)}}e.$TB=T;function y(P,s){const d=[];for(let t=0;t<P;t++)d[t]=s;return d}}),define(V[7],_([0,1,14]),function(K,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0;class T{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(s,d){const t=T.defaultTokenMetadata,o=new Uint32Array(2);return o[0]=s.length,o[1]=t,new T(o,s,d)}constructor(s,d,t){this._lineTokensBrand=void 0,this.a=s,this.b=this.a.length>>>1,this.c=d,this.d=t}equals(s){return s instanceof T?this.slicedEquals(s,0,this.b):!1}slicedEquals(s,d,t){if(this.c!==s.c||this.b!==s.b)return!1;const o=d<<1,g=o+(t<<1);for(let c=o;c<g;c++)if(this.a[c]!==s.a[c])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(s){return s>0?this.a[s-1<<1]:0}getMetadata(s){return this.a[(s<<1)+1]}getLanguageId(s){const d=this.a[(s<<1)+1],t=L.$_s.getLanguageId(d);return this.d.decodeLanguageId(t)}getStandardTokenType(s){const d=this.a[(s<<1)+1];return L.$_s.getTokenType(d)}getForeground(s){const d=this.a[(s<<1)+1];return L.$_s.getForeground(d)}getClassName(s){const d=this.a[(s<<1)+1];return L.$_s.getClassNameFromMetadata(d)}getInlineStyle(s,d){const t=this.a[(s<<1)+1];return L.$_s.getInlineStyleFromMetadata(t,d)}getPresentation(s){const d=this.a[(s<<1)+1];return L.$_s.getPresentationFromMetadata(d)}getEndOffset(s){return this.a[s<<1]}findTokenIndexAtOffset(s){return T.findIndexInTokensArray(this.a,s)}inflate(){return this}sliceAndInflate(s,d,t){return new y(this,s,d,t)}static convertToEndOffset(s,d){const o=(s.length>>>1)-1;for(let g=0;g<o;g++)s[g<<1]=s[g+1<<1];s[o<<1]=d}static findIndexInTokensArray(s,d){if(s.length<=2)return 0;let t=0,o=(s.length>>>1)-1;for(;t<o;){const g=t+Math.floor((o-t)/2),c=s[g<<1];if(c===d)return g+1;c<d?t=g+1:c>d&&(o=g)}return t}withInserted(s){if(s.length===0)return this;let d=0,t=0,o="";const g=new Array;let c=0;for(;;){const h=d<this.b?this.a[d<<1]:-1,a=t<s.length?s[t]:null;if(h!==-1&&(a===null||h<=a.offset)){o+=this.c.substring(c,h);const i=this.a[(d<<1)+1];g.push(o.length,i),d++,c=h}else if(a){if(a.offset>c){o+=this.c.substring(c,a.offset);const i=this.a[(d<<1)+1];g.push(o.length,i),c=a.offset}o+=a.text,g.push(o.length,a.tokenMetadata),t++}else break}return new T(new Uint32Array(g),o,this.d)}}e.$ct=T;class y{constructor(s,d,t,o){this.a=s,this.b=d,this.c=t,this.d=o,this.e=s.findTokenIndexAtOffset(d),this.f=0;for(let g=this.e,c=s.getCount();g<c&&!(s.getStartOffset(g)>=t);g++)this.f++}getMetadata(s){return this.a.getMetadata(this.e+s)}getLanguageId(s){return this.a.getLanguageId(this.e+s)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(s){return s instanceof y?this.b===s.b&&this.c===s.c&&this.d===s.d&&this.a.slicedEquals(s.a,this.e,this.f):!1}getCount(){return this.f}getForeground(s){return this.a.getForeground(this.e+s)}getEndOffset(s){const d=this.a.getEndOffset(this.e+s);return Math.min(this.c,d)-this.b+this.d}getClassName(s){return this.a.getClassName(this.e+s)}getInlineStyle(s,d){return this.a.getInlineStyle(this.e+s,d)}getPresentation(s){return this.a.getPresentation(this.e+s)}findTokenIndexAtOffset(s){return this.a.findTokenIndexAtOffset(s+this.b-this.d)-this.e}}}),define(V[28],_([0,1,7]),function(K,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.$et=e.$dt=void 0,e.$dt=new Uint32Array(0).buffer;class T{static deleteBeginning(s,d){return s===null||s===e.$dt?s:T.delete(s,0,d)}static deleteEnding(s,d){if(s===null||s===e.$dt)return s;const t=y(s),o=t[t.length-2];return T.delete(s,d,o)}static delete(s,d,t){if(s===null||s===e.$dt||d===t)return s;const o=y(s),g=o.length>>>1;if(d===0&&o[o.length-2]===t)return e.$dt;const c=L.$ct.findIndexInTokensArray(o,d),h=c>0?o[c-1<<1]:0,a=o[c<<1];if(t<a){const O=t-d;for(let j=c;j<g;j++)o[j<<1]-=O;return s}let i,n;h!==d?(o[c<<1]=d,i=c+1<<1,n=d):(i=c<<1,n=h);const r=t-d;for(let O=c+1;O<g;O++){const j=o[O<<1]-r;j>n&&(o[i++]=j,o[i++]=o[(O<<1)+1],n=j)}if(i===o.length)return s;const b=new Uint32Array(i);return b.set(o.subarray(0,i),0),b.buffer}static append(s,d){if(d===e.$dt)return s;if(s===e.$dt)return d;if(s===null)return s;if(d===null)return null;const t=y(s),o=y(d),g=o.length>>>1,c=new Uint32Array(t.length+o.length);c.set(t,0);let h=t.length;const a=t[t.length-2];for(let i=0;i<g;i++)c[h++]=o[i<<1]+a,c[h++]=o[(i<<1)+1];return c.buffer}static insert(s,d,t){if(s===null||s===e.$dt)return s;const o=y(s),g=o.length>>>1;let c=L.$ct.findIndexInTokensArray(o,d);c>0&&o[c-1<<1]===d&&c--;for(let h=c;h<g;h++)o[h<<1]+=t;return s}}e.$et=T;function y(P){return P instanceof Uint32Array?P:new Uint32Array(P)}e.$ft=y}),define(V[29],_([0,1,27,12,44,13,28,15]),function(K,e,L,T,y,P,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=void 0;class t{static deserialize(g,c,h){const a=new Uint32Array(g.buffer),i=(0,T.$je)(g,c);c+=4;const n=(0,T.$je)(g,c);c+=4;const r=[];for(let b=0;b<n;b++){const O=(0,T.$je)(g,c);c+=4,r.push(a.subarray(c/4,c/4+O/4)),c+=O}return h.push(new t(i,r)),c}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(g,c){this.a=g,this.b=c}getLineRange(){return new d.$Ks(this.a,this.a+this.b.length)}getLineTokens(g){return this.b[g-this.a]}appendLineTokens(g){this.b.push(g)}serializeSize(){let g=0;g+=4,g+=4;for(let c=0;c<this.b.length;c++){const h=this.b[c];if(!(h instanceof Uint32Array))throw new Error("Not supported!");g+=4,g+=h.byteLength}return g}serialize(g,c){(0,T.$ke)(g,this.a,c),c+=4,(0,T.$ke)(g,this.b.length,c),c+=4;for(let h=0;h<this.b.length;h++){const a=this.b[h];if(!(a instanceof Uint32Array))throw new Error("Not supported!");(0,T.$ke)(g,a.byteLength,c),c+=4,g.set(new Uint8Array(a.buffer),c),c+=a.byteLength}return c}applyEdit(g,c){const[h,a]=(0,P.$bt)(c);this.c(g),this.d(new y.$As(g.startLineNumber,g.startColumn),h,a)}c(g){if(g.startLineNumber===g.endLineNumber&&g.startColumn===g.endColumn)return;const c=g.startLineNumber-this.a,h=g.endLineNumber-this.a;if(h<0){const a=h-c;this.a-=a;return}if(!(c>=this.b.length)){if(c<0&&h>=this.b.length){this.a=0,this.b=[];return}if(c===h){this.b[c]=s.$et.delete(this.b[c],g.startColumn-1,g.endColumn-1);return}if(c>=0)if(this.b[c]=s.$et.deleteEnding(this.b[c],g.startColumn-1),h<this.b.length){const a=s.$et.deleteBeginning(this.b[h],g.endColumn-1);this.b[c]=s.$et.append(this.b[c],a),this.b.splice(c+1,h-c)}else this.b[c]=s.$et.append(this.b[c],null),this.b=this.b.slice(0,c+1);else{const a=-c;this.a-=a,this.b[h]=s.$et.deleteBeginning(this.b[h],g.endColumn-1),this.b=this.b.slice(h)}}}d(g,c,h){if(c===0&&h===0)return;const a=g.lineNumber-this.a;if(a<0){this.a+=c;return}if(!(a>=this.b.length)){if(c===0){this.b[a]=s.$et.insert(this.b[a],g.column-1,h);return}this.b[a]=s.$et.deleteEnding(this.b[a],g.column-1),this.b[a]=s.$et.insert(this.b[a],g.column-1,h),this.e(g.lineNumber,c)}}e(g,c){if(c===0)return;const h=[];for(let a=0;a<c;a++)h[a]=null;this.b=L.$Vb(this.b,g,h)}}e.$gt=t}),define(V[16],_([0,1,12,29]),function(K,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UB=void 0;class y{static deserialize(s){let d=0;const t=(0,L.$je)(s,d);d+=4;const o=[];for(let g=0;g<t;g++)d=T.$gt.deserialize(s,d,o);return o}constructor(){this.a=[]}add(s,d){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===s){t.appendLineTokens(d);return}}this.a.push(new T.$gt(s,[d]))}finalize(){return this.a}serialize(){const s=this.b(),d=new Uint8Array(s);return this.c(d),d}b(){let s=0;s+=4;for(let d=0;d<this.a.length;d++)s+=this.a[d].serializeSize();return s}c(s){let d=0;(0,L.$ke)(s,this.a.length,d),d+=4;for(let t=0;t<this.a.length;t++)d=this.a[t].serialize(s,d)}}e.$UB=y}),define(V[30],_([0,1,31,3,17,45]),function(K,e,L,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function s($){return $===47||$===92}e.$Uf=s;function d($){return $.replace(/[\\/]/g,L.$fc.sep)}e.$Vf=d;function t($){return $.indexOf("/")===-1&&($=d($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}e.$Wf=t;function o($,m=L.$fc.sep){if(!$)return"";const E=$.length,B=$.charCodeAt(0);if(s(B)){if(s($.charCodeAt(1))&&!s($.charCodeAt(2))){let l=3;const M=l;for(;l<E&&!s($.charCodeAt(l));l++);if(M!==l&&!s($.charCodeAt(l+1))){for(l+=1;l<E;l++)if(s($.charCodeAt(l)))return $.slice(0,l+1).replace(/[\\/]/g,m)}}return m}else if(b(B)&&$.charCodeAt(1)===58)return s($.charCodeAt(2))?$.slice(0,2)+m:$.slice(0,2);let S=$.indexOf("://");if(S!==-1){for(S+=3;S<E;S++)if(s($.charCodeAt(S)))return $.slice(0,S+1)}return""}e.$Xf=o;function g($){if(!T.$i||!$||$.length<5)return!1;let m=$.charCodeAt(0);if(m!==92||(m=$.charCodeAt(1),m!==92))return!1;let E=2;const B=E;for(;E<$.length&&(m=$.charCodeAt(E),m!==92);E++);return!(B===E||(m=$.charCodeAt(E+1),isNaN(m)||m===92))}e.$Yf=g;const c=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function i($,m=T.$i){const E=m?c:h;return!(!$||$.length===0||/^\s+$/.test($)||(E.lastIndex=0,E.test($))||m&&a.test($)||$==="."||$===".."||m&&$[$.length-1]==="."||m&&$.length!==$.trim().length||$.length>255)}e.$Zf=i;function n($,m,E){const B=$===m;return!E||B?B:!$||!m?!1:(0,y.$6e)($,m)}e.$1f=n;function r($,m,E,B=L.sep){if($===m)return!0;if(!$||!m||m.length>$.length)return!1;if(E){if(!(0,y.$7e)($,m))return!1;if(m.length===$.length)return!0;let l=m.length;return m.charAt(m.length-1)===B&&l--,$.charAt(l)===B}return m.charAt(m.length-1)!==B&&(m+=B),$.indexOf(m)===0}e.$2f=r;function b($){return $>=65&&$<=90||$>=97&&$<=122}e.$3f=b;function O($,m){return T.$i&&$.endsWith(":")&&($+=L.sep),(0,L.$hc)($)||($=(0,L.$ic)(m,$)),$=(0,L.$gc)($),T.$i?($=(0,y.$Oe)($,L.sep),$.endsWith(":")&&($+=L.sep)):($=(0,y.$Oe)($,L.sep),$||($=L.sep)),$}e.$4f=O;function j($){const m=(0,L.$gc)($);return T.$i?$.length>3?!1:N(m)&&($.length===2||m.charCodeAt(2)===92):m===L.$fc.sep}e.$5f=j;function N($,m=T.$i){return m?b($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}e.$6f=N;function A($,m=T.$i){return N($,m)?$[0]:void 0}e.$7f=A;function f($,m,E){return m.length>$.length?-1:$===m?0:(E&&($=$.toLowerCase(),m=m.toLowerCase()),$.indexOf(m))}e.$8f=f;function k($){const m=$.split(":");let E,B,S;for(const l of m){const M=Number(l);(0,P.$Gf)(M)?B===void 0?B=M:S===void 0&&(S=M):E=E?[E,l].join(":"):l}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:B!==void 0?B:void 0,column:S!==void 0?S:B!==void 0?1:void 0}}e.$9f=k;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function U($,m,E=8){let B="";for(let l=0;l<E;l++){let M;l===0&&T.$i&&!m&&(E===3||E===4)?M=I:M=w,B+=M.charAt(Math.floor(Math.random()*M.length))}let S;return m?S=`${m}-${B}`:S=B,$?(0,L.$ic)($,S):S}e.$0f=U}),define(V[18],_([0,1,6,3,17,8]),function(K,e,L,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var s;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm"})(s||(e.Schemas=s={}));function d(h,a){return P.URI.isUri(h)?(0,y.$6e)(h.scheme,a):(0,y.$7e)(h,a+":")}e.$$f=d;function t(h,...a){return a.some(i=>d(h,i))}e.$_f=t,e.$ag="vscode-tkn",e.$bg="tkn";class o{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${s.vscodeRemoteResource}`}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a){this.f=`${a}/${s.vscodeRemoteResource}`}set(a,i,n){this.a[a]=i,this.b[a]=n}setConnectionToken(a,i){this.c[a]=i}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(j){return L.$Z(j),a}const i=a.authority;let n=this.a[i];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const r=this.b[i],b=this.c[i];let O=`path=${encodeURIComponent(a.path)}`;return typeof b=="string"&&(O+=`&${e.$bg}=${encodeURIComponent(b)}`),P.URI.from({scheme:T.$o?this.d:s.vscodeRemoteResource,authority:`${n}:${r}`,path:this.f,query:O})}}e.$cg=new o,e.$dg="vs/../../extensions",e.$eg="vs/../../node_modules",e.$fg="vs/../../node_modules.asar",e.$gg="vs/../../node_modules.asar.unpacked",e.$hg="vscode-app";class g{static{this.a=e.$hg}asBrowserUri(a){const i=this.b(a,K);return this.uriToBrowserUri(i)}uriToBrowserUri(a){return a.scheme===s.vscodeRemote?e.$cg.rewrite(a):a.scheme===s.file&&(T.$m||T.$q===`${s.vscodeFileResource}://${g.a}`)?a.with({scheme:s.vscodeFileResource,authority:a.authority||g.a,query:null,fragment:null}):a}asFileUri(a){const i=this.b(a,K);return this.uriToFileUri(i)}uriToFileUri(a){return a.scheme===s.vscodeFileResource?a.with({scheme:s.file,authority:a.authority!==g.a?a.authority:null,query:null,fragment:null}):a}b(a,i){return P.URI.isUri(a)?a:P.URI.parse(i.toUrl(a))}}e.$ig=new g;var c;(function(h){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(a.get("3"));const i="vscode-coi";function n(b){let O;typeof b=="string"?O=new URL(b).searchParams:b instanceof URL?O=b.searchParams:P.URI.isUri(b)&&(O=new URL(b.toString(!0)).searchParams);const j=O?.get(i);if(j)return a.get(j)}h.getHeadersFromQuery=n;function r(b,O,j){if(!globalThis.crossOriginIsolated)return;const N=O&&j?"3":j?"2":"1";b instanceof URLSearchParams?b.set(i,N):b[i]=N}h.addSearchParam=r})(c||(e.COI=c={}))}),define(V[32],_([0,1,22,18,3,8]),function(K,e,L,T,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QC=void 0;class s{constructor(h,a,i){this.id=h,this.dependencies=a,this.callback=i}}class d{static{this.INSTANCE=new d}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(h,a,i)=>{typeof h!="string"&&(i=a,a=h,h=null),(typeof a!="object"||!Array.isArray(a))&&(i=a,a=null),this.c.push(new s(h,a,i))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this.g();const a=await(this.a?this.i(h):this.b?this.h(h):this.j(h));if(!a)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray(a.dependencies)&&a.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${a.dependencies.join(", ")}`);return typeof a.callback=="function"?a.callback([]):a.callback}h(h){return new Promise((a,i)=>{const n=document.createElement("script");n.setAttribute("async","async"),n.setAttribute("type","text/javascript");const r=()=>{n.removeEventListener("load",b),n.removeEventListener("error",O)},b=j=>{r(),a(this.c.pop())},O=j=>{r(),i(j)};n.addEventListener("load",b),n.addEventListener("error",O),this.f&&(h=this.f.createScriptURL(h)),n.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(n)})}i(h){return new Promise((a,i)=>{try{this.f&&(h=this.f.createScriptURL(h)),importScripts(h),a(this.c.pop())}catch(n){i(n)}})}async j(h){try{const a=globalThis._VSCODE_NODE_MODULES.fs,i=globalThis._VSCODE_NODE_MODULES.vm,n=globalThis._VSCODE_NODE_MODULES.module,r=P.URI.parse(h).fsPath,b=a.readFileSync(r).toString(),O=n.wrap(b.replace(/^#!.*/,""));return new i.Script(O).runInThisContext().apply(),this.c.pop()}catch(a){throw a}}}const t=new Map;let o={};typeof globalThis.require=="object"&&(o=globalThis.require.paths??{});async function g(c,h,a){if(L.$S){a===void 0&&(a=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),o[c]&&(c=o[c]);const i=`${c}/${h}`;if(t.has(i))return t.get(i);let n;if(/^\w[\w\d+.-]*:\/\//.test(i))n=i;else{const j=`${a&&!y.$o?T.$fg:T.$eg}/${i}`;n=T.$ig.asBrowserUri(j).toString(!0)}const r=d.INSTANCE.load(n);return t.set(i,r),r}else return await new Promise((i,n)=>{K([c],i,n)})}e.$QC=g}),define(V[19],_([0,1,30,18,31,3,17,8]),function(K,e,L,T,y,P,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lg=e.DataUri=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=void 0;function t(a){return(0,d.$vc)(a,!0)}e.$pg=t;class o{constructor(i){this.a=i}compare(i,n,r=!1){return i===n?0:(0,s.$Ye)(this.getComparisonKey(i,r),this.getComparisonKey(n,r))}isEqual(i,n,r=!1){return i===n?!0:!i||!n?!1:this.getComparisonKey(i,r)===this.getComparisonKey(n,r)}getComparisonKey(i,n=!1){return i.with({path:this.a(i)?i.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(i){return this.a(i)}isEqualOrParent(i,n,r=!1){if(i.scheme===n.scheme){if(i.scheme===T.Schemas.file)return L.$2f(t(i),t(n),this.a(i))&&i.query===n.query&&(r||i.fragment===n.fragment);if((0,e.$Gg)(i.authority,n.authority))return L.$2f(i.path,n.path,this.a(i),"/")&&i.query===n.query&&(r||i.fragment===n.fragment)}return!1}joinPath(i,...n){return d.URI.joinPath(i,...n)}basenameOrAuthority(i){return(0,e.$yg)(i)||i.authority}basename(i){return y.$fc.basename(i.path)}extname(i){return y.$fc.extname(i.path)}dirname(i){if(i.path.length===0)return i;let n;return i.scheme===T.Schemas.file?n=d.URI.file(y.$lc(t(i))).path:(n=y.$fc.dirname(i.path),i.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),n="/")),i.with({path:n})}normalizePath(i){if(!i.path.length)return i;let n;return i.scheme===T.Schemas.file?n=d.URI.file(y.$gc(t(i))).path:n=y.$fc.normalize(i.path),i.with({path:n})}relativePath(i,n){if(i.scheme!==n.scheme||!(0,e.$Gg)(i.authority,n.authority))return;if(i.scheme===T.Schemas.file){const O=y.$kc(t(i),t(n));return P.$i?L.$Vf(O):O}let r=i.path||"/";const b=n.path||"/";if(this.a(i)){let O=0;for(const j=Math.min(r.length,b.length);O<j&&!(r.charCodeAt(O)!==b.charCodeAt(O)&&r.charAt(O).toLowerCase()!==b.charAt(O).toLowerCase());O++);r=b.substr(0,O)+r.substr(O)}return y.$fc.relative(r,b)}resolvePath(i,n){if(i.scheme===T.Schemas.file){const r=d.URI.file(y.$jc(t(i),n));return i.with({authority:r.authority,path:r.path})}return n=L.$Wf(n),i.with({path:y.$fc.resolve(i.path,n)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,n){return i===n||i!==void 0&&n!==void 0&&(0,s.$6e)(i,n)}hasTrailingPathSeparator(i,n=y.sep){if(i.scheme===T.Schemas.file){const r=t(i);return r.length>L.$Xf(r).length&&r[r.length-1]===n}else{const r=i.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,n=y.sep){return(0,e.$Hg)(i,n)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,n=y.sep){let r=!1;if(i.scheme===T.Schemas.file){const b=t(i);r=b!==void 0&&b.length===L.$Xf(b).length&&b[b.length-1]===n}else{n="/";const b=i.path;r=b.length===1&&b.charCodeAt(b.length-1)===47}return!r&&!(0,e.$Hg)(i,n)?i.with({path:i.path+"/"}):i}}e.$qg=o,e.$rg=new o(()=>!1),e.$sg=new o(a=>a.scheme===T.Schemas.file?!P.$k:!0),e.$tg=new o(a=>!0),e.$ug=e.$rg.isEqual.bind(e.$rg),e.$vg=e.$rg.isEqualOrParent.bind(e.$rg),e.$wg=e.$rg.getComparisonKey.bind(e.$rg),e.$xg=e.$rg.basenameOrAuthority.bind(e.$rg),e.$yg=e.$rg.basename.bind(e.$rg),e.$zg=e.$rg.extname.bind(e.$rg),e.$Ag=e.$rg.dirname.bind(e.$rg),e.$Bg=e.$rg.joinPath.bind(e.$rg),e.$Cg=e.$rg.normalizePath.bind(e.$rg),e.$Dg=e.$rg.relativePath.bind(e.$rg),e.$Eg=e.$rg.resolvePath.bind(e.$rg),e.$Fg=e.$rg.isAbsolutePath.bind(e.$rg),e.$Gg=e.$rg.isEqualAuthority.bind(e.$rg),e.$Hg=e.$rg.hasTrailingPathSeparator.bind(e.$rg),e.$Ig=e.$rg.removeTrailingPathSeparator.bind(e.$rg),e.$Jg=e.$rg.addTrailingPathSeparator.bind(e.$rg);function g(a,i){const n=[];for(let r=0;r<a.length;r++){const b=i(a[r]);a.some((O,j)=>j===r?!1:(0,e.$vg)(b,i(O)))||n.push(a[r])}return n}e.$Kg=g;var c;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function i(n){const r=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(j=>{const[N,A]=j.split(":");N&&A&&r.set(N,A)});const O=n.path.substring(0,n.path.indexOf(";"));return O&&r.set(a.META_DATA_MIME,O),r}a.parseMetaData=i})(c||(e.DataUri=c={}));function h(a,i,n){if(i){let r=a.path;return r&&r[0]!==y.$fc.sep&&(r=y.$fc.sep+r),a.with({scheme:n,authority:i,path:r})}return a.with({scheme:n})}e.$Lg=h}),define(V[20],_([0,1,46,6,33,2,19,3,25]),function(K,e,L,T,y,P,s,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oh=e.$nh=e.$mh=e.$lh=e.Promises=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=void 0;function o(R){return!!R&&typeof R.then=="function"}e.$Mg=o;function g(R){const u=new L.$2d,v=R(u.token),C=new Promise((F,q)=>{const Z=u.token.onCancellationRequested(()=>{Z.dispose(),u.dispose(),q(new T.$4)});Promise.resolve(v).then(Q=>{Z.dispose(),u.dispose(),F(Q)},Q=>{Z.dispose(),u.dispose(),q(Q)})});return new class{cancel(){u.cancel()}then(F,q){return C.then(F,q)}catch(F){return this.then(void 0,F)}finally(F){return C.finally(F)}}}e.$Ng=g;function c(R,u,v){return new Promise((C,F)=>{const q=u.onCancellationRequested(()=>{q.dispose(),C(v)});R.then(C,F).finally(()=>q.dispose())})}e.$Og=c;function h(R,u){return new Promise((v,C)=>{const F=u.onCancellationRequested(()=>{F.dispose(),C(new T.$4)});R.then(v,C).finally(()=>F.dispose())})}e.$Pg=h;async function a(R){let u=-1;const v=R.map((C,F)=>C.then(q=>(u=F,q)));try{return await Promise.race(v)}finally{R.forEach((C,F)=>{F!==u&&C.cancel()})}}e.$Qg=a;function i(R,u,v){let C;const F=setTimeout(()=>{C?.(void 0),v?.()},u);return Promise.race([R.finally(()=>clearTimeout(F)),new Promise(q=>C=q)])}e.$Rg=i;function n(R){return new Promise((u,v)=>{const C=R();o(C)?C.then(u,v):u(C)})}e.$Sg=n;class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(u){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=u,!this.b){const v=()=>{if(this.b=null,this.f)return;const C=this.queue(this.d);return this.d=null,C};this.b=new Promise(C=>{this.a.then(v,v).then(C)})}return new Promise((v,C)=>{this.b.then(v,C)})}return this.a=u(),new Promise((v,C)=>{this.a.then(F=>{this.a=null,v(F)},F=>{this.a=null,C(F)})})}dispose(){this.f=!0}}e.$Tg=r;class b{constructor(){this.a=Promise.resolve(null)}queue(u){return this.a=this.a.then(()=>u(),()=>u())}}e.$Ug=b;class O{constructor(){this.a=new Map}queue(u,v){const F=(this.a.get(u)??Promise.resolve()).catch(()=>{}).then(v).finally(()=>{this.a.get(u)===F&&this.a.delete(u)});return this.a.set(u,F),F}}e.$Vg=O;const j=(R,u)=>{let v=!0;const C=setTimeout(()=>{v=!1,u()},R);return{isTriggered:()=>v,dispose:()=>{clearTimeout(C),v=!1}}},N=R=>{let u=!0;return queueMicrotask(()=>{u&&(u=!1,R())}),{isTriggered:()=>u,dispose:()=>{u=!1}}};class A{constructor(u){this.defaultDelay=u,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(u,v=this.defaultDelay){this.g=u,this.h(),this.b||(this.b=new Promise((F,q)=>{this.d=F,this.f=q}).then(()=>{if(this.b=null,this.d=null,this.g){const F=this.g;return this.g=null,F()}}));const C=()=>{this.a=null,this.d?.(null)};return this.a=v===t.$Od?N(C):j(v,C),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Wg=A;class f{constructor(u){this.a=new A(u),this.b=new r}trigger(u,v){return this.a.trigger(()=>this.b.queue(u),v)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Xg=f;class k{constructor(){this.a=!1,this.b=new Promise((u,v)=>{this.d=u})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Yg=k;class w extends k{constructor(u){super(),this.f=setTimeout(()=>this.open(),u)}open(){clearTimeout(this.f),super.open()}}e.$Zg=w;function I(R,u){return u?new Promise((v,C)=>{const F=setTimeout(()=>{q.dispose(),v()},R),q=u.onCancellationRequested(()=>{clearTimeout(F),q.dispose(),C(new T.$4)})}):g(v=>I(R,v))}e.$1g=I;function U(R,u=0,v){const C=setTimeout(()=>{R(),v&&F.dispose()},u),F=(0,P.$Pc)(()=>{clearTimeout(C),v?.deleteAndLeak(F)});return v?.add(F),F}e.$2g=U;function $(R){const u=[];let v=0;const C=R.length;function F(){return v<C?R[v++]():null}function q(Z){Z!=null&&u.push(Z);const Q=F();return Q?Q.then(q):Promise.resolve(u)}return Promise.resolve(null).then(q)}e.$3g=$;function m(R,u=C=>!!C,v=null){let C=0;const F=R.length,q=()=>{if(C>=F)return Promise.resolve(v);const Z=R[C++];return Promise.resolve(Z()).then(X=>u(X)?Promise.resolve(X):q())};return q()}e.$4g=m;function E(R,u=C=>!!C,v=null){if(R.length===0)return Promise.resolve(v);let C=R.length;const F=()=>{C=-1;for(const q of R)q.cancel?.()};return new Promise((q,Z)=>{for(const Q of R)Q.then(X=>{--C>=0&&u(X)?(F(),q(X)):C===0&&q(v)}).catch(X=>{--C>=0&&(F(),Z(X))})})}e.$5g=E;class B{constructor(u){this.a=0,this.d=u,this.f=[],this.b=0,this.g=new y.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(u){return this.a++,new Promise((v,C)=>{this.f.push({factory:u,c:v,e:C}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const u=this.f.shift();this.b++;const v=u.factory();v.then(u.c,u.e),v.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$6g=B;class S extends B{constructor(){super(1)}}e.$7g=S;class l{constructor(){this.a=new ee,this.b=0}queue(u){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,u())):this.a.run(this.b++,u())}}e.$8g=l;class M{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const u=new x;return this.b.add(u),u.p}g(){for(const[,u]of this.a)if(u.size>0)return!1;return!0}queueFor(u,v=s.$rg){const C=v.getComparisonKey(u);let F=this.a.get(C);if(!F){F=new S;const q=this.f++,Z=y.Event.once(F.onDrained)(()=>{F?.dispose(),this.a.delete(C),this.h(),this.d?.deleteAndDispose(q),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new P.$1c),this.d.set(q,Z),this.a.set(C,F)}return F}h(){this.g()&&this.j()}j(){for(const u of this.b)u.complete();this.b.clear()}dispose(){for(const[,u]of this.a)u.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$9g=M;class D{constructor(u,v){this.a=-1,typeof u=="function"&&typeof v=="number"&&this.setIfNotSet(u,v)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(u,v){this.cancel(),this.a=setTimeout(()=>{this.a=-1,u()},v)}setIfNotSet(u,v){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,u()},v))}}e.$0g=D;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(u,v,C=globalThis){this.cancel();const F=C.setInterval(()=>{u()},v);this.d=(0,P.$Pc)(()=>{C.clearInterval(F),this.d=void 0})}dispose(){this.cancel()}}e.$$g=z;class W{constructor(u,v){this.b=-1,this.a=u,this.d=v,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(u=this.d){this.cancel(),this.b=setTimeout(this.f,u)}get delay(){return this.d}set delay(u){this.d=u}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$_g=W;class H{constructor(u,v){v%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${v}ms is not a multiple of 1000ms.`),this.a=u,this.b=v,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(u=this.b){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(u/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ah=H;class G extends W{constructor(u,v){super(u,v),this.j=[]}work(u){this.j.push(u),this.isScheduled()||this.schedule()}h(){const u=this.j;this.j=[],this.a?.(u)}dispose(){this.j=[],super.dispose()}}e.$bh=G;class p extends P.$Rc{constructor(u,v){super(),this.g=u,this.h=v,this.a=[],this.b=this.B(new P.$Sc),this.f=!1}get pending(){return this.a.length}work(u){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+u.length>this.g.maxBufferedWork)return!1}else if(this.pending+u.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const v of u)this.a.push(v);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ch=p,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$eh=(R,u)=>{(0,d.$B)(()=>{if(v)return;const C=Date.now()+15;u(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,C-Date.now())}}))});let v=!1;return{dispose(){v||(v=!0)}}}:e.$eh=(R,u,v)=>{const C=R.requestIdleCallback(u,typeof v=="number"?{timeout:v}:void 0);let F=!1;return{dispose(){F||(F=!0,R.cancelIdleCallback(C))}}},e.$dh=R=>(0,e.$eh)(globalThis,R)}();class J{constructor(u,v){this.g=!1,this.d=()=>{try{this.j=v()}catch(C){this.l=C}finally{this.g=!0}},this.f=(0,e.$eh)(u,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$fh=J;class re extends J{constructor(u){super(globalThis,u)}}e.$gh=re;async function ae(R,u,v){let C;for(let F=0;F<v;F++)try{return await R()}catch(q){C=q,await I(u)}throw C}e.$hh=ae;class ee{isRunning(u){return typeof u=="number"?this.a?.taskId===u:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(u,v,C){return this.a={taskId:u,cancel:()=>C?.(),promise:v},v.then(()=>this.d(u),()=>this.d(u)),v}d(u){this.a&&u===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const u=this.b;this.b=void 0,u.run().then(u.promiseResolve,u.promiseReject)}}queue(u){if(this.b)this.b.run=u;else{let v,C;const F=new Promise((q,Z)=>{v=q,C=Z});this.b={run:u,promise:F,promiseResolve:v,promiseReject:C}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ih=ee;class he{constructor(u,v=()=>Date.now()){this.d=u,this.f=v,this.a=0,this.b=0}increment(){const u=this.f();return u-this.a>this.d&&(this.a=u,this.b=0),this.b++,this.b}}e.$jh=he;var te;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(te||(te={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((u,v)=>{this.a=u,this.b=v})}complete(u){return new Promise(v=>{this.a(u),this.d={outcome:0,value:u},v()})}error(u){return new Promise(v=>{this.b(u),this.d={outcome:1,value:u},v()})}cancel(){return this.error(new T.$4)}}e.$kh=x;var ne;(function(R){async function u(C){let F;const q=await Promise.all(C.map(Z=>Z.then(Q=>Q,Q=>{F||(F=Q)})));if(typeof F<"u")throw F;return q}R.settled=u;function v(C){return new Promise(async(F,q)=>{try{await C(F,q)}catch(Z){q(Z)}})}R.withAsyncBody=v})(ne||(e.Promises=ne={}));var ie;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(ie||(ie={}));class Y{static fromArray(u){return new Y(v=>{v.emitMany(u)})}static fromPromise(u){return new Y(async v=>{v.emitMany(await u)})}static fromPromises(u){return new Y(async v=>{await Promise.all(u.map(async C=>v.emitOne(await C)))})}static merge(u){return new Y(async v=>{await Promise.all(u.map(async C=>{for await(const F of C)v.emitOne(F)}))})}static{this.EMPTY=Y.fromArray([])}constructor(u){this.a=0,this.b=[],this.d=null,this.f=new y.$Rd,queueMicrotask(async()=>{const v={emitOne:C=>this.g(C),emitMany:C=>this.h(C),reject:C=>this.k(C)};try{await Promise.resolve(u(v)),this.j()}catch(C){this.k(C)}finally{v.emitOne=void 0,v.emitMany=void 0,v.reject=void 0}})}[Symbol.asyncIterator](){let u=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(u<this.b.length)return{done:!1,value:this.b[u++]};if(this.a===1)return{done:!0,value:void 0};await y.Event.toPromise(this.f.event)}while(!0)}}}static map(u,v){return new Y(async C=>{for await(const F of u)C.emitOne(v(F))})}map(u){return Y.map(this,u)}static filter(u,v){return new Y(async C=>{for await(const F of u)v(F)&&C.emitOne(F)})}filter(u){return Y.filter(this,u)}static coalesce(u){return Y.filter(u,v=>!!v)}coalesce(){return Y.coalesce(this)}static async toPromise(u){const v=[];for await(const C of u)v.push(C);return v}toPromise(){return Y.toPromise(this)}g(u){this.a===0&&(this.b.push(u),this.f.fire())}h(u){this.a===0&&(this.b=this.b.concat(u),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(u){this.a===0&&(this.a=2,this.d=u,this.f.fire())}}e.$lh=Y;class se extends Y{constructor(u,v){super(v),this.l=u}cancel(){this.l.cancel()}}e.$mh=se;function ue(R){const u=new L.$2d,v=R(u.token);return new se(u,async C=>{const F=u.token.onCancellationRequested(()=>{F.dispose(),u.dispose(),C.reject(new T.$4)});try{for await(const q of v){if(u.token.isCancellationRequested)return;C.emitOne(q)}F.dispose(),u.dispose()}catch(q){F.dispose(),u.dispose(),C.reject(q)}})}e.$nh=ue;class oe{constructor(){this.a=new x,this.b=new Y(C=>{if(u){C.reject(u);return}return v&&C.emitMany(v),this.d=F=>C.reject(F),this.f=F=>C.emitOne(F),this.a.p});let u,v;this.f=C=>{v||(v=[]),v.push(C)},this.d=C=>{u||(u=C)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(u){this.d(u),this.a.complete()}emitOne(u){this.f(u)}}e.$oh=oe}),define(V[21],_([0,1,34]),function(K,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SB=e.$RB=e.$QB=void 0,e.$QB=new class{clone(){return this}equals(P){return this===P}};function T(P,s){return new L.$jt([new L.$it(0,"",P)],s)}e.$RB=T;function y(P,s){const d=new Uint32Array(2);return d[0]=0,d[1]=(P<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new L.$kt(d,s===null?e.$QB:s)}e.$SB=y}),define(V[35],_([0,1,20,6,3,36,13,15,47,21,26,16,7]),function(K,e,L,T,y,P,s,d,t,o,g,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=void 0;var a;(function(A){A[A.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(a||(a={}));class i{constructor(f,k){this.tokenizationSupport=k,this.a=this.tokenizationSupport.getInitialState(),this.store=new r(f)}getStartState(f){return this.store.getStartState(f,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$VB=i;class n extends i{constructor(f,k,w,I){super(f,k),this._textModel=w,this._languageIdCodec=I}updateTokensUntilLine(f,k){const w=this._textModel.getLanguageId();for(;;){const I=this.getFirstInvalidLine();if(!I||I.lineNumber>k)break;const U=this._textModel.getLineContent(I.lineNumber),$=j(this._languageIdCodec,w,this.tokenizationSupport,U,!0,I.startState);f.add(I.lineNumber,$.tokens),this.store.setEndState(I.lineNumber,$.endState)}}getTokenTypeIfInsertingCharacter(f,k){const w=this.getStartState(f.lineNumber);if(!w)return 0;const I=this._textModel.getLanguageId(),U=this._textModel.getLineContent(f.lineNumber),$=U.substring(0,f.column-1)+k+U.substring(f.column-1),m=j(this._languageIdCodec,I,this.tokenizationSupport,$,!0,w),E=new h.$ct(m.tokens,$,this._languageIdCodec);if(E.getCount()===0)return 0;const B=E.findTokenIndexAtOffset(f.column-1);return E.getStandardTokenType(B)}tokenizeLineWithEdit(f,k,w){const I=f.lineNumber,U=f.column,$=this.getStartState(I);if(!$)return null;const m=this._textModel.getLineContent(I),E=m.substring(0,U-1)+w+m.substring(U-1+k),B=this._textModel.getLanguageIdAtPosition(I,0),S=j(this._languageIdCodec,B,this.tokenizationSupport,E,!0,$);return new h.$ct(S.tokens,E,this._languageIdCodec)}isCheapToTokenize(f){const k=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<k||f===k&&this._textModel.getLineLength(f)<2048}tokenizeHeuristically(f,k,w){if(w<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(k<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(f,w),{heuristicTokens:!1};let I=this.b(k);const U=this._textModel.getLanguageId();for(let $=k;$<=w;$++){const m=this._textModel.getLineContent($),E=j(this._languageIdCodec,U,this.tokenizationSupport,m,!0,I);f.add($,E.tokens),I=E.endState}return{heuristicTokens:!0}}b(f){let k=this._textModel.getLineFirstNonWhitespaceColumn(f);const w=[];let I=null;for(let m=f-1;k>1&&m>=1;m--){const E=this._textModel.getLineFirstNonWhitespaceColumn(m);if(E!==0&&E<k&&(w.push(this._textModel.getLineContent(m)),k=E,I=this.getStartState(m),I))break}I||(I=this.tokenizationSupport.getInitialState()),w.reverse();const U=this._textModel.getLanguageId();let $=I;for(const m of w)$=j(this._languageIdCodec,U,this.tokenizationSupport,m,!1,$).endState;return $}}e.$WB=n;class r{constructor(f){this.d=f,this.a=new b,this.b=new O,this.b.addRange(new t.$Is(1,f+1))}getEndState(f){return this.a.getEndState(f)}setEndState(f,k){if(!k)throw new T.$bb("Cannot set null/undefined state");this.b.delete(f);const w=this.a.setEndState(f,k);return w&&f<this.d&&this.b.addRange(new t.$Is(f+1,f+2)),w}acceptChange(f,k){this.d+=k-f.length,this.a.acceptChange(f,k),this.b.addRangeAndResize(new t.$Is(f.startLineNumber,f.endLineNumberExclusive),k)}acceptChanges(f){for(const k of f){const[w]=(0,s.$bt)(k.text);this.acceptChange(new d.$Ks(k.range.startLineNumber,k.range.endLineNumber+1),w+1)}}invalidateEndStateRange(f){this.b.addRange(new t.$Is(f.startLineNumber,f.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(f,k){return f===1?k:this.getEndState(f-1)}getFirstInvalidLine(f){const k=this.getFirstInvalidEndStateLineNumber();if(k===null)return null;const w=this.getStartState(k,f);if(!w)throw new T.$bb("Start state must be defined");return{lineNumber:k,startState:w}}}e.$XB=r;class b{constructor(){this.a=new g.$TB(null)}getEndState(f){return this.a.get(f)}setEndState(f,k){const w=this.a.get(f);return w&&w.equals(k)?!1:(this.a.set(f,k),!0)}acceptChange(f,k){let w=f.length;k>0&&w>0&&(w--,k--),this.a.replace(f.startLineNumber,w,k)}acceptChanges(f){for(const k of f){const[w]=(0,s.$bt)(k.text);this.acceptChange(new d.$Ks(k.range.startLineNumber,k.range.endLineNumber+1),w+1)}}}e.$YB=b;class O{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const f=this.a[0];return f.start+1===f.endExclusive?this.a.shift():this.a[0]=new t.$Is(f.start+1,f.endExclusive),f.start}delete(f){const k=this.a.findIndex(w=>w.contains(f));if(k!==-1){const w=this.a[k];w.start===f?w.endExclusive===f+1?this.a.splice(k,1):this.a[k]=new t.$Is(f+1,w.endExclusive):w.endExclusive===f+1?this.a[k]=new t.$Is(w.start,f):this.a.splice(k,1,new t.$Is(w.start,f),new t.$Is(f+1,w.endExclusive))}}addRange(f){t.$Is.addRange(f,this.a)}addRangeAndResize(f,k){let w=0;for(;!(w>=this.a.length||f.start<=this.a[w].endExclusive);)w++;let I=w;for(;!(I>=this.a.length||f.endExclusive<this.a[I].start);)I++;const U=k-f.length;for(let $=I;$<this.a.length;$++)this.a[$]=this.a[$].delta(U);if(w===I){const $=new t.$Is(f.start,f.start+k);$.isEmpty||this.a.splice(w,0,$)}else{const $=Math.min(f.start,this.a[w].start),m=Math.max(f.endExclusive,this.a[I-1].endExclusive),E=new t.$Is($,m+U);E.isEmpty?this.a.splice(w,I-w):this.a.splice(w,I-w,E)}}toString(){return this.a.map(f=>f.toString()).join(" + ")}}e.$ZB=O;function j(A,f,k,w,I,U){let $=null;if(k)try{$=k.tokenizeEncoded(w,I,U.clone())}catch(m){(0,T.$Z)(m)}return $||($=(0,o.$SB)(A.encodeLanguageId(f),U)),h.$ct.convertToEndOffset($.tokens,w.length),$}class N{constructor(f,k){this.b=f,this.d=k,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,L.$dh)(f=>{this.f=!1,this.h(f)}))}h(f){const k=Date.now()+f.timeRemaining(),w=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<k?(0,y.$B)(w):this.g())};w()}j(){const f=this.b._textModel.getLineCount(),k=new c.$UB,w=P.$Nd.create(!1);do if(w.elapsed()>1||this.l(k)>=f)break;while(this.k());this.d.setTokens(k.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(f){const k=this.b?.getFirstInvalidLine();return k?(this.b.updateTokensUntilLine(f,k.lineNumber),k.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(f,k){this.b.store.invalidateEndStateRange(new d.$Ks(f,k))}}e.$1B=N}),define(V[37],_([0,1,33,2,36,14,34]),function(K,e,L,T,y,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FFb=void 0;class d extends T.$Rc{constructor(o,g,c,h,a,i,n){super(),this.c=o,this.f=g,this.g=c,this.h=h,this.j=a,this.m=i,this.n=n,this.a=[],this.b=this.B(new L.$Rd),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(o,g,c){throw new Error("Not supported!")}createBackgroundTokenizer(o,g){if(this.h)return this.h(o,g)}tokenizeEncoded(o,g,c){const h=Math.random()*1e4<1,a=this.n||h,i=a?new y.$Nd(!0):void 0,n=this.c.tokenizeLine2(o,c,500);if(a){const b=i.elapsed();(h||b>32)&&this.m(b,o.length,h)}if(n.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${o.substring(0,100)}`),new s.$kt(n.tokens,c);if(this.g){const b=this.a,O=n.tokens;for(let j=0,N=O.length>>>1;j<N;j++){const A=O[(j<<1)+1],f=P.$_s.getLanguageId(A);b[f]||(b[f]=!0,this.b.fire(f))}}let r;return c.equals(n.ruleStack)?r=c:r=n.ruleStack,new s.$kt(n.tokens,r)}}e.$FFb=d}),define(V[38],_([0,1,21,2,11]),function(K,e,L,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GFb=void 0;class P extends T.$Rc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(d,t,o){super(),this.a=d,this.b=t,this.c=o,this.B((0,y.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(d,t,o){throw new Error("Not supported!")}tokenizeEncoded(d,t,o){return d.length>=this.c.get()?(0,L.$SB)(this.a,o):this.b.tokenizeEncoded(d,t,o)}createBackgroundTokenizer(d,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(d,t)}}e.$GFb=P}),define(V[39],_([0,1,32,20,11,3,15,48,35,16,7,37,38]),function(K,e,L,T,y,P,s,d,t,o,g,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LFb=void 0;class a extends d.$4u{constructor(r,b,O,j,N,A,f,k){super(r,b,O,j),this.s=N,this.t=A,this.u=f,this.a=null,this.b=!1,this.c=(0,y.observableValue)(this,-1),this.q=new T.$_g(()=>this.w(),10),this.c.set(k,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(r,b){this.t=r,this.u=b,this.v()}onEvents(r){super.onEvents(r),this.a?.store.acceptChanges(r.changes),this.q.schedule()}acceptMaxTokenizationLineLength(r){this.c.set(r,void 0)}retokenize(r,b){this.a&&(this.a.store.invalidateEndStateRange(new s.$Ks(r,b)),this.q.schedule())}async v(){this.a=null;const r=this.t,b=this.u,O=await this.s.getOrCreateGrammar(r,b);if(!(this.b||r!==this.t||b!==this.u||!O)){if(O.grammar){const j=new h.$GFb(this.u,new c.$FFb(O.grammar,O.initialState,!1,void 0,()=>!1,(N,A,f)=>{this.s.reportTokenizationTime(N,r,O.sourceExtensionId,A,f)},!1),this.c);this.a=new t.$VB(this.f.length,j)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:b}=await(0,L.$QC)("vscode-textmate","release/main.js");this.m=b}const r=new Date().getTime();for(;;){let b=0;const O=new o.$UB,j=new i;for(;;){const f=this.a.getFirstInvalidLine();if(f===null||b>200)break;b++;const k=this.f[f.lineNumber-1],w=this.a.tokenizationSupport.tokenizeEncoded(k,!0,f.startState);if(this.a.store.setEndState(f.lineNumber,w.endState)){const U=this.m(f.startState,w.endState);j.setState(f.lineNumber,U)}else j.setState(f.lineNumber,null);if(g.$ct.convertToEndOffset(w.tokens,k.length),O.add(f.lineNumber,w.tokens),new Date().getTime()-r>20)break}if(b===0)break;const N=j.getStateDeltas();if(this.s.setTokensAndStates(this.h,O.serialize(),N),new Date().getTime()-r>20){(0,P.$B)(()=>this.w());return}}}}e.$LFb=a;class i{constructor(){this.a=-1,this.b=[]}setState(r,b){r===this.a+1?this.b[this.b.length-1].stateDeltas.push(b):this.b.push({startLineNumber:r,stateDeltas:[b]}),this.a=r}getStateDeltas(){return this.b}}}),define(V[40],_([0,1,19]),function(K,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IFb=void 0;class T{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(P){if(this.a[P.scopeName]){const s=this.a[P.scopeName];L.$ug(s.location,P.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${P.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${P.location.toString()}`)}this.a[P.scopeName]=P}getGrammarDefinition(P){return this.a[P]||null}}e.$IFb=T}),define(V[41],_([0,1,2,40]),function(K,e,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KFb=e.$JFb=void 0,e.$JFb="No TM Grammar registered for this language.";class y extends L.$Rc{constructor(s,d,t,o){super(),this.a=s,this.b=t.INITIAL,this.c=new T.$IFb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:o,loadGrammar:async g=>{const c=this.c.getGrammarDefinition(g);if(!c)return this.a.logTrace(`No grammar found for scope ${g}`),null;const h=c.location;try{const a=await this.a.readFile(h);return t.parseRawGrammar(a,h.path)}catch(a){return this.a.logError(`Unable to load and parse grammar for scope ${g} from ${h}`,a),null}},getInjections:g=>{const c=g.split(".");let h=[];for(let a=1;a<=c.length;a++){const i=c.slice(0,a).join(".");h=[...h,...this.f[i]||[]]}return h}}));for(const g of d){if(this.c.register(g),g.injectTo){for(const c of g.injectTo){let h=this.f[c];h||(this.f[c]=h=[]),h.push(g.scopeName)}if(g.embeddedLanguages)for(const c of g.injectTo){let h=this.g[c];h||(this.g[c]=h=[]),h.push(g.embeddedLanguages)}}g.language&&this.h.set(g.language,g.scopeName)}}has(s){return this.h.has(s)}setTheme(s,d){this.j.setTheme(s,d)}getColorMap(){return this.j.getColorMap()}async createGrammar(s,d){const t=this.h.get(s);if(typeof t!="string")throw new Error(e.$JFb);const o=this.c.getGrammarDefinition(t);if(!o)throw new Error(e.$JFb);const g=o.embeddedLanguages;if(this.g[t]){const a=this.g[t];for(const i of a)for(const n of Object.keys(i))g[n]=i[n]}const c=Object.keys(g).length>0;let h;try{h=await this.j.loadGrammarWithConfiguration(t,d,{embeddedLanguages:g,tokenTypes:o.tokenTypes,balancedBracketSelectors:o.balancedBracketSelectors,unbalancedBracketSelectors:o.unbalancedBracketSelectors})}catch(a){throw a.message&&a.message.startsWith("No grammar provided for")?new Error(e.$JFb):a}return{languageId:s,grammar:h,initialState:this.b,containsEmbeddedLanguages:c,sourceExtensionId:o.sourceExtensionId}}}e.$KFb=y}),define(V[49],_([0,1,8,41,39]),function(K,e,L,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function P(d,t){return new s(d,t)}e.create=P;class s{constructor(t,o){this.f=o,this.b=new Map,this.c=[],this.a=t.host;const g=o.grammarDefinitions.map(c=>({location:L.URI.revive(c.location),language:c.language,scopeName:c.scopeName,embeddedLanguages:c.embeddedLanguages,tokenTypes:c.tokenTypes,injectTo:c.injectTo,balancedBracketSelectors:c.balancedBracketSelectors,unbalancedBracketSelectors:c.unbalancedBracketSelectors,sourceExtensionId:c.sourceExtensionId}));this.d=this.g(g)}async g(t){const o=this.f.textmateMainUri,g=await new Promise((n,r)=>{K([o],n,r)}),c=await new Promise((n,r)=>{K([this.f.onigurumaMainUri],n,r)}),a=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await c.loadWASM(a);const i=Promise.resolve({createOnigScanner:n=>c.createOnigScanner(n),createOnigString:n=>c.createOnigString(n)});return new T.$KFb({logTrace:n=>{},logError:(n,r)=>console.error(n,r),readFile:n=>this.a.readFile(n)},t,g,i)}acceptNewModel(t){const o=L.URI.revive(t.uri),g=this;this.b.set(t.controllerId,new y.$LFb(o,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(c,h){const a=await g.d;return a?(g.c[h]||(g.c[h]=a.createGrammar(c,h)),g.c[h]):Promise.resolve(null)},setTokensAndStates(c,h,a){g.a.setTokensAndStates(t.controllerId,c,h,a)},reportTokenizationTime(c,h,a,i,n){g.a.reportTokenizationTime(c,h,a,i,n)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,o){this.b.get(t).onEvents(o)}retokenize(t,o,g){this.b.get(t).retokenize(o,g)}acceptModelLanguageChanged(t,o,g){this.b.get(t).onLanguageId(o,g)}acceptRemovedModel(t){const o=this.b.get(t);o&&(o.dispose(),this.b.delete(t))}async acceptTheme(t,o){(await this.d)?.setTheme(t,o)}acceptMaxTokenizationLineLength(t,o){this.b.get(t).acceptMaxTokenizationLineLength(o)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/da5ab29656a9f0bef63602fbce10968a7f4db2b5/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
